/* Autogenerated file, DO NOT EDIT manually! generated by perf-codegen.py
 *
 * Copyright (c) 2018 Intel Corporation
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice (including the next
 * paragraph) shall be included in all copies or substantial portions of the
 * Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */

#include <stddef.h>
#include <stdint.h>
#include <stdbool.h>
#include <assert.h>

#include "i915_perf_metrics.h"
#include <stdlib.h>
#include <string.h>

#include <i915_drm.h>

#include "i915/perf.h"

#define MIN(x, y) (((x) < (y)) ? (x) : (y))
#define MAX(a, b) (((a) > (b)) ? (a) : (b))

static double
percentage_max_callback_float(const struct intel_perf *perf,
                              const struct intel_perf_metric_set *metric_set,
                              uint64_t *accumulator)
{
   return 100;
}

static uint64_t
percentage_max_callback_uint64(const struct intel_perf *perf,
                               const struct intel_perf_metric_set *metric_set,
                               uint64_t *accumulator)
{
   return 100;
}


/* Render Metrics Basic Gen7.5 :: GPU Time Elapsed */
static uint64_t
hsw__render_basic__gpu_time__read(const struct intel_perf *perf,
                                  const struct intel_perf_metric_set *metric_set,
                                  uint64_t *accumulator)
{
    /* RPN equation: GPU_TIME 0 READ 1000000000 UMUL $GpuTimestampFrequency UDIV */
    uint64_t tmp0 = accumulator[metric_set->gpu_time_offset + 0];
    uint64_t tmp1 = tmp0 * 1000000000;
    uint64_t tmp2 = tmp1;
    uint64_t tmp3 = perf->devinfo.timestamp_frequency;
    uint64_t tmp4 = tmp3 ? tmp2 / tmp3 : 0;

    return tmp4;
}

/* Render Metrics Basic Gen7.5 :: GPU Core Clocks */
static uint64_t
hsw__render_basic__gpu_core_clocks__read(const struct intel_perf *perf,
                                         const struct intel_perf_metric_set *metric_set,
                                         uint64_t *accumulator)
{
    /* RPN equation: C 2 READ */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 2];

    return tmp0;
}

/* Render Metrics Basic Gen7.5 :: AVG GPU Core Frequency */
static uint64_t
hsw__render_basic__avg_gpu_core_frequency__read(const struct intel_perf *perf,
                                                const struct intel_perf_metric_set *metric_set,
                                                uint64_t *accumulator)
{
    /* RPN equation: $GpuCoreClocks 1000000000 UMUL $GpuTime UDIV */
    uint64_t tmp0 = hsw__render_basic__gpu_core_clocks__read(perf, metric_set, accumulator) * 1000000000;
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = hsw__render_basic__gpu_time__read(perf, metric_set, accumulator);
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;

    return tmp3;
}

/* Render Metrics Basic Gen7.5 :: AVG GPU Core Frequency */
static uint64_t
hsw__render_basic__avg_gpu_core_frequency__max(const struct intel_perf *perf,
                                               const struct intel_perf_metric_set *metric_set,
                                               uint64_t *accumulator)
{
    /* RPN equation: $GpuMaxFrequency */

    return perf->devinfo.gt_max_freq;
}

/* Render Metrics Basic Gen7.5 :: VS Threads Dispatched */
static uint64_t
hsw__render_basic__vs_threads__read(const struct intel_perf *perf,
                                    const struct intel_perf_metric_set *metric_set,
                                    uint64_t *accumulator)
{
    /* RPN equation: A 5 READ */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 5];

    return tmp0;
}

/* Render Metrics Basic Gen7.5 :: TCS Threads Dispatched */
static uint64_t
hsw__render_basic__hs_threads__read(const struct intel_perf *perf,
                                    const struct intel_perf_metric_set *metric_set,
                                    uint64_t *accumulator)
{
    /* RPN equation: A 10 READ */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 10];

    return tmp0;
}

/* Render Metrics Basic Gen7.5 :: TES Threads Dispatched */
static uint64_t
hsw__render_basic__ds_threads__read(const struct intel_perf *perf,
                                    const struct intel_perf_metric_set *metric_set,
                                    uint64_t *accumulator)
{
    /* RPN equation: A 15 READ */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 15];

    return tmp0;
}

/* Render Metrics Basic Gen7.5 :: GS Threads Dispatched */
static uint64_t
hsw__render_basic__gs_threads__read(const struct intel_perf *perf,
                                    const struct intel_perf_metric_set *metric_set,
                                    uint64_t *accumulator)
{
    /* RPN equation: A 25 READ */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 25];

    return tmp0;
}

/* Render Metrics Basic Gen7.5 :: FS Threads Dispatched */
static uint64_t
hsw__render_basic__ps_threads__read(const struct intel_perf *perf,
                                    const struct intel_perf_metric_set *metric_set,
                                    uint64_t *accumulator)
{
    /* RPN equation: A 30 READ */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 30];

    return tmp0;
}

/* Render Metrics Basic Gen7.5 :: CS Threads Dispatched */
static uint64_t
hsw__render_basic__cs_threads__read(const struct intel_perf *perf,
                                    const struct intel_perf_metric_set *metric_set,
                                    uint64_t *accumulator)
{
    /* RPN equation: A 20 READ */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 20];

    return tmp0;
}

/* Render Metrics Basic Gen7.5 :: GPU Busy */
static double
hsw__render_basic__gpu_busy__read(const struct intel_perf *perf,
                                  const struct intel_perf_metric_set *metric_set,
                                  uint64_t *accumulator)
{
    /* RPN equation: A 41 READ 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 41];
    uint64_t tmp1 = tmp0 * 100;
    double tmp2 = tmp1;
    double tmp3 = hsw__render_basic__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp4 = tmp3 ? tmp2 / tmp3 : 0;

    return tmp4;
}

/* Render Metrics Basic Gen7.5 :: EU Active */
static double
hsw__render_basic__eu_active__read(const struct intel_perf *perf,
                                   const struct intel_perf_metric_set *metric_set,
                                   uint64_t *accumulator)
{
    /* RPN equation: A 0 READ $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 0];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = perf->devinfo.n_eus;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    uint64_t tmp4 = tmp3 * 100;
    double tmp5 = tmp4;
    double tmp6 = hsw__render_basic__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp7 = tmp6 ? tmp5 / tmp6 : 0;

    return tmp7;
}

/* Render Metrics Basic Gen7.5 :: EU Stall */
static double
hsw__render_basic__eu_stall__read(const struct intel_perf *perf,
                                  const struct intel_perf_metric_set *metric_set,
                                  uint64_t *accumulator)
{
    /* RPN equation: A 1 READ $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 1];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = perf->devinfo.n_eus;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    uint64_t tmp4 = tmp3 * 100;
    double tmp5 = tmp4;
    double tmp6 = hsw__render_basic__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp7 = tmp6 ? tmp5 / tmp6 : 0;

    return tmp7;
}

/* Render Metrics Basic Gen7.5 :: VS EU Active */
static double
hsw__render_basic__vs_eu_active__read(const struct intel_perf *perf,
                                      const struct intel_perf_metric_set *metric_set,
                                      uint64_t *accumulator)
{
    /* RPN equation: A 2 READ $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 2];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = perf->devinfo.n_eus;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    uint64_t tmp4 = tmp3 * 100;
    double tmp5 = tmp4;
    double tmp6 = hsw__render_basic__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp7 = tmp6 ? tmp5 / tmp6 : 0;

    return tmp7;
}

/* Render Metrics Basic Gen7.5 :: VS AVG Active per Thread */
static uint64_t
hsw__render_basic__vs_eu_active_per_thread__read(const struct intel_perf *perf,
                                                 const struct intel_perf_metric_set *metric_set,
                                                 uint64_t *accumulator)
{
    /* RPN equation: A 2 READ $VsThreads UDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 2];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = hsw__render_basic__vs_threads__read(perf, metric_set, accumulator);
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;

    return tmp3;
}

/* Render Metrics Basic Gen7.5 :: VS AVG Stall per Thread */
static uint64_t
hsw__render_basic__vs_eu_stall_per_thread__read(const struct intel_perf *perf,
                                                const struct intel_perf_metric_set *metric_set,
                                                uint64_t *accumulator)
{
    /* RPN equation: A 3 READ $VsThreads UDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 3];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = hsw__render_basic__vs_threads__read(perf, metric_set, accumulator);
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;

    return tmp3;
}

/* Render Metrics Basic Gen7.5 :: VS EU Stall */
static double
hsw__render_basic__vs_eu_stall__read(const struct intel_perf *perf,
                                     const struct intel_perf_metric_set *metric_set,
                                     uint64_t *accumulator)
{
    /* RPN equation: A 3 READ $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 3];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = perf->devinfo.n_eus;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    uint64_t tmp4 = tmp3 * 100;
    double tmp5 = tmp4;
    double tmp6 = hsw__render_basic__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp7 = tmp6 ? tmp5 / tmp6 : 0;

    return tmp7;
}

/* Render Metrics Basic Gen7.5 :: TCS EU Active */
static double
hsw__render_basic__hs_eu_active__read(const struct intel_perf *perf,
                                      const struct intel_perf_metric_set *metric_set,
                                      uint64_t *accumulator)
{
    /* RPN equation: A 7 READ $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 7];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = perf->devinfo.n_eus;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    uint64_t tmp4 = tmp3 * 100;
    double tmp5 = tmp4;
    double tmp6 = hsw__render_basic__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp7 = tmp6 ? tmp5 / tmp6 : 0;

    return tmp7;
}

/* Render Metrics Basic Gen7.5 :: TCS AVG Active per Thread */
static uint64_t
hsw__render_basic__hs_eu_active_per_thread__read(const struct intel_perf *perf,
                                                 const struct intel_perf_metric_set *metric_set,
                                                 uint64_t *accumulator)
{
    /* RPN equation: A 7 READ $HsThreads UDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 7];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = hsw__render_basic__hs_threads__read(perf, metric_set, accumulator);
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;

    return tmp3;
}

/* Render Metrics Basic Gen7.5 :: TCS AVG Stall per Thread */
static uint64_t
hsw__render_basic__hs_eu_stall_per_thread__read(const struct intel_perf *perf,
                                                const struct intel_perf_metric_set *metric_set,
                                                uint64_t *accumulator)
{
    /* RPN equation: A 8 READ $HsThreads UDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 8];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = hsw__render_basic__hs_threads__read(perf, metric_set, accumulator);
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;

    return tmp3;
}

/* Render Metrics Basic Gen7.5 :: TCS EU Stall */
static double
hsw__render_basic__hs_eu_stall__read(const struct intel_perf *perf,
                                     const struct intel_perf_metric_set *metric_set,
                                     uint64_t *accumulator)
{
    /* RPN equation: A 8 READ $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 8];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = perf->devinfo.n_eus;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    uint64_t tmp4 = tmp3 * 100;
    double tmp5 = tmp4;
    double tmp6 = hsw__render_basic__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp7 = tmp6 ? tmp5 / tmp6 : 0;

    return tmp7;
}

/* Render Metrics Basic Gen7.5 :: TES EU Active */
static double
hsw__render_basic__ds_eu_active__read(const struct intel_perf *perf,
                                      const struct intel_perf_metric_set *metric_set,
                                      uint64_t *accumulator)
{
    /* RPN equation: A 12 READ $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 12];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = perf->devinfo.n_eus;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    uint64_t tmp4 = tmp3 * 100;
    double tmp5 = tmp4;
    double tmp6 = hsw__render_basic__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp7 = tmp6 ? tmp5 / tmp6 : 0;

    return tmp7;
}

/* Render Metrics Basic Gen7.5 :: TES AVG Active per Thread */
static uint64_t
hsw__render_basic__ds_eu_active_per_thread__read(const struct intel_perf *perf,
                                                 const struct intel_perf_metric_set *metric_set,
                                                 uint64_t *accumulator)
{
    /* RPN equation: A 12 READ $DsThreads UDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 12];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = hsw__render_basic__ds_threads__read(perf, metric_set, accumulator);
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;

    return tmp3;
}

/* Render Metrics Basic Gen7.5 :: TES AVG Stall per Thread */
static uint64_t
hsw__render_basic__ds_eu_stall_per_thread__read(const struct intel_perf *perf,
                                                const struct intel_perf_metric_set *metric_set,
                                                uint64_t *accumulator)
{
    /* RPN equation: A 13 READ $DsThreads UDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 13];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = hsw__render_basic__ds_threads__read(perf, metric_set, accumulator);
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;

    return tmp3;
}

/* Render Metrics Basic Gen7.5 :: TES EU Stall */
static double
hsw__render_basic__ds_eu_stall__read(const struct intel_perf *perf,
                                     const struct intel_perf_metric_set *metric_set,
                                     uint64_t *accumulator)
{
    /* RPN equation: A 13 READ $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 13];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = perf->devinfo.n_eus;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    uint64_t tmp4 = tmp3 * 100;
    double tmp5 = tmp4;
    double tmp6 = hsw__render_basic__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp7 = tmp6 ? tmp5 / tmp6 : 0;

    return tmp7;
}

/* Render Metrics Basic Gen7.5 :: GS EU Active */
static double
hsw__render_basic__gs_eu_active__read(const struct intel_perf *perf,
                                      const struct intel_perf_metric_set *metric_set,
                                      uint64_t *accumulator)
{
    /* RPN equation: A 22 READ $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 22];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = perf->devinfo.n_eus;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    uint64_t tmp4 = tmp3 * 100;
    double tmp5 = tmp4;
    double tmp6 = hsw__render_basic__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp7 = tmp6 ? tmp5 / tmp6 : 0;

    return tmp7;
}

/* Render Metrics Basic Gen7.5 :: GS AVG Active per Thread */
static uint64_t
hsw__render_basic__gs_eu_active_per_thread__read(const struct intel_perf *perf,
                                                 const struct intel_perf_metric_set *metric_set,
                                                 uint64_t *accumulator)
{
    /* RPN equation: A 22 READ $GsThreads UDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 22];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = hsw__render_basic__gs_threads__read(perf, metric_set, accumulator);
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;

    return tmp3;
}

/* Render Metrics Basic Gen7.5 :: GS AVG Stall per Thread */
static uint64_t
hsw__render_basic__gs_eu_stall_per_thread__read(const struct intel_perf *perf,
                                                const struct intel_perf_metric_set *metric_set,
                                                uint64_t *accumulator)
{
    /* RPN equation: A 23 READ $GsThreads UDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 23];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = hsw__render_basic__gs_threads__read(perf, metric_set, accumulator);
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;

    return tmp3;
}

/* Render Metrics Basic Gen7.5 :: GS EU Stall */
static double
hsw__render_basic__gs_eu_stall__read(const struct intel_perf *perf,
                                     const struct intel_perf_metric_set *metric_set,
                                     uint64_t *accumulator)
{
    /* RPN equation: A 23 READ $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 23];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = perf->devinfo.n_eus;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    uint64_t tmp4 = tmp3 * 100;
    double tmp5 = tmp4;
    double tmp6 = hsw__render_basic__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp7 = tmp6 ? tmp5 / tmp6 : 0;

    return tmp7;
}

/* Render Metrics Basic Gen7.5 :: CS EU Active */
static double
hsw__render_basic__cs_eu_active__read(const struct intel_perf *perf,
                                      const struct intel_perf_metric_set *metric_set,
                                      uint64_t *accumulator)
{
    /* RPN equation: A 17 READ $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 17];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = perf->devinfo.n_eus;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    uint64_t tmp4 = tmp3 * 100;
    double tmp5 = tmp4;
    double tmp6 = hsw__render_basic__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp7 = tmp6 ? tmp5 / tmp6 : 0;

    return tmp7;
}

/* Render Metrics Basic Gen7.5 :: CS AVG Active per Thread */
static uint64_t
hsw__render_basic__cs_eu_active_per_thread__read(const struct intel_perf *perf,
                                                 const struct intel_perf_metric_set *metric_set,
                                                 uint64_t *accumulator)
{
    /* RPN equation: A 17 READ $CsThreads UDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 17];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = hsw__render_basic__cs_threads__read(perf, metric_set, accumulator);
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;

    return tmp3;
}

/* Render Metrics Basic Gen7.5 :: CS AVG Stall per Thread */
static uint64_t
hsw__render_basic__cs_eu_stall_per_thread__read(const struct intel_perf *perf,
                                                const struct intel_perf_metric_set *metric_set,
                                                uint64_t *accumulator)
{
    /* RPN equation: A 18 READ $CsThreads UDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 18];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = hsw__render_basic__cs_threads__read(perf, metric_set, accumulator);
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;

    return tmp3;
}

/* Render Metrics Basic Gen7.5 :: CS EU Stall */
static double
hsw__render_basic__cs_eu_stall__read(const struct intel_perf *perf,
                                     const struct intel_perf_metric_set *metric_set,
                                     uint64_t *accumulator)
{
    /* RPN equation: A 18 READ $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 18];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = perf->devinfo.n_eus;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    uint64_t tmp4 = tmp3 * 100;
    double tmp5 = tmp4;
    double tmp6 = hsw__render_basic__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp7 = tmp6 ? tmp5 / tmp6 : 0;

    return tmp7;
}

/* Render Metrics Basic Gen7.5 :: FS EU Active */
static double
hsw__render_basic__ps_eu_active__read(const struct intel_perf *perf,
                                      const struct intel_perf_metric_set *metric_set,
                                      uint64_t *accumulator)
{
    /* RPN equation: A 27 READ $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 27];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = perf->devinfo.n_eus;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    uint64_t tmp4 = tmp3 * 100;
    double tmp5 = tmp4;
    double tmp6 = hsw__render_basic__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp7 = tmp6 ? tmp5 / tmp6 : 0;

    return tmp7;
}

/* Render Metrics Basic Gen7.5 :: FS AVG Active per Thread */
static uint64_t
hsw__render_basic__ps_eu_active_per_thread__read(const struct intel_perf *perf,
                                                 const struct intel_perf_metric_set *metric_set,
                                                 uint64_t *accumulator)
{
    /* RPN equation: A 27 READ $PsThreads UDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 27];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = hsw__render_basic__ps_threads__read(perf, metric_set, accumulator);
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;

    return tmp3;
}

/* Render Metrics Basic Gen7.5 :: FS AVG Stall per Thread */
static uint64_t
hsw__render_basic__ps_eu_stall_per_thread__read(const struct intel_perf *perf,
                                                const struct intel_perf_metric_set *metric_set,
                                                uint64_t *accumulator)
{
    /* RPN equation: A 28 READ $PsThreads UDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 28];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = hsw__render_basic__ps_threads__read(perf, metric_set, accumulator);
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;

    return tmp3;
}

/* Render Metrics Basic Gen7.5 :: FS EU Stall */
static double
hsw__render_basic__ps_eu_stall__read(const struct intel_perf *perf,
                                     const struct intel_perf_metric_set *metric_set,
                                     uint64_t *accumulator)
{
    /* RPN equation: A 28 READ $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 28];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = perf->devinfo.n_eus;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    uint64_t tmp4 = tmp3 * 100;
    double tmp5 = tmp4;
    double tmp6 = hsw__render_basic__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp7 = tmp6 ? tmp5 / tmp6 : 0;

    return tmp7;
}

/* Render Metrics Basic Gen7.5 :: Sampler 0 Busy */
static double
hsw__render_basic__sampler0_busy__read(const struct intel_perf *perf,
                                       const struct intel_perf_metric_set *metric_set,
                                       uint64_t *accumulator)
{
    /* RPN equation: B 0 READ 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 0];
    uint64_t tmp1 = tmp0 * 100;
    double tmp2 = tmp1;
    double tmp3 = hsw__render_basic__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp4 = tmp3 ? tmp2 / tmp3 : 0;

    return tmp4;
}

/* Render Metrics Basic Gen7.5 :: Sampler 1 Busy */
static double
hsw__render_basic__sampler1_busy__read(const struct intel_perf *perf,
                                       const struct intel_perf_metric_set *metric_set,
                                       uint64_t *accumulator)
{
    /* RPN equation: B 1 READ 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 1];
    uint64_t tmp1 = tmp0 * 100;
    double tmp2 = tmp1;
    double tmp3 = hsw__render_basic__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp4 = tmp3 ? tmp2 / tmp3 : 0;

    return tmp4;
}

/* Render Metrics Basic Gen7.5 :: Samplers Busy */
static double
hsw__render_basic__samplers_busy__read(const struct intel_perf *perf,
                                       const struct intel_perf_metric_set *metric_set,
                                       uint64_t *accumulator)
{
    /* RPN equation: B 0 READ  B 1 READ UADD $GpuCoreClocks FDIV 2 FDIV 100 FMUL */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 0];
    uint64_t tmp1 = accumulator[metric_set->b_offset + 1];
    uint64_t tmp2 = tmp0 + tmp1;
    double tmp3 = tmp2;
    double tmp4 = hsw__render_basic__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp5 = tmp4 ? tmp3 / tmp4 : 0;
    double tmp6 = tmp5;
    double tmp7 = 2;
    double tmp8 = tmp7 ? tmp6 / tmp7 : 0;
    double tmp9 = tmp8 * 100;

    return tmp9;
}

/* Render Metrics Basic Gen7.5 :: Sampler 0 Bottleneck */
static double
hsw__render_basic__sampler0_bottleneck__read(const struct intel_perf *perf,
                                             const struct intel_perf_metric_set *metric_set,
                                             uint64_t *accumulator)
{
    /* RPN equation: B 2 READ 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 2];
    uint64_t tmp1 = tmp0 * 100;
    double tmp2 = tmp1;
    double tmp3 = hsw__render_basic__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp4 = tmp3 ? tmp2 / tmp3 : 0;

    return tmp4;
}

/* Render Metrics Basic Gen7.5 :: Sampler 1 Bottleneck */
static double
hsw__render_basic__sampler1_bottleneck__read(const struct intel_perf *perf,
                                             const struct intel_perf_metric_set *metric_set,
                                             uint64_t *accumulator)
{
    /* RPN equation: B 3 READ 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 3];
    uint64_t tmp1 = tmp0 * 100;
    double tmp2 = tmp1;
    double tmp3 = hsw__render_basic__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp4 = tmp3 ? tmp2 / tmp3 : 0;

    return tmp4;
}

/* Render Metrics Basic Gen7.5 :: Sampler 0 Texels LOD0 */
static uint64_t
hsw__render_basic__sampler0_texels__read(const struct intel_perf *perf,
                                         const struct intel_perf_metric_set *metric_set,
                                         uint64_t *accumulator)
{
    /* RPN equation: B 4 READ 4 UMUL */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 4];
    uint64_t tmp1 = tmp0 * 4;

    return tmp1;
}

/* Render Metrics Basic Gen7.5 :: Sampler 1 Texels LOD0 */
static uint64_t
hsw__render_basic__sampler1_texels__read(const struct intel_perf *perf,
                                         const struct intel_perf_metric_set *metric_set,
                                         uint64_t *accumulator)
{
    /* RPN equation: B 5 READ 4 UMUL */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 5];
    uint64_t tmp1 = tmp0 * 4;

    return tmp1;
}

/* Render Metrics Basic Gen7.5 :: Sampler Texels LOD0 */
static uint64_t
hsw__render_basic__sampler_texels__read(const struct intel_perf *perf,
                                        const struct intel_perf_metric_set *metric_set,
                                        uint64_t *accumulator)
{
    /* RPN equation: $Sampler0Texels $Sampler1Texels UADD $EuSlicesTotalCount UMUL */
    uint64_t tmp0 = hsw__render_basic__sampler0_texels__read(perf, metric_set, accumulator) + hsw__render_basic__sampler1_texels__read(perf, metric_set, accumulator);
    uint64_t tmp1 = tmp0 * perf->devinfo.n_eu_slices;

    return tmp1;
}

/* Render Metrics Basic Gen7.5 :: L3 Sampler Throughput */
static uint64_t
hsw__render_basic__l3_sampler_throughput__read(const struct intel_perf *perf,
                                               const struct intel_perf_metric_set *metric_set,
                                               uint64_t *accumulator)
{
    /* RPN equation: B 6 READ B 7 READ UADD 2 UMUL $EuSlicesTotalCount UMUL 64 UMUL */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 6];
    uint64_t tmp1 = accumulator[metric_set->b_offset + 7];
    uint64_t tmp2 = tmp0 + tmp1;
    uint64_t tmp3 = tmp2 * 2;
    uint64_t tmp4 = tmp3 * perf->devinfo.n_eu_slices;
    uint64_t tmp5 = tmp4 * 64;

    return tmp5;
}

/* Render Metrics Basic Gen7.5 :: L3 Sampler Throughput */
static uint64_t
hsw__render_basic__l3_sampler_throughput__max(const struct intel_perf *perf,
                                              const struct intel_perf_metric_set *metric_set,
                                              uint64_t *accumulator)
{
    /* RPN equation: $GpuCoreClocks 64 UMUL $EuSlicesTotalCount UMUL */
    uint64_t tmp0 = hsw__render_basic__gpu_core_clocks__read(perf, metric_set, accumulator) * 64;
    uint64_t tmp1 = tmp0 * perf->devinfo.n_eu_slices;

    return tmp1;
}

/* Render Metrics Basic Gen7.5 :: Early Hi-Depth Test Fails */
static uint64_t
hsw__render_basic__hi_depth_test_fails__read(const struct intel_perf *perf,
                                             const struct intel_perf_metric_set *metric_set,
                                             uint64_t *accumulator)
{
    /* RPN equation: A 33 READ */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 33];

    return tmp0;
}

/* Render Metrics Basic Gen7.5 :: Early Depth Test Fails */
static uint64_t
hsw__render_basic__early_depth_test_fails__read(const struct intel_perf *perf,
                                                const struct intel_perf_metric_set *metric_set,
                                                uint64_t *accumulator)
{
    /* RPN equation: A 35 READ */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 35];

    return tmp0;
}

/* Render Metrics Basic Gen7.5 :: Samples Killed in FS */
static uint64_t
hsw__render_basic__samples_killed_in_ps__read(const struct intel_perf *perf,
                                              const struct intel_perf_metric_set *metric_set,
                                              uint64_t *accumulator)
{
    /* RPN equation: A 36 READ */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 36];

    return tmp0;
}

/* Render Metrics Basic Gen7.5 :: Alpha Test Fails */
static uint64_t
hsw__render_basic__alpha_test_fails__read(const struct intel_perf *perf,
                                          const struct intel_perf_metric_set *metric_set,
                                          uint64_t *accumulator)
{
    /* RPN equation: A 37 READ */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 37];

    return tmp0;
}

/* Render Metrics Basic Gen7.5 :: Late Stencil Test Fails */
static uint64_t
hsw__render_basic__post_ps_stencil_test_fails__read(const struct intel_perf *perf,
                                                    const struct intel_perf_metric_set *metric_set,
                                                    uint64_t *accumulator)
{
    /* RPN equation: A 38 READ */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 38];

    return tmp0;
}

/* Render Metrics Basic Gen7.5 :: Late Depth Test Fails */
static uint64_t
hsw__render_basic__post_ps_depth_test_fails__read(const struct intel_perf *perf,
                                                  const struct intel_perf_metric_set *metric_set,
                                                  uint64_t *accumulator)
{
    /* RPN equation: A 39 READ $SamplesKilledInPs USUB */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 39];
    uint64_t tmp1 = tmp0 - hsw__render_basic__samples_killed_in_ps__read(perf, metric_set, accumulator);

    return tmp1;
}

/* Render Metrics Basic Gen7.5 :: Samples Written */
static uint64_t
hsw__render_basic__samples_written__read(const struct intel_perf *perf,
                                         const struct intel_perf_metric_set *metric_set,
                                         uint64_t *accumulator)
{
    /* RPN equation: A 40 READ */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 40];

    return tmp0;
}

/* Render Metrics Basic Gen7.5 :: Samples Blended */
static uint64_t
hsw__render_basic__samples_blended__read(const struct intel_perf *perf,
                                         const struct intel_perf_metric_set *metric_set,
                                         uint64_t *accumulator)
{
    /* RPN equation: C 5 READ $EuSlicesTotalCount 4 UMUL UMUL */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 5];
    uint64_t tmp1 = perf->devinfo.n_eu_slices * 4;
    uint64_t tmp2 = tmp0 * tmp1;

    return tmp2;
}

/* Render Metrics Basic Gen7.5 :: GTI Fixed Pipe Throughput */
static uint64_t
hsw__render_basic__gti_vf_throughput__read(const struct intel_perf *perf,
                                           const struct intel_perf_metric_set *metric_set,
                                           uint64_t *accumulator)
{
    /* RPN equation: C 1 READ 64 UMUL */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 1];
    uint64_t tmp1 = tmp0 * 64;

    return tmp1;
}

/* Render Metrics Basic Gen7.5 :: GTI Fixed Pipe Throughput */
static uint64_t
hsw__render_basic__gti_vf_throughput__max(const struct intel_perf *perf,
                                          const struct intel_perf_metric_set *metric_set,
                                          uint64_t *accumulator)
{
    /* RPN equation: $GpuCoreClocks 64 UMUL */
    uint64_t tmp0 = hsw__render_basic__gpu_core_clocks__read(perf, metric_set, accumulator) * 64;

    return tmp0;
}

/* Render Metrics Basic Gen7.5 :: GTI Depth Throughput */
static uint64_t
hsw__render_basic__gti_depth_throughput__read(const struct intel_perf *perf,
                                              const struct intel_perf_metric_set *metric_set,
                                              uint64_t *accumulator)
{
    /* RPN equation: C 0 READ 64 UMUL */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 0];
    uint64_t tmp1 = tmp0 * 64;

    return tmp1;
}

/* Render Metrics Basic Gen7.5 :: GTI Depth Throughput */
#define hsw__render_basic__gti_depth_throughput__max \
    hsw__render_basic__l3_sampler_throughput__max

/* Render Metrics Basic Gen7.5 :: GTI RCC Throughput */
static uint64_t
hsw__render_basic__gti_rcc_throughput__read(const struct intel_perf *perf,
                                            const struct intel_perf_metric_set *metric_set,
                                            uint64_t *accumulator)
{
    /* RPN equation: C 3 READ 64 UMUL */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 3];
    uint64_t tmp1 = tmp0 * 64;

    return tmp1;
}

/* Render Metrics Basic Gen7.5 :: GTI RCC Throughput */
#define hsw__render_basic__gti_rcc_throughput__max \
    hsw__render_basic__l3_sampler_throughput__max

/* Render Metrics Basic Gen7.5 :: GTI L3 Throughput */
static uint64_t
hsw__render_basic__gti_l3_throughput__read(const struct intel_perf *perf,
                                           const struct intel_perf_metric_set *metric_set,
                                           uint64_t *accumulator)
{
    /* RPN equation: C 4 READ 64 UMUL */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 4];
    uint64_t tmp1 = tmp0 * 64;

    return tmp1;
}

/* Render Metrics Basic Gen7.5 :: GTI L3 Throughput */
#define hsw__render_basic__gti_l3_throughput__max \
    hsw__render_basic__l3_sampler_throughput__max

/* Render Metrics Basic Gen7.5 :: GTI Read Throughput */
static uint64_t
hsw__render_basic__gti_read_throughput__read(const struct intel_perf *perf,
                                             const struct intel_perf_metric_set *metric_set,
                                             uint64_t *accumulator)
{
    /* RPN equation: C 6 READ 128 UMUL */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 6];
    uint64_t tmp1 = tmp0 * 128;

    return tmp1;
}

/* Render Metrics Basic Gen7.5 :: GTI Read Throughput */
#define hsw__render_basic__gti_read_throughput__max \
    hsw__render_basic__gti_vf_throughput__max

/* Render Metrics Basic Gen7.5 :: GTI Write Throughput */
static uint64_t
hsw__render_basic__gti_write_throughput__read(const struct intel_perf *perf,
                                              const struct intel_perf_metric_set *metric_set,
                                              uint64_t *accumulator)
{
    /* RPN equation: C 7 READ 64 UMUL */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 7];
    uint64_t tmp1 = tmp0 * 64;

    return tmp1;
}

/* Render Metrics Basic Gen7.5 :: GTI Write Throughput */
static uint64_t
hsw__render_basic__gti_write_throughput__max(const struct intel_perf *perf,
                                             const struct intel_perf_metric_set *metric_set,
                                             uint64_t *accumulator)
{
    /* RPN equation: $GpuCoreClocks 32 UMUL */
    uint64_t tmp0 = hsw__render_basic__gpu_core_clocks__read(perf, metric_set, accumulator) * 32;

    return tmp0;
}

/* Render Metrics Basic Gen7.5 :: LLC GPU Accesses */
static uint64_t
hsw__render_basic__llc_accesses__read(const struct intel_perf *perf,
                                      const struct intel_perf_metric_set *metric_set,
                                      uint64_t *accumulator)
{
    /* RPN equation: PERFCNT1 READ_REG */
    uint64_t tmp0 = 0;

    return tmp0;
}

/* Render Metrics Basic Gen7.5 :: LLC GPU Hits */
static uint64_t
hsw__render_basic__llc_hits__read(const struct intel_perf *perf,
                                  const struct intel_perf_metric_set *metric_set,
                                  uint64_t *accumulator)
{
    /* RPN equation: PERFCNT2 READ_REG */
    uint64_t tmp0 = 0;

    return tmp0;
}

/* Render Metrics Basic Gen7.5 :: LLC GPU Throughput */
static uint64_t
hsw__render_basic__llc_gpu_throughput__read(const struct intel_perf *perf,
                                            const struct intel_perf_metric_set *metric_set,
                                            uint64_t *accumulator)
{
    /* RPN equation: PERFCNT1 READ_REG C 7 READ USUB 64 UMUL */
    uint64_t tmp0 = 0;
    uint64_t tmp1 = accumulator[metric_set->c_offset + 7];
    uint64_t tmp2 = tmp0 - tmp1;
    uint64_t tmp3 = tmp2 * 64;

    return tmp3;
}

/* Render Metrics Basic Gen7.5 :: LLC GPU Throughput */
#define hsw__render_basic__llc_gpu_throughput__max \
    hsw__render_basic__gti_vf_throughput__max

/* Render Metrics Basic Gen7.5 :: FS Duration */
static uint64_t
hsw__render_basic__ps_duration__read(const struct intel_perf *perf,
                                     const struct intel_perf_metric_set *metric_set,
                                     uint64_t *accumulator)
{
    /* RPN equation: A 27 READ  A 0 READ UMUL  A 2 READ  A 7 READ UADD  A 12 READ UADD  A 17 READ UADD  A 22 READ UADD  A 27 READ UADD UDIV  A 28 READ  A 1 READ UMUL  A 3 READ  A 8 READ UADD  A 13 READ UADD  A 18 READ UADD  A 23 READ UADD  A 28 READ UADD UDIV UADD $GpuTime UMUL $GpuCoreClocks $EuCoresTotalCount UMUL 1000 UMUL UDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 27];
    uint64_t tmp1 = accumulator[metric_set->a_offset + 0];
    uint64_t tmp2 = tmp0 * tmp1;
    uint64_t tmp3 = accumulator[metric_set->a_offset + 2];
    uint64_t tmp4 = accumulator[metric_set->a_offset + 7];
    uint64_t tmp5 = tmp3 + tmp4;
    uint64_t tmp6 = accumulator[metric_set->a_offset + 12];
    uint64_t tmp7 = tmp5 + tmp6;
    uint64_t tmp8 = accumulator[metric_set->a_offset + 17];
    uint64_t tmp9 = tmp7 + tmp8;
    uint64_t tmp10 = accumulator[metric_set->a_offset + 22];
    uint64_t tmp11 = tmp9 + tmp10;
    uint64_t tmp12 = accumulator[metric_set->a_offset + 27];
    uint64_t tmp13 = tmp11 + tmp12;
    uint64_t tmp14 = tmp2;
    uint64_t tmp15 = tmp13;
    uint64_t tmp16 = tmp15 ? tmp14 / tmp15 : 0;
    uint64_t tmp17 = accumulator[metric_set->a_offset + 28];
    uint64_t tmp18 = accumulator[metric_set->a_offset + 1];
    uint64_t tmp19 = tmp17 * tmp18;
    uint64_t tmp20 = accumulator[metric_set->a_offset + 3];
    uint64_t tmp21 = accumulator[metric_set->a_offset + 8];
    uint64_t tmp22 = tmp20 + tmp21;
    uint64_t tmp23 = accumulator[metric_set->a_offset + 13];
    uint64_t tmp24 = tmp22 + tmp23;
    uint64_t tmp25 = accumulator[metric_set->a_offset + 18];
    uint64_t tmp26 = tmp24 + tmp25;
    uint64_t tmp27 = accumulator[metric_set->a_offset + 23];
    uint64_t tmp28 = tmp26 + tmp27;
    uint64_t tmp29 = accumulator[metric_set->a_offset + 28];
    uint64_t tmp30 = tmp28 + tmp29;
    uint64_t tmp31 = tmp19;
    uint64_t tmp32 = tmp30;
    uint64_t tmp33 = tmp32 ? tmp31 / tmp32 : 0;
    uint64_t tmp34 = tmp16 + tmp33;
    uint64_t tmp35 = tmp34 * hsw__render_basic__gpu_time__read(perf, metric_set, accumulator);
    uint64_t tmp36 = hsw__render_basic__gpu_core_clocks__read(perf, metric_set, accumulator) * perf->devinfo.n_eus;
    uint64_t tmp37 = tmp36 * 1000;
    uint64_t tmp38 = tmp35;
    uint64_t tmp39 = tmp37;
    uint64_t tmp40 = tmp39 ? tmp38 / tmp39 : 0;

    return tmp40;
}

/* Render Metrics Basic Gen7.5 :: VS Duration */
static uint64_t
hsw__render_basic__vs_duration__read(const struct intel_perf *perf,
                                     const struct intel_perf_metric_set *metric_set,
                                     uint64_t *accumulator)
{
    /* RPN equation: A 2 READ  A 0 READ UMUL  A 2 READ  A 7 READ UADD  A 12 READ UADD  A 17 READ UADD  A 22 READ UADD  A 27 READ UADD UDIV  A 3 READ  A 1 READ UMUL  A 3 READ  A 8 READ UADD  A 13 READ UADD  A 18 READ UADD  A 23 READ UADD  A 28 READ UADD UDIV UADD $GpuTime UMUL $GpuCoreClocks $EuCoresTotalCount UMUL 1000 UMUL UDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 2];
    uint64_t tmp1 = accumulator[metric_set->a_offset + 0];
    uint64_t tmp2 = tmp0 * tmp1;
    uint64_t tmp3 = accumulator[metric_set->a_offset + 2];
    uint64_t tmp4 = accumulator[metric_set->a_offset + 7];
    uint64_t tmp5 = tmp3 + tmp4;
    uint64_t tmp6 = accumulator[metric_set->a_offset + 12];
    uint64_t tmp7 = tmp5 + tmp6;
    uint64_t tmp8 = accumulator[metric_set->a_offset + 17];
    uint64_t tmp9 = tmp7 + tmp8;
    uint64_t tmp10 = accumulator[metric_set->a_offset + 22];
    uint64_t tmp11 = tmp9 + tmp10;
    uint64_t tmp12 = accumulator[metric_set->a_offset + 27];
    uint64_t tmp13 = tmp11 + tmp12;
    uint64_t tmp14 = tmp2;
    uint64_t tmp15 = tmp13;
    uint64_t tmp16 = tmp15 ? tmp14 / tmp15 : 0;
    uint64_t tmp17 = accumulator[metric_set->a_offset + 3];
    uint64_t tmp18 = accumulator[metric_set->a_offset + 1];
    uint64_t tmp19 = tmp17 * tmp18;
    uint64_t tmp20 = accumulator[metric_set->a_offset + 3];
    uint64_t tmp21 = accumulator[metric_set->a_offset + 8];
    uint64_t tmp22 = tmp20 + tmp21;
    uint64_t tmp23 = accumulator[metric_set->a_offset + 13];
    uint64_t tmp24 = tmp22 + tmp23;
    uint64_t tmp25 = accumulator[metric_set->a_offset + 18];
    uint64_t tmp26 = tmp24 + tmp25;
    uint64_t tmp27 = accumulator[metric_set->a_offset + 23];
    uint64_t tmp28 = tmp26 + tmp27;
    uint64_t tmp29 = accumulator[metric_set->a_offset + 28];
    uint64_t tmp30 = tmp28 + tmp29;
    uint64_t tmp31 = tmp19;
    uint64_t tmp32 = tmp30;
    uint64_t tmp33 = tmp32 ? tmp31 / tmp32 : 0;
    uint64_t tmp34 = tmp16 + tmp33;
    uint64_t tmp35 = tmp34 * hsw__render_basic__gpu_time__read(perf, metric_set, accumulator);
    uint64_t tmp36 = hsw__render_basic__gpu_core_clocks__read(perf, metric_set, accumulator) * perf->devinfo.n_eus;
    uint64_t tmp37 = tmp36 * 1000;
    uint64_t tmp38 = tmp35;
    uint64_t tmp39 = tmp37;
    uint64_t tmp40 = tmp39 ? tmp38 / tmp39 : 0;

    return tmp40;
}

/* Render Metrics Basic Gen7.5 :: GS Duration */
static uint64_t
hsw__render_basic__gs_duration__read(const struct intel_perf *perf,
                                     const struct intel_perf_metric_set *metric_set,
                                     uint64_t *accumulator)
{
    /* RPN equation: A 22 READ  A 0 READ UMUL  A 2 READ  A 7 READ UADD  A 12 READ UADD  A 17 READ UADD  A 22 READ UADD  A 27 READ UADD UDIV  A 23 READ  A 1 READ UMUL  A 3 READ  A 8 READ UADD  A 13 READ UADD  A 18 READ UADD  A 23 READ UADD  A 28 READ UADD UDIV UADD $GpuTime UMUL $GpuCoreClocks $EuCoresTotalCount UMUL 1000 UMUL UDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 22];
    uint64_t tmp1 = accumulator[metric_set->a_offset + 0];
    uint64_t tmp2 = tmp0 * tmp1;
    uint64_t tmp3 = accumulator[metric_set->a_offset + 2];
    uint64_t tmp4 = accumulator[metric_set->a_offset + 7];
    uint64_t tmp5 = tmp3 + tmp4;
    uint64_t tmp6 = accumulator[metric_set->a_offset + 12];
    uint64_t tmp7 = tmp5 + tmp6;
    uint64_t tmp8 = accumulator[metric_set->a_offset + 17];
    uint64_t tmp9 = tmp7 + tmp8;
    uint64_t tmp10 = accumulator[metric_set->a_offset + 22];
    uint64_t tmp11 = tmp9 + tmp10;
    uint64_t tmp12 = accumulator[metric_set->a_offset + 27];
    uint64_t tmp13 = tmp11 + tmp12;
    uint64_t tmp14 = tmp2;
    uint64_t tmp15 = tmp13;
    uint64_t tmp16 = tmp15 ? tmp14 / tmp15 : 0;
    uint64_t tmp17 = accumulator[metric_set->a_offset + 23];
    uint64_t tmp18 = accumulator[metric_set->a_offset + 1];
    uint64_t tmp19 = tmp17 * tmp18;
    uint64_t tmp20 = accumulator[metric_set->a_offset + 3];
    uint64_t tmp21 = accumulator[metric_set->a_offset + 8];
    uint64_t tmp22 = tmp20 + tmp21;
    uint64_t tmp23 = accumulator[metric_set->a_offset + 13];
    uint64_t tmp24 = tmp22 + tmp23;
    uint64_t tmp25 = accumulator[metric_set->a_offset + 18];
    uint64_t tmp26 = tmp24 + tmp25;
    uint64_t tmp27 = accumulator[metric_set->a_offset + 23];
    uint64_t tmp28 = tmp26 + tmp27;
    uint64_t tmp29 = accumulator[metric_set->a_offset + 28];
    uint64_t tmp30 = tmp28 + tmp29;
    uint64_t tmp31 = tmp19;
    uint64_t tmp32 = tmp30;
    uint64_t tmp33 = tmp32 ? tmp31 / tmp32 : 0;
    uint64_t tmp34 = tmp16 + tmp33;
    uint64_t tmp35 = tmp34 * hsw__render_basic__gpu_time__read(perf, metric_set, accumulator);
    uint64_t tmp36 = hsw__render_basic__gpu_core_clocks__read(perf, metric_set, accumulator) * perf->devinfo.n_eus;
    uint64_t tmp37 = tmp36 * 1000;
    uint64_t tmp38 = tmp35;
    uint64_t tmp39 = tmp37;
    uint64_t tmp40 = tmp39 ? tmp38 / tmp39 : 0;

    return tmp40;
}

/* Render Metrics Basic Gen7.5 :: TES Duration */
static uint64_t
hsw__render_basic__ds_duration__read(const struct intel_perf *perf,
                                     const struct intel_perf_metric_set *metric_set,
                                     uint64_t *accumulator)
{
    /* RPN equation: A 12 READ  A 0 READ UMUL  A 2 READ  A 7 READ UADD  A 12 READ UADD  A 17 READ UADD  A 22 READ UADD  A 27 READ UADD UDIV  A 13 READ  A 1 READ UMUL  A 3 READ  A 8 READ UADD  A 13 READ UADD  A 18 READ UADD  A 23 READ UADD  A 28 READ UADD UDIV UADD $GpuTime UMUL $GpuCoreClocks $EuCoresTotalCount UMUL 1000 UMUL UDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 12];
    uint64_t tmp1 = accumulator[metric_set->a_offset + 0];
    uint64_t tmp2 = tmp0 * tmp1;
    uint64_t tmp3 = accumulator[metric_set->a_offset + 2];
    uint64_t tmp4 = accumulator[metric_set->a_offset + 7];
    uint64_t tmp5 = tmp3 + tmp4;
    uint64_t tmp6 = accumulator[metric_set->a_offset + 12];
    uint64_t tmp7 = tmp5 + tmp6;
    uint64_t tmp8 = accumulator[metric_set->a_offset + 17];
    uint64_t tmp9 = tmp7 + tmp8;
    uint64_t tmp10 = accumulator[metric_set->a_offset + 22];
    uint64_t tmp11 = tmp9 + tmp10;
    uint64_t tmp12 = accumulator[metric_set->a_offset + 27];
    uint64_t tmp13 = tmp11 + tmp12;
    uint64_t tmp14 = tmp2;
    uint64_t tmp15 = tmp13;
    uint64_t tmp16 = tmp15 ? tmp14 / tmp15 : 0;
    uint64_t tmp17 = accumulator[metric_set->a_offset + 13];
    uint64_t tmp18 = accumulator[metric_set->a_offset + 1];
    uint64_t tmp19 = tmp17 * tmp18;
    uint64_t tmp20 = accumulator[metric_set->a_offset + 3];
    uint64_t tmp21 = accumulator[metric_set->a_offset + 8];
    uint64_t tmp22 = tmp20 + tmp21;
    uint64_t tmp23 = accumulator[metric_set->a_offset + 13];
    uint64_t tmp24 = tmp22 + tmp23;
    uint64_t tmp25 = accumulator[metric_set->a_offset + 18];
    uint64_t tmp26 = tmp24 + tmp25;
    uint64_t tmp27 = accumulator[metric_set->a_offset + 23];
    uint64_t tmp28 = tmp26 + tmp27;
    uint64_t tmp29 = accumulator[metric_set->a_offset + 28];
    uint64_t tmp30 = tmp28 + tmp29;
    uint64_t tmp31 = tmp19;
    uint64_t tmp32 = tmp30;
    uint64_t tmp33 = tmp32 ? tmp31 / tmp32 : 0;
    uint64_t tmp34 = tmp16 + tmp33;
    uint64_t tmp35 = tmp34 * hsw__render_basic__gpu_time__read(perf, metric_set, accumulator);
    uint64_t tmp36 = hsw__render_basic__gpu_core_clocks__read(perf, metric_set, accumulator) * perf->devinfo.n_eus;
    uint64_t tmp37 = tmp36 * 1000;
    uint64_t tmp38 = tmp35;
    uint64_t tmp39 = tmp37;
    uint64_t tmp40 = tmp39 ? tmp38 / tmp39 : 0;

    return tmp40;
}

/* Render Metrics Basic Gen7.5 :: TCS Duration */
static uint64_t
hsw__render_basic__hs_duration__read(const struct intel_perf *perf,
                                     const struct intel_perf_metric_set *metric_set,
                                     uint64_t *accumulator)
{
    /* RPN equation: A 7 READ  A 0 READ UMUL  A 2 READ  A 7 READ UADD  A 12 READ UADD  A 17 READ UADD  A 22 READ UADD  A 27 READ UADD UDIV  A 8 READ  A 1 READ UMUL  A 3 READ  A 8 READ UADD  A 13 READ UADD  A 18 READ UADD  A 23 READ UADD  A 28 READ UADD UDIV UADD $GpuTime UMUL $GpuCoreClocks $EuCoresTotalCount UMUL 1000 UMUL UDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 7];
    uint64_t tmp1 = accumulator[metric_set->a_offset + 0];
    uint64_t tmp2 = tmp0 * tmp1;
    uint64_t tmp3 = accumulator[metric_set->a_offset + 2];
    uint64_t tmp4 = accumulator[metric_set->a_offset + 7];
    uint64_t tmp5 = tmp3 + tmp4;
    uint64_t tmp6 = accumulator[metric_set->a_offset + 12];
    uint64_t tmp7 = tmp5 + tmp6;
    uint64_t tmp8 = accumulator[metric_set->a_offset + 17];
    uint64_t tmp9 = tmp7 + tmp8;
    uint64_t tmp10 = accumulator[metric_set->a_offset + 22];
    uint64_t tmp11 = tmp9 + tmp10;
    uint64_t tmp12 = accumulator[metric_set->a_offset + 27];
    uint64_t tmp13 = tmp11 + tmp12;
    uint64_t tmp14 = tmp2;
    uint64_t tmp15 = tmp13;
    uint64_t tmp16 = tmp15 ? tmp14 / tmp15 : 0;
    uint64_t tmp17 = accumulator[metric_set->a_offset + 8];
    uint64_t tmp18 = accumulator[metric_set->a_offset + 1];
    uint64_t tmp19 = tmp17 * tmp18;
    uint64_t tmp20 = accumulator[metric_set->a_offset + 3];
    uint64_t tmp21 = accumulator[metric_set->a_offset + 8];
    uint64_t tmp22 = tmp20 + tmp21;
    uint64_t tmp23 = accumulator[metric_set->a_offset + 13];
    uint64_t tmp24 = tmp22 + tmp23;
    uint64_t tmp25 = accumulator[metric_set->a_offset + 18];
    uint64_t tmp26 = tmp24 + tmp25;
    uint64_t tmp27 = accumulator[metric_set->a_offset + 23];
    uint64_t tmp28 = tmp26 + tmp27;
    uint64_t tmp29 = accumulator[metric_set->a_offset + 28];
    uint64_t tmp30 = tmp28 + tmp29;
    uint64_t tmp31 = tmp19;
    uint64_t tmp32 = tmp30;
    uint64_t tmp33 = tmp32 ? tmp31 / tmp32 : 0;
    uint64_t tmp34 = tmp16 + tmp33;
    uint64_t tmp35 = tmp34 * hsw__render_basic__gpu_time__read(perf, metric_set, accumulator);
    uint64_t tmp36 = hsw__render_basic__gpu_core_clocks__read(perf, metric_set, accumulator) * perf->devinfo.n_eus;
    uint64_t tmp37 = tmp36 * 1000;
    uint64_t tmp38 = tmp35;
    uint64_t tmp39 = tmp37;
    uint64_t tmp40 = tmp39 ? tmp38 / tmp39 : 0;

    return tmp40;
}

/* Render Metrics Basic Gen7.5 :: CS Duration */
static uint64_t
hsw__render_basic__cs_duration__read(const struct intel_perf *perf,
                                     const struct intel_perf_metric_set *metric_set,
                                     uint64_t *accumulator)
{
    /* RPN equation: A 17 READ  A 0 READ UMUL  A 2 READ  A 7 READ UADD  A 12 READ UADD  A 17 READ UADD  A 22 READ UADD  A 27 READ UADD UDIV  A 18 READ  A 1 READ UMUL  A 3 READ  A 8 READ UADD  A 13 READ UADD  A 18 READ UADD  A 23 READ UADD  A 28 READ UADD UDIV UADD $GpuTime UMUL $GpuCoreClocks $EuCoresTotalCount UMUL 1000 UMUL UDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 17];
    uint64_t tmp1 = accumulator[metric_set->a_offset + 0];
    uint64_t tmp2 = tmp0 * tmp1;
    uint64_t tmp3 = accumulator[metric_set->a_offset + 2];
    uint64_t tmp4 = accumulator[metric_set->a_offset + 7];
    uint64_t tmp5 = tmp3 + tmp4;
    uint64_t tmp6 = accumulator[metric_set->a_offset + 12];
    uint64_t tmp7 = tmp5 + tmp6;
    uint64_t tmp8 = accumulator[metric_set->a_offset + 17];
    uint64_t tmp9 = tmp7 + tmp8;
    uint64_t tmp10 = accumulator[metric_set->a_offset + 22];
    uint64_t tmp11 = tmp9 + tmp10;
    uint64_t tmp12 = accumulator[metric_set->a_offset + 27];
    uint64_t tmp13 = tmp11 + tmp12;
    uint64_t tmp14 = tmp2;
    uint64_t tmp15 = tmp13;
    uint64_t tmp16 = tmp15 ? tmp14 / tmp15 : 0;
    uint64_t tmp17 = accumulator[metric_set->a_offset + 18];
    uint64_t tmp18 = accumulator[metric_set->a_offset + 1];
    uint64_t tmp19 = tmp17 * tmp18;
    uint64_t tmp20 = accumulator[metric_set->a_offset + 3];
    uint64_t tmp21 = accumulator[metric_set->a_offset + 8];
    uint64_t tmp22 = tmp20 + tmp21;
    uint64_t tmp23 = accumulator[metric_set->a_offset + 13];
    uint64_t tmp24 = tmp22 + tmp23;
    uint64_t tmp25 = accumulator[metric_set->a_offset + 18];
    uint64_t tmp26 = tmp24 + tmp25;
    uint64_t tmp27 = accumulator[metric_set->a_offset + 23];
    uint64_t tmp28 = tmp26 + tmp27;
    uint64_t tmp29 = accumulator[metric_set->a_offset + 28];
    uint64_t tmp30 = tmp28 + tmp29;
    uint64_t tmp31 = tmp19;
    uint64_t tmp32 = tmp30;
    uint64_t tmp33 = tmp32 ? tmp31 / tmp32 : 0;
    uint64_t tmp34 = tmp16 + tmp33;
    uint64_t tmp35 = tmp34 * hsw__render_basic__gpu_time__read(perf, metric_set, accumulator);
    uint64_t tmp36 = hsw__render_basic__gpu_core_clocks__read(perf, metric_set, accumulator) * perf->devinfo.n_eus;
    uint64_t tmp37 = tmp36 * 1000;
    uint64_t tmp38 = tmp35;
    uint64_t tmp39 = tmp37;
    uint64_t tmp40 = tmp39 ? tmp38 / tmp39 : 0;

    return tmp40;
}

/* Render Metrics Basic Gen7.5 :: Sampler Bottleneck */
static double
hsw__render_basic__sampler_bottleneck__read(const struct intel_perf *perf,
                                            const struct intel_perf_metric_set *metric_set,
                                            uint64_t *accumulator)
{
    /* RPN equation: $Sampler0Bottleneck $Sampler1Bottleneck FMAX */
    double tmp0 = hsw__render_basic__sampler0_bottleneck__read(perf, metric_set, accumulator);
    double tmp1 = hsw__render_basic__sampler1_bottleneck__read(perf, metric_set, accumulator);
    double tmp2 = MAX(tmp0, tmp1);

    return tmp2;
}

/* Render Metrics Basic Gen7.5 :: EU Idle */
static double
hsw__render_basic__eu_idle__read(const struct intel_perf *perf,
                                 const struct intel_perf_metric_set *metric_set,
                                 uint64_t *accumulator)
{
    /* RPN equation: 100 $EuActive $EuStall FADD FSUB */
    double tmp0 = hsw__render_basic__eu_active__read(perf, metric_set, accumulator) + hsw__render_basic__eu_stall__read(perf, metric_set, accumulator);
    double tmp1 = 100 - tmp0;

    return tmp1;
}

/* Compute Metrics Basic Gen7.5 :: GPU Time Elapsed */
#define hsw__compute_basic__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Compute Metrics Basic Gen7.5 :: GPU Core Clocks */
#define hsw__compute_basic__gpu_core_clocks__read \
    hsw__render_basic__gpu_core_clocks__read

/* Compute Metrics Basic Gen7.5 :: AVG GPU Core Frequency */
#define hsw__compute_basic__avg_gpu_core_frequency__read \
    hsw__render_basic__avg_gpu_core_frequency__read

/* Compute Metrics Basic Gen7.5 :: AVG GPU Core Frequency */
#define hsw__compute_basic__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Compute Metrics Basic Gen7.5 :: GPU Busy */
#define hsw__compute_basic__gpu_busy__read \
    hsw__render_basic__gpu_busy__read

/* Compute Metrics Basic Gen7.5 :: VS Threads Dispatched */
#define hsw__compute_basic__vs_threads__read \
    hsw__render_basic__vs_threads__read

/* Compute Metrics Basic Gen7.5 :: TCS Threads Dispatched */
#define hsw__compute_basic__hs_threads__read \
    hsw__render_basic__hs_threads__read

/* Compute Metrics Basic Gen7.5 :: TES Threads Dispatched */
#define hsw__compute_basic__ds_threads__read \
    hsw__render_basic__ds_threads__read

/* Compute Metrics Basic Gen7.5 :: GS Threads Dispatched */
#define hsw__compute_basic__gs_threads__read \
    hsw__render_basic__gs_threads__read

/* Compute Metrics Basic Gen7.5 :: FS Threads Dispatched */
#define hsw__compute_basic__ps_threads__read \
    hsw__render_basic__ps_threads__read

/* Compute Metrics Basic Gen7.5 :: CS Threads Dispatched */
#define hsw__compute_basic__cs_threads__read \
    hsw__render_basic__cs_threads__read

/* Compute Metrics Basic Gen7.5 :: EU Active */
#define hsw__compute_basic__eu_active__read \
    hsw__render_basic__eu_active__read

/* Compute Metrics Basic Gen7.5 :: EU Stall */
#define hsw__compute_basic__eu_stall__read \
    hsw__render_basic__eu_stall__read

/* Compute Metrics Basic Gen7.5 :: VS EU Active */
#define hsw__compute_basic__vs_eu_active__read \
    hsw__render_basic__vs_eu_active__read

/* Compute Metrics Basic Gen7.5 :: VS AVG Active per Thread */
#define hsw__compute_basic__vs_eu_active_per_thread__read \
    hsw__render_basic__vs_eu_active_per_thread__read

/* Compute Metrics Basic Gen7.5 :: VS EU Stall */
#define hsw__compute_basic__vs_eu_stall__read \
    hsw__render_basic__vs_eu_stall__read

/* Compute Metrics Basic Gen7.5 :: VS AVG Stall per Thread */
#define hsw__compute_basic__vs_eu_stall_per_thread__read \
    hsw__render_basic__vs_eu_stall_per_thread__read

/* Compute Metrics Basic Gen7.5 :: FS EU Active */
#define hsw__compute_basic__ps_eu_active__read \
    hsw__render_basic__ps_eu_active__read

/* Compute Metrics Basic Gen7.5 :: TCS EU Active */
#define hsw__compute_basic__hs_eu_active__read \
    hsw__render_basic__hs_eu_active__read

/* Compute Metrics Basic Gen7.5 :: TCS AVG Active per Thread */
#define hsw__compute_basic__hs_eu_active_per_thread__read \
    hsw__render_basic__hs_eu_active_per_thread__read

/* Compute Metrics Basic Gen7.5 :: TCS EU Stall */
#define hsw__compute_basic__hs_eu_stall__read \
    hsw__render_basic__hs_eu_stall__read

/* Compute Metrics Basic Gen7.5 :: TCS AVG Stall per Thread */
#define hsw__compute_basic__hs_eu_stall_per_thread__read \
    hsw__render_basic__hs_eu_stall_per_thread__read

/* Compute Metrics Basic Gen7.5 :: TES EU Active */
#define hsw__compute_basic__ds_eu_active__read \
    hsw__render_basic__ds_eu_active__read

/* Compute Metrics Basic Gen7.5 :: TES AVG Active per Thread */
#define hsw__compute_basic__ds_eu_active_per_thread__read \
    hsw__render_basic__ds_eu_active_per_thread__read

/* Compute Metrics Basic Gen7.5 :: TES EU Stall */
#define hsw__compute_basic__ds_eu_stall__read \
    hsw__render_basic__ds_eu_stall__read

/* Compute Metrics Basic Gen7.5 :: TES AVG Stall per Thread */
#define hsw__compute_basic__ds_eu_stall_per_thread__read \
    hsw__render_basic__ds_eu_stall_per_thread__read

/* Compute Metrics Basic Gen7.5 :: GS EU Active */
#define hsw__compute_basic__gs_eu_active__read \
    hsw__render_basic__gs_eu_active__read

/* Compute Metrics Basic Gen7.5 :: GS AVG Active per Thread */
#define hsw__compute_basic__gs_eu_active_per_thread__read \
    hsw__render_basic__gs_eu_active_per_thread__read

/* Compute Metrics Basic Gen7.5 :: GS EU Stall */
#define hsw__compute_basic__gs_eu_stall__read \
    hsw__render_basic__gs_eu_stall__read

/* Compute Metrics Basic Gen7.5 :: GS AVG Stall per Thread */
#define hsw__compute_basic__gs_eu_stall_per_thread__read \
    hsw__render_basic__gs_eu_stall_per_thread__read

/* Compute Metrics Basic Gen7.5 :: CS EU Active */
#define hsw__compute_basic__cs_eu_active__read \
    hsw__render_basic__cs_eu_active__read

/* Compute Metrics Basic Gen7.5 :: CS AVG Active per Thread */
#define hsw__compute_basic__cs_eu_active_per_thread__read \
    hsw__render_basic__cs_eu_active_per_thread__read

/* Compute Metrics Basic Gen7.5 :: CS EU Stall */
#define hsw__compute_basic__cs_eu_stall__read \
    hsw__render_basic__cs_eu_stall__read

/* Compute Metrics Basic Gen7.5 :: CS AVG Stall per Thread */
#define hsw__compute_basic__cs_eu_stall_per_thread__read \
    hsw__render_basic__cs_eu_stall_per_thread__read

/* Compute Metrics Basic Gen7.5 :: FS AVG Active per Thread */
#define hsw__compute_basic__ps_eu_active_per_thread__read \
    hsw__render_basic__ps_eu_active_per_thread__read

/* Compute Metrics Basic Gen7.5 :: FS EU Stall */
#define hsw__compute_basic__ps_eu_stall__read \
    hsw__render_basic__ps_eu_stall__read

/* Compute Metrics Basic Gen7.5 :: FS AVG Stall per Thread */
#define hsw__compute_basic__ps_eu_stall_per_thread__read \
    hsw__render_basic__ps_eu_stall_per_thread__read

/* Compute Metrics Basic Gen7.5 :: Early Hi-Depth Test Fails */
#define hsw__compute_basic__hi_depth_test_fails__read \
    hsw__render_basic__hi_depth_test_fails__read

/* Compute Metrics Basic Gen7.5 :: Early Depth Test Fails */
#define hsw__compute_basic__early_depth_test_fails__read \
    hsw__render_basic__early_depth_test_fails__read

/* Compute Metrics Basic Gen7.5 :: Samples Killed in FS */
#define hsw__compute_basic__samples_killed_in_ps__read \
    hsw__render_basic__samples_killed_in_ps__read

/* Compute Metrics Basic Gen7.5 :: Alpha Test Fails */
#define hsw__compute_basic__alpha_test_fails__read \
    hsw__render_basic__alpha_test_fails__read

/* Compute Metrics Basic Gen7.5 :: Late Stencil Test Fails */
#define hsw__compute_basic__post_ps_stencil_test_fails__read \
    hsw__render_basic__post_ps_stencil_test_fails__read

/* Compute Metrics Basic Gen7.5 :: Late Depth Test Fails */
#define hsw__compute_basic__post_ps_depth_test_fails__read \
    hsw__render_basic__post_ps_depth_test_fails__read

/* Compute Metrics Basic Gen7.5 :: Samples Written */
#define hsw__compute_basic__samples_written__read \
    hsw__render_basic__samples_written__read

/* Compute Metrics Basic Gen7.5 :: Typed Bytes Read */
static uint64_t
hsw__compute_basic__typed_bytes_read__read(const struct intel_perf *perf,
                                           const struct intel_perf_metric_set *metric_set,
                                           uint64_t *accumulator)
{
    /* RPN equation: B 4 READ B 5 READ UADD $EuSlicesTotalCount 64 UMUL UMUL */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 4];
    uint64_t tmp1 = accumulator[metric_set->b_offset + 5];
    uint64_t tmp2 = tmp0 + tmp1;
    uint64_t tmp3 = perf->devinfo.n_eu_slices * 64;
    uint64_t tmp4 = tmp2 * tmp3;

    return tmp4;
}

/* Compute Metrics Basic Gen7.5 :: Typed Bytes Read */
#define hsw__compute_basic__typed_bytes_read__max \
    hsw__render_basic__l3_sampler_throughput__max

/* Compute Metrics Basic Gen7.5 :: Typed Bytes Written */
static uint64_t
hsw__compute_basic__typed_bytes_written__read(const struct intel_perf *perf,
                                              const struct intel_perf_metric_set *metric_set,
                                              uint64_t *accumulator)
{
    /* RPN equation: B 6 READ B 7 READ UADD $EuSlicesTotalCount 64 UMUL UMUL */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 6];
    uint64_t tmp1 = accumulator[metric_set->b_offset + 7];
    uint64_t tmp2 = tmp0 + tmp1;
    uint64_t tmp3 = perf->devinfo.n_eu_slices * 64;
    uint64_t tmp4 = tmp2 * tmp3;

    return tmp4;
}

/* Compute Metrics Basic Gen7.5 :: Typed Bytes Written */
#define hsw__compute_basic__typed_bytes_written__max \
    hsw__render_basic__l3_sampler_throughput__max

/* Compute Metrics Basic Gen7.5 :: Typed Atomics */
static uint64_t
hsw__compute_basic__typed_atomics__read(const struct intel_perf *perf,
                                        const struct intel_perf_metric_set *metric_set,
                                        uint64_t *accumulator)
{
    /* RPN equation: C 0 READ C 1 READ UADD $EuSlicesTotalCount UMUL */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 0];
    uint64_t tmp1 = accumulator[metric_set->c_offset + 1];
    uint64_t tmp2 = tmp0 + tmp1;
    uint64_t tmp3 = tmp2 * perf->devinfo.n_eu_slices;

    return tmp3;
}

/* Compute Metrics Basic Gen7.5 :: Untyped Bytes Read */
static uint64_t
hsw__compute_basic__untyped_bytes_read__read(const struct intel_perf *perf,
                                             const struct intel_perf_metric_set *metric_set,
                                             uint64_t *accumulator)
{
    /* RPN equation: B 0 READ B 1 READ UADD $EuSlicesTotalCount 64 UMUL UMUL */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 0];
    uint64_t tmp1 = accumulator[metric_set->b_offset + 1];
    uint64_t tmp2 = tmp0 + tmp1;
    uint64_t tmp3 = perf->devinfo.n_eu_slices * 64;
    uint64_t tmp4 = tmp2 * tmp3;

    return tmp4;
}

/* Compute Metrics Basic Gen7.5 :: Untyped Bytes Read */
#define hsw__compute_basic__untyped_bytes_read__max \
    hsw__render_basic__l3_sampler_throughput__max

/* Compute Metrics Basic Gen7.5 :: Untyped Writes */
static uint64_t
hsw__compute_basic__untyped_bytes_written__read(const struct intel_perf *perf,
                                                const struct intel_perf_metric_set *metric_set,
                                                uint64_t *accumulator)
{
    /* RPN equation: B 2 READ B 3 READ UADD $EuSlicesTotalCount 64 UMUL UMUL */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 2];
    uint64_t tmp1 = accumulator[metric_set->b_offset + 3];
    uint64_t tmp2 = tmp0 + tmp1;
    uint64_t tmp3 = perf->devinfo.n_eu_slices * 64;
    uint64_t tmp4 = tmp2 * tmp3;

    return tmp4;
}

/* Compute Metrics Basic Gen7.5 :: Untyped Writes */
#define hsw__compute_basic__untyped_bytes_written__max \
    hsw__render_basic__l3_sampler_throughput__max

/* Compute Metrics Basic Gen7.5 :: SLM Bytes Read */
static uint64_t
hsw__compute_basic__slm_bytes_read__read(const struct intel_perf *perf,
                                         const struct intel_perf_metric_set *metric_set,
                                         uint64_t *accumulator)
{
    /* RPN equation: C 6 READ C 7 READ UADD $EuSlicesTotalCount 64 UMUL UMUL */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 6];
    uint64_t tmp1 = accumulator[metric_set->c_offset + 7];
    uint64_t tmp2 = tmp0 + tmp1;
    uint64_t tmp3 = perf->devinfo.n_eu_slices * 64;
    uint64_t tmp4 = tmp2 * tmp3;

    return tmp4;
}

/* Compute Metrics Basic Gen7.5 :: SLM Bytes Read */
#define hsw__compute_basic__slm_bytes_read__max \
    hsw__render_basic__l3_sampler_throughput__max

/* Compute Metrics Basic Gen7.5 :: SLM Bytes Written */
static uint64_t
hsw__compute_basic__slm_bytes_written__read(const struct intel_perf *perf,
                                            const struct intel_perf_metric_set *metric_set,
                                            uint64_t *accumulator)
{
    /* RPN equation: C 4 READ C 5 READ UADD $EuSlicesTotalCount 64 UMUL UMUL */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 4];
    uint64_t tmp1 = accumulator[metric_set->c_offset + 5];
    uint64_t tmp2 = tmp0 + tmp1;
    uint64_t tmp3 = perf->devinfo.n_eu_slices * 64;
    uint64_t tmp4 = tmp2 * tmp3;

    return tmp4;
}

/* Compute Metrics Basic Gen7.5 :: SLM Bytes Written */
#define hsw__compute_basic__slm_bytes_written__max \
    hsw__render_basic__l3_sampler_throughput__max

/* Compute Metrics Basic Gen7.5 :: LLC GPU Accesses */
#define hsw__compute_basic__llc_accesses__read \
    hsw__render_basic__llc_accesses__read

/* Compute Metrics Basic Gen7.5 :: LLC GPU Hits */
#define hsw__compute_basic__llc_hits__read \
    hsw__render_basic__llc_hits__read

/* Compute Metrics Extended Gen7.5 :: GPU Time Elapsed */
#define hsw__compute_extended__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Compute Metrics Extended Gen7.5 :: GPU Core Clocks */
static uint64_t
hsw__compute_extended__gpu_clocks__read(const struct intel_perf *perf,
                                        const struct intel_perf_metric_set *metric_set,
                                        uint64_t *accumulator)
{
    /* RPN equation: B 7 READ */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 7];

    return tmp0;
}

/* Compute Metrics Extended Gen7.5 :: CS Threads Dispatched */
#define hsw__compute_extended__cs_threads__read \
    hsw__render_basic__cs_threads__read

/* Compute Metrics Extended Gen7.5 :: EuUntypedReads0 */
static uint64_t
hsw__compute_extended__eu_untyped_reads0__read(const struct intel_perf *perf,
                                               const struct intel_perf_metric_set *metric_set,
                                               uint64_t *accumulator)
{
    /* RPN equation: B 0 READ */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 0];

    return tmp0;
}

/* Compute Metrics Extended Gen7.5 :: EuTypedReads0 */
static uint64_t
hsw__compute_extended__eu_typed_reads0__read(const struct intel_perf *perf,
                                             const struct intel_perf_metric_set *metric_set,
                                             uint64_t *accumulator)
{
    /* RPN equation: B 2 READ */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 2];

    return tmp0;
}

/* Compute Metrics Extended Gen7.5 :: EuUntypedWrites0 */
static uint64_t
hsw__compute_extended__eu_untyped_writes0__read(const struct intel_perf *perf,
                                                const struct intel_perf_metric_set *metric_set,
                                                uint64_t *accumulator)
{
    /* RPN equation: B 1 READ */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 1];

    return tmp0;
}

/* Compute Metrics Extended Gen7.5 :: EuTypedWrites0 */
static uint64_t
hsw__compute_extended__eu_typed_writes0__read(const struct intel_perf *perf,
                                              const struct intel_perf_metric_set *metric_set,
                                              uint64_t *accumulator)
{
    /* RPN equation: B 3 READ */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 3];

    return tmp0;
}

/* Compute Metrics Extended Gen7.5 :: EuUntypedAtomics0 */
static uint64_t
hsw__compute_extended__eu_untyped_atomics0__read(const struct intel_perf *perf,
                                                 const struct intel_perf_metric_set *metric_set,
                                                 uint64_t *accumulator)
{
    /* RPN equation: B 4 READ */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 4];

    return tmp0;
}

/* Compute Metrics Extended Gen7.5 :: EuTypedAtomics0 */
static uint64_t
hsw__compute_extended__eu_typed_atomics0__read(const struct intel_perf *perf,
                                               const struct intel_perf_metric_set *metric_set,
                                               uint64_t *accumulator)
{
    /* RPN equation: B 5 READ */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 5];

    return tmp0;
}

/* Compute Metrics Extended Gen7.5 :: EuUrbAtomics0 */
static uint64_t
hsw__compute_extended__eu_urb_atomics0__read(const struct intel_perf *perf,
                                             const struct intel_perf_metric_set *metric_set,
                                             uint64_t *accumulator)
{
    /* RPN equation: B 6 READ */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 6];

    return tmp0;
}

/* Compute Metrics Extended Gen7.5 :: Typed Reads 0 */
#define hsw__compute_extended__typed_reads0__read \
    hsw__render_basic__gpu_core_clocks__read

/* Compute Metrics Extended Gen7.5 :: Typed Writes 0 */
static uint64_t
hsw__compute_extended__typed_writes0__read(const struct intel_perf *perf,
                                           const struct intel_perf_metric_set *metric_set,
                                           uint64_t *accumulator)
{
    /* RPN equation: C 0 READ */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 0];

    return tmp0;
}

/* Compute Metrics Extended Gen7.5 :: Untyped Reads 0 */
static uint64_t
hsw__compute_extended__untyped_reads0__read(const struct intel_perf *perf,
                                            const struct intel_perf_metric_set *metric_set,
                                            uint64_t *accumulator)
{
    /* RPN equation: C 3 READ */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 3];

    return tmp0;
}

/* Compute Metrics Extended Gen7.5 :: Untyped Writes 0 */
static uint64_t
hsw__compute_extended__untyped_writes0__read(const struct intel_perf *perf,
                                             const struct intel_perf_metric_set *metric_set,
                                             uint64_t *accumulator)
{
    /* RPN equation: C 1 READ */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 1];

    return tmp0;
}

/* Compute Metrics Extended Gen7.5 :: Typed Atomics 0 */
static uint64_t
hsw__compute_extended__typed_atomics0__read(const struct intel_perf *perf,
                                            const struct intel_perf_metric_set *metric_set,
                                            uint64_t *accumulator)
{
    /* RPN equation: C 4 READ */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 4];

    return tmp0;
}

/* Compute Metrics Extended Gen7.5 :: TypedReadsPerCacheLine */
static double
hsw__compute_extended__typed_reads_per_cache_line__read(const struct intel_perf *perf,
                                                        const struct intel_perf_metric_set *metric_set,
                                                        uint64_t *accumulator)
{
    /* RPN equation: $EuTypedReads0 $TypedReads0 FDIV */
    double tmp0 = hsw__compute_extended__eu_typed_reads0__read(perf, metric_set, accumulator);
    double tmp1 = hsw__compute_extended__typed_reads0__read(perf, metric_set, accumulator);
    double tmp2 = tmp1 ? tmp0 / tmp1 : 0;

    return tmp2;
}

/* Compute Metrics Extended Gen7.5 :: TypedWritesPerCacheLine */
static double
hsw__compute_extended__typed_writes_per_cache_line__read(const struct intel_perf *perf,
                                                         const struct intel_perf_metric_set *metric_set,
                                                         uint64_t *accumulator)
{
    /* RPN equation: $EuTypedWrites0 $TypedWrites0 FDIV */
    double tmp0 = hsw__compute_extended__eu_typed_writes0__read(perf, metric_set, accumulator);
    double tmp1 = hsw__compute_extended__typed_writes0__read(perf, metric_set, accumulator);
    double tmp2 = tmp1 ? tmp0 / tmp1 : 0;

    return tmp2;
}

/* Compute Metrics Extended Gen7.5 :: UntypedReadsPerCacheLine */
static double
hsw__compute_extended__untyped_reads_per_cache_line__read(const struct intel_perf *perf,
                                                          const struct intel_perf_metric_set *metric_set,
                                                          uint64_t *accumulator)
{
    /* RPN equation: $EuUntypedReads0 $UntypedReads0 FDIV */
    double tmp0 = hsw__compute_extended__eu_untyped_reads0__read(perf, metric_set, accumulator);
    double tmp1 = hsw__compute_extended__untyped_reads0__read(perf, metric_set, accumulator);
    double tmp2 = tmp1 ? tmp0 / tmp1 : 0;

    return tmp2;
}

/* Compute Metrics Extended Gen7.5 :: UntypedWritesPerCacheLine */
static double
hsw__compute_extended__untyped_writes_per_cache_line__read(const struct intel_perf *perf,
                                                           const struct intel_perf_metric_set *metric_set,
                                                           uint64_t *accumulator)
{
    /* RPN equation: $EuUntypedWrites0 $UntypedWrites0 FDIV */
    double tmp0 = hsw__compute_extended__eu_untyped_writes0__read(perf, metric_set, accumulator);
    double tmp1 = hsw__compute_extended__untyped_writes0__read(perf, metric_set, accumulator);
    double tmp2 = tmp1 ? tmp0 / tmp1 : 0;

    return tmp2;
}

/* Compute Metrics Extended Gen7.5 :: TypedAtomicsPerCacheLine */
static double
hsw__compute_extended__typed_atomics_per_cache_line__read(const struct intel_perf *perf,
                                                          const struct intel_perf_metric_set *metric_set,
                                                          uint64_t *accumulator)
{
    /* RPN equation: $EuTypedAtomics0 $TypedAtomics0 FDIV */
    double tmp0 = hsw__compute_extended__eu_typed_atomics0__read(perf, metric_set, accumulator);
    double tmp1 = hsw__compute_extended__typed_atomics0__read(perf, metric_set, accumulator);
    double tmp2 = tmp1 ? tmp0 / tmp1 : 0;

    return tmp2;
}

/* Compute Metrics Extended Gen7.5 :: LLC GPU Accesses */
#define hsw__compute_extended__llc_accesses__read \
    hsw__render_basic__llc_accesses__read

/* Compute Metrics Extended Gen7.5 :: LLC GPU Hits */
#define hsw__compute_extended__llc_hits__read \
    hsw__render_basic__llc_hits__read

/* Memory Reads Distribution Gen7.5 :: GPU Time Elapsed */
#define hsw__memory_reads__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Memory Reads Distribution Gen7.5 :: GPU Core Clocks */
static uint64_t
hsw__memory_reads__gpu_core_clocks__read(const struct intel_perf *perf,
                                         const struct intel_perf_metric_set *metric_set,
                                         uint64_t *accumulator)
{
    /* RPN equation: C 7 READ */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 7];

    return tmp0;
}

/* Memory Reads Distribution Gen7.5 :: AVG GPU Core Frequency */
static uint64_t
hsw__memory_reads__avg_gpu_core_frequency__read(const struct intel_perf *perf,
                                                const struct intel_perf_metric_set *metric_set,
                                                uint64_t *accumulator)
{
    /* RPN equation: $GpuCoreClocks 1000000000 UMUL $GpuTime UDIV */
    uint64_t tmp0 = hsw__memory_reads__gpu_core_clocks__read(perf, metric_set, accumulator) * 1000000000;
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = hsw__memory_reads__gpu_time__read(perf, metric_set, accumulator);
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;

    return tmp3;
}

/* Memory Reads Distribution Gen7.5 :: AVG GPU Core Frequency */
#define hsw__memory_reads__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Memory Reads Distribution Gen7.5 :: GPU Busy */
static double
hsw__memory_reads__gpu_busy__read(const struct intel_perf *perf,
                                  const struct intel_perf_metric_set *metric_set,
                                  uint64_t *accumulator)
{
    /* RPN equation: A 41 READ 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 41];
    uint64_t tmp1 = tmp0 * 100;
    double tmp2 = tmp1;
    double tmp3 = hsw__memory_reads__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp4 = tmp3 ? tmp2 / tmp3 : 0;

    return tmp4;
}

/* Memory Reads Distribution Gen7.5 :: VS Threads Dispatched */
#define hsw__memory_reads__vs_threads__read \
    hsw__render_basic__vs_threads__read

/* Memory Reads Distribution Gen7.5 :: TCS Threads Dispatched */
#define hsw__memory_reads__hs_threads__read \
    hsw__render_basic__hs_threads__read

/* Memory Reads Distribution Gen7.5 :: TES Threads Dispatched */
#define hsw__memory_reads__ds_threads__read \
    hsw__render_basic__ds_threads__read

/* Memory Reads Distribution Gen7.5 :: GS Threads Dispatched */
#define hsw__memory_reads__gs_threads__read \
    hsw__render_basic__gs_threads__read

/* Memory Reads Distribution Gen7.5 :: FS Threads Dispatched */
#define hsw__memory_reads__ps_threads__read \
    hsw__render_basic__ps_threads__read

/* Memory Reads Distribution Gen7.5 :: CS Threads Dispatched */
#define hsw__memory_reads__cs_threads__read \
    hsw__render_basic__cs_threads__read

/* Memory Reads Distribution Gen7.5 :: EU Active */
static double
hsw__memory_reads__eu_active__read(const struct intel_perf *perf,
                                   const struct intel_perf_metric_set *metric_set,
                                   uint64_t *accumulator)
{
    /* RPN equation: A 0 READ $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 0];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = perf->devinfo.n_eus;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    uint64_t tmp4 = tmp3 * 100;
    double tmp5 = tmp4;
    double tmp6 = hsw__memory_reads__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp7 = tmp6 ? tmp5 / tmp6 : 0;

    return tmp7;
}

/* Memory Reads Distribution Gen7.5 :: EU Stall */
static double
hsw__memory_reads__eu_stall__read(const struct intel_perf *perf,
                                  const struct intel_perf_metric_set *metric_set,
                                  uint64_t *accumulator)
{
    /* RPN equation: A 1 READ $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 1];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = perf->devinfo.n_eus;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    uint64_t tmp4 = tmp3 * 100;
    double tmp5 = tmp4;
    double tmp6 = hsw__memory_reads__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp7 = tmp6 ? tmp5 / tmp6 : 0;

    return tmp7;
}

/* Memory Reads Distribution Gen7.5 :: VS EU Active */
static double
hsw__memory_reads__vs_eu_active__read(const struct intel_perf *perf,
                                      const struct intel_perf_metric_set *metric_set,
                                      uint64_t *accumulator)
{
    /* RPN equation: A 2 READ $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 2];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = perf->devinfo.n_eus;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    uint64_t tmp4 = tmp3 * 100;
    double tmp5 = tmp4;
    double tmp6 = hsw__memory_reads__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp7 = tmp6 ? tmp5 / tmp6 : 0;

    return tmp7;
}

/* Memory Reads Distribution Gen7.5 :: VS AVG Active per Thread */
#define hsw__memory_reads__vs_eu_active_per_thread__read \
    hsw__render_basic__vs_eu_active_per_thread__read

/* Memory Reads Distribution Gen7.5 :: VS EU Stall */
static double
hsw__memory_reads__vs_eu_stall__read(const struct intel_perf *perf,
                                     const struct intel_perf_metric_set *metric_set,
                                     uint64_t *accumulator)
{
    /* RPN equation: A 3 READ $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 3];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = perf->devinfo.n_eus;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    uint64_t tmp4 = tmp3 * 100;
    double tmp5 = tmp4;
    double tmp6 = hsw__memory_reads__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp7 = tmp6 ? tmp5 / tmp6 : 0;

    return tmp7;
}

/* Memory Reads Distribution Gen7.5 :: VS AVG Stall per Thread */
#define hsw__memory_reads__vs_eu_stall_per_thread__read \
    hsw__render_basic__vs_eu_stall_per_thread__read

/* Memory Reads Distribution Gen7.5 :: TCS EU Active */
static double
hsw__memory_reads__hs_eu_active__read(const struct intel_perf *perf,
                                      const struct intel_perf_metric_set *metric_set,
                                      uint64_t *accumulator)
{
    /* RPN equation: A 7 READ $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 7];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = perf->devinfo.n_eus;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    uint64_t tmp4 = tmp3 * 100;
    double tmp5 = tmp4;
    double tmp6 = hsw__memory_reads__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp7 = tmp6 ? tmp5 / tmp6 : 0;

    return tmp7;
}

/* Memory Reads Distribution Gen7.5 :: TCS AVG Active per Thread */
#define hsw__memory_reads__hs_eu_active_per_thread__read \
    hsw__render_basic__hs_eu_active_per_thread__read

/* Memory Reads Distribution Gen7.5 :: TCS EU Stall */
static double
hsw__memory_reads__hs_eu_stall__read(const struct intel_perf *perf,
                                     const struct intel_perf_metric_set *metric_set,
                                     uint64_t *accumulator)
{
    /* RPN equation: A 8 READ $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 8];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = perf->devinfo.n_eus;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    uint64_t tmp4 = tmp3 * 100;
    double tmp5 = tmp4;
    double tmp6 = hsw__memory_reads__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp7 = tmp6 ? tmp5 / tmp6 : 0;

    return tmp7;
}

/* Memory Reads Distribution Gen7.5 :: TCS AVG Stall per Thread */
#define hsw__memory_reads__hs_eu_stall_per_thread__read \
    hsw__render_basic__hs_eu_stall_per_thread__read

/* Memory Reads Distribution Gen7.5 :: TES EU Active */
static double
hsw__memory_reads__ds_eu_active__read(const struct intel_perf *perf,
                                      const struct intel_perf_metric_set *metric_set,
                                      uint64_t *accumulator)
{
    /* RPN equation: A 12 READ $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 12];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = perf->devinfo.n_eus;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    uint64_t tmp4 = tmp3 * 100;
    double tmp5 = tmp4;
    double tmp6 = hsw__memory_reads__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp7 = tmp6 ? tmp5 / tmp6 : 0;

    return tmp7;
}

/* Memory Reads Distribution Gen7.5 :: TES AVG Active per Thread */
#define hsw__memory_reads__ds_eu_active_per_thread__read \
    hsw__render_basic__ds_eu_active_per_thread__read

/* Memory Reads Distribution Gen7.5 :: TES EU Stall */
static double
hsw__memory_reads__ds_eu_stall__read(const struct intel_perf *perf,
                                     const struct intel_perf_metric_set *metric_set,
                                     uint64_t *accumulator)
{
    /* RPN equation: A 13 READ $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 13];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = perf->devinfo.n_eus;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    uint64_t tmp4 = tmp3 * 100;
    double tmp5 = tmp4;
    double tmp6 = hsw__memory_reads__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp7 = tmp6 ? tmp5 / tmp6 : 0;

    return tmp7;
}

/* Memory Reads Distribution Gen7.5 :: TES AVG Stall per Thread */
#define hsw__memory_reads__ds_eu_stall_per_thread__read \
    hsw__render_basic__ds_eu_stall_per_thread__read

/* Memory Reads Distribution Gen7.5 :: GS EU Active */
static double
hsw__memory_reads__gs_eu_active__read(const struct intel_perf *perf,
                                      const struct intel_perf_metric_set *metric_set,
                                      uint64_t *accumulator)
{
    /* RPN equation: A 22 READ $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 22];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = perf->devinfo.n_eus;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    uint64_t tmp4 = tmp3 * 100;
    double tmp5 = tmp4;
    double tmp6 = hsw__memory_reads__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp7 = tmp6 ? tmp5 / tmp6 : 0;

    return tmp7;
}

/* Memory Reads Distribution Gen7.5 :: GS AVG Active per Thread */
#define hsw__memory_reads__gs_eu_active_per_thread__read \
    hsw__render_basic__gs_eu_active_per_thread__read

/* Memory Reads Distribution Gen7.5 :: GS EU Stall */
static double
hsw__memory_reads__gs_eu_stall__read(const struct intel_perf *perf,
                                     const struct intel_perf_metric_set *metric_set,
                                     uint64_t *accumulator)
{
    /* RPN equation: A 23 READ $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 23];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = perf->devinfo.n_eus;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    uint64_t tmp4 = tmp3 * 100;
    double tmp5 = tmp4;
    double tmp6 = hsw__memory_reads__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp7 = tmp6 ? tmp5 / tmp6 : 0;

    return tmp7;
}

/* Memory Reads Distribution Gen7.5 :: GS AVG Stall per Thread */
#define hsw__memory_reads__gs_eu_stall_per_thread__read \
    hsw__render_basic__gs_eu_stall_per_thread__read

/* Memory Reads Distribution Gen7.5 :: CS EU Active */
static double
hsw__memory_reads__cs_eu_active__read(const struct intel_perf *perf,
                                      const struct intel_perf_metric_set *metric_set,
                                      uint64_t *accumulator)
{
    /* RPN equation: A 17 READ $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 17];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = perf->devinfo.n_eus;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    uint64_t tmp4 = tmp3 * 100;
    double tmp5 = tmp4;
    double tmp6 = hsw__memory_reads__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp7 = tmp6 ? tmp5 / tmp6 : 0;

    return tmp7;
}

/* Memory Reads Distribution Gen7.5 :: CS AVG Active per Thread */
#define hsw__memory_reads__cs_eu_active_per_thread__read \
    hsw__render_basic__cs_eu_active_per_thread__read

/* Memory Reads Distribution Gen7.5 :: CS EU Stall */
static double
hsw__memory_reads__cs_eu_stall__read(const struct intel_perf *perf,
                                     const struct intel_perf_metric_set *metric_set,
                                     uint64_t *accumulator)
{
    /* RPN equation: A 18 READ $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 18];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = perf->devinfo.n_eus;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    uint64_t tmp4 = tmp3 * 100;
    double tmp5 = tmp4;
    double tmp6 = hsw__memory_reads__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp7 = tmp6 ? tmp5 / tmp6 : 0;

    return tmp7;
}

/* Memory Reads Distribution Gen7.5 :: CS AVG Stall per Thread */
#define hsw__memory_reads__cs_eu_stall_per_thread__read \
    hsw__render_basic__cs_eu_stall_per_thread__read

/* Memory Reads Distribution Gen7.5 :: FS EU Active */
static double
hsw__memory_reads__ps_eu_active__read(const struct intel_perf *perf,
                                      const struct intel_perf_metric_set *metric_set,
                                      uint64_t *accumulator)
{
    /* RPN equation: A 27 READ $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 27];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = perf->devinfo.n_eus;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    uint64_t tmp4 = tmp3 * 100;
    double tmp5 = tmp4;
    double tmp6 = hsw__memory_reads__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp7 = tmp6 ? tmp5 / tmp6 : 0;

    return tmp7;
}

/* Memory Reads Distribution Gen7.5 :: FS AVG Active per Thread */
#define hsw__memory_reads__ps_eu_active_per_thread__read \
    hsw__render_basic__ps_eu_active_per_thread__read

/* Memory Reads Distribution Gen7.5 :: FS EU Stall */
static double
hsw__memory_reads__ps_eu_stall__read(const struct intel_perf *perf,
                                     const struct intel_perf_metric_set *metric_set,
                                     uint64_t *accumulator)
{
    /* RPN equation: A 28 READ $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 28];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = perf->devinfo.n_eus;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    uint64_t tmp4 = tmp3 * 100;
    double tmp5 = tmp4;
    double tmp6 = hsw__memory_reads__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp7 = tmp6 ? tmp5 / tmp6 : 0;

    return tmp7;
}

/* Memory Reads Distribution Gen7.5 :: FS AVG Stall per Thread */
#define hsw__memory_reads__ps_eu_stall_per_thread__read \
    hsw__render_basic__ps_eu_stall_per_thread__read

/* Memory Reads Distribution Gen7.5 :: Early Hi-Depth Test Fails */
#define hsw__memory_reads__hi_depth_test_fails__read \
    hsw__render_basic__hi_depth_test_fails__read

/* Memory Reads Distribution Gen7.5 :: Early Depth Test Fails */
#define hsw__memory_reads__early_depth_test_fails__read \
    hsw__render_basic__early_depth_test_fails__read

/* Memory Reads Distribution Gen7.5 :: Samples Killed in FS */
#define hsw__memory_reads__samples_killed_in_ps__read \
    hsw__render_basic__samples_killed_in_ps__read

/* Memory Reads Distribution Gen7.5 :: Alpha Test Fails */
#define hsw__memory_reads__alpha_test_fails__read \
    hsw__render_basic__alpha_test_fails__read

/* Memory Reads Distribution Gen7.5 :: Late Stencil Test Fails */
#define hsw__memory_reads__post_ps_stencil_test_fails__read \
    hsw__render_basic__post_ps_stencil_test_fails__read

/* Memory Reads Distribution Gen7.5 :: Late Depth Test Fails */
#define hsw__memory_reads__post_ps_depth_test_fails__read \
    hsw__render_basic__post_ps_depth_test_fails__read

/* Memory Reads Distribution Gen7.5 :: Samples Written */
#define hsw__memory_reads__samples_written__read \
    hsw__render_basic__samples_written__read

/* Memory Reads Distribution Gen7.5 :: GtiCmdStreamerMemoryReads */
#define hsw__memory_reads__gti_cmd_streamer_memory_reads__read \
    hsw__compute_extended__eu_untyped_reads0__read

/* Memory Reads Distribution Gen7.5 :: GtiRsMemoryReads */
#define hsw__memory_reads__gti_rs_memory_reads__read \
    hsw__compute_extended__eu_typed_reads0__read

/* Memory Reads Distribution Gen7.5 :: GtiVfMemoryReads */
#define hsw__memory_reads__gti_vf_memory_reads__read \
    hsw__compute_extended__eu_untyped_writes0__read

/* Memory Reads Distribution Gen7.5 :: GtiRccMemoryReads */
#define hsw__memory_reads__gti_rcc_memory_reads__read \
    hsw__compute_extended__eu_typed_writes0__read

/* Memory Reads Distribution Gen7.5 :: GtiMscMemoryReads */
#define hsw__memory_reads__gti_msc_memory_reads__read \
    hsw__compute_extended__eu_untyped_atomics0__read

/* Memory Reads Distribution Gen7.5 :: GtiHiDepthMemoryReads */
#define hsw__memory_reads__gti_hi_depth_memory_reads__read \
    hsw__compute_extended__eu_typed_atomics0__read

/* Memory Reads Distribution Gen7.5 :: GtiStcMemoryReads */
#define hsw__memory_reads__gti_stc_memory_reads__read \
    hsw__compute_extended__eu_urb_atomics0__read

/* Memory Reads Distribution Gen7.5 :: GtiRczMemoryReads */
#define hsw__memory_reads__gti_rcz_memory_reads__read \
    hsw__compute_extended__gpu_clocks__read

/* Memory Reads Distribution Gen7.5 :: GtiL3Reads */
#define hsw__memory_reads__gti_l3_reads__read \
    hsw__compute_extended__typed_atomics0__read

/* Memory Reads Distribution Gen7.5 :: GtiMemoryReads */
static uint64_t
hsw__memory_reads__gti_memory_reads__read(const struct intel_perf *perf,
                                          const struct intel_perf_metric_set *metric_set,
                                          uint64_t *accumulator)
{
    /* RPN equation: C 5 READ */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 5];

    return tmp0;
}

/* Memory Reads Distribution Gen7.5 :: LLC GPU Read Accesses */
static uint64_t
hsw__memory_reads__llc_read_accesses__read(const struct intel_perf *perf,
                                           const struct intel_perf_metric_set *metric_set,
                                           uint64_t *accumulator)
{
    /* RPN equation: C 6 READ */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 6];

    return tmp0;
}

/* Memory Reads Distribution Gen7.5 :: LLC GPU Accesses */
#define hsw__memory_reads__llc_accesses__read \
    hsw__render_basic__llc_accesses__read

/* Memory Reads Distribution Gen7.5 :: LLC GPU Hits */
#define hsw__memory_reads__llc_hits__read \
    hsw__render_basic__llc_hits__read

/* Memory Writes Distribution Gen7.5 :: GPU Time Elapsed */
#define hsw__memory_writes__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Memory Writes Distribution Gen7.5 :: GPU Core Clocks */
#define hsw__memory_writes__gpu_core_clocks__read \
    hsw__memory_reads__gpu_core_clocks__read

/* Memory Writes Distribution Gen7.5 :: AVG GPU Core Frequency */
#define hsw__memory_writes__avg_gpu_core_frequency__read \
    hsw__memory_reads__avg_gpu_core_frequency__read

/* Memory Writes Distribution Gen7.5 :: AVG GPU Core Frequency */
#define hsw__memory_writes__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Memory Writes Distribution Gen7.5 :: GPU Busy */
#define hsw__memory_writes__gpu_busy__read \
    hsw__memory_reads__gpu_busy__read

/* Memory Writes Distribution Gen7.5 :: VS Threads Dispatched */
#define hsw__memory_writes__vs_threads__read \
    hsw__render_basic__vs_threads__read

/* Memory Writes Distribution Gen7.5 :: TCS Threads Dispatched */
#define hsw__memory_writes__hs_threads__read \
    hsw__render_basic__hs_threads__read

/* Memory Writes Distribution Gen7.5 :: TES Threads Dispatched */
#define hsw__memory_writes__ds_threads__read \
    hsw__render_basic__ds_threads__read

/* Memory Writes Distribution Gen7.5 :: GS Threads Dispatched */
#define hsw__memory_writes__gs_threads__read \
    hsw__render_basic__gs_threads__read

/* Memory Writes Distribution Gen7.5 :: FS Threads Dispatched */
#define hsw__memory_writes__ps_threads__read \
    hsw__render_basic__ps_threads__read

/* Memory Writes Distribution Gen7.5 :: CS Threads Dispatched */
#define hsw__memory_writes__cs_threads__read \
    hsw__render_basic__cs_threads__read

/* Memory Writes Distribution Gen7.5 :: EU Active */
#define hsw__memory_writes__eu_active__read \
    hsw__memory_reads__eu_active__read

/* Memory Writes Distribution Gen7.5 :: EU Stall */
#define hsw__memory_writes__eu_stall__read \
    hsw__memory_reads__eu_stall__read

/* Memory Writes Distribution Gen7.5 :: VS EU Active */
#define hsw__memory_writes__vs_eu_active__read \
    hsw__memory_reads__vs_eu_active__read

/* Memory Writes Distribution Gen7.5 :: VS AVG Active per Thread */
#define hsw__memory_writes__vs_eu_active_per_thread__read \
    hsw__render_basic__vs_eu_active_per_thread__read

/* Memory Writes Distribution Gen7.5 :: VS EU Stall */
#define hsw__memory_writes__vs_eu_stall__read \
    hsw__memory_reads__vs_eu_stall__read

/* Memory Writes Distribution Gen7.5 :: VS AVG Stall per Thread */
#define hsw__memory_writes__vs_eu_stall_per_thread__read \
    hsw__render_basic__vs_eu_stall_per_thread__read

/* Memory Writes Distribution Gen7.5 :: TCS EU Active */
#define hsw__memory_writes__hs_eu_active__read \
    hsw__memory_reads__hs_eu_active__read

/* Memory Writes Distribution Gen7.5 :: TCS AVG Active per Thread */
#define hsw__memory_writes__hs_eu_active_per_thread__read \
    hsw__render_basic__hs_eu_active_per_thread__read

/* Memory Writes Distribution Gen7.5 :: TCS EU Stall */
#define hsw__memory_writes__hs_eu_stall__read \
    hsw__memory_reads__hs_eu_stall__read

/* Memory Writes Distribution Gen7.5 :: TCS AVG Stall per Thread */
#define hsw__memory_writes__hs_eu_stall_per_thread__read \
    hsw__render_basic__hs_eu_stall_per_thread__read

/* Memory Writes Distribution Gen7.5 :: TES EU Active */
#define hsw__memory_writes__ds_eu_active__read \
    hsw__memory_reads__ds_eu_active__read

/* Memory Writes Distribution Gen7.5 :: TES AVG Active per Thread */
#define hsw__memory_writes__ds_eu_active_per_thread__read \
    hsw__render_basic__ds_eu_active_per_thread__read

/* Memory Writes Distribution Gen7.5 :: TES EU Stall */
#define hsw__memory_writes__ds_eu_stall__read \
    hsw__memory_reads__ds_eu_stall__read

/* Memory Writes Distribution Gen7.5 :: TES AVG Stall per Thread */
#define hsw__memory_writes__ds_eu_stall_per_thread__read \
    hsw__render_basic__ds_eu_stall_per_thread__read

/* Memory Writes Distribution Gen7.5 :: GS EU Active */
#define hsw__memory_writes__gs_eu_active__read \
    hsw__memory_reads__gs_eu_active__read

/* Memory Writes Distribution Gen7.5 :: GS AVG Active per Thread */
#define hsw__memory_writes__gs_eu_active_per_thread__read \
    hsw__render_basic__gs_eu_active_per_thread__read

/* Memory Writes Distribution Gen7.5 :: GS EU Stall */
#define hsw__memory_writes__gs_eu_stall__read \
    hsw__memory_reads__gs_eu_stall__read

/* Memory Writes Distribution Gen7.5 :: GS AVG Stall per Thread */
#define hsw__memory_writes__gs_eu_stall_per_thread__read \
    hsw__render_basic__gs_eu_stall_per_thread__read

/* Memory Writes Distribution Gen7.5 :: CS EU Active */
#define hsw__memory_writes__cs_eu_active__read \
    hsw__memory_reads__cs_eu_active__read

/* Memory Writes Distribution Gen7.5 :: CS AVG Active per Thread */
#define hsw__memory_writes__cs_eu_active_per_thread__read \
    hsw__render_basic__cs_eu_active_per_thread__read

/* Memory Writes Distribution Gen7.5 :: CS EU Stall */
#define hsw__memory_writes__cs_eu_stall__read \
    hsw__memory_reads__cs_eu_stall__read

/* Memory Writes Distribution Gen7.5 :: CS AVG Stall per Thread */
#define hsw__memory_writes__cs_eu_stall_per_thread__read \
    hsw__render_basic__cs_eu_stall_per_thread__read

/* Memory Writes Distribution Gen7.5 :: FS EU Active */
#define hsw__memory_writes__ps_eu_active__read \
    hsw__memory_reads__ps_eu_active__read

/* Memory Writes Distribution Gen7.5 :: FS AVG Active per Thread */
#define hsw__memory_writes__ps_eu_active_per_thread__read \
    hsw__render_basic__ps_eu_active_per_thread__read

/* Memory Writes Distribution Gen7.5 :: FS EU Stall */
#define hsw__memory_writes__ps_eu_stall__read \
    hsw__memory_reads__ps_eu_stall__read

/* Memory Writes Distribution Gen7.5 :: FS AVG Stall per Thread */
#define hsw__memory_writes__ps_eu_stall_per_thread__read \
    hsw__render_basic__ps_eu_stall_per_thread__read

/* Memory Writes Distribution Gen7.5 :: Early Hi-Depth Test Fails */
#define hsw__memory_writes__hi_depth_test_fails__read \
    hsw__render_basic__hi_depth_test_fails__read

/* Memory Writes Distribution Gen7.5 :: Early Depth Test Fails */
#define hsw__memory_writes__early_depth_test_fails__read \
    hsw__render_basic__early_depth_test_fails__read

/* Memory Writes Distribution Gen7.5 :: Samples Killed in FS */
#define hsw__memory_writes__samples_killed_in_ps__read \
    hsw__render_basic__samples_killed_in_ps__read

/* Memory Writes Distribution Gen7.5 :: Alpha Test Fails */
#define hsw__memory_writes__alpha_test_fails__read \
    hsw__render_basic__alpha_test_fails__read

/* Memory Writes Distribution Gen7.5 :: Late Stencil Test Fails */
#define hsw__memory_writes__post_ps_stencil_test_fails__read \
    hsw__render_basic__post_ps_stencil_test_fails__read

/* Memory Writes Distribution Gen7.5 :: Late Depth Test Fails */
#define hsw__memory_writes__post_ps_depth_test_fails__read \
    hsw__render_basic__post_ps_depth_test_fails__read

/* Memory Writes Distribution Gen7.5 :: Samples Written */
#define hsw__memory_writes__samples_written__read \
    hsw__render_basic__samples_written__read

/* Memory Writes Distribution Gen7.5 :: GtiCmdStreamerMemoryWrites */
#define hsw__memory_writes__gti_cmd_streamer_memory_writes__read \
    hsw__compute_extended__eu_untyped_reads0__read

/* Memory Writes Distribution Gen7.5 :: GtiSoMemoryWrites */
#define hsw__memory_writes__gti_so_memory_writes__read \
    hsw__compute_extended__eu_typed_reads0__read

/* Memory Writes Distribution Gen7.5 :: GtiRccMemoryWrites */
#define hsw__memory_writes__gti_rcc_memory_writes__read \
    hsw__compute_extended__eu_typed_writes0__read

/* Memory Writes Distribution Gen7.5 :: GtiMscMemoryWrites */
#define hsw__memory_writes__gti_msc_memory_writes__read \
    hsw__compute_extended__eu_untyped_atomics0__read

/* Memory Writes Distribution Gen7.5 :: GtiHizMemoryWrites */
#define hsw__memory_writes__gti_hiz_memory_writes__read \
    hsw__compute_extended__eu_typed_atomics0__read

/* Memory Writes Distribution Gen7.5 :: GtiStcMemoryWrites */
#define hsw__memory_writes__gti_stc_memory_writes__read \
    hsw__compute_extended__eu_urb_atomics0__read

/* Memory Writes Distribution Gen7.5 :: GtiRczMemoryWrites */
#define hsw__memory_writes__gti_rcz_memory_writes__read \
    hsw__compute_extended__gpu_clocks__read

/* Memory Writes Distribution Gen7.5 :: GtiL3Writes */
#define hsw__memory_writes__gti_l3_writes__read \
    hsw__compute_extended__typed_atomics0__read

/* Memory Writes Distribution Gen7.5 :: GtiMemoryWrites */
#define hsw__memory_writes__gti_memory_writes__read \
    hsw__memory_reads__gti_memory_reads__read

/* Memory Writes Distribution Gen7.5 :: LLC GPU Write Accesses */
static uint64_t
hsw__memory_writes__llc_wr_accesses__read(const struct intel_perf *perf,
                                          const struct intel_perf_metric_set *metric_set,
                                          uint64_t *accumulator)
{
    /* RPN equation: C 6 READ 2 UMUL */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 6];
    uint64_t tmp1 = tmp0 * 2;

    return tmp1;
}

/* Memory Writes Distribution Gen7.5 :: LLC GPU Accesses */
#define hsw__memory_writes__llc_accesses__read \
    hsw__render_basic__llc_accesses__read

/* Memory Writes Distribution Gen7.5 :: LLC GPU Hits */
#define hsw__memory_writes__llc_hits__read \
    hsw__render_basic__llc_hits__read

/* Memory Writes Distribution Gen7.5 :: LLC GPU Throughput */
static uint64_t
hsw__memory_writes__llc_gpu_throughput__read(const struct intel_perf *perf,
                                             const struct intel_perf_metric_set *metric_set,
                                             uint64_t *accumulator)
{
    /* RPN equation: PERFCNT1 READ_REG $LlcWrAccesses USUB 64 UMUL $LlcWrAccesses 32 UMUL UADD */
    uint64_t tmp0 = 0;
    uint64_t tmp1 = tmp0 - hsw__memory_writes__llc_wr_accesses__read(perf, metric_set, accumulator);
    uint64_t tmp2 = tmp1 * 64;
    uint64_t tmp3 = hsw__memory_writes__llc_wr_accesses__read(perf, metric_set, accumulator) * 32;
    uint64_t tmp4 = tmp2 + tmp3;

    return tmp4;
}

/* Memory Writes Distribution Gen7.5 :: LLC GPU Throughput */
#define hsw__memory_writes__llc_gpu_throughput__max \
    hsw__render_basic__gti_write_throughput__read

/* Metric set SamplerBalance :: GPU Time Elapsed */
#define hsw__sampler_balance__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set SamplerBalance :: GPU Core Clocks */
#define hsw__sampler_balance__gpu_core_clocks__read \
    hsw__compute_extended__gpu_clocks__read

/* Metric set SamplerBalance :: AVG GPU Core Frequency */
static uint64_t
hsw__sampler_balance__avg_gpu_core_frequency__read(const struct intel_perf *perf,
                                                   const struct intel_perf_metric_set *metric_set,
                                                   uint64_t *accumulator)
{
    /* RPN equation: $GpuCoreClocks 1000000000 UMUL $GpuTime UDIV */
    uint64_t tmp0 = hsw__sampler_balance__gpu_core_clocks__read(perf, metric_set, accumulator) * 1000000000;
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = hsw__sampler_balance__gpu_time__read(perf, metric_set, accumulator);
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;

    return tmp3;
}

/* Metric set SamplerBalance :: AVG GPU Core Frequency */
#define hsw__sampler_balance__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set SamplerBalance :: GPU Busy */
static double
hsw__sampler_balance__gpu_busy__read(const struct intel_perf *perf,
                                     const struct intel_perf_metric_set *metric_set,
                                     uint64_t *accumulator)
{
    /* RPN equation: A 41 READ 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 41];
    uint64_t tmp1 = tmp0 * 100;
    double tmp2 = tmp1;
    double tmp3 = hsw__sampler_balance__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp4 = tmp3 ? tmp2 / tmp3 : 0;

    return tmp4;
}

/* Metric set SamplerBalance :: VS Threads Dispatched */
#define hsw__sampler_balance__vs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set SamplerBalance :: TCS Threads Dispatched */
#define hsw__sampler_balance__hs_threads__read \
    hsw__render_basic__hs_threads__read

/* Metric set SamplerBalance :: TES Threads Dispatched */
#define hsw__sampler_balance__ds_threads__read \
    hsw__render_basic__ds_threads__read

/* Metric set SamplerBalance :: GS Threads Dispatched */
#define hsw__sampler_balance__gs_threads__read \
    hsw__render_basic__gs_threads__read

/* Metric set SamplerBalance :: FS Threads Dispatched */
#define hsw__sampler_balance__ps_threads__read \
    hsw__render_basic__ps_threads__read

/* Metric set SamplerBalance :: CS Threads Dispatched */
#define hsw__sampler_balance__cs_threads__read \
    hsw__render_basic__cs_threads__read

/* Metric set SamplerBalance :: EU Active */
static double
hsw__sampler_balance__eu_active__read(const struct intel_perf *perf,
                                      const struct intel_perf_metric_set *metric_set,
                                      uint64_t *accumulator)
{
    /* RPN equation: A 0 READ $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 0];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = perf->devinfo.n_eus;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    uint64_t tmp4 = tmp3 * 100;
    double tmp5 = tmp4;
    double tmp6 = hsw__sampler_balance__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp7 = tmp6 ? tmp5 / tmp6 : 0;

    return tmp7;
}

/* Metric set SamplerBalance :: EU Stall */
static double
hsw__sampler_balance__eu_stall__read(const struct intel_perf *perf,
                                     const struct intel_perf_metric_set *metric_set,
                                     uint64_t *accumulator)
{
    /* RPN equation: A 1 READ $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 1];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = perf->devinfo.n_eus;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    uint64_t tmp4 = tmp3 * 100;
    double tmp5 = tmp4;
    double tmp6 = hsw__sampler_balance__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp7 = tmp6 ? tmp5 / tmp6 : 0;

    return tmp7;
}

/* Metric set SamplerBalance :: VS EU Active */
static double
hsw__sampler_balance__vs_eu_active__read(const struct intel_perf *perf,
                                         const struct intel_perf_metric_set *metric_set,
                                         uint64_t *accumulator)
{
    /* RPN equation: A 2 READ $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 2];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = perf->devinfo.n_eus;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    uint64_t tmp4 = tmp3 * 100;
    double tmp5 = tmp4;
    double tmp6 = hsw__sampler_balance__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp7 = tmp6 ? tmp5 / tmp6 : 0;

    return tmp7;
}

/* Metric set SamplerBalance :: VS AVG Active per Thread */
#define hsw__sampler_balance__vs_eu_active_per_thread__read \
    hsw__render_basic__vs_eu_active_per_thread__read

/* Metric set SamplerBalance :: VS EU Stall */
static double
hsw__sampler_balance__vs_eu_stall__read(const struct intel_perf *perf,
                                        const struct intel_perf_metric_set *metric_set,
                                        uint64_t *accumulator)
{
    /* RPN equation: A 3 READ $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 3];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = perf->devinfo.n_eus;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    uint64_t tmp4 = tmp3 * 100;
    double tmp5 = tmp4;
    double tmp6 = hsw__sampler_balance__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp7 = tmp6 ? tmp5 / tmp6 : 0;

    return tmp7;
}

/* Metric set SamplerBalance :: VS AVG Stall per Thread */
#define hsw__sampler_balance__vs_eu_stall_per_thread__read \
    hsw__render_basic__vs_eu_stall_per_thread__read

/* Metric set SamplerBalance :: TCS EU Active */
static double
hsw__sampler_balance__hs_eu_active__read(const struct intel_perf *perf,
                                         const struct intel_perf_metric_set *metric_set,
                                         uint64_t *accumulator)
{
    /* RPN equation: A 7 READ $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 7];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = perf->devinfo.n_eus;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    uint64_t tmp4 = tmp3 * 100;
    double tmp5 = tmp4;
    double tmp6 = hsw__sampler_balance__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp7 = tmp6 ? tmp5 / tmp6 : 0;

    return tmp7;
}

/* Metric set SamplerBalance :: TCS AVG Active per Thread */
#define hsw__sampler_balance__hs_eu_active_per_thread__read \
    hsw__render_basic__hs_eu_active_per_thread__read

/* Metric set SamplerBalance :: TCS EU Stall */
static double
hsw__sampler_balance__hs_eu_stall__read(const struct intel_perf *perf,
                                        const struct intel_perf_metric_set *metric_set,
                                        uint64_t *accumulator)
{
    /* RPN equation: A 8 READ $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 8];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = perf->devinfo.n_eus;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    uint64_t tmp4 = tmp3 * 100;
    double tmp5 = tmp4;
    double tmp6 = hsw__sampler_balance__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp7 = tmp6 ? tmp5 / tmp6 : 0;

    return tmp7;
}

/* Metric set SamplerBalance :: TCS AVG Stall per Thread */
#define hsw__sampler_balance__hs_eu_stall_per_thread__read \
    hsw__render_basic__hs_eu_stall_per_thread__read

/* Metric set SamplerBalance :: TES EU Active */
static double
hsw__sampler_balance__ds_eu_active__read(const struct intel_perf *perf,
                                         const struct intel_perf_metric_set *metric_set,
                                         uint64_t *accumulator)
{
    /* RPN equation: A 12 READ $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 12];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = perf->devinfo.n_eus;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    uint64_t tmp4 = tmp3 * 100;
    double tmp5 = tmp4;
    double tmp6 = hsw__sampler_balance__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp7 = tmp6 ? tmp5 / tmp6 : 0;

    return tmp7;
}

/* Metric set SamplerBalance :: TES AVG Active per Thread */
#define hsw__sampler_balance__ds_eu_active_per_thread__read \
    hsw__render_basic__ds_eu_active_per_thread__read

/* Metric set SamplerBalance :: TES EU Stall */
static double
hsw__sampler_balance__ds_eu_stall__read(const struct intel_perf *perf,
                                        const struct intel_perf_metric_set *metric_set,
                                        uint64_t *accumulator)
{
    /* RPN equation: A 13 READ $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 13];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = perf->devinfo.n_eus;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    uint64_t tmp4 = tmp3 * 100;
    double tmp5 = tmp4;
    double tmp6 = hsw__sampler_balance__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp7 = tmp6 ? tmp5 / tmp6 : 0;

    return tmp7;
}

/* Metric set SamplerBalance :: TES AVG Stall per Thread */
#define hsw__sampler_balance__ds_eu_stall_per_thread__read \
    hsw__render_basic__ds_eu_stall_per_thread__read

/* Metric set SamplerBalance :: GS EU Active */
static double
hsw__sampler_balance__gs_eu_active__read(const struct intel_perf *perf,
                                         const struct intel_perf_metric_set *metric_set,
                                         uint64_t *accumulator)
{
    /* RPN equation: A 22 READ $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 22];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = perf->devinfo.n_eus;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    uint64_t tmp4 = tmp3 * 100;
    double tmp5 = tmp4;
    double tmp6 = hsw__sampler_balance__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp7 = tmp6 ? tmp5 / tmp6 : 0;

    return tmp7;
}

/* Metric set SamplerBalance :: GS AVG Active per Thread */
#define hsw__sampler_balance__gs_eu_active_per_thread__read \
    hsw__render_basic__gs_eu_active_per_thread__read

/* Metric set SamplerBalance :: GS EU Stall */
static double
hsw__sampler_balance__gs_eu_stall__read(const struct intel_perf *perf,
                                        const struct intel_perf_metric_set *metric_set,
                                        uint64_t *accumulator)
{
    /* RPN equation: A 23 READ $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 23];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = perf->devinfo.n_eus;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    uint64_t tmp4 = tmp3 * 100;
    double tmp5 = tmp4;
    double tmp6 = hsw__sampler_balance__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp7 = tmp6 ? tmp5 / tmp6 : 0;

    return tmp7;
}

/* Metric set SamplerBalance :: GS AVG Stall per Thread */
#define hsw__sampler_balance__gs_eu_stall_per_thread__read \
    hsw__render_basic__gs_eu_stall_per_thread__read

/* Metric set SamplerBalance :: CS EU Active */
static double
hsw__sampler_balance__cs_eu_active__read(const struct intel_perf *perf,
                                         const struct intel_perf_metric_set *metric_set,
                                         uint64_t *accumulator)
{
    /* RPN equation: A 17 READ $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 17];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = perf->devinfo.n_eus;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    uint64_t tmp4 = tmp3 * 100;
    double tmp5 = tmp4;
    double tmp6 = hsw__sampler_balance__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp7 = tmp6 ? tmp5 / tmp6 : 0;

    return tmp7;
}

/* Metric set SamplerBalance :: CS AVG Active per Thread */
#define hsw__sampler_balance__cs_eu_active_per_thread__read \
    hsw__render_basic__cs_eu_active_per_thread__read

/* Metric set SamplerBalance :: CS EU Stall */
static double
hsw__sampler_balance__cs_eu_stall__read(const struct intel_perf *perf,
                                        const struct intel_perf_metric_set *metric_set,
                                        uint64_t *accumulator)
{
    /* RPN equation: A 18 READ $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 18];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = perf->devinfo.n_eus;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    uint64_t tmp4 = tmp3 * 100;
    double tmp5 = tmp4;
    double tmp6 = hsw__sampler_balance__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp7 = tmp6 ? tmp5 / tmp6 : 0;

    return tmp7;
}

/* Metric set SamplerBalance :: CS AVG Stall per Thread */
#define hsw__sampler_balance__cs_eu_stall_per_thread__read \
    hsw__render_basic__cs_eu_stall_per_thread__read

/* Metric set SamplerBalance :: FS EU Active */
static double
hsw__sampler_balance__ps_eu_active__read(const struct intel_perf *perf,
                                         const struct intel_perf_metric_set *metric_set,
                                         uint64_t *accumulator)
{
    /* RPN equation: A 27 READ $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 27];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = perf->devinfo.n_eus;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    uint64_t tmp4 = tmp3 * 100;
    double tmp5 = tmp4;
    double tmp6 = hsw__sampler_balance__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp7 = tmp6 ? tmp5 / tmp6 : 0;

    return tmp7;
}

/* Metric set SamplerBalance :: FS AVG Active per Thread */
#define hsw__sampler_balance__ps_eu_active_per_thread__read \
    hsw__render_basic__ps_eu_active_per_thread__read

/* Metric set SamplerBalance :: FS EU Stall */
static double
hsw__sampler_balance__ps_eu_stall__read(const struct intel_perf *perf,
                                        const struct intel_perf_metric_set *metric_set,
                                        uint64_t *accumulator)
{
    /* RPN equation: A 28 READ $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 28];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = perf->devinfo.n_eus;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    uint64_t tmp4 = tmp3 * 100;
    double tmp5 = tmp4;
    double tmp6 = hsw__sampler_balance__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp7 = tmp6 ? tmp5 / tmp6 : 0;

    return tmp7;
}

/* Metric set SamplerBalance :: FS AVG Stall per Thread */
#define hsw__sampler_balance__ps_eu_stall_per_thread__read \
    hsw__render_basic__ps_eu_stall_per_thread__read

/* Metric set SamplerBalance :: Early Hi-Depth Test Fails */
#define hsw__sampler_balance__hi_depth_test_fails__read \
    hsw__render_basic__hi_depth_test_fails__read

/* Metric set SamplerBalance :: Early Depth Test Fails */
#define hsw__sampler_balance__early_depth_test_fails__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set SamplerBalance :: Samples Killed in FS */
#define hsw__sampler_balance__samples_killed_in_ps__read \
    hsw__render_basic__samples_killed_in_ps__read

/* Metric set SamplerBalance :: Alpha Test Fails */
#define hsw__sampler_balance__alpha_test_fails__read \
    hsw__render_basic__alpha_test_fails__read

/* Metric set SamplerBalance :: Late Stencil Test Fails */
#define hsw__sampler_balance__post_ps_stencil_test_fails__read \
    hsw__render_basic__post_ps_stencil_test_fails__read

/* Metric set SamplerBalance :: Late Depth Test Fails */
#define hsw__sampler_balance__post_ps_depth_test_fails__read \
    hsw__render_basic__post_ps_depth_test_fails__read

/* Metric set SamplerBalance :: Samples Written */
#define hsw__sampler_balance__samples_written__read \
    hsw__render_basic__samples_written__read

/* Metric set SamplerBalance :: FS Duration */
static uint64_t
hsw__sampler_balance__ps_duration__read(const struct intel_perf *perf,
                                        const struct intel_perf_metric_set *metric_set,
                                        uint64_t *accumulator)
{
    /* RPN equation: A 27 READ  A 0 READ UMUL  A 2 READ  A 7 READ UADD  A 12 READ UADD  A 17 READ UADD  A 22 READ UADD  A 27 READ UADD UDIV  A 28 READ  A 1 READ UMUL  A 3 READ  A 8 READ UADD  A 13 READ UADD  A 18 READ UADD  A 23 READ UADD  A 28 READ UADD UDIV UADD $GpuTime UMUL $GpuCoreClocks $EuCoresTotalCount UMUL 1000 UMUL UDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 27];
    uint64_t tmp1 = accumulator[metric_set->a_offset + 0];
    uint64_t tmp2 = tmp0 * tmp1;
    uint64_t tmp3 = accumulator[metric_set->a_offset + 2];
    uint64_t tmp4 = accumulator[metric_set->a_offset + 7];
    uint64_t tmp5 = tmp3 + tmp4;
    uint64_t tmp6 = accumulator[metric_set->a_offset + 12];
    uint64_t tmp7 = tmp5 + tmp6;
    uint64_t tmp8 = accumulator[metric_set->a_offset + 17];
    uint64_t tmp9 = tmp7 + tmp8;
    uint64_t tmp10 = accumulator[metric_set->a_offset + 22];
    uint64_t tmp11 = tmp9 + tmp10;
    uint64_t tmp12 = accumulator[metric_set->a_offset + 27];
    uint64_t tmp13 = tmp11 + tmp12;
    uint64_t tmp14 = tmp2;
    uint64_t tmp15 = tmp13;
    uint64_t tmp16 = tmp15 ? tmp14 / tmp15 : 0;
    uint64_t tmp17 = accumulator[metric_set->a_offset + 28];
    uint64_t tmp18 = accumulator[metric_set->a_offset + 1];
    uint64_t tmp19 = tmp17 * tmp18;
    uint64_t tmp20 = accumulator[metric_set->a_offset + 3];
    uint64_t tmp21 = accumulator[metric_set->a_offset + 8];
    uint64_t tmp22 = tmp20 + tmp21;
    uint64_t tmp23 = accumulator[metric_set->a_offset + 13];
    uint64_t tmp24 = tmp22 + tmp23;
    uint64_t tmp25 = accumulator[metric_set->a_offset + 18];
    uint64_t tmp26 = tmp24 + tmp25;
    uint64_t tmp27 = accumulator[metric_set->a_offset + 23];
    uint64_t tmp28 = tmp26 + tmp27;
    uint64_t tmp29 = accumulator[metric_set->a_offset + 28];
    uint64_t tmp30 = tmp28 + tmp29;
    uint64_t tmp31 = tmp19;
    uint64_t tmp32 = tmp30;
    uint64_t tmp33 = tmp32 ? tmp31 / tmp32 : 0;
    uint64_t tmp34 = tmp16 + tmp33;
    uint64_t tmp35 = tmp34 * hsw__sampler_balance__gpu_time__read(perf, metric_set, accumulator);
    uint64_t tmp36 = hsw__sampler_balance__gpu_core_clocks__read(perf, metric_set, accumulator) * perf->devinfo.n_eus;
    uint64_t tmp37 = tmp36 * 1000;
    uint64_t tmp38 = tmp35;
    uint64_t tmp39 = tmp37;
    uint64_t tmp40 = tmp39 ? tmp38 / tmp39 : 0;

    return tmp40;
}

/* Metric set SamplerBalance :: VS Duration */
static uint64_t
hsw__sampler_balance__vs_duration__read(const struct intel_perf *perf,
                                        const struct intel_perf_metric_set *metric_set,
                                        uint64_t *accumulator)
{
    /* RPN equation: A 2 READ  A 0 READ UMUL  A 2 READ  A 7 READ UADD  A 12 READ UADD  A 17 READ UADD  A 22 READ UADD  A 27 READ UADD UDIV  A 3 READ  A 1 READ UMUL  A 3 READ  A 8 READ UADD  A 13 READ UADD  A 18 READ UADD  A 23 READ UADD  A 28 READ UADD UDIV UADD $GpuTime UMUL $GpuCoreClocks $EuCoresTotalCount UMUL 1000 UMUL UDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 2];
    uint64_t tmp1 = accumulator[metric_set->a_offset + 0];
    uint64_t tmp2 = tmp0 * tmp1;
    uint64_t tmp3 = accumulator[metric_set->a_offset + 2];
    uint64_t tmp4 = accumulator[metric_set->a_offset + 7];
    uint64_t tmp5 = tmp3 + tmp4;
    uint64_t tmp6 = accumulator[metric_set->a_offset + 12];
    uint64_t tmp7 = tmp5 + tmp6;
    uint64_t tmp8 = accumulator[metric_set->a_offset + 17];
    uint64_t tmp9 = tmp7 + tmp8;
    uint64_t tmp10 = accumulator[metric_set->a_offset + 22];
    uint64_t tmp11 = tmp9 + tmp10;
    uint64_t tmp12 = accumulator[metric_set->a_offset + 27];
    uint64_t tmp13 = tmp11 + tmp12;
    uint64_t tmp14 = tmp2;
    uint64_t tmp15 = tmp13;
    uint64_t tmp16 = tmp15 ? tmp14 / tmp15 : 0;
    uint64_t tmp17 = accumulator[metric_set->a_offset + 3];
    uint64_t tmp18 = accumulator[metric_set->a_offset + 1];
    uint64_t tmp19 = tmp17 * tmp18;
    uint64_t tmp20 = accumulator[metric_set->a_offset + 3];
    uint64_t tmp21 = accumulator[metric_set->a_offset + 8];
    uint64_t tmp22 = tmp20 + tmp21;
    uint64_t tmp23 = accumulator[metric_set->a_offset + 13];
    uint64_t tmp24 = tmp22 + tmp23;
    uint64_t tmp25 = accumulator[metric_set->a_offset + 18];
    uint64_t tmp26 = tmp24 + tmp25;
    uint64_t tmp27 = accumulator[metric_set->a_offset + 23];
    uint64_t tmp28 = tmp26 + tmp27;
    uint64_t tmp29 = accumulator[metric_set->a_offset + 28];
    uint64_t tmp30 = tmp28 + tmp29;
    uint64_t tmp31 = tmp19;
    uint64_t tmp32 = tmp30;
    uint64_t tmp33 = tmp32 ? tmp31 / tmp32 : 0;
    uint64_t tmp34 = tmp16 + tmp33;
    uint64_t tmp35 = tmp34 * hsw__sampler_balance__gpu_time__read(perf, metric_set, accumulator);
    uint64_t tmp36 = hsw__sampler_balance__gpu_core_clocks__read(perf, metric_set, accumulator) * perf->devinfo.n_eus;
    uint64_t tmp37 = tmp36 * 1000;
    uint64_t tmp38 = tmp35;
    uint64_t tmp39 = tmp37;
    uint64_t tmp40 = tmp39 ? tmp38 / tmp39 : 0;

    return tmp40;
}

/* Metric set SamplerBalance :: GS Duration */
static uint64_t
hsw__sampler_balance__gs_duration__read(const struct intel_perf *perf,
                                        const struct intel_perf_metric_set *metric_set,
                                        uint64_t *accumulator)
{
    /* RPN equation: A 22 READ  A 0 READ UMUL  A 2 READ  A 7 READ UADD  A 12 READ UADD  A 17 READ UADD  A 22 READ UADD  A 27 READ UADD UDIV  A 23 READ  A 1 READ UMUL  A 3 READ  A 8 READ UADD  A 13 READ UADD  A 18 READ UADD  A 23 READ UADD  A 28 READ UADD UDIV UADD $GpuTime UMUL $GpuCoreClocks $EuCoresTotalCount UMUL 1000 UMUL UDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 22];
    uint64_t tmp1 = accumulator[metric_set->a_offset + 0];
    uint64_t tmp2 = tmp0 * tmp1;
    uint64_t tmp3 = accumulator[metric_set->a_offset + 2];
    uint64_t tmp4 = accumulator[metric_set->a_offset + 7];
    uint64_t tmp5 = tmp3 + tmp4;
    uint64_t tmp6 = accumulator[metric_set->a_offset + 12];
    uint64_t tmp7 = tmp5 + tmp6;
    uint64_t tmp8 = accumulator[metric_set->a_offset + 17];
    uint64_t tmp9 = tmp7 + tmp8;
    uint64_t tmp10 = accumulator[metric_set->a_offset + 22];
    uint64_t tmp11 = tmp9 + tmp10;
    uint64_t tmp12 = accumulator[metric_set->a_offset + 27];
    uint64_t tmp13 = tmp11 + tmp12;
    uint64_t tmp14 = tmp2;
    uint64_t tmp15 = tmp13;
    uint64_t tmp16 = tmp15 ? tmp14 / tmp15 : 0;
    uint64_t tmp17 = accumulator[metric_set->a_offset + 23];
    uint64_t tmp18 = accumulator[metric_set->a_offset + 1];
    uint64_t tmp19 = tmp17 * tmp18;
    uint64_t tmp20 = accumulator[metric_set->a_offset + 3];
    uint64_t tmp21 = accumulator[metric_set->a_offset + 8];
    uint64_t tmp22 = tmp20 + tmp21;
    uint64_t tmp23 = accumulator[metric_set->a_offset + 13];
    uint64_t tmp24 = tmp22 + tmp23;
    uint64_t tmp25 = accumulator[metric_set->a_offset + 18];
    uint64_t tmp26 = tmp24 + tmp25;
    uint64_t tmp27 = accumulator[metric_set->a_offset + 23];
    uint64_t tmp28 = tmp26 + tmp27;
    uint64_t tmp29 = accumulator[metric_set->a_offset + 28];
    uint64_t tmp30 = tmp28 + tmp29;
    uint64_t tmp31 = tmp19;
    uint64_t tmp32 = tmp30;
    uint64_t tmp33 = tmp32 ? tmp31 / tmp32 : 0;
    uint64_t tmp34 = tmp16 + tmp33;
    uint64_t tmp35 = tmp34 * hsw__sampler_balance__gpu_time__read(perf, metric_set, accumulator);
    uint64_t tmp36 = hsw__sampler_balance__gpu_core_clocks__read(perf, metric_set, accumulator) * perf->devinfo.n_eus;
    uint64_t tmp37 = tmp36 * 1000;
    uint64_t tmp38 = tmp35;
    uint64_t tmp39 = tmp37;
    uint64_t tmp40 = tmp39 ? tmp38 / tmp39 : 0;

    return tmp40;
}

/* Metric set SamplerBalance :: TES Duration */
static uint64_t
hsw__sampler_balance__ds_duration__read(const struct intel_perf *perf,
                                        const struct intel_perf_metric_set *metric_set,
                                        uint64_t *accumulator)
{
    /* RPN equation: A 12 READ  A 0 READ UMUL  A 2 READ  A 7 READ UADD  A 12 READ UADD  A 17 READ UADD  A 22 READ UADD  A 27 READ UADD UDIV  A 13 READ  A 1 READ UMUL  A 3 READ  A 8 READ UADD  A 13 READ UADD  A 18 READ UADD  A 23 READ UADD  A 28 READ UADD UDIV UADD $GpuTime UMUL $GpuCoreClocks $EuCoresTotalCount UMUL 1000 UMUL UDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 12];
    uint64_t tmp1 = accumulator[metric_set->a_offset + 0];
    uint64_t tmp2 = tmp0 * tmp1;
    uint64_t tmp3 = accumulator[metric_set->a_offset + 2];
    uint64_t tmp4 = accumulator[metric_set->a_offset + 7];
    uint64_t tmp5 = tmp3 + tmp4;
    uint64_t tmp6 = accumulator[metric_set->a_offset + 12];
    uint64_t tmp7 = tmp5 + tmp6;
    uint64_t tmp8 = accumulator[metric_set->a_offset + 17];
    uint64_t tmp9 = tmp7 + tmp8;
    uint64_t tmp10 = accumulator[metric_set->a_offset + 22];
    uint64_t tmp11 = tmp9 + tmp10;
    uint64_t tmp12 = accumulator[metric_set->a_offset + 27];
    uint64_t tmp13 = tmp11 + tmp12;
    uint64_t tmp14 = tmp2;
    uint64_t tmp15 = tmp13;
    uint64_t tmp16 = tmp15 ? tmp14 / tmp15 : 0;
    uint64_t tmp17 = accumulator[metric_set->a_offset + 13];
    uint64_t tmp18 = accumulator[metric_set->a_offset + 1];
    uint64_t tmp19 = tmp17 * tmp18;
    uint64_t tmp20 = accumulator[metric_set->a_offset + 3];
    uint64_t tmp21 = accumulator[metric_set->a_offset + 8];
    uint64_t tmp22 = tmp20 + tmp21;
    uint64_t tmp23 = accumulator[metric_set->a_offset + 13];
    uint64_t tmp24 = tmp22 + tmp23;
    uint64_t tmp25 = accumulator[metric_set->a_offset + 18];
    uint64_t tmp26 = tmp24 + tmp25;
    uint64_t tmp27 = accumulator[metric_set->a_offset + 23];
    uint64_t tmp28 = tmp26 + tmp27;
    uint64_t tmp29 = accumulator[metric_set->a_offset + 28];
    uint64_t tmp30 = tmp28 + tmp29;
    uint64_t tmp31 = tmp19;
    uint64_t tmp32 = tmp30;
    uint64_t tmp33 = tmp32 ? tmp31 / tmp32 : 0;
    uint64_t tmp34 = tmp16 + tmp33;
    uint64_t tmp35 = tmp34 * hsw__sampler_balance__gpu_time__read(perf, metric_set, accumulator);
    uint64_t tmp36 = hsw__sampler_balance__gpu_core_clocks__read(perf, metric_set, accumulator) * perf->devinfo.n_eus;
    uint64_t tmp37 = tmp36 * 1000;
    uint64_t tmp38 = tmp35;
    uint64_t tmp39 = tmp37;
    uint64_t tmp40 = tmp39 ? tmp38 / tmp39 : 0;

    return tmp40;
}

/* Metric set SamplerBalance :: TCS Duration */
static uint64_t
hsw__sampler_balance__hs_duration__read(const struct intel_perf *perf,
                                        const struct intel_perf_metric_set *metric_set,
                                        uint64_t *accumulator)
{
    /* RPN equation: A 7 READ  A 0 READ UMUL  A 2 READ  A 7 READ UADD  A 12 READ UADD  A 17 READ UADD  A 22 READ UADD  A 27 READ UADD UDIV  A 8 READ  A 1 READ UMUL  A 3 READ  A 8 READ UADD  A 13 READ UADD  A 18 READ UADD  A 23 READ UADD  A 28 READ UADD UDIV UADD $GpuTime UMUL $GpuCoreClocks $EuCoresTotalCount UMUL 1000 UMUL UDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 7];
    uint64_t tmp1 = accumulator[metric_set->a_offset + 0];
    uint64_t tmp2 = tmp0 * tmp1;
    uint64_t tmp3 = accumulator[metric_set->a_offset + 2];
    uint64_t tmp4 = accumulator[metric_set->a_offset + 7];
    uint64_t tmp5 = tmp3 + tmp4;
    uint64_t tmp6 = accumulator[metric_set->a_offset + 12];
    uint64_t tmp7 = tmp5 + tmp6;
    uint64_t tmp8 = accumulator[metric_set->a_offset + 17];
    uint64_t tmp9 = tmp7 + tmp8;
    uint64_t tmp10 = accumulator[metric_set->a_offset + 22];
    uint64_t tmp11 = tmp9 + tmp10;
    uint64_t tmp12 = accumulator[metric_set->a_offset + 27];
    uint64_t tmp13 = tmp11 + tmp12;
    uint64_t tmp14 = tmp2;
    uint64_t tmp15 = tmp13;
    uint64_t tmp16 = tmp15 ? tmp14 / tmp15 : 0;
    uint64_t tmp17 = accumulator[metric_set->a_offset + 8];
    uint64_t tmp18 = accumulator[metric_set->a_offset + 1];
    uint64_t tmp19 = tmp17 * tmp18;
    uint64_t tmp20 = accumulator[metric_set->a_offset + 3];
    uint64_t tmp21 = accumulator[metric_set->a_offset + 8];
    uint64_t tmp22 = tmp20 + tmp21;
    uint64_t tmp23 = accumulator[metric_set->a_offset + 13];
    uint64_t tmp24 = tmp22 + tmp23;
    uint64_t tmp25 = accumulator[metric_set->a_offset + 18];
    uint64_t tmp26 = tmp24 + tmp25;
    uint64_t tmp27 = accumulator[metric_set->a_offset + 23];
    uint64_t tmp28 = tmp26 + tmp27;
    uint64_t tmp29 = accumulator[metric_set->a_offset + 28];
    uint64_t tmp30 = tmp28 + tmp29;
    uint64_t tmp31 = tmp19;
    uint64_t tmp32 = tmp30;
    uint64_t tmp33 = tmp32 ? tmp31 / tmp32 : 0;
    uint64_t tmp34 = tmp16 + tmp33;
    uint64_t tmp35 = tmp34 * hsw__sampler_balance__gpu_time__read(perf, metric_set, accumulator);
    uint64_t tmp36 = hsw__sampler_balance__gpu_core_clocks__read(perf, metric_set, accumulator) * perf->devinfo.n_eus;
    uint64_t tmp37 = tmp36 * 1000;
    uint64_t tmp38 = tmp35;
    uint64_t tmp39 = tmp37;
    uint64_t tmp40 = tmp39 ? tmp38 / tmp39 : 0;

    return tmp40;
}

/* Metric set SamplerBalance :: CS Duration */
static uint64_t
hsw__sampler_balance__cs_duration__read(const struct intel_perf *perf,
                                        const struct intel_perf_metric_set *metric_set,
                                        uint64_t *accumulator)
{
    /* RPN equation: A 17 READ  A 0 READ UMUL  A 2 READ  A 7 READ UADD  A 12 READ UADD  A 17 READ UADD  A 22 READ UADD  A 27 READ UADD UDIV  A 18 READ  A 1 READ UMUL  A 3 READ  A 8 READ UADD  A 13 READ UADD  A 18 READ UADD  A 23 READ UADD  A 28 READ UADD UDIV UADD $GpuTime UMUL $GpuCoreClocks $EuCoresTotalCount UMUL 1000 UMUL UDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 17];
    uint64_t tmp1 = accumulator[metric_set->a_offset + 0];
    uint64_t tmp2 = tmp0 * tmp1;
    uint64_t tmp3 = accumulator[metric_set->a_offset + 2];
    uint64_t tmp4 = accumulator[metric_set->a_offset + 7];
    uint64_t tmp5 = tmp3 + tmp4;
    uint64_t tmp6 = accumulator[metric_set->a_offset + 12];
    uint64_t tmp7 = tmp5 + tmp6;
    uint64_t tmp8 = accumulator[metric_set->a_offset + 17];
    uint64_t tmp9 = tmp7 + tmp8;
    uint64_t tmp10 = accumulator[metric_set->a_offset + 22];
    uint64_t tmp11 = tmp9 + tmp10;
    uint64_t tmp12 = accumulator[metric_set->a_offset + 27];
    uint64_t tmp13 = tmp11 + tmp12;
    uint64_t tmp14 = tmp2;
    uint64_t tmp15 = tmp13;
    uint64_t tmp16 = tmp15 ? tmp14 / tmp15 : 0;
    uint64_t tmp17 = accumulator[metric_set->a_offset + 18];
    uint64_t tmp18 = accumulator[metric_set->a_offset + 1];
    uint64_t tmp19 = tmp17 * tmp18;
    uint64_t tmp20 = accumulator[metric_set->a_offset + 3];
    uint64_t tmp21 = accumulator[metric_set->a_offset + 8];
    uint64_t tmp22 = tmp20 + tmp21;
    uint64_t tmp23 = accumulator[metric_set->a_offset + 13];
    uint64_t tmp24 = tmp22 + tmp23;
    uint64_t tmp25 = accumulator[metric_set->a_offset + 18];
    uint64_t tmp26 = tmp24 + tmp25;
    uint64_t tmp27 = accumulator[metric_set->a_offset + 23];
    uint64_t tmp28 = tmp26 + tmp27;
    uint64_t tmp29 = accumulator[metric_set->a_offset + 28];
    uint64_t tmp30 = tmp28 + tmp29;
    uint64_t tmp31 = tmp19;
    uint64_t tmp32 = tmp30;
    uint64_t tmp33 = tmp32 ? tmp31 / tmp32 : 0;
    uint64_t tmp34 = tmp16 + tmp33;
    uint64_t tmp35 = tmp34 * hsw__sampler_balance__gpu_time__read(perf, metric_set, accumulator);
    uint64_t tmp36 = hsw__sampler_balance__gpu_core_clocks__read(perf, metric_set, accumulator) * perf->devinfo.n_eus;
    uint64_t tmp37 = tmp36 * 1000;
    uint64_t tmp38 = tmp35;
    uint64_t tmp39 = tmp37;
    uint64_t tmp40 = tmp39 ? tmp38 / tmp39 : 0;

    return tmp40;
}

/* Metric set SamplerBalance :: EU Idle */
static double
hsw__sampler_balance__eu_idle__read(const struct intel_perf *perf,
                                    const struct intel_perf_metric_set *metric_set,
                                    uint64_t *accumulator)
{
    /* RPN equation: 100 $EuActive $EuStall FADD FSUB */
    double tmp0 = hsw__sampler_balance__eu_active__read(perf, metric_set, accumulator) + hsw__sampler_balance__eu_stall__read(perf, metric_set, accumulator);
    double tmp1 = 100 - tmp0;

    return tmp1;
}

/* Metric set SamplerBalance :: Sampler L2 cache misses */
static uint64_t
hsw__sampler_balance__sampler_l2_cache_misses__read(const struct intel_perf *perf,
                                                    const struct intel_perf_metric_set *metric_set,
                                                    uint64_t *accumulator)
{
    /* RPN equation: C 7 READ C 6 READ UADD C 5 READ UADD C 4 READ UADD C 3 READ UADD C 2 READ UADD C 1 READ UADD C 0 READ UADD */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 7];
    uint64_t tmp1 = accumulator[metric_set->c_offset + 6];
    uint64_t tmp2 = tmp0 + tmp1;
    uint64_t tmp3 = accumulator[metric_set->c_offset + 5];
    uint64_t tmp4 = tmp2 + tmp3;
    uint64_t tmp5 = accumulator[metric_set->c_offset + 4];
    uint64_t tmp6 = tmp4 + tmp5;
    uint64_t tmp7 = accumulator[metric_set->c_offset + 3];
    uint64_t tmp8 = tmp6 + tmp7;
    uint64_t tmp9 = accumulator[metric_set->c_offset + 2];
    uint64_t tmp10 = tmp8 + tmp9;
    uint64_t tmp11 = accumulator[metric_set->c_offset + 1];
    uint64_t tmp12 = tmp10 + tmp11;
    uint64_t tmp13 = accumulator[metric_set->c_offset + 0];
    uint64_t tmp14 = tmp12 + tmp13;

    return tmp14;
}

/* Metric set SamplerBalance :: Sampler L2 cache misses (ss0) */
static uint64_t
hsw__sampler_balance__sampler0_l2_cache_misses__read(const struct intel_perf *perf,
                                                     const struct intel_perf_metric_set *metric_set,
                                                     uint64_t *accumulator)
{
    /* RPN equation: C 7 READ C 6 READ UADD */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 7];
    uint64_t tmp1 = accumulator[metric_set->c_offset + 6];
    uint64_t tmp2 = tmp0 + tmp1;

    return tmp2;
}

/* Metric set SamplerBalance :: Sampler L2 cache misses (ss1) */
static uint64_t
hsw__sampler_balance__sampler1_l2_cache_misses__read(const struct intel_perf *perf,
                                                     const struct intel_perf_metric_set *metric_set,
                                                     uint64_t *accumulator)
{
    /* RPN equation: C 5 READ C 4 READ UADD */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 5];
    uint64_t tmp1 = accumulator[metric_set->c_offset + 4];
    uint64_t tmp2 = tmp0 + tmp1;

    return tmp2;
}

/* Metric set SamplerBalance :: Sampler L2 cache misses (ss2) */
static uint64_t
hsw__sampler_balance__sampler2_l2_cache_misses__read(const struct intel_perf *perf,
                                                     const struct intel_perf_metric_set *metric_set,
                                                     uint64_t *accumulator)
{
    /* RPN equation: C 3 READ C 2 READ UADD */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 3];
    uint64_t tmp1 = accumulator[metric_set->c_offset + 2];
    uint64_t tmp2 = tmp0 + tmp1;

    return tmp2;
}

/* Metric set SamplerBalance :: Sampler L2 cache misses (ss3) */
static uint64_t
hsw__sampler_balance__sampler3_l2_cache_misses__read(const struct intel_perf *perf,
                                                     const struct intel_perf_metric_set *metric_set,
                                                     uint64_t *accumulator)
{
    /* RPN equation: C 1 READ C 0 READ UADD */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 1];
    uint64_t tmp1 = accumulator[metric_set->c_offset + 0];
    uint64_t tmp2 = tmp0 + tmp1;

    return tmp2;
}

/* Metric set SamplerBalance :: LLC GPU Accesses */
#define hsw__sampler_balance__llc_accesses__read \
    hsw__render_basic__llc_accesses__read

/* Metric set SamplerBalance :: LLC GPU Hits */
#define hsw__sampler_balance__llc_hits__read \
    hsw__render_basic__llc_hits__read

/* Render Metrics Basic Gen8 :: GPU Time Elapsed */
#define bdw__render_basic__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Render Metrics Basic Gen8 :: GPU Core Clocks */
static uint64_t
bdw__render_basic__gpu_core_clocks__read(const struct intel_perf *perf,
                                         const struct intel_perf_metric_set *metric_set,
                                         uint64_t *accumulator)
{
    /* RPN equation: GPU_CLOCK 0 READ */
    uint64_t tmp0 = accumulator[metric_set->gpu_clock_offset + 0];

    return tmp0;
}

/* Render Metrics Basic Gen8 :: AVG GPU Core Frequency */
static uint64_t
bdw__render_basic__avg_gpu_core_frequency__read(const struct intel_perf *perf,
                                                const struct intel_perf_metric_set *metric_set,
                                                uint64_t *accumulator)
{
    /* RPN equation: $GpuCoreClocks 1000000000 UMUL $GpuTime UDIV */
    uint64_t tmp0 = bdw__render_basic__gpu_core_clocks__read(perf, metric_set, accumulator) * 1000000000;
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = bdw__render_basic__gpu_time__read(perf, metric_set, accumulator);
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;

    return tmp3;
}

/* Render Metrics Basic Gen8 :: AVG GPU Core Frequency */
#define bdw__render_basic__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Render Metrics Basic Gen8 :: VS Threads Dispatched */
static uint64_t
bdw__render_basic__vs_threads__read(const struct intel_perf *perf,
                                    const struct intel_perf_metric_set *metric_set,
                                    uint64_t *accumulator)
{
    /* RPN equation: A 1 READ */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 1];

    return tmp0;
}

/* Render Metrics Basic Gen8 :: HS Threads Dispatched */
static uint64_t
bdw__render_basic__hs_threads__read(const struct intel_perf *perf,
                                    const struct intel_perf_metric_set *metric_set,
                                    uint64_t *accumulator)
{
    /* RPN equation: A 2 READ */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 2];

    return tmp0;
}

/* Render Metrics Basic Gen8 :: DS Threads Dispatched */
static uint64_t
bdw__render_basic__ds_threads__read(const struct intel_perf *perf,
                                    const struct intel_perf_metric_set *metric_set,
                                    uint64_t *accumulator)
{
    /* RPN equation: A 3 READ */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 3];

    return tmp0;
}

/* Render Metrics Basic Gen8 :: GS Threads Dispatched */
#define bdw__render_basic__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Render Metrics Basic Gen8 :: FS Threads Dispatched */
static uint64_t
bdw__render_basic__ps_threads__read(const struct intel_perf *perf,
                                    const struct intel_perf_metric_set *metric_set,
                                    uint64_t *accumulator)
{
    /* RPN equation: A 6 READ */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 6];

    return tmp0;
}

/* Render Metrics Basic Gen8 :: CS Threads Dispatched */
static uint64_t
bdw__render_basic__cs_threads__read(const struct intel_perf *perf,
                                    const struct intel_perf_metric_set *metric_set,
                                    uint64_t *accumulator)
{
    /* RPN equation: A 4 READ */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 4];

    return tmp0;
}

/* Render Metrics Basic Gen8 :: GPU Busy */
static double
bdw__render_basic__gpu_busy__read(const struct intel_perf *perf,
                                  const struct intel_perf_metric_set *metric_set,
                                  uint64_t *accumulator)
{
    /* RPN equation: A 0 READ 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 0];
    uint64_t tmp1 = tmp0 * 100;
    double tmp2 = tmp1;
    double tmp3 = bdw__render_basic__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp4 = tmp3 ? tmp2 / tmp3 : 0;

    return tmp4;
}

/* Render Metrics Basic Gen8 :: EU Active */
static double
bdw__render_basic__eu_active__read(const struct intel_perf *perf,
                                   const struct intel_perf_metric_set *metric_set,
                                   uint64_t *accumulator)
{
    /* RPN equation: A 7 READ $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 7];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = perf->devinfo.n_eus;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    uint64_t tmp4 = tmp3 * 100;
    double tmp5 = tmp4;
    double tmp6 = bdw__render_basic__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp7 = tmp6 ? tmp5 / tmp6 : 0;

    return tmp7;
}

/* Render Metrics Basic Gen8 :: EU Stall */
static double
bdw__render_basic__eu_stall__read(const struct intel_perf *perf,
                                  const struct intel_perf_metric_set *metric_set,
                                  uint64_t *accumulator)
{
    /* RPN equation: A 8 READ $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 8];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = perf->devinfo.n_eus;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    uint64_t tmp4 = tmp3 * 100;
    double tmp5 = tmp4;
    double tmp6 = bdw__render_basic__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp7 = tmp6 ? tmp5 / tmp6 : 0;

    return tmp7;
}

/* Render Metrics Basic Gen8 :: EU Both FPU Pipes Active */
static double
bdw__render_basic__eu_fpu_both_active__read(const struct intel_perf *perf,
                                            const struct intel_perf_metric_set *metric_set,
                                            uint64_t *accumulator)
{
    /* RPN equation: A 9 READ $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 9];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = perf->devinfo.n_eus;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    uint64_t tmp4 = tmp3 * 100;
    double tmp5 = tmp4;
    double tmp6 = bdw__render_basic__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp7 = tmp6 ? tmp5 / tmp6 : 0;

    return tmp7;
}

/* Render Metrics Basic Gen8 :: VS FPU0 Pipe Active */
static double
bdw__render_basic__vs_fpu0_active__read(const struct intel_perf *perf,
                                        const struct intel_perf_metric_set *metric_set,
                                        uint64_t *accumulator)
{
    /* RPN equation: A 10 READ $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 10];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = perf->devinfo.n_eus;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    uint64_t tmp4 = tmp3 * 100;
    double tmp5 = tmp4;
    double tmp6 = bdw__render_basic__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp7 = tmp6 ? tmp5 / tmp6 : 0;

    return tmp7;
}

/* Render Metrics Basic Gen8 :: VS FPU1 Pipe Active */
static double
bdw__render_basic__vs_fpu1_active__read(const struct intel_perf *perf,
                                        const struct intel_perf_metric_set *metric_set,
                                        uint64_t *accumulator)
{
    /* RPN equation: A 11 READ $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 11];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = perf->devinfo.n_eus;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    uint64_t tmp4 = tmp3 * 100;
    double tmp5 = tmp4;
    double tmp6 = bdw__render_basic__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp7 = tmp6 ? tmp5 / tmp6 : 0;

    return tmp7;
}

/* Render Metrics Basic Gen8 :: VS Send Pipe Active */
static double
bdw__render_basic__vs_send_active__read(const struct intel_perf *perf,
                                        const struct intel_perf_metric_set *metric_set,
                                        uint64_t *accumulator)
{
    /* RPN equation: A 12 READ $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 12];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = perf->devinfo.n_eus;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    uint64_t tmp4 = tmp3 * 100;
    double tmp5 = tmp4;
    double tmp6 = bdw__render_basic__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp7 = tmp6 ? tmp5 / tmp6 : 0;

    return tmp7;
}

/* Render Metrics Basic Gen8 :: PS FPU0 Pipe Active */
static double
bdw__render_basic__ps_fpu0_active__read(const struct intel_perf *perf,
                                        const struct intel_perf_metric_set *metric_set,
                                        uint64_t *accumulator)
{
    /* RPN equation: A 15 READ $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 15];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = perf->devinfo.n_eus;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    uint64_t tmp4 = tmp3 * 100;
    double tmp5 = tmp4;
    double tmp6 = bdw__render_basic__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp7 = tmp6 ? tmp5 / tmp6 : 0;

    return tmp7;
}

/* Render Metrics Basic Gen8 :: PS FPU1 Pipe Active */
static double
bdw__render_basic__ps_fpu1_active__read(const struct intel_perf *perf,
                                        const struct intel_perf_metric_set *metric_set,
                                        uint64_t *accumulator)
{
    /* RPN equation: A 16 READ $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 16];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = perf->devinfo.n_eus;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    uint64_t tmp4 = tmp3 * 100;
    double tmp5 = tmp4;
    double tmp6 = bdw__render_basic__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp7 = tmp6 ? tmp5 / tmp6 : 0;

    return tmp7;
}

/* Render Metrics Basic Gen8 :: PS Send Pipeline Active */
static double
bdw__render_basic__ps_send_active__read(const struct intel_perf *perf,
                                        const struct intel_perf_metric_set *metric_set,
                                        uint64_t *accumulator)
{
    /* RPN equation: A 17 READ $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 17];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = perf->devinfo.n_eus;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    uint64_t tmp4 = tmp3 * 100;
    double tmp5 = tmp4;
    double tmp6 = bdw__render_basic__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp7 = tmp6 ? tmp5 / tmp6 : 0;

    return tmp7;
}

/* Render Metrics Basic Gen8 :: FS Both FPU Active */
static double
bdw__render_basic__ps_eu_both_fpu_active__read(const struct intel_perf *perf,
                                               const struct intel_perf_metric_set *metric_set,
                                               uint64_t *accumulator)
{
    /* RPN equation: A 18 READ $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 18];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = perf->devinfo.n_eus;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    uint64_t tmp4 = tmp3 * 100;
    double tmp5 = tmp4;
    double tmp6 = bdw__render_basic__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp7 = tmp6 ? tmp5 / tmp6 : 0;

    return tmp7;
}

/* Render Metrics Basic Gen8 :: Sampler 0 Busy */
static double
bdw__render_basic__sampler0_busy__read(const struct intel_perf *perf,
                                       const struct intel_perf_metric_set *metric_set,
                                       uint64_t *accumulator)
{
    /* RPN equation: B 0 READ 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 0];
    uint64_t tmp1 = tmp0 * 100;
    double tmp2 = tmp1;
    double tmp3 = bdw__render_basic__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp4 = tmp3 ? tmp2 / tmp3 : 0;

    return tmp4;
}

/* Render Metrics Basic Gen8 :: Sampler 1 Busy */
static double
bdw__render_basic__sampler1_busy__read(const struct intel_perf *perf,
                                       const struct intel_perf_metric_set *metric_set,
                                       uint64_t *accumulator)
{
    /* RPN equation: B 1 READ 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 1];
    uint64_t tmp1 = tmp0 * 100;
    double tmp2 = tmp1;
    double tmp3 = bdw__render_basic__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp4 = tmp3 ? tmp2 / tmp3 : 0;

    return tmp4;
}

/* Render Metrics Basic Gen8 :: Samplers Busy */
static double
bdw__render_basic__samplers_busy__read(const struct intel_perf *perf,
                                       const struct intel_perf_metric_set *metric_set,
                                       uint64_t *accumulator)
{
    /* RPN equation: $Sampler0Busy $Sampler1Busy FMAX */
    double tmp0 = bdw__render_basic__sampler0_busy__read(perf, metric_set, accumulator);
    double tmp1 = bdw__render_basic__sampler1_busy__read(perf, metric_set, accumulator);
    double tmp2 = MAX(tmp0, tmp1);

    return tmp2;
}

/* Render Metrics Basic Gen8 :: Sampler 0 Bottleneck */
static double
bdw__render_basic__sampler0_bottleneck__read(const struct intel_perf *perf,
                                             const struct intel_perf_metric_set *metric_set,
                                             uint64_t *accumulator)
{
    /* RPN equation: B 2 READ 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 2];
    uint64_t tmp1 = tmp0 * 100;
    double tmp2 = tmp1;
    double tmp3 = bdw__render_basic__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp4 = tmp3 ? tmp2 / tmp3 : 0;

    return tmp4;
}

/* Render Metrics Basic Gen8 :: Sampler 1 Bottleneck */
static double
bdw__render_basic__sampler1_bottleneck__read(const struct intel_perf *perf,
                                             const struct intel_perf_metric_set *metric_set,
                                             uint64_t *accumulator)
{
    /* RPN equation: B 3 READ 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 3];
    uint64_t tmp1 = tmp0 * 100;
    double tmp2 = tmp1;
    double tmp3 = bdw__render_basic__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp4 = tmp3 ? tmp2 / tmp3 : 0;

    return tmp4;
}

/* Render Metrics Basic Gen8 :: Samples Written */
static uint64_t
bdw__render_basic__samples_written__read(const struct intel_perf *perf,
                                         const struct intel_perf_metric_set *metric_set,
                                         uint64_t *accumulator)
{
    /* RPN equation: A 26 READ 4 UMUL */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 26];
    uint64_t tmp1 = tmp0 * 4;

    return tmp1;
}

/* Render Metrics Basic Gen8 :: Samples Blended */
static uint64_t
bdw__render_basic__samples_blended__read(const struct intel_perf *perf,
                                         const struct intel_perf_metric_set *metric_set,
                                         uint64_t *accumulator)
{
    /* RPN equation: A 27 READ 4 UMUL */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 27];
    uint64_t tmp1 = tmp0 * 4;

    return tmp1;
}

/* Render Metrics Basic Gen8 :: Sampler Texels */
static uint64_t
bdw__render_basic__sampler_texels__read(const struct intel_perf *perf,
                                        const struct intel_perf_metric_set *metric_set,
                                        uint64_t *accumulator)
{
    /* RPN equation: A 28 READ 4 UMUL */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 28];
    uint64_t tmp1 = tmp0 * 4;

    return tmp1;
}

/* Render Metrics Basic Gen8 :: Sampler Texels Misses */
static uint64_t
bdw__render_basic__sampler_texel_misses__read(const struct intel_perf *perf,
                                              const struct intel_perf_metric_set *metric_set,
                                              uint64_t *accumulator)
{
    /* RPN equation: A 29 READ 4 UMUL */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 29];
    uint64_t tmp1 = tmp0 * 4;

    return tmp1;
}

/* Render Metrics Basic Gen8 :: Sampler Cache Misses */
static uint64_t
bdw__render_basic__sampler_l1_misses__read(const struct intel_perf *perf,
                                           const struct intel_perf_metric_set *metric_set,
                                           uint64_t *accumulator)
{
    /* RPN equation: B 4 READ B 5 READ UADD 8 UMUL */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 4];
    uint64_t tmp1 = accumulator[metric_set->b_offset + 5];
    uint64_t tmp2 = tmp0 + tmp1;
    uint64_t tmp3 = tmp2 * 8;

    return tmp3;
}

/* Render Metrics Basic Gen8 :: Rasterized Pixels */
static uint64_t
bdw__render_basic__rasterized_pixels__read(const struct intel_perf *perf,
                                           const struct intel_perf_metric_set *metric_set,
                                           uint64_t *accumulator)
{
    /* RPN equation: A 21 READ 4 UMUL */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 21];
    uint64_t tmp1 = tmp0 * 4;

    return tmp1;
}

/* Render Metrics Basic Gen8 :: Early Hi-Depth Test Fails */
static uint64_t
bdw__render_basic__hi_depth_test_fails__read(const struct intel_perf *perf,
                                             const struct intel_perf_metric_set *metric_set,
                                             uint64_t *accumulator)
{
    /* RPN equation: A 22 READ 4 UMUL */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 22];
    uint64_t tmp1 = tmp0 * 4;

    return tmp1;
}

/* Render Metrics Basic Gen8 :: Early Depth Test Fails */
static uint64_t
bdw__render_basic__early_depth_test_fails__read(const struct intel_perf *perf,
                                                const struct intel_perf_metric_set *metric_set,
                                                uint64_t *accumulator)
{
    /* RPN equation: A 23 READ 4 UMUL */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 23];
    uint64_t tmp1 = tmp0 * 4;

    return tmp1;
}

/* Render Metrics Basic Gen8 :: Samples Killed in FS */
static uint64_t
bdw__render_basic__samples_killed_in_ps__read(const struct intel_perf *perf,
                                              const struct intel_perf_metric_set *metric_set,
                                              uint64_t *accumulator)
{
    /* RPN equation: A 24 READ 4 UMUL */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 24];
    uint64_t tmp1 = tmp0 * 4;

    return tmp1;
}

/* Render Metrics Basic Gen8 :: Pixels Failing Tests */
static uint64_t
bdw__render_basic__pixels_failing_post_ps_tests__read(const struct intel_perf *perf,
                                                      const struct intel_perf_metric_set *metric_set,
                                                      uint64_t *accumulator)
{
    /* RPN equation: A 25 READ 4 UMUL */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 25];
    uint64_t tmp1 = tmp0 * 4;

    return tmp1;
}

/* Render Metrics Basic Gen8 :: SLM Bytes Read */
static uint64_t
bdw__render_basic__slm_bytes_read__read(const struct intel_perf *perf,
                                        const struct intel_perf_metric_set *metric_set,
                                        uint64_t *accumulator)
{
    /* RPN equation: A 30 READ 64 UMUL */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 30];
    uint64_t tmp1 = tmp0 * 64;

    return tmp1;
}

/* Render Metrics Basic Gen8 :: SLM Bytes Read */
static uint64_t
bdw__render_basic__slm_bytes_read__max(const struct intel_perf *perf,
                                       const struct intel_perf_metric_set *metric_set,
                                       uint64_t *accumulator)
{
    /* RPN equation: $GpuCoreClocks 64 UMUL $EuSubslicesTotalCount UMUL */
    uint64_t tmp0 = bdw__render_basic__gpu_core_clocks__read(perf, metric_set, accumulator) * 64;
    uint64_t tmp1 = tmp0 * perf->devinfo.n_eu_sub_slices;

    return tmp1;
}

/* Render Metrics Basic Gen8 :: SLM Bytes Written */
static uint64_t
bdw__render_basic__slm_bytes_written__read(const struct intel_perf *perf,
                                           const struct intel_perf_metric_set *metric_set,
                                           uint64_t *accumulator)
{
    /* RPN equation: A 31 READ 64 UMUL */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 31];
    uint64_t tmp1 = tmp0 * 64;

    return tmp1;
}

/* Render Metrics Basic Gen8 :: SLM Bytes Written */
#define bdw__render_basic__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics Basic Gen8 :: Shader Memory Accesses */
static uint64_t
bdw__render_basic__shader_memory_accesses__read(const struct intel_perf *perf,
                                                const struct intel_perf_metric_set *metric_set,
                                                uint64_t *accumulator)
{
    /* RPN equation: A 32 READ */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 32];

    return tmp0;
}

/* Render Metrics Basic Gen8 :: Shader Atomic Memory Accesses */
static uint64_t
bdw__render_basic__shader_atomics__read(const struct intel_perf *perf,
                                        const struct intel_perf_metric_set *metric_set,
                                        uint64_t *accumulator)
{
    /* RPN equation: A 34 READ */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 34];

    return tmp0;
}

/* Render Metrics Basic Gen8 :: L3 Lookup Accesses w/o IC */
static uint64_t
bdw__render_basic__l3_lookups__read(const struct intel_perf *perf,
                                    const struct intel_perf_metric_set *metric_set,
                                    uint64_t *accumulator)
{
    /* RPN equation: $SamplerL1Misses $ShaderMemoryAccesses UADD */
    uint64_t tmp0 = bdw__render_basic__sampler_l1_misses__read(perf, metric_set, accumulator) + bdw__render_basic__shader_memory_accesses__read(perf, metric_set, accumulator);

    return tmp0;
}

/* Render Metrics Basic Gen8 :: L3 Misses */
#define bdw__render_basic__l3_misses__read \
    hsw__compute_extended__typed_atomics0__read

/* Render Metrics Basic Gen8 :: L3 Sampler Throughput */
static uint64_t
bdw__render_basic__l3_sampler_throughput__read(const struct intel_perf *perf,
                                               const struct intel_perf_metric_set *metric_set,
                                               uint64_t *accumulator)
{
    /* RPN equation: $SamplerL1Misses 64 UMUL */
    uint64_t tmp0 = bdw__render_basic__sampler_l1_misses__read(perf, metric_set, accumulator) * 64;

    return tmp0;
}

/* Render Metrics Basic Gen8 :: L3 Sampler Throughput */
#define bdw__render_basic__l3_sampler_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics Basic Gen8 :: L3 Shader Throughput */
static uint64_t
bdw__render_basic__l3_shader_throughput__read(const struct intel_perf *perf,
                                              const struct intel_perf_metric_set *metric_set,
                                              uint64_t *accumulator)
{
    /* RPN equation: A 30 READ  A 31 READ $ShaderMemoryAccesses UADD UADD 64 UMUL */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 30];
    uint64_t tmp1 = accumulator[metric_set->a_offset + 31];
    uint64_t tmp2 = tmp1 + bdw__render_basic__shader_memory_accesses__read(perf, metric_set, accumulator);
    uint64_t tmp3 = tmp0 + tmp2;
    uint64_t tmp4 = tmp3 * 64;

    return tmp4;
}

/* Render Metrics Basic Gen8 :: L3 Shader Throughput */
static uint64_t
bdw__render_basic__l3_shader_throughput__max(const struct intel_perf *perf,
                                             const struct intel_perf_metric_set *metric_set,
                                             uint64_t *accumulator)
{
    /* RPN equation: $GpuCoreClocks 64 UMUL 2 UMUL $EuSubslicesTotalCount UMUL */
    uint64_t tmp0 = bdw__render_basic__gpu_core_clocks__read(perf, metric_set, accumulator) * 64;
    uint64_t tmp1 = tmp0 * 2;
    uint64_t tmp2 = tmp1 * perf->devinfo.n_eu_sub_slices;

    return tmp2;
}

/* Render Metrics Basic Gen8 :: Shader Barrier Messages */
#define bdw__render_basic__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Render Metrics Basic Gen8 :: GTI Fixed Pipe Throughput */
static uint64_t
bdw__render_basic__gti_vf_throughput__read(const struct intel_perf *perf,
                                           const struct intel_perf_metric_set *metric_set,
                                           uint64_t *accumulator)
{
    /* RPN equation: B 6 READ B 7 READ UADD 64 UMUL */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 6];
    uint64_t tmp1 = accumulator[metric_set->b_offset + 7];
    uint64_t tmp2 = tmp0 + tmp1;
    uint64_t tmp3 = tmp2 * 64;

    return tmp3;
}

/* Render Metrics Basic Gen8 :: GTI Fixed Pipe Throughput */
static uint64_t
bdw__render_basic__gti_vf_throughput__max(const struct intel_perf *perf,
                                          const struct intel_perf_metric_set *metric_set,
                                          uint64_t *accumulator)
{
    /* RPN equation: $GpuCoreClocks 64 UMUL */
    uint64_t tmp0 = bdw__render_basic__gpu_core_clocks__read(perf, metric_set, accumulator) * 64;

    return tmp0;
}

/* Render Metrics Basic Gen8 :: GTI Depth Throughput */
static uint64_t
bdw__render_basic__gti_depth_throughput__read(const struct intel_perf *perf,
                                              const struct intel_perf_metric_set *metric_set,
                                              uint64_t *accumulator)
{
    /* RPN equation: C 0 READ C 1 READ UADD 64 UMUL */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 0];
    uint64_t tmp1 = accumulator[metric_set->c_offset + 1];
    uint64_t tmp2 = tmp0 + tmp1;
    uint64_t tmp3 = tmp2 * 64;

    return tmp3;
}

/* Render Metrics Basic Gen8 :: GTI Depth Throughput */
static uint64_t
bdw__render_basic__gti_depth_throughput__max(const struct intel_perf *perf,
                                             const struct intel_perf_metric_set *metric_set,
                                             uint64_t *accumulator)
{
    /* RPN equation: $GpuCoreClocks 64 UMUL $EuSlicesTotalCount UMUL */
    uint64_t tmp0 = bdw__render_basic__gpu_core_clocks__read(perf, metric_set, accumulator) * 64;
    uint64_t tmp1 = tmp0 * perf->devinfo.n_eu_slices;

    return tmp1;
}

/* Render Metrics Basic Gen8 :: GTI RCC Throughput */
static uint64_t
bdw__render_basic__gti_rcc_throughput__read(const struct intel_perf *perf,
                                            const struct intel_perf_metric_set *metric_set,
                                            uint64_t *accumulator)
{
    /* RPN equation: C 2 READ C 3 READ UADD 64 UMUL */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 2];
    uint64_t tmp1 = accumulator[metric_set->c_offset + 3];
    uint64_t tmp2 = tmp0 + tmp1;
    uint64_t tmp3 = tmp2 * 64;

    return tmp3;
}

/* Render Metrics Basic Gen8 :: GTI RCC Throughput */
#define bdw__render_basic__gti_rcc_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics Basic Gen8 :: GTI L3 Throughput */
#define bdw__render_basic__gti_l3_throughput__read \
    hsw__render_basic__gti_l3_throughput__read

/* Render Metrics Basic Gen8 :: GTI L3 Throughput */
#define bdw__render_basic__gti_l3_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics Basic Gen8 :: GTI HDC TLB Lookup Throughput */
static uint64_t
bdw__render_basic__gti_hdc_lookups_throughput__read(const struct intel_perf *perf,
                                                    const struct intel_perf_metric_set *metric_set,
                                                    uint64_t *accumulator)
{
    /* RPN equation: C 5 READ 64 UMUL */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 5];
    uint64_t tmp1 = tmp0 * 64;

    return tmp1;
}

/* Render Metrics Basic Gen8 :: GTI HDC TLB Lookup Throughput */
#define bdw__render_basic__gti_hdc_lookups_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics Basic Gen8 :: GTI Read Throughput */
static uint64_t
bdw__render_basic__gti_read_throughput__read(const struct intel_perf *perf,
                                             const struct intel_perf_metric_set *metric_set,
                                             uint64_t *accumulator)
{
    /* RPN equation: C 6 READ 64 UMUL */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 6];
    uint64_t tmp1 = tmp0 * 64;

    return tmp1;
}

/* Render Metrics Basic Gen8 :: GTI Read Throughput */
#define bdw__render_basic__gti_read_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Render Metrics Basic Gen8 :: GTI Write Throughput */
#define bdw__render_basic__gti_write_throughput__read \
    hsw__render_basic__gti_write_throughput__read

/* Render Metrics Basic Gen8 :: GTI Write Throughput */
static uint64_t
bdw__render_basic__gti_write_throughput__max(const struct intel_perf *perf,
                                             const struct intel_perf_metric_set *metric_set,
                                             uint64_t *accumulator)
{
    /* RPN equation: $GpuCoreClocks 32 UMUL */
    uint64_t tmp0 = bdw__render_basic__gpu_core_clocks__read(perf, metric_set, accumulator) * 32;

    return tmp0;
}

/* Render Metrics Basic Gen8 :: Samplers Bottleneck */
static double
bdw__render_basic__sampler_bottleneck__read(const struct intel_perf *perf,
                                            const struct intel_perf_metric_set *metric_set,
                                            uint64_t *accumulator)
{
    /* RPN equation: $Sampler0Bottleneck $Sampler1Bottleneck FMAX */
    double tmp0 = bdw__render_basic__sampler0_bottleneck__read(perf, metric_set, accumulator);
    double tmp1 = bdw__render_basic__sampler1_bottleneck__read(perf, metric_set, accumulator);
    double tmp2 = MAX(tmp0, tmp1);

    return tmp2;
}

/* Compute Metrics Basic Gen8 :: GPU Time Elapsed */
#define bdw__compute_basic__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Compute Metrics Basic Gen8 :: GPU Core Clocks */
#define bdw__compute_basic__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Compute Metrics Basic Gen8 :: AVG GPU Core Frequency */
#define bdw__compute_basic__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Compute Metrics Basic Gen8 :: AVG GPU Core Frequency */
#define bdw__compute_basic__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Compute Metrics Basic Gen8 :: GPU Busy */
#define bdw__compute_basic__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Compute Metrics Basic Gen8 :: VS Threads Dispatched */
#define bdw__compute_basic__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Compute Metrics Basic Gen8 :: HS Threads Dispatched */
#define bdw__compute_basic__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Compute Metrics Basic Gen8 :: DS Threads Dispatched */
#define bdw__compute_basic__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Compute Metrics Basic Gen8 :: GS Threads Dispatched */
#define bdw__compute_basic__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Compute Metrics Basic Gen8 :: FS Threads Dispatched */
#define bdw__compute_basic__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Compute Metrics Basic Gen8 :: CS Threads Dispatched */
#define bdw__compute_basic__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Compute Metrics Basic Gen8 :: EU Active */
#define bdw__compute_basic__eu_active__read \
    bdw__render_basic__eu_active__read

/* Compute Metrics Basic Gen8 :: EU Stall */
#define bdw__compute_basic__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Compute Metrics Basic Gen8 :: EU Both FPU Pipes Active */
#define bdw__compute_basic__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Compute Metrics Basic Gen8 :: EU FPU0 Pipe Active */
#define bdw__compute_basic__fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Compute Metrics Basic Gen8 :: EU FPU1 Pipe Active */
#define bdw__compute_basic__fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Compute Metrics Basic Gen8 :: EU AVG IPC Rate */
static double
bdw__compute_basic__eu_avg_ipc_rate__read(const struct intel_perf *perf,
                                          const struct intel_perf_metric_set *metric_set,
                                          uint64_t *accumulator)
{
    /* RPN equation: A 9 READ  A 10 READ  A 11 READ UADD  A 9 READ USUB FDIV 1 FADD */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 9];
    uint64_t tmp1 = accumulator[metric_set->a_offset + 10];
    uint64_t tmp2 = accumulator[metric_set->a_offset + 11];
    uint64_t tmp3 = tmp1 + tmp2;
    uint64_t tmp4 = accumulator[metric_set->a_offset + 9];
    uint64_t tmp5 = tmp3 - tmp4;
    double tmp6 = tmp0;
    double tmp7 = tmp5;
    double tmp8 = tmp7 ? tmp6 / tmp7 : 0;
    double tmp9 = tmp8 + 1;

    return tmp9;
}

/* Compute Metrics Basic Gen8 :: EU AVG IPC Rate */
static double
bdw__compute_basic__eu_avg_ipc_rate__max(const struct intel_perf *perf,
                                         const struct intel_perf_metric_set *metric_set,
                                         uint64_t *accumulator)
{
    /* RPN equation: 2 */

    return 2;
}

/* Compute Metrics Basic Gen8 :: EU Send Pipe Active */
#define bdw__compute_basic__eu_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Compute Metrics Basic Gen8 :: EU Thread Occupancy */
static double
bdw__compute_basic__eu_thread_occupancy__read(const struct intel_perf *perf,
                                              const struct intel_perf_metric_set *metric_set,
                                              uint64_t *accumulator)
{
    /* RPN equation: A 13 READ 8 UMUL $EuCoresTotalCount UDIV $EuThreadsCount UDIV 100 UMUL  $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 13];
    uint64_t tmp1 = tmp0 * 8;
    uint64_t tmp2 = tmp1;
    uint64_t tmp3 = perf->devinfo.n_eus;
    uint64_t tmp4 = tmp3 ? tmp2 / tmp3 : 0;
    uint64_t tmp5 = tmp4;
    uint64_t tmp6 = perf->devinfo.eu_threads_count;
    uint64_t tmp7 = tmp6 ? tmp5 / tmp6 : 0;
    uint64_t tmp8 = tmp7 * 100;
    double tmp9 = tmp8;
    double tmp10 = bdw__compute_basic__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp11 = tmp10 ? tmp9 / tmp10 : 0;

    return tmp11;
}

/* Compute Metrics Basic Gen8 :: Rasterized Pixels */
#define bdw__compute_basic__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Compute Metrics Basic Gen8 :: Early Hi-Depth Test Fails */
#define bdw__compute_basic__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Compute Metrics Basic Gen8 :: Early Depth Test Fails */
#define bdw__compute_basic__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Compute Metrics Basic Gen8 :: Samples Killed in FS */
#define bdw__compute_basic__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Compute Metrics Basic Gen8 :: Pixels Failing Tests */
#define bdw__compute_basic__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Compute Metrics Basic Gen8 :: Samples Written */
#define bdw__compute_basic__samples_written__read \
    bdw__render_basic__samples_written__read

/* Compute Metrics Basic Gen8 :: Samples Blended */
#define bdw__compute_basic__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Compute Metrics Basic Gen8 :: Sampler Texels */
#define bdw__compute_basic__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Compute Metrics Basic Gen8 :: Sampler Texels Misses */
#define bdw__compute_basic__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Compute Metrics Basic Gen8 :: SLM Bytes Read */
#define bdw__compute_basic__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Compute Metrics Basic Gen8 :: SLM Bytes Read */
#define bdw__compute_basic__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Basic Gen8 :: SLM Bytes Written */
#define bdw__compute_basic__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Compute Metrics Basic Gen8 :: SLM Bytes Written */
#define bdw__compute_basic__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Basic Gen8 :: Shader Memory Accesses */
#define bdw__compute_basic__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Compute Metrics Basic Gen8 :: Shader Atomic Memory Accesses */
#define bdw__compute_basic__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Compute Metrics Basic Gen8 :: L3 Shader Throughput */
#define bdw__compute_basic__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Compute Metrics Basic Gen8 :: L3 Shader Throughput */
#define bdw__compute_basic__l3_shader_throughput__max \
    bdw__render_basic__l3_shader_throughput__max

/* Compute Metrics Basic Gen8 :: Shader Barrier Messages */
#define bdw__compute_basic__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Compute Metrics Basic Gen8 :: Typed Bytes Read */
static uint64_t
bdw__compute_basic__typed_bytes_read__read(const struct intel_perf *perf,
                                           const struct intel_perf_metric_set *metric_set,
                                           uint64_t *accumulator)
{
    /* RPN equation: B 0 READ B 1 READ B 2 READ UADD UADD $EuSlicesTotalCount 64 UMUL UMUL */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 0];
    uint64_t tmp1 = accumulator[metric_set->b_offset + 1];
    uint64_t tmp2 = accumulator[metric_set->b_offset + 2];
    uint64_t tmp3 = tmp1 + tmp2;
    uint64_t tmp4 = tmp0 + tmp3;
    uint64_t tmp5 = perf->devinfo.n_eu_slices * 64;
    uint64_t tmp6 = tmp4 * tmp5;

    return tmp6;
}

/* Compute Metrics Basic Gen8 :: Typed Bytes Read */
#define bdw__compute_basic__typed_bytes_read__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen8 :: Typed Bytes Written */
static uint64_t
bdw__compute_basic__typed_bytes_written__read(const struct intel_perf *perf,
                                              const struct intel_perf_metric_set *metric_set,
                                              uint64_t *accumulator)
{
    /* RPN equation: B 3 READ B 4 READ B 5 READ UADD UADD $EuSlicesTotalCount 64 UMUL UMUL */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 3];
    uint64_t tmp1 = accumulator[metric_set->b_offset + 4];
    uint64_t tmp2 = accumulator[metric_set->b_offset + 5];
    uint64_t tmp3 = tmp1 + tmp2;
    uint64_t tmp4 = tmp0 + tmp3;
    uint64_t tmp5 = perf->devinfo.n_eu_slices * 64;
    uint64_t tmp6 = tmp4 * tmp5;

    return tmp6;
}

/* Compute Metrics Basic Gen8 :: Typed Bytes Written */
#define bdw__compute_basic__typed_bytes_written__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen8 :: Untyped Bytes Read */
static uint64_t
bdw__compute_basic__untyped_bytes_read__read(const struct intel_perf *perf,
                                             const struct intel_perf_metric_set *metric_set,
                                             uint64_t *accumulator)
{
    /* RPN equation: B 6 READ B 7 READ C 0 READ UADD UADD $EuSlicesTotalCount 64 UMUL UMUL */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 6];
    uint64_t tmp1 = accumulator[metric_set->b_offset + 7];
    uint64_t tmp2 = accumulator[metric_set->c_offset + 0];
    uint64_t tmp3 = tmp1 + tmp2;
    uint64_t tmp4 = tmp0 + tmp3;
    uint64_t tmp5 = perf->devinfo.n_eu_slices * 64;
    uint64_t tmp6 = tmp4 * tmp5;

    return tmp6;
}

/* Compute Metrics Basic Gen8 :: Untyped Bytes Read */
#define bdw__compute_basic__untyped_bytes_read__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen8 :: Untyped Writes */
static uint64_t
bdw__compute_basic__untyped_bytes_written__read(const struct intel_perf *perf,
                                                const struct intel_perf_metric_set *metric_set,
                                                uint64_t *accumulator)
{
    /* RPN equation: C 1 READ C 2 READ C 3 READ UADD UADD $EuSlicesTotalCount 64 UMUL UMUL */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 1];
    uint64_t tmp1 = accumulator[metric_set->c_offset + 2];
    uint64_t tmp2 = accumulator[metric_set->c_offset + 3];
    uint64_t tmp3 = tmp1 + tmp2;
    uint64_t tmp4 = tmp0 + tmp3;
    uint64_t tmp5 = perf->devinfo.n_eu_slices * 64;
    uint64_t tmp6 = tmp4 * tmp5;

    return tmp6;
}

/* Compute Metrics Basic Gen8 :: Untyped Writes */
#define bdw__compute_basic__untyped_bytes_written__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen8 :: GTI Read Throughput */
#define bdw__compute_basic__gti_read_throughput__read \
    hsw__render_basic__gti_l3_throughput__read

/* Compute Metrics Basic Gen8 :: GTI Read Throughput */
#define bdw__compute_basic__gti_read_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Compute Metrics Basic Gen8 :: GTI Write Throughput */
#define bdw__compute_basic__gti_write_throughput__read \
    bdw__render_basic__gti_hdc_lookups_throughput__read

/* Compute Metrics Basic Gen8 :: GTI Write Throughput */
#define bdw__compute_basic__gti_write_throughput__max \
    bdw__render_basic__gti_write_throughput__max

/* Render Metrics for 3D Pipeline Profile :: GPU Time Elapsed */
#define bdw__render_pipe_profile__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Render Metrics for 3D Pipeline Profile :: GPU Core Clocks */
#define bdw__render_pipe_profile__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Render Metrics for 3D Pipeline Profile :: AVG GPU Core Frequency */
#define bdw__render_pipe_profile__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Render Metrics for 3D Pipeline Profile :: AVG GPU Core Frequency */
#define bdw__render_pipe_profile__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Render Metrics for 3D Pipeline Profile :: GPU Busy */
#define bdw__render_pipe_profile__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Render Metrics for 3D Pipeline Profile :: VS Threads Dispatched */
#define bdw__render_pipe_profile__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Render Metrics for 3D Pipeline Profile :: HS Threads Dispatched */
#define bdw__render_pipe_profile__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Render Metrics for 3D Pipeline Profile :: DS Threads Dispatched */
#define bdw__render_pipe_profile__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Render Metrics for 3D Pipeline Profile :: GS Threads Dispatched */
#define bdw__render_pipe_profile__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Render Metrics for 3D Pipeline Profile :: FS Threads Dispatched */
#define bdw__render_pipe_profile__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Render Metrics for 3D Pipeline Profile :: CS Threads Dispatched */
#define bdw__render_pipe_profile__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Render Metrics for 3D Pipeline Profile :: EU Active */
#define bdw__render_pipe_profile__eu_active__read \
    bdw__render_basic__eu_active__read

/* Render Metrics for 3D Pipeline Profile :: EU Stall */
#define bdw__render_pipe_profile__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Render Metrics for 3D Pipeline Profile :: Rasterized Pixels */
#define bdw__render_pipe_profile__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Render Metrics for 3D Pipeline Profile :: Early Hi-Depth Test Fails */
#define bdw__render_pipe_profile__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Render Metrics for 3D Pipeline Profile :: Early Depth Test Fails */
#define bdw__render_pipe_profile__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Render Metrics for 3D Pipeline Profile :: Samples Killed in FS */
#define bdw__render_pipe_profile__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Render Metrics for 3D Pipeline Profile :: Pixels Failing Tests */
#define bdw__render_pipe_profile__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Render Metrics for 3D Pipeline Profile :: Samples Written */
#define bdw__render_pipe_profile__samples_written__read \
    bdw__render_basic__samples_written__read

/* Render Metrics for 3D Pipeline Profile :: Samples Blended */
#define bdw__render_pipe_profile__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Render Metrics for 3D Pipeline Profile :: Sampler Accesses */
static uint64_t
bdw__render_pipe_profile__sampler_accesses__read(const struct intel_perf *perf,
                                                 const struct intel_perf_metric_set *metric_set,
                                                 uint64_t *accumulator)
{
    /* RPN equation: A 28 READ */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 28];

    return tmp0;
}

/* Render Metrics for 3D Pipeline Profile :: Sampler Texels */
#define bdw__render_pipe_profile__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Render Metrics for 3D Pipeline Profile :: Sampler Texels Misses */
#define bdw__render_pipe_profile__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Render Metrics for 3D Pipeline Profile :: SLM Bytes Read */
#define bdw__render_pipe_profile__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Render Metrics for 3D Pipeline Profile :: SLM Bytes Read */
#define bdw__render_pipe_profile__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics for 3D Pipeline Profile :: SLM Bytes Written */
#define bdw__render_pipe_profile__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Render Metrics for 3D Pipeline Profile :: SLM Bytes Written */
#define bdw__render_pipe_profile__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics for 3D Pipeline Profile :: Shader Memory Accesses */
#define bdw__render_pipe_profile__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Render Metrics for 3D Pipeline Profile :: Shader Atomic Memory Accesses */
#define bdw__render_pipe_profile__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Render Metrics for 3D Pipeline Profile :: L3 Shader Throughput */
#define bdw__render_pipe_profile__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Render Metrics for 3D Pipeline Profile :: L3 Shader Throughput */
#define bdw__render_pipe_profile__l3_shader_throughput__max \
    bdw__render_basic__l3_shader_throughput__max

/* Render Metrics for 3D Pipeline Profile :: Shader Barrier Messages */
#define bdw__render_pipe_profile__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Render Metrics for 3D Pipeline Profile :: VF Bottleneck */
static double
bdw__render_pipe_profile__vf_bottleneck__read(const struct intel_perf *perf,
                                              const struct intel_perf_metric_set *metric_set,
                                              uint64_t *accumulator)
{
    /* RPN equation: C 0 READ 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 0];
    uint64_t tmp1 = tmp0 * 100;
    double tmp2 = tmp1;
    double tmp3 = bdw__render_pipe_profile__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp4 = tmp3 ? tmp2 / tmp3 : 0;

    return tmp4;
}

/* Render Metrics for 3D Pipeline Profile :: VS Bottleneck */
#define bdw__render_pipe_profile__vs_bottleneck__read \
    bdw__render_basic__sampler0_busy__read

/* Render Metrics for 3D Pipeline Profile :: HS Bottleneck */
#define bdw__render_pipe_profile__hs_bottleneck__read \
    bdw__render_basic__sampler1_busy__read

/* Render Metrics for 3D Pipeline Profile :: DS Bottleneck */
#define bdw__render_pipe_profile__ds_bottleneck__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Render Metrics for 3D Pipeline Profile :: GS Bottleneck */
#define bdw__render_pipe_profile__gs_bottleneck__read \
    bdw__render_basic__sampler1_bottleneck__read

/* Render Metrics for 3D Pipeline Profile :: SO Bottleneck */
static double
bdw__render_pipe_profile__so_bottleneck__read(const struct intel_perf *perf,
                                              const struct intel_perf_metric_set *metric_set,
                                              uint64_t *accumulator)
{
    /* RPN equation: B 4 READ 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 4];
    uint64_t tmp1 = tmp0 * 100;
    double tmp2 = tmp1;
    double tmp3 = bdw__render_pipe_profile__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp4 = tmp3 ? tmp2 / tmp3 : 0;

    return tmp4;
}

/* Render Metrics for 3D Pipeline Profile :: Clipper Bottleneck */
static double
bdw__render_pipe_profile__cl_bottleneck__read(const struct intel_perf *perf,
                                              const struct intel_perf_metric_set *metric_set,
                                              uint64_t *accumulator)
{
    /* RPN equation: B 5 READ 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 5];
    uint64_t tmp1 = tmp0 * 100;
    double tmp2 = tmp1;
    double tmp3 = bdw__render_pipe_profile__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp4 = tmp3 ? tmp2 / tmp3 : 0;

    return tmp4;
}

/* Render Metrics for 3D Pipeline Profile :: Strip-Fans Bottleneck */
static double
bdw__render_pipe_profile__sf_bottleneck__read(const struct intel_perf *perf,
                                              const struct intel_perf_metric_set *metric_set,
                                              uint64_t *accumulator)
{
    /* RPN equation: B 6 READ 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 6];
    uint64_t tmp1 = tmp0 * 100;
    double tmp2 = tmp1;
    double tmp3 = bdw__render_pipe_profile__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp4 = tmp3 ? tmp2 / tmp3 : 0;

    return tmp4;
}

/* Render Metrics for 3D Pipeline Profile :: Hi-Depth Bottleneck */
static double
bdw__render_pipe_profile__hi_depth_bottleneck__read(const struct intel_perf *perf,
                                                    const struct intel_perf_metric_set *metric_set,
                                                    uint64_t *accumulator)
{
    /* RPN equation: C 6 READ 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 6];
    uint64_t tmp1 = tmp0 * 100;
    double tmp2 = tmp1;
    double tmp3 = bdw__render_pipe_profile__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp4 = tmp3 ? tmp2 / tmp3 : 0;

    return tmp4;
}

/* Render Metrics for 3D Pipeline Profile :: Early Depth Bottleneck */
static double
bdw__render_pipe_profile__early_depth_bottleneck__read(const struct intel_perf *perf,
                                                       const struct intel_perf_metric_set *metric_set,
                                                       uint64_t *accumulator)
{
    /* RPN equation: B 7 READ 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 7];
    uint64_t tmp1 = tmp0 * 100;
    double tmp2 = tmp1;
    double tmp3 = bdw__render_pipe_profile__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp4 = tmp3 ? tmp2 / tmp3 : 0;

    return tmp4;
}

/* Render Metrics for 3D Pipeline Profile :: BC Bottleneck */
static double
bdw__render_pipe_profile__bc_bottleneck__read(const struct intel_perf *perf,
                                              const struct intel_perf_metric_set *metric_set,
                                              uint64_t *accumulator)
{
    /* RPN equation: C 7 READ 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 7];
    uint64_t tmp1 = tmp0 * 100;
    double tmp2 = tmp1;
    double tmp3 = bdw__render_pipe_profile__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp4 = tmp3 ? tmp2 / tmp3 : 0;

    return tmp4;
}

/* Render Metrics for 3D Pipeline Profile :: HS Stall */
static double
bdw__render_pipe_profile__hs_stall__read(const struct intel_perf *perf,
                                         const struct intel_perf_metric_set *metric_set,
                                         uint64_t *accumulator)
{
    /* RPN equation: C 1 READ 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 1];
    uint64_t tmp1 = tmp0 * 100;
    double tmp2 = tmp1;
    double tmp3 = bdw__render_pipe_profile__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp4 = tmp3 ? tmp2 / tmp3 : 0;

    return tmp4;
}

/* Render Metrics for 3D Pipeline Profile :: DS Stall */
static double
bdw__render_pipe_profile__ds_stall__read(const struct intel_perf *perf,
                                         const struct intel_perf_metric_set *metric_set,
                                         uint64_t *accumulator)
{
    /* RPN equation: C 2 READ 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 2];
    uint64_t tmp1 = tmp0 * 100;
    double tmp2 = tmp1;
    double tmp3 = bdw__render_pipe_profile__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp4 = tmp3 ? tmp2 / tmp3 : 0;

    return tmp4;
}

/* Render Metrics for 3D Pipeline Profile :: SO Stall */
static double
bdw__render_pipe_profile__so_stall__read(const struct intel_perf *perf,
                                         const struct intel_perf_metric_set *metric_set,
                                         uint64_t *accumulator)
{
    /* RPN equation: C 3 READ 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 3];
    uint64_t tmp1 = tmp0 * 100;
    double tmp2 = tmp1;
    double tmp3 = bdw__render_pipe_profile__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp4 = tmp3 ? tmp2 / tmp3 : 0;

    return tmp4;
}

/* Render Metrics for 3D Pipeline Profile :: CL Stall */
static double
bdw__render_pipe_profile__cl_stall__read(const struct intel_perf *perf,
                                         const struct intel_perf_metric_set *metric_set,
                                         uint64_t *accumulator)
{
    /* RPN equation: C 4 READ 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 4];
    uint64_t tmp1 = tmp0 * 100;
    double tmp2 = tmp1;
    double tmp3 = bdw__render_pipe_profile__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp4 = tmp3 ? tmp2 / tmp3 : 0;

    return tmp4;
}

/* Render Metrics for 3D Pipeline Profile :: SF Stall */
static double
bdw__render_pipe_profile__sf_stall__read(const struct intel_perf *perf,
                                         const struct intel_perf_metric_set *metric_set,
                                         uint64_t *accumulator)
{
    /* RPN equation: C 5 READ 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 5];
    uint64_t tmp1 = tmp0 * 100;
    double tmp2 = tmp1;
    double tmp3 = bdw__render_pipe_profile__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp4 = tmp3 ? tmp2 / tmp3 : 0;

    return tmp4;
}

/* Memory Reads Distribution Gen8 :: GPU Time Elapsed */
#define bdw__memory_reads__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Memory Reads Distribution Gen8 :: GPU Core Clocks */
#define bdw__memory_reads__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Memory Reads Distribution Gen8 :: AVG GPU Core Frequency */
#define bdw__memory_reads__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Memory Reads Distribution Gen8 :: AVG GPU Core Frequency */
#define bdw__memory_reads__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Memory Reads Distribution Gen8 :: GPU Busy */
#define bdw__memory_reads__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Memory Reads Distribution Gen8 :: VS Threads Dispatched */
#define bdw__memory_reads__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Memory Reads Distribution Gen8 :: HS Threads Dispatched */
#define bdw__memory_reads__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Memory Reads Distribution Gen8 :: DS Threads Dispatched */
#define bdw__memory_reads__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Memory Reads Distribution Gen8 :: GS Threads Dispatched */
#define bdw__memory_reads__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Memory Reads Distribution Gen8 :: FS Threads Dispatched */
#define bdw__memory_reads__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Memory Reads Distribution Gen8 :: CS Threads Dispatched */
#define bdw__memory_reads__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Memory Reads Distribution Gen8 :: EU Active */
#define bdw__memory_reads__eu_active__read \
    bdw__render_basic__eu_active__read

/* Memory Reads Distribution Gen8 :: EU Stall */
#define bdw__memory_reads__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Memory Reads Distribution Gen8 :: Rasterized Pixels */
#define bdw__memory_reads__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Memory Reads Distribution Gen8 :: Early Hi-Depth Test Fails */
#define bdw__memory_reads__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Memory Reads Distribution Gen8 :: Early Depth Test Fails */
#define bdw__memory_reads__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Memory Reads Distribution Gen8 :: Samples Killed in FS */
#define bdw__memory_reads__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Memory Reads Distribution Gen8 :: Pixels Failing Tests */
#define bdw__memory_reads__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Memory Reads Distribution Gen8 :: Samples Written */
#define bdw__memory_reads__samples_written__read \
    bdw__render_basic__samples_written__read

/* Memory Reads Distribution Gen8 :: Samples Blended */
#define bdw__memory_reads__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Memory Reads Distribution Gen8 :: Sampler Texels */
#define bdw__memory_reads__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Memory Reads Distribution Gen8 :: Sampler Texels Misses */
#define bdw__memory_reads__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Memory Reads Distribution Gen8 :: SLM Bytes Read */
#define bdw__memory_reads__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Memory Reads Distribution Gen8 :: SLM Bytes Read */
#define bdw__memory_reads__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Memory Reads Distribution Gen8 :: SLM Bytes Written */
#define bdw__memory_reads__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Memory Reads Distribution Gen8 :: SLM Bytes Written */
#define bdw__memory_reads__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Memory Reads Distribution Gen8 :: Shader Memory Accesses */
#define bdw__memory_reads__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Memory Reads Distribution Gen8 :: Shader Atomic Memory Accesses */
#define bdw__memory_reads__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Memory Reads Distribution Gen8 :: Shader Barrier Messages */
#define bdw__memory_reads__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Memory Reads Distribution Gen8 :: L3 Shader Throughput */
#define bdw__memory_reads__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Memory Reads Distribution Gen8 :: L3 Shader Throughput */
#define bdw__memory_reads__l3_shader_throughput__max \
    bdw__render_basic__l3_shader_throughput__max

/* Memory Reads Distribution Gen8 :: GtiCmdStreamerMemoryReads */
#define bdw__memory_reads__gti_cmd_streamer_memory_reads__read \
    hsw__compute_extended__eu_untyped_reads0__read

/* Memory Reads Distribution Gen8 :: GtiRsMemoryReads */
#define bdw__memory_reads__gti_rs_memory_reads__read \
    hsw__compute_extended__eu_typed_reads0__read

/* Memory Reads Distribution Gen8 :: GtiVfMemoryReads */
#define bdw__memory_reads__gti_vf_memory_reads__read \
    hsw__compute_extended__eu_untyped_writes0__read

/* Memory Reads Distribution Gen8 :: GtiRccMemoryReads */
#define bdw__memory_reads__gti_rcc_memory_reads__read \
    hsw__compute_extended__eu_typed_writes0__read

/* Memory Reads Distribution Gen8 :: GtiMscMemoryReads */
#define bdw__memory_reads__gti_msc_memory_reads__read \
    hsw__compute_extended__eu_untyped_atomics0__read

/* Memory Reads Distribution Gen8 :: GtiHizMemoryReads */
#define bdw__memory_reads__gti_hiz_memory_reads__read \
    hsw__compute_extended__eu_typed_atomics0__read

/* Memory Reads Distribution Gen8 :: GtiStcMemoryReads */
#define bdw__memory_reads__gti_stc_memory_reads__read \
    hsw__compute_extended__eu_urb_atomics0__read

/* Memory Reads Distribution Gen8 :: GtiRczMemoryReads */
#define bdw__memory_reads__gti_rcz_memory_reads__read \
    hsw__compute_extended__gpu_clocks__read

/* Memory Reads Distribution Gen8 :: GtiMemoryReads */
#define bdw__memory_reads__gti_memory_reads__read \
    hsw__compute_extended__typed_writes0__read

/* Memory Reads Distribution Gen8 :: GtiL3Bank0Reads */
#define bdw__memory_reads__gti_l3_bank0_reads__read \
    hsw__compute_extended__typed_atomics0__read

/* Memory Reads Distribution Gen8 :: GtiL3Bank1Reads */
#define bdw__memory_reads__gti_l3_bank1_reads__read \
    hsw__memory_reads__gti_memory_reads__read

/* Memory Reads Distribution Gen8 :: GtiL3Bank2Reads */
#define bdw__memory_reads__gti_l3_bank2_reads__read \
    hsw__memory_reads__llc_read_accesses__read

/* Memory Reads Distribution Gen8 :: GtiL3Bank3Reads */
#define bdw__memory_reads__gti_l3_bank3_reads__read \
    hsw__memory_reads__gpu_core_clocks__read

/* Memory Reads Distribution Gen8 :: GtiL3Reads */
static uint64_t
bdw__memory_reads__gti_l3_reads__read(const struct intel_perf *perf,
                                      const struct intel_perf_metric_set *metric_set,
                                      uint64_t *accumulator)
{
    /* RPN equation: $GtiL3Bank0Reads $GtiL3Bank1Reads $GtiL3Bank2Reads $GtiL3Bank3Reads UADD UADD UADD */
    uint64_t tmp0 = bdw__memory_reads__gti_l3_bank2_reads__read(perf, metric_set, accumulator) + bdw__memory_reads__gti_l3_bank3_reads__read(perf, metric_set, accumulator);
    uint64_t tmp1 = bdw__memory_reads__gti_l3_bank1_reads__read(perf, metric_set, accumulator) + tmp0;
    uint64_t tmp2 = bdw__memory_reads__gti_l3_bank0_reads__read(perf, metric_set, accumulator) + tmp1;

    return tmp2;
}

/* Memory Reads Distribution Gen8 :: GtiRingAccesses */
static uint64_t
bdw__memory_reads__gti_ring_accesses__read(const struct intel_perf *perf,
                                           const struct intel_perf_metric_set *metric_set,
                                           uint64_t *accumulator)
{
    /* RPN equation: C 3 READ 2 UMUL */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 3];
    uint64_t tmp1 = tmp0 * 2;

    return tmp1;
}

/* Memory Writes Distribution Gen8 :: GPU Time Elapsed */
#define bdw__memory_writes__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Memory Writes Distribution Gen8 :: GPU Core Clocks */
#define bdw__memory_writes__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Memory Writes Distribution Gen8 :: AVG GPU Core Frequency */
#define bdw__memory_writes__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Memory Writes Distribution Gen8 :: AVG GPU Core Frequency */
#define bdw__memory_writes__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Memory Writes Distribution Gen8 :: GPU Busy */
#define bdw__memory_writes__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Memory Writes Distribution Gen8 :: VS Threads Dispatched */
#define bdw__memory_writes__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Memory Writes Distribution Gen8 :: HS Threads Dispatched */
#define bdw__memory_writes__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Memory Writes Distribution Gen8 :: DS Threads Dispatched */
#define bdw__memory_writes__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Memory Writes Distribution Gen8 :: GS Threads Dispatched */
#define bdw__memory_writes__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Memory Writes Distribution Gen8 :: FS Threads Dispatched */
#define bdw__memory_writes__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Memory Writes Distribution Gen8 :: CS Threads Dispatched */
#define bdw__memory_writes__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Memory Writes Distribution Gen8 :: EU Active */
#define bdw__memory_writes__eu_active__read \
    bdw__render_basic__eu_active__read

/* Memory Writes Distribution Gen8 :: EU Stall */
#define bdw__memory_writes__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Memory Writes Distribution Gen8 :: Rasterized Pixels */
#define bdw__memory_writes__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Memory Writes Distribution Gen8 :: Early Hi-Depth Test Fails */
#define bdw__memory_writes__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Memory Writes Distribution Gen8 :: Early Depth Test Fails */
#define bdw__memory_writes__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Memory Writes Distribution Gen8 :: Samples Killed in FS */
#define bdw__memory_writes__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Memory Writes Distribution Gen8 :: Pixels Failing Tests */
#define bdw__memory_writes__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Memory Writes Distribution Gen8 :: Samples Written */
#define bdw__memory_writes__samples_written__read \
    bdw__render_basic__samples_written__read

/* Memory Writes Distribution Gen8 :: Samples Blended */
#define bdw__memory_writes__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Memory Writes Distribution Gen8 :: Sampler Texels */
#define bdw__memory_writes__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Memory Writes Distribution Gen8 :: Sampler Texels Misses */
#define bdw__memory_writes__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Memory Writes Distribution Gen8 :: SLM Bytes Read */
#define bdw__memory_writes__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Memory Writes Distribution Gen8 :: SLM Bytes Read */
#define bdw__memory_writes__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Memory Writes Distribution Gen8 :: SLM Bytes Written */
#define bdw__memory_writes__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Memory Writes Distribution Gen8 :: SLM Bytes Written */
#define bdw__memory_writes__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Memory Writes Distribution Gen8 :: Shader Memory Accesses */
#define bdw__memory_writes__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Memory Writes Distribution Gen8 :: Shader Atomic Memory Accesses */
#define bdw__memory_writes__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Memory Writes Distribution Gen8 :: L3 Shader Throughput */
#define bdw__memory_writes__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Memory Writes Distribution Gen8 :: L3 Shader Throughput */
#define bdw__memory_writes__l3_shader_throughput__max \
    bdw__render_basic__l3_shader_throughput__max

/* Memory Writes Distribution Gen8 :: Shader Barrier Messages */
#define bdw__memory_writes__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Memory Writes Distribution Gen8 :: GtiCmdStreamerMemoryWrites */
#define bdw__memory_writes__gti_cmd_streamer_memory_writes__read \
    hsw__compute_extended__eu_untyped_reads0__read

/* Memory Writes Distribution Gen8 :: GtiSoMemoryWrites */
#define bdw__memory_writes__gti_so_memory_writes__read \
    hsw__compute_extended__eu_typed_reads0__read

/* Memory Writes Distribution Gen8 :: GtiRccMemoryWrites */
#define bdw__memory_writes__gti_rcc_memory_writes__read \
    hsw__compute_extended__eu_typed_writes0__read

/* Memory Writes Distribution Gen8 :: GtiMscMemoryWrites */
#define bdw__memory_writes__gti_msc_memory_writes__read \
    hsw__compute_extended__eu_untyped_atomics0__read

/* Memory Writes Distribution Gen8 :: GtiHizMemoryWrites */
#define bdw__memory_writes__gti_hiz_memory_writes__read \
    hsw__compute_extended__eu_typed_atomics0__read

/* Memory Writes Distribution Gen8 :: GtiStcMemoryWrites */
#define bdw__memory_writes__gti_stc_memory_writes__read \
    hsw__compute_extended__eu_urb_atomics0__read

/* Memory Writes Distribution Gen8 :: GtiRczMemoryWrites */
#define bdw__memory_writes__gti_rcz_memory_writes__read \
    hsw__compute_extended__gpu_clocks__read

/* Memory Writes Distribution Gen8 :: GtiMemoryWrites */
#define bdw__memory_writes__gti_memory_writes__read \
    hsw__compute_extended__typed_writes0__read

/* Memory Writes Distribution Gen8 :: GtiL3Bank0Writes */
#define bdw__memory_writes__gti_l3_bank0_writes__read \
    hsw__compute_extended__typed_atomics0__read

/* Memory Writes Distribution Gen8 :: GtiL3Bank1Writes */
#define bdw__memory_writes__gti_l3_bank1_writes__read \
    hsw__memory_reads__gti_memory_reads__read

/* Memory Writes Distribution Gen8 :: GtiL3Bank2Writes */
#define bdw__memory_writes__gti_l3_bank2_writes__read \
    hsw__memory_reads__llc_read_accesses__read

/* Memory Writes Distribution Gen8 :: GtiL3Bank3Writes */
#define bdw__memory_writes__gti_l3_bank3_writes__read \
    hsw__memory_reads__gpu_core_clocks__read

/* Memory Writes Distribution Gen8 :: GtiL3Writes */
#define bdw__memory_writes__gti_l3_writes__read \
    bdw__memory_reads__gti_l3_reads__read

/* Memory Writes Distribution Gen8 :: GtiRingAccesses */
#define bdw__memory_writes__gti_ring_accesses__read \
    bdw__memory_reads__gti_ring_accesses__read

/* Compute Metrics Extended Gen8 :: GPU Time Elapsed */
#define bdw__compute_extended__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Compute Metrics Extended Gen8 :: GPU Core Clocks */
#define bdw__compute_extended__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Compute Metrics Extended Gen8 :: AVG GPU Core Frequency */
#define bdw__compute_extended__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Compute Metrics Extended Gen8 :: AVG GPU Core Frequency */
#define bdw__compute_extended__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Compute Metrics Extended Gen8 :: CS Threads Dispatched */
#define bdw__compute_extended__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Compute Metrics Extended Gen8 :: EU Active */
#define bdw__compute_extended__eu_active__read \
    bdw__render_basic__eu_active__read

/* Compute Metrics Extended Gen8 :: EU Stall */
#define bdw__compute_extended__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Compute Metrics Extended Gen8 :: EU Both FPU Pipes Active */
#define bdw__compute_extended__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Compute Metrics Extended Gen8 :: EU FPU0 Pipe Active */
#define bdw__compute_extended__fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Compute Metrics Extended Gen8 :: EU FPU1 Pipe Active */
#define bdw__compute_extended__fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Compute Metrics Extended Gen8 :: EU AVG IPC Rate */
#define bdw__compute_extended__eu_avg_ipc_rate__read \
    bdw__compute_basic__eu_avg_ipc_rate__read

/* Compute Metrics Extended Gen8 :: EU AVG IPC Rate */
#define bdw__compute_extended__eu_avg_ipc_rate__max \
    bdw__compute_basic__eu_avg_ipc_rate__max

/* Compute Metrics Extended Gen8 :: EU Send Pipe Active */
#define bdw__compute_extended__eu_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Compute Metrics Extended Gen8 :: EU Thread Occupancy */
#define bdw__compute_extended__eu_thread_occupancy__read \
    bdw__compute_basic__eu_thread_occupancy__read

/* Compute Metrics Extended Gen8 :: Sampler Texels */
#define bdw__compute_extended__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Compute Metrics Extended Gen8 :: Sampler Texels Misses */
#define bdw__compute_extended__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Compute Metrics Extended Gen8 :: SLM Bytes Read */
#define bdw__compute_extended__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Compute Metrics Extended Gen8 :: SLM Bytes Read */
#define bdw__compute_extended__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Extended Gen8 :: SLM Bytes Written */
#define bdw__compute_extended__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Compute Metrics Extended Gen8 :: SLM Bytes Written */
#define bdw__compute_extended__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Extended Gen8 :: Shader Memory Accesses */
#define bdw__compute_extended__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Compute Metrics Extended Gen8 :: Shader Atomic Memory Accesses */
#define bdw__compute_extended__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Compute Metrics Extended Gen8 :: L3 Shader Throughput */
#define bdw__compute_extended__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Compute Metrics Extended Gen8 :: L3 Shader Throughput */
#define bdw__compute_extended__l3_shader_throughput__max \
    bdw__render_basic__l3_shader_throughput__max

/* Compute Metrics Extended Gen8 :: Shader Barrier Messages */
#define bdw__compute_extended__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Compute Metrics Extended Gen8 :: EuUntypedReads0 */
#define bdw__compute_extended__eu_untyped_reads0__read \
    hsw__compute_extended__eu_untyped_reads0__read

/* Compute Metrics Extended Gen8 :: EuTypedReads0 */
#define bdw__compute_extended__eu_typed_reads0__read \
    hsw__compute_extended__eu_typed_reads0__read

/* Compute Metrics Extended Gen8 :: EuUntypedWrites0 */
#define bdw__compute_extended__eu_untyped_writes0__read \
    hsw__compute_extended__eu_untyped_writes0__read

/* Compute Metrics Extended Gen8 :: EuTypedWrites0 */
#define bdw__compute_extended__eu_typed_writes0__read \
    hsw__compute_extended__eu_typed_writes0__read

/* Compute Metrics Extended Gen8 :: EuUntypedAtomics0 */
#define bdw__compute_extended__eu_untyped_atomics0__read \
    hsw__compute_extended__eu_untyped_atomics0__read

/* Compute Metrics Extended Gen8 :: EuTypedAtomics0 */
#define bdw__compute_extended__eu_typed_atomics0__read \
    hsw__compute_extended__eu_typed_atomics0__read

/* Compute Metrics Extended Gen8 :: EuA64UntypedReads0 */
#define bdw__compute_extended__eu_a64_untyped_reads0__read \
    hsw__compute_extended__eu_urb_atomics0__read

/* Compute Metrics Extended Gen8 :: EuA64UntypedWrites0 */
#define bdw__compute_extended__eu_a64_untyped_writes0__read \
    hsw__compute_extended__gpu_clocks__read

/* Compute Metrics Extended Gen8 :: Typed Reads 0 */
#define bdw__compute_extended__typed_reads0__read \
    hsw__render_basic__gpu_core_clocks__read

/* Compute Metrics Extended Gen8 :: Typed Writes 0 */
#define bdw__compute_extended__typed_writes0__read \
    hsw__compute_extended__typed_writes0__read

/* Compute Metrics Extended Gen8 :: Untyped Reads 0 */
#define bdw__compute_extended__untyped_reads0__read \
    hsw__compute_extended__untyped_reads0__read

/* Compute Metrics Extended Gen8 :: Untyped Writes 0 */
#define bdw__compute_extended__untyped_writes0__read \
    hsw__compute_extended__untyped_writes0__read

/* Compute Metrics Extended Gen8 :: Typed Atomics 0 */
#define bdw__compute_extended__typed_atomics0__read \
    hsw__compute_extended__typed_atomics0__read

/* Compute Metrics Extended Gen8 :: TypedReadsPerCacheLine */
#define bdw__compute_extended__typed_reads_per_cache_line__read \
    hsw__compute_extended__typed_reads_per_cache_line__read

/* Compute Metrics Extended Gen8 :: TypedWritesPerCacheLine */
#define bdw__compute_extended__typed_writes_per_cache_line__read \
    hsw__compute_extended__typed_writes_per_cache_line__read

/* Compute Metrics Extended Gen8 :: UntypedReadsPerCacheLine */
static double
bdw__compute_extended__untyped_reads_per_cache_line__read(const struct intel_perf *perf,
                                                          const struct intel_perf_metric_set *metric_set,
                                                          uint64_t *accumulator)
{
    /* RPN equation: $EuUntypedReads0 $EuA64UntypedReads0 UADD $UntypedReads0 FDIV */
    uint64_t tmp0 = bdw__compute_extended__eu_untyped_reads0__read(perf, metric_set, accumulator) + bdw__compute_extended__eu_a64_untyped_reads0__read(perf, metric_set, accumulator);
    double tmp1 = tmp0;
    double tmp2 = bdw__compute_extended__untyped_reads0__read(perf, metric_set, accumulator);
    double tmp3 = tmp2 ? tmp1 / tmp2 : 0;

    return tmp3;
}

/* Compute Metrics Extended Gen8 :: UntypedWritesPerCacheLine */
static double
bdw__compute_extended__untyped_writes_per_cache_line__read(const struct intel_perf *perf,
                                                           const struct intel_perf_metric_set *metric_set,
                                                           uint64_t *accumulator)
{
    /* RPN equation: $EuUntypedWrites0 $EuA64UntypedWrites0 UADD $UntypedWrites0 FDIV */
    uint64_t tmp0 = bdw__compute_extended__eu_untyped_writes0__read(perf, metric_set, accumulator) + bdw__compute_extended__eu_a64_untyped_writes0__read(perf, metric_set, accumulator);
    double tmp1 = tmp0;
    double tmp2 = bdw__compute_extended__untyped_writes0__read(perf, metric_set, accumulator);
    double tmp3 = tmp2 ? tmp1 / tmp2 : 0;

    return tmp3;
}

/* Compute Metrics Extended Gen8 :: TypedAtomicsPerCacheLine */
#define bdw__compute_extended__typed_atomics_per_cache_line__read \
    hsw__compute_extended__typed_atomics_per_cache_line__read

/* Compute Metrics L3 Cache Gen8 :: GPU Time Elapsed */
#define bdw__compute_l3_cache__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Compute Metrics L3 Cache Gen8 :: GPU Core Clocks */
#define bdw__compute_l3_cache__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Compute Metrics L3 Cache Gen8 :: AVG GPU Core Frequency */
#define bdw__compute_l3_cache__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Compute Metrics L3 Cache Gen8 :: AVG GPU Core Frequency */
#define bdw__compute_l3_cache__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Compute Metrics L3 Cache Gen8 :: GPU Busy */
#define bdw__compute_l3_cache__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Compute Metrics L3 Cache Gen8 :: VS Threads Dispatched */
#define bdw__compute_l3_cache__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Compute Metrics L3 Cache Gen8 :: HS Threads Dispatched */
#define bdw__compute_l3_cache__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Compute Metrics L3 Cache Gen8 :: DS Threads Dispatched */
#define bdw__compute_l3_cache__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Compute Metrics L3 Cache Gen8 :: GS Threads Dispatched */
#define bdw__compute_l3_cache__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Compute Metrics L3 Cache Gen8 :: FS Threads Dispatched */
#define bdw__compute_l3_cache__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Compute Metrics L3 Cache Gen8 :: CS Threads Dispatched */
#define bdw__compute_l3_cache__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Compute Metrics L3 Cache Gen8 :: EU Active */
#define bdw__compute_l3_cache__eu_active__read \
    bdw__render_basic__eu_active__read

/* Compute Metrics L3 Cache Gen8 :: EU Stall */
#define bdw__compute_l3_cache__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Compute Metrics L3 Cache Gen8 :: EU Both FPU Pipes Active */
#define bdw__compute_l3_cache__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Compute Metrics L3 Cache Gen8 :: EU FPU0 Pipe Active */
#define bdw__compute_l3_cache__fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Compute Metrics L3 Cache Gen8 :: EU FPU1 Pipe Active */
#define bdw__compute_l3_cache__fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Compute Metrics L3 Cache Gen8 :: EU AVG IPC Rate */
#define bdw__compute_l3_cache__eu_avg_ipc_rate__read \
    bdw__compute_basic__eu_avg_ipc_rate__read

/* Compute Metrics L3 Cache Gen8 :: EU AVG IPC Rate */
#define bdw__compute_l3_cache__eu_avg_ipc_rate__max \
    bdw__compute_basic__eu_avg_ipc_rate__max

/* Compute Metrics L3 Cache Gen8 :: EU Send Pipe Active */
#define bdw__compute_l3_cache__eu_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Compute Metrics L3 Cache Gen8 :: EU FPU0 Hybrid Instruction */
static double
bdw__compute_l3_cache__eu_hybrid_fpu0_instruction__read(const struct intel_perf *perf,
                                                        const struct intel_perf_metric_set *metric_set,
                                                        uint64_t *accumulator)
{
    /* RPN equation: A 13 READ $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 13];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = perf->devinfo.n_eus;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    uint64_t tmp4 = tmp3 * 100;
    double tmp5 = tmp4;
    double tmp6 = bdw__compute_l3_cache__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp7 = tmp6 ? tmp5 / tmp6 : 0;

    return tmp7;
}

/* Compute Metrics L3 Cache Gen8 :: EU FPU1 Hybrid Instruction */
static double
bdw__compute_l3_cache__eu_hybrid_fpu1_instruction__read(const struct intel_perf *perf,
                                                        const struct intel_perf_metric_set *metric_set,
                                                        uint64_t *accumulator)
{
    /* RPN equation: A 14 READ $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 14];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = perf->devinfo.n_eus;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    uint64_t tmp4 = tmp3 * 100;
    double tmp5 = tmp4;
    double tmp6 = bdw__compute_l3_cache__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp7 = tmp6 ? tmp5 / tmp6 : 0;

    return tmp7;
}

/* Compute Metrics L3 Cache Gen8 :: EU FPU0 Ternary Instruction */
#define bdw__compute_l3_cache__eu_ternary_fpu0_instruction__read \
    bdw__render_basic__ps_fpu0_active__read

/* Compute Metrics L3 Cache Gen8 :: EU FPU1 Ternary Instruction */
#define bdw__compute_l3_cache__eu_ternary_fpu1_instruction__read \
    bdw__render_basic__ps_fpu1_active__read

/* Compute Metrics L3 Cache Gen8 :: EU FPU0 Binary Instruction */
#define bdw__compute_l3_cache__eu_binary_fpu0_instruction__read \
    bdw__render_basic__ps_send_active__read

/* Compute Metrics L3 Cache Gen8 :: EU FPU1 Binary Instruction */
#define bdw__compute_l3_cache__eu_binary_fpu1_instruction__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Compute Metrics L3 Cache Gen8 :: EU FPU0 Move Instruction */
static double
bdw__compute_l3_cache__eu_move_fpu0_instruction__read(const struct intel_perf *perf,
                                                      const struct intel_perf_metric_set *metric_set,
                                                      uint64_t *accumulator)
{
    /* RPN equation: A 19 READ $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 19];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = perf->devinfo.n_eus;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    uint64_t tmp4 = tmp3 * 100;
    double tmp5 = tmp4;
    double tmp6 = bdw__compute_l3_cache__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp7 = tmp6 ? tmp5 / tmp6 : 0;

    return tmp7;
}

/* Compute Metrics L3 Cache Gen8 :: EU FPU1 Move Instruction */
static double
bdw__compute_l3_cache__eu_move_fpu1_instruction__read(const struct intel_perf *perf,
                                                      const struct intel_perf_metric_set *metric_set,
                                                      uint64_t *accumulator)
{
    /* RPN equation: A 20 READ $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 20];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = perf->devinfo.n_eus;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    uint64_t tmp4 = tmp3 * 100;
    double tmp5 = tmp4;
    double tmp6 = bdw__compute_l3_cache__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp7 = tmp6 ? tmp5 / tmp6 : 0;

    return tmp7;
}

/* Compute Metrics L3 Cache Gen8 :: Rasterized Pixels */
#define bdw__compute_l3_cache__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Compute Metrics L3 Cache Gen8 :: Early Hi-Depth Test Fails */
#define bdw__compute_l3_cache__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Compute Metrics L3 Cache Gen8 :: Early Depth Test Fails */
#define bdw__compute_l3_cache__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Compute Metrics L3 Cache Gen8 :: Samples Killed in FS */
#define bdw__compute_l3_cache__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Compute Metrics L3 Cache Gen8 :: Pixels Failing Tests */
#define bdw__compute_l3_cache__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Compute Metrics L3 Cache Gen8 :: Samples Written */
#define bdw__compute_l3_cache__samples_written__read \
    bdw__render_basic__samples_written__read

/* Compute Metrics L3 Cache Gen8 :: Samples Blended */
#define bdw__compute_l3_cache__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Compute Metrics L3 Cache Gen8 :: Sampler Texels */
#define bdw__compute_l3_cache__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Compute Metrics L3 Cache Gen8 :: Sampler Texels Misses */
#define bdw__compute_l3_cache__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Compute Metrics L3 Cache Gen8 :: SLM Bytes Read */
#define bdw__compute_l3_cache__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Compute Metrics L3 Cache Gen8 :: SLM Bytes Read */
#define bdw__compute_l3_cache__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics L3 Cache Gen8 :: SLM Bytes Written */
#define bdw__compute_l3_cache__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Compute Metrics L3 Cache Gen8 :: SLM Bytes Written */
#define bdw__compute_l3_cache__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics L3 Cache Gen8 :: Shader Memory Accesses */
#define bdw__compute_l3_cache__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Compute Metrics L3 Cache Gen8 :: Shader Atomic Memory Accesses */
#define bdw__compute_l3_cache__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Compute Metrics L3 Cache Gen8 :: L3 Accesses */
static uint64_t
bdw__compute_l3_cache__l3_accesses__read(const struct intel_perf *perf,
                                         const struct intel_perf_metric_set *metric_set,
                                         uint64_t *accumulator)
{
    /* RPN equation: C 0 READ C 1 READ B 2 READ B 3 READ C 2 READ C 3 READ B 6 READ B 7 READ UADD UADD UADD UADD UADD UADD UADD 2 UMUL */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 0];
    uint64_t tmp1 = accumulator[metric_set->c_offset + 1];
    uint64_t tmp2 = accumulator[metric_set->b_offset + 2];
    uint64_t tmp3 = accumulator[metric_set->b_offset + 3];
    uint64_t tmp4 = accumulator[metric_set->c_offset + 2];
    uint64_t tmp5 = accumulator[metric_set->c_offset + 3];
    uint64_t tmp6 = accumulator[metric_set->b_offset + 6];
    uint64_t tmp7 = accumulator[metric_set->b_offset + 7];
    uint64_t tmp8 = tmp6 + tmp7;
    uint64_t tmp9 = tmp5 + tmp8;
    uint64_t tmp10 = tmp4 + tmp9;
    uint64_t tmp11 = tmp3 + tmp10;
    uint64_t tmp12 = tmp2 + tmp11;
    uint64_t tmp13 = tmp1 + tmp12;
    uint64_t tmp14 = tmp0 + tmp13;
    uint64_t tmp15 = tmp14 * 2;

    return tmp15;
}

/* Compute Metrics L3 Cache Gen8 :: L3 Misses */
static uint64_t
bdw__compute_l3_cache__l3_misses__read(const struct intel_perf *perf,
                                       const struct intel_perf_metric_set *metric_set,
                                       uint64_t *accumulator)
{
    /* RPN equation: C 4 READ C 5 READ UADD */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 4];
    uint64_t tmp1 = accumulator[metric_set->c_offset + 5];
    uint64_t tmp2 = tmp0 + tmp1;

    return tmp2;
}

/* Compute Metrics L3 Cache Gen8 :: L3 Shader Throughput */
#define bdw__compute_l3_cache__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Compute Metrics L3 Cache Gen8 :: L3 Shader Throughput */
#define bdw__compute_l3_cache__l3_shader_throughput__max \
    bdw__render_basic__l3_shader_throughput__max

/* Compute Metrics L3 Cache Gen8 :: L3 Total Throughput */
static uint64_t
bdw__compute_l3_cache__l3_total_throughput__read(const struct intel_perf *perf,
                                                 const struct intel_perf_metric_set *metric_set,
                                                 uint64_t *accumulator)
{
    /* RPN equation: $L3Accesses 64 UMUL */
    uint64_t tmp0 = bdw__compute_l3_cache__l3_accesses__read(perf, metric_set, accumulator) * 64;

    return tmp0;
}

/* Compute Metrics L3 Cache Gen8 :: L3 Total Throughput */
#define bdw__compute_l3_cache__l3_total_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics L3 Cache Gen8 :: Shader Barrier Messages */
#define bdw__compute_l3_cache__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Compute Metrics L3 Cache Gen8 :: L3 Bank 00 Accesses */
static uint64_t
bdw__compute_l3_cache__l3_bank00_accesses__read(const struct intel_perf *perf,
                                                const struct intel_perf_metric_set *metric_set,
                                                uint64_t *accumulator)
{
    /* RPN equation: C 0 READ 2 UMUL */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 0];
    uint64_t tmp1 = tmp0 * 2;

    return tmp1;
}

/* Compute Metrics L3 Cache Gen8 :: L3 Bank 01 Accesses */
static uint64_t
bdw__compute_l3_cache__l3_bank01_accesses__read(const struct intel_perf *perf,
                                                const struct intel_perf_metric_set *metric_set,
                                                uint64_t *accumulator)
{
    /* RPN equation: C 1 READ 2 UMUL */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 1];
    uint64_t tmp1 = tmp0 * 2;

    return tmp1;
}

/* Compute Metrics L3 Cache Gen8 :: L3 Bank 02 Accesses */
static uint64_t
bdw__compute_l3_cache__l3_bank02_accesses__read(const struct intel_perf *perf,
                                                const struct intel_perf_metric_set *metric_set,
                                                uint64_t *accumulator)
{
    /* RPN equation: B 2 READ 2 UMUL */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 2];
    uint64_t tmp1 = tmp0 * 2;

    return tmp1;
}

/* Compute Metrics L3 Cache Gen8 :: L3 Bank 03 Accesses */
static uint64_t
bdw__compute_l3_cache__l3_bank03_accesses__read(const struct intel_perf *perf,
                                                const struct intel_perf_metric_set *metric_set,
                                                uint64_t *accumulator)
{
    /* RPN equation: B 3 READ 2 UMUL */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 3];
    uint64_t tmp1 = tmp0 * 2;

    return tmp1;
}

/* Compute Metrics L3 Cache Gen8 :: L3 Bank 10 Accesses */
static uint64_t
bdw__compute_l3_cache__l3_bank10_accesses__read(const struct intel_perf *perf,
                                                const struct intel_perf_metric_set *metric_set,
                                                uint64_t *accumulator)
{
    /* RPN equation: C 2 READ 2 UMUL */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 2];
    uint64_t tmp1 = tmp0 * 2;

    return tmp1;
}

/* Compute Metrics L3 Cache Gen8 :: L3 Bank 11 Accesses */
#define bdw__compute_l3_cache__l3_bank11_accesses__read \
    bdw__memory_reads__gti_ring_accesses__read

/* Compute Metrics L3 Cache Gen8 :: L3 Bank 12 Accesses */
static uint64_t
bdw__compute_l3_cache__l3_bank12_accesses__read(const struct intel_perf *perf,
                                                const struct intel_perf_metric_set *metric_set,
                                                uint64_t *accumulator)
{
    /* RPN equation: B 6 READ 2 UMUL */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 6];
    uint64_t tmp1 = tmp0 * 2;

    return tmp1;
}

/* Compute Metrics L3 Cache Gen8 :: L3 Bank 13 Accesses */
static uint64_t
bdw__compute_l3_cache__l3_bank13_accesses__read(const struct intel_perf *perf,
                                                const struct intel_perf_metric_set *metric_set,
                                                uint64_t *accumulator)
{
    /* RPN equation: B 7 READ 2 UMUL */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 7];
    uint64_t tmp1 = tmp0 * 2;

    return tmp1;
}

/* Compute Metrics L3 Cache Gen8 :: L3 Bank 00 IC Accesses */
static uint64_t
bdw__compute_l3_cache__l3_bank00_ic_accesses__read(const struct intel_perf *perf,
                                                   const struct intel_perf_metric_set *metric_set,
                                                   uint64_t *accumulator)
{
    /* RPN equation: B 0 READ B 1 READ UADD 2 UMUL $L3Bank00Accesses UMIN */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 0];
    uint64_t tmp1 = accumulator[metric_set->b_offset + 1];
    uint64_t tmp2 = tmp0 + tmp1;
    uint64_t tmp3 = tmp2 * 2;
    uint64_t tmp4 = MIN(tmp3, bdw__compute_l3_cache__l3_bank00_accesses__read(perf, metric_set, accumulator));

    return tmp4;
}

/* Compute Metrics L3 Cache Gen8 :: L3 Bank 00 IC Hits */
static uint64_t
bdw__compute_l3_cache__l3_bank00_ic_hits__read(const struct intel_perf *perf,
                                               const struct intel_perf_metric_set *metric_set,
                                               uint64_t *accumulator)
{
    /* RPN equation: B 1 READ 2 UMUL $L3Bank00IcAccesses UMIN */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 1];
    uint64_t tmp1 = tmp0 * 2;
    uint64_t tmp2 = MIN(tmp1, bdw__compute_l3_cache__l3_bank00_ic_accesses__read(perf, metric_set, accumulator));

    return tmp2;
}

/* Compute Metrics L3 Cache Gen8 :: L3 Bank 10 IC Accesses */
static uint64_t
bdw__compute_l3_cache__l3_bank10_ic_accesses__read(const struct intel_perf *perf,
                                                   const struct intel_perf_metric_set *metric_set,
                                                   uint64_t *accumulator)
{
    /* RPN equation: B 4 READ B 5 READ UADD 2 UMUL $L3Bank10Accesses UMIN */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 4];
    uint64_t tmp1 = accumulator[metric_set->b_offset + 5];
    uint64_t tmp2 = tmp0 + tmp1;
    uint64_t tmp3 = tmp2 * 2;
    uint64_t tmp4 = MIN(tmp3, bdw__compute_l3_cache__l3_bank10_accesses__read(perf, metric_set, accumulator));

    return tmp4;
}

/* Compute Metrics L3 Cache Gen8 :: L3 Bank 10 IC Hits */
static uint64_t
bdw__compute_l3_cache__l3_bank10_ic_hits__read(const struct intel_perf *perf,
                                               const struct intel_perf_metric_set *metric_set,
                                               uint64_t *accumulator)
{
    /* RPN equation: B 5 READ 2 UMUL $L3Bank10IcAccesses UMIN */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 5];
    uint64_t tmp1 = tmp0 * 2;
    uint64_t tmp2 = MIN(tmp1, bdw__compute_l3_cache__l3_bank10_ic_accesses__read(perf, metric_set, accumulator));

    return tmp2;
}

/* Compute Metrics L3 Cache Gen8 :: GTI L3 Throughput */
static uint64_t
bdw__compute_l3_cache__gti_l3_throughput__read(const struct intel_perf *perf,
                                               const struct intel_perf_metric_set *metric_set,
                                               uint64_t *accumulator)
{
    /* RPN equation: C 4 READ C 5 READ UADD 64 UMUL */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 4];
    uint64_t tmp1 = accumulator[metric_set->c_offset + 5];
    uint64_t tmp2 = tmp0 + tmp1;
    uint64_t tmp3 = tmp2 * 64;

    return tmp3;
}

/* Compute Metrics L3 Cache Gen8 :: GTI L3 Throughput */
#define bdw__compute_l3_cache__gti_l3_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics L3 Cache Gen8 :: GTI Read Throughput */
#define bdw__compute_l3_cache__gti_read_throughput__read \
    bdw__render_basic__gti_read_throughput__read

/* Compute Metrics L3 Cache Gen8 :: GTI Read Throughput */
#define bdw__compute_l3_cache__gti_read_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Compute Metrics L3 Cache Gen8 :: GTI Write Throughput */
#define bdw__compute_l3_cache__gti_write_throughput__read \
    hsw__render_basic__gti_write_throughput__read

/* Compute Metrics L3 Cache Gen8 :: GTI Write Throughput */
#define bdw__compute_l3_cache__gti_write_throughput__max \
    bdw__render_basic__gti_write_throughput__max

/* Data Port Reads Coalescing Gen8 :: GPU Time Elapsed */
#define bdw__data_port_reads_coalescing__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Data Port Reads Coalescing Gen8 :: GPU Core Clocks */
#define bdw__data_port_reads_coalescing__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Data Port Reads Coalescing Gen8 :: AVG GPU Core Frequency */
#define bdw__data_port_reads_coalescing__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Data Port Reads Coalescing Gen8 :: AVG GPU Core Frequency */
#define bdw__data_port_reads_coalescing__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Data Port Reads Coalescing Gen8 :: VS Threads Dispatched */
#define bdw__data_port_reads_coalescing__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Data Port Reads Coalescing Gen8 :: HS Threads Dispatched */
#define bdw__data_port_reads_coalescing__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Data Port Reads Coalescing Gen8 :: DS Threads Dispatched */
#define bdw__data_port_reads_coalescing__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Data Port Reads Coalescing Gen8 :: GS Threads Dispatched */
#define bdw__data_port_reads_coalescing__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Data Port Reads Coalescing Gen8 :: FS Threads Dispatched */
#define bdw__data_port_reads_coalescing__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Data Port Reads Coalescing Gen8 :: CS Threads Dispatched */
#define bdw__data_port_reads_coalescing__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Data Port Reads Coalescing Gen8 :: EU Active */
#define bdw__data_port_reads_coalescing__eu_active__read \
    bdw__render_basic__eu_active__read

/* Data Port Reads Coalescing Gen8 :: EU Stall */
#define bdw__data_port_reads_coalescing__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Data Port Reads Coalescing Gen8 :: EU Both FPU Pipes Active */
#define bdw__data_port_reads_coalescing__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Data Port Reads Coalescing Gen8 :: EU FPU0 Pipe Active */
#define bdw__data_port_reads_coalescing__fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Data Port Reads Coalescing Gen8 :: EU FPU1 Pipe Active */
#define bdw__data_port_reads_coalescing__fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Data Port Reads Coalescing Gen8 :: EU AVG IPC Rate */
#define bdw__data_port_reads_coalescing__eu_avg_ipc_rate__read \
    bdw__compute_basic__eu_avg_ipc_rate__read

/* Data Port Reads Coalescing Gen8 :: EU AVG IPC Rate */
#define bdw__data_port_reads_coalescing__eu_avg_ipc_rate__max \
    bdw__compute_basic__eu_avg_ipc_rate__max

/* Data Port Reads Coalescing Gen8 :: EU Send Pipe Active */
#define bdw__data_port_reads_coalescing__eu_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Data Port Reads Coalescing Gen8 :: EU Thread Occupancy */
#define bdw__data_port_reads_coalescing__eu_thread_occupancy__read \
    bdw__compute_basic__eu_thread_occupancy__read

/* Data Port Reads Coalescing Gen8 :: Sampler Texels */
#define bdw__data_port_reads_coalescing__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Data Port Reads Coalescing Gen8 :: Sampler Texels Misses */
#define bdw__data_port_reads_coalescing__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Data Port Reads Coalescing Gen8 :: SLM Bytes Read */
#define bdw__data_port_reads_coalescing__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Data Port Reads Coalescing Gen8 :: SLM Bytes Read */
#define bdw__data_port_reads_coalescing__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Data Port Reads Coalescing Gen8 :: SLM Bytes Written */
#define bdw__data_port_reads_coalescing__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Data Port Reads Coalescing Gen8 :: SLM Bytes Written */
#define bdw__data_port_reads_coalescing__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Data Port Reads Coalescing Gen8 :: Shader Memory Accesses */
#define bdw__data_port_reads_coalescing__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Data Port Reads Coalescing Gen8 :: Shader Atomic Memory Accesses */
#define bdw__data_port_reads_coalescing__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Data Port Reads Coalescing Gen8 :: L3 Shader Throughput */
#define bdw__data_port_reads_coalescing__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Data Port Reads Coalescing Gen8 :: L3 Shader Throughput */
#define bdw__data_port_reads_coalescing__l3_shader_throughput__max \
    bdw__render_basic__l3_shader_throughput__max

/* Data Port Reads Coalescing Gen8 :: Shader Barrier Messages */
#define bdw__data_port_reads_coalescing__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Data Port Reads Coalescing Gen8 :: EU to Data Port 0 Reads 32 */
#define bdw__data_port_reads_coalescing__eu_hdc0_reads32_b__read \
    hsw__compute_extended__eu_untyped_atomics0__read

/* Data Port Reads Coalescing Gen8 :: EU to Data Port 0 Reads 64 */
#define bdw__data_port_reads_coalescing__eu_hdc0_reads64_b__read \
    hsw__compute_extended__eu_typed_atomics0__read

/* Data Port Reads Coalescing Gen8 :: EU to Data Port 0 Reads 128 */
#define bdw__data_port_reads_coalescing__eu_hdc0_reads128_b__read \
    hsw__compute_extended__eu_urb_atomics0__read

/* Data Port Reads Coalescing Gen8 :: EU to Data Port 0 Reads 256 */
#define bdw__data_port_reads_coalescing__eu_hdc0_reads256_b__read \
    hsw__compute_extended__gpu_clocks__read

/* Data Port Reads Coalescing Gen8 :: Data Port 0 to L3 Data Reads */
#define bdw__data_port_reads_coalescing__hdc0_l3_data_reads__read \
    hsw__compute_extended__typed_atomics0__read

/* Data Port Reads Coalescing Gen8 :: Data Port 0 to L3 Data Writes */
#define bdw__data_port_reads_coalescing__hdc0_l3_data_writes__read \
    hsw__memory_reads__gti_memory_reads__read

/* Data Port Reads Coalescing Gen8 :: All Data Port 0 Reads from L3 */
static uint64_t
bdw__data_port_reads_coalescing__hdc0_l3_reads__read(const struct intel_perf *perf,
                                                     const struct intel_perf_metric_set *metric_set,
                                                     uint64_t *accumulator)
{
    /* RPN equation: C 3 READ C 2 READ USUB */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 3];
    uint64_t tmp1 = accumulator[metric_set->c_offset + 2];
    uint64_t tmp2 = tmp0 - tmp1;

    return tmp2;
}

/* Data Port Reads Coalescing Gen8 :: All Data Port 0 Writes to L3 */
#define bdw__data_port_reads_coalescing__hdc0_l3_writes__read \
    hsw__render_basic__gpu_core_clocks__read

/* Data Port Reads Coalescing Gen8 :: EuBytesReadPerCacheLine */
static double
bdw__data_port_reads_coalescing__eu_bytes_read_per_cache_line__read(const struct intel_perf *perf,
                                                                    const struct intel_perf_metric_set *metric_set,
                                                                    uint64_t *accumulator)
{
    /* RPN equation: $EuHdc0Reads32B 32 UMUL $EuHdc0Reads64B 64 UMUL $EuHdc0Reads128B 128 UMUL $EuHdc0Reads256B 256 UMUL UADD UADD UADD $Hdc0L3DataReads FDIV */
    uint64_t tmp0 = bdw__data_port_reads_coalescing__eu_hdc0_reads32_b__read(perf, metric_set, accumulator) * 32;
    uint64_t tmp1 = bdw__data_port_reads_coalescing__eu_hdc0_reads64_b__read(perf, metric_set, accumulator) * 64;
    uint64_t tmp2 = bdw__data_port_reads_coalescing__eu_hdc0_reads128_b__read(perf, metric_set, accumulator) * 128;
    uint64_t tmp3 = bdw__data_port_reads_coalescing__eu_hdc0_reads256_b__read(perf, metric_set, accumulator) * 256;
    uint64_t tmp4 = tmp2 + tmp3;
    uint64_t tmp5 = tmp1 + tmp4;
    uint64_t tmp6 = tmp0 + tmp5;
    double tmp7 = tmp6;
    double tmp8 = bdw__data_port_reads_coalescing__hdc0_l3_data_reads__read(perf, metric_set, accumulator);
    double tmp9 = tmp8 ? tmp7 / tmp8 : 0;

    return tmp9;
}

/* Data Port Reads Coalescing Gen8 :: EuDataReadsPerCacheLine */
static double
bdw__data_port_reads_coalescing__eu_data_reads_per_cache_line__read(const struct intel_perf *perf,
                                                                    const struct intel_perf_metric_set *metric_set,
                                                                    uint64_t *accumulator)
{
    /* RPN equation: $EuBytesReadPerCacheLine 64 FDIV */
    double tmp0 = bdw__data_port_reads_coalescing__eu_bytes_read_per_cache_line__read(perf, metric_set, accumulator);
    double tmp1 = 64;
    double tmp2 = tmp1 ? tmp0 / tmp1 : 0;

    return tmp2;
}

/* Data Port Writes Coalescing Gen8 :: GPU Time Elapsed */
#define bdw__data_port_writes_coalescing__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Data Port Writes Coalescing Gen8 :: GPU Core Clocks */
#define bdw__data_port_writes_coalescing__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Data Port Writes Coalescing Gen8 :: AVG GPU Core Frequency */
#define bdw__data_port_writes_coalescing__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Data Port Writes Coalescing Gen8 :: AVG GPU Core Frequency */
#define bdw__data_port_writes_coalescing__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Data Port Writes Coalescing Gen8 :: VS Threads Dispatched */
#define bdw__data_port_writes_coalescing__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Data Port Writes Coalescing Gen8 :: HS Threads Dispatched */
#define bdw__data_port_writes_coalescing__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Data Port Writes Coalescing Gen8 :: DS Threads Dispatched */
#define bdw__data_port_writes_coalescing__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Data Port Writes Coalescing Gen8 :: GS Threads Dispatched */
#define bdw__data_port_writes_coalescing__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Data Port Writes Coalescing Gen8 :: FS Threads Dispatched */
#define bdw__data_port_writes_coalescing__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Data Port Writes Coalescing Gen8 :: CS Threads Dispatched */
#define bdw__data_port_writes_coalescing__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Data Port Writes Coalescing Gen8 :: EU Active */
#define bdw__data_port_writes_coalescing__eu_active__read \
    bdw__render_basic__eu_active__read

/* Data Port Writes Coalescing Gen8 :: EU Stall */
#define bdw__data_port_writes_coalescing__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Data Port Writes Coalescing Gen8 :: EU Both FPU Pipes Active */
#define bdw__data_port_writes_coalescing__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Data Port Writes Coalescing Gen8 :: EU FPU0 Pipe Active */
#define bdw__data_port_writes_coalescing__fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Data Port Writes Coalescing Gen8 :: EU FPU1 Pipe Active */
#define bdw__data_port_writes_coalescing__fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Data Port Writes Coalescing Gen8 :: EU AVG IPC Rate */
#define bdw__data_port_writes_coalescing__eu_avg_ipc_rate__read \
    bdw__compute_basic__eu_avg_ipc_rate__read

/* Data Port Writes Coalescing Gen8 :: EU AVG IPC Rate */
#define bdw__data_port_writes_coalescing__eu_avg_ipc_rate__max \
    bdw__compute_basic__eu_avg_ipc_rate__max

/* Data Port Writes Coalescing Gen8 :: EU Send Pipe Active */
#define bdw__data_port_writes_coalescing__eu_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Data Port Writes Coalescing Gen8 :: EU Thread Occupancy */
#define bdw__data_port_writes_coalescing__eu_thread_occupancy__read \
    bdw__compute_basic__eu_thread_occupancy__read

/* Data Port Writes Coalescing Gen8 :: Sampler Texels */
#define bdw__data_port_writes_coalescing__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Data Port Writes Coalescing Gen8 :: Sampler Texels Misses */
#define bdw__data_port_writes_coalescing__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Data Port Writes Coalescing Gen8 :: SLM Bytes Read */
#define bdw__data_port_writes_coalescing__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Data Port Writes Coalescing Gen8 :: SLM Bytes Read */
#define bdw__data_port_writes_coalescing__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Data Port Writes Coalescing Gen8 :: SLM Bytes Written */
#define bdw__data_port_writes_coalescing__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Data Port Writes Coalescing Gen8 :: SLM Bytes Written */
#define bdw__data_port_writes_coalescing__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Data Port Writes Coalescing Gen8 :: Shader Memory Accesses */
#define bdw__data_port_writes_coalescing__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Data Port Writes Coalescing Gen8 :: Shader Atomic Memory Accesses */
#define bdw__data_port_writes_coalescing__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Data Port Writes Coalescing Gen8 :: L3 Shader Throughput */
#define bdw__data_port_writes_coalescing__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Data Port Writes Coalescing Gen8 :: L3 Shader Throughput */
#define bdw__data_port_writes_coalescing__l3_shader_throughput__max \
    bdw__render_basic__l3_shader_throughput__max

/* Data Port Writes Coalescing Gen8 :: Shader Barrier Messages */
#define bdw__data_port_writes_coalescing__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Data Port Writes Coalescing Gen8 :: EU to Data Port 0 Writes 32B */
#define bdw__data_port_writes_coalescing__eu_hdc0_writes32_b__read \
    hsw__compute_extended__eu_untyped_reads0__read

/* Data Port Writes Coalescing Gen8 :: EU to Data Port 0 Writes 64B */
static uint64_t
bdw__data_port_writes_coalescing__eu_hdc0_writes64_b__read(const struct intel_perf *perf,
                                                           const struct intel_perf_metric_set *metric_set,
                                                           uint64_t *accumulator)
{
    /* RPN equation: B 1 READ B 4 READ UADD */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 1];
    uint64_t tmp1 = accumulator[metric_set->b_offset + 4];
    uint64_t tmp2 = tmp0 + tmp1;

    return tmp2;
}

/* Data Port Writes Coalescing Gen8 :: EU to Data Port 0 Writes 64B */
static uint64_t
bdw__data_port_writes_coalescing__eu_hdc0_writes96_b__read(const struct intel_perf *perf,
                                                           const struct intel_perf_metric_set *metric_set,
                                                           uint64_t *accumulator)
{
    /* RPN equation: B 2 READ 2 UDIV */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 2];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = 2;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;

    return tmp3;
}

/* Data Port Writes Coalescing Gen8 :: EU to Data Port 0 Writes 128 */
static uint64_t
bdw__data_port_writes_coalescing__eu_hdc0_writes128_b__read(const struct intel_perf *perf,
                                                            const struct intel_perf_metric_set *metric_set,
                                                            uint64_t *accumulator)
{
    /* RPN equation: B 3 READ 2 UDIV */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 3];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = 2;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;

    return tmp3;
}

/* Data Port Writes Coalescing Gen8 :: EU to Data Port 0 Writes 128 */
static uint64_t
bdw__data_port_writes_coalescing__eu_hdc0_writes192_b__read(const struct intel_perf *perf,
                                                            const struct intel_perf_metric_set *metric_set,
                                                            uint64_t *accumulator)
{
    /* RPN equation: B 6 READ 2 UDIV */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 6];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = 2;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;

    return tmp3;
}

/* Data Port Writes Coalescing Gen8 :: EU to Data Port 0 Writes 64B */
#define bdw__data_port_writes_coalescing__eu_hdc0_writes128_b_simd16__read \
    hsw__compute_extended__eu_typed_atomics0__read

/* Data Port Writes Coalescing Gen8 :: EU to Data Port 0 Writes 256B */
static uint64_t
bdw__data_port_writes_coalescing__eu_hdc0_writes256_b_simd16__read(const struct intel_perf *perf,
                                                                   const struct intel_perf_metric_set *metric_set,
                                                                   uint64_t *accumulator)
{
    /* RPN equation: B 7 READ 2 UDIV */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 7];
    uint64_t tmp1 = tmp0;
    uint64_t tmp2 = 2;
    uint64_t tmp3 = tmp2 ? tmp1 / tmp2 : 0;

    return tmp3;
}

/* Data Port Writes Coalescing Gen8 :: Data Port 0 to L3 Data Reads */
#define bdw__data_port_writes_coalescing__hdc0_l3_data_reads__read \
    hsw__compute_extended__typed_atomics0__read

/* Data Port Writes Coalescing Gen8 :: Data Port 0 to L3 Data Writes */
#define bdw__data_port_writes_coalescing__hdc0_l3_data_writes__read \
    hsw__memory_reads__gti_memory_reads__read

/* Data Port Writes Coalescing Gen8 :: All Data Port 0 Reads from L3 */
#define bdw__data_port_writes_coalescing__hdc0_l3_reads__read \
    bdw__data_port_reads_coalescing__hdc0_l3_reads__read

/* Data Port Writes Coalescing Gen8 :: All Data Port 0 Writes to L3 */
#define bdw__data_port_writes_coalescing__hdc0_l3_writes__read \
    hsw__render_basic__gpu_core_clocks__read

/* Data Port Writes Coalescing Gen8 :: EuBytesWrittenPerCacheLine */
static double
bdw__data_port_writes_coalescing__eu_bytes_written_per_cache_line__read(const struct intel_perf *perf,
                                                                        const struct intel_perf_metric_set *metric_set,
                                                                        uint64_t *accumulator)
{
    /* RPN equation: $EuHdc0Writes32B 32 UMUL $EuHdc0Writes64B 64 UMUL $EuHdc0Writes96B 96 UMUL $EuHdc0Writes128B 128 UMUL $EuHdc0Writes128BSimd16 128 UMUL $EuHdc0Writes256BSimd16 256 UMUL $EuHdc0Writes192B 192 UMUL UADD UADD UADD UADD UADD UADD $Hdc0L3DataWrites FDIV */
    uint64_t tmp0 = bdw__data_port_writes_coalescing__eu_hdc0_writes32_b__read(perf, metric_set, accumulator) * 32;
    uint64_t tmp1 = bdw__data_port_writes_coalescing__eu_hdc0_writes64_b__read(perf, metric_set, accumulator) * 64;
    uint64_t tmp2 = bdw__data_port_writes_coalescing__eu_hdc0_writes96_b__read(perf, metric_set, accumulator) * 96;
    uint64_t tmp3 = bdw__data_port_writes_coalescing__eu_hdc0_writes128_b__read(perf, metric_set, accumulator) * 128;
    uint64_t tmp4 = bdw__data_port_writes_coalescing__eu_hdc0_writes128_b_simd16__read(perf, metric_set, accumulator) * 128;
    uint64_t tmp5 = bdw__data_port_writes_coalescing__eu_hdc0_writes256_b_simd16__read(perf, metric_set, accumulator) * 256;
    uint64_t tmp6 = bdw__data_port_writes_coalescing__eu_hdc0_writes192_b__read(perf, metric_set, accumulator) * 192;
    uint64_t tmp7 = tmp5 + tmp6;
    uint64_t tmp8 = tmp4 + tmp7;
    uint64_t tmp9 = tmp3 + tmp8;
    uint64_t tmp10 = tmp2 + tmp9;
    uint64_t tmp11 = tmp1 + tmp10;
    uint64_t tmp12 = tmp0 + tmp11;
    double tmp13 = tmp12;
    double tmp14 = bdw__data_port_writes_coalescing__hdc0_l3_data_writes__read(perf, metric_set, accumulator);
    double tmp15 = tmp14 ? tmp13 / tmp14 : 0;

    return tmp15;
}

/* Data Port Writes Coalescing Gen8 :: EuDataWritesPerCacheLine */
static double
bdw__data_port_writes_coalescing__eu_data_writes_per_cache_line__read(const struct intel_perf *perf,
                                                                      const struct intel_perf_metric_set *metric_set,
                                                                      uint64_t *accumulator)
{
    /* RPN equation: $EuBytesWrittenPerCacheLine 64 FDIV */
    double tmp0 = bdw__data_port_writes_coalescing__eu_bytes_written_per_cache_line__read(perf, metric_set, accumulator);
    double tmp1 = 64;
    double tmp2 = tmp1 ? tmp0 / tmp1 : 0;

    return tmp2;
}

/* Metric set HDCAndSF :: GPU Time Elapsed */
#define bdw__hdc_and_sf__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set HDCAndSF :: GPU Core Clocks */
#define bdw__hdc_and_sf__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set HDCAndSF :: AVG GPU Core Frequency */
#define bdw__hdc_and_sf__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set HDCAndSF :: AVG GPU Core Frequency */
#define bdw__hdc_and_sf__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set HDCAndSF :: GPU Busy */
#define bdw__hdc_and_sf__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set HDCAndSF :: VS Threads Dispatched */
#define bdw__hdc_and_sf__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set HDCAndSF :: HS Threads Dispatched */
#define bdw__hdc_and_sf__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set HDCAndSF :: DS Threads Dispatched */
#define bdw__hdc_and_sf__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set HDCAndSF :: GS Threads Dispatched */
#define bdw__hdc_and_sf__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set HDCAndSF :: FS Threads Dispatched */
#define bdw__hdc_and_sf__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set HDCAndSF :: CS Threads Dispatched */
#define bdw__hdc_and_sf__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set HDCAndSF :: EU Active */
#define bdw__hdc_and_sf__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set HDCAndSF :: EU Stall */
#define bdw__hdc_and_sf__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set HDCAndSF :: EU Both FPU Pipes Active */
#define bdw__hdc_and_sf__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set HDCAndSF :: VS FPU0 Pipe Active */
#define bdw__hdc_and_sf__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set HDCAndSF :: VS FPU1 Pipe Active */
#define bdw__hdc_and_sf__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set HDCAndSF :: VS Send Pipe Active */
#define bdw__hdc_and_sf__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set HDCAndSF :: PS FPU0 Pipe Active */
#define bdw__hdc_and_sf__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set HDCAndSF :: PS FPU1 Pipe Active */
#define bdw__hdc_and_sf__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set HDCAndSF :: PS Send Pipeline Active */
#define bdw__hdc_and_sf__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set HDCAndSF :: FS Both FPU Active */
#define bdw__hdc_and_sf__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set HDCAndSF :: Rasterized Pixels */
#define bdw__hdc_and_sf__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set HDCAndSF :: Early Hi-Depth Test Fails */
#define bdw__hdc_and_sf__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set HDCAndSF :: Early Depth Test Fails */
#define bdw__hdc_and_sf__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set HDCAndSF :: Samples Killed in FS */
#define bdw__hdc_and_sf__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set HDCAndSF :: Pixels Failing Tests */
#define bdw__hdc_and_sf__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set HDCAndSF :: Samples Written */
#define bdw__hdc_and_sf__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set HDCAndSF :: Samples Blended */
#define bdw__hdc_and_sf__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set HDCAndSF :: Sampler Texels */
#define bdw__hdc_and_sf__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set HDCAndSF :: Sampler Texels Misses */
#define bdw__hdc_and_sf__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set HDCAndSF :: SLM Bytes Read */
#define bdw__hdc_and_sf__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set HDCAndSF :: SLM Bytes Read */
#define bdw__hdc_and_sf__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set HDCAndSF :: SLM Bytes Written */
#define bdw__hdc_and_sf__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set HDCAndSF :: SLM Bytes Written */
#define bdw__hdc_and_sf__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set HDCAndSF :: Shader Memory Accesses */
#define bdw__hdc_and_sf__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set HDCAndSF :: Shader Atomic Memory Accesses */
#define bdw__hdc_and_sf__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set HDCAndSF :: L3 Shader Throughput */
#define bdw__hdc_and_sf__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set HDCAndSF :: L3 Shader Throughput */
static uint64_t
bdw__hdc_and_sf__l3_shader_throughput__max(const struct intel_perf *perf,
                                           const struct intel_perf_metric_set *metric_set,
                                           uint64_t *accumulator)
{
    /* RPN equation: $GpuCoreClocks 64 UMUL $EuSubslicesTotalCount UMUL 2 UMUL */
    uint64_t tmp0 = bdw__hdc_and_sf__gpu_core_clocks__read(perf, metric_set, accumulator) * 64;
    uint64_t tmp1 = tmp0 * perf->devinfo.n_eu_sub_slices;
    uint64_t tmp2 = tmp1 * 2;

    return tmp2;
}

/* Metric set HDCAndSF :: Shader Barrier Messages */
#define bdw__hdc_and_sf__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set HDCAndSF :: Polygon Data Ready */
#define bdw__hdc_and_sf__poly_data_ready__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set HDCAndSF :: HDC stalled by L3 (s0.ss2) */
static double
bdw__hdc_and_sf__non_sampler_shader02_access_stalled_on_l3__read(const struct intel_perf *perf,
                                                                 const struct intel_perf_metric_set *metric_set,
                                                                 uint64_t *accumulator)
{
    /* RPN equation: C 7 READ C 6 READ USUB 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 7];
    uint64_t tmp1 = accumulator[metric_set->c_offset + 6];
    uint64_t tmp2 = tmp0 - tmp1;
    uint64_t tmp3 = tmp2 * 100;
    double tmp4 = tmp3;
    double tmp5 = bdw__hdc_and_sf__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp6 = tmp5 ? tmp4 / tmp5 : 0;

    return tmp6;
}

/* Metric set HDCAndSF :: HDC stalled by L3 (s0.ss1) */
static double
bdw__hdc_and_sf__non_sampler_shader01_access_stalled_on_l3__read(const struct intel_perf *perf,
                                                                 const struct intel_perf_metric_set *metric_set,
                                                                 uint64_t *accumulator)
{
    /* RPN equation: C 5 READ C 4 READ USUB 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 5];
    uint64_t tmp1 = accumulator[metric_set->c_offset + 4];
    uint64_t tmp2 = tmp0 - tmp1;
    uint64_t tmp3 = tmp2 * 100;
    double tmp4 = tmp3;
    double tmp5 = bdw__hdc_and_sf__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp6 = tmp5 ? tmp4 / tmp5 : 0;

    return tmp6;
}

/* Metric set HDCAndSF :: HDC stalled by L3 (s0.ss0) */
static double
bdw__hdc_and_sf__non_sampler_shader00_access_stalled_on_l3__read(const struct intel_perf *perf,
                                                                 const struct intel_perf_metric_set *metric_set,
                                                                 uint64_t *accumulator)
{
    /* RPN equation: C 3 READ C 2 READ USUB 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 3];
    uint64_t tmp1 = accumulator[metric_set->c_offset + 2];
    uint64_t tmp2 = tmp0 - tmp1;
    uint64_t tmp3 = tmp2 * 100;
    double tmp4 = tmp3;
    double tmp5 = bdw__hdc_and_sf__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp6 = tmp5 ? tmp4 / tmp5 : 0;

    return tmp6;
}

/* Metric set HDCAndSF :: HDC stalled by L3 (s0.ss2) */
static double
bdw__hdc_and_sf__non_sampler_shader12_access_stalled_on_l3__read(const struct intel_perf *perf,
                                                                 const struct intel_perf_metric_set *metric_set,
                                                                 uint64_t *accumulator)
{
    /* RPN equation: C 1 READ C 0 READ USUB 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 1];
    uint64_t tmp1 = accumulator[metric_set->c_offset + 0];
    uint64_t tmp2 = tmp0 - tmp1;
    uint64_t tmp3 = tmp2 * 100;
    double tmp4 = tmp3;
    double tmp5 = bdw__hdc_and_sf__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp6 = tmp5 ? tmp4 / tmp5 : 0;

    return tmp6;
}

/* Metric set HDCAndSF :: HDC stalled by L3 (s0.ss1) */
static double
bdw__hdc_and_sf__non_sampler_shader11_access_stalled_on_l3__read(const struct intel_perf *perf,
                                                                 const struct intel_perf_metric_set *metric_set,
                                                                 uint64_t *accumulator)
{
    /* RPN equation: B 7 READ B 6 READ USUB 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 7];
    uint64_t tmp1 = accumulator[metric_set->b_offset + 6];
    uint64_t tmp2 = tmp0 - tmp1;
    uint64_t tmp3 = tmp2 * 100;
    double tmp4 = tmp3;
    double tmp5 = bdw__hdc_and_sf__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp6 = tmp5 ? tmp4 / tmp5 : 0;

    return tmp6;
}

/* Metric set HDCAndSF :: HDC stalled by L3 (s0.ss0) */
static double
bdw__hdc_and_sf__non_sampler_shader10_access_stalled_on_l3__read(const struct intel_perf *perf,
                                                                 const struct intel_perf_metric_set *metric_set,
                                                                 uint64_t *accumulator)
{
    /* RPN equation: B 5 READ B 4 READ USUB 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 5];
    uint64_t tmp1 = accumulator[metric_set->b_offset + 4];
    uint64_t tmp2 = tmp0 - tmp1;
    uint64_t tmp3 = tmp2 * 100;
    double tmp4 = tmp3;
    double tmp5 = bdw__hdc_and_sf__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp6 = tmp5 ? tmp4 / tmp5 : 0;

    return tmp6;
}

/* Metric set HDCAndSF :: SQ is full */
static double
bdw__hdc_and_sf__gt_request_queue_full__read(const struct intel_perf *perf,
                                             const struct intel_perf_metric_set *metric_set,
                                             uint64_t *accumulator)
{
    /* RPN equation: PERFCNT1 READ_REG 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = 0;
    uint64_t tmp1 = tmp0 * 100;
    double tmp2 = tmp1;
    double tmp3 = bdw__hdc_and_sf__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp4 = tmp3 ? tmp2 / tmp3 : 0;

    return tmp4;
}

/* Metric set L3_1 :: GPU Time Elapsed */
#define bdw__l3_1__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set L3_1 :: GPU Core Clocks */
#define bdw__l3_1__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set L3_1 :: AVG GPU Core Frequency */
#define bdw__l3_1__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set L3_1 :: AVG GPU Core Frequency */
#define bdw__l3_1__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set L3_1 :: GPU Busy */
#define bdw__l3_1__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set L3_1 :: VS Threads Dispatched */
#define bdw__l3_1__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set L3_1 :: HS Threads Dispatched */
#define bdw__l3_1__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set L3_1 :: DS Threads Dispatched */
#define bdw__l3_1__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set L3_1 :: GS Threads Dispatched */
#define bdw__l3_1__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set L3_1 :: FS Threads Dispatched */
#define bdw__l3_1__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set L3_1 :: CS Threads Dispatched */
#define bdw__l3_1__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set L3_1 :: EU Active */
#define bdw__l3_1__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set L3_1 :: EU Stall */
#define bdw__l3_1__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set L3_1 :: EU Both FPU Pipes Active */
#define bdw__l3_1__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set L3_1 :: VS FPU0 Pipe Active */
#define bdw__l3_1__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set L3_1 :: VS FPU1 Pipe Active */
#define bdw__l3_1__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set L3_1 :: VS Send Pipe Active */
#define bdw__l3_1__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set L3_1 :: PS FPU0 Pipe Active */
#define bdw__l3_1__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set L3_1 :: PS FPU1 Pipe Active */
#define bdw__l3_1__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set L3_1 :: PS Send Pipeline Active */
#define bdw__l3_1__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set L3_1 :: FS Both FPU Active */
#define bdw__l3_1__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set L3_1 :: Rasterized Pixels */
#define bdw__l3_1__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set L3_1 :: Early Hi-Depth Test Fails */
#define bdw__l3_1__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set L3_1 :: Early Depth Test Fails */
#define bdw__l3_1__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set L3_1 :: Samples Killed in FS */
#define bdw__l3_1__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set L3_1 :: Pixels Failing Tests */
#define bdw__l3_1__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set L3_1 :: Samples Written */
#define bdw__l3_1__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set L3_1 :: Samples Blended */
#define bdw__l3_1__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set L3_1 :: Sampler Texels */
#define bdw__l3_1__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set L3_1 :: Sampler Texels Misses */
#define bdw__l3_1__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set L3_1 :: SLM Bytes Read */
#define bdw__l3_1__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set L3_1 :: SLM Bytes Read */
#define bdw__l3_1__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_1 :: SLM Bytes Written */
#define bdw__l3_1__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set L3_1 :: SLM Bytes Written */
#define bdw__l3_1__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_1 :: Shader Memory Accesses */
#define bdw__l3_1__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set L3_1 :: Shader Atomic Memory Accesses */
#define bdw__l3_1__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set L3_1 :: L3 Shader Throughput */
#define bdw__l3_1__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set L3_1 :: L3 Shader Throughput */
#define bdw__l3_1__l3_shader_throughput__max \
    bdw__hdc_and_sf__l3_shader_throughput__max

/* Metric set L3_1 :: Shader Barrier Messages */
#define bdw__l3_1__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set L3_1 :: Slice1 L3 Bank0 Stalled */
#define bdw__l3_1__l31_bank0_stalled__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set L3_1 :: Slice1 L3 Bank1 Stalled */
#define bdw__l3_1__l31_bank1_stalled__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* Metric set L3_1 :: Slice1 L3 Bank1 Active */
#define bdw__l3_1__l31_bank1_active__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set L3_1 :: Slice1 L3 Bank0 Active */
#define bdw__l3_1__l31_bank0_active__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set L3_1 :: SQ is full */
#define bdw__l3_1__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set L3_2 :: GPU Time Elapsed */
#define bdw__l3_2__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set L3_2 :: GPU Core Clocks */
#define bdw__l3_2__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set L3_2 :: AVG GPU Core Frequency */
#define bdw__l3_2__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set L3_2 :: AVG GPU Core Frequency */
#define bdw__l3_2__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set L3_2 :: GPU Busy */
#define bdw__l3_2__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set L3_2 :: VS Threads Dispatched */
#define bdw__l3_2__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set L3_2 :: HS Threads Dispatched */
#define bdw__l3_2__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set L3_2 :: DS Threads Dispatched */
#define bdw__l3_2__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set L3_2 :: GS Threads Dispatched */
#define bdw__l3_2__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set L3_2 :: FS Threads Dispatched */
#define bdw__l3_2__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set L3_2 :: CS Threads Dispatched */
#define bdw__l3_2__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set L3_2 :: EU Active */
#define bdw__l3_2__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set L3_2 :: EU Stall */
#define bdw__l3_2__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set L3_2 :: EU Both FPU Pipes Active */
#define bdw__l3_2__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set L3_2 :: VS FPU0 Pipe Active */
#define bdw__l3_2__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set L3_2 :: VS FPU1 Pipe Active */
#define bdw__l3_2__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set L3_2 :: VS Send Pipe Active */
#define bdw__l3_2__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set L3_2 :: PS FPU0 Pipe Active */
#define bdw__l3_2__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set L3_2 :: PS FPU1 Pipe Active */
#define bdw__l3_2__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set L3_2 :: PS Send Pipeline Active */
#define bdw__l3_2__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set L3_2 :: FS Both FPU Active */
#define bdw__l3_2__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set L3_2 :: Rasterized Pixels */
#define bdw__l3_2__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set L3_2 :: Early Hi-Depth Test Fails */
#define bdw__l3_2__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set L3_2 :: Early Depth Test Fails */
#define bdw__l3_2__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set L3_2 :: Samples Killed in FS */
#define bdw__l3_2__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set L3_2 :: Pixels Failing Tests */
#define bdw__l3_2__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set L3_2 :: Samples Written */
#define bdw__l3_2__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set L3_2 :: Samples Blended */
#define bdw__l3_2__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set L3_2 :: Sampler Texels */
#define bdw__l3_2__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set L3_2 :: Sampler Texels Misses */
#define bdw__l3_2__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set L3_2 :: SLM Bytes Read */
#define bdw__l3_2__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set L3_2 :: SLM Bytes Read */
#define bdw__l3_2__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_2 :: SLM Bytes Written */
#define bdw__l3_2__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set L3_2 :: SLM Bytes Written */
#define bdw__l3_2__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_2 :: Shader Memory Accesses */
#define bdw__l3_2__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set L3_2 :: Shader Atomic Memory Accesses */
#define bdw__l3_2__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set L3_2 :: L3 Shader Throughput */
#define bdw__l3_2__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set L3_2 :: L3 Shader Throughput */
#define bdw__l3_2__l3_shader_throughput__max \
    bdw__hdc_and_sf__l3_shader_throughput__max

/* Metric set L3_2 :: Shader Barrier Messages */
#define bdw__l3_2__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set L3_2 :: Slice0 L3 Bank0 Stalled */
#define bdw__l3_2__l30_bank0_stalled__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set L3_2 :: Slice0 L3 Bank1 Stalled */
#define bdw__l3_2__l30_bank1_stalled__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* Metric set L3_2 :: Slice0 L3 Bank1 Active */
#define bdw__l3_2__l30_bank1_active__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set L3_2 :: Slice0 L3 Bank0 Active */
#define bdw__l3_2__l30_bank0_active__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set L3_2 :: SQ is full */
#define bdw__l3_2__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set L3_3 :: GPU Time Elapsed */
#define bdw__l3_3__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set L3_3 :: GPU Core Clocks */
#define bdw__l3_3__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set L3_3 :: AVG GPU Core Frequency */
#define bdw__l3_3__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set L3_3 :: AVG GPU Core Frequency */
#define bdw__l3_3__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set L3_3 :: GPU Busy */
#define bdw__l3_3__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set L3_3 :: VS Threads Dispatched */
#define bdw__l3_3__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set L3_3 :: HS Threads Dispatched */
#define bdw__l3_3__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set L3_3 :: DS Threads Dispatched */
#define bdw__l3_3__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set L3_3 :: GS Threads Dispatched */
#define bdw__l3_3__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set L3_3 :: FS Threads Dispatched */
#define bdw__l3_3__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set L3_3 :: CS Threads Dispatched */
#define bdw__l3_3__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set L3_3 :: EU Active */
#define bdw__l3_3__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set L3_3 :: EU Stall */
#define bdw__l3_3__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set L3_3 :: EU Both FPU Pipes Active */
#define bdw__l3_3__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set L3_3 :: VS FPU0 Pipe Active */
#define bdw__l3_3__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set L3_3 :: VS FPU1 Pipe Active */
#define bdw__l3_3__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set L3_3 :: VS Send Pipe Active */
#define bdw__l3_3__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set L3_3 :: PS FPU0 Pipe Active */
#define bdw__l3_3__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set L3_3 :: PS FPU1 Pipe Active */
#define bdw__l3_3__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set L3_3 :: PS Send Pipeline Active */
#define bdw__l3_3__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set L3_3 :: FS Both FPU Active */
#define bdw__l3_3__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set L3_3 :: Rasterized Pixels */
#define bdw__l3_3__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set L3_3 :: Early Hi-Depth Test Fails */
#define bdw__l3_3__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set L3_3 :: Early Depth Test Fails */
#define bdw__l3_3__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set L3_3 :: Samples Killed in FS */
#define bdw__l3_3__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set L3_3 :: Pixels Failing Tests */
#define bdw__l3_3__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set L3_3 :: Samples Written */
#define bdw__l3_3__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set L3_3 :: Samples Blended */
#define bdw__l3_3__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set L3_3 :: Sampler Texels */
#define bdw__l3_3__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set L3_3 :: Sampler Texels Misses */
#define bdw__l3_3__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set L3_3 :: SLM Bytes Read */
#define bdw__l3_3__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set L3_3 :: SLM Bytes Read */
#define bdw__l3_3__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_3 :: SLM Bytes Written */
#define bdw__l3_3__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set L3_3 :: SLM Bytes Written */
#define bdw__l3_3__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_3 :: Shader Memory Accesses */
#define bdw__l3_3__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set L3_3 :: Shader Atomic Memory Accesses */
#define bdw__l3_3__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set L3_3 :: L3 Shader Throughput */
#define bdw__l3_3__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set L3_3 :: L3 Shader Throughput */
#define bdw__l3_3__l3_shader_throughput__max \
    bdw__hdc_and_sf__l3_shader_throughput__max

/* Metric set L3_3 :: Shader Barrier Messages */
#define bdw__l3_3__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set L3_3 :: Slice0 L3 Bank3 Stalled */
#define bdw__l3_3__l30_bank3_stalled__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set L3_3 :: Slice1 L3 Bank3 Stalled */
#define bdw__l3_3__l31_bank3_stalled__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* Metric set L3_3 :: Slice1 L3 Bank3 Active */
#define bdw__l3_3__l31_bank3_active__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set L3_3 :: Slice0 L3 Bank3 Active */
#define bdw__l3_3__l30_bank3_active__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set L3_3 :: SQ is full */
#define bdw__l3_3__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set L3_4 :: GPU Time Elapsed */
#define bdw__l3_4__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set L3_4 :: GPU Core Clocks */
#define bdw__l3_4__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set L3_4 :: AVG GPU Core Frequency */
#define bdw__l3_4__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set L3_4 :: AVG GPU Core Frequency */
#define bdw__l3_4__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set L3_4 :: GPU Busy */
#define bdw__l3_4__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set L3_4 :: VS Threads Dispatched */
#define bdw__l3_4__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set L3_4 :: HS Threads Dispatched */
#define bdw__l3_4__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set L3_4 :: DS Threads Dispatched */
#define bdw__l3_4__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set L3_4 :: GS Threads Dispatched */
#define bdw__l3_4__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set L3_4 :: FS Threads Dispatched */
#define bdw__l3_4__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set L3_4 :: CS Threads Dispatched */
#define bdw__l3_4__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set L3_4 :: EU Active */
#define bdw__l3_4__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set L3_4 :: EU Stall */
#define bdw__l3_4__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set L3_4 :: EU Both FPU Pipes Active */
#define bdw__l3_4__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set L3_4 :: VS FPU0 Pipe Active */
#define bdw__l3_4__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set L3_4 :: VS FPU1 Pipe Active */
#define bdw__l3_4__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set L3_4 :: VS Send Pipe Active */
#define bdw__l3_4__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set L3_4 :: PS FPU0 Pipe Active */
#define bdw__l3_4__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set L3_4 :: PS FPU1 Pipe Active */
#define bdw__l3_4__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set L3_4 :: PS Send Pipeline Active */
#define bdw__l3_4__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set L3_4 :: FS Both FPU Active */
#define bdw__l3_4__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set L3_4 :: Rasterized Pixels */
#define bdw__l3_4__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set L3_4 :: Early Hi-Depth Test Fails */
#define bdw__l3_4__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set L3_4 :: Early Depth Test Fails */
#define bdw__l3_4__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set L3_4 :: Samples Killed in FS */
#define bdw__l3_4__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set L3_4 :: Pixels Failing Tests */
#define bdw__l3_4__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set L3_4 :: Samples Written */
#define bdw__l3_4__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set L3_4 :: Samples Blended */
#define bdw__l3_4__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set L3_4 :: Sampler Texels */
#define bdw__l3_4__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set L3_4 :: Sampler Texels Misses */
#define bdw__l3_4__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set L3_4 :: SLM Bytes Read */
#define bdw__l3_4__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set L3_4 :: SLM Bytes Read */
#define bdw__l3_4__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_4 :: SLM Bytes Written */
#define bdw__l3_4__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set L3_4 :: SLM Bytes Written */
#define bdw__l3_4__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_4 :: Shader Memory Accesses */
#define bdw__l3_4__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set L3_4 :: Shader Atomic Memory Accesses */
#define bdw__l3_4__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set L3_4 :: L3 Shader Throughput */
#define bdw__l3_4__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set L3_4 :: L3 Shader Throughput */
#define bdw__l3_4__l3_shader_throughput__max \
    bdw__hdc_and_sf__l3_shader_throughput__max

/* Metric set L3_4 :: Shader Barrier Messages */
#define bdw__l3_4__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set L3_4 :: Slice0 L3 Bank2 Stalled */
#define bdw__l3_4__l30_bank2_stalled__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set L3_4 :: Slice1 L3 Bank2 Stalled */
#define bdw__l3_4__l31_bank2_stalled__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* Metric set L3_4 :: Slice1 L3 Bank2 Active */
#define bdw__l3_4__l31_bank2_active__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set L3_4 :: Slice0 L3 Bank2 Active */
#define bdw__l3_4__l30_bank2_active__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set L3_4 :: SQ is full */
#define bdw__l3_4__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set RasterizerAndPixelBackend :: GPU Time Elapsed */
#define bdw__rasterizer_and_pixel_backend__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set RasterizerAndPixelBackend :: GPU Core Clocks */
#define bdw__rasterizer_and_pixel_backend__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set RasterizerAndPixelBackend :: AVG GPU Core Frequency */
#define bdw__rasterizer_and_pixel_backend__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set RasterizerAndPixelBackend :: AVG GPU Core Frequency */
#define bdw__rasterizer_and_pixel_backend__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set RasterizerAndPixelBackend :: GPU Busy */
#define bdw__rasterizer_and_pixel_backend__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set RasterizerAndPixelBackend :: VS Threads Dispatched */
#define bdw__rasterizer_and_pixel_backend__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set RasterizerAndPixelBackend :: HS Threads Dispatched */
#define bdw__rasterizer_and_pixel_backend__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set RasterizerAndPixelBackend :: DS Threads Dispatched */
#define bdw__rasterizer_and_pixel_backend__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set RasterizerAndPixelBackend :: GS Threads Dispatched */
#define bdw__rasterizer_and_pixel_backend__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set RasterizerAndPixelBackend :: FS Threads Dispatched */
#define bdw__rasterizer_and_pixel_backend__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set RasterizerAndPixelBackend :: CS Threads Dispatched */
#define bdw__rasterizer_and_pixel_backend__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set RasterizerAndPixelBackend :: EU Active */
#define bdw__rasterizer_and_pixel_backend__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set RasterizerAndPixelBackend :: EU Stall */
#define bdw__rasterizer_and_pixel_backend__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set RasterizerAndPixelBackend :: EU Both FPU Pipes Active */
#define bdw__rasterizer_and_pixel_backend__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set RasterizerAndPixelBackend :: VS FPU0 Pipe Active */
#define bdw__rasterizer_and_pixel_backend__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set RasterizerAndPixelBackend :: VS FPU1 Pipe Active */
#define bdw__rasterizer_and_pixel_backend__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set RasterizerAndPixelBackend :: VS Send Pipe Active */
#define bdw__rasterizer_and_pixel_backend__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set RasterizerAndPixelBackend :: PS FPU0 Pipe Active */
#define bdw__rasterizer_and_pixel_backend__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set RasterizerAndPixelBackend :: PS FPU1 Pipe Active */
#define bdw__rasterizer_and_pixel_backend__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set RasterizerAndPixelBackend :: PS Send Pipeline Active */
#define bdw__rasterizer_and_pixel_backend__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set RasterizerAndPixelBackend :: FS Both FPU Active */
#define bdw__rasterizer_and_pixel_backend__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set RasterizerAndPixelBackend :: Rasterized Pixels */
#define bdw__rasterizer_and_pixel_backend__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set RasterizerAndPixelBackend :: Early Hi-Depth Test Fails */
#define bdw__rasterizer_and_pixel_backend__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set RasterizerAndPixelBackend :: Early Depth Test Fails */
#define bdw__rasterizer_and_pixel_backend__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set RasterizerAndPixelBackend :: Samples Killed in FS */
#define bdw__rasterizer_and_pixel_backend__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set RasterizerAndPixelBackend :: Pixels Failing Tests */
#define bdw__rasterizer_and_pixel_backend__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set RasterizerAndPixelBackend :: Samples Written */
#define bdw__rasterizer_and_pixel_backend__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set RasterizerAndPixelBackend :: Samples Blended */
#define bdw__rasterizer_and_pixel_backend__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set RasterizerAndPixelBackend :: Sampler Texels */
#define bdw__rasterizer_and_pixel_backend__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set RasterizerAndPixelBackend :: Sampler Texels Misses */
#define bdw__rasterizer_and_pixel_backend__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Read */
#define bdw__rasterizer_and_pixel_backend__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Read */
#define bdw__rasterizer_and_pixel_backend__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Written */
#define bdw__rasterizer_and_pixel_backend__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Written */
#define bdw__rasterizer_and_pixel_backend__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set RasterizerAndPixelBackend :: Shader Memory Accesses */
#define bdw__rasterizer_and_pixel_backend__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set RasterizerAndPixelBackend :: Shader Atomic Memory Accesses */
#define bdw__rasterizer_and_pixel_backend__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set RasterizerAndPixelBackend :: L3 Shader Throughput */
#define bdw__rasterizer_and_pixel_backend__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set RasterizerAndPixelBackend :: L3 Shader Throughput */
#define bdw__rasterizer_and_pixel_backend__l3_shader_throughput__max \
    bdw__hdc_and_sf__l3_shader_throughput__max

/* Metric set RasterizerAndPixelBackend :: Shader Barrier Messages */
#define bdw__rasterizer_and_pixel_backend__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Rasterizer Output Ready */
#define bdw__rasterizer_and_pixel_backend__rasterizer0_output_ready__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set RasterizerAndPixelBackend :: Slice1 Post-EarlyZ Pixel Data Ready */
#define bdw__rasterizer_and_pixel_backend__pixel_data1_ready__read \
    bdw__render_basic__sampler1_busy__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Post-EarlyZ Pixel Data Ready */
#define bdw__rasterizer_and_pixel_backend__pixel_data0_ready__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Metric set RasterizerAndPixelBackend :: Slice1 Rasterizer Input Available */
#define bdw__rasterizer_and_pixel_backend__rasterizer1_input_available__read \
    bdw__render_basic__sampler1_bottleneck__read

/* Metric set RasterizerAndPixelBackend :: Slice1 Rasterizer Output Ready */
#define bdw__rasterizer_and_pixel_backend__rasterizer1_output_ready__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Rasterizer Input Available */
#define bdw__rasterizer_and_pixel_backend__rasterizer0_input_available__read \
    bdw__render_pipe_profile__cl_bottleneck__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Pixel Values Ready */
#define bdw__rasterizer_and_pixel_backend__pixel_values0_ready__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set RasterizerAndPixelBackend :: Slice0 PS Output Available */
#define bdw__rasterizer_and_pixel_backend__ps_output0_available__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set RasterizerAndPixelBackend :: Slice1 Pixel Values Ready */
#define bdw__rasterizer_and_pixel_backend__pixel_values1_ready__read \
    bdw__render_pipe_profile__sf_stall__read

/* Metric set RasterizerAndPixelBackend :: Slice1 PS Output Available */
#define bdw__rasterizer_and_pixel_backend__ps_output1_available__read \
    bdw__render_pipe_profile__cl_stall__read

/* Metric set RasterizerAndPixelBackend :: SQ is full */
#define bdw__rasterizer_and_pixel_backend__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set Sampler_1 :: GPU Time Elapsed */
#define bdw__sampler_1__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set Sampler_1 :: GPU Core Clocks */
#define bdw__sampler_1__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set Sampler_1 :: AVG GPU Core Frequency */
#define bdw__sampler_1__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set Sampler_1 :: AVG GPU Core Frequency */
#define bdw__sampler_1__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set Sampler_1 :: GPU Busy */
#define bdw__sampler_1__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set Sampler_1 :: VS Threads Dispatched */
#define bdw__sampler_1__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set Sampler_1 :: HS Threads Dispatched */
#define bdw__sampler_1__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set Sampler_1 :: DS Threads Dispatched */
#define bdw__sampler_1__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set Sampler_1 :: GS Threads Dispatched */
#define bdw__sampler_1__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set Sampler_1 :: FS Threads Dispatched */
#define bdw__sampler_1__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set Sampler_1 :: CS Threads Dispatched */
#define bdw__sampler_1__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set Sampler_1 :: EU Active */
#define bdw__sampler_1__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set Sampler_1 :: EU Stall */
#define bdw__sampler_1__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set Sampler_1 :: EU Both FPU Pipes Active */
#define bdw__sampler_1__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set Sampler_1 :: VS FPU0 Pipe Active */
#define bdw__sampler_1__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set Sampler_1 :: VS FPU1 Pipe Active */
#define bdw__sampler_1__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set Sampler_1 :: VS Send Pipe Active */
#define bdw__sampler_1__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set Sampler_1 :: PS FPU0 Pipe Active */
#define bdw__sampler_1__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set Sampler_1 :: PS FPU1 Pipe Active */
#define bdw__sampler_1__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set Sampler_1 :: PS Send Pipeline Active */
#define bdw__sampler_1__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set Sampler_1 :: FS Both FPU Active */
#define bdw__sampler_1__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set Sampler_1 :: Rasterized Pixels */
#define bdw__sampler_1__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set Sampler_1 :: Early Hi-Depth Test Fails */
#define bdw__sampler_1__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set Sampler_1 :: Early Depth Test Fails */
#define bdw__sampler_1__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set Sampler_1 :: Samples Killed in FS */
#define bdw__sampler_1__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set Sampler_1 :: Pixels Failing Tests */
#define bdw__sampler_1__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set Sampler_1 :: Samples Written */
#define bdw__sampler_1__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set Sampler_1 :: Samples Blended */
#define bdw__sampler_1__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set Sampler_1 :: Sampler Texels */
#define bdw__sampler_1__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set Sampler_1 :: Sampler Texels Misses */
#define bdw__sampler_1__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set Sampler_1 :: SLM Bytes Read */
#define bdw__sampler_1__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set Sampler_1 :: SLM Bytes Read */
#define bdw__sampler_1__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set Sampler_1 :: SLM Bytes Written */
#define bdw__sampler_1__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set Sampler_1 :: SLM Bytes Written */
#define bdw__sampler_1__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set Sampler_1 :: Shader Memory Accesses */
#define bdw__sampler_1__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set Sampler_1 :: Shader Atomic Memory Accesses */
#define bdw__sampler_1__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set Sampler_1 :: L3 Shader Throughput */
#define bdw__sampler_1__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set Sampler_1 :: L3 Shader Throughput */
#define bdw__sampler_1__l3_shader_throughput__max \
    bdw__hdc_and_sf__l3_shader_throughput__max

/* Metric set Sampler_1 :: Shader Barrier Messages */
#define bdw__sampler_1__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set Sampler_1 :: Slice1 Subslice1 Input Available */
#define bdw__sampler_1__sampler11_input_available__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set Sampler_1 :: Slice1 Subslice2 Input Available */
#define bdw__sampler_1__sampler12_input_available__read \
    bdw__render_basic__sampler1_busy__read

/* Metric set Sampler_1 :: Slice1 Subslice0 Input Available */
#define bdw__sampler_1__sampler10_input_available__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Metric set Sampler_1 :: Slice1 Subslice2 Sampler Output Ready */
#define bdw__sampler_1__sampler12_output_ready__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set Sampler_1 :: Slice1 Subslice0 Sampler Output Ready */
#define bdw__sampler_1__sampler10_output_ready__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set Sampler_1 :: Slice1 Subslice1 Sampler Output Ready */
#define bdw__sampler_1__sampler11_output_ready__read \
    bdw__render_pipe_profile__sf_stall__read

/* Metric set Sampler_1 :: SQ is full */
#define bdw__sampler_1__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set Sampler_2 :: GPU Time Elapsed */
#define bdw__sampler_2__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set Sampler_2 :: GPU Core Clocks */
#define bdw__sampler_2__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set Sampler_2 :: AVG GPU Core Frequency */
#define bdw__sampler_2__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set Sampler_2 :: AVG GPU Core Frequency */
#define bdw__sampler_2__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set Sampler_2 :: GPU Busy */
#define bdw__sampler_2__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set Sampler_2 :: VS Threads Dispatched */
#define bdw__sampler_2__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set Sampler_2 :: HS Threads Dispatched */
#define bdw__sampler_2__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set Sampler_2 :: DS Threads Dispatched */
#define bdw__sampler_2__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set Sampler_2 :: GS Threads Dispatched */
#define bdw__sampler_2__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set Sampler_2 :: FS Threads Dispatched */
#define bdw__sampler_2__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set Sampler_2 :: CS Threads Dispatched */
#define bdw__sampler_2__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set Sampler_2 :: EU Active */
#define bdw__sampler_2__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set Sampler_2 :: EU Stall */
#define bdw__sampler_2__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set Sampler_2 :: EU Both FPU Pipes Active */
#define bdw__sampler_2__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set Sampler_2 :: VS FPU0 Pipe Active */
#define bdw__sampler_2__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set Sampler_2 :: VS FPU1 Pipe Active */
#define bdw__sampler_2__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set Sampler_2 :: VS Send Pipe Active */
#define bdw__sampler_2__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set Sampler_2 :: PS FPU0 Pipe Active */
#define bdw__sampler_2__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set Sampler_2 :: PS FPU1 Pipe Active */
#define bdw__sampler_2__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set Sampler_2 :: PS Send Pipeline Active */
#define bdw__sampler_2__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set Sampler_2 :: FS Both FPU Active */
#define bdw__sampler_2__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set Sampler_2 :: Rasterized Pixels */
#define bdw__sampler_2__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set Sampler_2 :: Early Hi-Depth Test Fails */
#define bdw__sampler_2__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set Sampler_2 :: Early Depth Test Fails */
#define bdw__sampler_2__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set Sampler_2 :: Samples Killed in FS */
#define bdw__sampler_2__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set Sampler_2 :: Pixels Failing Tests */
#define bdw__sampler_2__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set Sampler_2 :: Samples Written */
#define bdw__sampler_2__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set Sampler_2 :: Samples Blended */
#define bdw__sampler_2__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set Sampler_2 :: Sampler Texels */
#define bdw__sampler_2__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set Sampler_2 :: Sampler Texels Misses */
#define bdw__sampler_2__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set Sampler_2 :: SLM Bytes Read */
#define bdw__sampler_2__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set Sampler_2 :: SLM Bytes Read */
#define bdw__sampler_2__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set Sampler_2 :: SLM Bytes Written */
#define bdw__sampler_2__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set Sampler_2 :: SLM Bytes Written */
#define bdw__sampler_2__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set Sampler_2 :: Shader Memory Accesses */
#define bdw__sampler_2__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set Sampler_2 :: Shader Atomic Memory Accesses */
#define bdw__sampler_2__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set Sampler_2 :: L3 Shader Throughput */
#define bdw__sampler_2__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set Sampler_2 :: L3 Shader Throughput */
#define bdw__sampler_2__l3_shader_throughput__max \
    bdw__hdc_and_sf__l3_shader_throughput__max

/* Metric set Sampler_2 :: Shader Barrier Messages */
#define bdw__sampler_2__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set Sampler_2 :: Slice0 Subslice1 Input Available */
#define bdw__sampler_2__sampler01_input_available__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set Sampler_2 :: Slice0 Subslice2 Input Available */
#define bdw__sampler_2__sampler02_input_available__read \
    bdw__render_basic__sampler1_busy__read

/* Metric set Sampler_2 :: Slice0 Subslice0 Input Available */
#define bdw__sampler_2__sampler00_input_available__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Metric set Sampler_2 :: Slice0 Subslice2 Sampler Output Ready */
#define bdw__sampler_2__sampler02_output_ready__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set Sampler_2 :: Slice0 Subslice0 Sampler Output Ready */
#define bdw__sampler_2__sampler00_output_ready__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set Sampler_2 :: Slice0 Subslice1 Sampler Output Ready */
#define bdw__sampler_2__sampler01_output_ready__read \
    bdw__render_pipe_profile__sf_stall__read

/* Metric set Sampler_2 :: SQ is full */
#define bdw__sampler_2__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set TDL_1 :: GPU Time Elapsed */
#define bdw__tdl_1__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set TDL_1 :: GPU Core Clocks */
#define bdw__tdl_1__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set TDL_1 :: AVG GPU Core Frequency */
#define bdw__tdl_1__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set TDL_1 :: AVG GPU Core Frequency */
#define bdw__tdl_1__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set TDL_1 :: GPU Busy */
#define bdw__tdl_1__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set TDL_1 :: VS Threads Dispatched */
#define bdw__tdl_1__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set TDL_1 :: HS Threads Dispatched */
#define bdw__tdl_1__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set TDL_1 :: DS Threads Dispatched */
#define bdw__tdl_1__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set TDL_1 :: GS Threads Dispatched */
#define bdw__tdl_1__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set TDL_1 :: FS Threads Dispatched */
#define bdw__tdl_1__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set TDL_1 :: CS Threads Dispatched */
#define bdw__tdl_1__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set TDL_1 :: EU Active */
#define bdw__tdl_1__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set TDL_1 :: EU Stall */
#define bdw__tdl_1__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set TDL_1 :: EU Both FPU Pipes Active */
#define bdw__tdl_1__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set TDL_1 :: VS FPU0 Pipe Active */
#define bdw__tdl_1__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set TDL_1 :: VS FPU1 Pipe Active */
#define bdw__tdl_1__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set TDL_1 :: VS Send Pipe Active */
#define bdw__tdl_1__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set TDL_1 :: PS FPU0 Pipe Active */
#define bdw__tdl_1__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set TDL_1 :: PS FPU1 Pipe Active */
#define bdw__tdl_1__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set TDL_1 :: PS Send Pipeline Active */
#define bdw__tdl_1__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set TDL_1 :: FS Both FPU Active */
#define bdw__tdl_1__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set TDL_1 :: Rasterized Pixels */
#define bdw__tdl_1__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set TDL_1 :: Early Hi-Depth Test Fails */
#define bdw__tdl_1__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set TDL_1 :: Early Depth Test Fails */
#define bdw__tdl_1__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set TDL_1 :: Samples Killed in FS */
#define bdw__tdl_1__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set TDL_1 :: Pixels Failing Tests */
#define bdw__tdl_1__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set TDL_1 :: Samples Written */
#define bdw__tdl_1__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set TDL_1 :: Samples Blended */
#define bdw__tdl_1__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set TDL_1 :: Sampler Texels */
#define bdw__tdl_1__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set TDL_1 :: Sampler Texels Misses */
#define bdw__tdl_1__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set TDL_1 :: SLM Bytes Read */
#define bdw__tdl_1__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set TDL_1 :: SLM Bytes Read */
#define bdw__tdl_1__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_1 :: SLM Bytes Written */
#define bdw__tdl_1__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set TDL_1 :: SLM Bytes Written */
#define bdw__tdl_1__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_1 :: Shader Memory Accesses */
#define bdw__tdl_1__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set TDL_1 :: Shader Atomic Memory Accesses */
#define bdw__tdl_1__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set TDL_1 :: L3 Shader Throughput */
#define bdw__tdl_1__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set TDL_1 :: L3 Shader Throughput */
#define bdw__tdl_1__l3_shader_throughput__max \
    bdw__hdc_and_sf__l3_shader_throughput__max

/* Metric set TDL_1 :: Shader Barrier Messages */
#define bdw__tdl_1__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set TDL_1 :: NonPS Thread Ready For Dispatch on Slice1 Subslice1 */
#define bdw__tdl_1__non_ps_thread11_ready_for_dispatch__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set TDL_1 :: PS Thread Ready For Dispatch on Slice1 Subslice0 */
#define bdw__tdl_1__ps_thread10_ready_for_dispatch__read \
    bdw__render_basic__sampler1_busy__read

/* Metric set TDL_1 :: NonPS Thread Ready For Dispatch on Slice1 Subslice0 */
#define bdw__tdl_1__non_ps_thread10_ready_for_dispatch__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Metric set TDL_1 :: PS Thread Ready For Dispatch on Slice1 Subslice2 */
#define bdw__tdl_1__ps_thread12_ready_for_dispatch__read \
    bdw__render_basic__sampler1_bottleneck__read

/* Metric set TDL_1 :: NonPS Thread Ready For Dispatch on Slice1 Subslice2 */
#define bdw__tdl_1__non_ps_thread12_ready_for_dispatch__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* Metric set TDL_1 :: PS Thread Ready For Dispatch on Slice1 Subslice1 */
#define bdw__tdl_1__ps_thread11_ready_for_dispatch__read \
    bdw__render_pipe_profile__cl_bottleneck__read

/* Metric set TDL_1 :: Thread Header Ready on Slice0 Subslice1 Port 0 */
#define bdw__tdl_1__thread_header01_ready_port0__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set TDL_1 :: Thread Header Ready on Slice0 Subslice0 Port 1 */
#define bdw__tdl_1__thread_header00_ready_port1__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set TDL_1 :: Thread Header Ready on Slice0 Subslice0 Port 0 */
#define bdw__tdl_1__thread_header00_ready_port0__read \
    bdw__render_pipe_profile__sf_stall__read

/* Metric set TDL_1 :: Thread Header Ready on Slice0 Subslice2 Port 1 */
#define bdw__tdl_1__thread_header02_ready_port1__read \
    bdw__render_pipe_profile__cl_stall__read

/* Metric set TDL_1 :: Thread Header Ready on Slice0 Subslice2 Port 0 */
#define bdw__tdl_1__thread_header02_ready_port0__read \
    bdw__render_pipe_profile__so_stall__read

/* Metric set TDL_1 :: Thread Header Ready on Slice0 Subslice1 Port 1 */
#define bdw__tdl_1__thread_header01_ready_port1__read \
    bdw__render_pipe_profile__ds_stall__read

/* Metric set TDL_1 :: SQ is full */
#define bdw__tdl_1__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set TDL_2 :: GPU Time Elapsed */
#define bdw__tdl_2__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set TDL_2 :: GPU Core Clocks */
#define bdw__tdl_2__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set TDL_2 :: AVG GPU Core Frequency */
#define bdw__tdl_2__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set TDL_2 :: AVG GPU Core Frequency */
#define bdw__tdl_2__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set TDL_2 :: GPU Busy */
#define bdw__tdl_2__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set TDL_2 :: VS Threads Dispatched */
#define bdw__tdl_2__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set TDL_2 :: HS Threads Dispatched */
#define bdw__tdl_2__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set TDL_2 :: DS Threads Dispatched */
#define bdw__tdl_2__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set TDL_2 :: GS Threads Dispatched */
#define bdw__tdl_2__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set TDL_2 :: FS Threads Dispatched */
#define bdw__tdl_2__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set TDL_2 :: CS Threads Dispatched */
#define bdw__tdl_2__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set TDL_2 :: EU Active */
#define bdw__tdl_2__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set TDL_2 :: EU Stall */
#define bdw__tdl_2__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set TDL_2 :: EU Both FPU Pipes Active */
#define bdw__tdl_2__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set TDL_2 :: VS FPU0 Pipe Active */
#define bdw__tdl_2__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set TDL_2 :: VS FPU1 Pipe Active */
#define bdw__tdl_2__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set TDL_2 :: VS Send Pipe Active */
#define bdw__tdl_2__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set TDL_2 :: PS FPU0 Pipe Active */
#define bdw__tdl_2__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set TDL_2 :: PS FPU1 Pipe Active */
#define bdw__tdl_2__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set TDL_2 :: PS Send Pipeline Active */
#define bdw__tdl_2__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set TDL_2 :: FS Both FPU Active */
#define bdw__tdl_2__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set TDL_2 :: Rasterized Pixels */
#define bdw__tdl_2__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set TDL_2 :: Early Hi-Depth Test Fails */
#define bdw__tdl_2__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set TDL_2 :: Early Depth Test Fails */
#define bdw__tdl_2__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set TDL_2 :: Samples Killed in FS */
#define bdw__tdl_2__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set TDL_2 :: Pixels Failing Tests */
#define bdw__tdl_2__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set TDL_2 :: Samples Written */
#define bdw__tdl_2__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set TDL_2 :: Samples Blended */
#define bdw__tdl_2__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set TDL_2 :: Sampler Texels */
#define bdw__tdl_2__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set TDL_2 :: Sampler Texels Misses */
#define bdw__tdl_2__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set TDL_2 :: SLM Bytes Read */
#define bdw__tdl_2__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set TDL_2 :: SLM Bytes Read */
#define bdw__tdl_2__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_2 :: SLM Bytes Written */
#define bdw__tdl_2__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set TDL_2 :: SLM Bytes Written */
#define bdw__tdl_2__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_2 :: Shader Memory Accesses */
#define bdw__tdl_2__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set TDL_2 :: Shader Atomic Memory Accesses */
#define bdw__tdl_2__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set TDL_2 :: L3 Shader Throughput */
#define bdw__tdl_2__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set TDL_2 :: L3 Shader Throughput */
#define bdw__tdl_2__l3_shader_throughput__max \
    bdw__hdc_and_sf__l3_shader_throughput__max

/* Metric set TDL_2 :: Shader Barrier Messages */
#define bdw__tdl_2__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set TDL_2 :: NonPS Thread Ready For Dispatch on Slice0 Subslice2 */
#define bdw__tdl_2__non_ps_thread02_ready_for_dispatch__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set TDL_2 :: PS Thread Ready For Dispatch on Slice0 Subslice2 */
#define bdw__tdl_2__ps_thread02_ready_for_dispatch__read \
    bdw__render_basic__sampler1_busy__read

/* Metric set TDL_2 :: PS Thread Ready For Dispatch on Slice0 Subslice1 */
#define bdw__tdl_2__ps_thread01_ready_for_dispatch__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Metric set TDL_2 :: PS Thread Ready For Dispatch on Slice0 Subslice0 */
#define bdw__tdl_2__ps_thread00_ready_for_dispatch__read \
    bdw__render_basic__sampler1_bottleneck__read

/* Metric set TDL_2 :: NonPS Thread Ready For Dispatch on Slice0 Subslice1 */
#define bdw__tdl_2__non_ps_thread01_ready_for_dispatch__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* Metric set TDL_2 :: NonPS Thread Ready For Dispatch on Slice0 Subslice0 */
#define bdw__tdl_2__non_ps_thread00_ready_for_dispatch__read \
    bdw__render_pipe_profile__cl_bottleneck__read

/* Metric set TDL_2 :: Thread Header Ready on Slice1 Subslice2 Port 0 */
#define bdw__tdl_2__thread_header12_ready_port0__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set TDL_2 :: Thread Header Ready on Slice1 Subslice2 Port 1 */
#define bdw__tdl_2__thread_header12_ready_port1__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set TDL_2 :: Thread Header Ready on Slice1 Subslice1 Port 1 */
#define bdw__tdl_2__thread_header11_ready_port1__read \
    bdw__render_pipe_profile__sf_stall__read

/* Metric set TDL_2 :: Thread Header Ready on Slice1 Subslice0 Port 0 */
#define bdw__tdl_2__thread_header10_ready_port0__read \
    bdw__render_pipe_profile__cl_stall__read

/* Metric set TDL_2 :: Thread Header Ready on Slice1 Subslice0 Port 1 */
#define bdw__tdl_2__thread_header10_ready_port1__read \
    bdw__render_pipe_profile__so_stall__read

/* Metric set TDL_2 :: Thread Header Ready on Slice1 Subslice1 Port 0 */
#define bdw__tdl_2__thread_header11_ready_port0__read \
    bdw__render_pipe_profile__ds_stall__read

/* Metric set TDL_2 :: SQ is full */
#define bdw__tdl_2__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Compute Metrics Extra Gen8 :: GPU Time Elapsed */
#define bdw__compute_extra__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Compute Metrics Extra Gen8 :: GPU Core Clocks */
#define bdw__compute_extra__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Compute Metrics Extra Gen8 :: AVG GPU Core Frequency */
#define bdw__compute_extra__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Compute Metrics Extra Gen8 :: AVG GPU Core Frequency */
#define bdw__compute_extra__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Compute Metrics Extra Gen8 :: EU FPU1 Pipe Active */
#define bdw__compute_extra__fpu1_active__read \
    bdw__render_basic__eu_stall__read

/* Compute Metrics Extra Gen8 :: EU FPU1 Pipe Active including Ext Math */
static double
bdw__compute_extra__fpu1_active_adjusted__read(const struct intel_perf *perf,
                                               const struct intel_perf_metric_set *metric_set,
                                               uint64_t *accumulator)
{
    /* RPN equation: A 8 READ  C 5 READ C 6 READ FADD C 7 READ FADD C 2 READ FADD C 3 READ FADD C 4 READ FADD 8 FMUL FADD 100 FMUL $EuCoresTotalCount FDIV $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 8];
    uint64_t tmp1 = accumulator[metric_set->c_offset + 5];
    uint64_t tmp2 = accumulator[metric_set->c_offset + 6];
    double tmp3 = tmp1 + tmp2;
    uint64_t tmp4 = accumulator[metric_set->c_offset + 7];
    double tmp5 = tmp3 + tmp4;
    uint64_t tmp6 = accumulator[metric_set->c_offset + 2];
    double tmp7 = tmp5 + tmp6;
    uint64_t tmp8 = accumulator[metric_set->c_offset + 3];
    double tmp9 = tmp7 + tmp8;
    uint64_t tmp10 = accumulator[metric_set->c_offset + 4];
    double tmp11 = tmp9 + tmp10;
    double tmp12 = tmp11 * 8;
    double tmp13 = tmp0 + tmp12;
    double tmp14 = tmp13 * 100;
    double tmp15 = tmp14;
    double tmp16 = perf->devinfo.n_eus;
    double tmp17 = tmp16 ? tmp15 / tmp16 : 0;
    double tmp18 = tmp17;
    double tmp19 = bdw__compute_extra__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp20 = tmp19 ? tmp18 / tmp19 : 0;

    return tmp20;
}

/* Media Vme Pipe Gen8 :: GPU Time Elapsed */
#define bdw__vme_pipe__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Media Vme Pipe Gen8 :: GPU Core Clocks */
#define bdw__vme_pipe__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Media Vme Pipe Gen8 :: AVG GPU Core Frequency */
#define bdw__vme_pipe__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Media Vme Pipe Gen8 :: AVG GPU Core Frequency */
#define bdw__vme_pipe__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Media Vme Pipe Gen8 :: GPU Busy */
#define bdw__vme_pipe__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Media Vme Pipe Gen8 :: CS Threads Dispatched */
#define bdw__vme_pipe__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Media Vme Pipe Gen8 :: EU Active */
#define bdw__vme_pipe__eu_active__read \
    bdw__render_basic__eu_active__read

/* Media Vme Pipe Gen8 :: EU Stall */
#define bdw__vme_pipe__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Media Vme Pipe Gen8 :: EU Both FPU Pipes Active */
#define bdw__vme_pipe__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Media Vme Pipe Gen8 :: EU Thread Occupancy */
static double
bdw__vme_pipe__eu_thread_occupancy__read(const struct intel_perf *perf,
                                         const struct intel_perf_metric_set *metric_set,
                                         uint64_t *accumulator)
{
    /* RPN equation: 8 A 10 READ FMUL $EuThreadsCount FDIV $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 10];
    double tmp1 = 8 * tmp0;
    double tmp2 = tmp1;
    double tmp3 = perf->devinfo.eu_threads_count;
    double tmp4 = tmp3 ? tmp2 / tmp3 : 0;
    uint64_t tmp5 = tmp4;
    uint64_t tmp6 = perf->devinfo.n_eus;
    uint64_t tmp7 = tmp6 ? tmp5 / tmp6 : 0;
    uint64_t tmp8 = tmp7 * 100;
    double tmp9 = tmp8;
    double tmp10 = bdw__vme_pipe__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp11 = tmp10 ? tmp9 / tmp10 : 0;

    return tmp11;
}

/* Media Vme Pipe Gen8 :: VME Busy */
static double
bdw__vme_pipe__vme_busy__read(const struct intel_perf *perf,
                              const struct intel_perf_metric_set *metric_set,
                              uint64_t *accumulator)
{
    /* RPN equation: B 0 READ B 3 READ FADD 2 FDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 0];
    uint64_t tmp1 = accumulator[metric_set->b_offset + 3];
    double tmp2 = tmp0 + tmp1;
    double tmp3 = tmp2;
    double tmp4 = 2;
    double tmp5 = tmp4 ? tmp3 / tmp4 : 0;
    uint64_t tmp6 = tmp5 * 100;
    double tmp7 = tmp6;
    double tmp8 = bdw__vme_pipe__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp9 = tmp8 ? tmp7 / tmp8 : 0;

    return tmp9;
}

/* Gpu Rings Busyness :: GPU Time Elapsed */
#define bdw__gpu_busyness__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Gpu Rings Busyness :: GPU Core Clocks */
#define bdw__gpu_busyness__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Gpu Rings Busyness :: AVG GPU Core Frequency */
#define bdw__gpu_busyness__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Gpu Rings Busyness :: AVG GPU Core Frequency */
#define bdw__gpu_busyness__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Gpu Rings Busyness :: Render Ring Busy */
#define bdw__gpu_busyness__render_busy__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Gpu Rings Busyness :: Vdbox0 Ring Busy */
#define bdw__gpu_busyness__vdbox0_busy__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Gpu Rings Busyness :: Vdbox1 Ring Busy */
#define bdw__gpu_busyness__vdbox1_busy__read \
    bdw__render_pipe_profile__so_stall__read

/* Gpu Rings Busyness :: Vebox Ring Busy */
#define bdw__gpu_busyness__vebox_busy__read \
    bdw__render_pipe_profile__sf_stall__read

/* Gpu Rings Busyness :: Blitter Ring Busy */
#define bdw__gpu_busyness__blitter_busy__read \
    bdw__render_pipe_profile__cl_stall__read

/* Gpu Rings Busyness :: AnyRingBusy */
#define bdw__gpu_busyness__any_ring_busy__read \
    bdw__render_basic__sampler0_busy__read

/* MDAPI testing set Gen8 :: GPU Time Elapsed */
#define bdw__test_oa__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* MDAPI testing set Gen8 :: GPU Core Clocks */
#define bdw__test_oa__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* MDAPI testing set Gen8 :: AVG GPU Core Frequency */
#define bdw__test_oa__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* MDAPI testing set Gen8 :: AVG GPU Core Frequency */
#define bdw__test_oa__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* MDAPI testing set Gen8 :: TestCounter0 */
#define bdw__test_oa__counter0__read \
    hsw__compute_extended__eu_untyped_reads0__read

/* MDAPI testing set Gen8 :: TestCounter1 */
#define bdw__test_oa__counter1__read \
    hsw__compute_extended__eu_untyped_writes0__read

/* MDAPI testing set Gen8 :: TestCounter2 */
#define bdw__test_oa__counter2__read \
    hsw__compute_extended__eu_typed_reads0__read

/* MDAPI testing set Gen8 :: TestCounter3 */
#define bdw__test_oa__counter3__read \
    hsw__compute_extended__eu_typed_writes0__read

/* MDAPI testing set Gen8 :: TestCounter4 */
#define bdw__test_oa__counter4__read \
    hsw__compute_extended__eu_untyped_atomics0__read

/* MDAPI testing set Gen8 :: TestCounter5 */
#define bdw__test_oa__counter5__read \
    hsw__compute_extended__eu_typed_atomics0__read

/* MDAPI testing set Gen8 :: TestCounter6 */
#define bdw__test_oa__counter6__read \
    hsw__compute_extended__eu_urb_atomics0__read

/* MDAPI testing set Gen8 :: TestCounter7 */
#define bdw__test_oa__counter7__read \
    hsw__compute_extended__gpu_clocks__read

/* MDAPI testing set Gen8 :: TestCounter8 */
#define bdw__test_oa__counter8__read \
    hsw__memory_reads__gpu_core_clocks__read

/* Metric set PMA Stall :: GPU Time Elapsed */
#define bdw__stc__pma_stall__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set PMA Stall :: GPU Core Clocks */
#define bdw__stc__pma_stall__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set PMA Stall :: AVG GPU Core Frequency */
#define bdw__stc__pma_stall__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set PMA Stall :: AVG GPU Core Frequency */
#define bdw__stc__pma_stall__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set PMA Stall :: GPU Busy */
#define bdw__stc__pma_stall__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set PMA Stall :: VS Threads Dispatched */
#define bdw__stc__pma_stall__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set PMA Stall :: HS Threads Dispatched */
#define bdw__stc__pma_stall__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set PMA Stall :: DS Threads Dispatched */
#define bdw__stc__pma_stall__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set PMA Stall :: GS Threads Dispatched */
#define bdw__stc__pma_stall__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set PMA Stall :: FS Threads Dispatched */
#define bdw__stc__pma_stall__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set PMA Stall :: CS Threads Dispatched */
#define bdw__stc__pma_stall__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set PMA Stall :: STC PMA stall */
#define bdw__stc__pma_stall__stc_pma_stall__read \
    bdw__render_basic__sampler0_busy__read

/* Render Metrics Basic Gen8LP :: GPU Time Elapsed */
#define chv__render_basic__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Render Metrics Basic Gen8LP :: GPU Core Clocks */
#define chv__render_basic__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Render Metrics Basic Gen8LP :: AVG GPU Core Frequency */
#define chv__render_basic__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Render Metrics Basic Gen8LP :: AVG GPU Core Frequency */
#define chv__render_basic__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Render Metrics Basic Gen8LP :: VS Threads Dispatched */
#define chv__render_basic__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Render Metrics Basic Gen8LP :: HS Threads Dispatched */
#define chv__render_basic__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Render Metrics Basic Gen8LP :: DS Threads Dispatched */
#define chv__render_basic__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Render Metrics Basic Gen8LP :: GS Threads Dispatched */
#define chv__render_basic__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Render Metrics Basic Gen8LP :: FS Threads Dispatched */
#define chv__render_basic__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Render Metrics Basic Gen8LP :: CS Threads Dispatched */
#define chv__render_basic__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Render Metrics Basic Gen8LP :: GPU Busy */
#define chv__render_basic__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Render Metrics Basic Gen8LP :: EU Active */
#define chv__render_basic__eu_active__read \
    bdw__render_basic__eu_active__read

/* Render Metrics Basic Gen8LP :: EU Stall */
#define chv__render_basic__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Render Metrics Basic Gen8LP :: EU Both FPU Pipes Active */
#define chv__render_basic__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Render Metrics Basic Gen8LP :: VS FPU0 Pipe Active */
#define chv__render_basic__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Render Metrics Basic Gen8LP :: VS FPU1 Pipe Active */
#define chv__render_basic__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Render Metrics Basic Gen8LP :: VS Send Pipe Active */
#define chv__render_basic__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Render Metrics Basic Gen8LP :: PS FPU0 Pipe Active */
#define chv__render_basic__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Render Metrics Basic Gen8LP :: PS FPU1 Pipe Active */
#define chv__render_basic__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Render Metrics Basic Gen8LP :: PS Send Pipeline Active */
#define chv__render_basic__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Render Metrics Basic Gen8LP :: FS Both FPU Active */
#define chv__render_basic__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Render Metrics Basic Gen8LP :: Sampler 0 Busy */
#define chv__render_basic__sampler0_busy__read \
    bdw__render_basic__sampler0_busy__read

/* Render Metrics Basic Gen8LP :: Sampler 1 Busy */
#define chv__render_basic__sampler1_busy__read \
    bdw__render_basic__sampler1_busy__read

/* Render Metrics Basic Gen8LP :: Samplers Busy */
static double
chv__render_basic__samplers_busy__read(const struct intel_perf *perf,
                                       const struct intel_perf_metric_set *metric_set,
                                       uint64_t *accumulator)
{
    /* RPN equation: B 0 READ  B 1 READ UADD $GpuCoreClocks FDIV 2 FDIV 100 FMUL */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 0];
    uint64_t tmp1 = accumulator[metric_set->b_offset + 1];
    uint64_t tmp2 = tmp0 + tmp1;
    double tmp3 = tmp2;
    double tmp4 = chv__render_basic__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp5 = tmp4 ? tmp3 / tmp4 : 0;
    double tmp6 = tmp5;
    double tmp7 = 2;
    double tmp8 = tmp7 ? tmp6 / tmp7 : 0;
    double tmp9 = tmp8 * 100;

    return tmp9;
}

/* Render Metrics Basic Gen8LP :: Sampler 0 Bottleneck */
#define chv__render_basic__sampler0_bottleneck__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Render Metrics Basic Gen8LP :: Sampler 1 Bottleneck */
#define chv__render_basic__sampler1_bottleneck__read \
    bdw__render_basic__sampler1_bottleneck__read

/* Render Metrics Basic Gen8LP :: Samples Written */
#define chv__render_basic__samples_written__read \
    bdw__render_basic__samples_written__read

/* Render Metrics Basic Gen8LP :: Samples Blended */
#define chv__render_basic__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Render Metrics Basic Gen8LP :: Sampler Texels */
#define chv__render_basic__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Render Metrics Basic Gen8LP :: Sampler Texels Misses */
#define chv__render_basic__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Render Metrics Basic Gen8LP :: Rasterized Pixels */
#define chv__render_basic__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Render Metrics Basic Gen8LP :: Early Hi-Depth Test Fails */
#define chv__render_basic__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Render Metrics Basic Gen8LP :: Early Depth Test Fails */
#define chv__render_basic__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Render Metrics Basic Gen8LP :: Samples Killed in FS */
#define chv__render_basic__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Render Metrics Basic Gen8LP :: Pixels Failing Tests */
#define chv__render_basic__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Render Metrics Basic Gen8LP :: SLM Bytes Read */
#define chv__render_basic__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Render Metrics Basic Gen8LP :: SLM Bytes Read */
#define chv__render_basic__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics Basic Gen8LP :: SLM Bytes Written */
#define chv__render_basic__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Render Metrics Basic Gen8LP :: SLM Bytes Written */
#define chv__render_basic__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics Basic Gen8LP :: Shader Memory Accesses */
#define chv__render_basic__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Render Metrics Basic Gen8LP :: Shader Atomic Memory Accesses */
#define chv__render_basic__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Render Metrics Basic Gen8LP :: L3 Misses */
#define chv__render_basic__l3_misses__read \
    hsw__compute_extended__typed_atomics0__read

/* Render Metrics Basic Gen8LP :: L3 Sampler Throughput */
static uint64_t
chv__render_basic__l3_sampler_throughput__read(const struct intel_perf *perf,
                                               const struct intel_perf_metric_set *metric_set,
                                               uint64_t *accumulator)
{
    /* RPN equation: A 29 READ 64 UMUL */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 29];
    uint64_t tmp1 = tmp0 * 64;

    return tmp1;
}

/* Render Metrics Basic Gen8LP :: L3 Sampler Throughput */
#define chv__render_basic__l3_sampler_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Render Metrics Basic Gen8LP :: L3 Shader Throughput */
#define chv__render_basic__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Render Metrics Basic Gen8LP :: L3 Shader Throughput */
static uint64_t
chv__render_basic__l3_shader_throughput__max(const struct intel_perf *perf,
                                             const struct intel_perf_metric_set *metric_set,
                                             uint64_t *accumulator)
{
    /* RPN equation: $GpuCoreClocks 64 UMUL $EuSlicesTotalCount UMUL 2 UMUL */
    uint64_t tmp0 = chv__render_basic__gpu_core_clocks__read(perf, metric_set, accumulator) * 64;
    uint64_t tmp1 = tmp0 * perf->devinfo.n_eu_slices;
    uint64_t tmp2 = tmp1 * 2;

    return tmp2;
}

/* Render Metrics Basic Gen8LP :: Shader Barrier Messages */
#define chv__render_basic__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Render Metrics Basic Gen8LP :: GTI Fixed Pipe Throughput */
#define chv__render_basic__gti_vf_throughput__read \
    bdw__render_basic__gti_vf_throughput__read

/* Render Metrics Basic Gen8LP :: GTI Fixed Pipe Throughput */
#define chv__render_basic__gti_vf_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Render Metrics Basic Gen8LP :: GTI Depth Throughput */
#define chv__render_basic__gti_depth_throughput__read \
    bdw__render_basic__gti_depth_throughput__read

/* Render Metrics Basic Gen8LP :: GTI Depth Throughput */
#define chv__render_basic__gti_depth_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Render Metrics Basic Gen8LP :: GTI RCC Throughput */
#define chv__render_basic__gti_rcc_throughput__read \
    bdw__render_basic__gti_rcc_throughput__read

/* Render Metrics Basic Gen8LP :: GTI RCC Throughput */
#define chv__render_basic__gti_rcc_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Render Metrics Basic Gen8LP :: GTI L3 Throughput */
#define chv__render_basic__gti_l3_throughput__read \
    hsw__render_basic__gti_l3_throughput__read

/* Render Metrics Basic Gen8LP :: GTI L3 Throughput */
#define chv__render_basic__gti_l3_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics Basic Gen8LP :: GTI HDC TLB Lookup Throughput */
#define chv__render_basic__gti_hdc_lookups_throughput__read \
    bdw__render_basic__gti_hdc_lookups_throughput__read

/* Render Metrics Basic Gen8LP :: GTI HDC TLB Lookup Throughput */
#define chv__render_basic__gti_hdc_lookups_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics Basic Gen8LP :: GTI Read Throughput */
#define chv__render_basic__gti_read_throughput__read \
    bdw__render_basic__gti_read_throughput__read

/* Render Metrics Basic Gen8LP :: GTI Read Throughput */
#define chv__render_basic__gti_read_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Render Metrics Basic Gen8LP :: GTI Write Throughput */
#define chv__render_basic__gti_write_throughput__read \
    hsw__render_basic__gti_write_throughput__read

/* Render Metrics Basic Gen8LP :: GTI Write Throughput */
#define chv__render_basic__gti_write_throughput__max \
    bdw__render_basic__gti_write_throughput__max

/* Render Metrics Basic Gen8LP :: Samplers Bottleneck */
#define chv__render_basic__sampler_bottleneck__read \
    bdw__render_basic__sampler_bottleneck__read

/* Compute Metrics Basic Gen8LP :: GPU Time Elapsed */
#define chv__compute_basic__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Compute Metrics Basic Gen8LP :: GPU Core Clocks */
#define chv__compute_basic__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Compute Metrics Basic Gen8LP :: AVG GPU Core Frequency */
#define chv__compute_basic__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Compute Metrics Basic Gen8LP :: AVG GPU Core Frequency */
#define chv__compute_basic__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Compute Metrics Basic Gen8LP :: GPU Busy */
#define chv__compute_basic__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Compute Metrics Basic Gen8LP :: VS Threads Dispatched */
#define chv__compute_basic__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Compute Metrics Basic Gen8LP :: HS Threads Dispatched */
#define chv__compute_basic__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Compute Metrics Basic Gen8LP :: DS Threads Dispatched */
#define chv__compute_basic__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Compute Metrics Basic Gen8LP :: GS Threads Dispatched */
#define chv__compute_basic__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Compute Metrics Basic Gen8LP :: FS Threads Dispatched */
#define chv__compute_basic__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Compute Metrics Basic Gen8LP :: CS Threads Dispatched */
#define chv__compute_basic__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Compute Metrics Basic Gen8LP :: EU Active */
#define chv__compute_basic__eu_active__read \
    bdw__render_basic__eu_active__read

/* Compute Metrics Basic Gen8LP :: EU Stall */
#define chv__compute_basic__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Compute Metrics Basic Gen8LP :: EU Both FPU Pipes Active */
#define chv__compute_basic__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Compute Metrics Basic Gen8LP :: EU FPU0 Pipe Active */
#define chv__compute_basic__fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Compute Metrics Basic Gen8LP :: EU FPU1 Pipe Active */
#define chv__compute_basic__fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Compute Metrics Basic Gen8LP :: EU AVG IPC Rate */
#define chv__compute_basic__eu_avg_ipc_rate__read \
    bdw__compute_basic__eu_avg_ipc_rate__read

/* Compute Metrics Basic Gen8LP :: EU AVG IPC Rate */
#define chv__compute_basic__eu_avg_ipc_rate__max \
    bdw__compute_basic__eu_avg_ipc_rate__max

/* Compute Metrics Basic Gen8LP :: EU Send Pipe Active */
#define chv__compute_basic__eu_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Compute Metrics Basic Gen8LP :: EU Thread Occupancy */
#define chv__compute_basic__eu_thread_occupancy__read \
    bdw__compute_basic__eu_thread_occupancy__read

/* Compute Metrics Basic Gen8LP :: Rasterized Pixels */
#define chv__compute_basic__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Compute Metrics Basic Gen8LP :: Early Hi-Depth Test Fails */
#define chv__compute_basic__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Compute Metrics Basic Gen8LP :: Early Depth Test Fails */
#define chv__compute_basic__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Compute Metrics Basic Gen8LP :: Samples Killed in FS */
#define chv__compute_basic__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Compute Metrics Basic Gen8LP :: Pixels Failing Tests */
#define chv__compute_basic__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Compute Metrics Basic Gen8LP :: Samples Written */
#define chv__compute_basic__samples_written__read \
    bdw__render_basic__samples_written__read

/* Compute Metrics Basic Gen8LP :: Samples Blended */
#define chv__compute_basic__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Compute Metrics Basic Gen8LP :: Sampler Texels */
#define chv__compute_basic__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Compute Metrics Basic Gen8LP :: Sampler Texels Misses */
#define chv__compute_basic__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Compute Metrics Basic Gen8LP :: SLM Bytes Read */
#define chv__compute_basic__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Compute Metrics Basic Gen8LP :: SLM Bytes Read */
#define chv__compute_basic__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Basic Gen8LP :: SLM Bytes Written */
#define chv__compute_basic__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Compute Metrics Basic Gen8LP :: SLM Bytes Written */
#define chv__compute_basic__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Basic Gen8LP :: Shader Memory Accesses */
#define chv__compute_basic__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Compute Metrics Basic Gen8LP :: Shader Atomic Memory Accesses */
#define chv__compute_basic__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Compute Metrics Basic Gen8LP :: L3 Shader Throughput */
#define chv__compute_basic__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Compute Metrics Basic Gen8LP :: L3 Shader Throughput */
#define chv__compute_basic__l3_shader_throughput__max \
    chv__render_basic__l3_shader_throughput__max

/* Compute Metrics Basic Gen8LP :: Shader Barrier Messages */
#define chv__compute_basic__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Compute Metrics Basic Gen8LP :: Typed Bytes Read */
static uint64_t
chv__compute_basic__typed_bytes_read__read(const struct intel_perf *perf,
                                           const struct intel_perf_metric_set *metric_set,
                                           uint64_t *accumulator)
{
    /* RPN equation: B 0 READ B 1 READ UADD 64 UMUL */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 0];
    uint64_t tmp1 = accumulator[metric_set->b_offset + 1];
    uint64_t tmp2 = tmp0 + tmp1;
    uint64_t tmp3 = tmp2 * 64;

    return tmp3;
}

/* Compute Metrics Basic Gen8LP :: Typed Bytes Read */
#define chv__compute_basic__typed_bytes_read__max \
    bdw__render_basic__gti_vf_throughput__max

/* Compute Metrics Basic Gen8LP :: Typed Bytes Written */
static uint64_t
chv__compute_basic__typed_bytes_written__read(const struct intel_perf *perf,
                                              const struct intel_perf_metric_set *metric_set,
                                              uint64_t *accumulator)
{
    /* RPN equation: B 2 READ B 3 READ UADD 64 UMUL */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 2];
    uint64_t tmp1 = accumulator[metric_set->b_offset + 3];
    uint64_t tmp2 = tmp0 + tmp1;
    uint64_t tmp3 = tmp2 * 64;

    return tmp3;
}

/* Compute Metrics Basic Gen8LP :: Typed Bytes Written */
#define chv__compute_basic__typed_bytes_written__max \
    bdw__render_basic__gti_vf_throughput__max

/* Compute Metrics Basic Gen8LP :: Untyped Bytes Read */
static uint64_t
chv__compute_basic__untyped_bytes_read__read(const struct intel_perf *perf,
                                             const struct intel_perf_metric_set *metric_set,
                                             uint64_t *accumulator)
{
    /* RPN equation: B 4 READ B 5 READ UADD 64 UMUL */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 4];
    uint64_t tmp1 = accumulator[metric_set->b_offset + 5];
    uint64_t tmp2 = tmp0 + tmp1;
    uint64_t tmp3 = tmp2 * 64;

    return tmp3;
}

/* Compute Metrics Basic Gen8LP :: Untyped Bytes Read */
#define chv__compute_basic__untyped_bytes_read__max \
    bdw__render_basic__gti_vf_throughput__max

/* Compute Metrics Basic Gen8LP :: Untyped Writes */
#define chv__compute_basic__untyped_bytes_written__read \
    hsw__compute_basic__typed_bytes_written__read

/* Compute Metrics Basic Gen8LP :: Untyped Writes */
#define chv__compute_basic__untyped_bytes_written__max \
    bdw__render_basic__gti_vf_throughput__max

/* Compute Metrics Basic Gen8LP :: GTI Read Throughput */
#define chv__compute_basic__gti_read_throughput__read \
    hsw__render_basic__gti_depth_throughput__read

/* Compute Metrics Basic Gen8LP :: GTI Read Throughput */
#define chv__compute_basic__gti_read_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Compute Metrics Basic Gen8LP :: GTI Write Throughput */
#define chv__compute_basic__gti_write_throughput__read \
    hsw__render_basic__gti_vf_throughput__read

/* Compute Metrics Basic Gen8LP :: GTI Write Throughput */
#define chv__compute_basic__gti_write_throughput__max \
    bdw__render_basic__gti_write_throughput__max

/* Compute Metrics Basic Gen8LP :: GTI Ring Throughput */
static uint64_t
chv__compute_basic__gti_ring_throughput__read(const struct intel_perf *perf,
                                              const struct intel_perf_metric_set *metric_set,
                                              uint64_t *accumulator)
{
    /* RPN equation: C 2 READ 128 UMUL */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 2];
    uint64_t tmp1 = tmp0 * 128;

    return tmp1;
}

/* Compute Metrics Basic Gen8LP :: GTI Ring Throughput */
static uint64_t
chv__compute_basic__gti_ring_throughput__max(const struct intel_perf *perf,
                                             const struct intel_perf_metric_set *metric_set,
                                             uint64_t *accumulator)
{
    /* RPN equation: $GpuCoreClocks 128 UMUL */
    uint64_t tmp0 = chv__compute_basic__gpu_core_clocks__read(perf, metric_set, accumulator) * 128;

    return tmp0;
}

/* Compute Metrics Basic Gen8LP :: GTI Read-Only Stall */
#define chv__compute_basic__gti_ro_stall__read \
    bdw__render_pipe_profile__so_stall__read

/* Compute Metrics Basic Gen8LP :: GTI Read-Write Stall */
#define chv__compute_basic__gti_rw_stall__read \
    bdw__render_pipe_profile__cl_stall__read

/* Render Metrics for 3D Pipeline Profile :: GPU Time Elapsed */
#define chv__render_pipe_profile__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Render Metrics for 3D Pipeline Profile :: GPU Core Clocks */
#define chv__render_pipe_profile__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Render Metrics for 3D Pipeline Profile :: AVG GPU Core Frequency */
#define chv__render_pipe_profile__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Render Metrics for 3D Pipeline Profile :: AVG GPU Core Frequency */
#define chv__render_pipe_profile__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Render Metrics for 3D Pipeline Profile :: GPU Busy */
#define chv__render_pipe_profile__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Render Metrics for 3D Pipeline Profile :: VS Threads Dispatched */
#define chv__render_pipe_profile__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Render Metrics for 3D Pipeline Profile :: HS Threads Dispatched */
#define chv__render_pipe_profile__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Render Metrics for 3D Pipeline Profile :: DS Threads Dispatched */
#define chv__render_pipe_profile__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Render Metrics for 3D Pipeline Profile :: GS Threads Dispatched */
#define chv__render_pipe_profile__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Render Metrics for 3D Pipeline Profile :: FS Threads Dispatched */
#define chv__render_pipe_profile__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Render Metrics for 3D Pipeline Profile :: CS Threads Dispatched */
#define chv__render_pipe_profile__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Render Metrics for 3D Pipeline Profile :: EU Active */
#define chv__render_pipe_profile__eu_active__read \
    bdw__render_basic__eu_active__read

/* Render Metrics for 3D Pipeline Profile :: EU Stall */
#define chv__render_pipe_profile__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Render Metrics for 3D Pipeline Profile :: Rasterized Pixels */
#define chv__render_pipe_profile__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Render Metrics for 3D Pipeline Profile :: Early Hi-Depth Test Fails */
#define chv__render_pipe_profile__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Render Metrics for 3D Pipeline Profile :: Early Depth Test Fails */
#define chv__render_pipe_profile__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Render Metrics for 3D Pipeline Profile :: Samples Killed in FS */
#define chv__render_pipe_profile__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Render Metrics for 3D Pipeline Profile :: Pixels Failing Tests */
#define chv__render_pipe_profile__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Render Metrics for 3D Pipeline Profile :: Samples Written */
#define chv__render_pipe_profile__samples_written__read \
    bdw__render_basic__samples_written__read

/* Render Metrics for 3D Pipeline Profile :: Samples Blended */
#define chv__render_pipe_profile__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Render Metrics for 3D Pipeline Profile :: Sampler Accesses */
#define chv__render_pipe_profile__sampler_accesses__read \
    bdw__render_pipe_profile__sampler_accesses__read

/* Render Metrics for 3D Pipeline Profile :: Sampler Texels */
#define chv__render_pipe_profile__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Render Metrics for 3D Pipeline Profile :: Sampler Texels Misses */
#define chv__render_pipe_profile__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Render Metrics for 3D Pipeline Profile :: SLM Bytes Read */
#define chv__render_pipe_profile__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Render Metrics for 3D Pipeline Profile :: SLM Bytes Read */
#define chv__render_pipe_profile__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics for 3D Pipeline Profile :: SLM Bytes Written */
#define chv__render_pipe_profile__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Render Metrics for 3D Pipeline Profile :: SLM Bytes Written */
#define chv__render_pipe_profile__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics for 3D Pipeline Profile :: Shader Memory Accesses */
#define chv__render_pipe_profile__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Render Metrics for 3D Pipeline Profile :: Shader Atomic Memory Accesses */
#define chv__render_pipe_profile__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Render Metrics for 3D Pipeline Profile :: L3 Shader Throughput */
#define chv__render_pipe_profile__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Render Metrics for 3D Pipeline Profile :: L3 Shader Throughput */
#define chv__render_pipe_profile__l3_shader_throughput__max \
    chv__render_basic__l3_shader_throughput__max

/* Render Metrics for 3D Pipeline Profile :: Shader Barrier Messages */
#define chv__render_pipe_profile__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Render Metrics for 3D Pipeline Profile :: VF Bottleneck */
#define chv__render_pipe_profile__vf_bottleneck__read \
    bdw__render_pipe_profile__vf_bottleneck__read

/* Render Metrics for 3D Pipeline Profile :: VS Bottleneck */
#define chv__render_pipe_profile__vs_bottleneck__read \
    bdw__render_basic__sampler0_busy__read

/* Render Metrics for 3D Pipeline Profile :: HS Bottleneck */
#define chv__render_pipe_profile__hs_bottleneck__read \
    bdw__render_basic__sampler1_busy__read

/* Render Metrics for 3D Pipeline Profile :: DS Bottleneck */
#define chv__render_pipe_profile__ds_bottleneck__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Render Metrics for 3D Pipeline Profile :: GS Bottleneck */
#define chv__render_pipe_profile__gs_bottleneck__read \
    bdw__render_basic__sampler1_bottleneck__read

/* Render Metrics for 3D Pipeline Profile :: SO Bottleneck */
#define chv__render_pipe_profile__so_bottleneck__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* Render Metrics for 3D Pipeline Profile :: Clipper Bottleneck */
#define chv__render_pipe_profile__cl_bottleneck__read \
    bdw__render_pipe_profile__cl_bottleneck__read

/* Render Metrics for 3D Pipeline Profile :: Strip-Fans Bottleneck */
#define chv__render_pipe_profile__sf_bottleneck__read \
    bdw__render_pipe_profile__sf_bottleneck__read

/* Render Metrics for 3D Pipeline Profile :: Hi-Depth Bottleneck */
#define chv__render_pipe_profile__hi_depth_bottleneck__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Render Metrics for 3D Pipeline Profile :: Early Depth Bottleneck */
#define chv__render_pipe_profile__early_depth_bottleneck__read \
    bdw__render_pipe_profile__early_depth_bottleneck__read

/* Render Metrics for 3D Pipeline Profile :: BC Bottleneck */
#define chv__render_pipe_profile__bc_bottleneck__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Render Metrics for 3D Pipeline Profile :: HS Stall */
#define chv__render_pipe_profile__hs_stall__read \
    bdw__render_pipe_profile__hs_stall__read

/* Render Metrics for 3D Pipeline Profile :: DS Stall */
#define chv__render_pipe_profile__ds_stall__read \
    bdw__render_pipe_profile__ds_stall__read

/* Render Metrics for 3D Pipeline Profile :: SO Stall */
#define chv__render_pipe_profile__so_stall__read \
    bdw__render_pipe_profile__so_stall__read

/* Render Metrics for 3D Pipeline Profile :: CL Stall */
#define chv__render_pipe_profile__cl_stall__read \
    bdw__render_pipe_profile__cl_stall__read

/* Render Metrics for 3D Pipeline Profile :: SF Stall */
#define chv__render_pipe_profile__sf_stall__read \
    bdw__render_pipe_profile__sf_stall__read

/* Metric set HDCAndSF :: GPU Time Elapsed */
#define chv__hdc_and_sf__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set HDCAndSF :: GPU Core Clocks */
#define chv__hdc_and_sf__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set HDCAndSF :: AVG GPU Core Frequency */
#define chv__hdc_and_sf__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set HDCAndSF :: AVG GPU Core Frequency */
#define chv__hdc_and_sf__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set HDCAndSF :: GPU Busy */
#define chv__hdc_and_sf__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set HDCAndSF :: VS Threads Dispatched */
#define chv__hdc_and_sf__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set HDCAndSF :: HS Threads Dispatched */
#define chv__hdc_and_sf__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set HDCAndSF :: DS Threads Dispatched */
#define chv__hdc_and_sf__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set HDCAndSF :: GS Threads Dispatched */
#define chv__hdc_and_sf__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set HDCAndSF :: FS Threads Dispatched */
#define chv__hdc_and_sf__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set HDCAndSF :: CS Threads Dispatched */
#define chv__hdc_and_sf__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set HDCAndSF :: EU Active */
#define chv__hdc_and_sf__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set HDCAndSF :: EU Stall */
#define chv__hdc_and_sf__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set HDCAndSF :: EU Both FPU Pipes Active */
#define chv__hdc_and_sf__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set HDCAndSF :: VS FPU0 Pipe Active */
#define chv__hdc_and_sf__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set HDCAndSF :: VS FPU1 Pipe Active */
#define chv__hdc_and_sf__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set HDCAndSF :: VS Send Pipe Active */
#define chv__hdc_and_sf__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set HDCAndSF :: PS FPU0 Pipe Active */
#define chv__hdc_and_sf__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set HDCAndSF :: PS FPU1 Pipe Active */
#define chv__hdc_and_sf__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set HDCAndSF :: PS Send Pipeline Active */
#define chv__hdc_and_sf__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set HDCAndSF :: FS Both FPU Active */
#define chv__hdc_and_sf__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set HDCAndSF :: Rasterized Pixels */
#define chv__hdc_and_sf__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set HDCAndSF :: Early Hi-Depth Test Fails */
#define chv__hdc_and_sf__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set HDCAndSF :: Early Depth Test Fails */
#define chv__hdc_and_sf__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set HDCAndSF :: Samples Killed in FS */
#define chv__hdc_and_sf__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set HDCAndSF :: Pixels Failing Tests */
#define chv__hdc_and_sf__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set HDCAndSF :: Samples Written */
#define chv__hdc_and_sf__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set HDCAndSF :: Samples Blended */
#define chv__hdc_and_sf__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set HDCAndSF :: Sampler Texels */
#define chv__hdc_and_sf__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set HDCAndSF :: Sampler Texels Misses */
#define chv__hdc_and_sf__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set HDCAndSF :: SLM Bytes Read */
#define chv__hdc_and_sf__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set HDCAndSF :: SLM Bytes Read */
#define chv__hdc_and_sf__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set HDCAndSF :: SLM Bytes Written */
#define chv__hdc_and_sf__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set HDCAndSF :: SLM Bytes Written */
#define chv__hdc_and_sf__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set HDCAndSF :: Shader Memory Accesses */
#define chv__hdc_and_sf__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set HDCAndSF :: Shader Atomic Memory Accesses */
#define chv__hdc_and_sf__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set HDCAndSF :: L3 Shader Throughput */
#define chv__hdc_and_sf__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set HDCAndSF :: L3 Shader Throughput */
#define chv__hdc_and_sf__l3_shader_throughput__max \
    bdw__hdc_and_sf__l3_shader_throughput__max

/* Metric set HDCAndSF :: Shader Barrier Messages */
#define chv__hdc_and_sf__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set HDCAndSF :: Polygon Data Ready */
#define chv__hdc_and_sf__poly_data_ready__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set HDCAndSF :: HDC stalled by L3 (s0.ss2) */
#define chv__hdc_and_sf__non_sampler_shader02_access_stalled_on_l3__read \
    bdw__hdc_and_sf__non_sampler_shader02_access_stalled_on_l3__read

/* Metric set HDCAndSF :: HDC stalled by L3 (s0.ss1) */
#define chv__hdc_and_sf__non_sampler_shader01_access_stalled_on_l3__read \
    bdw__hdc_and_sf__non_sampler_shader01_access_stalled_on_l3__read

/* Metric set HDCAndSF :: HDC stalled by L3 (s0.ss0) */
#define chv__hdc_and_sf__non_sampler_shader00_access_stalled_on_l3__read \
    bdw__hdc_and_sf__non_sampler_shader00_access_stalled_on_l3__read

/* Metric set HDCAndSF :: HDC stalled by L3 (s0.ss2) */
#define chv__hdc_and_sf__non_sampler_shader12_access_stalled_on_l3__read \
    bdw__hdc_and_sf__non_sampler_shader12_access_stalled_on_l3__read

/* Metric set HDCAndSF :: HDC stalled by L3 (s0.ss1) */
#define chv__hdc_and_sf__non_sampler_shader11_access_stalled_on_l3__read \
    bdw__hdc_and_sf__non_sampler_shader11_access_stalled_on_l3__read

/* Metric set HDCAndSF :: HDC stalled by L3 (s0.ss0) */
#define chv__hdc_and_sf__non_sampler_shader10_access_stalled_on_l3__read \
    bdw__hdc_and_sf__non_sampler_shader10_access_stalled_on_l3__read

/* Metric set HDCAndSF :: SQ is full */
#define chv__hdc_and_sf__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set L3_1 :: GPU Time Elapsed */
#define chv__l3_1__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set L3_1 :: GPU Core Clocks */
#define chv__l3_1__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set L3_1 :: AVG GPU Core Frequency */
#define chv__l3_1__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set L3_1 :: AVG GPU Core Frequency */
#define chv__l3_1__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set L3_1 :: GPU Busy */
#define chv__l3_1__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set L3_1 :: VS Threads Dispatched */
#define chv__l3_1__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set L3_1 :: HS Threads Dispatched */
#define chv__l3_1__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set L3_1 :: DS Threads Dispatched */
#define chv__l3_1__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set L3_1 :: GS Threads Dispatched */
#define chv__l3_1__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set L3_1 :: FS Threads Dispatched */
#define chv__l3_1__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set L3_1 :: CS Threads Dispatched */
#define chv__l3_1__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set L3_1 :: EU Active */
#define chv__l3_1__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set L3_1 :: EU Stall */
#define chv__l3_1__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set L3_1 :: EU Both FPU Pipes Active */
#define chv__l3_1__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set L3_1 :: VS FPU0 Pipe Active */
#define chv__l3_1__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set L3_1 :: VS FPU1 Pipe Active */
#define chv__l3_1__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set L3_1 :: VS Send Pipe Active */
#define chv__l3_1__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set L3_1 :: PS FPU0 Pipe Active */
#define chv__l3_1__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set L3_1 :: PS FPU1 Pipe Active */
#define chv__l3_1__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set L3_1 :: PS Send Pipeline Active */
#define chv__l3_1__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set L3_1 :: FS Both FPU Active */
#define chv__l3_1__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set L3_1 :: Rasterized Pixels */
#define chv__l3_1__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set L3_1 :: Early Hi-Depth Test Fails */
#define chv__l3_1__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set L3_1 :: Early Depth Test Fails */
#define chv__l3_1__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set L3_1 :: Samples Killed in FS */
#define chv__l3_1__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set L3_1 :: Pixels Failing Tests */
#define chv__l3_1__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set L3_1 :: Samples Written */
#define chv__l3_1__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set L3_1 :: Samples Blended */
#define chv__l3_1__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set L3_1 :: Sampler Texels */
#define chv__l3_1__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set L3_1 :: Sampler Texels Misses */
#define chv__l3_1__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set L3_1 :: SLM Bytes Read */
#define chv__l3_1__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set L3_1 :: SLM Bytes Read */
#define chv__l3_1__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_1 :: SLM Bytes Written */
#define chv__l3_1__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set L3_1 :: SLM Bytes Written */
#define chv__l3_1__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_1 :: Shader Memory Accesses */
#define chv__l3_1__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set L3_1 :: Shader Atomic Memory Accesses */
#define chv__l3_1__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set L3_1 :: L3 Shader Throughput */
#define chv__l3_1__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set L3_1 :: L3 Shader Throughput */
#define chv__l3_1__l3_shader_throughput__max \
    bdw__hdc_and_sf__l3_shader_throughput__max

/* Metric set L3_1 :: Shader Barrier Messages */
#define chv__l3_1__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set L3_1 :: Slice1 L3 Bank0 Stalled */
#define chv__l3_1__l31_bank0_stalled__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set L3_1 :: Slice1 L3 Bank1 Stalled */
#define chv__l3_1__l31_bank1_stalled__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* Metric set L3_1 :: Slice1 L3 Bank1 Active */
#define chv__l3_1__l31_bank1_active__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set L3_1 :: Slice1 L3 Bank0 Active */
#define chv__l3_1__l31_bank0_active__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set L3_1 :: SQ is full */
#define chv__l3_1__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set L3_2 :: GPU Time Elapsed */
#define chv__l3_2__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set L3_2 :: GPU Core Clocks */
#define chv__l3_2__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set L3_2 :: AVG GPU Core Frequency */
#define chv__l3_2__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set L3_2 :: AVG GPU Core Frequency */
#define chv__l3_2__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set L3_2 :: GPU Busy */
#define chv__l3_2__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set L3_2 :: VS Threads Dispatched */
#define chv__l3_2__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set L3_2 :: HS Threads Dispatched */
#define chv__l3_2__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set L3_2 :: DS Threads Dispatched */
#define chv__l3_2__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set L3_2 :: GS Threads Dispatched */
#define chv__l3_2__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set L3_2 :: FS Threads Dispatched */
#define chv__l3_2__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set L3_2 :: CS Threads Dispatched */
#define chv__l3_2__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set L3_2 :: EU Active */
#define chv__l3_2__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set L3_2 :: EU Stall */
#define chv__l3_2__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set L3_2 :: EU Both FPU Pipes Active */
#define chv__l3_2__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set L3_2 :: VS FPU0 Pipe Active */
#define chv__l3_2__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set L3_2 :: VS FPU1 Pipe Active */
#define chv__l3_2__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set L3_2 :: VS Send Pipe Active */
#define chv__l3_2__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set L3_2 :: PS FPU0 Pipe Active */
#define chv__l3_2__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set L3_2 :: PS FPU1 Pipe Active */
#define chv__l3_2__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set L3_2 :: PS Send Pipeline Active */
#define chv__l3_2__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set L3_2 :: FS Both FPU Active */
#define chv__l3_2__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set L3_2 :: Rasterized Pixels */
#define chv__l3_2__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set L3_2 :: Early Hi-Depth Test Fails */
#define chv__l3_2__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set L3_2 :: Early Depth Test Fails */
#define chv__l3_2__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set L3_2 :: Samples Killed in FS */
#define chv__l3_2__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set L3_2 :: Pixels Failing Tests */
#define chv__l3_2__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set L3_2 :: Samples Written */
#define chv__l3_2__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set L3_2 :: Samples Blended */
#define chv__l3_2__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set L3_2 :: Sampler Texels */
#define chv__l3_2__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set L3_2 :: Sampler Texels Misses */
#define chv__l3_2__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set L3_2 :: SLM Bytes Read */
#define chv__l3_2__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set L3_2 :: SLM Bytes Read */
#define chv__l3_2__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_2 :: SLM Bytes Written */
#define chv__l3_2__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set L3_2 :: SLM Bytes Written */
#define chv__l3_2__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_2 :: Shader Memory Accesses */
#define chv__l3_2__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set L3_2 :: Shader Atomic Memory Accesses */
#define chv__l3_2__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set L3_2 :: L3 Shader Throughput */
#define chv__l3_2__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set L3_2 :: L3 Shader Throughput */
#define chv__l3_2__l3_shader_throughput__max \
    bdw__hdc_and_sf__l3_shader_throughput__max

/* Metric set L3_2 :: Shader Barrier Messages */
#define chv__l3_2__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set L3_2 :: Slice0 L3 Bank0 Stalled */
#define chv__l3_2__l30_bank0_stalled__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set L3_2 :: Slice0 L3 Bank1 Stalled */
#define chv__l3_2__l30_bank1_stalled__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* Metric set L3_2 :: Slice0 L3 Bank1 Active */
#define chv__l3_2__l30_bank1_active__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set L3_2 :: Slice0 L3 Bank0 Active */
#define chv__l3_2__l30_bank0_active__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set L3_2 :: SQ is full */
#define chv__l3_2__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set L3_3 :: GPU Time Elapsed */
#define chv__l3_3__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set L3_3 :: GPU Core Clocks */
#define chv__l3_3__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set L3_3 :: AVG GPU Core Frequency */
#define chv__l3_3__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set L3_3 :: AVG GPU Core Frequency */
#define chv__l3_3__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set L3_3 :: GPU Busy */
#define chv__l3_3__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set L3_3 :: VS Threads Dispatched */
#define chv__l3_3__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set L3_3 :: HS Threads Dispatched */
#define chv__l3_3__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set L3_3 :: DS Threads Dispatched */
#define chv__l3_3__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set L3_3 :: GS Threads Dispatched */
#define chv__l3_3__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set L3_3 :: FS Threads Dispatched */
#define chv__l3_3__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set L3_3 :: CS Threads Dispatched */
#define chv__l3_3__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set L3_3 :: EU Active */
#define chv__l3_3__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set L3_3 :: EU Stall */
#define chv__l3_3__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set L3_3 :: EU Both FPU Pipes Active */
#define chv__l3_3__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set L3_3 :: VS FPU0 Pipe Active */
#define chv__l3_3__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set L3_3 :: VS FPU1 Pipe Active */
#define chv__l3_3__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set L3_3 :: VS Send Pipe Active */
#define chv__l3_3__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set L3_3 :: PS FPU0 Pipe Active */
#define chv__l3_3__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set L3_3 :: PS FPU1 Pipe Active */
#define chv__l3_3__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set L3_3 :: PS Send Pipeline Active */
#define chv__l3_3__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set L3_3 :: FS Both FPU Active */
#define chv__l3_3__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set L3_3 :: Rasterized Pixels */
#define chv__l3_3__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set L3_3 :: Early Hi-Depth Test Fails */
#define chv__l3_3__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set L3_3 :: Early Depth Test Fails */
#define chv__l3_3__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set L3_3 :: Samples Killed in FS */
#define chv__l3_3__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set L3_3 :: Pixels Failing Tests */
#define chv__l3_3__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set L3_3 :: Samples Written */
#define chv__l3_3__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set L3_3 :: Samples Blended */
#define chv__l3_3__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set L3_3 :: Sampler Texels */
#define chv__l3_3__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set L3_3 :: Sampler Texels Misses */
#define chv__l3_3__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set L3_3 :: SLM Bytes Read */
#define chv__l3_3__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set L3_3 :: SLM Bytes Read */
#define chv__l3_3__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_3 :: SLM Bytes Written */
#define chv__l3_3__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set L3_3 :: SLM Bytes Written */
#define chv__l3_3__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_3 :: Shader Memory Accesses */
#define chv__l3_3__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set L3_3 :: Shader Atomic Memory Accesses */
#define chv__l3_3__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set L3_3 :: L3 Shader Throughput */
#define chv__l3_3__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set L3_3 :: L3 Shader Throughput */
#define chv__l3_3__l3_shader_throughput__max \
    bdw__hdc_and_sf__l3_shader_throughput__max

/* Metric set L3_3 :: Shader Barrier Messages */
#define chv__l3_3__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set L3_3 :: Slice0 L3 Bank3 Stalled */
#define chv__l3_3__l30_bank3_stalled__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set L3_3 :: Slice1 L3 Bank3 Stalled */
#define chv__l3_3__l31_bank3_stalled__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* Metric set L3_3 :: Slice1 L3 Bank3 Active */
#define chv__l3_3__l31_bank3_active__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set L3_3 :: Slice0 L3 Bank3 Active */
#define chv__l3_3__l30_bank3_active__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set L3_3 :: SQ is full */
#define chv__l3_3__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set L3_4 :: GPU Time Elapsed */
#define chv__l3_4__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set L3_4 :: GPU Core Clocks */
#define chv__l3_4__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set L3_4 :: AVG GPU Core Frequency */
#define chv__l3_4__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set L3_4 :: AVG GPU Core Frequency */
#define chv__l3_4__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set L3_4 :: GPU Busy */
#define chv__l3_4__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set L3_4 :: VS Threads Dispatched */
#define chv__l3_4__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set L3_4 :: HS Threads Dispatched */
#define chv__l3_4__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set L3_4 :: DS Threads Dispatched */
#define chv__l3_4__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set L3_4 :: GS Threads Dispatched */
#define chv__l3_4__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set L3_4 :: FS Threads Dispatched */
#define chv__l3_4__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set L3_4 :: CS Threads Dispatched */
#define chv__l3_4__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set L3_4 :: EU Active */
#define chv__l3_4__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set L3_4 :: EU Stall */
#define chv__l3_4__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set L3_4 :: EU Both FPU Pipes Active */
#define chv__l3_4__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set L3_4 :: VS FPU0 Pipe Active */
#define chv__l3_4__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set L3_4 :: VS FPU1 Pipe Active */
#define chv__l3_4__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set L3_4 :: VS Send Pipe Active */
#define chv__l3_4__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set L3_4 :: PS FPU0 Pipe Active */
#define chv__l3_4__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set L3_4 :: PS FPU1 Pipe Active */
#define chv__l3_4__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set L3_4 :: PS Send Pipeline Active */
#define chv__l3_4__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set L3_4 :: FS Both FPU Active */
#define chv__l3_4__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set L3_4 :: Rasterized Pixels */
#define chv__l3_4__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set L3_4 :: Early Hi-Depth Test Fails */
#define chv__l3_4__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set L3_4 :: Early Depth Test Fails */
#define chv__l3_4__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set L3_4 :: Samples Killed in FS */
#define chv__l3_4__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set L3_4 :: Pixels Failing Tests */
#define chv__l3_4__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set L3_4 :: Samples Written */
#define chv__l3_4__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set L3_4 :: Samples Blended */
#define chv__l3_4__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set L3_4 :: Sampler Texels */
#define chv__l3_4__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set L3_4 :: Sampler Texels Misses */
#define chv__l3_4__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set L3_4 :: SLM Bytes Read */
#define chv__l3_4__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set L3_4 :: SLM Bytes Read */
#define chv__l3_4__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_4 :: SLM Bytes Written */
#define chv__l3_4__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set L3_4 :: SLM Bytes Written */
#define chv__l3_4__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_4 :: Shader Memory Accesses */
#define chv__l3_4__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set L3_4 :: Shader Atomic Memory Accesses */
#define chv__l3_4__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set L3_4 :: L3 Shader Throughput */
#define chv__l3_4__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set L3_4 :: L3 Shader Throughput */
#define chv__l3_4__l3_shader_throughput__max \
    bdw__hdc_and_sf__l3_shader_throughput__max

/* Metric set L3_4 :: Shader Barrier Messages */
#define chv__l3_4__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set L3_4 :: Slice0 L3 Bank2 Stalled */
#define chv__l3_4__l30_bank2_stalled__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set L3_4 :: Slice1 L3 Bank2 Stalled */
#define chv__l3_4__l31_bank2_stalled__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* Metric set L3_4 :: Slice1 L3 Bank2 Active */
#define chv__l3_4__l31_bank2_active__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set L3_4 :: Slice0 L3 Bank2 Active */
#define chv__l3_4__l30_bank2_active__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set L3_4 :: SQ is full */
#define chv__l3_4__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set RasterizerAndPixelBackend :: GPU Time Elapsed */
#define chv__rasterizer_and_pixel_backend__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set RasterizerAndPixelBackend :: GPU Core Clocks */
#define chv__rasterizer_and_pixel_backend__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set RasterizerAndPixelBackend :: AVG GPU Core Frequency */
#define chv__rasterizer_and_pixel_backend__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set RasterizerAndPixelBackend :: AVG GPU Core Frequency */
#define chv__rasterizer_and_pixel_backend__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set RasterizerAndPixelBackend :: GPU Busy */
#define chv__rasterizer_and_pixel_backend__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set RasterizerAndPixelBackend :: VS Threads Dispatched */
#define chv__rasterizer_and_pixel_backend__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set RasterizerAndPixelBackend :: HS Threads Dispatched */
#define chv__rasterizer_and_pixel_backend__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set RasterizerAndPixelBackend :: DS Threads Dispatched */
#define chv__rasterizer_and_pixel_backend__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set RasterizerAndPixelBackend :: GS Threads Dispatched */
#define chv__rasterizer_and_pixel_backend__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set RasterizerAndPixelBackend :: FS Threads Dispatched */
#define chv__rasterizer_and_pixel_backend__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set RasterizerAndPixelBackend :: CS Threads Dispatched */
#define chv__rasterizer_and_pixel_backend__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set RasterizerAndPixelBackend :: EU Active */
#define chv__rasterizer_and_pixel_backend__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set RasterizerAndPixelBackend :: EU Stall */
#define chv__rasterizer_and_pixel_backend__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set RasterizerAndPixelBackend :: EU Both FPU Pipes Active */
#define chv__rasterizer_and_pixel_backend__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set RasterizerAndPixelBackend :: VS FPU0 Pipe Active */
#define chv__rasterizer_and_pixel_backend__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set RasterizerAndPixelBackend :: VS FPU1 Pipe Active */
#define chv__rasterizer_and_pixel_backend__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set RasterizerAndPixelBackend :: VS Send Pipe Active */
#define chv__rasterizer_and_pixel_backend__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set RasterizerAndPixelBackend :: PS FPU0 Pipe Active */
#define chv__rasterizer_and_pixel_backend__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set RasterizerAndPixelBackend :: PS FPU1 Pipe Active */
#define chv__rasterizer_and_pixel_backend__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set RasterizerAndPixelBackend :: PS Send Pipeline Active */
#define chv__rasterizer_and_pixel_backend__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set RasterizerAndPixelBackend :: FS Both FPU Active */
#define chv__rasterizer_and_pixel_backend__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set RasterizerAndPixelBackend :: Rasterized Pixels */
#define chv__rasterizer_and_pixel_backend__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set RasterizerAndPixelBackend :: Early Hi-Depth Test Fails */
#define chv__rasterizer_and_pixel_backend__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set RasterizerAndPixelBackend :: Early Depth Test Fails */
#define chv__rasterizer_and_pixel_backend__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set RasterizerAndPixelBackend :: Samples Killed in FS */
#define chv__rasterizer_and_pixel_backend__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set RasterizerAndPixelBackend :: Pixels Failing Tests */
#define chv__rasterizer_and_pixel_backend__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set RasterizerAndPixelBackend :: Samples Written */
#define chv__rasterizer_and_pixel_backend__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set RasterizerAndPixelBackend :: Samples Blended */
#define chv__rasterizer_and_pixel_backend__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set RasterizerAndPixelBackend :: Sampler Texels */
#define chv__rasterizer_and_pixel_backend__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set RasterizerAndPixelBackend :: Sampler Texels Misses */
#define chv__rasterizer_and_pixel_backend__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Read */
#define chv__rasterizer_and_pixel_backend__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Read */
#define chv__rasterizer_and_pixel_backend__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Written */
#define chv__rasterizer_and_pixel_backend__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Written */
#define chv__rasterizer_and_pixel_backend__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set RasterizerAndPixelBackend :: Shader Memory Accesses */
#define chv__rasterizer_and_pixel_backend__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set RasterizerAndPixelBackend :: Shader Atomic Memory Accesses */
#define chv__rasterizer_and_pixel_backend__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set RasterizerAndPixelBackend :: L3 Shader Throughput */
#define chv__rasterizer_and_pixel_backend__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set RasterizerAndPixelBackend :: L3 Shader Throughput */
#define chv__rasterizer_and_pixel_backend__l3_shader_throughput__max \
    bdw__hdc_and_sf__l3_shader_throughput__max

/* Metric set RasterizerAndPixelBackend :: Shader Barrier Messages */
#define chv__rasterizer_and_pixel_backend__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Rasterizer Output Ready */
#define chv__rasterizer_and_pixel_backend__rasterizer0_output_ready__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set RasterizerAndPixelBackend :: Slice1 Post-EarlyZ Pixel Data Ready */
#define chv__rasterizer_and_pixel_backend__pixel_data1_ready__read \
    bdw__render_basic__sampler1_busy__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Post-EarlyZ Pixel Data Ready */
#define chv__rasterizer_and_pixel_backend__pixel_data0_ready__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Metric set RasterizerAndPixelBackend :: Slice1 Rasterizer Input Available */
#define chv__rasterizer_and_pixel_backend__rasterizer1_input_available__read \
    bdw__render_basic__sampler1_bottleneck__read

/* Metric set RasterizerAndPixelBackend :: Slice1 Rasterizer Output Ready */
#define chv__rasterizer_and_pixel_backend__rasterizer1_output_ready__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Rasterizer Input Available */
#define chv__rasterizer_and_pixel_backend__rasterizer0_input_available__read \
    bdw__render_pipe_profile__cl_bottleneck__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Pixel Values Ready */
#define chv__rasterizer_and_pixel_backend__pixel_values0_ready__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set RasterizerAndPixelBackend :: Slice0 PS Output Available */
#define chv__rasterizer_and_pixel_backend__ps_output0_available__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set RasterizerAndPixelBackend :: Slice1 Pixel Values Ready */
#define chv__rasterizer_and_pixel_backend__pixel_values1_ready__read \
    bdw__render_pipe_profile__sf_stall__read

/* Metric set RasterizerAndPixelBackend :: Slice1 PS Output Available */
#define chv__rasterizer_and_pixel_backend__ps_output1_available__read \
    bdw__render_pipe_profile__cl_stall__read

/* Metric set RasterizerAndPixelBackend :: SQ is full */
#define chv__rasterizer_and_pixel_backend__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set Sampler_1 :: GPU Time Elapsed */
#define chv__sampler_1__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set Sampler_1 :: GPU Core Clocks */
#define chv__sampler_1__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set Sampler_1 :: AVG GPU Core Frequency */
#define chv__sampler_1__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set Sampler_1 :: AVG GPU Core Frequency */
#define chv__sampler_1__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set Sampler_1 :: GPU Busy */
#define chv__sampler_1__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set Sampler_1 :: VS Threads Dispatched */
#define chv__sampler_1__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set Sampler_1 :: HS Threads Dispatched */
#define chv__sampler_1__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set Sampler_1 :: DS Threads Dispatched */
#define chv__sampler_1__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set Sampler_1 :: GS Threads Dispatched */
#define chv__sampler_1__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set Sampler_1 :: FS Threads Dispatched */
#define chv__sampler_1__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set Sampler_1 :: CS Threads Dispatched */
#define chv__sampler_1__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set Sampler_1 :: EU Active */
#define chv__sampler_1__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set Sampler_1 :: EU Stall */
#define chv__sampler_1__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set Sampler_1 :: EU Both FPU Pipes Active */
#define chv__sampler_1__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set Sampler_1 :: VS FPU0 Pipe Active */
#define chv__sampler_1__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set Sampler_1 :: VS FPU1 Pipe Active */
#define chv__sampler_1__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set Sampler_1 :: VS Send Pipe Active */
#define chv__sampler_1__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set Sampler_1 :: PS FPU0 Pipe Active */
#define chv__sampler_1__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set Sampler_1 :: PS FPU1 Pipe Active */
#define chv__sampler_1__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set Sampler_1 :: PS Send Pipeline Active */
#define chv__sampler_1__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set Sampler_1 :: FS Both FPU Active */
#define chv__sampler_1__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set Sampler_1 :: Rasterized Pixels */
#define chv__sampler_1__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set Sampler_1 :: Early Hi-Depth Test Fails */
#define chv__sampler_1__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set Sampler_1 :: Early Depth Test Fails */
#define chv__sampler_1__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set Sampler_1 :: Samples Killed in FS */
#define chv__sampler_1__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set Sampler_1 :: Pixels Failing Tests */
#define chv__sampler_1__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set Sampler_1 :: Samples Written */
#define chv__sampler_1__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set Sampler_1 :: Samples Blended */
#define chv__sampler_1__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set Sampler_1 :: Sampler Texels */
#define chv__sampler_1__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set Sampler_1 :: Sampler Texels Misses */
#define chv__sampler_1__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set Sampler_1 :: SLM Bytes Read */
#define chv__sampler_1__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set Sampler_1 :: SLM Bytes Read */
#define chv__sampler_1__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set Sampler_1 :: SLM Bytes Written */
#define chv__sampler_1__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set Sampler_1 :: SLM Bytes Written */
#define chv__sampler_1__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set Sampler_1 :: Shader Memory Accesses */
#define chv__sampler_1__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set Sampler_1 :: Shader Atomic Memory Accesses */
#define chv__sampler_1__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set Sampler_1 :: L3 Shader Throughput */
#define chv__sampler_1__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set Sampler_1 :: L3 Shader Throughput */
#define chv__sampler_1__l3_shader_throughput__max \
    bdw__hdc_and_sf__l3_shader_throughput__max

/* Metric set Sampler_1 :: Shader Barrier Messages */
#define chv__sampler_1__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set Sampler_1 :: Slice1 Subslice1 Input Available */
#define chv__sampler_1__sampler11_input_available__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set Sampler_1 :: Slice1 Subslice2 Input Available */
#define chv__sampler_1__sampler12_input_available__read \
    bdw__render_basic__sampler1_busy__read

/* Metric set Sampler_1 :: Slice1 Subslice0 Input Available */
#define chv__sampler_1__sampler10_input_available__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Metric set Sampler_1 :: Slice1 Subslice2 Sampler Output Ready */
#define chv__sampler_1__sampler12_output_ready__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set Sampler_1 :: Slice1 Subslice0 Sampler Output Ready */
#define chv__sampler_1__sampler10_output_ready__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set Sampler_1 :: Slice1 Subslice1 Sampler Output Ready */
#define chv__sampler_1__sampler11_output_ready__read \
    bdw__render_pipe_profile__sf_stall__read

/* Metric set Sampler_1 :: SQ is full */
#define chv__sampler_1__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set Sampler_2 :: GPU Time Elapsed */
#define chv__sampler_2__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set Sampler_2 :: GPU Core Clocks */
#define chv__sampler_2__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set Sampler_2 :: AVG GPU Core Frequency */
#define chv__sampler_2__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set Sampler_2 :: AVG GPU Core Frequency */
#define chv__sampler_2__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set Sampler_2 :: GPU Busy */
#define chv__sampler_2__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set Sampler_2 :: VS Threads Dispatched */
#define chv__sampler_2__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set Sampler_2 :: HS Threads Dispatched */
#define chv__sampler_2__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set Sampler_2 :: DS Threads Dispatched */
#define chv__sampler_2__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set Sampler_2 :: GS Threads Dispatched */
#define chv__sampler_2__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set Sampler_2 :: FS Threads Dispatched */
#define chv__sampler_2__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set Sampler_2 :: CS Threads Dispatched */
#define chv__sampler_2__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set Sampler_2 :: EU Active */
#define chv__sampler_2__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set Sampler_2 :: EU Stall */
#define chv__sampler_2__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set Sampler_2 :: EU Both FPU Pipes Active */
#define chv__sampler_2__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set Sampler_2 :: VS FPU0 Pipe Active */
#define chv__sampler_2__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set Sampler_2 :: VS FPU1 Pipe Active */
#define chv__sampler_2__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set Sampler_2 :: VS Send Pipe Active */
#define chv__sampler_2__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set Sampler_2 :: PS FPU0 Pipe Active */
#define chv__sampler_2__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set Sampler_2 :: PS FPU1 Pipe Active */
#define chv__sampler_2__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set Sampler_2 :: PS Send Pipeline Active */
#define chv__sampler_2__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set Sampler_2 :: FS Both FPU Active */
#define chv__sampler_2__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set Sampler_2 :: Rasterized Pixels */
#define chv__sampler_2__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set Sampler_2 :: Early Hi-Depth Test Fails */
#define chv__sampler_2__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set Sampler_2 :: Early Depth Test Fails */
#define chv__sampler_2__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set Sampler_2 :: Samples Killed in FS */
#define chv__sampler_2__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set Sampler_2 :: Pixels Failing Tests */
#define chv__sampler_2__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set Sampler_2 :: Samples Written */
#define chv__sampler_2__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set Sampler_2 :: Samples Blended */
#define chv__sampler_2__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set Sampler_2 :: Sampler Texels */
#define chv__sampler_2__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set Sampler_2 :: Sampler Texels Misses */
#define chv__sampler_2__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set Sampler_2 :: SLM Bytes Read */
#define chv__sampler_2__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set Sampler_2 :: SLM Bytes Read */
#define chv__sampler_2__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set Sampler_2 :: SLM Bytes Written */
#define chv__sampler_2__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set Sampler_2 :: SLM Bytes Written */
#define chv__sampler_2__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set Sampler_2 :: Shader Memory Accesses */
#define chv__sampler_2__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set Sampler_2 :: Shader Atomic Memory Accesses */
#define chv__sampler_2__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set Sampler_2 :: L3 Shader Throughput */
#define chv__sampler_2__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set Sampler_2 :: L3 Shader Throughput */
#define chv__sampler_2__l3_shader_throughput__max \
    bdw__hdc_and_sf__l3_shader_throughput__max

/* Metric set Sampler_2 :: Shader Barrier Messages */
#define chv__sampler_2__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set Sampler_2 :: Slice0 Subslice1 Input Available */
#define chv__sampler_2__sampler01_input_available__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set Sampler_2 :: Slice0 Subslice2 Input Available */
#define chv__sampler_2__sampler02_input_available__read \
    bdw__render_basic__sampler1_busy__read

/* Metric set Sampler_2 :: Slice0 Subslice0 Input Available */
#define chv__sampler_2__sampler00_input_available__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Metric set Sampler_2 :: Slice0 Subslice2 Sampler Output Ready */
#define chv__sampler_2__sampler02_output_ready__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set Sampler_2 :: Slice0 Subslice0 Sampler Output Ready */
#define chv__sampler_2__sampler00_output_ready__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set Sampler_2 :: Slice0 Subslice1 Sampler Output Ready */
#define chv__sampler_2__sampler01_output_ready__read \
    bdw__render_pipe_profile__sf_stall__read

/* Metric set Sampler_2 :: SQ is full */
#define chv__sampler_2__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set TDL_1 :: GPU Time Elapsed */
#define chv__tdl_1__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set TDL_1 :: GPU Core Clocks */
#define chv__tdl_1__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set TDL_1 :: AVG GPU Core Frequency */
#define chv__tdl_1__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set TDL_1 :: AVG GPU Core Frequency */
#define chv__tdl_1__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set TDL_1 :: GPU Busy */
#define chv__tdl_1__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set TDL_1 :: VS Threads Dispatched */
#define chv__tdl_1__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set TDL_1 :: HS Threads Dispatched */
#define chv__tdl_1__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set TDL_1 :: DS Threads Dispatched */
#define chv__tdl_1__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set TDL_1 :: GS Threads Dispatched */
#define chv__tdl_1__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set TDL_1 :: FS Threads Dispatched */
#define chv__tdl_1__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set TDL_1 :: CS Threads Dispatched */
#define chv__tdl_1__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set TDL_1 :: EU Active */
#define chv__tdl_1__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set TDL_1 :: EU Stall */
#define chv__tdl_1__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set TDL_1 :: EU Both FPU Pipes Active */
#define chv__tdl_1__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set TDL_1 :: VS FPU0 Pipe Active */
#define chv__tdl_1__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set TDL_1 :: VS FPU1 Pipe Active */
#define chv__tdl_1__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set TDL_1 :: VS Send Pipe Active */
#define chv__tdl_1__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set TDL_1 :: PS FPU0 Pipe Active */
#define chv__tdl_1__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set TDL_1 :: PS FPU1 Pipe Active */
#define chv__tdl_1__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set TDL_1 :: PS Send Pipeline Active */
#define chv__tdl_1__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set TDL_1 :: FS Both FPU Active */
#define chv__tdl_1__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set TDL_1 :: Rasterized Pixels */
#define chv__tdl_1__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set TDL_1 :: Early Hi-Depth Test Fails */
#define chv__tdl_1__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set TDL_1 :: Early Depth Test Fails */
#define chv__tdl_1__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set TDL_1 :: Samples Killed in FS */
#define chv__tdl_1__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set TDL_1 :: Pixels Failing Tests */
#define chv__tdl_1__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set TDL_1 :: Samples Written */
#define chv__tdl_1__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set TDL_1 :: Samples Blended */
#define chv__tdl_1__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set TDL_1 :: Sampler Texels */
#define chv__tdl_1__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set TDL_1 :: Sampler Texels Misses */
#define chv__tdl_1__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set TDL_1 :: SLM Bytes Read */
#define chv__tdl_1__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set TDL_1 :: SLM Bytes Read */
#define chv__tdl_1__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_1 :: SLM Bytes Written */
#define chv__tdl_1__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set TDL_1 :: SLM Bytes Written */
#define chv__tdl_1__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_1 :: Shader Memory Accesses */
#define chv__tdl_1__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set TDL_1 :: Shader Atomic Memory Accesses */
#define chv__tdl_1__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set TDL_1 :: L3 Shader Throughput */
#define chv__tdl_1__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set TDL_1 :: L3 Shader Throughput */
#define chv__tdl_1__l3_shader_throughput__max \
    bdw__hdc_and_sf__l3_shader_throughput__max

/* Metric set TDL_1 :: Shader Barrier Messages */
#define chv__tdl_1__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set TDL_1 :: NonPS Thread Ready For Dispatch on Slice1 Subslice1 */
#define chv__tdl_1__non_ps_thread11_ready_for_dispatch__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set TDL_1 :: PS Thread Ready For Dispatch on Slice1 Subslice0 */
#define chv__tdl_1__ps_thread10_ready_for_dispatch__read \
    bdw__render_basic__sampler1_busy__read

/* Metric set TDL_1 :: NonPS Thread Ready For Dispatch on Slice1 Subslice0 */
#define chv__tdl_1__non_ps_thread10_ready_for_dispatch__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Metric set TDL_1 :: PS Thread Ready For Dispatch on Slice1 Subslice2 */
#define chv__tdl_1__ps_thread12_ready_for_dispatch__read \
    bdw__render_basic__sampler1_bottleneck__read

/* Metric set TDL_1 :: NonPS Thread Ready For Dispatch on Slice1 Subslice2 */
#define chv__tdl_1__non_ps_thread12_ready_for_dispatch__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* Metric set TDL_1 :: PS Thread Ready For Dispatch on Slice1 Subslice1 */
#define chv__tdl_1__ps_thread11_ready_for_dispatch__read \
    bdw__render_pipe_profile__cl_bottleneck__read

/* Metric set TDL_1 :: Thread Header Ready on Slice0 Subslice1 Port 0 */
#define chv__tdl_1__thread_header01_ready_port0__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set TDL_1 :: Thread Header Ready on Slice0 Subslice0 Port 1 */
#define chv__tdl_1__thread_header00_ready_port1__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set TDL_1 :: Thread Header Ready on Slice0 Subslice0 Port 0 */
#define chv__tdl_1__thread_header00_ready_port0__read \
    bdw__render_pipe_profile__sf_stall__read

/* Metric set TDL_1 :: Thread Header Ready on Slice0 Subslice2 Port 1 */
#define chv__tdl_1__thread_header02_ready_port1__read \
    bdw__render_pipe_profile__cl_stall__read

/* Metric set TDL_1 :: Thread Header Ready on Slice0 Subslice2 Port 0 */
#define chv__tdl_1__thread_header02_ready_port0__read \
    bdw__render_pipe_profile__so_stall__read

/* Metric set TDL_1 :: Thread Header Ready on Slice0 Subslice1 Port 1 */
#define chv__tdl_1__thread_header01_ready_port1__read \
    bdw__render_pipe_profile__ds_stall__read

/* Metric set TDL_1 :: SQ is full */
#define chv__tdl_1__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set TDL_2 :: GPU Time Elapsed */
#define chv__tdl_2__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set TDL_2 :: GPU Core Clocks */
#define chv__tdl_2__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set TDL_2 :: AVG GPU Core Frequency */
#define chv__tdl_2__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set TDL_2 :: AVG GPU Core Frequency */
#define chv__tdl_2__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set TDL_2 :: GPU Busy */
#define chv__tdl_2__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set TDL_2 :: VS Threads Dispatched */
#define chv__tdl_2__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set TDL_2 :: HS Threads Dispatched */
#define chv__tdl_2__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set TDL_2 :: DS Threads Dispatched */
#define chv__tdl_2__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set TDL_2 :: GS Threads Dispatched */
#define chv__tdl_2__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set TDL_2 :: FS Threads Dispatched */
#define chv__tdl_2__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set TDL_2 :: CS Threads Dispatched */
#define chv__tdl_2__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set TDL_2 :: EU Active */
#define chv__tdl_2__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set TDL_2 :: EU Stall */
#define chv__tdl_2__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set TDL_2 :: EU Both FPU Pipes Active */
#define chv__tdl_2__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set TDL_2 :: VS FPU0 Pipe Active */
#define chv__tdl_2__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set TDL_2 :: VS FPU1 Pipe Active */
#define chv__tdl_2__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set TDL_2 :: VS Send Pipe Active */
#define chv__tdl_2__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set TDL_2 :: PS FPU0 Pipe Active */
#define chv__tdl_2__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set TDL_2 :: PS FPU1 Pipe Active */
#define chv__tdl_2__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set TDL_2 :: PS Send Pipeline Active */
#define chv__tdl_2__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set TDL_2 :: FS Both FPU Active */
#define chv__tdl_2__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set TDL_2 :: Rasterized Pixels */
#define chv__tdl_2__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set TDL_2 :: Early Hi-Depth Test Fails */
#define chv__tdl_2__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set TDL_2 :: Early Depth Test Fails */
#define chv__tdl_2__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set TDL_2 :: Samples Killed in FS */
#define chv__tdl_2__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set TDL_2 :: Pixels Failing Tests */
#define chv__tdl_2__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set TDL_2 :: Samples Written */
#define chv__tdl_2__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set TDL_2 :: Samples Blended */
#define chv__tdl_2__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set TDL_2 :: Sampler Texels */
#define chv__tdl_2__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set TDL_2 :: Sampler Texels Misses */
#define chv__tdl_2__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set TDL_2 :: SLM Bytes Read */
#define chv__tdl_2__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set TDL_2 :: SLM Bytes Read */
#define chv__tdl_2__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_2 :: SLM Bytes Written */
#define chv__tdl_2__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set TDL_2 :: SLM Bytes Written */
#define chv__tdl_2__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_2 :: Shader Memory Accesses */
#define chv__tdl_2__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set TDL_2 :: Shader Atomic Memory Accesses */
#define chv__tdl_2__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set TDL_2 :: L3 Shader Throughput */
#define chv__tdl_2__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set TDL_2 :: L3 Shader Throughput */
#define chv__tdl_2__l3_shader_throughput__max \
    bdw__hdc_and_sf__l3_shader_throughput__max

/* Metric set TDL_2 :: Shader Barrier Messages */
#define chv__tdl_2__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set TDL_2 :: NonPS Thread Ready For Dispatch on Slice0 Subslice2 */
#define chv__tdl_2__non_ps_thread02_ready_for_dispatch__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set TDL_2 :: PS Thread Ready For Dispatch on Slice0 Subslice2 */
#define chv__tdl_2__ps_thread02_ready_for_dispatch__read \
    bdw__render_basic__sampler1_busy__read

/* Metric set TDL_2 :: PS Thread Ready For Dispatch on Slice0 Subslice1 */
#define chv__tdl_2__ps_thread01_ready_for_dispatch__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Metric set TDL_2 :: PS Thread Ready For Dispatch on Slice0 Subslice0 */
#define chv__tdl_2__ps_thread00_ready_for_dispatch__read \
    bdw__render_basic__sampler1_bottleneck__read

/* Metric set TDL_2 :: NonPS Thread Ready For Dispatch on Slice0 Subslice1 */
#define chv__tdl_2__non_ps_thread01_ready_for_dispatch__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* Metric set TDL_2 :: NonPS Thread Ready For Dispatch on Slice0 Subslice0 */
#define chv__tdl_2__non_ps_thread00_ready_for_dispatch__read \
    bdw__render_pipe_profile__cl_bottleneck__read

/* Metric set TDL_2 :: Thread Header Ready on Slice1 Subslice2 Port 0 */
#define chv__tdl_2__thread_header12_ready_port0__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set TDL_2 :: Thread Header Ready on Slice1 Subslice2 Port 1 */
#define chv__tdl_2__thread_header12_ready_port1__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set TDL_2 :: Thread Header Ready on Slice1 Subslice1 Port 1 */
#define chv__tdl_2__thread_header11_ready_port1__read \
    bdw__render_pipe_profile__sf_stall__read

/* Metric set TDL_2 :: Thread Header Ready on Slice1 Subslice0 Port 0 */
#define chv__tdl_2__thread_header10_ready_port0__read \
    bdw__render_pipe_profile__cl_stall__read

/* Metric set TDL_2 :: Thread Header Ready on Slice1 Subslice0 Port 1 */
#define chv__tdl_2__thread_header10_ready_port1__read \
    bdw__render_pipe_profile__so_stall__read

/* Metric set TDL_2 :: Thread Header Ready on Slice1 Subslice1 Port 0 */
#define chv__tdl_2__thread_header11_ready_port0__read \
    bdw__render_pipe_profile__ds_stall__read

/* Metric set TDL_2 :: SQ is full */
#define chv__tdl_2__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* MDAPI testing set Gen8LP :: GPU Time Elapsed */
#define chv__test_oa__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* MDAPI testing set Gen8LP :: GPU Core Clocks */
#define chv__test_oa__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* MDAPI testing set Gen8LP :: AVG GPU Core Frequency */
#define chv__test_oa__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* MDAPI testing set Gen8LP :: AVG GPU Core Frequency */
#define chv__test_oa__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* MDAPI testing set Gen8LP :: TestCounter0 */
#define chv__test_oa__counter0__read \
    hsw__compute_extended__eu_untyped_reads0__read

/* MDAPI testing set Gen8LP :: TestCounter1 */
#define chv__test_oa__counter1__read \
    hsw__compute_extended__eu_untyped_writes0__read

/* MDAPI testing set Gen8LP :: TestCounter2 */
#define chv__test_oa__counter2__read \
    hsw__compute_extended__eu_typed_reads0__read

/* MDAPI testing set Gen8LP :: TestCounter3 */
#define chv__test_oa__counter3__read \
    hsw__compute_extended__eu_typed_writes0__read

/* MDAPI testing set Gen8LP :: TestCounter4 */
#define chv__test_oa__counter4__read \
    hsw__compute_extended__eu_untyped_atomics0__read

/* MDAPI testing set Gen8LP :: TestCounter5 */
#define chv__test_oa__counter5__read \
    hsw__compute_extended__eu_typed_atomics0__read

/* MDAPI testing set Gen8LP :: TestCounter6 */
#define chv__test_oa__counter6__read \
    hsw__compute_extended__eu_urb_atomics0__read

/* MDAPI testing set Gen8LP :: TestCounter7 */
#define chv__test_oa__counter7__read \
    hsw__compute_extended__gpu_clocks__read

/* MDAPI testing set Gen8LP :: TestCounter8 */
#define chv__test_oa__counter8__read \
    hsw__memory_reads__gpu_core_clocks__read

/* Render Metrics Basic Gen9 :: GPU Time Elapsed */
#define sklgt2__render_basic__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Render Metrics Basic Gen9 :: GPU Core Clocks */
#define sklgt2__render_basic__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Render Metrics Basic Gen9 :: AVG GPU Core Frequency */
#define sklgt2__render_basic__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Render Metrics Basic Gen9 :: AVG GPU Core Frequency */
#define sklgt2__render_basic__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Render Metrics Basic Gen9 :: VS Threads Dispatched */
#define sklgt2__render_basic__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Render Metrics Basic Gen9 :: HS Threads Dispatched */
#define sklgt2__render_basic__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Render Metrics Basic Gen9 :: DS Threads Dispatched */
#define sklgt2__render_basic__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Render Metrics Basic Gen9 :: GS Threads Dispatched */
#define sklgt2__render_basic__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Render Metrics Basic Gen9 :: FS Threads Dispatched */
#define sklgt2__render_basic__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Render Metrics Basic Gen9 :: CS Threads Dispatched */
#define sklgt2__render_basic__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Render Metrics Basic Gen9 :: GPU Busy */
#define sklgt2__render_basic__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Render Metrics Basic Gen9 :: EU Active */
#define sklgt2__render_basic__eu_active__read \
    bdw__render_basic__eu_active__read

/* Render Metrics Basic Gen9 :: EU Stall */
#define sklgt2__render_basic__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Render Metrics Basic Gen9 :: EU Both FPU Pipes Active */
#define sklgt2__render_basic__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Render Metrics Basic Gen9 :: VS FPU0 Pipe Active */
#define sklgt2__render_basic__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Render Metrics Basic Gen9 :: VS FPU1 Pipe Active */
#define sklgt2__render_basic__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Render Metrics Basic Gen9 :: VS Send Pipe Active */
#define sklgt2__render_basic__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Render Metrics Basic Gen9 :: PS FPU0 Pipe Active */
#define sklgt2__render_basic__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Render Metrics Basic Gen9 :: PS FPU1 Pipe Active */
#define sklgt2__render_basic__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Render Metrics Basic Gen9 :: PS Send Pipeline Active */
#define sklgt2__render_basic__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Render Metrics Basic Gen9 :: FS Both FPU Active */
#define sklgt2__render_basic__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Render Metrics Basic Gen9 :: Sampler 0 Busy */
#define sklgt2__render_basic__sampler0_busy__read \
    bdw__render_basic__sampler0_busy__read

/* Render Metrics Basic Gen9 :: Sampler 1 Busy */
#define sklgt2__render_basic__sampler1_busy__read \
    bdw__render_basic__sampler1_busy__read

/* Render Metrics Basic Gen9 :: Samplers Busy */
#define sklgt2__render_basic__samplers_busy__read \
    bdw__render_basic__samplers_busy__read

/* Render Metrics Basic Gen9 :: Sampler 0 Bottleneck */
#define sklgt2__render_basic__sampler0_bottleneck__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Render Metrics Basic Gen9 :: Sampler 1 Bottleneck */
#define sklgt2__render_basic__sampler1_bottleneck__read \
    bdw__render_basic__sampler1_bottleneck__read

/* Render Metrics Basic Gen9 :: Rasterized Pixels */
#define sklgt2__render_basic__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Render Metrics Basic Gen9 :: Early Hi-Depth Test Fails */
#define sklgt2__render_basic__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Render Metrics Basic Gen9 :: Early Depth Test Fails */
#define sklgt2__render_basic__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Render Metrics Basic Gen9 :: Samples Killed in FS */
#define sklgt2__render_basic__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Render Metrics Basic Gen9 :: Pixels Failing Tests */
#define sklgt2__render_basic__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Render Metrics Basic Gen9 :: Samples Written */
#define sklgt2__render_basic__samples_written__read \
    bdw__render_basic__samples_written__read

/* Render Metrics Basic Gen9 :: Samples Blended */
#define sklgt2__render_basic__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Render Metrics Basic Gen9 :: Sampler Texels */
#define sklgt2__render_basic__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Render Metrics Basic Gen9 :: Sampler Texels Misses */
#define sklgt2__render_basic__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Render Metrics Basic Gen9 :: Sampler Cache Misses */
static uint64_t
sklgt2__render_basic__sampler_l1_misses__read(const struct intel_perf *perf,
                                              const struct intel_perf_metric_set *metric_set,
                                              uint64_t *accumulator)
{
    /* RPN equation: B 4 READ 8 UMUL */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 4];
    uint64_t tmp1 = tmp0 * 8;

    return tmp1;
}

/* Render Metrics Basic Gen9 :: SLM Bytes Read */
#define sklgt2__render_basic__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Render Metrics Basic Gen9 :: SLM Bytes Read */
#define sklgt2__render_basic__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics Basic Gen9 :: SLM Bytes Written */
#define sklgt2__render_basic__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Render Metrics Basic Gen9 :: SLM Bytes Written */
#define sklgt2__render_basic__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics Basic Gen9 :: Shader Memory Accesses */
#define sklgt2__render_basic__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Render Metrics Basic Gen9 :: Shader Atomic Memory Accesses */
#define sklgt2__render_basic__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Render Metrics Basic Gen9 :: L3 Lookup Accesses w/o IC */
static uint64_t
sklgt2__render_basic__l3_lookups__read(const struct intel_perf *perf,
                                       const struct intel_perf_metric_set *metric_set,
                                       uint64_t *accumulator)
{
    /* RPN equation: $SamplerL1Misses $ShaderMemoryAccesses UADD */
    uint64_t tmp0 = sklgt2__render_basic__sampler_l1_misses__read(perf, metric_set, accumulator) + sklgt2__render_basic__shader_memory_accesses__read(perf, metric_set, accumulator);

    return tmp0;
}

/* Render Metrics Basic Gen9 :: L3 Misses */
#define sklgt2__render_basic__l3_misses__read \
    hsw__compute_extended__typed_atomics0__read

/* Render Metrics Basic Gen9 :: L3 Sampler Throughput */
static uint64_t
sklgt2__render_basic__l3_sampler_throughput__read(const struct intel_perf *perf,
                                                  const struct intel_perf_metric_set *metric_set,
                                                  uint64_t *accumulator)
{
    /* RPN equation: $SamplerL1Misses 64 UMUL */
    uint64_t tmp0 = sklgt2__render_basic__sampler_l1_misses__read(perf, metric_set, accumulator) * 64;

    return tmp0;
}

/* Render Metrics Basic Gen9 :: L3 Sampler Throughput */
#define sklgt2__render_basic__l3_sampler_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics Basic Gen9 :: L3 Shader Throughput */
#define sklgt2__render_basic__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Render Metrics Basic Gen9 :: L3 Shader Throughput */
#define sklgt2__render_basic__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics Basic Gen9 :: Shader Barrier Messages */
#define sklgt2__render_basic__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Render Metrics Basic Gen9 :: GTI Fixed Pipe Throughput */
#define sklgt2__render_basic__gti_vf_throughput__read \
    bdw__render_basic__gti_vf_throughput__read

/* Render Metrics Basic Gen9 :: GTI Fixed Pipe Throughput */
#define sklgt2__render_basic__gti_vf_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Render Metrics Basic Gen9 :: GTI Depth Throughput */
#define sklgt2__render_basic__gti_depth_throughput__read \
    bdw__render_basic__gti_depth_throughput__read

/* Render Metrics Basic Gen9 :: GTI Depth Throughput */
#define sklgt2__render_basic__gti_depth_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics Basic Gen9 :: GTI RCC Throughput */
#define sklgt2__render_basic__gti_rcc_throughput__read \
    bdw__render_basic__gti_rcc_throughput__read

/* Render Metrics Basic Gen9 :: GTI RCC Throughput */
#define sklgt2__render_basic__gti_rcc_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics Basic Gen9 :: GTI L3 Throughput */
#define sklgt2__render_basic__gti_l3_throughput__read \
    hsw__render_basic__gti_l3_throughput__read

/* Render Metrics Basic Gen9 :: GTI L3 Throughput */
#define sklgt2__render_basic__gti_l3_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics Basic Gen9 :: GTI HDC TLB Lookup Throughput */
#define sklgt2__render_basic__gti_hdc_lookups_throughput__read \
    bdw__render_basic__gti_hdc_lookups_throughput__read

/* Render Metrics Basic Gen9 :: GTI HDC TLB Lookup Throughput */
#define sklgt2__render_basic__gti_hdc_lookups_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics Basic Gen9 :: GTI Read Throughput */
#define sklgt2__render_basic__gti_read_throughput__read \
    bdw__render_basic__gti_read_throughput__read

/* Render Metrics Basic Gen9 :: GTI Read Throughput */
#define sklgt2__render_basic__gti_read_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Render Metrics Basic Gen9 :: GTI Write Throughput */
#define sklgt2__render_basic__gti_write_throughput__read \
    hsw__render_basic__gti_write_throughput__read

/* Render Metrics Basic Gen9 :: GTI Write Throughput */
#define sklgt2__render_basic__gti_write_throughput__max \
    bdw__render_basic__gti_write_throughput__max

/* Render Metrics Basic Gen9 :: Samplers Bottleneck */
#define sklgt2__render_basic__sampler_bottleneck__read \
    bdw__render_basic__sampler_bottleneck__read

/* Compute Metrics Basic Gen9 :: GPU Time Elapsed */
#define sklgt2__compute_basic__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Compute Metrics Basic Gen9 :: GPU Core Clocks */
#define sklgt2__compute_basic__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Compute Metrics Basic Gen9 :: AVG GPU Core Frequency */
#define sklgt2__compute_basic__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Compute Metrics Basic Gen9 :: AVG GPU Core Frequency */
#define sklgt2__compute_basic__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Compute Metrics Basic Gen9 :: GPU Busy */
#define sklgt2__compute_basic__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Compute Metrics Basic Gen9 :: VS Threads Dispatched */
#define sklgt2__compute_basic__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Compute Metrics Basic Gen9 :: HS Threads Dispatched */
#define sklgt2__compute_basic__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Compute Metrics Basic Gen9 :: DS Threads Dispatched */
#define sklgt2__compute_basic__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Compute Metrics Basic Gen9 :: GS Threads Dispatched */
#define sklgt2__compute_basic__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Compute Metrics Basic Gen9 :: FS Threads Dispatched */
#define sklgt2__compute_basic__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Compute Metrics Basic Gen9 :: CS Threads Dispatched */
#define sklgt2__compute_basic__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Compute Metrics Basic Gen9 :: EU Active */
#define sklgt2__compute_basic__eu_active__read \
    bdw__render_basic__eu_active__read

/* Compute Metrics Basic Gen9 :: EU Stall */
#define sklgt2__compute_basic__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Compute Metrics Basic Gen9 :: EU Both FPU Pipes Active */
#define sklgt2__compute_basic__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Compute Metrics Basic Gen9 :: EU FPU0 Pipe Active */
#define sklgt2__compute_basic__fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Compute Metrics Basic Gen9 :: EU FPU1 Pipe Active */
#define sklgt2__compute_basic__fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Compute Metrics Basic Gen9 :: EU AVG IPC Rate */
#define sklgt2__compute_basic__eu_avg_ipc_rate__read \
    bdw__compute_basic__eu_avg_ipc_rate__read

/* Compute Metrics Basic Gen9 :: EU AVG IPC Rate */
#define sklgt2__compute_basic__eu_avg_ipc_rate__max \
    bdw__compute_basic__eu_avg_ipc_rate__max

/* Compute Metrics Basic Gen9 :: EU Send Pipe Active */
#define sklgt2__compute_basic__eu_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Compute Metrics Basic Gen9 :: EU Thread Occupancy */
#define sklgt2__compute_basic__eu_thread_occupancy__read \
    bdw__compute_basic__eu_thread_occupancy__read

/* Compute Metrics Basic Gen9 :: Rasterized Pixels */
#define sklgt2__compute_basic__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Compute Metrics Basic Gen9 :: Early Hi-Depth Test Fails */
#define sklgt2__compute_basic__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Compute Metrics Basic Gen9 :: Early Depth Test Fails */
#define sklgt2__compute_basic__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Compute Metrics Basic Gen9 :: Samples Killed in FS */
#define sklgt2__compute_basic__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Compute Metrics Basic Gen9 :: Pixels Failing Tests */
#define sklgt2__compute_basic__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Compute Metrics Basic Gen9 :: Samples Written */
#define sklgt2__compute_basic__samples_written__read \
    bdw__render_basic__samples_written__read

/* Compute Metrics Basic Gen9 :: Samples Blended */
#define sklgt2__compute_basic__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Compute Metrics Basic Gen9 :: Sampler Texels */
#define sklgt2__compute_basic__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Compute Metrics Basic Gen9 :: Sampler Texels Misses */
#define sklgt2__compute_basic__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Compute Metrics Basic Gen9 :: SLM Bytes Read */
#define sklgt2__compute_basic__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Compute Metrics Basic Gen9 :: SLM Bytes Read */
#define sklgt2__compute_basic__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Basic Gen9 :: SLM Bytes Written */
#define sklgt2__compute_basic__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Compute Metrics Basic Gen9 :: SLM Bytes Written */
#define sklgt2__compute_basic__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Basic Gen9 :: Shader Memory Accesses */
#define sklgt2__compute_basic__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Compute Metrics Basic Gen9 :: Shader Atomic Memory Accesses */
#define sklgt2__compute_basic__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Compute Metrics Basic Gen9 :: L3 Shader Throughput */
#define sklgt2__compute_basic__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Compute Metrics Basic Gen9 :: L3 Shader Throughput */
#define sklgt2__compute_basic__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Basic Gen9 :: Shader Barrier Messages */
#define sklgt2__compute_basic__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Compute Metrics Basic Gen9 :: Typed Bytes Read */
#define sklgt2__compute_basic__typed_bytes_read__read \
    bdw__compute_basic__typed_bytes_read__read

/* Compute Metrics Basic Gen9 :: Typed Bytes Read */
#define sklgt2__compute_basic__typed_bytes_read__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen9 :: Typed Bytes Written */
#define sklgt2__compute_basic__typed_bytes_written__read \
    bdw__compute_basic__typed_bytes_written__read

/* Compute Metrics Basic Gen9 :: Typed Bytes Written */
#define sklgt2__compute_basic__typed_bytes_written__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen9 :: Untyped Bytes Read */
#define sklgt2__compute_basic__untyped_bytes_read__read \
    bdw__compute_basic__untyped_bytes_read__read

/* Compute Metrics Basic Gen9 :: Untyped Bytes Read */
#define sklgt2__compute_basic__untyped_bytes_read__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen9 :: Untyped Writes */
#define sklgt2__compute_basic__untyped_bytes_written__read \
    bdw__compute_basic__untyped_bytes_written__read

/* Compute Metrics Basic Gen9 :: Untyped Writes */
#define sklgt2__compute_basic__untyped_bytes_written__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen9 :: GTI Read Throughput */
#define sklgt2__compute_basic__gti_read_throughput__read \
    hsw__render_basic__gti_l3_throughput__read

/* Compute Metrics Basic Gen9 :: GTI Read Throughput */
#define sklgt2__compute_basic__gti_read_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen9 :: GTI Write Throughput */
#define sklgt2__compute_basic__gti_write_throughput__read \
    bdw__render_basic__gti_hdc_lookups_throughput__read

/* Compute Metrics Basic Gen9 :: GTI Write Throughput */
#define sklgt2__compute_basic__gti_write_throughput__max \
    bdw__render_basic__gti_write_throughput__max

/* Render Metrics for 3D Pipeline Profile Gen9 :: GPU Time Elapsed */
#define sklgt2__render_pipe_profile__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: GPU Core Clocks */
#define sklgt2__render_pipe_profile__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: AVG GPU Core Frequency */
#define sklgt2__render_pipe_profile__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: AVG GPU Core Frequency */
#define sklgt2__render_pipe_profile__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Render Metrics for 3D Pipeline Profile Gen9 :: GPU Busy */
#define sklgt2__render_pipe_profile__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: VS Threads Dispatched */
#define sklgt2__render_pipe_profile__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: HS Threads Dispatched */
#define sklgt2__render_pipe_profile__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: DS Threads Dispatched */
#define sklgt2__render_pipe_profile__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: GS Threads Dispatched */
#define sklgt2__render_pipe_profile__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: FS Threads Dispatched */
#define sklgt2__render_pipe_profile__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: CS Threads Dispatched */
#define sklgt2__render_pipe_profile__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: EU Active */
#define sklgt2__render_pipe_profile__eu_active__read \
    bdw__render_basic__eu_active__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: EU Stall */
#define sklgt2__render_pipe_profile__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Rasterized Pixels */
#define sklgt2__render_pipe_profile__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Early Hi-Depth Test Fails */
#define sklgt2__render_pipe_profile__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Early Depth Test Fails */
#define sklgt2__render_pipe_profile__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Samples Killed in FS */
#define sklgt2__render_pipe_profile__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Pixels Failing Tests */
#define sklgt2__render_pipe_profile__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Samples Written */
#define sklgt2__render_pipe_profile__samples_written__read \
    bdw__render_basic__samples_written__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Samples Blended */
#define sklgt2__render_pipe_profile__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Sampler Texels */
#define sklgt2__render_pipe_profile__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Sampler Texels Misses */
#define sklgt2__render_pipe_profile__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: SLM Bytes Read */
#define sklgt2__render_pipe_profile__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: SLM Bytes Read */
#define sklgt2__render_pipe_profile__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics for 3D Pipeline Profile Gen9 :: SLM Bytes Written */
#define sklgt2__render_pipe_profile__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: SLM Bytes Written */
#define sklgt2__render_pipe_profile__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics for 3D Pipeline Profile Gen9 :: Shader Memory Accesses */
#define sklgt2__render_pipe_profile__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Shader Atomic Memory Accesses */
#define sklgt2__render_pipe_profile__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: L3 Shader Throughput */
#define sklgt2__render_pipe_profile__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: L3 Shader Throughput */
#define sklgt2__render_pipe_profile__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics for 3D Pipeline Profile Gen9 :: Shader Barrier Messages */
#define sklgt2__render_pipe_profile__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: VF Bottleneck */
#define sklgt2__render_pipe_profile__vf_bottleneck__read \
    bdw__render_pipe_profile__vf_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: VS Bottleneck */
#define sklgt2__render_pipe_profile__vs_bottleneck__read \
    bdw__render_basic__sampler0_busy__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: HS Bottleneck */
#define sklgt2__render_pipe_profile__hs_bottleneck__read \
    bdw__render_basic__sampler1_busy__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: DS Bottleneck */
#define sklgt2__render_pipe_profile__ds_bottleneck__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: GS Bottleneck */
#define sklgt2__render_pipe_profile__gs_bottleneck__read \
    bdw__render_basic__sampler1_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: SO Bottleneck */
#define sklgt2__render_pipe_profile__so_bottleneck__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Clipper Bottleneck */
#define sklgt2__render_pipe_profile__cl_bottleneck__read \
    bdw__render_pipe_profile__cl_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Strip-Fans Bottleneck */
#define sklgt2__render_pipe_profile__sf_bottleneck__read \
    bdw__render_pipe_profile__sf_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Hi-Depth Bottleneck */
#define sklgt2__render_pipe_profile__hi_depth_bottleneck__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Early Depth Bottleneck */
#define sklgt2__render_pipe_profile__early_depth_bottleneck__read \
    bdw__render_pipe_profile__early_depth_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: BC Bottleneck */
#define sklgt2__render_pipe_profile__bc_bottleneck__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: HS Stall */
#define sklgt2__render_pipe_profile__hs_stall__read \
    bdw__render_pipe_profile__hs_stall__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: DS Stall */
#define sklgt2__render_pipe_profile__ds_stall__read \
    bdw__render_pipe_profile__ds_stall__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: SO Stall */
#define sklgt2__render_pipe_profile__so_stall__read \
    bdw__render_pipe_profile__so_stall__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: CL Stall */
#define sklgt2__render_pipe_profile__cl_stall__read \
    bdw__render_pipe_profile__cl_stall__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: SF Stall */
#define sklgt2__render_pipe_profile__sf_stall__read \
    bdw__render_pipe_profile__sf_stall__read

/* Memory Reads Distribution Gen9 :: GPU Time Elapsed */
#define sklgt2__memory_reads__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Memory Reads Distribution Gen9 :: GPU Core Clocks */
#define sklgt2__memory_reads__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Memory Reads Distribution Gen9 :: AVG GPU Core Frequency */
#define sklgt2__memory_reads__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Memory Reads Distribution Gen9 :: AVG GPU Core Frequency */
#define sklgt2__memory_reads__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Memory Reads Distribution Gen9 :: GPU Busy */
#define sklgt2__memory_reads__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Memory Reads Distribution Gen9 :: VS Threads Dispatched */
#define sklgt2__memory_reads__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Memory Reads Distribution Gen9 :: HS Threads Dispatched */
#define sklgt2__memory_reads__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Memory Reads Distribution Gen9 :: DS Threads Dispatched */
#define sklgt2__memory_reads__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Memory Reads Distribution Gen9 :: GS Threads Dispatched */
#define sklgt2__memory_reads__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Memory Reads Distribution Gen9 :: FS Threads Dispatched */
#define sklgt2__memory_reads__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Memory Reads Distribution Gen9 :: CS Threads Dispatched */
#define sklgt2__memory_reads__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Memory Reads Distribution Gen9 :: EU Active */
#define sklgt2__memory_reads__eu_active__read \
    bdw__render_basic__eu_active__read

/* Memory Reads Distribution Gen9 :: EU Stall */
#define sklgt2__memory_reads__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Memory Reads Distribution Gen9 :: Rasterized Pixels */
#define sklgt2__memory_reads__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Memory Reads Distribution Gen9 :: Early Hi-Depth Test Fails */
#define sklgt2__memory_reads__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Memory Reads Distribution Gen9 :: Early Depth Test Fails */
#define sklgt2__memory_reads__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Memory Reads Distribution Gen9 :: Samples Killed in FS */
#define sklgt2__memory_reads__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Memory Reads Distribution Gen9 :: Pixels Failing Tests */
#define sklgt2__memory_reads__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Memory Reads Distribution Gen9 :: Samples Written */
#define sklgt2__memory_reads__samples_written__read \
    bdw__render_basic__samples_written__read

/* Memory Reads Distribution Gen9 :: Samples Blended */
#define sklgt2__memory_reads__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Memory Reads Distribution Gen9 :: Sampler Texels */
#define sklgt2__memory_reads__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Memory Reads Distribution Gen9 :: Sampler Texels Misses */
#define sklgt2__memory_reads__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Memory Reads Distribution Gen9 :: SLM Bytes Read */
#define sklgt2__memory_reads__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Memory Reads Distribution Gen9 :: SLM Bytes Read */
#define sklgt2__memory_reads__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Memory Reads Distribution Gen9 :: SLM Bytes Written */
#define sklgt2__memory_reads__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Memory Reads Distribution Gen9 :: SLM Bytes Written */
#define sklgt2__memory_reads__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Memory Reads Distribution Gen9 :: Shader Memory Accesses */
#define sklgt2__memory_reads__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Memory Reads Distribution Gen9 :: Shader Atomic Memory Accesses */
#define sklgt2__memory_reads__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Memory Reads Distribution Gen9 :: Shader Barrier Messages */
#define sklgt2__memory_reads__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Memory Reads Distribution Gen9 :: GtiCmdStreamerMemoryReads */
#define sklgt2__memory_reads__gti_cmd_streamer_memory_reads__read \
    hsw__compute_extended__eu_untyped_reads0__read

/* Memory Reads Distribution Gen9 :: GtiRsMemoryReads */
#define sklgt2__memory_reads__gti_rs_memory_reads__read \
    hsw__compute_extended__eu_typed_reads0__read

/* Memory Reads Distribution Gen9 :: GtiVfMemoryReads */
#define sklgt2__memory_reads__gti_vf_memory_reads__read \
    hsw__compute_extended__eu_untyped_writes0__read

/* Memory Reads Distribution Gen9 :: GtiRccMemoryReads */
#define sklgt2__memory_reads__gti_rcc_memory_reads__read \
    hsw__compute_extended__eu_typed_writes0__read

/* Memory Reads Distribution Gen9 :: GtiMscMemoryReads */
#define sklgt2__memory_reads__gti_msc_memory_reads__read \
    hsw__compute_extended__eu_untyped_atomics0__read

/* Memory Reads Distribution Gen9 :: GtiHizMemoryReads */
#define sklgt2__memory_reads__gti_hiz_memory_reads__read \
    hsw__compute_extended__eu_typed_atomics0__read

/* Memory Reads Distribution Gen9 :: GtiStcMemoryReads */
#define sklgt2__memory_reads__gti_stc_memory_reads__read \
    hsw__compute_extended__eu_urb_atomics0__read

/* Memory Reads Distribution Gen9 :: GtiRczMemoryReads */
#define sklgt2__memory_reads__gti_rcz_memory_reads__read \
    hsw__compute_extended__gpu_clocks__read

/* Memory Reads Distribution Gen9 :: GtiMemoryReads */
#define sklgt2__memory_reads__gti_memory_reads__read \
    hsw__compute_extended__typed_writes0__read

/* Memory Reads Distribution Gen9 :: GtiL3Bank0Reads */
#define sklgt2__memory_reads__gti_l3_bank0_reads__read \
    hsw__compute_extended__typed_atomics0__read

/* Memory Reads Distribution Gen9 :: GtiL3Bank1Reads */
#define sklgt2__memory_reads__gti_l3_bank1_reads__read \
    hsw__memory_reads__gti_memory_reads__read

/* Memory Reads Distribution Gen9 :: GtiL3Bank2Reads */
#define sklgt2__memory_reads__gti_l3_bank2_reads__read \
    hsw__memory_reads__llc_read_accesses__read

/* Memory Reads Distribution Gen9 :: GtiL3Bank3Reads */
#define sklgt2__memory_reads__gti_l3_bank3_reads__read \
    hsw__memory_reads__gpu_core_clocks__read

/* Memory Reads Distribution Gen9 :: GtiL3Reads */
#define sklgt2__memory_reads__gti_l3_reads__read \
    bdw__memory_reads__gti_l3_reads__read

/* Memory Reads Distribution Gen9 :: GtiRingAccesses */
#define sklgt2__memory_reads__gti_ring_accesses__read \
    bdw__memory_reads__gti_ring_accesses__read

/* Memory Writes Distribution Gen9 :: GPU Time Elapsed */
#define sklgt2__memory_writes__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Memory Writes Distribution Gen9 :: GPU Core Clocks */
#define sklgt2__memory_writes__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Memory Writes Distribution Gen9 :: AVG GPU Core Frequency */
#define sklgt2__memory_writes__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Memory Writes Distribution Gen9 :: AVG GPU Core Frequency */
#define sklgt2__memory_writes__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Memory Writes Distribution Gen9 :: GPU Busy */
#define sklgt2__memory_writes__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Memory Writes Distribution Gen9 :: VS Threads Dispatched */
#define sklgt2__memory_writes__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Memory Writes Distribution Gen9 :: HS Threads Dispatched */
#define sklgt2__memory_writes__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Memory Writes Distribution Gen9 :: DS Threads Dispatched */
#define sklgt2__memory_writes__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Memory Writes Distribution Gen9 :: GS Threads Dispatched */
#define sklgt2__memory_writes__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Memory Writes Distribution Gen9 :: FS Threads Dispatched */
#define sklgt2__memory_writes__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Memory Writes Distribution Gen9 :: CS Threads Dispatched */
#define sklgt2__memory_writes__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Memory Writes Distribution Gen9 :: EU Active */
#define sklgt2__memory_writes__eu_active__read \
    bdw__render_basic__eu_active__read

/* Memory Writes Distribution Gen9 :: EU Stall */
#define sklgt2__memory_writes__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Memory Writes Distribution Gen9 :: Rasterized Pixels */
#define sklgt2__memory_writes__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Memory Writes Distribution Gen9 :: Early Hi-Depth Test Fails */
#define sklgt2__memory_writes__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Memory Writes Distribution Gen9 :: Early Depth Test Fails */
#define sklgt2__memory_writes__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Memory Writes Distribution Gen9 :: Samples Killed in FS */
#define sklgt2__memory_writes__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Memory Writes Distribution Gen9 :: Pixels Failing Tests */
#define sklgt2__memory_writes__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Memory Writes Distribution Gen9 :: Samples Written */
#define sklgt2__memory_writes__samples_written__read \
    bdw__render_basic__samples_written__read

/* Memory Writes Distribution Gen9 :: Samples Blended */
#define sklgt2__memory_writes__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Memory Writes Distribution Gen9 :: Sampler Texels */
#define sklgt2__memory_writes__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Memory Writes Distribution Gen9 :: Sampler Texels Misses */
#define sklgt2__memory_writes__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Memory Writes Distribution Gen9 :: SLM Bytes Read */
#define sklgt2__memory_writes__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Memory Writes Distribution Gen9 :: SLM Bytes Read */
#define sklgt2__memory_writes__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Memory Writes Distribution Gen9 :: SLM Bytes Written */
#define sklgt2__memory_writes__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Memory Writes Distribution Gen9 :: SLM Bytes Written */
#define sklgt2__memory_writes__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Memory Writes Distribution Gen9 :: Shader Memory Accesses */
#define sklgt2__memory_writes__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Memory Writes Distribution Gen9 :: Shader Atomic Memory Accesses */
#define sklgt2__memory_writes__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Memory Writes Distribution Gen9 :: L3 Shader Throughput */
#define sklgt2__memory_writes__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Memory Writes Distribution Gen9 :: L3 Shader Throughput */
#define sklgt2__memory_writes__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Memory Writes Distribution Gen9 :: Shader Barrier Messages */
#define sklgt2__memory_writes__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Memory Writes Distribution Gen9 :: GtiCmdStreamerMemoryWrites */
#define sklgt2__memory_writes__gti_cmd_streamer_memory_writes__read \
    hsw__compute_extended__eu_untyped_reads0__read

/* Memory Writes Distribution Gen9 :: GtiSoMemoryWrites */
#define sklgt2__memory_writes__gti_so_memory_writes__read \
    hsw__compute_extended__eu_typed_reads0__read

/* Memory Writes Distribution Gen9 :: GtiRccMemoryWrites */
#define sklgt2__memory_writes__gti_rcc_memory_writes__read \
    hsw__compute_extended__eu_typed_writes0__read

/* Memory Writes Distribution Gen9 :: GtiMscMemoryWrites */
#define sklgt2__memory_writes__gti_msc_memory_writes__read \
    hsw__compute_extended__eu_untyped_atomics0__read

/* Memory Writes Distribution Gen9 :: GtiHizMemoryWrites */
#define sklgt2__memory_writes__gti_hiz_memory_writes__read \
    hsw__compute_extended__eu_typed_atomics0__read

/* Memory Writes Distribution Gen9 :: GtiStcMemoryWrites */
#define sklgt2__memory_writes__gti_stc_memory_writes__read \
    hsw__compute_extended__eu_urb_atomics0__read

/* Memory Writes Distribution Gen9 :: GtiRczMemoryWrites */
#define sklgt2__memory_writes__gti_rcz_memory_writes__read \
    hsw__compute_extended__gpu_clocks__read

/* Memory Writes Distribution Gen9 :: GtiMemoryWrites */
#define sklgt2__memory_writes__gti_memory_writes__read \
    hsw__compute_extended__typed_writes0__read

/* Memory Writes Distribution Gen9 :: GtiL3Bank0Writes */
#define sklgt2__memory_writes__gti_l3_bank0_writes__read \
    hsw__compute_extended__typed_atomics0__read

/* Memory Writes Distribution Gen9 :: GtiL3Bank1Writes */
#define sklgt2__memory_writes__gti_l3_bank1_writes__read \
    hsw__memory_reads__gti_memory_reads__read

/* Memory Writes Distribution Gen9 :: GtiL3Bank2Writes */
#define sklgt2__memory_writes__gti_l3_bank2_writes__read \
    hsw__memory_reads__llc_read_accesses__read

/* Memory Writes Distribution Gen9 :: GtiL3Bank3Writes */
#define sklgt2__memory_writes__gti_l3_bank3_writes__read \
    hsw__memory_reads__gpu_core_clocks__read

/* Memory Writes Distribution Gen9 :: GtiL3Writes */
#define sklgt2__memory_writes__gti_l3_writes__read \
    bdw__memory_reads__gti_l3_reads__read

/* Memory Writes Distribution Gen9 :: GtiRingAccesses */
#define sklgt2__memory_writes__gti_ring_accesses__read \
    bdw__memory_reads__gti_ring_accesses__read

/* Compute Metrics Extended Gen9 :: GPU Time Elapsed */
#define sklgt2__compute_extended__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Compute Metrics Extended Gen9 :: GPU Core Clocks */
#define sklgt2__compute_extended__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Compute Metrics Extended Gen9 :: AVG GPU Core Frequency */
#define sklgt2__compute_extended__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Compute Metrics Extended Gen9 :: AVG GPU Core Frequency */
#define sklgt2__compute_extended__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Compute Metrics Extended Gen9 :: CS Threads Dispatched */
#define sklgt2__compute_extended__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Compute Metrics Extended Gen9 :: EU Active */
#define sklgt2__compute_extended__eu_active__read \
    bdw__render_basic__eu_active__read

/* Compute Metrics Extended Gen9 :: EU Stall */
#define sklgt2__compute_extended__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Compute Metrics Extended Gen9 :: EU Both FPU Pipes Active */
#define sklgt2__compute_extended__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Compute Metrics Extended Gen9 :: EU FPU0 Pipe Active */
#define sklgt2__compute_extended__fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Compute Metrics Extended Gen9 :: EU FPU1 Pipe Active */
#define sklgt2__compute_extended__fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Compute Metrics Extended Gen9 :: EU AVG IPC Rate */
#define sklgt2__compute_extended__eu_avg_ipc_rate__read \
    bdw__compute_basic__eu_avg_ipc_rate__read

/* Compute Metrics Extended Gen9 :: EU AVG IPC Rate */
#define sklgt2__compute_extended__eu_avg_ipc_rate__max \
    bdw__compute_basic__eu_avg_ipc_rate__max

/* Compute Metrics Extended Gen9 :: EU Send Pipe Active */
#define sklgt2__compute_extended__eu_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Compute Metrics Extended Gen9 :: EU Thread Occupancy */
#define sklgt2__compute_extended__eu_thread_occupancy__read \
    bdw__compute_basic__eu_thread_occupancy__read

/* Compute Metrics Extended Gen9 :: Sampler Texels */
#define sklgt2__compute_extended__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Compute Metrics Extended Gen9 :: Sampler Texels Misses */
#define sklgt2__compute_extended__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Compute Metrics Extended Gen9 :: SLM Bytes Read */
#define sklgt2__compute_extended__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Compute Metrics Extended Gen9 :: SLM Bytes Read */
#define sklgt2__compute_extended__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Extended Gen9 :: SLM Bytes Written */
#define sklgt2__compute_extended__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Compute Metrics Extended Gen9 :: SLM Bytes Written */
#define sklgt2__compute_extended__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Extended Gen9 :: Shader Memory Accesses */
#define sklgt2__compute_extended__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Compute Metrics Extended Gen9 :: Shader Atomic Memory Accesses */
#define sklgt2__compute_extended__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Compute Metrics Extended Gen9 :: L3 Shader Throughput */
#define sklgt2__compute_extended__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Compute Metrics Extended Gen9 :: L3 Shader Throughput */
#define sklgt2__compute_extended__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Extended Gen9 :: Shader Barrier Messages */
#define sklgt2__compute_extended__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Compute Metrics Extended Gen9 :: EuUntypedReads0 */
#define sklgt2__compute_extended__eu_untyped_reads0__read \
    hsw__compute_extended__eu_untyped_reads0__read

/* Compute Metrics Extended Gen9 :: EuTypedReads0 */
#define sklgt2__compute_extended__eu_typed_reads0__read \
    hsw__compute_extended__eu_typed_reads0__read

/* Compute Metrics Extended Gen9 :: EuUntypedWrites0 */
#define sklgt2__compute_extended__eu_untyped_writes0__read \
    hsw__compute_extended__eu_untyped_writes0__read

/* Compute Metrics Extended Gen9 :: EuTypedWrites0 */
#define sklgt2__compute_extended__eu_typed_writes0__read \
    hsw__compute_extended__eu_typed_writes0__read

/* Compute Metrics Extended Gen9 :: EuUntypedAtomics0 */
#define sklgt2__compute_extended__eu_untyped_atomics0__read \
    hsw__compute_extended__eu_untyped_atomics0__read

/* Compute Metrics Extended Gen9 :: EuTypedAtomics0 */
#define sklgt2__compute_extended__eu_typed_atomics0__read \
    hsw__compute_extended__eu_typed_atomics0__read

/* Compute Metrics Extended Gen9 :: EuA64UntypedReads0 */
#define sklgt2__compute_extended__eu_a64_untyped_reads0__read \
    hsw__compute_extended__eu_urb_atomics0__read

/* Compute Metrics Extended Gen9 :: EuA64UntypedWrites0 */
#define sklgt2__compute_extended__eu_a64_untyped_writes0__read \
    hsw__compute_extended__gpu_clocks__read

/* Compute Metrics Extended Gen9 :: Typed Reads 0 */
#define sklgt2__compute_extended__typed_reads0__read \
    hsw__render_basic__gpu_core_clocks__read

/* Compute Metrics Extended Gen9 :: Typed Writes 0 */
#define sklgt2__compute_extended__typed_writes0__read \
    hsw__compute_extended__typed_writes0__read

/* Compute Metrics Extended Gen9 :: Untyped Reads 0 */
#define sklgt2__compute_extended__untyped_reads0__read \
    hsw__compute_extended__untyped_reads0__read

/* Compute Metrics Extended Gen9 :: Untyped Writes 0 */
#define sklgt2__compute_extended__untyped_writes0__read \
    hsw__compute_extended__untyped_writes0__read

/* Compute Metrics Extended Gen9 :: Typed Atomics 0 */
#define sklgt2__compute_extended__typed_atomics0__read \
    hsw__compute_extended__typed_atomics0__read

/* Compute Metrics Extended Gen9 :: TypedReadsPerCacheLine */
#define sklgt2__compute_extended__typed_reads_per_cache_line__read \
    hsw__compute_extended__typed_reads_per_cache_line__read

/* Compute Metrics Extended Gen9 :: TypedWritesPerCacheLine */
#define sklgt2__compute_extended__typed_writes_per_cache_line__read \
    hsw__compute_extended__typed_writes_per_cache_line__read

/* Compute Metrics Extended Gen9 :: UntypedReadsPerCacheLine */
#define sklgt2__compute_extended__untyped_reads_per_cache_line__read \
    bdw__compute_extended__untyped_reads_per_cache_line__read

/* Compute Metrics Extended Gen9 :: UntypedWritesPerCacheLine */
#define sklgt2__compute_extended__untyped_writes_per_cache_line__read \
    bdw__compute_extended__untyped_writes_per_cache_line__read

/* Compute Metrics Extended Gen9 :: TypedAtomicsPerCacheLine */
#define sklgt2__compute_extended__typed_atomics_per_cache_line__read \
    hsw__compute_extended__typed_atomics_per_cache_line__read

/* Compute Metrics L3 Cache Gen9 :: GPU Time Elapsed */
#define sklgt2__compute_l3_cache__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Compute Metrics L3 Cache Gen9 :: GPU Core Clocks */
#define sklgt2__compute_l3_cache__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Compute Metrics L3 Cache Gen9 :: AVG GPU Core Frequency */
#define sklgt2__compute_l3_cache__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Compute Metrics L3 Cache Gen9 :: AVG GPU Core Frequency */
#define sklgt2__compute_l3_cache__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Compute Metrics L3 Cache Gen9 :: GPU Busy */
#define sklgt2__compute_l3_cache__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Compute Metrics L3 Cache Gen9 :: VS Threads Dispatched */
#define sklgt2__compute_l3_cache__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Compute Metrics L3 Cache Gen9 :: HS Threads Dispatched */
#define sklgt2__compute_l3_cache__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Compute Metrics L3 Cache Gen9 :: DS Threads Dispatched */
#define sklgt2__compute_l3_cache__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Compute Metrics L3 Cache Gen9 :: GS Threads Dispatched */
#define sklgt2__compute_l3_cache__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Compute Metrics L3 Cache Gen9 :: FS Threads Dispatched */
#define sklgt2__compute_l3_cache__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Compute Metrics L3 Cache Gen9 :: CS Threads Dispatched */
#define sklgt2__compute_l3_cache__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Compute Metrics L3 Cache Gen9 :: EU Active */
#define sklgt2__compute_l3_cache__eu_active__read \
    bdw__render_basic__eu_active__read

/* Compute Metrics L3 Cache Gen9 :: EU Stall */
#define sklgt2__compute_l3_cache__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Compute Metrics L3 Cache Gen9 :: EU Both FPU Pipes Active */
#define sklgt2__compute_l3_cache__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU0 Pipe Active */
#define sklgt2__compute_l3_cache__fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU1 Pipe Active */
#define sklgt2__compute_l3_cache__fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Compute Metrics L3 Cache Gen9 :: EU AVG IPC Rate */
#define sklgt2__compute_l3_cache__eu_avg_ipc_rate__read \
    bdw__compute_basic__eu_avg_ipc_rate__read

/* Compute Metrics L3 Cache Gen9 :: EU AVG IPC Rate */
#define sklgt2__compute_l3_cache__eu_avg_ipc_rate__max \
    bdw__compute_basic__eu_avg_ipc_rate__max

/* Compute Metrics L3 Cache Gen9 :: EU Send Pipe Active */
#define sklgt2__compute_l3_cache__eu_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU0 Hybrid Instruction */
#define sklgt2__compute_l3_cache__eu_hybrid_fpu0_instruction__read \
    bdw__compute_l3_cache__eu_hybrid_fpu0_instruction__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU1 Hybrid Instruction */
#define sklgt2__compute_l3_cache__eu_hybrid_fpu1_instruction__read \
    bdw__compute_l3_cache__eu_hybrid_fpu1_instruction__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU0 Ternary Instruction */
#define sklgt2__compute_l3_cache__eu_ternary_fpu0_instruction__read \
    bdw__render_basic__ps_fpu0_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU1 Ternary Instruction */
#define sklgt2__compute_l3_cache__eu_ternary_fpu1_instruction__read \
    bdw__render_basic__ps_fpu1_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU0 Binary Instruction */
#define sklgt2__compute_l3_cache__eu_binary_fpu0_instruction__read \
    bdw__render_basic__ps_send_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU1 Binary Instruction */
#define sklgt2__compute_l3_cache__eu_binary_fpu1_instruction__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU0 Move Instruction */
#define sklgt2__compute_l3_cache__eu_move_fpu0_instruction__read \
    bdw__compute_l3_cache__eu_move_fpu0_instruction__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU1 Move Instruction */
#define sklgt2__compute_l3_cache__eu_move_fpu1_instruction__read \
    bdw__compute_l3_cache__eu_move_fpu1_instruction__read

/* Compute Metrics L3 Cache Gen9 :: Rasterized Pixels */
#define sklgt2__compute_l3_cache__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Compute Metrics L3 Cache Gen9 :: Early Hi-Depth Test Fails */
#define sklgt2__compute_l3_cache__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Compute Metrics L3 Cache Gen9 :: Early Depth Test Fails */
#define sklgt2__compute_l3_cache__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Compute Metrics L3 Cache Gen9 :: Samples Killed in FS */
#define sklgt2__compute_l3_cache__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Compute Metrics L3 Cache Gen9 :: Pixels Failing Tests */
#define sklgt2__compute_l3_cache__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Compute Metrics L3 Cache Gen9 :: Samples Written */
#define sklgt2__compute_l3_cache__samples_written__read \
    bdw__render_basic__samples_written__read

/* Compute Metrics L3 Cache Gen9 :: Samples Blended */
#define sklgt2__compute_l3_cache__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Compute Metrics L3 Cache Gen9 :: Sampler Accesses */
#define sklgt2__compute_l3_cache__sampler_accesses__read \
    bdw__render_pipe_profile__sampler_accesses__read

/* Compute Metrics L3 Cache Gen9 :: Sampler Texels */
#define sklgt2__compute_l3_cache__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Compute Metrics L3 Cache Gen9 :: Sampler Texels Misses */
#define sklgt2__compute_l3_cache__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Compute Metrics L3 Cache Gen9 :: SLM Bytes Read */
#define sklgt2__compute_l3_cache__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Compute Metrics L3 Cache Gen9 :: SLM Bytes Read */
#define sklgt2__compute_l3_cache__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics L3 Cache Gen9 :: SLM Bytes Written */
#define sklgt2__compute_l3_cache__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Compute Metrics L3 Cache Gen9 :: SLM Bytes Written */
#define sklgt2__compute_l3_cache__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics L3 Cache Gen9 :: Shader Memory Accesses */
#define sklgt2__compute_l3_cache__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Compute Metrics L3 Cache Gen9 :: Shader Atomic Memory Accesses */
#define sklgt2__compute_l3_cache__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Compute Metrics L3 Cache Gen9 :: L3 Accesses */
static uint64_t
sklgt2__compute_l3_cache__l3_accesses__read(const struct intel_perf *perf,
                                            const struct intel_perf_metric_set *metric_set,
                                            uint64_t *accumulator)
{
    /* RPN equation: C 0 READ C 1 READ B 2 READ B 3 READ UADD UADD UADD 2 UMUL */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 0];
    uint64_t tmp1 = accumulator[metric_set->c_offset + 1];
    uint64_t tmp2 = accumulator[metric_set->b_offset + 2];
    uint64_t tmp3 = accumulator[metric_set->b_offset + 3];
    uint64_t tmp4 = tmp2 + tmp3;
    uint64_t tmp5 = tmp1 + tmp4;
    uint64_t tmp6 = tmp0 + tmp5;
    uint64_t tmp7 = tmp6 * 2;

    return tmp7;
}

/* Compute Metrics L3 Cache Gen9 :: L3 Misses */
#define sklgt2__compute_l3_cache__l3_misses__read \
    bdw__compute_l3_cache__l3_misses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Sampler Throughput */
#define sklgt2__compute_l3_cache__l3_sampler_throughput__read \
    chv__render_basic__l3_sampler_throughput__read

/* Compute Metrics L3 Cache Gen9 :: L3 Sampler Throughput */
#define sklgt2__compute_l3_cache__l3_sampler_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics L3 Cache Gen9 :: L3 Shader Throughput */
#define sklgt2__compute_l3_cache__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Compute Metrics L3 Cache Gen9 :: L3 Shader Throughput */
#define sklgt2__compute_l3_cache__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics L3 Cache Gen9 :: L3 Total Throughput */
static uint64_t
sklgt2__compute_l3_cache__l3_total_throughput__read(const struct intel_perf *perf,
                                                    const struct intel_perf_metric_set *metric_set,
                                                    uint64_t *accumulator)
{
    /* RPN equation: $L3Accesses 64 UMUL */
    uint64_t tmp0 = sklgt2__compute_l3_cache__l3_accesses__read(perf, metric_set, accumulator) * 64;

    return tmp0;
}

/* Compute Metrics L3 Cache Gen9 :: L3 Total Throughput */
#define sklgt2__compute_l3_cache__l3_total_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics L3 Cache Gen9 :: Shader Barrier Messages */
#define sklgt2__compute_l3_cache__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Compute Metrics L3 Cache Gen9 :: L3 Bank 00 Accesses */
#define sklgt2__compute_l3_cache__l3_bank00_accesses__read \
    bdw__compute_l3_cache__l3_bank00_accesses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Bank 01 Accesses */
#define sklgt2__compute_l3_cache__l3_bank01_accesses__read \
    bdw__compute_l3_cache__l3_bank01_accesses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Bank 02 Accesses */
#define sklgt2__compute_l3_cache__l3_bank02_accesses__read \
    bdw__compute_l3_cache__l3_bank02_accesses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Bank 03 Accesses */
#define sklgt2__compute_l3_cache__l3_bank03_accesses__read \
    bdw__compute_l3_cache__l3_bank03_accesses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Bank 00 IC Accesses */
#define sklgt2__compute_l3_cache__l3_bank00_ic_accesses__read \
    bdw__compute_l3_cache__l3_bank00_ic_accesses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Bank 00 IC Hits */
#define sklgt2__compute_l3_cache__l3_bank00_ic_hits__read \
    bdw__compute_l3_cache__l3_bank00_ic_hits__read

/* Compute Metrics L3 Cache Gen9 :: GTI L3 Throughput */
#define sklgt2__compute_l3_cache__gti_l3_throughput__read \
    bdw__compute_l3_cache__gti_l3_throughput__read

/* Compute Metrics L3 Cache Gen9 :: GTI L3 Throughput */
#define sklgt2__compute_l3_cache__gti_l3_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics L3 Cache Gen9 :: GTI Read Throughput */
#define sklgt2__compute_l3_cache__gti_read_throughput__read \
    bdw__render_basic__gti_read_throughput__read

/* Compute Metrics L3 Cache Gen9 :: GTI Read Throughput */
#define sklgt2__compute_l3_cache__gti_read_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Compute Metrics L3 Cache Gen9 :: GTI Write Throughput */
#define sklgt2__compute_l3_cache__gti_write_throughput__read \
    hsw__render_basic__gti_write_throughput__read

/* Compute Metrics L3 Cache Gen9 :: GTI Write Throughput */
#define sklgt2__compute_l3_cache__gti_write_throughput__max \
    bdw__render_basic__gti_write_throughput__max

/* Metric set HDCAndSF :: GPU Time Elapsed */
#define sklgt2__hdc_and_sf__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set HDCAndSF :: GPU Core Clocks */
#define sklgt2__hdc_and_sf__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set HDCAndSF :: AVG GPU Core Frequency */
#define sklgt2__hdc_and_sf__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set HDCAndSF :: AVG GPU Core Frequency */
#define sklgt2__hdc_and_sf__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set HDCAndSF :: GPU Busy */
#define sklgt2__hdc_and_sf__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set HDCAndSF :: VS Threads Dispatched */
#define sklgt2__hdc_and_sf__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set HDCAndSF :: HS Threads Dispatched */
#define sklgt2__hdc_and_sf__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set HDCAndSF :: DS Threads Dispatched */
#define sklgt2__hdc_and_sf__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set HDCAndSF :: GS Threads Dispatched */
#define sklgt2__hdc_and_sf__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set HDCAndSF :: FS Threads Dispatched */
#define sklgt2__hdc_and_sf__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set HDCAndSF :: CS Threads Dispatched */
#define sklgt2__hdc_and_sf__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set HDCAndSF :: EU Active */
#define sklgt2__hdc_and_sf__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set HDCAndSF :: EU Stall */
#define sklgt2__hdc_and_sf__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set HDCAndSF :: EU Both FPU Pipes Active */
#define sklgt2__hdc_and_sf__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set HDCAndSF :: VS FPU0 Pipe Active */
#define sklgt2__hdc_and_sf__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set HDCAndSF :: VS FPU1 Pipe Active */
#define sklgt2__hdc_and_sf__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set HDCAndSF :: VS Send Pipe Active */
#define sklgt2__hdc_and_sf__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set HDCAndSF :: PS FPU0 Pipe Active */
#define sklgt2__hdc_and_sf__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set HDCAndSF :: PS FPU1 Pipe Active */
#define sklgt2__hdc_and_sf__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set HDCAndSF :: PS Send Pipeline Active */
#define sklgt2__hdc_and_sf__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set HDCAndSF :: FS Both FPU Active */
#define sklgt2__hdc_and_sf__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set HDCAndSF :: Rasterized Pixels */
#define sklgt2__hdc_and_sf__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set HDCAndSF :: Early Hi-Depth Test Fails */
#define sklgt2__hdc_and_sf__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set HDCAndSF :: Early Depth Test Fails */
#define sklgt2__hdc_and_sf__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set HDCAndSF :: Samples Killed in FS */
#define sklgt2__hdc_and_sf__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set HDCAndSF :: Pixels Failing Tests */
#define sklgt2__hdc_and_sf__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set HDCAndSF :: Samples Written */
#define sklgt2__hdc_and_sf__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set HDCAndSF :: Samples Blended */
#define sklgt2__hdc_and_sf__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set HDCAndSF :: Sampler Texels */
#define sklgt2__hdc_and_sf__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set HDCAndSF :: Sampler Texels Misses */
#define sklgt2__hdc_and_sf__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set HDCAndSF :: SLM Bytes Read */
#define sklgt2__hdc_and_sf__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set HDCAndSF :: SLM Bytes Read */
#define sklgt2__hdc_and_sf__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set HDCAndSF :: SLM Bytes Written */
#define sklgt2__hdc_and_sf__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set HDCAndSF :: SLM Bytes Written */
#define sklgt2__hdc_and_sf__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set HDCAndSF :: Shader Memory Accesses */
#define sklgt2__hdc_and_sf__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set HDCAndSF :: Shader Atomic Memory Accesses */
#define sklgt2__hdc_and_sf__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set HDCAndSF :: L3 Shader Throughput */
#define sklgt2__hdc_and_sf__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set HDCAndSF :: L3 Shader Throughput */
#define sklgt2__hdc_and_sf__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set HDCAndSF :: Shader Barrier Messages */
#define sklgt2__hdc_and_sf__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set HDCAndSF :: Polygon Data Ready */
#define sklgt2__hdc_and_sf__poly_data_ready__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set HDCAndSF :: HDC stalled by L3 (s0.ss0) */
#define sklgt2__hdc_and_sf__non_sampler_shader00_access_stalled_on_l3__read \
    bdw__hdc_and_sf__non_sampler_shader02_access_stalled_on_l3__read

/* Metric set HDCAndSF :: HDC stalled by L3 (s0.ss1) */
#define sklgt2__hdc_and_sf__non_sampler_shader01_access_stalled_on_l3__read \
    bdw__hdc_and_sf__non_sampler_shader01_access_stalled_on_l3__read

/* Metric set HDCAndSF :: HDC stalled by L3 (s0.ss2) */
#define sklgt2__hdc_and_sf__non_sampler_shader02_access_stalled_on_l3__read \
    bdw__hdc_and_sf__non_sampler_shader00_access_stalled_on_l3__read

/* Metric set HDCAndSF :: SQ is full */
#define sklgt2__hdc_and_sf__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set L3_1 :: GPU Time Elapsed */
#define sklgt2__l3_1__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set L3_1 :: GPU Core Clocks */
#define sklgt2__l3_1__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set L3_1 :: AVG GPU Core Frequency */
#define sklgt2__l3_1__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set L3_1 :: AVG GPU Core Frequency */
#define sklgt2__l3_1__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set L3_1 :: GPU Busy */
#define sklgt2__l3_1__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set L3_1 :: VS Threads Dispatched */
#define sklgt2__l3_1__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set L3_1 :: HS Threads Dispatched */
#define sklgt2__l3_1__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set L3_1 :: DS Threads Dispatched */
#define sklgt2__l3_1__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set L3_1 :: GS Threads Dispatched */
#define sklgt2__l3_1__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set L3_1 :: FS Threads Dispatched */
#define sklgt2__l3_1__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set L3_1 :: CS Threads Dispatched */
#define sklgt2__l3_1__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set L3_1 :: EU Active */
#define sklgt2__l3_1__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set L3_1 :: EU Stall */
#define sklgt2__l3_1__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set L3_1 :: EU Both FPU Pipes Active */
#define sklgt2__l3_1__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set L3_1 :: VS FPU0 Pipe Active */
#define sklgt2__l3_1__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set L3_1 :: VS FPU1 Pipe Active */
#define sklgt2__l3_1__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set L3_1 :: VS Send Pipe Active */
#define sklgt2__l3_1__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set L3_1 :: PS FPU0 Pipe Active */
#define sklgt2__l3_1__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set L3_1 :: PS FPU1 Pipe Active */
#define sklgt2__l3_1__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set L3_1 :: PS Send Pipeline Active */
#define sklgt2__l3_1__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set L3_1 :: FS Both FPU Active */
#define sklgt2__l3_1__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set L3_1 :: Rasterized Pixels */
#define sklgt2__l3_1__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set L3_1 :: Early Hi-Depth Test Fails */
#define sklgt2__l3_1__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set L3_1 :: Early Depth Test Fails */
#define sklgt2__l3_1__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set L3_1 :: Samples Killed in FS */
#define sklgt2__l3_1__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set L3_1 :: Pixels Failing Tests */
#define sklgt2__l3_1__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set L3_1 :: Samples Written */
#define sklgt2__l3_1__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set L3_1 :: Samples Blended */
#define sklgt2__l3_1__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set L3_1 :: Sampler Texels */
#define sklgt2__l3_1__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set L3_1 :: Sampler Texels Misses */
#define sklgt2__l3_1__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set L3_1 :: SLM Bytes Read */
#define sklgt2__l3_1__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set L3_1 :: SLM Bytes Read */
#define sklgt2__l3_1__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_1 :: SLM Bytes Written */
#define sklgt2__l3_1__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set L3_1 :: SLM Bytes Written */
#define sklgt2__l3_1__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_1 :: Shader Memory Accesses */
#define sklgt2__l3_1__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set L3_1 :: Shader Atomic Memory Accesses */
#define sklgt2__l3_1__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set L3_1 :: L3 Shader Throughput */
#define sklgt2__l3_1__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set L3_1 :: L3 Shader Throughput */
#define sklgt2__l3_1__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_1 :: Shader Barrier Messages */
#define sklgt2__l3_1__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set L3_1 :: Slice0 L3 Bank0 Stalled */
#define sklgt2__l3_1__l30_bank0_stalled__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set L3_1 :: Slice0 L3 Bank1 Stalled */
#define sklgt2__l3_1__l30_bank1_stalled__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* Metric set L3_1 :: Slice0 L3 Bank1 Active */
#define sklgt2__l3_1__l30_bank1_active__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set L3_1 :: Slice0 L3 Bank0 Active */
#define sklgt2__l3_1__l30_bank0_active__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set L3_1 :: SQ is full */
#define sklgt2__l3_1__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set L3_2 :: GPU Time Elapsed */
#define sklgt2__l3_2__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set L3_2 :: GPU Core Clocks */
#define sklgt2__l3_2__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set L3_2 :: AVG GPU Core Frequency */
#define sklgt2__l3_2__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set L3_2 :: AVG GPU Core Frequency */
#define sklgt2__l3_2__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set L3_2 :: GPU Busy */
#define sklgt2__l3_2__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set L3_2 :: VS Threads Dispatched */
#define sklgt2__l3_2__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set L3_2 :: HS Threads Dispatched */
#define sklgt2__l3_2__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set L3_2 :: DS Threads Dispatched */
#define sklgt2__l3_2__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set L3_2 :: GS Threads Dispatched */
#define sklgt2__l3_2__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set L3_2 :: FS Threads Dispatched */
#define sklgt2__l3_2__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set L3_2 :: CS Threads Dispatched */
#define sklgt2__l3_2__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set L3_2 :: EU Active */
#define sklgt2__l3_2__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set L3_2 :: EU Stall */
#define sklgt2__l3_2__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set L3_2 :: EU Both FPU Pipes Active */
#define sklgt2__l3_2__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set L3_2 :: VS FPU0 Pipe Active */
#define sklgt2__l3_2__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set L3_2 :: VS FPU1 Pipe Active */
#define sklgt2__l3_2__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set L3_2 :: VS Send Pipe Active */
#define sklgt2__l3_2__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set L3_2 :: PS FPU0 Pipe Active */
#define sklgt2__l3_2__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set L3_2 :: PS FPU1 Pipe Active */
#define sklgt2__l3_2__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set L3_2 :: PS Send Pipeline Active */
#define sklgt2__l3_2__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set L3_2 :: FS Both FPU Active */
#define sklgt2__l3_2__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set L3_2 :: Rasterized Pixels */
#define sklgt2__l3_2__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set L3_2 :: Early Hi-Depth Test Fails */
#define sklgt2__l3_2__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set L3_2 :: Early Depth Test Fails */
#define sklgt2__l3_2__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set L3_2 :: Samples Killed in FS */
#define sklgt2__l3_2__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set L3_2 :: Pixels Failing Tests */
#define sklgt2__l3_2__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set L3_2 :: Samples Written */
#define sklgt2__l3_2__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set L3_2 :: Samples Blended */
#define sklgt2__l3_2__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set L3_2 :: Sampler Texels */
#define sklgt2__l3_2__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set L3_2 :: Sampler Texels Misses */
#define sklgt2__l3_2__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set L3_2 :: SLM Bytes Read */
#define sklgt2__l3_2__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set L3_2 :: SLM Bytes Read */
#define sklgt2__l3_2__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_2 :: SLM Bytes Written */
#define sklgt2__l3_2__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set L3_2 :: SLM Bytes Written */
#define sklgt2__l3_2__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_2 :: Shader Memory Accesses */
#define sklgt2__l3_2__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set L3_2 :: Shader Atomic Memory Accesses */
#define sklgt2__l3_2__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set L3_2 :: L3 Shader Throughput */
#define sklgt2__l3_2__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set L3_2 :: L3 Shader Throughput */
#define sklgt2__l3_2__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_2 :: Shader Barrier Messages */
#define sklgt2__l3_2__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set L3_2 :: Slice0 L3 Bank2 Stalled */
#define sklgt2__l3_2__l30_bank2_stalled__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set L3_2 :: Slice0 L3 Bank2 Active */
#define sklgt2__l3_2__l30_bank2_active__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set L3_2 :: SQ is full */
#define sklgt2__l3_2__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set L3_3 :: GPU Time Elapsed */
#define sklgt2__l3_3__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set L3_3 :: GPU Core Clocks */
#define sklgt2__l3_3__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set L3_3 :: AVG GPU Core Frequency */
#define sklgt2__l3_3__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set L3_3 :: AVG GPU Core Frequency */
#define sklgt2__l3_3__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set L3_3 :: GPU Busy */
#define sklgt2__l3_3__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set L3_3 :: VS Threads Dispatched */
#define sklgt2__l3_3__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set L3_3 :: HS Threads Dispatched */
#define sklgt2__l3_3__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set L3_3 :: DS Threads Dispatched */
#define sklgt2__l3_3__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set L3_3 :: GS Threads Dispatched */
#define sklgt2__l3_3__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set L3_3 :: FS Threads Dispatched */
#define sklgt2__l3_3__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set L3_3 :: CS Threads Dispatched */
#define sklgt2__l3_3__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set L3_3 :: EU Active */
#define sklgt2__l3_3__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set L3_3 :: EU Stall */
#define sklgt2__l3_3__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set L3_3 :: EU Both FPU Pipes Active */
#define sklgt2__l3_3__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set L3_3 :: VS FPU0 Pipe Active */
#define sklgt2__l3_3__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set L3_3 :: VS FPU1 Pipe Active */
#define sklgt2__l3_3__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set L3_3 :: VS Send Pipe Active */
#define sklgt2__l3_3__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set L3_3 :: PS FPU0 Pipe Active */
#define sklgt2__l3_3__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set L3_3 :: PS FPU1 Pipe Active */
#define sklgt2__l3_3__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set L3_3 :: PS Send Pipeline Active */
#define sklgt2__l3_3__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set L3_3 :: FS Both FPU Active */
#define sklgt2__l3_3__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set L3_3 :: Rasterized Pixels */
#define sklgt2__l3_3__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set L3_3 :: Early Hi-Depth Test Fails */
#define sklgt2__l3_3__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set L3_3 :: Early Depth Test Fails */
#define sklgt2__l3_3__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set L3_3 :: Samples Killed in FS */
#define sklgt2__l3_3__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set L3_3 :: Pixels Failing Tests */
#define sklgt2__l3_3__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set L3_3 :: Samples Written */
#define sklgt2__l3_3__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set L3_3 :: Samples Blended */
#define sklgt2__l3_3__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set L3_3 :: Sampler Texels */
#define sklgt2__l3_3__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set L3_3 :: Sampler Texels Misses */
#define sklgt2__l3_3__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set L3_3 :: SLM Bytes Read */
#define sklgt2__l3_3__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set L3_3 :: SLM Bytes Read */
#define sklgt2__l3_3__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_3 :: SLM Bytes Written */
#define sklgt2__l3_3__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set L3_3 :: SLM Bytes Written */
#define sklgt2__l3_3__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_3 :: Shader Memory Accesses */
#define sklgt2__l3_3__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set L3_3 :: Shader Atomic Memory Accesses */
#define sklgt2__l3_3__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set L3_3 :: L3 Shader Throughput */
#define sklgt2__l3_3__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set L3_3 :: L3 Shader Throughput */
#define sklgt2__l3_3__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_3 :: Shader Barrier Messages */
#define sklgt2__l3_3__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set L3_3 :: Slice0 L3 Bank3 Stalled */
#define sklgt2__l3_3__l30_bank3_stalled__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set L3_3 :: Slice0 L3 Bank3 Active */
#define sklgt2__l3_3__l30_bank3_active__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set L3_3 :: SQ is full */
#define sklgt2__l3_3__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set RasterizerAndPixelBackend :: GPU Time Elapsed */
#define sklgt2__rasterizer_and_pixel_backend__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set RasterizerAndPixelBackend :: GPU Core Clocks */
#define sklgt2__rasterizer_and_pixel_backend__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set RasterizerAndPixelBackend :: AVG GPU Core Frequency */
#define sklgt2__rasterizer_and_pixel_backend__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set RasterizerAndPixelBackend :: AVG GPU Core Frequency */
#define sklgt2__rasterizer_and_pixel_backend__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set RasterizerAndPixelBackend :: GPU Busy */
#define sklgt2__rasterizer_and_pixel_backend__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set RasterizerAndPixelBackend :: VS Threads Dispatched */
#define sklgt2__rasterizer_and_pixel_backend__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set RasterizerAndPixelBackend :: HS Threads Dispatched */
#define sklgt2__rasterizer_and_pixel_backend__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set RasterizerAndPixelBackend :: DS Threads Dispatched */
#define sklgt2__rasterizer_and_pixel_backend__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set RasterizerAndPixelBackend :: GS Threads Dispatched */
#define sklgt2__rasterizer_and_pixel_backend__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set RasterizerAndPixelBackend :: FS Threads Dispatched */
#define sklgt2__rasterizer_and_pixel_backend__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set RasterizerAndPixelBackend :: CS Threads Dispatched */
#define sklgt2__rasterizer_and_pixel_backend__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set RasterizerAndPixelBackend :: EU Active */
#define sklgt2__rasterizer_and_pixel_backend__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set RasterizerAndPixelBackend :: EU Stall */
#define sklgt2__rasterizer_and_pixel_backend__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set RasterizerAndPixelBackend :: EU Both FPU Pipes Active */
#define sklgt2__rasterizer_and_pixel_backend__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set RasterizerAndPixelBackend :: VS FPU0 Pipe Active */
#define sklgt2__rasterizer_and_pixel_backend__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set RasterizerAndPixelBackend :: VS FPU1 Pipe Active */
#define sklgt2__rasterizer_and_pixel_backend__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set RasterizerAndPixelBackend :: VS Send Pipe Active */
#define sklgt2__rasterizer_and_pixel_backend__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set RasterizerAndPixelBackend :: PS FPU0 Pipe Active */
#define sklgt2__rasterizer_and_pixel_backend__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set RasterizerAndPixelBackend :: PS FPU1 Pipe Active */
#define sklgt2__rasterizer_and_pixel_backend__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set RasterizerAndPixelBackend :: PS Send Pipeline Active */
#define sklgt2__rasterizer_and_pixel_backend__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set RasterizerAndPixelBackend :: FS Both FPU Active */
#define sklgt2__rasterizer_and_pixel_backend__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set RasterizerAndPixelBackend :: Rasterized Pixels */
#define sklgt2__rasterizer_and_pixel_backend__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set RasterizerAndPixelBackend :: Early Hi-Depth Test Fails */
#define sklgt2__rasterizer_and_pixel_backend__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set RasterizerAndPixelBackend :: Early Depth Test Fails */
#define sklgt2__rasterizer_and_pixel_backend__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set RasterizerAndPixelBackend :: Samples Killed in FS */
#define sklgt2__rasterizer_and_pixel_backend__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set RasterizerAndPixelBackend :: Pixels Failing Tests */
#define sklgt2__rasterizer_and_pixel_backend__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set RasterizerAndPixelBackend :: Samples Written */
#define sklgt2__rasterizer_and_pixel_backend__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set RasterizerAndPixelBackend :: Samples Blended */
#define sklgt2__rasterizer_and_pixel_backend__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set RasterizerAndPixelBackend :: Sampler Texels */
#define sklgt2__rasterizer_and_pixel_backend__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set RasterizerAndPixelBackend :: Sampler Texels Misses */
#define sklgt2__rasterizer_and_pixel_backend__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Read */
#define sklgt2__rasterizer_and_pixel_backend__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Read */
#define sklgt2__rasterizer_and_pixel_backend__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Written */
#define sklgt2__rasterizer_and_pixel_backend__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Written */
#define sklgt2__rasterizer_and_pixel_backend__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set RasterizerAndPixelBackend :: Shader Memory Accesses */
#define sklgt2__rasterizer_and_pixel_backend__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set RasterizerAndPixelBackend :: Shader Atomic Memory Accesses */
#define sklgt2__rasterizer_and_pixel_backend__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set RasterizerAndPixelBackend :: L3 Shader Throughput */
#define sklgt2__rasterizer_and_pixel_backend__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set RasterizerAndPixelBackend :: L3 Shader Throughput */
#define sklgt2__rasterizer_and_pixel_backend__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set RasterizerAndPixelBackend :: Shader Barrier Messages */
#define sklgt2__rasterizer_and_pixel_backend__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Post-EarlyZ Pixel Data Ready */
#define sklgt2__rasterizer_and_pixel_backend__pixel_data0_ready__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Rasterizer Input Available */
#define sklgt2__rasterizer_and_pixel_backend__rasterizer0_input_available__read \
    bdw__render_basic__sampler1_busy__read

/* Metric set RasterizerAndPixelBackend :: Slice0 PS Output Available */
#define sklgt2__rasterizer_and_pixel_backend__ps_output0_available__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Pixel Values Ready */
#define sklgt2__rasterizer_and_pixel_backend__pixel_values0_ready__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Rasterizer Output Ready */
#define sklgt2__rasterizer_and_pixel_backend__rasterizer0_output_ready__read \
    bdw__render_pipe_profile__sf_stall__read

/* Metric set RasterizerAndPixelBackend :: SQ is full */
#define sklgt2__rasterizer_and_pixel_backend__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set Sampler :: GPU Time Elapsed */
#define sklgt2__sampler__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set Sampler :: GPU Core Clocks */
#define sklgt2__sampler__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set Sampler :: AVG GPU Core Frequency */
#define sklgt2__sampler__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set Sampler :: AVG GPU Core Frequency */
#define sklgt2__sampler__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set Sampler :: GPU Busy */
#define sklgt2__sampler__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set Sampler :: VS Threads Dispatched */
#define sklgt2__sampler__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set Sampler :: HS Threads Dispatched */
#define sklgt2__sampler__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set Sampler :: DS Threads Dispatched */
#define sklgt2__sampler__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set Sampler :: GS Threads Dispatched */
#define sklgt2__sampler__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set Sampler :: FS Threads Dispatched */
#define sklgt2__sampler__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set Sampler :: CS Threads Dispatched */
#define sklgt2__sampler__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set Sampler :: EU Active */
#define sklgt2__sampler__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set Sampler :: EU Stall */
#define sklgt2__sampler__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set Sampler :: EU Both FPU Pipes Active */
#define sklgt2__sampler__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set Sampler :: VS FPU0 Pipe Active */
#define sklgt2__sampler__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set Sampler :: VS FPU1 Pipe Active */
#define sklgt2__sampler__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set Sampler :: VS Send Pipe Active */
#define sklgt2__sampler__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set Sampler :: PS FPU0 Pipe Active */
#define sklgt2__sampler__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set Sampler :: PS FPU1 Pipe Active */
#define sklgt2__sampler__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set Sampler :: PS Send Pipeline Active */
#define sklgt2__sampler__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set Sampler :: FS Both FPU Active */
#define sklgt2__sampler__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set Sampler :: Rasterized Pixels */
#define sklgt2__sampler__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set Sampler :: Early Hi-Depth Test Fails */
#define sklgt2__sampler__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set Sampler :: Early Depth Test Fails */
#define sklgt2__sampler__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set Sampler :: Samples Killed in FS */
#define sklgt2__sampler__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set Sampler :: Pixels Failing Tests */
#define sklgt2__sampler__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set Sampler :: Samples Written */
#define sklgt2__sampler__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set Sampler :: Samples Blended */
#define sklgt2__sampler__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set Sampler :: Sampler Texels */
#define sklgt2__sampler__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set Sampler :: Sampler Texels Misses */
#define sklgt2__sampler__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set Sampler :: SLM Bytes Read */
#define sklgt2__sampler__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set Sampler :: SLM Bytes Read */
#define sklgt2__sampler__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set Sampler :: SLM Bytes Written */
#define sklgt2__sampler__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set Sampler :: SLM Bytes Written */
#define sklgt2__sampler__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set Sampler :: Shader Memory Accesses */
#define sklgt2__sampler__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set Sampler :: Shader Atomic Memory Accesses */
#define sklgt2__sampler__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set Sampler :: L3 Shader Throughput */
#define sklgt2__sampler__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set Sampler :: L3 Shader Throughput */
#define sklgt2__sampler__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set Sampler :: Shader Barrier Messages */
#define sklgt2__sampler__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set Sampler :: Slice0 Subslice1 Input Available */
#define sklgt2__sampler__sampler01_input_available__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set Sampler :: Slice0 Subslice2 Input Available */
#define sklgt2__sampler__sampler02_input_available__read \
    bdw__render_basic__sampler1_busy__read

/* Metric set Sampler :: Slice0 Subslice0 Input Available */
#define sklgt2__sampler__sampler00_input_available__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Metric set Sampler :: Slice0 Subslice2 Sampler Output Ready */
#define sklgt2__sampler__sampler02_output_ready__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set Sampler :: Slice0 Subslice0 Sampler Output Ready */
#define sklgt2__sampler__sampler00_output_ready__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set Sampler :: Slice0 Subslice1 Sampler Output Ready */
#define sklgt2__sampler__sampler01_output_ready__read \
    bdw__render_pipe_profile__sf_stall__read

/* Metric set Sampler :: SQ is full */
#define sklgt2__sampler__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set TDL_1 :: GPU Time Elapsed */
#define sklgt2__tdl_1__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set TDL_1 :: GPU Core Clocks */
#define sklgt2__tdl_1__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set TDL_1 :: AVG GPU Core Frequency */
#define sklgt2__tdl_1__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set TDL_1 :: AVG GPU Core Frequency */
#define sklgt2__tdl_1__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set TDL_1 :: GPU Busy */
#define sklgt2__tdl_1__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set TDL_1 :: VS Threads Dispatched */
#define sklgt2__tdl_1__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set TDL_1 :: HS Threads Dispatched */
#define sklgt2__tdl_1__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set TDL_1 :: DS Threads Dispatched */
#define sklgt2__tdl_1__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set TDL_1 :: GS Threads Dispatched */
#define sklgt2__tdl_1__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set TDL_1 :: FS Threads Dispatched */
#define sklgt2__tdl_1__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set TDL_1 :: CS Threads Dispatched */
#define sklgt2__tdl_1__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set TDL_1 :: EU Active */
#define sklgt2__tdl_1__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set TDL_1 :: EU Stall */
#define sklgt2__tdl_1__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set TDL_1 :: EU Both FPU Pipes Active */
#define sklgt2__tdl_1__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set TDL_1 :: VS FPU0 Pipe Active */
#define sklgt2__tdl_1__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set TDL_1 :: VS FPU1 Pipe Active */
#define sklgt2__tdl_1__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set TDL_1 :: VS Send Pipe Active */
#define sklgt2__tdl_1__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set TDL_1 :: PS FPU0 Pipe Active */
#define sklgt2__tdl_1__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set TDL_1 :: PS FPU1 Pipe Active */
#define sklgt2__tdl_1__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set TDL_1 :: PS Send Pipeline Active */
#define sklgt2__tdl_1__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set TDL_1 :: FS Both FPU Active */
#define sklgt2__tdl_1__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set TDL_1 :: Rasterized Pixels */
#define sklgt2__tdl_1__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set TDL_1 :: Early Hi-Depth Test Fails */
#define sklgt2__tdl_1__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set TDL_1 :: Early Depth Test Fails */
#define sklgt2__tdl_1__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set TDL_1 :: Samples Killed in FS */
#define sklgt2__tdl_1__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set TDL_1 :: Pixels Failing Tests */
#define sklgt2__tdl_1__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set TDL_1 :: Samples Written */
#define sklgt2__tdl_1__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set TDL_1 :: Samples Blended */
#define sklgt2__tdl_1__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set TDL_1 :: Sampler Texels */
#define sklgt2__tdl_1__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set TDL_1 :: Sampler Texels Misses */
#define sklgt2__tdl_1__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set TDL_1 :: SLM Bytes Read */
#define sklgt2__tdl_1__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set TDL_1 :: SLM Bytes Read */
#define sklgt2__tdl_1__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_1 :: SLM Bytes Written */
#define sklgt2__tdl_1__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set TDL_1 :: SLM Bytes Written */
#define sklgt2__tdl_1__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_1 :: Shader Memory Accesses */
#define sklgt2__tdl_1__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set TDL_1 :: Shader Atomic Memory Accesses */
#define sklgt2__tdl_1__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set TDL_1 :: L3 Shader Throughput */
#define sklgt2__tdl_1__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set TDL_1 :: L3 Shader Throughput */
#define sklgt2__tdl_1__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_1 :: Shader Barrier Messages */
#define sklgt2__tdl_1__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set TDL_1 :: NonPS Thread Ready For Dispatch on Slice0 Subslice1 */
#define sklgt2__tdl_1__non_ps_thread01_ready_for_dispatch__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set TDL_1 :: PS Thread Ready For Dispatch on Slice0 Subslice0 */
#define sklgt2__tdl_1__ps_thread00_ready_for_dispatch__read \
    bdw__render_basic__sampler1_busy__read

/* Metric set TDL_1 :: NonPS Thread Ready For Dispatch on Slice0 Subslice0 */
#define sklgt2__tdl_1__non_ps_thread00_ready_for_dispatch__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Metric set TDL_1 :: PS Thread Ready For Dispatch on Slice0 Subslice2 */
#define sklgt2__tdl_1__ps_thread02_ready_for_dispatch__read \
    bdw__render_basic__sampler1_bottleneck__read

/* Metric set TDL_1 :: NonPS Thread Ready For Dispatch on Slice0 Subslice2 */
#define sklgt2__tdl_1__non_ps_thread02_ready_for_dispatch__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* Metric set TDL_1 :: PS Thread Ready For Dispatch on Slice0 Subslice1 */
#define sklgt2__tdl_1__ps_thread01_ready_for_dispatch__read \
    bdw__render_pipe_profile__cl_bottleneck__read

/* Metric set TDL_1 :: SQ is full */
#define sklgt2__tdl_1__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set TDL_2 :: GPU Time Elapsed */
#define sklgt2__tdl_2__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set TDL_2 :: GPU Core Clocks */
#define sklgt2__tdl_2__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set TDL_2 :: AVG GPU Core Frequency */
#define sklgt2__tdl_2__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set TDL_2 :: AVG GPU Core Frequency */
#define sklgt2__tdl_2__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set TDL_2 :: GPU Busy */
#define sklgt2__tdl_2__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set TDL_2 :: VS Threads Dispatched */
#define sklgt2__tdl_2__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set TDL_2 :: HS Threads Dispatched */
#define sklgt2__tdl_2__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set TDL_2 :: DS Threads Dispatched */
#define sklgt2__tdl_2__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set TDL_2 :: GS Threads Dispatched */
#define sklgt2__tdl_2__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set TDL_2 :: FS Threads Dispatched */
#define sklgt2__tdl_2__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set TDL_2 :: CS Threads Dispatched */
#define sklgt2__tdl_2__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set TDL_2 :: EU Active */
#define sklgt2__tdl_2__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set TDL_2 :: EU Stall */
#define sklgt2__tdl_2__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set TDL_2 :: EU Both FPU Pipes Active */
#define sklgt2__tdl_2__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set TDL_2 :: VS FPU0 Pipe Active */
#define sklgt2__tdl_2__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set TDL_2 :: VS FPU1 Pipe Active */
#define sklgt2__tdl_2__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set TDL_2 :: VS Send Pipe Active */
#define sklgt2__tdl_2__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set TDL_2 :: PS FPU0 Pipe Active */
#define sklgt2__tdl_2__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set TDL_2 :: PS FPU1 Pipe Active */
#define sklgt2__tdl_2__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set TDL_2 :: PS Send Pipeline Active */
#define sklgt2__tdl_2__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set TDL_2 :: FS Both FPU Active */
#define sklgt2__tdl_2__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set TDL_2 :: Rasterized Pixels */
#define sklgt2__tdl_2__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set TDL_2 :: Early Hi-Depth Test Fails */
#define sklgt2__tdl_2__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set TDL_2 :: Early Depth Test Fails */
#define sklgt2__tdl_2__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set TDL_2 :: Samples Killed in FS */
#define sklgt2__tdl_2__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set TDL_2 :: Pixels Failing Tests */
#define sklgt2__tdl_2__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set TDL_2 :: Samples Written */
#define sklgt2__tdl_2__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set TDL_2 :: Samples Blended */
#define sklgt2__tdl_2__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set TDL_2 :: Sampler Texels */
#define sklgt2__tdl_2__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set TDL_2 :: Sampler Texels Misses */
#define sklgt2__tdl_2__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set TDL_2 :: SLM Bytes Read */
#define sklgt2__tdl_2__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set TDL_2 :: SLM Bytes Read */
#define sklgt2__tdl_2__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_2 :: SLM Bytes Written */
#define sklgt2__tdl_2__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set TDL_2 :: SLM Bytes Written */
#define sklgt2__tdl_2__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_2 :: Shader Memory Accesses */
#define sklgt2__tdl_2__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set TDL_2 :: Shader Atomic Memory Accesses */
#define sklgt2__tdl_2__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set TDL_2 :: L3 Shader Throughput */
#define sklgt2__tdl_2__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set TDL_2 :: L3 Shader Throughput */
#define sklgt2__tdl_2__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_2 :: Shader Barrier Messages */
#define sklgt2__tdl_2__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice1 Port 0 */
#define sklgt2__tdl_2__thread_header01_ready_port0__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice0 Port 1 */
#define sklgt2__tdl_2__thread_header00_ready_port1__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice0 Port 0 */
#define sklgt2__tdl_2__thread_header00_ready_port0__read \
    bdw__render_pipe_profile__sf_stall__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice2 Port 1 */
#define sklgt2__tdl_2__thread_header02_ready_port1__read \
    bdw__render_pipe_profile__cl_stall__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice2 Port 0 */
#define sklgt2__tdl_2__thread_header02_ready_port0__read \
    bdw__render_pipe_profile__so_stall__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice1 Port 1 */
#define sklgt2__tdl_2__thread_header01_ready_port1__read \
    bdw__render_pipe_profile__ds_stall__read

/* Metric set TDL_2 :: SQ is full */
#define sklgt2__tdl_2__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Compute Metrics Extra Gen9 :: GPU Time Elapsed */
#define sklgt2__compute_extra__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Compute Metrics Extra Gen9 :: GPU Core Clocks */
#define sklgt2__compute_extra__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Compute Metrics Extra Gen9 :: AVG GPU Core Frequency */
#define sklgt2__compute_extra__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Compute Metrics Extra Gen9 :: AVG GPU Core Frequency */
#define sklgt2__compute_extra__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Compute Metrics Extra Gen9 :: EU FPU1 Pipe Active */
#define sklgt2__compute_extra__fpu1_active__read \
    bdw__render_basic__eu_stall__read

/* Compute Metrics Extra Gen9 :: EU FPU1 Pipe Active including Ext Math */
static double
sklgt2__compute_extra__fpu1_active_adjusted__read(const struct intel_perf *perf,
                                                  const struct intel_perf_metric_set *metric_set,
                                                  uint64_t *accumulator)
{
    /* RPN equation: A 8 READ  C 7 READ C 6 READ FADD C 5 READ FADD 8 FMUL FADD 100 FMUL $EuCoresTotalCount FDIV $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 8];
    uint64_t tmp1 = accumulator[metric_set->c_offset + 7];
    uint64_t tmp2 = accumulator[metric_set->c_offset + 6];
    double tmp3 = tmp1 + tmp2;
    uint64_t tmp4 = accumulator[metric_set->c_offset + 5];
    double tmp5 = tmp3 + tmp4;
    double tmp6 = tmp5 * 8;
    double tmp7 = tmp0 + tmp6;
    double tmp8 = tmp7 * 100;
    double tmp9 = tmp8;
    double tmp10 = perf->devinfo.n_eus;
    double tmp11 = tmp10 ? tmp9 / tmp10 : 0;
    double tmp12 = tmp11;
    double tmp13 = sklgt2__compute_extra__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp14 = tmp13 ? tmp12 / tmp13 : 0;

    return tmp14;
}

/* Media Vme Pipe Gen9 :: GPU Time Elapsed */
#define sklgt2__vme_pipe__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Media Vme Pipe Gen9 :: GPU Core Clocks */
#define sklgt2__vme_pipe__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Media Vme Pipe Gen9 :: AVG GPU Core Frequency */
#define sklgt2__vme_pipe__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Media Vme Pipe Gen9 :: AVG GPU Core Frequency */
#define sklgt2__vme_pipe__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Media Vme Pipe Gen9 :: GPU Busy */
#define sklgt2__vme_pipe__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Media Vme Pipe Gen9 :: CS Threads Dispatched */
#define sklgt2__vme_pipe__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Media Vme Pipe Gen9 :: EU Active */
#define sklgt2__vme_pipe__eu_active__read \
    bdw__render_basic__eu_active__read

/* Media Vme Pipe Gen9 :: EU Stall */
#define sklgt2__vme_pipe__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Media Vme Pipe Gen9 :: EU Both FPU Pipes Active */
#define sklgt2__vme_pipe__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Media Vme Pipe Gen9 :: EU Thread Occupancy */
#define sklgt2__vme_pipe__eu_thread_occupancy__read \
    bdw__vme_pipe__eu_thread_occupancy__read

/* Media Vme Pipe Gen9 :: VME Busy */
#define sklgt2__vme_pipe__vme_busy__read \
    bdw__vme_pipe__vme_busy__read

/* Gpu Rings Busyness :: GPU Time Elapsed */
#define sklgt2__gpu_busyness__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Gpu Rings Busyness :: GPU Core Clocks */
#define sklgt2__gpu_busyness__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Gpu Rings Busyness :: AVG GPU Core Frequency */
#define sklgt2__gpu_busyness__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Gpu Rings Busyness :: AVG GPU Core Frequency */
#define sklgt2__gpu_busyness__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Gpu Rings Busyness :: Render Ring Busy */
#define sklgt2__gpu_busyness__render_busy__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Gpu Rings Busyness :: Vdbox0 Ring Busy */
#define sklgt2__gpu_busyness__vdbox0_busy__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Gpu Rings Busyness :: Vebox Ring Busy */
#define sklgt2__gpu_busyness__vebox_busy__read \
    bdw__render_pipe_profile__sf_stall__read

/* Gpu Rings Busyness :: Blitter Ring Busy */
#define sklgt2__gpu_busyness__blitter_busy__read \
    bdw__render_pipe_profile__cl_stall__read

/* Gpu Rings Busyness :: AnyRingBusy */
#define sklgt2__gpu_busyness__any_ring_busy__read \
    bdw__render_basic__sampler0_busy__read

/* FF Bottlenecks :: GPU Time Elapsed */
#define sklgt2__ff_bottlenecks__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* FF Bottlenecks :: GPU Core Clocks */
#define sklgt2__ff_bottlenecks__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* FF Bottlenecks :: AVG GPU Core Frequency */
#define sklgt2__ff_bottlenecks__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* FF Bottlenecks :: AVG GPU Core Frequency */
#define sklgt2__ff_bottlenecks__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* FF Bottlenecks :: GPU Busy */
#define sklgt2__ff_bottlenecks__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* FF Bottlenecks :: VS Threads Dispatched */
#define sklgt2__ff_bottlenecks__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* FF Bottlenecks :: HS Threads Dispatched */
#define sklgt2__ff_bottlenecks__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* FF Bottlenecks :: DS Threads Dispatched */
#define sklgt2__ff_bottlenecks__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* FF Bottlenecks :: GS Threads Dispatched */
#define sklgt2__ff_bottlenecks__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* FF Bottlenecks :: FS Threads Dispatched */
#define sklgt2__ff_bottlenecks__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* FF Bottlenecks :: CS Threads Dispatched */
#define sklgt2__ff_bottlenecks__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* FF Bottlenecks :: Rasterized Pixels */
#define sklgt2__ff_bottlenecks__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* FF Bottlenecks :: Early Hi-Depth Test Fails */
#define sklgt2__ff_bottlenecks__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* FF Bottlenecks :: Early Depth Test Fails */
#define sklgt2__ff_bottlenecks__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* FF Bottlenecks :: Samples Killed in FS */
#define sklgt2__ff_bottlenecks__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* FF Bottlenecks :: Pixels Failing Tests */
#define sklgt2__ff_bottlenecks__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* FF Bottlenecks :: Samples Written */
#define sklgt2__ff_bottlenecks__samples_written__read \
    bdw__render_basic__samples_written__read

/* FF Bottlenecks :: Samples Blended */
#define sklgt2__ff_bottlenecks__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* FF Bottlenecks :: EU Active */
#define sklgt2__ff_bottlenecks__eu_active__read \
    bdw__render_basic__eu_active__read

/* FF Bottlenecks :: EU Stall */
#define sklgt2__ff_bottlenecks__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* FF Bottlenecks :: EU Both FPU Pipes Active */
#define sklgt2__ff_bottlenecks__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* FF Bottlenecks :: EU Thread Occupancy */
static double
sklgt2__ff_bottlenecks__eu_thread_occupancy__read(const struct intel_perf *perf,
                                                  const struct intel_perf_metric_set *metric_set,
                                                  uint64_t *accumulator)
{
    /* RPN equation: 8 A 17 READ FMUL $EuThreadsCount FDIV $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 17];
    double tmp1 = 8 * tmp0;
    double tmp2 = tmp1;
    double tmp3 = perf->devinfo.eu_threads_count;
    double tmp4 = tmp3 ? tmp2 / tmp3 : 0;
    uint64_t tmp5 = tmp4;
    uint64_t tmp6 = perf->devinfo.n_eus;
    uint64_t tmp7 = tmp6 ? tmp5 / tmp6 : 0;
    uint64_t tmp8 = tmp7 * 100;
    double tmp9 = tmp8;
    double tmp10 = sklgt2__ff_bottlenecks__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp11 = tmp10 ? tmp9 / tmp10 : 0;

    return tmp11;
}

/* FF Bottlenecks :: VS FPU0 Pipe Active */
#define sklgt2__ff_bottlenecks__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* FF Bottlenecks :: VS FPU1 Pipe Active */
#define sklgt2__ff_bottlenecks__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* FF Bottlenecks :: PS FPU0 Pipe Active */
#define sklgt2__ff_bottlenecks__ps_fpu0_active__read \
    bdw__compute_l3_cache__eu_hybrid_fpu0_instruction__read

/* FF Bottlenecks :: PS FPU1 Pipe Active */
#define sklgt2__ff_bottlenecks__ps_fpu1_active__read \
    bdw__compute_l3_cache__eu_hybrid_fpu1_instruction__read

/* FF Bottlenecks :: VS is sending vertices to CL */
static double
sklgt2__ff_bottlenecks__vs_cl_bypass__read(const struct intel_perf *perf,
                                           const struct intel_perf_metric_set *metric_set,
                                           uint64_t *accumulator)
{
    /* RPN equation: B 0 READ B 4 READ FADD 2 FDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 0];
    uint64_t tmp1 = accumulator[metric_set->b_offset + 4];
    double tmp2 = tmp0 + tmp1;
    double tmp3 = tmp2;
    double tmp4 = 2;
    double tmp5 = tmp4 ? tmp3 / tmp4 : 0;
    uint64_t tmp6 = tmp5 * 100;
    double tmp7 = tmp6;
    double tmp8 = sklgt2__ff_bottlenecks__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp9 = tmp8 ? tmp7 / tmp8 : 0;

    return tmp9;
}

/* FF Bottlenecks :: HS Bottleneck */
#define sklgt2__ff_bottlenecks__hs_bottleneck__read \
    bdw__render_basic__sampler1_bottleneck__read

/* FF Bottlenecks :: DS Bottleneck */
static double
sklgt2__ff_bottlenecks__ds_bottleneck__read(const struct intel_perf *perf,
                                            const struct intel_perf_metric_set *metric_set,
                                            uint64_t *accumulator)
{
    /* RPN equation: B 1 READ B 5 READ FADD 2 FDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 1];
    uint64_t tmp1 = accumulator[metric_set->b_offset + 5];
    double tmp2 = tmp0 + tmp1;
    double tmp3 = tmp2;
    double tmp4 = 2;
    double tmp5 = tmp4 ? tmp3 / tmp4 : 0;
    uint64_t tmp6 = tmp5 * 100;
    double tmp7 = tmp6;
    double tmp8 = sklgt2__ff_bottlenecks__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp9 = tmp8 ? tmp7 / tmp8 : 0;

    return tmp9;
}

/* FF Bottlenecks :: TE Bottleneck */
static double
sklgt2__ff_bottlenecks__te_bottleneck__read(const struct intel_perf *perf,
                                            const struct intel_perf_metric_set *metric_set,
                                            uint64_t *accumulator)
{
    /* RPN equation: B 2 READ B 6 READ FADD 2 FDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 2];
    uint64_t tmp1 = accumulator[metric_set->b_offset + 6];
    double tmp2 = tmp0 + tmp1;
    double tmp3 = tmp2;
    double tmp4 = 2;
    double tmp5 = tmp4 ? tmp3 / tmp4 : 0;
    uint64_t tmp6 = tmp5 * 100;
    double tmp7 = tmp6;
    double tmp8 = sklgt2__ff_bottlenecks__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp9 = tmp8 ? tmp7 / tmp8 : 0;

    return tmp9;
}

/* FF Bottlenecks :: GS Bottleneck */
#define sklgt2__ff_bottlenecks__gs_bottleneck__read \
    bdw__render_pipe_profile__early_depth_bottleneck__read

/* MDAPI testing set Gen9 :: GPU Time Elapsed */
#define sklgt2__test_oa__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* MDAPI testing set Gen9 :: GPU Core Clocks */
#define sklgt2__test_oa__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* MDAPI testing set Gen9 :: AVG GPU Core Frequency */
#define sklgt2__test_oa__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* MDAPI testing set Gen9 :: AVG GPU Core Frequency */
#define sklgt2__test_oa__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* MDAPI testing set Gen9 :: TestCounter0 */
#define sklgt2__test_oa__counter0__read \
    hsw__compute_extended__eu_untyped_reads0__read

/* MDAPI testing set Gen9 :: TestCounter1 */
#define sklgt2__test_oa__counter1__read \
    hsw__compute_extended__eu_untyped_writes0__read

/* MDAPI testing set Gen9 :: TestCounter2 */
#define sklgt2__test_oa__counter2__read \
    hsw__compute_extended__eu_typed_reads0__read

/* MDAPI testing set Gen9 :: TestCounter3 */
#define sklgt2__test_oa__counter3__read \
    hsw__compute_extended__eu_typed_writes0__read

/* MDAPI testing set Gen9 :: TestCounter4 */
#define sklgt2__test_oa__counter4__read \
    hsw__compute_extended__eu_untyped_atomics0__read

/* MDAPI testing set Gen9 :: TestCounter5 */
#define sklgt2__test_oa__counter5__read \
    hsw__compute_extended__eu_typed_atomics0__read

/* MDAPI testing set Gen9 :: TestCounter6 */
#define sklgt2__test_oa__counter6__read \
    hsw__compute_extended__eu_urb_atomics0__read

/* MDAPI testing set Gen9 :: TestCounter7 */
#define sklgt2__test_oa__counter7__read \
    hsw__compute_extended__gpu_clocks__read

/* MDAPI testing set Gen9 :: TestCounter8 */
#define sklgt2__test_oa__counter8__read \
    hsw__memory_reads__gpu_core_clocks__read

/* Metric set PMA Stall :: GPU Time Elapsed */
#define sklgt2__pma__stall__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set PMA Stall :: GPU Core Clocks */
#define sklgt2__pma__stall__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set PMA Stall :: AVG GPU Core Frequency */
#define sklgt2__pma__stall__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set PMA Stall :: AVG GPU Core Frequency */
#define sklgt2__pma__stall__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set PMA Stall :: STC PMA stall */
static double
sklgt2__pma__stall__stc_pma_stall__read(const struct intel_perf *perf,
                                        const struct intel_perf_metric_set *metric_set,
                                        uint64_t *accumulator)
{
    /* RPN equation: B 0 READ B 1 READ FADD 2 FDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 0];
    uint64_t tmp1 = accumulator[metric_set->b_offset + 1];
    double tmp2 = tmp0 + tmp1;
    double tmp3 = tmp2;
    double tmp4 = 2;
    double tmp5 = tmp4 ? tmp3 / tmp4 : 0;
    uint64_t tmp6 = tmp5 * 100;
    double tmp7 = tmp6;
    double tmp8 = sklgt2__pma__stall__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp9 = tmp8 ? tmp7 / tmp8 : 0;

    return tmp9;
}

/* Render Metrics Basic Gen9 :: GPU Time Elapsed */
#define sklgt3__render_basic__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Render Metrics Basic Gen9 :: GPU Core Clocks */
#define sklgt3__render_basic__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Render Metrics Basic Gen9 :: AVG GPU Core Frequency */
#define sklgt3__render_basic__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Render Metrics Basic Gen9 :: AVG GPU Core Frequency */
#define sklgt3__render_basic__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Render Metrics Basic Gen9 :: VS Threads Dispatched */
#define sklgt3__render_basic__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Render Metrics Basic Gen9 :: HS Threads Dispatched */
#define sklgt3__render_basic__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Render Metrics Basic Gen9 :: DS Threads Dispatched */
#define sklgt3__render_basic__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Render Metrics Basic Gen9 :: GS Threads Dispatched */
#define sklgt3__render_basic__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Render Metrics Basic Gen9 :: FS Threads Dispatched */
#define sklgt3__render_basic__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Render Metrics Basic Gen9 :: CS Threads Dispatched */
#define sklgt3__render_basic__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Render Metrics Basic Gen9 :: GPU Busy */
#define sklgt3__render_basic__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Render Metrics Basic Gen9 :: EU Active */
#define sklgt3__render_basic__eu_active__read \
    bdw__render_basic__eu_active__read

/* Render Metrics Basic Gen9 :: EU Stall */
#define sklgt3__render_basic__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Render Metrics Basic Gen9 :: EU Both FPU Pipes Active */
#define sklgt3__render_basic__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Render Metrics Basic Gen9 :: VS FPU0 Pipe Active */
#define sklgt3__render_basic__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Render Metrics Basic Gen9 :: VS FPU1 Pipe Active */
#define sklgt3__render_basic__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Render Metrics Basic Gen9 :: VS Send Pipe Active */
#define sklgt3__render_basic__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Render Metrics Basic Gen9 :: PS FPU0 Pipe Active */
#define sklgt3__render_basic__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Render Metrics Basic Gen9 :: PS FPU1 Pipe Active */
#define sklgt3__render_basic__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Render Metrics Basic Gen9 :: PS Send Pipeline Active */
#define sklgt3__render_basic__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Render Metrics Basic Gen9 :: FS Both FPU Active */
#define sklgt3__render_basic__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Render Metrics Basic Gen9 :: Sampler 0 Busy */
#define sklgt3__render_basic__sampler0_busy__read \
    bdw__render_basic__sampler0_busy__read

/* Render Metrics Basic Gen9 :: Sampler 1 Busy */
#define sklgt3__render_basic__sampler1_busy__read \
    bdw__render_basic__sampler1_busy__read

/* Render Metrics Basic Gen9 :: Samplers Busy */
#define sklgt3__render_basic__samplers_busy__read \
    bdw__render_basic__samplers_busy__read

/* Render Metrics Basic Gen9 :: Sampler 0 Bottleneck */
#define sklgt3__render_basic__sampler0_bottleneck__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Render Metrics Basic Gen9 :: Sampler 1 Bottleneck */
#define sklgt3__render_basic__sampler1_bottleneck__read \
    bdw__render_basic__sampler1_bottleneck__read

/* Render Metrics Basic Gen9 :: Rasterized Pixels */
#define sklgt3__render_basic__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Render Metrics Basic Gen9 :: Early Hi-Depth Test Fails */
#define sklgt3__render_basic__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Render Metrics Basic Gen9 :: Early Depth Test Fails */
#define sklgt3__render_basic__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Render Metrics Basic Gen9 :: Samples Killed in FS */
#define sklgt3__render_basic__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Render Metrics Basic Gen9 :: Pixels Failing Tests */
#define sklgt3__render_basic__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Render Metrics Basic Gen9 :: Samples Written */
#define sklgt3__render_basic__samples_written__read \
    bdw__render_basic__samples_written__read

/* Render Metrics Basic Gen9 :: Samples Blended */
#define sklgt3__render_basic__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Render Metrics Basic Gen9 :: Sampler Texels */
#define sklgt3__render_basic__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Render Metrics Basic Gen9 :: Sampler Texels Misses */
#define sklgt3__render_basic__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Render Metrics Basic Gen9 :: Sampler Cache Misses */
#define sklgt3__render_basic__sampler_l1_misses__read \
    bdw__render_basic__sampler_l1_misses__read

/* Render Metrics Basic Gen9 :: SLM Bytes Read */
#define sklgt3__render_basic__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Render Metrics Basic Gen9 :: SLM Bytes Read */
#define sklgt3__render_basic__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics Basic Gen9 :: SLM Bytes Written */
#define sklgt3__render_basic__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Render Metrics Basic Gen9 :: SLM Bytes Written */
#define sklgt3__render_basic__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics Basic Gen9 :: Shader Memory Accesses */
#define sklgt3__render_basic__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Render Metrics Basic Gen9 :: Shader Atomic Memory Accesses */
#define sklgt3__render_basic__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Render Metrics Basic Gen9 :: L3 Lookup Accesses w/o IC */
#define sklgt3__render_basic__l3_lookups__read \
    bdw__render_basic__l3_lookups__read

/* Render Metrics Basic Gen9 :: L3 Misses */
#define sklgt3__render_basic__l3_misses__read \
    hsw__compute_extended__typed_atomics0__read

/* Render Metrics Basic Gen9 :: L3 Sampler Throughput */
#define sklgt3__render_basic__l3_sampler_throughput__read \
    bdw__render_basic__l3_sampler_throughput__read

/* Render Metrics Basic Gen9 :: L3 Sampler Throughput */
#define sklgt3__render_basic__l3_sampler_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics Basic Gen9 :: L3 Shader Throughput */
#define sklgt3__render_basic__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Render Metrics Basic Gen9 :: L3 Shader Throughput */
#define sklgt3__render_basic__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics Basic Gen9 :: Shader Barrier Messages */
#define sklgt3__render_basic__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Render Metrics Basic Gen9 :: GTI Fixed Pipe Throughput */
#define sklgt3__render_basic__gti_vf_throughput__read \
    bdw__render_basic__gti_vf_throughput__read

/* Render Metrics Basic Gen9 :: GTI Fixed Pipe Throughput */
#define sklgt3__render_basic__gti_vf_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Render Metrics Basic Gen9 :: GTI Depth Throughput */
#define sklgt3__render_basic__gti_depth_throughput__read \
    bdw__render_basic__gti_depth_throughput__read

/* Render Metrics Basic Gen9 :: GTI Depth Throughput */
#define sklgt3__render_basic__gti_depth_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics Basic Gen9 :: GTI RCC Throughput */
#define sklgt3__render_basic__gti_rcc_throughput__read \
    bdw__render_basic__gti_rcc_throughput__read

/* Render Metrics Basic Gen9 :: GTI RCC Throughput */
#define sklgt3__render_basic__gti_rcc_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics Basic Gen9 :: GTI L3 Throughput */
#define sklgt3__render_basic__gti_l3_throughput__read \
    hsw__render_basic__gti_l3_throughput__read

/* Render Metrics Basic Gen9 :: GTI L3 Throughput */
#define sklgt3__render_basic__gti_l3_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics Basic Gen9 :: GTI HDC TLB Lookup Throughput */
#define sklgt3__render_basic__gti_hdc_lookups_throughput__read \
    bdw__render_basic__gti_hdc_lookups_throughput__read

/* Render Metrics Basic Gen9 :: GTI HDC TLB Lookup Throughput */
#define sklgt3__render_basic__gti_hdc_lookups_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics Basic Gen9 :: GTI Read Throughput */
#define sklgt3__render_basic__gti_read_throughput__read \
    bdw__render_basic__gti_read_throughput__read

/* Render Metrics Basic Gen9 :: GTI Read Throughput */
#define sklgt3__render_basic__gti_read_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Render Metrics Basic Gen9 :: GTI Write Throughput */
#define sklgt3__render_basic__gti_write_throughput__read \
    hsw__render_basic__gti_write_throughput__read

/* Render Metrics Basic Gen9 :: GTI Write Throughput */
#define sklgt3__render_basic__gti_write_throughput__max \
    bdw__render_basic__gti_write_throughput__max

/* Render Metrics Basic Gen9 :: Samplers Bottleneck */
#define sklgt3__render_basic__sampler_bottleneck__read \
    bdw__render_basic__sampler_bottleneck__read

/* Compute Metrics Basic Gen9 :: GPU Time Elapsed */
#define sklgt3__compute_basic__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Compute Metrics Basic Gen9 :: GPU Core Clocks */
#define sklgt3__compute_basic__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Compute Metrics Basic Gen9 :: AVG GPU Core Frequency */
#define sklgt3__compute_basic__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Compute Metrics Basic Gen9 :: AVG GPU Core Frequency */
#define sklgt3__compute_basic__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Compute Metrics Basic Gen9 :: GPU Busy */
#define sklgt3__compute_basic__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Compute Metrics Basic Gen9 :: VS Threads Dispatched */
#define sklgt3__compute_basic__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Compute Metrics Basic Gen9 :: HS Threads Dispatched */
#define sklgt3__compute_basic__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Compute Metrics Basic Gen9 :: DS Threads Dispatched */
#define sklgt3__compute_basic__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Compute Metrics Basic Gen9 :: GS Threads Dispatched */
#define sklgt3__compute_basic__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Compute Metrics Basic Gen9 :: FS Threads Dispatched */
#define sklgt3__compute_basic__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Compute Metrics Basic Gen9 :: CS Threads Dispatched */
#define sklgt3__compute_basic__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Compute Metrics Basic Gen9 :: EU Active */
#define sklgt3__compute_basic__eu_active__read \
    bdw__render_basic__eu_active__read

/* Compute Metrics Basic Gen9 :: EU Stall */
#define sklgt3__compute_basic__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Compute Metrics Basic Gen9 :: EU Both FPU Pipes Active */
#define sklgt3__compute_basic__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Compute Metrics Basic Gen9 :: EU FPU0 Pipe Active */
#define sklgt3__compute_basic__fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Compute Metrics Basic Gen9 :: EU FPU1 Pipe Active */
#define sklgt3__compute_basic__fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Compute Metrics Basic Gen9 :: EU AVG IPC Rate */
#define sklgt3__compute_basic__eu_avg_ipc_rate__read \
    bdw__compute_basic__eu_avg_ipc_rate__read

/* Compute Metrics Basic Gen9 :: EU AVG IPC Rate */
#define sklgt3__compute_basic__eu_avg_ipc_rate__max \
    bdw__compute_basic__eu_avg_ipc_rate__max

/* Compute Metrics Basic Gen9 :: EU Send Pipe Active */
#define sklgt3__compute_basic__eu_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Compute Metrics Basic Gen9 :: EU Thread Occupancy */
#define sklgt3__compute_basic__eu_thread_occupancy__read \
    bdw__compute_basic__eu_thread_occupancy__read

/* Compute Metrics Basic Gen9 :: Rasterized Pixels */
#define sklgt3__compute_basic__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Compute Metrics Basic Gen9 :: Early Hi-Depth Test Fails */
#define sklgt3__compute_basic__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Compute Metrics Basic Gen9 :: Early Depth Test Fails */
#define sklgt3__compute_basic__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Compute Metrics Basic Gen9 :: Samples Killed in FS */
#define sklgt3__compute_basic__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Compute Metrics Basic Gen9 :: Pixels Failing Tests */
#define sklgt3__compute_basic__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Compute Metrics Basic Gen9 :: Samples Written */
#define sklgt3__compute_basic__samples_written__read \
    bdw__render_basic__samples_written__read

/* Compute Metrics Basic Gen9 :: Samples Blended */
#define sklgt3__compute_basic__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Compute Metrics Basic Gen9 :: Sampler Texels */
#define sklgt3__compute_basic__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Compute Metrics Basic Gen9 :: Sampler Texels Misses */
#define sklgt3__compute_basic__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Compute Metrics Basic Gen9 :: SLM Bytes Read */
#define sklgt3__compute_basic__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Compute Metrics Basic Gen9 :: SLM Bytes Read */
#define sklgt3__compute_basic__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Basic Gen9 :: SLM Bytes Written */
#define sklgt3__compute_basic__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Compute Metrics Basic Gen9 :: SLM Bytes Written */
#define sklgt3__compute_basic__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Basic Gen9 :: Shader Memory Accesses */
#define sklgt3__compute_basic__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Compute Metrics Basic Gen9 :: Shader Atomic Memory Accesses */
#define sklgt3__compute_basic__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Compute Metrics Basic Gen9 :: L3 Shader Throughput */
#define sklgt3__compute_basic__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Compute Metrics Basic Gen9 :: L3 Shader Throughput */
#define sklgt3__compute_basic__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Basic Gen9 :: Shader Barrier Messages */
#define sklgt3__compute_basic__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Compute Metrics Basic Gen9 :: Typed Bytes Read */
#define sklgt3__compute_basic__typed_bytes_read__read \
    bdw__compute_basic__typed_bytes_read__read

/* Compute Metrics Basic Gen9 :: Typed Bytes Read */
#define sklgt3__compute_basic__typed_bytes_read__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen9 :: Typed Bytes Written */
#define sklgt3__compute_basic__typed_bytes_written__read \
    bdw__compute_basic__typed_bytes_written__read

/* Compute Metrics Basic Gen9 :: Typed Bytes Written */
#define sklgt3__compute_basic__typed_bytes_written__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen9 :: Untyped Bytes Read */
#define sklgt3__compute_basic__untyped_bytes_read__read \
    bdw__compute_basic__untyped_bytes_read__read

/* Compute Metrics Basic Gen9 :: Untyped Bytes Read */
#define sklgt3__compute_basic__untyped_bytes_read__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen9 :: Untyped Writes */
#define sklgt3__compute_basic__untyped_bytes_written__read \
    bdw__compute_basic__untyped_bytes_written__read

/* Compute Metrics Basic Gen9 :: Untyped Writes */
#define sklgt3__compute_basic__untyped_bytes_written__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen9 :: GTI Read Throughput */
#define sklgt3__compute_basic__gti_read_throughput__read \
    hsw__render_basic__gti_l3_throughput__read

/* Compute Metrics Basic Gen9 :: GTI Read Throughput */
#define sklgt3__compute_basic__gti_read_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen9 :: GTI Write Throughput */
#define sklgt3__compute_basic__gti_write_throughput__read \
    bdw__render_basic__gti_hdc_lookups_throughput__read

/* Compute Metrics Basic Gen9 :: GTI Write Throughput */
#define sklgt3__compute_basic__gti_write_throughput__max \
    bdw__render_basic__gti_write_throughput__max

/* Render Metrics for 3D Pipeline Profile Gen9 :: GPU Time Elapsed */
#define sklgt3__render_pipe_profile__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: GPU Core Clocks */
#define sklgt3__render_pipe_profile__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: AVG GPU Core Frequency */
#define sklgt3__render_pipe_profile__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: AVG GPU Core Frequency */
#define sklgt3__render_pipe_profile__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Render Metrics for 3D Pipeline Profile Gen9 :: GPU Busy */
#define sklgt3__render_pipe_profile__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: VS Threads Dispatched */
#define sklgt3__render_pipe_profile__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: HS Threads Dispatched */
#define sklgt3__render_pipe_profile__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: DS Threads Dispatched */
#define sklgt3__render_pipe_profile__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: GS Threads Dispatched */
#define sklgt3__render_pipe_profile__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: FS Threads Dispatched */
#define sklgt3__render_pipe_profile__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: CS Threads Dispatched */
#define sklgt3__render_pipe_profile__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: EU Active */
#define sklgt3__render_pipe_profile__eu_active__read \
    bdw__render_basic__eu_active__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: EU Stall */
#define sklgt3__render_pipe_profile__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Rasterized Pixels */
#define sklgt3__render_pipe_profile__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Early Hi-Depth Test Fails */
#define sklgt3__render_pipe_profile__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Early Depth Test Fails */
#define sklgt3__render_pipe_profile__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Samples Killed in FS */
#define sklgt3__render_pipe_profile__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Pixels Failing Tests */
#define sklgt3__render_pipe_profile__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Samples Written */
#define sklgt3__render_pipe_profile__samples_written__read \
    bdw__render_basic__samples_written__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Samples Blended */
#define sklgt3__render_pipe_profile__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Sampler Texels */
#define sklgt3__render_pipe_profile__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Sampler Texels Misses */
#define sklgt3__render_pipe_profile__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: SLM Bytes Read */
#define sklgt3__render_pipe_profile__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: SLM Bytes Read */
#define sklgt3__render_pipe_profile__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics for 3D Pipeline Profile Gen9 :: SLM Bytes Written */
#define sklgt3__render_pipe_profile__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: SLM Bytes Written */
#define sklgt3__render_pipe_profile__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics for 3D Pipeline Profile Gen9 :: Shader Memory Accesses */
#define sklgt3__render_pipe_profile__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Shader Atomic Memory Accesses */
#define sklgt3__render_pipe_profile__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: L3 Shader Throughput */
#define sklgt3__render_pipe_profile__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: L3 Shader Throughput */
#define sklgt3__render_pipe_profile__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics for 3D Pipeline Profile Gen9 :: Shader Barrier Messages */
#define sklgt3__render_pipe_profile__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: VF Bottleneck */
#define sklgt3__render_pipe_profile__vf_bottleneck__read \
    bdw__render_pipe_profile__vf_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: VS Bottleneck */
#define sklgt3__render_pipe_profile__vs_bottleneck__read \
    bdw__render_basic__sampler0_busy__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: HS Bottleneck */
#define sklgt3__render_pipe_profile__hs_bottleneck__read \
    bdw__render_basic__sampler1_busy__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: DS Bottleneck */
#define sklgt3__render_pipe_profile__ds_bottleneck__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: GS Bottleneck */
#define sklgt3__render_pipe_profile__gs_bottleneck__read \
    bdw__render_basic__sampler1_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: SO Bottleneck */
#define sklgt3__render_pipe_profile__so_bottleneck__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Clipper Bottleneck */
#define sklgt3__render_pipe_profile__cl_bottleneck__read \
    bdw__render_pipe_profile__cl_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Strip-Fans Bottleneck */
#define sklgt3__render_pipe_profile__sf_bottleneck__read \
    bdw__render_pipe_profile__sf_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Hi-Depth Bottleneck */
#define sklgt3__render_pipe_profile__hi_depth_bottleneck__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Early Depth Bottleneck */
#define sklgt3__render_pipe_profile__early_depth_bottleneck__read \
    bdw__render_pipe_profile__early_depth_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: BC Bottleneck */
#define sklgt3__render_pipe_profile__bc_bottleneck__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: HS Stall */
#define sklgt3__render_pipe_profile__hs_stall__read \
    bdw__render_pipe_profile__hs_stall__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: DS Stall */
#define sklgt3__render_pipe_profile__ds_stall__read \
    bdw__render_pipe_profile__ds_stall__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: SO Stall */
#define sklgt3__render_pipe_profile__so_stall__read \
    bdw__render_pipe_profile__so_stall__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: CL Stall */
#define sklgt3__render_pipe_profile__cl_stall__read \
    bdw__render_pipe_profile__cl_stall__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: SF Stall */
#define sklgt3__render_pipe_profile__sf_stall__read \
    bdw__render_pipe_profile__sf_stall__read

/* Memory Reads Distribution Gen9 :: GPU Time Elapsed */
#define sklgt3__memory_reads__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Memory Reads Distribution Gen9 :: GPU Core Clocks */
#define sklgt3__memory_reads__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Memory Reads Distribution Gen9 :: AVG GPU Core Frequency */
#define sklgt3__memory_reads__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Memory Reads Distribution Gen9 :: AVG GPU Core Frequency */
#define sklgt3__memory_reads__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Memory Reads Distribution Gen9 :: GPU Busy */
#define sklgt3__memory_reads__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Memory Reads Distribution Gen9 :: VS Threads Dispatched */
#define sklgt3__memory_reads__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Memory Reads Distribution Gen9 :: HS Threads Dispatched */
#define sklgt3__memory_reads__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Memory Reads Distribution Gen9 :: DS Threads Dispatched */
#define sklgt3__memory_reads__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Memory Reads Distribution Gen9 :: GS Threads Dispatched */
#define sklgt3__memory_reads__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Memory Reads Distribution Gen9 :: FS Threads Dispatched */
#define sklgt3__memory_reads__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Memory Reads Distribution Gen9 :: CS Threads Dispatched */
#define sklgt3__memory_reads__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Memory Reads Distribution Gen9 :: EU Active */
#define sklgt3__memory_reads__eu_active__read \
    bdw__render_basic__eu_active__read

/* Memory Reads Distribution Gen9 :: EU Stall */
#define sklgt3__memory_reads__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Memory Reads Distribution Gen9 :: Rasterized Pixels */
#define sklgt3__memory_reads__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Memory Reads Distribution Gen9 :: Early Hi-Depth Test Fails */
#define sklgt3__memory_reads__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Memory Reads Distribution Gen9 :: Early Depth Test Fails */
#define sklgt3__memory_reads__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Memory Reads Distribution Gen9 :: Samples Killed in FS */
#define sklgt3__memory_reads__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Memory Reads Distribution Gen9 :: Pixels Failing Tests */
#define sklgt3__memory_reads__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Memory Reads Distribution Gen9 :: Samples Written */
#define sklgt3__memory_reads__samples_written__read \
    bdw__render_basic__samples_written__read

/* Memory Reads Distribution Gen9 :: Samples Blended */
#define sklgt3__memory_reads__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Memory Reads Distribution Gen9 :: Sampler Texels */
#define sklgt3__memory_reads__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Memory Reads Distribution Gen9 :: Sampler Texels Misses */
#define sklgt3__memory_reads__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Memory Reads Distribution Gen9 :: SLM Bytes Read */
#define sklgt3__memory_reads__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Memory Reads Distribution Gen9 :: SLM Bytes Read */
#define sklgt3__memory_reads__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Memory Reads Distribution Gen9 :: SLM Bytes Written */
#define sklgt3__memory_reads__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Memory Reads Distribution Gen9 :: SLM Bytes Written */
#define sklgt3__memory_reads__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Memory Reads Distribution Gen9 :: Shader Memory Accesses */
#define sklgt3__memory_reads__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Memory Reads Distribution Gen9 :: Shader Atomic Memory Accesses */
#define sklgt3__memory_reads__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Memory Reads Distribution Gen9 :: Shader Barrier Messages */
#define sklgt3__memory_reads__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Memory Reads Distribution Gen9 :: GtiCmdStreamerMemoryReads */
#define sklgt3__memory_reads__gti_cmd_streamer_memory_reads__read \
    hsw__compute_extended__eu_untyped_reads0__read

/* Memory Reads Distribution Gen9 :: GtiRsMemoryReads */
#define sklgt3__memory_reads__gti_rs_memory_reads__read \
    hsw__compute_extended__eu_typed_reads0__read

/* Memory Reads Distribution Gen9 :: GtiVfMemoryReads */
#define sklgt3__memory_reads__gti_vf_memory_reads__read \
    hsw__compute_extended__eu_untyped_writes0__read

/* Memory Reads Distribution Gen9 :: GtiRccMemoryReads */
#define sklgt3__memory_reads__gti_rcc_memory_reads__read \
    hsw__compute_extended__eu_typed_writes0__read

/* Memory Reads Distribution Gen9 :: GtiMscMemoryReads */
#define sklgt3__memory_reads__gti_msc_memory_reads__read \
    hsw__compute_extended__eu_untyped_atomics0__read

/* Memory Reads Distribution Gen9 :: GtiHizMemoryReads */
#define sklgt3__memory_reads__gti_hiz_memory_reads__read \
    hsw__compute_extended__eu_typed_atomics0__read

/* Memory Reads Distribution Gen9 :: GtiStcMemoryReads */
#define sklgt3__memory_reads__gti_stc_memory_reads__read \
    hsw__compute_extended__eu_urb_atomics0__read

/* Memory Reads Distribution Gen9 :: GtiRczMemoryReads */
#define sklgt3__memory_reads__gti_rcz_memory_reads__read \
    hsw__compute_extended__gpu_clocks__read

/* Memory Reads Distribution Gen9 :: GtiMemoryReads */
#define sklgt3__memory_reads__gti_memory_reads__read \
    hsw__compute_extended__typed_writes0__read

/* Memory Reads Distribution Gen9 :: GtiL3Bank0Reads */
#define sklgt3__memory_reads__gti_l3_bank0_reads__read \
    hsw__compute_extended__typed_atomics0__read

/* Memory Reads Distribution Gen9 :: GtiL3Bank1Reads */
#define sklgt3__memory_reads__gti_l3_bank1_reads__read \
    hsw__memory_reads__gti_memory_reads__read

/* Memory Reads Distribution Gen9 :: GtiL3Bank2Reads */
#define sklgt3__memory_reads__gti_l3_bank2_reads__read \
    hsw__memory_reads__llc_read_accesses__read

/* Memory Reads Distribution Gen9 :: GtiL3Bank3Reads */
#define sklgt3__memory_reads__gti_l3_bank3_reads__read \
    hsw__memory_reads__gpu_core_clocks__read

/* Memory Reads Distribution Gen9 :: GtiL3Reads */
#define sklgt3__memory_reads__gti_l3_reads__read \
    bdw__memory_reads__gti_l3_reads__read

/* Memory Reads Distribution Gen9 :: GtiRingAccesses */
#define sklgt3__memory_reads__gti_ring_accesses__read \
    bdw__memory_reads__gti_ring_accesses__read

/* Memory Writes Distribution Gen9 :: GPU Time Elapsed */
#define sklgt3__memory_writes__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Memory Writes Distribution Gen9 :: GPU Core Clocks */
#define sklgt3__memory_writes__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Memory Writes Distribution Gen9 :: AVG GPU Core Frequency */
#define sklgt3__memory_writes__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Memory Writes Distribution Gen9 :: AVG GPU Core Frequency */
#define sklgt3__memory_writes__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Memory Writes Distribution Gen9 :: GPU Busy */
#define sklgt3__memory_writes__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Memory Writes Distribution Gen9 :: VS Threads Dispatched */
#define sklgt3__memory_writes__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Memory Writes Distribution Gen9 :: HS Threads Dispatched */
#define sklgt3__memory_writes__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Memory Writes Distribution Gen9 :: DS Threads Dispatched */
#define sklgt3__memory_writes__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Memory Writes Distribution Gen9 :: GS Threads Dispatched */
#define sklgt3__memory_writes__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Memory Writes Distribution Gen9 :: FS Threads Dispatched */
#define sklgt3__memory_writes__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Memory Writes Distribution Gen9 :: CS Threads Dispatched */
#define sklgt3__memory_writes__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Memory Writes Distribution Gen9 :: EU Active */
#define sklgt3__memory_writes__eu_active__read \
    bdw__render_basic__eu_active__read

/* Memory Writes Distribution Gen9 :: EU Stall */
#define sklgt3__memory_writes__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Memory Writes Distribution Gen9 :: Rasterized Pixels */
#define sklgt3__memory_writes__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Memory Writes Distribution Gen9 :: Early Hi-Depth Test Fails */
#define sklgt3__memory_writes__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Memory Writes Distribution Gen9 :: Early Depth Test Fails */
#define sklgt3__memory_writes__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Memory Writes Distribution Gen9 :: Samples Killed in FS */
#define sklgt3__memory_writes__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Memory Writes Distribution Gen9 :: Pixels Failing Tests */
#define sklgt3__memory_writes__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Memory Writes Distribution Gen9 :: Samples Written */
#define sklgt3__memory_writes__samples_written__read \
    bdw__render_basic__samples_written__read

/* Memory Writes Distribution Gen9 :: Samples Blended */
#define sklgt3__memory_writes__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Memory Writes Distribution Gen9 :: Sampler Texels */
#define sklgt3__memory_writes__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Memory Writes Distribution Gen9 :: Sampler Texels Misses */
#define sklgt3__memory_writes__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Memory Writes Distribution Gen9 :: SLM Bytes Read */
#define sklgt3__memory_writes__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Memory Writes Distribution Gen9 :: SLM Bytes Read */
#define sklgt3__memory_writes__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Memory Writes Distribution Gen9 :: SLM Bytes Written */
#define sklgt3__memory_writes__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Memory Writes Distribution Gen9 :: SLM Bytes Written */
#define sklgt3__memory_writes__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Memory Writes Distribution Gen9 :: Shader Memory Accesses */
#define sklgt3__memory_writes__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Memory Writes Distribution Gen9 :: Shader Atomic Memory Accesses */
#define sklgt3__memory_writes__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Memory Writes Distribution Gen9 :: L3 Shader Throughput */
#define sklgt3__memory_writes__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Memory Writes Distribution Gen9 :: L3 Shader Throughput */
#define sklgt3__memory_writes__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Memory Writes Distribution Gen9 :: Shader Barrier Messages */
#define sklgt3__memory_writes__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Memory Writes Distribution Gen9 :: GtiCmdStreamerMemoryWrites */
#define sklgt3__memory_writes__gti_cmd_streamer_memory_writes__read \
    hsw__compute_extended__eu_untyped_reads0__read

/* Memory Writes Distribution Gen9 :: GtiSoMemoryWrites */
#define sklgt3__memory_writes__gti_so_memory_writes__read \
    hsw__compute_extended__eu_typed_reads0__read

/* Memory Writes Distribution Gen9 :: GtiRccMemoryWrites */
#define sklgt3__memory_writes__gti_rcc_memory_writes__read \
    hsw__compute_extended__eu_typed_writes0__read

/* Memory Writes Distribution Gen9 :: GtiMscMemoryWrites */
#define sklgt3__memory_writes__gti_msc_memory_writes__read \
    hsw__compute_extended__eu_untyped_atomics0__read

/* Memory Writes Distribution Gen9 :: GtiHizMemoryWrites */
#define sklgt3__memory_writes__gti_hiz_memory_writes__read \
    hsw__compute_extended__eu_typed_atomics0__read

/* Memory Writes Distribution Gen9 :: GtiStcMemoryWrites */
#define sklgt3__memory_writes__gti_stc_memory_writes__read \
    hsw__compute_extended__eu_urb_atomics0__read

/* Memory Writes Distribution Gen9 :: GtiRczMemoryWrites */
#define sklgt3__memory_writes__gti_rcz_memory_writes__read \
    hsw__compute_extended__gpu_clocks__read

/* Memory Writes Distribution Gen9 :: GtiMemoryWrites */
#define sklgt3__memory_writes__gti_memory_writes__read \
    hsw__compute_extended__typed_writes0__read

/* Memory Writes Distribution Gen9 :: GtiL3Bank0Writes */
#define sklgt3__memory_writes__gti_l3_bank0_writes__read \
    hsw__compute_extended__typed_atomics0__read

/* Memory Writes Distribution Gen9 :: GtiL3Bank1Writes */
#define sklgt3__memory_writes__gti_l3_bank1_writes__read \
    hsw__memory_reads__gti_memory_reads__read

/* Memory Writes Distribution Gen9 :: GtiL3Bank2Writes */
#define sklgt3__memory_writes__gti_l3_bank2_writes__read \
    hsw__memory_reads__llc_read_accesses__read

/* Memory Writes Distribution Gen9 :: GtiL3Bank3Writes */
#define sklgt3__memory_writes__gti_l3_bank3_writes__read \
    hsw__memory_reads__gpu_core_clocks__read

/* Memory Writes Distribution Gen9 :: GtiL3Writes */
#define sklgt3__memory_writes__gti_l3_writes__read \
    bdw__memory_reads__gti_l3_reads__read

/* Memory Writes Distribution Gen9 :: GtiRingAccesses */
#define sklgt3__memory_writes__gti_ring_accesses__read \
    bdw__memory_reads__gti_ring_accesses__read

/* Compute Metrics Extended Gen9 :: GPU Time Elapsed */
#define sklgt3__compute_extended__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Compute Metrics Extended Gen9 :: GPU Core Clocks */
#define sklgt3__compute_extended__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Compute Metrics Extended Gen9 :: AVG GPU Core Frequency */
#define sklgt3__compute_extended__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Compute Metrics Extended Gen9 :: AVG GPU Core Frequency */
#define sklgt3__compute_extended__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Compute Metrics Extended Gen9 :: CS Threads Dispatched */
#define sklgt3__compute_extended__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Compute Metrics Extended Gen9 :: EU Active */
#define sklgt3__compute_extended__eu_active__read \
    bdw__render_basic__eu_active__read

/* Compute Metrics Extended Gen9 :: EU Stall */
#define sklgt3__compute_extended__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Compute Metrics Extended Gen9 :: EU Both FPU Pipes Active */
#define sklgt3__compute_extended__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Compute Metrics Extended Gen9 :: EU FPU0 Pipe Active */
#define sklgt3__compute_extended__fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Compute Metrics Extended Gen9 :: EU FPU1 Pipe Active */
#define sklgt3__compute_extended__fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Compute Metrics Extended Gen9 :: EU AVG IPC Rate */
#define sklgt3__compute_extended__eu_avg_ipc_rate__read \
    bdw__compute_basic__eu_avg_ipc_rate__read

/* Compute Metrics Extended Gen9 :: EU AVG IPC Rate */
#define sklgt3__compute_extended__eu_avg_ipc_rate__max \
    bdw__compute_basic__eu_avg_ipc_rate__max

/* Compute Metrics Extended Gen9 :: EU Send Pipe Active */
#define sklgt3__compute_extended__eu_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Compute Metrics Extended Gen9 :: EU Thread Occupancy */
#define sklgt3__compute_extended__eu_thread_occupancy__read \
    bdw__compute_basic__eu_thread_occupancy__read

/* Compute Metrics Extended Gen9 :: Sampler Texels */
#define sklgt3__compute_extended__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Compute Metrics Extended Gen9 :: Sampler Texels Misses */
#define sklgt3__compute_extended__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Compute Metrics Extended Gen9 :: SLM Bytes Read */
#define sklgt3__compute_extended__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Compute Metrics Extended Gen9 :: SLM Bytes Read */
#define sklgt3__compute_extended__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Extended Gen9 :: SLM Bytes Written */
#define sklgt3__compute_extended__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Compute Metrics Extended Gen9 :: SLM Bytes Written */
#define sklgt3__compute_extended__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Extended Gen9 :: Shader Memory Accesses */
#define sklgt3__compute_extended__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Compute Metrics Extended Gen9 :: Shader Atomic Memory Accesses */
#define sklgt3__compute_extended__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Compute Metrics Extended Gen9 :: L3 Shader Throughput */
#define sklgt3__compute_extended__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Compute Metrics Extended Gen9 :: L3 Shader Throughput */
#define sklgt3__compute_extended__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Extended Gen9 :: Shader Barrier Messages */
#define sklgt3__compute_extended__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Compute Metrics Extended Gen9 :: EuUntypedReads0 */
#define sklgt3__compute_extended__eu_untyped_reads0__read \
    hsw__compute_extended__eu_untyped_reads0__read

/* Compute Metrics Extended Gen9 :: EuTypedReads0 */
#define sklgt3__compute_extended__eu_typed_reads0__read \
    hsw__compute_extended__eu_typed_reads0__read

/* Compute Metrics Extended Gen9 :: EuUntypedWrites0 */
#define sklgt3__compute_extended__eu_untyped_writes0__read \
    hsw__compute_extended__eu_untyped_writes0__read

/* Compute Metrics Extended Gen9 :: EuTypedWrites0 */
#define sklgt3__compute_extended__eu_typed_writes0__read \
    hsw__compute_extended__eu_typed_writes0__read

/* Compute Metrics Extended Gen9 :: EuUntypedAtomics0 */
#define sklgt3__compute_extended__eu_untyped_atomics0__read \
    hsw__compute_extended__eu_untyped_atomics0__read

/* Compute Metrics Extended Gen9 :: EuTypedAtomics0 */
#define sklgt3__compute_extended__eu_typed_atomics0__read \
    hsw__compute_extended__eu_typed_atomics0__read

/* Compute Metrics Extended Gen9 :: EuA64UntypedReads0 */
#define sklgt3__compute_extended__eu_a64_untyped_reads0__read \
    hsw__compute_extended__eu_urb_atomics0__read

/* Compute Metrics Extended Gen9 :: EuA64UntypedWrites0 */
#define sklgt3__compute_extended__eu_a64_untyped_writes0__read \
    hsw__compute_extended__gpu_clocks__read

/* Compute Metrics Extended Gen9 :: Typed Reads 0 */
#define sklgt3__compute_extended__typed_reads0__read \
    hsw__render_basic__gpu_core_clocks__read

/* Compute Metrics Extended Gen9 :: Typed Writes 0 */
#define sklgt3__compute_extended__typed_writes0__read \
    hsw__compute_extended__typed_writes0__read

/* Compute Metrics Extended Gen9 :: Untyped Reads 0 */
#define sklgt3__compute_extended__untyped_reads0__read \
    hsw__compute_extended__untyped_reads0__read

/* Compute Metrics Extended Gen9 :: Untyped Writes 0 */
#define sklgt3__compute_extended__untyped_writes0__read \
    hsw__compute_extended__untyped_writes0__read

/* Compute Metrics Extended Gen9 :: Typed Atomics 0 */
#define sklgt3__compute_extended__typed_atomics0__read \
    hsw__compute_extended__typed_atomics0__read

/* Compute Metrics Extended Gen9 :: TypedReadsPerCacheLine */
#define sklgt3__compute_extended__typed_reads_per_cache_line__read \
    hsw__compute_extended__typed_reads_per_cache_line__read

/* Compute Metrics Extended Gen9 :: TypedWritesPerCacheLine */
#define sklgt3__compute_extended__typed_writes_per_cache_line__read \
    hsw__compute_extended__typed_writes_per_cache_line__read

/* Compute Metrics Extended Gen9 :: UntypedReadsPerCacheLine */
#define sklgt3__compute_extended__untyped_reads_per_cache_line__read \
    bdw__compute_extended__untyped_reads_per_cache_line__read

/* Compute Metrics Extended Gen9 :: UntypedWritesPerCacheLine */
#define sklgt3__compute_extended__untyped_writes_per_cache_line__read \
    bdw__compute_extended__untyped_writes_per_cache_line__read

/* Compute Metrics Extended Gen9 :: TypedAtomicsPerCacheLine */
#define sklgt3__compute_extended__typed_atomics_per_cache_line__read \
    hsw__compute_extended__typed_atomics_per_cache_line__read

/* Compute Metrics L3 Cache Gen9 :: GPU Time Elapsed */
#define sklgt3__compute_l3_cache__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Compute Metrics L3 Cache Gen9 :: GPU Core Clocks */
#define sklgt3__compute_l3_cache__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Compute Metrics L3 Cache Gen9 :: AVG GPU Core Frequency */
#define sklgt3__compute_l3_cache__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Compute Metrics L3 Cache Gen9 :: AVG GPU Core Frequency */
#define sklgt3__compute_l3_cache__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Compute Metrics L3 Cache Gen9 :: GPU Busy */
#define sklgt3__compute_l3_cache__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Compute Metrics L3 Cache Gen9 :: VS Threads Dispatched */
#define sklgt3__compute_l3_cache__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Compute Metrics L3 Cache Gen9 :: HS Threads Dispatched */
#define sklgt3__compute_l3_cache__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Compute Metrics L3 Cache Gen9 :: DS Threads Dispatched */
#define sklgt3__compute_l3_cache__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Compute Metrics L3 Cache Gen9 :: GS Threads Dispatched */
#define sklgt3__compute_l3_cache__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Compute Metrics L3 Cache Gen9 :: FS Threads Dispatched */
#define sklgt3__compute_l3_cache__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Compute Metrics L3 Cache Gen9 :: CS Threads Dispatched */
#define sklgt3__compute_l3_cache__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Compute Metrics L3 Cache Gen9 :: EU Active */
#define sklgt3__compute_l3_cache__eu_active__read \
    bdw__render_basic__eu_active__read

/* Compute Metrics L3 Cache Gen9 :: EU Stall */
#define sklgt3__compute_l3_cache__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Compute Metrics L3 Cache Gen9 :: EU Both FPU Pipes Active */
#define sklgt3__compute_l3_cache__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU0 Pipe Active */
#define sklgt3__compute_l3_cache__fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU1 Pipe Active */
#define sklgt3__compute_l3_cache__fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Compute Metrics L3 Cache Gen9 :: EU AVG IPC Rate */
#define sklgt3__compute_l3_cache__eu_avg_ipc_rate__read \
    bdw__compute_basic__eu_avg_ipc_rate__read

/* Compute Metrics L3 Cache Gen9 :: EU AVG IPC Rate */
#define sklgt3__compute_l3_cache__eu_avg_ipc_rate__max \
    bdw__compute_basic__eu_avg_ipc_rate__max

/* Compute Metrics L3 Cache Gen9 :: EU Send Pipe Active */
#define sklgt3__compute_l3_cache__eu_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU0 Hybrid Instruction */
#define sklgt3__compute_l3_cache__eu_hybrid_fpu0_instruction__read \
    bdw__compute_l3_cache__eu_hybrid_fpu0_instruction__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU1 Hybrid Instruction */
#define sklgt3__compute_l3_cache__eu_hybrid_fpu1_instruction__read \
    bdw__compute_l3_cache__eu_hybrid_fpu1_instruction__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU0 Ternary Instruction */
#define sklgt3__compute_l3_cache__eu_ternary_fpu0_instruction__read \
    bdw__render_basic__ps_fpu0_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU1 Ternary Instruction */
#define sklgt3__compute_l3_cache__eu_ternary_fpu1_instruction__read \
    bdw__render_basic__ps_fpu1_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU0 Binary Instruction */
#define sklgt3__compute_l3_cache__eu_binary_fpu0_instruction__read \
    bdw__render_basic__ps_send_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU1 Binary Instruction */
#define sklgt3__compute_l3_cache__eu_binary_fpu1_instruction__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU0 Move Instruction */
#define sklgt3__compute_l3_cache__eu_move_fpu0_instruction__read \
    bdw__compute_l3_cache__eu_move_fpu0_instruction__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU1 Move Instruction */
#define sklgt3__compute_l3_cache__eu_move_fpu1_instruction__read \
    bdw__compute_l3_cache__eu_move_fpu1_instruction__read

/* Compute Metrics L3 Cache Gen9 :: Rasterized Pixels */
#define sklgt3__compute_l3_cache__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Compute Metrics L3 Cache Gen9 :: Early Hi-Depth Test Fails */
#define sklgt3__compute_l3_cache__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Compute Metrics L3 Cache Gen9 :: Early Depth Test Fails */
#define sklgt3__compute_l3_cache__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Compute Metrics L3 Cache Gen9 :: Samples Killed in FS */
#define sklgt3__compute_l3_cache__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Compute Metrics L3 Cache Gen9 :: Pixels Failing Tests */
#define sklgt3__compute_l3_cache__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Compute Metrics L3 Cache Gen9 :: Samples Written */
#define sklgt3__compute_l3_cache__samples_written__read \
    bdw__render_basic__samples_written__read

/* Compute Metrics L3 Cache Gen9 :: Samples Blended */
#define sklgt3__compute_l3_cache__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Compute Metrics L3 Cache Gen9 :: Sampler Accesses */
#define sklgt3__compute_l3_cache__sampler_accesses__read \
    bdw__render_pipe_profile__sampler_accesses__read

/* Compute Metrics L3 Cache Gen9 :: Sampler Texels */
#define sklgt3__compute_l3_cache__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Compute Metrics L3 Cache Gen9 :: Sampler Texels Misses */
#define sklgt3__compute_l3_cache__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Compute Metrics L3 Cache Gen9 :: SLM Bytes Read */
#define sklgt3__compute_l3_cache__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Compute Metrics L3 Cache Gen9 :: SLM Bytes Read */
#define sklgt3__compute_l3_cache__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics L3 Cache Gen9 :: SLM Bytes Written */
#define sklgt3__compute_l3_cache__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Compute Metrics L3 Cache Gen9 :: SLM Bytes Written */
#define sklgt3__compute_l3_cache__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics L3 Cache Gen9 :: Shader Memory Accesses */
#define sklgt3__compute_l3_cache__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Compute Metrics L3 Cache Gen9 :: Shader Atomic Memory Accesses */
#define sklgt3__compute_l3_cache__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Compute Metrics L3 Cache Gen9 :: L3 Accesses */
#define sklgt3__compute_l3_cache__l3_accesses__read \
    sklgt2__compute_l3_cache__l3_accesses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Misses */
#define sklgt3__compute_l3_cache__l3_misses__read \
    bdw__compute_l3_cache__l3_misses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Sampler Throughput */
#define sklgt3__compute_l3_cache__l3_sampler_throughput__read \
    chv__render_basic__l3_sampler_throughput__read

/* Compute Metrics L3 Cache Gen9 :: L3 Sampler Throughput */
#define sklgt3__compute_l3_cache__l3_sampler_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics L3 Cache Gen9 :: L3 Shader Throughput */
#define sklgt3__compute_l3_cache__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Compute Metrics L3 Cache Gen9 :: L3 Shader Throughput */
#define sklgt3__compute_l3_cache__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics L3 Cache Gen9 :: L3 Total Throughput */
#define sklgt3__compute_l3_cache__l3_total_throughput__read \
    sklgt2__compute_l3_cache__l3_total_throughput__read

/* Compute Metrics L3 Cache Gen9 :: L3 Total Throughput */
#define sklgt3__compute_l3_cache__l3_total_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics L3 Cache Gen9 :: Shader Barrier Messages */
#define sklgt3__compute_l3_cache__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Compute Metrics L3 Cache Gen9 :: L3 Bank 00 Accesses */
#define sklgt3__compute_l3_cache__l3_bank00_accesses__read \
    bdw__compute_l3_cache__l3_bank00_accesses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Bank 01 Accesses */
#define sklgt3__compute_l3_cache__l3_bank01_accesses__read \
    bdw__compute_l3_cache__l3_bank01_accesses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Bank 02 Accesses */
#define sklgt3__compute_l3_cache__l3_bank02_accesses__read \
    bdw__compute_l3_cache__l3_bank02_accesses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Bank 03 Accesses */
#define sklgt3__compute_l3_cache__l3_bank03_accesses__read \
    bdw__compute_l3_cache__l3_bank03_accesses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Bank 00 IC Accesses */
#define sklgt3__compute_l3_cache__l3_bank00_ic_accesses__read \
    bdw__compute_l3_cache__l3_bank00_ic_accesses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Bank 00 IC Hits */
#define sklgt3__compute_l3_cache__l3_bank00_ic_hits__read \
    bdw__compute_l3_cache__l3_bank00_ic_hits__read

/* Compute Metrics L3 Cache Gen9 :: GTI L3 Throughput */
#define sklgt3__compute_l3_cache__gti_l3_throughput__read \
    bdw__compute_l3_cache__gti_l3_throughput__read

/* Compute Metrics L3 Cache Gen9 :: GTI L3 Throughput */
#define sklgt3__compute_l3_cache__gti_l3_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics L3 Cache Gen9 :: GTI Read Throughput */
#define sklgt3__compute_l3_cache__gti_read_throughput__read \
    bdw__render_basic__gti_read_throughput__read

/* Compute Metrics L3 Cache Gen9 :: GTI Read Throughput */
#define sklgt3__compute_l3_cache__gti_read_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Compute Metrics L3 Cache Gen9 :: GTI Write Throughput */
#define sklgt3__compute_l3_cache__gti_write_throughput__read \
    hsw__render_basic__gti_write_throughput__read

/* Compute Metrics L3 Cache Gen9 :: GTI Write Throughput */
#define sklgt3__compute_l3_cache__gti_write_throughput__max \
    bdw__render_basic__gti_write_throughput__max

/* Metric set HDCAndSF :: GPU Time Elapsed */
#define sklgt3__hdc_and_sf__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set HDCAndSF :: GPU Core Clocks */
#define sklgt3__hdc_and_sf__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set HDCAndSF :: AVG GPU Core Frequency */
#define sklgt3__hdc_and_sf__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set HDCAndSF :: AVG GPU Core Frequency */
#define sklgt3__hdc_and_sf__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set HDCAndSF :: GPU Busy */
#define sklgt3__hdc_and_sf__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set HDCAndSF :: VS Threads Dispatched */
#define sklgt3__hdc_and_sf__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set HDCAndSF :: HS Threads Dispatched */
#define sklgt3__hdc_and_sf__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set HDCAndSF :: DS Threads Dispatched */
#define sklgt3__hdc_and_sf__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set HDCAndSF :: GS Threads Dispatched */
#define sklgt3__hdc_and_sf__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set HDCAndSF :: FS Threads Dispatched */
#define sklgt3__hdc_and_sf__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set HDCAndSF :: CS Threads Dispatched */
#define sklgt3__hdc_and_sf__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set HDCAndSF :: EU Active */
#define sklgt3__hdc_and_sf__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set HDCAndSF :: EU Stall */
#define sklgt3__hdc_and_sf__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set HDCAndSF :: EU Both FPU Pipes Active */
#define sklgt3__hdc_and_sf__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set HDCAndSF :: VS FPU0 Pipe Active */
#define sklgt3__hdc_and_sf__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set HDCAndSF :: VS FPU1 Pipe Active */
#define sklgt3__hdc_and_sf__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set HDCAndSF :: VS Send Pipe Active */
#define sklgt3__hdc_and_sf__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set HDCAndSF :: PS FPU0 Pipe Active */
#define sklgt3__hdc_and_sf__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set HDCAndSF :: PS FPU1 Pipe Active */
#define sklgt3__hdc_and_sf__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set HDCAndSF :: PS Send Pipeline Active */
#define sklgt3__hdc_and_sf__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set HDCAndSF :: FS Both FPU Active */
#define sklgt3__hdc_and_sf__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set HDCAndSF :: Rasterized Pixels */
#define sklgt3__hdc_and_sf__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set HDCAndSF :: Early Hi-Depth Test Fails */
#define sklgt3__hdc_and_sf__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set HDCAndSF :: Early Depth Test Fails */
#define sklgt3__hdc_and_sf__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set HDCAndSF :: Samples Killed in FS */
#define sklgt3__hdc_and_sf__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set HDCAndSF :: Pixels Failing Tests */
#define sklgt3__hdc_and_sf__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set HDCAndSF :: Samples Written */
#define sklgt3__hdc_and_sf__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set HDCAndSF :: Samples Blended */
#define sklgt3__hdc_and_sf__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set HDCAndSF :: Sampler Texels */
#define sklgt3__hdc_and_sf__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set HDCAndSF :: Sampler Texels Misses */
#define sklgt3__hdc_and_sf__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set HDCAndSF :: SLM Bytes Read */
#define sklgt3__hdc_and_sf__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set HDCAndSF :: SLM Bytes Read */
#define sklgt3__hdc_and_sf__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set HDCAndSF :: SLM Bytes Written */
#define sklgt3__hdc_and_sf__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set HDCAndSF :: SLM Bytes Written */
#define sklgt3__hdc_and_sf__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set HDCAndSF :: Shader Memory Accesses */
#define sklgt3__hdc_and_sf__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set HDCAndSF :: Shader Atomic Memory Accesses */
#define sklgt3__hdc_and_sf__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set HDCAndSF :: L3 Shader Throughput */
#define sklgt3__hdc_and_sf__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set HDCAndSF :: L3 Shader Throughput */
#define sklgt3__hdc_and_sf__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set HDCAndSF :: Shader Barrier Messages */
#define sklgt3__hdc_and_sf__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set HDCAndSF :: Polygon Data Ready */
#define sklgt3__hdc_and_sf__poly_data_ready__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set HDCAndSF :: HDC stalled by L3 (s0.ss0) */
#define sklgt3__hdc_and_sf__non_sampler_shader00_access_stalled_on_l3__read \
    bdw__hdc_and_sf__non_sampler_shader02_access_stalled_on_l3__read

/* Metric set HDCAndSF :: HDC stalled by L3 (s0.ss1) */
#define sklgt3__hdc_and_sf__non_sampler_shader01_access_stalled_on_l3__read \
    bdw__hdc_and_sf__non_sampler_shader01_access_stalled_on_l3__read

/* Metric set HDCAndSF :: HDC stalled by L3 (s0.ss2) */
#define sklgt3__hdc_and_sf__non_sampler_shader02_access_stalled_on_l3__read \
    bdw__hdc_and_sf__non_sampler_shader00_access_stalled_on_l3__read

/* Metric set HDCAndSF :: SQ is full */
#define sklgt3__hdc_and_sf__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set L3_1 :: GPU Time Elapsed */
#define sklgt3__l3_1__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set L3_1 :: GPU Core Clocks */
#define sklgt3__l3_1__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set L3_1 :: AVG GPU Core Frequency */
#define sklgt3__l3_1__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set L3_1 :: AVG GPU Core Frequency */
#define sklgt3__l3_1__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set L3_1 :: GPU Busy */
#define sklgt3__l3_1__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set L3_1 :: VS Threads Dispatched */
#define sklgt3__l3_1__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set L3_1 :: HS Threads Dispatched */
#define sklgt3__l3_1__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set L3_1 :: DS Threads Dispatched */
#define sklgt3__l3_1__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set L3_1 :: GS Threads Dispatched */
#define sklgt3__l3_1__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set L3_1 :: FS Threads Dispatched */
#define sklgt3__l3_1__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set L3_1 :: CS Threads Dispatched */
#define sklgt3__l3_1__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set L3_1 :: EU Active */
#define sklgt3__l3_1__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set L3_1 :: EU Stall */
#define sklgt3__l3_1__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set L3_1 :: EU Both FPU Pipes Active */
#define sklgt3__l3_1__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set L3_1 :: VS FPU0 Pipe Active */
#define sklgt3__l3_1__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set L3_1 :: VS FPU1 Pipe Active */
#define sklgt3__l3_1__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set L3_1 :: VS Send Pipe Active */
#define sklgt3__l3_1__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set L3_1 :: PS FPU0 Pipe Active */
#define sklgt3__l3_1__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set L3_1 :: PS FPU1 Pipe Active */
#define sklgt3__l3_1__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set L3_1 :: PS Send Pipeline Active */
#define sklgt3__l3_1__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set L3_1 :: FS Both FPU Active */
#define sklgt3__l3_1__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set L3_1 :: Rasterized Pixels */
#define sklgt3__l3_1__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set L3_1 :: Early Hi-Depth Test Fails */
#define sklgt3__l3_1__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set L3_1 :: Early Depth Test Fails */
#define sklgt3__l3_1__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set L3_1 :: Samples Killed in FS */
#define sklgt3__l3_1__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set L3_1 :: Pixels Failing Tests */
#define sklgt3__l3_1__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set L3_1 :: Samples Written */
#define sklgt3__l3_1__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set L3_1 :: Samples Blended */
#define sklgt3__l3_1__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set L3_1 :: Sampler Texels */
#define sklgt3__l3_1__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set L3_1 :: Sampler Texels Misses */
#define sklgt3__l3_1__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set L3_1 :: SLM Bytes Read */
#define sklgt3__l3_1__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set L3_1 :: SLM Bytes Read */
#define sklgt3__l3_1__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_1 :: SLM Bytes Written */
#define sklgt3__l3_1__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set L3_1 :: SLM Bytes Written */
#define sklgt3__l3_1__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_1 :: Shader Memory Accesses */
#define sklgt3__l3_1__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set L3_1 :: Shader Atomic Memory Accesses */
#define sklgt3__l3_1__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set L3_1 :: L3 Shader Throughput */
#define sklgt3__l3_1__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set L3_1 :: L3 Shader Throughput */
#define sklgt3__l3_1__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_1 :: Shader Barrier Messages */
#define sklgt3__l3_1__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set L3_1 :: Slice0 L3 Bank0 Stalled */
#define sklgt3__l3_1__l30_bank0_stalled__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set L3_1 :: Slice0 L3 Bank1 Stalled */
#define sklgt3__l3_1__l30_bank1_stalled__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* Metric set L3_1 :: Slice0 L3 Bank1 Active */
#define sklgt3__l3_1__l30_bank1_active__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set L3_1 :: Slice0 L3 Bank0 Active */
#define sklgt3__l3_1__l30_bank0_active__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set L3_1 :: SQ is full */
#define sklgt3__l3_1__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set L3_2 :: GPU Time Elapsed */
#define sklgt3__l3_2__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set L3_2 :: GPU Core Clocks */
#define sklgt3__l3_2__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set L3_2 :: AVG GPU Core Frequency */
#define sklgt3__l3_2__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set L3_2 :: AVG GPU Core Frequency */
#define sklgt3__l3_2__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set L3_2 :: GPU Busy */
#define sklgt3__l3_2__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set L3_2 :: VS Threads Dispatched */
#define sklgt3__l3_2__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set L3_2 :: HS Threads Dispatched */
#define sklgt3__l3_2__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set L3_2 :: DS Threads Dispatched */
#define sklgt3__l3_2__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set L3_2 :: GS Threads Dispatched */
#define sklgt3__l3_2__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set L3_2 :: FS Threads Dispatched */
#define sklgt3__l3_2__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set L3_2 :: CS Threads Dispatched */
#define sklgt3__l3_2__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set L3_2 :: EU Active */
#define sklgt3__l3_2__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set L3_2 :: EU Stall */
#define sklgt3__l3_2__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set L3_2 :: EU Both FPU Pipes Active */
#define sklgt3__l3_2__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set L3_2 :: VS FPU0 Pipe Active */
#define sklgt3__l3_2__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set L3_2 :: VS FPU1 Pipe Active */
#define sklgt3__l3_2__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set L3_2 :: VS Send Pipe Active */
#define sklgt3__l3_2__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set L3_2 :: PS FPU0 Pipe Active */
#define sklgt3__l3_2__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set L3_2 :: PS FPU1 Pipe Active */
#define sklgt3__l3_2__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set L3_2 :: PS Send Pipeline Active */
#define sklgt3__l3_2__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set L3_2 :: FS Both FPU Active */
#define sklgt3__l3_2__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set L3_2 :: Rasterized Pixels */
#define sklgt3__l3_2__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set L3_2 :: Early Hi-Depth Test Fails */
#define sklgt3__l3_2__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set L3_2 :: Early Depth Test Fails */
#define sklgt3__l3_2__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set L3_2 :: Samples Killed in FS */
#define sklgt3__l3_2__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set L3_2 :: Pixels Failing Tests */
#define sklgt3__l3_2__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set L3_2 :: Samples Written */
#define sklgt3__l3_2__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set L3_2 :: Samples Blended */
#define sklgt3__l3_2__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set L3_2 :: Sampler Texels */
#define sklgt3__l3_2__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set L3_2 :: Sampler Texels Misses */
#define sklgt3__l3_2__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set L3_2 :: SLM Bytes Read */
#define sklgt3__l3_2__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set L3_2 :: SLM Bytes Read */
#define sklgt3__l3_2__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_2 :: SLM Bytes Written */
#define sklgt3__l3_2__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set L3_2 :: SLM Bytes Written */
#define sklgt3__l3_2__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_2 :: Shader Memory Accesses */
#define sklgt3__l3_2__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set L3_2 :: Shader Atomic Memory Accesses */
#define sklgt3__l3_2__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set L3_2 :: L3 Shader Throughput */
#define sklgt3__l3_2__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set L3_2 :: L3 Shader Throughput */
#define sklgt3__l3_2__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_2 :: Shader Barrier Messages */
#define sklgt3__l3_2__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set L3_2 :: Slice0 L3 Bank2 Stalled */
#define sklgt3__l3_2__l30_bank2_stalled__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set L3_2 :: Slice0 L3 Bank2 Active */
#define sklgt3__l3_2__l30_bank2_active__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set L3_2 :: SQ is full */
#define sklgt3__l3_2__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set L3_3 :: GPU Time Elapsed */
#define sklgt3__l3_3__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set L3_3 :: GPU Core Clocks */
#define sklgt3__l3_3__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set L3_3 :: AVG GPU Core Frequency */
#define sklgt3__l3_3__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set L3_3 :: AVG GPU Core Frequency */
#define sklgt3__l3_3__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set L3_3 :: GPU Busy */
#define sklgt3__l3_3__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set L3_3 :: VS Threads Dispatched */
#define sklgt3__l3_3__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set L3_3 :: HS Threads Dispatched */
#define sklgt3__l3_3__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set L3_3 :: DS Threads Dispatched */
#define sklgt3__l3_3__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set L3_3 :: GS Threads Dispatched */
#define sklgt3__l3_3__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set L3_3 :: FS Threads Dispatched */
#define sklgt3__l3_3__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set L3_3 :: CS Threads Dispatched */
#define sklgt3__l3_3__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set L3_3 :: EU Active */
#define sklgt3__l3_3__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set L3_3 :: EU Stall */
#define sklgt3__l3_3__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set L3_3 :: EU Both FPU Pipes Active */
#define sklgt3__l3_3__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set L3_3 :: VS FPU0 Pipe Active */
#define sklgt3__l3_3__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set L3_3 :: VS FPU1 Pipe Active */
#define sklgt3__l3_3__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set L3_3 :: VS Send Pipe Active */
#define sklgt3__l3_3__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set L3_3 :: PS FPU0 Pipe Active */
#define sklgt3__l3_3__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set L3_3 :: PS FPU1 Pipe Active */
#define sklgt3__l3_3__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set L3_3 :: PS Send Pipeline Active */
#define sklgt3__l3_3__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set L3_3 :: FS Both FPU Active */
#define sklgt3__l3_3__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set L3_3 :: Rasterized Pixels */
#define sklgt3__l3_3__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set L3_3 :: Early Hi-Depth Test Fails */
#define sklgt3__l3_3__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set L3_3 :: Early Depth Test Fails */
#define sklgt3__l3_3__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set L3_3 :: Samples Killed in FS */
#define sklgt3__l3_3__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set L3_3 :: Pixels Failing Tests */
#define sklgt3__l3_3__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set L3_3 :: Samples Written */
#define sklgt3__l3_3__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set L3_3 :: Samples Blended */
#define sklgt3__l3_3__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set L3_3 :: Sampler Texels */
#define sklgt3__l3_3__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set L3_3 :: Sampler Texels Misses */
#define sklgt3__l3_3__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set L3_3 :: SLM Bytes Read */
#define sklgt3__l3_3__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set L3_3 :: SLM Bytes Read */
#define sklgt3__l3_3__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_3 :: SLM Bytes Written */
#define sklgt3__l3_3__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set L3_3 :: SLM Bytes Written */
#define sklgt3__l3_3__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_3 :: Shader Memory Accesses */
#define sklgt3__l3_3__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set L3_3 :: Shader Atomic Memory Accesses */
#define sklgt3__l3_3__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set L3_3 :: L3 Shader Throughput */
#define sklgt3__l3_3__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set L3_3 :: L3 Shader Throughput */
#define sklgt3__l3_3__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_3 :: Shader Barrier Messages */
#define sklgt3__l3_3__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set L3_3 :: Slice0 L3 Bank3 Stalled */
#define sklgt3__l3_3__l30_bank3_stalled__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set L3_3 :: Slice0 L3 Bank3 Active */
#define sklgt3__l3_3__l30_bank3_active__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set L3_3 :: SQ is full */
#define sklgt3__l3_3__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set RasterizerAndPixelBackend :: GPU Time Elapsed */
#define sklgt3__rasterizer_and_pixel_backend__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set RasterizerAndPixelBackend :: GPU Core Clocks */
#define sklgt3__rasterizer_and_pixel_backend__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set RasterizerAndPixelBackend :: AVG GPU Core Frequency */
#define sklgt3__rasterizer_and_pixel_backend__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set RasterizerAndPixelBackend :: AVG GPU Core Frequency */
#define sklgt3__rasterizer_and_pixel_backend__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set RasterizerAndPixelBackend :: GPU Busy */
#define sklgt3__rasterizer_and_pixel_backend__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set RasterizerAndPixelBackend :: VS Threads Dispatched */
#define sklgt3__rasterizer_and_pixel_backend__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set RasterizerAndPixelBackend :: HS Threads Dispatched */
#define sklgt3__rasterizer_and_pixel_backend__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set RasterizerAndPixelBackend :: DS Threads Dispatched */
#define sklgt3__rasterizer_and_pixel_backend__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set RasterizerAndPixelBackend :: GS Threads Dispatched */
#define sklgt3__rasterizer_and_pixel_backend__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set RasterizerAndPixelBackend :: FS Threads Dispatched */
#define sklgt3__rasterizer_and_pixel_backend__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set RasterizerAndPixelBackend :: CS Threads Dispatched */
#define sklgt3__rasterizer_and_pixel_backend__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set RasterizerAndPixelBackend :: EU Active */
#define sklgt3__rasterizer_and_pixel_backend__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set RasterizerAndPixelBackend :: EU Stall */
#define sklgt3__rasterizer_and_pixel_backend__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set RasterizerAndPixelBackend :: EU Both FPU Pipes Active */
#define sklgt3__rasterizer_and_pixel_backend__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set RasterizerAndPixelBackend :: VS FPU0 Pipe Active */
#define sklgt3__rasterizer_and_pixel_backend__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set RasterizerAndPixelBackend :: VS FPU1 Pipe Active */
#define sklgt3__rasterizer_and_pixel_backend__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set RasterizerAndPixelBackend :: VS Send Pipe Active */
#define sklgt3__rasterizer_and_pixel_backend__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set RasterizerAndPixelBackend :: PS FPU0 Pipe Active */
#define sklgt3__rasterizer_and_pixel_backend__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set RasterizerAndPixelBackend :: PS FPU1 Pipe Active */
#define sklgt3__rasterizer_and_pixel_backend__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set RasterizerAndPixelBackend :: PS Send Pipeline Active */
#define sklgt3__rasterizer_and_pixel_backend__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set RasterizerAndPixelBackend :: FS Both FPU Active */
#define sklgt3__rasterizer_and_pixel_backend__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set RasterizerAndPixelBackend :: Rasterized Pixels */
#define sklgt3__rasterizer_and_pixel_backend__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set RasterizerAndPixelBackend :: Early Hi-Depth Test Fails */
#define sklgt3__rasterizer_and_pixel_backend__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set RasterizerAndPixelBackend :: Early Depth Test Fails */
#define sklgt3__rasterizer_and_pixel_backend__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set RasterizerAndPixelBackend :: Samples Killed in FS */
#define sklgt3__rasterizer_and_pixel_backend__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set RasterizerAndPixelBackend :: Pixels Failing Tests */
#define sklgt3__rasterizer_and_pixel_backend__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set RasterizerAndPixelBackend :: Samples Written */
#define sklgt3__rasterizer_and_pixel_backend__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set RasterizerAndPixelBackend :: Samples Blended */
#define sklgt3__rasterizer_and_pixel_backend__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set RasterizerAndPixelBackend :: Sampler Texels */
#define sklgt3__rasterizer_and_pixel_backend__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set RasterizerAndPixelBackend :: Sampler Texels Misses */
#define sklgt3__rasterizer_and_pixel_backend__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Read */
#define sklgt3__rasterizer_and_pixel_backend__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Read */
#define sklgt3__rasterizer_and_pixel_backend__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Written */
#define sklgt3__rasterizer_and_pixel_backend__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Written */
#define sklgt3__rasterizer_and_pixel_backend__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set RasterizerAndPixelBackend :: Shader Memory Accesses */
#define sklgt3__rasterizer_and_pixel_backend__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set RasterizerAndPixelBackend :: Shader Atomic Memory Accesses */
#define sklgt3__rasterizer_and_pixel_backend__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set RasterizerAndPixelBackend :: L3 Shader Throughput */
#define sklgt3__rasterizer_and_pixel_backend__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set RasterizerAndPixelBackend :: L3 Shader Throughput */
#define sklgt3__rasterizer_and_pixel_backend__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set RasterizerAndPixelBackend :: Shader Barrier Messages */
#define sklgt3__rasterizer_and_pixel_backend__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Post-EarlyZ Pixel Data Ready */
#define sklgt3__rasterizer_and_pixel_backend__pixel_data0_ready__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Rasterizer Input Available */
#define sklgt3__rasterizer_and_pixel_backend__rasterizer0_input_available__read \
    bdw__render_basic__sampler1_busy__read

/* Metric set RasterizerAndPixelBackend :: Slice0 PS Output Available */
#define sklgt3__rasterizer_and_pixel_backend__ps_output0_available__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Pixel Values Ready */
#define sklgt3__rasterizer_and_pixel_backend__pixel_values0_ready__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Rasterizer Output Ready */
#define sklgt3__rasterizer_and_pixel_backend__rasterizer0_output_ready__read \
    bdw__render_pipe_profile__sf_stall__read

/* Metric set RasterizerAndPixelBackend :: SQ is full */
#define sklgt3__rasterizer_and_pixel_backend__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set Sampler :: GPU Time Elapsed */
#define sklgt3__sampler__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set Sampler :: GPU Core Clocks */
#define sklgt3__sampler__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set Sampler :: AVG GPU Core Frequency */
#define sklgt3__sampler__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set Sampler :: AVG GPU Core Frequency */
#define sklgt3__sampler__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set Sampler :: GPU Busy */
#define sklgt3__sampler__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set Sampler :: VS Threads Dispatched */
#define sklgt3__sampler__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set Sampler :: HS Threads Dispatched */
#define sklgt3__sampler__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set Sampler :: DS Threads Dispatched */
#define sklgt3__sampler__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set Sampler :: GS Threads Dispatched */
#define sklgt3__sampler__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set Sampler :: FS Threads Dispatched */
#define sklgt3__sampler__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set Sampler :: CS Threads Dispatched */
#define sklgt3__sampler__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set Sampler :: EU Active */
#define sklgt3__sampler__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set Sampler :: EU Stall */
#define sklgt3__sampler__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set Sampler :: EU Both FPU Pipes Active */
#define sklgt3__sampler__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set Sampler :: VS FPU0 Pipe Active */
#define sklgt3__sampler__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set Sampler :: VS FPU1 Pipe Active */
#define sklgt3__sampler__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set Sampler :: VS Send Pipe Active */
#define sklgt3__sampler__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set Sampler :: PS FPU0 Pipe Active */
#define sklgt3__sampler__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set Sampler :: PS FPU1 Pipe Active */
#define sklgt3__sampler__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set Sampler :: PS Send Pipeline Active */
#define sklgt3__sampler__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set Sampler :: FS Both FPU Active */
#define sklgt3__sampler__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set Sampler :: Rasterized Pixels */
#define sklgt3__sampler__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set Sampler :: Early Hi-Depth Test Fails */
#define sklgt3__sampler__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set Sampler :: Early Depth Test Fails */
#define sklgt3__sampler__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set Sampler :: Samples Killed in FS */
#define sklgt3__sampler__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set Sampler :: Pixels Failing Tests */
#define sklgt3__sampler__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set Sampler :: Samples Written */
#define sklgt3__sampler__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set Sampler :: Samples Blended */
#define sklgt3__sampler__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set Sampler :: Sampler Texels */
#define sklgt3__sampler__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set Sampler :: Sampler Texels Misses */
#define sklgt3__sampler__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set Sampler :: SLM Bytes Read */
#define sklgt3__sampler__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set Sampler :: SLM Bytes Read */
#define sklgt3__sampler__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set Sampler :: SLM Bytes Written */
#define sklgt3__sampler__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set Sampler :: SLM Bytes Written */
#define sklgt3__sampler__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set Sampler :: Shader Memory Accesses */
#define sklgt3__sampler__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set Sampler :: Shader Atomic Memory Accesses */
#define sklgt3__sampler__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set Sampler :: L3 Shader Throughput */
#define sklgt3__sampler__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set Sampler :: L3 Shader Throughput */
#define sklgt3__sampler__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set Sampler :: Shader Barrier Messages */
#define sklgt3__sampler__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set Sampler :: Slice0 Subslice1 Input Available */
#define sklgt3__sampler__sampler01_input_available__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set Sampler :: Slice0 Subslice2 Input Available */
#define sklgt3__sampler__sampler02_input_available__read \
    bdw__render_basic__sampler1_busy__read

/* Metric set Sampler :: Slice0 Subslice0 Input Available */
#define sklgt3__sampler__sampler00_input_available__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Metric set Sampler :: Slice0 Subslice2 Sampler Output Ready */
#define sklgt3__sampler__sampler02_output_ready__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set Sampler :: Slice0 Subslice0 Sampler Output Ready */
#define sklgt3__sampler__sampler00_output_ready__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set Sampler :: Slice0 Subslice1 Sampler Output Ready */
#define sklgt3__sampler__sampler01_output_ready__read \
    bdw__render_pipe_profile__sf_stall__read

/* Metric set Sampler :: SQ is full */
#define sklgt3__sampler__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set TDL_1 :: GPU Time Elapsed */
#define sklgt3__tdl_1__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set TDL_1 :: GPU Core Clocks */
#define sklgt3__tdl_1__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set TDL_1 :: AVG GPU Core Frequency */
#define sklgt3__tdl_1__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set TDL_1 :: AVG GPU Core Frequency */
#define sklgt3__tdl_1__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set TDL_1 :: GPU Busy */
#define sklgt3__tdl_1__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set TDL_1 :: VS Threads Dispatched */
#define sklgt3__tdl_1__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set TDL_1 :: HS Threads Dispatched */
#define sklgt3__tdl_1__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set TDL_1 :: DS Threads Dispatched */
#define sklgt3__tdl_1__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set TDL_1 :: GS Threads Dispatched */
#define sklgt3__tdl_1__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set TDL_1 :: FS Threads Dispatched */
#define sklgt3__tdl_1__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set TDL_1 :: CS Threads Dispatched */
#define sklgt3__tdl_1__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set TDL_1 :: EU Active */
#define sklgt3__tdl_1__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set TDL_1 :: EU Stall */
#define sklgt3__tdl_1__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set TDL_1 :: EU Both FPU Pipes Active */
#define sklgt3__tdl_1__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set TDL_1 :: VS FPU0 Pipe Active */
#define sklgt3__tdl_1__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set TDL_1 :: VS FPU1 Pipe Active */
#define sklgt3__tdl_1__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set TDL_1 :: VS Send Pipe Active */
#define sklgt3__tdl_1__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set TDL_1 :: PS FPU0 Pipe Active */
#define sklgt3__tdl_1__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set TDL_1 :: PS FPU1 Pipe Active */
#define sklgt3__tdl_1__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set TDL_1 :: PS Send Pipeline Active */
#define sklgt3__tdl_1__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set TDL_1 :: FS Both FPU Active */
#define sklgt3__tdl_1__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set TDL_1 :: Rasterized Pixels */
#define sklgt3__tdl_1__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set TDL_1 :: Early Hi-Depth Test Fails */
#define sklgt3__tdl_1__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set TDL_1 :: Early Depth Test Fails */
#define sklgt3__tdl_1__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set TDL_1 :: Samples Killed in FS */
#define sklgt3__tdl_1__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set TDL_1 :: Pixels Failing Tests */
#define sklgt3__tdl_1__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set TDL_1 :: Samples Written */
#define sklgt3__tdl_1__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set TDL_1 :: Samples Blended */
#define sklgt3__tdl_1__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set TDL_1 :: Sampler Texels */
#define sklgt3__tdl_1__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set TDL_1 :: Sampler Texels Misses */
#define sklgt3__tdl_1__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set TDL_1 :: SLM Bytes Read */
#define sklgt3__tdl_1__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set TDL_1 :: SLM Bytes Read */
#define sklgt3__tdl_1__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_1 :: SLM Bytes Written */
#define sklgt3__tdl_1__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set TDL_1 :: SLM Bytes Written */
#define sklgt3__tdl_1__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_1 :: Shader Memory Accesses */
#define sklgt3__tdl_1__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set TDL_1 :: Shader Atomic Memory Accesses */
#define sklgt3__tdl_1__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set TDL_1 :: L3 Shader Throughput */
#define sklgt3__tdl_1__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set TDL_1 :: L3 Shader Throughput */
#define sklgt3__tdl_1__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_1 :: Shader Barrier Messages */
#define sklgt3__tdl_1__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set TDL_1 :: NonPS Thread Ready For Dispatch on Slice0 Subslice1 */
#define sklgt3__tdl_1__non_ps_thread01_ready_for_dispatch__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set TDL_1 :: PS Thread Ready For Dispatch on Slice0 Subslice0 */
#define sklgt3__tdl_1__ps_thread00_ready_for_dispatch__read \
    bdw__render_basic__sampler1_busy__read

/* Metric set TDL_1 :: NonPS Thread Ready For Dispatch on Slice0 Subslice0 */
#define sklgt3__tdl_1__non_ps_thread00_ready_for_dispatch__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Metric set TDL_1 :: PS Thread Ready For Dispatch on Slice0 Subslice2 */
#define sklgt3__tdl_1__ps_thread02_ready_for_dispatch__read \
    bdw__render_basic__sampler1_bottleneck__read

/* Metric set TDL_1 :: NonPS Thread Ready For Dispatch on Slice0 Subslice2 */
#define sklgt3__tdl_1__non_ps_thread02_ready_for_dispatch__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* Metric set TDL_1 :: PS Thread Ready For Dispatch on Slice0 Subslice1 */
#define sklgt3__tdl_1__ps_thread01_ready_for_dispatch__read \
    bdw__render_pipe_profile__cl_bottleneck__read

/* Metric set TDL_1 :: SQ is full */
#define sklgt3__tdl_1__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set TDL_2 :: GPU Time Elapsed */
#define sklgt3__tdl_2__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set TDL_2 :: GPU Core Clocks */
#define sklgt3__tdl_2__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set TDL_2 :: AVG GPU Core Frequency */
#define sklgt3__tdl_2__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set TDL_2 :: AVG GPU Core Frequency */
#define sklgt3__tdl_2__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set TDL_2 :: GPU Busy */
#define sklgt3__tdl_2__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set TDL_2 :: VS Threads Dispatched */
#define sklgt3__tdl_2__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set TDL_2 :: HS Threads Dispatched */
#define sklgt3__tdl_2__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set TDL_2 :: DS Threads Dispatched */
#define sklgt3__tdl_2__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set TDL_2 :: GS Threads Dispatched */
#define sklgt3__tdl_2__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set TDL_2 :: FS Threads Dispatched */
#define sklgt3__tdl_2__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set TDL_2 :: CS Threads Dispatched */
#define sklgt3__tdl_2__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set TDL_2 :: EU Active */
#define sklgt3__tdl_2__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set TDL_2 :: EU Stall */
#define sklgt3__tdl_2__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set TDL_2 :: EU Both FPU Pipes Active */
#define sklgt3__tdl_2__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set TDL_2 :: VS FPU0 Pipe Active */
#define sklgt3__tdl_2__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set TDL_2 :: VS FPU1 Pipe Active */
#define sklgt3__tdl_2__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set TDL_2 :: VS Send Pipe Active */
#define sklgt3__tdl_2__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set TDL_2 :: PS FPU0 Pipe Active */
#define sklgt3__tdl_2__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set TDL_2 :: PS FPU1 Pipe Active */
#define sklgt3__tdl_2__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set TDL_2 :: PS Send Pipeline Active */
#define sklgt3__tdl_2__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set TDL_2 :: FS Both FPU Active */
#define sklgt3__tdl_2__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set TDL_2 :: Rasterized Pixels */
#define sklgt3__tdl_2__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set TDL_2 :: Early Hi-Depth Test Fails */
#define sklgt3__tdl_2__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set TDL_2 :: Early Depth Test Fails */
#define sklgt3__tdl_2__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set TDL_2 :: Samples Killed in FS */
#define sklgt3__tdl_2__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set TDL_2 :: Pixels Failing Tests */
#define sklgt3__tdl_2__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set TDL_2 :: Samples Written */
#define sklgt3__tdl_2__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set TDL_2 :: Samples Blended */
#define sklgt3__tdl_2__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set TDL_2 :: Sampler Texels */
#define sklgt3__tdl_2__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set TDL_2 :: Sampler Texels Misses */
#define sklgt3__tdl_2__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set TDL_2 :: SLM Bytes Read */
#define sklgt3__tdl_2__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set TDL_2 :: SLM Bytes Read */
#define sklgt3__tdl_2__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_2 :: SLM Bytes Written */
#define sklgt3__tdl_2__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set TDL_2 :: SLM Bytes Written */
#define sklgt3__tdl_2__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_2 :: Shader Memory Accesses */
#define sklgt3__tdl_2__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set TDL_2 :: Shader Atomic Memory Accesses */
#define sklgt3__tdl_2__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set TDL_2 :: L3 Shader Throughput */
#define sklgt3__tdl_2__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set TDL_2 :: L3 Shader Throughput */
#define sklgt3__tdl_2__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_2 :: Shader Barrier Messages */
#define sklgt3__tdl_2__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice1 Port 0 */
#define sklgt3__tdl_2__thread_header01_ready_port0__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice0 Port 1 */
#define sklgt3__tdl_2__thread_header00_ready_port1__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice0 Port 0 */
#define sklgt3__tdl_2__thread_header00_ready_port0__read \
    bdw__render_pipe_profile__sf_stall__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice2 Port 1 */
#define sklgt3__tdl_2__thread_header02_ready_port1__read \
    bdw__render_pipe_profile__cl_stall__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice2 Port 0 */
#define sklgt3__tdl_2__thread_header02_ready_port0__read \
    bdw__render_pipe_profile__so_stall__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice1 Port 1 */
#define sklgt3__tdl_2__thread_header01_ready_port1__read \
    bdw__render_pipe_profile__ds_stall__read

/* Metric set TDL_2 :: SQ is full */
#define sklgt3__tdl_2__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Compute Metrics Extra Gen9 :: GPU Time Elapsed */
#define sklgt3__compute_extra__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Compute Metrics Extra Gen9 :: GPU Core Clocks */
#define sklgt3__compute_extra__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Compute Metrics Extra Gen9 :: AVG GPU Core Frequency */
#define sklgt3__compute_extra__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Compute Metrics Extra Gen9 :: AVG GPU Core Frequency */
#define sklgt3__compute_extra__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Compute Metrics Extra Gen9 :: EU FPU1 Pipe Active */
#define sklgt3__compute_extra__fpu1_active__read \
    bdw__render_basic__eu_stall__read

/* Compute Metrics Extra Gen9 :: EU FPU1 Pipe Active including Ext Math */
#define sklgt3__compute_extra__fpu1_active_adjusted__read \
    bdw__compute_extra__fpu1_active_adjusted__read

/* Media Vme Pipe Gen9 :: GPU Time Elapsed */
#define sklgt3__vme_pipe__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Media Vme Pipe Gen9 :: GPU Core Clocks */
#define sklgt3__vme_pipe__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Media Vme Pipe Gen9 :: AVG GPU Core Frequency */
#define sklgt3__vme_pipe__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Media Vme Pipe Gen9 :: AVG GPU Core Frequency */
#define sklgt3__vme_pipe__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Media Vme Pipe Gen9 :: GPU Busy */
#define sklgt3__vme_pipe__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Media Vme Pipe Gen9 :: CS Threads Dispatched */
#define sklgt3__vme_pipe__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Media Vme Pipe Gen9 :: EU Active */
#define sklgt3__vme_pipe__eu_active__read \
    bdw__render_basic__eu_active__read

/* Media Vme Pipe Gen9 :: EU Stall */
#define sklgt3__vme_pipe__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Media Vme Pipe Gen9 :: EU Both FPU Pipes Active */
#define sklgt3__vme_pipe__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Media Vme Pipe Gen9 :: EU Thread Occupancy */
#define sklgt3__vme_pipe__eu_thread_occupancy__read \
    bdw__vme_pipe__eu_thread_occupancy__read

/* Media Vme Pipe Gen9 :: VME Busy */
#define sklgt3__vme_pipe__vme_busy__read \
    bdw__vme_pipe__vme_busy__read

/* Gpu Rings Busyness :: GPU Time Elapsed */
#define sklgt3__gpu_busyness__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Gpu Rings Busyness :: GPU Core Clocks */
#define sklgt3__gpu_busyness__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Gpu Rings Busyness :: AVG GPU Core Frequency */
#define sklgt3__gpu_busyness__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Gpu Rings Busyness :: AVG GPU Core Frequency */
#define sklgt3__gpu_busyness__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Gpu Rings Busyness :: Render Ring Busy */
#define sklgt3__gpu_busyness__render_busy__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Gpu Rings Busyness :: Vdbox0 Ring Busy */
#define sklgt3__gpu_busyness__vdbox0_busy__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Gpu Rings Busyness :: Vdbox1 Ring Busy */
#define sklgt3__gpu_busyness__vdbox1_busy__read \
    bdw__render_pipe_profile__sf_stall__read

/* Gpu Rings Busyness :: Vebox Ring Busy */
#define sklgt3__gpu_busyness__vebox_busy__read \
    bdw__render_pipe_profile__cl_stall__read

/* Gpu Rings Busyness :: Blitter Ring Busy */
#define sklgt3__gpu_busyness__blitter_busy__read \
    bdw__render_pipe_profile__so_stall__read

/* Gpu Rings Busyness :: AnyRingBusy */
#define sklgt3__gpu_busyness__any_ring_busy__read \
    bdw__render_basic__sampler0_busy__read

/* MDAPI testing set Gen9 :: GPU Time Elapsed */
#define sklgt3__test_oa__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* MDAPI testing set Gen9 :: GPU Core Clocks */
#define sklgt3__test_oa__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* MDAPI testing set Gen9 :: AVG GPU Core Frequency */
#define sklgt3__test_oa__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* MDAPI testing set Gen9 :: AVG GPU Core Frequency */
#define sklgt3__test_oa__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* MDAPI testing set Gen9 :: TestCounter0 */
#define sklgt3__test_oa__counter0__read \
    hsw__compute_extended__eu_untyped_reads0__read

/* MDAPI testing set Gen9 :: TestCounter1 */
#define sklgt3__test_oa__counter1__read \
    hsw__compute_extended__eu_untyped_writes0__read

/* MDAPI testing set Gen9 :: TestCounter2 */
#define sklgt3__test_oa__counter2__read \
    hsw__compute_extended__eu_typed_reads0__read

/* MDAPI testing set Gen9 :: TestCounter3 */
#define sklgt3__test_oa__counter3__read \
    hsw__compute_extended__eu_typed_writes0__read

/* MDAPI testing set Gen9 :: TestCounter4 */
#define sklgt3__test_oa__counter4__read \
    hsw__compute_extended__eu_untyped_atomics0__read

/* MDAPI testing set Gen9 :: TestCounter5 */
#define sklgt3__test_oa__counter5__read \
    hsw__compute_extended__eu_typed_atomics0__read

/* MDAPI testing set Gen9 :: TestCounter6 */
#define sklgt3__test_oa__counter6__read \
    hsw__compute_extended__eu_urb_atomics0__read

/* MDAPI testing set Gen9 :: TestCounter7 */
#define sklgt3__test_oa__counter7__read \
    hsw__compute_extended__gpu_clocks__read

/* MDAPI testing set Gen9 :: TestCounter8 */
#define sklgt3__test_oa__counter8__read \
    hsw__memory_reads__gpu_core_clocks__read

/* Metric set PMA Stall :: GPU Time Elapsed */
#define sklgt3__pma__stall__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set PMA Stall :: GPU Core Clocks */
#define sklgt3__pma__stall__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set PMA Stall :: AVG GPU Core Frequency */
#define sklgt3__pma__stall__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set PMA Stall :: AVG GPU Core Frequency */
#define sklgt3__pma__stall__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set PMA Stall :: STC PMA stall */
#define sklgt3__pma__stall__stc_pma_stall__read \
    sklgt2__pma__stall__stc_pma_stall__read

/* Render Metrics Basic Gen9 :: GPU Time Elapsed */
#define sklgt4__render_basic__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Render Metrics Basic Gen9 :: GPU Core Clocks */
#define sklgt4__render_basic__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Render Metrics Basic Gen9 :: AVG GPU Core Frequency */
#define sklgt4__render_basic__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Render Metrics Basic Gen9 :: AVG GPU Core Frequency */
#define sklgt4__render_basic__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Render Metrics Basic Gen9 :: VS Threads Dispatched */
#define sklgt4__render_basic__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Render Metrics Basic Gen9 :: HS Threads Dispatched */
#define sklgt4__render_basic__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Render Metrics Basic Gen9 :: DS Threads Dispatched */
#define sklgt4__render_basic__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Render Metrics Basic Gen9 :: GS Threads Dispatched */
#define sklgt4__render_basic__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Render Metrics Basic Gen9 :: FS Threads Dispatched */
#define sklgt4__render_basic__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Render Metrics Basic Gen9 :: CS Threads Dispatched */
#define sklgt4__render_basic__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Render Metrics Basic Gen9 :: GPU Busy */
#define sklgt4__render_basic__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Render Metrics Basic Gen9 :: EU Active */
#define sklgt4__render_basic__eu_active__read \
    bdw__render_basic__eu_active__read

/* Render Metrics Basic Gen9 :: EU Stall */
#define sklgt4__render_basic__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Render Metrics Basic Gen9 :: EU Both FPU Pipes Active */
#define sklgt4__render_basic__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Render Metrics Basic Gen9 :: VS FPU0 Pipe Active */
#define sklgt4__render_basic__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Render Metrics Basic Gen9 :: VS FPU1 Pipe Active */
#define sklgt4__render_basic__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Render Metrics Basic Gen9 :: VS Send Pipe Active */
#define sklgt4__render_basic__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Render Metrics Basic Gen9 :: PS FPU0 Pipe Active */
#define sklgt4__render_basic__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Render Metrics Basic Gen9 :: PS FPU1 Pipe Active */
#define sklgt4__render_basic__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Render Metrics Basic Gen9 :: PS Send Pipeline Active */
#define sklgt4__render_basic__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Render Metrics Basic Gen9 :: FS Both FPU Active */
#define sklgt4__render_basic__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Render Metrics Basic Gen9 :: Sampler 0 Busy */
#define sklgt4__render_basic__sampler0_busy__read \
    bdw__render_basic__sampler0_busy__read

/* Render Metrics Basic Gen9 :: Sampler 1 Busy */
#define sklgt4__render_basic__sampler1_busy__read \
    bdw__render_basic__sampler1_busy__read

/* Render Metrics Basic Gen9 :: Samplers Busy */
#define sklgt4__render_basic__samplers_busy__read \
    bdw__render_basic__samplers_busy__read

/* Render Metrics Basic Gen9 :: Sampler 0 Bottleneck */
#define sklgt4__render_basic__sampler0_bottleneck__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Render Metrics Basic Gen9 :: Rasterized Pixels */
#define sklgt4__render_basic__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Render Metrics Basic Gen9 :: Early Hi-Depth Test Fails */
#define sklgt4__render_basic__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Render Metrics Basic Gen9 :: Early Depth Test Fails */
#define sklgt4__render_basic__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Render Metrics Basic Gen9 :: Samples Killed in FS */
#define sklgt4__render_basic__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Render Metrics Basic Gen9 :: Pixels Failing Tests */
#define sklgt4__render_basic__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Render Metrics Basic Gen9 :: Samples Written */
#define sklgt4__render_basic__samples_written__read \
    bdw__render_basic__samples_written__read

/* Render Metrics Basic Gen9 :: Samples Blended */
#define sklgt4__render_basic__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Render Metrics Basic Gen9 :: Sampler Texels */
#define sklgt4__render_basic__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Render Metrics Basic Gen9 :: Sampler Texels Misses */
#define sklgt4__render_basic__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Render Metrics Basic Gen9 :: Sampler Cache Misses */
static uint64_t
sklgt4__render_basic__sampler_l1_misses__read(const struct intel_perf *perf,
                                              const struct intel_perf_metric_set *metric_set,
                                              uint64_t *accumulator)
{
    /* RPN equation: B 4 READ B 5 READ UADD B 3 READ UADD 8 UMUL */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 4];
    uint64_t tmp1 = accumulator[metric_set->b_offset + 5];
    uint64_t tmp2 = tmp0 + tmp1;
    uint64_t tmp3 = accumulator[metric_set->b_offset + 3];
    uint64_t tmp4 = tmp2 + tmp3;
    uint64_t tmp5 = tmp4 * 8;

    return tmp5;
}

/* Render Metrics Basic Gen9 :: SLM Bytes Read */
#define sklgt4__render_basic__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Render Metrics Basic Gen9 :: SLM Bytes Read */
#define sklgt4__render_basic__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics Basic Gen9 :: SLM Bytes Written */
#define sklgt4__render_basic__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Render Metrics Basic Gen9 :: SLM Bytes Written */
#define sklgt4__render_basic__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics Basic Gen9 :: Shader Memory Accesses */
#define sklgt4__render_basic__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Render Metrics Basic Gen9 :: Shader Atomic Memory Accesses */
#define sklgt4__render_basic__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Render Metrics Basic Gen9 :: L3 Lookup Accesses w/o IC */
static uint64_t
sklgt4__render_basic__l3_lookups__read(const struct intel_perf *perf,
                                       const struct intel_perf_metric_set *metric_set,
                                       uint64_t *accumulator)
{
    /* RPN equation: $SamplerL1Misses $ShaderMemoryAccesses UADD */
    uint64_t tmp0 = sklgt4__render_basic__sampler_l1_misses__read(perf, metric_set, accumulator) + sklgt4__render_basic__shader_memory_accesses__read(perf, metric_set, accumulator);

    return tmp0;
}

/* Render Metrics Basic Gen9 :: L3 Misses */
#define sklgt4__render_basic__l3_misses__read \
    hsw__compute_extended__typed_atomics0__read

/* Render Metrics Basic Gen9 :: L3 Sampler Throughput */
static uint64_t
sklgt4__render_basic__l3_sampler_throughput__read(const struct intel_perf *perf,
                                                  const struct intel_perf_metric_set *metric_set,
                                                  uint64_t *accumulator)
{
    /* RPN equation: $SamplerL1Misses 64 UMUL */
    uint64_t tmp0 = sklgt4__render_basic__sampler_l1_misses__read(perf, metric_set, accumulator) * 64;

    return tmp0;
}

/* Render Metrics Basic Gen9 :: L3 Sampler Throughput */
#define sklgt4__render_basic__l3_sampler_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics Basic Gen9 :: L3 Shader Throughput */
#define sklgt4__render_basic__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Render Metrics Basic Gen9 :: L3 Shader Throughput */
#define sklgt4__render_basic__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics Basic Gen9 :: Shader Barrier Messages */
#define sklgt4__render_basic__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Render Metrics Basic Gen9 :: GTI Fixed Pipe Throughput */
#define sklgt4__render_basic__gti_vf_throughput__read \
    bdw__render_basic__gti_vf_throughput__read

/* Render Metrics Basic Gen9 :: GTI Fixed Pipe Throughput */
#define sklgt4__render_basic__gti_vf_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Render Metrics Basic Gen9 :: GTI Depth Throughput */
#define sklgt4__render_basic__gti_depth_throughput__read \
    bdw__render_basic__gti_depth_throughput__read

/* Render Metrics Basic Gen9 :: GTI Depth Throughput */
#define sklgt4__render_basic__gti_depth_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics Basic Gen9 :: GTI RCC Throughput */
#define sklgt4__render_basic__gti_rcc_throughput__read \
    bdw__render_basic__gti_rcc_throughput__read

/* Render Metrics Basic Gen9 :: GTI RCC Throughput */
#define sklgt4__render_basic__gti_rcc_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics Basic Gen9 :: GTI L3 Throughput */
#define sklgt4__render_basic__gti_l3_throughput__read \
    hsw__render_basic__gti_l3_throughput__read

/* Render Metrics Basic Gen9 :: GTI L3 Throughput */
#define sklgt4__render_basic__gti_l3_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics Basic Gen9 :: GTI HDC TLB Lookup Throughput */
#define sklgt4__render_basic__gti_hdc_lookups_throughput__read \
    bdw__render_basic__gti_hdc_lookups_throughput__read

/* Render Metrics Basic Gen9 :: GTI HDC TLB Lookup Throughput */
#define sklgt4__render_basic__gti_hdc_lookups_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics Basic Gen9 :: GTI Read Throughput */
#define sklgt4__render_basic__gti_read_throughput__read \
    bdw__render_basic__gti_read_throughput__read

/* Render Metrics Basic Gen9 :: GTI Read Throughput */
#define sklgt4__render_basic__gti_read_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Render Metrics Basic Gen9 :: GTI Write Throughput */
#define sklgt4__render_basic__gti_write_throughput__read \
    hsw__render_basic__gti_write_throughput__read

/* Render Metrics Basic Gen9 :: GTI Write Throughput */
#define sklgt4__render_basic__gti_write_throughput__max \
    bdw__render_basic__gti_write_throughput__max

/* Render Metrics Basic Gen9 :: Samplers Bottleneck */
#define sklgt4__render_basic__sampler_bottleneck__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Compute Metrics Basic Gen9 :: GPU Time Elapsed */
#define sklgt4__compute_basic__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Compute Metrics Basic Gen9 :: GPU Core Clocks */
#define sklgt4__compute_basic__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Compute Metrics Basic Gen9 :: AVG GPU Core Frequency */
#define sklgt4__compute_basic__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Compute Metrics Basic Gen9 :: AVG GPU Core Frequency */
#define sklgt4__compute_basic__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Compute Metrics Basic Gen9 :: GPU Busy */
#define sklgt4__compute_basic__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Compute Metrics Basic Gen9 :: VS Threads Dispatched */
#define sklgt4__compute_basic__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Compute Metrics Basic Gen9 :: HS Threads Dispatched */
#define sklgt4__compute_basic__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Compute Metrics Basic Gen9 :: DS Threads Dispatched */
#define sklgt4__compute_basic__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Compute Metrics Basic Gen9 :: GS Threads Dispatched */
#define sklgt4__compute_basic__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Compute Metrics Basic Gen9 :: FS Threads Dispatched */
#define sklgt4__compute_basic__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Compute Metrics Basic Gen9 :: CS Threads Dispatched */
#define sklgt4__compute_basic__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Compute Metrics Basic Gen9 :: EU Active */
#define sklgt4__compute_basic__eu_active__read \
    bdw__render_basic__eu_active__read

/* Compute Metrics Basic Gen9 :: EU Stall */
#define sklgt4__compute_basic__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Compute Metrics Basic Gen9 :: EU Both FPU Pipes Active */
#define sklgt4__compute_basic__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Compute Metrics Basic Gen9 :: EU FPU0 Pipe Active */
#define sklgt4__compute_basic__fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Compute Metrics Basic Gen9 :: EU FPU1 Pipe Active */
#define sklgt4__compute_basic__fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Compute Metrics Basic Gen9 :: EU AVG IPC Rate */
#define sklgt4__compute_basic__eu_avg_ipc_rate__read \
    bdw__compute_basic__eu_avg_ipc_rate__read

/* Compute Metrics Basic Gen9 :: EU AVG IPC Rate */
#define sklgt4__compute_basic__eu_avg_ipc_rate__max \
    bdw__compute_basic__eu_avg_ipc_rate__max

/* Compute Metrics Basic Gen9 :: EU Send Pipe Active */
#define sklgt4__compute_basic__eu_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Compute Metrics Basic Gen9 :: EU Thread Occupancy */
#define sklgt4__compute_basic__eu_thread_occupancy__read \
    bdw__compute_basic__eu_thread_occupancy__read

/* Compute Metrics Basic Gen9 :: Rasterized Pixels */
#define sklgt4__compute_basic__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Compute Metrics Basic Gen9 :: Early Hi-Depth Test Fails */
#define sklgt4__compute_basic__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Compute Metrics Basic Gen9 :: Early Depth Test Fails */
#define sklgt4__compute_basic__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Compute Metrics Basic Gen9 :: Samples Killed in FS */
#define sklgt4__compute_basic__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Compute Metrics Basic Gen9 :: Pixels Failing Tests */
#define sklgt4__compute_basic__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Compute Metrics Basic Gen9 :: Samples Written */
#define sklgt4__compute_basic__samples_written__read \
    bdw__render_basic__samples_written__read

/* Compute Metrics Basic Gen9 :: Samples Blended */
#define sklgt4__compute_basic__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Compute Metrics Basic Gen9 :: Sampler Texels */
#define sklgt4__compute_basic__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Compute Metrics Basic Gen9 :: Sampler Texels Misses */
#define sklgt4__compute_basic__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Compute Metrics Basic Gen9 :: SLM Bytes Read */
#define sklgt4__compute_basic__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Compute Metrics Basic Gen9 :: SLM Bytes Read */
#define sklgt4__compute_basic__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Basic Gen9 :: SLM Bytes Written */
#define sklgt4__compute_basic__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Compute Metrics Basic Gen9 :: SLM Bytes Written */
#define sklgt4__compute_basic__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Basic Gen9 :: Shader Memory Accesses */
#define sklgt4__compute_basic__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Compute Metrics Basic Gen9 :: Shader Atomic Memory Accesses */
#define sklgt4__compute_basic__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Compute Metrics Basic Gen9 :: L3 Shader Throughput */
#define sklgt4__compute_basic__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Compute Metrics Basic Gen9 :: L3 Shader Throughput */
#define sklgt4__compute_basic__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Basic Gen9 :: Shader Barrier Messages */
#define sklgt4__compute_basic__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Compute Metrics Basic Gen9 :: Typed Bytes Read */
#define sklgt4__compute_basic__typed_bytes_read__read \
    bdw__compute_basic__typed_bytes_read__read

/* Compute Metrics Basic Gen9 :: Typed Bytes Read */
#define sklgt4__compute_basic__typed_bytes_read__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen9 :: Typed Bytes Written */
#define sklgt4__compute_basic__typed_bytes_written__read \
    bdw__compute_basic__typed_bytes_written__read

/* Compute Metrics Basic Gen9 :: Typed Bytes Written */
#define sklgt4__compute_basic__typed_bytes_written__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen9 :: Untyped Bytes Read */
#define sklgt4__compute_basic__untyped_bytes_read__read \
    bdw__compute_basic__untyped_bytes_read__read

/* Compute Metrics Basic Gen9 :: Untyped Bytes Read */
#define sklgt4__compute_basic__untyped_bytes_read__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen9 :: Untyped Writes */
#define sklgt4__compute_basic__untyped_bytes_written__read \
    bdw__compute_basic__untyped_bytes_written__read

/* Compute Metrics Basic Gen9 :: Untyped Writes */
#define sklgt4__compute_basic__untyped_bytes_written__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen9 :: GTI Read Throughput */
#define sklgt4__compute_basic__gti_read_throughput__read \
    hsw__render_basic__gti_l3_throughput__read

/* Compute Metrics Basic Gen9 :: GTI Read Throughput */
#define sklgt4__compute_basic__gti_read_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen9 :: GTI Write Throughput */
#define sklgt4__compute_basic__gti_write_throughput__read \
    bdw__render_basic__gti_hdc_lookups_throughput__read

/* Compute Metrics Basic Gen9 :: GTI Write Throughput */
#define sklgt4__compute_basic__gti_write_throughput__max \
    bdw__render_basic__gti_write_throughput__max

/* Render Metrics for 3D Pipeline Profile Gen9 :: GPU Time Elapsed */
#define sklgt4__render_pipe_profile__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: GPU Core Clocks */
#define sklgt4__render_pipe_profile__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: AVG GPU Core Frequency */
#define sklgt4__render_pipe_profile__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: AVG GPU Core Frequency */
#define sklgt4__render_pipe_profile__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Render Metrics for 3D Pipeline Profile Gen9 :: GPU Busy */
#define sklgt4__render_pipe_profile__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: VS Threads Dispatched */
#define sklgt4__render_pipe_profile__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: HS Threads Dispatched */
#define sklgt4__render_pipe_profile__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: DS Threads Dispatched */
#define sklgt4__render_pipe_profile__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: GS Threads Dispatched */
#define sklgt4__render_pipe_profile__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: FS Threads Dispatched */
#define sklgt4__render_pipe_profile__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: CS Threads Dispatched */
#define sklgt4__render_pipe_profile__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: EU Active */
#define sklgt4__render_pipe_profile__eu_active__read \
    bdw__render_basic__eu_active__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: EU Stall */
#define sklgt4__render_pipe_profile__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Rasterized Pixels */
#define sklgt4__render_pipe_profile__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Early Hi-Depth Test Fails */
#define sklgt4__render_pipe_profile__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Early Depth Test Fails */
#define sklgt4__render_pipe_profile__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Samples Killed in FS */
#define sklgt4__render_pipe_profile__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Pixels Failing Tests */
#define sklgt4__render_pipe_profile__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Samples Written */
#define sklgt4__render_pipe_profile__samples_written__read \
    bdw__render_basic__samples_written__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Samples Blended */
#define sklgt4__render_pipe_profile__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Sampler Texels */
#define sklgt4__render_pipe_profile__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Sampler Texels Misses */
#define sklgt4__render_pipe_profile__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: SLM Bytes Read */
#define sklgt4__render_pipe_profile__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: SLM Bytes Read */
#define sklgt4__render_pipe_profile__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics for 3D Pipeline Profile Gen9 :: SLM Bytes Written */
#define sklgt4__render_pipe_profile__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: SLM Bytes Written */
#define sklgt4__render_pipe_profile__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics for 3D Pipeline Profile Gen9 :: Shader Memory Accesses */
#define sklgt4__render_pipe_profile__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Shader Atomic Memory Accesses */
#define sklgt4__render_pipe_profile__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: L3 Shader Throughput */
#define sklgt4__render_pipe_profile__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: L3 Shader Throughput */
#define sklgt4__render_pipe_profile__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics for 3D Pipeline Profile Gen9 :: Shader Barrier Messages */
#define sklgt4__render_pipe_profile__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: VF Bottleneck */
#define sklgt4__render_pipe_profile__vf_bottleneck__read \
    bdw__render_pipe_profile__vf_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: VS Bottleneck */
#define sklgt4__render_pipe_profile__vs_bottleneck__read \
    bdw__render_basic__sampler0_busy__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: HS Bottleneck */
#define sklgt4__render_pipe_profile__hs_bottleneck__read \
    bdw__render_basic__sampler1_busy__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: DS Bottleneck */
#define sklgt4__render_pipe_profile__ds_bottleneck__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: GS Bottleneck */
#define sklgt4__render_pipe_profile__gs_bottleneck__read \
    bdw__render_basic__sampler1_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: SO Bottleneck */
#define sklgt4__render_pipe_profile__so_bottleneck__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Clipper Bottleneck */
#define sklgt4__render_pipe_profile__cl_bottleneck__read \
    bdw__render_pipe_profile__cl_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Strip-Fans Bottleneck */
#define sklgt4__render_pipe_profile__sf_bottleneck__read \
    bdw__render_pipe_profile__sf_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Hi-Depth Bottleneck */
#define sklgt4__render_pipe_profile__hi_depth_bottleneck__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Early Depth Bottleneck */
#define sklgt4__render_pipe_profile__early_depth_bottleneck__read \
    bdw__render_pipe_profile__early_depth_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: BC Bottleneck */
#define sklgt4__render_pipe_profile__bc_bottleneck__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: HS Stall */
#define sklgt4__render_pipe_profile__hs_stall__read \
    bdw__render_pipe_profile__hs_stall__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: DS Stall */
#define sklgt4__render_pipe_profile__ds_stall__read \
    bdw__render_pipe_profile__ds_stall__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: SO Stall */
#define sklgt4__render_pipe_profile__so_stall__read \
    bdw__render_pipe_profile__so_stall__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: CL Stall */
#define sklgt4__render_pipe_profile__cl_stall__read \
    bdw__render_pipe_profile__cl_stall__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: SF Stall */
#define sklgt4__render_pipe_profile__sf_stall__read \
    bdw__render_pipe_profile__sf_stall__read

/* Memory Reads Distribution Gen9 :: GPU Time Elapsed */
#define sklgt4__memory_reads__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Memory Reads Distribution Gen9 :: GPU Core Clocks */
#define sklgt4__memory_reads__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Memory Reads Distribution Gen9 :: AVG GPU Core Frequency */
#define sklgt4__memory_reads__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Memory Reads Distribution Gen9 :: AVG GPU Core Frequency */
#define sklgt4__memory_reads__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Memory Reads Distribution Gen9 :: GPU Busy */
#define sklgt4__memory_reads__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Memory Reads Distribution Gen9 :: VS Threads Dispatched */
#define sklgt4__memory_reads__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Memory Reads Distribution Gen9 :: HS Threads Dispatched */
#define sklgt4__memory_reads__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Memory Reads Distribution Gen9 :: DS Threads Dispatched */
#define sklgt4__memory_reads__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Memory Reads Distribution Gen9 :: GS Threads Dispatched */
#define sklgt4__memory_reads__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Memory Reads Distribution Gen9 :: FS Threads Dispatched */
#define sklgt4__memory_reads__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Memory Reads Distribution Gen9 :: CS Threads Dispatched */
#define sklgt4__memory_reads__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Memory Reads Distribution Gen9 :: EU Active */
#define sklgt4__memory_reads__eu_active__read \
    bdw__render_basic__eu_active__read

/* Memory Reads Distribution Gen9 :: EU Stall */
#define sklgt4__memory_reads__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Memory Reads Distribution Gen9 :: Rasterized Pixels */
#define sklgt4__memory_reads__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Memory Reads Distribution Gen9 :: Early Hi-Depth Test Fails */
#define sklgt4__memory_reads__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Memory Reads Distribution Gen9 :: Early Depth Test Fails */
#define sklgt4__memory_reads__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Memory Reads Distribution Gen9 :: Samples Killed in FS */
#define sklgt4__memory_reads__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Memory Reads Distribution Gen9 :: Pixels Failing Tests */
#define sklgt4__memory_reads__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Memory Reads Distribution Gen9 :: Samples Written */
#define sklgt4__memory_reads__samples_written__read \
    bdw__render_basic__samples_written__read

/* Memory Reads Distribution Gen9 :: Samples Blended */
#define sklgt4__memory_reads__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Memory Reads Distribution Gen9 :: Sampler Texels */
#define sklgt4__memory_reads__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Memory Reads Distribution Gen9 :: Sampler Texels Misses */
#define sklgt4__memory_reads__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Memory Reads Distribution Gen9 :: SLM Bytes Read */
#define sklgt4__memory_reads__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Memory Reads Distribution Gen9 :: SLM Bytes Read */
#define sklgt4__memory_reads__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Memory Reads Distribution Gen9 :: SLM Bytes Written */
#define sklgt4__memory_reads__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Memory Reads Distribution Gen9 :: SLM Bytes Written */
#define sklgt4__memory_reads__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Memory Reads Distribution Gen9 :: Shader Memory Accesses */
#define sklgt4__memory_reads__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Memory Reads Distribution Gen9 :: Shader Atomic Memory Accesses */
#define sklgt4__memory_reads__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Memory Reads Distribution Gen9 :: Shader Barrier Messages */
#define sklgt4__memory_reads__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Memory Reads Distribution Gen9 :: GtiCmdStreamerMemoryReads */
#define sklgt4__memory_reads__gti_cmd_streamer_memory_reads__read \
    hsw__compute_extended__eu_untyped_reads0__read

/* Memory Reads Distribution Gen9 :: GtiRsMemoryReads */
#define sklgt4__memory_reads__gti_rs_memory_reads__read \
    hsw__compute_extended__eu_typed_reads0__read

/* Memory Reads Distribution Gen9 :: GtiVfMemoryReads */
#define sklgt4__memory_reads__gti_vf_memory_reads__read \
    hsw__compute_extended__eu_untyped_writes0__read

/* Memory Reads Distribution Gen9 :: GtiRccMemoryReads */
#define sklgt4__memory_reads__gti_rcc_memory_reads__read \
    hsw__compute_extended__eu_typed_writes0__read

/* Memory Reads Distribution Gen9 :: GtiMscMemoryReads */
#define sklgt4__memory_reads__gti_msc_memory_reads__read \
    hsw__compute_extended__eu_untyped_atomics0__read

/* Memory Reads Distribution Gen9 :: GtiHizMemoryReads */
#define sklgt4__memory_reads__gti_hiz_memory_reads__read \
    hsw__compute_extended__eu_typed_atomics0__read

/* Memory Reads Distribution Gen9 :: GtiStcMemoryReads */
#define sklgt4__memory_reads__gti_stc_memory_reads__read \
    hsw__compute_extended__eu_urb_atomics0__read

/* Memory Reads Distribution Gen9 :: GtiRczMemoryReads */
#define sklgt4__memory_reads__gti_rcz_memory_reads__read \
    hsw__compute_extended__gpu_clocks__read

/* Memory Reads Distribution Gen9 :: GtiMemoryReads */
#define sklgt4__memory_reads__gti_memory_reads__read \
    hsw__compute_extended__typed_writes0__read

/* Memory Reads Distribution Gen9 :: GtiL3Bank0Reads */
#define sklgt4__memory_reads__gti_l3_bank0_reads__read \
    hsw__compute_extended__typed_atomics0__read

/* Memory Reads Distribution Gen9 :: GtiL3Bank1Reads */
#define sklgt4__memory_reads__gti_l3_bank1_reads__read \
    hsw__memory_reads__gti_memory_reads__read

/* Memory Reads Distribution Gen9 :: GtiL3Bank2Reads */
#define sklgt4__memory_reads__gti_l3_bank2_reads__read \
    hsw__memory_reads__llc_read_accesses__read

/* Memory Reads Distribution Gen9 :: GtiL3Bank3Reads */
#define sklgt4__memory_reads__gti_l3_bank3_reads__read \
    hsw__memory_reads__gpu_core_clocks__read

/* Memory Reads Distribution Gen9 :: GtiL3Reads */
#define sklgt4__memory_reads__gti_l3_reads__read \
    bdw__memory_reads__gti_l3_reads__read

/* Memory Reads Distribution Gen9 :: GtiRingAccesses */
#define sklgt4__memory_reads__gti_ring_accesses__read \
    bdw__memory_reads__gti_ring_accesses__read

/* Memory Writes Distribution Gen9 :: GPU Time Elapsed */
#define sklgt4__memory_writes__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Memory Writes Distribution Gen9 :: GPU Core Clocks */
#define sklgt4__memory_writes__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Memory Writes Distribution Gen9 :: AVG GPU Core Frequency */
#define sklgt4__memory_writes__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Memory Writes Distribution Gen9 :: AVG GPU Core Frequency */
#define sklgt4__memory_writes__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Memory Writes Distribution Gen9 :: GPU Busy */
#define sklgt4__memory_writes__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Memory Writes Distribution Gen9 :: VS Threads Dispatched */
#define sklgt4__memory_writes__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Memory Writes Distribution Gen9 :: HS Threads Dispatched */
#define sklgt4__memory_writes__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Memory Writes Distribution Gen9 :: DS Threads Dispatched */
#define sklgt4__memory_writes__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Memory Writes Distribution Gen9 :: GS Threads Dispatched */
#define sklgt4__memory_writes__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Memory Writes Distribution Gen9 :: FS Threads Dispatched */
#define sklgt4__memory_writes__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Memory Writes Distribution Gen9 :: CS Threads Dispatched */
#define sklgt4__memory_writes__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Memory Writes Distribution Gen9 :: EU Active */
#define sklgt4__memory_writes__eu_active__read \
    bdw__render_basic__eu_active__read

/* Memory Writes Distribution Gen9 :: EU Stall */
#define sklgt4__memory_writes__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Memory Writes Distribution Gen9 :: Rasterized Pixels */
#define sklgt4__memory_writes__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Memory Writes Distribution Gen9 :: Early Hi-Depth Test Fails */
#define sklgt4__memory_writes__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Memory Writes Distribution Gen9 :: Early Depth Test Fails */
#define sklgt4__memory_writes__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Memory Writes Distribution Gen9 :: Samples Killed in FS */
#define sklgt4__memory_writes__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Memory Writes Distribution Gen9 :: Pixels Failing Tests */
#define sklgt4__memory_writes__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Memory Writes Distribution Gen9 :: Samples Written */
#define sklgt4__memory_writes__samples_written__read \
    bdw__render_basic__samples_written__read

/* Memory Writes Distribution Gen9 :: Samples Blended */
#define sklgt4__memory_writes__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Memory Writes Distribution Gen9 :: Sampler Texels */
#define sklgt4__memory_writes__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Memory Writes Distribution Gen9 :: Sampler Texels Misses */
#define sklgt4__memory_writes__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Memory Writes Distribution Gen9 :: SLM Bytes Read */
#define sklgt4__memory_writes__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Memory Writes Distribution Gen9 :: SLM Bytes Read */
#define sklgt4__memory_writes__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Memory Writes Distribution Gen9 :: SLM Bytes Written */
#define sklgt4__memory_writes__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Memory Writes Distribution Gen9 :: SLM Bytes Written */
#define sklgt4__memory_writes__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Memory Writes Distribution Gen9 :: Shader Memory Accesses */
#define sklgt4__memory_writes__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Memory Writes Distribution Gen9 :: Shader Atomic Memory Accesses */
#define sklgt4__memory_writes__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Memory Writes Distribution Gen9 :: L3 Shader Throughput */
#define sklgt4__memory_writes__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Memory Writes Distribution Gen9 :: L3 Shader Throughput */
#define sklgt4__memory_writes__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Memory Writes Distribution Gen9 :: Shader Barrier Messages */
#define sklgt4__memory_writes__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Memory Writes Distribution Gen9 :: GtiCmdStreamerMemoryWrites */
#define sklgt4__memory_writes__gti_cmd_streamer_memory_writes__read \
    hsw__compute_extended__eu_untyped_reads0__read

/* Memory Writes Distribution Gen9 :: GtiSoMemoryWrites */
#define sklgt4__memory_writes__gti_so_memory_writes__read \
    hsw__compute_extended__eu_typed_reads0__read

/* Memory Writes Distribution Gen9 :: GtiRccMemoryWrites */
#define sklgt4__memory_writes__gti_rcc_memory_writes__read \
    hsw__compute_extended__eu_typed_writes0__read

/* Memory Writes Distribution Gen9 :: GtiMscMemoryWrites */
#define sklgt4__memory_writes__gti_msc_memory_writes__read \
    hsw__compute_extended__eu_untyped_atomics0__read

/* Memory Writes Distribution Gen9 :: GtiHizMemoryWrites */
#define sklgt4__memory_writes__gti_hiz_memory_writes__read \
    hsw__compute_extended__eu_typed_atomics0__read

/* Memory Writes Distribution Gen9 :: GtiStcMemoryWrites */
#define sklgt4__memory_writes__gti_stc_memory_writes__read \
    hsw__compute_extended__eu_urb_atomics0__read

/* Memory Writes Distribution Gen9 :: GtiRczMemoryWrites */
#define sklgt4__memory_writes__gti_rcz_memory_writes__read \
    hsw__compute_extended__gpu_clocks__read

/* Memory Writes Distribution Gen9 :: GtiMemoryWrites */
#define sklgt4__memory_writes__gti_memory_writes__read \
    hsw__compute_extended__typed_writes0__read

/* Memory Writes Distribution Gen9 :: GtiL3Bank0Writes */
#define sklgt4__memory_writes__gti_l3_bank0_writes__read \
    hsw__compute_extended__typed_atomics0__read

/* Memory Writes Distribution Gen9 :: GtiL3Bank1Writes */
#define sklgt4__memory_writes__gti_l3_bank1_writes__read \
    hsw__memory_reads__gti_memory_reads__read

/* Memory Writes Distribution Gen9 :: GtiL3Bank2Writes */
#define sklgt4__memory_writes__gti_l3_bank2_writes__read \
    hsw__memory_reads__llc_read_accesses__read

/* Memory Writes Distribution Gen9 :: GtiL3Bank3Writes */
#define sklgt4__memory_writes__gti_l3_bank3_writes__read \
    hsw__memory_reads__gpu_core_clocks__read

/* Memory Writes Distribution Gen9 :: GtiL3Writes */
#define sklgt4__memory_writes__gti_l3_writes__read \
    bdw__memory_reads__gti_l3_reads__read

/* Memory Writes Distribution Gen9 :: GtiRingAccesses */
#define sklgt4__memory_writes__gti_ring_accesses__read \
    bdw__memory_reads__gti_ring_accesses__read

/* Compute Metrics Extended Gen9 :: GPU Time Elapsed */
#define sklgt4__compute_extended__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Compute Metrics Extended Gen9 :: GPU Core Clocks */
#define sklgt4__compute_extended__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Compute Metrics Extended Gen9 :: AVG GPU Core Frequency */
#define sklgt4__compute_extended__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Compute Metrics Extended Gen9 :: AVG GPU Core Frequency */
#define sklgt4__compute_extended__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Compute Metrics Extended Gen9 :: CS Threads Dispatched */
#define sklgt4__compute_extended__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Compute Metrics Extended Gen9 :: EU Active */
#define sklgt4__compute_extended__eu_active__read \
    bdw__render_basic__eu_active__read

/* Compute Metrics Extended Gen9 :: EU Stall */
#define sklgt4__compute_extended__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Compute Metrics Extended Gen9 :: EU Both FPU Pipes Active */
#define sklgt4__compute_extended__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Compute Metrics Extended Gen9 :: EU FPU0 Pipe Active */
#define sklgt4__compute_extended__fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Compute Metrics Extended Gen9 :: EU FPU1 Pipe Active */
#define sklgt4__compute_extended__fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Compute Metrics Extended Gen9 :: EU AVG IPC Rate */
#define sklgt4__compute_extended__eu_avg_ipc_rate__read \
    bdw__compute_basic__eu_avg_ipc_rate__read

/* Compute Metrics Extended Gen9 :: EU AVG IPC Rate */
#define sklgt4__compute_extended__eu_avg_ipc_rate__max \
    bdw__compute_basic__eu_avg_ipc_rate__max

/* Compute Metrics Extended Gen9 :: EU Send Pipe Active */
#define sklgt4__compute_extended__eu_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Compute Metrics Extended Gen9 :: EU Thread Occupancy */
#define sklgt4__compute_extended__eu_thread_occupancy__read \
    bdw__compute_basic__eu_thread_occupancy__read

/* Compute Metrics Extended Gen9 :: Sampler Texels */
#define sklgt4__compute_extended__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Compute Metrics Extended Gen9 :: Sampler Texels Misses */
#define sklgt4__compute_extended__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Compute Metrics Extended Gen9 :: SLM Bytes Read */
#define sklgt4__compute_extended__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Compute Metrics Extended Gen9 :: SLM Bytes Read */
#define sklgt4__compute_extended__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Extended Gen9 :: SLM Bytes Written */
#define sklgt4__compute_extended__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Compute Metrics Extended Gen9 :: SLM Bytes Written */
#define sklgt4__compute_extended__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Extended Gen9 :: Shader Memory Accesses */
#define sklgt4__compute_extended__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Compute Metrics Extended Gen9 :: Shader Atomic Memory Accesses */
#define sklgt4__compute_extended__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Compute Metrics Extended Gen9 :: L3 Shader Throughput */
#define sklgt4__compute_extended__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Compute Metrics Extended Gen9 :: L3 Shader Throughput */
#define sklgt4__compute_extended__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Extended Gen9 :: Shader Barrier Messages */
#define sklgt4__compute_extended__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Compute Metrics Extended Gen9 :: EuUntypedReads0 */
#define sklgt4__compute_extended__eu_untyped_reads0__read \
    hsw__compute_extended__eu_untyped_reads0__read

/* Compute Metrics Extended Gen9 :: EuTypedReads0 */
#define sklgt4__compute_extended__eu_typed_reads0__read \
    hsw__compute_extended__eu_typed_reads0__read

/* Compute Metrics Extended Gen9 :: EuUntypedWrites0 */
#define sklgt4__compute_extended__eu_untyped_writes0__read \
    hsw__compute_extended__eu_untyped_writes0__read

/* Compute Metrics Extended Gen9 :: EuTypedWrites0 */
#define sklgt4__compute_extended__eu_typed_writes0__read \
    hsw__compute_extended__eu_typed_writes0__read

/* Compute Metrics Extended Gen9 :: EuUntypedAtomics0 */
#define sklgt4__compute_extended__eu_untyped_atomics0__read \
    hsw__compute_extended__eu_untyped_atomics0__read

/* Compute Metrics Extended Gen9 :: EuTypedAtomics0 */
#define sklgt4__compute_extended__eu_typed_atomics0__read \
    hsw__compute_extended__eu_typed_atomics0__read

/* Compute Metrics Extended Gen9 :: EuA64UntypedReads0 */
#define sklgt4__compute_extended__eu_a64_untyped_reads0__read \
    hsw__compute_extended__eu_urb_atomics0__read

/* Compute Metrics Extended Gen9 :: EuA64UntypedWrites0 */
#define sklgt4__compute_extended__eu_a64_untyped_writes0__read \
    hsw__compute_extended__gpu_clocks__read

/* Compute Metrics Extended Gen9 :: Typed Reads 0 */
#define sklgt4__compute_extended__typed_reads0__read \
    hsw__render_basic__gpu_core_clocks__read

/* Compute Metrics Extended Gen9 :: Typed Writes 0 */
#define sklgt4__compute_extended__typed_writes0__read \
    hsw__compute_extended__typed_writes0__read

/* Compute Metrics Extended Gen9 :: Untyped Reads 0 */
#define sklgt4__compute_extended__untyped_reads0__read \
    hsw__compute_extended__untyped_reads0__read

/* Compute Metrics Extended Gen9 :: Untyped Writes 0 */
#define sklgt4__compute_extended__untyped_writes0__read \
    hsw__compute_extended__untyped_writes0__read

/* Compute Metrics Extended Gen9 :: Typed Atomics 0 */
#define sklgt4__compute_extended__typed_atomics0__read \
    hsw__compute_extended__typed_atomics0__read

/* Compute Metrics Extended Gen9 :: TypedReadsPerCacheLine */
#define sklgt4__compute_extended__typed_reads_per_cache_line__read \
    hsw__compute_extended__typed_reads_per_cache_line__read

/* Compute Metrics Extended Gen9 :: TypedWritesPerCacheLine */
#define sklgt4__compute_extended__typed_writes_per_cache_line__read \
    hsw__compute_extended__typed_writes_per_cache_line__read

/* Compute Metrics Extended Gen9 :: UntypedReadsPerCacheLine */
#define sklgt4__compute_extended__untyped_reads_per_cache_line__read \
    bdw__compute_extended__untyped_reads_per_cache_line__read

/* Compute Metrics Extended Gen9 :: UntypedWritesPerCacheLine */
#define sklgt4__compute_extended__untyped_writes_per_cache_line__read \
    bdw__compute_extended__untyped_writes_per_cache_line__read

/* Compute Metrics Extended Gen9 :: TypedAtomicsPerCacheLine */
#define sklgt4__compute_extended__typed_atomics_per_cache_line__read \
    hsw__compute_extended__typed_atomics_per_cache_line__read

/* Compute Metrics L3 Cache Gen9 :: GPU Time Elapsed */
#define sklgt4__compute_l3_cache__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Compute Metrics L3 Cache Gen9 :: GPU Core Clocks */
#define sklgt4__compute_l3_cache__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Compute Metrics L3 Cache Gen9 :: AVG GPU Core Frequency */
#define sklgt4__compute_l3_cache__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Compute Metrics L3 Cache Gen9 :: AVG GPU Core Frequency */
#define sklgt4__compute_l3_cache__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Compute Metrics L3 Cache Gen9 :: GPU Busy */
#define sklgt4__compute_l3_cache__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Compute Metrics L3 Cache Gen9 :: VS Threads Dispatched */
#define sklgt4__compute_l3_cache__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Compute Metrics L3 Cache Gen9 :: HS Threads Dispatched */
#define sklgt4__compute_l3_cache__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Compute Metrics L3 Cache Gen9 :: DS Threads Dispatched */
#define sklgt4__compute_l3_cache__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Compute Metrics L3 Cache Gen9 :: GS Threads Dispatched */
#define sklgt4__compute_l3_cache__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Compute Metrics L3 Cache Gen9 :: FS Threads Dispatched */
#define sklgt4__compute_l3_cache__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Compute Metrics L3 Cache Gen9 :: CS Threads Dispatched */
#define sklgt4__compute_l3_cache__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Compute Metrics L3 Cache Gen9 :: EU Active */
#define sklgt4__compute_l3_cache__eu_active__read \
    bdw__render_basic__eu_active__read

/* Compute Metrics L3 Cache Gen9 :: EU Stall */
#define sklgt4__compute_l3_cache__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Compute Metrics L3 Cache Gen9 :: EU Both FPU Pipes Active */
#define sklgt4__compute_l3_cache__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU0 Pipe Active */
#define sklgt4__compute_l3_cache__fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU1 Pipe Active */
#define sklgt4__compute_l3_cache__fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Compute Metrics L3 Cache Gen9 :: EU AVG IPC Rate */
#define sklgt4__compute_l3_cache__eu_avg_ipc_rate__read \
    bdw__compute_basic__eu_avg_ipc_rate__read

/* Compute Metrics L3 Cache Gen9 :: EU AVG IPC Rate */
#define sklgt4__compute_l3_cache__eu_avg_ipc_rate__max \
    bdw__compute_basic__eu_avg_ipc_rate__max

/* Compute Metrics L3 Cache Gen9 :: EU Send Pipe Active */
#define sklgt4__compute_l3_cache__eu_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU0 Hybrid Instruction */
#define sklgt4__compute_l3_cache__eu_hybrid_fpu0_instruction__read \
    bdw__compute_l3_cache__eu_hybrid_fpu0_instruction__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU1 Hybrid Instruction */
#define sklgt4__compute_l3_cache__eu_hybrid_fpu1_instruction__read \
    bdw__compute_l3_cache__eu_hybrid_fpu1_instruction__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU0 Ternary Instruction */
#define sklgt4__compute_l3_cache__eu_ternary_fpu0_instruction__read \
    bdw__render_basic__ps_fpu0_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU1 Ternary Instruction */
#define sklgt4__compute_l3_cache__eu_ternary_fpu1_instruction__read \
    bdw__render_basic__ps_fpu1_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU0 Binary Instruction */
#define sklgt4__compute_l3_cache__eu_binary_fpu0_instruction__read \
    bdw__render_basic__ps_send_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU1 Binary Instruction */
#define sklgt4__compute_l3_cache__eu_binary_fpu1_instruction__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU0 Move Instruction */
#define sklgt4__compute_l3_cache__eu_move_fpu0_instruction__read \
    bdw__compute_l3_cache__eu_move_fpu0_instruction__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU1 Move Instruction */
#define sklgt4__compute_l3_cache__eu_move_fpu1_instruction__read \
    bdw__compute_l3_cache__eu_move_fpu1_instruction__read

/* Compute Metrics L3 Cache Gen9 :: Rasterized Pixels */
#define sklgt4__compute_l3_cache__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Compute Metrics L3 Cache Gen9 :: Early Hi-Depth Test Fails */
#define sklgt4__compute_l3_cache__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Compute Metrics L3 Cache Gen9 :: Early Depth Test Fails */
#define sklgt4__compute_l3_cache__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Compute Metrics L3 Cache Gen9 :: Samples Killed in FS */
#define sklgt4__compute_l3_cache__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Compute Metrics L3 Cache Gen9 :: Pixels Failing Tests */
#define sklgt4__compute_l3_cache__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Compute Metrics L3 Cache Gen9 :: Samples Written */
#define sklgt4__compute_l3_cache__samples_written__read \
    bdw__render_basic__samples_written__read

/* Compute Metrics L3 Cache Gen9 :: Samples Blended */
#define sklgt4__compute_l3_cache__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Compute Metrics L3 Cache Gen9 :: Sampler Accesses */
#define sklgt4__compute_l3_cache__sampler_accesses__read \
    bdw__render_pipe_profile__sampler_accesses__read

/* Compute Metrics L3 Cache Gen9 :: Sampler Texels */
#define sklgt4__compute_l3_cache__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Compute Metrics L3 Cache Gen9 :: Sampler Texels Misses */
#define sklgt4__compute_l3_cache__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Compute Metrics L3 Cache Gen9 :: SLM Bytes Read */
#define sklgt4__compute_l3_cache__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Compute Metrics L3 Cache Gen9 :: SLM Bytes Read */
#define sklgt4__compute_l3_cache__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics L3 Cache Gen9 :: SLM Bytes Written */
#define sklgt4__compute_l3_cache__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Compute Metrics L3 Cache Gen9 :: SLM Bytes Written */
#define sklgt4__compute_l3_cache__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics L3 Cache Gen9 :: Shader Memory Accesses */
#define sklgt4__compute_l3_cache__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Compute Metrics L3 Cache Gen9 :: Shader Atomic Memory Accesses */
#define sklgt4__compute_l3_cache__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Compute Metrics L3 Cache Gen9 :: L3 Accesses */
#define sklgt4__compute_l3_cache__l3_accesses__read \
    sklgt2__compute_l3_cache__l3_accesses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Misses */
#define sklgt4__compute_l3_cache__l3_misses__read \
    bdw__compute_l3_cache__l3_misses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Sampler Throughput */
#define sklgt4__compute_l3_cache__l3_sampler_throughput__read \
    chv__render_basic__l3_sampler_throughput__read

/* Compute Metrics L3 Cache Gen9 :: L3 Sampler Throughput */
#define sklgt4__compute_l3_cache__l3_sampler_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics L3 Cache Gen9 :: L3 Shader Throughput */
#define sklgt4__compute_l3_cache__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Compute Metrics L3 Cache Gen9 :: L3 Shader Throughput */
#define sklgt4__compute_l3_cache__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics L3 Cache Gen9 :: L3 Total Throughput */
#define sklgt4__compute_l3_cache__l3_total_throughput__read \
    sklgt2__compute_l3_cache__l3_total_throughput__read

/* Compute Metrics L3 Cache Gen9 :: L3 Total Throughput */
#define sklgt4__compute_l3_cache__l3_total_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics L3 Cache Gen9 :: Shader Barrier Messages */
#define sklgt4__compute_l3_cache__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Compute Metrics L3 Cache Gen9 :: L3 Bank 00 Accesses */
#define sklgt4__compute_l3_cache__l3_bank00_accesses__read \
    bdw__compute_l3_cache__l3_bank00_accesses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Bank 01 Accesses */
#define sklgt4__compute_l3_cache__l3_bank01_accesses__read \
    bdw__compute_l3_cache__l3_bank01_accesses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Bank 02 Accesses */
#define sklgt4__compute_l3_cache__l3_bank02_accesses__read \
    bdw__compute_l3_cache__l3_bank02_accesses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Bank 03 Accesses */
#define sklgt4__compute_l3_cache__l3_bank03_accesses__read \
    bdw__compute_l3_cache__l3_bank03_accesses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Bank 00 IC Accesses */
#define sklgt4__compute_l3_cache__l3_bank00_ic_accesses__read \
    bdw__compute_l3_cache__l3_bank00_ic_accesses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Bank 00 IC Hits */
#define sklgt4__compute_l3_cache__l3_bank00_ic_hits__read \
    bdw__compute_l3_cache__l3_bank00_ic_hits__read

/* Compute Metrics L3 Cache Gen9 :: GTI L3 Throughput */
#define sklgt4__compute_l3_cache__gti_l3_throughput__read \
    bdw__compute_l3_cache__gti_l3_throughput__read

/* Compute Metrics L3 Cache Gen9 :: GTI L3 Throughput */
#define sklgt4__compute_l3_cache__gti_l3_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics L3 Cache Gen9 :: GTI Read Throughput */
#define sklgt4__compute_l3_cache__gti_read_throughput__read \
    bdw__render_basic__gti_read_throughput__read

/* Compute Metrics L3 Cache Gen9 :: GTI Read Throughput */
#define sklgt4__compute_l3_cache__gti_read_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Compute Metrics L3 Cache Gen9 :: GTI Write Throughput */
#define sklgt4__compute_l3_cache__gti_write_throughput__read \
    hsw__render_basic__gti_write_throughput__read

/* Compute Metrics L3 Cache Gen9 :: GTI Write Throughput */
#define sklgt4__compute_l3_cache__gti_write_throughput__max \
    bdw__render_basic__gti_write_throughput__max

/* Metric set HDCAndSF :: GPU Time Elapsed */
#define sklgt4__hdc_and_sf__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set HDCAndSF :: GPU Core Clocks */
#define sklgt4__hdc_and_sf__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set HDCAndSF :: AVG GPU Core Frequency */
#define sklgt4__hdc_and_sf__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set HDCAndSF :: AVG GPU Core Frequency */
#define sklgt4__hdc_and_sf__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set HDCAndSF :: GPU Busy */
#define sklgt4__hdc_and_sf__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set HDCAndSF :: VS Threads Dispatched */
#define sklgt4__hdc_and_sf__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set HDCAndSF :: HS Threads Dispatched */
#define sklgt4__hdc_and_sf__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set HDCAndSF :: DS Threads Dispatched */
#define sklgt4__hdc_and_sf__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set HDCAndSF :: GS Threads Dispatched */
#define sklgt4__hdc_and_sf__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set HDCAndSF :: FS Threads Dispatched */
#define sklgt4__hdc_and_sf__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set HDCAndSF :: CS Threads Dispatched */
#define sklgt4__hdc_and_sf__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set HDCAndSF :: EU Active */
#define sklgt4__hdc_and_sf__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set HDCAndSF :: EU Stall */
#define sklgt4__hdc_and_sf__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set HDCAndSF :: EU Both FPU Pipes Active */
#define sklgt4__hdc_and_sf__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set HDCAndSF :: VS FPU0 Pipe Active */
#define sklgt4__hdc_and_sf__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set HDCAndSF :: VS FPU1 Pipe Active */
#define sklgt4__hdc_and_sf__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set HDCAndSF :: VS Send Pipe Active */
#define sklgt4__hdc_and_sf__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set HDCAndSF :: PS FPU0 Pipe Active */
#define sklgt4__hdc_and_sf__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set HDCAndSF :: PS FPU1 Pipe Active */
#define sklgt4__hdc_and_sf__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set HDCAndSF :: PS Send Pipeline Active */
#define sklgt4__hdc_and_sf__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set HDCAndSF :: FS Both FPU Active */
#define sklgt4__hdc_and_sf__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set HDCAndSF :: Rasterized Pixels */
#define sklgt4__hdc_and_sf__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set HDCAndSF :: Early Hi-Depth Test Fails */
#define sklgt4__hdc_and_sf__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set HDCAndSF :: Early Depth Test Fails */
#define sklgt4__hdc_and_sf__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set HDCAndSF :: Samples Killed in FS */
#define sklgt4__hdc_and_sf__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set HDCAndSF :: Pixels Failing Tests */
#define sklgt4__hdc_and_sf__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set HDCAndSF :: Samples Written */
#define sklgt4__hdc_and_sf__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set HDCAndSF :: Samples Blended */
#define sklgt4__hdc_and_sf__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set HDCAndSF :: Sampler Texels */
#define sklgt4__hdc_and_sf__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set HDCAndSF :: Sampler Texels Misses */
#define sklgt4__hdc_and_sf__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set HDCAndSF :: SLM Bytes Read */
#define sklgt4__hdc_and_sf__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set HDCAndSF :: SLM Bytes Read */
#define sklgt4__hdc_and_sf__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set HDCAndSF :: SLM Bytes Written */
#define sklgt4__hdc_and_sf__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set HDCAndSF :: SLM Bytes Written */
#define sklgt4__hdc_and_sf__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set HDCAndSF :: Shader Memory Accesses */
#define sklgt4__hdc_and_sf__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set HDCAndSF :: Shader Atomic Memory Accesses */
#define sklgt4__hdc_and_sf__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set HDCAndSF :: L3 Shader Throughput */
#define sklgt4__hdc_and_sf__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set HDCAndSF :: L3 Shader Throughput */
#define sklgt4__hdc_and_sf__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set HDCAndSF :: Shader Barrier Messages */
#define sklgt4__hdc_and_sf__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set HDCAndSF :: Polygon Data Ready */
#define sklgt4__hdc_and_sf__poly_data_ready__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set HDCAndSF :: HDC stalled by L3 (s0.ss0) */
#define sklgt4__hdc_and_sf__non_sampler_shader00_access_stalled_on_l3__read \
    bdw__hdc_and_sf__non_sampler_shader02_access_stalled_on_l3__read

/* Metric set HDCAndSF :: HDC stalled by L3 (s0.ss1) */
#define sklgt4__hdc_and_sf__non_sampler_shader01_access_stalled_on_l3__read \
    bdw__hdc_and_sf__non_sampler_shader01_access_stalled_on_l3__read

/* Metric set HDCAndSF :: HDC stalled by L3 (s0.ss2) */
#define sklgt4__hdc_and_sf__non_sampler_shader02_access_stalled_on_l3__read \
    bdw__hdc_and_sf__non_sampler_shader00_access_stalled_on_l3__read

/* Metric set HDCAndSF :: SQ is full */
#define sklgt4__hdc_and_sf__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set L3_1 :: GPU Time Elapsed */
#define sklgt4__l3_1__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set L3_1 :: GPU Core Clocks */
#define sklgt4__l3_1__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set L3_1 :: AVG GPU Core Frequency */
#define sklgt4__l3_1__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set L3_1 :: AVG GPU Core Frequency */
#define sklgt4__l3_1__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set L3_1 :: GPU Busy */
#define sklgt4__l3_1__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set L3_1 :: VS Threads Dispatched */
#define sklgt4__l3_1__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set L3_1 :: HS Threads Dispatched */
#define sklgt4__l3_1__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set L3_1 :: DS Threads Dispatched */
#define sklgt4__l3_1__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set L3_1 :: GS Threads Dispatched */
#define sklgt4__l3_1__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set L3_1 :: FS Threads Dispatched */
#define sklgt4__l3_1__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set L3_1 :: CS Threads Dispatched */
#define sklgt4__l3_1__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set L3_1 :: EU Active */
#define sklgt4__l3_1__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set L3_1 :: EU Stall */
#define sklgt4__l3_1__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set L3_1 :: EU Both FPU Pipes Active */
#define sklgt4__l3_1__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set L3_1 :: VS FPU0 Pipe Active */
#define sklgt4__l3_1__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set L3_1 :: VS FPU1 Pipe Active */
#define sklgt4__l3_1__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set L3_1 :: VS Send Pipe Active */
#define sklgt4__l3_1__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set L3_1 :: PS FPU0 Pipe Active */
#define sklgt4__l3_1__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set L3_1 :: PS FPU1 Pipe Active */
#define sklgt4__l3_1__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set L3_1 :: PS Send Pipeline Active */
#define sklgt4__l3_1__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set L3_1 :: FS Both FPU Active */
#define sklgt4__l3_1__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set L3_1 :: Rasterized Pixels */
#define sklgt4__l3_1__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set L3_1 :: Early Hi-Depth Test Fails */
#define sklgt4__l3_1__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set L3_1 :: Early Depth Test Fails */
#define sklgt4__l3_1__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set L3_1 :: Samples Killed in FS */
#define sklgt4__l3_1__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set L3_1 :: Pixels Failing Tests */
#define sklgt4__l3_1__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set L3_1 :: Samples Written */
#define sklgt4__l3_1__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set L3_1 :: Samples Blended */
#define sklgt4__l3_1__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set L3_1 :: Sampler Texels */
#define sklgt4__l3_1__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set L3_1 :: Sampler Texels Misses */
#define sklgt4__l3_1__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set L3_1 :: SLM Bytes Read */
#define sklgt4__l3_1__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set L3_1 :: SLM Bytes Read */
#define sklgt4__l3_1__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_1 :: SLM Bytes Written */
#define sklgt4__l3_1__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set L3_1 :: SLM Bytes Written */
#define sklgt4__l3_1__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_1 :: Shader Memory Accesses */
#define sklgt4__l3_1__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set L3_1 :: Shader Atomic Memory Accesses */
#define sklgt4__l3_1__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set L3_1 :: L3 Shader Throughput */
#define sklgt4__l3_1__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set L3_1 :: L3 Shader Throughput */
#define sklgt4__l3_1__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_1 :: Shader Barrier Messages */
#define sklgt4__l3_1__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set L3_1 :: Slice0 L3 Bank0 Stalled */
#define sklgt4__l3_1__l30_bank0_stalled__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set L3_1 :: Slice0 L3 Bank1 Stalled */
#define sklgt4__l3_1__l30_bank1_stalled__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* Metric set L3_1 :: Slice0 L3 Bank1 Active */
#define sklgt4__l3_1__l30_bank1_active__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set L3_1 :: Slice0 L3 Bank0 Active */
#define sklgt4__l3_1__l30_bank0_active__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set L3_1 :: SQ is full */
#define sklgt4__l3_1__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set L3_2 :: GPU Time Elapsed */
#define sklgt4__l3_2__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set L3_2 :: GPU Core Clocks */
#define sklgt4__l3_2__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set L3_2 :: AVG GPU Core Frequency */
#define sklgt4__l3_2__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set L3_2 :: AVG GPU Core Frequency */
#define sklgt4__l3_2__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set L3_2 :: GPU Busy */
#define sklgt4__l3_2__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set L3_2 :: VS Threads Dispatched */
#define sklgt4__l3_2__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set L3_2 :: HS Threads Dispatched */
#define sklgt4__l3_2__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set L3_2 :: DS Threads Dispatched */
#define sklgt4__l3_2__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set L3_2 :: GS Threads Dispatched */
#define sklgt4__l3_2__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set L3_2 :: FS Threads Dispatched */
#define sklgt4__l3_2__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set L3_2 :: CS Threads Dispatched */
#define sklgt4__l3_2__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set L3_2 :: EU Active */
#define sklgt4__l3_2__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set L3_2 :: EU Stall */
#define sklgt4__l3_2__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set L3_2 :: EU Both FPU Pipes Active */
#define sklgt4__l3_2__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set L3_2 :: VS FPU0 Pipe Active */
#define sklgt4__l3_2__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set L3_2 :: VS FPU1 Pipe Active */
#define sklgt4__l3_2__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set L3_2 :: VS Send Pipe Active */
#define sklgt4__l3_2__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set L3_2 :: PS FPU0 Pipe Active */
#define sklgt4__l3_2__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set L3_2 :: PS FPU1 Pipe Active */
#define sklgt4__l3_2__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set L3_2 :: PS Send Pipeline Active */
#define sklgt4__l3_2__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set L3_2 :: FS Both FPU Active */
#define sklgt4__l3_2__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set L3_2 :: Rasterized Pixels */
#define sklgt4__l3_2__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set L3_2 :: Early Hi-Depth Test Fails */
#define sklgt4__l3_2__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set L3_2 :: Early Depth Test Fails */
#define sklgt4__l3_2__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set L3_2 :: Samples Killed in FS */
#define sklgt4__l3_2__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set L3_2 :: Pixels Failing Tests */
#define sklgt4__l3_2__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set L3_2 :: Samples Written */
#define sklgt4__l3_2__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set L3_2 :: Samples Blended */
#define sklgt4__l3_2__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set L3_2 :: Sampler Texels */
#define sklgt4__l3_2__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set L3_2 :: Sampler Texels Misses */
#define sklgt4__l3_2__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set L3_2 :: SLM Bytes Read */
#define sklgt4__l3_2__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set L3_2 :: SLM Bytes Read */
#define sklgt4__l3_2__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_2 :: SLM Bytes Written */
#define sklgt4__l3_2__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set L3_2 :: SLM Bytes Written */
#define sklgt4__l3_2__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_2 :: Shader Memory Accesses */
#define sklgt4__l3_2__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set L3_2 :: Shader Atomic Memory Accesses */
#define sklgt4__l3_2__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set L3_2 :: L3 Shader Throughput */
#define sklgt4__l3_2__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set L3_2 :: L3 Shader Throughput */
#define sklgt4__l3_2__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_2 :: Shader Barrier Messages */
#define sklgt4__l3_2__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set L3_2 :: Slice0 L3 Bank2 Stalled */
#define sklgt4__l3_2__l30_bank2_stalled__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set L3_2 :: Slice0 L3 Bank2 Active */
#define sklgt4__l3_2__l30_bank2_active__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set L3_2 :: SQ is full */
#define sklgt4__l3_2__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set L3_3 :: GPU Time Elapsed */
#define sklgt4__l3_3__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set L3_3 :: GPU Core Clocks */
#define sklgt4__l3_3__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set L3_3 :: AVG GPU Core Frequency */
#define sklgt4__l3_3__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set L3_3 :: AVG GPU Core Frequency */
#define sklgt4__l3_3__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set L3_3 :: GPU Busy */
#define sklgt4__l3_3__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set L3_3 :: VS Threads Dispatched */
#define sklgt4__l3_3__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set L3_3 :: HS Threads Dispatched */
#define sklgt4__l3_3__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set L3_3 :: DS Threads Dispatched */
#define sklgt4__l3_3__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set L3_3 :: GS Threads Dispatched */
#define sklgt4__l3_3__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set L3_3 :: FS Threads Dispatched */
#define sklgt4__l3_3__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set L3_3 :: CS Threads Dispatched */
#define sklgt4__l3_3__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set L3_3 :: EU Active */
#define sklgt4__l3_3__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set L3_3 :: EU Stall */
#define sklgt4__l3_3__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set L3_3 :: EU Both FPU Pipes Active */
#define sklgt4__l3_3__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set L3_3 :: VS FPU0 Pipe Active */
#define sklgt4__l3_3__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set L3_3 :: VS FPU1 Pipe Active */
#define sklgt4__l3_3__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set L3_3 :: VS Send Pipe Active */
#define sklgt4__l3_3__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set L3_3 :: PS FPU0 Pipe Active */
#define sklgt4__l3_3__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set L3_3 :: PS FPU1 Pipe Active */
#define sklgt4__l3_3__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set L3_3 :: PS Send Pipeline Active */
#define sklgt4__l3_3__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set L3_3 :: FS Both FPU Active */
#define sklgt4__l3_3__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set L3_3 :: Rasterized Pixels */
#define sklgt4__l3_3__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set L3_3 :: Early Hi-Depth Test Fails */
#define sklgt4__l3_3__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set L3_3 :: Early Depth Test Fails */
#define sklgt4__l3_3__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set L3_3 :: Samples Killed in FS */
#define sklgt4__l3_3__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set L3_3 :: Pixels Failing Tests */
#define sklgt4__l3_3__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set L3_3 :: Samples Written */
#define sklgt4__l3_3__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set L3_3 :: Samples Blended */
#define sklgt4__l3_3__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set L3_3 :: Sampler Texels */
#define sklgt4__l3_3__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set L3_3 :: Sampler Texels Misses */
#define sklgt4__l3_3__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set L3_3 :: SLM Bytes Read */
#define sklgt4__l3_3__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set L3_3 :: SLM Bytes Read */
#define sklgt4__l3_3__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_3 :: SLM Bytes Written */
#define sklgt4__l3_3__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set L3_3 :: SLM Bytes Written */
#define sklgt4__l3_3__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_3 :: Shader Memory Accesses */
#define sklgt4__l3_3__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set L3_3 :: Shader Atomic Memory Accesses */
#define sklgt4__l3_3__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set L3_3 :: L3 Shader Throughput */
#define sklgt4__l3_3__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set L3_3 :: L3 Shader Throughput */
#define sklgt4__l3_3__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_3 :: Shader Barrier Messages */
#define sklgt4__l3_3__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set L3_3 :: Slice0 L3 Bank3 Stalled */
#define sklgt4__l3_3__l30_bank3_stalled__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set L3_3 :: Slice0 L3 Bank3 Active */
#define sklgt4__l3_3__l30_bank3_active__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set L3_3 :: SQ is full */
#define sklgt4__l3_3__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set RasterizerAndPixelBackend :: GPU Time Elapsed */
#define sklgt4__rasterizer_and_pixel_backend__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set RasterizerAndPixelBackend :: GPU Core Clocks */
#define sklgt4__rasterizer_and_pixel_backend__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set RasterizerAndPixelBackend :: AVG GPU Core Frequency */
#define sklgt4__rasterizer_and_pixel_backend__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set RasterizerAndPixelBackend :: AVG GPU Core Frequency */
#define sklgt4__rasterizer_and_pixel_backend__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set RasterizerAndPixelBackend :: GPU Busy */
#define sklgt4__rasterizer_and_pixel_backend__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set RasterizerAndPixelBackend :: VS Threads Dispatched */
#define sklgt4__rasterizer_and_pixel_backend__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set RasterizerAndPixelBackend :: HS Threads Dispatched */
#define sklgt4__rasterizer_and_pixel_backend__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set RasterizerAndPixelBackend :: DS Threads Dispatched */
#define sklgt4__rasterizer_and_pixel_backend__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set RasterizerAndPixelBackend :: GS Threads Dispatched */
#define sklgt4__rasterizer_and_pixel_backend__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set RasterizerAndPixelBackend :: FS Threads Dispatched */
#define sklgt4__rasterizer_and_pixel_backend__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set RasterizerAndPixelBackend :: CS Threads Dispatched */
#define sklgt4__rasterizer_and_pixel_backend__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set RasterizerAndPixelBackend :: EU Active */
#define sklgt4__rasterizer_and_pixel_backend__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set RasterizerAndPixelBackend :: EU Stall */
#define sklgt4__rasterizer_and_pixel_backend__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set RasterizerAndPixelBackend :: EU Both FPU Pipes Active */
#define sklgt4__rasterizer_and_pixel_backend__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set RasterizerAndPixelBackend :: VS FPU0 Pipe Active */
#define sklgt4__rasterizer_and_pixel_backend__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set RasterizerAndPixelBackend :: VS FPU1 Pipe Active */
#define sklgt4__rasterizer_and_pixel_backend__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set RasterizerAndPixelBackend :: VS Send Pipe Active */
#define sklgt4__rasterizer_and_pixel_backend__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set RasterizerAndPixelBackend :: PS FPU0 Pipe Active */
#define sklgt4__rasterizer_and_pixel_backend__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set RasterizerAndPixelBackend :: PS FPU1 Pipe Active */
#define sklgt4__rasterizer_and_pixel_backend__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set RasterizerAndPixelBackend :: PS Send Pipeline Active */
#define sklgt4__rasterizer_and_pixel_backend__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set RasterizerAndPixelBackend :: FS Both FPU Active */
#define sklgt4__rasterizer_and_pixel_backend__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set RasterizerAndPixelBackend :: Rasterized Pixels */
#define sklgt4__rasterizer_and_pixel_backend__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set RasterizerAndPixelBackend :: Early Hi-Depth Test Fails */
#define sklgt4__rasterizer_and_pixel_backend__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set RasterizerAndPixelBackend :: Early Depth Test Fails */
#define sklgt4__rasterizer_and_pixel_backend__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set RasterizerAndPixelBackend :: Samples Killed in FS */
#define sklgt4__rasterizer_and_pixel_backend__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set RasterizerAndPixelBackend :: Pixels Failing Tests */
#define sklgt4__rasterizer_and_pixel_backend__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set RasterizerAndPixelBackend :: Samples Written */
#define sklgt4__rasterizer_and_pixel_backend__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set RasterizerAndPixelBackend :: Samples Blended */
#define sklgt4__rasterizer_and_pixel_backend__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set RasterizerAndPixelBackend :: Sampler Texels */
#define sklgt4__rasterizer_and_pixel_backend__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set RasterizerAndPixelBackend :: Sampler Texels Misses */
#define sklgt4__rasterizer_and_pixel_backend__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Read */
#define sklgt4__rasterizer_and_pixel_backend__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Read */
#define sklgt4__rasterizer_and_pixel_backend__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Written */
#define sklgt4__rasterizer_and_pixel_backend__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Written */
#define sklgt4__rasterizer_and_pixel_backend__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set RasterizerAndPixelBackend :: Shader Memory Accesses */
#define sklgt4__rasterizer_and_pixel_backend__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set RasterizerAndPixelBackend :: Shader Atomic Memory Accesses */
#define sklgt4__rasterizer_and_pixel_backend__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set RasterizerAndPixelBackend :: L3 Shader Throughput */
#define sklgt4__rasterizer_and_pixel_backend__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set RasterizerAndPixelBackend :: L3 Shader Throughput */
#define sklgt4__rasterizer_and_pixel_backend__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set RasterizerAndPixelBackend :: Shader Barrier Messages */
#define sklgt4__rasterizer_and_pixel_backend__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Post-EarlyZ Pixel Data Ready */
#define sklgt4__rasterizer_and_pixel_backend__pixel_data0_ready__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Rasterizer Input Available */
#define sklgt4__rasterizer_and_pixel_backend__rasterizer0_input_available__read \
    bdw__render_basic__sampler1_busy__read

/* Metric set RasterizerAndPixelBackend :: Slice0 PS Output Available */
#define sklgt4__rasterizer_and_pixel_backend__ps_output0_available__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Pixel Values Ready */
#define sklgt4__rasterizer_and_pixel_backend__pixel_values0_ready__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Rasterizer Output Ready */
#define sklgt4__rasterizer_and_pixel_backend__rasterizer0_output_ready__read \
    bdw__render_pipe_profile__sf_stall__read

/* Metric set RasterizerAndPixelBackend :: SQ is full */
#define sklgt4__rasterizer_and_pixel_backend__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set Sampler :: GPU Time Elapsed */
#define sklgt4__sampler__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set Sampler :: GPU Core Clocks */
#define sklgt4__sampler__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set Sampler :: AVG GPU Core Frequency */
#define sklgt4__sampler__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set Sampler :: AVG GPU Core Frequency */
#define sklgt4__sampler__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set Sampler :: GPU Busy */
#define sklgt4__sampler__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set Sampler :: VS Threads Dispatched */
#define sklgt4__sampler__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set Sampler :: HS Threads Dispatched */
#define sklgt4__sampler__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set Sampler :: DS Threads Dispatched */
#define sklgt4__sampler__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set Sampler :: GS Threads Dispatched */
#define sklgt4__sampler__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set Sampler :: FS Threads Dispatched */
#define sklgt4__sampler__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set Sampler :: CS Threads Dispatched */
#define sklgt4__sampler__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set Sampler :: EU Active */
#define sklgt4__sampler__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set Sampler :: EU Stall */
#define sklgt4__sampler__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set Sampler :: EU Both FPU Pipes Active */
#define sklgt4__sampler__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set Sampler :: VS FPU0 Pipe Active */
#define sklgt4__sampler__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set Sampler :: VS FPU1 Pipe Active */
#define sklgt4__sampler__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set Sampler :: VS Send Pipe Active */
#define sklgt4__sampler__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set Sampler :: PS FPU0 Pipe Active */
#define sklgt4__sampler__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set Sampler :: PS FPU1 Pipe Active */
#define sklgt4__sampler__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set Sampler :: PS Send Pipeline Active */
#define sklgt4__sampler__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set Sampler :: FS Both FPU Active */
#define sklgt4__sampler__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set Sampler :: Rasterized Pixels */
#define sklgt4__sampler__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set Sampler :: Early Hi-Depth Test Fails */
#define sklgt4__sampler__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set Sampler :: Early Depth Test Fails */
#define sklgt4__sampler__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set Sampler :: Samples Killed in FS */
#define sklgt4__sampler__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set Sampler :: Pixels Failing Tests */
#define sklgt4__sampler__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set Sampler :: Samples Written */
#define sklgt4__sampler__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set Sampler :: Samples Blended */
#define sklgt4__sampler__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set Sampler :: Sampler Texels */
#define sklgt4__sampler__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set Sampler :: Sampler Texels Misses */
#define sklgt4__sampler__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set Sampler :: SLM Bytes Read */
#define sklgt4__sampler__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set Sampler :: SLM Bytes Read */
#define sklgt4__sampler__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set Sampler :: SLM Bytes Written */
#define sklgt4__sampler__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set Sampler :: SLM Bytes Written */
#define sklgt4__sampler__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set Sampler :: Shader Memory Accesses */
#define sklgt4__sampler__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set Sampler :: Shader Atomic Memory Accesses */
#define sklgt4__sampler__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set Sampler :: L3 Shader Throughput */
#define sklgt4__sampler__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set Sampler :: L3 Shader Throughput */
#define sklgt4__sampler__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set Sampler :: Shader Barrier Messages */
#define sklgt4__sampler__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set Sampler :: Slice0 Subslice1 Input Available */
#define sklgt4__sampler__sampler01_input_available__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set Sampler :: Slice0 Subslice2 Input Available */
#define sklgt4__sampler__sampler02_input_available__read \
    bdw__render_basic__sampler1_busy__read

/* Metric set Sampler :: Slice0 Subslice0 Input Available */
#define sklgt4__sampler__sampler00_input_available__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Metric set Sampler :: Slice0 Subslice2 Sampler Output Ready */
#define sklgt4__sampler__sampler02_output_ready__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set Sampler :: Slice0 Subslice0 Sampler Output Ready */
#define sklgt4__sampler__sampler00_output_ready__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set Sampler :: Slice0 Subslice1 Sampler Output Ready */
#define sklgt4__sampler__sampler01_output_ready__read \
    bdw__render_pipe_profile__sf_stall__read

/* Metric set Sampler :: SQ is full */
#define sklgt4__sampler__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set TDL_1 :: GPU Time Elapsed */
#define sklgt4__tdl_1__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set TDL_1 :: GPU Core Clocks */
#define sklgt4__tdl_1__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set TDL_1 :: AVG GPU Core Frequency */
#define sklgt4__tdl_1__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set TDL_1 :: AVG GPU Core Frequency */
#define sklgt4__tdl_1__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set TDL_1 :: GPU Busy */
#define sklgt4__tdl_1__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set TDL_1 :: VS Threads Dispatched */
#define sklgt4__tdl_1__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set TDL_1 :: HS Threads Dispatched */
#define sklgt4__tdl_1__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set TDL_1 :: DS Threads Dispatched */
#define sklgt4__tdl_1__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set TDL_1 :: GS Threads Dispatched */
#define sklgt4__tdl_1__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set TDL_1 :: FS Threads Dispatched */
#define sklgt4__tdl_1__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set TDL_1 :: CS Threads Dispatched */
#define sklgt4__tdl_1__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set TDL_1 :: EU Active */
#define sklgt4__tdl_1__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set TDL_1 :: EU Stall */
#define sklgt4__tdl_1__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set TDL_1 :: EU Both FPU Pipes Active */
#define sklgt4__tdl_1__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set TDL_1 :: VS FPU0 Pipe Active */
#define sklgt4__tdl_1__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set TDL_1 :: VS FPU1 Pipe Active */
#define sklgt4__tdl_1__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set TDL_1 :: VS Send Pipe Active */
#define sklgt4__tdl_1__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set TDL_1 :: PS FPU0 Pipe Active */
#define sklgt4__tdl_1__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set TDL_1 :: PS FPU1 Pipe Active */
#define sklgt4__tdl_1__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set TDL_1 :: PS Send Pipeline Active */
#define sklgt4__tdl_1__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set TDL_1 :: FS Both FPU Active */
#define sklgt4__tdl_1__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set TDL_1 :: Rasterized Pixels */
#define sklgt4__tdl_1__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set TDL_1 :: Early Hi-Depth Test Fails */
#define sklgt4__tdl_1__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set TDL_1 :: Early Depth Test Fails */
#define sklgt4__tdl_1__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set TDL_1 :: Samples Killed in FS */
#define sklgt4__tdl_1__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set TDL_1 :: Pixels Failing Tests */
#define sklgt4__tdl_1__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set TDL_1 :: Samples Written */
#define sklgt4__tdl_1__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set TDL_1 :: Samples Blended */
#define sklgt4__tdl_1__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set TDL_1 :: Sampler Texels */
#define sklgt4__tdl_1__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set TDL_1 :: Sampler Texels Misses */
#define sklgt4__tdl_1__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set TDL_1 :: SLM Bytes Read */
#define sklgt4__tdl_1__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set TDL_1 :: SLM Bytes Read */
#define sklgt4__tdl_1__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_1 :: SLM Bytes Written */
#define sklgt4__tdl_1__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set TDL_1 :: SLM Bytes Written */
#define sklgt4__tdl_1__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_1 :: Shader Memory Accesses */
#define sklgt4__tdl_1__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set TDL_1 :: Shader Atomic Memory Accesses */
#define sklgt4__tdl_1__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set TDL_1 :: L3 Shader Throughput */
#define sklgt4__tdl_1__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set TDL_1 :: L3 Shader Throughput */
#define sklgt4__tdl_1__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_1 :: Shader Barrier Messages */
#define sklgt4__tdl_1__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set TDL_1 :: NonPS Thread Ready For Dispatch on Slice0 Subslice1 */
#define sklgt4__tdl_1__non_ps_thread01_ready_for_dispatch__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set TDL_1 :: PS Thread Ready For Dispatch on Slice0 Subslice0 */
#define sklgt4__tdl_1__ps_thread00_ready_for_dispatch__read \
    bdw__render_basic__sampler1_busy__read

/* Metric set TDL_1 :: NonPS Thread Ready For Dispatch on Slice0 Subslice0 */
#define sklgt4__tdl_1__non_ps_thread00_ready_for_dispatch__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Metric set TDL_1 :: PS Thread Ready For Dispatch on Slice0 Subslice2 */
#define sklgt4__tdl_1__ps_thread02_ready_for_dispatch__read \
    bdw__render_basic__sampler1_bottleneck__read

/* Metric set TDL_1 :: NonPS Thread Ready For Dispatch on Slice0 Subslice2 */
#define sklgt4__tdl_1__non_ps_thread02_ready_for_dispatch__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* Metric set TDL_1 :: PS Thread Ready For Dispatch on Slice0 Subslice1 */
#define sklgt4__tdl_1__ps_thread01_ready_for_dispatch__read \
    bdw__render_pipe_profile__cl_bottleneck__read

/* Metric set TDL_1 :: SQ is full */
#define sklgt4__tdl_1__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set TDL_2 :: GPU Time Elapsed */
#define sklgt4__tdl_2__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set TDL_2 :: GPU Core Clocks */
#define sklgt4__tdl_2__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set TDL_2 :: AVG GPU Core Frequency */
#define sklgt4__tdl_2__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set TDL_2 :: AVG GPU Core Frequency */
#define sklgt4__tdl_2__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set TDL_2 :: GPU Busy */
#define sklgt4__tdl_2__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set TDL_2 :: VS Threads Dispatched */
#define sklgt4__tdl_2__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set TDL_2 :: HS Threads Dispatched */
#define sklgt4__tdl_2__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set TDL_2 :: DS Threads Dispatched */
#define sklgt4__tdl_2__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set TDL_2 :: GS Threads Dispatched */
#define sklgt4__tdl_2__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set TDL_2 :: FS Threads Dispatched */
#define sklgt4__tdl_2__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set TDL_2 :: CS Threads Dispatched */
#define sklgt4__tdl_2__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set TDL_2 :: EU Active */
#define sklgt4__tdl_2__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set TDL_2 :: EU Stall */
#define sklgt4__tdl_2__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set TDL_2 :: EU Both FPU Pipes Active */
#define sklgt4__tdl_2__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set TDL_2 :: VS FPU0 Pipe Active */
#define sklgt4__tdl_2__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set TDL_2 :: VS FPU1 Pipe Active */
#define sklgt4__tdl_2__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set TDL_2 :: VS Send Pipe Active */
#define sklgt4__tdl_2__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set TDL_2 :: PS FPU0 Pipe Active */
#define sklgt4__tdl_2__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set TDL_2 :: PS FPU1 Pipe Active */
#define sklgt4__tdl_2__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set TDL_2 :: PS Send Pipeline Active */
#define sklgt4__tdl_2__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set TDL_2 :: FS Both FPU Active */
#define sklgt4__tdl_2__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set TDL_2 :: Rasterized Pixels */
#define sklgt4__tdl_2__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set TDL_2 :: Early Hi-Depth Test Fails */
#define sklgt4__tdl_2__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set TDL_2 :: Early Depth Test Fails */
#define sklgt4__tdl_2__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set TDL_2 :: Samples Killed in FS */
#define sklgt4__tdl_2__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set TDL_2 :: Pixels Failing Tests */
#define sklgt4__tdl_2__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set TDL_2 :: Samples Written */
#define sklgt4__tdl_2__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set TDL_2 :: Samples Blended */
#define sklgt4__tdl_2__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set TDL_2 :: Sampler Texels */
#define sklgt4__tdl_2__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set TDL_2 :: Sampler Texels Misses */
#define sklgt4__tdl_2__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set TDL_2 :: SLM Bytes Read */
#define sklgt4__tdl_2__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set TDL_2 :: SLM Bytes Read */
#define sklgt4__tdl_2__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_2 :: SLM Bytes Written */
#define sklgt4__tdl_2__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set TDL_2 :: SLM Bytes Written */
#define sklgt4__tdl_2__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_2 :: Shader Memory Accesses */
#define sklgt4__tdl_2__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set TDL_2 :: Shader Atomic Memory Accesses */
#define sklgt4__tdl_2__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set TDL_2 :: L3 Shader Throughput */
#define sklgt4__tdl_2__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set TDL_2 :: L3 Shader Throughput */
#define sklgt4__tdl_2__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_2 :: Shader Barrier Messages */
#define sklgt4__tdl_2__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice1 Port 0 */
#define sklgt4__tdl_2__thread_header01_ready_port0__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice0 Port 1 */
#define sklgt4__tdl_2__thread_header00_ready_port1__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice0 Port 0 */
#define sklgt4__tdl_2__thread_header00_ready_port0__read \
    bdw__render_pipe_profile__sf_stall__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice2 Port 1 */
#define sklgt4__tdl_2__thread_header02_ready_port1__read \
    bdw__render_pipe_profile__cl_stall__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice2 Port 0 */
#define sklgt4__tdl_2__thread_header02_ready_port0__read \
    bdw__render_pipe_profile__so_stall__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice1 Port 1 */
#define sklgt4__tdl_2__thread_header01_ready_port1__read \
    bdw__render_pipe_profile__ds_stall__read

/* Metric set TDL_2 :: SQ is full */
#define sklgt4__tdl_2__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Compute Metrics Extra Gen9 :: GPU Time Elapsed */
#define sklgt4__compute_extra__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Compute Metrics Extra Gen9 :: GPU Core Clocks */
#define sklgt4__compute_extra__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Compute Metrics Extra Gen9 :: AVG GPU Core Frequency */
#define sklgt4__compute_extra__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Compute Metrics Extra Gen9 :: AVG GPU Core Frequency */
#define sklgt4__compute_extra__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Compute Metrics Extra Gen9 :: EU FPU1 Pipe Active */
#define sklgt4__compute_extra__fpu1_active__read \
    bdw__render_basic__eu_stall__read

/* Media Vme Pipe Gen9 :: GPU Time Elapsed */
#define sklgt4__vme_pipe__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Media Vme Pipe Gen9 :: GPU Core Clocks */
#define sklgt4__vme_pipe__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Media Vme Pipe Gen9 :: AVG GPU Core Frequency */
#define sklgt4__vme_pipe__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Media Vme Pipe Gen9 :: AVG GPU Core Frequency */
#define sklgt4__vme_pipe__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Media Vme Pipe Gen9 :: GPU Busy */
#define sklgt4__vme_pipe__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Media Vme Pipe Gen9 :: CS Threads Dispatched */
#define sklgt4__vme_pipe__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Media Vme Pipe Gen9 :: EU Active */
#define sklgt4__vme_pipe__eu_active__read \
    bdw__render_basic__eu_active__read

/* Media Vme Pipe Gen9 :: EU Stall */
#define sklgt4__vme_pipe__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Media Vme Pipe Gen9 :: EU Both FPU Pipes Active */
#define sklgt4__vme_pipe__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Media Vme Pipe Gen9 :: EU Thread Occupancy */
#define sklgt4__vme_pipe__eu_thread_occupancy__read \
    bdw__vme_pipe__eu_thread_occupancy__read

/* Media Vme Pipe Gen9 :: VME Busy */
#define sklgt4__vme_pipe__vme_busy__read \
    bdw__vme_pipe__vme_busy__read

/* Gpu Rings Busyness :: GPU Time Elapsed */
#define sklgt4__gpu_busyness__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Gpu Rings Busyness :: GPU Core Clocks */
#define sklgt4__gpu_busyness__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Gpu Rings Busyness :: AVG GPU Core Frequency */
#define sklgt4__gpu_busyness__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Gpu Rings Busyness :: AVG GPU Core Frequency */
#define sklgt4__gpu_busyness__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Gpu Rings Busyness :: Render Ring Busy */
#define sklgt4__gpu_busyness__render_busy__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Gpu Rings Busyness :: Vdbox0 Ring Busy */
#define sklgt4__gpu_busyness__vdbox0_busy__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Gpu Rings Busyness :: Vdbox1 Ring Busy */
#define sklgt4__gpu_busyness__vdbox1_busy__read \
    bdw__render_pipe_profile__sf_stall__read

/* Gpu Rings Busyness :: Vebox Ring Busy */
#define sklgt4__gpu_busyness__vebox_busy__read \
    bdw__render_pipe_profile__cl_stall__read

/* Gpu Rings Busyness :: Blitter Ring Busy */
#define sklgt4__gpu_busyness__blitter_busy__read \
    bdw__render_pipe_profile__so_stall__read

/* Gpu Rings Busyness :: AnyRingBusy */
#define sklgt4__gpu_busyness__any_ring_busy__read \
    bdw__render_basic__sampler0_busy__read

/* MDAPI testing set Gen9 :: GPU Time Elapsed */
#define sklgt4__test_oa__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* MDAPI testing set Gen9 :: GPU Core Clocks */
#define sklgt4__test_oa__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* MDAPI testing set Gen9 :: AVG GPU Core Frequency */
#define sklgt4__test_oa__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* MDAPI testing set Gen9 :: AVG GPU Core Frequency */
#define sklgt4__test_oa__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* MDAPI testing set Gen9 :: TestCounter0 */
#define sklgt4__test_oa__counter0__read \
    hsw__compute_extended__eu_untyped_reads0__read

/* MDAPI testing set Gen9 :: TestCounter1 */
#define sklgt4__test_oa__counter1__read \
    hsw__compute_extended__eu_untyped_writes0__read

/* MDAPI testing set Gen9 :: TestCounter2 */
#define sklgt4__test_oa__counter2__read \
    hsw__compute_extended__eu_typed_reads0__read

/* MDAPI testing set Gen9 :: TestCounter3 */
#define sklgt4__test_oa__counter3__read \
    hsw__compute_extended__eu_typed_writes0__read

/* MDAPI testing set Gen9 :: TestCounter4 */
#define sklgt4__test_oa__counter4__read \
    hsw__compute_extended__eu_untyped_atomics0__read

/* MDAPI testing set Gen9 :: TestCounter5 */
#define sklgt4__test_oa__counter5__read \
    hsw__compute_extended__eu_typed_atomics0__read

/* MDAPI testing set Gen9 :: TestCounter6 */
#define sklgt4__test_oa__counter6__read \
    hsw__compute_extended__eu_urb_atomics0__read

/* MDAPI testing set Gen9 :: TestCounter7 */
#define sklgt4__test_oa__counter7__read \
    hsw__compute_extended__gpu_clocks__read

/* MDAPI testing set Gen9 :: TestCounter8 */
#define sklgt4__test_oa__counter8__read \
    hsw__memory_reads__gpu_core_clocks__read

/* Metric set PMA Stall :: GPU Time Elapsed */
#define sklgt4__pma__stall__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set PMA Stall :: GPU Core Clocks */
#define sklgt4__pma__stall__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set PMA Stall :: AVG GPU Core Frequency */
#define sklgt4__pma__stall__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set PMA Stall :: AVG GPU Core Frequency */
#define sklgt4__pma__stall__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set PMA Stall :: STC PMA stall */
#define sklgt4__pma__stall__stc_pma_stall__read \
    sklgt2__pma__stall__stc_pma_stall__read

/* Render Metrics Basic Gen9 :: GPU Time Elapsed */
#define kblgt2__render_basic__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Render Metrics Basic Gen9 :: GPU Core Clocks */
#define kblgt2__render_basic__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Render Metrics Basic Gen9 :: AVG GPU Core Frequency */
#define kblgt2__render_basic__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Render Metrics Basic Gen9 :: AVG GPU Core Frequency */
#define kblgt2__render_basic__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Render Metrics Basic Gen9 :: VS Threads Dispatched */
#define kblgt2__render_basic__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Render Metrics Basic Gen9 :: HS Threads Dispatched */
#define kblgt2__render_basic__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Render Metrics Basic Gen9 :: DS Threads Dispatched */
#define kblgt2__render_basic__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Render Metrics Basic Gen9 :: GS Threads Dispatched */
#define kblgt2__render_basic__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Render Metrics Basic Gen9 :: FS Threads Dispatched */
#define kblgt2__render_basic__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Render Metrics Basic Gen9 :: CS Threads Dispatched */
#define kblgt2__render_basic__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Render Metrics Basic Gen9 :: GPU Busy */
#define kblgt2__render_basic__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Render Metrics Basic Gen9 :: EU Active */
#define kblgt2__render_basic__eu_active__read \
    bdw__render_basic__eu_active__read

/* Render Metrics Basic Gen9 :: EU Stall */
#define kblgt2__render_basic__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Render Metrics Basic Gen9 :: EU Both FPU Pipes Active */
#define kblgt2__render_basic__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Render Metrics Basic Gen9 :: VS FPU0 Pipe Active */
#define kblgt2__render_basic__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Render Metrics Basic Gen9 :: VS FPU1 Pipe Active */
#define kblgt2__render_basic__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Render Metrics Basic Gen9 :: VS Send Pipe Active */
#define kblgt2__render_basic__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Render Metrics Basic Gen9 :: PS FPU0 Pipe Active */
#define kblgt2__render_basic__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Render Metrics Basic Gen9 :: PS FPU1 Pipe Active */
#define kblgt2__render_basic__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Render Metrics Basic Gen9 :: PS Send Pipeline Active */
#define kblgt2__render_basic__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Render Metrics Basic Gen9 :: FS Both FPU Active */
#define kblgt2__render_basic__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Render Metrics Basic Gen9 :: Sampler 0 Busy */
#define kblgt2__render_basic__sampler0_busy__read \
    bdw__render_basic__sampler0_busy__read

/* Render Metrics Basic Gen9 :: Sampler 1 Busy */
#define kblgt2__render_basic__sampler1_busy__read \
    bdw__render_basic__sampler1_busy__read

/* Render Metrics Basic Gen9 :: Samplers Busy */
#define kblgt2__render_basic__samplers_busy__read \
    bdw__render_basic__samplers_busy__read

/* Render Metrics Basic Gen9 :: Sampler 0 Bottleneck */
#define kblgt2__render_basic__sampler0_bottleneck__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Render Metrics Basic Gen9 :: Sampler 1 Bottleneck */
#define kblgt2__render_basic__sampler1_bottleneck__read \
    bdw__render_basic__sampler1_bottleneck__read

/* Render Metrics Basic Gen9 :: Rasterized Pixels */
#define kblgt2__render_basic__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Render Metrics Basic Gen9 :: Early Hi-Depth Test Fails */
#define kblgt2__render_basic__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Render Metrics Basic Gen9 :: Early Depth Test Fails */
#define kblgt2__render_basic__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Render Metrics Basic Gen9 :: Samples Killed in FS */
#define kblgt2__render_basic__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Render Metrics Basic Gen9 :: Pixels Failing Tests */
#define kblgt2__render_basic__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Render Metrics Basic Gen9 :: Samples Written */
#define kblgt2__render_basic__samples_written__read \
    bdw__render_basic__samples_written__read

/* Render Metrics Basic Gen9 :: Samples Blended */
#define kblgt2__render_basic__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Render Metrics Basic Gen9 :: Sampler Texels */
#define kblgt2__render_basic__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Render Metrics Basic Gen9 :: Sampler Texels Misses */
#define kblgt2__render_basic__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Render Metrics Basic Gen9 :: Sampler Cache Misses */
#define kblgt2__render_basic__sampler_l1_misses__read \
    sklgt2__render_basic__sampler_l1_misses__read

/* Render Metrics Basic Gen9 :: SLM Bytes Read */
#define kblgt2__render_basic__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Render Metrics Basic Gen9 :: SLM Bytes Read */
#define kblgt2__render_basic__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics Basic Gen9 :: SLM Bytes Written */
#define kblgt2__render_basic__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Render Metrics Basic Gen9 :: SLM Bytes Written */
#define kblgt2__render_basic__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics Basic Gen9 :: Shader Memory Accesses */
#define kblgt2__render_basic__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Render Metrics Basic Gen9 :: Shader Atomic Memory Accesses */
#define kblgt2__render_basic__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Render Metrics Basic Gen9 :: L3 Lookup Accesses w/o IC */
#define kblgt2__render_basic__l3_lookups__read \
    sklgt2__render_basic__l3_lookups__read

/* Render Metrics Basic Gen9 :: L3 Misses */
#define kblgt2__render_basic__l3_misses__read \
    hsw__compute_extended__typed_atomics0__read

/* Render Metrics Basic Gen9 :: L3 Sampler Throughput */
#define kblgt2__render_basic__l3_sampler_throughput__read \
    sklgt2__render_basic__l3_sampler_throughput__read

/* Render Metrics Basic Gen9 :: L3 Sampler Throughput */
#define kblgt2__render_basic__l3_sampler_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics Basic Gen9 :: L3 Shader Throughput */
#define kblgt2__render_basic__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Render Metrics Basic Gen9 :: L3 Shader Throughput */
#define kblgt2__render_basic__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics Basic Gen9 :: Shader Barrier Messages */
#define kblgt2__render_basic__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Render Metrics Basic Gen9 :: GTI Fixed Pipe Throughput */
#define kblgt2__render_basic__gti_vf_throughput__read \
    bdw__render_basic__gti_vf_throughput__read

/* Render Metrics Basic Gen9 :: GTI Fixed Pipe Throughput */
#define kblgt2__render_basic__gti_vf_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Render Metrics Basic Gen9 :: GTI Depth Throughput */
#define kblgt2__render_basic__gti_depth_throughput__read \
    bdw__render_basic__gti_depth_throughput__read

/* Render Metrics Basic Gen9 :: GTI Depth Throughput */
#define kblgt2__render_basic__gti_depth_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics Basic Gen9 :: GTI RCC Throughput */
#define kblgt2__render_basic__gti_rcc_throughput__read \
    bdw__render_basic__gti_rcc_throughput__read

/* Render Metrics Basic Gen9 :: GTI RCC Throughput */
#define kblgt2__render_basic__gti_rcc_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics Basic Gen9 :: GTI L3 Throughput */
#define kblgt2__render_basic__gti_l3_throughput__read \
    hsw__render_basic__gti_l3_throughput__read

/* Render Metrics Basic Gen9 :: GTI L3 Throughput */
#define kblgt2__render_basic__gti_l3_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics Basic Gen9 :: GTI HDC TLB Lookup Throughput */
#define kblgt2__render_basic__gti_hdc_lookups_throughput__read \
    bdw__render_basic__gti_hdc_lookups_throughput__read

/* Render Metrics Basic Gen9 :: GTI HDC TLB Lookup Throughput */
#define kblgt2__render_basic__gti_hdc_lookups_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics Basic Gen9 :: GTI Read Throughput */
#define kblgt2__render_basic__gti_read_throughput__read \
    bdw__render_basic__gti_read_throughput__read

/* Render Metrics Basic Gen9 :: GTI Read Throughput */
#define kblgt2__render_basic__gti_read_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Render Metrics Basic Gen9 :: GTI Write Throughput */
#define kblgt2__render_basic__gti_write_throughput__read \
    hsw__render_basic__gti_write_throughput__read

/* Render Metrics Basic Gen9 :: GTI Write Throughput */
#define kblgt2__render_basic__gti_write_throughput__max \
    bdw__render_basic__gti_write_throughput__max

/* Render Metrics Basic Gen9 :: Samplers Bottleneck */
#define kblgt2__render_basic__sampler_bottleneck__read \
    bdw__render_basic__sampler_bottleneck__read

/* Compute Metrics Basic Gen9 :: GPU Time Elapsed */
#define kblgt2__compute_basic__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Compute Metrics Basic Gen9 :: GPU Core Clocks */
#define kblgt2__compute_basic__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Compute Metrics Basic Gen9 :: AVG GPU Core Frequency */
#define kblgt2__compute_basic__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Compute Metrics Basic Gen9 :: AVG GPU Core Frequency */
#define kblgt2__compute_basic__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Compute Metrics Basic Gen9 :: GPU Busy */
#define kblgt2__compute_basic__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Compute Metrics Basic Gen9 :: VS Threads Dispatched */
#define kblgt2__compute_basic__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Compute Metrics Basic Gen9 :: HS Threads Dispatched */
#define kblgt2__compute_basic__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Compute Metrics Basic Gen9 :: DS Threads Dispatched */
#define kblgt2__compute_basic__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Compute Metrics Basic Gen9 :: GS Threads Dispatched */
#define kblgt2__compute_basic__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Compute Metrics Basic Gen9 :: FS Threads Dispatched */
#define kblgt2__compute_basic__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Compute Metrics Basic Gen9 :: CS Threads Dispatched */
#define kblgt2__compute_basic__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Compute Metrics Basic Gen9 :: EU Active */
#define kblgt2__compute_basic__eu_active__read \
    bdw__render_basic__eu_active__read

/* Compute Metrics Basic Gen9 :: EU Stall */
#define kblgt2__compute_basic__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Compute Metrics Basic Gen9 :: EU Both FPU Pipes Active */
#define kblgt2__compute_basic__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Compute Metrics Basic Gen9 :: EU FPU0 Pipe Active */
#define kblgt2__compute_basic__fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Compute Metrics Basic Gen9 :: EU FPU1 Pipe Active */
#define kblgt2__compute_basic__fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Compute Metrics Basic Gen9 :: EU AVG IPC Rate */
#define kblgt2__compute_basic__eu_avg_ipc_rate__read \
    bdw__compute_basic__eu_avg_ipc_rate__read

/* Compute Metrics Basic Gen9 :: EU AVG IPC Rate */
#define kblgt2__compute_basic__eu_avg_ipc_rate__max \
    bdw__compute_basic__eu_avg_ipc_rate__max

/* Compute Metrics Basic Gen9 :: EU Send Pipe Active */
#define kblgt2__compute_basic__eu_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Compute Metrics Basic Gen9 :: EU Thread Occupancy */
#define kblgt2__compute_basic__eu_thread_occupancy__read \
    bdw__compute_basic__eu_thread_occupancy__read

/* Compute Metrics Basic Gen9 :: Rasterized Pixels */
#define kblgt2__compute_basic__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Compute Metrics Basic Gen9 :: Early Hi-Depth Test Fails */
#define kblgt2__compute_basic__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Compute Metrics Basic Gen9 :: Early Depth Test Fails */
#define kblgt2__compute_basic__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Compute Metrics Basic Gen9 :: Samples Killed in FS */
#define kblgt2__compute_basic__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Compute Metrics Basic Gen9 :: Pixels Failing Tests */
#define kblgt2__compute_basic__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Compute Metrics Basic Gen9 :: Samples Written */
#define kblgt2__compute_basic__samples_written__read \
    bdw__render_basic__samples_written__read

/* Compute Metrics Basic Gen9 :: Samples Blended */
#define kblgt2__compute_basic__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Compute Metrics Basic Gen9 :: Sampler Texels */
#define kblgt2__compute_basic__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Compute Metrics Basic Gen9 :: Sampler Texels Misses */
#define kblgt2__compute_basic__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Compute Metrics Basic Gen9 :: SLM Bytes Read */
#define kblgt2__compute_basic__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Compute Metrics Basic Gen9 :: SLM Bytes Read */
#define kblgt2__compute_basic__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Basic Gen9 :: SLM Bytes Written */
#define kblgt2__compute_basic__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Compute Metrics Basic Gen9 :: SLM Bytes Written */
#define kblgt2__compute_basic__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Basic Gen9 :: Shader Memory Accesses */
#define kblgt2__compute_basic__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Compute Metrics Basic Gen9 :: Shader Atomic Memory Accesses */
#define kblgt2__compute_basic__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Compute Metrics Basic Gen9 :: L3 Shader Throughput */
#define kblgt2__compute_basic__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Compute Metrics Basic Gen9 :: L3 Shader Throughput */
#define kblgt2__compute_basic__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Basic Gen9 :: Shader Barrier Messages */
#define kblgt2__compute_basic__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Compute Metrics Basic Gen9 :: Typed Bytes Read */
#define kblgt2__compute_basic__typed_bytes_read__read \
    bdw__compute_basic__typed_bytes_read__read

/* Compute Metrics Basic Gen9 :: Typed Bytes Read */
#define kblgt2__compute_basic__typed_bytes_read__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen9 :: Typed Bytes Written */
#define kblgt2__compute_basic__typed_bytes_written__read \
    bdw__compute_basic__typed_bytes_written__read

/* Compute Metrics Basic Gen9 :: Typed Bytes Written */
#define kblgt2__compute_basic__typed_bytes_written__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen9 :: Untyped Bytes Read */
#define kblgt2__compute_basic__untyped_bytes_read__read \
    bdw__compute_basic__untyped_bytes_read__read

/* Compute Metrics Basic Gen9 :: Untyped Bytes Read */
#define kblgt2__compute_basic__untyped_bytes_read__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen9 :: Untyped Writes */
#define kblgt2__compute_basic__untyped_bytes_written__read \
    bdw__compute_basic__untyped_bytes_written__read

/* Compute Metrics Basic Gen9 :: Untyped Writes */
#define kblgt2__compute_basic__untyped_bytes_written__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen9 :: GTI Read Throughput */
#define kblgt2__compute_basic__gti_read_throughput__read \
    hsw__render_basic__gti_l3_throughput__read

/* Compute Metrics Basic Gen9 :: GTI Read Throughput */
#define kblgt2__compute_basic__gti_read_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen9 :: GTI Write Throughput */
#define kblgt2__compute_basic__gti_write_throughput__read \
    bdw__render_basic__gti_hdc_lookups_throughput__read

/* Compute Metrics Basic Gen9 :: GTI Write Throughput */
#define kblgt2__compute_basic__gti_write_throughput__max \
    bdw__render_basic__gti_write_throughput__max

/* Render Metrics for 3D Pipeline Profile Gen9 :: GPU Time Elapsed */
#define kblgt2__render_pipe_profile__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: GPU Core Clocks */
#define kblgt2__render_pipe_profile__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: AVG GPU Core Frequency */
#define kblgt2__render_pipe_profile__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: AVG GPU Core Frequency */
#define kblgt2__render_pipe_profile__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Render Metrics for 3D Pipeline Profile Gen9 :: GPU Busy */
#define kblgt2__render_pipe_profile__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: VS Threads Dispatched */
#define kblgt2__render_pipe_profile__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: HS Threads Dispatched */
#define kblgt2__render_pipe_profile__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: DS Threads Dispatched */
#define kblgt2__render_pipe_profile__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: GS Threads Dispatched */
#define kblgt2__render_pipe_profile__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: FS Threads Dispatched */
#define kblgt2__render_pipe_profile__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: CS Threads Dispatched */
#define kblgt2__render_pipe_profile__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: EU Active */
#define kblgt2__render_pipe_profile__eu_active__read \
    bdw__render_basic__eu_active__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: EU Stall */
#define kblgt2__render_pipe_profile__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Rasterized Pixels */
#define kblgt2__render_pipe_profile__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Early Hi-Depth Test Fails */
#define kblgt2__render_pipe_profile__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Early Depth Test Fails */
#define kblgt2__render_pipe_profile__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Samples Killed in FS */
#define kblgt2__render_pipe_profile__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Pixels Failing Tests */
#define kblgt2__render_pipe_profile__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Samples Written */
#define kblgt2__render_pipe_profile__samples_written__read \
    bdw__render_basic__samples_written__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Samples Blended */
#define kblgt2__render_pipe_profile__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Sampler Texels */
#define kblgt2__render_pipe_profile__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Sampler Texels Misses */
#define kblgt2__render_pipe_profile__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: SLM Bytes Read */
#define kblgt2__render_pipe_profile__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: SLM Bytes Read */
#define kblgt2__render_pipe_profile__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics for 3D Pipeline Profile Gen9 :: SLM Bytes Written */
#define kblgt2__render_pipe_profile__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: SLM Bytes Written */
#define kblgt2__render_pipe_profile__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics for 3D Pipeline Profile Gen9 :: Shader Memory Accesses */
#define kblgt2__render_pipe_profile__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Shader Atomic Memory Accesses */
#define kblgt2__render_pipe_profile__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: L3 Shader Throughput */
#define kblgt2__render_pipe_profile__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: L3 Shader Throughput */
#define kblgt2__render_pipe_profile__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics for 3D Pipeline Profile Gen9 :: Shader Barrier Messages */
#define kblgt2__render_pipe_profile__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: VF Bottleneck */
#define kblgt2__render_pipe_profile__vf_bottleneck__read \
    bdw__render_pipe_profile__vf_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: VS Bottleneck */
#define kblgt2__render_pipe_profile__vs_bottleneck__read \
    bdw__render_basic__sampler0_busy__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: HS Bottleneck */
#define kblgt2__render_pipe_profile__hs_bottleneck__read \
    bdw__render_basic__sampler1_busy__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: DS Bottleneck */
#define kblgt2__render_pipe_profile__ds_bottleneck__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: GS Bottleneck */
#define kblgt2__render_pipe_profile__gs_bottleneck__read \
    bdw__render_basic__sampler1_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: SO Bottleneck */
#define kblgt2__render_pipe_profile__so_bottleneck__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Clipper Bottleneck */
#define kblgt2__render_pipe_profile__cl_bottleneck__read \
    bdw__render_pipe_profile__cl_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Strip-Fans Bottleneck */
#define kblgt2__render_pipe_profile__sf_bottleneck__read \
    bdw__render_pipe_profile__sf_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Hi-Depth Bottleneck */
#define kblgt2__render_pipe_profile__hi_depth_bottleneck__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Early Depth Bottleneck */
#define kblgt2__render_pipe_profile__early_depth_bottleneck__read \
    bdw__render_pipe_profile__early_depth_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: BC Bottleneck */
#define kblgt2__render_pipe_profile__bc_bottleneck__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: HS Stall */
#define kblgt2__render_pipe_profile__hs_stall__read \
    bdw__render_pipe_profile__hs_stall__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: DS Stall */
#define kblgt2__render_pipe_profile__ds_stall__read \
    bdw__render_pipe_profile__ds_stall__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: SO Stall */
#define kblgt2__render_pipe_profile__so_stall__read \
    bdw__render_pipe_profile__so_stall__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: CL Stall */
#define kblgt2__render_pipe_profile__cl_stall__read \
    bdw__render_pipe_profile__cl_stall__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: SF Stall */
#define kblgt2__render_pipe_profile__sf_stall__read \
    bdw__render_pipe_profile__sf_stall__read

/* Memory Reads Distribution Gen9 :: GPU Time Elapsed */
#define kblgt2__memory_reads__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Memory Reads Distribution Gen9 :: GPU Core Clocks */
#define kblgt2__memory_reads__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Memory Reads Distribution Gen9 :: AVG GPU Core Frequency */
#define kblgt2__memory_reads__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Memory Reads Distribution Gen9 :: AVG GPU Core Frequency */
#define kblgt2__memory_reads__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Memory Reads Distribution Gen9 :: GPU Busy */
#define kblgt2__memory_reads__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Memory Reads Distribution Gen9 :: VS Threads Dispatched */
#define kblgt2__memory_reads__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Memory Reads Distribution Gen9 :: HS Threads Dispatched */
#define kblgt2__memory_reads__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Memory Reads Distribution Gen9 :: DS Threads Dispatched */
#define kblgt2__memory_reads__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Memory Reads Distribution Gen9 :: GS Threads Dispatched */
#define kblgt2__memory_reads__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Memory Reads Distribution Gen9 :: FS Threads Dispatched */
#define kblgt2__memory_reads__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Memory Reads Distribution Gen9 :: CS Threads Dispatched */
#define kblgt2__memory_reads__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Memory Reads Distribution Gen9 :: EU Active */
#define kblgt2__memory_reads__eu_active__read \
    bdw__render_basic__eu_active__read

/* Memory Reads Distribution Gen9 :: EU Stall */
#define kblgt2__memory_reads__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Memory Reads Distribution Gen9 :: Rasterized Pixels */
#define kblgt2__memory_reads__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Memory Reads Distribution Gen9 :: Early Hi-Depth Test Fails */
#define kblgt2__memory_reads__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Memory Reads Distribution Gen9 :: Early Depth Test Fails */
#define kblgt2__memory_reads__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Memory Reads Distribution Gen9 :: Samples Killed in FS */
#define kblgt2__memory_reads__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Memory Reads Distribution Gen9 :: Pixels Failing Tests */
#define kblgt2__memory_reads__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Memory Reads Distribution Gen9 :: Samples Written */
#define kblgt2__memory_reads__samples_written__read \
    bdw__render_basic__samples_written__read

/* Memory Reads Distribution Gen9 :: Samples Blended */
#define kblgt2__memory_reads__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Memory Reads Distribution Gen9 :: Sampler Texels */
#define kblgt2__memory_reads__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Memory Reads Distribution Gen9 :: Sampler Texels Misses */
#define kblgt2__memory_reads__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Memory Reads Distribution Gen9 :: SLM Bytes Read */
#define kblgt2__memory_reads__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Memory Reads Distribution Gen9 :: SLM Bytes Read */
#define kblgt2__memory_reads__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Memory Reads Distribution Gen9 :: SLM Bytes Written */
#define kblgt2__memory_reads__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Memory Reads Distribution Gen9 :: SLM Bytes Written */
#define kblgt2__memory_reads__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Memory Reads Distribution Gen9 :: Shader Memory Accesses */
#define kblgt2__memory_reads__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Memory Reads Distribution Gen9 :: Shader Atomic Memory Accesses */
#define kblgt2__memory_reads__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Memory Reads Distribution Gen9 :: Shader Barrier Messages */
#define kblgt2__memory_reads__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Memory Reads Distribution Gen9 :: GtiCmdStreamerMemoryReads */
#define kblgt2__memory_reads__gti_cmd_streamer_memory_reads__read \
    hsw__compute_extended__eu_untyped_reads0__read

/* Memory Reads Distribution Gen9 :: GtiRsMemoryReads */
#define kblgt2__memory_reads__gti_rs_memory_reads__read \
    hsw__compute_extended__eu_typed_reads0__read

/* Memory Reads Distribution Gen9 :: GtiVfMemoryReads */
#define kblgt2__memory_reads__gti_vf_memory_reads__read \
    hsw__compute_extended__eu_untyped_writes0__read

/* Memory Reads Distribution Gen9 :: GtiRccMemoryReads */
#define kblgt2__memory_reads__gti_rcc_memory_reads__read \
    hsw__compute_extended__eu_typed_writes0__read

/* Memory Reads Distribution Gen9 :: GtiMscMemoryReads */
#define kblgt2__memory_reads__gti_msc_memory_reads__read \
    hsw__compute_extended__eu_untyped_atomics0__read

/* Memory Reads Distribution Gen9 :: GtiHizMemoryReads */
#define kblgt2__memory_reads__gti_hiz_memory_reads__read \
    hsw__compute_extended__eu_typed_atomics0__read

/* Memory Reads Distribution Gen9 :: GtiStcMemoryReads */
#define kblgt2__memory_reads__gti_stc_memory_reads__read \
    hsw__compute_extended__eu_urb_atomics0__read

/* Memory Reads Distribution Gen9 :: GtiRczMemoryReads */
#define kblgt2__memory_reads__gti_rcz_memory_reads__read \
    hsw__compute_extended__gpu_clocks__read

/* Memory Reads Distribution Gen9 :: GtiMemoryReads */
#define kblgt2__memory_reads__gti_memory_reads__read \
    hsw__compute_extended__typed_writes0__read

/* Memory Reads Distribution Gen9 :: GtiL3Bank0Reads */
#define kblgt2__memory_reads__gti_l3_bank0_reads__read \
    hsw__compute_extended__typed_atomics0__read

/* Memory Reads Distribution Gen9 :: GtiL3Bank1Reads */
#define kblgt2__memory_reads__gti_l3_bank1_reads__read \
    hsw__memory_reads__gti_memory_reads__read

/* Memory Reads Distribution Gen9 :: GtiL3Bank2Reads */
#define kblgt2__memory_reads__gti_l3_bank2_reads__read \
    hsw__memory_reads__llc_read_accesses__read

/* Memory Reads Distribution Gen9 :: GtiL3Bank3Reads */
#define kblgt2__memory_reads__gti_l3_bank3_reads__read \
    hsw__memory_reads__gpu_core_clocks__read

/* Memory Reads Distribution Gen9 :: GtiL3Reads */
#define kblgt2__memory_reads__gti_l3_reads__read \
    bdw__memory_reads__gti_l3_reads__read

/* Memory Reads Distribution Gen9 :: GtiRingAccesses */
#define kblgt2__memory_reads__gti_ring_accesses__read \
    bdw__memory_reads__gti_ring_accesses__read

/* Memory Writes Distribution Gen9 :: GPU Time Elapsed */
#define kblgt2__memory_writes__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Memory Writes Distribution Gen9 :: GPU Core Clocks */
#define kblgt2__memory_writes__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Memory Writes Distribution Gen9 :: AVG GPU Core Frequency */
#define kblgt2__memory_writes__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Memory Writes Distribution Gen9 :: AVG GPU Core Frequency */
#define kblgt2__memory_writes__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Memory Writes Distribution Gen9 :: GPU Busy */
#define kblgt2__memory_writes__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Memory Writes Distribution Gen9 :: VS Threads Dispatched */
#define kblgt2__memory_writes__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Memory Writes Distribution Gen9 :: HS Threads Dispatched */
#define kblgt2__memory_writes__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Memory Writes Distribution Gen9 :: DS Threads Dispatched */
#define kblgt2__memory_writes__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Memory Writes Distribution Gen9 :: GS Threads Dispatched */
#define kblgt2__memory_writes__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Memory Writes Distribution Gen9 :: FS Threads Dispatched */
#define kblgt2__memory_writes__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Memory Writes Distribution Gen9 :: CS Threads Dispatched */
#define kblgt2__memory_writes__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Memory Writes Distribution Gen9 :: EU Active */
#define kblgt2__memory_writes__eu_active__read \
    bdw__render_basic__eu_active__read

/* Memory Writes Distribution Gen9 :: EU Stall */
#define kblgt2__memory_writes__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Memory Writes Distribution Gen9 :: Rasterized Pixels */
#define kblgt2__memory_writes__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Memory Writes Distribution Gen9 :: Early Hi-Depth Test Fails */
#define kblgt2__memory_writes__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Memory Writes Distribution Gen9 :: Early Depth Test Fails */
#define kblgt2__memory_writes__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Memory Writes Distribution Gen9 :: Samples Killed in FS */
#define kblgt2__memory_writes__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Memory Writes Distribution Gen9 :: Pixels Failing Tests */
#define kblgt2__memory_writes__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Memory Writes Distribution Gen9 :: Samples Written */
#define kblgt2__memory_writes__samples_written__read \
    bdw__render_basic__samples_written__read

/* Memory Writes Distribution Gen9 :: Samples Blended */
#define kblgt2__memory_writes__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Memory Writes Distribution Gen9 :: Sampler Texels */
#define kblgt2__memory_writes__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Memory Writes Distribution Gen9 :: Sampler Texels Misses */
#define kblgt2__memory_writes__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Memory Writes Distribution Gen9 :: SLM Bytes Read */
#define kblgt2__memory_writes__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Memory Writes Distribution Gen9 :: SLM Bytes Read */
#define kblgt2__memory_writes__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Memory Writes Distribution Gen9 :: SLM Bytes Written */
#define kblgt2__memory_writes__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Memory Writes Distribution Gen9 :: SLM Bytes Written */
#define kblgt2__memory_writes__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Memory Writes Distribution Gen9 :: Shader Memory Accesses */
#define kblgt2__memory_writes__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Memory Writes Distribution Gen9 :: Shader Atomic Memory Accesses */
#define kblgt2__memory_writes__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Memory Writes Distribution Gen9 :: L3 Shader Throughput */
#define kblgt2__memory_writes__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Memory Writes Distribution Gen9 :: L3 Shader Throughput */
#define kblgt2__memory_writes__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Memory Writes Distribution Gen9 :: Shader Barrier Messages */
#define kblgt2__memory_writes__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Memory Writes Distribution Gen9 :: GtiCmdStreamerMemoryWrites */
#define kblgt2__memory_writes__gti_cmd_streamer_memory_writes__read \
    hsw__compute_extended__eu_untyped_reads0__read

/* Memory Writes Distribution Gen9 :: GtiSoMemoryWrites */
#define kblgt2__memory_writes__gti_so_memory_writes__read \
    hsw__compute_extended__eu_typed_reads0__read

/* Memory Writes Distribution Gen9 :: GtiRccMemoryWrites */
#define kblgt2__memory_writes__gti_rcc_memory_writes__read \
    hsw__compute_extended__eu_typed_writes0__read

/* Memory Writes Distribution Gen9 :: GtiMscMemoryWrites */
#define kblgt2__memory_writes__gti_msc_memory_writes__read \
    hsw__compute_extended__eu_untyped_atomics0__read

/* Memory Writes Distribution Gen9 :: GtiHizMemoryWrites */
#define kblgt2__memory_writes__gti_hiz_memory_writes__read \
    hsw__compute_extended__eu_typed_atomics0__read

/* Memory Writes Distribution Gen9 :: GtiStcMemoryWrites */
#define kblgt2__memory_writes__gti_stc_memory_writes__read \
    hsw__compute_extended__eu_urb_atomics0__read

/* Memory Writes Distribution Gen9 :: GtiRczMemoryWrites */
#define kblgt2__memory_writes__gti_rcz_memory_writes__read \
    hsw__compute_extended__gpu_clocks__read

/* Memory Writes Distribution Gen9 :: GtiMemoryWrites */
#define kblgt2__memory_writes__gti_memory_writes__read \
    hsw__compute_extended__typed_writes0__read

/* Memory Writes Distribution Gen9 :: GtiL3Bank0Writes */
#define kblgt2__memory_writes__gti_l3_bank0_writes__read \
    hsw__compute_extended__typed_atomics0__read

/* Memory Writes Distribution Gen9 :: GtiL3Bank1Writes */
#define kblgt2__memory_writes__gti_l3_bank1_writes__read \
    hsw__memory_reads__gti_memory_reads__read

/* Memory Writes Distribution Gen9 :: GtiL3Bank2Writes */
#define kblgt2__memory_writes__gti_l3_bank2_writes__read \
    hsw__memory_reads__llc_read_accesses__read

/* Memory Writes Distribution Gen9 :: GtiL3Bank3Writes */
#define kblgt2__memory_writes__gti_l3_bank3_writes__read \
    hsw__memory_reads__gpu_core_clocks__read

/* Memory Writes Distribution Gen9 :: GtiL3Writes */
#define kblgt2__memory_writes__gti_l3_writes__read \
    bdw__memory_reads__gti_l3_reads__read

/* Memory Writes Distribution Gen9 :: GtiRingAccesses */
#define kblgt2__memory_writes__gti_ring_accesses__read \
    bdw__memory_reads__gti_ring_accesses__read

/* Compute Metrics Extended Gen9 :: GPU Time Elapsed */
#define kblgt2__compute_extended__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Compute Metrics Extended Gen9 :: GPU Core Clocks */
#define kblgt2__compute_extended__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Compute Metrics Extended Gen9 :: AVG GPU Core Frequency */
#define kblgt2__compute_extended__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Compute Metrics Extended Gen9 :: AVG GPU Core Frequency */
#define kblgt2__compute_extended__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Compute Metrics Extended Gen9 :: CS Threads Dispatched */
#define kblgt2__compute_extended__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Compute Metrics Extended Gen9 :: EU Active */
#define kblgt2__compute_extended__eu_active__read \
    bdw__render_basic__eu_active__read

/* Compute Metrics Extended Gen9 :: EU Stall */
#define kblgt2__compute_extended__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Compute Metrics Extended Gen9 :: EU Both FPU Pipes Active */
#define kblgt2__compute_extended__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Compute Metrics Extended Gen9 :: EU FPU0 Pipe Active */
#define kblgt2__compute_extended__fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Compute Metrics Extended Gen9 :: EU FPU1 Pipe Active */
#define kblgt2__compute_extended__fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Compute Metrics Extended Gen9 :: EU AVG IPC Rate */
#define kblgt2__compute_extended__eu_avg_ipc_rate__read \
    bdw__compute_basic__eu_avg_ipc_rate__read

/* Compute Metrics Extended Gen9 :: EU AVG IPC Rate */
#define kblgt2__compute_extended__eu_avg_ipc_rate__max \
    bdw__compute_basic__eu_avg_ipc_rate__max

/* Compute Metrics Extended Gen9 :: EU Send Pipe Active */
#define kblgt2__compute_extended__eu_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Compute Metrics Extended Gen9 :: EU Thread Occupancy */
#define kblgt2__compute_extended__eu_thread_occupancy__read \
    bdw__compute_basic__eu_thread_occupancy__read

/* Compute Metrics Extended Gen9 :: Sampler Texels */
#define kblgt2__compute_extended__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Compute Metrics Extended Gen9 :: Sampler Texels Misses */
#define kblgt2__compute_extended__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Compute Metrics Extended Gen9 :: SLM Bytes Read */
#define kblgt2__compute_extended__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Compute Metrics Extended Gen9 :: SLM Bytes Read */
#define kblgt2__compute_extended__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Extended Gen9 :: SLM Bytes Written */
#define kblgt2__compute_extended__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Compute Metrics Extended Gen9 :: SLM Bytes Written */
#define kblgt2__compute_extended__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Extended Gen9 :: Shader Memory Accesses */
#define kblgt2__compute_extended__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Compute Metrics Extended Gen9 :: Shader Atomic Memory Accesses */
#define kblgt2__compute_extended__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Compute Metrics Extended Gen9 :: L3 Shader Throughput */
#define kblgt2__compute_extended__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Compute Metrics Extended Gen9 :: L3 Shader Throughput */
#define kblgt2__compute_extended__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Extended Gen9 :: Shader Barrier Messages */
#define kblgt2__compute_extended__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Compute Metrics Extended Gen9 :: EuUntypedReads0 */
#define kblgt2__compute_extended__eu_untyped_reads0__read \
    hsw__compute_extended__eu_untyped_reads0__read

/* Compute Metrics Extended Gen9 :: EuTypedReads0 */
#define kblgt2__compute_extended__eu_typed_reads0__read \
    hsw__compute_extended__eu_typed_reads0__read

/* Compute Metrics Extended Gen9 :: EuUntypedWrites0 */
#define kblgt2__compute_extended__eu_untyped_writes0__read \
    hsw__compute_extended__eu_untyped_writes0__read

/* Compute Metrics Extended Gen9 :: EuTypedWrites0 */
#define kblgt2__compute_extended__eu_typed_writes0__read \
    hsw__compute_extended__eu_typed_writes0__read

/* Compute Metrics Extended Gen9 :: EuUntypedAtomics0 */
#define kblgt2__compute_extended__eu_untyped_atomics0__read \
    hsw__compute_extended__eu_untyped_atomics0__read

/* Compute Metrics Extended Gen9 :: EuTypedAtomics0 */
#define kblgt2__compute_extended__eu_typed_atomics0__read \
    hsw__compute_extended__eu_typed_atomics0__read

/* Compute Metrics Extended Gen9 :: EuA64UntypedReads0 */
#define kblgt2__compute_extended__eu_a64_untyped_reads0__read \
    hsw__compute_extended__eu_urb_atomics0__read

/* Compute Metrics Extended Gen9 :: EuA64UntypedWrites0 */
#define kblgt2__compute_extended__eu_a64_untyped_writes0__read \
    hsw__compute_extended__gpu_clocks__read

/* Compute Metrics Extended Gen9 :: Typed Reads 0 */
#define kblgt2__compute_extended__typed_reads0__read \
    hsw__render_basic__gpu_core_clocks__read

/* Compute Metrics Extended Gen9 :: Typed Writes 0 */
#define kblgt2__compute_extended__typed_writes0__read \
    hsw__compute_extended__typed_writes0__read

/* Compute Metrics Extended Gen9 :: Untyped Reads 0 */
#define kblgt2__compute_extended__untyped_reads0__read \
    hsw__compute_extended__untyped_reads0__read

/* Compute Metrics Extended Gen9 :: Untyped Writes 0 */
#define kblgt2__compute_extended__untyped_writes0__read \
    hsw__compute_extended__untyped_writes0__read

/* Compute Metrics Extended Gen9 :: Typed Atomics 0 */
#define kblgt2__compute_extended__typed_atomics0__read \
    hsw__compute_extended__typed_atomics0__read

/* Compute Metrics Extended Gen9 :: TypedReadsPerCacheLine */
#define kblgt2__compute_extended__typed_reads_per_cache_line__read \
    hsw__compute_extended__typed_reads_per_cache_line__read

/* Compute Metrics Extended Gen9 :: TypedWritesPerCacheLine */
#define kblgt2__compute_extended__typed_writes_per_cache_line__read \
    hsw__compute_extended__typed_writes_per_cache_line__read

/* Compute Metrics Extended Gen9 :: UntypedReadsPerCacheLine */
#define kblgt2__compute_extended__untyped_reads_per_cache_line__read \
    bdw__compute_extended__untyped_reads_per_cache_line__read

/* Compute Metrics Extended Gen9 :: UntypedWritesPerCacheLine */
#define kblgt2__compute_extended__untyped_writes_per_cache_line__read \
    bdw__compute_extended__untyped_writes_per_cache_line__read

/* Compute Metrics Extended Gen9 :: TypedAtomicsPerCacheLine */
#define kblgt2__compute_extended__typed_atomics_per_cache_line__read \
    hsw__compute_extended__typed_atomics_per_cache_line__read

/* Compute Metrics L3 Cache Gen9 :: GPU Time Elapsed */
#define kblgt2__compute_l3_cache__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Compute Metrics L3 Cache Gen9 :: GPU Core Clocks */
#define kblgt2__compute_l3_cache__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Compute Metrics L3 Cache Gen9 :: AVG GPU Core Frequency */
#define kblgt2__compute_l3_cache__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Compute Metrics L3 Cache Gen9 :: AVG GPU Core Frequency */
#define kblgt2__compute_l3_cache__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Compute Metrics L3 Cache Gen9 :: GPU Busy */
#define kblgt2__compute_l3_cache__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Compute Metrics L3 Cache Gen9 :: VS Threads Dispatched */
#define kblgt2__compute_l3_cache__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Compute Metrics L3 Cache Gen9 :: HS Threads Dispatched */
#define kblgt2__compute_l3_cache__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Compute Metrics L3 Cache Gen9 :: DS Threads Dispatched */
#define kblgt2__compute_l3_cache__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Compute Metrics L3 Cache Gen9 :: GS Threads Dispatched */
#define kblgt2__compute_l3_cache__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Compute Metrics L3 Cache Gen9 :: FS Threads Dispatched */
#define kblgt2__compute_l3_cache__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Compute Metrics L3 Cache Gen9 :: CS Threads Dispatched */
#define kblgt2__compute_l3_cache__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Compute Metrics L3 Cache Gen9 :: EU Active */
#define kblgt2__compute_l3_cache__eu_active__read \
    bdw__render_basic__eu_active__read

/* Compute Metrics L3 Cache Gen9 :: EU Stall */
#define kblgt2__compute_l3_cache__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Compute Metrics L3 Cache Gen9 :: EU Both FPU Pipes Active */
#define kblgt2__compute_l3_cache__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU0 Pipe Active */
#define kblgt2__compute_l3_cache__fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU1 Pipe Active */
#define kblgt2__compute_l3_cache__fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Compute Metrics L3 Cache Gen9 :: EU AVG IPC Rate */
#define kblgt2__compute_l3_cache__eu_avg_ipc_rate__read \
    bdw__compute_basic__eu_avg_ipc_rate__read

/* Compute Metrics L3 Cache Gen9 :: EU AVG IPC Rate */
#define kblgt2__compute_l3_cache__eu_avg_ipc_rate__max \
    bdw__compute_basic__eu_avg_ipc_rate__max

/* Compute Metrics L3 Cache Gen9 :: EU Send Pipe Active */
#define kblgt2__compute_l3_cache__eu_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU0 Hybrid Instruction */
#define kblgt2__compute_l3_cache__eu_hybrid_fpu0_instruction__read \
    bdw__compute_l3_cache__eu_hybrid_fpu0_instruction__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU1 Hybrid Instruction */
#define kblgt2__compute_l3_cache__eu_hybrid_fpu1_instruction__read \
    bdw__compute_l3_cache__eu_hybrid_fpu1_instruction__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU0 Ternary Instruction */
#define kblgt2__compute_l3_cache__eu_ternary_fpu0_instruction__read \
    bdw__render_basic__ps_fpu0_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU1 Ternary Instruction */
#define kblgt2__compute_l3_cache__eu_ternary_fpu1_instruction__read \
    bdw__render_basic__ps_fpu1_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU0 Binary Instruction */
#define kblgt2__compute_l3_cache__eu_binary_fpu0_instruction__read \
    bdw__render_basic__ps_send_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU1 Binary Instruction */
#define kblgt2__compute_l3_cache__eu_binary_fpu1_instruction__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU0 Move Instruction */
#define kblgt2__compute_l3_cache__eu_move_fpu0_instruction__read \
    bdw__compute_l3_cache__eu_move_fpu0_instruction__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU1 Move Instruction */
#define kblgt2__compute_l3_cache__eu_move_fpu1_instruction__read \
    bdw__compute_l3_cache__eu_move_fpu1_instruction__read

/* Compute Metrics L3 Cache Gen9 :: Rasterized Pixels */
#define kblgt2__compute_l3_cache__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Compute Metrics L3 Cache Gen9 :: Early Hi-Depth Test Fails */
#define kblgt2__compute_l3_cache__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Compute Metrics L3 Cache Gen9 :: Early Depth Test Fails */
#define kblgt2__compute_l3_cache__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Compute Metrics L3 Cache Gen9 :: Samples Killed in FS */
#define kblgt2__compute_l3_cache__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Compute Metrics L3 Cache Gen9 :: Pixels Failing Tests */
#define kblgt2__compute_l3_cache__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Compute Metrics L3 Cache Gen9 :: Samples Written */
#define kblgt2__compute_l3_cache__samples_written__read \
    bdw__render_basic__samples_written__read

/* Compute Metrics L3 Cache Gen9 :: Samples Blended */
#define kblgt2__compute_l3_cache__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Compute Metrics L3 Cache Gen9 :: Sampler Accesses */
#define kblgt2__compute_l3_cache__sampler_accesses__read \
    bdw__render_pipe_profile__sampler_accesses__read

/* Compute Metrics L3 Cache Gen9 :: Sampler Texels */
#define kblgt2__compute_l3_cache__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Compute Metrics L3 Cache Gen9 :: Sampler Texels Misses */
#define kblgt2__compute_l3_cache__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Compute Metrics L3 Cache Gen9 :: SLM Bytes Read */
#define kblgt2__compute_l3_cache__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Compute Metrics L3 Cache Gen9 :: SLM Bytes Read */
#define kblgt2__compute_l3_cache__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics L3 Cache Gen9 :: SLM Bytes Written */
#define kblgt2__compute_l3_cache__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Compute Metrics L3 Cache Gen9 :: SLM Bytes Written */
#define kblgt2__compute_l3_cache__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics L3 Cache Gen9 :: Shader Memory Accesses */
#define kblgt2__compute_l3_cache__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Compute Metrics L3 Cache Gen9 :: Shader Atomic Memory Accesses */
#define kblgt2__compute_l3_cache__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Compute Metrics L3 Cache Gen9 :: L3 Accesses */
#define kblgt2__compute_l3_cache__l3_accesses__read \
    sklgt2__compute_l3_cache__l3_accesses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Misses */
#define kblgt2__compute_l3_cache__l3_misses__read \
    bdw__compute_l3_cache__l3_misses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Sampler Throughput */
#define kblgt2__compute_l3_cache__l3_sampler_throughput__read \
    chv__render_basic__l3_sampler_throughput__read

/* Compute Metrics L3 Cache Gen9 :: L3 Sampler Throughput */
#define kblgt2__compute_l3_cache__l3_sampler_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics L3 Cache Gen9 :: L3 Shader Throughput */
#define kblgt2__compute_l3_cache__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Compute Metrics L3 Cache Gen9 :: L3 Shader Throughput */
#define kblgt2__compute_l3_cache__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics L3 Cache Gen9 :: L3 Total Throughput */
#define kblgt2__compute_l3_cache__l3_total_throughput__read \
    sklgt2__compute_l3_cache__l3_total_throughput__read

/* Compute Metrics L3 Cache Gen9 :: L3 Total Throughput */
#define kblgt2__compute_l3_cache__l3_total_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics L3 Cache Gen9 :: Shader Barrier Messages */
#define kblgt2__compute_l3_cache__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Compute Metrics L3 Cache Gen9 :: L3 Bank 00 Accesses */
#define kblgt2__compute_l3_cache__l3_bank00_accesses__read \
    bdw__compute_l3_cache__l3_bank00_accesses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Bank 01 Accesses */
#define kblgt2__compute_l3_cache__l3_bank01_accesses__read \
    bdw__compute_l3_cache__l3_bank01_accesses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Bank 02 Accesses */
#define kblgt2__compute_l3_cache__l3_bank02_accesses__read \
    bdw__compute_l3_cache__l3_bank02_accesses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Bank 03 Accesses */
#define kblgt2__compute_l3_cache__l3_bank03_accesses__read \
    bdw__compute_l3_cache__l3_bank03_accesses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Bank 00 IC Accesses */
#define kblgt2__compute_l3_cache__l3_bank00_ic_accesses__read \
    bdw__compute_l3_cache__l3_bank00_ic_accesses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Bank 00 IC Hits */
#define kblgt2__compute_l3_cache__l3_bank00_ic_hits__read \
    bdw__compute_l3_cache__l3_bank00_ic_hits__read

/* Compute Metrics L3 Cache Gen9 :: GTI L3 Throughput */
#define kblgt2__compute_l3_cache__gti_l3_throughput__read \
    bdw__compute_l3_cache__gti_l3_throughput__read

/* Compute Metrics L3 Cache Gen9 :: GTI L3 Throughput */
#define kblgt2__compute_l3_cache__gti_l3_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics L3 Cache Gen9 :: GTI Read Throughput */
#define kblgt2__compute_l3_cache__gti_read_throughput__read \
    bdw__render_basic__gti_read_throughput__read

/* Compute Metrics L3 Cache Gen9 :: GTI Read Throughput */
#define kblgt2__compute_l3_cache__gti_read_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Compute Metrics L3 Cache Gen9 :: GTI Write Throughput */
#define kblgt2__compute_l3_cache__gti_write_throughput__read \
    hsw__render_basic__gti_write_throughput__read

/* Compute Metrics L3 Cache Gen9 :: GTI Write Throughput */
#define kblgt2__compute_l3_cache__gti_write_throughput__max \
    bdw__render_basic__gti_write_throughput__max

/* Metric set HDCAndSF :: GPU Time Elapsed */
#define kblgt2__hdc_and_sf__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set HDCAndSF :: GPU Core Clocks */
#define kblgt2__hdc_and_sf__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set HDCAndSF :: AVG GPU Core Frequency */
#define kblgt2__hdc_and_sf__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set HDCAndSF :: AVG GPU Core Frequency */
#define kblgt2__hdc_and_sf__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set HDCAndSF :: GPU Busy */
#define kblgt2__hdc_and_sf__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set HDCAndSF :: VS Threads Dispatched */
#define kblgt2__hdc_and_sf__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set HDCAndSF :: HS Threads Dispatched */
#define kblgt2__hdc_and_sf__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set HDCAndSF :: DS Threads Dispatched */
#define kblgt2__hdc_and_sf__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set HDCAndSF :: GS Threads Dispatched */
#define kblgt2__hdc_and_sf__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set HDCAndSF :: FS Threads Dispatched */
#define kblgt2__hdc_and_sf__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set HDCAndSF :: CS Threads Dispatched */
#define kblgt2__hdc_and_sf__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set HDCAndSF :: EU Active */
#define kblgt2__hdc_and_sf__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set HDCAndSF :: EU Stall */
#define kblgt2__hdc_and_sf__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set HDCAndSF :: EU Both FPU Pipes Active */
#define kblgt2__hdc_and_sf__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set HDCAndSF :: VS FPU0 Pipe Active */
#define kblgt2__hdc_and_sf__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set HDCAndSF :: VS FPU1 Pipe Active */
#define kblgt2__hdc_and_sf__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set HDCAndSF :: VS Send Pipe Active */
#define kblgt2__hdc_and_sf__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set HDCAndSF :: PS FPU0 Pipe Active */
#define kblgt2__hdc_and_sf__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set HDCAndSF :: PS FPU1 Pipe Active */
#define kblgt2__hdc_and_sf__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set HDCAndSF :: PS Send Pipeline Active */
#define kblgt2__hdc_and_sf__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set HDCAndSF :: FS Both FPU Active */
#define kblgt2__hdc_and_sf__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set HDCAndSF :: Rasterized Pixels */
#define kblgt2__hdc_and_sf__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set HDCAndSF :: Early Hi-Depth Test Fails */
#define kblgt2__hdc_and_sf__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set HDCAndSF :: Early Depth Test Fails */
#define kblgt2__hdc_and_sf__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set HDCAndSF :: Samples Killed in FS */
#define kblgt2__hdc_and_sf__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set HDCAndSF :: Pixels Failing Tests */
#define kblgt2__hdc_and_sf__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set HDCAndSF :: Samples Written */
#define kblgt2__hdc_and_sf__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set HDCAndSF :: Samples Blended */
#define kblgt2__hdc_and_sf__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set HDCAndSF :: Sampler Texels */
#define kblgt2__hdc_and_sf__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set HDCAndSF :: Sampler Texels Misses */
#define kblgt2__hdc_and_sf__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set HDCAndSF :: SLM Bytes Read */
#define kblgt2__hdc_and_sf__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set HDCAndSF :: SLM Bytes Read */
#define kblgt2__hdc_and_sf__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set HDCAndSF :: SLM Bytes Written */
#define kblgt2__hdc_and_sf__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set HDCAndSF :: SLM Bytes Written */
#define kblgt2__hdc_and_sf__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set HDCAndSF :: Shader Memory Accesses */
#define kblgt2__hdc_and_sf__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set HDCAndSF :: Shader Atomic Memory Accesses */
#define kblgt2__hdc_and_sf__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set HDCAndSF :: L3 Shader Throughput */
#define kblgt2__hdc_and_sf__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set HDCAndSF :: L3 Shader Throughput */
#define kblgt2__hdc_and_sf__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set HDCAndSF :: Shader Barrier Messages */
#define kblgt2__hdc_and_sf__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set HDCAndSF :: Polygon Data Ready */
#define kblgt2__hdc_and_sf__poly_data_ready__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set HDCAndSF :: HDC stalled by L3 (s0.ss0) */
#define kblgt2__hdc_and_sf__non_sampler_shader00_access_stalled_on_l3__read \
    bdw__hdc_and_sf__non_sampler_shader02_access_stalled_on_l3__read

/* Metric set HDCAndSF :: HDC stalled by L3 (s0.ss1) */
#define kblgt2__hdc_and_sf__non_sampler_shader01_access_stalled_on_l3__read \
    bdw__hdc_and_sf__non_sampler_shader01_access_stalled_on_l3__read

/* Metric set HDCAndSF :: HDC stalled by L3 (s0.ss2) */
#define kblgt2__hdc_and_sf__non_sampler_shader02_access_stalled_on_l3__read \
    bdw__hdc_and_sf__non_sampler_shader00_access_stalled_on_l3__read

/* Metric set HDCAndSF :: SQ is full */
#define kblgt2__hdc_and_sf__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set L3_1 :: GPU Time Elapsed */
#define kblgt2__l3_1__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set L3_1 :: GPU Core Clocks */
#define kblgt2__l3_1__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set L3_1 :: AVG GPU Core Frequency */
#define kblgt2__l3_1__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set L3_1 :: AVG GPU Core Frequency */
#define kblgt2__l3_1__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set L3_1 :: GPU Busy */
#define kblgt2__l3_1__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set L3_1 :: VS Threads Dispatched */
#define kblgt2__l3_1__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set L3_1 :: HS Threads Dispatched */
#define kblgt2__l3_1__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set L3_1 :: DS Threads Dispatched */
#define kblgt2__l3_1__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set L3_1 :: GS Threads Dispatched */
#define kblgt2__l3_1__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set L3_1 :: FS Threads Dispatched */
#define kblgt2__l3_1__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set L3_1 :: CS Threads Dispatched */
#define kblgt2__l3_1__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set L3_1 :: EU Active */
#define kblgt2__l3_1__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set L3_1 :: EU Stall */
#define kblgt2__l3_1__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set L3_1 :: EU Both FPU Pipes Active */
#define kblgt2__l3_1__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set L3_1 :: VS FPU0 Pipe Active */
#define kblgt2__l3_1__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set L3_1 :: VS FPU1 Pipe Active */
#define kblgt2__l3_1__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set L3_1 :: VS Send Pipe Active */
#define kblgt2__l3_1__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set L3_1 :: PS FPU0 Pipe Active */
#define kblgt2__l3_1__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set L3_1 :: PS FPU1 Pipe Active */
#define kblgt2__l3_1__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set L3_1 :: PS Send Pipeline Active */
#define kblgt2__l3_1__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set L3_1 :: FS Both FPU Active */
#define kblgt2__l3_1__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set L3_1 :: Rasterized Pixels */
#define kblgt2__l3_1__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set L3_1 :: Early Hi-Depth Test Fails */
#define kblgt2__l3_1__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set L3_1 :: Early Depth Test Fails */
#define kblgt2__l3_1__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set L3_1 :: Samples Killed in FS */
#define kblgt2__l3_1__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set L3_1 :: Pixels Failing Tests */
#define kblgt2__l3_1__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set L3_1 :: Samples Written */
#define kblgt2__l3_1__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set L3_1 :: Samples Blended */
#define kblgt2__l3_1__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set L3_1 :: Sampler Texels */
#define kblgt2__l3_1__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set L3_1 :: Sampler Texels Misses */
#define kblgt2__l3_1__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set L3_1 :: SLM Bytes Read */
#define kblgt2__l3_1__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set L3_1 :: SLM Bytes Read */
#define kblgt2__l3_1__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_1 :: SLM Bytes Written */
#define kblgt2__l3_1__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set L3_1 :: SLM Bytes Written */
#define kblgt2__l3_1__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_1 :: Shader Memory Accesses */
#define kblgt2__l3_1__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set L3_1 :: Shader Atomic Memory Accesses */
#define kblgt2__l3_1__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set L3_1 :: L3 Shader Throughput */
#define kblgt2__l3_1__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set L3_1 :: L3 Shader Throughput */
#define kblgt2__l3_1__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_1 :: Shader Barrier Messages */
#define kblgt2__l3_1__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set L3_1 :: Slice0 L3 Bank0 Stalled */
#define kblgt2__l3_1__l30_bank0_stalled__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set L3_1 :: Slice0 L3 Bank1 Stalled */
#define kblgt2__l3_1__l30_bank1_stalled__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* Metric set L3_1 :: Slice0 L3 Bank1 Active */
#define kblgt2__l3_1__l30_bank1_active__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set L3_1 :: Slice0 L3 Bank0 Active */
#define kblgt2__l3_1__l30_bank0_active__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set L3_1 :: SQ is full */
#define kblgt2__l3_1__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set L3_2 :: GPU Time Elapsed */
#define kblgt2__l3_2__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set L3_2 :: GPU Core Clocks */
#define kblgt2__l3_2__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set L3_2 :: AVG GPU Core Frequency */
#define kblgt2__l3_2__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set L3_2 :: AVG GPU Core Frequency */
#define kblgt2__l3_2__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set L3_2 :: GPU Busy */
#define kblgt2__l3_2__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set L3_2 :: VS Threads Dispatched */
#define kblgt2__l3_2__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set L3_2 :: HS Threads Dispatched */
#define kblgt2__l3_2__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set L3_2 :: DS Threads Dispatched */
#define kblgt2__l3_2__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set L3_2 :: GS Threads Dispatched */
#define kblgt2__l3_2__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set L3_2 :: FS Threads Dispatched */
#define kblgt2__l3_2__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set L3_2 :: CS Threads Dispatched */
#define kblgt2__l3_2__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set L3_2 :: EU Active */
#define kblgt2__l3_2__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set L3_2 :: EU Stall */
#define kblgt2__l3_2__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set L3_2 :: EU Both FPU Pipes Active */
#define kblgt2__l3_2__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set L3_2 :: VS FPU0 Pipe Active */
#define kblgt2__l3_2__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set L3_2 :: VS FPU1 Pipe Active */
#define kblgt2__l3_2__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set L3_2 :: VS Send Pipe Active */
#define kblgt2__l3_2__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set L3_2 :: PS FPU0 Pipe Active */
#define kblgt2__l3_2__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set L3_2 :: PS FPU1 Pipe Active */
#define kblgt2__l3_2__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set L3_2 :: PS Send Pipeline Active */
#define kblgt2__l3_2__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set L3_2 :: FS Both FPU Active */
#define kblgt2__l3_2__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set L3_2 :: Rasterized Pixels */
#define kblgt2__l3_2__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set L3_2 :: Early Hi-Depth Test Fails */
#define kblgt2__l3_2__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set L3_2 :: Early Depth Test Fails */
#define kblgt2__l3_2__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set L3_2 :: Samples Killed in FS */
#define kblgt2__l3_2__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set L3_2 :: Pixels Failing Tests */
#define kblgt2__l3_2__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set L3_2 :: Samples Written */
#define kblgt2__l3_2__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set L3_2 :: Samples Blended */
#define kblgt2__l3_2__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set L3_2 :: Sampler Texels */
#define kblgt2__l3_2__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set L3_2 :: Sampler Texels Misses */
#define kblgt2__l3_2__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set L3_2 :: SLM Bytes Read */
#define kblgt2__l3_2__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set L3_2 :: SLM Bytes Read */
#define kblgt2__l3_2__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_2 :: SLM Bytes Written */
#define kblgt2__l3_2__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set L3_2 :: SLM Bytes Written */
#define kblgt2__l3_2__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_2 :: Shader Memory Accesses */
#define kblgt2__l3_2__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set L3_2 :: Shader Atomic Memory Accesses */
#define kblgt2__l3_2__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set L3_2 :: L3 Shader Throughput */
#define kblgt2__l3_2__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set L3_2 :: L3 Shader Throughput */
#define kblgt2__l3_2__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_2 :: Shader Barrier Messages */
#define kblgt2__l3_2__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set L3_2 :: Slice0 L3 Bank2 Stalled */
#define kblgt2__l3_2__l30_bank2_stalled__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set L3_2 :: Slice0 L3 Bank2 Active */
#define kblgt2__l3_2__l30_bank2_active__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set L3_2 :: SQ is full */
#define kblgt2__l3_2__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set L3_3 :: GPU Time Elapsed */
#define kblgt2__l3_3__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set L3_3 :: GPU Core Clocks */
#define kblgt2__l3_3__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set L3_3 :: AVG GPU Core Frequency */
#define kblgt2__l3_3__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set L3_3 :: AVG GPU Core Frequency */
#define kblgt2__l3_3__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set L3_3 :: GPU Busy */
#define kblgt2__l3_3__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set L3_3 :: VS Threads Dispatched */
#define kblgt2__l3_3__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set L3_3 :: HS Threads Dispatched */
#define kblgt2__l3_3__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set L3_3 :: DS Threads Dispatched */
#define kblgt2__l3_3__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set L3_3 :: GS Threads Dispatched */
#define kblgt2__l3_3__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set L3_3 :: FS Threads Dispatched */
#define kblgt2__l3_3__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set L3_3 :: CS Threads Dispatched */
#define kblgt2__l3_3__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set L3_3 :: EU Active */
#define kblgt2__l3_3__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set L3_3 :: EU Stall */
#define kblgt2__l3_3__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set L3_3 :: EU Both FPU Pipes Active */
#define kblgt2__l3_3__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set L3_3 :: VS FPU0 Pipe Active */
#define kblgt2__l3_3__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set L3_3 :: VS FPU1 Pipe Active */
#define kblgt2__l3_3__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set L3_3 :: VS Send Pipe Active */
#define kblgt2__l3_3__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set L3_3 :: PS FPU0 Pipe Active */
#define kblgt2__l3_3__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set L3_3 :: PS FPU1 Pipe Active */
#define kblgt2__l3_3__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set L3_3 :: PS Send Pipeline Active */
#define kblgt2__l3_3__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set L3_3 :: FS Both FPU Active */
#define kblgt2__l3_3__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set L3_3 :: Rasterized Pixels */
#define kblgt2__l3_3__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set L3_3 :: Early Hi-Depth Test Fails */
#define kblgt2__l3_3__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set L3_3 :: Early Depth Test Fails */
#define kblgt2__l3_3__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set L3_3 :: Samples Killed in FS */
#define kblgt2__l3_3__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set L3_3 :: Pixels Failing Tests */
#define kblgt2__l3_3__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set L3_3 :: Samples Written */
#define kblgt2__l3_3__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set L3_3 :: Samples Blended */
#define kblgt2__l3_3__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set L3_3 :: Sampler Texels */
#define kblgt2__l3_3__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set L3_3 :: Sampler Texels Misses */
#define kblgt2__l3_3__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set L3_3 :: SLM Bytes Read */
#define kblgt2__l3_3__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set L3_3 :: SLM Bytes Read */
#define kblgt2__l3_3__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_3 :: SLM Bytes Written */
#define kblgt2__l3_3__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set L3_3 :: SLM Bytes Written */
#define kblgt2__l3_3__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_3 :: Shader Memory Accesses */
#define kblgt2__l3_3__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set L3_3 :: Shader Atomic Memory Accesses */
#define kblgt2__l3_3__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set L3_3 :: L3 Shader Throughput */
#define kblgt2__l3_3__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set L3_3 :: L3 Shader Throughput */
#define kblgt2__l3_3__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_3 :: Shader Barrier Messages */
#define kblgt2__l3_3__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set L3_3 :: Slice0 L3 Bank3 Stalled */
#define kblgt2__l3_3__l30_bank3_stalled__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set L3_3 :: Slice0 L3 Bank3 Active */
#define kblgt2__l3_3__l30_bank3_active__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set L3_3 :: SQ is full */
#define kblgt2__l3_3__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set RasterizerAndPixelBackend :: GPU Time Elapsed */
#define kblgt2__rasterizer_and_pixel_backend__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set RasterizerAndPixelBackend :: GPU Core Clocks */
#define kblgt2__rasterizer_and_pixel_backend__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set RasterizerAndPixelBackend :: AVG GPU Core Frequency */
#define kblgt2__rasterizer_and_pixel_backend__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set RasterizerAndPixelBackend :: AVG GPU Core Frequency */
#define kblgt2__rasterizer_and_pixel_backend__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set RasterizerAndPixelBackend :: GPU Busy */
#define kblgt2__rasterizer_and_pixel_backend__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set RasterizerAndPixelBackend :: VS Threads Dispatched */
#define kblgt2__rasterizer_and_pixel_backend__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set RasterizerAndPixelBackend :: HS Threads Dispatched */
#define kblgt2__rasterizer_and_pixel_backend__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set RasterizerAndPixelBackend :: DS Threads Dispatched */
#define kblgt2__rasterizer_and_pixel_backend__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set RasterizerAndPixelBackend :: GS Threads Dispatched */
#define kblgt2__rasterizer_and_pixel_backend__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set RasterizerAndPixelBackend :: FS Threads Dispatched */
#define kblgt2__rasterizer_and_pixel_backend__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set RasterizerAndPixelBackend :: CS Threads Dispatched */
#define kblgt2__rasterizer_and_pixel_backend__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set RasterizerAndPixelBackend :: EU Active */
#define kblgt2__rasterizer_and_pixel_backend__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set RasterizerAndPixelBackend :: EU Stall */
#define kblgt2__rasterizer_and_pixel_backend__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set RasterizerAndPixelBackend :: EU Both FPU Pipes Active */
#define kblgt2__rasterizer_and_pixel_backend__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set RasterizerAndPixelBackend :: VS FPU0 Pipe Active */
#define kblgt2__rasterizer_and_pixel_backend__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set RasterizerAndPixelBackend :: VS FPU1 Pipe Active */
#define kblgt2__rasterizer_and_pixel_backend__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set RasterizerAndPixelBackend :: VS Send Pipe Active */
#define kblgt2__rasterizer_and_pixel_backend__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set RasterizerAndPixelBackend :: PS FPU0 Pipe Active */
#define kblgt2__rasterizer_and_pixel_backend__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set RasterizerAndPixelBackend :: PS FPU1 Pipe Active */
#define kblgt2__rasterizer_and_pixel_backend__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set RasterizerAndPixelBackend :: PS Send Pipeline Active */
#define kblgt2__rasterizer_and_pixel_backend__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set RasterizerAndPixelBackend :: FS Both FPU Active */
#define kblgt2__rasterizer_and_pixel_backend__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set RasterizerAndPixelBackend :: Rasterized Pixels */
#define kblgt2__rasterizer_and_pixel_backend__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set RasterizerAndPixelBackend :: Early Hi-Depth Test Fails */
#define kblgt2__rasterizer_and_pixel_backend__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set RasterizerAndPixelBackend :: Early Depth Test Fails */
#define kblgt2__rasterizer_and_pixel_backend__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set RasterizerAndPixelBackend :: Samples Killed in FS */
#define kblgt2__rasterizer_and_pixel_backend__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set RasterizerAndPixelBackend :: Pixels Failing Tests */
#define kblgt2__rasterizer_and_pixel_backend__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set RasterizerAndPixelBackend :: Samples Written */
#define kblgt2__rasterizer_and_pixel_backend__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set RasterizerAndPixelBackend :: Samples Blended */
#define kblgt2__rasterizer_and_pixel_backend__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set RasterizerAndPixelBackend :: Sampler Texels */
#define kblgt2__rasterizer_and_pixel_backend__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set RasterizerAndPixelBackend :: Sampler Texels Misses */
#define kblgt2__rasterizer_and_pixel_backend__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Read */
#define kblgt2__rasterizer_and_pixel_backend__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Read */
#define kblgt2__rasterizer_and_pixel_backend__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Written */
#define kblgt2__rasterizer_and_pixel_backend__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Written */
#define kblgt2__rasterizer_and_pixel_backend__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set RasterizerAndPixelBackend :: Shader Memory Accesses */
#define kblgt2__rasterizer_and_pixel_backend__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set RasterizerAndPixelBackend :: Shader Atomic Memory Accesses */
#define kblgt2__rasterizer_and_pixel_backend__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set RasterizerAndPixelBackend :: L3 Shader Throughput */
#define kblgt2__rasterizer_and_pixel_backend__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set RasterizerAndPixelBackend :: L3 Shader Throughput */
#define kblgt2__rasterizer_and_pixel_backend__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set RasterizerAndPixelBackend :: Shader Barrier Messages */
#define kblgt2__rasterizer_and_pixel_backend__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Post-EarlyZ Pixel Data Ready */
#define kblgt2__rasterizer_and_pixel_backend__pixel_data0_ready__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Rasterizer Input Available */
#define kblgt2__rasterizer_and_pixel_backend__rasterizer0_input_available__read \
    bdw__render_basic__sampler1_busy__read

/* Metric set RasterizerAndPixelBackend :: Slice0 PS Output Available */
#define kblgt2__rasterizer_and_pixel_backend__ps_output0_available__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Pixel Values Ready */
#define kblgt2__rasterizer_and_pixel_backend__pixel_values0_ready__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Rasterizer Output Ready */
#define kblgt2__rasterizer_and_pixel_backend__rasterizer0_output_ready__read \
    bdw__render_pipe_profile__sf_stall__read

/* Metric set RasterizerAndPixelBackend :: SQ is full */
#define kblgt2__rasterizer_and_pixel_backend__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set Sampler :: GPU Time Elapsed */
#define kblgt2__sampler__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set Sampler :: GPU Core Clocks */
#define kblgt2__sampler__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set Sampler :: AVG GPU Core Frequency */
#define kblgt2__sampler__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set Sampler :: AVG GPU Core Frequency */
#define kblgt2__sampler__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set Sampler :: GPU Busy */
#define kblgt2__sampler__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set Sampler :: VS Threads Dispatched */
#define kblgt2__sampler__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set Sampler :: HS Threads Dispatched */
#define kblgt2__sampler__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set Sampler :: DS Threads Dispatched */
#define kblgt2__sampler__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set Sampler :: GS Threads Dispatched */
#define kblgt2__sampler__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set Sampler :: FS Threads Dispatched */
#define kblgt2__sampler__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set Sampler :: CS Threads Dispatched */
#define kblgt2__sampler__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set Sampler :: EU Active */
#define kblgt2__sampler__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set Sampler :: EU Stall */
#define kblgt2__sampler__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set Sampler :: EU Both FPU Pipes Active */
#define kblgt2__sampler__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set Sampler :: VS FPU0 Pipe Active */
#define kblgt2__sampler__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set Sampler :: VS FPU1 Pipe Active */
#define kblgt2__sampler__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set Sampler :: VS Send Pipe Active */
#define kblgt2__sampler__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set Sampler :: PS FPU0 Pipe Active */
#define kblgt2__sampler__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set Sampler :: PS FPU1 Pipe Active */
#define kblgt2__sampler__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set Sampler :: PS Send Pipeline Active */
#define kblgt2__sampler__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set Sampler :: FS Both FPU Active */
#define kblgt2__sampler__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set Sampler :: Rasterized Pixels */
#define kblgt2__sampler__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set Sampler :: Early Hi-Depth Test Fails */
#define kblgt2__sampler__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set Sampler :: Early Depth Test Fails */
#define kblgt2__sampler__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set Sampler :: Samples Killed in FS */
#define kblgt2__sampler__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set Sampler :: Pixels Failing Tests */
#define kblgt2__sampler__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set Sampler :: Samples Written */
#define kblgt2__sampler__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set Sampler :: Samples Blended */
#define kblgt2__sampler__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set Sampler :: Sampler Texels */
#define kblgt2__sampler__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set Sampler :: Sampler Texels Misses */
#define kblgt2__sampler__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set Sampler :: SLM Bytes Read */
#define kblgt2__sampler__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set Sampler :: SLM Bytes Read */
#define kblgt2__sampler__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set Sampler :: SLM Bytes Written */
#define kblgt2__sampler__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set Sampler :: SLM Bytes Written */
#define kblgt2__sampler__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set Sampler :: Shader Memory Accesses */
#define kblgt2__sampler__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set Sampler :: Shader Atomic Memory Accesses */
#define kblgt2__sampler__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set Sampler :: L3 Shader Throughput */
#define kblgt2__sampler__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set Sampler :: L3 Shader Throughput */
#define kblgt2__sampler__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set Sampler :: Shader Barrier Messages */
#define kblgt2__sampler__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set Sampler :: Slice0 Subslice1 Input Available */
#define kblgt2__sampler__sampler01_input_available__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set Sampler :: Slice0 Subslice2 Input Available */
#define kblgt2__sampler__sampler02_input_available__read \
    bdw__render_basic__sampler1_busy__read

/* Metric set Sampler :: Slice0 Subslice0 Input Available */
#define kblgt2__sampler__sampler00_input_available__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Metric set Sampler :: Slice0 Subslice2 Sampler Output Ready */
#define kblgt2__sampler__sampler02_output_ready__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set Sampler :: Slice0 Subslice0 Sampler Output Ready */
#define kblgt2__sampler__sampler00_output_ready__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set Sampler :: Slice0 Subslice1 Sampler Output Ready */
#define kblgt2__sampler__sampler01_output_ready__read \
    bdw__render_pipe_profile__sf_stall__read

/* Metric set Sampler :: SQ is full */
#define kblgt2__sampler__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set TDL_1 :: GPU Time Elapsed */
#define kblgt2__tdl_1__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set TDL_1 :: GPU Core Clocks */
#define kblgt2__tdl_1__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set TDL_1 :: AVG GPU Core Frequency */
#define kblgt2__tdl_1__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set TDL_1 :: AVG GPU Core Frequency */
#define kblgt2__tdl_1__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set TDL_1 :: GPU Busy */
#define kblgt2__tdl_1__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set TDL_1 :: VS Threads Dispatched */
#define kblgt2__tdl_1__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set TDL_1 :: HS Threads Dispatched */
#define kblgt2__tdl_1__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set TDL_1 :: DS Threads Dispatched */
#define kblgt2__tdl_1__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set TDL_1 :: GS Threads Dispatched */
#define kblgt2__tdl_1__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set TDL_1 :: FS Threads Dispatched */
#define kblgt2__tdl_1__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set TDL_1 :: CS Threads Dispatched */
#define kblgt2__tdl_1__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set TDL_1 :: EU Active */
#define kblgt2__tdl_1__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set TDL_1 :: EU Stall */
#define kblgt2__tdl_1__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set TDL_1 :: EU Both FPU Pipes Active */
#define kblgt2__tdl_1__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set TDL_1 :: VS FPU0 Pipe Active */
#define kblgt2__tdl_1__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set TDL_1 :: VS FPU1 Pipe Active */
#define kblgt2__tdl_1__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set TDL_1 :: VS Send Pipe Active */
#define kblgt2__tdl_1__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set TDL_1 :: PS FPU0 Pipe Active */
#define kblgt2__tdl_1__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set TDL_1 :: PS FPU1 Pipe Active */
#define kblgt2__tdl_1__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set TDL_1 :: PS Send Pipeline Active */
#define kblgt2__tdl_1__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set TDL_1 :: FS Both FPU Active */
#define kblgt2__tdl_1__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set TDL_1 :: Rasterized Pixels */
#define kblgt2__tdl_1__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set TDL_1 :: Early Hi-Depth Test Fails */
#define kblgt2__tdl_1__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set TDL_1 :: Early Depth Test Fails */
#define kblgt2__tdl_1__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set TDL_1 :: Samples Killed in FS */
#define kblgt2__tdl_1__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set TDL_1 :: Pixels Failing Tests */
#define kblgt2__tdl_1__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set TDL_1 :: Samples Written */
#define kblgt2__tdl_1__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set TDL_1 :: Samples Blended */
#define kblgt2__tdl_1__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set TDL_1 :: Sampler Texels */
#define kblgt2__tdl_1__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set TDL_1 :: Sampler Texels Misses */
#define kblgt2__tdl_1__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set TDL_1 :: SLM Bytes Read */
#define kblgt2__tdl_1__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set TDL_1 :: SLM Bytes Read */
#define kblgt2__tdl_1__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_1 :: SLM Bytes Written */
#define kblgt2__tdl_1__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set TDL_1 :: SLM Bytes Written */
#define kblgt2__tdl_1__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_1 :: Shader Memory Accesses */
#define kblgt2__tdl_1__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set TDL_1 :: Shader Atomic Memory Accesses */
#define kblgt2__tdl_1__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set TDL_1 :: L3 Shader Throughput */
#define kblgt2__tdl_1__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set TDL_1 :: L3 Shader Throughput */
#define kblgt2__tdl_1__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_1 :: Shader Barrier Messages */
#define kblgt2__tdl_1__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set TDL_1 :: NonPS Thread Ready For Dispatch on Slice0 Subslice1 */
#define kblgt2__tdl_1__non_ps_thread01_ready_for_dispatch__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set TDL_1 :: PS Thread Ready For Dispatch on Slice0 Subslice0 */
#define kblgt2__tdl_1__ps_thread00_ready_for_dispatch__read \
    bdw__render_basic__sampler1_busy__read

/* Metric set TDL_1 :: NonPS Thread Ready For Dispatch on Slice0 Subslice0 */
#define kblgt2__tdl_1__non_ps_thread00_ready_for_dispatch__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Metric set TDL_1 :: PS Thread Ready For Dispatch on Slice0 Subslice2 */
#define kblgt2__tdl_1__ps_thread02_ready_for_dispatch__read \
    bdw__render_basic__sampler1_bottleneck__read

/* Metric set TDL_1 :: NonPS Thread Ready For Dispatch on Slice0 Subslice2 */
#define kblgt2__tdl_1__non_ps_thread02_ready_for_dispatch__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* Metric set TDL_1 :: PS Thread Ready For Dispatch on Slice0 Subslice1 */
#define kblgt2__tdl_1__ps_thread01_ready_for_dispatch__read \
    bdw__render_pipe_profile__cl_bottleneck__read

/* Metric set TDL_1 :: SQ is full */
#define kblgt2__tdl_1__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set TDL_2 :: GPU Time Elapsed */
#define kblgt2__tdl_2__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set TDL_2 :: GPU Core Clocks */
#define kblgt2__tdl_2__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set TDL_2 :: AVG GPU Core Frequency */
#define kblgt2__tdl_2__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set TDL_2 :: AVG GPU Core Frequency */
#define kblgt2__tdl_2__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set TDL_2 :: GPU Busy */
#define kblgt2__tdl_2__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set TDL_2 :: VS Threads Dispatched */
#define kblgt2__tdl_2__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set TDL_2 :: HS Threads Dispatched */
#define kblgt2__tdl_2__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set TDL_2 :: DS Threads Dispatched */
#define kblgt2__tdl_2__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set TDL_2 :: GS Threads Dispatched */
#define kblgt2__tdl_2__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set TDL_2 :: FS Threads Dispatched */
#define kblgt2__tdl_2__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set TDL_2 :: CS Threads Dispatched */
#define kblgt2__tdl_2__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set TDL_2 :: EU Active */
#define kblgt2__tdl_2__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set TDL_2 :: EU Stall */
#define kblgt2__tdl_2__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set TDL_2 :: EU Both FPU Pipes Active */
#define kblgt2__tdl_2__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set TDL_2 :: VS FPU0 Pipe Active */
#define kblgt2__tdl_2__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set TDL_2 :: VS FPU1 Pipe Active */
#define kblgt2__tdl_2__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set TDL_2 :: VS Send Pipe Active */
#define kblgt2__tdl_2__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set TDL_2 :: PS FPU0 Pipe Active */
#define kblgt2__tdl_2__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set TDL_2 :: PS FPU1 Pipe Active */
#define kblgt2__tdl_2__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set TDL_2 :: PS Send Pipeline Active */
#define kblgt2__tdl_2__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set TDL_2 :: FS Both FPU Active */
#define kblgt2__tdl_2__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set TDL_2 :: Rasterized Pixels */
#define kblgt2__tdl_2__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set TDL_2 :: Early Hi-Depth Test Fails */
#define kblgt2__tdl_2__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set TDL_2 :: Early Depth Test Fails */
#define kblgt2__tdl_2__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set TDL_2 :: Samples Killed in FS */
#define kblgt2__tdl_2__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set TDL_2 :: Pixels Failing Tests */
#define kblgt2__tdl_2__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set TDL_2 :: Samples Written */
#define kblgt2__tdl_2__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set TDL_2 :: Samples Blended */
#define kblgt2__tdl_2__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set TDL_2 :: Sampler Texels */
#define kblgt2__tdl_2__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set TDL_2 :: Sampler Texels Misses */
#define kblgt2__tdl_2__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set TDL_2 :: SLM Bytes Read */
#define kblgt2__tdl_2__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set TDL_2 :: SLM Bytes Read */
#define kblgt2__tdl_2__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_2 :: SLM Bytes Written */
#define kblgt2__tdl_2__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set TDL_2 :: SLM Bytes Written */
#define kblgt2__tdl_2__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_2 :: Shader Memory Accesses */
#define kblgt2__tdl_2__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set TDL_2 :: Shader Atomic Memory Accesses */
#define kblgt2__tdl_2__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set TDL_2 :: L3 Shader Throughput */
#define kblgt2__tdl_2__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set TDL_2 :: L3 Shader Throughput */
#define kblgt2__tdl_2__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_2 :: Shader Barrier Messages */
#define kblgt2__tdl_2__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice1 Port 0 */
#define kblgt2__tdl_2__thread_header01_ready_port0__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice0 Port 1 */
#define kblgt2__tdl_2__thread_header00_ready_port1__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice0 Port 0 */
#define kblgt2__tdl_2__thread_header00_ready_port0__read \
    bdw__render_pipe_profile__sf_stall__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice2 Port 1 */
#define kblgt2__tdl_2__thread_header02_ready_port1__read \
    bdw__render_pipe_profile__cl_stall__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice2 Port 0 */
#define kblgt2__tdl_2__thread_header02_ready_port0__read \
    bdw__render_pipe_profile__so_stall__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice1 Port 1 */
#define kblgt2__tdl_2__thread_header01_ready_port1__read \
    bdw__render_pipe_profile__ds_stall__read

/* Metric set TDL_2 :: SQ is full */
#define kblgt2__tdl_2__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Compute Metrics Extra Gen9 :: GPU Time Elapsed */
#define kblgt2__compute_extra__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Compute Metrics Extra Gen9 :: GPU Core Clocks */
#define kblgt2__compute_extra__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Compute Metrics Extra Gen9 :: AVG GPU Core Frequency */
#define kblgt2__compute_extra__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Compute Metrics Extra Gen9 :: AVG GPU Core Frequency */
#define kblgt2__compute_extra__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Compute Metrics Extra Gen9 :: EU FPU1 Pipe Active */
#define kblgt2__compute_extra__fpu1_active__read \
    bdw__render_basic__eu_stall__read

/* Compute Metrics Extra Gen9 :: EU FPU1 Pipe Active including Ext Math */
#define kblgt2__compute_extra__fpu1_active_adjusted__read \
    sklgt2__compute_extra__fpu1_active_adjusted__read

/* Media Vme Pipe Gen9 :: GPU Time Elapsed */
#define kblgt2__vme_pipe__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Media Vme Pipe Gen9 :: GPU Core Clocks */
#define kblgt2__vme_pipe__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Media Vme Pipe Gen9 :: AVG GPU Core Frequency */
#define kblgt2__vme_pipe__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Media Vme Pipe Gen9 :: AVG GPU Core Frequency */
#define kblgt2__vme_pipe__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Media Vme Pipe Gen9 :: GPU Busy */
#define kblgt2__vme_pipe__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Media Vme Pipe Gen9 :: CS Threads Dispatched */
#define kblgt2__vme_pipe__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Media Vme Pipe Gen9 :: EU Active */
#define kblgt2__vme_pipe__eu_active__read \
    bdw__render_basic__eu_active__read

/* Media Vme Pipe Gen9 :: EU Stall */
#define kblgt2__vme_pipe__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Media Vme Pipe Gen9 :: EU Both FPU Pipes Active */
#define kblgt2__vme_pipe__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Media Vme Pipe Gen9 :: EU Thread Occupancy */
#define kblgt2__vme_pipe__eu_thread_occupancy__read \
    bdw__vme_pipe__eu_thread_occupancy__read

/* Media Vme Pipe Gen9 :: VME Busy */
#define kblgt2__vme_pipe__vme_busy__read \
    bdw__vme_pipe__vme_busy__read

/* Gpu Rings Busyness :: GPU Time Elapsed */
#define kblgt2__gpu_busyness__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Gpu Rings Busyness :: GPU Core Clocks */
#define kblgt2__gpu_busyness__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Gpu Rings Busyness :: AVG GPU Core Frequency */
#define kblgt2__gpu_busyness__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Gpu Rings Busyness :: AVG GPU Core Frequency */
#define kblgt2__gpu_busyness__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Gpu Rings Busyness :: Render Ring Busy */
#define kblgt2__gpu_busyness__render_busy__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Gpu Rings Busyness :: Vdbox0 Ring Busy */
#define kblgt2__gpu_busyness__vdbox0_busy__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Gpu Rings Busyness :: Vebox Ring Busy */
#define kblgt2__gpu_busyness__vebox_busy__read \
    bdw__render_pipe_profile__sf_stall__read

/* Gpu Rings Busyness :: Blitter Ring Busy */
#define kblgt2__gpu_busyness__blitter_busy__read \
    bdw__render_pipe_profile__cl_stall__read

/* Gpu Rings Busyness :: AnyRingBusy */
#define kblgt2__gpu_busyness__any_ring_busy__read \
    bdw__render_basic__sampler0_busy__read

/* MDAPI testing set Gen9.5 :: GPU Time Elapsed */
#define kblgt2__test_oa__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* MDAPI testing set Gen9.5 :: GPU Core Clocks */
#define kblgt2__test_oa__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* MDAPI testing set Gen9.5 :: AVG GPU Core Frequency */
#define kblgt2__test_oa__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* MDAPI testing set Gen9.5 :: AVG GPU Core Frequency */
#define kblgt2__test_oa__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* MDAPI testing set Gen9.5 :: TestCounter0 */
#define kblgt2__test_oa__counter0__read \
    hsw__compute_extended__eu_untyped_reads0__read

/* MDAPI testing set Gen9.5 :: TestCounter1 */
#define kblgt2__test_oa__counter1__read \
    hsw__compute_extended__eu_untyped_writes0__read

/* MDAPI testing set Gen9.5 :: TestCounter2 */
#define kblgt2__test_oa__counter2__read \
    hsw__compute_extended__eu_typed_reads0__read

/* MDAPI testing set Gen9.5 :: TestCounter3 */
#define kblgt2__test_oa__counter3__read \
    hsw__compute_extended__eu_typed_writes0__read

/* MDAPI testing set Gen9.5 :: TestCounter4 */
#define kblgt2__test_oa__counter4__read \
    hsw__compute_extended__eu_untyped_atomics0__read

/* MDAPI testing set Gen9.5 :: TestCounter5 */
#define kblgt2__test_oa__counter5__read \
    hsw__compute_extended__eu_typed_atomics0__read

/* MDAPI testing set Gen9.5 :: TestCounter6 */
#define kblgt2__test_oa__counter6__read \
    hsw__compute_extended__eu_urb_atomics0__read

/* MDAPI testing set Gen9.5 :: TestCounter7 */
#define kblgt2__test_oa__counter7__read \
    hsw__compute_extended__gpu_clocks__read

/* MDAPI testing set Gen9.5 :: TestCounter8 */
#define kblgt2__test_oa__counter8__read \
    hsw__memory_reads__gpu_core_clocks__read

/* Metric set PMA Stall :: GPU Time Elapsed */
#define kblgt2__pma__stall__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set PMA Stall :: GPU Core Clocks */
#define kblgt2__pma__stall__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set PMA Stall :: AVG GPU Core Frequency */
#define kblgt2__pma__stall__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set PMA Stall :: AVG GPU Core Frequency */
#define kblgt2__pma__stall__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set PMA Stall :: STC PMA stall */
#define kblgt2__pma__stall__stc_pma_stall__read \
    sklgt2__pma__stall__stc_pma_stall__read

/* Render Metrics Basic Gen9 :: GPU Time Elapsed */
#define kblgt3__render_basic__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Render Metrics Basic Gen9 :: GPU Core Clocks */
#define kblgt3__render_basic__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Render Metrics Basic Gen9 :: AVG GPU Core Frequency */
#define kblgt3__render_basic__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Render Metrics Basic Gen9 :: AVG GPU Core Frequency */
#define kblgt3__render_basic__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Render Metrics Basic Gen9 :: VS Threads Dispatched */
#define kblgt3__render_basic__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Render Metrics Basic Gen9 :: HS Threads Dispatched */
#define kblgt3__render_basic__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Render Metrics Basic Gen9 :: DS Threads Dispatched */
#define kblgt3__render_basic__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Render Metrics Basic Gen9 :: GS Threads Dispatched */
#define kblgt3__render_basic__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Render Metrics Basic Gen9 :: FS Threads Dispatched */
#define kblgt3__render_basic__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Render Metrics Basic Gen9 :: CS Threads Dispatched */
#define kblgt3__render_basic__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Render Metrics Basic Gen9 :: GPU Busy */
#define kblgt3__render_basic__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Render Metrics Basic Gen9 :: EU Active */
#define kblgt3__render_basic__eu_active__read \
    bdw__render_basic__eu_active__read

/* Render Metrics Basic Gen9 :: EU Stall */
#define kblgt3__render_basic__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Render Metrics Basic Gen9 :: EU Both FPU Pipes Active */
#define kblgt3__render_basic__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Render Metrics Basic Gen9 :: VS FPU0 Pipe Active */
#define kblgt3__render_basic__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Render Metrics Basic Gen9 :: VS FPU1 Pipe Active */
#define kblgt3__render_basic__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Render Metrics Basic Gen9 :: VS Send Pipe Active */
#define kblgt3__render_basic__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Render Metrics Basic Gen9 :: PS FPU0 Pipe Active */
#define kblgt3__render_basic__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Render Metrics Basic Gen9 :: PS FPU1 Pipe Active */
#define kblgt3__render_basic__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Render Metrics Basic Gen9 :: PS Send Pipeline Active */
#define kblgt3__render_basic__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Render Metrics Basic Gen9 :: FS Both FPU Active */
#define kblgt3__render_basic__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Render Metrics Basic Gen9 :: Sampler 0 Busy */
#define kblgt3__render_basic__sampler0_busy__read \
    bdw__render_basic__sampler0_busy__read

/* Render Metrics Basic Gen9 :: Sampler 1 Busy */
#define kblgt3__render_basic__sampler1_busy__read \
    bdw__render_basic__sampler1_busy__read

/* Render Metrics Basic Gen9 :: Samplers Busy */
#define kblgt3__render_basic__samplers_busy__read \
    bdw__render_basic__samplers_busy__read

/* Render Metrics Basic Gen9 :: Sampler 0 Bottleneck */
#define kblgt3__render_basic__sampler0_bottleneck__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Render Metrics Basic Gen9 :: Sampler 1 Bottleneck */
#define kblgt3__render_basic__sampler1_bottleneck__read \
    bdw__render_basic__sampler1_bottleneck__read

/* Render Metrics Basic Gen9 :: Rasterized Pixels */
#define kblgt3__render_basic__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Render Metrics Basic Gen9 :: Early Hi-Depth Test Fails */
#define kblgt3__render_basic__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Render Metrics Basic Gen9 :: Early Depth Test Fails */
#define kblgt3__render_basic__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Render Metrics Basic Gen9 :: Samples Killed in FS */
#define kblgt3__render_basic__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Render Metrics Basic Gen9 :: Pixels Failing Tests */
#define kblgt3__render_basic__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Render Metrics Basic Gen9 :: Samples Written */
#define kblgt3__render_basic__samples_written__read \
    bdw__render_basic__samples_written__read

/* Render Metrics Basic Gen9 :: Samples Blended */
#define kblgt3__render_basic__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Render Metrics Basic Gen9 :: Sampler Texels */
#define kblgt3__render_basic__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Render Metrics Basic Gen9 :: Sampler Texels Misses */
#define kblgt3__render_basic__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Render Metrics Basic Gen9 :: Sampler Cache Misses */
#define kblgt3__render_basic__sampler_l1_misses__read \
    bdw__render_basic__sampler_l1_misses__read

/* Render Metrics Basic Gen9 :: SLM Bytes Read */
#define kblgt3__render_basic__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Render Metrics Basic Gen9 :: SLM Bytes Read */
#define kblgt3__render_basic__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics Basic Gen9 :: SLM Bytes Written */
#define kblgt3__render_basic__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Render Metrics Basic Gen9 :: SLM Bytes Written */
#define kblgt3__render_basic__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics Basic Gen9 :: Shader Memory Accesses */
#define kblgt3__render_basic__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Render Metrics Basic Gen9 :: Shader Atomic Memory Accesses */
#define kblgt3__render_basic__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Render Metrics Basic Gen9 :: L3 Lookup Accesses w/o IC */
#define kblgt3__render_basic__l3_lookups__read \
    bdw__render_basic__l3_lookups__read

/* Render Metrics Basic Gen9 :: L3 Misses */
#define kblgt3__render_basic__l3_misses__read \
    hsw__compute_extended__typed_atomics0__read

/* Render Metrics Basic Gen9 :: L3 Sampler Throughput */
#define kblgt3__render_basic__l3_sampler_throughput__read \
    bdw__render_basic__l3_sampler_throughput__read

/* Render Metrics Basic Gen9 :: L3 Sampler Throughput */
#define kblgt3__render_basic__l3_sampler_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics Basic Gen9 :: L3 Shader Throughput */
#define kblgt3__render_basic__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Render Metrics Basic Gen9 :: L3 Shader Throughput */
#define kblgt3__render_basic__l3_shader_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics Basic Gen9 :: Shader Barrier Messages */
#define kblgt3__render_basic__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Render Metrics Basic Gen9 :: GTI Fixed Pipe Throughput */
#define kblgt3__render_basic__gti_vf_throughput__read \
    bdw__render_basic__gti_vf_throughput__read

/* Render Metrics Basic Gen9 :: GTI Fixed Pipe Throughput */
#define kblgt3__render_basic__gti_vf_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Render Metrics Basic Gen9 :: GTI Depth Throughput */
#define kblgt3__render_basic__gti_depth_throughput__read \
    bdw__render_basic__gti_depth_throughput__read

/* Render Metrics Basic Gen9 :: GTI Depth Throughput */
#define kblgt3__render_basic__gti_depth_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics Basic Gen9 :: GTI RCC Throughput */
#define kblgt3__render_basic__gti_rcc_throughput__read \
    bdw__render_basic__gti_rcc_throughput__read

/* Render Metrics Basic Gen9 :: GTI RCC Throughput */
#define kblgt3__render_basic__gti_rcc_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics Basic Gen9 :: GTI L3 Throughput */
#define kblgt3__render_basic__gti_l3_throughput__read \
    hsw__render_basic__gti_l3_throughput__read

/* Render Metrics Basic Gen9 :: GTI L3 Throughput */
#define kblgt3__render_basic__gti_l3_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics Basic Gen9 :: GTI HDC TLB Lookup Throughput */
#define kblgt3__render_basic__gti_hdc_lookups_throughput__read \
    bdw__render_basic__gti_hdc_lookups_throughput__read

/* Render Metrics Basic Gen9 :: GTI HDC TLB Lookup Throughput */
#define kblgt3__render_basic__gti_hdc_lookups_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics Basic Gen9 :: GTI Read Throughput */
#define kblgt3__render_basic__gti_read_throughput__read \
    bdw__render_basic__gti_read_throughput__read

/* Render Metrics Basic Gen9 :: GTI Read Throughput */
#define kblgt3__render_basic__gti_read_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Render Metrics Basic Gen9 :: GTI Write Throughput */
#define kblgt3__render_basic__gti_write_throughput__read \
    hsw__render_basic__gti_write_throughput__read

/* Render Metrics Basic Gen9 :: GTI Write Throughput */
#define kblgt3__render_basic__gti_write_throughput__max \
    bdw__render_basic__gti_write_throughput__max

/* Render Metrics Basic Gen9 :: Samplers Bottleneck */
#define kblgt3__render_basic__sampler_bottleneck__read \
    bdw__render_basic__sampler_bottleneck__read

/* Compute Metrics Basic Gen9 :: GPU Time Elapsed */
#define kblgt3__compute_basic__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Compute Metrics Basic Gen9 :: GPU Core Clocks */
#define kblgt3__compute_basic__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Compute Metrics Basic Gen9 :: AVG GPU Core Frequency */
#define kblgt3__compute_basic__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Compute Metrics Basic Gen9 :: AVG GPU Core Frequency */
#define kblgt3__compute_basic__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Compute Metrics Basic Gen9 :: GPU Busy */
#define kblgt3__compute_basic__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Compute Metrics Basic Gen9 :: VS Threads Dispatched */
#define kblgt3__compute_basic__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Compute Metrics Basic Gen9 :: HS Threads Dispatched */
#define kblgt3__compute_basic__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Compute Metrics Basic Gen9 :: DS Threads Dispatched */
#define kblgt3__compute_basic__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Compute Metrics Basic Gen9 :: GS Threads Dispatched */
#define kblgt3__compute_basic__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Compute Metrics Basic Gen9 :: FS Threads Dispatched */
#define kblgt3__compute_basic__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Compute Metrics Basic Gen9 :: CS Threads Dispatched */
#define kblgt3__compute_basic__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Compute Metrics Basic Gen9 :: EU Active */
#define kblgt3__compute_basic__eu_active__read \
    bdw__render_basic__eu_active__read

/* Compute Metrics Basic Gen9 :: EU Stall */
#define kblgt3__compute_basic__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Compute Metrics Basic Gen9 :: EU Both FPU Pipes Active */
#define kblgt3__compute_basic__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Compute Metrics Basic Gen9 :: EU FPU0 Pipe Active */
#define kblgt3__compute_basic__fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Compute Metrics Basic Gen9 :: EU FPU1 Pipe Active */
#define kblgt3__compute_basic__fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Compute Metrics Basic Gen9 :: EU AVG IPC Rate */
#define kblgt3__compute_basic__eu_avg_ipc_rate__read \
    bdw__compute_basic__eu_avg_ipc_rate__read

/* Compute Metrics Basic Gen9 :: EU AVG IPC Rate */
#define kblgt3__compute_basic__eu_avg_ipc_rate__max \
    bdw__compute_basic__eu_avg_ipc_rate__max

/* Compute Metrics Basic Gen9 :: EU Send Pipe Active */
#define kblgt3__compute_basic__eu_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Compute Metrics Basic Gen9 :: EU Thread Occupancy */
#define kblgt3__compute_basic__eu_thread_occupancy__read \
    bdw__compute_basic__eu_thread_occupancy__read

/* Compute Metrics Basic Gen9 :: Rasterized Pixels */
#define kblgt3__compute_basic__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Compute Metrics Basic Gen9 :: Early Hi-Depth Test Fails */
#define kblgt3__compute_basic__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Compute Metrics Basic Gen9 :: Early Depth Test Fails */
#define kblgt3__compute_basic__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Compute Metrics Basic Gen9 :: Samples Killed in FS */
#define kblgt3__compute_basic__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Compute Metrics Basic Gen9 :: Pixels Failing Tests */
#define kblgt3__compute_basic__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Compute Metrics Basic Gen9 :: Samples Written */
#define kblgt3__compute_basic__samples_written__read \
    bdw__render_basic__samples_written__read

/* Compute Metrics Basic Gen9 :: Samples Blended */
#define kblgt3__compute_basic__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Compute Metrics Basic Gen9 :: Sampler Texels */
#define kblgt3__compute_basic__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Compute Metrics Basic Gen9 :: Sampler Texels Misses */
#define kblgt3__compute_basic__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Compute Metrics Basic Gen9 :: SLM Bytes Read */
#define kblgt3__compute_basic__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Compute Metrics Basic Gen9 :: SLM Bytes Read */
#define kblgt3__compute_basic__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Basic Gen9 :: SLM Bytes Written */
#define kblgt3__compute_basic__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Compute Metrics Basic Gen9 :: SLM Bytes Written */
#define kblgt3__compute_basic__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Basic Gen9 :: Shader Memory Accesses */
#define kblgt3__compute_basic__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Compute Metrics Basic Gen9 :: Shader Atomic Memory Accesses */
#define kblgt3__compute_basic__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Compute Metrics Basic Gen9 :: L3 Shader Throughput */
#define kblgt3__compute_basic__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Compute Metrics Basic Gen9 :: L3 Shader Throughput */
#define kblgt3__compute_basic__l3_shader_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen9 :: Shader Barrier Messages */
#define kblgt3__compute_basic__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Compute Metrics Basic Gen9 :: Typed Bytes Read */
#define kblgt3__compute_basic__typed_bytes_read__read \
    bdw__compute_basic__typed_bytes_read__read

/* Compute Metrics Basic Gen9 :: Typed Bytes Read */
#define kblgt3__compute_basic__typed_bytes_read__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen9 :: Typed Bytes Written */
#define kblgt3__compute_basic__typed_bytes_written__read \
    bdw__compute_basic__typed_bytes_written__read

/* Compute Metrics Basic Gen9 :: Typed Bytes Written */
#define kblgt3__compute_basic__typed_bytes_written__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen9 :: Untyped Bytes Read */
#define kblgt3__compute_basic__untyped_bytes_read__read \
    bdw__compute_basic__untyped_bytes_read__read

/* Compute Metrics Basic Gen9 :: Untyped Bytes Read */
#define kblgt3__compute_basic__untyped_bytes_read__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen9 :: Untyped Writes */
#define kblgt3__compute_basic__untyped_bytes_written__read \
    bdw__compute_basic__untyped_bytes_written__read

/* Compute Metrics Basic Gen9 :: Untyped Writes */
#define kblgt3__compute_basic__untyped_bytes_written__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen9 :: GTI Read Throughput */
#define kblgt3__compute_basic__gti_read_throughput__read \
    hsw__render_basic__gti_l3_throughput__read

/* Compute Metrics Basic Gen9 :: GTI Read Throughput */
#define kblgt3__compute_basic__gti_read_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen9 :: GTI Write Throughput */
#define kblgt3__compute_basic__gti_write_throughput__read \
    bdw__render_basic__gti_hdc_lookups_throughput__read

/* Compute Metrics Basic Gen9 :: GTI Write Throughput */
#define kblgt3__compute_basic__gti_write_throughput__max \
    bdw__render_basic__gti_write_throughput__max

/* Render Metrics for 3D Pipeline Profile Gen9 :: GPU Time Elapsed */
#define kblgt3__render_pipe_profile__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: GPU Core Clocks */
#define kblgt3__render_pipe_profile__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: AVG GPU Core Frequency */
#define kblgt3__render_pipe_profile__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: AVG GPU Core Frequency */
#define kblgt3__render_pipe_profile__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Render Metrics for 3D Pipeline Profile Gen9 :: GPU Busy */
#define kblgt3__render_pipe_profile__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: VS Threads Dispatched */
#define kblgt3__render_pipe_profile__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: HS Threads Dispatched */
#define kblgt3__render_pipe_profile__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: DS Threads Dispatched */
#define kblgt3__render_pipe_profile__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: GS Threads Dispatched */
#define kblgt3__render_pipe_profile__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: FS Threads Dispatched */
#define kblgt3__render_pipe_profile__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: CS Threads Dispatched */
#define kblgt3__render_pipe_profile__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: EU Active */
#define kblgt3__render_pipe_profile__eu_active__read \
    bdw__render_basic__eu_active__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: EU Stall */
#define kblgt3__render_pipe_profile__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Rasterized Pixels */
#define kblgt3__render_pipe_profile__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Early Hi-Depth Test Fails */
#define kblgt3__render_pipe_profile__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Early Depth Test Fails */
#define kblgt3__render_pipe_profile__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Samples Killed in FS */
#define kblgt3__render_pipe_profile__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Pixels Failing Tests */
#define kblgt3__render_pipe_profile__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Samples Written */
#define kblgt3__render_pipe_profile__samples_written__read \
    bdw__render_basic__samples_written__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Samples Blended */
#define kblgt3__render_pipe_profile__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Sampler Texels */
#define kblgt3__render_pipe_profile__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Sampler Texels Misses */
#define kblgt3__render_pipe_profile__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: SLM Bytes Read */
#define kblgt3__render_pipe_profile__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: SLM Bytes Read */
#define kblgt3__render_pipe_profile__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics for 3D Pipeline Profile Gen9 :: SLM Bytes Written */
#define kblgt3__render_pipe_profile__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: SLM Bytes Written */
#define kblgt3__render_pipe_profile__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics for 3D Pipeline Profile Gen9 :: Shader Memory Accesses */
#define kblgt3__render_pipe_profile__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Shader Atomic Memory Accesses */
#define kblgt3__render_pipe_profile__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: L3 Shader Throughput */
#define kblgt3__render_pipe_profile__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: L3 Shader Throughput */
#define kblgt3__render_pipe_profile__l3_shader_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics for 3D Pipeline Profile Gen9 :: Shader Barrier Messages */
#define kblgt3__render_pipe_profile__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: VF Bottleneck */
#define kblgt3__render_pipe_profile__vf_bottleneck__read \
    bdw__render_pipe_profile__vf_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: VS Bottleneck */
#define kblgt3__render_pipe_profile__vs_bottleneck__read \
    bdw__render_basic__sampler0_busy__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: HS Bottleneck */
#define kblgt3__render_pipe_profile__hs_bottleneck__read \
    bdw__render_basic__sampler1_busy__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: DS Bottleneck */
#define kblgt3__render_pipe_profile__ds_bottleneck__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: GS Bottleneck */
#define kblgt3__render_pipe_profile__gs_bottleneck__read \
    bdw__render_basic__sampler1_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: SO Bottleneck */
#define kblgt3__render_pipe_profile__so_bottleneck__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Clipper Bottleneck */
#define kblgt3__render_pipe_profile__cl_bottleneck__read \
    bdw__render_pipe_profile__cl_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Strip-Fans Bottleneck */
#define kblgt3__render_pipe_profile__sf_bottleneck__read \
    bdw__render_pipe_profile__sf_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Hi-Depth Bottleneck */
#define kblgt3__render_pipe_profile__hi_depth_bottleneck__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Early Depth Bottleneck */
#define kblgt3__render_pipe_profile__early_depth_bottleneck__read \
    bdw__render_pipe_profile__early_depth_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: BC Bottleneck */
#define kblgt3__render_pipe_profile__bc_bottleneck__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: HS Stall */
#define kblgt3__render_pipe_profile__hs_stall__read \
    bdw__render_pipe_profile__hs_stall__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: DS Stall */
#define kblgt3__render_pipe_profile__ds_stall__read \
    bdw__render_pipe_profile__ds_stall__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: SO Stall */
#define kblgt3__render_pipe_profile__so_stall__read \
    bdw__render_pipe_profile__so_stall__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: CL Stall */
#define kblgt3__render_pipe_profile__cl_stall__read \
    bdw__render_pipe_profile__cl_stall__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: SF Stall */
#define kblgt3__render_pipe_profile__sf_stall__read \
    bdw__render_pipe_profile__sf_stall__read

/* Memory Reads Distribution Gen9 :: GPU Time Elapsed */
#define kblgt3__memory_reads__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Memory Reads Distribution Gen9 :: GPU Core Clocks */
#define kblgt3__memory_reads__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Memory Reads Distribution Gen9 :: AVG GPU Core Frequency */
#define kblgt3__memory_reads__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Memory Reads Distribution Gen9 :: AVG GPU Core Frequency */
#define kblgt3__memory_reads__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Memory Reads Distribution Gen9 :: GPU Busy */
#define kblgt3__memory_reads__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Memory Reads Distribution Gen9 :: VS Threads Dispatched */
#define kblgt3__memory_reads__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Memory Reads Distribution Gen9 :: HS Threads Dispatched */
#define kblgt3__memory_reads__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Memory Reads Distribution Gen9 :: DS Threads Dispatched */
#define kblgt3__memory_reads__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Memory Reads Distribution Gen9 :: GS Threads Dispatched */
#define kblgt3__memory_reads__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Memory Reads Distribution Gen9 :: FS Threads Dispatched */
#define kblgt3__memory_reads__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Memory Reads Distribution Gen9 :: CS Threads Dispatched */
#define kblgt3__memory_reads__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Memory Reads Distribution Gen9 :: EU Active */
#define kblgt3__memory_reads__eu_active__read \
    bdw__render_basic__eu_active__read

/* Memory Reads Distribution Gen9 :: EU Stall */
#define kblgt3__memory_reads__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Memory Reads Distribution Gen9 :: Rasterized Pixels */
#define kblgt3__memory_reads__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Memory Reads Distribution Gen9 :: Early Hi-Depth Test Fails */
#define kblgt3__memory_reads__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Memory Reads Distribution Gen9 :: Early Depth Test Fails */
#define kblgt3__memory_reads__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Memory Reads Distribution Gen9 :: Samples Killed in FS */
#define kblgt3__memory_reads__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Memory Reads Distribution Gen9 :: Pixels Failing Tests */
#define kblgt3__memory_reads__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Memory Reads Distribution Gen9 :: Samples Written */
#define kblgt3__memory_reads__samples_written__read \
    bdw__render_basic__samples_written__read

/* Memory Reads Distribution Gen9 :: Samples Blended */
#define kblgt3__memory_reads__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Memory Reads Distribution Gen9 :: Sampler Texels */
#define kblgt3__memory_reads__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Memory Reads Distribution Gen9 :: Sampler Texels Misses */
#define kblgt3__memory_reads__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Memory Reads Distribution Gen9 :: SLM Bytes Read */
#define kblgt3__memory_reads__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Memory Reads Distribution Gen9 :: SLM Bytes Read */
#define kblgt3__memory_reads__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Memory Reads Distribution Gen9 :: SLM Bytes Written */
#define kblgt3__memory_reads__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Memory Reads Distribution Gen9 :: SLM Bytes Written */
#define kblgt3__memory_reads__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Memory Reads Distribution Gen9 :: Shader Memory Accesses */
#define kblgt3__memory_reads__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Memory Reads Distribution Gen9 :: Shader Atomic Memory Accesses */
#define kblgt3__memory_reads__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Memory Reads Distribution Gen9 :: Shader Barrier Messages */
#define kblgt3__memory_reads__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Memory Reads Distribution Gen9 :: GtiCmdStreamerMemoryReads */
#define kblgt3__memory_reads__gti_cmd_streamer_memory_reads__read \
    hsw__compute_extended__eu_untyped_reads0__read

/* Memory Reads Distribution Gen9 :: GtiRsMemoryReads */
#define kblgt3__memory_reads__gti_rs_memory_reads__read \
    hsw__compute_extended__eu_typed_reads0__read

/* Memory Reads Distribution Gen9 :: GtiVfMemoryReads */
#define kblgt3__memory_reads__gti_vf_memory_reads__read \
    hsw__compute_extended__eu_untyped_writes0__read

/* Memory Reads Distribution Gen9 :: GtiRccMemoryReads */
#define kblgt3__memory_reads__gti_rcc_memory_reads__read \
    hsw__compute_extended__eu_typed_writes0__read

/* Memory Reads Distribution Gen9 :: GtiMscMemoryReads */
#define kblgt3__memory_reads__gti_msc_memory_reads__read \
    hsw__compute_extended__eu_untyped_atomics0__read

/* Memory Reads Distribution Gen9 :: GtiHizMemoryReads */
#define kblgt3__memory_reads__gti_hiz_memory_reads__read \
    hsw__compute_extended__eu_typed_atomics0__read

/* Memory Reads Distribution Gen9 :: GtiStcMemoryReads */
#define kblgt3__memory_reads__gti_stc_memory_reads__read \
    hsw__compute_extended__eu_urb_atomics0__read

/* Memory Reads Distribution Gen9 :: GtiRczMemoryReads */
#define kblgt3__memory_reads__gti_rcz_memory_reads__read \
    hsw__compute_extended__gpu_clocks__read

/* Memory Reads Distribution Gen9 :: GtiMemoryReads */
#define kblgt3__memory_reads__gti_memory_reads__read \
    hsw__compute_extended__typed_writes0__read

/* Memory Reads Distribution Gen9 :: GtiL3Bank0Reads */
#define kblgt3__memory_reads__gti_l3_bank0_reads__read \
    hsw__compute_extended__typed_atomics0__read

/* Memory Reads Distribution Gen9 :: GtiL3Bank1Reads */
#define kblgt3__memory_reads__gti_l3_bank1_reads__read \
    hsw__memory_reads__gti_memory_reads__read

/* Memory Reads Distribution Gen9 :: GtiL3Bank2Reads */
#define kblgt3__memory_reads__gti_l3_bank2_reads__read \
    hsw__memory_reads__llc_read_accesses__read

/* Memory Reads Distribution Gen9 :: GtiL3Bank3Reads */
#define kblgt3__memory_reads__gti_l3_bank3_reads__read \
    hsw__memory_reads__gpu_core_clocks__read

/* Memory Reads Distribution Gen9 :: GtiL3Reads */
#define kblgt3__memory_reads__gti_l3_reads__read \
    bdw__memory_reads__gti_l3_reads__read

/* Memory Reads Distribution Gen9 :: GtiRingAccesses */
#define kblgt3__memory_reads__gti_ring_accesses__read \
    bdw__memory_reads__gti_ring_accesses__read

/* Memory Writes Distribution Gen9 :: GPU Time Elapsed */
#define kblgt3__memory_writes__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Memory Writes Distribution Gen9 :: GPU Core Clocks */
#define kblgt3__memory_writes__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Memory Writes Distribution Gen9 :: AVG GPU Core Frequency */
#define kblgt3__memory_writes__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Memory Writes Distribution Gen9 :: AVG GPU Core Frequency */
#define kblgt3__memory_writes__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Memory Writes Distribution Gen9 :: GPU Busy */
#define kblgt3__memory_writes__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Memory Writes Distribution Gen9 :: VS Threads Dispatched */
#define kblgt3__memory_writes__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Memory Writes Distribution Gen9 :: HS Threads Dispatched */
#define kblgt3__memory_writes__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Memory Writes Distribution Gen9 :: DS Threads Dispatched */
#define kblgt3__memory_writes__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Memory Writes Distribution Gen9 :: GS Threads Dispatched */
#define kblgt3__memory_writes__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Memory Writes Distribution Gen9 :: FS Threads Dispatched */
#define kblgt3__memory_writes__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Memory Writes Distribution Gen9 :: CS Threads Dispatched */
#define kblgt3__memory_writes__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Memory Writes Distribution Gen9 :: EU Active */
#define kblgt3__memory_writes__eu_active__read \
    bdw__render_basic__eu_active__read

/* Memory Writes Distribution Gen9 :: EU Stall */
#define kblgt3__memory_writes__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Memory Writes Distribution Gen9 :: Rasterized Pixels */
#define kblgt3__memory_writes__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Memory Writes Distribution Gen9 :: Early Hi-Depth Test Fails */
#define kblgt3__memory_writes__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Memory Writes Distribution Gen9 :: Early Depth Test Fails */
#define kblgt3__memory_writes__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Memory Writes Distribution Gen9 :: Samples Killed in FS */
#define kblgt3__memory_writes__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Memory Writes Distribution Gen9 :: Pixels Failing Tests */
#define kblgt3__memory_writes__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Memory Writes Distribution Gen9 :: Samples Written */
#define kblgt3__memory_writes__samples_written__read \
    bdw__render_basic__samples_written__read

/* Memory Writes Distribution Gen9 :: Samples Blended */
#define kblgt3__memory_writes__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Memory Writes Distribution Gen9 :: Sampler Texels */
#define kblgt3__memory_writes__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Memory Writes Distribution Gen9 :: Sampler Texels Misses */
#define kblgt3__memory_writes__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Memory Writes Distribution Gen9 :: SLM Bytes Read */
#define kblgt3__memory_writes__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Memory Writes Distribution Gen9 :: SLM Bytes Read */
#define kblgt3__memory_writes__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Memory Writes Distribution Gen9 :: SLM Bytes Written */
#define kblgt3__memory_writes__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Memory Writes Distribution Gen9 :: SLM Bytes Written */
#define kblgt3__memory_writes__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Memory Writes Distribution Gen9 :: Shader Memory Accesses */
#define kblgt3__memory_writes__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Memory Writes Distribution Gen9 :: Shader Atomic Memory Accesses */
#define kblgt3__memory_writes__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Memory Writes Distribution Gen9 :: L3 Shader Throughput */
#define kblgt3__memory_writes__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Memory Writes Distribution Gen9 :: L3 Shader Throughput */
#define kblgt3__memory_writes__l3_shader_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Memory Writes Distribution Gen9 :: Shader Barrier Messages */
#define kblgt3__memory_writes__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Memory Writes Distribution Gen9 :: GtiCmdStreamerMemoryWrites */
#define kblgt3__memory_writes__gti_cmd_streamer_memory_writes__read \
    hsw__compute_extended__eu_untyped_reads0__read

/* Memory Writes Distribution Gen9 :: GtiSoMemoryWrites */
#define kblgt3__memory_writes__gti_so_memory_writes__read \
    hsw__compute_extended__eu_typed_reads0__read

/* Memory Writes Distribution Gen9 :: GtiRccMemoryWrites */
#define kblgt3__memory_writes__gti_rcc_memory_writes__read \
    hsw__compute_extended__eu_typed_writes0__read

/* Memory Writes Distribution Gen9 :: GtiMscMemoryWrites */
#define kblgt3__memory_writes__gti_msc_memory_writes__read \
    hsw__compute_extended__eu_untyped_atomics0__read

/* Memory Writes Distribution Gen9 :: GtiHizMemoryWrites */
#define kblgt3__memory_writes__gti_hiz_memory_writes__read \
    hsw__compute_extended__eu_typed_atomics0__read

/* Memory Writes Distribution Gen9 :: GtiStcMemoryWrites */
#define kblgt3__memory_writes__gti_stc_memory_writes__read \
    hsw__compute_extended__eu_urb_atomics0__read

/* Memory Writes Distribution Gen9 :: GtiRczMemoryWrites */
#define kblgt3__memory_writes__gti_rcz_memory_writes__read \
    hsw__compute_extended__gpu_clocks__read

/* Memory Writes Distribution Gen9 :: GtiMemoryWrites */
#define kblgt3__memory_writes__gti_memory_writes__read \
    hsw__compute_extended__typed_writes0__read

/* Memory Writes Distribution Gen9 :: GtiL3Bank0Writes */
#define kblgt3__memory_writes__gti_l3_bank0_writes__read \
    hsw__compute_extended__typed_atomics0__read

/* Memory Writes Distribution Gen9 :: GtiL3Bank1Writes */
#define kblgt3__memory_writes__gti_l3_bank1_writes__read \
    hsw__memory_reads__gti_memory_reads__read

/* Memory Writes Distribution Gen9 :: GtiL3Bank2Writes */
#define kblgt3__memory_writes__gti_l3_bank2_writes__read \
    hsw__memory_reads__llc_read_accesses__read

/* Memory Writes Distribution Gen9 :: GtiL3Bank3Writes */
#define kblgt3__memory_writes__gti_l3_bank3_writes__read \
    hsw__memory_reads__gpu_core_clocks__read

/* Memory Writes Distribution Gen9 :: GtiL3Writes */
#define kblgt3__memory_writes__gti_l3_writes__read \
    bdw__memory_reads__gti_l3_reads__read

/* Memory Writes Distribution Gen9 :: GtiRingAccesses */
#define kblgt3__memory_writes__gti_ring_accesses__read \
    bdw__memory_reads__gti_ring_accesses__read

/* Compute Metrics Extended Gen9 :: GPU Time Elapsed */
#define kblgt3__compute_extended__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Compute Metrics Extended Gen9 :: GPU Core Clocks */
#define kblgt3__compute_extended__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Compute Metrics Extended Gen9 :: AVG GPU Core Frequency */
#define kblgt3__compute_extended__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Compute Metrics Extended Gen9 :: AVG GPU Core Frequency */
#define kblgt3__compute_extended__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Compute Metrics Extended Gen9 :: CS Threads Dispatched */
#define kblgt3__compute_extended__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Compute Metrics Extended Gen9 :: EU Active */
#define kblgt3__compute_extended__eu_active__read \
    bdw__render_basic__eu_active__read

/* Compute Metrics Extended Gen9 :: EU Stall */
#define kblgt3__compute_extended__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Compute Metrics Extended Gen9 :: EU Both FPU Pipes Active */
#define kblgt3__compute_extended__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Compute Metrics Extended Gen9 :: EU FPU0 Pipe Active */
#define kblgt3__compute_extended__fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Compute Metrics Extended Gen9 :: EU FPU1 Pipe Active */
#define kblgt3__compute_extended__fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Compute Metrics Extended Gen9 :: EU AVG IPC Rate */
#define kblgt3__compute_extended__eu_avg_ipc_rate__read \
    bdw__compute_basic__eu_avg_ipc_rate__read

/* Compute Metrics Extended Gen9 :: EU AVG IPC Rate */
#define kblgt3__compute_extended__eu_avg_ipc_rate__max \
    bdw__compute_basic__eu_avg_ipc_rate__max

/* Compute Metrics Extended Gen9 :: EU Send Pipe Active */
#define kblgt3__compute_extended__eu_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Compute Metrics Extended Gen9 :: EU Thread Occupancy */
#define kblgt3__compute_extended__eu_thread_occupancy__read \
    bdw__compute_basic__eu_thread_occupancy__read

/* Compute Metrics Extended Gen9 :: Sampler Texels */
#define kblgt3__compute_extended__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Compute Metrics Extended Gen9 :: Sampler Texels Misses */
#define kblgt3__compute_extended__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Compute Metrics Extended Gen9 :: SLM Bytes Read */
#define kblgt3__compute_extended__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Compute Metrics Extended Gen9 :: SLM Bytes Read */
#define kblgt3__compute_extended__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Extended Gen9 :: SLM Bytes Written */
#define kblgt3__compute_extended__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Compute Metrics Extended Gen9 :: SLM Bytes Written */
#define kblgt3__compute_extended__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Extended Gen9 :: Shader Memory Accesses */
#define kblgt3__compute_extended__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Compute Metrics Extended Gen9 :: Shader Atomic Memory Accesses */
#define kblgt3__compute_extended__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Compute Metrics Extended Gen9 :: L3 Shader Throughput */
#define kblgt3__compute_extended__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Compute Metrics Extended Gen9 :: L3 Shader Throughput */
#define kblgt3__compute_extended__l3_shader_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Extended Gen9 :: Shader Barrier Messages */
#define kblgt3__compute_extended__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Compute Metrics Extended Gen9 :: EuUntypedReads0 */
#define kblgt3__compute_extended__eu_untyped_reads0__read \
    hsw__compute_extended__eu_untyped_reads0__read

/* Compute Metrics Extended Gen9 :: EuTypedReads0 */
#define kblgt3__compute_extended__eu_typed_reads0__read \
    hsw__compute_extended__eu_typed_reads0__read

/* Compute Metrics Extended Gen9 :: EuUntypedWrites0 */
#define kblgt3__compute_extended__eu_untyped_writes0__read \
    hsw__compute_extended__eu_untyped_writes0__read

/* Compute Metrics Extended Gen9 :: EuTypedWrites0 */
#define kblgt3__compute_extended__eu_typed_writes0__read \
    hsw__compute_extended__eu_typed_writes0__read

/* Compute Metrics Extended Gen9 :: EuUntypedAtomics0 */
#define kblgt3__compute_extended__eu_untyped_atomics0__read \
    hsw__compute_extended__eu_untyped_atomics0__read

/* Compute Metrics Extended Gen9 :: EuTypedAtomics0 */
#define kblgt3__compute_extended__eu_typed_atomics0__read \
    hsw__compute_extended__eu_typed_atomics0__read

/* Compute Metrics Extended Gen9 :: EuA64UntypedReads0 */
#define kblgt3__compute_extended__eu_a64_untyped_reads0__read \
    hsw__compute_extended__eu_urb_atomics0__read

/* Compute Metrics Extended Gen9 :: EuA64UntypedWrites0 */
#define kblgt3__compute_extended__eu_a64_untyped_writes0__read \
    hsw__compute_extended__gpu_clocks__read

/* Compute Metrics Extended Gen9 :: Typed Reads 0 */
#define kblgt3__compute_extended__typed_reads0__read \
    hsw__render_basic__gpu_core_clocks__read

/* Compute Metrics Extended Gen9 :: Typed Writes 0 */
#define kblgt3__compute_extended__typed_writes0__read \
    hsw__compute_extended__typed_writes0__read

/* Compute Metrics Extended Gen9 :: Untyped Reads 0 */
#define kblgt3__compute_extended__untyped_reads0__read \
    hsw__compute_extended__untyped_reads0__read

/* Compute Metrics Extended Gen9 :: Untyped Writes 0 */
#define kblgt3__compute_extended__untyped_writes0__read \
    hsw__compute_extended__untyped_writes0__read

/* Compute Metrics Extended Gen9 :: Typed Atomics 0 */
#define kblgt3__compute_extended__typed_atomics0__read \
    hsw__compute_extended__typed_atomics0__read

/* Compute Metrics Extended Gen9 :: TypedReadsPerCacheLine */
#define kblgt3__compute_extended__typed_reads_per_cache_line__read \
    hsw__compute_extended__typed_reads_per_cache_line__read

/* Compute Metrics Extended Gen9 :: TypedWritesPerCacheLine */
#define kblgt3__compute_extended__typed_writes_per_cache_line__read \
    hsw__compute_extended__typed_writes_per_cache_line__read

/* Compute Metrics Extended Gen9 :: UntypedReadsPerCacheLine */
#define kblgt3__compute_extended__untyped_reads_per_cache_line__read \
    bdw__compute_extended__untyped_reads_per_cache_line__read

/* Compute Metrics Extended Gen9 :: UntypedWritesPerCacheLine */
#define kblgt3__compute_extended__untyped_writes_per_cache_line__read \
    bdw__compute_extended__untyped_writes_per_cache_line__read

/* Compute Metrics Extended Gen9 :: TypedAtomicsPerCacheLine */
#define kblgt3__compute_extended__typed_atomics_per_cache_line__read \
    hsw__compute_extended__typed_atomics_per_cache_line__read

/* Compute Metrics L3 Cache Gen9 :: GPU Time Elapsed */
#define kblgt3__compute_l3_cache__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Compute Metrics L3 Cache Gen9 :: GPU Core Clocks */
#define kblgt3__compute_l3_cache__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Compute Metrics L3 Cache Gen9 :: AVG GPU Core Frequency */
#define kblgt3__compute_l3_cache__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Compute Metrics L3 Cache Gen9 :: AVG GPU Core Frequency */
#define kblgt3__compute_l3_cache__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Compute Metrics L3 Cache Gen9 :: GPU Busy */
#define kblgt3__compute_l3_cache__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Compute Metrics L3 Cache Gen9 :: VS Threads Dispatched */
#define kblgt3__compute_l3_cache__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Compute Metrics L3 Cache Gen9 :: HS Threads Dispatched */
#define kblgt3__compute_l3_cache__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Compute Metrics L3 Cache Gen9 :: DS Threads Dispatched */
#define kblgt3__compute_l3_cache__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Compute Metrics L3 Cache Gen9 :: GS Threads Dispatched */
#define kblgt3__compute_l3_cache__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Compute Metrics L3 Cache Gen9 :: FS Threads Dispatched */
#define kblgt3__compute_l3_cache__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Compute Metrics L3 Cache Gen9 :: CS Threads Dispatched */
#define kblgt3__compute_l3_cache__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Compute Metrics L3 Cache Gen9 :: EU Active */
#define kblgt3__compute_l3_cache__eu_active__read \
    bdw__render_basic__eu_active__read

/* Compute Metrics L3 Cache Gen9 :: EU Stall */
#define kblgt3__compute_l3_cache__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Compute Metrics L3 Cache Gen9 :: EU Both FPU Pipes Active */
#define kblgt3__compute_l3_cache__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU0 Pipe Active */
#define kblgt3__compute_l3_cache__fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU1 Pipe Active */
#define kblgt3__compute_l3_cache__fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Compute Metrics L3 Cache Gen9 :: EU AVG IPC Rate */
#define kblgt3__compute_l3_cache__eu_avg_ipc_rate__read \
    bdw__compute_basic__eu_avg_ipc_rate__read

/* Compute Metrics L3 Cache Gen9 :: EU AVG IPC Rate */
#define kblgt3__compute_l3_cache__eu_avg_ipc_rate__max \
    bdw__compute_basic__eu_avg_ipc_rate__max

/* Compute Metrics L3 Cache Gen9 :: EU Send Pipe Active */
#define kblgt3__compute_l3_cache__eu_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU0 Hybrid Instruction */
#define kblgt3__compute_l3_cache__eu_hybrid_fpu0_instruction__read \
    bdw__compute_l3_cache__eu_hybrid_fpu0_instruction__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU1 Hybrid Instruction */
#define kblgt3__compute_l3_cache__eu_hybrid_fpu1_instruction__read \
    bdw__compute_l3_cache__eu_hybrid_fpu1_instruction__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU0 Ternary Instruction */
#define kblgt3__compute_l3_cache__eu_ternary_fpu0_instruction__read \
    bdw__render_basic__ps_fpu0_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU1 Ternary Instruction */
#define kblgt3__compute_l3_cache__eu_ternary_fpu1_instruction__read \
    bdw__render_basic__ps_fpu1_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU0 Binary Instruction */
#define kblgt3__compute_l3_cache__eu_binary_fpu0_instruction__read \
    bdw__render_basic__ps_send_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU1 Binary Instruction */
#define kblgt3__compute_l3_cache__eu_binary_fpu1_instruction__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU0 Move Instruction */
#define kblgt3__compute_l3_cache__eu_move_fpu0_instruction__read \
    bdw__compute_l3_cache__eu_move_fpu0_instruction__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU1 Move Instruction */
#define kblgt3__compute_l3_cache__eu_move_fpu1_instruction__read \
    bdw__compute_l3_cache__eu_move_fpu1_instruction__read

/* Compute Metrics L3 Cache Gen9 :: Rasterized Pixels */
#define kblgt3__compute_l3_cache__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Compute Metrics L3 Cache Gen9 :: Early Hi-Depth Test Fails */
#define kblgt3__compute_l3_cache__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Compute Metrics L3 Cache Gen9 :: Early Depth Test Fails */
#define kblgt3__compute_l3_cache__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Compute Metrics L3 Cache Gen9 :: Samples Killed in FS */
#define kblgt3__compute_l3_cache__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Compute Metrics L3 Cache Gen9 :: Pixels Failing Tests */
#define kblgt3__compute_l3_cache__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Compute Metrics L3 Cache Gen9 :: Samples Written */
#define kblgt3__compute_l3_cache__samples_written__read \
    bdw__render_basic__samples_written__read

/* Compute Metrics L3 Cache Gen9 :: Samples Blended */
#define kblgt3__compute_l3_cache__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Compute Metrics L3 Cache Gen9 :: Sampler Accesses */
#define kblgt3__compute_l3_cache__sampler_accesses__read \
    bdw__render_pipe_profile__sampler_accesses__read

/* Compute Metrics L3 Cache Gen9 :: Sampler Texels */
#define kblgt3__compute_l3_cache__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Compute Metrics L3 Cache Gen9 :: Sampler Texels Misses */
#define kblgt3__compute_l3_cache__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Compute Metrics L3 Cache Gen9 :: SLM Bytes Read */
#define kblgt3__compute_l3_cache__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Compute Metrics L3 Cache Gen9 :: SLM Bytes Read */
#define kblgt3__compute_l3_cache__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics L3 Cache Gen9 :: SLM Bytes Written */
#define kblgt3__compute_l3_cache__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Compute Metrics L3 Cache Gen9 :: SLM Bytes Written */
#define kblgt3__compute_l3_cache__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics L3 Cache Gen9 :: Shader Memory Accesses */
#define kblgt3__compute_l3_cache__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Compute Metrics L3 Cache Gen9 :: Shader Atomic Memory Accesses */
#define kblgt3__compute_l3_cache__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Compute Metrics L3 Cache Gen9 :: L3 Accesses */
#define kblgt3__compute_l3_cache__l3_accesses__read \
    sklgt2__compute_l3_cache__l3_accesses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Misses */
#define kblgt3__compute_l3_cache__l3_misses__read \
    bdw__compute_l3_cache__l3_misses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Sampler Throughput */
#define kblgt3__compute_l3_cache__l3_sampler_throughput__read \
    chv__render_basic__l3_sampler_throughput__read

/* Compute Metrics L3 Cache Gen9 :: L3 Sampler Throughput */
#define kblgt3__compute_l3_cache__l3_sampler_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics L3 Cache Gen9 :: L3 Shader Throughput */
#define kblgt3__compute_l3_cache__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Compute Metrics L3 Cache Gen9 :: L3 Shader Throughput */
#define kblgt3__compute_l3_cache__l3_shader_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics L3 Cache Gen9 :: L3 Total Throughput */
#define kblgt3__compute_l3_cache__l3_total_throughput__read \
    sklgt2__compute_l3_cache__l3_total_throughput__read

/* Compute Metrics L3 Cache Gen9 :: L3 Total Throughput */
#define kblgt3__compute_l3_cache__l3_total_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics L3 Cache Gen9 :: Shader Barrier Messages */
#define kblgt3__compute_l3_cache__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Compute Metrics L3 Cache Gen9 :: L3 Bank 00 Accesses */
#define kblgt3__compute_l3_cache__l3_bank00_accesses__read \
    bdw__compute_l3_cache__l3_bank00_accesses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Bank 01 Accesses */
#define kblgt3__compute_l3_cache__l3_bank01_accesses__read \
    bdw__compute_l3_cache__l3_bank01_accesses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Bank 02 Accesses */
#define kblgt3__compute_l3_cache__l3_bank02_accesses__read \
    bdw__compute_l3_cache__l3_bank02_accesses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Bank 03 Accesses */
#define kblgt3__compute_l3_cache__l3_bank03_accesses__read \
    bdw__compute_l3_cache__l3_bank03_accesses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Bank 00 IC Accesses */
#define kblgt3__compute_l3_cache__l3_bank00_ic_accesses__read \
    bdw__compute_l3_cache__l3_bank00_ic_accesses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Bank 00 IC Hits */
#define kblgt3__compute_l3_cache__l3_bank00_ic_hits__read \
    bdw__compute_l3_cache__l3_bank00_ic_hits__read

/* Compute Metrics L3 Cache Gen9 :: GTI L3 Throughput */
#define kblgt3__compute_l3_cache__gti_l3_throughput__read \
    bdw__compute_l3_cache__gti_l3_throughput__read

/* Compute Metrics L3 Cache Gen9 :: GTI L3 Throughput */
#define kblgt3__compute_l3_cache__gti_l3_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics L3 Cache Gen9 :: GTI Read Throughput */
#define kblgt3__compute_l3_cache__gti_read_throughput__read \
    bdw__render_basic__gti_read_throughput__read

/* Compute Metrics L3 Cache Gen9 :: GTI Read Throughput */
#define kblgt3__compute_l3_cache__gti_read_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Compute Metrics L3 Cache Gen9 :: GTI Write Throughput */
#define kblgt3__compute_l3_cache__gti_write_throughput__read \
    hsw__render_basic__gti_write_throughput__read

/* Compute Metrics L3 Cache Gen9 :: GTI Write Throughput */
#define kblgt3__compute_l3_cache__gti_write_throughput__max \
    bdw__render_basic__gti_write_throughput__max

/* Metric set HDCAndSF :: GPU Time Elapsed */
#define kblgt3__hdc_and_sf__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set HDCAndSF :: GPU Core Clocks */
#define kblgt3__hdc_and_sf__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set HDCAndSF :: AVG GPU Core Frequency */
#define kblgt3__hdc_and_sf__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set HDCAndSF :: AVG GPU Core Frequency */
#define kblgt3__hdc_and_sf__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set HDCAndSF :: GPU Busy */
#define kblgt3__hdc_and_sf__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set HDCAndSF :: VS Threads Dispatched */
#define kblgt3__hdc_and_sf__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set HDCAndSF :: HS Threads Dispatched */
#define kblgt3__hdc_and_sf__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set HDCAndSF :: DS Threads Dispatched */
#define kblgt3__hdc_and_sf__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set HDCAndSF :: GS Threads Dispatched */
#define kblgt3__hdc_and_sf__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set HDCAndSF :: FS Threads Dispatched */
#define kblgt3__hdc_and_sf__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set HDCAndSF :: CS Threads Dispatched */
#define kblgt3__hdc_and_sf__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set HDCAndSF :: EU Active */
#define kblgt3__hdc_and_sf__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set HDCAndSF :: EU Stall */
#define kblgt3__hdc_and_sf__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set HDCAndSF :: EU Both FPU Pipes Active */
#define kblgt3__hdc_and_sf__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set HDCAndSF :: VS FPU0 Pipe Active */
#define kblgt3__hdc_and_sf__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set HDCAndSF :: VS FPU1 Pipe Active */
#define kblgt3__hdc_and_sf__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set HDCAndSF :: VS Send Pipe Active */
#define kblgt3__hdc_and_sf__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set HDCAndSF :: PS FPU0 Pipe Active */
#define kblgt3__hdc_and_sf__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set HDCAndSF :: PS FPU1 Pipe Active */
#define kblgt3__hdc_and_sf__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set HDCAndSF :: PS Send Pipeline Active */
#define kblgt3__hdc_and_sf__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set HDCAndSF :: FS Both FPU Active */
#define kblgt3__hdc_and_sf__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set HDCAndSF :: Rasterized Pixels */
#define kblgt3__hdc_and_sf__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set HDCAndSF :: Early Hi-Depth Test Fails */
#define kblgt3__hdc_and_sf__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set HDCAndSF :: Early Depth Test Fails */
#define kblgt3__hdc_and_sf__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set HDCAndSF :: Samples Killed in FS */
#define kblgt3__hdc_and_sf__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set HDCAndSF :: Pixels Failing Tests */
#define kblgt3__hdc_and_sf__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set HDCAndSF :: Samples Written */
#define kblgt3__hdc_and_sf__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set HDCAndSF :: Samples Blended */
#define kblgt3__hdc_and_sf__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set HDCAndSF :: Sampler Texels */
#define kblgt3__hdc_and_sf__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set HDCAndSF :: Sampler Texels Misses */
#define kblgt3__hdc_and_sf__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set HDCAndSF :: SLM Bytes Read */
#define kblgt3__hdc_and_sf__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set HDCAndSF :: SLM Bytes Read */
#define kblgt3__hdc_and_sf__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set HDCAndSF :: SLM Bytes Written */
#define kblgt3__hdc_and_sf__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set HDCAndSF :: SLM Bytes Written */
#define kblgt3__hdc_and_sf__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set HDCAndSF :: Shader Memory Accesses */
#define kblgt3__hdc_and_sf__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set HDCAndSF :: Shader Atomic Memory Accesses */
#define kblgt3__hdc_and_sf__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set HDCAndSF :: L3 Shader Throughput */
#define kblgt3__hdc_and_sf__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set HDCAndSF :: L3 Shader Throughput */
#define kblgt3__hdc_and_sf__l3_shader_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Metric set HDCAndSF :: Shader Barrier Messages */
#define kblgt3__hdc_and_sf__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set HDCAndSF :: Polygon Data Ready */
#define kblgt3__hdc_and_sf__poly_data_ready__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set HDCAndSF :: HDC stalled by L3 (s0.ss0) */
#define kblgt3__hdc_and_sf__non_sampler_shader00_access_stalled_on_l3__read \
    bdw__hdc_and_sf__non_sampler_shader02_access_stalled_on_l3__read

/* Metric set HDCAndSF :: HDC stalled by L3 (s0.ss1) */
#define kblgt3__hdc_and_sf__non_sampler_shader01_access_stalled_on_l3__read \
    bdw__hdc_and_sf__non_sampler_shader01_access_stalled_on_l3__read

/* Metric set HDCAndSF :: HDC stalled by L3 (s0.ss2) */
#define kblgt3__hdc_and_sf__non_sampler_shader02_access_stalled_on_l3__read \
    bdw__hdc_and_sf__non_sampler_shader00_access_stalled_on_l3__read

/* Metric set HDCAndSF :: SQ is full */
#define kblgt3__hdc_and_sf__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set L3_1 :: GPU Time Elapsed */
#define kblgt3__l3_1__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set L3_1 :: GPU Core Clocks */
#define kblgt3__l3_1__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set L3_1 :: AVG GPU Core Frequency */
#define kblgt3__l3_1__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set L3_1 :: AVG GPU Core Frequency */
#define kblgt3__l3_1__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set L3_1 :: GPU Busy */
#define kblgt3__l3_1__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set L3_1 :: VS Threads Dispatched */
#define kblgt3__l3_1__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set L3_1 :: HS Threads Dispatched */
#define kblgt3__l3_1__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set L3_1 :: DS Threads Dispatched */
#define kblgt3__l3_1__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set L3_1 :: GS Threads Dispatched */
#define kblgt3__l3_1__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set L3_1 :: FS Threads Dispatched */
#define kblgt3__l3_1__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set L3_1 :: CS Threads Dispatched */
#define kblgt3__l3_1__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set L3_1 :: EU Active */
#define kblgt3__l3_1__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set L3_1 :: EU Stall */
#define kblgt3__l3_1__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set L3_1 :: EU Both FPU Pipes Active */
#define kblgt3__l3_1__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set L3_1 :: VS FPU0 Pipe Active */
#define kblgt3__l3_1__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set L3_1 :: VS FPU1 Pipe Active */
#define kblgt3__l3_1__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set L3_1 :: VS Send Pipe Active */
#define kblgt3__l3_1__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set L3_1 :: PS FPU0 Pipe Active */
#define kblgt3__l3_1__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set L3_1 :: PS FPU1 Pipe Active */
#define kblgt3__l3_1__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set L3_1 :: PS Send Pipeline Active */
#define kblgt3__l3_1__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set L3_1 :: FS Both FPU Active */
#define kblgt3__l3_1__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set L3_1 :: Rasterized Pixels */
#define kblgt3__l3_1__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set L3_1 :: Early Hi-Depth Test Fails */
#define kblgt3__l3_1__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set L3_1 :: Early Depth Test Fails */
#define kblgt3__l3_1__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set L3_1 :: Samples Killed in FS */
#define kblgt3__l3_1__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set L3_1 :: Pixels Failing Tests */
#define kblgt3__l3_1__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set L3_1 :: Samples Written */
#define kblgt3__l3_1__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set L3_1 :: Samples Blended */
#define kblgt3__l3_1__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set L3_1 :: Sampler Texels */
#define kblgt3__l3_1__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set L3_1 :: Sampler Texels Misses */
#define kblgt3__l3_1__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set L3_1 :: SLM Bytes Read */
#define kblgt3__l3_1__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set L3_1 :: SLM Bytes Read */
#define kblgt3__l3_1__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_1 :: SLM Bytes Written */
#define kblgt3__l3_1__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set L3_1 :: SLM Bytes Written */
#define kblgt3__l3_1__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_1 :: Shader Memory Accesses */
#define kblgt3__l3_1__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set L3_1 :: Shader Atomic Memory Accesses */
#define kblgt3__l3_1__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set L3_1 :: L3 Shader Throughput */
#define kblgt3__l3_1__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set L3_1 :: L3 Shader Throughput */
#define kblgt3__l3_1__l3_shader_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Metric set L3_1 :: Shader Barrier Messages */
#define kblgt3__l3_1__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set L3_1 :: Slice0 L3 Bank0 Stalled */
#define kblgt3__l3_1__l30_bank0_stalled__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set L3_1 :: Slice0 L3 Bank1 Stalled */
#define kblgt3__l3_1__l30_bank1_stalled__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* Metric set L3_1 :: Slice0 L3 Bank1 Active */
#define kblgt3__l3_1__l30_bank1_active__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set L3_1 :: Slice0 L3 Bank0 Active */
#define kblgt3__l3_1__l30_bank0_active__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set L3_1 :: SQ is full */
#define kblgt3__l3_1__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set L3_2 :: GPU Time Elapsed */
#define kblgt3__l3_2__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set L3_2 :: GPU Core Clocks */
#define kblgt3__l3_2__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set L3_2 :: AVG GPU Core Frequency */
#define kblgt3__l3_2__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set L3_2 :: AVG GPU Core Frequency */
#define kblgt3__l3_2__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set L3_2 :: GPU Busy */
#define kblgt3__l3_2__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set L3_2 :: VS Threads Dispatched */
#define kblgt3__l3_2__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set L3_2 :: HS Threads Dispatched */
#define kblgt3__l3_2__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set L3_2 :: DS Threads Dispatched */
#define kblgt3__l3_2__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set L3_2 :: GS Threads Dispatched */
#define kblgt3__l3_2__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set L3_2 :: FS Threads Dispatched */
#define kblgt3__l3_2__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set L3_2 :: CS Threads Dispatched */
#define kblgt3__l3_2__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set L3_2 :: EU Active */
#define kblgt3__l3_2__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set L3_2 :: EU Stall */
#define kblgt3__l3_2__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set L3_2 :: EU Both FPU Pipes Active */
#define kblgt3__l3_2__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set L3_2 :: VS FPU0 Pipe Active */
#define kblgt3__l3_2__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set L3_2 :: VS FPU1 Pipe Active */
#define kblgt3__l3_2__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set L3_2 :: VS Send Pipe Active */
#define kblgt3__l3_2__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set L3_2 :: PS FPU0 Pipe Active */
#define kblgt3__l3_2__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set L3_2 :: PS FPU1 Pipe Active */
#define kblgt3__l3_2__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set L3_2 :: PS Send Pipeline Active */
#define kblgt3__l3_2__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set L3_2 :: FS Both FPU Active */
#define kblgt3__l3_2__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set L3_2 :: Rasterized Pixels */
#define kblgt3__l3_2__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set L3_2 :: Early Hi-Depth Test Fails */
#define kblgt3__l3_2__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set L3_2 :: Early Depth Test Fails */
#define kblgt3__l3_2__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set L3_2 :: Samples Killed in FS */
#define kblgt3__l3_2__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set L3_2 :: Pixels Failing Tests */
#define kblgt3__l3_2__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set L3_2 :: Samples Written */
#define kblgt3__l3_2__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set L3_2 :: Samples Blended */
#define kblgt3__l3_2__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set L3_2 :: Sampler Texels */
#define kblgt3__l3_2__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set L3_2 :: Sampler Texels Misses */
#define kblgt3__l3_2__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set L3_2 :: SLM Bytes Read */
#define kblgt3__l3_2__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set L3_2 :: SLM Bytes Read */
#define kblgt3__l3_2__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_2 :: SLM Bytes Written */
#define kblgt3__l3_2__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set L3_2 :: SLM Bytes Written */
#define kblgt3__l3_2__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_2 :: Shader Memory Accesses */
#define kblgt3__l3_2__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set L3_2 :: Shader Atomic Memory Accesses */
#define kblgt3__l3_2__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set L3_2 :: L3 Shader Throughput */
#define kblgt3__l3_2__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set L3_2 :: L3 Shader Throughput */
#define kblgt3__l3_2__l3_shader_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Metric set L3_2 :: Shader Barrier Messages */
#define kblgt3__l3_2__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set L3_2 :: Slice0 L3 Bank2 Stalled */
#define kblgt3__l3_2__l30_bank2_stalled__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set L3_2 :: Slice0 L3 Bank2 Active */
#define kblgt3__l3_2__l30_bank2_active__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set L3_2 :: SQ is full */
#define kblgt3__l3_2__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set L3_3 :: GPU Time Elapsed */
#define kblgt3__l3_3__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set L3_3 :: GPU Core Clocks */
#define kblgt3__l3_3__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set L3_3 :: AVG GPU Core Frequency */
#define kblgt3__l3_3__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set L3_3 :: AVG GPU Core Frequency */
#define kblgt3__l3_3__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set L3_3 :: GPU Busy */
#define kblgt3__l3_3__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set L3_3 :: VS Threads Dispatched */
#define kblgt3__l3_3__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set L3_3 :: HS Threads Dispatched */
#define kblgt3__l3_3__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set L3_3 :: DS Threads Dispatched */
#define kblgt3__l3_3__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set L3_3 :: GS Threads Dispatched */
#define kblgt3__l3_3__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set L3_3 :: FS Threads Dispatched */
#define kblgt3__l3_3__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set L3_3 :: CS Threads Dispatched */
#define kblgt3__l3_3__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set L3_3 :: EU Active */
#define kblgt3__l3_3__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set L3_3 :: EU Stall */
#define kblgt3__l3_3__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set L3_3 :: EU Both FPU Pipes Active */
#define kblgt3__l3_3__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set L3_3 :: VS FPU0 Pipe Active */
#define kblgt3__l3_3__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set L3_3 :: VS FPU1 Pipe Active */
#define kblgt3__l3_3__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set L3_3 :: VS Send Pipe Active */
#define kblgt3__l3_3__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set L3_3 :: PS FPU0 Pipe Active */
#define kblgt3__l3_3__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set L3_3 :: PS FPU1 Pipe Active */
#define kblgt3__l3_3__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set L3_3 :: PS Send Pipeline Active */
#define kblgt3__l3_3__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set L3_3 :: FS Both FPU Active */
#define kblgt3__l3_3__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set L3_3 :: Rasterized Pixels */
#define kblgt3__l3_3__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set L3_3 :: Early Hi-Depth Test Fails */
#define kblgt3__l3_3__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set L3_3 :: Early Depth Test Fails */
#define kblgt3__l3_3__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set L3_3 :: Samples Killed in FS */
#define kblgt3__l3_3__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set L3_3 :: Pixels Failing Tests */
#define kblgt3__l3_3__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set L3_3 :: Samples Written */
#define kblgt3__l3_3__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set L3_3 :: Samples Blended */
#define kblgt3__l3_3__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set L3_3 :: Sampler Texels */
#define kblgt3__l3_3__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set L3_3 :: Sampler Texels Misses */
#define kblgt3__l3_3__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set L3_3 :: SLM Bytes Read */
#define kblgt3__l3_3__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set L3_3 :: SLM Bytes Read */
#define kblgt3__l3_3__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_3 :: SLM Bytes Written */
#define kblgt3__l3_3__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set L3_3 :: SLM Bytes Written */
#define kblgt3__l3_3__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_3 :: Shader Memory Accesses */
#define kblgt3__l3_3__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set L3_3 :: Shader Atomic Memory Accesses */
#define kblgt3__l3_3__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set L3_3 :: L3 Shader Throughput */
#define kblgt3__l3_3__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set L3_3 :: L3 Shader Throughput */
#define kblgt3__l3_3__l3_shader_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Metric set L3_3 :: Shader Barrier Messages */
#define kblgt3__l3_3__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set L3_3 :: Slice0 L3 Bank3 Stalled */
#define kblgt3__l3_3__l30_bank3_stalled__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set L3_3 :: Slice0 L3 Bank3 Active */
#define kblgt3__l3_3__l30_bank3_active__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set L3_3 :: SQ is full */
#define kblgt3__l3_3__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set RasterizerAndPixelBackend :: GPU Time Elapsed */
#define kblgt3__rasterizer_and_pixel_backend__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set RasterizerAndPixelBackend :: GPU Core Clocks */
#define kblgt3__rasterizer_and_pixel_backend__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set RasterizerAndPixelBackend :: AVG GPU Core Frequency */
#define kblgt3__rasterizer_and_pixel_backend__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set RasterizerAndPixelBackend :: AVG GPU Core Frequency */
#define kblgt3__rasterizer_and_pixel_backend__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set RasterizerAndPixelBackend :: GPU Busy */
#define kblgt3__rasterizer_and_pixel_backend__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set RasterizerAndPixelBackend :: VS Threads Dispatched */
#define kblgt3__rasterizer_and_pixel_backend__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set RasterizerAndPixelBackend :: HS Threads Dispatched */
#define kblgt3__rasterizer_and_pixel_backend__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set RasterizerAndPixelBackend :: DS Threads Dispatched */
#define kblgt3__rasterizer_and_pixel_backend__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set RasterizerAndPixelBackend :: GS Threads Dispatched */
#define kblgt3__rasterizer_and_pixel_backend__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set RasterizerAndPixelBackend :: FS Threads Dispatched */
#define kblgt3__rasterizer_and_pixel_backend__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set RasterizerAndPixelBackend :: CS Threads Dispatched */
#define kblgt3__rasterizer_and_pixel_backend__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set RasterizerAndPixelBackend :: EU Active */
#define kblgt3__rasterizer_and_pixel_backend__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set RasterizerAndPixelBackend :: EU Stall */
#define kblgt3__rasterizer_and_pixel_backend__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set RasterizerAndPixelBackend :: EU Both FPU Pipes Active */
#define kblgt3__rasterizer_and_pixel_backend__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set RasterizerAndPixelBackend :: VS FPU0 Pipe Active */
#define kblgt3__rasterizer_and_pixel_backend__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set RasterizerAndPixelBackend :: VS FPU1 Pipe Active */
#define kblgt3__rasterizer_and_pixel_backend__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set RasterizerAndPixelBackend :: VS Send Pipe Active */
#define kblgt3__rasterizer_and_pixel_backend__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set RasterizerAndPixelBackend :: PS FPU0 Pipe Active */
#define kblgt3__rasterizer_and_pixel_backend__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set RasterizerAndPixelBackend :: PS FPU1 Pipe Active */
#define kblgt3__rasterizer_and_pixel_backend__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set RasterizerAndPixelBackend :: PS Send Pipeline Active */
#define kblgt3__rasterizer_and_pixel_backend__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set RasterizerAndPixelBackend :: FS Both FPU Active */
#define kblgt3__rasterizer_and_pixel_backend__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set RasterizerAndPixelBackend :: Rasterized Pixels */
#define kblgt3__rasterizer_and_pixel_backend__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set RasterizerAndPixelBackend :: Early Hi-Depth Test Fails */
#define kblgt3__rasterizer_and_pixel_backend__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set RasterizerAndPixelBackend :: Early Depth Test Fails */
#define kblgt3__rasterizer_and_pixel_backend__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set RasterizerAndPixelBackend :: Samples Killed in FS */
#define kblgt3__rasterizer_and_pixel_backend__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set RasterizerAndPixelBackend :: Pixels Failing Tests */
#define kblgt3__rasterizer_and_pixel_backend__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set RasterizerAndPixelBackend :: Samples Written */
#define kblgt3__rasterizer_and_pixel_backend__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set RasterizerAndPixelBackend :: Samples Blended */
#define kblgt3__rasterizer_and_pixel_backend__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set RasterizerAndPixelBackend :: Sampler Texels */
#define kblgt3__rasterizer_and_pixel_backend__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set RasterizerAndPixelBackend :: Sampler Texels Misses */
#define kblgt3__rasterizer_and_pixel_backend__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Read */
#define kblgt3__rasterizer_and_pixel_backend__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Read */
#define kblgt3__rasterizer_and_pixel_backend__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Written */
#define kblgt3__rasterizer_and_pixel_backend__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Written */
#define kblgt3__rasterizer_and_pixel_backend__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set RasterizerAndPixelBackend :: Shader Memory Accesses */
#define kblgt3__rasterizer_and_pixel_backend__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set RasterizerAndPixelBackend :: Shader Atomic Memory Accesses */
#define kblgt3__rasterizer_and_pixel_backend__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set RasterizerAndPixelBackend :: L3 Shader Throughput */
#define kblgt3__rasterizer_and_pixel_backend__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set RasterizerAndPixelBackend :: L3 Shader Throughput */
#define kblgt3__rasterizer_and_pixel_backend__l3_shader_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Metric set RasterizerAndPixelBackend :: Shader Barrier Messages */
#define kblgt3__rasterizer_and_pixel_backend__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Post-EarlyZ Pixel Data Ready */
#define kblgt3__rasterizer_and_pixel_backend__pixel_data0_ready__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Rasterizer Input Available */
#define kblgt3__rasterizer_and_pixel_backend__rasterizer0_input_available__read \
    bdw__render_basic__sampler1_busy__read

/* Metric set RasterizerAndPixelBackend :: Slice0 PS Output Available */
#define kblgt3__rasterizer_and_pixel_backend__ps_output0_available__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Pixel Values Ready */
#define kblgt3__rasterizer_and_pixel_backend__pixel_values0_ready__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Rasterizer Output Ready */
#define kblgt3__rasterizer_and_pixel_backend__rasterizer0_output_ready__read \
    bdw__render_pipe_profile__sf_stall__read

/* Metric set RasterizerAndPixelBackend :: SQ is full */
#define kblgt3__rasterizer_and_pixel_backend__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set Sampler :: GPU Time Elapsed */
#define kblgt3__sampler__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set Sampler :: GPU Core Clocks */
#define kblgt3__sampler__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set Sampler :: AVG GPU Core Frequency */
#define kblgt3__sampler__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set Sampler :: AVG GPU Core Frequency */
#define kblgt3__sampler__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set Sampler :: GPU Busy */
#define kblgt3__sampler__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set Sampler :: VS Threads Dispatched */
#define kblgt3__sampler__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set Sampler :: HS Threads Dispatched */
#define kblgt3__sampler__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set Sampler :: DS Threads Dispatched */
#define kblgt3__sampler__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set Sampler :: GS Threads Dispatched */
#define kblgt3__sampler__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set Sampler :: FS Threads Dispatched */
#define kblgt3__sampler__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set Sampler :: CS Threads Dispatched */
#define kblgt3__sampler__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set Sampler :: EU Active */
#define kblgt3__sampler__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set Sampler :: EU Stall */
#define kblgt3__sampler__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set Sampler :: EU Both FPU Pipes Active */
#define kblgt3__sampler__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set Sampler :: VS FPU0 Pipe Active */
#define kblgt3__sampler__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set Sampler :: VS FPU1 Pipe Active */
#define kblgt3__sampler__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set Sampler :: VS Send Pipe Active */
#define kblgt3__sampler__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set Sampler :: PS FPU0 Pipe Active */
#define kblgt3__sampler__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set Sampler :: PS FPU1 Pipe Active */
#define kblgt3__sampler__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set Sampler :: PS Send Pipeline Active */
#define kblgt3__sampler__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set Sampler :: FS Both FPU Active */
#define kblgt3__sampler__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set Sampler :: Rasterized Pixels */
#define kblgt3__sampler__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set Sampler :: Early Hi-Depth Test Fails */
#define kblgt3__sampler__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set Sampler :: Early Depth Test Fails */
#define kblgt3__sampler__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set Sampler :: Samples Killed in FS */
#define kblgt3__sampler__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set Sampler :: Pixels Failing Tests */
#define kblgt3__sampler__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set Sampler :: Samples Written */
#define kblgt3__sampler__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set Sampler :: Samples Blended */
#define kblgt3__sampler__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set Sampler :: Sampler Texels */
#define kblgt3__sampler__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set Sampler :: Sampler Texels Misses */
#define kblgt3__sampler__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set Sampler :: SLM Bytes Read */
#define kblgt3__sampler__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set Sampler :: SLM Bytes Read */
#define kblgt3__sampler__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set Sampler :: SLM Bytes Written */
#define kblgt3__sampler__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set Sampler :: SLM Bytes Written */
#define kblgt3__sampler__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set Sampler :: Shader Memory Accesses */
#define kblgt3__sampler__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set Sampler :: Shader Atomic Memory Accesses */
#define kblgt3__sampler__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set Sampler :: L3 Shader Throughput */
#define kblgt3__sampler__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set Sampler :: L3 Shader Throughput */
#define kblgt3__sampler__l3_shader_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Metric set Sampler :: Shader Barrier Messages */
#define kblgt3__sampler__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set Sampler :: Slice0 Subslice1 Input Available */
#define kblgt3__sampler__sampler01_input_available__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set Sampler :: Slice0 Subslice2 Input Available */
#define kblgt3__sampler__sampler02_input_available__read \
    bdw__render_basic__sampler1_busy__read

/* Metric set Sampler :: Slice0 Subslice0 Input Available */
#define kblgt3__sampler__sampler00_input_available__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Metric set Sampler :: Slice0 Subslice2 Sampler Output Ready */
#define kblgt3__sampler__sampler02_output_ready__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set Sampler :: Slice0 Subslice0 Sampler Output Ready */
#define kblgt3__sampler__sampler00_output_ready__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set Sampler :: Slice0 Subslice1 Sampler Output Ready */
#define kblgt3__sampler__sampler01_output_ready__read \
    bdw__render_pipe_profile__sf_stall__read

/* Metric set Sampler :: SQ is full */
#define kblgt3__sampler__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set TDL_1 :: GPU Time Elapsed */
#define kblgt3__tdl_1__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set TDL_1 :: GPU Core Clocks */
#define kblgt3__tdl_1__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set TDL_1 :: AVG GPU Core Frequency */
#define kblgt3__tdl_1__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set TDL_1 :: AVG GPU Core Frequency */
#define kblgt3__tdl_1__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set TDL_1 :: GPU Busy */
#define kblgt3__tdl_1__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set TDL_1 :: VS Threads Dispatched */
#define kblgt3__tdl_1__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set TDL_1 :: HS Threads Dispatched */
#define kblgt3__tdl_1__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set TDL_1 :: DS Threads Dispatched */
#define kblgt3__tdl_1__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set TDL_1 :: GS Threads Dispatched */
#define kblgt3__tdl_1__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set TDL_1 :: FS Threads Dispatched */
#define kblgt3__tdl_1__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set TDL_1 :: CS Threads Dispatched */
#define kblgt3__tdl_1__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set TDL_1 :: EU Active */
#define kblgt3__tdl_1__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set TDL_1 :: EU Stall */
#define kblgt3__tdl_1__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set TDL_1 :: EU Both FPU Pipes Active */
#define kblgt3__tdl_1__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set TDL_1 :: VS FPU0 Pipe Active */
#define kblgt3__tdl_1__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set TDL_1 :: VS FPU1 Pipe Active */
#define kblgt3__tdl_1__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set TDL_1 :: VS Send Pipe Active */
#define kblgt3__tdl_1__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set TDL_1 :: PS FPU0 Pipe Active */
#define kblgt3__tdl_1__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set TDL_1 :: PS FPU1 Pipe Active */
#define kblgt3__tdl_1__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set TDL_1 :: PS Send Pipeline Active */
#define kblgt3__tdl_1__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set TDL_1 :: FS Both FPU Active */
#define kblgt3__tdl_1__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set TDL_1 :: Rasterized Pixels */
#define kblgt3__tdl_1__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set TDL_1 :: Early Hi-Depth Test Fails */
#define kblgt3__tdl_1__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set TDL_1 :: Early Depth Test Fails */
#define kblgt3__tdl_1__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set TDL_1 :: Samples Killed in FS */
#define kblgt3__tdl_1__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set TDL_1 :: Pixels Failing Tests */
#define kblgt3__tdl_1__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set TDL_1 :: Samples Written */
#define kblgt3__tdl_1__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set TDL_1 :: Samples Blended */
#define kblgt3__tdl_1__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set TDL_1 :: Sampler Texels */
#define kblgt3__tdl_1__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set TDL_1 :: Sampler Texels Misses */
#define kblgt3__tdl_1__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set TDL_1 :: SLM Bytes Read */
#define kblgt3__tdl_1__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set TDL_1 :: SLM Bytes Read */
#define kblgt3__tdl_1__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_1 :: SLM Bytes Written */
#define kblgt3__tdl_1__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set TDL_1 :: SLM Bytes Written */
#define kblgt3__tdl_1__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_1 :: Shader Memory Accesses */
#define kblgt3__tdl_1__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set TDL_1 :: Shader Atomic Memory Accesses */
#define kblgt3__tdl_1__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set TDL_1 :: L3 Shader Throughput */
#define kblgt3__tdl_1__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set TDL_1 :: L3 Shader Throughput */
#define kblgt3__tdl_1__l3_shader_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Metric set TDL_1 :: Shader Barrier Messages */
#define kblgt3__tdl_1__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set TDL_1 :: NonPS Thread Ready For Dispatch on Slice0 Subslice1 */
#define kblgt3__tdl_1__non_ps_thread01_ready_for_dispatch__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set TDL_1 :: PS Thread Ready For Dispatch on Slice0 Subslice0 */
#define kblgt3__tdl_1__ps_thread00_ready_for_dispatch__read \
    bdw__render_basic__sampler1_busy__read

/* Metric set TDL_1 :: NonPS Thread Ready For Dispatch on Slice0 Subslice0 */
#define kblgt3__tdl_1__non_ps_thread00_ready_for_dispatch__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Metric set TDL_1 :: PS Thread Ready For Dispatch on Slice0 Subslice2 */
#define kblgt3__tdl_1__ps_thread02_ready_for_dispatch__read \
    bdw__render_basic__sampler1_bottleneck__read

/* Metric set TDL_1 :: NonPS Thread Ready For Dispatch on Slice0 Subslice2 */
#define kblgt3__tdl_1__non_ps_thread02_ready_for_dispatch__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* Metric set TDL_1 :: PS Thread Ready For Dispatch on Slice0 Subslice1 */
#define kblgt3__tdl_1__ps_thread01_ready_for_dispatch__read \
    bdw__render_pipe_profile__cl_bottleneck__read

/* Metric set TDL_1 :: SQ is full */
#define kblgt3__tdl_1__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set TDL_2 :: GPU Time Elapsed */
#define kblgt3__tdl_2__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set TDL_2 :: GPU Core Clocks */
#define kblgt3__tdl_2__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set TDL_2 :: AVG GPU Core Frequency */
#define kblgt3__tdl_2__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set TDL_2 :: AVG GPU Core Frequency */
#define kblgt3__tdl_2__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set TDL_2 :: GPU Busy */
#define kblgt3__tdl_2__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set TDL_2 :: VS Threads Dispatched */
#define kblgt3__tdl_2__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set TDL_2 :: HS Threads Dispatched */
#define kblgt3__tdl_2__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set TDL_2 :: DS Threads Dispatched */
#define kblgt3__tdl_2__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set TDL_2 :: GS Threads Dispatched */
#define kblgt3__tdl_2__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set TDL_2 :: FS Threads Dispatched */
#define kblgt3__tdl_2__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set TDL_2 :: CS Threads Dispatched */
#define kblgt3__tdl_2__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set TDL_2 :: EU Active */
#define kblgt3__tdl_2__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set TDL_2 :: EU Stall */
#define kblgt3__tdl_2__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set TDL_2 :: EU Both FPU Pipes Active */
#define kblgt3__tdl_2__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set TDL_2 :: VS FPU0 Pipe Active */
#define kblgt3__tdl_2__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set TDL_2 :: VS FPU1 Pipe Active */
#define kblgt3__tdl_2__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set TDL_2 :: VS Send Pipe Active */
#define kblgt3__tdl_2__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set TDL_2 :: PS FPU0 Pipe Active */
#define kblgt3__tdl_2__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set TDL_2 :: PS FPU1 Pipe Active */
#define kblgt3__tdl_2__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set TDL_2 :: PS Send Pipeline Active */
#define kblgt3__tdl_2__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set TDL_2 :: FS Both FPU Active */
#define kblgt3__tdl_2__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set TDL_2 :: Rasterized Pixels */
#define kblgt3__tdl_2__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set TDL_2 :: Early Hi-Depth Test Fails */
#define kblgt3__tdl_2__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set TDL_2 :: Early Depth Test Fails */
#define kblgt3__tdl_2__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set TDL_2 :: Samples Killed in FS */
#define kblgt3__tdl_2__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set TDL_2 :: Pixels Failing Tests */
#define kblgt3__tdl_2__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set TDL_2 :: Samples Written */
#define kblgt3__tdl_2__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set TDL_2 :: Samples Blended */
#define kblgt3__tdl_2__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set TDL_2 :: Sampler Texels */
#define kblgt3__tdl_2__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set TDL_2 :: Sampler Texels Misses */
#define kblgt3__tdl_2__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set TDL_2 :: SLM Bytes Read */
#define kblgt3__tdl_2__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set TDL_2 :: SLM Bytes Read */
#define kblgt3__tdl_2__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_2 :: SLM Bytes Written */
#define kblgt3__tdl_2__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set TDL_2 :: SLM Bytes Written */
#define kblgt3__tdl_2__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_2 :: Shader Memory Accesses */
#define kblgt3__tdl_2__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set TDL_2 :: Shader Atomic Memory Accesses */
#define kblgt3__tdl_2__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set TDL_2 :: L3 Shader Throughput */
#define kblgt3__tdl_2__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set TDL_2 :: L3 Shader Throughput */
#define kblgt3__tdl_2__l3_shader_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Metric set TDL_2 :: Shader Barrier Messages */
#define kblgt3__tdl_2__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice1 Port 0 */
#define kblgt3__tdl_2__thread_header01_ready_port0__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice0 Port 1 */
#define kblgt3__tdl_2__thread_header00_ready_port1__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice0 Port 0 */
#define kblgt3__tdl_2__thread_header00_ready_port0__read \
    bdw__render_pipe_profile__sf_stall__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice2 Port 1 */
#define kblgt3__tdl_2__thread_header02_ready_port1__read \
    bdw__render_pipe_profile__cl_stall__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice2 Port 0 */
#define kblgt3__tdl_2__thread_header02_ready_port0__read \
    bdw__render_pipe_profile__so_stall__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice1 Port 1 */
#define kblgt3__tdl_2__thread_header01_ready_port1__read \
    bdw__render_pipe_profile__ds_stall__read

/* Metric set TDL_2 :: SQ is full */
#define kblgt3__tdl_2__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Compute Metrics Extra Gen9 :: GPU Time Elapsed */
#define kblgt3__compute_extra__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Compute Metrics Extra Gen9 :: GPU Core Clocks */
#define kblgt3__compute_extra__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Compute Metrics Extra Gen9 :: AVG GPU Core Frequency */
#define kblgt3__compute_extra__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Compute Metrics Extra Gen9 :: AVG GPU Core Frequency */
#define kblgt3__compute_extra__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Compute Metrics Extra Gen9 :: EU FPU1 Pipe Active */
#define kblgt3__compute_extra__fpu1_active__read \
    bdw__render_basic__eu_stall__read

/* Compute Metrics Extra Gen9 :: EU FPU1 Pipe Active including Ext Math */
#define kblgt3__compute_extra__fpu1_active_adjusted__read \
    bdw__compute_extra__fpu1_active_adjusted__read

/* Media Vme Pipe Gen9 :: GPU Time Elapsed */
#define kblgt3__vme_pipe__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Media Vme Pipe Gen9 :: GPU Core Clocks */
#define kblgt3__vme_pipe__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Media Vme Pipe Gen9 :: AVG GPU Core Frequency */
#define kblgt3__vme_pipe__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Media Vme Pipe Gen9 :: AVG GPU Core Frequency */
#define kblgt3__vme_pipe__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Media Vme Pipe Gen9 :: GPU Busy */
#define kblgt3__vme_pipe__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Media Vme Pipe Gen9 :: CS Threads Dispatched */
#define kblgt3__vme_pipe__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Media Vme Pipe Gen9 :: EU Active */
#define kblgt3__vme_pipe__eu_active__read \
    bdw__render_basic__eu_active__read

/* Media Vme Pipe Gen9 :: EU Stall */
#define kblgt3__vme_pipe__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Media Vme Pipe Gen9 :: EU Both FPU Pipes Active */
#define kblgt3__vme_pipe__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Media Vme Pipe Gen9 :: EU Thread Occupancy */
#define kblgt3__vme_pipe__eu_thread_occupancy__read \
    bdw__vme_pipe__eu_thread_occupancy__read

/* Media Vme Pipe Gen9 :: VME Busy */
#define kblgt3__vme_pipe__vme_busy__read \
    bdw__vme_pipe__vme_busy__read

/* Gpu Rings Busyness :: GPU Time Elapsed */
#define kblgt3__gpu_busyness__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Gpu Rings Busyness :: GPU Core Clocks */
#define kblgt3__gpu_busyness__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Gpu Rings Busyness :: AVG GPU Core Frequency */
#define kblgt3__gpu_busyness__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Gpu Rings Busyness :: AVG GPU Core Frequency */
#define kblgt3__gpu_busyness__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Gpu Rings Busyness :: Render Ring Busy */
#define kblgt3__gpu_busyness__render_busy__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Gpu Rings Busyness :: Vdbox0 Ring Busy */
#define kblgt3__gpu_busyness__vdbox0_busy__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Gpu Rings Busyness :: Vdbox1 Ring Busy */
#define kblgt3__gpu_busyness__vdbox1_busy__read \
    bdw__render_pipe_profile__sf_stall__read

/* Gpu Rings Busyness :: Vebox Ring Busy */
#define kblgt3__gpu_busyness__vebox_busy__read \
    bdw__render_pipe_profile__cl_stall__read

/* Gpu Rings Busyness :: Blitter Ring Busy */
#define kblgt3__gpu_busyness__blitter_busy__read \
    bdw__render_pipe_profile__so_stall__read

/* Gpu Rings Busyness :: AnyRingBusy */
#define kblgt3__gpu_busyness__any_ring_busy__read \
    bdw__render_basic__sampler0_busy__read

/* MDAPI testing set Gen9 :: GPU Time Elapsed */
#define kblgt3__test_oa__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* MDAPI testing set Gen9 :: GPU Core Clocks */
#define kblgt3__test_oa__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* MDAPI testing set Gen9 :: AVG GPU Core Frequency */
#define kblgt3__test_oa__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* MDAPI testing set Gen9 :: AVG GPU Core Frequency */
#define kblgt3__test_oa__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* MDAPI testing set Gen9 :: TestCounter0 */
#define kblgt3__test_oa__counter0__read \
    hsw__compute_extended__eu_untyped_reads0__read

/* MDAPI testing set Gen9 :: TestCounter1 */
#define kblgt3__test_oa__counter1__read \
    hsw__compute_extended__eu_untyped_writes0__read

/* MDAPI testing set Gen9 :: TestCounter2 */
#define kblgt3__test_oa__counter2__read \
    hsw__compute_extended__eu_typed_reads0__read

/* MDAPI testing set Gen9 :: TestCounter3 */
#define kblgt3__test_oa__counter3__read \
    hsw__compute_extended__eu_typed_writes0__read

/* MDAPI testing set Gen9 :: TestCounter4 */
#define kblgt3__test_oa__counter4__read \
    hsw__compute_extended__eu_untyped_atomics0__read

/* MDAPI testing set Gen9 :: TestCounter5 */
#define kblgt3__test_oa__counter5__read \
    hsw__compute_extended__eu_typed_atomics0__read

/* MDAPI testing set Gen9 :: TestCounter6 */
#define kblgt3__test_oa__counter6__read \
    hsw__compute_extended__eu_urb_atomics0__read

/* MDAPI testing set Gen9 :: TestCounter7 */
#define kblgt3__test_oa__counter7__read \
    hsw__compute_extended__gpu_clocks__read

/* MDAPI testing set Gen9 :: TestCounter8 */
#define kblgt3__test_oa__counter8__read \
    hsw__memory_reads__gpu_core_clocks__read

/* Metric set PMA Stall :: GPU Time Elapsed */
#define kblgt3__pma__stall__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set PMA Stall :: GPU Core Clocks */
#define kblgt3__pma__stall__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set PMA Stall :: AVG GPU Core Frequency */
#define kblgt3__pma__stall__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set PMA Stall :: AVG GPU Core Frequency */
#define kblgt3__pma__stall__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set PMA Stall :: STC PMA stall */
#define kblgt3__pma__stall__stc_pma_stall__read \
    sklgt2__pma__stall__stc_pma_stall__read

/* Render Metrics Basic Gen9 :: GPU Time Elapsed */
#define cflgt2__render_basic__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Render Metrics Basic Gen9 :: GPU Core Clocks */
#define cflgt2__render_basic__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Render Metrics Basic Gen9 :: AVG GPU Core Frequency */
#define cflgt2__render_basic__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Render Metrics Basic Gen9 :: AVG GPU Core Frequency */
#define cflgt2__render_basic__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Render Metrics Basic Gen9 :: VS Threads Dispatched */
#define cflgt2__render_basic__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Render Metrics Basic Gen9 :: HS Threads Dispatched */
#define cflgt2__render_basic__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Render Metrics Basic Gen9 :: DS Threads Dispatched */
#define cflgt2__render_basic__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Render Metrics Basic Gen9 :: GS Threads Dispatched */
#define cflgt2__render_basic__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Render Metrics Basic Gen9 :: FS Threads Dispatched */
#define cflgt2__render_basic__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Render Metrics Basic Gen9 :: CS Threads Dispatched */
#define cflgt2__render_basic__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Render Metrics Basic Gen9 :: GPU Busy */
#define cflgt2__render_basic__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Render Metrics Basic Gen9 :: EU Active */
#define cflgt2__render_basic__eu_active__read \
    bdw__render_basic__eu_active__read

/* Render Metrics Basic Gen9 :: EU Stall */
#define cflgt2__render_basic__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Render Metrics Basic Gen9 :: EU Both FPU Pipes Active */
#define cflgt2__render_basic__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Render Metrics Basic Gen9 :: VS FPU0 Pipe Active */
#define cflgt2__render_basic__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Render Metrics Basic Gen9 :: VS FPU1 Pipe Active */
#define cflgt2__render_basic__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Render Metrics Basic Gen9 :: VS Send Pipe Active */
#define cflgt2__render_basic__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Render Metrics Basic Gen9 :: PS FPU0 Pipe Active */
#define cflgt2__render_basic__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Render Metrics Basic Gen9 :: PS FPU1 Pipe Active */
#define cflgt2__render_basic__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Render Metrics Basic Gen9 :: PS Send Pipeline Active */
#define cflgt2__render_basic__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Render Metrics Basic Gen9 :: FS Both FPU Active */
#define cflgt2__render_basic__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Render Metrics Basic Gen9 :: Sampler 0 Busy */
#define cflgt2__render_basic__sampler0_busy__read \
    bdw__render_basic__sampler0_busy__read

/* Render Metrics Basic Gen9 :: Sampler 1 Busy */
#define cflgt2__render_basic__sampler1_busy__read \
    bdw__render_basic__sampler1_busy__read

/* Render Metrics Basic Gen9 :: Samplers Busy */
#define cflgt2__render_basic__samplers_busy__read \
    bdw__render_basic__samplers_busy__read

/* Render Metrics Basic Gen9 :: Sampler 0 Bottleneck */
#define cflgt2__render_basic__sampler0_bottleneck__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Render Metrics Basic Gen9 :: Sampler 1 Bottleneck */
#define cflgt2__render_basic__sampler1_bottleneck__read \
    bdw__render_basic__sampler1_bottleneck__read

/* Render Metrics Basic Gen9 :: Rasterized Pixels */
#define cflgt2__render_basic__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Render Metrics Basic Gen9 :: Early Hi-Depth Test Fails */
#define cflgt2__render_basic__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Render Metrics Basic Gen9 :: Early Depth Test Fails */
#define cflgt2__render_basic__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Render Metrics Basic Gen9 :: Samples Killed in FS */
#define cflgt2__render_basic__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Render Metrics Basic Gen9 :: Pixels Failing Tests */
#define cflgt2__render_basic__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Render Metrics Basic Gen9 :: Samples Written */
#define cflgt2__render_basic__samples_written__read \
    bdw__render_basic__samples_written__read

/* Render Metrics Basic Gen9 :: Samples Blended */
#define cflgt2__render_basic__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Render Metrics Basic Gen9 :: Sampler Texels */
#define cflgt2__render_basic__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Render Metrics Basic Gen9 :: Sampler Texels Misses */
#define cflgt2__render_basic__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Render Metrics Basic Gen9 :: Sampler Cache Misses */
#define cflgt2__render_basic__sampler_l1_misses__read \
    sklgt2__render_basic__sampler_l1_misses__read

/* Render Metrics Basic Gen9 :: SLM Bytes Read */
#define cflgt2__render_basic__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Render Metrics Basic Gen9 :: SLM Bytes Read */
#define cflgt2__render_basic__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics Basic Gen9 :: SLM Bytes Written */
#define cflgt2__render_basic__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Render Metrics Basic Gen9 :: SLM Bytes Written */
#define cflgt2__render_basic__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics Basic Gen9 :: Shader Memory Accesses */
#define cflgt2__render_basic__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Render Metrics Basic Gen9 :: Shader Atomic Memory Accesses */
#define cflgt2__render_basic__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Render Metrics Basic Gen9 :: L3 Lookup Accesses w/o IC */
#define cflgt2__render_basic__l3_lookups__read \
    sklgt2__render_basic__l3_lookups__read

/* Render Metrics Basic Gen9 :: L3 Misses */
#define cflgt2__render_basic__l3_misses__read \
    hsw__compute_extended__typed_atomics0__read

/* Render Metrics Basic Gen9 :: L3 Sampler Throughput */
#define cflgt2__render_basic__l3_sampler_throughput__read \
    sklgt2__render_basic__l3_sampler_throughput__read

/* Render Metrics Basic Gen9 :: L3 Sampler Throughput */
#define cflgt2__render_basic__l3_sampler_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics Basic Gen9 :: L3 Shader Throughput */
#define cflgt2__render_basic__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Render Metrics Basic Gen9 :: L3 Shader Throughput */
#define cflgt2__render_basic__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics Basic Gen9 :: Shader Barrier Messages */
#define cflgt2__render_basic__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Render Metrics Basic Gen9 :: GTI Fixed Pipe Throughput */
#define cflgt2__render_basic__gti_vf_throughput__read \
    bdw__render_basic__gti_vf_throughput__read

/* Render Metrics Basic Gen9 :: GTI Fixed Pipe Throughput */
#define cflgt2__render_basic__gti_vf_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Render Metrics Basic Gen9 :: GTI Depth Throughput */
#define cflgt2__render_basic__gti_depth_throughput__read \
    bdw__render_basic__gti_depth_throughput__read

/* Render Metrics Basic Gen9 :: GTI Depth Throughput */
#define cflgt2__render_basic__gti_depth_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics Basic Gen9 :: GTI RCC Throughput */
#define cflgt2__render_basic__gti_rcc_throughput__read \
    bdw__render_basic__gti_rcc_throughput__read

/* Render Metrics Basic Gen9 :: GTI RCC Throughput */
#define cflgt2__render_basic__gti_rcc_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics Basic Gen9 :: GTI L3 Throughput */
#define cflgt2__render_basic__gti_l3_throughput__read \
    hsw__render_basic__gti_l3_throughput__read

/* Render Metrics Basic Gen9 :: GTI L3 Throughput */
#define cflgt2__render_basic__gti_l3_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics Basic Gen9 :: GTI HDC TLB Lookup Throughput */
#define cflgt2__render_basic__gti_hdc_lookups_throughput__read \
    bdw__render_basic__gti_hdc_lookups_throughput__read

/* Render Metrics Basic Gen9 :: GTI HDC TLB Lookup Throughput */
#define cflgt2__render_basic__gti_hdc_lookups_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics Basic Gen9 :: GTI Read Throughput */
#define cflgt2__render_basic__gti_read_throughput__read \
    bdw__render_basic__gti_read_throughput__read

/* Render Metrics Basic Gen9 :: GTI Read Throughput */
#define cflgt2__render_basic__gti_read_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Render Metrics Basic Gen9 :: GTI Write Throughput */
#define cflgt2__render_basic__gti_write_throughput__read \
    hsw__render_basic__gti_write_throughput__read

/* Render Metrics Basic Gen9 :: GTI Write Throughput */
#define cflgt2__render_basic__gti_write_throughput__max \
    bdw__render_basic__gti_write_throughput__max

/* Render Metrics Basic Gen9 :: Samplers Bottleneck */
#define cflgt2__render_basic__sampler_bottleneck__read \
    bdw__render_basic__sampler_bottleneck__read

/* Compute Metrics Basic Gen9 :: GPU Time Elapsed */
#define cflgt2__compute_basic__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Compute Metrics Basic Gen9 :: GPU Core Clocks */
#define cflgt2__compute_basic__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Compute Metrics Basic Gen9 :: AVG GPU Core Frequency */
#define cflgt2__compute_basic__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Compute Metrics Basic Gen9 :: AVG GPU Core Frequency */
#define cflgt2__compute_basic__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Compute Metrics Basic Gen9 :: GPU Busy */
#define cflgt2__compute_basic__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Compute Metrics Basic Gen9 :: VS Threads Dispatched */
#define cflgt2__compute_basic__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Compute Metrics Basic Gen9 :: HS Threads Dispatched */
#define cflgt2__compute_basic__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Compute Metrics Basic Gen9 :: DS Threads Dispatched */
#define cflgt2__compute_basic__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Compute Metrics Basic Gen9 :: GS Threads Dispatched */
#define cflgt2__compute_basic__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Compute Metrics Basic Gen9 :: FS Threads Dispatched */
#define cflgt2__compute_basic__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Compute Metrics Basic Gen9 :: CS Threads Dispatched */
#define cflgt2__compute_basic__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Compute Metrics Basic Gen9 :: EU Active */
#define cflgt2__compute_basic__eu_active__read \
    bdw__render_basic__eu_active__read

/* Compute Metrics Basic Gen9 :: EU Stall */
#define cflgt2__compute_basic__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Compute Metrics Basic Gen9 :: EU Both FPU Pipes Active */
#define cflgt2__compute_basic__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Compute Metrics Basic Gen9 :: EU FPU0 Pipe Active */
#define cflgt2__compute_basic__fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Compute Metrics Basic Gen9 :: EU FPU1 Pipe Active */
#define cflgt2__compute_basic__fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Compute Metrics Basic Gen9 :: EU AVG IPC Rate */
#define cflgt2__compute_basic__eu_avg_ipc_rate__read \
    bdw__compute_basic__eu_avg_ipc_rate__read

/* Compute Metrics Basic Gen9 :: EU AVG IPC Rate */
#define cflgt2__compute_basic__eu_avg_ipc_rate__max \
    bdw__compute_basic__eu_avg_ipc_rate__max

/* Compute Metrics Basic Gen9 :: EU Send Pipe Active */
#define cflgt2__compute_basic__eu_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Compute Metrics Basic Gen9 :: EU Thread Occupancy */
#define cflgt2__compute_basic__eu_thread_occupancy__read \
    bdw__compute_basic__eu_thread_occupancy__read

/* Compute Metrics Basic Gen9 :: Rasterized Pixels */
#define cflgt2__compute_basic__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Compute Metrics Basic Gen9 :: Early Hi-Depth Test Fails */
#define cflgt2__compute_basic__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Compute Metrics Basic Gen9 :: Early Depth Test Fails */
#define cflgt2__compute_basic__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Compute Metrics Basic Gen9 :: Samples Killed in FS */
#define cflgt2__compute_basic__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Compute Metrics Basic Gen9 :: Pixels Failing Tests */
#define cflgt2__compute_basic__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Compute Metrics Basic Gen9 :: Samples Written */
#define cflgt2__compute_basic__samples_written__read \
    bdw__render_basic__samples_written__read

/* Compute Metrics Basic Gen9 :: Samples Blended */
#define cflgt2__compute_basic__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Compute Metrics Basic Gen9 :: Sampler Texels */
#define cflgt2__compute_basic__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Compute Metrics Basic Gen9 :: Sampler Texels Misses */
#define cflgt2__compute_basic__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Compute Metrics Basic Gen9 :: SLM Bytes Read */
#define cflgt2__compute_basic__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Compute Metrics Basic Gen9 :: SLM Bytes Read */
#define cflgt2__compute_basic__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Basic Gen9 :: SLM Bytes Written */
#define cflgt2__compute_basic__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Compute Metrics Basic Gen9 :: SLM Bytes Written */
#define cflgt2__compute_basic__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Basic Gen9 :: Shader Memory Accesses */
#define cflgt2__compute_basic__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Compute Metrics Basic Gen9 :: Shader Atomic Memory Accesses */
#define cflgt2__compute_basic__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Compute Metrics Basic Gen9 :: L3 Shader Throughput */
#define cflgt2__compute_basic__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Compute Metrics Basic Gen9 :: L3 Shader Throughput */
#define cflgt2__compute_basic__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Basic Gen9 :: Shader Barrier Messages */
#define cflgt2__compute_basic__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Compute Metrics Basic Gen9 :: Typed Bytes Read */
#define cflgt2__compute_basic__typed_bytes_read__read \
    bdw__compute_basic__typed_bytes_read__read

/* Compute Metrics Basic Gen9 :: Typed Bytes Read */
#define cflgt2__compute_basic__typed_bytes_read__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen9 :: Typed Bytes Written */
#define cflgt2__compute_basic__typed_bytes_written__read \
    bdw__compute_basic__typed_bytes_written__read

/* Compute Metrics Basic Gen9 :: Typed Bytes Written */
#define cflgt2__compute_basic__typed_bytes_written__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen9 :: Untyped Bytes Read */
#define cflgt2__compute_basic__untyped_bytes_read__read \
    bdw__compute_basic__untyped_bytes_read__read

/* Compute Metrics Basic Gen9 :: Untyped Bytes Read */
#define cflgt2__compute_basic__untyped_bytes_read__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen9 :: Untyped Writes */
#define cflgt2__compute_basic__untyped_bytes_written__read \
    bdw__compute_basic__untyped_bytes_written__read

/* Compute Metrics Basic Gen9 :: Untyped Writes */
#define cflgt2__compute_basic__untyped_bytes_written__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen9 :: GTI Read Throughput */
#define cflgt2__compute_basic__gti_read_throughput__read \
    hsw__render_basic__gti_l3_throughput__read

/* Compute Metrics Basic Gen9 :: GTI Read Throughput */
#define cflgt2__compute_basic__gti_read_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen9 :: GTI Write Throughput */
#define cflgt2__compute_basic__gti_write_throughput__read \
    bdw__render_basic__gti_hdc_lookups_throughput__read

/* Compute Metrics Basic Gen9 :: GTI Write Throughput */
#define cflgt2__compute_basic__gti_write_throughput__max \
    bdw__render_basic__gti_write_throughput__max

/* Render Metrics for 3D Pipeline Profile Gen9 :: GPU Time Elapsed */
#define cflgt2__render_pipe_profile__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: GPU Core Clocks */
#define cflgt2__render_pipe_profile__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: AVG GPU Core Frequency */
#define cflgt2__render_pipe_profile__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: AVG GPU Core Frequency */
#define cflgt2__render_pipe_profile__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Render Metrics for 3D Pipeline Profile Gen9 :: GPU Busy */
#define cflgt2__render_pipe_profile__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: VS Threads Dispatched */
#define cflgt2__render_pipe_profile__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: HS Threads Dispatched */
#define cflgt2__render_pipe_profile__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: DS Threads Dispatched */
#define cflgt2__render_pipe_profile__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: GS Threads Dispatched */
#define cflgt2__render_pipe_profile__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: FS Threads Dispatched */
#define cflgt2__render_pipe_profile__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: CS Threads Dispatched */
#define cflgt2__render_pipe_profile__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: EU Active */
#define cflgt2__render_pipe_profile__eu_active__read \
    bdw__render_basic__eu_active__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: EU Stall */
#define cflgt2__render_pipe_profile__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Rasterized Pixels */
#define cflgt2__render_pipe_profile__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Early Hi-Depth Test Fails */
#define cflgt2__render_pipe_profile__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Early Depth Test Fails */
#define cflgt2__render_pipe_profile__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Samples Killed in FS */
#define cflgt2__render_pipe_profile__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Pixels Failing Tests */
#define cflgt2__render_pipe_profile__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Samples Written */
#define cflgt2__render_pipe_profile__samples_written__read \
    bdw__render_basic__samples_written__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Samples Blended */
#define cflgt2__render_pipe_profile__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Sampler Texels */
#define cflgt2__render_pipe_profile__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Sampler Texels Misses */
#define cflgt2__render_pipe_profile__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: SLM Bytes Read */
#define cflgt2__render_pipe_profile__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: SLM Bytes Read */
#define cflgt2__render_pipe_profile__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics for 3D Pipeline Profile Gen9 :: SLM Bytes Written */
#define cflgt2__render_pipe_profile__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: SLM Bytes Written */
#define cflgt2__render_pipe_profile__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics for 3D Pipeline Profile Gen9 :: Shader Memory Accesses */
#define cflgt2__render_pipe_profile__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Shader Atomic Memory Accesses */
#define cflgt2__render_pipe_profile__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: L3 Shader Throughput */
#define cflgt2__render_pipe_profile__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: L3 Shader Throughput */
#define cflgt2__render_pipe_profile__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics for 3D Pipeline Profile Gen9 :: Shader Barrier Messages */
#define cflgt2__render_pipe_profile__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: VF Bottleneck */
#define cflgt2__render_pipe_profile__vf_bottleneck__read \
    bdw__render_pipe_profile__vf_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: VS Bottleneck */
#define cflgt2__render_pipe_profile__vs_bottleneck__read \
    bdw__render_basic__sampler0_busy__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: HS Bottleneck */
#define cflgt2__render_pipe_profile__hs_bottleneck__read \
    bdw__render_basic__sampler1_busy__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: DS Bottleneck */
#define cflgt2__render_pipe_profile__ds_bottleneck__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: GS Bottleneck */
#define cflgt2__render_pipe_profile__gs_bottleneck__read \
    bdw__render_basic__sampler1_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: SO Bottleneck */
#define cflgt2__render_pipe_profile__so_bottleneck__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Clipper Bottleneck */
#define cflgt2__render_pipe_profile__cl_bottleneck__read \
    bdw__render_pipe_profile__cl_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Strip-Fans Bottleneck */
#define cflgt2__render_pipe_profile__sf_bottleneck__read \
    bdw__render_pipe_profile__sf_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Hi-Depth Bottleneck */
#define cflgt2__render_pipe_profile__hi_depth_bottleneck__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Early Depth Bottleneck */
#define cflgt2__render_pipe_profile__early_depth_bottleneck__read \
    bdw__render_pipe_profile__early_depth_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: BC Bottleneck */
#define cflgt2__render_pipe_profile__bc_bottleneck__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: HS Stall */
#define cflgt2__render_pipe_profile__hs_stall__read \
    bdw__render_pipe_profile__hs_stall__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: DS Stall */
#define cflgt2__render_pipe_profile__ds_stall__read \
    bdw__render_pipe_profile__ds_stall__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: SO Stall */
#define cflgt2__render_pipe_profile__so_stall__read \
    bdw__render_pipe_profile__so_stall__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: CL Stall */
#define cflgt2__render_pipe_profile__cl_stall__read \
    bdw__render_pipe_profile__cl_stall__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: SF Stall */
#define cflgt2__render_pipe_profile__sf_stall__read \
    bdw__render_pipe_profile__sf_stall__read

/* Memory Reads Distribution Gen9 :: GPU Time Elapsed */
#define cflgt2__memory_reads__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Memory Reads Distribution Gen9 :: GPU Core Clocks */
#define cflgt2__memory_reads__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Memory Reads Distribution Gen9 :: AVG GPU Core Frequency */
#define cflgt2__memory_reads__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Memory Reads Distribution Gen9 :: AVG GPU Core Frequency */
#define cflgt2__memory_reads__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Memory Reads Distribution Gen9 :: GPU Busy */
#define cflgt2__memory_reads__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Memory Reads Distribution Gen9 :: VS Threads Dispatched */
#define cflgt2__memory_reads__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Memory Reads Distribution Gen9 :: HS Threads Dispatched */
#define cflgt2__memory_reads__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Memory Reads Distribution Gen9 :: DS Threads Dispatched */
#define cflgt2__memory_reads__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Memory Reads Distribution Gen9 :: GS Threads Dispatched */
#define cflgt2__memory_reads__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Memory Reads Distribution Gen9 :: FS Threads Dispatched */
#define cflgt2__memory_reads__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Memory Reads Distribution Gen9 :: CS Threads Dispatched */
#define cflgt2__memory_reads__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Memory Reads Distribution Gen9 :: EU Active */
#define cflgt2__memory_reads__eu_active__read \
    bdw__render_basic__eu_active__read

/* Memory Reads Distribution Gen9 :: EU Stall */
#define cflgt2__memory_reads__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Memory Reads Distribution Gen9 :: Rasterized Pixels */
#define cflgt2__memory_reads__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Memory Reads Distribution Gen9 :: Early Hi-Depth Test Fails */
#define cflgt2__memory_reads__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Memory Reads Distribution Gen9 :: Early Depth Test Fails */
#define cflgt2__memory_reads__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Memory Reads Distribution Gen9 :: Samples Killed in FS */
#define cflgt2__memory_reads__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Memory Reads Distribution Gen9 :: Pixels Failing Tests */
#define cflgt2__memory_reads__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Memory Reads Distribution Gen9 :: Samples Written */
#define cflgt2__memory_reads__samples_written__read \
    bdw__render_basic__samples_written__read

/* Memory Reads Distribution Gen9 :: Samples Blended */
#define cflgt2__memory_reads__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Memory Reads Distribution Gen9 :: Sampler Texels */
#define cflgt2__memory_reads__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Memory Reads Distribution Gen9 :: Sampler Texels Misses */
#define cflgt2__memory_reads__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Memory Reads Distribution Gen9 :: SLM Bytes Read */
#define cflgt2__memory_reads__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Memory Reads Distribution Gen9 :: SLM Bytes Read */
#define cflgt2__memory_reads__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Memory Reads Distribution Gen9 :: SLM Bytes Written */
#define cflgt2__memory_reads__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Memory Reads Distribution Gen9 :: SLM Bytes Written */
#define cflgt2__memory_reads__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Memory Reads Distribution Gen9 :: Shader Memory Accesses */
#define cflgt2__memory_reads__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Memory Reads Distribution Gen9 :: Shader Atomic Memory Accesses */
#define cflgt2__memory_reads__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Memory Reads Distribution Gen9 :: Shader Barrier Messages */
#define cflgt2__memory_reads__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Memory Reads Distribution Gen9 :: GtiCmdStreamerMemoryReads */
#define cflgt2__memory_reads__gti_cmd_streamer_memory_reads__read \
    hsw__compute_extended__eu_untyped_reads0__read

/* Memory Reads Distribution Gen9 :: GtiRsMemoryReads */
#define cflgt2__memory_reads__gti_rs_memory_reads__read \
    hsw__compute_extended__eu_typed_reads0__read

/* Memory Reads Distribution Gen9 :: GtiVfMemoryReads */
#define cflgt2__memory_reads__gti_vf_memory_reads__read \
    hsw__compute_extended__eu_untyped_writes0__read

/* Memory Reads Distribution Gen9 :: GtiRccMemoryReads */
#define cflgt2__memory_reads__gti_rcc_memory_reads__read \
    hsw__compute_extended__eu_typed_writes0__read

/* Memory Reads Distribution Gen9 :: GtiMscMemoryReads */
#define cflgt2__memory_reads__gti_msc_memory_reads__read \
    hsw__compute_extended__eu_untyped_atomics0__read

/* Memory Reads Distribution Gen9 :: GtiHizMemoryReads */
#define cflgt2__memory_reads__gti_hiz_memory_reads__read \
    hsw__compute_extended__eu_typed_atomics0__read

/* Memory Reads Distribution Gen9 :: GtiStcMemoryReads */
#define cflgt2__memory_reads__gti_stc_memory_reads__read \
    hsw__compute_extended__eu_urb_atomics0__read

/* Memory Reads Distribution Gen9 :: GtiRczMemoryReads */
#define cflgt2__memory_reads__gti_rcz_memory_reads__read \
    hsw__compute_extended__gpu_clocks__read

/* Memory Reads Distribution Gen9 :: GtiMemoryReads */
#define cflgt2__memory_reads__gti_memory_reads__read \
    hsw__compute_extended__typed_writes0__read

/* Memory Reads Distribution Gen9 :: GtiL3Bank0Reads */
#define cflgt2__memory_reads__gti_l3_bank0_reads__read \
    hsw__compute_extended__typed_atomics0__read

/* Memory Reads Distribution Gen9 :: GtiL3Bank1Reads */
#define cflgt2__memory_reads__gti_l3_bank1_reads__read \
    hsw__memory_reads__gti_memory_reads__read

/* Memory Reads Distribution Gen9 :: GtiL3Bank2Reads */
#define cflgt2__memory_reads__gti_l3_bank2_reads__read \
    hsw__memory_reads__llc_read_accesses__read

/* Memory Reads Distribution Gen9 :: GtiL3Bank3Reads */
#define cflgt2__memory_reads__gti_l3_bank3_reads__read \
    hsw__memory_reads__gpu_core_clocks__read

/* Memory Reads Distribution Gen9 :: GtiL3Reads */
#define cflgt2__memory_reads__gti_l3_reads__read \
    bdw__memory_reads__gti_l3_reads__read

/* Memory Reads Distribution Gen9 :: GtiRingAccesses */
#define cflgt2__memory_reads__gti_ring_accesses__read \
    bdw__memory_reads__gti_ring_accesses__read

/* Memory Writes Distribution Gen9 :: GPU Time Elapsed */
#define cflgt2__memory_writes__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Memory Writes Distribution Gen9 :: GPU Core Clocks */
#define cflgt2__memory_writes__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Memory Writes Distribution Gen9 :: AVG GPU Core Frequency */
#define cflgt2__memory_writes__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Memory Writes Distribution Gen9 :: AVG GPU Core Frequency */
#define cflgt2__memory_writes__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Memory Writes Distribution Gen9 :: GPU Busy */
#define cflgt2__memory_writes__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Memory Writes Distribution Gen9 :: VS Threads Dispatched */
#define cflgt2__memory_writes__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Memory Writes Distribution Gen9 :: HS Threads Dispatched */
#define cflgt2__memory_writes__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Memory Writes Distribution Gen9 :: DS Threads Dispatched */
#define cflgt2__memory_writes__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Memory Writes Distribution Gen9 :: GS Threads Dispatched */
#define cflgt2__memory_writes__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Memory Writes Distribution Gen9 :: FS Threads Dispatched */
#define cflgt2__memory_writes__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Memory Writes Distribution Gen9 :: CS Threads Dispatched */
#define cflgt2__memory_writes__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Memory Writes Distribution Gen9 :: EU Active */
#define cflgt2__memory_writes__eu_active__read \
    bdw__render_basic__eu_active__read

/* Memory Writes Distribution Gen9 :: EU Stall */
#define cflgt2__memory_writes__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Memory Writes Distribution Gen9 :: Rasterized Pixels */
#define cflgt2__memory_writes__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Memory Writes Distribution Gen9 :: Early Hi-Depth Test Fails */
#define cflgt2__memory_writes__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Memory Writes Distribution Gen9 :: Early Depth Test Fails */
#define cflgt2__memory_writes__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Memory Writes Distribution Gen9 :: Samples Killed in FS */
#define cflgt2__memory_writes__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Memory Writes Distribution Gen9 :: Pixels Failing Tests */
#define cflgt2__memory_writes__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Memory Writes Distribution Gen9 :: Samples Written */
#define cflgt2__memory_writes__samples_written__read \
    bdw__render_basic__samples_written__read

/* Memory Writes Distribution Gen9 :: Samples Blended */
#define cflgt2__memory_writes__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Memory Writes Distribution Gen9 :: Sampler Texels */
#define cflgt2__memory_writes__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Memory Writes Distribution Gen9 :: Sampler Texels Misses */
#define cflgt2__memory_writes__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Memory Writes Distribution Gen9 :: SLM Bytes Read */
#define cflgt2__memory_writes__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Memory Writes Distribution Gen9 :: SLM Bytes Read */
#define cflgt2__memory_writes__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Memory Writes Distribution Gen9 :: SLM Bytes Written */
#define cflgt2__memory_writes__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Memory Writes Distribution Gen9 :: SLM Bytes Written */
#define cflgt2__memory_writes__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Memory Writes Distribution Gen9 :: Shader Memory Accesses */
#define cflgt2__memory_writes__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Memory Writes Distribution Gen9 :: Shader Atomic Memory Accesses */
#define cflgt2__memory_writes__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Memory Writes Distribution Gen9 :: L3 Shader Throughput */
#define cflgt2__memory_writes__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Memory Writes Distribution Gen9 :: L3 Shader Throughput */
#define cflgt2__memory_writes__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Memory Writes Distribution Gen9 :: Shader Barrier Messages */
#define cflgt2__memory_writes__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Memory Writes Distribution Gen9 :: GtiCmdStreamerMemoryWrites */
#define cflgt2__memory_writes__gti_cmd_streamer_memory_writes__read \
    hsw__compute_extended__eu_untyped_reads0__read

/* Memory Writes Distribution Gen9 :: GtiSoMemoryWrites */
#define cflgt2__memory_writes__gti_so_memory_writes__read \
    hsw__compute_extended__eu_typed_reads0__read

/* Memory Writes Distribution Gen9 :: GtiRccMemoryWrites */
#define cflgt2__memory_writes__gti_rcc_memory_writes__read \
    hsw__compute_extended__eu_typed_writes0__read

/* Memory Writes Distribution Gen9 :: GtiMscMemoryWrites */
#define cflgt2__memory_writes__gti_msc_memory_writes__read \
    hsw__compute_extended__eu_untyped_atomics0__read

/* Memory Writes Distribution Gen9 :: GtiHizMemoryWrites */
#define cflgt2__memory_writes__gti_hiz_memory_writes__read \
    hsw__compute_extended__eu_typed_atomics0__read

/* Memory Writes Distribution Gen9 :: GtiStcMemoryWrites */
#define cflgt2__memory_writes__gti_stc_memory_writes__read \
    hsw__compute_extended__eu_urb_atomics0__read

/* Memory Writes Distribution Gen9 :: GtiRczMemoryWrites */
#define cflgt2__memory_writes__gti_rcz_memory_writes__read \
    hsw__compute_extended__gpu_clocks__read

/* Memory Writes Distribution Gen9 :: GtiMemoryWrites */
#define cflgt2__memory_writes__gti_memory_writes__read \
    hsw__compute_extended__typed_writes0__read

/* Memory Writes Distribution Gen9 :: GtiL3Bank0Writes */
#define cflgt2__memory_writes__gti_l3_bank0_writes__read \
    hsw__compute_extended__typed_atomics0__read

/* Memory Writes Distribution Gen9 :: GtiL3Bank1Writes */
#define cflgt2__memory_writes__gti_l3_bank1_writes__read \
    hsw__memory_reads__gti_memory_reads__read

/* Memory Writes Distribution Gen9 :: GtiL3Bank2Writes */
#define cflgt2__memory_writes__gti_l3_bank2_writes__read \
    hsw__memory_reads__llc_read_accesses__read

/* Memory Writes Distribution Gen9 :: GtiL3Bank3Writes */
#define cflgt2__memory_writes__gti_l3_bank3_writes__read \
    hsw__memory_reads__gpu_core_clocks__read

/* Memory Writes Distribution Gen9 :: GtiL3Writes */
#define cflgt2__memory_writes__gti_l3_writes__read \
    bdw__memory_reads__gti_l3_reads__read

/* Memory Writes Distribution Gen9 :: GtiRingAccesses */
#define cflgt2__memory_writes__gti_ring_accesses__read \
    bdw__memory_reads__gti_ring_accesses__read

/* Compute Metrics Extended Gen9 :: GPU Time Elapsed */
#define cflgt2__compute_extended__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Compute Metrics Extended Gen9 :: GPU Core Clocks */
#define cflgt2__compute_extended__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Compute Metrics Extended Gen9 :: AVG GPU Core Frequency */
#define cflgt2__compute_extended__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Compute Metrics Extended Gen9 :: AVG GPU Core Frequency */
#define cflgt2__compute_extended__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Compute Metrics Extended Gen9 :: CS Threads Dispatched */
#define cflgt2__compute_extended__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Compute Metrics Extended Gen9 :: EU Active */
#define cflgt2__compute_extended__eu_active__read \
    bdw__render_basic__eu_active__read

/* Compute Metrics Extended Gen9 :: EU Stall */
#define cflgt2__compute_extended__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Compute Metrics Extended Gen9 :: EU Both FPU Pipes Active */
#define cflgt2__compute_extended__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Compute Metrics Extended Gen9 :: EU FPU0 Pipe Active */
#define cflgt2__compute_extended__fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Compute Metrics Extended Gen9 :: EU FPU1 Pipe Active */
#define cflgt2__compute_extended__fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Compute Metrics Extended Gen9 :: EU AVG IPC Rate */
#define cflgt2__compute_extended__eu_avg_ipc_rate__read \
    bdw__compute_basic__eu_avg_ipc_rate__read

/* Compute Metrics Extended Gen9 :: EU AVG IPC Rate */
#define cflgt2__compute_extended__eu_avg_ipc_rate__max \
    bdw__compute_basic__eu_avg_ipc_rate__max

/* Compute Metrics Extended Gen9 :: EU Send Pipe Active */
#define cflgt2__compute_extended__eu_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Compute Metrics Extended Gen9 :: EU Thread Occupancy */
#define cflgt2__compute_extended__eu_thread_occupancy__read \
    bdw__compute_basic__eu_thread_occupancy__read

/* Compute Metrics Extended Gen9 :: Sampler Texels */
#define cflgt2__compute_extended__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Compute Metrics Extended Gen9 :: Sampler Texels Misses */
#define cflgt2__compute_extended__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Compute Metrics Extended Gen9 :: SLM Bytes Read */
#define cflgt2__compute_extended__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Compute Metrics Extended Gen9 :: SLM Bytes Read */
#define cflgt2__compute_extended__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Extended Gen9 :: SLM Bytes Written */
#define cflgt2__compute_extended__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Compute Metrics Extended Gen9 :: SLM Bytes Written */
#define cflgt2__compute_extended__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Extended Gen9 :: Shader Memory Accesses */
#define cflgt2__compute_extended__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Compute Metrics Extended Gen9 :: Shader Atomic Memory Accesses */
#define cflgt2__compute_extended__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Compute Metrics Extended Gen9 :: L3 Shader Throughput */
#define cflgt2__compute_extended__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Compute Metrics Extended Gen9 :: L3 Shader Throughput */
#define cflgt2__compute_extended__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Extended Gen9 :: Shader Barrier Messages */
#define cflgt2__compute_extended__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Compute Metrics Extended Gen9 :: EuUntypedReads0 */
#define cflgt2__compute_extended__eu_untyped_reads0__read \
    hsw__compute_extended__eu_untyped_reads0__read

/* Compute Metrics Extended Gen9 :: EuTypedReads0 */
#define cflgt2__compute_extended__eu_typed_reads0__read \
    hsw__compute_extended__eu_typed_reads0__read

/* Compute Metrics Extended Gen9 :: EuUntypedWrites0 */
#define cflgt2__compute_extended__eu_untyped_writes0__read \
    hsw__compute_extended__eu_untyped_writes0__read

/* Compute Metrics Extended Gen9 :: EuTypedWrites0 */
#define cflgt2__compute_extended__eu_typed_writes0__read \
    hsw__compute_extended__eu_typed_writes0__read

/* Compute Metrics Extended Gen9 :: EuUntypedAtomics0 */
#define cflgt2__compute_extended__eu_untyped_atomics0__read \
    hsw__compute_extended__eu_untyped_atomics0__read

/* Compute Metrics Extended Gen9 :: EuTypedAtomics0 */
#define cflgt2__compute_extended__eu_typed_atomics0__read \
    hsw__compute_extended__eu_typed_atomics0__read

/* Compute Metrics Extended Gen9 :: EuA64UntypedReads0 */
#define cflgt2__compute_extended__eu_a64_untyped_reads0__read \
    hsw__compute_extended__eu_urb_atomics0__read

/* Compute Metrics Extended Gen9 :: EuA64UntypedWrites0 */
#define cflgt2__compute_extended__eu_a64_untyped_writes0__read \
    hsw__compute_extended__gpu_clocks__read

/* Compute Metrics Extended Gen9 :: Typed Reads 0 */
#define cflgt2__compute_extended__typed_reads0__read \
    hsw__render_basic__gpu_core_clocks__read

/* Compute Metrics Extended Gen9 :: Typed Writes 0 */
#define cflgt2__compute_extended__typed_writes0__read \
    hsw__compute_extended__typed_writes0__read

/* Compute Metrics Extended Gen9 :: Untyped Reads 0 */
#define cflgt2__compute_extended__untyped_reads0__read \
    hsw__compute_extended__untyped_reads0__read

/* Compute Metrics Extended Gen9 :: Untyped Writes 0 */
#define cflgt2__compute_extended__untyped_writes0__read \
    hsw__compute_extended__untyped_writes0__read

/* Compute Metrics Extended Gen9 :: Typed Atomics 0 */
#define cflgt2__compute_extended__typed_atomics0__read \
    hsw__compute_extended__typed_atomics0__read

/* Compute Metrics Extended Gen9 :: TypedReadsPerCacheLine */
#define cflgt2__compute_extended__typed_reads_per_cache_line__read \
    hsw__compute_extended__typed_reads_per_cache_line__read

/* Compute Metrics Extended Gen9 :: TypedWritesPerCacheLine */
#define cflgt2__compute_extended__typed_writes_per_cache_line__read \
    hsw__compute_extended__typed_writes_per_cache_line__read

/* Compute Metrics Extended Gen9 :: UntypedReadsPerCacheLine */
#define cflgt2__compute_extended__untyped_reads_per_cache_line__read \
    bdw__compute_extended__untyped_reads_per_cache_line__read

/* Compute Metrics Extended Gen9 :: UntypedWritesPerCacheLine */
#define cflgt2__compute_extended__untyped_writes_per_cache_line__read \
    bdw__compute_extended__untyped_writes_per_cache_line__read

/* Compute Metrics Extended Gen9 :: TypedAtomicsPerCacheLine */
#define cflgt2__compute_extended__typed_atomics_per_cache_line__read \
    hsw__compute_extended__typed_atomics_per_cache_line__read

/* Compute Metrics L3 Cache Gen9 :: GPU Time Elapsed */
#define cflgt2__compute_l3_cache__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Compute Metrics L3 Cache Gen9 :: GPU Core Clocks */
#define cflgt2__compute_l3_cache__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Compute Metrics L3 Cache Gen9 :: AVG GPU Core Frequency */
#define cflgt2__compute_l3_cache__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Compute Metrics L3 Cache Gen9 :: AVG GPU Core Frequency */
#define cflgt2__compute_l3_cache__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Compute Metrics L3 Cache Gen9 :: GPU Busy */
#define cflgt2__compute_l3_cache__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Compute Metrics L3 Cache Gen9 :: VS Threads Dispatched */
#define cflgt2__compute_l3_cache__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Compute Metrics L3 Cache Gen9 :: HS Threads Dispatched */
#define cflgt2__compute_l3_cache__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Compute Metrics L3 Cache Gen9 :: DS Threads Dispatched */
#define cflgt2__compute_l3_cache__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Compute Metrics L3 Cache Gen9 :: GS Threads Dispatched */
#define cflgt2__compute_l3_cache__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Compute Metrics L3 Cache Gen9 :: FS Threads Dispatched */
#define cflgt2__compute_l3_cache__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Compute Metrics L3 Cache Gen9 :: CS Threads Dispatched */
#define cflgt2__compute_l3_cache__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Compute Metrics L3 Cache Gen9 :: EU Active */
#define cflgt2__compute_l3_cache__eu_active__read \
    bdw__render_basic__eu_active__read

/* Compute Metrics L3 Cache Gen9 :: EU Stall */
#define cflgt2__compute_l3_cache__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Compute Metrics L3 Cache Gen9 :: EU Both FPU Pipes Active */
#define cflgt2__compute_l3_cache__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU0 Pipe Active */
#define cflgt2__compute_l3_cache__fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU1 Pipe Active */
#define cflgt2__compute_l3_cache__fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Compute Metrics L3 Cache Gen9 :: EU AVG IPC Rate */
#define cflgt2__compute_l3_cache__eu_avg_ipc_rate__read \
    bdw__compute_basic__eu_avg_ipc_rate__read

/* Compute Metrics L3 Cache Gen9 :: EU AVG IPC Rate */
#define cflgt2__compute_l3_cache__eu_avg_ipc_rate__max \
    bdw__compute_basic__eu_avg_ipc_rate__max

/* Compute Metrics L3 Cache Gen9 :: EU Send Pipe Active */
#define cflgt2__compute_l3_cache__eu_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU0 Hybrid Instruction */
#define cflgt2__compute_l3_cache__eu_hybrid_fpu0_instruction__read \
    bdw__compute_l3_cache__eu_hybrid_fpu0_instruction__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU1 Hybrid Instruction */
#define cflgt2__compute_l3_cache__eu_hybrid_fpu1_instruction__read \
    bdw__compute_l3_cache__eu_hybrid_fpu1_instruction__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU0 Ternary Instruction */
#define cflgt2__compute_l3_cache__eu_ternary_fpu0_instruction__read \
    bdw__render_basic__ps_fpu0_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU1 Ternary Instruction */
#define cflgt2__compute_l3_cache__eu_ternary_fpu1_instruction__read \
    bdw__render_basic__ps_fpu1_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU0 Binary Instruction */
#define cflgt2__compute_l3_cache__eu_binary_fpu0_instruction__read \
    bdw__render_basic__ps_send_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU1 Binary Instruction */
#define cflgt2__compute_l3_cache__eu_binary_fpu1_instruction__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU0 Move Instruction */
#define cflgt2__compute_l3_cache__eu_move_fpu0_instruction__read \
    bdw__compute_l3_cache__eu_move_fpu0_instruction__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU1 Move Instruction */
#define cflgt2__compute_l3_cache__eu_move_fpu1_instruction__read \
    bdw__compute_l3_cache__eu_move_fpu1_instruction__read

/* Compute Metrics L3 Cache Gen9 :: Rasterized Pixels */
#define cflgt2__compute_l3_cache__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Compute Metrics L3 Cache Gen9 :: Early Hi-Depth Test Fails */
#define cflgt2__compute_l3_cache__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Compute Metrics L3 Cache Gen9 :: Early Depth Test Fails */
#define cflgt2__compute_l3_cache__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Compute Metrics L3 Cache Gen9 :: Samples Killed in FS */
#define cflgt2__compute_l3_cache__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Compute Metrics L3 Cache Gen9 :: Pixels Failing Tests */
#define cflgt2__compute_l3_cache__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Compute Metrics L3 Cache Gen9 :: Samples Written */
#define cflgt2__compute_l3_cache__samples_written__read \
    bdw__render_basic__samples_written__read

/* Compute Metrics L3 Cache Gen9 :: Samples Blended */
#define cflgt2__compute_l3_cache__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Compute Metrics L3 Cache Gen9 :: Sampler Accesses */
#define cflgt2__compute_l3_cache__sampler_accesses__read \
    bdw__render_pipe_profile__sampler_accesses__read

/* Compute Metrics L3 Cache Gen9 :: Sampler Texels */
#define cflgt2__compute_l3_cache__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Compute Metrics L3 Cache Gen9 :: Sampler Texels Misses */
#define cflgt2__compute_l3_cache__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Compute Metrics L3 Cache Gen9 :: SLM Bytes Read */
#define cflgt2__compute_l3_cache__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Compute Metrics L3 Cache Gen9 :: SLM Bytes Read */
#define cflgt2__compute_l3_cache__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics L3 Cache Gen9 :: SLM Bytes Written */
#define cflgt2__compute_l3_cache__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Compute Metrics L3 Cache Gen9 :: SLM Bytes Written */
#define cflgt2__compute_l3_cache__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics L3 Cache Gen9 :: Shader Memory Accesses */
#define cflgt2__compute_l3_cache__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Compute Metrics L3 Cache Gen9 :: Shader Atomic Memory Accesses */
#define cflgt2__compute_l3_cache__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Compute Metrics L3 Cache Gen9 :: L3 Accesses */
#define cflgt2__compute_l3_cache__l3_accesses__read \
    sklgt2__compute_l3_cache__l3_accesses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Misses */
#define cflgt2__compute_l3_cache__l3_misses__read \
    bdw__compute_l3_cache__l3_misses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Sampler Throughput */
#define cflgt2__compute_l3_cache__l3_sampler_throughput__read \
    chv__render_basic__l3_sampler_throughput__read

/* Compute Metrics L3 Cache Gen9 :: L3 Sampler Throughput */
#define cflgt2__compute_l3_cache__l3_sampler_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics L3 Cache Gen9 :: L3 Shader Throughput */
#define cflgt2__compute_l3_cache__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Compute Metrics L3 Cache Gen9 :: L3 Shader Throughput */
#define cflgt2__compute_l3_cache__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics L3 Cache Gen9 :: L3 Total Throughput */
#define cflgt2__compute_l3_cache__l3_total_throughput__read \
    sklgt2__compute_l3_cache__l3_total_throughput__read

/* Compute Metrics L3 Cache Gen9 :: L3 Total Throughput */
#define cflgt2__compute_l3_cache__l3_total_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics L3 Cache Gen9 :: Shader Barrier Messages */
#define cflgt2__compute_l3_cache__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Compute Metrics L3 Cache Gen9 :: L3 Bank 00 Accesses */
#define cflgt2__compute_l3_cache__l3_bank00_accesses__read \
    bdw__compute_l3_cache__l3_bank00_accesses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Bank 01 Accesses */
#define cflgt2__compute_l3_cache__l3_bank01_accesses__read \
    bdw__compute_l3_cache__l3_bank01_accesses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Bank 02 Accesses */
#define cflgt2__compute_l3_cache__l3_bank02_accesses__read \
    bdw__compute_l3_cache__l3_bank02_accesses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Bank 03 Accesses */
#define cflgt2__compute_l3_cache__l3_bank03_accesses__read \
    bdw__compute_l3_cache__l3_bank03_accesses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Bank 00 IC Accesses */
#define cflgt2__compute_l3_cache__l3_bank00_ic_accesses__read \
    bdw__compute_l3_cache__l3_bank00_ic_accesses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Bank 00 IC Hits */
#define cflgt2__compute_l3_cache__l3_bank00_ic_hits__read \
    bdw__compute_l3_cache__l3_bank00_ic_hits__read

/* Compute Metrics L3 Cache Gen9 :: GTI L3 Throughput */
#define cflgt2__compute_l3_cache__gti_l3_throughput__read \
    bdw__compute_l3_cache__gti_l3_throughput__read

/* Compute Metrics L3 Cache Gen9 :: GTI L3 Throughput */
#define cflgt2__compute_l3_cache__gti_l3_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics L3 Cache Gen9 :: GTI Read Throughput */
#define cflgt2__compute_l3_cache__gti_read_throughput__read \
    bdw__render_basic__gti_read_throughput__read

/* Compute Metrics L3 Cache Gen9 :: GTI Read Throughput */
#define cflgt2__compute_l3_cache__gti_read_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Compute Metrics L3 Cache Gen9 :: GTI Write Throughput */
#define cflgt2__compute_l3_cache__gti_write_throughput__read \
    hsw__render_basic__gti_write_throughput__read

/* Compute Metrics L3 Cache Gen9 :: GTI Write Throughput */
#define cflgt2__compute_l3_cache__gti_write_throughput__max \
    bdw__render_basic__gti_write_throughput__max

/* Metric set HDCAndSF :: GPU Time Elapsed */
#define cflgt2__hdc_and_sf__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set HDCAndSF :: GPU Core Clocks */
#define cflgt2__hdc_and_sf__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set HDCAndSF :: AVG GPU Core Frequency */
#define cflgt2__hdc_and_sf__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set HDCAndSF :: AVG GPU Core Frequency */
#define cflgt2__hdc_and_sf__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set HDCAndSF :: GPU Busy */
#define cflgt2__hdc_and_sf__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set HDCAndSF :: VS Threads Dispatched */
#define cflgt2__hdc_and_sf__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set HDCAndSF :: HS Threads Dispatched */
#define cflgt2__hdc_and_sf__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set HDCAndSF :: DS Threads Dispatched */
#define cflgt2__hdc_and_sf__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set HDCAndSF :: GS Threads Dispatched */
#define cflgt2__hdc_and_sf__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set HDCAndSF :: FS Threads Dispatched */
#define cflgt2__hdc_and_sf__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set HDCAndSF :: CS Threads Dispatched */
#define cflgt2__hdc_and_sf__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set HDCAndSF :: EU Active */
#define cflgt2__hdc_and_sf__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set HDCAndSF :: EU Stall */
#define cflgt2__hdc_and_sf__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set HDCAndSF :: EU Both FPU Pipes Active */
#define cflgt2__hdc_and_sf__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set HDCAndSF :: VS FPU0 Pipe Active */
#define cflgt2__hdc_and_sf__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set HDCAndSF :: VS FPU1 Pipe Active */
#define cflgt2__hdc_and_sf__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set HDCAndSF :: VS Send Pipe Active */
#define cflgt2__hdc_and_sf__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set HDCAndSF :: PS FPU0 Pipe Active */
#define cflgt2__hdc_and_sf__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set HDCAndSF :: PS FPU1 Pipe Active */
#define cflgt2__hdc_and_sf__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set HDCAndSF :: PS Send Pipeline Active */
#define cflgt2__hdc_and_sf__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set HDCAndSF :: FS Both FPU Active */
#define cflgt2__hdc_and_sf__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set HDCAndSF :: Rasterized Pixels */
#define cflgt2__hdc_and_sf__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set HDCAndSF :: Early Hi-Depth Test Fails */
#define cflgt2__hdc_and_sf__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set HDCAndSF :: Early Depth Test Fails */
#define cflgt2__hdc_and_sf__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set HDCAndSF :: Samples Killed in FS */
#define cflgt2__hdc_and_sf__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set HDCAndSF :: Pixels Failing Tests */
#define cflgt2__hdc_and_sf__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set HDCAndSF :: Samples Written */
#define cflgt2__hdc_and_sf__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set HDCAndSF :: Samples Blended */
#define cflgt2__hdc_and_sf__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set HDCAndSF :: Sampler Texels */
#define cflgt2__hdc_and_sf__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set HDCAndSF :: Sampler Texels Misses */
#define cflgt2__hdc_and_sf__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set HDCAndSF :: SLM Bytes Read */
#define cflgt2__hdc_and_sf__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set HDCAndSF :: SLM Bytes Read */
#define cflgt2__hdc_and_sf__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set HDCAndSF :: SLM Bytes Written */
#define cflgt2__hdc_and_sf__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set HDCAndSF :: SLM Bytes Written */
#define cflgt2__hdc_and_sf__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set HDCAndSF :: Shader Memory Accesses */
#define cflgt2__hdc_and_sf__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set HDCAndSF :: Shader Atomic Memory Accesses */
#define cflgt2__hdc_and_sf__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set HDCAndSF :: L3 Shader Throughput */
#define cflgt2__hdc_and_sf__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set HDCAndSF :: L3 Shader Throughput */
#define cflgt2__hdc_and_sf__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set HDCAndSF :: Shader Barrier Messages */
#define cflgt2__hdc_and_sf__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set HDCAndSF :: Polygon Data Ready */
#define cflgt2__hdc_and_sf__poly_data_ready__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set HDCAndSF :: HDC stalled by L3 (s0.ss0) */
#define cflgt2__hdc_and_sf__non_sampler_shader00_access_stalled_on_l3__read \
    bdw__hdc_and_sf__non_sampler_shader02_access_stalled_on_l3__read

/* Metric set HDCAndSF :: HDC stalled by L3 (s0.ss1) */
#define cflgt2__hdc_and_sf__non_sampler_shader01_access_stalled_on_l3__read \
    bdw__hdc_and_sf__non_sampler_shader01_access_stalled_on_l3__read

/* Metric set HDCAndSF :: HDC stalled by L3 (s0.ss2) */
#define cflgt2__hdc_and_sf__non_sampler_shader02_access_stalled_on_l3__read \
    bdw__hdc_and_sf__non_sampler_shader00_access_stalled_on_l3__read

/* Metric set HDCAndSF :: SQ is full */
#define cflgt2__hdc_and_sf__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set L3_1 :: GPU Time Elapsed */
#define cflgt2__l3_1__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set L3_1 :: GPU Core Clocks */
#define cflgt2__l3_1__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set L3_1 :: AVG GPU Core Frequency */
#define cflgt2__l3_1__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set L3_1 :: AVG GPU Core Frequency */
#define cflgt2__l3_1__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set L3_1 :: GPU Busy */
#define cflgt2__l3_1__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set L3_1 :: VS Threads Dispatched */
#define cflgt2__l3_1__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set L3_1 :: HS Threads Dispatched */
#define cflgt2__l3_1__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set L3_1 :: DS Threads Dispatched */
#define cflgt2__l3_1__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set L3_1 :: GS Threads Dispatched */
#define cflgt2__l3_1__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set L3_1 :: FS Threads Dispatched */
#define cflgt2__l3_1__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set L3_1 :: CS Threads Dispatched */
#define cflgt2__l3_1__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set L3_1 :: EU Active */
#define cflgt2__l3_1__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set L3_1 :: EU Stall */
#define cflgt2__l3_1__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set L3_1 :: EU Both FPU Pipes Active */
#define cflgt2__l3_1__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set L3_1 :: VS FPU0 Pipe Active */
#define cflgt2__l3_1__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set L3_1 :: VS FPU1 Pipe Active */
#define cflgt2__l3_1__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set L3_1 :: VS Send Pipe Active */
#define cflgt2__l3_1__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set L3_1 :: PS FPU0 Pipe Active */
#define cflgt2__l3_1__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set L3_1 :: PS FPU1 Pipe Active */
#define cflgt2__l3_1__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set L3_1 :: PS Send Pipeline Active */
#define cflgt2__l3_1__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set L3_1 :: FS Both FPU Active */
#define cflgt2__l3_1__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set L3_1 :: Rasterized Pixels */
#define cflgt2__l3_1__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set L3_1 :: Early Hi-Depth Test Fails */
#define cflgt2__l3_1__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set L3_1 :: Early Depth Test Fails */
#define cflgt2__l3_1__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set L3_1 :: Samples Killed in FS */
#define cflgt2__l3_1__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set L3_1 :: Pixels Failing Tests */
#define cflgt2__l3_1__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set L3_1 :: Samples Written */
#define cflgt2__l3_1__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set L3_1 :: Samples Blended */
#define cflgt2__l3_1__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set L3_1 :: Sampler Texels */
#define cflgt2__l3_1__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set L3_1 :: Sampler Texels Misses */
#define cflgt2__l3_1__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set L3_1 :: SLM Bytes Read */
#define cflgt2__l3_1__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set L3_1 :: SLM Bytes Read */
#define cflgt2__l3_1__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_1 :: SLM Bytes Written */
#define cflgt2__l3_1__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set L3_1 :: SLM Bytes Written */
#define cflgt2__l3_1__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_1 :: Shader Memory Accesses */
#define cflgt2__l3_1__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set L3_1 :: Shader Atomic Memory Accesses */
#define cflgt2__l3_1__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set L3_1 :: L3 Shader Throughput */
#define cflgt2__l3_1__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set L3_1 :: L3 Shader Throughput */
#define cflgt2__l3_1__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_1 :: Shader Barrier Messages */
#define cflgt2__l3_1__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set L3_1 :: Slice0 L3 Bank0 Stalled */
#define cflgt2__l3_1__l30_bank0_stalled__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set L3_1 :: Slice0 L3 Bank1 Stalled */
#define cflgt2__l3_1__l30_bank1_stalled__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* Metric set L3_1 :: Slice0 L3 Bank1 Active */
#define cflgt2__l3_1__l30_bank1_active__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set L3_1 :: Slice0 L3 Bank0 Active */
#define cflgt2__l3_1__l30_bank0_active__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set L3_1 :: SQ is full */
#define cflgt2__l3_1__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set L3_2 :: GPU Time Elapsed */
#define cflgt2__l3_2__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set L3_2 :: GPU Core Clocks */
#define cflgt2__l3_2__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set L3_2 :: AVG GPU Core Frequency */
#define cflgt2__l3_2__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set L3_2 :: AVG GPU Core Frequency */
#define cflgt2__l3_2__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set L3_2 :: GPU Busy */
#define cflgt2__l3_2__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set L3_2 :: VS Threads Dispatched */
#define cflgt2__l3_2__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set L3_2 :: HS Threads Dispatched */
#define cflgt2__l3_2__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set L3_2 :: DS Threads Dispatched */
#define cflgt2__l3_2__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set L3_2 :: GS Threads Dispatched */
#define cflgt2__l3_2__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set L3_2 :: FS Threads Dispatched */
#define cflgt2__l3_2__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set L3_2 :: CS Threads Dispatched */
#define cflgt2__l3_2__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set L3_2 :: EU Active */
#define cflgt2__l3_2__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set L3_2 :: EU Stall */
#define cflgt2__l3_2__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set L3_2 :: EU Both FPU Pipes Active */
#define cflgt2__l3_2__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set L3_2 :: VS FPU0 Pipe Active */
#define cflgt2__l3_2__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set L3_2 :: VS FPU1 Pipe Active */
#define cflgt2__l3_2__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set L3_2 :: VS Send Pipe Active */
#define cflgt2__l3_2__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set L3_2 :: PS FPU0 Pipe Active */
#define cflgt2__l3_2__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set L3_2 :: PS FPU1 Pipe Active */
#define cflgt2__l3_2__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set L3_2 :: PS Send Pipeline Active */
#define cflgt2__l3_2__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set L3_2 :: FS Both FPU Active */
#define cflgt2__l3_2__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set L3_2 :: Rasterized Pixels */
#define cflgt2__l3_2__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set L3_2 :: Early Hi-Depth Test Fails */
#define cflgt2__l3_2__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set L3_2 :: Early Depth Test Fails */
#define cflgt2__l3_2__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set L3_2 :: Samples Killed in FS */
#define cflgt2__l3_2__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set L3_2 :: Pixels Failing Tests */
#define cflgt2__l3_2__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set L3_2 :: Samples Written */
#define cflgt2__l3_2__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set L3_2 :: Samples Blended */
#define cflgt2__l3_2__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set L3_2 :: Sampler Texels */
#define cflgt2__l3_2__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set L3_2 :: Sampler Texels Misses */
#define cflgt2__l3_2__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set L3_2 :: SLM Bytes Read */
#define cflgt2__l3_2__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set L3_2 :: SLM Bytes Read */
#define cflgt2__l3_2__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_2 :: SLM Bytes Written */
#define cflgt2__l3_2__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set L3_2 :: SLM Bytes Written */
#define cflgt2__l3_2__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_2 :: Shader Memory Accesses */
#define cflgt2__l3_2__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set L3_2 :: Shader Atomic Memory Accesses */
#define cflgt2__l3_2__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set L3_2 :: L3 Shader Throughput */
#define cflgt2__l3_2__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set L3_2 :: L3 Shader Throughput */
#define cflgt2__l3_2__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_2 :: Shader Barrier Messages */
#define cflgt2__l3_2__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set L3_2 :: Slice0 L3 Bank2 Stalled */
#define cflgt2__l3_2__l30_bank2_stalled__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set L3_2 :: Slice0 L3 Bank2 Active */
#define cflgt2__l3_2__l30_bank2_active__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set L3_2 :: SQ is full */
#define cflgt2__l3_2__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set L3_3 :: GPU Time Elapsed */
#define cflgt2__l3_3__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set L3_3 :: GPU Core Clocks */
#define cflgt2__l3_3__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set L3_3 :: AVG GPU Core Frequency */
#define cflgt2__l3_3__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set L3_3 :: AVG GPU Core Frequency */
#define cflgt2__l3_3__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set L3_3 :: GPU Busy */
#define cflgt2__l3_3__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set L3_3 :: VS Threads Dispatched */
#define cflgt2__l3_3__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set L3_3 :: HS Threads Dispatched */
#define cflgt2__l3_3__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set L3_3 :: DS Threads Dispatched */
#define cflgt2__l3_3__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set L3_3 :: GS Threads Dispatched */
#define cflgt2__l3_3__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set L3_3 :: FS Threads Dispatched */
#define cflgt2__l3_3__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set L3_3 :: CS Threads Dispatched */
#define cflgt2__l3_3__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set L3_3 :: EU Active */
#define cflgt2__l3_3__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set L3_3 :: EU Stall */
#define cflgt2__l3_3__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set L3_3 :: EU Both FPU Pipes Active */
#define cflgt2__l3_3__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set L3_3 :: VS FPU0 Pipe Active */
#define cflgt2__l3_3__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set L3_3 :: VS FPU1 Pipe Active */
#define cflgt2__l3_3__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set L3_3 :: VS Send Pipe Active */
#define cflgt2__l3_3__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set L3_3 :: PS FPU0 Pipe Active */
#define cflgt2__l3_3__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set L3_3 :: PS FPU1 Pipe Active */
#define cflgt2__l3_3__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set L3_3 :: PS Send Pipeline Active */
#define cflgt2__l3_3__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set L3_3 :: FS Both FPU Active */
#define cflgt2__l3_3__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set L3_3 :: Rasterized Pixels */
#define cflgt2__l3_3__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set L3_3 :: Early Hi-Depth Test Fails */
#define cflgt2__l3_3__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set L3_3 :: Early Depth Test Fails */
#define cflgt2__l3_3__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set L3_3 :: Samples Killed in FS */
#define cflgt2__l3_3__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set L3_3 :: Pixels Failing Tests */
#define cflgt2__l3_3__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set L3_3 :: Samples Written */
#define cflgt2__l3_3__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set L3_3 :: Samples Blended */
#define cflgt2__l3_3__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set L3_3 :: Sampler Texels */
#define cflgt2__l3_3__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set L3_3 :: Sampler Texels Misses */
#define cflgt2__l3_3__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set L3_3 :: SLM Bytes Read */
#define cflgt2__l3_3__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set L3_3 :: SLM Bytes Read */
#define cflgt2__l3_3__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_3 :: SLM Bytes Written */
#define cflgt2__l3_3__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set L3_3 :: SLM Bytes Written */
#define cflgt2__l3_3__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_3 :: Shader Memory Accesses */
#define cflgt2__l3_3__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set L3_3 :: Shader Atomic Memory Accesses */
#define cflgt2__l3_3__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set L3_3 :: L3 Shader Throughput */
#define cflgt2__l3_3__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set L3_3 :: L3 Shader Throughput */
#define cflgt2__l3_3__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_3 :: Shader Barrier Messages */
#define cflgt2__l3_3__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set L3_3 :: Slice0 L3 Bank3 Stalled */
#define cflgt2__l3_3__l30_bank3_stalled__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set L3_3 :: Slice0 L3 Bank3 Active */
#define cflgt2__l3_3__l30_bank3_active__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set L3_3 :: SQ is full */
#define cflgt2__l3_3__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set RasterizerAndPixelBackend :: GPU Time Elapsed */
#define cflgt2__rasterizer_and_pixel_backend__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set RasterizerAndPixelBackend :: GPU Core Clocks */
#define cflgt2__rasterizer_and_pixel_backend__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set RasterizerAndPixelBackend :: AVG GPU Core Frequency */
#define cflgt2__rasterizer_and_pixel_backend__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set RasterizerAndPixelBackend :: AVG GPU Core Frequency */
#define cflgt2__rasterizer_and_pixel_backend__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set RasterizerAndPixelBackend :: GPU Busy */
#define cflgt2__rasterizer_and_pixel_backend__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set RasterizerAndPixelBackend :: VS Threads Dispatched */
#define cflgt2__rasterizer_and_pixel_backend__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set RasterizerAndPixelBackend :: HS Threads Dispatched */
#define cflgt2__rasterizer_and_pixel_backend__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set RasterizerAndPixelBackend :: DS Threads Dispatched */
#define cflgt2__rasterizer_and_pixel_backend__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set RasterizerAndPixelBackend :: GS Threads Dispatched */
#define cflgt2__rasterizer_and_pixel_backend__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set RasterizerAndPixelBackend :: FS Threads Dispatched */
#define cflgt2__rasterizer_and_pixel_backend__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set RasterizerAndPixelBackend :: CS Threads Dispatched */
#define cflgt2__rasterizer_and_pixel_backend__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set RasterizerAndPixelBackend :: EU Active */
#define cflgt2__rasterizer_and_pixel_backend__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set RasterizerAndPixelBackend :: EU Stall */
#define cflgt2__rasterizer_and_pixel_backend__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set RasterizerAndPixelBackend :: EU Both FPU Pipes Active */
#define cflgt2__rasterizer_and_pixel_backend__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set RasterizerAndPixelBackend :: VS FPU0 Pipe Active */
#define cflgt2__rasterizer_and_pixel_backend__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set RasterizerAndPixelBackend :: VS FPU1 Pipe Active */
#define cflgt2__rasterizer_and_pixel_backend__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set RasterizerAndPixelBackend :: VS Send Pipe Active */
#define cflgt2__rasterizer_and_pixel_backend__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set RasterizerAndPixelBackend :: PS FPU0 Pipe Active */
#define cflgt2__rasterizer_and_pixel_backend__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set RasterizerAndPixelBackend :: PS FPU1 Pipe Active */
#define cflgt2__rasterizer_and_pixel_backend__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set RasterizerAndPixelBackend :: PS Send Pipeline Active */
#define cflgt2__rasterizer_and_pixel_backend__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set RasterizerAndPixelBackend :: FS Both FPU Active */
#define cflgt2__rasterizer_and_pixel_backend__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set RasterizerAndPixelBackend :: Rasterized Pixels */
#define cflgt2__rasterizer_and_pixel_backend__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set RasterizerAndPixelBackend :: Early Hi-Depth Test Fails */
#define cflgt2__rasterizer_and_pixel_backend__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set RasterizerAndPixelBackend :: Early Depth Test Fails */
#define cflgt2__rasterizer_and_pixel_backend__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set RasterizerAndPixelBackend :: Samples Killed in FS */
#define cflgt2__rasterizer_and_pixel_backend__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set RasterizerAndPixelBackend :: Pixels Failing Tests */
#define cflgt2__rasterizer_and_pixel_backend__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set RasterizerAndPixelBackend :: Samples Written */
#define cflgt2__rasterizer_and_pixel_backend__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set RasterizerAndPixelBackend :: Samples Blended */
#define cflgt2__rasterizer_and_pixel_backend__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set RasterizerAndPixelBackend :: Sampler Texels */
#define cflgt2__rasterizer_and_pixel_backend__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set RasterizerAndPixelBackend :: Sampler Texels Misses */
#define cflgt2__rasterizer_and_pixel_backend__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Read */
#define cflgt2__rasterizer_and_pixel_backend__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Read */
#define cflgt2__rasterizer_and_pixel_backend__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Written */
#define cflgt2__rasterizer_and_pixel_backend__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Written */
#define cflgt2__rasterizer_and_pixel_backend__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set RasterizerAndPixelBackend :: Shader Memory Accesses */
#define cflgt2__rasterizer_and_pixel_backend__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set RasterizerAndPixelBackend :: Shader Atomic Memory Accesses */
#define cflgt2__rasterizer_and_pixel_backend__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set RasterizerAndPixelBackend :: L3 Shader Throughput */
#define cflgt2__rasterizer_and_pixel_backend__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set RasterizerAndPixelBackend :: L3 Shader Throughput */
#define cflgt2__rasterizer_and_pixel_backend__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set RasterizerAndPixelBackend :: Shader Barrier Messages */
#define cflgt2__rasterizer_and_pixel_backend__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Post-EarlyZ Pixel Data Ready */
#define cflgt2__rasterizer_and_pixel_backend__pixel_data0_ready__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Rasterizer Input Available */
#define cflgt2__rasterizer_and_pixel_backend__rasterizer0_input_available__read \
    bdw__render_basic__sampler1_busy__read

/* Metric set RasterizerAndPixelBackend :: Slice0 PS Output Available */
#define cflgt2__rasterizer_and_pixel_backend__ps_output0_available__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Pixel Values Ready */
#define cflgt2__rasterizer_and_pixel_backend__pixel_values0_ready__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Rasterizer Output Ready */
#define cflgt2__rasterizer_and_pixel_backend__rasterizer0_output_ready__read \
    bdw__render_pipe_profile__sf_stall__read

/* Metric set RasterizerAndPixelBackend :: SQ is full */
#define cflgt2__rasterizer_and_pixel_backend__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set Sampler :: GPU Time Elapsed */
#define cflgt2__sampler__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set Sampler :: GPU Core Clocks */
#define cflgt2__sampler__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set Sampler :: AVG GPU Core Frequency */
#define cflgt2__sampler__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set Sampler :: AVG GPU Core Frequency */
#define cflgt2__sampler__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set Sampler :: GPU Busy */
#define cflgt2__sampler__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set Sampler :: VS Threads Dispatched */
#define cflgt2__sampler__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set Sampler :: HS Threads Dispatched */
#define cflgt2__sampler__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set Sampler :: DS Threads Dispatched */
#define cflgt2__sampler__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set Sampler :: GS Threads Dispatched */
#define cflgt2__sampler__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set Sampler :: FS Threads Dispatched */
#define cflgt2__sampler__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set Sampler :: CS Threads Dispatched */
#define cflgt2__sampler__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set Sampler :: EU Active */
#define cflgt2__sampler__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set Sampler :: EU Stall */
#define cflgt2__sampler__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set Sampler :: EU Both FPU Pipes Active */
#define cflgt2__sampler__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set Sampler :: VS FPU0 Pipe Active */
#define cflgt2__sampler__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set Sampler :: VS FPU1 Pipe Active */
#define cflgt2__sampler__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set Sampler :: VS Send Pipe Active */
#define cflgt2__sampler__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set Sampler :: PS FPU0 Pipe Active */
#define cflgt2__sampler__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set Sampler :: PS FPU1 Pipe Active */
#define cflgt2__sampler__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set Sampler :: PS Send Pipeline Active */
#define cflgt2__sampler__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set Sampler :: FS Both FPU Active */
#define cflgt2__sampler__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set Sampler :: Rasterized Pixels */
#define cflgt2__sampler__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set Sampler :: Early Hi-Depth Test Fails */
#define cflgt2__sampler__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set Sampler :: Early Depth Test Fails */
#define cflgt2__sampler__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set Sampler :: Samples Killed in FS */
#define cflgt2__sampler__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set Sampler :: Pixels Failing Tests */
#define cflgt2__sampler__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set Sampler :: Samples Written */
#define cflgt2__sampler__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set Sampler :: Samples Blended */
#define cflgt2__sampler__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set Sampler :: Sampler Texels */
#define cflgt2__sampler__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set Sampler :: Sampler Texels Misses */
#define cflgt2__sampler__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set Sampler :: SLM Bytes Read */
#define cflgt2__sampler__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set Sampler :: SLM Bytes Read */
#define cflgt2__sampler__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set Sampler :: SLM Bytes Written */
#define cflgt2__sampler__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set Sampler :: SLM Bytes Written */
#define cflgt2__sampler__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set Sampler :: Shader Memory Accesses */
#define cflgt2__sampler__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set Sampler :: Shader Atomic Memory Accesses */
#define cflgt2__sampler__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set Sampler :: L3 Shader Throughput */
#define cflgt2__sampler__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set Sampler :: L3 Shader Throughput */
#define cflgt2__sampler__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set Sampler :: Shader Barrier Messages */
#define cflgt2__sampler__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set Sampler :: Slice0 Subslice1 Input Available */
#define cflgt2__sampler__sampler01_input_available__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set Sampler :: Slice0 Subslice2 Input Available */
#define cflgt2__sampler__sampler02_input_available__read \
    bdw__render_basic__sampler1_busy__read

/* Metric set Sampler :: Slice0 Subslice0 Input Available */
#define cflgt2__sampler__sampler00_input_available__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Metric set Sampler :: Slice0 Subslice2 Sampler Output Ready */
#define cflgt2__sampler__sampler02_output_ready__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set Sampler :: Slice0 Subslice0 Sampler Output Ready */
#define cflgt2__sampler__sampler00_output_ready__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set Sampler :: Slice0 Subslice1 Sampler Output Ready */
#define cflgt2__sampler__sampler01_output_ready__read \
    bdw__render_pipe_profile__sf_stall__read

/* Metric set Sampler :: SQ is full */
#define cflgt2__sampler__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set TDL_1 :: GPU Time Elapsed */
#define cflgt2__tdl_1__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set TDL_1 :: GPU Core Clocks */
#define cflgt2__tdl_1__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set TDL_1 :: AVG GPU Core Frequency */
#define cflgt2__tdl_1__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set TDL_1 :: AVG GPU Core Frequency */
#define cflgt2__tdl_1__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set TDL_1 :: GPU Busy */
#define cflgt2__tdl_1__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set TDL_1 :: VS Threads Dispatched */
#define cflgt2__tdl_1__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set TDL_1 :: HS Threads Dispatched */
#define cflgt2__tdl_1__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set TDL_1 :: DS Threads Dispatched */
#define cflgt2__tdl_1__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set TDL_1 :: GS Threads Dispatched */
#define cflgt2__tdl_1__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set TDL_1 :: FS Threads Dispatched */
#define cflgt2__tdl_1__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set TDL_1 :: CS Threads Dispatched */
#define cflgt2__tdl_1__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set TDL_1 :: EU Active */
#define cflgt2__tdl_1__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set TDL_1 :: EU Stall */
#define cflgt2__tdl_1__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set TDL_1 :: EU Both FPU Pipes Active */
#define cflgt2__tdl_1__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set TDL_1 :: VS FPU0 Pipe Active */
#define cflgt2__tdl_1__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set TDL_1 :: VS FPU1 Pipe Active */
#define cflgt2__tdl_1__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set TDL_1 :: VS Send Pipe Active */
#define cflgt2__tdl_1__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set TDL_1 :: PS FPU0 Pipe Active */
#define cflgt2__tdl_1__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set TDL_1 :: PS FPU1 Pipe Active */
#define cflgt2__tdl_1__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set TDL_1 :: PS Send Pipeline Active */
#define cflgt2__tdl_1__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set TDL_1 :: FS Both FPU Active */
#define cflgt2__tdl_1__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set TDL_1 :: Rasterized Pixels */
#define cflgt2__tdl_1__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set TDL_1 :: Early Hi-Depth Test Fails */
#define cflgt2__tdl_1__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set TDL_1 :: Early Depth Test Fails */
#define cflgt2__tdl_1__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set TDL_1 :: Samples Killed in FS */
#define cflgt2__tdl_1__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set TDL_1 :: Pixels Failing Tests */
#define cflgt2__tdl_1__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set TDL_1 :: Samples Written */
#define cflgt2__tdl_1__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set TDL_1 :: Samples Blended */
#define cflgt2__tdl_1__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set TDL_1 :: Sampler Texels */
#define cflgt2__tdl_1__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set TDL_1 :: Sampler Texels Misses */
#define cflgt2__tdl_1__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set TDL_1 :: SLM Bytes Read */
#define cflgt2__tdl_1__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set TDL_1 :: SLM Bytes Read */
#define cflgt2__tdl_1__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_1 :: SLM Bytes Written */
#define cflgt2__tdl_1__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set TDL_1 :: SLM Bytes Written */
#define cflgt2__tdl_1__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_1 :: Shader Memory Accesses */
#define cflgt2__tdl_1__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set TDL_1 :: Shader Atomic Memory Accesses */
#define cflgt2__tdl_1__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set TDL_1 :: L3 Shader Throughput */
#define cflgt2__tdl_1__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set TDL_1 :: L3 Shader Throughput */
#define cflgt2__tdl_1__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_1 :: Shader Barrier Messages */
#define cflgt2__tdl_1__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set TDL_1 :: NonPS Thread Ready For Dispatch on Slice0 Subslice1 */
#define cflgt2__tdl_1__non_ps_thread01_ready_for_dispatch__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set TDL_1 :: PS Thread Ready For Dispatch on Slice0 Subslice0 */
#define cflgt2__tdl_1__ps_thread00_ready_for_dispatch__read \
    bdw__render_basic__sampler1_busy__read

/* Metric set TDL_1 :: NonPS Thread Ready For Dispatch on Slice0 Subslice0 */
#define cflgt2__tdl_1__non_ps_thread00_ready_for_dispatch__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Metric set TDL_1 :: PS Thread Ready For Dispatch on Slice0 Subslice2 */
#define cflgt2__tdl_1__ps_thread02_ready_for_dispatch__read \
    bdw__render_basic__sampler1_bottleneck__read

/* Metric set TDL_1 :: NonPS Thread Ready For Dispatch on Slice0 Subslice2 */
#define cflgt2__tdl_1__non_ps_thread02_ready_for_dispatch__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* Metric set TDL_1 :: PS Thread Ready For Dispatch on Slice0 Subslice1 */
#define cflgt2__tdl_1__ps_thread01_ready_for_dispatch__read \
    bdw__render_pipe_profile__cl_bottleneck__read

/* Metric set TDL_1 :: SQ is full */
#define cflgt2__tdl_1__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set TDL_2 :: GPU Time Elapsed */
#define cflgt2__tdl_2__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set TDL_2 :: GPU Core Clocks */
#define cflgt2__tdl_2__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set TDL_2 :: AVG GPU Core Frequency */
#define cflgt2__tdl_2__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set TDL_2 :: AVG GPU Core Frequency */
#define cflgt2__tdl_2__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set TDL_2 :: GPU Busy */
#define cflgt2__tdl_2__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set TDL_2 :: VS Threads Dispatched */
#define cflgt2__tdl_2__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set TDL_2 :: HS Threads Dispatched */
#define cflgt2__tdl_2__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set TDL_2 :: DS Threads Dispatched */
#define cflgt2__tdl_2__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set TDL_2 :: GS Threads Dispatched */
#define cflgt2__tdl_2__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set TDL_2 :: FS Threads Dispatched */
#define cflgt2__tdl_2__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set TDL_2 :: CS Threads Dispatched */
#define cflgt2__tdl_2__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set TDL_2 :: EU Active */
#define cflgt2__tdl_2__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set TDL_2 :: EU Stall */
#define cflgt2__tdl_2__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set TDL_2 :: EU Both FPU Pipes Active */
#define cflgt2__tdl_2__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set TDL_2 :: VS FPU0 Pipe Active */
#define cflgt2__tdl_2__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set TDL_2 :: VS FPU1 Pipe Active */
#define cflgt2__tdl_2__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set TDL_2 :: VS Send Pipe Active */
#define cflgt2__tdl_2__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set TDL_2 :: PS FPU0 Pipe Active */
#define cflgt2__tdl_2__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set TDL_2 :: PS FPU1 Pipe Active */
#define cflgt2__tdl_2__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set TDL_2 :: PS Send Pipeline Active */
#define cflgt2__tdl_2__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set TDL_2 :: FS Both FPU Active */
#define cflgt2__tdl_2__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set TDL_2 :: Rasterized Pixels */
#define cflgt2__tdl_2__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set TDL_2 :: Early Hi-Depth Test Fails */
#define cflgt2__tdl_2__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set TDL_2 :: Early Depth Test Fails */
#define cflgt2__tdl_2__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set TDL_2 :: Samples Killed in FS */
#define cflgt2__tdl_2__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set TDL_2 :: Pixels Failing Tests */
#define cflgt2__tdl_2__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set TDL_2 :: Samples Written */
#define cflgt2__tdl_2__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set TDL_2 :: Samples Blended */
#define cflgt2__tdl_2__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set TDL_2 :: Sampler Texels */
#define cflgt2__tdl_2__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set TDL_2 :: Sampler Texels Misses */
#define cflgt2__tdl_2__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set TDL_2 :: SLM Bytes Read */
#define cflgt2__tdl_2__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set TDL_2 :: SLM Bytes Read */
#define cflgt2__tdl_2__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_2 :: SLM Bytes Written */
#define cflgt2__tdl_2__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set TDL_2 :: SLM Bytes Written */
#define cflgt2__tdl_2__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_2 :: Shader Memory Accesses */
#define cflgt2__tdl_2__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set TDL_2 :: Shader Atomic Memory Accesses */
#define cflgt2__tdl_2__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set TDL_2 :: L3 Shader Throughput */
#define cflgt2__tdl_2__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set TDL_2 :: L3 Shader Throughput */
#define cflgt2__tdl_2__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_2 :: Shader Barrier Messages */
#define cflgt2__tdl_2__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice1 Port 0 */
#define cflgt2__tdl_2__thread_header01_ready_port0__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice0 Port 1 */
#define cflgt2__tdl_2__thread_header00_ready_port1__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice0 Port 0 */
#define cflgt2__tdl_2__thread_header00_ready_port0__read \
    bdw__render_pipe_profile__sf_stall__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice2 Port 1 */
#define cflgt2__tdl_2__thread_header02_ready_port1__read \
    bdw__render_pipe_profile__cl_stall__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice2 Port 0 */
#define cflgt2__tdl_2__thread_header02_ready_port0__read \
    bdw__render_pipe_profile__so_stall__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice1 Port 1 */
#define cflgt2__tdl_2__thread_header01_ready_port1__read \
    bdw__render_pipe_profile__ds_stall__read

/* Metric set TDL_2 :: SQ is full */
#define cflgt2__tdl_2__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Compute Metrics Extra Gen9 :: GPU Time Elapsed */
#define cflgt2__compute_extra__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Compute Metrics Extra Gen9 :: GPU Core Clocks */
#define cflgt2__compute_extra__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Compute Metrics Extra Gen9 :: AVG GPU Core Frequency */
#define cflgt2__compute_extra__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Compute Metrics Extra Gen9 :: AVG GPU Core Frequency */
#define cflgt2__compute_extra__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Compute Metrics Extra Gen9 :: EU FPU1 Pipe Active */
#define cflgt2__compute_extra__fpu1_active__read \
    bdw__render_basic__eu_stall__read

/* Compute Metrics Extra Gen9 :: EU FPU1 Pipe Active including Ext Math */
#define cflgt2__compute_extra__fpu1_active_adjusted__read \
    sklgt2__compute_extra__fpu1_active_adjusted__read

/* Media Vme Pipe Gen9 :: GPU Time Elapsed */
#define cflgt2__vme_pipe__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Media Vme Pipe Gen9 :: GPU Core Clocks */
#define cflgt2__vme_pipe__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Media Vme Pipe Gen9 :: AVG GPU Core Frequency */
#define cflgt2__vme_pipe__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Media Vme Pipe Gen9 :: AVG GPU Core Frequency */
#define cflgt2__vme_pipe__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Media Vme Pipe Gen9 :: GPU Busy */
#define cflgt2__vme_pipe__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Media Vme Pipe Gen9 :: CS Threads Dispatched */
#define cflgt2__vme_pipe__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Media Vme Pipe Gen9 :: EU Active */
#define cflgt2__vme_pipe__eu_active__read \
    bdw__render_basic__eu_active__read

/* Media Vme Pipe Gen9 :: EU Stall */
#define cflgt2__vme_pipe__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Media Vme Pipe Gen9 :: EU Both FPU Pipes Active */
#define cflgt2__vme_pipe__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Media Vme Pipe Gen9 :: EU Thread Occupancy */
#define cflgt2__vme_pipe__eu_thread_occupancy__read \
    bdw__vme_pipe__eu_thread_occupancy__read

/* Media Vme Pipe Gen9 :: VME Busy */
#define cflgt2__vme_pipe__vme_busy__read \
    bdw__vme_pipe__vme_busy__read

/* Gpu Rings Busyness :: GPU Time Elapsed */
#define cflgt2__gpu_busyness__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Gpu Rings Busyness :: GPU Core Clocks */
#define cflgt2__gpu_busyness__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Gpu Rings Busyness :: AVG GPU Core Frequency */
#define cflgt2__gpu_busyness__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Gpu Rings Busyness :: AVG GPU Core Frequency */
#define cflgt2__gpu_busyness__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Gpu Rings Busyness :: Render Ring Busy */
#define cflgt2__gpu_busyness__render_busy__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Gpu Rings Busyness :: Vdbox0 Ring Busy */
#define cflgt2__gpu_busyness__vdbox0_busy__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Gpu Rings Busyness :: Vebox Ring Busy */
#define cflgt2__gpu_busyness__vebox_busy__read \
    bdw__render_pipe_profile__sf_stall__read

/* Gpu Rings Busyness :: Blitter Ring Busy */
#define cflgt2__gpu_busyness__blitter_busy__read \
    bdw__render_pipe_profile__cl_stall__read

/* Gpu Rings Busyness :: AnyRingBusy */
#define cflgt2__gpu_busyness__any_ring_busy__read \
    bdw__render_basic__sampler0_busy__read

/* MDAPI testing set Gen9.5 :: GPU Time Elapsed */
#define cflgt2__test_oa__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* MDAPI testing set Gen9.5 :: GPU Core Clocks */
#define cflgt2__test_oa__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* MDAPI testing set Gen9.5 :: AVG GPU Core Frequency */
#define cflgt2__test_oa__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* MDAPI testing set Gen9.5 :: AVG GPU Core Frequency */
#define cflgt2__test_oa__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* MDAPI testing set Gen9.5 :: TestCounter0 */
#define cflgt2__test_oa__counter0__read \
    hsw__compute_extended__eu_untyped_reads0__read

/* MDAPI testing set Gen9.5 :: TestCounter1 */
#define cflgt2__test_oa__counter1__read \
    hsw__compute_extended__eu_untyped_writes0__read

/* MDAPI testing set Gen9.5 :: TestCounter2 */
#define cflgt2__test_oa__counter2__read \
    hsw__compute_extended__eu_typed_reads0__read

/* MDAPI testing set Gen9.5 :: TestCounter3 */
#define cflgt2__test_oa__counter3__read \
    hsw__compute_extended__eu_typed_writes0__read

/* MDAPI testing set Gen9.5 :: TestCounter4 */
#define cflgt2__test_oa__counter4__read \
    hsw__compute_extended__eu_untyped_atomics0__read

/* MDAPI testing set Gen9.5 :: TestCounter5 */
#define cflgt2__test_oa__counter5__read \
    hsw__compute_extended__eu_typed_atomics0__read

/* MDAPI testing set Gen9.5 :: TestCounter6 */
#define cflgt2__test_oa__counter6__read \
    hsw__compute_extended__eu_urb_atomics0__read

/* MDAPI testing set Gen9.5 :: TestCounter7 */
#define cflgt2__test_oa__counter7__read \
    hsw__compute_extended__gpu_clocks__read

/* MDAPI testing set Gen9.5 :: TestCounter8 */
#define cflgt2__test_oa__counter8__read \
    hsw__memory_reads__gpu_core_clocks__read

/* Metric set PMA Stall :: GPU Time Elapsed */
#define cflgt2__pma__stall__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set PMA Stall :: GPU Core Clocks */
#define cflgt2__pma__stall__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set PMA Stall :: AVG GPU Core Frequency */
#define cflgt2__pma__stall__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set PMA Stall :: AVG GPU Core Frequency */
#define cflgt2__pma__stall__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set PMA Stall :: STC PMA stall */
#define cflgt2__pma__stall__stc_pma_stall__read \
    sklgt2__pma__stall__stc_pma_stall__read

/* Render Metrics Basic Gen9 :: GPU Time Elapsed */
#define cflgt3__render_basic__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Render Metrics Basic Gen9 :: GPU Core Clocks */
#define cflgt3__render_basic__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Render Metrics Basic Gen9 :: AVG GPU Core Frequency */
#define cflgt3__render_basic__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Render Metrics Basic Gen9 :: AVG GPU Core Frequency */
#define cflgt3__render_basic__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Render Metrics Basic Gen9 :: VS Threads Dispatched */
#define cflgt3__render_basic__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Render Metrics Basic Gen9 :: HS Threads Dispatched */
#define cflgt3__render_basic__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Render Metrics Basic Gen9 :: DS Threads Dispatched */
#define cflgt3__render_basic__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Render Metrics Basic Gen9 :: GS Threads Dispatched */
#define cflgt3__render_basic__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Render Metrics Basic Gen9 :: FS Threads Dispatched */
#define cflgt3__render_basic__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Render Metrics Basic Gen9 :: CS Threads Dispatched */
#define cflgt3__render_basic__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Render Metrics Basic Gen9 :: GPU Busy */
#define cflgt3__render_basic__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Render Metrics Basic Gen9 :: EU Active */
#define cflgt3__render_basic__eu_active__read \
    bdw__render_basic__eu_active__read

/* Render Metrics Basic Gen9 :: EU Stall */
#define cflgt3__render_basic__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Render Metrics Basic Gen9 :: EU Both FPU Pipes Active */
#define cflgt3__render_basic__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Render Metrics Basic Gen9 :: VS FPU0 Pipe Active */
#define cflgt3__render_basic__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Render Metrics Basic Gen9 :: VS FPU1 Pipe Active */
#define cflgt3__render_basic__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Render Metrics Basic Gen9 :: VS Send Pipe Active */
#define cflgt3__render_basic__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Render Metrics Basic Gen9 :: PS FPU0 Pipe Active */
#define cflgt3__render_basic__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Render Metrics Basic Gen9 :: PS FPU1 Pipe Active */
#define cflgt3__render_basic__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Render Metrics Basic Gen9 :: PS Send Pipeline Active */
#define cflgt3__render_basic__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Render Metrics Basic Gen9 :: FS Both FPU Active */
#define cflgt3__render_basic__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Render Metrics Basic Gen9 :: Sampler 0 Busy */
#define cflgt3__render_basic__sampler0_busy__read \
    bdw__render_basic__sampler0_busy__read

/* Render Metrics Basic Gen9 :: Sampler 1 Busy */
#define cflgt3__render_basic__sampler1_busy__read \
    bdw__render_basic__sampler1_busy__read

/* Render Metrics Basic Gen9 :: Samplers Busy */
#define cflgt3__render_basic__samplers_busy__read \
    bdw__render_basic__samplers_busy__read

/* Render Metrics Basic Gen9 :: Sampler 0 Bottleneck */
#define cflgt3__render_basic__sampler0_bottleneck__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Render Metrics Basic Gen9 :: Sampler 1 Bottleneck */
#define cflgt3__render_basic__sampler1_bottleneck__read \
    bdw__render_basic__sampler1_bottleneck__read

/* Render Metrics Basic Gen9 :: Rasterized Pixels */
#define cflgt3__render_basic__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Render Metrics Basic Gen9 :: Early Hi-Depth Test Fails */
#define cflgt3__render_basic__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Render Metrics Basic Gen9 :: Early Depth Test Fails */
#define cflgt3__render_basic__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Render Metrics Basic Gen9 :: Samples Killed in FS */
#define cflgt3__render_basic__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Render Metrics Basic Gen9 :: Pixels Failing Tests */
#define cflgt3__render_basic__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Render Metrics Basic Gen9 :: Samples Written */
#define cflgt3__render_basic__samples_written__read \
    bdw__render_basic__samples_written__read

/* Render Metrics Basic Gen9 :: Samples Blended */
#define cflgt3__render_basic__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Render Metrics Basic Gen9 :: Sampler Texels */
#define cflgt3__render_basic__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Render Metrics Basic Gen9 :: Sampler Texels Misses */
#define cflgt3__render_basic__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Render Metrics Basic Gen9 :: Sampler Cache Misses */
#define cflgt3__render_basic__sampler_l1_misses__read \
    bdw__render_basic__sampler_l1_misses__read

/* Render Metrics Basic Gen9 :: SLM Bytes Read */
#define cflgt3__render_basic__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Render Metrics Basic Gen9 :: SLM Bytes Read */
#define cflgt3__render_basic__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics Basic Gen9 :: SLM Bytes Written */
#define cflgt3__render_basic__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Render Metrics Basic Gen9 :: SLM Bytes Written */
#define cflgt3__render_basic__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics Basic Gen9 :: Shader Memory Accesses */
#define cflgt3__render_basic__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Render Metrics Basic Gen9 :: Shader Atomic Memory Accesses */
#define cflgt3__render_basic__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Render Metrics Basic Gen9 :: L3 Lookup Accesses w/o IC */
#define cflgt3__render_basic__l3_lookups__read \
    bdw__render_basic__l3_lookups__read

/* Render Metrics Basic Gen9 :: L3 Misses */
#define cflgt3__render_basic__l3_misses__read \
    hsw__compute_extended__typed_atomics0__read

/* Render Metrics Basic Gen9 :: L3 Sampler Throughput */
#define cflgt3__render_basic__l3_sampler_throughput__read \
    bdw__render_basic__l3_sampler_throughput__read

/* Render Metrics Basic Gen9 :: L3 Sampler Throughput */
#define cflgt3__render_basic__l3_sampler_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics Basic Gen9 :: L3 Shader Throughput */
#define cflgt3__render_basic__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Render Metrics Basic Gen9 :: L3 Shader Throughput */
#define cflgt3__render_basic__l3_shader_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics Basic Gen9 :: Shader Barrier Messages */
#define cflgt3__render_basic__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Render Metrics Basic Gen9 :: GTI Fixed Pipe Throughput */
#define cflgt3__render_basic__gti_vf_throughput__read \
    bdw__render_basic__gti_vf_throughput__read

/* Render Metrics Basic Gen9 :: GTI Fixed Pipe Throughput */
#define cflgt3__render_basic__gti_vf_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Render Metrics Basic Gen9 :: GTI Depth Throughput */
#define cflgt3__render_basic__gti_depth_throughput__read \
    bdw__render_basic__gti_depth_throughput__read

/* Render Metrics Basic Gen9 :: GTI Depth Throughput */
#define cflgt3__render_basic__gti_depth_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics Basic Gen9 :: GTI RCC Throughput */
#define cflgt3__render_basic__gti_rcc_throughput__read \
    bdw__render_basic__gti_rcc_throughput__read

/* Render Metrics Basic Gen9 :: GTI RCC Throughput */
#define cflgt3__render_basic__gti_rcc_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics Basic Gen9 :: GTI L3 Throughput */
#define cflgt3__render_basic__gti_l3_throughput__read \
    hsw__render_basic__gti_l3_throughput__read

/* Render Metrics Basic Gen9 :: GTI L3 Throughput */
#define cflgt3__render_basic__gti_l3_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics Basic Gen9 :: GTI HDC TLB Lookup Throughput */
#define cflgt3__render_basic__gti_hdc_lookups_throughput__read \
    bdw__render_basic__gti_hdc_lookups_throughput__read

/* Render Metrics Basic Gen9 :: GTI HDC TLB Lookup Throughput */
#define cflgt3__render_basic__gti_hdc_lookups_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics Basic Gen9 :: GTI Read Throughput */
#define cflgt3__render_basic__gti_read_throughput__read \
    bdw__render_basic__gti_read_throughput__read

/* Render Metrics Basic Gen9 :: GTI Read Throughput */
#define cflgt3__render_basic__gti_read_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Render Metrics Basic Gen9 :: GTI Write Throughput */
#define cflgt3__render_basic__gti_write_throughput__read \
    hsw__render_basic__gti_write_throughput__read

/* Render Metrics Basic Gen9 :: GTI Write Throughput */
#define cflgt3__render_basic__gti_write_throughput__max \
    bdw__render_basic__gti_write_throughput__max

/* Render Metrics Basic Gen9 :: Samplers Bottleneck */
#define cflgt3__render_basic__sampler_bottleneck__read \
    bdw__render_basic__sampler_bottleneck__read

/* Compute Metrics Basic Gen9 :: GPU Time Elapsed */
#define cflgt3__compute_basic__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Compute Metrics Basic Gen9 :: GPU Core Clocks */
#define cflgt3__compute_basic__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Compute Metrics Basic Gen9 :: AVG GPU Core Frequency */
#define cflgt3__compute_basic__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Compute Metrics Basic Gen9 :: AVG GPU Core Frequency */
#define cflgt3__compute_basic__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Compute Metrics Basic Gen9 :: GPU Busy */
#define cflgt3__compute_basic__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Compute Metrics Basic Gen9 :: VS Threads Dispatched */
#define cflgt3__compute_basic__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Compute Metrics Basic Gen9 :: HS Threads Dispatched */
#define cflgt3__compute_basic__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Compute Metrics Basic Gen9 :: DS Threads Dispatched */
#define cflgt3__compute_basic__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Compute Metrics Basic Gen9 :: GS Threads Dispatched */
#define cflgt3__compute_basic__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Compute Metrics Basic Gen9 :: FS Threads Dispatched */
#define cflgt3__compute_basic__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Compute Metrics Basic Gen9 :: CS Threads Dispatched */
#define cflgt3__compute_basic__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Compute Metrics Basic Gen9 :: EU Active */
#define cflgt3__compute_basic__eu_active__read \
    bdw__render_basic__eu_active__read

/* Compute Metrics Basic Gen9 :: EU Stall */
#define cflgt3__compute_basic__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Compute Metrics Basic Gen9 :: EU Both FPU Pipes Active */
#define cflgt3__compute_basic__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Compute Metrics Basic Gen9 :: EU FPU0 Pipe Active */
#define cflgt3__compute_basic__fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Compute Metrics Basic Gen9 :: EU FPU1 Pipe Active */
#define cflgt3__compute_basic__fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Compute Metrics Basic Gen9 :: EU AVG IPC Rate */
#define cflgt3__compute_basic__eu_avg_ipc_rate__read \
    bdw__compute_basic__eu_avg_ipc_rate__read

/* Compute Metrics Basic Gen9 :: EU AVG IPC Rate */
#define cflgt3__compute_basic__eu_avg_ipc_rate__max \
    bdw__compute_basic__eu_avg_ipc_rate__max

/* Compute Metrics Basic Gen9 :: EU Send Pipe Active */
#define cflgt3__compute_basic__eu_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Compute Metrics Basic Gen9 :: EU Thread Occupancy */
#define cflgt3__compute_basic__eu_thread_occupancy__read \
    bdw__compute_basic__eu_thread_occupancy__read

/* Compute Metrics Basic Gen9 :: Rasterized Pixels */
#define cflgt3__compute_basic__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Compute Metrics Basic Gen9 :: Early Hi-Depth Test Fails */
#define cflgt3__compute_basic__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Compute Metrics Basic Gen9 :: Early Depth Test Fails */
#define cflgt3__compute_basic__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Compute Metrics Basic Gen9 :: Samples Killed in FS */
#define cflgt3__compute_basic__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Compute Metrics Basic Gen9 :: Pixels Failing Tests */
#define cflgt3__compute_basic__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Compute Metrics Basic Gen9 :: Samples Written */
#define cflgt3__compute_basic__samples_written__read \
    bdw__render_basic__samples_written__read

/* Compute Metrics Basic Gen9 :: Samples Blended */
#define cflgt3__compute_basic__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Compute Metrics Basic Gen9 :: Sampler Texels */
#define cflgt3__compute_basic__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Compute Metrics Basic Gen9 :: Sampler Texels Misses */
#define cflgt3__compute_basic__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Compute Metrics Basic Gen9 :: SLM Bytes Read */
#define cflgt3__compute_basic__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Compute Metrics Basic Gen9 :: SLM Bytes Read */
#define cflgt3__compute_basic__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Basic Gen9 :: SLM Bytes Written */
#define cflgt3__compute_basic__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Compute Metrics Basic Gen9 :: SLM Bytes Written */
#define cflgt3__compute_basic__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Basic Gen9 :: Shader Memory Accesses */
#define cflgt3__compute_basic__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Compute Metrics Basic Gen9 :: Shader Atomic Memory Accesses */
#define cflgt3__compute_basic__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Compute Metrics Basic Gen9 :: L3 Shader Throughput */
#define cflgt3__compute_basic__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Compute Metrics Basic Gen9 :: L3 Shader Throughput */
#define cflgt3__compute_basic__l3_shader_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen9 :: Shader Barrier Messages */
#define cflgt3__compute_basic__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Compute Metrics Basic Gen9 :: Typed Bytes Read */
#define cflgt3__compute_basic__typed_bytes_read__read \
    bdw__compute_basic__typed_bytes_read__read

/* Compute Metrics Basic Gen9 :: Typed Bytes Read */
#define cflgt3__compute_basic__typed_bytes_read__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen9 :: Typed Bytes Written */
#define cflgt3__compute_basic__typed_bytes_written__read \
    bdw__compute_basic__typed_bytes_written__read

/* Compute Metrics Basic Gen9 :: Typed Bytes Written */
#define cflgt3__compute_basic__typed_bytes_written__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen9 :: Untyped Bytes Read */
#define cflgt3__compute_basic__untyped_bytes_read__read \
    bdw__compute_basic__untyped_bytes_read__read

/* Compute Metrics Basic Gen9 :: Untyped Bytes Read */
#define cflgt3__compute_basic__untyped_bytes_read__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen9 :: Untyped Writes */
#define cflgt3__compute_basic__untyped_bytes_written__read \
    bdw__compute_basic__untyped_bytes_written__read

/* Compute Metrics Basic Gen9 :: Untyped Writes */
#define cflgt3__compute_basic__untyped_bytes_written__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen9 :: GTI Read Throughput */
#define cflgt3__compute_basic__gti_read_throughput__read \
    hsw__render_basic__gti_l3_throughput__read

/* Compute Metrics Basic Gen9 :: GTI Read Throughput */
#define cflgt3__compute_basic__gti_read_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen9 :: GTI Write Throughput */
#define cflgt3__compute_basic__gti_write_throughput__read \
    bdw__render_basic__gti_hdc_lookups_throughput__read

/* Compute Metrics Basic Gen9 :: GTI Write Throughput */
#define cflgt3__compute_basic__gti_write_throughput__max \
    bdw__render_basic__gti_write_throughput__max

/* Render Metrics for 3D Pipeline Profile Gen9 :: GPU Time Elapsed */
#define cflgt3__render_pipe_profile__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: GPU Core Clocks */
#define cflgt3__render_pipe_profile__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: AVG GPU Core Frequency */
#define cflgt3__render_pipe_profile__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: AVG GPU Core Frequency */
#define cflgt3__render_pipe_profile__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Render Metrics for 3D Pipeline Profile Gen9 :: GPU Busy */
#define cflgt3__render_pipe_profile__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: VS Threads Dispatched */
#define cflgt3__render_pipe_profile__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: HS Threads Dispatched */
#define cflgt3__render_pipe_profile__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: DS Threads Dispatched */
#define cflgt3__render_pipe_profile__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: GS Threads Dispatched */
#define cflgt3__render_pipe_profile__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: FS Threads Dispatched */
#define cflgt3__render_pipe_profile__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: CS Threads Dispatched */
#define cflgt3__render_pipe_profile__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: EU Active */
#define cflgt3__render_pipe_profile__eu_active__read \
    bdw__render_basic__eu_active__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: EU Stall */
#define cflgt3__render_pipe_profile__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Rasterized Pixels */
#define cflgt3__render_pipe_profile__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Early Hi-Depth Test Fails */
#define cflgt3__render_pipe_profile__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Early Depth Test Fails */
#define cflgt3__render_pipe_profile__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Samples Killed in FS */
#define cflgt3__render_pipe_profile__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Pixels Failing Tests */
#define cflgt3__render_pipe_profile__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Samples Written */
#define cflgt3__render_pipe_profile__samples_written__read \
    bdw__render_basic__samples_written__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Samples Blended */
#define cflgt3__render_pipe_profile__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Sampler Texels */
#define cflgt3__render_pipe_profile__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Sampler Texels Misses */
#define cflgt3__render_pipe_profile__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: SLM Bytes Read */
#define cflgt3__render_pipe_profile__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: SLM Bytes Read */
#define cflgt3__render_pipe_profile__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics for 3D Pipeline Profile Gen9 :: SLM Bytes Written */
#define cflgt3__render_pipe_profile__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: SLM Bytes Written */
#define cflgt3__render_pipe_profile__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics for 3D Pipeline Profile Gen9 :: Shader Memory Accesses */
#define cflgt3__render_pipe_profile__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Shader Atomic Memory Accesses */
#define cflgt3__render_pipe_profile__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: L3 Shader Throughput */
#define cflgt3__render_pipe_profile__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: L3 Shader Throughput */
#define cflgt3__render_pipe_profile__l3_shader_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics for 3D Pipeline Profile Gen9 :: Shader Barrier Messages */
#define cflgt3__render_pipe_profile__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: VF Bottleneck */
#define cflgt3__render_pipe_profile__vf_bottleneck__read \
    bdw__render_pipe_profile__vf_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: VS Bottleneck */
#define cflgt3__render_pipe_profile__vs_bottleneck__read \
    bdw__render_basic__sampler0_busy__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: HS Bottleneck */
#define cflgt3__render_pipe_profile__hs_bottleneck__read \
    bdw__render_basic__sampler1_busy__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: DS Bottleneck */
#define cflgt3__render_pipe_profile__ds_bottleneck__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: GS Bottleneck */
#define cflgt3__render_pipe_profile__gs_bottleneck__read \
    bdw__render_basic__sampler1_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: SO Bottleneck */
#define cflgt3__render_pipe_profile__so_bottleneck__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Clipper Bottleneck */
#define cflgt3__render_pipe_profile__cl_bottleneck__read \
    bdw__render_pipe_profile__cl_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Strip-Fans Bottleneck */
#define cflgt3__render_pipe_profile__sf_bottleneck__read \
    bdw__render_pipe_profile__sf_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Hi-Depth Bottleneck */
#define cflgt3__render_pipe_profile__hi_depth_bottleneck__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Early Depth Bottleneck */
#define cflgt3__render_pipe_profile__early_depth_bottleneck__read \
    bdw__render_pipe_profile__early_depth_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: BC Bottleneck */
#define cflgt3__render_pipe_profile__bc_bottleneck__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: HS Stall */
#define cflgt3__render_pipe_profile__hs_stall__read \
    bdw__render_pipe_profile__hs_stall__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: DS Stall */
#define cflgt3__render_pipe_profile__ds_stall__read \
    bdw__render_pipe_profile__ds_stall__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: SO Stall */
#define cflgt3__render_pipe_profile__so_stall__read \
    bdw__render_pipe_profile__so_stall__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: CL Stall */
#define cflgt3__render_pipe_profile__cl_stall__read \
    bdw__render_pipe_profile__cl_stall__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: SF Stall */
#define cflgt3__render_pipe_profile__sf_stall__read \
    bdw__render_pipe_profile__sf_stall__read

/* Memory Reads Distribution Gen9 :: GPU Time Elapsed */
#define cflgt3__memory_reads__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Memory Reads Distribution Gen9 :: GPU Core Clocks */
#define cflgt3__memory_reads__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Memory Reads Distribution Gen9 :: AVG GPU Core Frequency */
#define cflgt3__memory_reads__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Memory Reads Distribution Gen9 :: AVG GPU Core Frequency */
#define cflgt3__memory_reads__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Memory Reads Distribution Gen9 :: GPU Busy */
#define cflgt3__memory_reads__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Memory Reads Distribution Gen9 :: VS Threads Dispatched */
#define cflgt3__memory_reads__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Memory Reads Distribution Gen9 :: HS Threads Dispatched */
#define cflgt3__memory_reads__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Memory Reads Distribution Gen9 :: DS Threads Dispatched */
#define cflgt3__memory_reads__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Memory Reads Distribution Gen9 :: GS Threads Dispatched */
#define cflgt3__memory_reads__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Memory Reads Distribution Gen9 :: FS Threads Dispatched */
#define cflgt3__memory_reads__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Memory Reads Distribution Gen9 :: CS Threads Dispatched */
#define cflgt3__memory_reads__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Memory Reads Distribution Gen9 :: EU Active */
#define cflgt3__memory_reads__eu_active__read \
    bdw__render_basic__eu_active__read

/* Memory Reads Distribution Gen9 :: EU Stall */
#define cflgt3__memory_reads__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Memory Reads Distribution Gen9 :: Rasterized Pixels */
#define cflgt3__memory_reads__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Memory Reads Distribution Gen9 :: Early Hi-Depth Test Fails */
#define cflgt3__memory_reads__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Memory Reads Distribution Gen9 :: Early Depth Test Fails */
#define cflgt3__memory_reads__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Memory Reads Distribution Gen9 :: Samples Killed in FS */
#define cflgt3__memory_reads__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Memory Reads Distribution Gen9 :: Pixels Failing Tests */
#define cflgt3__memory_reads__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Memory Reads Distribution Gen9 :: Samples Written */
#define cflgt3__memory_reads__samples_written__read \
    bdw__render_basic__samples_written__read

/* Memory Reads Distribution Gen9 :: Samples Blended */
#define cflgt3__memory_reads__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Memory Reads Distribution Gen9 :: Sampler Texels */
#define cflgt3__memory_reads__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Memory Reads Distribution Gen9 :: Sampler Texels Misses */
#define cflgt3__memory_reads__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Memory Reads Distribution Gen9 :: SLM Bytes Read */
#define cflgt3__memory_reads__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Memory Reads Distribution Gen9 :: SLM Bytes Read */
#define cflgt3__memory_reads__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Memory Reads Distribution Gen9 :: SLM Bytes Written */
#define cflgt3__memory_reads__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Memory Reads Distribution Gen9 :: SLM Bytes Written */
#define cflgt3__memory_reads__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Memory Reads Distribution Gen9 :: Shader Memory Accesses */
#define cflgt3__memory_reads__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Memory Reads Distribution Gen9 :: Shader Atomic Memory Accesses */
#define cflgt3__memory_reads__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Memory Reads Distribution Gen9 :: Shader Barrier Messages */
#define cflgt3__memory_reads__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Memory Reads Distribution Gen9 :: GtiCmdStreamerMemoryReads */
#define cflgt3__memory_reads__gti_cmd_streamer_memory_reads__read \
    hsw__compute_extended__eu_untyped_reads0__read

/* Memory Reads Distribution Gen9 :: GtiRsMemoryReads */
#define cflgt3__memory_reads__gti_rs_memory_reads__read \
    hsw__compute_extended__eu_typed_reads0__read

/* Memory Reads Distribution Gen9 :: GtiVfMemoryReads */
#define cflgt3__memory_reads__gti_vf_memory_reads__read \
    hsw__compute_extended__eu_untyped_writes0__read

/* Memory Reads Distribution Gen9 :: GtiRccMemoryReads */
#define cflgt3__memory_reads__gti_rcc_memory_reads__read \
    hsw__compute_extended__eu_typed_writes0__read

/* Memory Reads Distribution Gen9 :: GtiMscMemoryReads */
#define cflgt3__memory_reads__gti_msc_memory_reads__read \
    hsw__compute_extended__eu_untyped_atomics0__read

/* Memory Reads Distribution Gen9 :: GtiHizMemoryReads */
#define cflgt3__memory_reads__gti_hiz_memory_reads__read \
    hsw__compute_extended__eu_typed_atomics0__read

/* Memory Reads Distribution Gen9 :: GtiStcMemoryReads */
#define cflgt3__memory_reads__gti_stc_memory_reads__read \
    hsw__compute_extended__eu_urb_atomics0__read

/* Memory Reads Distribution Gen9 :: GtiRczMemoryReads */
#define cflgt3__memory_reads__gti_rcz_memory_reads__read \
    hsw__compute_extended__gpu_clocks__read

/* Memory Reads Distribution Gen9 :: GtiMemoryReads */
#define cflgt3__memory_reads__gti_memory_reads__read \
    hsw__compute_extended__typed_writes0__read

/* Memory Reads Distribution Gen9 :: GtiL3Bank0Reads */
#define cflgt3__memory_reads__gti_l3_bank0_reads__read \
    hsw__compute_extended__typed_atomics0__read

/* Memory Reads Distribution Gen9 :: GtiL3Bank1Reads */
#define cflgt3__memory_reads__gti_l3_bank1_reads__read \
    hsw__memory_reads__gti_memory_reads__read

/* Memory Reads Distribution Gen9 :: GtiL3Bank2Reads */
#define cflgt3__memory_reads__gti_l3_bank2_reads__read \
    hsw__memory_reads__llc_read_accesses__read

/* Memory Reads Distribution Gen9 :: GtiL3Bank3Reads */
#define cflgt3__memory_reads__gti_l3_bank3_reads__read \
    hsw__memory_reads__gpu_core_clocks__read

/* Memory Reads Distribution Gen9 :: GtiL3Reads */
#define cflgt3__memory_reads__gti_l3_reads__read \
    bdw__memory_reads__gti_l3_reads__read

/* Memory Reads Distribution Gen9 :: GtiRingAccesses */
#define cflgt3__memory_reads__gti_ring_accesses__read \
    bdw__memory_reads__gti_ring_accesses__read

/* Memory Writes Distribution Gen9 :: GPU Time Elapsed */
#define cflgt3__memory_writes__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Memory Writes Distribution Gen9 :: GPU Core Clocks */
#define cflgt3__memory_writes__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Memory Writes Distribution Gen9 :: AVG GPU Core Frequency */
#define cflgt3__memory_writes__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Memory Writes Distribution Gen9 :: AVG GPU Core Frequency */
#define cflgt3__memory_writes__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Memory Writes Distribution Gen9 :: GPU Busy */
#define cflgt3__memory_writes__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Memory Writes Distribution Gen9 :: VS Threads Dispatched */
#define cflgt3__memory_writes__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Memory Writes Distribution Gen9 :: HS Threads Dispatched */
#define cflgt3__memory_writes__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Memory Writes Distribution Gen9 :: DS Threads Dispatched */
#define cflgt3__memory_writes__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Memory Writes Distribution Gen9 :: GS Threads Dispatched */
#define cflgt3__memory_writes__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Memory Writes Distribution Gen9 :: FS Threads Dispatched */
#define cflgt3__memory_writes__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Memory Writes Distribution Gen9 :: CS Threads Dispatched */
#define cflgt3__memory_writes__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Memory Writes Distribution Gen9 :: EU Active */
#define cflgt3__memory_writes__eu_active__read \
    bdw__render_basic__eu_active__read

/* Memory Writes Distribution Gen9 :: EU Stall */
#define cflgt3__memory_writes__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Memory Writes Distribution Gen9 :: Rasterized Pixels */
#define cflgt3__memory_writes__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Memory Writes Distribution Gen9 :: Early Hi-Depth Test Fails */
#define cflgt3__memory_writes__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Memory Writes Distribution Gen9 :: Early Depth Test Fails */
#define cflgt3__memory_writes__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Memory Writes Distribution Gen9 :: Samples Killed in FS */
#define cflgt3__memory_writes__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Memory Writes Distribution Gen9 :: Pixels Failing Tests */
#define cflgt3__memory_writes__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Memory Writes Distribution Gen9 :: Samples Written */
#define cflgt3__memory_writes__samples_written__read \
    bdw__render_basic__samples_written__read

/* Memory Writes Distribution Gen9 :: Samples Blended */
#define cflgt3__memory_writes__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Memory Writes Distribution Gen9 :: Sampler Texels */
#define cflgt3__memory_writes__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Memory Writes Distribution Gen9 :: Sampler Texels Misses */
#define cflgt3__memory_writes__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Memory Writes Distribution Gen9 :: SLM Bytes Read */
#define cflgt3__memory_writes__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Memory Writes Distribution Gen9 :: SLM Bytes Read */
#define cflgt3__memory_writes__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Memory Writes Distribution Gen9 :: SLM Bytes Written */
#define cflgt3__memory_writes__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Memory Writes Distribution Gen9 :: SLM Bytes Written */
#define cflgt3__memory_writes__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Memory Writes Distribution Gen9 :: Shader Memory Accesses */
#define cflgt3__memory_writes__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Memory Writes Distribution Gen9 :: Shader Atomic Memory Accesses */
#define cflgt3__memory_writes__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Memory Writes Distribution Gen9 :: L3 Shader Throughput */
#define cflgt3__memory_writes__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Memory Writes Distribution Gen9 :: L3 Shader Throughput */
#define cflgt3__memory_writes__l3_shader_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Memory Writes Distribution Gen9 :: Shader Barrier Messages */
#define cflgt3__memory_writes__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Memory Writes Distribution Gen9 :: GtiCmdStreamerMemoryWrites */
#define cflgt3__memory_writes__gti_cmd_streamer_memory_writes__read \
    hsw__compute_extended__eu_untyped_reads0__read

/* Memory Writes Distribution Gen9 :: GtiSoMemoryWrites */
#define cflgt3__memory_writes__gti_so_memory_writes__read \
    hsw__compute_extended__eu_typed_reads0__read

/* Memory Writes Distribution Gen9 :: GtiRccMemoryWrites */
#define cflgt3__memory_writes__gti_rcc_memory_writes__read \
    hsw__compute_extended__eu_typed_writes0__read

/* Memory Writes Distribution Gen9 :: GtiMscMemoryWrites */
#define cflgt3__memory_writes__gti_msc_memory_writes__read \
    hsw__compute_extended__eu_untyped_atomics0__read

/* Memory Writes Distribution Gen9 :: GtiHizMemoryWrites */
#define cflgt3__memory_writes__gti_hiz_memory_writes__read \
    hsw__compute_extended__eu_typed_atomics0__read

/* Memory Writes Distribution Gen9 :: GtiStcMemoryWrites */
#define cflgt3__memory_writes__gti_stc_memory_writes__read \
    hsw__compute_extended__eu_urb_atomics0__read

/* Memory Writes Distribution Gen9 :: GtiRczMemoryWrites */
#define cflgt3__memory_writes__gti_rcz_memory_writes__read \
    hsw__compute_extended__gpu_clocks__read

/* Memory Writes Distribution Gen9 :: GtiMemoryWrites */
#define cflgt3__memory_writes__gti_memory_writes__read \
    hsw__compute_extended__typed_writes0__read

/* Memory Writes Distribution Gen9 :: GtiL3Bank0Writes */
#define cflgt3__memory_writes__gti_l3_bank0_writes__read \
    hsw__compute_extended__typed_atomics0__read

/* Memory Writes Distribution Gen9 :: GtiL3Bank1Writes */
#define cflgt3__memory_writes__gti_l3_bank1_writes__read \
    hsw__memory_reads__gti_memory_reads__read

/* Memory Writes Distribution Gen9 :: GtiL3Bank2Writes */
#define cflgt3__memory_writes__gti_l3_bank2_writes__read \
    hsw__memory_reads__llc_read_accesses__read

/* Memory Writes Distribution Gen9 :: GtiL3Bank3Writes */
#define cflgt3__memory_writes__gti_l3_bank3_writes__read \
    hsw__memory_reads__gpu_core_clocks__read

/* Memory Writes Distribution Gen9 :: GtiL3Writes */
#define cflgt3__memory_writes__gti_l3_writes__read \
    bdw__memory_reads__gti_l3_reads__read

/* Memory Writes Distribution Gen9 :: GtiRingAccesses */
#define cflgt3__memory_writes__gti_ring_accesses__read \
    bdw__memory_reads__gti_ring_accesses__read

/* Compute Metrics Extended Gen9 :: GPU Time Elapsed */
#define cflgt3__compute_extended__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Compute Metrics Extended Gen9 :: GPU Core Clocks */
#define cflgt3__compute_extended__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Compute Metrics Extended Gen9 :: AVG GPU Core Frequency */
#define cflgt3__compute_extended__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Compute Metrics Extended Gen9 :: AVG GPU Core Frequency */
#define cflgt3__compute_extended__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Compute Metrics Extended Gen9 :: CS Threads Dispatched */
#define cflgt3__compute_extended__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Compute Metrics Extended Gen9 :: EU Active */
#define cflgt3__compute_extended__eu_active__read \
    bdw__render_basic__eu_active__read

/* Compute Metrics Extended Gen9 :: EU Stall */
#define cflgt3__compute_extended__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Compute Metrics Extended Gen9 :: EU Both FPU Pipes Active */
#define cflgt3__compute_extended__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Compute Metrics Extended Gen9 :: EU FPU0 Pipe Active */
#define cflgt3__compute_extended__fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Compute Metrics Extended Gen9 :: EU FPU1 Pipe Active */
#define cflgt3__compute_extended__fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Compute Metrics Extended Gen9 :: EU AVG IPC Rate */
#define cflgt3__compute_extended__eu_avg_ipc_rate__read \
    bdw__compute_basic__eu_avg_ipc_rate__read

/* Compute Metrics Extended Gen9 :: EU AVG IPC Rate */
#define cflgt3__compute_extended__eu_avg_ipc_rate__max \
    bdw__compute_basic__eu_avg_ipc_rate__max

/* Compute Metrics Extended Gen9 :: EU Send Pipe Active */
#define cflgt3__compute_extended__eu_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Compute Metrics Extended Gen9 :: EU Thread Occupancy */
#define cflgt3__compute_extended__eu_thread_occupancy__read \
    bdw__compute_basic__eu_thread_occupancy__read

/* Compute Metrics Extended Gen9 :: Sampler Texels */
#define cflgt3__compute_extended__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Compute Metrics Extended Gen9 :: Sampler Texels Misses */
#define cflgt3__compute_extended__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Compute Metrics Extended Gen9 :: SLM Bytes Read */
#define cflgt3__compute_extended__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Compute Metrics Extended Gen9 :: SLM Bytes Read */
#define cflgt3__compute_extended__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Extended Gen9 :: SLM Bytes Written */
#define cflgt3__compute_extended__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Compute Metrics Extended Gen9 :: SLM Bytes Written */
#define cflgt3__compute_extended__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Extended Gen9 :: Shader Memory Accesses */
#define cflgt3__compute_extended__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Compute Metrics Extended Gen9 :: Shader Atomic Memory Accesses */
#define cflgt3__compute_extended__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Compute Metrics Extended Gen9 :: L3 Shader Throughput */
#define cflgt3__compute_extended__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Compute Metrics Extended Gen9 :: L3 Shader Throughput */
#define cflgt3__compute_extended__l3_shader_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Extended Gen9 :: Shader Barrier Messages */
#define cflgt3__compute_extended__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Compute Metrics Extended Gen9 :: EuUntypedReads0 */
#define cflgt3__compute_extended__eu_untyped_reads0__read \
    hsw__compute_extended__eu_untyped_reads0__read

/* Compute Metrics Extended Gen9 :: EuTypedReads0 */
#define cflgt3__compute_extended__eu_typed_reads0__read \
    hsw__compute_extended__eu_typed_reads0__read

/* Compute Metrics Extended Gen9 :: EuUntypedWrites0 */
#define cflgt3__compute_extended__eu_untyped_writes0__read \
    hsw__compute_extended__eu_untyped_writes0__read

/* Compute Metrics Extended Gen9 :: EuTypedWrites0 */
#define cflgt3__compute_extended__eu_typed_writes0__read \
    hsw__compute_extended__eu_typed_writes0__read

/* Compute Metrics Extended Gen9 :: EuUntypedAtomics0 */
#define cflgt3__compute_extended__eu_untyped_atomics0__read \
    hsw__compute_extended__eu_untyped_atomics0__read

/* Compute Metrics Extended Gen9 :: EuTypedAtomics0 */
#define cflgt3__compute_extended__eu_typed_atomics0__read \
    hsw__compute_extended__eu_typed_atomics0__read

/* Compute Metrics Extended Gen9 :: EuA64UntypedReads0 */
#define cflgt3__compute_extended__eu_a64_untyped_reads0__read \
    hsw__compute_extended__eu_urb_atomics0__read

/* Compute Metrics Extended Gen9 :: EuA64UntypedWrites0 */
#define cflgt3__compute_extended__eu_a64_untyped_writes0__read \
    hsw__compute_extended__gpu_clocks__read

/* Compute Metrics Extended Gen9 :: Typed Reads 0 */
#define cflgt3__compute_extended__typed_reads0__read \
    hsw__render_basic__gpu_core_clocks__read

/* Compute Metrics Extended Gen9 :: Typed Writes 0 */
#define cflgt3__compute_extended__typed_writes0__read \
    hsw__compute_extended__typed_writes0__read

/* Compute Metrics Extended Gen9 :: Untyped Reads 0 */
#define cflgt3__compute_extended__untyped_reads0__read \
    hsw__compute_extended__untyped_reads0__read

/* Compute Metrics Extended Gen9 :: Untyped Writes 0 */
#define cflgt3__compute_extended__untyped_writes0__read \
    hsw__compute_extended__untyped_writes0__read

/* Compute Metrics Extended Gen9 :: Typed Atomics 0 */
#define cflgt3__compute_extended__typed_atomics0__read \
    hsw__compute_extended__typed_atomics0__read

/* Compute Metrics Extended Gen9 :: TypedReadsPerCacheLine */
#define cflgt3__compute_extended__typed_reads_per_cache_line__read \
    hsw__compute_extended__typed_reads_per_cache_line__read

/* Compute Metrics Extended Gen9 :: TypedWritesPerCacheLine */
#define cflgt3__compute_extended__typed_writes_per_cache_line__read \
    hsw__compute_extended__typed_writes_per_cache_line__read

/* Compute Metrics Extended Gen9 :: UntypedReadsPerCacheLine */
#define cflgt3__compute_extended__untyped_reads_per_cache_line__read \
    bdw__compute_extended__untyped_reads_per_cache_line__read

/* Compute Metrics Extended Gen9 :: UntypedWritesPerCacheLine */
#define cflgt3__compute_extended__untyped_writes_per_cache_line__read \
    bdw__compute_extended__untyped_writes_per_cache_line__read

/* Compute Metrics Extended Gen9 :: TypedAtomicsPerCacheLine */
#define cflgt3__compute_extended__typed_atomics_per_cache_line__read \
    hsw__compute_extended__typed_atomics_per_cache_line__read

/* Compute Metrics L3 Cache Gen9 :: GPU Time Elapsed */
#define cflgt3__compute_l3_cache__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Compute Metrics L3 Cache Gen9 :: GPU Core Clocks */
#define cflgt3__compute_l3_cache__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Compute Metrics L3 Cache Gen9 :: AVG GPU Core Frequency */
#define cflgt3__compute_l3_cache__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Compute Metrics L3 Cache Gen9 :: AVG GPU Core Frequency */
#define cflgt3__compute_l3_cache__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Compute Metrics L3 Cache Gen9 :: GPU Busy */
#define cflgt3__compute_l3_cache__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Compute Metrics L3 Cache Gen9 :: VS Threads Dispatched */
#define cflgt3__compute_l3_cache__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Compute Metrics L3 Cache Gen9 :: HS Threads Dispatched */
#define cflgt3__compute_l3_cache__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Compute Metrics L3 Cache Gen9 :: DS Threads Dispatched */
#define cflgt3__compute_l3_cache__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Compute Metrics L3 Cache Gen9 :: GS Threads Dispatched */
#define cflgt3__compute_l3_cache__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Compute Metrics L3 Cache Gen9 :: FS Threads Dispatched */
#define cflgt3__compute_l3_cache__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Compute Metrics L3 Cache Gen9 :: CS Threads Dispatched */
#define cflgt3__compute_l3_cache__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Compute Metrics L3 Cache Gen9 :: EU Active */
#define cflgt3__compute_l3_cache__eu_active__read \
    bdw__render_basic__eu_active__read

/* Compute Metrics L3 Cache Gen9 :: EU Stall */
#define cflgt3__compute_l3_cache__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Compute Metrics L3 Cache Gen9 :: EU Both FPU Pipes Active */
#define cflgt3__compute_l3_cache__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU0 Pipe Active */
#define cflgt3__compute_l3_cache__fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU1 Pipe Active */
#define cflgt3__compute_l3_cache__fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Compute Metrics L3 Cache Gen9 :: EU AVG IPC Rate */
#define cflgt3__compute_l3_cache__eu_avg_ipc_rate__read \
    bdw__compute_basic__eu_avg_ipc_rate__read

/* Compute Metrics L3 Cache Gen9 :: EU AVG IPC Rate */
#define cflgt3__compute_l3_cache__eu_avg_ipc_rate__max \
    bdw__compute_basic__eu_avg_ipc_rate__max

/* Compute Metrics L3 Cache Gen9 :: EU Send Pipe Active */
#define cflgt3__compute_l3_cache__eu_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU0 Hybrid Instruction */
#define cflgt3__compute_l3_cache__eu_hybrid_fpu0_instruction__read \
    bdw__compute_l3_cache__eu_hybrid_fpu0_instruction__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU1 Hybrid Instruction */
#define cflgt3__compute_l3_cache__eu_hybrid_fpu1_instruction__read \
    bdw__compute_l3_cache__eu_hybrid_fpu1_instruction__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU0 Ternary Instruction */
#define cflgt3__compute_l3_cache__eu_ternary_fpu0_instruction__read \
    bdw__render_basic__ps_fpu0_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU1 Ternary Instruction */
#define cflgt3__compute_l3_cache__eu_ternary_fpu1_instruction__read \
    bdw__render_basic__ps_fpu1_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU0 Binary Instruction */
#define cflgt3__compute_l3_cache__eu_binary_fpu0_instruction__read \
    bdw__render_basic__ps_send_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU1 Binary Instruction */
#define cflgt3__compute_l3_cache__eu_binary_fpu1_instruction__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU0 Move Instruction */
#define cflgt3__compute_l3_cache__eu_move_fpu0_instruction__read \
    bdw__compute_l3_cache__eu_move_fpu0_instruction__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU1 Move Instruction */
#define cflgt3__compute_l3_cache__eu_move_fpu1_instruction__read \
    bdw__compute_l3_cache__eu_move_fpu1_instruction__read

/* Compute Metrics L3 Cache Gen9 :: Rasterized Pixels */
#define cflgt3__compute_l3_cache__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Compute Metrics L3 Cache Gen9 :: Early Hi-Depth Test Fails */
#define cflgt3__compute_l3_cache__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Compute Metrics L3 Cache Gen9 :: Early Depth Test Fails */
#define cflgt3__compute_l3_cache__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Compute Metrics L3 Cache Gen9 :: Samples Killed in FS */
#define cflgt3__compute_l3_cache__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Compute Metrics L3 Cache Gen9 :: Pixels Failing Tests */
#define cflgt3__compute_l3_cache__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Compute Metrics L3 Cache Gen9 :: Samples Written */
#define cflgt3__compute_l3_cache__samples_written__read \
    bdw__render_basic__samples_written__read

/* Compute Metrics L3 Cache Gen9 :: Samples Blended */
#define cflgt3__compute_l3_cache__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Compute Metrics L3 Cache Gen9 :: Sampler Accesses */
#define cflgt3__compute_l3_cache__sampler_accesses__read \
    bdw__render_pipe_profile__sampler_accesses__read

/* Compute Metrics L3 Cache Gen9 :: Sampler Texels */
#define cflgt3__compute_l3_cache__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Compute Metrics L3 Cache Gen9 :: Sampler Texels Misses */
#define cflgt3__compute_l3_cache__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Compute Metrics L3 Cache Gen9 :: SLM Bytes Read */
#define cflgt3__compute_l3_cache__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Compute Metrics L3 Cache Gen9 :: SLM Bytes Read */
#define cflgt3__compute_l3_cache__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics L3 Cache Gen9 :: SLM Bytes Written */
#define cflgt3__compute_l3_cache__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Compute Metrics L3 Cache Gen9 :: SLM Bytes Written */
#define cflgt3__compute_l3_cache__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics L3 Cache Gen9 :: Shader Memory Accesses */
#define cflgt3__compute_l3_cache__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Compute Metrics L3 Cache Gen9 :: Shader Atomic Memory Accesses */
#define cflgt3__compute_l3_cache__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Compute Metrics L3 Cache Gen9 :: L3 Accesses */
#define cflgt3__compute_l3_cache__l3_accesses__read \
    sklgt2__compute_l3_cache__l3_accesses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Misses */
#define cflgt3__compute_l3_cache__l3_misses__read \
    bdw__compute_l3_cache__l3_misses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Sampler Throughput */
#define cflgt3__compute_l3_cache__l3_sampler_throughput__read \
    chv__render_basic__l3_sampler_throughput__read

/* Compute Metrics L3 Cache Gen9 :: L3 Sampler Throughput */
#define cflgt3__compute_l3_cache__l3_sampler_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics L3 Cache Gen9 :: L3 Shader Throughput */
#define cflgt3__compute_l3_cache__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Compute Metrics L3 Cache Gen9 :: L3 Shader Throughput */
#define cflgt3__compute_l3_cache__l3_shader_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics L3 Cache Gen9 :: L3 Total Throughput */
#define cflgt3__compute_l3_cache__l3_total_throughput__read \
    sklgt2__compute_l3_cache__l3_total_throughput__read

/* Compute Metrics L3 Cache Gen9 :: L3 Total Throughput */
#define cflgt3__compute_l3_cache__l3_total_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics L3 Cache Gen9 :: Shader Barrier Messages */
#define cflgt3__compute_l3_cache__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Compute Metrics L3 Cache Gen9 :: L3 Bank 00 Accesses */
#define cflgt3__compute_l3_cache__l3_bank00_accesses__read \
    bdw__compute_l3_cache__l3_bank00_accesses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Bank 01 Accesses */
#define cflgt3__compute_l3_cache__l3_bank01_accesses__read \
    bdw__compute_l3_cache__l3_bank01_accesses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Bank 02 Accesses */
#define cflgt3__compute_l3_cache__l3_bank02_accesses__read \
    bdw__compute_l3_cache__l3_bank02_accesses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Bank 03 Accesses */
#define cflgt3__compute_l3_cache__l3_bank03_accesses__read \
    bdw__compute_l3_cache__l3_bank03_accesses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Bank 00 IC Accesses */
#define cflgt3__compute_l3_cache__l3_bank00_ic_accesses__read \
    bdw__compute_l3_cache__l3_bank00_ic_accesses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Bank 00 IC Hits */
#define cflgt3__compute_l3_cache__l3_bank00_ic_hits__read \
    bdw__compute_l3_cache__l3_bank00_ic_hits__read

/* Compute Metrics L3 Cache Gen9 :: GTI L3 Throughput */
#define cflgt3__compute_l3_cache__gti_l3_throughput__read \
    bdw__compute_l3_cache__gti_l3_throughput__read

/* Compute Metrics L3 Cache Gen9 :: GTI L3 Throughput */
#define cflgt3__compute_l3_cache__gti_l3_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics L3 Cache Gen9 :: GTI Read Throughput */
#define cflgt3__compute_l3_cache__gti_read_throughput__read \
    bdw__render_basic__gti_read_throughput__read

/* Compute Metrics L3 Cache Gen9 :: GTI Read Throughput */
#define cflgt3__compute_l3_cache__gti_read_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Compute Metrics L3 Cache Gen9 :: GTI Write Throughput */
#define cflgt3__compute_l3_cache__gti_write_throughput__read \
    hsw__render_basic__gti_write_throughput__read

/* Compute Metrics L3 Cache Gen9 :: GTI Write Throughput */
#define cflgt3__compute_l3_cache__gti_write_throughput__max \
    bdw__render_basic__gti_write_throughput__max

/* Metric set HDCAndSF :: GPU Time Elapsed */
#define cflgt3__hdc_and_sf__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set HDCAndSF :: GPU Core Clocks */
#define cflgt3__hdc_and_sf__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set HDCAndSF :: AVG GPU Core Frequency */
#define cflgt3__hdc_and_sf__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set HDCAndSF :: AVG GPU Core Frequency */
#define cflgt3__hdc_and_sf__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set HDCAndSF :: GPU Busy */
#define cflgt3__hdc_and_sf__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set HDCAndSF :: VS Threads Dispatched */
#define cflgt3__hdc_and_sf__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set HDCAndSF :: HS Threads Dispatched */
#define cflgt3__hdc_and_sf__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set HDCAndSF :: DS Threads Dispatched */
#define cflgt3__hdc_and_sf__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set HDCAndSF :: GS Threads Dispatched */
#define cflgt3__hdc_and_sf__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set HDCAndSF :: FS Threads Dispatched */
#define cflgt3__hdc_and_sf__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set HDCAndSF :: CS Threads Dispatched */
#define cflgt3__hdc_and_sf__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set HDCAndSF :: EU Active */
#define cflgt3__hdc_and_sf__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set HDCAndSF :: EU Stall */
#define cflgt3__hdc_and_sf__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set HDCAndSF :: EU Both FPU Pipes Active */
#define cflgt3__hdc_and_sf__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set HDCAndSF :: VS FPU0 Pipe Active */
#define cflgt3__hdc_and_sf__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set HDCAndSF :: VS FPU1 Pipe Active */
#define cflgt3__hdc_and_sf__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set HDCAndSF :: VS Send Pipe Active */
#define cflgt3__hdc_and_sf__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set HDCAndSF :: PS FPU0 Pipe Active */
#define cflgt3__hdc_and_sf__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set HDCAndSF :: PS FPU1 Pipe Active */
#define cflgt3__hdc_and_sf__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set HDCAndSF :: PS Send Pipeline Active */
#define cflgt3__hdc_and_sf__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set HDCAndSF :: FS Both FPU Active */
#define cflgt3__hdc_and_sf__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set HDCAndSF :: Rasterized Pixels */
#define cflgt3__hdc_and_sf__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set HDCAndSF :: Early Hi-Depth Test Fails */
#define cflgt3__hdc_and_sf__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set HDCAndSF :: Early Depth Test Fails */
#define cflgt3__hdc_and_sf__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set HDCAndSF :: Samples Killed in FS */
#define cflgt3__hdc_and_sf__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set HDCAndSF :: Pixels Failing Tests */
#define cflgt3__hdc_and_sf__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set HDCAndSF :: Samples Written */
#define cflgt3__hdc_and_sf__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set HDCAndSF :: Samples Blended */
#define cflgt3__hdc_and_sf__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set HDCAndSF :: Sampler Texels */
#define cflgt3__hdc_and_sf__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set HDCAndSF :: Sampler Texels Misses */
#define cflgt3__hdc_and_sf__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set HDCAndSF :: SLM Bytes Read */
#define cflgt3__hdc_and_sf__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set HDCAndSF :: SLM Bytes Read */
#define cflgt3__hdc_and_sf__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set HDCAndSF :: SLM Bytes Written */
#define cflgt3__hdc_and_sf__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set HDCAndSF :: SLM Bytes Written */
#define cflgt3__hdc_and_sf__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set HDCAndSF :: Shader Memory Accesses */
#define cflgt3__hdc_and_sf__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set HDCAndSF :: Shader Atomic Memory Accesses */
#define cflgt3__hdc_and_sf__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set HDCAndSF :: L3 Shader Throughput */
#define cflgt3__hdc_and_sf__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set HDCAndSF :: L3 Shader Throughput */
#define cflgt3__hdc_and_sf__l3_shader_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Metric set HDCAndSF :: Shader Barrier Messages */
#define cflgt3__hdc_and_sf__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set HDCAndSF :: Polygon Data Ready */
#define cflgt3__hdc_and_sf__poly_data_ready__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set HDCAndSF :: HDC stalled by L3 (s0.ss0) */
#define cflgt3__hdc_and_sf__non_sampler_shader00_access_stalled_on_l3__read \
    bdw__hdc_and_sf__non_sampler_shader02_access_stalled_on_l3__read

/* Metric set HDCAndSF :: HDC stalled by L3 (s0.ss1) */
#define cflgt3__hdc_and_sf__non_sampler_shader01_access_stalled_on_l3__read \
    bdw__hdc_and_sf__non_sampler_shader01_access_stalled_on_l3__read

/* Metric set HDCAndSF :: HDC stalled by L3 (s0.ss2) */
#define cflgt3__hdc_and_sf__non_sampler_shader02_access_stalled_on_l3__read \
    bdw__hdc_and_sf__non_sampler_shader00_access_stalled_on_l3__read

/* Metric set HDCAndSF :: SQ is full */
#define cflgt3__hdc_and_sf__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set L3_1 :: GPU Time Elapsed */
#define cflgt3__l3_1__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set L3_1 :: GPU Core Clocks */
#define cflgt3__l3_1__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set L3_1 :: AVG GPU Core Frequency */
#define cflgt3__l3_1__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set L3_1 :: AVG GPU Core Frequency */
#define cflgt3__l3_1__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set L3_1 :: GPU Busy */
#define cflgt3__l3_1__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set L3_1 :: VS Threads Dispatched */
#define cflgt3__l3_1__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set L3_1 :: HS Threads Dispatched */
#define cflgt3__l3_1__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set L3_1 :: DS Threads Dispatched */
#define cflgt3__l3_1__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set L3_1 :: GS Threads Dispatched */
#define cflgt3__l3_1__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set L3_1 :: FS Threads Dispatched */
#define cflgt3__l3_1__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set L3_1 :: CS Threads Dispatched */
#define cflgt3__l3_1__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set L3_1 :: EU Active */
#define cflgt3__l3_1__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set L3_1 :: EU Stall */
#define cflgt3__l3_1__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set L3_1 :: EU Both FPU Pipes Active */
#define cflgt3__l3_1__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set L3_1 :: VS FPU0 Pipe Active */
#define cflgt3__l3_1__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set L3_1 :: VS FPU1 Pipe Active */
#define cflgt3__l3_1__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set L3_1 :: VS Send Pipe Active */
#define cflgt3__l3_1__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set L3_1 :: PS FPU0 Pipe Active */
#define cflgt3__l3_1__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set L3_1 :: PS FPU1 Pipe Active */
#define cflgt3__l3_1__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set L3_1 :: PS Send Pipeline Active */
#define cflgt3__l3_1__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set L3_1 :: FS Both FPU Active */
#define cflgt3__l3_1__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set L3_1 :: Rasterized Pixels */
#define cflgt3__l3_1__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set L3_1 :: Early Hi-Depth Test Fails */
#define cflgt3__l3_1__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set L3_1 :: Early Depth Test Fails */
#define cflgt3__l3_1__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set L3_1 :: Samples Killed in FS */
#define cflgt3__l3_1__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set L3_1 :: Pixels Failing Tests */
#define cflgt3__l3_1__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set L3_1 :: Samples Written */
#define cflgt3__l3_1__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set L3_1 :: Samples Blended */
#define cflgt3__l3_1__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set L3_1 :: Sampler Texels */
#define cflgt3__l3_1__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set L3_1 :: Sampler Texels Misses */
#define cflgt3__l3_1__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set L3_1 :: SLM Bytes Read */
#define cflgt3__l3_1__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set L3_1 :: SLM Bytes Read */
#define cflgt3__l3_1__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_1 :: SLM Bytes Written */
#define cflgt3__l3_1__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set L3_1 :: SLM Bytes Written */
#define cflgt3__l3_1__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_1 :: Shader Memory Accesses */
#define cflgt3__l3_1__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set L3_1 :: Shader Atomic Memory Accesses */
#define cflgt3__l3_1__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set L3_1 :: L3 Shader Throughput */
#define cflgt3__l3_1__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set L3_1 :: L3 Shader Throughput */
#define cflgt3__l3_1__l3_shader_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Metric set L3_1 :: Shader Barrier Messages */
#define cflgt3__l3_1__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set L3_1 :: Slice0 L3 Bank0 Stalled */
#define cflgt3__l3_1__l30_bank0_stalled__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set L3_1 :: Slice0 L3 Bank1 Stalled */
#define cflgt3__l3_1__l30_bank1_stalled__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* Metric set L3_1 :: Slice0 L3 Bank1 Active */
#define cflgt3__l3_1__l30_bank1_active__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set L3_1 :: Slice0 L3 Bank0 Active */
#define cflgt3__l3_1__l30_bank0_active__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set L3_1 :: SQ is full */
#define cflgt3__l3_1__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set L3_2 :: GPU Time Elapsed */
#define cflgt3__l3_2__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set L3_2 :: GPU Core Clocks */
#define cflgt3__l3_2__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set L3_2 :: AVG GPU Core Frequency */
#define cflgt3__l3_2__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set L3_2 :: AVG GPU Core Frequency */
#define cflgt3__l3_2__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set L3_2 :: GPU Busy */
#define cflgt3__l3_2__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set L3_2 :: VS Threads Dispatched */
#define cflgt3__l3_2__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set L3_2 :: HS Threads Dispatched */
#define cflgt3__l3_2__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set L3_2 :: DS Threads Dispatched */
#define cflgt3__l3_2__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set L3_2 :: GS Threads Dispatched */
#define cflgt3__l3_2__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set L3_2 :: FS Threads Dispatched */
#define cflgt3__l3_2__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set L3_2 :: CS Threads Dispatched */
#define cflgt3__l3_2__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set L3_2 :: EU Active */
#define cflgt3__l3_2__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set L3_2 :: EU Stall */
#define cflgt3__l3_2__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set L3_2 :: EU Both FPU Pipes Active */
#define cflgt3__l3_2__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set L3_2 :: VS FPU0 Pipe Active */
#define cflgt3__l3_2__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set L3_2 :: VS FPU1 Pipe Active */
#define cflgt3__l3_2__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set L3_2 :: VS Send Pipe Active */
#define cflgt3__l3_2__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set L3_2 :: PS FPU0 Pipe Active */
#define cflgt3__l3_2__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set L3_2 :: PS FPU1 Pipe Active */
#define cflgt3__l3_2__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set L3_2 :: PS Send Pipeline Active */
#define cflgt3__l3_2__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set L3_2 :: FS Both FPU Active */
#define cflgt3__l3_2__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set L3_2 :: Rasterized Pixels */
#define cflgt3__l3_2__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set L3_2 :: Early Hi-Depth Test Fails */
#define cflgt3__l3_2__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set L3_2 :: Early Depth Test Fails */
#define cflgt3__l3_2__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set L3_2 :: Samples Killed in FS */
#define cflgt3__l3_2__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set L3_2 :: Pixels Failing Tests */
#define cflgt3__l3_2__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set L3_2 :: Samples Written */
#define cflgt3__l3_2__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set L3_2 :: Samples Blended */
#define cflgt3__l3_2__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set L3_2 :: Sampler Texels */
#define cflgt3__l3_2__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set L3_2 :: Sampler Texels Misses */
#define cflgt3__l3_2__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set L3_2 :: SLM Bytes Read */
#define cflgt3__l3_2__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set L3_2 :: SLM Bytes Read */
#define cflgt3__l3_2__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_2 :: SLM Bytes Written */
#define cflgt3__l3_2__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set L3_2 :: SLM Bytes Written */
#define cflgt3__l3_2__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_2 :: Shader Memory Accesses */
#define cflgt3__l3_2__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set L3_2 :: Shader Atomic Memory Accesses */
#define cflgt3__l3_2__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set L3_2 :: L3 Shader Throughput */
#define cflgt3__l3_2__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set L3_2 :: L3 Shader Throughput */
#define cflgt3__l3_2__l3_shader_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Metric set L3_2 :: Shader Barrier Messages */
#define cflgt3__l3_2__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set L3_2 :: Slice0 L3 Bank2 Stalled */
#define cflgt3__l3_2__l30_bank2_stalled__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set L3_2 :: Slice0 L3 Bank2 Active */
#define cflgt3__l3_2__l30_bank2_active__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set L3_2 :: SQ is full */
#define cflgt3__l3_2__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set L3_3 :: GPU Time Elapsed */
#define cflgt3__l3_3__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set L3_3 :: GPU Core Clocks */
#define cflgt3__l3_3__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set L3_3 :: AVG GPU Core Frequency */
#define cflgt3__l3_3__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set L3_3 :: AVG GPU Core Frequency */
#define cflgt3__l3_3__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set L3_3 :: GPU Busy */
#define cflgt3__l3_3__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set L3_3 :: VS Threads Dispatched */
#define cflgt3__l3_3__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set L3_3 :: HS Threads Dispatched */
#define cflgt3__l3_3__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set L3_3 :: DS Threads Dispatched */
#define cflgt3__l3_3__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set L3_3 :: GS Threads Dispatched */
#define cflgt3__l3_3__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set L3_3 :: FS Threads Dispatched */
#define cflgt3__l3_3__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set L3_3 :: CS Threads Dispatched */
#define cflgt3__l3_3__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set L3_3 :: EU Active */
#define cflgt3__l3_3__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set L3_3 :: EU Stall */
#define cflgt3__l3_3__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set L3_3 :: EU Both FPU Pipes Active */
#define cflgt3__l3_3__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set L3_3 :: VS FPU0 Pipe Active */
#define cflgt3__l3_3__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set L3_3 :: VS FPU1 Pipe Active */
#define cflgt3__l3_3__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set L3_3 :: VS Send Pipe Active */
#define cflgt3__l3_3__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set L3_3 :: PS FPU0 Pipe Active */
#define cflgt3__l3_3__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set L3_3 :: PS FPU1 Pipe Active */
#define cflgt3__l3_3__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set L3_3 :: PS Send Pipeline Active */
#define cflgt3__l3_3__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set L3_3 :: FS Both FPU Active */
#define cflgt3__l3_3__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set L3_3 :: Rasterized Pixels */
#define cflgt3__l3_3__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set L3_3 :: Early Hi-Depth Test Fails */
#define cflgt3__l3_3__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set L3_3 :: Early Depth Test Fails */
#define cflgt3__l3_3__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set L3_3 :: Samples Killed in FS */
#define cflgt3__l3_3__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set L3_3 :: Pixels Failing Tests */
#define cflgt3__l3_3__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set L3_3 :: Samples Written */
#define cflgt3__l3_3__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set L3_3 :: Samples Blended */
#define cflgt3__l3_3__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set L3_3 :: Sampler Texels */
#define cflgt3__l3_3__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set L3_3 :: Sampler Texels Misses */
#define cflgt3__l3_3__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set L3_3 :: SLM Bytes Read */
#define cflgt3__l3_3__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set L3_3 :: SLM Bytes Read */
#define cflgt3__l3_3__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_3 :: SLM Bytes Written */
#define cflgt3__l3_3__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set L3_3 :: SLM Bytes Written */
#define cflgt3__l3_3__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_3 :: Shader Memory Accesses */
#define cflgt3__l3_3__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set L3_3 :: Shader Atomic Memory Accesses */
#define cflgt3__l3_3__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set L3_3 :: L3 Shader Throughput */
#define cflgt3__l3_3__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set L3_3 :: L3 Shader Throughput */
#define cflgt3__l3_3__l3_shader_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Metric set L3_3 :: Shader Barrier Messages */
#define cflgt3__l3_3__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set L3_3 :: Slice0 L3 Bank3 Stalled */
#define cflgt3__l3_3__l30_bank3_stalled__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set L3_3 :: Slice0 L3 Bank3 Active */
#define cflgt3__l3_3__l30_bank3_active__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set L3_3 :: SQ is full */
#define cflgt3__l3_3__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set RasterizerAndPixelBackend :: GPU Time Elapsed */
#define cflgt3__rasterizer_and_pixel_backend__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set RasterizerAndPixelBackend :: GPU Core Clocks */
#define cflgt3__rasterizer_and_pixel_backend__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set RasterizerAndPixelBackend :: AVG GPU Core Frequency */
#define cflgt3__rasterizer_and_pixel_backend__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set RasterizerAndPixelBackend :: AVG GPU Core Frequency */
#define cflgt3__rasterizer_and_pixel_backend__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set RasterizerAndPixelBackend :: GPU Busy */
#define cflgt3__rasterizer_and_pixel_backend__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set RasterizerAndPixelBackend :: VS Threads Dispatched */
#define cflgt3__rasterizer_and_pixel_backend__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set RasterizerAndPixelBackend :: HS Threads Dispatched */
#define cflgt3__rasterizer_and_pixel_backend__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set RasterizerAndPixelBackend :: DS Threads Dispatched */
#define cflgt3__rasterizer_and_pixel_backend__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set RasterizerAndPixelBackend :: GS Threads Dispatched */
#define cflgt3__rasterizer_and_pixel_backend__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set RasterizerAndPixelBackend :: FS Threads Dispatched */
#define cflgt3__rasterizer_and_pixel_backend__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set RasterizerAndPixelBackend :: CS Threads Dispatched */
#define cflgt3__rasterizer_and_pixel_backend__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set RasterizerAndPixelBackend :: EU Active */
#define cflgt3__rasterizer_and_pixel_backend__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set RasterizerAndPixelBackend :: EU Stall */
#define cflgt3__rasterizer_and_pixel_backend__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set RasterizerAndPixelBackend :: EU Both FPU Pipes Active */
#define cflgt3__rasterizer_and_pixel_backend__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set RasterizerAndPixelBackend :: VS FPU0 Pipe Active */
#define cflgt3__rasterizer_and_pixel_backend__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set RasterizerAndPixelBackend :: VS FPU1 Pipe Active */
#define cflgt3__rasterizer_and_pixel_backend__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set RasterizerAndPixelBackend :: VS Send Pipe Active */
#define cflgt3__rasterizer_and_pixel_backend__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set RasterizerAndPixelBackend :: PS FPU0 Pipe Active */
#define cflgt3__rasterizer_and_pixel_backend__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set RasterizerAndPixelBackend :: PS FPU1 Pipe Active */
#define cflgt3__rasterizer_and_pixel_backend__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set RasterizerAndPixelBackend :: PS Send Pipeline Active */
#define cflgt3__rasterizer_and_pixel_backend__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set RasterizerAndPixelBackend :: FS Both FPU Active */
#define cflgt3__rasterizer_and_pixel_backend__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set RasterizerAndPixelBackend :: Rasterized Pixels */
#define cflgt3__rasterizer_and_pixel_backend__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set RasterizerAndPixelBackend :: Early Hi-Depth Test Fails */
#define cflgt3__rasterizer_and_pixel_backend__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set RasterizerAndPixelBackend :: Early Depth Test Fails */
#define cflgt3__rasterizer_and_pixel_backend__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set RasterizerAndPixelBackend :: Samples Killed in FS */
#define cflgt3__rasterizer_and_pixel_backend__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set RasterizerAndPixelBackend :: Pixels Failing Tests */
#define cflgt3__rasterizer_and_pixel_backend__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set RasterizerAndPixelBackend :: Samples Written */
#define cflgt3__rasterizer_and_pixel_backend__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set RasterizerAndPixelBackend :: Samples Blended */
#define cflgt3__rasterizer_and_pixel_backend__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set RasterizerAndPixelBackend :: Sampler Texels */
#define cflgt3__rasterizer_and_pixel_backend__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set RasterizerAndPixelBackend :: Sampler Texels Misses */
#define cflgt3__rasterizer_and_pixel_backend__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Read */
#define cflgt3__rasterizer_and_pixel_backend__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Read */
#define cflgt3__rasterizer_and_pixel_backend__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Written */
#define cflgt3__rasterizer_and_pixel_backend__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Written */
#define cflgt3__rasterizer_and_pixel_backend__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set RasterizerAndPixelBackend :: Shader Memory Accesses */
#define cflgt3__rasterizer_and_pixel_backend__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set RasterizerAndPixelBackend :: Shader Atomic Memory Accesses */
#define cflgt3__rasterizer_and_pixel_backend__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set RasterizerAndPixelBackend :: L3 Shader Throughput */
#define cflgt3__rasterizer_and_pixel_backend__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set RasterizerAndPixelBackend :: L3 Shader Throughput */
#define cflgt3__rasterizer_and_pixel_backend__l3_shader_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Metric set RasterizerAndPixelBackend :: Shader Barrier Messages */
#define cflgt3__rasterizer_and_pixel_backend__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Post-EarlyZ Pixel Data Ready */
#define cflgt3__rasterizer_and_pixel_backend__pixel_data0_ready__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Rasterizer Input Available */
#define cflgt3__rasterizer_and_pixel_backend__rasterizer0_input_available__read \
    bdw__render_basic__sampler1_busy__read

/* Metric set RasterizerAndPixelBackend :: Slice0 PS Output Available */
#define cflgt3__rasterizer_and_pixel_backend__ps_output0_available__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Pixel Values Ready */
#define cflgt3__rasterizer_and_pixel_backend__pixel_values0_ready__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Rasterizer Output Ready */
#define cflgt3__rasterizer_and_pixel_backend__rasterizer0_output_ready__read \
    bdw__render_pipe_profile__sf_stall__read

/* Metric set RasterizerAndPixelBackend :: SQ is full */
#define cflgt3__rasterizer_and_pixel_backend__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set Sampler :: GPU Time Elapsed */
#define cflgt3__sampler__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set Sampler :: GPU Core Clocks */
#define cflgt3__sampler__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set Sampler :: AVG GPU Core Frequency */
#define cflgt3__sampler__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set Sampler :: AVG GPU Core Frequency */
#define cflgt3__sampler__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set Sampler :: GPU Busy */
#define cflgt3__sampler__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set Sampler :: VS Threads Dispatched */
#define cflgt3__sampler__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set Sampler :: HS Threads Dispatched */
#define cflgt3__sampler__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set Sampler :: DS Threads Dispatched */
#define cflgt3__sampler__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set Sampler :: GS Threads Dispatched */
#define cflgt3__sampler__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set Sampler :: FS Threads Dispatched */
#define cflgt3__sampler__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set Sampler :: CS Threads Dispatched */
#define cflgt3__sampler__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set Sampler :: EU Active */
#define cflgt3__sampler__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set Sampler :: EU Stall */
#define cflgt3__sampler__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set Sampler :: EU Both FPU Pipes Active */
#define cflgt3__sampler__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set Sampler :: VS FPU0 Pipe Active */
#define cflgt3__sampler__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set Sampler :: VS FPU1 Pipe Active */
#define cflgt3__sampler__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set Sampler :: VS Send Pipe Active */
#define cflgt3__sampler__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set Sampler :: PS FPU0 Pipe Active */
#define cflgt3__sampler__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set Sampler :: PS FPU1 Pipe Active */
#define cflgt3__sampler__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set Sampler :: PS Send Pipeline Active */
#define cflgt3__sampler__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set Sampler :: FS Both FPU Active */
#define cflgt3__sampler__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set Sampler :: Rasterized Pixels */
#define cflgt3__sampler__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set Sampler :: Early Hi-Depth Test Fails */
#define cflgt3__sampler__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set Sampler :: Early Depth Test Fails */
#define cflgt3__sampler__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set Sampler :: Samples Killed in FS */
#define cflgt3__sampler__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set Sampler :: Pixels Failing Tests */
#define cflgt3__sampler__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set Sampler :: Samples Written */
#define cflgt3__sampler__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set Sampler :: Samples Blended */
#define cflgt3__sampler__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set Sampler :: Sampler Texels */
#define cflgt3__sampler__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set Sampler :: Sampler Texels Misses */
#define cflgt3__sampler__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set Sampler :: SLM Bytes Read */
#define cflgt3__sampler__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set Sampler :: SLM Bytes Read */
#define cflgt3__sampler__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set Sampler :: SLM Bytes Written */
#define cflgt3__sampler__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set Sampler :: SLM Bytes Written */
#define cflgt3__sampler__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set Sampler :: Shader Memory Accesses */
#define cflgt3__sampler__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set Sampler :: Shader Atomic Memory Accesses */
#define cflgt3__sampler__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set Sampler :: L3 Shader Throughput */
#define cflgt3__sampler__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set Sampler :: L3 Shader Throughput */
#define cflgt3__sampler__l3_shader_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Metric set Sampler :: Shader Barrier Messages */
#define cflgt3__sampler__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set Sampler :: Slice0 Subslice1 Input Available */
#define cflgt3__sampler__sampler01_input_available__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set Sampler :: Slice0 Subslice2 Input Available */
#define cflgt3__sampler__sampler02_input_available__read \
    bdw__render_basic__sampler1_busy__read

/* Metric set Sampler :: Slice0 Subslice0 Input Available */
#define cflgt3__sampler__sampler00_input_available__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Metric set Sampler :: Slice0 Subslice2 Sampler Output Ready */
#define cflgt3__sampler__sampler02_output_ready__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set Sampler :: Slice0 Subslice0 Sampler Output Ready */
#define cflgt3__sampler__sampler00_output_ready__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set Sampler :: Slice0 Subslice1 Sampler Output Ready */
#define cflgt3__sampler__sampler01_output_ready__read \
    bdw__render_pipe_profile__sf_stall__read

/* Metric set Sampler :: SQ is full */
#define cflgt3__sampler__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set TDL_1 :: GPU Time Elapsed */
#define cflgt3__tdl_1__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set TDL_1 :: GPU Core Clocks */
#define cflgt3__tdl_1__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set TDL_1 :: AVG GPU Core Frequency */
#define cflgt3__tdl_1__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set TDL_1 :: AVG GPU Core Frequency */
#define cflgt3__tdl_1__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set TDL_1 :: GPU Busy */
#define cflgt3__tdl_1__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set TDL_1 :: VS Threads Dispatched */
#define cflgt3__tdl_1__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set TDL_1 :: HS Threads Dispatched */
#define cflgt3__tdl_1__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set TDL_1 :: DS Threads Dispatched */
#define cflgt3__tdl_1__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set TDL_1 :: GS Threads Dispatched */
#define cflgt3__tdl_1__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set TDL_1 :: FS Threads Dispatched */
#define cflgt3__tdl_1__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set TDL_1 :: CS Threads Dispatched */
#define cflgt3__tdl_1__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set TDL_1 :: EU Active */
#define cflgt3__tdl_1__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set TDL_1 :: EU Stall */
#define cflgt3__tdl_1__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set TDL_1 :: EU Both FPU Pipes Active */
#define cflgt3__tdl_1__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set TDL_1 :: VS FPU0 Pipe Active */
#define cflgt3__tdl_1__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set TDL_1 :: VS FPU1 Pipe Active */
#define cflgt3__tdl_1__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set TDL_1 :: VS Send Pipe Active */
#define cflgt3__tdl_1__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set TDL_1 :: PS FPU0 Pipe Active */
#define cflgt3__tdl_1__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set TDL_1 :: PS FPU1 Pipe Active */
#define cflgt3__tdl_1__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set TDL_1 :: PS Send Pipeline Active */
#define cflgt3__tdl_1__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set TDL_1 :: FS Both FPU Active */
#define cflgt3__tdl_1__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set TDL_1 :: Rasterized Pixels */
#define cflgt3__tdl_1__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set TDL_1 :: Early Hi-Depth Test Fails */
#define cflgt3__tdl_1__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set TDL_1 :: Early Depth Test Fails */
#define cflgt3__tdl_1__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set TDL_1 :: Samples Killed in FS */
#define cflgt3__tdl_1__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set TDL_1 :: Pixels Failing Tests */
#define cflgt3__tdl_1__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set TDL_1 :: Samples Written */
#define cflgt3__tdl_1__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set TDL_1 :: Samples Blended */
#define cflgt3__tdl_1__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set TDL_1 :: Sampler Texels */
#define cflgt3__tdl_1__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set TDL_1 :: Sampler Texels Misses */
#define cflgt3__tdl_1__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set TDL_1 :: SLM Bytes Read */
#define cflgt3__tdl_1__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set TDL_1 :: SLM Bytes Read */
#define cflgt3__tdl_1__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_1 :: SLM Bytes Written */
#define cflgt3__tdl_1__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set TDL_1 :: SLM Bytes Written */
#define cflgt3__tdl_1__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_1 :: Shader Memory Accesses */
#define cflgt3__tdl_1__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set TDL_1 :: Shader Atomic Memory Accesses */
#define cflgt3__tdl_1__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set TDL_1 :: L3 Shader Throughput */
#define cflgt3__tdl_1__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set TDL_1 :: L3 Shader Throughput */
#define cflgt3__tdl_1__l3_shader_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Metric set TDL_1 :: Shader Barrier Messages */
#define cflgt3__tdl_1__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set TDL_1 :: NonPS Thread Ready For Dispatch on Slice0 Subslice1 */
#define cflgt3__tdl_1__non_ps_thread01_ready_for_dispatch__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set TDL_1 :: PS Thread Ready For Dispatch on Slice0 Subslice0 */
#define cflgt3__tdl_1__ps_thread00_ready_for_dispatch__read \
    bdw__render_basic__sampler1_busy__read

/* Metric set TDL_1 :: NonPS Thread Ready For Dispatch on Slice0 Subslice0 */
#define cflgt3__tdl_1__non_ps_thread00_ready_for_dispatch__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Metric set TDL_1 :: PS Thread Ready For Dispatch on Slice0 Subslice2 */
#define cflgt3__tdl_1__ps_thread02_ready_for_dispatch__read \
    bdw__render_basic__sampler1_bottleneck__read

/* Metric set TDL_1 :: NonPS Thread Ready For Dispatch on Slice0 Subslice2 */
#define cflgt3__tdl_1__non_ps_thread02_ready_for_dispatch__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* Metric set TDL_1 :: PS Thread Ready For Dispatch on Slice0 Subslice1 */
#define cflgt3__tdl_1__ps_thread01_ready_for_dispatch__read \
    bdw__render_pipe_profile__cl_bottleneck__read

/* Metric set TDL_1 :: SQ is full */
#define cflgt3__tdl_1__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set TDL_2 :: GPU Time Elapsed */
#define cflgt3__tdl_2__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set TDL_2 :: GPU Core Clocks */
#define cflgt3__tdl_2__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set TDL_2 :: AVG GPU Core Frequency */
#define cflgt3__tdl_2__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set TDL_2 :: AVG GPU Core Frequency */
#define cflgt3__tdl_2__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set TDL_2 :: GPU Busy */
#define cflgt3__tdl_2__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set TDL_2 :: VS Threads Dispatched */
#define cflgt3__tdl_2__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set TDL_2 :: HS Threads Dispatched */
#define cflgt3__tdl_2__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set TDL_2 :: DS Threads Dispatched */
#define cflgt3__tdl_2__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set TDL_2 :: GS Threads Dispatched */
#define cflgt3__tdl_2__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set TDL_2 :: FS Threads Dispatched */
#define cflgt3__tdl_2__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set TDL_2 :: CS Threads Dispatched */
#define cflgt3__tdl_2__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set TDL_2 :: EU Active */
#define cflgt3__tdl_2__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set TDL_2 :: EU Stall */
#define cflgt3__tdl_2__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set TDL_2 :: EU Both FPU Pipes Active */
#define cflgt3__tdl_2__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set TDL_2 :: VS FPU0 Pipe Active */
#define cflgt3__tdl_2__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set TDL_2 :: VS FPU1 Pipe Active */
#define cflgt3__tdl_2__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set TDL_2 :: VS Send Pipe Active */
#define cflgt3__tdl_2__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set TDL_2 :: PS FPU0 Pipe Active */
#define cflgt3__tdl_2__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set TDL_2 :: PS FPU1 Pipe Active */
#define cflgt3__tdl_2__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set TDL_2 :: PS Send Pipeline Active */
#define cflgt3__tdl_2__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set TDL_2 :: FS Both FPU Active */
#define cflgt3__tdl_2__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set TDL_2 :: Rasterized Pixels */
#define cflgt3__tdl_2__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set TDL_2 :: Early Hi-Depth Test Fails */
#define cflgt3__tdl_2__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set TDL_2 :: Early Depth Test Fails */
#define cflgt3__tdl_2__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set TDL_2 :: Samples Killed in FS */
#define cflgt3__tdl_2__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set TDL_2 :: Pixels Failing Tests */
#define cflgt3__tdl_2__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set TDL_2 :: Samples Written */
#define cflgt3__tdl_2__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set TDL_2 :: Samples Blended */
#define cflgt3__tdl_2__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set TDL_2 :: Sampler Texels */
#define cflgt3__tdl_2__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set TDL_2 :: Sampler Texels Misses */
#define cflgt3__tdl_2__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set TDL_2 :: SLM Bytes Read */
#define cflgt3__tdl_2__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set TDL_2 :: SLM Bytes Read */
#define cflgt3__tdl_2__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_2 :: SLM Bytes Written */
#define cflgt3__tdl_2__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set TDL_2 :: SLM Bytes Written */
#define cflgt3__tdl_2__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_2 :: Shader Memory Accesses */
#define cflgt3__tdl_2__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set TDL_2 :: Shader Atomic Memory Accesses */
#define cflgt3__tdl_2__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set TDL_2 :: L3 Shader Throughput */
#define cflgt3__tdl_2__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set TDL_2 :: L3 Shader Throughput */
#define cflgt3__tdl_2__l3_shader_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Metric set TDL_2 :: Shader Barrier Messages */
#define cflgt3__tdl_2__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice1 Port 0 */
#define cflgt3__tdl_2__thread_header01_ready_port0__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice0 Port 1 */
#define cflgt3__tdl_2__thread_header00_ready_port1__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice0 Port 0 */
#define cflgt3__tdl_2__thread_header00_ready_port0__read \
    bdw__render_pipe_profile__sf_stall__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice2 Port 1 */
#define cflgt3__tdl_2__thread_header02_ready_port1__read \
    bdw__render_pipe_profile__cl_stall__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice2 Port 0 */
#define cflgt3__tdl_2__thread_header02_ready_port0__read \
    bdw__render_pipe_profile__so_stall__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice1 Port 1 */
#define cflgt3__tdl_2__thread_header01_ready_port1__read \
    bdw__render_pipe_profile__ds_stall__read

/* Metric set TDL_2 :: SQ is full */
#define cflgt3__tdl_2__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Compute Metrics Extra Gen9 :: GPU Time Elapsed */
#define cflgt3__compute_extra__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Compute Metrics Extra Gen9 :: GPU Core Clocks */
#define cflgt3__compute_extra__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Compute Metrics Extra Gen9 :: AVG GPU Core Frequency */
#define cflgt3__compute_extra__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Compute Metrics Extra Gen9 :: AVG GPU Core Frequency */
#define cflgt3__compute_extra__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Compute Metrics Extra Gen9 :: EU FPU1 Pipe Active */
#define cflgt3__compute_extra__fpu1_active__read \
    bdw__render_basic__eu_stall__read

/* Compute Metrics Extra Gen9 :: EU FPU1 Pipe Active including Ext Math */
#define cflgt3__compute_extra__fpu1_active_adjusted__read \
    bdw__compute_extra__fpu1_active_adjusted__read

/* Media Vme Pipe Gen9 :: GPU Time Elapsed */
#define cflgt3__vme_pipe__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Media Vme Pipe Gen9 :: GPU Core Clocks */
#define cflgt3__vme_pipe__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Media Vme Pipe Gen9 :: AVG GPU Core Frequency */
#define cflgt3__vme_pipe__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Media Vme Pipe Gen9 :: AVG GPU Core Frequency */
#define cflgt3__vme_pipe__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Media Vme Pipe Gen9 :: GPU Busy */
#define cflgt3__vme_pipe__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Media Vme Pipe Gen9 :: CS Threads Dispatched */
#define cflgt3__vme_pipe__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Media Vme Pipe Gen9 :: EU Active */
#define cflgt3__vme_pipe__eu_active__read \
    bdw__render_basic__eu_active__read

/* Media Vme Pipe Gen9 :: EU Stall */
#define cflgt3__vme_pipe__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Media Vme Pipe Gen9 :: EU Both FPU Pipes Active */
#define cflgt3__vme_pipe__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Media Vme Pipe Gen9 :: EU Thread Occupancy */
#define cflgt3__vme_pipe__eu_thread_occupancy__read \
    bdw__vme_pipe__eu_thread_occupancy__read

/* Media Vme Pipe Gen9 :: VME Busy */
#define cflgt3__vme_pipe__vme_busy__read \
    bdw__vme_pipe__vme_busy__read

/* Gpu Rings Busyness :: GPU Time Elapsed */
#define cflgt3__gpu_busyness__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Gpu Rings Busyness :: GPU Core Clocks */
#define cflgt3__gpu_busyness__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Gpu Rings Busyness :: AVG GPU Core Frequency */
#define cflgt3__gpu_busyness__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Gpu Rings Busyness :: AVG GPU Core Frequency */
#define cflgt3__gpu_busyness__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Gpu Rings Busyness :: Render Ring Busy */
#define cflgt3__gpu_busyness__render_busy__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Gpu Rings Busyness :: Vdbox0 Ring Busy */
#define cflgt3__gpu_busyness__vdbox0_busy__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Gpu Rings Busyness :: Vdbox1 Ring Busy */
#define cflgt3__gpu_busyness__vdbox1_busy__read \
    bdw__render_pipe_profile__sf_stall__read

/* Gpu Rings Busyness :: Vebox Ring Busy */
#define cflgt3__gpu_busyness__vebox_busy__read \
    bdw__render_pipe_profile__cl_stall__read

/* Gpu Rings Busyness :: Blitter Ring Busy */
#define cflgt3__gpu_busyness__blitter_busy__read \
    bdw__render_pipe_profile__so_stall__read

/* Gpu Rings Busyness :: AnyRingBusy */
#define cflgt3__gpu_busyness__any_ring_busy__read \
    bdw__render_basic__sampler0_busy__read

/* MDAPI testing set Gen9 :: GPU Time Elapsed */
#define cflgt3__test_oa__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* MDAPI testing set Gen9 :: GPU Core Clocks */
#define cflgt3__test_oa__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* MDAPI testing set Gen9 :: AVG GPU Core Frequency */
#define cflgt3__test_oa__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* MDAPI testing set Gen9 :: AVG GPU Core Frequency */
#define cflgt3__test_oa__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* MDAPI testing set Gen9 :: TestCounter0 */
#define cflgt3__test_oa__counter0__read \
    hsw__compute_extended__eu_untyped_reads0__read

/* MDAPI testing set Gen9 :: TestCounter1 */
#define cflgt3__test_oa__counter1__read \
    hsw__compute_extended__eu_untyped_writes0__read

/* MDAPI testing set Gen9 :: TestCounter2 */
#define cflgt3__test_oa__counter2__read \
    hsw__compute_extended__eu_typed_reads0__read

/* MDAPI testing set Gen9 :: TestCounter3 */
#define cflgt3__test_oa__counter3__read \
    hsw__compute_extended__eu_typed_writes0__read

/* MDAPI testing set Gen9 :: TestCounter4 */
#define cflgt3__test_oa__counter4__read \
    hsw__compute_extended__eu_untyped_atomics0__read

/* MDAPI testing set Gen9 :: TestCounter5 */
#define cflgt3__test_oa__counter5__read \
    hsw__compute_extended__eu_typed_atomics0__read

/* MDAPI testing set Gen9 :: TestCounter6 */
#define cflgt3__test_oa__counter6__read \
    hsw__compute_extended__eu_urb_atomics0__read

/* MDAPI testing set Gen9 :: TestCounter7 */
#define cflgt3__test_oa__counter7__read \
    hsw__compute_extended__gpu_clocks__read

/* MDAPI testing set Gen9 :: TestCounter8 */
#define cflgt3__test_oa__counter8__read \
    hsw__memory_reads__gpu_core_clocks__read

/* Metric set PMA Stall :: GPU Time Elapsed */
#define cflgt3__pma__stall__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set PMA Stall :: GPU Core Clocks */
#define cflgt3__pma__stall__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set PMA Stall :: AVG GPU Core Frequency */
#define cflgt3__pma__stall__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set PMA Stall :: AVG GPU Core Frequency */
#define cflgt3__pma__stall__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set PMA Stall :: STC PMA stall */
#define cflgt3__pma__stall__stc_pma_stall__read \
    sklgt2__pma__stall__stc_pma_stall__read

/* Render Metrics Basic Gen9 :: GPU Time Elapsed */
#define bxt__render_basic__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Render Metrics Basic Gen9 :: GPU Core Clocks */
#define bxt__render_basic__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Render Metrics Basic Gen9 :: AVG GPU Core Frequency */
#define bxt__render_basic__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Render Metrics Basic Gen9 :: AVG GPU Core Frequency */
#define bxt__render_basic__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Render Metrics Basic Gen9 :: VS Threads Dispatched */
#define bxt__render_basic__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Render Metrics Basic Gen9 :: HS Threads Dispatched */
#define bxt__render_basic__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Render Metrics Basic Gen9 :: DS Threads Dispatched */
#define bxt__render_basic__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Render Metrics Basic Gen9 :: GS Threads Dispatched */
#define bxt__render_basic__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Render Metrics Basic Gen9 :: FS Threads Dispatched */
#define bxt__render_basic__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Render Metrics Basic Gen9 :: CS Threads Dispatched */
#define bxt__render_basic__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Render Metrics Basic Gen9 :: GPU Busy */
#define bxt__render_basic__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Render Metrics Basic Gen9 :: EU Active */
#define bxt__render_basic__eu_active__read \
    bdw__render_basic__eu_active__read

/* Render Metrics Basic Gen9 :: EU Stall */
#define bxt__render_basic__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Render Metrics Basic Gen9 :: EU Both FPU Pipes Active */
#define bxt__render_basic__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Render Metrics Basic Gen9 :: VS FPU0 Pipe Active */
#define bxt__render_basic__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Render Metrics Basic Gen9 :: VS FPU1 Pipe Active */
#define bxt__render_basic__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Render Metrics Basic Gen9 :: VS Send Pipe Active */
#define bxt__render_basic__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Render Metrics Basic Gen9 :: PS FPU0 Pipe Active */
#define bxt__render_basic__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Render Metrics Basic Gen9 :: PS FPU1 Pipe Active */
#define bxt__render_basic__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Render Metrics Basic Gen9 :: PS Send Pipeline Active */
#define bxt__render_basic__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Render Metrics Basic Gen9 :: FS Both FPU Active */
#define bxt__render_basic__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Render Metrics Basic Gen9 :: Sampler 0 Busy */
#define bxt__render_basic__sampler0_busy__read \
    bdw__render_basic__sampler0_busy__read

/* Render Metrics Basic Gen9 :: Sampler 1 Busy */
#define bxt__render_basic__sampler1_busy__read \
    bdw__render_basic__sampler1_busy__read

/* Render Metrics Basic Gen9 :: Samplers Busy */
#define bxt__render_basic__samplers_busy__read \
    bdw__render_basic__samplers_busy__read

/* Render Metrics Basic Gen9 :: Sampler 0 Bottleneck */
#define bxt__render_basic__sampler0_bottleneck__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Render Metrics Basic Gen9 :: Sampler 1 Bottleneck */
#define bxt__render_basic__sampler1_bottleneck__read \
    bdw__render_basic__sampler1_bottleneck__read

/* Render Metrics Basic Gen9 :: Rasterized Pixels */
#define bxt__render_basic__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Render Metrics Basic Gen9 :: Early Hi-Depth Test Fails */
#define bxt__render_basic__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Render Metrics Basic Gen9 :: Early Depth Test Fails */
#define bxt__render_basic__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Render Metrics Basic Gen9 :: Samples Killed in FS */
#define bxt__render_basic__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Render Metrics Basic Gen9 :: Pixels Failing Tests */
#define bxt__render_basic__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Render Metrics Basic Gen9 :: Samples Written */
#define bxt__render_basic__samples_written__read \
    bdw__render_basic__samples_written__read

/* Render Metrics Basic Gen9 :: Samples Blended */
#define bxt__render_basic__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Render Metrics Basic Gen9 :: Sampler Texels */
#define bxt__render_basic__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Render Metrics Basic Gen9 :: Sampler Texels Misses */
#define bxt__render_basic__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Render Metrics Basic Gen9 :: Sampler Cache Misses */
#define bxt__render_basic__sampler_l1_misses__read \
    sklgt2__render_basic__sampler_l1_misses__read

/* Render Metrics Basic Gen9 :: SLM Bytes Read */
#define bxt__render_basic__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Render Metrics Basic Gen9 :: SLM Bytes Read */
#define bxt__render_basic__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics Basic Gen9 :: SLM Bytes Written */
#define bxt__render_basic__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Render Metrics Basic Gen9 :: SLM Bytes Written */
#define bxt__render_basic__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics Basic Gen9 :: Shader Memory Accesses */
#define bxt__render_basic__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Render Metrics Basic Gen9 :: Shader Atomic Memory Accesses */
#define bxt__render_basic__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Render Metrics Basic Gen9 :: L3 Lookup Accesses w/o IC */
#define bxt__render_basic__l3_lookups__read \
    sklgt2__render_basic__l3_lookups__read

/* Render Metrics Basic Gen9 :: L3 Misses */
#define bxt__render_basic__l3_misses__read \
    hsw__compute_extended__typed_atomics0__read

/* Render Metrics Basic Gen9 :: L3 Sampler Throughput */
#define bxt__render_basic__l3_sampler_throughput__read \
    sklgt2__render_basic__l3_sampler_throughput__read

/* Render Metrics Basic Gen9 :: L3 Sampler Throughput */
#define bxt__render_basic__l3_sampler_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics Basic Gen9 :: L3 Shader Throughput */
#define bxt__render_basic__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Render Metrics Basic Gen9 :: L3 Shader Throughput */
#define bxt__render_basic__l3_shader_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics Basic Gen9 :: Shader Barrier Messages */
#define bxt__render_basic__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Render Metrics Basic Gen9 :: GTI Fixed Pipe Throughput */
#define bxt__render_basic__gti_vf_throughput__read \
    bdw__render_basic__gti_vf_throughput__read

/* Render Metrics Basic Gen9 :: GTI Fixed Pipe Throughput */
#define bxt__render_basic__gti_vf_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Render Metrics Basic Gen9 :: GTI Depth Throughput */
#define bxt__render_basic__gti_depth_throughput__read \
    bdw__render_basic__gti_depth_throughput__read

/* Render Metrics Basic Gen9 :: GTI Depth Throughput */
#define bxt__render_basic__gti_depth_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics Basic Gen9 :: GTI RCC Throughput */
#define bxt__render_basic__gti_rcc_throughput__read \
    bdw__render_basic__gti_rcc_throughput__read

/* Render Metrics Basic Gen9 :: GTI RCC Throughput */
#define bxt__render_basic__gti_rcc_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics Basic Gen9 :: GTI L3 Throughput */
#define bxt__render_basic__gti_l3_throughput__read \
    hsw__render_basic__gti_l3_throughput__read

/* Render Metrics Basic Gen9 :: GTI L3 Throughput */
#define bxt__render_basic__gti_l3_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics Basic Gen9 :: GTI HDC TLB Lookup Throughput */
#define bxt__render_basic__gti_hdc_lookups_throughput__read \
    bdw__render_basic__gti_hdc_lookups_throughput__read

/* Render Metrics Basic Gen9 :: GTI HDC TLB Lookup Throughput */
#define bxt__render_basic__gti_hdc_lookups_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics Basic Gen9 :: GTI Read Throughput */
#define bxt__render_basic__gti_read_throughput__read \
    bdw__render_basic__gti_read_throughput__read

/* Render Metrics Basic Gen9 :: GTI Read Throughput */
#define bxt__render_basic__gti_read_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Render Metrics Basic Gen9 :: GTI Write Throughput */
#define bxt__render_basic__gti_write_throughput__read \
    hsw__render_basic__gti_write_throughput__read

/* Render Metrics Basic Gen9 :: GTI Write Throughput */
#define bxt__render_basic__gti_write_throughput__max \
    bdw__render_basic__gti_write_throughput__max

/* Render Metrics Basic Gen9 :: Samplers Bottleneck */
#define bxt__render_basic__sampler_bottleneck__read \
    bdw__render_basic__sampler_bottleneck__read

/* Compute Metrics Basic Gen9 :: GPU Time Elapsed */
#define bxt__compute_basic__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Compute Metrics Basic Gen9 :: GPU Core Clocks */
#define bxt__compute_basic__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Compute Metrics Basic Gen9 :: AVG GPU Core Frequency */
#define bxt__compute_basic__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Compute Metrics Basic Gen9 :: AVG GPU Core Frequency */
#define bxt__compute_basic__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Compute Metrics Basic Gen9 :: GPU Busy */
#define bxt__compute_basic__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Compute Metrics Basic Gen9 :: VS Threads Dispatched */
#define bxt__compute_basic__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Compute Metrics Basic Gen9 :: HS Threads Dispatched */
#define bxt__compute_basic__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Compute Metrics Basic Gen9 :: DS Threads Dispatched */
#define bxt__compute_basic__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Compute Metrics Basic Gen9 :: GS Threads Dispatched */
#define bxt__compute_basic__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Compute Metrics Basic Gen9 :: FS Threads Dispatched */
#define bxt__compute_basic__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Compute Metrics Basic Gen9 :: CS Threads Dispatched */
#define bxt__compute_basic__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Compute Metrics Basic Gen9 :: EU Active */
#define bxt__compute_basic__eu_active__read \
    bdw__render_basic__eu_active__read

/* Compute Metrics Basic Gen9 :: EU Stall */
#define bxt__compute_basic__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Compute Metrics Basic Gen9 :: EU Both FPU Pipes Active */
#define bxt__compute_basic__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Compute Metrics Basic Gen9 :: EU FPU0 Pipe Active */
#define bxt__compute_basic__fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Compute Metrics Basic Gen9 :: EU FPU1 Pipe Active */
#define bxt__compute_basic__fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Compute Metrics Basic Gen9 :: EU AVG IPC Rate */
#define bxt__compute_basic__eu_avg_ipc_rate__read \
    bdw__compute_basic__eu_avg_ipc_rate__read

/* Compute Metrics Basic Gen9 :: EU AVG IPC Rate */
#define bxt__compute_basic__eu_avg_ipc_rate__max \
    bdw__compute_basic__eu_avg_ipc_rate__max

/* Compute Metrics Basic Gen9 :: EU Send Pipe Active */
#define bxt__compute_basic__eu_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Compute Metrics Basic Gen9 :: EU Thread Occupancy */
#define bxt__compute_basic__eu_thread_occupancy__read \
    bdw__compute_basic__eu_thread_occupancy__read

/* Compute Metrics Basic Gen9 :: Rasterized Pixels */
#define bxt__compute_basic__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Compute Metrics Basic Gen9 :: Early Hi-Depth Test Fails */
#define bxt__compute_basic__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Compute Metrics Basic Gen9 :: Early Depth Test Fails */
#define bxt__compute_basic__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Compute Metrics Basic Gen9 :: Samples Killed in FS */
#define bxt__compute_basic__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Compute Metrics Basic Gen9 :: Pixels Failing Tests */
#define bxt__compute_basic__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Compute Metrics Basic Gen9 :: Samples Written */
#define bxt__compute_basic__samples_written__read \
    bdw__render_basic__samples_written__read

/* Compute Metrics Basic Gen9 :: Samples Blended */
#define bxt__compute_basic__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Compute Metrics Basic Gen9 :: Sampler Texels */
#define bxt__compute_basic__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Compute Metrics Basic Gen9 :: Sampler Texels Misses */
#define bxt__compute_basic__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Compute Metrics Basic Gen9 :: SLM Bytes Read */
#define bxt__compute_basic__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Compute Metrics Basic Gen9 :: SLM Bytes Read */
#define bxt__compute_basic__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Basic Gen9 :: SLM Bytes Written */
#define bxt__compute_basic__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Compute Metrics Basic Gen9 :: SLM Bytes Written */
#define bxt__compute_basic__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Basic Gen9 :: Shader Memory Accesses */
#define bxt__compute_basic__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Compute Metrics Basic Gen9 :: Shader Atomic Memory Accesses */
#define bxt__compute_basic__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Compute Metrics Basic Gen9 :: L3 Shader Throughput */
#define bxt__compute_basic__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Compute Metrics Basic Gen9 :: L3 Shader Throughput */
#define bxt__compute_basic__l3_shader_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen9 :: Shader Barrier Messages */
#define bxt__compute_basic__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Compute Metrics Basic Gen9 :: Typed Bytes Read */
#define bxt__compute_basic__typed_bytes_read__read \
    hsw__compute_basic__untyped_bytes_read__read

/* Compute Metrics Basic Gen9 :: Typed Bytes Read */
#define bxt__compute_basic__typed_bytes_read__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen9 :: Typed Bytes Written */
static uint64_t
bxt__compute_basic__typed_bytes_written__read(const struct intel_perf *perf,
                                              const struct intel_perf_metric_set *metric_set,
                                              uint64_t *accumulator)
{
    /* RPN equation: B 3 READ B 4 READ UADD $EuSlicesTotalCount 64 UMUL UMUL */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 3];
    uint64_t tmp1 = accumulator[metric_set->b_offset + 4];
    uint64_t tmp2 = tmp0 + tmp1;
    uint64_t tmp3 = perf->devinfo.n_eu_slices * 64;
    uint64_t tmp4 = tmp2 * tmp3;

    return tmp4;
}

/* Compute Metrics Basic Gen9 :: Typed Bytes Written */
#define bxt__compute_basic__typed_bytes_written__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen9 :: Untyped Bytes Read */
#define bxt__compute_basic__untyped_bytes_read__read \
    hsw__compute_basic__typed_bytes_written__read

/* Compute Metrics Basic Gen9 :: Untyped Bytes Read */
#define bxt__compute_basic__untyped_bytes_read__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen9 :: Untyped Writes */
static uint64_t
bxt__compute_basic__untyped_bytes_written__read(const struct intel_perf *perf,
                                                const struct intel_perf_metric_set *metric_set,
                                                uint64_t *accumulator)
{
    /* RPN equation: C 1 READ C 2 READ UADD $EuSlicesTotalCount 64 UMUL UMUL */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 1];
    uint64_t tmp1 = accumulator[metric_set->c_offset + 2];
    uint64_t tmp2 = tmp0 + tmp1;
    uint64_t tmp3 = perf->devinfo.n_eu_slices * 64;
    uint64_t tmp4 = tmp2 * tmp3;

    return tmp4;
}

/* Compute Metrics Basic Gen9 :: Untyped Writes */
#define bxt__compute_basic__untyped_bytes_written__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen9 :: GTI Read Throughput */
#define bxt__compute_basic__gti_read_throughput__read \
    hsw__render_basic__gti_l3_throughput__read

/* Compute Metrics Basic Gen9 :: GTI Read Throughput */
#define bxt__compute_basic__gti_read_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen9 :: GTI Write Throughput */
#define bxt__compute_basic__gti_write_throughput__read \
    bdw__render_basic__gti_hdc_lookups_throughput__read

/* Compute Metrics Basic Gen9 :: GTI Write Throughput */
#define bxt__compute_basic__gti_write_throughput__max \
    bdw__render_basic__gti_write_throughput__max

/* Render Metrics for 3D Pipeline Profile Gen9 :: GPU Time Elapsed */
#define bxt__render_pipe_profile__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: GPU Core Clocks */
#define bxt__render_pipe_profile__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: AVG GPU Core Frequency */
#define bxt__render_pipe_profile__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: AVG GPU Core Frequency */
#define bxt__render_pipe_profile__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Render Metrics for 3D Pipeline Profile Gen9 :: GPU Busy */
#define bxt__render_pipe_profile__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: VS Threads Dispatched */
#define bxt__render_pipe_profile__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: HS Threads Dispatched */
#define bxt__render_pipe_profile__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: DS Threads Dispatched */
#define bxt__render_pipe_profile__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: GS Threads Dispatched */
#define bxt__render_pipe_profile__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: FS Threads Dispatched */
#define bxt__render_pipe_profile__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: CS Threads Dispatched */
#define bxt__render_pipe_profile__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: EU Active */
#define bxt__render_pipe_profile__eu_active__read \
    bdw__render_basic__eu_active__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: EU Stall */
#define bxt__render_pipe_profile__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Rasterized Pixels */
#define bxt__render_pipe_profile__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Early Hi-Depth Test Fails */
#define bxt__render_pipe_profile__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Early Depth Test Fails */
#define bxt__render_pipe_profile__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Samples Killed in FS */
#define bxt__render_pipe_profile__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Pixels Failing Tests */
#define bxt__render_pipe_profile__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Samples Written */
#define bxt__render_pipe_profile__samples_written__read \
    bdw__render_basic__samples_written__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Samples Blended */
#define bxt__render_pipe_profile__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Sampler Texels */
#define bxt__render_pipe_profile__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Sampler Texels Misses */
#define bxt__render_pipe_profile__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: SLM Bytes Read */
#define bxt__render_pipe_profile__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: SLM Bytes Read */
#define bxt__render_pipe_profile__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics for 3D Pipeline Profile Gen9 :: SLM Bytes Written */
#define bxt__render_pipe_profile__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: SLM Bytes Written */
#define bxt__render_pipe_profile__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics for 3D Pipeline Profile Gen9 :: Shader Memory Accesses */
#define bxt__render_pipe_profile__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Shader Atomic Memory Accesses */
#define bxt__render_pipe_profile__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: L3 Shader Throughput */
#define bxt__render_pipe_profile__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: L3 Shader Throughput */
#define bxt__render_pipe_profile__l3_shader_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics for 3D Pipeline Profile Gen9 :: Shader Barrier Messages */
#define bxt__render_pipe_profile__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: VF Bottleneck */
#define bxt__render_pipe_profile__vf_bottleneck__read \
    bdw__render_pipe_profile__vf_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: VS Bottleneck */
#define bxt__render_pipe_profile__vs_bottleneck__read \
    bdw__render_basic__sampler0_busy__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: HS Bottleneck */
#define bxt__render_pipe_profile__hs_bottleneck__read \
    bdw__render_basic__sampler1_busy__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: DS Bottleneck */
#define bxt__render_pipe_profile__ds_bottleneck__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: GS Bottleneck */
#define bxt__render_pipe_profile__gs_bottleneck__read \
    bdw__render_basic__sampler1_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: SO Bottleneck */
#define bxt__render_pipe_profile__so_bottleneck__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Clipper Bottleneck */
#define bxt__render_pipe_profile__cl_bottleneck__read \
    bdw__render_pipe_profile__cl_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Strip-Fans Bottleneck */
#define bxt__render_pipe_profile__sf_bottleneck__read \
    bdw__render_pipe_profile__sf_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Hi-Depth Bottleneck */
#define bxt__render_pipe_profile__hi_depth_bottleneck__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Early Depth Bottleneck */
#define bxt__render_pipe_profile__early_depth_bottleneck__read \
    bdw__render_pipe_profile__early_depth_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: BC Bottleneck */
#define bxt__render_pipe_profile__bc_bottleneck__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: HS Stall */
#define bxt__render_pipe_profile__hs_stall__read \
    bdw__render_pipe_profile__hs_stall__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: DS Stall */
#define bxt__render_pipe_profile__ds_stall__read \
    bdw__render_pipe_profile__ds_stall__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: SO Stall */
#define bxt__render_pipe_profile__so_stall__read \
    bdw__render_pipe_profile__so_stall__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: CL Stall */
#define bxt__render_pipe_profile__cl_stall__read \
    bdw__render_pipe_profile__cl_stall__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: SF Stall */
#define bxt__render_pipe_profile__sf_stall__read \
    bdw__render_pipe_profile__sf_stall__read

/* Memory Reads Distribution Gen9 :: GPU Time Elapsed */
#define bxt__memory_reads__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Memory Reads Distribution Gen9 :: GPU Core Clocks */
#define bxt__memory_reads__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Memory Reads Distribution Gen9 :: AVG GPU Core Frequency */
#define bxt__memory_reads__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Memory Reads Distribution Gen9 :: AVG GPU Core Frequency */
#define bxt__memory_reads__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Memory Reads Distribution Gen9 :: GPU Busy */
#define bxt__memory_reads__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Memory Reads Distribution Gen9 :: VS Threads Dispatched */
#define bxt__memory_reads__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Memory Reads Distribution Gen9 :: HS Threads Dispatched */
#define bxt__memory_reads__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Memory Reads Distribution Gen9 :: DS Threads Dispatched */
#define bxt__memory_reads__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Memory Reads Distribution Gen9 :: GS Threads Dispatched */
#define bxt__memory_reads__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Memory Reads Distribution Gen9 :: FS Threads Dispatched */
#define bxt__memory_reads__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Memory Reads Distribution Gen9 :: CS Threads Dispatched */
#define bxt__memory_reads__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Memory Reads Distribution Gen9 :: EU Active */
#define bxt__memory_reads__eu_active__read \
    bdw__render_basic__eu_active__read

/* Memory Reads Distribution Gen9 :: EU Stall */
#define bxt__memory_reads__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Memory Reads Distribution Gen9 :: Rasterized Pixels */
#define bxt__memory_reads__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Memory Reads Distribution Gen9 :: Early Hi-Depth Test Fails */
#define bxt__memory_reads__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Memory Reads Distribution Gen9 :: Early Depth Test Fails */
#define bxt__memory_reads__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Memory Reads Distribution Gen9 :: Samples Killed in FS */
#define bxt__memory_reads__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Memory Reads Distribution Gen9 :: Pixels Failing Tests */
#define bxt__memory_reads__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Memory Reads Distribution Gen9 :: Samples Written */
#define bxt__memory_reads__samples_written__read \
    bdw__render_basic__samples_written__read

/* Memory Reads Distribution Gen9 :: Samples Blended */
#define bxt__memory_reads__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Memory Reads Distribution Gen9 :: Sampler Texels */
#define bxt__memory_reads__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Memory Reads Distribution Gen9 :: Sampler Texels Misses */
#define bxt__memory_reads__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Memory Reads Distribution Gen9 :: SLM Bytes Read */
#define bxt__memory_reads__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Memory Reads Distribution Gen9 :: SLM Bytes Read */
#define bxt__memory_reads__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Memory Reads Distribution Gen9 :: SLM Bytes Written */
#define bxt__memory_reads__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Memory Reads Distribution Gen9 :: SLM Bytes Written */
#define bxt__memory_reads__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Memory Reads Distribution Gen9 :: Shader Memory Accesses */
#define bxt__memory_reads__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Memory Reads Distribution Gen9 :: Shader Atomic Memory Accesses */
#define bxt__memory_reads__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Memory Reads Distribution Gen9 :: Shader Barrier Messages */
#define bxt__memory_reads__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Memory Reads Distribution Gen9 :: GtiCmdStreamerMemoryReads */
#define bxt__memory_reads__gti_cmd_streamer_memory_reads__read \
    hsw__compute_extended__eu_untyped_reads0__read

/* Memory Reads Distribution Gen9 :: GtiRsMemoryReads */
#define bxt__memory_reads__gti_rs_memory_reads__read \
    hsw__compute_extended__eu_typed_reads0__read

/* Memory Reads Distribution Gen9 :: GtiVfMemoryReads */
#define bxt__memory_reads__gti_vf_memory_reads__read \
    hsw__compute_extended__eu_untyped_writes0__read

/* Memory Reads Distribution Gen9 :: GtiRccMemoryReads */
#define bxt__memory_reads__gti_rcc_memory_reads__read \
    hsw__compute_extended__eu_typed_writes0__read

/* Memory Reads Distribution Gen9 :: GtiMscMemoryReads */
#define bxt__memory_reads__gti_msc_memory_reads__read \
    hsw__compute_extended__eu_untyped_atomics0__read

/* Memory Reads Distribution Gen9 :: GtiHizMemoryReads */
#define bxt__memory_reads__gti_hiz_memory_reads__read \
    hsw__compute_extended__eu_typed_atomics0__read

/* Memory Reads Distribution Gen9 :: GtiStcMemoryReads */
#define bxt__memory_reads__gti_stc_memory_reads__read \
    hsw__compute_extended__eu_urb_atomics0__read

/* Memory Reads Distribution Gen9 :: GtiRczMemoryReads */
#define bxt__memory_reads__gti_rcz_memory_reads__read \
    hsw__compute_extended__gpu_clocks__read

/* Memory Reads Distribution Gen9 :: GtiMemoryReads */
#define bxt__memory_reads__gti_memory_reads__read \
    hsw__compute_extended__typed_writes0__read

/* Memory Reads Distribution Gen9 :: GtiL3Bank0Reads */
#define bxt__memory_reads__gti_l3_bank0_reads__read \
    hsw__compute_extended__typed_atomics0__read

/* Memory Reads Distribution Gen9 :: GtiL3Bank1Reads */
#define bxt__memory_reads__gti_l3_bank1_reads__read \
    hsw__memory_reads__gti_memory_reads__read

/* Memory Reads Distribution Gen9 :: GtiL3Bank2Reads */
#define bxt__memory_reads__gti_l3_bank2_reads__read \
    hsw__memory_reads__llc_read_accesses__read

/* Memory Reads Distribution Gen9 :: GtiL3Bank3Reads */
#define bxt__memory_reads__gti_l3_bank3_reads__read \
    hsw__memory_reads__gpu_core_clocks__read

/* Memory Reads Distribution Gen9 :: GtiL3Reads */
#define bxt__memory_reads__gti_l3_reads__read \
    bdw__memory_reads__gti_l3_reads__read

/* Memory Reads Distribution Gen9 :: GtiRingAccesses */
#define bxt__memory_reads__gti_ring_accesses__read \
    bdw__memory_reads__gti_ring_accesses__read

/* Memory Writes Distribution Gen9 :: GPU Time Elapsed */
#define bxt__memory_writes__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Memory Writes Distribution Gen9 :: GPU Core Clocks */
#define bxt__memory_writes__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Memory Writes Distribution Gen9 :: AVG GPU Core Frequency */
#define bxt__memory_writes__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Memory Writes Distribution Gen9 :: AVG GPU Core Frequency */
#define bxt__memory_writes__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Memory Writes Distribution Gen9 :: GPU Busy */
#define bxt__memory_writes__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Memory Writes Distribution Gen9 :: VS Threads Dispatched */
#define bxt__memory_writes__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Memory Writes Distribution Gen9 :: HS Threads Dispatched */
#define bxt__memory_writes__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Memory Writes Distribution Gen9 :: DS Threads Dispatched */
#define bxt__memory_writes__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Memory Writes Distribution Gen9 :: GS Threads Dispatched */
#define bxt__memory_writes__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Memory Writes Distribution Gen9 :: FS Threads Dispatched */
#define bxt__memory_writes__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Memory Writes Distribution Gen9 :: CS Threads Dispatched */
#define bxt__memory_writes__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Memory Writes Distribution Gen9 :: EU Active */
#define bxt__memory_writes__eu_active__read \
    bdw__render_basic__eu_active__read

/* Memory Writes Distribution Gen9 :: EU Stall */
#define bxt__memory_writes__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Memory Writes Distribution Gen9 :: Rasterized Pixels */
#define bxt__memory_writes__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Memory Writes Distribution Gen9 :: Early Hi-Depth Test Fails */
#define bxt__memory_writes__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Memory Writes Distribution Gen9 :: Early Depth Test Fails */
#define bxt__memory_writes__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Memory Writes Distribution Gen9 :: Samples Killed in FS */
#define bxt__memory_writes__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Memory Writes Distribution Gen9 :: Pixels Failing Tests */
#define bxt__memory_writes__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Memory Writes Distribution Gen9 :: Samples Written */
#define bxt__memory_writes__samples_written__read \
    bdw__render_basic__samples_written__read

/* Memory Writes Distribution Gen9 :: Samples Blended */
#define bxt__memory_writes__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Memory Writes Distribution Gen9 :: Sampler Texels */
#define bxt__memory_writes__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Memory Writes Distribution Gen9 :: Sampler Texels Misses */
#define bxt__memory_writes__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Memory Writes Distribution Gen9 :: SLM Bytes Read */
#define bxt__memory_writes__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Memory Writes Distribution Gen9 :: SLM Bytes Read */
#define bxt__memory_writes__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Memory Writes Distribution Gen9 :: SLM Bytes Written */
#define bxt__memory_writes__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Memory Writes Distribution Gen9 :: SLM Bytes Written */
#define bxt__memory_writes__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Memory Writes Distribution Gen9 :: Shader Memory Accesses */
#define bxt__memory_writes__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Memory Writes Distribution Gen9 :: Shader Atomic Memory Accesses */
#define bxt__memory_writes__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Memory Writes Distribution Gen9 :: L3 Shader Throughput */
#define bxt__memory_writes__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Memory Writes Distribution Gen9 :: L3 Shader Throughput */
#define bxt__memory_writes__l3_shader_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Memory Writes Distribution Gen9 :: Shader Barrier Messages */
#define bxt__memory_writes__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Memory Writes Distribution Gen9 :: GtiCmdStreamerMemoryWrites */
#define bxt__memory_writes__gti_cmd_streamer_memory_writes__read \
    hsw__compute_extended__eu_untyped_reads0__read

/* Memory Writes Distribution Gen9 :: GtiSoMemoryWrites */
#define bxt__memory_writes__gti_so_memory_writes__read \
    hsw__compute_extended__eu_typed_reads0__read

/* Memory Writes Distribution Gen9 :: GtiRccMemoryWrites */
#define bxt__memory_writes__gti_rcc_memory_writes__read \
    hsw__compute_extended__eu_typed_writes0__read

/* Memory Writes Distribution Gen9 :: GtiMscMemoryWrites */
#define bxt__memory_writes__gti_msc_memory_writes__read \
    hsw__compute_extended__eu_untyped_atomics0__read

/* Memory Writes Distribution Gen9 :: GtiHizMemoryWrites */
#define bxt__memory_writes__gti_hiz_memory_writes__read \
    hsw__compute_extended__eu_typed_atomics0__read

/* Memory Writes Distribution Gen9 :: GtiStcMemoryWrites */
#define bxt__memory_writes__gti_stc_memory_writes__read \
    hsw__compute_extended__eu_urb_atomics0__read

/* Memory Writes Distribution Gen9 :: GtiRczMemoryWrites */
#define bxt__memory_writes__gti_rcz_memory_writes__read \
    hsw__compute_extended__gpu_clocks__read

/* Memory Writes Distribution Gen9 :: GtiMemoryWrites */
#define bxt__memory_writes__gti_memory_writes__read \
    hsw__compute_extended__typed_writes0__read

/* Memory Writes Distribution Gen9 :: GtiL3Bank0Writes */
#define bxt__memory_writes__gti_l3_bank0_writes__read \
    hsw__compute_extended__typed_atomics0__read

/* Memory Writes Distribution Gen9 :: GtiL3Bank1Writes */
#define bxt__memory_writes__gti_l3_bank1_writes__read \
    hsw__memory_reads__gti_memory_reads__read

/* Memory Writes Distribution Gen9 :: GtiL3Bank2Writes */
#define bxt__memory_writes__gti_l3_bank2_writes__read \
    hsw__memory_reads__llc_read_accesses__read

/* Memory Writes Distribution Gen9 :: GtiL3Bank3Writes */
#define bxt__memory_writes__gti_l3_bank3_writes__read \
    hsw__memory_reads__gpu_core_clocks__read

/* Memory Writes Distribution Gen9 :: GtiL3Writes */
#define bxt__memory_writes__gti_l3_writes__read \
    bdw__memory_reads__gti_l3_reads__read

/* Memory Writes Distribution Gen9 :: GtiRingAccesses */
#define bxt__memory_writes__gti_ring_accesses__read \
    bdw__memory_reads__gti_ring_accesses__read

/* Compute Metrics Extended Gen9 :: GPU Time Elapsed */
#define bxt__compute_extended__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Compute Metrics Extended Gen9 :: GPU Core Clocks */
#define bxt__compute_extended__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Compute Metrics Extended Gen9 :: AVG GPU Core Frequency */
#define bxt__compute_extended__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Compute Metrics Extended Gen9 :: AVG GPU Core Frequency */
#define bxt__compute_extended__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Compute Metrics Extended Gen9 :: CS Threads Dispatched */
#define bxt__compute_extended__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Compute Metrics Extended Gen9 :: EU Active */
#define bxt__compute_extended__eu_active__read \
    bdw__render_basic__eu_active__read

/* Compute Metrics Extended Gen9 :: EU Stall */
#define bxt__compute_extended__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Compute Metrics Extended Gen9 :: EU Both FPU Pipes Active */
#define bxt__compute_extended__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Compute Metrics Extended Gen9 :: EU FPU0 Pipe Active */
#define bxt__compute_extended__fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Compute Metrics Extended Gen9 :: EU FPU1 Pipe Active */
#define bxt__compute_extended__fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Compute Metrics Extended Gen9 :: EU AVG IPC Rate */
#define bxt__compute_extended__eu_avg_ipc_rate__read \
    bdw__compute_basic__eu_avg_ipc_rate__read

/* Compute Metrics Extended Gen9 :: EU AVG IPC Rate */
#define bxt__compute_extended__eu_avg_ipc_rate__max \
    bdw__compute_basic__eu_avg_ipc_rate__max

/* Compute Metrics Extended Gen9 :: EU Send Pipe Active */
#define bxt__compute_extended__eu_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Compute Metrics Extended Gen9 :: EU Thread Occupancy */
#define bxt__compute_extended__eu_thread_occupancy__read \
    bdw__compute_basic__eu_thread_occupancy__read

/* Compute Metrics Extended Gen9 :: Sampler Texels */
#define bxt__compute_extended__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Compute Metrics Extended Gen9 :: Sampler Texels Misses */
#define bxt__compute_extended__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Compute Metrics Extended Gen9 :: SLM Bytes Read */
#define bxt__compute_extended__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Compute Metrics Extended Gen9 :: SLM Bytes Read */
#define bxt__compute_extended__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Extended Gen9 :: SLM Bytes Written */
#define bxt__compute_extended__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Compute Metrics Extended Gen9 :: SLM Bytes Written */
#define bxt__compute_extended__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Extended Gen9 :: Shader Memory Accesses */
#define bxt__compute_extended__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Compute Metrics Extended Gen9 :: Shader Atomic Memory Accesses */
#define bxt__compute_extended__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Compute Metrics Extended Gen9 :: L3 Shader Throughput */
#define bxt__compute_extended__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Compute Metrics Extended Gen9 :: L3 Shader Throughput */
#define bxt__compute_extended__l3_shader_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Extended Gen9 :: Shader Barrier Messages */
#define bxt__compute_extended__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Compute Metrics Extended Gen9 :: EuUntypedReads0 */
#define bxt__compute_extended__eu_untyped_reads0__read \
    hsw__compute_extended__eu_untyped_reads0__read

/* Compute Metrics Extended Gen9 :: EuTypedReads0 */
#define bxt__compute_extended__eu_typed_reads0__read \
    hsw__compute_extended__eu_typed_reads0__read

/* Compute Metrics Extended Gen9 :: EuUntypedWrites0 */
#define bxt__compute_extended__eu_untyped_writes0__read \
    hsw__compute_extended__eu_untyped_writes0__read

/* Compute Metrics Extended Gen9 :: EuTypedWrites0 */
#define bxt__compute_extended__eu_typed_writes0__read \
    hsw__compute_extended__eu_typed_writes0__read

/* Compute Metrics Extended Gen9 :: EuUntypedAtomics0 */
#define bxt__compute_extended__eu_untyped_atomics0__read \
    hsw__compute_extended__eu_untyped_atomics0__read

/* Compute Metrics Extended Gen9 :: EuTypedAtomics0 */
#define bxt__compute_extended__eu_typed_atomics0__read \
    hsw__compute_extended__eu_typed_atomics0__read

/* Compute Metrics Extended Gen9 :: EuA64UntypedReads0 */
#define bxt__compute_extended__eu_a64_untyped_reads0__read \
    hsw__compute_extended__eu_urb_atomics0__read

/* Compute Metrics Extended Gen9 :: EuA64UntypedWrites0 */
#define bxt__compute_extended__eu_a64_untyped_writes0__read \
    hsw__compute_extended__gpu_clocks__read

/* Compute Metrics Extended Gen9 :: Typed Reads 0 */
#define bxt__compute_extended__typed_reads0__read \
    hsw__render_basic__gpu_core_clocks__read

/* Compute Metrics Extended Gen9 :: Typed Writes 0 */
#define bxt__compute_extended__typed_writes0__read \
    hsw__compute_extended__typed_writes0__read

/* Compute Metrics Extended Gen9 :: Untyped Reads 0 */
#define bxt__compute_extended__untyped_reads0__read \
    hsw__compute_extended__untyped_reads0__read

/* Compute Metrics Extended Gen9 :: Untyped Writes 0 */
#define bxt__compute_extended__untyped_writes0__read \
    hsw__compute_extended__untyped_writes0__read

/* Compute Metrics Extended Gen9 :: Typed Atomics 0 */
#define bxt__compute_extended__typed_atomics0__read \
    hsw__compute_extended__typed_atomics0__read

/* Compute Metrics Extended Gen9 :: TypedReadsPerCacheLine */
#define bxt__compute_extended__typed_reads_per_cache_line__read \
    hsw__compute_extended__typed_reads_per_cache_line__read

/* Compute Metrics Extended Gen9 :: TypedWritesPerCacheLine */
#define bxt__compute_extended__typed_writes_per_cache_line__read \
    hsw__compute_extended__typed_writes_per_cache_line__read

/* Compute Metrics Extended Gen9 :: UntypedReadsPerCacheLine */
#define bxt__compute_extended__untyped_reads_per_cache_line__read \
    bdw__compute_extended__untyped_reads_per_cache_line__read

/* Compute Metrics Extended Gen9 :: UntypedWritesPerCacheLine */
#define bxt__compute_extended__untyped_writes_per_cache_line__read \
    bdw__compute_extended__untyped_writes_per_cache_line__read

/* Compute Metrics Extended Gen9 :: TypedAtomicsPerCacheLine */
#define bxt__compute_extended__typed_atomics_per_cache_line__read \
    hsw__compute_extended__typed_atomics_per_cache_line__read

/* Compute Metrics L3 Cache Gen9 :: GPU Time Elapsed */
#define bxt__compute_l3_cache__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Compute Metrics L3 Cache Gen9 :: GPU Core Clocks */
#define bxt__compute_l3_cache__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Compute Metrics L3 Cache Gen9 :: AVG GPU Core Frequency */
#define bxt__compute_l3_cache__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Compute Metrics L3 Cache Gen9 :: AVG GPU Core Frequency */
#define bxt__compute_l3_cache__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Compute Metrics L3 Cache Gen9 :: GPU Busy */
#define bxt__compute_l3_cache__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Compute Metrics L3 Cache Gen9 :: VS Threads Dispatched */
#define bxt__compute_l3_cache__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Compute Metrics L3 Cache Gen9 :: HS Threads Dispatched */
#define bxt__compute_l3_cache__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Compute Metrics L3 Cache Gen9 :: DS Threads Dispatched */
#define bxt__compute_l3_cache__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Compute Metrics L3 Cache Gen9 :: GS Threads Dispatched */
#define bxt__compute_l3_cache__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Compute Metrics L3 Cache Gen9 :: FS Threads Dispatched */
#define bxt__compute_l3_cache__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Compute Metrics L3 Cache Gen9 :: CS Threads Dispatched */
#define bxt__compute_l3_cache__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Compute Metrics L3 Cache Gen9 :: EU Active */
#define bxt__compute_l3_cache__eu_active__read \
    bdw__render_basic__eu_active__read

/* Compute Metrics L3 Cache Gen9 :: EU Stall */
#define bxt__compute_l3_cache__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Compute Metrics L3 Cache Gen9 :: EU Both FPU Pipes Active */
#define bxt__compute_l3_cache__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU0 Pipe Active */
#define bxt__compute_l3_cache__fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU1 Pipe Active */
#define bxt__compute_l3_cache__fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Compute Metrics L3 Cache Gen9 :: EU AVG IPC Rate */
#define bxt__compute_l3_cache__eu_avg_ipc_rate__read \
    bdw__compute_basic__eu_avg_ipc_rate__read

/* Compute Metrics L3 Cache Gen9 :: EU AVG IPC Rate */
#define bxt__compute_l3_cache__eu_avg_ipc_rate__max \
    bdw__compute_basic__eu_avg_ipc_rate__max

/* Compute Metrics L3 Cache Gen9 :: EU Send Pipe Active */
#define bxt__compute_l3_cache__eu_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU0 Hybrid Instruction */
#define bxt__compute_l3_cache__eu_hybrid_fpu0_instruction__read \
    bdw__compute_l3_cache__eu_hybrid_fpu0_instruction__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU1 Hybrid Instruction */
#define bxt__compute_l3_cache__eu_hybrid_fpu1_instruction__read \
    bdw__compute_l3_cache__eu_hybrid_fpu1_instruction__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU0 Ternary Instruction */
#define bxt__compute_l3_cache__eu_ternary_fpu0_instruction__read \
    bdw__render_basic__ps_fpu0_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU1 Ternary Instruction */
#define bxt__compute_l3_cache__eu_ternary_fpu1_instruction__read \
    bdw__render_basic__ps_fpu1_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU0 Binary Instruction */
#define bxt__compute_l3_cache__eu_binary_fpu0_instruction__read \
    bdw__render_basic__ps_send_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU1 Binary Instruction */
#define bxt__compute_l3_cache__eu_binary_fpu1_instruction__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU0 Move Instruction */
#define bxt__compute_l3_cache__eu_move_fpu0_instruction__read \
    bdw__compute_l3_cache__eu_move_fpu0_instruction__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU1 Move Instruction */
#define bxt__compute_l3_cache__eu_move_fpu1_instruction__read \
    bdw__compute_l3_cache__eu_move_fpu1_instruction__read

/* Compute Metrics L3 Cache Gen9 :: Rasterized Pixels */
#define bxt__compute_l3_cache__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Compute Metrics L3 Cache Gen9 :: Early Hi-Depth Test Fails */
#define bxt__compute_l3_cache__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Compute Metrics L3 Cache Gen9 :: Early Depth Test Fails */
#define bxt__compute_l3_cache__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Compute Metrics L3 Cache Gen9 :: Samples Killed in FS */
#define bxt__compute_l3_cache__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Compute Metrics L3 Cache Gen9 :: Pixels Failing Tests */
#define bxt__compute_l3_cache__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Compute Metrics L3 Cache Gen9 :: Samples Written */
#define bxt__compute_l3_cache__samples_written__read \
    bdw__render_basic__samples_written__read

/* Compute Metrics L3 Cache Gen9 :: Samples Blended */
#define bxt__compute_l3_cache__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Compute Metrics L3 Cache Gen9 :: Sampler Accesses */
#define bxt__compute_l3_cache__sampler_accesses__read \
    bdw__render_pipe_profile__sampler_accesses__read

/* Compute Metrics L3 Cache Gen9 :: Sampler Texels */
#define bxt__compute_l3_cache__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Compute Metrics L3 Cache Gen9 :: Sampler Texels Misses */
#define bxt__compute_l3_cache__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Compute Metrics L3 Cache Gen9 :: SLM Bytes Read */
#define bxt__compute_l3_cache__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Compute Metrics L3 Cache Gen9 :: SLM Bytes Read */
#define bxt__compute_l3_cache__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics L3 Cache Gen9 :: SLM Bytes Written */
#define bxt__compute_l3_cache__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Compute Metrics L3 Cache Gen9 :: SLM Bytes Written */
#define bxt__compute_l3_cache__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics L3 Cache Gen9 :: Shader Memory Accesses */
#define bxt__compute_l3_cache__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Compute Metrics L3 Cache Gen9 :: Shader Atomic Memory Accesses */
#define bxt__compute_l3_cache__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Compute Metrics L3 Cache Gen9 :: L3 Accesses */
#define bxt__compute_l3_cache__l3_accesses__read \
    sklgt2__compute_l3_cache__l3_accesses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Misses */
#define bxt__compute_l3_cache__l3_misses__read \
    bdw__compute_l3_cache__l3_misses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Sampler Throughput */
#define bxt__compute_l3_cache__l3_sampler_throughput__read \
    chv__render_basic__l3_sampler_throughput__read

/* Compute Metrics L3 Cache Gen9 :: L3 Sampler Throughput */
#define bxt__compute_l3_cache__l3_sampler_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics L3 Cache Gen9 :: L3 Shader Throughput */
#define bxt__compute_l3_cache__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Compute Metrics L3 Cache Gen9 :: L3 Shader Throughput */
#define bxt__compute_l3_cache__l3_shader_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics L3 Cache Gen9 :: L3 Total Throughput */
#define bxt__compute_l3_cache__l3_total_throughput__read \
    sklgt2__compute_l3_cache__l3_total_throughput__read

/* Compute Metrics L3 Cache Gen9 :: L3 Total Throughput */
#define bxt__compute_l3_cache__l3_total_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics L3 Cache Gen9 :: Shader Barrier Messages */
#define bxt__compute_l3_cache__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Compute Metrics L3 Cache Gen9 :: L3 Bank 00 Accesses */
#define bxt__compute_l3_cache__l3_bank00_accesses__read \
    bdw__compute_l3_cache__l3_bank00_accesses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Bank 01 Accesses */
#define bxt__compute_l3_cache__l3_bank01_accesses__read \
    bdw__compute_l3_cache__l3_bank01_accesses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Bank 02 Accesses */
#define bxt__compute_l3_cache__l3_bank02_accesses__read \
    bdw__compute_l3_cache__l3_bank02_accesses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Bank 03 Accesses */
#define bxt__compute_l3_cache__l3_bank03_accesses__read \
    bdw__compute_l3_cache__l3_bank03_accesses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Bank 00 IC Accesses */
#define bxt__compute_l3_cache__l3_bank00_ic_accesses__read \
    bdw__compute_l3_cache__l3_bank00_ic_accesses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Bank 00 IC Hits */
#define bxt__compute_l3_cache__l3_bank00_ic_hits__read \
    bdw__compute_l3_cache__l3_bank00_ic_hits__read

/* Compute Metrics L3 Cache Gen9 :: GTI L3 Throughput */
#define bxt__compute_l3_cache__gti_l3_throughput__read \
    bdw__compute_l3_cache__gti_l3_throughput__read

/* Compute Metrics L3 Cache Gen9 :: GTI L3 Throughput */
#define bxt__compute_l3_cache__gti_l3_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics L3 Cache Gen9 :: GTI Read Throughput */
#define bxt__compute_l3_cache__gti_read_throughput__read \
    bdw__render_basic__gti_read_throughput__read

/* Compute Metrics L3 Cache Gen9 :: GTI Read Throughput */
#define bxt__compute_l3_cache__gti_read_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Compute Metrics L3 Cache Gen9 :: GTI Write Throughput */
#define bxt__compute_l3_cache__gti_write_throughput__read \
    hsw__render_basic__gti_write_throughput__read

/* Compute Metrics L3 Cache Gen9 :: GTI Write Throughput */
#define bxt__compute_l3_cache__gti_write_throughput__max \
    bdw__render_basic__gti_write_throughput__max

/* Metric set HDCAndSF :: GPU Time Elapsed */
#define bxt__hdc_and_sf__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set HDCAndSF :: GPU Core Clocks */
#define bxt__hdc_and_sf__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set HDCAndSF :: AVG GPU Core Frequency */
#define bxt__hdc_and_sf__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set HDCAndSF :: AVG GPU Core Frequency */
#define bxt__hdc_and_sf__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set HDCAndSF :: GPU Busy */
#define bxt__hdc_and_sf__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set HDCAndSF :: VS Threads Dispatched */
#define bxt__hdc_and_sf__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set HDCAndSF :: HS Threads Dispatched */
#define bxt__hdc_and_sf__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set HDCAndSF :: DS Threads Dispatched */
#define bxt__hdc_and_sf__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set HDCAndSF :: GS Threads Dispatched */
#define bxt__hdc_and_sf__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set HDCAndSF :: FS Threads Dispatched */
#define bxt__hdc_and_sf__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set HDCAndSF :: CS Threads Dispatched */
#define bxt__hdc_and_sf__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set HDCAndSF :: EU Active */
#define bxt__hdc_and_sf__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set HDCAndSF :: EU Stall */
#define bxt__hdc_and_sf__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set HDCAndSF :: EU Both FPU Pipes Active */
#define bxt__hdc_and_sf__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set HDCAndSF :: VS FPU0 Pipe Active */
#define bxt__hdc_and_sf__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set HDCAndSF :: VS FPU1 Pipe Active */
#define bxt__hdc_and_sf__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set HDCAndSF :: VS Send Pipe Active */
#define bxt__hdc_and_sf__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set HDCAndSF :: PS FPU0 Pipe Active */
#define bxt__hdc_and_sf__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set HDCAndSF :: PS FPU1 Pipe Active */
#define bxt__hdc_and_sf__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set HDCAndSF :: PS Send Pipeline Active */
#define bxt__hdc_and_sf__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set HDCAndSF :: FS Both FPU Active */
#define bxt__hdc_and_sf__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set HDCAndSF :: Rasterized Pixels */
#define bxt__hdc_and_sf__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set HDCAndSF :: Early Hi-Depth Test Fails */
#define bxt__hdc_and_sf__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set HDCAndSF :: Early Depth Test Fails */
#define bxt__hdc_and_sf__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set HDCAndSF :: Samples Killed in FS */
#define bxt__hdc_and_sf__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set HDCAndSF :: Pixels Failing Tests */
#define bxt__hdc_and_sf__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set HDCAndSF :: Samples Written */
#define bxt__hdc_and_sf__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set HDCAndSF :: Samples Blended */
#define bxt__hdc_and_sf__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set HDCAndSF :: Sampler Texels */
#define bxt__hdc_and_sf__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set HDCAndSF :: Sampler Texels Misses */
#define bxt__hdc_and_sf__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set HDCAndSF :: SLM Bytes Read */
#define bxt__hdc_and_sf__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set HDCAndSF :: SLM Bytes Read */
#define bxt__hdc_and_sf__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set HDCAndSF :: SLM Bytes Written */
#define bxt__hdc_and_sf__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set HDCAndSF :: SLM Bytes Written */
#define bxt__hdc_and_sf__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set HDCAndSF :: Shader Memory Accesses */
#define bxt__hdc_and_sf__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set HDCAndSF :: Shader Atomic Memory Accesses */
#define bxt__hdc_and_sf__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set HDCAndSF :: L3 Shader Throughput */
#define bxt__hdc_and_sf__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set HDCAndSF :: L3 Shader Throughput */
#define bxt__hdc_and_sf__l3_shader_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Metric set HDCAndSF :: Shader Barrier Messages */
#define bxt__hdc_and_sf__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set HDCAndSF :: Polygon Data Ready */
#define bxt__hdc_and_sf__poly_data_ready__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set HDCAndSF :: HDC stalled by L3 (s0.ss0) */
#define bxt__hdc_and_sf__non_sampler_shader00_access_stalled_on_l3__read \
    bdw__hdc_and_sf__non_sampler_shader02_access_stalled_on_l3__read

/* Metric set HDCAndSF :: HDC stalled by L3 (s0.ss1) */
#define bxt__hdc_and_sf__non_sampler_shader01_access_stalled_on_l3__read \
    bdw__hdc_and_sf__non_sampler_shader01_access_stalled_on_l3__read

/* Metric set HDCAndSF :: SQ is full */
#define bxt__hdc_and_sf__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set L3_1 :: GPU Time Elapsed */
#define bxt__l3_1__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set L3_1 :: GPU Core Clocks */
#define bxt__l3_1__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set L3_1 :: AVG GPU Core Frequency */
#define bxt__l3_1__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set L3_1 :: AVG GPU Core Frequency */
#define bxt__l3_1__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set L3_1 :: GPU Busy */
#define bxt__l3_1__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set L3_1 :: VS Threads Dispatched */
#define bxt__l3_1__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set L3_1 :: HS Threads Dispatched */
#define bxt__l3_1__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set L3_1 :: DS Threads Dispatched */
#define bxt__l3_1__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set L3_1 :: GS Threads Dispatched */
#define bxt__l3_1__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set L3_1 :: FS Threads Dispatched */
#define bxt__l3_1__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set L3_1 :: CS Threads Dispatched */
#define bxt__l3_1__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set L3_1 :: EU Active */
#define bxt__l3_1__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set L3_1 :: EU Stall */
#define bxt__l3_1__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set L3_1 :: EU Both FPU Pipes Active */
#define bxt__l3_1__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set L3_1 :: VS FPU0 Pipe Active */
#define bxt__l3_1__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set L3_1 :: VS FPU1 Pipe Active */
#define bxt__l3_1__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set L3_1 :: VS Send Pipe Active */
#define bxt__l3_1__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set L3_1 :: PS FPU0 Pipe Active */
#define bxt__l3_1__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set L3_1 :: PS FPU1 Pipe Active */
#define bxt__l3_1__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set L3_1 :: PS Send Pipeline Active */
#define bxt__l3_1__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set L3_1 :: FS Both FPU Active */
#define bxt__l3_1__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set L3_1 :: Rasterized Pixels */
#define bxt__l3_1__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set L3_1 :: Early Hi-Depth Test Fails */
#define bxt__l3_1__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set L3_1 :: Early Depth Test Fails */
#define bxt__l3_1__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set L3_1 :: Samples Killed in FS */
#define bxt__l3_1__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set L3_1 :: Pixels Failing Tests */
#define bxt__l3_1__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set L3_1 :: Samples Written */
#define bxt__l3_1__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set L3_1 :: Samples Blended */
#define bxt__l3_1__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set L3_1 :: Sampler Texels */
#define bxt__l3_1__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set L3_1 :: Sampler Texels Misses */
#define bxt__l3_1__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set L3_1 :: SLM Bytes Read */
#define bxt__l3_1__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set L3_1 :: SLM Bytes Read */
#define bxt__l3_1__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_1 :: SLM Bytes Written */
#define bxt__l3_1__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set L3_1 :: SLM Bytes Written */
#define bxt__l3_1__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_1 :: Shader Memory Accesses */
#define bxt__l3_1__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set L3_1 :: Shader Atomic Memory Accesses */
#define bxt__l3_1__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set L3_1 :: L3 Shader Throughput */
#define bxt__l3_1__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set L3_1 :: L3 Shader Throughput */
#define bxt__l3_1__l3_shader_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Metric set L3_1 :: Shader Barrier Messages */
#define bxt__l3_1__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set L3_1 :: Slice0 L3 Bank0 Stalled */
#define bxt__l3_1__l30_bank0_stalled__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set L3_1 :: Slice0 L3 Bank1 Stalled */
#define bxt__l3_1__l30_bank1_stalled__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* Metric set L3_1 :: Slice0 L3 Bank1 Active */
#define bxt__l3_1__l30_bank1_active__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set L3_1 :: Slice0 L3 Bank0 Active */
#define bxt__l3_1__l30_bank0_active__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set L3_1 :: SQ is full */
#define bxt__l3_1__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set RasterizerAndPixelBackend :: GPU Time Elapsed */
#define bxt__rasterizer_and_pixel_backend__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set RasterizerAndPixelBackend :: GPU Core Clocks */
#define bxt__rasterizer_and_pixel_backend__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set RasterizerAndPixelBackend :: AVG GPU Core Frequency */
#define bxt__rasterizer_and_pixel_backend__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set RasterizerAndPixelBackend :: AVG GPU Core Frequency */
#define bxt__rasterizer_and_pixel_backend__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set RasterizerAndPixelBackend :: GPU Busy */
#define bxt__rasterizer_and_pixel_backend__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set RasterizerAndPixelBackend :: VS Threads Dispatched */
#define bxt__rasterizer_and_pixel_backend__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set RasterizerAndPixelBackend :: HS Threads Dispatched */
#define bxt__rasterizer_and_pixel_backend__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set RasterizerAndPixelBackend :: DS Threads Dispatched */
#define bxt__rasterizer_and_pixel_backend__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set RasterizerAndPixelBackend :: GS Threads Dispatched */
#define bxt__rasterizer_and_pixel_backend__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set RasterizerAndPixelBackend :: FS Threads Dispatched */
#define bxt__rasterizer_and_pixel_backend__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set RasterizerAndPixelBackend :: CS Threads Dispatched */
#define bxt__rasterizer_and_pixel_backend__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set RasterizerAndPixelBackend :: EU Active */
#define bxt__rasterizer_and_pixel_backend__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set RasterizerAndPixelBackend :: EU Stall */
#define bxt__rasterizer_and_pixel_backend__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set RasterizerAndPixelBackend :: EU Both FPU Pipes Active */
#define bxt__rasterizer_and_pixel_backend__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set RasterizerAndPixelBackend :: VS FPU0 Pipe Active */
#define bxt__rasterizer_and_pixel_backend__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set RasterizerAndPixelBackend :: VS FPU1 Pipe Active */
#define bxt__rasterizer_and_pixel_backend__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set RasterizerAndPixelBackend :: VS Send Pipe Active */
#define bxt__rasterizer_and_pixel_backend__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set RasterizerAndPixelBackend :: PS FPU0 Pipe Active */
#define bxt__rasterizer_and_pixel_backend__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set RasterizerAndPixelBackend :: PS FPU1 Pipe Active */
#define bxt__rasterizer_and_pixel_backend__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set RasterizerAndPixelBackend :: PS Send Pipeline Active */
#define bxt__rasterizer_and_pixel_backend__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set RasterizerAndPixelBackend :: FS Both FPU Active */
#define bxt__rasterizer_and_pixel_backend__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set RasterizerAndPixelBackend :: Rasterized Pixels */
#define bxt__rasterizer_and_pixel_backend__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set RasterizerAndPixelBackend :: Early Hi-Depth Test Fails */
#define bxt__rasterizer_and_pixel_backend__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set RasterizerAndPixelBackend :: Early Depth Test Fails */
#define bxt__rasterizer_and_pixel_backend__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set RasterizerAndPixelBackend :: Samples Killed in FS */
#define bxt__rasterizer_and_pixel_backend__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set RasterizerAndPixelBackend :: Pixels Failing Tests */
#define bxt__rasterizer_and_pixel_backend__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set RasterizerAndPixelBackend :: Samples Written */
#define bxt__rasterizer_and_pixel_backend__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set RasterizerAndPixelBackend :: Samples Blended */
#define bxt__rasterizer_and_pixel_backend__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set RasterizerAndPixelBackend :: Sampler Texels */
#define bxt__rasterizer_and_pixel_backend__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set RasterizerAndPixelBackend :: Sampler Texels Misses */
#define bxt__rasterizer_and_pixel_backend__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Read */
#define bxt__rasterizer_and_pixel_backend__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Read */
#define bxt__rasterizer_and_pixel_backend__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Written */
#define bxt__rasterizer_and_pixel_backend__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Written */
#define bxt__rasterizer_and_pixel_backend__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set RasterizerAndPixelBackend :: Shader Memory Accesses */
#define bxt__rasterizer_and_pixel_backend__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set RasterizerAndPixelBackend :: Shader Atomic Memory Accesses */
#define bxt__rasterizer_and_pixel_backend__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set RasterizerAndPixelBackend :: L3 Shader Throughput */
#define bxt__rasterizer_and_pixel_backend__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set RasterizerAndPixelBackend :: L3 Shader Throughput */
#define bxt__rasterizer_and_pixel_backend__l3_shader_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Metric set RasterizerAndPixelBackend :: Shader Barrier Messages */
#define bxt__rasterizer_and_pixel_backend__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Post-EarlyZ Pixel Data Ready */
#define bxt__rasterizer_and_pixel_backend__pixel_data0_ready__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Rasterizer Input Available */
#define bxt__rasterizer_and_pixel_backend__rasterizer0_input_available__read \
    bdw__render_basic__sampler1_busy__read

/* Metric set RasterizerAndPixelBackend :: Slice0 PS Output Available */
#define bxt__rasterizer_and_pixel_backend__ps_output0_available__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Pixel Values Ready */
#define bxt__rasterizer_and_pixel_backend__pixel_values0_ready__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Rasterizer Output Ready */
#define bxt__rasterizer_and_pixel_backend__rasterizer0_output_ready__read \
    bdw__render_pipe_profile__sf_stall__read

/* Metric set RasterizerAndPixelBackend :: SQ is full */
#define bxt__rasterizer_and_pixel_backend__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set Sampler :: GPU Time Elapsed */
#define bxt__sampler__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set Sampler :: GPU Core Clocks */
#define bxt__sampler__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set Sampler :: AVG GPU Core Frequency */
#define bxt__sampler__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set Sampler :: AVG GPU Core Frequency */
#define bxt__sampler__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set Sampler :: GPU Busy */
#define bxt__sampler__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set Sampler :: VS Threads Dispatched */
#define bxt__sampler__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set Sampler :: HS Threads Dispatched */
#define bxt__sampler__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set Sampler :: DS Threads Dispatched */
#define bxt__sampler__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set Sampler :: GS Threads Dispatched */
#define bxt__sampler__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set Sampler :: FS Threads Dispatched */
#define bxt__sampler__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set Sampler :: CS Threads Dispatched */
#define bxt__sampler__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set Sampler :: EU Active */
#define bxt__sampler__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set Sampler :: EU Stall */
#define bxt__sampler__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set Sampler :: EU Both FPU Pipes Active */
#define bxt__sampler__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set Sampler :: VS FPU0 Pipe Active */
#define bxt__sampler__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set Sampler :: VS FPU1 Pipe Active */
#define bxt__sampler__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set Sampler :: VS Send Pipe Active */
#define bxt__sampler__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set Sampler :: PS FPU0 Pipe Active */
#define bxt__sampler__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set Sampler :: PS FPU1 Pipe Active */
#define bxt__sampler__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set Sampler :: PS Send Pipeline Active */
#define bxt__sampler__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set Sampler :: FS Both FPU Active */
#define bxt__sampler__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set Sampler :: Rasterized Pixels */
#define bxt__sampler__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set Sampler :: Early Hi-Depth Test Fails */
#define bxt__sampler__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set Sampler :: Early Depth Test Fails */
#define bxt__sampler__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set Sampler :: Samples Killed in FS */
#define bxt__sampler__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set Sampler :: Pixels Failing Tests */
#define bxt__sampler__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set Sampler :: Samples Written */
#define bxt__sampler__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set Sampler :: Samples Blended */
#define bxt__sampler__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set Sampler :: Sampler Texels */
#define bxt__sampler__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set Sampler :: Sampler Texels Misses */
#define bxt__sampler__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set Sampler :: SLM Bytes Read */
#define bxt__sampler__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set Sampler :: SLM Bytes Read */
#define bxt__sampler__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set Sampler :: SLM Bytes Written */
#define bxt__sampler__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set Sampler :: SLM Bytes Written */
#define bxt__sampler__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set Sampler :: Shader Memory Accesses */
#define bxt__sampler__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set Sampler :: Shader Atomic Memory Accesses */
#define bxt__sampler__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set Sampler :: L3 Shader Throughput */
#define bxt__sampler__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set Sampler :: L3 Shader Throughput */
#define bxt__sampler__l3_shader_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Metric set Sampler :: Shader Barrier Messages */
#define bxt__sampler__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set Sampler :: Slice0 Subslice1 Input Available */
#define bxt__sampler__sampler01_input_available__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set Sampler :: Slice0 Subslice2 Input Available */
#define bxt__sampler__sampler02_input_available__read \
    bdw__render_basic__sampler1_busy__read

/* Metric set Sampler :: Slice0 Subslice0 Input Available */
#define bxt__sampler__sampler00_input_available__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Metric set Sampler :: Slice0 Subslice2 Sampler Output Ready */
#define bxt__sampler__sampler02_output_ready__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set Sampler :: Slice0 Subslice0 Sampler Output Ready */
#define bxt__sampler__sampler00_output_ready__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set Sampler :: Slice0 Subslice1 Sampler Output Ready */
#define bxt__sampler__sampler01_output_ready__read \
    bdw__render_pipe_profile__sf_stall__read

/* Metric set Sampler :: SQ is full */
#define bxt__sampler__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set TDL_1 :: GPU Time Elapsed */
#define bxt__tdl_1__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set TDL_1 :: GPU Core Clocks */
#define bxt__tdl_1__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set TDL_1 :: AVG GPU Core Frequency */
#define bxt__tdl_1__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set TDL_1 :: AVG GPU Core Frequency */
#define bxt__tdl_1__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set TDL_1 :: GPU Busy */
#define bxt__tdl_1__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set TDL_1 :: VS Threads Dispatched */
#define bxt__tdl_1__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set TDL_1 :: HS Threads Dispatched */
#define bxt__tdl_1__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set TDL_1 :: DS Threads Dispatched */
#define bxt__tdl_1__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set TDL_1 :: GS Threads Dispatched */
#define bxt__tdl_1__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set TDL_1 :: FS Threads Dispatched */
#define bxt__tdl_1__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set TDL_1 :: CS Threads Dispatched */
#define bxt__tdl_1__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set TDL_1 :: EU Active */
#define bxt__tdl_1__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set TDL_1 :: EU Stall */
#define bxt__tdl_1__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set TDL_1 :: EU Both FPU Pipes Active */
#define bxt__tdl_1__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set TDL_1 :: VS FPU0 Pipe Active */
#define bxt__tdl_1__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set TDL_1 :: VS FPU1 Pipe Active */
#define bxt__tdl_1__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set TDL_1 :: VS Send Pipe Active */
#define bxt__tdl_1__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set TDL_1 :: PS FPU0 Pipe Active */
#define bxt__tdl_1__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set TDL_1 :: PS FPU1 Pipe Active */
#define bxt__tdl_1__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set TDL_1 :: PS Send Pipeline Active */
#define bxt__tdl_1__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set TDL_1 :: FS Both FPU Active */
#define bxt__tdl_1__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set TDL_1 :: Rasterized Pixels */
#define bxt__tdl_1__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set TDL_1 :: Early Hi-Depth Test Fails */
#define bxt__tdl_1__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set TDL_1 :: Early Depth Test Fails */
#define bxt__tdl_1__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set TDL_1 :: Samples Killed in FS */
#define bxt__tdl_1__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set TDL_1 :: Pixels Failing Tests */
#define bxt__tdl_1__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set TDL_1 :: Samples Written */
#define bxt__tdl_1__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set TDL_1 :: Samples Blended */
#define bxt__tdl_1__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set TDL_1 :: Sampler Texels */
#define bxt__tdl_1__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set TDL_1 :: Sampler Texels Misses */
#define bxt__tdl_1__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set TDL_1 :: SLM Bytes Read */
#define bxt__tdl_1__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set TDL_1 :: SLM Bytes Read */
#define bxt__tdl_1__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_1 :: SLM Bytes Written */
#define bxt__tdl_1__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set TDL_1 :: SLM Bytes Written */
#define bxt__tdl_1__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_1 :: Shader Memory Accesses */
#define bxt__tdl_1__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set TDL_1 :: Shader Atomic Memory Accesses */
#define bxt__tdl_1__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set TDL_1 :: L3 Shader Throughput */
#define bxt__tdl_1__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set TDL_1 :: L3 Shader Throughput */
#define bxt__tdl_1__l3_shader_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Metric set TDL_1 :: Shader Barrier Messages */
#define bxt__tdl_1__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set TDL_1 :: NonPS Thread Ready For Dispatch on Slice0 Subslice1 */
#define bxt__tdl_1__non_ps_thread01_ready_for_dispatch__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set TDL_1 :: PS Thread Ready For Dispatch on Slice0 Subslice0 */
#define bxt__tdl_1__ps_thread00_ready_for_dispatch__read \
    bdw__render_basic__sampler1_busy__read

/* Metric set TDL_1 :: NonPS Thread Ready For Dispatch on Slice0 Subslice0 */
#define bxt__tdl_1__non_ps_thread00_ready_for_dispatch__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Metric set TDL_1 :: PS Thread Ready For Dispatch on Slice0 Subslice2 */
#define bxt__tdl_1__ps_thread02_ready_for_dispatch__read \
    bdw__render_basic__sampler1_bottleneck__read

/* Metric set TDL_1 :: NonPS Thread Ready For Dispatch on Slice0 Subslice2 */
#define bxt__tdl_1__non_ps_thread02_ready_for_dispatch__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* Metric set TDL_1 :: PS Thread Ready For Dispatch on Slice0 Subslice1 */
#define bxt__tdl_1__ps_thread01_ready_for_dispatch__read \
    bdw__render_pipe_profile__cl_bottleneck__read

/* Metric set TDL_1 :: SQ is full */
#define bxt__tdl_1__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set TDL_2 :: GPU Time Elapsed */
#define bxt__tdl_2__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set TDL_2 :: GPU Core Clocks */
#define bxt__tdl_2__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set TDL_2 :: AVG GPU Core Frequency */
#define bxt__tdl_2__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set TDL_2 :: AVG GPU Core Frequency */
#define bxt__tdl_2__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set TDL_2 :: GPU Busy */
#define bxt__tdl_2__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set TDL_2 :: VS Threads Dispatched */
#define bxt__tdl_2__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set TDL_2 :: HS Threads Dispatched */
#define bxt__tdl_2__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set TDL_2 :: DS Threads Dispatched */
#define bxt__tdl_2__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set TDL_2 :: GS Threads Dispatched */
#define bxt__tdl_2__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set TDL_2 :: FS Threads Dispatched */
#define bxt__tdl_2__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set TDL_2 :: CS Threads Dispatched */
#define bxt__tdl_2__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set TDL_2 :: EU Active */
#define bxt__tdl_2__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set TDL_2 :: EU Stall */
#define bxt__tdl_2__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set TDL_2 :: EU Both FPU Pipes Active */
#define bxt__tdl_2__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set TDL_2 :: VS FPU0 Pipe Active */
#define bxt__tdl_2__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set TDL_2 :: VS FPU1 Pipe Active */
#define bxt__tdl_2__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set TDL_2 :: VS Send Pipe Active */
#define bxt__tdl_2__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set TDL_2 :: PS FPU0 Pipe Active */
#define bxt__tdl_2__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set TDL_2 :: PS FPU1 Pipe Active */
#define bxt__tdl_2__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set TDL_2 :: PS Send Pipeline Active */
#define bxt__tdl_2__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set TDL_2 :: FS Both FPU Active */
#define bxt__tdl_2__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set TDL_2 :: Rasterized Pixels */
#define bxt__tdl_2__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set TDL_2 :: Early Hi-Depth Test Fails */
#define bxt__tdl_2__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set TDL_2 :: Early Depth Test Fails */
#define bxt__tdl_2__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set TDL_2 :: Samples Killed in FS */
#define bxt__tdl_2__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set TDL_2 :: Pixels Failing Tests */
#define bxt__tdl_2__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set TDL_2 :: Samples Written */
#define bxt__tdl_2__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set TDL_2 :: Samples Blended */
#define bxt__tdl_2__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set TDL_2 :: Sampler Texels */
#define bxt__tdl_2__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set TDL_2 :: Sampler Texels Misses */
#define bxt__tdl_2__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set TDL_2 :: SLM Bytes Read */
#define bxt__tdl_2__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set TDL_2 :: SLM Bytes Read */
#define bxt__tdl_2__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_2 :: SLM Bytes Written */
#define bxt__tdl_2__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set TDL_2 :: SLM Bytes Written */
#define bxt__tdl_2__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_2 :: Shader Memory Accesses */
#define bxt__tdl_2__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set TDL_2 :: Shader Atomic Memory Accesses */
#define bxt__tdl_2__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set TDL_2 :: L3 Shader Throughput */
#define bxt__tdl_2__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set TDL_2 :: L3 Shader Throughput */
#define bxt__tdl_2__l3_shader_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Metric set TDL_2 :: Shader Barrier Messages */
#define bxt__tdl_2__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice1 Port 0 */
#define bxt__tdl_2__thread_header01_ready_port0__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice0 Port 1 */
#define bxt__tdl_2__thread_header00_ready_port1__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice0 Port 0 */
#define bxt__tdl_2__thread_header00_ready_port0__read \
    bdw__render_pipe_profile__sf_stall__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice2 Port 1 */
#define bxt__tdl_2__thread_header02_ready_port1__read \
    bdw__render_pipe_profile__cl_stall__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice2 Port 0 */
#define bxt__tdl_2__thread_header02_ready_port0__read \
    bdw__render_pipe_profile__so_stall__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice1 Port 1 */
#define bxt__tdl_2__thread_header01_ready_port1__read \
    bdw__render_pipe_profile__ds_stall__read

/* Metric set TDL_2 :: SQ is full */
#define bxt__tdl_2__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Compute Metrics Extra Gen9 :: GPU Time Elapsed */
#define bxt__compute_extra__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Compute Metrics Extra Gen9 :: GPU Core Clocks */
#define bxt__compute_extra__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Compute Metrics Extra Gen9 :: AVG GPU Core Frequency */
#define bxt__compute_extra__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Compute Metrics Extra Gen9 :: AVG GPU Core Frequency */
#define bxt__compute_extra__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Compute Metrics Extra Gen9 :: EU FPU1 Pipe Active */
#define bxt__compute_extra__fpu1_active__read \
    bdw__render_basic__eu_stall__read

/* Compute Metrics Extra Gen9 :: EU FPU1 Pipe Active including Ext Math */
#define bxt__compute_extra__fpu1_active_adjusted__read \
    sklgt2__compute_extra__fpu1_active_adjusted__read

/* Gpu Rings Busyness :: GPU Time Elapsed */
#define bxt__gpu_busyness__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Gpu Rings Busyness :: GPU Core Clocks */
#define bxt__gpu_busyness__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Gpu Rings Busyness :: AVG GPU Core Frequency */
#define bxt__gpu_busyness__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Gpu Rings Busyness :: AVG GPU Core Frequency */
#define bxt__gpu_busyness__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Gpu Rings Busyness :: Render Ring Busy */
#define bxt__gpu_busyness__render_busy__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Gpu Rings Busyness :: Vdbox0 Ring Busy */
#define bxt__gpu_busyness__vdbox0_busy__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Gpu Rings Busyness :: Vebox Ring Busy */
#define bxt__gpu_busyness__vebox_busy__read \
    bdw__render_pipe_profile__sf_stall__read

/* Gpu Rings Busyness :: Blitter Ring Busy */
#define bxt__gpu_busyness__blitter_busy__read \
    bdw__render_pipe_profile__cl_stall__read

/* Gpu Rings Busyness :: AnyRingBusy */
#define bxt__gpu_busyness__any_ring_busy__read \
    bdw__render_basic__sampler0_busy__read

/* MDAPI testing set Gen9 :: GPU Time Elapsed */
#define bxt__test_oa__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* MDAPI testing set Gen9 :: GPU Core Clocks */
#define bxt__test_oa__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* MDAPI testing set Gen9 :: AVG GPU Core Frequency */
#define bxt__test_oa__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* MDAPI testing set Gen9 :: AVG GPU Core Frequency */
#define bxt__test_oa__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* MDAPI testing set Gen9 :: TestCounter0 */
#define bxt__test_oa__counter0__read \
    hsw__compute_extended__eu_untyped_reads0__read

/* MDAPI testing set Gen9 :: TestCounter1 */
#define bxt__test_oa__counter1__read \
    hsw__compute_extended__eu_untyped_writes0__read

/* MDAPI testing set Gen9 :: TestCounter2 */
#define bxt__test_oa__counter2__read \
    hsw__compute_extended__eu_typed_reads0__read

/* MDAPI testing set Gen9 :: TestCounter3 */
#define bxt__test_oa__counter3__read \
    hsw__compute_extended__eu_typed_writes0__read

/* MDAPI testing set Gen9 :: TestCounter4 */
#define bxt__test_oa__counter4__read \
    hsw__compute_extended__eu_untyped_atomics0__read

/* MDAPI testing set Gen9 :: TestCounter5 */
#define bxt__test_oa__counter5__read \
    hsw__compute_extended__eu_typed_atomics0__read

/* MDAPI testing set Gen9 :: TestCounter6 */
#define bxt__test_oa__counter6__read \
    hsw__compute_extended__eu_urb_atomics0__read

/* MDAPI testing set Gen9 :: TestCounter7 */
#define bxt__test_oa__counter7__read \
    hsw__compute_extended__gpu_clocks__read

/* MDAPI testing set Gen9 :: TestCounter8 */
#define bxt__test_oa__counter8__read \
    hsw__memory_reads__gpu_core_clocks__read

/* Metric set PMA Stall :: GPU Time Elapsed */
#define bxt__pma__stall__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set PMA Stall :: GPU Core Clocks */
#define bxt__pma__stall__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set PMA Stall :: AVG GPU Core Frequency */
#define bxt__pma__stall__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set PMA Stall :: AVG GPU Core Frequency */
#define bxt__pma__stall__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set PMA Stall :: STC PMA stall */
#define bxt__pma__stall__stc_pma_stall__read \
    sklgt2__pma__stall__stc_pma_stall__read

/* Render Metrics Basic Gen9 :: GPU Time Elapsed */
#define glk__render_basic__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Render Metrics Basic Gen9 :: GPU Core Clocks */
#define glk__render_basic__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Render Metrics Basic Gen9 :: AVG GPU Core Frequency */
#define glk__render_basic__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Render Metrics Basic Gen9 :: AVG GPU Core Frequency */
#define glk__render_basic__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Render Metrics Basic Gen9 :: VS Threads Dispatched */
#define glk__render_basic__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Render Metrics Basic Gen9 :: HS Threads Dispatched */
#define glk__render_basic__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Render Metrics Basic Gen9 :: DS Threads Dispatched */
#define glk__render_basic__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Render Metrics Basic Gen9 :: GS Threads Dispatched */
#define glk__render_basic__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Render Metrics Basic Gen9 :: FS Threads Dispatched */
#define glk__render_basic__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Render Metrics Basic Gen9 :: CS Threads Dispatched */
#define glk__render_basic__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Render Metrics Basic Gen9 :: GPU Busy */
#define glk__render_basic__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Render Metrics Basic Gen9 :: EU Active */
#define glk__render_basic__eu_active__read \
    bdw__render_basic__eu_active__read

/* Render Metrics Basic Gen9 :: EU Stall */
#define glk__render_basic__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Render Metrics Basic Gen9 :: EU Both FPU Pipes Active */
#define glk__render_basic__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Render Metrics Basic Gen9 :: VS FPU0 Pipe Active */
#define glk__render_basic__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Render Metrics Basic Gen9 :: VS FPU1 Pipe Active */
#define glk__render_basic__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Render Metrics Basic Gen9 :: VS Send Pipe Active */
#define glk__render_basic__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Render Metrics Basic Gen9 :: PS FPU0 Pipe Active */
#define glk__render_basic__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Render Metrics Basic Gen9 :: PS FPU1 Pipe Active */
#define glk__render_basic__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Render Metrics Basic Gen9 :: PS Send Pipeline Active */
#define glk__render_basic__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Render Metrics Basic Gen9 :: FS Both FPU Active */
#define glk__render_basic__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Render Metrics Basic Gen9 :: Sampler 0 Busy */
#define glk__render_basic__sampler0_busy__read \
    bdw__render_basic__sampler0_busy__read

/* Render Metrics Basic Gen9 :: Sampler 1 Busy */
#define glk__render_basic__sampler1_busy__read \
    bdw__render_basic__sampler1_busy__read

/* Render Metrics Basic Gen9 :: Samplers Busy */
#define glk__render_basic__samplers_busy__read \
    bdw__render_basic__samplers_busy__read

/* Render Metrics Basic Gen9 :: Sampler 0 Bottleneck */
#define glk__render_basic__sampler0_bottleneck__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Render Metrics Basic Gen9 :: Sampler 1 Bottleneck */
#define glk__render_basic__sampler1_bottleneck__read \
    bdw__render_basic__sampler1_bottleneck__read

/* Render Metrics Basic Gen9 :: Rasterized Pixels */
#define glk__render_basic__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Render Metrics Basic Gen9 :: Early Hi-Depth Test Fails */
#define glk__render_basic__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Render Metrics Basic Gen9 :: Early Depth Test Fails */
#define glk__render_basic__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Render Metrics Basic Gen9 :: Samples Killed in FS */
#define glk__render_basic__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Render Metrics Basic Gen9 :: Pixels Failing Tests */
#define glk__render_basic__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Render Metrics Basic Gen9 :: Samples Written */
#define glk__render_basic__samples_written__read \
    bdw__render_basic__samples_written__read

/* Render Metrics Basic Gen9 :: Samples Blended */
#define glk__render_basic__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Render Metrics Basic Gen9 :: Sampler Texels */
#define glk__render_basic__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Render Metrics Basic Gen9 :: Sampler Texels Misses */
#define glk__render_basic__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Render Metrics Basic Gen9 :: Sampler Cache Misses */
#define glk__render_basic__sampler_l1_misses__read \
    sklgt2__render_basic__sampler_l1_misses__read

/* Render Metrics Basic Gen9 :: SLM Bytes Read */
#define glk__render_basic__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Render Metrics Basic Gen9 :: SLM Bytes Read */
#define glk__render_basic__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics Basic Gen9 :: SLM Bytes Written */
#define glk__render_basic__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Render Metrics Basic Gen9 :: SLM Bytes Written */
#define glk__render_basic__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics Basic Gen9 :: Shader Memory Accesses */
#define glk__render_basic__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Render Metrics Basic Gen9 :: Shader Atomic Memory Accesses */
#define glk__render_basic__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Render Metrics Basic Gen9 :: L3 Lookup Accesses w/o IC */
#define glk__render_basic__l3_lookups__read \
    sklgt2__render_basic__l3_lookups__read

/* Render Metrics Basic Gen9 :: L3 Misses */
#define glk__render_basic__l3_misses__read \
    hsw__compute_extended__typed_atomics0__read

/* Render Metrics Basic Gen9 :: L3 Sampler Throughput */
#define glk__render_basic__l3_sampler_throughput__read \
    sklgt2__render_basic__l3_sampler_throughput__read

/* Render Metrics Basic Gen9 :: L3 Sampler Throughput */
#define glk__render_basic__l3_sampler_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics Basic Gen9 :: L3 Shader Throughput */
#define glk__render_basic__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Render Metrics Basic Gen9 :: L3 Shader Throughput */
#define glk__render_basic__l3_shader_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics Basic Gen9 :: Shader Barrier Messages */
#define glk__render_basic__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Render Metrics Basic Gen9 :: GTI Fixed Pipe Throughput */
#define glk__render_basic__gti_vf_throughput__read \
    bdw__render_basic__gti_vf_throughput__read

/* Render Metrics Basic Gen9 :: GTI Fixed Pipe Throughput */
#define glk__render_basic__gti_vf_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Render Metrics Basic Gen9 :: GTI Depth Throughput */
#define glk__render_basic__gti_depth_throughput__read \
    bdw__render_basic__gti_depth_throughput__read

/* Render Metrics Basic Gen9 :: GTI Depth Throughput */
#define glk__render_basic__gti_depth_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics Basic Gen9 :: GTI RCC Throughput */
#define glk__render_basic__gti_rcc_throughput__read \
    bdw__render_basic__gti_rcc_throughput__read

/* Render Metrics Basic Gen9 :: GTI RCC Throughput */
#define glk__render_basic__gti_rcc_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics Basic Gen9 :: GTI L3 Throughput */
#define glk__render_basic__gti_l3_throughput__read \
    hsw__render_basic__gti_l3_throughput__read

/* Render Metrics Basic Gen9 :: GTI L3 Throughput */
#define glk__render_basic__gti_l3_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics Basic Gen9 :: GTI HDC TLB Lookup Throughput */
#define glk__render_basic__gti_hdc_lookups_throughput__read \
    bdw__render_basic__gti_hdc_lookups_throughput__read

/* Render Metrics Basic Gen9 :: GTI HDC TLB Lookup Throughput */
#define glk__render_basic__gti_hdc_lookups_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics Basic Gen9 :: GTI Read Throughput */
#define glk__render_basic__gti_read_throughput__read \
    bdw__render_basic__gti_read_throughput__read

/* Render Metrics Basic Gen9 :: GTI Read Throughput */
#define glk__render_basic__gti_read_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Render Metrics Basic Gen9 :: GTI Write Throughput */
#define glk__render_basic__gti_write_throughput__read \
    hsw__render_basic__gti_write_throughput__read

/* Render Metrics Basic Gen9 :: GTI Write Throughput */
#define glk__render_basic__gti_write_throughput__max \
    bdw__render_basic__gti_write_throughput__max

/* Render Metrics Basic Gen9 :: Samplers Bottleneck */
#define glk__render_basic__sampler_bottleneck__read \
    bdw__render_basic__sampler_bottleneck__read

/* Compute Metrics Basic Gen9 :: GPU Time Elapsed */
#define glk__compute_basic__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Compute Metrics Basic Gen9 :: GPU Core Clocks */
#define glk__compute_basic__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Compute Metrics Basic Gen9 :: AVG GPU Core Frequency */
#define glk__compute_basic__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Compute Metrics Basic Gen9 :: AVG GPU Core Frequency */
#define glk__compute_basic__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Compute Metrics Basic Gen9 :: GPU Busy */
#define glk__compute_basic__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Compute Metrics Basic Gen9 :: VS Threads Dispatched */
#define glk__compute_basic__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Compute Metrics Basic Gen9 :: HS Threads Dispatched */
#define glk__compute_basic__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Compute Metrics Basic Gen9 :: DS Threads Dispatched */
#define glk__compute_basic__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Compute Metrics Basic Gen9 :: GS Threads Dispatched */
#define glk__compute_basic__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Compute Metrics Basic Gen9 :: FS Threads Dispatched */
#define glk__compute_basic__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Compute Metrics Basic Gen9 :: CS Threads Dispatched */
#define glk__compute_basic__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Compute Metrics Basic Gen9 :: EU Active */
#define glk__compute_basic__eu_active__read \
    bdw__render_basic__eu_active__read

/* Compute Metrics Basic Gen9 :: EU Stall */
#define glk__compute_basic__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Compute Metrics Basic Gen9 :: EU Both FPU Pipes Active */
#define glk__compute_basic__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Compute Metrics Basic Gen9 :: EU FPU0 Pipe Active */
#define glk__compute_basic__fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Compute Metrics Basic Gen9 :: EU FPU1 Pipe Active */
#define glk__compute_basic__fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Compute Metrics Basic Gen9 :: EU AVG IPC Rate */
#define glk__compute_basic__eu_avg_ipc_rate__read \
    bdw__compute_basic__eu_avg_ipc_rate__read

/* Compute Metrics Basic Gen9 :: EU AVG IPC Rate */
#define glk__compute_basic__eu_avg_ipc_rate__max \
    bdw__compute_basic__eu_avg_ipc_rate__max

/* Compute Metrics Basic Gen9 :: EU Send Pipe Active */
#define glk__compute_basic__eu_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Compute Metrics Basic Gen9 :: EU Thread Occupancy */
#define glk__compute_basic__eu_thread_occupancy__read \
    bdw__compute_basic__eu_thread_occupancy__read

/* Compute Metrics Basic Gen9 :: Rasterized Pixels */
#define glk__compute_basic__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Compute Metrics Basic Gen9 :: Early Hi-Depth Test Fails */
#define glk__compute_basic__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Compute Metrics Basic Gen9 :: Early Depth Test Fails */
#define glk__compute_basic__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Compute Metrics Basic Gen9 :: Samples Killed in FS */
#define glk__compute_basic__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Compute Metrics Basic Gen9 :: Pixels Failing Tests */
#define glk__compute_basic__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Compute Metrics Basic Gen9 :: Samples Written */
#define glk__compute_basic__samples_written__read \
    bdw__render_basic__samples_written__read

/* Compute Metrics Basic Gen9 :: Samples Blended */
#define glk__compute_basic__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Compute Metrics Basic Gen9 :: Sampler Texels */
#define glk__compute_basic__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Compute Metrics Basic Gen9 :: Sampler Texels Misses */
#define glk__compute_basic__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Compute Metrics Basic Gen9 :: SLM Bytes Read */
#define glk__compute_basic__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Compute Metrics Basic Gen9 :: SLM Bytes Read */
#define glk__compute_basic__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Basic Gen9 :: SLM Bytes Written */
#define glk__compute_basic__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Compute Metrics Basic Gen9 :: SLM Bytes Written */
#define glk__compute_basic__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Basic Gen9 :: Shader Memory Accesses */
#define glk__compute_basic__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Compute Metrics Basic Gen9 :: Shader Atomic Memory Accesses */
#define glk__compute_basic__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Compute Metrics Basic Gen9 :: L3 Shader Throughput */
#define glk__compute_basic__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Compute Metrics Basic Gen9 :: L3 Shader Throughput */
#define glk__compute_basic__l3_shader_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen9 :: Shader Barrier Messages */
#define glk__compute_basic__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Compute Metrics Basic Gen9 :: Typed Bytes Read */
#define glk__compute_basic__typed_bytes_read__read \
    hsw__compute_basic__untyped_bytes_read__read

/* Compute Metrics Basic Gen9 :: Typed Bytes Read */
#define glk__compute_basic__typed_bytes_read__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen9 :: Typed Bytes Written */
#define glk__compute_basic__typed_bytes_written__read \
    bxt__compute_basic__typed_bytes_written__read

/* Compute Metrics Basic Gen9 :: Typed Bytes Written */
#define glk__compute_basic__typed_bytes_written__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen9 :: Untyped Bytes Read */
#define glk__compute_basic__untyped_bytes_read__read \
    hsw__compute_basic__typed_bytes_written__read

/* Compute Metrics Basic Gen9 :: Untyped Bytes Read */
#define glk__compute_basic__untyped_bytes_read__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen9 :: Untyped Writes */
#define glk__compute_basic__untyped_bytes_written__read \
    bxt__compute_basic__untyped_bytes_written__read

/* Compute Metrics Basic Gen9 :: Untyped Writes */
#define glk__compute_basic__untyped_bytes_written__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen9 :: GTI Read Throughput */
#define glk__compute_basic__gti_read_throughput__read \
    hsw__render_basic__gti_l3_throughput__read

/* Compute Metrics Basic Gen9 :: GTI Read Throughput */
#define glk__compute_basic__gti_read_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen9 :: GTI Write Throughput */
#define glk__compute_basic__gti_write_throughput__read \
    bdw__render_basic__gti_hdc_lookups_throughput__read

/* Compute Metrics Basic Gen9 :: GTI Write Throughput */
#define glk__compute_basic__gti_write_throughput__max \
    bdw__render_basic__gti_write_throughput__max

/* Render Metrics for 3D Pipeline Profile Gen9 :: GPU Time Elapsed */
#define glk__render_pipe_profile__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: GPU Core Clocks */
#define glk__render_pipe_profile__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: AVG GPU Core Frequency */
#define glk__render_pipe_profile__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: AVG GPU Core Frequency */
#define glk__render_pipe_profile__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Render Metrics for 3D Pipeline Profile Gen9 :: GPU Busy */
#define glk__render_pipe_profile__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: VS Threads Dispatched */
#define glk__render_pipe_profile__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: HS Threads Dispatched */
#define glk__render_pipe_profile__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: DS Threads Dispatched */
#define glk__render_pipe_profile__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: GS Threads Dispatched */
#define glk__render_pipe_profile__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: FS Threads Dispatched */
#define glk__render_pipe_profile__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: CS Threads Dispatched */
#define glk__render_pipe_profile__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: EU Active */
#define glk__render_pipe_profile__eu_active__read \
    bdw__render_basic__eu_active__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: EU Stall */
#define glk__render_pipe_profile__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Rasterized Pixels */
#define glk__render_pipe_profile__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Early Hi-Depth Test Fails */
#define glk__render_pipe_profile__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Early Depth Test Fails */
#define glk__render_pipe_profile__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Samples Killed in FS */
#define glk__render_pipe_profile__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Pixels Failing Tests */
#define glk__render_pipe_profile__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Samples Written */
#define glk__render_pipe_profile__samples_written__read \
    bdw__render_basic__samples_written__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Samples Blended */
#define glk__render_pipe_profile__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Sampler Texels */
#define glk__render_pipe_profile__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Sampler Texels Misses */
#define glk__render_pipe_profile__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: SLM Bytes Read */
#define glk__render_pipe_profile__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: SLM Bytes Read */
#define glk__render_pipe_profile__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics for 3D Pipeline Profile Gen9 :: SLM Bytes Written */
#define glk__render_pipe_profile__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: SLM Bytes Written */
#define glk__render_pipe_profile__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics for 3D Pipeline Profile Gen9 :: Shader Memory Accesses */
#define glk__render_pipe_profile__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Shader Atomic Memory Accesses */
#define glk__render_pipe_profile__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: L3 Shader Throughput */
#define glk__render_pipe_profile__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: L3 Shader Throughput */
#define glk__render_pipe_profile__l3_shader_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics for 3D Pipeline Profile Gen9 :: Shader Barrier Messages */
#define glk__render_pipe_profile__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: VF Bottleneck */
#define glk__render_pipe_profile__vf_bottleneck__read \
    bdw__render_pipe_profile__vf_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: VS Bottleneck */
#define glk__render_pipe_profile__vs_bottleneck__read \
    bdw__render_basic__sampler0_busy__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: HS Bottleneck */
#define glk__render_pipe_profile__hs_bottleneck__read \
    bdw__render_basic__sampler1_busy__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: DS Bottleneck */
#define glk__render_pipe_profile__ds_bottleneck__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: GS Bottleneck */
#define glk__render_pipe_profile__gs_bottleneck__read \
    bdw__render_basic__sampler1_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: SO Bottleneck */
#define glk__render_pipe_profile__so_bottleneck__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Clipper Bottleneck */
#define glk__render_pipe_profile__cl_bottleneck__read \
    bdw__render_pipe_profile__cl_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Strip-Fans Bottleneck */
#define glk__render_pipe_profile__sf_bottleneck__read \
    bdw__render_pipe_profile__sf_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Hi-Depth Bottleneck */
#define glk__render_pipe_profile__hi_depth_bottleneck__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: Early Depth Bottleneck */
#define glk__render_pipe_profile__early_depth_bottleneck__read \
    bdw__render_pipe_profile__early_depth_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: BC Bottleneck */
#define glk__render_pipe_profile__bc_bottleneck__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: HS Stall */
#define glk__render_pipe_profile__hs_stall__read \
    bdw__render_pipe_profile__hs_stall__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: DS Stall */
#define glk__render_pipe_profile__ds_stall__read \
    bdw__render_pipe_profile__ds_stall__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: SO Stall */
#define glk__render_pipe_profile__so_stall__read \
    bdw__render_pipe_profile__so_stall__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: CL Stall */
#define glk__render_pipe_profile__cl_stall__read \
    bdw__render_pipe_profile__cl_stall__read

/* Render Metrics for 3D Pipeline Profile Gen9 :: SF Stall */
#define glk__render_pipe_profile__sf_stall__read \
    bdw__render_pipe_profile__sf_stall__read

/* Memory Reads Distribution Gen9 :: GPU Time Elapsed */
#define glk__memory_reads__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Memory Reads Distribution Gen9 :: GPU Core Clocks */
#define glk__memory_reads__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Memory Reads Distribution Gen9 :: AVG GPU Core Frequency */
#define glk__memory_reads__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Memory Reads Distribution Gen9 :: AVG GPU Core Frequency */
#define glk__memory_reads__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Memory Reads Distribution Gen9 :: GPU Busy */
#define glk__memory_reads__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Memory Reads Distribution Gen9 :: VS Threads Dispatched */
#define glk__memory_reads__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Memory Reads Distribution Gen9 :: HS Threads Dispatched */
#define glk__memory_reads__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Memory Reads Distribution Gen9 :: DS Threads Dispatched */
#define glk__memory_reads__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Memory Reads Distribution Gen9 :: GS Threads Dispatched */
#define glk__memory_reads__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Memory Reads Distribution Gen9 :: FS Threads Dispatched */
#define glk__memory_reads__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Memory Reads Distribution Gen9 :: CS Threads Dispatched */
#define glk__memory_reads__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Memory Reads Distribution Gen9 :: EU Active */
#define glk__memory_reads__eu_active__read \
    bdw__render_basic__eu_active__read

/* Memory Reads Distribution Gen9 :: EU Stall */
#define glk__memory_reads__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Memory Reads Distribution Gen9 :: Rasterized Pixels */
#define glk__memory_reads__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Memory Reads Distribution Gen9 :: Early Hi-Depth Test Fails */
#define glk__memory_reads__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Memory Reads Distribution Gen9 :: Early Depth Test Fails */
#define glk__memory_reads__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Memory Reads Distribution Gen9 :: Samples Killed in FS */
#define glk__memory_reads__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Memory Reads Distribution Gen9 :: Pixels Failing Tests */
#define glk__memory_reads__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Memory Reads Distribution Gen9 :: Samples Written */
#define glk__memory_reads__samples_written__read \
    bdw__render_basic__samples_written__read

/* Memory Reads Distribution Gen9 :: Samples Blended */
#define glk__memory_reads__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Memory Reads Distribution Gen9 :: Sampler Texels */
#define glk__memory_reads__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Memory Reads Distribution Gen9 :: Sampler Texels Misses */
#define glk__memory_reads__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Memory Reads Distribution Gen9 :: SLM Bytes Read */
#define glk__memory_reads__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Memory Reads Distribution Gen9 :: SLM Bytes Read */
#define glk__memory_reads__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Memory Reads Distribution Gen9 :: SLM Bytes Written */
#define glk__memory_reads__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Memory Reads Distribution Gen9 :: SLM Bytes Written */
#define glk__memory_reads__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Memory Reads Distribution Gen9 :: Shader Memory Accesses */
#define glk__memory_reads__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Memory Reads Distribution Gen9 :: Shader Atomic Memory Accesses */
#define glk__memory_reads__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Memory Reads Distribution Gen9 :: Shader Barrier Messages */
#define glk__memory_reads__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Memory Reads Distribution Gen9 :: GtiCmdStreamerMemoryReads */
#define glk__memory_reads__gti_cmd_streamer_memory_reads__read \
    hsw__compute_extended__eu_untyped_reads0__read

/* Memory Reads Distribution Gen9 :: GtiRsMemoryReads */
#define glk__memory_reads__gti_rs_memory_reads__read \
    hsw__compute_extended__eu_typed_reads0__read

/* Memory Reads Distribution Gen9 :: GtiVfMemoryReads */
#define glk__memory_reads__gti_vf_memory_reads__read \
    hsw__compute_extended__eu_untyped_writes0__read

/* Memory Reads Distribution Gen9 :: GtiRccMemoryReads */
#define glk__memory_reads__gti_rcc_memory_reads__read \
    hsw__compute_extended__eu_typed_writes0__read

/* Memory Reads Distribution Gen9 :: GtiMscMemoryReads */
#define glk__memory_reads__gti_msc_memory_reads__read \
    hsw__compute_extended__eu_untyped_atomics0__read

/* Memory Reads Distribution Gen9 :: GtiHizMemoryReads */
#define glk__memory_reads__gti_hiz_memory_reads__read \
    hsw__compute_extended__eu_typed_atomics0__read

/* Memory Reads Distribution Gen9 :: GtiStcMemoryReads */
#define glk__memory_reads__gti_stc_memory_reads__read \
    hsw__compute_extended__eu_urb_atomics0__read

/* Memory Reads Distribution Gen9 :: GtiRczMemoryReads */
#define glk__memory_reads__gti_rcz_memory_reads__read \
    hsw__compute_extended__gpu_clocks__read

/* Memory Reads Distribution Gen9 :: GtiMemoryReads */
#define glk__memory_reads__gti_memory_reads__read \
    hsw__compute_extended__typed_writes0__read

/* Memory Reads Distribution Gen9 :: GtiL3Bank0Reads */
#define glk__memory_reads__gti_l3_bank0_reads__read \
    hsw__compute_extended__typed_atomics0__read

/* Memory Reads Distribution Gen9 :: GtiL3Bank1Reads */
#define glk__memory_reads__gti_l3_bank1_reads__read \
    hsw__memory_reads__gti_memory_reads__read

/* Memory Reads Distribution Gen9 :: GtiL3Bank2Reads */
#define glk__memory_reads__gti_l3_bank2_reads__read \
    hsw__memory_reads__llc_read_accesses__read

/* Memory Reads Distribution Gen9 :: GtiL3Bank3Reads */
#define glk__memory_reads__gti_l3_bank3_reads__read \
    hsw__memory_reads__gpu_core_clocks__read

/* Memory Reads Distribution Gen9 :: GtiL3Reads */
#define glk__memory_reads__gti_l3_reads__read \
    bdw__memory_reads__gti_l3_reads__read

/* Memory Reads Distribution Gen9 :: GtiRingAccesses */
#define glk__memory_reads__gti_ring_accesses__read \
    bdw__memory_reads__gti_ring_accesses__read

/* Memory Writes Distribution Gen9 :: GPU Time Elapsed */
#define glk__memory_writes__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Memory Writes Distribution Gen9 :: GPU Core Clocks */
#define glk__memory_writes__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Memory Writes Distribution Gen9 :: AVG GPU Core Frequency */
#define glk__memory_writes__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Memory Writes Distribution Gen9 :: AVG GPU Core Frequency */
#define glk__memory_writes__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Memory Writes Distribution Gen9 :: GPU Busy */
#define glk__memory_writes__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Memory Writes Distribution Gen9 :: VS Threads Dispatched */
#define glk__memory_writes__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Memory Writes Distribution Gen9 :: HS Threads Dispatched */
#define glk__memory_writes__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Memory Writes Distribution Gen9 :: DS Threads Dispatched */
#define glk__memory_writes__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Memory Writes Distribution Gen9 :: GS Threads Dispatched */
#define glk__memory_writes__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Memory Writes Distribution Gen9 :: FS Threads Dispatched */
#define glk__memory_writes__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Memory Writes Distribution Gen9 :: CS Threads Dispatched */
#define glk__memory_writes__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Memory Writes Distribution Gen9 :: EU Active */
#define glk__memory_writes__eu_active__read \
    bdw__render_basic__eu_active__read

/* Memory Writes Distribution Gen9 :: EU Stall */
#define glk__memory_writes__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Memory Writes Distribution Gen9 :: Rasterized Pixels */
#define glk__memory_writes__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Memory Writes Distribution Gen9 :: Early Hi-Depth Test Fails */
#define glk__memory_writes__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Memory Writes Distribution Gen9 :: Early Depth Test Fails */
#define glk__memory_writes__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Memory Writes Distribution Gen9 :: Samples Killed in FS */
#define glk__memory_writes__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Memory Writes Distribution Gen9 :: Pixels Failing Tests */
#define glk__memory_writes__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Memory Writes Distribution Gen9 :: Samples Written */
#define glk__memory_writes__samples_written__read \
    bdw__render_basic__samples_written__read

/* Memory Writes Distribution Gen9 :: Samples Blended */
#define glk__memory_writes__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Memory Writes Distribution Gen9 :: Sampler Texels */
#define glk__memory_writes__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Memory Writes Distribution Gen9 :: Sampler Texels Misses */
#define glk__memory_writes__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Memory Writes Distribution Gen9 :: SLM Bytes Read */
#define glk__memory_writes__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Memory Writes Distribution Gen9 :: SLM Bytes Read */
#define glk__memory_writes__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Memory Writes Distribution Gen9 :: SLM Bytes Written */
#define glk__memory_writes__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Memory Writes Distribution Gen9 :: SLM Bytes Written */
#define glk__memory_writes__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Memory Writes Distribution Gen9 :: Shader Memory Accesses */
#define glk__memory_writes__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Memory Writes Distribution Gen9 :: Shader Atomic Memory Accesses */
#define glk__memory_writes__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Memory Writes Distribution Gen9 :: L3 Shader Throughput */
#define glk__memory_writes__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Memory Writes Distribution Gen9 :: L3 Shader Throughput */
#define glk__memory_writes__l3_shader_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Memory Writes Distribution Gen9 :: Shader Barrier Messages */
#define glk__memory_writes__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Memory Writes Distribution Gen9 :: GtiCmdStreamerMemoryWrites */
#define glk__memory_writes__gti_cmd_streamer_memory_writes__read \
    hsw__compute_extended__eu_untyped_reads0__read

/* Memory Writes Distribution Gen9 :: GtiSoMemoryWrites */
#define glk__memory_writes__gti_so_memory_writes__read \
    hsw__compute_extended__eu_typed_reads0__read

/* Memory Writes Distribution Gen9 :: GtiRccMemoryWrites */
#define glk__memory_writes__gti_rcc_memory_writes__read \
    hsw__compute_extended__eu_typed_writes0__read

/* Memory Writes Distribution Gen9 :: GtiMscMemoryWrites */
#define glk__memory_writes__gti_msc_memory_writes__read \
    hsw__compute_extended__eu_untyped_atomics0__read

/* Memory Writes Distribution Gen9 :: GtiHizMemoryWrites */
#define glk__memory_writes__gti_hiz_memory_writes__read \
    hsw__compute_extended__eu_typed_atomics0__read

/* Memory Writes Distribution Gen9 :: GtiStcMemoryWrites */
#define glk__memory_writes__gti_stc_memory_writes__read \
    hsw__compute_extended__eu_urb_atomics0__read

/* Memory Writes Distribution Gen9 :: GtiRczMemoryWrites */
#define glk__memory_writes__gti_rcz_memory_writes__read \
    hsw__compute_extended__gpu_clocks__read

/* Memory Writes Distribution Gen9 :: GtiMemoryWrites */
#define glk__memory_writes__gti_memory_writes__read \
    hsw__compute_extended__typed_writes0__read

/* Memory Writes Distribution Gen9 :: GtiL3Bank0Writes */
#define glk__memory_writes__gti_l3_bank0_writes__read \
    hsw__compute_extended__typed_atomics0__read

/* Memory Writes Distribution Gen9 :: GtiL3Bank1Writes */
#define glk__memory_writes__gti_l3_bank1_writes__read \
    hsw__memory_reads__gti_memory_reads__read

/* Memory Writes Distribution Gen9 :: GtiL3Bank2Writes */
#define glk__memory_writes__gti_l3_bank2_writes__read \
    hsw__memory_reads__llc_read_accesses__read

/* Memory Writes Distribution Gen9 :: GtiL3Bank3Writes */
#define glk__memory_writes__gti_l3_bank3_writes__read \
    hsw__memory_reads__gpu_core_clocks__read

/* Memory Writes Distribution Gen9 :: GtiL3Writes */
#define glk__memory_writes__gti_l3_writes__read \
    bdw__memory_reads__gti_l3_reads__read

/* Memory Writes Distribution Gen9 :: GtiRingAccesses */
#define glk__memory_writes__gti_ring_accesses__read \
    bdw__memory_reads__gti_ring_accesses__read

/* Compute Metrics Extended Gen9 :: GPU Time Elapsed */
#define glk__compute_extended__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Compute Metrics Extended Gen9 :: GPU Core Clocks */
#define glk__compute_extended__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Compute Metrics Extended Gen9 :: AVG GPU Core Frequency */
#define glk__compute_extended__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Compute Metrics Extended Gen9 :: AVG GPU Core Frequency */
#define glk__compute_extended__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Compute Metrics Extended Gen9 :: CS Threads Dispatched */
#define glk__compute_extended__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Compute Metrics Extended Gen9 :: EU Active */
#define glk__compute_extended__eu_active__read \
    bdw__render_basic__eu_active__read

/* Compute Metrics Extended Gen9 :: EU Stall */
#define glk__compute_extended__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Compute Metrics Extended Gen9 :: EU Both FPU Pipes Active */
#define glk__compute_extended__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Compute Metrics Extended Gen9 :: EU FPU0 Pipe Active */
#define glk__compute_extended__fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Compute Metrics Extended Gen9 :: EU FPU1 Pipe Active */
#define glk__compute_extended__fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Compute Metrics Extended Gen9 :: EU AVG IPC Rate */
#define glk__compute_extended__eu_avg_ipc_rate__read \
    bdw__compute_basic__eu_avg_ipc_rate__read

/* Compute Metrics Extended Gen9 :: EU AVG IPC Rate */
#define glk__compute_extended__eu_avg_ipc_rate__max \
    bdw__compute_basic__eu_avg_ipc_rate__max

/* Compute Metrics Extended Gen9 :: EU Send Pipe Active */
#define glk__compute_extended__eu_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Compute Metrics Extended Gen9 :: EU Thread Occupancy */
#define glk__compute_extended__eu_thread_occupancy__read \
    bdw__compute_basic__eu_thread_occupancy__read

/* Compute Metrics Extended Gen9 :: Sampler Texels */
#define glk__compute_extended__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Compute Metrics Extended Gen9 :: Sampler Texels Misses */
#define glk__compute_extended__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Compute Metrics Extended Gen9 :: SLM Bytes Read */
#define glk__compute_extended__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Compute Metrics Extended Gen9 :: SLM Bytes Read */
#define glk__compute_extended__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Extended Gen9 :: SLM Bytes Written */
#define glk__compute_extended__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Compute Metrics Extended Gen9 :: SLM Bytes Written */
#define glk__compute_extended__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Extended Gen9 :: Shader Memory Accesses */
#define glk__compute_extended__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Compute Metrics Extended Gen9 :: Shader Atomic Memory Accesses */
#define glk__compute_extended__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Compute Metrics Extended Gen9 :: L3 Shader Throughput */
#define glk__compute_extended__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Compute Metrics Extended Gen9 :: L3 Shader Throughput */
#define glk__compute_extended__l3_shader_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Extended Gen9 :: Shader Barrier Messages */
#define glk__compute_extended__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Compute Metrics Extended Gen9 :: EuUntypedReads0 */
#define glk__compute_extended__eu_untyped_reads0__read \
    hsw__compute_extended__eu_untyped_reads0__read

/* Compute Metrics Extended Gen9 :: EuTypedReads0 */
#define glk__compute_extended__eu_typed_reads0__read \
    hsw__compute_extended__eu_typed_reads0__read

/* Compute Metrics Extended Gen9 :: EuUntypedWrites0 */
#define glk__compute_extended__eu_untyped_writes0__read \
    hsw__compute_extended__eu_untyped_writes0__read

/* Compute Metrics Extended Gen9 :: EuTypedWrites0 */
#define glk__compute_extended__eu_typed_writes0__read \
    hsw__compute_extended__eu_typed_writes0__read

/* Compute Metrics Extended Gen9 :: EuUntypedAtomics0 */
#define glk__compute_extended__eu_untyped_atomics0__read \
    hsw__compute_extended__eu_untyped_atomics0__read

/* Compute Metrics Extended Gen9 :: EuTypedAtomics0 */
#define glk__compute_extended__eu_typed_atomics0__read \
    hsw__compute_extended__eu_typed_atomics0__read

/* Compute Metrics Extended Gen9 :: EuA64UntypedReads0 */
#define glk__compute_extended__eu_a64_untyped_reads0__read \
    hsw__compute_extended__eu_urb_atomics0__read

/* Compute Metrics Extended Gen9 :: EuA64UntypedWrites0 */
#define glk__compute_extended__eu_a64_untyped_writes0__read \
    hsw__compute_extended__gpu_clocks__read

/* Compute Metrics Extended Gen9 :: Typed Reads 0 */
#define glk__compute_extended__typed_reads0__read \
    hsw__render_basic__gpu_core_clocks__read

/* Compute Metrics Extended Gen9 :: Typed Writes 0 */
#define glk__compute_extended__typed_writes0__read \
    hsw__compute_extended__typed_writes0__read

/* Compute Metrics Extended Gen9 :: Untyped Reads 0 */
#define glk__compute_extended__untyped_reads0__read \
    hsw__compute_extended__untyped_reads0__read

/* Compute Metrics Extended Gen9 :: Untyped Writes 0 */
#define glk__compute_extended__untyped_writes0__read \
    hsw__compute_extended__untyped_writes0__read

/* Compute Metrics Extended Gen9 :: Typed Atomics 0 */
#define glk__compute_extended__typed_atomics0__read \
    hsw__compute_extended__typed_atomics0__read

/* Compute Metrics Extended Gen9 :: TypedReadsPerCacheLine */
#define glk__compute_extended__typed_reads_per_cache_line__read \
    hsw__compute_extended__typed_reads_per_cache_line__read

/* Compute Metrics Extended Gen9 :: TypedWritesPerCacheLine */
#define glk__compute_extended__typed_writes_per_cache_line__read \
    hsw__compute_extended__typed_writes_per_cache_line__read

/* Compute Metrics Extended Gen9 :: UntypedReadsPerCacheLine */
#define glk__compute_extended__untyped_reads_per_cache_line__read \
    bdw__compute_extended__untyped_reads_per_cache_line__read

/* Compute Metrics Extended Gen9 :: UntypedWritesPerCacheLine */
#define glk__compute_extended__untyped_writes_per_cache_line__read \
    bdw__compute_extended__untyped_writes_per_cache_line__read

/* Compute Metrics Extended Gen9 :: TypedAtomicsPerCacheLine */
#define glk__compute_extended__typed_atomics_per_cache_line__read \
    hsw__compute_extended__typed_atomics_per_cache_line__read

/* Compute Metrics L3 Cache Gen9 :: GPU Time Elapsed */
#define glk__compute_l3_cache__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Compute Metrics L3 Cache Gen9 :: GPU Core Clocks */
#define glk__compute_l3_cache__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Compute Metrics L3 Cache Gen9 :: AVG GPU Core Frequency */
#define glk__compute_l3_cache__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Compute Metrics L3 Cache Gen9 :: AVG GPU Core Frequency */
#define glk__compute_l3_cache__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Compute Metrics L3 Cache Gen9 :: GPU Busy */
#define glk__compute_l3_cache__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Compute Metrics L3 Cache Gen9 :: VS Threads Dispatched */
#define glk__compute_l3_cache__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Compute Metrics L3 Cache Gen9 :: HS Threads Dispatched */
#define glk__compute_l3_cache__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Compute Metrics L3 Cache Gen9 :: DS Threads Dispatched */
#define glk__compute_l3_cache__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Compute Metrics L3 Cache Gen9 :: GS Threads Dispatched */
#define glk__compute_l3_cache__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Compute Metrics L3 Cache Gen9 :: FS Threads Dispatched */
#define glk__compute_l3_cache__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Compute Metrics L3 Cache Gen9 :: CS Threads Dispatched */
#define glk__compute_l3_cache__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Compute Metrics L3 Cache Gen9 :: EU Active */
#define glk__compute_l3_cache__eu_active__read \
    bdw__render_basic__eu_active__read

/* Compute Metrics L3 Cache Gen9 :: EU Stall */
#define glk__compute_l3_cache__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Compute Metrics L3 Cache Gen9 :: EU Both FPU Pipes Active */
#define glk__compute_l3_cache__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU0 Pipe Active */
#define glk__compute_l3_cache__fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU1 Pipe Active */
#define glk__compute_l3_cache__fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Compute Metrics L3 Cache Gen9 :: EU AVG IPC Rate */
#define glk__compute_l3_cache__eu_avg_ipc_rate__read \
    bdw__compute_basic__eu_avg_ipc_rate__read

/* Compute Metrics L3 Cache Gen9 :: EU AVG IPC Rate */
#define glk__compute_l3_cache__eu_avg_ipc_rate__max \
    bdw__compute_basic__eu_avg_ipc_rate__max

/* Compute Metrics L3 Cache Gen9 :: EU Send Pipe Active */
#define glk__compute_l3_cache__eu_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU0 Hybrid Instruction */
#define glk__compute_l3_cache__eu_hybrid_fpu0_instruction__read \
    bdw__compute_l3_cache__eu_hybrid_fpu0_instruction__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU1 Hybrid Instruction */
#define glk__compute_l3_cache__eu_hybrid_fpu1_instruction__read \
    bdw__compute_l3_cache__eu_hybrid_fpu1_instruction__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU0 Ternary Instruction */
#define glk__compute_l3_cache__eu_ternary_fpu0_instruction__read \
    bdw__render_basic__ps_fpu0_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU1 Ternary Instruction */
#define glk__compute_l3_cache__eu_ternary_fpu1_instruction__read \
    bdw__render_basic__ps_fpu1_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU0 Binary Instruction */
#define glk__compute_l3_cache__eu_binary_fpu0_instruction__read \
    bdw__render_basic__ps_send_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU1 Binary Instruction */
#define glk__compute_l3_cache__eu_binary_fpu1_instruction__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU0 Move Instruction */
#define glk__compute_l3_cache__eu_move_fpu0_instruction__read \
    bdw__compute_l3_cache__eu_move_fpu0_instruction__read

/* Compute Metrics L3 Cache Gen9 :: EU FPU1 Move Instruction */
#define glk__compute_l3_cache__eu_move_fpu1_instruction__read \
    bdw__compute_l3_cache__eu_move_fpu1_instruction__read

/* Compute Metrics L3 Cache Gen9 :: Rasterized Pixels */
#define glk__compute_l3_cache__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Compute Metrics L3 Cache Gen9 :: Early Hi-Depth Test Fails */
#define glk__compute_l3_cache__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Compute Metrics L3 Cache Gen9 :: Early Depth Test Fails */
#define glk__compute_l3_cache__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Compute Metrics L3 Cache Gen9 :: Samples Killed in FS */
#define glk__compute_l3_cache__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Compute Metrics L3 Cache Gen9 :: Pixels Failing Tests */
#define glk__compute_l3_cache__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Compute Metrics L3 Cache Gen9 :: Samples Written */
#define glk__compute_l3_cache__samples_written__read \
    bdw__render_basic__samples_written__read

/* Compute Metrics L3 Cache Gen9 :: Samples Blended */
#define glk__compute_l3_cache__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Compute Metrics L3 Cache Gen9 :: Sampler Accesses */
#define glk__compute_l3_cache__sampler_accesses__read \
    bdw__render_pipe_profile__sampler_accesses__read

/* Compute Metrics L3 Cache Gen9 :: Sampler Texels */
#define glk__compute_l3_cache__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Compute Metrics L3 Cache Gen9 :: Sampler Texels Misses */
#define glk__compute_l3_cache__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Compute Metrics L3 Cache Gen9 :: SLM Bytes Read */
#define glk__compute_l3_cache__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Compute Metrics L3 Cache Gen9 :: SLM Bytes Read */
#define glk__compute_l3_cache__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics L3 Cache Gen9 :: SLM Bytes Written */
#define glk__compute_l3_cache__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Compute Metrics L3 Cache Gen9 :: SLM Bytes Written */
#define glk__compute_l3_cache__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics L3 Cache Gen9 :: Shader Memory Accesses */
#define glk__compute_l3_cache__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Compute Metrics L3 Cache Gen9 :: Shader Atomic Memory Accesses */
#define glk__compute_l3_cache__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Compute Metrics L3 Cache Gen9 :: L3 Accesses */
#define glk__compute_l3_cache__l3_accesses__read \
    sklgt2__compute_l3_cache__l3_accesses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Misses */
#define glk__compute_l3_cache__l3_misses__read \
    bdw__compute_l3_cache__l3_misses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Sampler Throughput */
#define glk__compute_l3_cache__l3_sampler_throughput__read \
    chv__render_basic__l3_sampler_throughput__read

/* Compute Metrics L3 Cache Gen9 :: L3 Sampler Throughput */
#define glk__compute_l3_cache__l3_sampler_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics L3 Cache Gen9 :: L3 Shader Throughput */
#define glk__compute_l3_cache__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Compute Metrics L3 Cache Gen9 :: L3 Shader Throughput */
#define glk__compute_l3_cache__l3_shader_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics L3 Cache Gen9 :: L3 Total Throughput */
#define glk__compute_l3_cache__l3_total_throughput__read \
    sklgt2__compute_l3_cache__l3_total_throughput__read

/* Compute Metrics L3 Cache Gen9 :: L3 Total Throughput */
#define glk__compute_l3_cache__l3_total_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics L3 Cache Gen9 :: Shader Barrier Messages */
#define glk__compute_l3_cache__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Compute Metrics L3 Cache Gen9 :: L3 Bank 00 Accesses */
#define glk__compute_l3_cache__l3_bank00_accesses__read \
    bdw__compute_l3_cache__l3_bank00_accesses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Bank 01 Accesses */
#define glk__compute_l3_cache__l3_bank01_accesses__read \
    bdw__compute_l3_cache__l3_bank01_accesses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Bank 02 Accesses */
#define glk__compute_l3_cache__l3_bank02_accesses__read \
    bdw__compute_l3_cache__l3_bank02_accesses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Bank 03 Accesses */
#define glk__compute_l3_cache__l3_bank03_accesses__read \
    bdw__compute_l3_cache__l3_bank03_accesses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Bank 00 IC Accesses */
#define glk__compute_l3_cache__l3_bank00_ic_accesses__read \
    bdw__compute_l3_cache__l3_bank00_ic_accesses__read

/* Compute Metrics L3 Cache Gen9 :: L3 Bank 00 IC Hits */
#define glk__compute_l3_cache__l3_bank00_ic_hits__read \
    bdw__compute_l3_cache__l3_bank00_ic_hits__read

/* Compute Metrics L3 Cache Gen9 :: GTI L3 Throughput */
#define glk__compute_l3_cache__gti_l3_throughput__read \
    bdw__compute_l3_cache__gti_l3_throughput__read

/* Compute Metrics L3 Cache Gen9 :: GTI L3 Throughput */
#define glk__compute_l3_cache__gti_l3_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics L3 Cache Gen9 :: GTI Read Throughput */
#define glk__compute_l3_cache__gti_read_throughput__read \
    bdw__render_basic__gti_read_throughput__read

/* Compute Metrics L3 Cache Gen9 :: GTI Read Throughput */
#define glk__compute_l3_cache__gti_read_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Compute Metrics L3 Cache Gen9 :: GTI Write Throughput */
#define glk__compute_l3_cache__gti_write_throughput__read \
    hsw__render_basic__gti_write_throughput__read

/* Compute Metrics L3 Cache Gen9 :: GTI Write Throughput */
#define glk__compute_l3_cache__gti_write_throughput__max \
    bdw__render_basic__gti_write_throughput__max

/* Metric set HDCAndSF :: GPU Time Elapsed */
#define glk__hdc_and_sf__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set HDCAndSF :: GPU Core Clocks */
#define glk__hdc_and_sf__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set HDCAndSF :: AVG GPU Core Frequency */
#define glk__hdc_and_sf__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set HDCAndSF :: AVG GPU Core Frequency */
#define glk__hdc_and_sf__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set HDCAndSF :: GPU Busy */
#define glk__hdc_and_sf__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set HDCAndSF :: VS Threads Dispatched */
#define glk__hdc_and_sf__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set HDCAndSF :: HS Threads Dispatched */
#define glk__hdc_and_sf__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set HDCAndSF :: DS Threads Dispatched */
#define glk__hdc_and_sf__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set HDCAndSF :: GS Threads Dispatched */
#define glk__hdc_and_sf__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set HDCAndSF :: FS Threads Dispatched */
#define glk__hdc_and_sf__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set HDCAndSF :: CS Threads Dispatched */
#define glk__hdc_and_sf__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set HDCAndSF :: EU Active */
#define glk__hdc_and_sf__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set HDCAndSF :: EU Stall */
#define glk__hdc_and_sf__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set HDCAndSF :: EU Both FPU Pipes Active */
#define glk__hdc_and_sf__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set HDCAndSF :: VS FPU0 Pipe Active */
#define glk__hdc_and_sf__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set HDCAndSF :: VS FPU1 Pipe Active */
#define glk__hdc_and_sf__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set HDCAndSF :: VS Send Pipe Active */
#define glk__hdc_and_sf__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set HDCAndSF :: PS FPU0 Pipe Active */
#define glk__hdc_and_sf__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set HDCAndSF :: PS FPU1 Pipe Active */
#define glk__hdc_and_sf__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set HDCAndSF :: PS Send Pipeline Active */
#define glk__hdc_and_sf__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set HDCAndSF :: FS Both FPU Active */
#define glk__hdc_and_sf__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set HDCAndSF :: Rasterized Pixels */
#define glk__hdc_and_sf__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set HDCAndSF :: Early Hi-Depth Test Fails */
#define glk__hdc_and_sf__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set HDCAndSF :: Early Depth Test Fails */
#define glk__hdc_and_sf__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set HDCAndSF :: Samples Killed in FS */
#define glk__hdc_and_sf__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set HDCAndSF :: Pixels Failing Tests */
#define glk__hdc_and_sf__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set HDCAndSF :: Samples Written */
#define glk__hdc_and_sf__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set HDCAndSF :: Samples Blended */
#define glk__hdc_and_sf__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set HDCAndSF :: Sampler Texels */
#define glk__hdc_and_sf__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set HDCAndSF :: Sampler Texels Misses */
#define glk__hdc_and_sf__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set HDCAndSF :: SLM Bytes Read */
#define glk__hdc_and_sf__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set HDCAndSF :: SLM Bytes Read */
#define glk__hdc_and_sf__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set HDCAndSF :: SLM Bytes Written */
#define glk__hdc_and_sf__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set HDCAndSF :: SLM Bytes Written */
#define glk__hdc_and_sf__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set HDCAndSF :: Shader Memory Accesses */
#define glk__hdc_and_sf__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set HDCAndSF :: Shader Atomic Memory Accesses */
#define glk__hdc_and_sf__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set HDCAndSF :: L3 Shader Throughput */
#define glk__hdc_and_sf__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set HDCAndSF :: L3 Shader Throughput */
#define glk__hdc_and_sf__l3_shader_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Metric set HDCAndSF :: Shader Barrier Messages */
#define glk__hdc_and_sf__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set HDCAndSF :: Polygon Data Ready */
#define glk__hdc_and_sf__poly_data_ready__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set HDCAndSF :: HDC stalled by L3 (s0.ss0) */
#define glk__hdc_and_sf__non_sampler_shader00_access_stalled_on_l3__read \
    bdw__hdc_and_sf__non_sampler_shader02_access_stalled_on_l3__read

/* Metric set HDCAndSF :: HDC stalled by L3 (s0.ss1) */
#define glk__hdc_and_sf__non_sampler_shader01_access_stalled_on_l3__read \
    bdw__hdc_and_sf__non_sampler_shader01_access_stalled_on_l3__read

/* Metric set HDCAndSF :: SQ is full */
#define glk__hdc_and_sf__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set L3_1 :: GPU Time Elapsed */
#define glk__l3_1__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set L3_1 :: GPU Core Clocks */
#define glk__l3_1__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set L3_1 :: AVG GPU Core Frequency */
#define glk__l3_1__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set L3_1 :: AVG GPU Core Frequency */
#define glk__l3_1__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set L3_1 :: GPU Busy */
#define glk__l3_1__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set L3_1 :: VS Threads Dispatched */
#define glk__l3_1__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set L3_1 :: HS Threads Dispatched */
#define glk__l3_1__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set L3_1 :: DS Threads Dispatched */
#define glk__l3_1__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set L3_1 :: GS Threads Dispatched */
#define glk__l3_1__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set L3_1 :: FS Threads Dispatched */
#define glk__l3_1__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set L3_1 :: CS Threads Dispatched */
#define glk__l3_1__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set L3_1 :: EU Active */
#define glk__l3_1__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set L3_1 :: EU Stall */
#define glk__l3_1__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set L3_1 :: EU Both FPU Pipes Active */
#define glk__l3_1__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set L3_1 :: VS FPU0 Pipe Active */
#define glk__l3_1__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set L3_1 :: VS FPU1 Pipe Active */
#define glk__l3_1__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set L3_1 :: VS Send Pipe Active */
#define glk__l3_1__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set L3_1 :: PS FPU0 Pipe Active */
#define glk__l3_1__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set L3_1 :: PS FPU1 Pipe Active */
#define glk__l3_1__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set L3_1 :: PS Send Pipeline Active */
#define glk__l3_1__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set L3_1 :: FS Both FPU Active */
#define glk__l3_1__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set L3_1 :: Rasterized Pixels */
#define glk__l3_1__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set L3_1 :: Early Hi-Depth Test Fails */
#define glk__l3_1__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set L3_1 :: Early Depth Test Fails */
#define glk__l3_1__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set L3_1 :: Samples Killed in FS */
#define glk__l3_1__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set L3_1 :: Pixels Failing Tests */
#define glk__l3_1__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set L3_1 :: Samples Written */
#define glk__l3_1__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set L3_1 :: Samples Blended */
#define glk__l3_1__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set L3_1 :: Sampler Texels */
#define glk__l3_1__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set L3_1 :: Sampler Texels Misses */
#define glk__l3_1__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set L3_1 :: SLM Bytes Read */
#define glk__l3_1__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set L3_1 :: SLM Bytes Read */
#define glk__l3_1__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_1 :: SLM Bytes Written */
#define glk__l3_1__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set L3_1 :: SLM Bytes Written */
#define glk__l3_1__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_1 :: Shader Memory Accesses */
#define glk__l3_1__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set L3_1 :: Shader Atomic Memory Accesses */
#define glk__l3_1__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set L3_1 :: L3 Shader Throughput */
#define glk__l3_1__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set L3_1 :: L3 Shader Throughput */
#define glk__l3_1__l3_shader_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Metric set L3_1 :: Shader Barrier Messages */
#define glk__l3_1__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set L3_1 :: Slice0 L3 Bank0 Stalled */
#define glk__l3_1__l30_bank0_stalled__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set L3_1 :: Slice0 L3 Bank1 Stalled */
#define glk__l3_1__l30_bank1_stalled__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* Metric set L3_1 :: Slice0 L3 Bank1 Active */
#define glk__l3_1__l30_bank1_active__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set L3_1 :: Slice0 L3 Bank0 Active */
#define glk__l3_1__l30_bank0_active__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set L3_1 :: SQ is full */
#define glk__l3_1__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set RasterizerAndPixelBackend :: GPU Time Elapsed */
#define glk__rasterizer_and_pixel_backend__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set RasterizerAndPixelBackend :: GPU Core Clocks */
#define glk__rasterizer_and_pixel_backend__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set RasterizerAndPixelBackend :: AVG GPU Core Frequency */
#define glk__rasterizer_and_pixel_backend__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set RasterizerAndPixelBackend :: AVG GPU Core Frequency */
#define glk__rasterizer_and_pixel_backend__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set RasterizerAndPixelBackend :: GPU Busy */
#define glk__rasterizer_and_pixel_backend__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set RasterizerAndPixelBackend :: VS Threads Dispatched */
#define glk__rasterizer_and_pixel_backend__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set RasterizerAndPixelBackend :: HS Threads Dispatched */
#define glk__rasterizer_and_pixel_backend__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set RasterizerAndPixelBackend :: DS Threads Dispatched */
#define glk__rasterizer_and_pixel_backend__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set RasterizerAndPixelBackend :: GS Threads Dispatched */
#define glk__rasterizer_and_pixel_backend__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set RasterizerAndPixelBackend :: FS Threads Dispatched */
#define glk__rasterizer_and_pixel_backend__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set RasterizerAndPixelBackend :: CS Threads Dispatched */
#define glk__rasterizer_and_pixel_backend__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set RasterizerAndPixelBackend :: EU Active */
#define glk__rasterizer_and_pixel_backend__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set RasterizerAndPixelBackend :: EU Stall */
#define glk__rasterizer_and_pixel_backend__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set RasterizerAndPixelBackend :: EU Both FPU Pipes Active */
#define glk__rasterizer_and_pixel_backend__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set RasterizerAndPixelBackend :: VS FPU0 Pipe Active */
#define glk__rasterizer_and_pixel_backend__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set RasterizerAndPixelBackend :: VS FPU1 Pipe Active */
#define glk__rasterizer_and_pixel_backend__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set RasterizerAndPixelBackend :: VS Send Pipe Active */
#define glk__rasterizer_and_pixel_backend__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set RasterizerAndPixelBackend :: PS FPU0 Pipe Active */
#define glk__rasterizer_and_pixel_backend__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set RasterizerAndPixelBackend :: PS FPU1 Pipe Active */
#define glk__rasterizer_and_pixel_backend__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set RasterizerAndPixelBackend :: PS Send Pipeline Active */
#define glk__rasterizer_and_pixel_backend__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set RasterizerAndPixelBackend :: FS Both FPU Active */
#define glk__rasterizer_and_pixel_backend__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set RasterizerAndPixelBackend :: Rasterized Pixels */
#define glk__rasterizer_and_pixel_backend__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set RasterizerAndPixelBackend :: Early Hi-Depth Test Fails */
#define glk__rasterizer_and_pixel_backend__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set RasterizerAndPixelBackend :: Early Depth Test Fails */
#define glk__rasterizer_and_pixel_backend__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set RasterizerAndPixelBackend :: Samples Killed in FS */
#define glk__rasterizer_and_pixel_backend__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set RasterizerAndPixelBackend :: Pixels Failing Tests */
#define glk__rasterizer_and_pixel_backend__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set RasterizerAndPixelBackend :: Samples Written */
#define glk__rasterizer_and_pixel_backend__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set RasterizerAndPixelBackend :: Samples Blended */
#define glk__rasterizer_and_pixel_backend__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set RasterizerAndPixelBackend :: Sampler Texels */
#define glk__rasterizer_and_pixel_backend__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set RasterizerAndPixelBackend :: Sampler Texels Misses */
#define glk__rasterizer_and_pixel_backend__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Read */
#define glk__rasterizer_and_pixel_backend__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Read */
#define glk__rasterizer_and_pixel_backend__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Written */
#define glk__rasterizer_and_pixel_backend__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Written */
#define glk__rasterizer_and_pixel_backend__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set RasterizerAndPixelBackend :: Shader Memory Accesses */
#define glk__rasterizer_and_pixel_backend__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set RasterizerAndPixelBackend :: Shader Atomic Memory Accesses */
#define glk__rasterizer_and_pixel_backend__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set RasterizerAndPixelBackend :: L3 Shader Throughput */
#define glk__rasterizer_and_pixel_backend__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set RasterizerAndPixelBackend :: L3 Shader Throughput */
#define glk__rasterizer_and_pixel_backend__l3_shader_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Metric set RasterizerAndPixelBackend :: Shader Barrier Messages */
#define glk__rasterizer_and_pixel_backend__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Post-EarlyZ Pixel Data Ready */
#define glk__rasterizer_and_pixel_backend__pixel_data0_ready__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Rasterizer Input Available */
#define glk__rasterizer_and_pixel_backend__rasterizer0_input_available__read \
    bdw__render_basic__sampler1_busy__read

/* Metric set RasterizerAndPixelBackend :: Slice0 PS Output Available */
#define glk__rasterizer_and_pixel_backend__ps_output0_available__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Pixel Values Ready */
#define glk__rasterizer_and_pixel_backend__pixel_values0_ready__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Rasterizer Output Ready */
#define glk__rasterizer_and_pixel_backend__rasterizer0_output_ready__read \
    bdw__render_pipe_profile__sf_stall__read

/* Metric set RasterizerAndPixelBackend :: SQ is full */
#define glk__rasterizer_and_pixel_backend__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set Sampler :: GPU Time Elapsed */
#define glk__sampler__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set Sampler :: GPU Core Clocks */
#define glk__sampler__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set Sampler :: AVG GPU Core Frequency */
#define glk__sampler__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set Sampler :: AVG GPU Core Frequency */
#define glk__sampler__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set Sampler :: GPU Busy */
#define glk__sampler__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set Sampler :: VS Threads Dispatched */
#define glk__sampler__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set Sampler :: HS Threads Dispatched */
#define glk__sampler__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set Sampler :: DS Threads Dispatched */
#define glk__sampler__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set Sampler :: GS Threads Dispatched */
#define glk__sampler__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set Sampler :: FS Threads Dispatched */
#define glk__sampler__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set Sampler :: CS Threads Dispatched */
#define glk__sampler__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set Sampler :: EU Active */
#define glk__sampler__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set Sampler :: EU Stall */
#define glk__sampler__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set Sampler :: EU Both FPU Pipes Active */
#define glk__sampler__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set Sampler :: VS FPU0 Pipe Active */
#define glk__sampler__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set Sampler :: VS FPU1 Pipe Active */
#define glk__sampler__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set Sampler :: VS Send Pipe Active */
#define glk__sampler__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set Sampler :: PS FPU0 Pipe Active */
#define glk__sampler__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set Sampler :: PS FPU1 Pipe Active */
#define glk__sampler__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set Sampler :: PS Send Pipeline Active */
#define glk__sampler__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set Sampler :: FS Both FPU Active */
#define glk__sampler__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set Sampler :: Rasterized Pixels */
#define glk__sampler__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set Sampler :: Early Hi-Depth Test Fails */
#define glk__sampler__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set Sampler :: Early Depth Test Fails */
#define glk__sampler__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set Sampler :: Samples Killed in FS */
#define glk__sampler__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set Sampler :: Pixels Failing Tests */
#define glk__sampler__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set Sampler :: Samples Written */
#define glk__sampler__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set Sampler :: Samples Blended */
#define glk__sampler__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set Sampler :: Sampler Texels */
#define glk__sampler__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set Sampler :: Sampler Texels Misses */
#define glk__sampler__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set Sampler :: SLM Bytes Read */
#define glk__sampler__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set Sampler :: SLM Bytes Read */
#define glk__sampler__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set Sampler :: SLM Bytes Written */
#define glk__sampler__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set Sampler :: SLM Bytes Written */
#define glk__sampler__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set Sampler :: Shader Memory Accesses */
#define glk__sampler__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set Sampler :: Shader Atomic Memory Accesses */
#define glk__sampler__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set Sampler :: L3 Shader Throughput */
#define glk__sampler__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set Sampler :: L3 Shader Throughput */
#define glk__sampler__l3_shader_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Metric set Sampler :: Shader Barrier Messages */
#define glk__sampler__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set Sampler :: Slice0 Subslice1 Input Available */
#define glk__sampler__sampler01_input_available__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set Sampler :: Slice0 Subslice2 Input Available */
#define glk__sampler__sampler02_input_available__read \
    bdw__render_basic__sampler1_busy__read

/* Metric set Sampler :: Slice0 Subslice0 Input Available */
#define glk__sampler__sampler00_input_available__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Metric set Sampler :: Slice0 Subslice2 Sampler Output Ready */
#define glk__sampler__sampler02_output_ready__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set Sampler :: Slice0 Subslice0 Sampler Output Ready */
#define glk__sampler__sampler00_output_ready__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set Sampler :: Slice0 Subslice1 Sampler Output Ready */
#define glk__sampler__sampler01_output_ready__read \
    bdw__render_pipe_profile__sf_stall__read

/* Metric set Sampler :: SQ is full */
#define glk__sampler__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set TDL_1 :: GPU Time Elapsed */
#define glk__tdl_1__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set TDL_1 :: GPU Core Clocks */
#define glk__tdl_1__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set TDL_1 :: AVG GPU Core Frequency */
#define glk__tdl_1__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set TDL_1 :: AVG GPU Core Frequency */
#define glk__tdl_1__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set TDL_1 :: GPU Busy */
#define glk__tdl_1__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set TDL_1 :: VS Threads Dispatched */
#define glk__tdl_1__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set TDL_1 :: HS Threads Dispatched */
#define glk__tdl_1__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set TDL_1 :: DS Threads Dispatched */
#define glk__tdl_1__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set TDL_1 :: GS Threads Dispatched */
#define glk__tdl_1__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set TDL_1 :: FS Threads Dispatched */
#define glk__tdl_1__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set TDL_1 :: CS Threads Dispatched */
#define glk__tdl_1__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set TDL_1 :: EU Active */
#define glk__tdl_1__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set TDL_1 :: EU Stall */
#define glk__tdl_1__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set TDL_1 :: EU Both FPU Pipes Active */
#define glk__tdl_1__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set TDL_1 :: VS FPU0 Pipe Active */
#define glk__tdl_1__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set TDL_1 :: VS FPU1 Pipe Active */
#define glk__tdl_1__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set TDL_1 :: VS Send Pipe Active */
#define glk__tdl_1__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set TDL_1 :: PS FPU0 Pipe Active */
#define glk__tdl_1__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set TDL_1 :: PS FPU1 Pipe Active */
#define glk__tdl_1__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set TDL_1 :: PS Send Pipeline Active */
#define glk__tdl_1__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set TDL_1 :: FS Both FPU Active */
#define glk__tdl_1__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set TDL_1 :: Rasterized Pixels */
#define glk__tdl_1__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set TDL_1 :: Early Hi-Depth Test Fails */
#define glk__tdl_1__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set TDL_1 :: Early Depth Test Fails */
#define glk__tdl_1__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set TDL_1 :: Samples Killed in FS */
#define glk__tdl_1__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set TDL_1 :: Pixels Failing Tests */
#define glk__tdl_1__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set TDL_1 :: Samples Written */
#define glk__tdl_1__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set TDL_1 :: Samples Blended */
#define glk__tdl_1__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set TDL_1 :: Sampler Texels */
#define glk__tdl_1__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set TDL_1 :: Sampler Texels Misses */
#define glk__tdl_1__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set TDL_1 :: SLM Bytes Read */
#define glk__tdl_1__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set TDL_1 :: SLM Bytes Read */
#define glk__tdl_1__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_1 :: SLM Bytes Written */
#define glk__tdl_1__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set TDL_1 :: SLM Bytes Written */
#define glk__tdl_1__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_1 :: Shader Memory Accesses */
#define glk__tdl_1__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set TDL_1 :: Shader Atomic Memory Accesses */
#define glk__tdl_1__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set TDL_1 :: L3 Shader Throughput */
#define glk__tdl_1__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set TDL_1 :: L3 Shader Throughput */
#define glk__tdl_1__l3_shader_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Metric set TDL_1 :: Shader Barrier Messages */
#define glk__tdl_1__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set TDL_1 :: NonPS Thread Ready For Dispatch on Slice0 Subslice1 */
#define glk__tdl_1__non_ps_thread01_ready_for_dispatch__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set TDL_1 :: PS Thread Ready For Dispatch on Slice0 Subslice0 */
#define glk__tdl_1__ps_thread00_ready_for_dispatch__read \
    bdw__render_basic__sampler1_busy__read

/* Metric set TDL_1 :: NonPS Thread Ready For Dispatch on Slice0 Subslice0 */
#define glk__tdl_1__non_ps_thread00_ready_for_dispatch__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Metric set TDL_1 :: PS Thread Ready For Dispatch on Slice0 Subslice2 */
#define glk__tdl_1__ps_thread02_ready_for_dispatch__read \
    bdw__render_basic__sampler1_bottleneck__read

/* Metric set TDL_1 :: NonPS Thread Ready For Dispatch on Slice0 Subslice2 */
#define glk__tdl_1__non_ps_thread02_ready_for_dispatch__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* Metric set TDL_1 :: PS Thread Ready For Dispatch on Slice0 Subslice1 */
#define glk__tdl_1__ps_thread01_ready_for_dispatch__read \
    bdw__render_pipe_profile__cl_bottleneck__read

/* Metric set TDL_1 :: SQ is full */
#define glk__tdl_1__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Metric set TDL_2 :: GPU Time Elapsed */
#define glk__tdl_2__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set TDL_2 :: GPU Core Clocks */
#define glk__tdl_2__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set TDL_2 :: AVG GPU Core Frequency */
#define glk__tdl_2__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set TDL_2 :: AVG GPU Core Frequency */
#define glk__tdl_2__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set TDL_2 :: GPU Busy */
#define glk__tdl_2__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set TDL_2 :: VS Threads Dispatched */
#define glk__tdl_2__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set TDL_2 :: HS Threads Dispatched */
#define glk__tdl_2__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set TDL_2 :: DS Threads Dispatched */
#define glk__tdl_2__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set TDL_2 :: GS Threads Dispatched */
#define glk__tdl_2__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set TDL_2 :: FS Threads Dispatched */
#define glk__tdl_2__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set TDL_2 :: CS Threads Dispatched */
#define glk__tdl_2__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set TDL_2 :: EU Active */
#define glk__tdl_2__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set TDL_2 :: EU Stall */
#define glk__tdl_2__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set TDL_2 :: EU Both FPU Pipes Active */
#define glk__tdl_2__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set TDL_2 :: VS FPU0 Pipe Active */
#define glk__tdl_2__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set TDL_2 :: VS FPU1 Pipe Active */
#define glk__tdl_2__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set TDL_2 :: VS Send Pipe Active */
#define glk__tdl_2__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set TDL_2 :: PS FPU0 Pipe Active */
#define glk__tdl_2__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set TDL_2 :: PS FPU1 Pipe Active */
#define glk__tdl_2__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set TDL_2 :: PS Send Pipeline Active */
#define glk__tdl_2__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set TDL_2 :: FS Both FPU Active */
#define glk__tdl_2__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set TDL_2 :: Rasterized Pixels */
#define glk__tdl_2__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set TDL_2 :: Early Hi-Depth Test Fails */
#define glk__tdl_2__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set TDL_2 :: Early Depth Test Fails */
#define glk__tdl_2__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set TDL_2 :: Samples Killed in FS */
#define glk__tdl_2__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set TDL_2 :: Pixels Failing Tests */
#define glk__tdl_2__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set TDL_2 :: Samples Written */
#define glk__tdl_2__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set TDL_2 :: Samples Blended */
#define glk__tdl_2__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set TDL_2 :: Sampler Texels */
#define glk__tdl_2__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set TDL_2 :: Sampler Texels Misses */
#define glk__tdl_2__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set TDL_2 :: SLM Bytes Read */
#define glk__tdl_2__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set TDL_2 :: SLM Bytes Read */
#define glk__tdl_2__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_2 :: SLM Bytes Written */
#define glk__tdl_2__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set TDL_2 :: SLM Bytes Written */
#define glk__tdl_2__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_2 :: Shader Memory Accesses */
#define glk__tdl_2__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set TDL_2 :: Shader Atomic Memory Accesses */
#define glk__tdl_2__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set TDL_2 :: L3 Shader Throughput */
#define glk__tdl_2__l3_shader_throughput__read \
    bdw__render_basic__l3_shader_throughput__read

/* Metric set TDL_2 :: L3 Shader Throughput */
#define glk__tdl_2__l3_shader_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Metric set TDL_2 :: Shader Barrier Messages */
#define glk__tdl_2__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice1 Port 0 */
#define glk__tdl_2__thread_header01_ready_port0__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice0 Port 1 */
#define glk__tdl_2__thread_header00_ready_port1__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice0 Port 0 */
#define glk__tdl_2__thread_header00_ready_port0__read \
    bdw__render_pipe_profile__sf_stall__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice2 Port 1 */
#define glk__tdl_2__thread_header02_ready_port1__read \
    bdw__render_pipe_profile__cl_stall__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice2 Port 0 */
#define glk__tdl_2__thread_header02_ready_port0__read \
    bdw__render_pipe_profile__so_stall__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice1 Port 1 */
#define glk__tdl_2__thread_header01_ready_port1__read \
    bdw__render_pipe_profile__ds_stall__read

/* Metric set TDL_2 :: SQ is full */
#define glk__tdl_2__gt_request_queue_full__read \
    bdw__hdc_and_sf__gt_request_queue_full__read

/* Compute Metrics Extra Gen9 :: GPU Time Elapsed */
#define glk__compute_extra__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Compute Metrics Extra Gen9 :: GPU Core Clocks */
#define glk__compute_extra__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Compute Metrics Extra Gen9 :: AVG GPU Core Frequency */
#define glk__compute_extra__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Compute Metrics Extra Gen9 :: AVG GPU Core Frequency */
#define glk__compute_extra__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Compute Metrics Extra Gen9 :: EU FPU1 Pipe Active */
#define glk__compute_extra__fpu1_active__read \
    bdw__render_basic__eu_stall__read

/* Compute Metrics Extra Gen9 :: EU FPU1 Pipe Active including Ext Math */
#define glk__compute_extra__fpu1_active_adjusted__read \
    sklgt2__compute_extra__fpu1_active_adjusted__read

/* MDAPI testing set Gen9 :: GPU Time Elapsed */
#define glk__test_oa__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* MDAPI testing set Gen9 :: GPU Core Clocks */
#define glk__test_oa__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* MDAPI testing set Gen9 :: AVG GPU Core Frequency */
#define glk__test_oa__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* MDAPI testing set Gen9 :: AVG GPU Core Frequency */
#define glk__test_oa__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* MDAPI testing set Gen9 :: TestCounter0 */
#define glk__test_oa__counter0__read \
    hsw__compute_extended__eu_untyped_reads0__read

/* MDAPI testing set Gen9 :: TestCounter1 */
#define glk__test_oa__counter1__read \
    hsw__compute_extended__eu_untyped_writes0__read

/* MDAPI testing set Gen9 :: TestCounter2 */
#define glk__test_oa__counter2__read \
    hsw__compute_extended__eu_typed_reads0__read

/* MDAPI testing set Gen9 :: TestCounter3 */
#define glk__test_oa__counter3__read \
    hsw__compute_extended__eu_typed_writes0__read

/* MDAPI testing set Gen9 :: TestCounter4 */
#define glk__test_oa__counter4__read \
    hsw__compute_extended__eu_untyped_atomics0__read

/* MDAPI testing set Gen9 :: TestCounter5 */
#define glk__test_oa__counter5__read \
    hsw__compute_extended__eu_typed_atomics0__read

/* MDAPI testing set Gen9 :: TestCounter6 */
#define glk__test_oa__counter6__read \
    hsw__compute_extended__eu_urb_atomics0__read

/* MDAPI testing set Gen9 :: TestCounter7 */
#define glk__test_oa__counter7__read \
    hsw__compute_extended__gpu_clocks__read

/* MDAPI testing set Gen9 :: TestCounter8 */
#define glk__test_oa__counter8__read \
    hsw__memory_reads__gpu_core_clocks__read

/* Metric set PMA Stall :: GPU Time Elapsed */
#define glk__pma__stall__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set PMA Stall :: GPU Core Clocks */
#define glk__pma__stall__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set PMA Stall :: AVG GPU Core Frequency */
#define glk__pma__stall__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set PMA Stall :: AVG GPU Core Frequency */
#define glk__pma__stall__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set PMA Stall :: STC PMA stall */
#define glk__pma__stall__stc_pma_stall__read \
    sklgt2__pma__stall__stc_pma_stall__read

/* Render Metrics Basic Gen10 :: GPU Time Elapsed */
#define cnl__render_basic__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Render Metrics Basic Gen10 :: GPU Core Clocks */
#define cnl__render_basic__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Render Metrics Basic Gen10 :: AVG GPU Core Frequency */
#define cnl__render_basic__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Render Metrics Basic Gen10 :: AVG GPU Core Frequency */
#define cnl__render_basic__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Render Metrics Basic Gen10 :: VS Threads Dispatched */
#define cnl__render_basic__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Render Metrics Basic Gen10 :: HS Threads Dispatched */
#define cnl__render_basic__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Render Metrics Basic Gen10 :: DS Threads Dispatched */
#define cnl__render_basic__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Render Metrics Basic Gen10 :: GS Threads Dispatched */
#define cnl__render_basic__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Render Metrics Basic Gen10 :: FS Threads Dispatched */
#define cnl__render_basic__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Render Metrics Basic Gen10 :: CS Threads Dispatched */
#define cnl__render_basic__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Render Metrics Basic Gen10 :: GPU Busy */
#define cnl__render_basic__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Render Metrics Basic Gen10 :: EU Active */
#define cnl__render_basic__eu_active__read \
    bdw__render_basic__eu_active__read

/* Render Metrics Basic Gen10 :: EU Stall */
#define cnl__render_basic__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Render Metrics Basic Gen10 :: EU Both FPU Pipes Active */
#define cnl__render_basic__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Render Metrics Basic Gen10 :: VS FPU0 Pipe Active */
#define cnl__render_basic__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Render Metrics Basic Gen10 :: VS FPU1 Pipe Active */
#define cnl__render_basic__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Render Metrics Basic Gen10 :: VS Send Pipe Active */
#define cnl__render_basic__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Render Metrics Basic Gen10 :: PS FPU0 Pipe Active */
#define cnl__render_basic__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Render Metrics Basic Gen10 :: PS FPU1 Pipe Active */
#define cnl__render_basic__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Render Metrics Basic Gen10 :: PS Send Pipeline Active */
#define cnl__render_basic__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Render Metrics Basic Gen10 :: FS Both FPU Active */
#define cnl__render_basic__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Render Metrics Basic Gen10 :: Sampler00 Busy */
#define cnl__render_basic__sampler00_busy__read \
    bdw__render_basic__sampler0_busy__read

/* Render Metrics Basic Gen10 :: Sampler10 Busy */
#define cnl__render_basic__sampler10_busy__read \
    bdw__render_basic__sampler1_busy__read

/* Render Metrics Basic Gen10 :: Samplers Busy */
static double
cnl__render_basic__samplers_busy__read(const struct intel_perf *perf,
                                       const struct intel_perf_metric_set *metric_set,
                                       uint64_t *accumulator)
{
    /* RPN equation: $SubsliceMask 1 AND $Sampler00Busy FMUL $SubsliceMask 3 >> 1 AND $Sampler10Busy FMUL FADD $SubsliceMask 1 AND $SubsliceMask 3 >> 1 AND FADD FDIV */
    uint64_t tmp0 = perf->devinfo.subslice_mask & 1;
    double tmp1 = tmp0 * cnl__render_basic__sampler00_busy__read(perf, metric_set, accumulator);
    uint64_t tmp2 = perf->devinfo.subslice_mask >> 3;
    uint64_t tmp3 = tmp2 & 1;
    double tmp4 = tmp3 * cnl__render_basic__sampler10_busy__read(perf, metric_set, accumulator);
    double tmp5 = tmp1 + tmp4;
    uint64_t tmp6 = perf->devinfo.subslice_mask & 1;
    uint64_t tmp7 = perf->devinfo.subslice_mask >> 3;
    uint64_t tmp8 = tmp7 & 1;
    double tmp9 = tmp6 + tmp8;
    double tmp10 = tmp5;
    double tmp11 = tmp9;
    double tmp12 = tmp11 ? tmp10 / tmp11 : 0;

    return tmp12;
}

/* Render Metrics Basic Gen10 :: Sampler00 Bottleneck */
#define cnl__render_basic__sampler00_bottleneck__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Render Metrics Basic Gen10 :: Sampler10 Bottleneck */
#define cnl__render_basic__sampler10_bottleneck__read \
    bdw__render_basic__sampler1_bottleneck__read

/* Render Metrics Basic Gen10 :: Rasterized Pixels */
#define cnl__render_basic__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Render Metrics Basic Gen10 :: Early Hi-Depth Test Fails */
#define cnl__render_basic__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Render Metrics Basic Gen10 :: Early Depth Test Fails */
#define cnl__render_basic__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Render Metrics Basic Gen10 :: Samples Killed in FS */
#define cnl__render_basic__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Render Metrics Basic Gen10 :: Pixels Failing Tests */
#define cnl__render_basic__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Render Metrics Basic Gen10 :: Samples Written */
#define cnl__render_basic__samples_written__read \
    bdw__render_basic__samples_written__read

/* Render Metrics Basic Gen10 :: Samples Blended */
#define cnl__render_basic__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Render Metrics Basic Gen10 :: Sampler Texels */
#define cnl__render_basic__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Render Metrics Basic Gen10 :: Sampler Texels Misses */
#define cnl__render_basic__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Render Metrics Basic Gen10 :: Sampler Cache Misses */
static uint64_t
cnl__render_basic__sampler_l1_misses__read(const struct intel_perf *perf,
                                           const struct intel_perf_metric_set *metric_set,
                                           uint64_t *accumulator)
{
    /* RPN equation: $SliceMask 1 AND B 4 READ UMUL $SliceMask 1 >> 1 AND B 5 READ UMUL UADD 8 UMUL */
    uint64_t tmp0 = perf->devinfo.slice_mask & 1;
    uint64_t tmp1 = accumulator[metric_set->b_offset + 4];
    uint64_t tmp2 = tmp0 * tmp1;
    uint64_t tmp3 = perf->devinfo.slice_mask >> 1;
    uint64_t tmp4 = tmp3 & 1;
    uint64_t tmp5 = accumulator[metric_set->b_offset + 5];
    uint64_t tmp6 = tmp4 * tmp5;
    uint64_t tmp7 = tmp2 + tmp6;
    uint64_t tmp8 = tmp7 * 8;

    return tmp8;
}

/* Render Metrics Basic Gen10 :: SLM Bytes Read */
#define cnl__render_basic__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Render Metrics Basic Gen10 :: SLM Bytes Read */
#define cnl__render_basic__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics Basic Gen10 :: SLM Bytes Written */
#define cnl__render_basic__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Render Metrics Basic Gen10 :: SLM Bytes Written */
#define cnl__render_basic__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics Basic Gen10 :: Shader Memory Accesses */
#define cnl__render_basic__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Render Metrics Basic Gen10 :: Shader Atomic Memory Accesses */
#define cnl__render_basic__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Render Metrics Basic Gen10 :: L3 Lookup Accesses w/o IC */
static uint64_t
cnl__render_basic__l3_lookups__read(const struct intel_perf *perf,
                                    const struct intel_perf_metric_set *metric_set,
                                    uint64_t *accumulator)
{
    /* RPN equation: $SamplerL1Misses $ShaderMemoryAccesses UADD */
    uint64_t tmp0 = cnl__render_basic__sampler_l1_misses__read(perf, metric_set, accumulator) + cnl__render_basic__shader_memory_accesses__read(perf, metric_set, accumulator);

    return tmp0;
}

/* Render Metrics Basic Gen10 :: L3 Misses */
static uint64_t
cnl__render_basic__l3_misses__read(const struct intel_perf *perf,
                                   const struct intel_perf_metric_set *metric_set,
                                   uint64_t *accumulator)
{
    /* RPN equation: C 2 READ C 3 READ UADD */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 2];
    uint64_t tmp1 = accumulator[metric_set->c_offset + 3];
    uint64_t tmp2 = tmp0 + tmp1;

    return tmp2;
}

/* Render Metrics Basic Gen10 :: L3 Sampler Throughput */
static uint64_t
cnl__render_basic__l3_sampler_throughput__read(const struct intel_perf *perf,
                                               const struct intel_perf_metric_set *metric_set,
                                               uint64_t *accumulator)
{
    /* RPN equation: 64 $SamplerL1Misses UMUL */
    uint64_t tmp0 = 64 * cnl__render_basic__sampler_l1_misses__read(perf, metric_set, accumulator);

    return tmp0;
}

/* Render Metrics Basic Gen10 :: L3 Sampler Throughput */
#define cnl__render_basic__l3_sampler_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Render Metrics Basic Gen10 :: L3 Shader Throughput */
static uint64_t
cnl__render_basic__l3_shader_throughput__read(const struct intel_perf *perf,
                                              const struct intel_perf_metric_set *metric_set,
                                              uint64_t *accumulator)
{
    /* RPN equation: A 30 READ A 31 READ UADD A 32 READ UADD 64 UMUL */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 30];
    uint64_t tmp1 = accumulator[metric_set->a_offset + 31];
    uint64_t tmp2 = tmp0 + tmp1;
    uint64_t tmp3 = accumulator[metric_set->a_offset + 32];
    uint64_t tmp4 = tmp2 + tmp3;
    uint64_t tmp5 = tmp4 * 64;

    return tmp5;
}

/* Render Metrics Basic Gen10 :: L3 Shader Throughput */
#define cnl__render_basic__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics Basic Gen10 :: Shader Barrier Messages */
#define cnl__render_basic__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Render Metrics Basic Gen10 :: GTI Depth Throughput */
static uint64_t
cnl__render_basic__gti_depth_throughput__read(const struct intel_perf *perf,
                                              const struct intel_perf_metric_set *metric_set,
                                              uint64_t *accumulator)
{
    /* RPN equation: 128  B 6 READ UMUL */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 6];
    uint64_t tmp1 = 128 * tmp0;

    return tmp1;
}

/* Render Metrics Basic Gen10 :: GTI Depth Throughput */
#define cnl__render_basic__gti_depth_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Render Metrics Basic Gen10 :: GTI Fixed Pipe Throughput */
#define cnl__render_basic__gti_vf_throughput__read \
    bdw__compute_l3_cache__gti_l3_throughput__read

/* Render Metrics Basic Gen10 :: GTI Fixed Pipe Throughput */
#define cnl__render_basic__gti_vf_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Render Metrics Basic Gen10 :: GTI RCC Throughput */
static uint64_t
cnl__render_basic__gti_rcc_throughput__read(const struct intel_perf *perf,
                                            const struct intel_perf_metric_set *metric_set,
                                            uint64_t *accumulator)
{
    /* RPN equation: C 0 READ C 1 READ UADD 128 UMUL */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 0];
    uint64_t tmp1 = accumulator[metric_set->c_offset + 1];
    uint64_t tmp2 = tmp0 + tmp1;
    uint64_t tmp3 = tmp2 * 128;

    return tmp3;
}

/* Render Metrics Basic Gen10 :: GTI RCC Throughput */
#define cnl__render_basic__gti_rcc_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Render Metrics Basic Gen10 :: GTI L3 Throughput */
#define cnl__render_basic__gti_l3_throughput__read \
    bdw__render_basic__gti_rcc_throughput__read

/* Render Metrics Basic Gen10 :: GTI L3 Throughput */
#define cnl__render_basic__gti_l3_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Render Metrics Basic Gen10 :: GTI Read Throughput */
static uint64_t
cnl__render_basic__gti_read_throughput__read(const struct intel_perf *perf,
                                             const struct intel_perf_metric_set *metric_set,
                                             uint64_t *accumulator)
{
    /* RPN equation: 64  C 6 READ UMUL */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 6];
    uint64_t tmp1 = 64 * tmp0;

    return tmp1;
}

/* Render Metrics Basic Gen10 :: GTI Read Throughput */
#define cnl__render_basic__gti_read_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Render Metrics Basic Gen10 :: GTI Write Throughput */
static uint64_t
cnl__render_basic__gti_write_throughput__read(const struct intel_perf *perf,
                                              const struct intel_perf_metric_set *metric_set,
                                              uint64_t *accumulator)
{
    /* RPN equation: 64  C 7 READ UMUL */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 7];
    uint64_t tmp1 = 64 * tmp0;

    return tmp1;
}

/* Render Metrics Basic Gen10 :: GTI Write Throughput */
#define cnl__render_basic__gti_write_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Render Metrics Basic Gen10 :: Samplers Bottleneck */
static double
cnl__render_basic__sampler_bottleneck__read(const struct intel_perf *perf,
                                            const struct intel_perf_metric_set *metric_set,
                                            uint64_t *accumulator)
{
    /* RPN equation: $SubsliceMask 1 AND $Sampler00Bottleneck FMUL $SubsliceMask 3 >> 1 AND $Sampler10Bottleneck FMUL FADD $SubsliceMask 1 AND $SubsliceMask 3 >> 1 AND FADD FDIV */
    uint64_t tmp0 = perf->devinfo.subslice_mask & 1;
    double tmp1 = tmp0 * cnl__render_basic__sampler00_bottleneck__read(perf, metric_set, accumulator);
    uint64_t tmp2 = perf->devinfo.subslice_mask >> 3;
    uint64_t tmp3 = tmp2 & 1;
    double tmp4 = tmp3 * cnl__render_basic__sampler10_bottleneck__read(perf, metric_set, accumulator);
    double tmp5 = tmp1 + tmp4;
    uint64_t tmp6 = perf->devinfo.subslice_mask & 1;
    uint64_t tmp7 = perf->devinfo.subslice_mask >> 3;
    uint64_t tmp8 = tmp7 & 1;
    double tmp9 = tmp6 + tmp8;
    double tmp10 = tmp5;
    double tmp11 = tmp9;
    double tmp12 = tmp11 ? tmp10 / tmp11 : 0;

    return tmp12;
}

/* Compute Metrics Basic Gen10 :: GPU Time Elapsed */
#define cnl__compute_basic__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Compute Metrics Basic Gen10 :: GPU Core Clocks */
#define cnl__compute_basic__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Compute Metrics Basic Gen10 :: AVG GPU Core Frequency */
#define cnl__compute_basic__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Compute Metrics Basic Gen10 :: AVG GPU Core Frequency */
#define cnl__compute_basic__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Compute Metrics Basic Gen10 :: GPU Busy */
#define cnl__compute_basic__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Compute Metrics Basic Gen10 :: VS Threads Dispatched */
#define cnl__compute_basic__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Compute Metrics Basic Gen10 :: HS Threads Dispatched */
#define cnl__compute_basic__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Compute Metrics Basic Gen10 :: DS Threads Dispatched */
#define cnl__compute_basic__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Compute Metrics Basic Gen10 :: GS Threads Dispatched */
#define cnl__compute_basic__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Compute Metrics Basic Gen10 :: FS Threads Dispatched */
#define cnl__compute_basic__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Compute Metrics Basic Gen10 :: CS Threads Dispatched */
#define cnl__compute_basic__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Compute Metrics Basic Gen10 :: EU Active */
#define cnl__compute_basic__eu_active__read \
    bdw__render_basic__eu_active__read

/* Compute Metrics Basic Gen10 :: EU Stall */
#define cnl__compute_basic__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Compute Metrics Basic Gen10 :: EU AVG IPC Rate */
static double
cnl__compute_basic__eu_avg_ipc_rate__read(const struct intel_perf *perf,
                                          const struct intel_perf_metric_set *metric_set,
                                          uint64_t *accumulator)
{
    /* RPN equation: A 9 READ A 10 READ A 11 READ FADD A 9 READ FSUB FDIV 1 FADD */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 9];
    uint64_t tmp1 = accumulator[metric_set->a_offset + 10];
    uint64_t tmp2 = accumulator[metric_set->a_offset + 11];
    double tmp3 = tmp1 + tmp2;
    uint64_t tmp4 = accumulator[metric_set->a_offset + 9];
    double tmp5 = tmp3 - tmp4;
    double tmp6 = tmp0;
    double tmp7 = tmp5;
    double tmp8 = tmp7 ? tmp6 / tmp7 : 0;
    double tmp9 = tmp8 + 1;

    return tmp9;
}

/* Compute Metrics Basic Gen10 :: EU AVG IPC Rate */
#define cnl__compute_basic__eu_avg_ipc_rate__max \
    bdw__compute_basic__eu_avg_ipc_rate__max

/* Compute Metrics Basic Gen10 :: EU Both FPU Pipes Active */
#define cnl__compute_basic__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Compute Metrics Basic Gen10 :: EU FPU0 Pipe Active */
#define cnl__compute_basic__fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Compute Metrics Basic Gen10 :: EU FPU1 Pipe Active */
#define cnl__compute_basic__fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Compute Metrics Basic Gen10 :: EU Send Pipe Active */
#define cnl__compute_basic__eu_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Compute Metrics Basic Gen10 :: EU Thread Occupancy */
static double
cnl__compute_basic__eu_thread_occupancy__read(const struct intel_perf *perf,
                                              const struct intel_perf_metric_set *metric_set,
                                              uint64_t *accumulator)
{
    /* RPN equation: 8 A 13 READ FMUL $EuThreadsCount FDIV $EuCoresTotalCount UDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 13];
    double tmp1 = 8 * tmp0;
    double tmp2 = tmp1;
    double tmp3 = perf->devinfo.eu_threads_count;
    double tmp4 = tmp3 ? tmp2 / tmp3 : 0;
    uint64_t tmp5 = tmp4;
    uint64_t tmp6 = perf->devinfo.n_eus;
    uint64_t tmp7 = tmp6 ? tmp5 / tmp6 : 0;
    uint64_t tmp8 = tmp7 * 100;
    double tmp9 = tmp8;
    double tmp10 = cnl__compute_basic__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp11 = tmp10 ? tmp9 / tmp10 : 0;

    return tmp11;
}

/* Compute Metrics Basic Gen10 :: Rasterized Pixels */
#define cnl__compute_basic__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Compute Metrics Basic Gen10 :: Early Hi-Depth Test Fails */
#define cnl__compute_basic__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Compute Metrics Basic Gen10 :: Early Depth Test Fails */
#define cnl__compute_basic__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Compute Metrics Basic Gen10 :: Samples Killed in FS */
#define cnl__compute_basic__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Compute Metrics Basic Gen10 :: Pixels Failing Tests */
#define cnl__compute_basic__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Compute Metrics Basic Gen10 :: Samples Written */
#define cnl__compute_basic__samples_written__read \
    bdw__render_basic__samples_written__read

/* Compute Metrics Basic Gen10 :: Samples Blended */
#define cnl__compute_basic__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Compute Metrics Basic Gen10 :: Sampler Texels */
#define cnl__compute_basic__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Compute Metrics Basic Gen10 :: Sampler Texels Misses */
#define cnl__compute_basic__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Compute Metrics Basic Gen10 :: SLM Bytes Read */
#define cnl__compute_basic__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Compute Metrics Basic Gen10 :: SLM Bytes Read */
#define cnl__compute_basic__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Basic Gen10 :: SLM Bytes Written */
#define cnl__compute_basic__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Compute Metrics Basic Gen10 :: SLM Bytes Written */
#define cnl__compute_basic__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Basic Gen10 :: Shader Memory Accesses */
#define cnl__compute_basic__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Compute Metrics Basic Gen10 :: Shader Atomic Memory Accesses */
#define cnl__compute_basic__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Compute Metrics Basic Gen10 :: L3 Shader Throughput */
#define cnl__compute_basic__l3_shader_throughput__read \
    cnl__render_basic__l3_shader_throughput__read

/* Compute Metrics Basic Gen10 :: L3 Shader Throughput */
#define cnl__compute_basic__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Basic Gen10 :: Shader Barrier Messages */
#define cnl__compute_basic__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Compute Metrics Basic Gen10 :: Typed Bytes Read */
static uint64_t
cnl__compute_basic__typed_bytes_read__read(const struct intel_perf *perf,
                                           const struct intel_perf_metric_set *metric_set,
                                           uint64_t *accumulator)
{
    /* RPN equation: $SubsliceMask 1 AND B 0 READ UMUL $SubsliceMask 1 >> 1 AND B 1 READ UMUL UADD $SubsliceMask 2 >> 1 AND B 2 READ UMUL UADD $SubsliceMask 3 >> 1 AND B 3 READ UMUL UADD $SubsliceMask 4 >> 1 AND B 4 READ UMUL UADD 64 UMUL */
    uint64_t tmp0 = perf->devinfo.subslice_mask & 1;
    uint64_t tmp1 = accumulator[metric_set->b_offset + 0];
    uint64_t tmp2 = tmp0 * tmp1;
    uint64_t tmp3 = perf->devinfo.subslice_mask >> 1;
    uint64_t tmp4 = tmp3 & 1;
    uint64_t tmp5 = accumulator[metric_set->b_offset + 1];
    uint64_t tmp6 = tmp4 * tmp5;
    uint64_t tmp7 = tmp2 + tmp6;
    uint64_t tmp8 = perf->devinfo.subslice_mask >> 2;
    uint64_t tmp9 = tmp8 & 1;
    uint64_t tmp10 = accumulator[metric_set->b_offset + 2];
    uint64_t tmp11 = tmp9 * tmp10;
    uint64_t tmp12 = tmp7 + tmp11;
    uint64_t tmp13 = perf->devinfo.subslice_mask >> 3;
    uint64_t tmp14 = tmp13 & 1;
    uint64_t tmp15 = accumulator[metric_set->b_offset + 3];
    uint64_t tmp16 = tmp14 * tmp15;
    uint64_t tmp17 = tmp12 + tmp16;
    uint64_t tmp18 = perf->devinfo.subslice_mask >> 4;
    uint64_t tmp19 = tmp18 & 1;
    uint64_t tmp20 = accumulator[metric_set->b_offset + 4];
    uint64_t tmp21 = tmp19 * tmp20;
    uint64_t tmp22 = tmp17 + tmp21;
    uint64_t tmp23 = tmp22 * 64;

    return tmp23;
}

/* Compute Metrics Basic Gen10 :: Typed Bytes Read */
#define cnl__compute_basic__typed_bytes_read__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen10 :: Typed Bytes Written */
static uint64_t
cnl__compute_basic__typed_bytes_written__read(const struct intel_perf *perf,
                                              const struct intel_perf_metric_set *metric_set,
                                              uint64_t *accumulator)
{
    /* RPN equation: $SubsliceMask 1 AND B 5 READ UMUL $SubsliceMask 1 >> 1 AND B 6 READ UMUL UADD $SubsliceMask 2 >> 1 AND B 7 READ UMUL UADD $SubsliceMask 3 >> 1 AND C 0 READ UMUL UADD $SubsliceMask 4 >> 1 AND C 1 READ UMUL UADD 64 UMUL */
    uint64_t tmp0 = perf->devinfo.subslice_mask & 1;
    uint64_t tmp1 = accumulator[metric_set->b_offset + 5];
    uint64_t tmp2 = tmp0 * tmp1;
    uint64_t tmp3 = perf->devinfo.subslice_mask >> 1;
    uint64_t tmp4 = tmp3 & 1;
    uint64_t tmp5 = accumulator[metric_set->b_offset + 6];
    uint64_t tmp6 = tmp4 * tmp5;
    uint64_t tmp7 = tmp2 + tmp6;
    uint64_t tmp8 = perf->devinfo.subslice_mask >> 2;
    uint64_t tmp9 = tmp8 & 1;
    uint64_t tmp10 = accumulator[metric_set->b_offset + 7];
    uint64_t tmp11 = tmp9 * tmp10;
    uint64_t tmp12 = tmp7 + tmp11;
    uint64_t tmp13 = perf->devinfo.subslice_mask >> 3;
    uint64_t tmp14 = tmp13 & 1;
    uint64_t tmp15 = accumulator[metric_set->c_offset + 0];
    uint64_t tmp16 = tmp14 * tmp15;
    uint64_t tmp17 = tmp12 + tmp16;
    uint64_t tmp18 = perf->devinfo.subslice_mask >> 4;
    uint64_t tmp19 = tmp18 & 1;
    uint64_t tmp20 = accumulator[metric_set->c_offset + 1];
    uint64_t tmp21 = tmp19 * tmp20;
    uint64_t tmp22 = tmp17 + tmp21;
    uint64_t tmp23 = tmp22 * 64;

    return tmp23;
}

/* Compute Metrics Basic Gen10 :: Typed Bytes Written */
#define cnl__compute_basic__typed_bytes_written__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen10 :: Untyped Bytes Read */
static uint64_t
cnl__compute_basic__untyped_bytes_read__read(const struct intel_perf *perf,
                                             const struct intel_perf_metric_set *metric_set,
                                             uint64_t *accumulator)
{
    /* RPN equation: $EuSubslicesTotalCount $SubsliceMask 1 AND C 2 READ FMUL $SubsliceMask 3 >> 1 AND C 3 READ FMUL FADD FMUL $SubsliceMask 1 AND $SubsliceMask 3 >> 1 AND FADD FDIV 64 UMUL */
    uint64_t tmp0 = perf->devinfo.subslice_mask & 1;
    uint64_t tmp1 = accumulator[metric_set->c_offset + 2];
    double tmp2 = tmp0 * tmp1;
    uint64_t tmp3 = perf->devinfo.subslice_mask >> 3;
    uint64_t tmp4 = tmp3 & 1;
    uint64_t tmp5 = accumulator[metric_set->c_offset + 3];
    double tmp6 = tmp4 * tmp5;
    double tmp7 = tmp2 + tmp6;
    double tmp8 = perf->devinfo.n_eu_sub_slices * tmp7;
    uint64_t tmp9 = perf->devinfo.subslice_mask & 1;
    uint64_t tmp10 = perf->devinfo.subslice_mask >> 3;
    uint64_t tmp11 = tmp10 & 1;
    double tmp12 = tmp9 + tmp11;
    double tmp13 = tmp8;
    double tmp14 = tmp12;
    double tmp15 = tmp14 ? tmp13 / tmp14 : 0;
    uint64_t tmp16 = tmp15 * 64;

    return tmp16;
}

/* Compute Metrics Basic Gen10 :: Untyped Bytes Read */
#define cnl__compute_basic__untyped_bytes_read__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen10 :: Untyped Writes */
static uint64_t
cnl__compute_basic__untyped_bytes_written__read(const struct intel_perf *perf,
                                                const struct intel_perf_metric_set *metric_set,
                                                uint64_t *accumulator)
{
    /* RPN equation: $EuSubslicesTotalCount $SubsliceMask 1 AND C 4 READ FMUL $SubsliceMask 3 >> 1 AND C 5 READ FMUL FADD FMUL $SubsliceMask 1 AND $SubsliceMask 3 >> 1 AND FADD FDIV 64 UMUL */
    uint64_t tmp0 = perf->devinfo.subslice_mask & 1;
    uint64_t tmp1 = accumulator[metric_set->c_offset + 4];
    double tmp2 = tmp0 * tmp1;
    uint64_t tmp3 = perf->devinfo.subslice_mask >> 3;
    uint64_t tmp4 = tmp3 & 1;
    uint64_t tmp5 = accumulator[metric_set->c_offset + 5];
    double tmp6 = tmp4 * tmp5;
    double tmp7 = tmp2 + tmp6;
    double tmp8 = perf->devinfo.n_eu_sub_slices * tmp7;
    uint64_t tmp9 = perf->devinfo.subslice_mask & 1;
    uint64_t tmp10 = perf->devinfo.subslice_mask >> 3;
    uint64_t tmp11 = tmp10 & 1;
    double tmp12 = tmp9 + tmp11;
    double tmp13 = tmp8;
    double tmp14 = tmp12;
    double tmp15 = tmp14 ? tmp13 / tmp14 : 0;
    uint64_t tmp16 = tmp15 * 64;

    return tmp16;
}

/* Compute Metrics Basic Gen10 :: Untyped Writes */
#define cnl__compute_basic__untyped_bytes_written__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen10 :: GTI Read Throughput */
#define cnl__compute_basic__gti_read_throughput__read \
    cnl__render_basic__gti_read_throughput__read

/* Compute Metrics Basic Gen10 :: GTI Read Throughput */
#define cnl__compute_basic__gti_read_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Compute Metrics Basic Gen10 :: GTI Write Throughput */
#define cnl__compute_basic__gti_write_throughput__read \
    cnl__render_basic__gti_write_throughput__read

/* Compute Metrics Basic Gen10 :: GTI Write Throughput */
#define cnl__compute_basic__gti_write_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Render Metrics for 3D Pipeline Profile Gen10 :: GPU Time Elapsed */
#define cnl__render_pipe_profile__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Render Metrics for 3D Pipeline Profile Gen10 :: GPU Core Clocks */
#define cnl__render_pipe_profile__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Render Metrics for 3D Pipeline Profile Gen10 :: AVG GPU Core Frequency */
#define cnl__render_pipe_profile__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Render Metrics for 3D Pipeline Profile Gen10 :: AVG GPU Core Frequency */
#define cnl__render_pipe_profile__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Render Metrics for 3D Pipeline Profile Gen10 :: GPU Busy */
#define cnl__render_pipe_profile__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Render Metrics for 3D Pipeline Profile Gen10 :: VS Threads Dispatched */
#define cnl__render_pipe_profile__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Render Metrics for 3D Pipeline Profile Gen10 :: HS Threads Dispatched */
#define cnl__render_pipe_profile__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Render Metrics for 3D Pipeline Profile Gen10 :: DS Threads Dispatched */
#define cnl__render_pipe_profile__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Render Metrics for 3D Pipeline Profile Gen10 :: GS Threads Dispatched */
#define cnl__render_pipe_profile__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Render Metrics for 3D Pipeline Profile Gen10 :: FS Threads Dispatched */
#define cnl__render_pipe_profile__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Render Metrics for 3D Pipeline Profile Gen10 :: CS Threads Dispatched */
#define cnl__render_pipe_profile__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Render Metrics for 3D Pipeline Profile Gen10 :: EU Active */
#define cnl__render_pipe_profile__eu_active__read \
    bdw__render_basic__eu_active__read

/* Render Metrics for 3D Pipeline Profile Gen10 :: EU Stall */
#define cnl__render_pipe_profile__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Render Metrics for 3D Pipeline Profile Gen10 :: Rasterized Pixels */
#define cnl__render_pipe_profile__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Render Metrics for 3D Pipeline Profile Gen10 :: Early Hi-Depth Test Fails */
#define cnl__render_pipe_profile__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Render Metrics for 3D Pipeline Profile Gen10 :: Early Depth Test Fails */
#define cnl__render_pipe_profile__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Render Metrics for 3D Pipeline Profile Gen10 :: Samples Killed in FS */
#define cnl__render_pipe_profile__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Render Metrics for 3D Pipeline Profile Gen10 :: Pixels Failing Tests */
#define cnl__render_pipe_profile__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Render Metrics for 3D Pipeline Profile Gen10 :: Samples Written */
#define cnl__render_pipe_profile__samples_written__read \
    bdw__render_basic__samples_written__read

/* Render Metrics for 3D Pipeline Profile Gen10 :: Samples Blended */
#define cnl__render_pipe_profile__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Render Metrics for 3D Pipeline Profile Gen10 :: Sampler Texels */
#define cnl__render_pipe_profile__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Render Metrics for 3D Pipeline Profile Gen10 :: Sampler Texels Misses */
#define cnl__render_pipe_profile__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Render Metrics for 3D Pipeline Profile Gen10 :: SLM Bytes Read */
#define cnl__render_pipe_profile__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Render Metrics for 3D Pipeline Profile Gen10 :: SLM Bytes Read */
#define cnl__render_pipe_profile__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics for 3D Pipeline Profile Gen10 :: SLM Bytes Written */
#define cnl__render_pipe_profile__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Render Metrics for 3D Pipeline Profile Gen10 :: SLM Bytes Written */
#define cnl__render_pipe_profile__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics for 3D Pipeline Profile Gen10 :: Shader Memory Accesses */
#define cnl__render_pipe_profile__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Render Metrics for 3D Pipeline Profile Gen10 :: Shader Atomic Memory Accesses */
#define cnl__render_pipe_profile__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Render Metrics for 3D Pipeline Profile Gen10 :: L3 Shader Throughput */
#define cnl__render_pipe_profile__l3_shader_throughput__read \
    cnl__render_basic__l3_shader_throughput__read

/* Render Metrics for 3D Pipeline Profile Gen10 :: L3 Shader Throughput */
#define cnl__render_pipe_profile__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics for 3D Pipeline Profile Gen10 :: Shader Barrier Messages */
#define cnl__render_pipe_profile__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Render Metrics for 3D Pipeline Profile Gen10 :: VF Bottleneck */
#define cnl__render_pipe_profile__vf_bottleneck__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen10 :: VS Bottleneck */
#define cnl__render_pipe_profile__vs_bottleneck__read \
    bdw__render_pipe_profile__so_stall__read

/* Render Metrics for 3D Pipeline Profile Gen10 :: HS Bottleneck */
#define cnl__render_pipe_profile__hs_bottleneck__read \
    bdw__render_pipe_profile__ds_stall__read

/* Render Metrics for 3D Pipeline Profile Gen10 :: DS Bottleneck */
#define cnl__render_pipe_profile__ds_bottleneck__read \
    bdw__render_pipe_profile__hs_stall__read

/* Render Metrics for 3D Pipeline Profile Gen10 :: GS Bottleneck */
#define cnl__render_pipe_profile__gs_bottleneck__read \
    bdw__render_pipe_profile__vf_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen10 :: SO Bottleneck */
#define cnl__render_pipe_profile__so_bottleneck__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen10 :: Clipper Bottleneck */
#define cnl__render_pipe_profile__cl_bottleneck__read \
    bdw__render_pipe_profile__early_depth_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen10 :: Strip-Fans Bottleneck */
#define cnl__render_pipe_profile__sf_bottleneck__read \
    bdw__render_pipe_profile__sf_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen10 :: Hi-Depth Bottleneck */
#define cnl__render_pipe_profile__hi_depth_bottleneck__read \
    bdw__render_basic__sampler1_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen10 :: Early Depth Bottleneck */
#define cnl__render_pipe_profile__early_depth_bottleneck__read \
    bdw__render_pipe_profile__cl_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen10 :: BC Bottleneck */
#define cnl__render_pipe_profile__bc_bottleneck__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen10 :: HS Stall */
#define cnl__render_pipe_profile__hs_stall__read \
    bdw__render_basic__sampler1_busy__read

/* Render Metrics for 3D Pipeline Profile Gen10 :: DS Stall */
#define cnl__render_pipe_profile__ds_stall__read \
    bdw__render_basic__sampler0_busy__read

/* Render Metrics for 3D Pipeline Profile Gen10 :: SO Stall */
#define cnl__render_pipe_profile__so_stall__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen10 :: CL Stall */
#define cnl__render_pipe_profile__cl_stall__read \
    bdw__render_pipe_profile__sf_stall__read

/* Render Metrics for 3D Pipeline Profile Gen10 :: SF Stall */
#define cnl__render_pipe_profile__sf_stall__read \
    bdw__render_pipe_profile__cl_stall__read

/* Memory Reads Distribution Gen10 :: GPU Time Elapsed */
#define cnl__memory_reads__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Memory Reads Distribution Gen10 :: GPU Core Clocks */
#define cnl__memory_reads__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Memory Reads Distribution Gen10 :: AVG GPU Core Frequency */
#define cnl__memory_reads__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Memory Reads Distribution Gen10 :: AVG GPU Core Frequency */
#define cnl__memory_reads__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Memory Reads Distribution Gen10 :: GPU Busy */
#define cnl__memory_reads__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Memory Reads Distribution Gen10 :: VS Threads Dispatched */
#define cnl__memory_reads__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Memory Reads Distribution Gen10 :: HS Threads Dispatched */
#define cnl__memory_reads__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Memory Reads Distribution Gen10 :: DS Threads Dispatched */
#define cnl__memory_reads__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Memory Reads Distribution Gen10 :: GS Threads Dispatched */
#define cnl__memory_reads__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Memory Reads Distribution Gen10 :: FS Threads Dispatched */
#define cnl__memory_reads__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Memory Reads Distribution Gen10 :: CS Threads Dispatched */
#define cnl__memory_reads__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Memory Reads Distribution Gen10 :: EU Active */
#define cnl__memory_reads__eu_active__read \
    bdw__render_basic__eu_active__read

/* Memory Reads Distribution Gen10 :: EU Stall */
#define cnl__memory_reads__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Memory Reads Distribution Gen10 :: Rasterized Pixels */
#define cnl__memory_reads__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Memory Reads Distribution Gen10 :: Early Hi-Depth Test Fails */
#define cnl__memory_reads__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Memory Reads Distribution Gen10 :: Early Depth Test Fails */
#define cnl__memory_reads__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Memory Reads Distribution Gen10 :: Samples Killed in FS */
#define cnl__memory_reads__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Memory Reads Distribution Gen10 :: Pixels Failing Tests */
#define cnl__memory_reads__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Memory Reads Distribution Gen10 :: Samples Written */
#define cnl__memory_reads__samples_written__read \
    bdw__render_basic__samples_written__read

/* Memory Reads Distribution Gen10 :: Samples Blended */
#define cnl__memory_reads__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Memory Reads Distribution Gen10 :: Sampler Texels */
#define cnl__memory_reads__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Memory Reads Distribution Gen10 :: Sampler Texels Misses */
#define cnl__memory_reads__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Memory Reads Distribution Gen10 :: SLM Bytes Read */
#define cnl__memory_reads__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Memory Reads Distribution Gen10 :: SLM Bytes Read */
#define cnl__memory_reads__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Memory Reads Distribution Gen10 :: SLM Bytes Written */
#define cnl__memory_reads__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Memory Reads Distribution Gen10 :: SLM Bytes Written */
#define cnl__memory_reads__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Memory Reads Distribution Gen10 :: Shader Memory Accesses */
#define cnl__memory_reads__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Memory Reads Distribution Gen10 :: Shader Atomic Memory Accesses */
#define cnl__memory_reads__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Memory Reads Distribution Gen10 :: Shader Barrier Messages */
#define cnl__memory_reads__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Memory Reads Distribution Gen10 :: GtiCmdStreamerMemoryReads */
#define cnl__memory_reads__gti_cmd_streamer_memory_reads__read \
    hsw__compute_extended__eu_untyped_reads0__read

/* Memory Reads Distribution Gen10 :: GtiRsMemoryReads */
#define cnl__memory_reads__gti_rs_memory_reads__read \
    hsw__compute_extended__eu_typed_reads0__read

/* Memory Reads Distribution Gen10 :: GtiVfMemoryReads */
#define cnl__memory_reads__gti_vf_memory_reads__read \
    hsw__compute_extended__eu_untyped_writes0__read

/* Memory Reads Distribution Gen10 :: GtiRccMemoryReads */
#define cnl__memory_reads__gti_rcc_memory_reads__read \
    hsw__compute_extended__eu_typed_writes0__read

/* Memory Reads Distribution Gen10 :: GtiMscMemoryReads */
#define cnl__memory_reads__gti_msc_memory_reads__read \
    hsw__compute_extended__eu_untyped_atomics0__read

/* Memory Reads Distribution Gen10 :: GtiHizMemoryReads */
#define cnl__memory_reads__gti_hiz_memory_reads__read \
    hsw__compute_extended__eu_typed_atomics0__read

/* Memory Reads Distribution Gen10 :: GtiStcMemoryReads */
#define cnl__memory_reads__gti_stc_memory_reads__read \
    hsw__compute_extended__eu_urb_atomics0__read

/* Memory Reads Distribution Gen10 :: GtiRczMemoryReads */
#define cnl__memory_reads__gti_rcz_memory_reads__read \
    hsw__compute_extended__gpu_clocks__read

/* Memory Reads Distribution Gen10 :: GtiMemoryReads */
#define cnl__memory_reads__gti_memory_reads__read \
    hsw__compute_extended__typed_writes0__read

/* Memory Reads Distribution Gen10 :: GtiL3Bank0Reads */
#define cnl__memory_reads__gti_l3_bank0_reads__read \
    hsw__compute_extended__untyped_writes0__read

/* Memory Reads Distribution Gen10 :: GtiL3Bank1Reads */
#define cnl__memory_reads__gti_l3_bank1_reads__read \
    hsw__render_basic__gpu_core_clocks__read

/* Memory Reads Distribution Gen10 :: GtiL3Bank2Reads */
#define cnl__memory_reads__gti_l3_bank2_reads__read \
    hsw__compute_extended__untyped_reads0__read

/* Memory Reads Distribution Gen10 :: GtiL3Reads */
static uint64_t
cnl__memory_reads__gti_l3_reads__read(const struct intel_perf *perf,
                                      const struct intel_perf_metric_set *metric_set,
                                      uint64_t *accumulator)
{
    /* RPN equation: $GtiL3Bank0Reads $GtiL3Bank1Reads UADD $GtiL3Bank2Reads UADD */
    uint64_t tmp0 = cnl__memory_reads__gti_l3_bank0_reads__read(perf, metric_set, accumulator) + cnl__memory_reads__gti_l3_bank1_reads__read(perf, metric_set, accumulator);
    uint64_t tmp1 = tmp0 + cnl__memory_reads__gti_l3_bank2_reads__read(perf, metric_set, accumulator);

    return tmp1;
}

/* Memory Reads Distribution Gen10 :: GtiRingAccesses */
#define cnl__memory_reads__gti_ring_accesses__read \
    hsw__memory_reads__gpu_core_clocks__read

/* Memory Writes Distribution Gen10 :: GPU Time Elapsed */
#define cnl__memory_writes__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Memory Writes Distribution Gen10 :: GPU Core Clocks */
#define cnl__memory_writes__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Memory Writes Distribution Gen10 :: AVG GPU Core Frequency */
#define cnl__memory_writes__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Memory Writes Distribution Gen10 :: AVG GPU Core Frequency */
#define cnl__memory_writes__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Memory Writes Distribution Gen10 :: GPU Busy */
#define cnl__memory_writes__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Memory Writes Distribution Gen10 :: VS Threads Dispatched */
#define cnl__memory_writes__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Memory Writes Distribution Gen10 :: HS Threads Dispatched */
#define cnl__memory_writes__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Memory Writes Distribution Gen10 :: DS Threads Dispatched */
#define cnl__memory_writes__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Memory Writes Distribution Gen10 :: GS Threads Dispatched */
#define cnl__memory_writes__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Memory Writes Distribution Gen10 :: FS Threads Dispatched */
#define cnl__memory_writes__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Memory Writes Distribution Gen10 :: CS Threads Dispatched */
#define cnl__memory_writes__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Memory Writes Distribution Gen10 :: EU Active */
#define cnl__memory_writes__eu_active__read \
    bdw__render_basic__eu_active__read

/* Memory Writes Distribution Gen10 :: EU Stall */
#define cnl__memory_writes__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Memory Writes Distribution Gen10 :: Rasterized Pixels */
#define cnl__memory_writes__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Memory Writes Distribution Gen10 :: Early Hi-Depth Test Fails */
#define cnl__memory_writes__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Memory Writes Distribution Gen10 :: Early Depth Test Fails */
#define cnl__memory_writes__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Memory Writes Distribution Gen10 :: Samples Killed in FS */
#define cnl__memory_writes__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Memory Writes Distribution Gen10 :: Pixels Failing Tests */
#define cnl__memory_writes__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Memory Writes Distribution Gen10 :: Samples Written */
#define cnl__memory_writes__samples_written__read \
    bdw__render_basic__samples_written__read

/* Memory Writes Distribution Gen10 :: Samples Blended */
#define cnl__memory_writes__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Memory Writes Distribution Gen10 :: Sampler Texels */
#define cnl__memory_writes__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Memory Writes Distribution Gen10 :: Sampler Texels Misses */
#define cnl__memory_writes__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Memory Writes Distribution Gen10 :: SLM Bytes Read */
#define cnl__memory_writes__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Memory Writes Distribution Gen10 :: SLM Bytes Read */
#define cnl__memory_writes__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Memory Writes Distribution Gen10 :: SLM Bytes Written */
#define cnl__memory_writes__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Memory Writes Distribution Gen10 :: SLM Bytes Written */
#define cnl__memory_writes__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Memory Writes Distribution Gen10 :: Shader Memory Accesses */
#define cnl__memory_writes__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Memory Writes Distribution Gen10 :: Shader Atomic Memory Accesses */
#define cnl__memory_writes__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Memory Writes Distribution Gen10 :: L3 Shader Throughput */
#define cnl__memory_writes__l3_shader_throughput__read \
    cnl__render_basic__l3_shader_throughput__read

/* Memory Writes Distribution Gen10 :: L3 Shader Throughput */
#define cnl__memory_writes__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Memory Writes Distribution Gen10 :: Shader Barrier Messages */
#define cnl__memory_writes__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Memory Writes Distribution Gen10 :: GtiCmdStreamerMemoryWrites */
#define cnl__memory_writes__gti_cmd_streamer_memory_writes__read \
    hsw__compute_extended__eu_untyped_reads0__read

/* Memory Writes Distribution Gen10 :: GtiSoMemoryWrites */
#define cnl__memory_writes__gti_so_memory_writes__read \
    hsw__compute_extended__eu_untyped_writes0__read

/* Memory Writes Distribution Gen10 :: GtiRccMemoryWrites */
#define cnl__memory_writes__gti_rcc_memory_writes__read \
    hsw__compute_extended__eu_typed_reads0__read

/* Memory Writes Distribution Gen10 :: GtiMscMemoryWrites */
#define cnl__memory_writes__gti_msc_memory_writes__read \
    hsw__compute_extended__eu_typed_writes0__read

/* Memory Writes Distribution Gen10 :: GtiHizMemoryWrites */
#define cnl__memory_writes__gti_hiz_memory_writes__read \
    hsw__compute_extended__eu_untyped_atomics0__read

/* Memory Writes Distribution Gen10 :: GtiStcMemoryWrites */
#define cnl__memory_writes__gti_stc_memory_writes__read \
    hsw__compute_extended__eu_typed_atomics0__read

/* Memory Writes Distribution Gen10 :: GtiRczMemoryWrites */
#define cnl__memory_writes__gti_rcz_memory_writes__read \
    hsw__compute_extended__eu_urb_atomics0__read

/* Memory Writes Distribution Gen10 :: GtiMemoryWrites */
#define cnl__memory_writes__gti_memory_writes__read \
    hsw__compute_extended__typed_writes0__read

/* Memory Writes Distribution Gen10 :: GtiL3Bank0Writes */
#define cnl__memory_writes__gti_l3_bank0_writes__read \
    hsw__compute_extended__untyped_writes0__read

/* Memory Writes Distribution Gen10 :: GtiL3Bank1Writes */
#define cnl__memory_writes__gti_l3_bank1_writes__read \
    hsw__render_basic__gpu_core_clocks__read

/* Memory Writes Distribution Gen10 :: GtiL3Bank2Writes */
#define cnl__memory_writes__gti_l3_bank2_writes__read \
    hsw__compute_extended__untyped_reads0__read

/* Memory Writes Distribution Gen10 :: GtiL3Writes */
#define cnl__memory_writes__gti_l3_writes__read \
    cnl__memory_reads__gti_l3_reads__read

/* Memory Writes Distribution Gen10 :: GtiRingAccesses */
#define cnl__memory_writes__gti_ring_accesses__read \
    hsw__memory_reads__gpu_core_clocks__read

/* Compute Metrics Extended Gen10 :: GPU Time Elapsed */
#define cnl__compute_extended__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Compute Metrics Extended Gen10 :: GPU Core Clocks */
#define cnl__compute_extended__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Compute Metrics Extended Gen10 :: AVG GPU Core Frequency */
#define cnl__compute_extended__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Compute Metrics Extended Gen10 :: AVG GPU Core Frequency */
#define cnl__compute_extended__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Compute Metrics Extended Gen10 :: CS Threads Dispatched */
#define cnl__compute_extended__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Compute Metrics Extended Gen10 :: EU Active */
#define cnl__compute_extended__eu_active__read \
    bdw__render_basic__eu_active__read

/* Compute Metrics Extended Gen10 :: EU Stall */
#define cnl__compute_extended__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Compute Metrics Extended Gen10 :: EU AVG IPC Rate */
#define cnl__compute_extended__eu_avg_ipc_rate__read \
    cnl__compute_basic__eu_avg_ipc_rate__read

/* Compute Metrics Extended Gen10 :: EU AVG IPC Rate */
#define cnl__compute_extended__eu_avg_ipc_rate__max \
    bdw__compute_basic__eu_avg_ipc_rate__max

/* Compute Metrics Extended Gen10 :: EU Both FPU Pipes Active */
#define cnl__compute_extended__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Compute Metrics Extended Gen10 :: EU FPU0 Pipe Active */
#define cnl__compute_extended__fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Compute Metrics Extended Gen10 :: EU FPU1 Pipe Active */
#define cnl__compute_extended__fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Compute Metrics Extended Gen10 :: EU Send Pipe Active */
#define cnl__compute_extended__eu_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Compute Metrics Extended Gen10 :: EU Thread Occupancy */
#define cnl__compute_extended__eu_thread_occupancy__read \
    cnl__compute_basic__eu_thread_occupancy__read

/* Compute Metrics Extended Gen10 :: Sampler Texels */
#define cnl__compute_extended__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Compute Metrics Extended Gen10 :: Sampler Texels Misses */
#define cnl__compute_extended__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Compute Metrics Extended Gen10 :: SLM Bytes Read */
#define cnl__compute_extended__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Compute Metrics Extended Gen10 :: SLM Bytes Read */
#define cnl__compute_extended__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Extended Gen10 :: SLM Bytes Written */
#define cnl__compute_extended__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Compute Metrics Extended Gen10 :: SLM Bytes Written */
#define cnl__compute_extended__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Extended Gen10 :: Shader Memory Accesses */
#define cnl__compute_extended__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Compute Metrics Extended Gen10 :: Shader Atomic Memory Accesses */
#define cnl__compute_extended__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Compute Metrics Extended Gen10 :: L3 Shader Throughput */
#define cnl__compute_extended__l3_shader_throughput__read \
    cnl__render_basic__l3_shader_throughput__read

/* Compute Metrics Extended Gen10 :: L3 Shader Throughput */
#define cnl__compute_extended__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Extended Gen10 :: Shader Barrier Messages */
#define cnl__compute_extended__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Compute Metrics Extended Gen10 :: EuUntypedReads0 */
#define cnl__compute_extended__eu_untyped_reads0__read \
    hsw__compute_extended__eu_untyped_reads0__read

/* Compute Metrics Extended Gen10 :: EuTypedReads0 */
#define cnl__compute_extended__eu_typed_reads0__read \
    hsw__compute_extended__eu_typed_atomics0__read

/* Compute Metrics Extended Gen10 :: EuUntypedWrites0 */
#define cnl__compute_extended__eu_untyped_writes0__read \
    hsw__compute_extended__eu_untyped_writes0__read

/* Compute Metrics Extended Gen10 :: EuTypedWrites0 */
#define cnl__compute_extended__eu_typed_writes0__read \
    hsw__compute_extended__eu_urb_atomics0__read

/* Compute Metrics Extended Gen10 :: EuUntypedAtomics0 */
#define cnl__compute_extended__eu_untyped_atomics0__read \
    hsw__compute_extended__eu_typed_reads0__read

/* Compute Metrics Extended Gen10 :: EuTypedAtomics0 */
#define cnl__compute_extended__eu_typed_atomics0__read \
    hsw__compute_extended__gpu_clocks__read

/* Compute Metrics Extended Gen10 :: EuA64UntypedReads0 */
#define cnl__compute_extended__eu_a64_untyped_reads0__read \
    hsw__compute_extended__eu_typed_writes0__read

/* Compute Metrics Extended Gen10 :: EuA64UntypedWrites0 */
#define cnl__compute_extended__eu_a64_untyped_writes0__read \
    hsw__compute_extended__eu_untyped_atomics0__read

/* Compute Metrics Extended Gen10 :: Typed Reads 0 */
#define cnl__compute_extended__typed_reads0__read \
    hsw__compute_extended__untyped_reads0__read

/* Compute Metrics Extended Gen10 :: Typed Writes 0 */
#define cnl__compute_extended__typed_writes0__read \
    hsw__compute_extended__typed_atomics0__read

/* Compute Metrics Extended Gen10 :: Untyped Reads 0 */
#define cnl__compute_extended__untyped_reads0__read \
    hsw__compute_extended__untyped_writes0__read

/* Compute Metrics Extended Gen10 :: Untyped Writes 0 */
#define cnl__compute_extended__untyped_writes0__read \
    hsw__render_basic__gpu_core_clocks__read

/* Compute Metrics Extended Gen10 :: Typed Atomics 0 */
#define cnl__compute_extended__typed_atomics0__read \
    hsw__memory_reads__gti_memory_reads__read

/* Compute Metrics Extended Gen10 :: TypedReadsPerCacheLine */
static double
cnl__compute_extended__typed_reads_per_cache_line__read(const struct intel_perf *perf,
                                                        const struct intel_perf_metric_set *metric_set,
                                                        uint64_t *accumulator)
{
    /* RPN equation: $EuTypedReads0 $TypedReads0 FDIV */
    double tmp0 = cnl__compute_extended__eu_typed_reads0__read(perf, metric_set, accumulator);
    double tmp1 = cnl__compute_extended__typed_reads0__read(perf, metric_set, accumulator);
    double tmp2 = tmp1 ? tmp0 / tmp1 : 0;

    return tmp2;
}

/* Compute Metrics Extended Gen10 :: TypedWritesPerCacheLine */
static double
cnl__compute_extended__typed_writes_per_cache_line__read(const struct intel_perf *perf,
                                                         const struct intel_perf_metric_set *metric_set,
                                                         uint64_t *accumulator)
{
    /* RPN equation: $EuTypedWrites0 $TypedWrites0 FDIV */
    double tmp0 = cnl__compute_extended__eu_typed_writes0__read(perf, metric_set, accumulator);
    double tmp1 = cnl__compute_extended__typed_writes0__read(perf, metric_set, accumulator);
    double tmp2 = tmp1 ? tmp0 / tmp1 : 0;

    return tmp2;
}

/* Compute Metrics Extended Gen10 :: UntypedReadsPerCacheLine */
static double
cnl__compute_extended__untyped_reads_per_cache_line__read(const struct intel_perf *perf,
                                                          const struct intel_perf_metric_set *metric_set,
                                                          uint64_t *accumulator)
{
    /* RPN equation: $EuUntypedReads0 $EuA64UntypedReads0 FADD $UntypedReads0 FDIV */
    double tmp0 = cnl__compute_extended__eu_untyped_reads0__read(perf, metric_set, accumulator) + cnl__compute_extended__eu_a64_untyped_reads0__read(perf, metric_set, accumulator);
    double tmp1 = tmp0;
    double tmp2 = cnl__compute_extended__untyped_reads0__read(perf, metric_set, accumulator);
    double tmp3 = tmp2 ? tmp1 / tmp2 : 0;

    return tmp3;
}

/* Compute Metrics Extended Gen10 :: UntypedWritesPerCacheLine */
static double
cnl__compute_extended__untyped_writes_per_cache_line__read(const struct intel_perf *perf,
                                                           const struct intel_perf_metric_set *metric_set,
                                                           uint64_t *accumulator)
{
    /* RPN equation: $EuUntypedWrites0 $EuA64UntypedWrites0 FADD $UntypedWrites0 FDIV */
    double tmp0 = cnl__compute_extended__eu_untyped_writes0__read(perf, metric_set, accumulator) + cnl__compute_extended__eu_a64_untyped_writes0__read(perf, metric_set, accumulator);
    double tmp1 = tmp0;
    double tmp2 = cnl__compute_extended__untyped_writes0__read(perf, metric_set, accumulator);
    double tmp3 = tmp2 ? tmp1 / tmp2 : 0;

    return tmp3;
}

/* Compute Metrics Extended Gen10 :: TypedAtomicsPerCacheLine */
static double
cnl__compute_extended__typed_atomics_per_cache_line__read(const struct intel_perf *perf,
                                                          const struct intel_perf_metric_set *metric_set,
                                                          uint64_t *accumulator)
{
    /* RPN equation: $EuTypedAtomics0 $TypedAtomics0 FDIV */
    double tmp0 = cnl__compute_extended__eu_typed_atomics0__read(perf, metric_set, accumulator);
    double tmp1 = cnl__compute_extended__typed_atomics0__read(perf, metric_set, accumulator);
    double tmp2 = tmp1 ? tmp0 / tmp1 : 0;

    return tmp2;
}

/* Compute Metrics L3 Cache Gen10 :: GPU Time Elapsed */
#define cnl__compute_l3_cache__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Compute Metrics L3 Cache Gen10 :: GPU Core Clocks */
#define cnl__compute_l3_cache__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Compute Metrics L3 Cache Gen10 :: AVG GPU Core Frequency */
#define cnl__compute_l3_cache__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Compute Metrics L3 Cache Gen10 :: AVG GPU Core Frequency */
#define cnl__compute_l3_cache__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Compute Metrics L3 Cache Gen10 :: GPU Busy */
#define cnl__compute_l3_cache__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Compute Metrics L3 Cache Gen10 :: VS Threads Dispatched */
#define cnl__compute_l3_cache__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Compute Metrics L3 Cache Gen10 :: HS Threads Dispatched */
#define cnl__compute_l3_cache__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Compute Metrics L3 Cache Gen10 :: DS Threads Dispatched */
#define cnl__compute_l3_cache__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Compute Metrics L3 Cache Gen10 :: GS Threads Dispatched */
#define cnl__compute_l3_cache__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Compute Metrics L3 Cache Gen10 :: FS Threads Dispatched */
#define cnl__compute_l3_cache__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Compute Metrics L3 Cache Gen10 :: CS Threads Dispatched */
#define cnl__compute_l3_cache__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Compute Metrics L3 Cache Gen10 :: EU Active */
#define cnl__compute_l3_cache__eu_active__read \
    bdw__render_basic__eu_active__read

/* Compute Metrics L3 Cache Gen10 :: EU Stall */
#define cnl__compute_l3_cache__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Compute Metrics L3 Cache Gen10 :: EU AVG IPC Rate */
#define cnl__compute_l3_cache__eu_avg_ipc_rate__read \
    cnl__compute_basic__eu_avg_ipc_rate__read

/* Compute Metrics L3 Cache Gen10 :: EU AVG IPC Rate */
#define cnl__compute_l3_cache__eu_avg_ipc_rate__max \
    bdw__compute_basic__eu_avg_ipc_rate__max

/* Compute Metrics L3 Cache Gen10 :: EU Both FPU Pipes Active */
#define cnl__compute_l3_cache__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Compute Metrics L3 Cache Gen10 :: EU FPU0 Pipe Active */
#define cnl__compute_l3_cache__fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Compute Metrics L3 Cache Gen10 :: EU FPU1 Pipe Active */
#define cnl__compute_l3_cache__fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Compute Metrics L3 Cache Gen10 :: EU Send Pipe Active */
#define cnl__compute_l3_cache__eu_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Compute Metrics L3 Cache Gen10 :: EU FPU0 Hybrid Instruction */
#define cnl__compute_l3_cache__eu_hybrid_fpu0_instruction__read \
    bdw__compute_l3_cache__eu_hybrid_fpu0_instruction__read

/* Compute Metrics L3 Cache Gen10 :: EU FPU1 Hybrid Instruction */
#define cnl__compute_l3_cache__eu_hybrid_fpu1_instruction__read \
    bdw__compute_l3_cache__eu_hybrid_fpu1_instruction__read

/* Compute Metrics L3 Cache Gen10 :: EU FPU0 Ternary Instruction */
#define cnl__compute_l3_cache__eu_ternary_fpu0_instruction__read \
    bdw__render_basic__ps_fpu0_active__read

/* Compute Metrics L3 Cache Gen10 :: EU FPU1 Ternary Instruction */
#define cnl__compute_l3_cache__eu_ternary_fpu1_instruction__read \
    bdw__render_basic__ps_fpu1_active__read

/* Compute Metrics L3 Cache Gen10 :: EU FPU0 Binary Instruction */
#define cnl__compute_l3_cache__eu_binary_fpu0_instruction__read \
    bdw__render_basic__ps_send_active__read

/* Compute Metrics L3 Cache Gen10 :: EU FPU1 Binary Instruction */
#define cnl__compute_l3_cache__eu_binary_fpu1_instruction__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Compute Metrics L3 Cache Gen10 :: EU FPU0 Move Instruction */
#define cnl__compute_l3_cache__eu_move_fpu0_instruction__read \
    bdw__compute_l3_cache__eu_move_fpu0_instruction__read

/* Compute Metrics L3 Cache Gen10 :: EU FPU1 Move Instruction */
#define cnl__compute_l3_cache__eu_move_fpu1_instruction__read \
    bdw__compute_l3_cache__eu_move_fpu1_instruction__read

/* Compute Metrics L3 Cache Gen10 :: Rasterized Pixels */
#define cnl__compute_l3_cache__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Compute Metrics L3 Cache Gen10 :: Early Hi-Depth Test Fails */
#define cnl__compute_l3_cache__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Compute Metrics L3 Cache Gen10 :: Early Depth Test Fails */
#define cnl__compute_l3_cache__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Compute Metrics L3 Cache Gen10 :: Samples Killed in FS */
#define cnl__compute_l3_cache__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Compute Metrics L3 Cache Gen10 :: Pixels Failing Tests */
#define cnl__compute_l3_cache__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Compute Metrics L3 Cache Gen10 :: Samples Written */
#define cnl__compute_l3_cache__samples_written__read \
    bdw__render_basic__samples_written__read

/* Compute Metrics L3 Cache Gen10 :: Samples Blended */
#define cnl__compute_l3_cache__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Compute Metrics L3 Cache Gen10 :: Sampler Accesses */
#define cnl__compute_l3_cache__sampler_accesses__read \
    bdw__render_pipe_profile__sampler_accesses__read

/* Compute Metrics L3 Cache Gen10 :: Sampler Texels */
#define cnl__compute_l3_cache__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Compute Metrics L3 Cache Gen10 :: Sampler Texels Misses */
#define cnl__compute_l3_cache__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Compute Metrics L3 Cache Gen10 :: SLM Bytes Read */
#define cnl__compute_l3_cache__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Compute Metrics L3 Cache Gen10 :: SLM Bytes Read */
#define cnl__compute_l3_cache__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics L3 Cache Gen10 :: SLM Bytes Written */
#define cnl__compute_l3_cache__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Compute Metrics L3 Cache Gen10 :: SLM Bytes Written */
#define cnl__compute_l3_cache__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics L3 Cache Gen10 :: Shader Memory Accesses */
#define cnl__compute_l3_cache__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Compute Metrics L3 Cache Gen10 :: Shader Atomic Memory Accesses */
#define cnl__compute_l3_cache__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Compute Metrics L3 Cache Gen10 :: L3 Lookup Accesses w/o IC */
static uint64_t
cnl__compute_l3_cache__l3_lookups__read(const struct intel_perf *perf,
                                        const struct intel_perf_metric_set *metric_set,
                                        uint64_t *accumulator)
{
    /* RPN equation: $SliceMask 1 AND C 4 READ UMUL $SliceMask 1 >> 1 AND C 5 READ UMUL UADD 8 UMUL A 32 READ UADD */
    uint64_t tmp0 = perf->devinfo.slice_mask & 1;
    uint64_t tmp1 = accumulator[metric_set->c_offset + 4];
    uint64_t tmp2 = tmp0 * tmp1;
    uint64_t tmp3 = perf->devinfo.slice_mask >> 1;
    uint64_t tmp4 = tmp3 & 1;
    uint64_t tmp5 = accumulator[metric_set->c_offset + 5];
    uint64_t tmp6 = tmp4 * tmp5;
    uint64_t tmp7 = tmp2 + tmp6;
    uint64_t tmp8 = tmp7 * 8;
    uint64_t tmp9 = accumulator[metric_set->a_offset + 32];
    uint64_t tmp10 = tmp8 + tmp9;

    return tmp10;
}

/* Compute Metrics L3 Cache Gen10 :: L3 Misses */
#define cnl__compute_l3_cache__l3_misses__read \
    cnl__render_basic__l3_misses__read

/* Compute Metrics L3 Cache Gen10 :: L3 Sampler Throughput */
static uint64_t
cnl__compute_l3_cache__l3_sampler_throughput__read(const struct intel_perf *perf,
                                                   const struct intel_perf_metric_set *metric_set,
                                                   uint64_t *accumulator)
{
    /* RPN equation: 64  $SliceMask 1 AND C 4 READ UMUL $SliceMask 1 >> 1 AND C 5 READ UMUL UADD 8 UMUL UMUL */
    uint64_t tmp0 = perf->devinfo.slice_mask & 1;
    uint64_t tmp1 = accumulator[metric_set->c_offset + 4];
    uint64_t tmp2 = tmp0 * tmp1;
    uint64_t tmp3 = perf->devinfo.slice_mask >> 1;
    uint64_t tmp4 = tmp3 & 1;
    uint64_t tmp5 = accumulator[metric_set->c_offset + 5];
    uint64_t tmp6 = tmp4 * tmp5;
    uint64_t tmp7 = tmp2 + tmp6;
    uint64_t tmp8 = tmp7 * 8;
    uint64_t tmp9 = 64 * tmp8;

    return tmp9;
}

/* Compute Metrics L3 Cache Gen10 :: L3 Sampler Throughput */
#define cnl__compute_l3_cache__l3_sampler_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics L3 Cache Gen10 :: L3 Shader Throughput */
#define cnl__compute_l3_cache__l3_shader_throughput__read \
    cnl__render_basic__l3_shader_throughput__read

/* Compute Metrics L3 Cache Gen10 :: L3 Shader Throughput */
#define cnl__compute_l3_cache__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics L3 Cache Gen10 :: Slice0 L3 Bank0 Accesses */
static uint64_t
cnl__compute_l3_cache__l3_bank00_accesses__read(const struct intel_perf *perf,
                                                const struct intel_perf_metric_set *metric_set,
                                                uint64_t *accumulator)
{
    /* RPN equation: B 0 READ 2 UMUL */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 0];
    uint64_t tmp1 = tmp0 * 2;

    return tmp1;
}

/* Compute Metrics L3 Cache Gen10 :: Slice0 L3 Bank1 Accesses */
static uint64_t
cnl__compute_l3_cache__l3_bank01_accesses__read(const struct intel_perf *perf,
                                                const struct intel_perf_metric_set *metric_set,
                                                uint64_t *accumulator)
{
    /* RPN equation: B 1 READ 2 UMUL */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 1];
    uint64_t tmp1 = tmp0 * 2;

    return tmp1;
}

/* Compute Metrics L3 Cache Gen10 :: Slice0 L3 Bank2 Accesses */
#define cnl__compute_l3_cache__l3_bank02_accesses__read \
    bdw__compute_l3_cache__l3_bank02_accesses__read

/* Compute Metrics L3 Cache Gen10 :: Slice1 L3 Bank0 Accesses */
#define cnl__compute_l3_cache__l3_bank10_accesses__read \
    bdw__compute_l3_cache__l3_bank03_accesses__read

/* Compute Metrics L3 Cache Gen10 :: Slice1 L3 Bank1 Accesses */
static uint64_t
cnl__compute_l3_cache__l3_bank11_accesses__read(const struct intel_perf *perf,
                                                const struct intel_perf_metric_set *metric_set,
                                                uint64_t *accumulator)
{
    /* RPN equation: B 4 READ 2 UMUL */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 4];
    uint64_t tmp1 = tmp0 * 2;

    return tmp1;
}

/* Compute Metrics L3 Cache Gen10 :: Slice1 L3 Bank2 Accesses */
static uint64_t
cnl__compute_l3_cache__l3_bank12_accesses__read(const struct intel_perf *perf,
                                                const struct intel_perf_metric_set *metric_set,
                                                uint64_t *accumulator)
{
    /* RPN equation: B 5 READ 2 UMUL */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 5];
    uint64_t tmp1 = tmp0 * 2;

    return tmp1;
}

/* Compute Metrics L3 Cache Gen10 :: L3 Accesses */
static uint64_t
cnl__compute_l3_cache__l3_accesses__read(const struct intel_perf *perf,
                                         const struct intel_perf_metric_set *metric_set,
                                         uint64_t *accumulator)
{
    /* RPN equation: $L3Bank00Accesses $L3Bank01Accesses UADD $L3Bank02Accesses UADD $L3Bank10Accesses UADD $L3Bank11Accesses UADD $L3Bank12Accesses UADD */
    uint64_t tmp0 = cnl__compute_l3_cache__l3_bank00_accesses__read(perf, metric_set, accumulator) + cnl__compute_l3_cache__l3_bank01_accesses__read(perf, metric_set, accumulator);
    uint64_t tmp1 = tmp0 + cnl__compute_l3_cache__l3_bank02_accesses__read(perf, metric_set, accumulator);
    uint64_t tmp2 = tmp1 + cnl__compute_l3_cache__l3_bank10_accesses__read(perf, metric_set, accumulator);
    uint64_t tmp3 = tmp2 + cnl__compute_l3_cache__l3_bank11_accesses__read(perf, metric_set, accumulator);
    uint64_t tmp4 = tmp3 + cnl__compute_l3_cache__l3_bank12_accesses__read(perf, metric_set, accumulator);

    return tmp4;
}

/* Compute Metrics L3 Cache Gen10 :: L3 Total Throughput */
static uint64_t
cnl__compute_l3_cache__l3_total_throughput__read(const struct intel_perf *perf,
                                                 const struct intel_perf_metric_set *metric_set,
                                                 uint64_t *accumulator)
{
    /* RPN equation: $L3Accesses 64 UMUL */
    uint64_t tmp0 = cnl__compute_l3_cache__l3_accesses__read(perf, metric_set, accumulator) * 64;

    return tmp0;
}

/* Compute Metrics L3 Cache Gen10 :: L3 Total Throughput */
#define cnl__compute_l3_cache__l3_total_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics L3 Cache Gen10 :: Shader Barrier Messages */
#define cnl__compute_l3_cache__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Compute Metrics L3 Cache Gen10 :: GTI L3 Throughput */
#define cnl__compute_l3_cache__gti_l3_throughput__read \
    bdw__render_basic__gti_rcc_throughput__read

/* Compute Metrics L3 Cache Gen10 :: GTI L3 Throughput */
#define cnl__compute_l3_cache__gti_l3_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Compute Metrics L3 Cache Gen10 :: GTI Read Throughput */
#define cnl__compute_l3_cache__gti_read_throughput__read \
    cnl__render_basic__gti_read_throughput__read

/* Compute Metrics L3 Cache Gen10 :: GTI Read Throughput */
#define cnl__compute_l3_cache__gti_read_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Compute Metrics L3 Cache Gen10 :: GTI Write Throughput */
#define cnl__compute_l3_cache__gti_write_throughput__read \
    cnl__render_basic__gti_write_throughput__read

/* Compute Metrics L3 Cache Gen10 :: GTI Write Throughput */
#define cnl__compute_l3_cache__gti_write_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Metric set HDCAndSF :: GPU Time Elapsed */
#define cnl__hdc_and_sf__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set HDCAndSF :: GPU Core Clocks */
#define cnl__hdc_and_sf__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set HDCAndSF :: AVG GPU Core Frequency */
#define cnl__hdc_and_sf__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set HDCAndSF :: AVG GPU Core Frequency */
#define cnl__hdc_and_sf__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set HDCAndSF :: GPU Busy */
#define cnl__hdc_and_sf__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set HDCAndSF :: VS Threads Dispatched */
#define cnl__hdc_and_sf__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set HDCAndSF :: HS Threads Dispatched */
#define cnl__hdc_and_sf__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set HDCAndSF :: DS Threads Dispatched */
#define cnl__hdc_and_sf__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set HDCAndSF :: GS Threads Dispatched */
#define cnl__hdc_and_sf__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set HDCAndSF :: FS Threads Dispatched */
#define cnl__hdc_and_sf__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set HDCAndSF :: CS Threads Dispatched */
#define cnl__hdc_and_sf__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set HDCAndSF :: EU Active */
#define cnl__hdc_and_sf__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set HDCAndSF :: EU Stall */
#define cnl__hdc_and_sf__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set HDCAndSF :: EU Both FPU Pipes Active */
#define cnl__hdc_and_sf__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set HDCAndSF :: VS FPU0 Pipe Active */
#define cnl__hdc_and_sf__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set HDCAndSF :: VS FPU1 Pipe Active */
#define cnl__hdc_and_sf__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set HDCAndSF :: VS Send Pipe Active */
#define cnl__hdc_and_sf__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set HDCAndSF :: PS FPU0 Pipe Active */
#define cnl__hdc_and_sf__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set HDCAndSF :: PS FPU1 Pipe Active */
#define cnl__hdc_and_sf__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set HDCAndSF :: PS Send Pipeline Active */
#define cnl__hdc_and_sf__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set HDCAndSF :: FS Both FPU Active */
#define cnl__hdc_and_sf__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set HDCAndSF :: Rasterized Pixels */
#define cnl__hdc_and_sf__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set HDCAndSF :: Early Hi-Depth Test Fails */
#define cnl__hdc_and_sf__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set HDCAndSF :: Early Depth Test Fails */
#define cnl__hdc_and_sf__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set HDCAndSF :: Samples Killed in FS */
#define cnl__hdc_and_sf__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set HDCAndSF :: Pixels Failing Tests */
#define cnl__hdc_and_sf__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set HDCAndSF :: Samples Written */
#define cnl__hdc_and_sf__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set HDCAndSF :: Samples Blended */
#define cnl__hdc_and_sf__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set HDCAndSF :: Sampler Texels */
#define cnl__hdc_and_sf__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set HDCAndSF :: Sampler Texels Misses */
#define cnl__hdc_and_sf__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set HDCAndSF :: SLM Bytes Read */
#define cnl__hdc_and_sf__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set HDCAndSF :: SLM Bytes Read */
#define cnl__hdc_and_sf__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set HDCAndSF :: SLM Bytes Written */
#define cnl__hdc_and_sf__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set HDCAndSF :: SLM Bytes Written */
#define cnl__hdc_and_sf__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set HDCAndSF :: Shader Memory Accesses */
#define cnl__hdc_and_sf__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set HDCAndSF :: Shader Atomic Memory Accesses */
#define cnl__hdc_and_sf__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set HDCAndSF :: L3 Shader Throughput */
#define cnl__hdc_and_sf__l3_shader_throughput__read \
    cnl__render_basic__l3_shader_throughput__read

/* Metric set HDCAndSF :: L3 Shader Throughput */
#define cnl__hdc_and_sf__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set HDCAndSF :: Shader Barrier Messages */
#define cnl__hdc_and_sf__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set HDCAndSF :: Polygon Data Ready */
#define cnl__hdc_and_sf__poly_data_ready__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set HDCAndSF :: Slice0 Subslice0 Non-sampler Shader Access Stalled On L3 */
static double
cnl__hdc_and_sf__non_sampler_shader00_access_stalled_on_l3__read(const struct intel_perf *perf,
                                                                 const struct intel_perf_metric_set *metric_set,
                                                                 uint64_t *accumulator)
{
    /* RPN equation: B 2 READ B 3 READ FSUB 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 2];
    uint64_t tmp1 = accumulator[metric_set->b_offset + 3];
    double tmp2 = tmp0 - tmp1;
    uint64_t tmp3 = tmp2 * 100;
    double tmp4 = tmp3;
    double tmp5 = cnl__hdc_and_sf__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp6 = tmp5 ? tmp4 / tmp5 : 0;

    return tmp6;
}

/* Metric set HDCAndSF :: Slice0 Subslice1 Non-sampler Shader Access Stalled On L3 */
static double
cnl__hdc_and_sf__non_sampler_shader01_access_stalled_on_l3__read(const struct intel_perf *perf,
                                                                 const struct intel_perf_metric_set *metric_set,
                                                                 uint64_t *accumulator)
{
    /* RPN equation: B 4 READ B 5 READ FSUB 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 4];
    uint64_t tmp1 = accumulator[metric_set->b_offset + 5];
    double tmp2 = tmp0 - tmp1;
    uint64_t tmp3 = tmp2 * 100;
    double tmp4 = tmp3;
    double tmp5 = cnl__hdc_and_sf__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp6 = tmp5 ? tmp4 / tmp5 : 0;

    return tmp6;
}

/* Metric set HDCAndSF :: Slice0 Subslice2 Non-sampler Shader Access Stalled On L3 */
static double
cnl__hdc_and_sf__non_sampler_shader02_access_stalled_on_l3__read(const struct intel_perf *perf,
                                                                 const struct intel_perf_metric_set *metric_set,
                                                                 uint64_t *accumulator)
{
    /* RPN equation: B 6 READ B 7 READ FSUB 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 6];
    uint64_t tmp1 = accumulator[metric_set->b_offset + 7];
    double tmp2 = tmp0 - tmp1;
    uint64_t tmp3 = tmp2 * 100;
    double tmp4 = tmp3;
    double tmp5 = cnl__hdc_and_sf__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp6 = tmp5 ? tmp4 / tmp5 : 0;

    return tmp6;
}

/* Metric set HDCAndSF :: Slice1 Subslice0 Non-sampler Shader Access Stalled On L3 */
static double
cnl__hdc_and_sf__non_sampler_shader10_access_stalled_on_l3__read(const struct intel_perf *perf,
                                                                 const struct intel_perf_metric_set *metric_set,
                                                                 uint64_t *accumulator)
{
    /* RPN equation: C 0 READ C 1 READ FSUB 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 0];
    uint64_t tmp1 = accumulator[metric_set->c_offset + 1];
    double tmp2 = tmp0 - tmp1;
    uint64_t tmp3 = tmp2 * 100;
    double tmp4 = tmp3;
    double tmp5 = cnl__hdc_and_sf__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp6 = tmp5 ? tmp4 / tmp5 : 0;

    return tmp6;
}

/* Metric set HDCAndSF :: Slice1 Subslice1 Non-sampler Shader Access Stalled On L3 */
static double
cnl__hdc_and_sf__non_sampler_shader11_access_stalled_on_l3__read(const struct intel_perf *perf,
                                                                 const struct intel_perf_metric_set *metric_set,
                                                                 uint64_t *accumulator)
{
    /* RPN equation: C 2 READ C 3 READ FSUB 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 2];
    uint64_t tmp1 = accumulator[metric_set->c_offset + 3];
    double tmp2 = tmp0 - tmp1;
    uint64_t tmp3 = tmp2 * 100;
    double tmp4 = tmp3;
    double tmp5 = cnl__hdc_and_sf__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp6 = tmp5 ? tmp4 / tmp5 : 0;

    return tmp6;
}

/* Metric set HDCAndSF :: SQ is full */
#define cnl__hdc_and_sf__gt_request_queue_full__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set L3_1 :: GPU Time Elapsed */
#define cnl__l3_1__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set L3_1 :: GPU Core Clocks */
#define cnl__l3_1__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set L3_1 :: AVG GPU Core Frequency */
#define cnl__l3_1__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set L3_1 :: AVG GPU Core Frequency */
#define cnl__l3_1__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set L3_1 :: GPU Busy */
#define cnl__l3_1__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set L3_1 :: VS Threads Dispatched */
#define cnl__l3_1__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set L3_1 :: HS Threads Dispatched */
#define cnl__l3_1__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set L3_1 :: DS Threads Dispatched */
#define cnl__l3_1__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set L3_1 :: GS Threads Dispatched */
#define cnl__l3_1__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set L3_1 :: FS Threads Dispatched */
#define cnl__l3_1__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set L3_1 :: CS Threads Dispatched */
#define cnl__l3_1__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set L3_1 :: EU Active */
#define cnl__l3_1__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set L3_1 :: EU Stall */
#define cnl__l3_1__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set L3_1 :: EU Both FPU Pipes Active */
#define cnl__l3_1__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set L3_1 :: VS FPU0 Pipe Active */
#define cnl__l3_1__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set L3_1 :: VS FPU1 Pipe Active */
#define cnl__l3_1__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set L3_1 :: VS Send Pipe Active */
#define cnl__l3_1__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set L3_1 :: PS FPU0 Pipe Active */
#define cnl__l3_1__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set L3_1 :: PS FPU1 Pipe Active */
#define cnl__l3_1__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set L3_1 :: PS Send Pipeline Active */
#define cnl__l3_1__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set L3_1 :: FS Both FPU Active */
#define cnl__l3_1__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set L3_1 :: Rasterized Pixels */
#define cnl__l3_1__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set L3_1 :: Early Hi-Depth Test Fails */
#define cnl__l3_1__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set L3_1 :: Early Depth Test Fails */
#define cnl__l3_1__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set L3_1 :: Samples Killed in FS */
#define cnl__l3_1__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set L3_1 :: Pixels Failing Tests */
#define cnl__l3_1__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set L3_1 :: Samples Written */
#define cnl__l3_1__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set L3_1 :: Samples Blended */
#define cnl__l3_1__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set L3_1 :: Sampler Texels */
#define cnl__l3_1__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set L3_1 :: Sampler Texels Misses */
#define cnl__l3_1__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set L3_1 :: SLM Bytes Read */
#define cnl__l3_1__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set L3_1 :: SLM Bytes Read */
#define cnl__l3_1__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_1 :: SLM Bytes Written */
#define cnl__l3_1__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set L3_1 :: SLM Bytes Written */
#define cnl__l3_1__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_1 :: Shader Memory Accesses */
#define cnl__l3_1__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set L3_1 :: Shader Atomic Memory Accesses */
#define cnl__l3_1__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set L3_1 :: L3 Shader Throughput */
#define cnl__l3_1__l3_shader_throughput__read \
    cnl__render_basic__l3_shader_throughput__read

/* Metric set L3_1 :: L3 Shader Throughput */
#define cnl__l3_1__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_1 :: Shader Barrier Messages */
#define cnl__l3_1__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set L3_1 :: Slice0 L3 Bank0 Stalled */
#define cnl__l3_1__l30_bank0_stalled__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set L3_1 :: Slice0 L3 Bank1 Stalled */
#define cnl__l3_1__l30_bank1_stalled__read \
    bdw__render_basic__sampler1_busy__read

/* Metric set L3_1 :: Slice0 L3 Bank0 Active */
#define cnl__l3_1__l30_bank0_active__read \
    bdw__render_pipe_profile__so_stall__read

/* Metric set L3_1 :: Slice0 L3 Bank1 Active */
#define cnl__l3_1__l30_bank1_active__read \
    bdw__render_pipe_profile__cl_stall__read

/* Metric set L3_1 :: Slice0 L3 Bank2 Active */
#define cnl__l3_1__l30_bank2_active__read \
    bdw__render_pipe_profile__sf_stall__read

/* Metric set L3_1 :: Slice1 L3 Bank2 Stalled */
#define cnl__l3_1__l31_bank2_stalled__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Metric set L3_1 :: SQ is full */
#define cnl__l3_1__gt_request_queue_full__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set L3_2 :: GPU Time Elapsed */
#define cnl__l3_2__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set L3_2 :: GPU Core Clocks */
#define cnl__l3_2__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set L3_2 :: AVG GPU Core Frequency */
#define cnl__l3_2__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set L3_2 :: AVG GPU Core Frequency */
#define cnl__l3_2__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set L3_2 :: GPU Busy */
#define cnl__l3_2__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set L3_2 :: VS Threads Dispatched */
#define cnl__l3_2__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set L3_2 :: HS Threads Dispatched */
#define cnl__l3_2__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set L3_2 :: DS Threads Dispatched */
#define cnl__l3_2__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set L3_2 :: GS Threads Dispatched */
#define cnl__l3_2__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set L3_2 :: FS Threads Dispatched */
#define cnl__l3_2__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set L3_2 :: CS Threads Dispatched */
#define cnl__l3_2__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set L3_2 :: EU Active */
#define cnl__l3_2__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set L3_2 :: EU Stall */
#define cnl__l3_2__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set L3_2 :: EU Both FPU Pipes Active */
#define cnl__l3_2__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set L3_2 :: VS FPU0 Pipe Active */
#define cnl__l3_2__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set L3_2 :: VS FPU1 Pipe Active */
#define cnl__l3_2__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set L3_2 :: VS Send Pipe Active */
#define cnl__l3_2__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set L3_2 :: PS FPU0 Pipe Active */
#define cnl__l3_2__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set L3_2 :: PS FPU1 Pipe Active */
#define cnl__l3_2__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set L3_2 :: PS Send Pipeline Active */
#define cnl__l3_2__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set L3_2 :: FS Both FPU Active */
#define cnl__l3_2__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set L3_2 :: Rasterized Pixels */
#define cnl__l3_2__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set L3_2 :: Early Hi-Depth Test Fails */
#define cnl__l3_2__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set L3_2 :: Early Depth Test Fails */
#define cnl__l3_2__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set L3_2 :: Samples Killed in FS */
#define cnl__l3_2__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set L3_2 :: Pixels Failing Tests */
#define cnl__l3_2__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set L3_2 :: Samples Written */
#define cnl__l3_2__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set L3_2 :: Samples Blended */
#define cnl__l3_2__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set L3_2 :: Sampler Texels */
#define cnl__l3_2__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set L3_2 :: Sampler Texels Misses */
#define cnl__l3_2__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set L3_2 :: SLM Bytes Read */
#define cnl__l3_2__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set L3_2 :: SLM Bytes Read */
#define cnl__l3_2__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_2 :: SLM Bytes Written */
#define cnl__l3_2__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set L3_2 :: SLM Bytes Written */
#define cnl__l3_2__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_2 :: Shader Memory Accesses */
#define cnl__l3_2__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set L3_2 :: Shader Atomic Memory Accesses */
#define cnl__l3_2__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set L3_2 :: L3 Shader Throughput */
#define cnl__l3_2__l3_shader_throughput__read \
    cnl__render_basic__l3_shader_throughput__read

/* Metric set L3_2 :: L3 Shader Throughput */
#define cnl__l3_2__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_2 :: Shader Barrier Messages */
#define cnl__l3_2__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set L3_2 :: Slice1 L3 Bank0 Stalled */
#define cnl__l3_2__l31_bank0_stalled__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set L3_2 :: Slice1 L3 Bank1 Stalled */
#define cnl__l3_2__l31_bank1_stalled__read \
    bdw__render_basic__sampler1_busy__read

/* Metric set L3_2 :: Slice1 L3 Bank0 Active */
#define cnl__l3_2__l31_bank0_active__read \
    bdw__render_pipe_profile__so_stall__read

/* Metric set L3_2 :: Slice1 L3 Bank1 Active */
#define cnl__l3_2__l31_bank1_active__read \
    bdw__render_pipe_profile__cl_stall__read

/* Metric set L3_2 :: Slice1 L3 Bank2 Active */
#define cnl__l3_2__l31_bank2_active__read \
    bdw__render_pipe_profile__sf_stall__read

/* Metric set L3_2 :: Slice0 L3 Bank2 Stalled */
#define cnl__l3_2__l30_bank2_stalled__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Metric set L3_2 :: SQ is full */
#define cnl__l3_2__gt_request_queue_full__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set RasterizerAndPixelBackend :: GPU Time Elapsed */
#define cnl__rasterizer_and_pixel_backend__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set RasterizerAndPixelBackend :: GPU Core Clocks */
#define cnl__rasterizer_and_pixel_backend__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set RasterizerAndPixelBackend :: AVG GPU Core Frequency */
#define cnl__rasterizer_and_pixel_backend__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set RasterizerAndPixelBackend :: AVG GPU Core Frequency */
#define cnl__rasterizer_and_pixel_backend__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set RasterizerAndPixelBackend :: GPU Busy */
#define cnl__rasterizer_and_pixel_backend__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set RasterizerAndPixelBackend :: VS Threads Dispatched */
#define cnl__rasterizer_and_pixel_backend__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set RasterizerAndPixelBackend :: HS Threads Dispatched */
#define cnl__rasterizer_and_pixel_backend__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set RasterizerAndPixelBackend :: DS Threads Dispatched */
#define cnl__rasterizer_and_pixel_backend__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set RasterizerAndPixelBackend :: GS Threads Dispatched */
#define cnl__rasterizer_and_pixel_backend__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set RasterizerAndPixelBackend :: FS Threads Dispatched */
#define cnl__rasterizer_and_pixel_backend__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set RasterizerAndPixelBackend :: CS Threads Dispatched */
#define cnl__rasterizer_and_pixel_backend__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set RasterizerAndPixelBackend :: EU Active */
#define cnl__rasterizer_and_pixel_backend__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set RasterizerAndPixelBackend :: EU Stall */
#define cnl__rasterizer_and_pixel_backend__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set RasterizerAndPixelBackend :: EU Both FPU Pipes Active */
#define cnl__rasterizer_and_pixel_backend__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set RasterizerAndPixelBackend :: VS FPU0 Pipe Active */
#define cnl__rasterizer_and_pixel_backend__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set RasterizerAndPixelBackend :: VS FPU1 Pipe Active */
#define cnl__rasterizer_and_pixel_backend__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set RasterizerAndPixelBackend :: VS Send Pipe Active */
#define cnl__rasterizer_and_pixel_backend__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set RasterizerAndPixelBackend :: PS FPU0 Pipe Active */
#define cnl__rasterizer_and_pixel_backend__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set RasterizerAndPixelBackend :: PS FPU1 Pipe Active */
#define cnl__rasterizer_and_pixel_backend__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set RasterizerAndPixelBackend :: PS Send Pipeline Active */
#define cnl__rasterizer_and_pixel_backend__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set RasterizerAndPixelBackend :: FS Both FPU Active */
#define cnl__rasterizer_and_pixel_backend__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set RasterizerAndPixelBackend :: Rasterized Pixels */
#define cnl__rasterizer_and_pixel_backend__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set RasterizerAndPixelBackend :: Early Hi-Depth Test Fails */
#define cnl__rasterizer_and_pixel_backend__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set RasterizerAndPixelBackend :: Early Depth Test Fails */
#define cnl__rasterizer_and_pixel_backend__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set RasterizerAndPixelBackend :: Samples Killed in FS */
#define cnl__rasterizer_and_pixel_backend__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set RasterizerAndPixelBackend :: Pixels Failing Tests */
#define cnl__rasterizer_and_pixel_backend__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set RasterizerAndPixelBackend :: Samples Written */
#define cnl__rasterizer_and_pixel_backend__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set RasterizerAndPixelBackend :: Samples Blended */
#define cnl__rasterizer_and_pixel_backend__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set RasterizerAndPixelBackend :: Sampler Texels */
#define cnl__rasterizer_and_pixel_backend__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set RasterizerAndPixelBackend :: Sampler Texels Misses */
#define cnl__rasterizer_and_pixel_backend__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Read */
#define cnl__rasterizer_and_pixel_backend__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Read */
#define cnl__rasterizer_and_pixel_backend__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Written */
#define cnl__rasterizer_and_pixel_backend__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Written */
#define cnl__rasterizer_and_pixel_backend__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set RasterizerAndPixelBackend :: Shader Memory Accesses */
#define cnl__rasterizer_and_pixel_backend__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set RasterizerAndPixelBackend :: Shader Atomic Memory Accesses */
#define cnl__rasterizer_and_pixel_backend__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set RasterizerAndPixelBackend :: L3 Shader Throughput */
#define cnl__rasterizer_and_pixel_backend__l3_shader_throughput__read \
    cnl__render_basic__l3_shader_throughput__read

/* Metric set RasterizerAndPixelBackend :: L3 Shader Throughput */
#define cnl__rasterizer_and_pixel_backend__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set RasterizerAndPixelBackend :: Shader Barrier Messages */
#define cnl__rasterizer_and_pixel_backend__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Rasterizer Input Available */
#define cnl__rasterizer_and_pixel_backend__rasterizer0_input_available__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set RasterizerAndPixelBackend :: Slice1 Rasterizer Input Available */
#define cnl__rasterizer_and_pixel_backend__rasterizer1_input_available__read \
    bdw__render_basic__sampler1_busy__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Rasterizer Output Ready */
#define cnl__rasterizer_and_pixel_backend__rasterizer0_output_ready__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Metric set RasterizerAndPixelBackend :: Slice1 Rasterizer Output Ready */
#define cnl__rasterizer_and_pixel_backend__rasterizer1_output_ready__read \
    bdw__render_basic__sampler1_bottleneck__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Post-EarlyZ Pixel Data Ready */
#define cnl__rasterizer_and_pixel_backend__pixel_data0_ready__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* Metric set RasterizerAndPixelBackend :: Slice1 Post-EarlyZ Pixel Data Ready */
#define cnl__rasterizer_and_pixel_backend__pixel_data1_ready__read \
    bdw__render_pipe_profile__cl_bottleneck__read

/* Metric set RasterizerAndPixelBackend :: Slice0 PS Output Available */
#define cnl__rasterizer_and_pixel_backend__ps_output0_available__read \
    bdw__render_pipe_profile__sf_bottleneck__read

/* Metric set RasterizerAndPixelBackend :: Slice1 PS Output Available */
#define cnl__rasterizer_and_pixel_backend__ps_output1_available__read \
    bdw__render_pipe_profile__early_depth_bottleneck__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Pixel Values Ready */
#define cnl__rasterizer_and_pixel_backend__pixel_values0_ready__read \
    bdw__render_pipe_profile__vf_bottleneck__read

/* Metric set RasterizerAndPixelBackend :: Slice1 Pixel Values Ready */
#define cnl__rasterizer_and_pixel_backend__pixel_values1_ready__read \
    bdw__render_pipe_profile__hs_stall__read

/* Metric set RasterizerAndPixelBackend :: SQ is full */
#define cnl__rasterizer_and_pixel_backend__gt_request_queue_full__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set Sampler :: GPU Time Elapsed */
#define cnl__sampler__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set Sampler :: GPU Core Clocks */
#define cnl__sampler__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set Sampler :: AVG GPU Core Frequency */
#define cnl__sampler__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set Sampler :: AVG GPU Core Frequency */
#define cnl__sampler__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set Sampler :: GPU Busy */
#define cnl__sampler__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set Sampler :: VS Threads Dispatched */
#define cnl__sampler__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set Sampler :: HS Threads Dispatched */
#define cnl__sampler__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set Sampler :: DS Threads Dispatched */
#define cnl__sampler__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set Sampler :: GS Threads Dispatched */
#define cnl__sampler__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set Sampler :: FS Threads Dispatched */
#define cnl__sampler__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set Sampler :: CS Threads Dispatched */
#define cnl__sampler__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set Sampler :: EU Active */
#define cnl__sampler__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set Sampler :: EU Stall */
#define cnl__sampler__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set Sampler :: EU Both FPU Pipes Active */
#define cnl__sampler__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set Sampler :: VS FPU0 Pipe Active */
#define cnl__sampler__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set Sampler :: VS FPU1 Pipe Active */
#define cnl__sampler__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set Sampler :: VS Send Pipe Active */
#define cnl__sampler__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set Sampler :: PS FPU0 Pipe Active */
#define cnl__sampler__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set Sampler :: PS FPU1 Pipe Active */
#define cnl__sampler__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set Sampler :: PS Send Pipeline Active */
#define cnl__sampler__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set Sampler :: FS Both FPU Active */
#define cnl__sampler__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set Sampler :: Rasterized Pixels */
#define cnl__sampler__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set Sampler :: Early Hi-Depth Test Fails */
#define cnl__sampler__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set Sampler :: Early Depth Test Fails */
#define cnl__sampler__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set Sampler :: Samples Killed in FS */
#define cnl__sampler__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set Sampler :: Pixels Failing Tests */
#define cnl__sampler__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set Sampler :: Samples Written */
#define cnl__sampler__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set Sampler :: Samples Blended */
#define cnl__sampler__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set Sampler :: Sampler Texels */
#define cnl__sampler__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set Sampler :: Sampler Texels Misses */
#define cnl__sampler__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set Sampler :: SLM Bytes Read */
#define cnl__sampler__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set Sampler :: SLM Bytes Read */
#define cnl__sampler__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set Sampler :: SLM Bytes Written */
#define cnl__sampler__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set Sampler :: SLM Bytes Written */
#define cnl__sampler__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set Sampler :: Shader Memory Accesses */
#define cnl__sampler__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set Sampler :: Shader Atomic Memory Accesses */
#define cnl__sampler__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set Sampler :: L3 Shader Throughput */
#define cnl__sampler__l3_shader_throughput__read \
    cnl__render_basic__l3_shader_throughput__read

/* Metric set Sampler :: L3 Shader Throughput */
#define cnl__sampler__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set Sampler :: Shader Barrier Messages */
#define cnl__sampler__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set Sampler :: Slice0 Subslice0 Input Available */
#define cnl__sampler__sampler00_input_available__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set Sampler :: Slice0 Subslice1 Input Available */
#define cnl__sampler__sampler01_input_available__read \
    bdw__render_basic__sampler1_busy__read

/* Metric set Sampler :: Slice0 Subslice2 Input Available */
#define cnl__sampler__sampler02_input_available__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Metric set Sampler :: Slice1 Subslice0 Input Available */
#define cnl__sampler__sampler10_input_available__read \
    bdw__render_basic__sampler1_bottleneck__read

/* Metric set Sampler :: Slice1 Subslice1 Input Available */
#define cnl__sampler__sampler11_input_available__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* Metric set Sampler :: Slice0 Subslice0 Sampler Output Ready */
#define cnl__sampler__sampler00_output_ready__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set Sampler :: Slice0 Subslice1 Sampler Output Ready */
#define cnl__sampler__sampler01_output_ready__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set Sampler :: Slice0 Subslice2 Sampler Output Ready */
#define cnl__sampler__sampler02_output_ready__read \
    bdw__render_pipe_profile__sf_stall__read

/* Metric set Sampler :: Slice1 Subslice0 Sampler Output Ready */
#define cnl__sampler__sampler10_output_ready__read \
    bdw__render_pipe_profile__cl_stall__read

/* Metric set Sampler :: Slice1 Subslice1 Sampler Output Ready */
#define cnl__sampler__sampler11_output_ready__read \
    bdw__render_pipe_profile__so_stall__read

/* Metric set Sampler :: SQ is full */
#define cnl__sampler__gt_request_queue_full__read \
    bdw__render_pipe_profile__ds_stall__read

/* Metric set TDL_1 :: GPU Time Elapsed */
#define cnl__tdl_1__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set TDL_1 :: GPU Core Clocks */
#define cnl__tdl_1__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set TDL_1 :: AVG GPU Core Frequency */
#define cnl__tdl_1__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set TDL_1 :: AVG GPU Core Frequency */
#define cnl__tdl_1__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set TDL_1 :: GPU Busy */
#define cnl__tdl_1__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set TDL_1 :: VS Threads Dispatched */
#define cnl__tdl_1__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set TDL_1 :: HS Threads Dispatched */
#define cnl__tdl_1__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set TDL_1 :: DS Threads Dispatched */
#define cnl__tdl_1__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set TDL_1 :: GS Threads Dispatched */
#define cnl__tdl_1__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set TDL_1 :: FS Threads Dispatched */
#define cnl__tdl_1__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set TDL_1 :: CS Threads Dispatched */
#define cnl__tdl_1__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set TDL_1 :: EU Active */
#define cnl__tdl_1__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set TDL_1 :: EU Stall */
#define cnl__tdl_1__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set TDL_1 :: EU Both FPU Pipes Active */
#define cnl__tdl_1__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set TDL_1 :: VS FPU0 Pipe Active */
#define cnl__tdl_1__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set TDL_1 :: VS FPU1 Pipe Active */
#define cnl__tdl_1__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set TDL_1 :: VS Send Pipe Active */
#define cnl__tdl_1__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set TDL_1 :: PS FPU0 Pipe Active */
#define cnl__tdl_1__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set TDL_1 :: PS FPU1 Pipe Active */
#define cnl__tdl_1__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set TDL_1 :: PS Send Pipeline Active */
#define cnl__tdl_1__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set TDL_1 :: FS Both FPU Active */
#define cnl__tdl_1__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set TDL_1 :: Rasterized Pixels */
#define cnl__tdl_1__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set TDL_1 :: Early Hi-Depth Test Fails */
#define cnl__tdl_1__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set TDL_1 :: Early Depth Test Fails */
#define cnl__tdl_1__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set TDL_1 :: Samples Killed in FS */
#define cnl__tdl_1__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set TDL_1 :: Pixels Failing Tests */
#define cnl__tdl_1__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set TDL_1 :: Samples Written */
#define cnl__tdl_1__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set TDL_1 :: Samples Blended */
#define cnl__tdl_1__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set TDL_1 :: Sampler Texels */
#define cnl__tdl_1__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set TDL_1 :: Sampler Texels Misses */
#define cnl__tdl_1__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set TDL_1 :: SLM Bytes Read */
#define cnl__tdl_1__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set TDL_1 :: SLM Bytes Read */
#define cnl__tdl_1__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_1 :: SLM Bytes Written */
#define cnl__tdl_1__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set TDL_1 :: SLM Bytes Written */
#define cnl__tdl_1__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_1 :: Shader Memory Accesses */
#define cnl__tdl_1__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set TDL_1 :: Shader Atomic Memory Accesses */
#define cnl__tdl_1__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set TDL_1 :: L3 Shader Throughput */
#define cnl__tdl_1__l3_shader_throughput__read \
    cnl__render_basic__l3_shader_throughput__read

/* Metric set TDL_1 :: L3 Shader Throughput */
#define cnl__tdl_1__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_1 :: Shader Barrier Messages */
#define cnl__tdl_1__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set TDL_1 :: PS Thread Ready For Dispatch on Slice0 Subslice0 */
#define cnl__tdl_1__ps_thread00_ready_for_dispatch__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set TDL_1 :: PS Thread Ready For Dispatch on Slice0 Subslice1 */
#define cnl__tdl_1__ps_thread01_ready_for_dispatch__read \
    bdw__render_basic__sampler1_busy__read

/* Metric set TDL_1 :: PS Thread Ready For Dispatch on Slice0 Subslice2 */
#define cnl__tdl_1__ps_thread02_ready_for_dispatch__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Metric set TDL_1 :: PS Thread Ready For Dispatch on Slice1 Subslice0 */
#define cnl__tdl_1__ps_thread10_ready_for_dispatch__read \
    bdw__render_basic__sampler1_bottleneck__read

/* Metric set TDL_1 :: PS Thread Ready For Dispatch on Slice1 Subslice1 */
#define cnl__tdl_1__ps_thread11_ready_for_dispatch__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* Metric set TDL_1 :: NonPS Thread Ready For Dispatch on Slice0 Subslice0 */
static double
cnl__tdl_1__non_ps_thread00_ready_for_dispatch__read(const struct intel_perf *perf,
                                                     const struct intel_perf_metric_set *metric_set,
                                                     uint64_t *accumulator)
{
    /* RPN equation: 1  C 2 READ $GpuCoreClocks FDIV FSUB */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 2];
    double tmp1 = tmp0;
    double tmp2 = cnl__tdl_1__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    double tmp4 = 1 - tmp3;

    return tmp4;
}

/* Metric set TDL_1 :: NonPS Thread Ready For Dispatch on Slice0 Subslice1 */
static double
cnl__tdl_1__non_ps_thread01_ready_for_dispatch__read(const struct intel_perf *perf,
                                                     const struct intel_perf_metric_set *metric_set,
                                                     uint64_t *accumulator)
{
    /* RPN equation: 1  C 3 READ $GpuCoreClocks FDIV FSUB */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 3];
    double tmp1 = tmp0;
    double tmp2 = cnl__tdl_1__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    double tmp4 = 1 - tmp3;

    return tmp4;
}

/* Metric set TDL_1 :: NonPS Thread Ready For Dispatch on Slice0 Subslice2 */
static double
cnl__tdl_1__non_ps_thread02_ready_for_dispatch__read(const struct intel_perf *perf,
                                                     const struct intel_perf_metric_set *metric_set,
                                                     uint64_t *accumulator)
{
    /* RPN equation: 1  C 4 READ $GpuCoreClocks FDIV FSUB */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 4];
    double tmp1 = tmp0;
    double tmp2 = cnl__tdl_1__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    double tmp4 = 1 - tmp3;

    return tmp4;
}

/* Metric set TDL_1 :: NonPS Thread Ready For Dispatch on Slice1 Subslice0 */
static double
cnl__tdl_1__non_ps_thread10_ready_for_dispatch__read(const struct intel_perf *perf,
                                                     const struct intel_perf_metric_set *metric_set,
                                                     uint64_t *accumulator)
{
    /* RPN equation: 1  C 5 READ $GpuCoreClocks FDIV FSUB */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 5];
    double tmp1 = tmp0;
    double tmp2 = cnl__tdl_1__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    double tmp4 = 1 - tmp3;

    return tmp4;
}

/* Metric set TDL_1 :: NonPS Thread Ready For Dispatch on Slice1 Subslice1 */
static double
cnl__tdl_1__non_ps_thread11_ready_for_dispatch__read(const struct intel_perf *perf,
                                                     const struct intel_perf_metric_set *metric_set,
                                                     uint64_t *accumulator)
{
    /* RPN equation: 1  C 6 READ $GpuCoreClocks FDIV FSUB */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 6];
    double tmp1 = tmp0;
    double tmp2 = cnl__tdl_1__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp3 = tmp2 ? tmp1 / tmp2 : 0;
    double tmp4 = 1 - tmp3;

    return tmp4;
}

/* Metric set TDL_1 :: SQ is full */
#define cnl__tdl_1__gt_request_queue_full__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set TDL_2 :: GPU Time Elapsed */
#define cnl__tdl_2__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set TDL_2 :: GPU Core Clocks */
#define cnl__tdl_2__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set TDL_2 :: AVG GPU Core Frequency */
#define cnl__tdl_2__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set TDL_2 :: AVG GPU Core Frequency */
#define cnl__tdl_2__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set TDL_2 :: GPU Busy */
#define cnl__tdl_2__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set TDL_2 :: VS Threads Dispatched */
#define cnl__tdl_2__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set TDL_2 :: HS Threads Dispatched */
#define cnl__tdl_2__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set TDL_2 :: DS Threads Dispatched */
#define cnl__tdl_2__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set TDL_2 :: GS Threads Dispatched */
#define cnl__tdl_2__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set TDL_2 :: FS Threads Dispatched */
#define cnl__tdl_2__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set TDL_2 :: CS Threads Dispatched */
#define cnl__tdl_2__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set TDL_2 :: EU Active */
#define cnl__tdl_2__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set TDL_2 :: EU Stall */
#define cnl__tdl_2__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set TDL_2 :: EU Both FPU Pipes Active */
#define cnl__tdl_2__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set TDL_2 :: VS FPU0 Pipe Active */
#define cnl__tdl_2__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set TDL_2 :: VS FPU1 Pipe Active */
#define cnl__tdl_2__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set TDL_2 :: VS Send Pipe Active */
#define cnl__tdl_2__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set TDL_2 :: PS FPU0 Pipe Active */
#define cnl__tdl_2__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set TDL_2 :: PS FPU1 Pipe Active */
#define cnl__tdl_2__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set TDL_2 :: PS Send Pipeline Active */
#define cnl__tdl_2__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set TDL_2 :: FS Both FPU Active */
#define cnl__tdl_2__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set TDL_2 :: Rasterized Pixels */
#define cnl__tdl_2__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set TDL_2 :: Early Hi-Depth Test Fails */
#define cnl__tdl_2__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set TDL_2 :: Early Depth Test Fails */
#define cnl__tdl_2__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set TDL_2 :: Samples Killed in FS */
#define cnl__tdl_2__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set TDL_2 :: Pixels Failing Tests */
#define cnl__tdl_2__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set TDL_2 :: Samples Written */
#define cnl__tdl_2__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set TDL_2 :: Samples Blended */
#define cnl__tdl_2__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set TDL_2 :: Sampler Texels */
#define cnl__tdl_2__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set TDL_2 :: Sampler Texels Misses */
#define cnl__tdl_2__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set TDL_2 :: SLM Bytes Read */
#define cnl__tdl_2__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set TDL_2 :: SLM Bytes Read */
#define cnl__tdl_2__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_2 :: SLM Bytes Written */
#define cnl__tdl_2__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set TDL_2 :: SLM Bytes Written */
#define cnl__tdl_2__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_2 :: Shader Memory Accesses */
#define cnl__tdl_2__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set TDL_2 :: Shader Atomic Memory Accesses */
#define cnl__tdl_2__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set TDL_2 :: L3 Shader Throughput */
#define cnl__tdl_2__l3_shader_throughput__read \
    cnl__render_basic__l3_shader_throughput__read

/* Metric set TDL_2 :: L3 Shader Throughput */
#define cnl__tdl_2__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_2 :: Shader Barrier Messages */
#define cnl__tdl_2__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice1 Port 0 */
#define cnl__tdl_2__thread_header01_ready_port0__read \
    bdw__render_pipe_profile__vf_bottleneck__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice0 Port 1 */
#define cnl__tdl_2__thread_header00_ready_port1__read \
    bdw__render_pipe_profile__early_depth_bottleneck__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice0 Port 0 */
#define cnl__tdl_2__thread_header00_ready_port0__read \
    bdw__render_pipe_profile__sf_bottleneck__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice2 Port 1 */
#define cnl__tdl_2__thread_header02_ready_port1__read \
    bdw__render_pipe_profile__so_stall__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice2 Port 0 */
#define cnl__tdl_2__thread_header02_ready_port0__read \
    bdw__render_pipe_profile__ds_stall__read

/* Metric set TDL_2 :: Thread Header Ready on Slice0 Subslice1 Port 1 */
#define cnl__tdl_2__thread_header01_ready_port1__read \
    bdw__render_pipe_profile__hs_stall__read

/* Metric set TDL_2 :: Thread Header Ready on Slice1 Subslice0 Port 0 */
#define cnl__tdl_2__thread_header10_ready_port0__read \
    bdw__render_pipe_profile__cl_stall__read

/* Metric set TDL_2 :: Thread Header Ready on Slice1 Subslice0 Port 1 */
#define cnl__tdl_2__thread_header10_ready_port1__read \
    bdw__render_pipe_profile__sf_stall__read

/* Metric set TDL_2 :: Thread Header Ready on Slice1 Subslice1 Port 0 */
#define cnl__tdl_2__thread_header11_ready_port0__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set TDL_2 :: Thread Header Ready on Slice1 Subslice1 Port 1 */
#define cnl__tdl_2__thread_header11_ready_port1__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set TDL_2 :: SQ is full */
#define cnl__tdl_2__gt_request_queue_full__read \
    bdw__render_pipe_profile__cl_bottleneck__read

/* Metric set TestOa :: GPU Time Elapsed */
#define cnl__test_oa__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set TestOa :: GPU Core Clocks */
#define cnl__test_oa__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set TestOa :: AVG GPU Core Frequency */
#define cnl__test_oa__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set TestOa :: AVG GPU Core Frequency */
#define cnl__test_oa__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set TestOa :: TestCounter0 */
#define cnl__test_oa__counter0__read \
    hsw__compute_extended__eu_untyped_reads0__read

/* Metric set TestOa :: TestCounter1 */
#define cnl__test_oa__counter1__read \
    hsw__compute_extended__eu_untyped_writes0__read

/* Metric set TestOa :: TestCounter2 */
#define cnl__test_oa__counter2__read \
    hsw__compute_extended__eu_typed_reads0__read

/* Metric set TestOa :: TestCounter3 */
#define cnl__test_oa__counter3__read \
    hsw__compute_extended__eu_typed_writes0__read

/* Metric set TestOa :: TestCounter4 */
#define cnl__test_oa__counter4__read \
    hsw__compute_extended__eu_untyped_atomics0__read

/* Metric set TestOa :: TestCounter5 */
#define cnl__test_oa__counter5__read \
    hsw__compute_extended__eu_typed_atomics0__read

/* Metric set TestOa :: TestCounter6 */
#define cnl__test_oa__counter6__read \
    hsw__compute_extended__eu_urb_atomics0__read

/* Metric set TestOa :: TestCounter7 */
#define cnl__test_oa__counter7__read \
    hsw__compute_extended__gpu_clocks__read

/* Metric set TestOa :: TestCounter8 */
#define cnl__test_oa__counter8__read \
    hsw__memory_reads__gpu_core_clocks__read

/* Render Metrics Basic Gen11 :: GPU Time Elapsed */
#define icl__render_basic__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Render Metrics Basic Gen11 :: GPU Core Clocks */
#define icl__render_basic__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Render Metrics Basic Gen11 :: AVG GPU Core Frequency */
#define icl__render_basic__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Render Metrics Basic Gen11 :: AVG GPU Core Frequency */
#define icl__render_basic__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Render Metrics Basic Gen11 :: VS Threads Dispatched */
#define icl__render_basic__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Render Metrics Basic Gen11 :: HS Threads Dispatched */
#define icl__render_basic__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Render Metrics Basic Gen11 :: DS Threads Dispatched */
#define icl__render_basic__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Render Metrics Basic Gen11 :: GS Threads Dispatched */
#define icl__render_basic__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Render Metrics Basic Gen11 :: FS Threads Dispatched */
#define icl__render_basic__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Render Metrics Basic Gen11 :: CS Threads Dispatched */
#define icl__render_basic__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Render Metrics Basic Gen11 :: GPU Busy */
#define icl__render_basic__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Render Metrics Basic Gen11 :: EU Active */
#define icl__render_basic__eu_active__read \
    bdw__render_basic__eu_active__read

/* Render Metrics Basic Gen11 :: EU Stall */
#define icl__render_basic__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Render Metrics Basic Gen11 :: EU Both FPU Pipes Active */
#define icl__render_basic__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Render Metrics Basic Gen11 :: VS FPU0 Pipe Active */
#define icl__render_basic__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Render Metrics Basic Gen11 :: VS FPU1 Pipe Active */
#define icl__render_basic__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Render Metrics Basic Gen11 :: VS Send Pipe Active */
#define icl__render_basic__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Render Metrics Basic Gen11 :: PS FPU0 Pipe Active */
#define icl__render_basic__ps_fpu0_active__read \
    bdw__compute_l3_cache__eu_hybrid_fpu0_instruction__read

/* Render Metrics Basic Gen11 :: PS FPU1 Pipe Active */
#define icl__render_basic__ps_fpu1_active__read \
    bdw__compute_l3_cache__eu_hybrid_fpu1_instruction__read

/* Render Metrics Basic Gen11 :: PS Send Pipeline Active */
#define icl__render_basic__ps_send_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Render Metrics Basic Gen11 :: Sampler00 Busy */
#define icl__render_basic__sampler00_busy__read \
    bdw__render_pipe_profile__hs_stall__read

/* Render Metrics Basic Gen11 :: Samplers Busy */
#define icl__render_basic__samplers_busy__read \
    bdw__render_pipe_profile__hs_stall__read

/* Render Metrics Basic Gen11 :: Sampler00 Bottleneck */
#define icl__render_basic__sampler00_bottleneck__read \
    bdw__render_pipe_profile__vf_bottleneck__read

/* Render Metrics Basic Gen11 :: Rasterized Pixels */
#define icl__render_basic__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Render Metrics Basic Gen11 :: Early Hi-Depth Test Fails */
#define icl__render_basic__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Render Metrics Basic Gen11 :: Early Depth Test Fails */
#define icl__render_basic__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Render Metrics Basic Gen11 :: Samples Killed in FS */
#define icl__render_basic__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Render Metrics Basic Gen11 :: Pixels Failing Tests */
#define icl__render_basic__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Render Metrics Basic Gen11 :: Samples Written */
#define icl__render_basic__samples_written__read \
    bdw__render_basic__samples_written__read

/* Render Metrics Basic Gen11 :: Samples Blended */
#define icl__render_basic__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Render Metrics Basic Gen11 :: Sampler Texels */
#define icl__render_basic__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Render Metrics Basic Gen11 :: Sampler Texels Misses */
#define icl__render_basic__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Render Metrics Basic Gen11 :: Sampler Cache Misses */
static uint64_t
icl__render_basic__sampler_l1_misses__read(const struct intel_perf *perf,
                                           const struct intel_perf_metric_set *metric_set,
                                           uint64_t *accumulator)
{
    /* RPN equation: C 4 READ C 5 READ UADD 2 UMUL */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 4];
    uint64_t tmp1 = accumulator[metric_set->c_offset + 5];
    uint64_t tmp2 = tmp0 + tmp1;
    uint64_t tmp3 = tmp2 * 2;

    return tmp3;
}

/* Render Metrics Basic Gen11 :: SLM Bytes Read */
#define icl__render_basic__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Render Metrics Basic Gen11 :: SLM Bytes Read */
#define icl__render_basic__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics Basic Gen11 :: SLM Bytes Written */
#define icl__render_basic__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Render Metrics Basic Gen11 :: SLM Bytes Written */
#define icl__render_basic__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics Basic Gen11 :: Shader Memory Accesses */
#define icl__render_basic__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Render Metrics Basic Gen11 :: Shader Atomic Memory Accesses */
#define icl__render_basic__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Render Metrics Basic Gen11 :: L3 Shader Throughput */
static uint64_t
icl__render_basic__l3_shader_throughput__read(const struct intel_perf *perf,
                                              const struct intel_perf_metric_set *metric_set,
                                              uint64_t *accumulator)
{
    /* RPN equation: $ShaderMemoryAccesses 64 UMUL */
    uint64_t tmp0 = icl__render_basic__shader_memory_accesses__read(perf, metric_set, accumulator) * 64;

    return tmp0;
}

/* Render Metrics Basic Gen11 :: L3 Shader Throughput */
#define icl__render_basic__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics Basic Gen11 :: Shader Barrier Messages */
#define icl__render_basic__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Render Metrics Basic Gen11 :: GTI Read Throughput */
static uint64_t
icl__render_basic__gti_read_throughput__read(const struct intel_perf *perf,
                                             const struct intel_perf_metric_set *metric_set,
                                             uint64_t *accumulator)
{
    /* RPN equation: 64  B 1 READ B 3 READ UADD B 4 READ UADD B 5 READ UADD UMUL */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 1];
    uint64_t tmp1 = accumulator[metric_set->b_offset + 3];
    uint64_t tmp2 = tmp0 + tmp1;
    uint64_t tmp3 = accumulator[metric_set->b_offset + 4];
    uint64_t tmp4 = tmp2 + tmp3;
    uint64_t tmp5 = accumulator[metric_set->b_offset + 5];
    uint64_t tmp6 = tmp4 + tmp5;
    uint64_t tmp7 = 64 * tmp6;

    return tmp7;
}

/* Render Metrics Basic Gen11 :: GTI Read Throughput */
#define icl__render_basic__gti_read_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Render Metrics Basic Gen11 :: GTI Write Throughput */
static uint64_t
icl__render_basic__gti_write_throughput__read(const struct intel_perf *perf,
                                              const struct intel_perf_metric_set *metric_set,
                                              uint64_t *accumulator)
{
    /* RPN equation: 64  B 0 READ B 2 READ UADD UMUL */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 0];
    uint64_t tmp1 = accumulator[metric_set->b_offset + 2];
    uint64_t tmp2 = tmp0 + tmp1;
    uint64_t tmp3 = 64 * tmp2;

    return tmp3;
}

/* Render Metrics Basic Gen11 :: GTI Write Throughput */
#define icl__render_basic__gti_write_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Render Metrics Basic Gen11 :: Samplers Bottleneck */
#define icl__render_basic__sampler_bottleneck__read \
    bdw__render_pipe_profile__vf_bottleneck__read

/* Compute Metrics Basic Gen11 :: GPU Time Elapsed */
#define icl__compute_basic__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Compute Metrics Basic Gen11 :: GPU Core Clocks */
#define icl__compute_basic__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Compute Metrics Basic Gen11 :: AVG GPU Core Frequency */
#define icl__compute_basic__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Compute Metrics Basic Gen11 :: AVG GPU Core Frequency */
#define icl__compute_basic__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Compute Metrics Basic Gen11 :: GPU Busy */
#define icl__compute_basic__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Compute Metrics Basic Gen11 :: VS Threads Dispatched */
#define icl__compute_basic__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Compute Metrics Basic Gen11 :: HS Threads Dispatched */
#define icl__compute_basic__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Compute Metrics Basic Gen11 :: DS Threads Dispatched */
#define icl__compute_basic__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Compute Metrics Basic Gen11 :: GS Threads Dispatched */
#define icl__compute_basic__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Compute Metrics Basic Gen11 :: FS Threads Dispatched */
#define icl__compute_basic__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Compute Metrics Basic Gen11 :: CS Threads Dispatched */
#define icl__compute_basic__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Compute Metrics Basic Gen11 :: EU Active */
#define icl__compute_basic__eu_active__read \
    bdw__render_basic__eu_active__read

/* Compute Metrics Basic Gen11 :: EU Stall */
#define icl__compute_basic__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Compute Metrics Basic Gen11 :: EU AVG IPC Rate */
#define icl__compute_basic__eu_avg_ipc_rate__read \
    cnl__compute_basic__eu_avg_ipc_rate__read

/* Compute Metrics Basic Gen11 :: EU AVG IPC Rate */
#define icl__compute_basic__eu_avg_ipc_rate__max \
    bdw__compute_basic__eu_avg_ipc_rate__max

/* Compute Metrics Basic Gen11 :: EU Both FPU Pipes Active */
#define icl__compute_basic__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Compute Metrics Basic Gen11 :: EU FPU0 Pipe Active */
#define icl__compute_basic__fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Compute Metrics Basic Gen11 :: EU FPU1 Pipe Active */
#define icl__compute_basic__fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Compute Metrics Basic Gen11 :: EU Send Pipe Active */
#define icl__compute_basic__eu_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Compute Metrics Basic Gen11 :: EU Thread Occupancy */
#define icl__compute_basic__eu_thread_occupancy__read \
    cnl__compute_basic__eu_thread_occupancy__read

/* Compute Metrics Basic Gen11 :: Rasterized Pixels */
#define icl__compute_basic__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Compute Metrics Basic Gen11 :: Early Hi-Depth Test Fails */
#define icl__compute_basic__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Compute Metrics Basic Gen11 :: Early Depth Test Fails */
#define icl__compute_basic__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Compute Metrics Basic Gen11 :: Samples Killed in FS */
#define icl__compute_basic__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Compute Metrics Basic Gen11 :: Pixels Failing Tests */
#define icl__compute_basic__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Compute Metrics Basic Gen11 :: Samples Written */
#define icl__compute_basic__samples_written__read \
    bdw__render_basic__samples_written__read

/* Compute Metrics Basic Gen11 :: Samples Blended */
#define icl__compute_basic__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Compute Metrics Basic Gen11 :: Sampler Texels */
#define icl__compute_basic__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Compute Metrics Basic Gen11 :: Sampler Texels Misses */
#define icl__compute_basic__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Compute Metrics Basic Gen11 :: SLM Bytes Read */
#define icl__compute_basic__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Compute Metrics Basic Gen11 :: SLM Bytes Read */
#define icl__compute_basic__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Basic Gen11 :: SLM Bytes Written */
#define icl__compute_basic__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Compute Metrics Basic Gen11 :: SLM Bytes Written */
#define icl__compute_basic__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Basic Gen11 :: Shader Memory Accesses */
#define icl__compute_basic__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Compute Metrics Basic Gen11 :: Shader Atomic Memory Accesses */
#define icl__compute_basic__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Compute Metrics Basic Gen11 :: L3 Shader Throughput */
#define icl__compute_basic__l3_shader_throughput__read \
    icl__render_basic__l3_shader_throughput__read

/* Compute Metrics Basic Gen11 :: L3 Shader Throughput */
#define icl__compute_basic__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Basic Gen11 :: Shader Barrier Messages */
#define icl__compute_basic__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Compute Metrics Basic Gen11 :: Typed Bytes Read */
static uint64_t
icl__compute_basic__typed_bytes_read__read(const struct intel_perf *perf,
                                           const struct intel_perf_metric_set *metric_set,
                                           uint64_t *accumulator)
{
    /* RPN equation: C 7 READ C 6 READ UADD $EuSubslicesTotalCount UMUL 32 UMUL */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 7];
    uint64_t tmp1 = accumulator[metric_set->c_offset + 6];
    uint64_t tmp2 = tmp0 + tmp1;
    uint64_t tmp3 = tmp2 * perf->devinfo.n_eu_sub_slices;
    uint64_t tmp4 = tmp3 * 32;

    return tmp4;
}

/* Compute Metrics Basic Gen11 :: Typed Bytes Read */
#define icl__compute_basic__typed_bytes_read__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen11 :: Typed Bytes Written */
static uint64_t
icl__compute_basic__typed_bytes_written__read(const struct intel_perf *perf,
                                              const struct intel_perf_metric_set *metric_set,
                                              uint64_t *accumulator)
{
    /* RPN equation: C 5 READ C 4 READ UADD $EuSubslicesTotalCount UMUL 32 UMUL */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 5];
    uint64_t tmp1 = accumulator[metric_set->c_offset + 4];
    uint64_t tmp2 = tmp0 + tmp1;
    uint64_t tmp3 = tmp2 * perf->devinfo.n_eu_sub_slices;
    uint64_t tmp4 = tmp3 * 32;

    return tmp4;
}

/* Compute Metrics Basic Gen11 :: Typed Bytes Written */
#define icl__compute_basic__typed_bytes_written__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen11 :: Untyped Bytes Read */
static uint64_t
icl__compute_basic__untyped_bytes_read__read(const struct intel_perf *perf,
                                             const struct intel_perf_metric_set *metric_set,
                                             uint64_t *accumulator)
{
    /* RPN equation: C 3 READ C 2 READ UADD $EuSubslicesTotalCount UMUL 32 UMUL */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 3];
    uint64_t tmp1 = accumulator[metric_set->c_offset + 2];
    uint64_t tmp2 = tmp0 + tmp1;
    uint64_t tmp3 = tmp2 * perf->devinfo.n_eu_sub_slices;
    uint64_t tmp4 = tmp3 * 32;

    return tmp4;
}

/* Compute Metrics Basic Gen11 :: Untyped Bytes Read */
#define icl__compute_basic__untyped_bytes_read__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen11 :: Untyped Writes */
static uint64_t
icl__compute_basic__untyped_bytes_written__read(const struct intel_perf *perf,
                                                const struct intel_perf_metric_set *metric_set,
                                                uint64_t *accumulator)
{
    /* RPN equation: C 1 READ C 0 READ UADD $EuSubslicesTotalCount UMUL 32 UMUL */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 1];
    uint64_t tmp1 = accumulator[metric_set->c_offset + 0];
    uint64_t tmp2 = tmp0 + tmp1;
    uint64_t tmp3 = tmp2 * perf->devinfo.n_eu_sub_slices;
    uint64_t tmp4 = tmp3 * 32;

    return tmp4;
}

/* Compute Metrics Basic Gen11 :: Untyped Writes */
#define icl__compute_basic__untyped_bytes_written__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen11 :: Typed Atomics Accesses */
static uint64_t
icl__compute_basic__typed_atomics__read(const struct intel_perf *perf,
                                        const struct intel_perf_metric_set *metric_set,
                                        uint64_t *accumulator)
{
    /* RPN equation: B 4 READ B 5 READ FADD 2 FDIV $EuSubslicesTotalCount FMUL */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 4];
    uint64_t tmp1 = accumulator[metric_set->b_offset + 5];
    double tmp2 = tmp0 + tmp1;
    double tmp3 = tmp2;
    double tmp4 = 2;
    double tmp5 = tmp4 ? tmp3 / tmp4 : 0;
    double tmp6 = tmp5 * perf->devinfo.n_eu_sub_slices;

    return tmp6;
}

/* Compute Metrics Basic Gen11 :: Typed Atomics Accesses */
#define icl__compute_basic__typed_atomics__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen11 :: GTI Read Throughput */
static uint64_t
icl__compute_basic__gti_read_throughput__read(const struct intel_perf *perf,
                                              const struct intel_perf_metric_set *metric_set,
                                              uint64_t *accumulator)
{
    /* RPN equation: 64  B 1 READ B 3 READ UADD B 6 READ UADD B 7 READ UADD UMUL */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 1];
    uint64_t tmp1 = accumulator[metric_set->b_offset + 3];
    uint64_t tmp2 = tmp0 + tmp1;
    uint64_t tmp3 = accumulator[metric_set->b_offset + 6];
    uint64_t tmp4 = tmp2 + tmp3;
    uint64_t tmp5 = accumulator[metric_set->b_offset + 7];
    uint64_t tmp6 = tmp4 + tmp5;
    uint64_t tmp7 = 64 * tmp6;

    return tmp7;
}

/* Compute Metrics Basic Gen11 :: GTI Read Throughput */
#define icl__compute_basic__gti_read_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Compute Metrics Basic Gen11 :: GTI Write Throughput */
#define icl__compute_basic__gti_write_throughput__read \
    icl__render_basic__gti_write_throughput__read

/* Compute Metrics Basic Gen11 :: GTI Write Throughput */
#define icl__compute_basic__gti_write_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* ComputeExtended Gen11 :: GPU Time Elapsed */
#define icl__compute_extended__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* ComputeExtended Gen11 :: GPU Core Clocks */
#define icl__compute_extended__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* ComputeExtended Gen11 :: AVG GPU Core Frequency */
#define icl__compute_extended__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* ComputeExtended Gen11 :: AVG GPU Core Frequency */
#define icl__compute_extended__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* ComputeExtended Gen11 :: GPU Busy */
#define icl__compute_extended__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* ComputeExtended Gen11 :: CS Threads Dispatched */
#define icl__compute_extended__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* ComputeExtended Gen11 :: Typed Atomics 00 */
#define icl__compute_extended__typed_atomics00__read \
    hsw__memory_reads__gpu_core_clocks__read

/* ComputeExtended Gen11 :: Typed Reads 00 */
#define icl__compute_extended__typed_reads00__read \
    hsw__memory_reads__llc_read_accesses__read

/* ComputeExtended Gen11 :: Typed Writes 00 */
#define icl__compute_extended__typed_writes00__read \
    hsw__memory_reads__gti_memory_reads__read

/* ComputeExtended Gen11 :: Untyped Reads 00 */
#define icl__compute_extended__untyped_reads00__read \
    hsw__compute_extended__typed_atomics0__read

/* ComputeExtended Gen11 :: Untyped Writes 00 */
#define icl__compute_extended__untyped_writes00__read \
    hsw__compute_extended__untyped_reads0__read

/* ComputeExtended Gen11 :: Eu Typed Reads 00 */
#define icl__compute_extended__eu_typed_reads00__read \
    hsw__compute_extended__eu_typed_writes0__read

/* ComputeExtended Gen11 :: Eu Typed Writes 00 */
#define icl__compute_extended__eu_typed_writes00__read \
    hsw__compute_extended__eu_untyped_atomics0__read

/* ComputeExtended Gen11 :: Eu Typed Atomics 00 */
#define icl__compute_extended__eu_typed_atomics00__read \
    hsw__compute_extended__eu_typed_reads0__read

/* ComputeExtended Gen11 :: Eu A32 Untyped Reads 00 */
#define icl__compute_extended__eu_a32_untyped_reads00__read \
    hsw__compute_extended__eu_untyped_reads0__read

/* ComputeExtended Gen11 :: Eu A32 Untyped Writes 00 */
static uint64_t
icl__compute_extended__eu_a32_untyped_writes00__read(const struct intel_perf *perf,
                                                     const struct intel_perf_metric_set *metric_set,
                                                     uint64_t *accumulator)
{
    /* RPN equation: B 7 READ B 1 READ UADD */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 7];
    uint64_t tmp1 = accumulator[metric_set->b_offset + 1];
    uint64_t tmp2 = tmp0 + tmp1;

    return tmp2;
}

/* ComputeExtended Gen11 :: Eu 64 Untyped Reads 00 */
static double
icl__compute_extended__eu_a64_untyped_reads00__read(const struct intel_perf *perf,
                                                    const struct intel_perf_metric_set *metric_set,
                                                    uint64_t *accumulator)
{
    /* RPN equation: B 5 READ C 1 READ FADD B 6 READ FADD */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 5];
    uint64_t tmp1 = accumulator[metric_set->c_offset + 1];
    double tmp2 = tmp0 + tmp1;
    uint64_t tmp3 = accumulator[metric_set->b_offset + 6];
    double tmp4 = tmp2 + tmp3;

    return tmp4;
}

/* ComputeExtended Gen11 :: Eu A64 Untyped Writes 00 */
#define icl__compute_extended__eu_a64_untyped_writes00__read \
    hsw__render_basic__gpu_core_clocks__read

/* ComputeExtended Gen11 :: TypedAtomicsPerCacheLine */
static double
icl__compute_extended__typed_atomics_per_cache_line__read(const struct intel_perf *perf,
                                                          const struct intel_perf_metric_set *metric_set,
                                                          uint64_t *accumulator)
{
    /* RPN equation: $EuTypedAtomics00 $TypedAtomics00 FDIV */
    double tmp0 = icl__compute_extended__eu_typed_atomics00__read(perf, metric_set, accumulator);
    double tmp1 = icl__compute_extended__typed_atomics00__read(perf, metric_set, accumulator);
    double tmp2 = tmp1 ? tmp0 / tmp1 : 0;

    return tmp2;
}

/* ComputeExtended Gen11 :: TypedReadsPerCacheLine */
static double
icl__compute_extended__typed_reads_per_cache_line__read(const struct intel_perf *perf,
                                                        const struct intel_perf_metric_set *metric_set,
                                                        uint64_t *accumulator)
{
    /* RPN equation: $EuTypedReads00 $TypedReads00 FDIV */
    double tmp0 = icl__compute_extended__eu_typed_reads00__read(perf, metric_set, accumulator);
    double tmp1 = icl__compute_extended__typed_reads00__read(perf, metric_set, accumulator);
    double tmp2 = tmp1 ? tmp0 / tmp1 : 0;

    return tmp2;
}

/* ComputeExtended Gen11 :: TypedWritesPerCacheLine */
static double
icl__compute_extended__typed_writes_per_cache_line__read(const struct intel_perf *perf,
                                                         const struct intel_perf_metric_set *metric_set,
                                                         uint64_t *accumulator)
{
    /* RPN equation: $EuTypedWrites00 $TypedWrites00 FDIV */
    double tmp0 = icl__compute_extended__eu_typed_writes00__read(perf, metric_set, accumulator);
    double tmp1 = icl__compute_extended__typed_writes00__read(perf, metric_set, accumulator);
    double tmp2 = tmp1 ? tmp0 / tmp1 : 0;

    return tmp2;
}

/* ComputeExtended Gen11 :: UntypedReadsPerCacheLine */
static double
icl__compute_extended__untyped_reads_per_cache_line__read(const struct intel_perf *perf,
                                                          const struct intel_perf_metric_set *metric_set,
                                                          uint64_t *accumulator)
{
    /* RPN equation: B 0 READ B 5 READ C 1 READ FADD B 6 READ FADD FADD C 4 READ FDIV */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 0];
    uint64_t tmp1 = accumulator[metric_set->b_offset + 5];
    uint64_t tmp2 = accumulator[metric_set->c_offset + 1];
    double tmp3 = tmp1 + tmp2;
    uint64_t tmp4 = accumulator[metric_set->b_offset + 6];
    double tmp5 = tmp3 + tmp4;
    double tmp6 = tmp0 + tmp5;
    uint64_t tmp7 = accumulator[metric_set->c_offset + 4];
    double tmp8 = tmp6;
    double tmp9 = tmp7;
    double tmp10 = tmp9 ? tmp8 / tmp9 : 0;

    return tmp10;
}

/* ComputeExtended Gen11 :: UntypedWritesPerCacheLine */
static double
icl__compute_extended__untyped_writes_per_cache_line__read(const struct intel_perf *perf,
                                                           const struct intel_perf_metric_set *metric_set,
                                                           uint64_t *accumulator)
{
    /* RPN equation: B 7 READ B 1 READ FADD C 2 READ FADD C 3 READ FDIV */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 7];
    uint64_t tmp1 = accumulator[metric_set->b_offset + 1];
    double tmp2 = tmp0 + tmp1;
    uint64_t tmp3 = accumulator[metric_set->c_offset + 2];
    double tmp4 = tmp2 + tmp3;
    uint64_t tmp5 = accumulator[metric_set->c_offset + 3];
    double tmp6 = tmp4;
    double tmp7 = tmp5;
    double tmp8 = tmp7 ? tmp6 / tmp7 : 0;

    return tmp8;
}

/* Compute Metrics L3 Cache Gen11 :: GPU Time Elapsed */
#define icl__compute_l3_cache__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Compute Metrics L3 Cache Gen11 :: GPU Core Clocks */
#define icl__compute_l3_cache__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Compute Metrics L3 Cache Gen11 :: AVG GPU Core Frequency */
#define icl__compute_l3_cache__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Compute Metrics L3 Cache Gen11 :: AVG GPU Core Frequency */
#define icl__compute_l3_cache__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Compute Metrics L3 Cache Gen11 :: GPU Busy */
#define icl__compute_l3_cache__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Compute Metrics L3 Cache Gen11 :: VS Threads Dispatched */
#define icl__compute_l3_cache__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Compute Metrics L3 Cache Gen11 :: HS Threads Dispatched */
#define icl__compute_l3_cache__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Compute Metrics L3 Cache Gen11 :: DS Threads Dispatched */
#define icl__compute_l3_cache__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Compute Metrics L3 Cache Gen11 :: GS Threads Dispatched */
#define icl__compute_l3_cache__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Compute Metrics L3 Cache Gen11 :: FS Threads Dispatched */
#define icl__compute_l3_cache__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Compute Metrics L3 Cache Gen11 :: CS Threads Dispatched */
#define icl__compute_l3_cache__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Compute Metrics L3 Cache Gen11 :: EU Active */
#define icl__compute_l3_cache__eu_active__read \
    bdw__render_basic__eu_active__read

/* Compute Metrics L3 Cache Gen11 :: EU Stall */
#define icl__compute_l3_cache__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Compute Metrics L3 Cache Gen11 :: EU AVG IPC Rate */
#define icl__compute_l3_cache__eu_avg_ipc_rate__read \
    cnl__compute_basic__eu_avg_ipc_rate__read

/* Compute Metrics L3 Cache Gen11 :: EU AVG IPC Rate */
#define icl__compute_l3_cache__eu_avg_ipc_rate__max \
    bdw__compute_basic__eu_avg_ipc_rate__max

/* Compute Metrics L3 Cache Gen11 :: EU Both FPU Pipes Active */
#define icl__compute_l3_cache__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Compute Metrics L3 Cache Gen11 :: EU FPU0 Pipe Active */
#define icl__compute_l3_cache__fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Compute Metrics L3 Cache Gen11 :: EU FPU1 Pipe Active */
#define icl__compute_l3_cache__fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Compute Metrics L3 Cache Gen11 :: EU Send Pipe Active */
#define icl__compute_l3_cache__eu_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Compute Metrics L3 Cache Gen11 :: EU FPU0 Hybrid Instruction */
#define icl__compute_l3_cache__eu_hybrid_fpu0_instruction__read \
    bdw__compute_l3_cache__eu_hybrid_fpu0_instruction__read

/* Compute Metrics L3 Cache Gen11 :: EU FPU1 Hybrid Instruction */
#define icl__compute_l3_cache__eu_hybrid_fpu1_instruction__read \
    bdw__compute_l3_cache__eu_hybrid_fpu1_instruction__read

/* Compute Metrics L3 Cache Gen11 :: EU FPU0 Ternary Instruction */
#define icl__compute_l3_cache__eu_ternary_fpu0_instruction__read \
    bdw__render_basic__ps_fpu0_active__read

/* Compute Metrics L3 Cache Gen11 :: EU FPU1 Ternary Instruction */
#define icl__compute_l3_cache__eu_ternary_fpu1_instruction__read \
    bdw__render_basic__ps_fpu1_active__read

/* Compute Metrics L3 Cache Gen11 :: EU FPU0 Binary Instruction */
#define icl__compute_l3_cache__eu_binary_fpu0_instruction__read \
    bdw__render_basic__ps_send_active__read

/* Compute Metrics L3 Cache Gen11 :: EU FPU1 Binary Instruction */
#define icl__compute_l3_cache__eu_binary_fpu1_instruction__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Compute Metrics L3 Cache Gen11 :: EU FPU0 Move Instruction */
#define icl__compute_l3_cache__eu_move_fpu0_instruction__read \
    bdw__compute_l3_cache__eu_move_fpu0_instruction__read

/* Compute Metrics L3 Cache Gen11 :: EU FPU1 Move Instruction */
#define icl__compute_l3_cache__eu_move_fpu1_instruction__read \
    bdw__compute_l3_cache__eu_move_fpu1_instruction__read

/* Compute Metrics L3 Cache Gen11 :: Rasterized Pixels */
#define icl__compute_l3_cache__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Compute Metrics L3 Cache Gen11 :: Early Hi-Depth Test Fails */
#define icl__compute_l3_cache__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Compute Metrics L3 Cache Gen11 :: Early Depth Test Fails */
#define icl__compute_l3_cache__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Compute Metrics L3 Cache Gen11 :: Samples Killed in FS */
#define icl__compute_l3_cache__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Compute Metrics L3 Cache Gen11 :: Pixels Failing Tests */
#define icl__compute_l3_cache__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Compute Metrics L3 Cache Gen11 :: Samples Written */
#define icl__compute_l3_cache__samples_written__read \
    bdw__render_basic__samples_written__read

/* Compute Metrics L3 Cache Gen11 :: Samples Blended */
#define icl__compute_l3_cache__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Compute Metrics L3 Cache Gen11 :: Sampler Accesses */
#define icl__compute_l3_cache__sampler_accesses__read \
    bdw__render_pipe_profile__sampler_accesses__read

/* Compute Metrics L3 Cache Gen11 :: Sampler Texels */
#define icl__compute_l3_cache__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Compute Metrics L3 Cache Gen11 :: Sampler Texels Misses */
#define icl__compute_l3_cache__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Compute Metrics L3 Cache Gen11 :: SLM Bytes Read */
#define icl__compute_l3_cache__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Compute Metrics L3 Cache Gen11 :: SLM Bytes Read */
#define icl__compute_l3_cache__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics L3 Cache Gen11 :: SLM Bytes Written */
#define icl__compute_l3_cache__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Compute Metrics L3 Cache Gen11 :: SLM Bytes Written */
#define icl__compute_l3_cache__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics L3 Cache Gen11 :: Shader Memory Accesses */
#define icl__compute_l3_cache__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Compute Metrics L3 Cache Gen11 :: Shader Atomic Memory Accesses */
#define icl__compute_l3_cache__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Compute Metrics L3 Cache Gen11 :: Shader Barrier Messages */
#define icl__compute_l3_cache__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Compute Metrics L3 Cache Gen11 :: Slice0 L3 Bank0 Accesses */
static uint64_t
icl__compute_l3_cache__l3_bank00_accesses__read(const struct intel_perf *perf,
                                                const struct intel_perf_metric_set *metric_set,
                                                uint64_t *accumulator)
{
    /* RPN equation: C 7 READ 2 UMUL */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 7];
    uint64_t tmp1 = tmp0 * 2;

    return tmp1;
}

/* Compute Metrics L3 Cache Gen11 :: Slice0 L3 Bank1 Accesses */
#define icl__compute_l3_cache__l3_bank01_accesses__read \
    hsw__memory_writes__llc_wr_accesses__read

/* Compute Metrics L3 Cache Gen11 :: Slice0 L3 Bank2 Accesses */
static uint64_t
icl__compute_l3_cache__l3_bank02_accesses__read(const struct intel_perf *perf,
                                                const struct intel_perf_metric_set *metric_set,
                                                uint64_t *accumulator)
{
    /* RPN equation: C 5 READ 2 UMUL */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 5];
    uint64_t tmp1 = tmp0 * 2;

    return tmp1;
}

/* Compute Metrics L3 Cache Gen11 :: Slice0 L3 Bank3 Accesses */
static uint64_t
icl__compute_l3_cache__l3_bank03_accesses__read(const struct intel_perf *perf,
                                                const struct intel_perf_metric_set *metric_set,
                                                uint64_t *accumulator)
{
    /* RPN equation: C 4 READ 2 UMUL */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 4];
    uint64_t tmp1 = tmp0 * 2;

    return tmp1;
}

/* Compute Metrics L3 Cache Gen11 :: Slice0 L3 Bank4 Accesses */
#define icl__compute_l3_cache__l3_bank04_accesses__read \
    bdw__memory_reads__gti_ring_accesses__read

/* Compute Metrics L3 Cache Gen11 :: Slice0 L3 Bank5 Accesses */
#define icl__compute_l3_cache__l3_bank05_accesses__read \
    bdw__compute_l3_cache__l3_bank10_accesses__read

/* Compute Metrics L3 Cache Gen11 :: Slice0 L3 Bank6 Accesses */
#define icl__compute_l3_cache__l3_bank06_accesses__read \
    bdw__compute_l3_cache__l3_bank01_accesses__read

/* Compute Metrics L3 Cache Gen11 :: Slice0 L3 Bank7 Accesses */
#define icl__compute_l3_cache__l3_bank07_accesses__read \
    bdw__compute_l3_cache__l3_bank00_accesses__read

/* Compute Metrics L3 Cache Gen11 :: L3 Accesses */
static uint64_t
icl__compute_l3_cache__l3_accesses__read(const struct intel_perf *perf,
                                         const struct intel_perf_metric_set *metric_set,
                                         uint64_t *accumulator)
{
    /* RPN equation: $L3Bank00Accesses $L3Bank01Accesses UADD $L3Bank02Accesses UADD $L3Bank03Accesses UADD $L3Bank04Accesses UADD $L3Bank05Accesses UADD $L3Bank06Accesses UADD $L3Bank07Accesses UADD */
    uint64_t tmp0 = icl__compute_l3_cache__l3_bank00_accesses__read(perf, metric_set, accumulator) + icl__compute_l3_cache__l3_bank01_accesses__read(perf, metric_set, accumulator);
    uint64_t tmp1 = tmp0 + icl__compute_l3_cache__l3_bank02_accesses__read(perf, metric_set, accumulator);
    uint64_t tmp2 = tmp1 + icl__compute_l3_cache__l3_bank03_accesses__read(perf, metric_set, accumulator);
    uint64_t tmp3 = tmp2 + icl__compute_l3_cache__l3_bank04_accesses__read(perf, metric_set, accumulator);
    uint64_t tmp4 = tmp3 + icl__compute_l3_cache__l3_bank05_accesses__read(perf, metric_set, accumulator);
    uint64_t tmp5 = tmp4 + icl__compute_l3_cache__l3_bank06_accesses__read(perf, metric_set, accumulator);
    uint64_t tmp6 = tmp5 + icl__compute_l3_cache__l3_bank07_accesses__read(perf, metric_set, accumulator);

    return tmp6;
}

/* Compute Metrics L3 Cache Gen11 :: L3 Lookup Accesses w/o IC */
static uint64_t
icl__compute_l3_cache__l3_lookups__read(const struct intel_perf *perf,
                                        const struct intel_perf_metric_set *metric_set,
                                        uint64_t *accumulator)
{
    /* RPN equation: B 7 READ B 6 READ UADD 2 UMUL A 32 READ UADD */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 7];
    uint64_t tmp1 = accumulator[metric_set->b_offset + 6];
    uint64_t tmp2 = tmp0 + tmp1;
    uint64_t tmp3 = tmp2 * 2;
    uint64_t tmp4 = accumulator[metric_set->a_offset + 32];
    uint64_t tmp5 = tmp3 + tmp4;

    return tmp5;
}

/* Compute Metrics L3 Cache Gen11 :: L3 Sampler Throughput */
static uint64_t
icl__compute_l3_cache__l3_sampler_throughput__read(const struct intel_perf *perf,
                                                   const struct intel_perf_metric_set *metric_set,
                                                   uint64_t *accumulator)
{
    /* RPN equation: 64  B 7 READ B 6 READ UADD 2 UMUL UMUL */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 7];
    uint64_t tmp1 = accumulator[metric_set->b_offset + 6];
    uint64_t tmp2 = tmp0 + tmp1;
    uint64_t tmp3 = tmp2 * 2;
    uint64_t tmp4 = 64 * tmp3;

    return tmp4;
}

/* Compute Metrics L3 Cache Gen11 :: L3 Sampler Throughput */
#define icl__compute_l3_cache__l3_sampler_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics L3 Cache Gen11 :: L3 Shader Throughput */
#define icl__compute_l3_cache__l3_shader_throughput__read \
    icl__render_basic__l3_shader_throughput__read

/* Compute Metrics L3 Cache Gen11 :: L3 Shader Throughput */
#define icl__compute_l3_cache__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics L3 Cache Gen11 :: L3 Total Throughput */
static uint64_t
icl__compute_l3_cache__l3_total_throughput__read(const struct intel_perf *perf,
                                                 const struct intel_perf_metric_set *metric_set,
                                                 uint64_t *accumulator)
{
    /* RPN equation: $L3Accesses 64 UMUL */
    uint64_t tmp0 = icl__compute_l3_cache__l3_accesses__read(perf, metric_set, accumulator) * 64;

    return tmp0;
}

/* Compute Metrics L3 Cache Gen11 :: L3 Total Throughput */
#define icl__compute_l3_cache__l3_total_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics L3 Cache Gen11 :: GTI Read Throughput */
static uint64_t
icl__compute_l3_cache__gti_read_throughput__read(const struct intel_perf *perf,
                                                 const struct intel_perf_metric_set *metric_set,
                                                 uint64_t *accumulator)
{
    /* RPN equation: B 2 READ 64 UMUL */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 2];
    uint64_t tmp1 = tmp0 * 64;

    return tmp1;
}

/* Compute Metrics L3 Cache Gen11 :: GTI Read Throughput */
#define icl__compute_l3_cache__gti_read_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Compute Metrics L3 Cache Gen11 :: GTI Write Throughput */
static uint64_t
icl__compute_l3_cache__gti_write_throughput__read(const struct intel_perf *perf,
                                                  const struct intel_perf_metric_set *metric_set,
                                                  uint64_t *accumulator)
{
    /* RPN equation: B 3 READ 64 UMUL */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 3];
    uint64_t tmp1 = tmp0 * 64;

    return tmp1;
}

/* Compute Metrics L3 Cache Gen11 :: GTI Write Throughput */
#define icl__compute_l3_cache__gti_write_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Render Metrics for 3D Pipeline Profile Gen11 :: GPU Time Elapsed */
#define icl__render_pipe_profile__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: GPU Core Clocks */
#define icl__render_pipe_profile__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: AVG GPU Core Frequency */
#define icl__render_pipe_profile__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: AVG GPU Core Frequency */
#define icl__render_pipe_profile__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Render Metrics for 3D Pipeline Profile Gen11 :: GPU Busy */
#define icl__render_pipe_profile__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: VS Threads Dispatched */
#define icl__render_pipe_profile__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: HS Threads Dispatched */
#define icl__render_pipe_profile__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: DS Threads Dispatched */
#define icl__render_pipe_profile__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: GS Threads Dispatched */
#define icl__render_pipe_profile__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: FS Threads Dispatched */
#define icl__render_pipe_profile__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: CS Threads Dispatched */
#define icl__render_pipe_profile__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: EU Active */
#define icl__render_pipe_profile__eu_active__read \
    bdw__render_basic__eu_active__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: EU Stall */
#define icl__render_pipe_profile__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: Rasterized Pixels */
#define icl__render_pipe_profile__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: Early Hi-Depth Test Fails */
#define icl__render_pipe_profile__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: Early Depth Test Fails */
#define icl__render_pipe_profile__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: Samples Killed in FS */
#define icl__render_pipe_profile__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: Pixels Failing Tests */
#define icl__render_pipe_profile__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: Samples Written */
#define icl__render_pipe_profile__samples_written__read \
    bdw__render_basic__samples_written__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: Samples Blended */
#define icl__render_pipe_profile__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: Sampler Texels */
#define icl__render_pipe_profile__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: Sampler Texels Misses */
#define icl__render_pipe_profile__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: SLM Bytes Read */
#define icl__render_pipe_profile__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: SLM Bytes Read */
#define icl__render_pipe_profile__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics for 3D Pipeline Profile Gen11 :: SLM Bytes Written */
#define icl__render_pipe_profile__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: SLM Bytes Written */
#define icl__render_pipe_profile__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics for 3D Pipeline Profile Gen11 :: Shader Memory Accesses */
#define icl__render_pipe_profile__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: Shader Atomic Memory Accesses */
#define icl__render_pipe_profile__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: L3 Shader Throughput */
#define icl__render_pipe_profile__l3_shader_throughput__read \
    icl__render_basic__l3_shader_throughput__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: L3 Shader Throughput */
#define icl__render_pipe_profile__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics for 3D Pipeline Profile Gen11 :: Shader Barrier Messages */
#define icl__render_pipe_profile__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: VF Bottleneck */
#define icl__render_pipe_profile__vf_bottleneck__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: VS Bottleneck */
#define icl__render_pipe_profile__vs_bottleneck__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: HS Bottleneck */
#define icl__render_pipe_profile__hs_bottleneck__read \
    bdw__render_pipe_profile__sf_stall__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: DS Bottleneck */
#define icl__render_pipe_profile__ds_bottleneck__read \
    bdw__render_pipe_profile__cl_stall__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: GS Bottleneck */
#define icl__render_pipe_profile__gs_bottleneck__read \
    bdw__render_pipe_profile__so_stall__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: SO Bottleneck */
#define icl__render_pipe_profile__so_bottleneck__read \
    bdw__render_pipe_profile__ds_stall__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: Clipper Bottleneck */
#define icl__render_pipe_profile__cl_bottleneck__read \
    bdw__render_pipe_profile__hs_stall__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: Strip-Fans Bottleneck */
#define icl__render_pipe_profile__sf_bottleneck__read \
    bdw__render_pipe_profile__vf_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: Hi-Depth Bottleneck */
#define icl__render_pipe_profile__hi_depth_bottleneck__read \
    bdw__render_pipe_profile__early_depth_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: Early Depth Bottleneck */
#define icl__render_pipe_profile__early_depth_bottleneck__read \
    bdw__render_pipe_profile__sf_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: BC Bottleneck */
#define icl__render_pipe_profile__bc_bottleneck__read \
    bdw__render_pipe_profile__cl_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: HS Stall */
#define icl__render_pipe_profile__hs_stall__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: DS Stall */
#define icl__render_pipe_profile__ds_stall__read \
    bdw__render_basic__sampler1_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: SO Stall */
#define icl__render_pipe_profile__so_stall__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: CL Stall */
#define icl__render_pipe_profile__cl_stall__read \
    bdw__render_basic__sampler1_busy__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: SF Stall */
#define icl__render_pipe_profile__sf_stall__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set HDCAndSF :: GPU Time Elapsed */
#define icl__hdc_and_sf__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set HDCAndSF :: GPU Core Clocks */
#define icl__hdc_and_sf__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set HDCAndSF :: AVG GPU Core Frequency */
#define icl__hdc_and_sf__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set HDCAndSF :: AVG GPU Core Frequency */
#define icl__hdc_and_sf__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set HDCAndSF :: GPU Busy */
#define icl__hdc_and_sf__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set HDCAndSF :: VS Threads Dispatched */
#define icl__hdc_and_sf__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set HDCAndSF :: HS Threads Dispatched */
#define icl__hdc_and_sf__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set HDCAndSF :: DS Threads Dispatched */
#define icl__hdc_and_sf__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set HDCAndSF :: GS Threads Dispatched */
#define icl__hdc_and_sf__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set HDCAndSF :: FS Threads Dispatched */
#define icl__hdc_and_sf__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set HDCAndSF :: CS Threads Dispatched */
#define icl__hdc_and_sf__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set HDCAndSF :: EU Active */
#define icl__hdc_and_sf__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set HDCAndSF :: EU Stall */
#define icl__hdc_and_sf__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set HDCAndSF :: EU Both FPU Pipes Active */
#define icl__hdc_and_sf__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set HDCAndSF :: VS FPU0 Pipe Active */
#define icl__hdc_and_sf__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set HDCAndSF :: VS FPU1 Pipe Active */
#define icl__hdc_and_sf__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set HDCAndSF :: VS Send Pipe Active */
#define icl__hdc_and_sf__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set HDCAndSF :: PS FPU0 Pipe Active */
#define icl__hdc_and_sf__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set HDCAndSF :: PS FPU1 Pipe Active */
#define icl__hdc_and_sf__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set HDCAndSF :: PS Send Pipeline Active */
#define icl__hdc_and_sf__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set HDCAndSF :: FS Both FPU Active */
#define icl__hdc_and_sf__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set HDCAndSF :: Rasterized Pixels */
#define icl__hdc_and_sf__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set HDCAndSF :: Early Hi-Depth Test Fails */
#define icl__hdc_and_sf__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set HDCAndSF :: Early Depth Test Fails */
#define icl__hdc_and_sf__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set HDCAndSF :: Samples Killed in FS */
#define icl__hdc_and_sf__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set HDCAndSF :: Pixels Failing Tests */
#define icl__hdc_and_sf__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set HDCAndSF :: Samples Written */
#define icl__hdc_and_sf__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set HDCAndSF :: Samples Blended */
#define icl__hdc_and_sf__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set HDCAndSF :: Sampler Texels */
#define icl__hdc_and_sf__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set HDCAndSF :: Sampler Texels Misses */
#define icl__hdc_and_sf__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set HDCAndSF :: SLM Bytes Read */
#define icl__hdc_and_sf__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set HDCAndSF :: SLM Bytes Read */
#define icl__hdc_and_sf__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set HDCAndSF :: SLM Bytes Written */
#define icl__hdc_and_sf__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set HDCAndSF :: SLM Bytes Written */
#define icl__hdc_and_sf__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set HDCAndSF :: Shader Memory Accesses */
#define icl__hdc_and_sf__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set HDCAndSF :: Shader Atomic Memory Accesses */
#define icl__hdc_and_sf__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set HDCAndSF :: L3 Shader Throughput */
#define icl__hdc_and_sf__l3_shader_throughput__read \
    icl__render_basic__l3_shader_throughput__read

/* Metric set HDCAndSF :: L3 Shader Throughput */
#define icl__hdc_and_sf__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set HDCAndSF :: Shader Barrier Messages */
#define icl__hdc_and_sf__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set HDCAndSF :: Slice0 Dualsubslice0 Non-sampler Shader Access Stalled On L3 */
static double
icl__hdc_and_sf__non_sampler_shader00_access_stalled_on_l3__read(const struct intel_perf *perf,
                                                                 const struct intel_perf_metric_set *metric_set,
                                                                 uint64_t *accumulator)
{
    /* RPN equation: C 0 READ B 7 READ FSUB 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 0];
    uint64_t tmp1 = accumulator[metric_set->b_offset + 7];
    double tmp2 = tmp0 - tmp1;
    uint64_t tmp3 = tmp2 * 100;
    double tmp4 = tmp3;
    double tmp5 = icl__hdc_and_sf__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp6 = tmp5 ? tmp4 / tmp5 : 0;

    return tmp6;
}

/* Metric set HDCAndSF :: Slice0 Dualsubslice1 Non-sampler Shader Access Stalled On L3 */
static double
icl__hdc_and_sf__non_sampler_shader01_access_stalled_on_l3__read(const struct intel_perf *perf,
                                                                 const struct intel_perf_metric_set *metric_set,
                                                                 uint64_t *accumulator)
{
    /* RPN equation: C 2 READ C 1 READ FSUB 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 2];
    uint64_t tmp1 = accumulator[metric_set->c_offset + 1];
    double tmp2 = tmp0 - tmp1;
    uint64_t tmp3 = tmp2 * 100;
    double tmp4 = tmp3;
    double tmp5 = icl__hdc_and_sf__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp6 = tmp5 ? tmp4 / tmp5 : 0;

    return tmp6;
}

/* Metric set HDCAndSF :: Slice0 Dualsubslice2 Non-sampler Shader Access Stalled On L3 */
static double
icl__hdc_and_sf__non_sampler_shader02_access_stalled_on_l3__read(const struct intel_perf *perf,
                                                                 const struct intel_perf_metric_set *metric_set,
                                                                 uint64_t *accumulator)
{
    /* RPN equation: C 4 READ C 3 READ FSUB 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 4];
    uint64_t tmp1 = accumulator[metric_set->c_offset + 3];
    double tmp2 = tmp0 - tmp1;
    uint64_t tmp3 = tmp2 * 100;
    double tmp4 = tmp3;
    double tmp5 = icl__hdc_and_sf__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp6 = tmp5 ? tmp4 / tmp5 : 0;

    return tmp6;
}

/* Metric set HDCAndSF :: Slice0 Dualsubslice3 Non-sampler Shader Access Stalled On L3 */
static double
icl__hdc_and_sf__non_sampler_shader03_access_stalled_on_l3__read(const struct intel_perf *perf,
                                                                 const struct intel_perf_metric_set *metric_set,
                                                                 uint64_t *accumulator)
{
    /* RPN equation: C 6 READ C 5 READ FSUB 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 6];
    uint64_t tmp1 = accumulator[metric_set->c_offset + 5];
    double tmp2 = tmp0 - tmp1;
    uint64_t tmp3 = tmp2 * 100;
    double tmp4 = tmp3;
    double tmp5 = icl__hdc_and_sf__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp6 = tmp5 ? tmp4 / tmp5 : 0;

    return tmp6;
}

/* Metric set HDCAndSF :: Polygon Data Ready */
#define icl__hdc_and_sf__poly_data_ready__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set HDCAndSF :: SQ is full */
#define icl__hdc_and_sf__gt_request_queue_full__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set RasterizerAndPixelBackend :: GPU Time Elapsed */
#define icl__rasterizer_and_pixel_backend__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set RasterizerAndPixelBackend :: GPU Core Clocks */
#define icl__rasterizer_and_pixel_backend__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set RasterizerAndPixelBackend :: AVG GPU Core Frequency */
#define icl__rasterizer_and_pixel_backend__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set RasterizerAndPixelBackend :: AVG GPU Core Frequency */
#define icl__rasterizer_and_pixel_backend__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set RasterizerAndPixelBackend :: GPU Busy */
#define icl__rasterizer_and_pixel_backend__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set RasterizerAndPixelBackend :: VS Threads Dispatched */
#define icl__rasterizer_and_pixel_backend__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set RasterizerAndPixelBackend :: HS Threads Dispatched */
#define icl__rasterizer_and_pixel_backend__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set RasterizerAndPixelBackend :: DS Threads Dispatched */
#define icl__rasterizer_and_pixel_backend__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set RasterizerAndPixelBackend :: GS Threads Dispatched */
#define icl__rasterizer_and_pixel_backend__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set RasterizerAndPixelBackend :: FS Threads Dispatched */
#define icl__rasterizer_and_pixel_backend__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set RasterizerAndPixelBackend :: CS Threads Dispatched */
#define icl__rasterizer_and_pixel_backend__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set RasterizerAndPixelBackend :: EU Active */
#define icl__rasterizer_and_pixel_backend__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set RasterizerAndPixelBackend :: EU Stall */
#define icl__rasterizer_and_pixel_backend__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set RasterizerAndPixelBackend :: EU Both FPU Pipes Active */
#define icl__rasterizer_and_pixel_backend__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set RasterizerAndPixelBackend :: VS FPU0 Pipe Active */
#define icl__rasterizer_and_pixel_backend__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set RasterizerAndPixelBackend :: VS FPU1 Pipe Active */
#define icl__rasterizer_and_pixel_backend__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set RasterizerAndPixelBackend :: VS Send Pipe Active */
#define icl__rasterizer_and_pixel_backend__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set RasterizerAndPixelBackend :: PS FPU0 Pipe Active */
#define icl__rasterizer_and_pixel_backend__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set RasterizerAndPixelBackend :: PS FPU1 Pipe Active */
#define icl__rasterizer_and_pixel_backend__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set RasterizerAndPixelBackend :: PS Send Pipeline Active */
#define icl__rasterizer_and_pixel_backend__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set RasterizerAndPixelBackend :: FS Both FPU Active */
#define icl__rasterizer_and_pixel_backend__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set RasterizerAndPixelBackend :: Rasterized Pixels */
#define icl__rasterizer_and_pixel_backend__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set RasterizerAndPixelBackend :: Early Hi-Depth Test Fails */
#define icl__rasterizer_and_pixel_backend__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set RasterizerAndPixelBackend :: Early Depth Test Fails */
#define icl__rasterizer_and_pixel_backend__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set RasterizerAndPixelBackend :: Samples Killed in FS */
#define icl__rasterizer_and_pixel_backend__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set RasterizerAndPixelBackend :: Pixels Failing Tests */
#define icl__rasterizer_and_pixel_backend__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set RasterizerAndPixelBackend :: Samples Written */
#define icl__rasterizer_and_pixel_backend__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set RasterizerAndPixelBackend :: Samples Blended */
#define icl__rasterizer_and_pixel_backend__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set RasterizerAndPixelBackend :: Sampler Texels */
#define icl__rasterizer_and_pixel_backend__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set RasterizerAndPixelBackend :: Sampler Texels Misses */
#define icl__rasterizer_and_pixel_backend__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Read */
#define icl__rasterizer_and_pixel_backend__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Read */
#define icl__rasterizer_and_pixel_backend__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Written */
#define icl__rasterizer_and_pixel_backend__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Written */
#define icl__rasterizer_and_pixel_backend__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set RasterizerAndPixelBackend :: Shader Memory Accesses */
#define icl__rasterizer_and_pixel_backend__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set RasterizerAndPixelBackend :: Shader Atomic Memory Accesses */
#define icl__rasterizer_and_pixel_backend__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set RasterizerAndPixelBackend :: L3 Shader Throughput */
#define icl__rasterizer_and_pixel_backend__l3_shader_throughput__read \
    icl__render_basic__l3_shader_throughput__read

/* Metric set RasterizerAndPixelBackend :: L3 Shader Throughput */
#define icl__rasterizer_and_pixel_backend__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set RasterizerAndPixelBackend :: Shader Barrier Messages */
#define icl__rasterizer_and_pixel_backend__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Rasterizer Input Available */
#define icl__rasterizer_and_pixel_backend__rasterizer0_input_available__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Rasterizer Output Ready */
#define icl__rasterizer_and_pixel_backend__rasterizer0_output_ready__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Pipe0 Post-EarlyZ Pixel Data Ready */
#define icl__rasterizer_and_pixel_backend__pixel_data00_ready__read \
    bdw__render_basic__sampler1_busy__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Pipe1 Post-EarlyZ Pixel Data Ready */
#define icl__rasterizer_and_pixel_backend__pixel_data01_ready__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Pipe0 PS Output Available */
#define icl__rasterizer_and_pixel_backend__ps_output00_available__read \
    bdw__render_pipe_profile__cl_stall__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Pipe1 PS Output Available */
#define icl__rasterizer_and_pixel_backend__ps_output01_available__read \
    bdw__render_pipe_profile__sf_stall__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Pipe0 Pixel Values Ready */
#define icl__rasterizer_and_pixel_backend__pixel_values00_ready__read \
    bdw__render_pipe_profile__ds_stall__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Pipe1 Pixel Values Ready */
#define icl__rasterizer_and_pixel_backend__pixel_values01_ready__read \
    bdw__render_pipe_profile__so_stall__read

/* Metric set RasterizerAndPixelBackend :: SQ is full */
#define icl__rasterizer_and_pixel_backend__gt_request_queue_full__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set L3_1 :: GPU Time Elapsed */
#define icl__l3_1__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set L3_1 :: GPU Core Clocks */
#define icl__l3_1__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set L3_1 :: AVG GPU Core Frequency */
#define icl__l3_1__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set L3_1 :: AVG GPU Core Frequency */
#define icl__l3_1__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set L3_1 :: GPU Busy */
#define icl__l3_1__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set L3_1 :: VS Threads Dispatched */
#define icl__l3_1__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set L3_1 :: HS Threads Dispatched */
#define icl__l3_1__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set L3_1 :: DS Threads Dispatched */
#define icl__l3_1__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set L3_1 :: GS Threads Dispatched */
#define icl__l3_1__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set L3_1 :: FS Threads Dispatched */
#define icl__l3_1__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set L3_1 :: CS Threads Dispatched */
#define icl__l3_1__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set L3_1 :: EU Active */
#define icl__l3_1__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set L3_1 :: EU Stall */
#define icl__l3_1__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set L3_1 :: EU Both FPU Pipes Active */
#define icl__l3_1__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set L3_1 :: VS FPU0 Pipe Active */
#define icl__l3_1__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set L3_1 :: VS FPU1 Pipe Active */
#define icl__l3_1__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set L3_1 :: VS Send Pipe Active */
#define icl__l3_1__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set L3_1 :: PS FPU0 Pipe Active */
#define icl__l3_1__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set L3_1 :: PS FPU1 Pipe Active */
#define icl__l3_1__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set L3_1 :: PS Send Pipeline Active */
#define icl__l3_1__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set L3_1 :: FS Both FPU Active */
#define icl__l3_1__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set L3_1 :: Rasterized Pixels */
#define icl__l3_1__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set L3_1 :: Early Hi-Depth Test Fails */
#define icl__l3_1__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set L3_1 :: Early Depth Test Fails */
#define icl__l3_1__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set L3_1 :: Samples Killed in FS */
#define icl__l3_1__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set L3_1 :: Pixels Failing Tests */
#define icl__l3_1__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set L3_1 :: Samples Written */
#define icl__l3_1__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set L3_1 :: Samples Blended */
#define icl__l3_1__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set L3_1 :: Sampler Texels */
#define icl__l3_1__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set L3_1 :: Sampler Texels Misses */
#define icl__l3_1__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set L3_1 :: SLM Bytes Read */
#define icl__l3_1__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set L3_1 :: SLM Bytes Read */
#define icl__l3_1__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_1 :: SLM Bytes Written */
#define icl__l3_1__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set L3_1 :: SLM Bytes Written */
#define icl__l3_1__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_1 :: Shader Memory Accesses */
#define icl__l3_1__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set L3_1 :: Shader Atomic Memory Accesses */
#define icl__l3_1__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set L3_1 :: L3 Shader Throughput */
#define icl__l3_1__l3_shader_throughput__read \
    icl__render_basic__l3_shader_throughput__read

/* Metric set L3_1 :: L3 Shader Throughput */
#define icl__l3_1__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_1 :: Shader Barrier Messages */
#define icl__l3_1__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set L3_1 :: Slice0 L3 Bank0 Active */
#define icl__l3_1__l30_bank0_active__read \
    bdw__render_pipe_profile__vf_bottleneck__read

/* Metric set L3_1 :: Slice0 L3 Bank1 Active */
#define icl__l3_1__l30_bank1_active__read \
    bdw__render_pipe_profile__hs_stall__read

/* Metric set L3_1 :: Slice0 L3 Bank2 Active */
#define icl__l3_1__l30_bank2_active__read \
    bdw__render_pipe_profile__ds_stall__read

/* Metric set L3_1 :: Slice0 L3 Bank3 Active */
#define icl__l3_1__l30_bank3_active__read \
    bdw__render_pipe_profile__so_stall__read

/* Metric set L3_1 :: Slice0 L3 Bank4 Active */
#define icl__l3_1__l30_bank4_active__read \
    bdw__render_pipe_profile__cl_stall__read

/* Metric set L3_1 :: Slice0 L3 Bank5 Active */
#define icl__l3_1__l30_bank5_active__read \
    bdw__render_pipe_profile__sf_stall__read

/* Metric set L3_1 :: Slice0 L3 Bank6 Active */
#define icl__l3_1__l30_bank6_active__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set L3_1 :: Slice0 L3 Bank7 Active */
#define icl__l3_1__l30_bank7_active__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set L3_1 :: SQ is full */
#define icl__l3_1__gt_request_queue_full__read \
    bdw__render_pipe_profile__early_depth_bottleneck__read

/* Gen11 L2Bank0 stalled metric set :: GPU Time Elapsed */
#define icl__l3_2__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Gen11 L2Bank0 stalled metric set :: GPU Core Clocks */
#define icl__l3_2__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Gen11 L2Bank0 stalled metric set :: AVG GPU Core Frequency */
#define icl__l3_2__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Gen11 L2Bank0 stalled metric set :: AVG GPU Core Frequency */
#define icl__l3_2__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Gen11 L2Bank0 stalled metric set :: GPU Busy */
#define icl__l3_2__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Gen11 L2Bank0 stalled metric set :: VS Threads Dispatched */
#define icl__l3_2__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Gen11 L2Bank0 stalled metric set :: HS Threads Dispatched */
#define icl__l3_2__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Gen11 L2Bank0 stalled metric set :: DS Threads Dispatched */
#define icl__l3_2__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Gen11 L2Bank0 stalled metric set :: GS Threads Dispatched */
#define icl__l3_2__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Gen11 L2Bank0 stalled metric set :: FS Threads Dispatched */
#define icl__l3_2__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Gen11 L2Bank0 stalled metric set :: CS Threads Dispatched */
#define icl__l3_2__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Gen11 L2Bank0 stalled metric set :: Rasterized Pixels */
#define icl__l3_2__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Gen11 L2Bank0 stalled metric set :: Early Hi-Depth Test Fails */
#define icl__l3_2__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Gen11 L2Bank0 stalled metric set :: Early Depth Test Fails */
#define icl__l3_2__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Gen11 L2Bank0 stalled metric set :: Samples Killed in FS */
#define icl__l3_2__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Gen11 L2Bank0 stalled metric set :: Pixels Failing Tests */
#define icl__l3_2__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Gen11 L2Bank0 stalled metric set :: Samples Written */
#define icl__l3_2__samples_written__read \
    bdw__render_basic__samples_written__read

/* Gen11 L2Bank0 stalled metric set :: Samples Blended */
#define icl__l3_2__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Gen11 L2Bank0 stalled metric set :: EU Active */
#define icl__l3_2__eu_active__read \
    bdw__render_basic__eu_active__read

/* Gen11 L2Bank0 stalled metric set :: EU Stall */
#define icl__l3_2__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Gen11 L2Bank0 stalled metric set :: EU Both FPU Pipes Active */
#define icl__l3_2__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Gen11 L2Bank0 stalled metric set :: EU Thread Occupancy */
#define icl__l3_2__eu_thread_occupancy__read \
    bdw__vme_pipe__eu_thread_occupancy__read

/* Gen11 L2Bank0 stalled metric set :: VS FPU0 Pipe Active */
#define icl__l3_2__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Gen11 L2Bank0 stalled metric set :: VS FPU1 Pipe Active */
#define icl__l3_2__vs_fpu1_active__read \
    bdw__render_basic__vs_send_active__read

/* Gen11 L2Bank0 stalled metric set :: VS Send Pipe Active */
#define icl__l3_2__vs_send_active__read \
    bdw__compute_l3_cache__eu_hybrid_fpu0_instruction__read

/* Gen11 L2Bank0 stalled metric set :: PS FPU0 Pipe Active */
#define icl__l3_2__ps_fpu0_active__read \
    bdw__compute_l3_cache__eu_hybrid_fpu1_instruction__read

/* Gen11 L2Bank0 stalled metric set :: PS FPU1 Pipe Active */
#define icl__l3_2__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Gen11 L2Bank0 stalled metric set :: PS Send Pipeline Active */
#define icl__l3_2__ps_send_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Gen11 L2Bank0 stalled metric set :: FS Both FPU Active */
#define icl__l3_2__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_send_active__read

/* Gen11 L2Bank0 stalled metric set :: Slice0 L3 Bank0 Stalled */
static double
icl__l3_2__l30_bank0_stalled__read(const struct intel_perf *perf,
                                   const struct intel_perf_metric_set *metric_set,
                                   uint64_t *accumulator)
{
    /* RPN equation: B 0 READ B 1 READ FADD B 2 READ FADD B 3 READ FADD 4 FDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 0];
    uint64_t tmp1 = accumulator[metric_set->b_offset + 1];
    double tmp2 = tmp0 + tmp1;
    uint64_t tmp3 = accumulator[metric_set->b_offset + 2];
    double tmp4 = tmp2 + tmp3;
    uint64_t tmp5 = accumulator[metric_set->b_offset + 3];
    double tmp6 = tmp4 + tmp5;
    double tmp7 = tmp6;
    double tmp8 = 4;
    double tmp9 = tmp8 ? tmp7 / tmp8 : 0;
    uint64_t tmp10 = tmp9 * 100;
    double tmp11 = tmp10;
    double tmp12 = icl__l3_2__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp13 = tmp12 ? tmp11 / tmp12 : 0;

    return tmp13;
}

/* Gen11 L2Bank1 stalled metric set :: GPU Time Elapsed */
#define icl__l3_3__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Gen11 L2Bank1 stalled metric set :: GPU Core Clocks */
#define icl__l3_3__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Gen11 L2Bank1 stalled metric set :: AVG GPU Core Frequency */
#define icl__l3_3__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Gen11 L2Bank1 stalled metric set :: AVG GPU Core Frequency */
#define icl__l3_3__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Gen11 L2Bank1 stalled metric set :: GPU Busy */
#define icl__l3_3__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Gen11 L2Bank1 stalled metric set :: VS Threads Dispatched */
#define icl__l3_3__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Gen11 L2Bank1 stalled metric set :: HS Threads Dispatched */
#define icl__l3_3__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Gen11 L2Bank1 stalled metric set :: DS Threads Dispatched */
#define icl__l3_3__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Gen11 L2Bank1 stalled metric set :: GS Threads Dispatched */
#define icl__l3_3__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Gen11 L2Bank1 stalled metric set :: FS Threads Dispatched */
#define icl__l3_3__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Gen11 L2Bank1 stalled metric set :: CS Threads Dispatched */
#define icl__l3_3__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Gen11 L2Bank1 stalled metric set :: Rasterized Pixels */
#define icl__l3_3__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Gen11 L2Bank1 stalled metric set :: Early Hi-Depth Test Fails */
#define icl__l3_3__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Gen11 L2Bank1 stalled metric set :: Early Depth Test Fails */
#define icl__l3_3__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Gen11 L2Bank1 stalled metric set :: Samples Killed in FS */
#define icl__l3_3__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Gen11 L2Bank1 stalled metric set :: Pixels Failing Tests */
#define icl__l3_3__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Gen11 L2Bank1 stalled metric set :: Samples Written */
#define icl__l3_3__samples_written__read \
    bdw__render_basic__samples_written__read

/* Gen11 L2Bank1 stalled metric set :: Samples Blended */
#define icl__l3_3__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Gen11 L2Bank1 stalled metric set :: EU Active */
#define icl__l3_3__eu_active__read \
    bdw__render_basic__eu_active__read

/* Gen11 L2Bank1 stalled metric set :: EU Stall */
#define icl__l3_3__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Gen11 L2Bank1 stalled metric set :: EU Both FPU Pipes Active */
#define icl__l3_3__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Gen11 L2Bank1 stalled metric set :: EU Thread Occupancy */
#define icl__l3_3__eu_thread_occupancy__read \
    bdw__vme_pipe__eu_thread_occupancy__read

/* Gen11 L2Bank1 stalled metric set :: VS FPU0 Pipe Active */
#define icl__l3_3__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Gen11 L2Bank1 stalled metric set :: VS FPU1 Pipe Active */
#define icl__l3_3__vs_fpu1_active__read \
    bdw__render_basic__vs_send_active__read

/* Gen11 L2Bank1 stalled metric set :: VS Send Pipe Active */
#define icl__l3_3__vs_send_active__read \
    bdw__compute_l3_cache__eu_hybrid_fpu0_instruction__read

/* Gen11 L2Bank1 stalled metric set :: PS FPU0 Pipe Active */
#define icl__l3_3__ps_fpu0_active__read \
    bdw__compute_l3_cache__eu_hybrid_fpu1_instruction__read

/* Gen11 L2Bank1 stalled metric set :: PS FPU1 Pipe Active */
#define icl__l3_3__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Gen11 L2Bank1 stalled metric set :: PS Send Pipeline Active */
#define icl__l3_3__ps_send_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Gen11 L2Bank1 stalled metric set :: FS Both FPU Active */
#define icl__l3_3__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_send_active__read

/* Gen11 L2Bank1 stalled metric set :: Slice0 L3 Bank1 Stalled */
#define icl__l3_3__l30_bank1_stalled__read \
    icl__l3_2__l30_bank0_stalled__read

/* Gen11 L2Bank4 stalled metric set :: GPU Time Elapsed */
#define icl__l3_4__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Gen11 L2Bank4 stalled metric set :: GPU Core Clocks */
#define icl__l3_4__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Gen11 L2Bank4 stalled metric set :: AVG GPU Core Frequency */
#define icl__l3_4__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Gen11 L2Bank4 stalled metric set :: AVG GPU Core Frequency */
#define icl__l3_4__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Gen11 L2Bank4 stalled metric set :: GPU Busy */
#define icl__l3_4__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Gen11 L2Bank4 stalled metric set :: VS Threads Dispatched */
#define icl__l3_4__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Gen11 L2Bank4 stalled metric set :: HS Threads Dispatched */
#define icl__l3_4__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Gen11 L2Bank4 stalled metric set :: DS Threads Dispatched */
#define icl__l3_4__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Gen11 L2Bank4 stalled metric set :: GS Threads Dispatched */
#define icl__l3_4__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Gen11 L2Bank4 stalled metric set :: FS Threads Dispatched */
#define icl__l3_4__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Gen11 L2Bank4 stalled metric set :: CS Threads Dispatched */
#define icl__l3_4__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Gen11 L2Bank4 stalled metric set :: Rasterized Pixels */
#define icl__l3_4__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Gen11 L2Bank4 stalled metric set :: Early Hi-Depth Test Fails */
#define icl__l3_4__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Gen11 L2Bank4 stalled metric set :: Early Depth Test Fails */
#define icl__l3_4__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Gen11 L2Bank4 stalled metric set :: Samples Killed in FS */
#define icl__l3_4__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Gen11 L2Bank4 stalled metric set :: Pixels Failing Tests */
#define icl__l3_4__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Gen11 L2Bank4 stalled metric set :: Samples Written */
#define icl__l3_4__samples_written__read \
    bdw__render_basic__samples_written__read

/* Gen11 L2Bank4 stalled metric set :: Samples Blended */
#define icl__l3_4__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Gen11 L2Bank4 stalled metric set :: EU Active */
#define icl__l3_4__eu_active__read \
    bdw__render_basic__eu_active__read

/* Gen11 L2Bank4 stalled metric set :: EU Stall */
#define icl__l3_4__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Gen11 L2Bank4 stalled metric set :: EU Both FPU Pipes Active */
#define icl__l3_4__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Gen11 L2Bank4 stalled metric set :: EU Thread Occupancy */
#define icl__l3_4__eu_thread_occupancy__read \
    bdw__vme_pipe__eu_thread_occupancy__read

/* Gen11 L2Bank4 stalled metric set :: VS FPU0 Pipe Active */
#define icl__l3_4__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Gen11 L2Bank4 stalled metric set :: VS FPU1 Pipe Active */
#define icl__l3_4__vs_fpu1_active__read \
    bdw__render_basic__vs_send_active__read

/* Gen11 L2Bank4 stalled metric set :: VS Send Pipe Active */
#define icl__l3_4__vs_send_active__read \
    bdw__compute_l3_cache__eu_hybrid_fpu0_instruction__read

/* Gen11 L2Bank4 stalled metric set :: PS FPU0 Pipe Active */
#define icl__l3_4__ps_fpu0_active__read \
    bdw__compute_l3_cache__eu_hybrid_fpu1_instruction__read

/* Gen11 L2Bank4 stalled metric set :: PS FPU1 Pipe Active */
#define icl__l3_4__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Gen11 L2Bank4 stalled metric set :: PS Send Pipeline Active */
#define icl__l3_4__ps_send_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Gen11 L2Bank4 stalled metric set :: FS Both FPU Active */
#define icl__l3_4__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_send_active__read

/* Gen11 L2Bank4 stalled metric set :: Slice0 L3 Bank4 Stalled */
#define icl__l3_4__l30_bank4_stalled__read \
    icl__l3_2__l30_bank0_stalled__read

/* Gen11 L2Bank5 stalled metric set :: GPU Time Elapsed */
#define icl__l3_5__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Gen11 L2Bank5 stalled metric set :: GPU Core Clocks */
#define icl__l3_5__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Gen11 L2Bank5 stalled metric set :: AVG GPU Core Frequency */
#define icl__l3_5__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Gen11 L2Bank5 stalled metric set :: AVG GPU Core Frequency */
#define icl__l3_5__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Gen11 L2Bank5 stalled metric set :: GPU Busy */
#define icl__l3_5__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Gen11 L2Bank5 stalled metric set :: VS Threads Dispatched */
#define icl__l3_5__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Gen11 L2Bank5 stalled metric set :: HS Threads Dispatched */
#define icl__l3_5__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Gen11 L2Bank5 stalled metric set :: DS Threads Dispatched */
#define icl__l3_5__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Gen11 L2Bank5 stalled metric set :: GS Threads Dispatched */
#define icl__l3_5__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Gen11 L2Bank5 stalled metric set :: FS Threads Dispatched */
#define icl__l3_5__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Gen11 L2Bank5 stalled metric set :: CS Threads Dispatched */
#define icl__l3_5__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Gen11 L2Bank5 stalled metric set :: Rasterized Pixels */
#define icl__l3_5__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Gen11 L2Bank5 stalled metric set :: Early Hi-Depth Test Fails */
#define icl__l3_5__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Gen11 L2Bank5 stalled metric set :: Early Depth Test Fails */
#define icl__l3_5__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Gen11 L2Bank5 stalled metric set :: Samples Killed in FS */
#define icl__l3_5__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Gen11 L2Bank5 stalled metric set :: Pixels Failing Tests */
#define icl__l3_5__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Gen11 L2Bank5 stalled metric set :: Samples Written */
#define icl__l3_5__samples_written__read \
    bdw__render_basic__samples_written__read

/* Gen11 L2Bank5 stalled metric set :: Samples Blended */
#define icl__l3_5__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Gen11 L2Bank5 stalled metric set :: EU Active */
#define icl__l3_5__eu_active__read \
    bdw__render_basic__eu_active__read

/* Gen11 L2Bank5 stalled metric set :: EU Stall */
#define icl__l3_5__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Gen11 L2Bank5 stalled metric set :: EU Both FPU Pipes Active */
#define icl__l3_5__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Gen11 L2Bank5 stalled metric set :: EU Thread Occupancy */
#define icl__l3_5__eu_thread_occupancy__read \
    bdw__vme_pipe__eu_thread_occupancy__read

/* Gen11 L2Bank5 stalled metric set :: VS FPU0 Pipe Active */
#define icl__l3_5__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Gen11 L2Bank5 stalled metric set :: VS FPU1 Pipe Active */
#define icl__l3_5__vs_fpu1_active__read \
    bdw__render_basic__vs_send_active__read

/* Gen11 L2Bank5 stalled metric set :: VS Send Pipe Active */
#define icl__l3_5__vs_send_active__read \
    bdw__compute_l3_cache__eu_hybrid_fpu0_instruction__read

/* Gen11 L2Bank5 stalled metric set :: PS FPU0 Pipe Active */
#define icl__l3_5__ps_fpu0_active__read \
    bdw__compute_l3_cache__eu_hybrid_fpu1_instruction__read

/* Gen11 L2Bank5 stalled metric set :: PS FPU1 Pipe Active */
#define icl__l3_5__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Gen11 L2Bank5 stalled metric set :: PS Send Pipeline Active */
#define icl__l3_5__ps_send_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Gen11 L2Bank5 stalled metric set :: FS Both FPU Active */
#define icl__l3_5__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_send_active__read

/* Gen11 L2Bank5 stalled metric set :: Slice0 L3 Bank5 Stalled */
static double
icl__l3_5__l30_bank5_stalled__read(const struct intel_perf *perf,
                                   const struct intel_perf_metric_set *metric_set,
                                   uint64_t *accumulator)
{
    /* RPN equation: B 2 READ B 3 READ FADD B 0 READ FADD B 1 READ FADD 4 FDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 2];
    uint64_t tmp1 = accumulator[metric_set->b_offset + 3];
    double tmp2 = tmp0 + tmp1;
    uint64_t tmp3 = accumulator[metric_set->b_offset + 0];
    double tmp4 = tmp2 + tmp3;
    uint64_t tmp5 = accumulator[metric_set->b_offset + 1];
    double tmp6 = tmp4 + tmp5;
    double tmp7 = tmp6;
    double tmp8 = 4;
    double tmp9 = tmp8 ? tmp7 / tmp8 : 0;
    uint64_t tmp10 = tmp9 * 100;
    double tmp11 = tmp10;
    double tmp12 = icl__l3_5__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp13 = tmp12 ? tmp11 / tmp12 : 0;

    return tmp13;
}

/* Metric set Sampler 1 :: GPU Time Elapsed */
#define icl__sampler_1__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set Sampler 1 :: GPU Core Clocks */
#define icl__sampler_1__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set Sampler 1 :: AVG GPU Core Frequency */
#define icl__sampler_1__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set Sampler 1 :: AVG GPU Core Frequency */
#define icl__sampler_1__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set Sampler 1 :: GPU Busy */
#define icl__sampler_1__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set Sampler 1 :: VS Threads Dispatched */
#define icl__sampler_1__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set Sampler 1 :: HS Threads Dispatched */
#define icl__sampler_1__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set Sampler 1 :: DS Threads Dispatched */
#define icl__sampler_1__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set Sampler 1 :: GS Threads Dispatched */
#define icl__sampler_1__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set Sampler 1 :: FS Threads Dispatched */
#define icl__sampler_1__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set Sampler 1 :: CS Threads Dispatched */
#define icl__sampler_1__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set Sampler 1 :: EU Active */
#define icl__sampler_1__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set Sampler 1 :: EU Stall */
#define icl__sampler_1__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set Sampler 1 :: EU Both FPU Pipes Active */
#define icl__sampler_1__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set Sampler 1 :: VS FPU0 Pipe Active */
#define icl__sampler_1__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set Sampler 1 :: VS FPU1 Pipe Active */
#define icl__sampler_1__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set Sampler 1 :: VS Send Pipe Active */
#define icl__sampler_1__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set Sampler 1 :: PS FPU0 Pipe Active */
#define icl__sampler_1__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set Sampler 1 :: PS FPU1 Pipe Active */
#define icl__sampler_1__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set Sampler 1 :: PS Send Pipeline Active */
#define icl__sampler_1__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set Sampler 1 :: FS Both FPU Active */
#define icl__sampler_1__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set Sampler 1 :: Rasterized Pixels */
#define icl__sampler_1__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set Sampler 1 :: Early Hi-Depth Test Fails */
#define icl__sampler_1__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set Sampler 1 :: Early Depth Test Fails */
#define icl__sampler_1__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set Sampler 1 :: Samples Killed in FS */
#define icl__sampler_1__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set Sampler 1 :: Pixels Failing Tests */
#define icl__sampler_1__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set Sampler 1 :: Samples Written */
#define icl__sampler_1__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set Sampler 1 :: Samples Blended */
#define icl__sampler_1__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set Sampler 1 :: Sampler Texels */
#define icl__sampler_1__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set Sampler 1 :: Sampler Texels Misses */
#define icl__sampler_1__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set Sampler 1 :: SLM Bytes Read */
#define icl__sampler_1__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set Sampler 1 :: SLM Bytes Read */
#define icl__sampler_1__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set Sampler 1 :: SLM Bytes Written */
#define icl__sampler_1__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set Sampler 1 :: SLM Bytes Written */
#define icl__sampler_1__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set Sampler 1 :: Shader Memory Accesses */
#define icl__sampler_1__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set Sampler 1 :: Shader Atomic Memory Accesses */
#define icl__sampler_1__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set Sampler 1 :: L3 Shader Throughput */
#define icl__sampler_1__l3_shader_throughput__read \
    icl__render_basic__l3_shader_throughput__read

/* Metric set Sampler 1 :: L3 Shader Throughput */
#define icl__sampler_1__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set Sampler 1 :: Shader Barrier Messages */
#define icl__sampler_1__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set Sampler 1 :: Slice0 Subslice0 Input Available */
#define icl__sampler_1__sampler00_input_available__read \
    bdw__render_pipe_profile__early_depth_bottleneck__read

/* Metric set Sampler 1 :: Slice0 Subslice1 Input Available */
#define icl__sampler_1__sampler01_input_available__read \
    bdw__render_pipe_profile__sf_bottleneck__read

/* Metric set Sampler 1 :: Slice0 Subslice2 Input Available */
#define icl__sampler_1__sampler02_input_available__read \
    bdw__render_pipe_profile__cl_bottleneck__read

/* Metric set Sampler 1 :: Slice0 Subslice3 Input Available */
#define icl__sampler_1__sampler03_input_available__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* Metric set Sampler 1 :: Slice0 Subslice4 Input Available */
#define icl__sampler_1__sampler04_input_available__read \
    bdw__render_basic__sampler1_bottleneck__read

/* Metric set Sampler 1 :: Slice0 Subslice5 Input Available */
#define icl__sampler_1__sampler05_input_available__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Metric set Sampler 1 :: Slice0 Subslice6 Input Available */
#define icl__sampler_1__sampler06_input_available__read \
    bdw__render_basic__sampler1_busy__read

/* Metric set Sampler 1 :: Slice0 Subslice7 Input Available */
#define icl__sampler_1__sampler07_input_available__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set Sampler 2 :: GPU Time Elapsed */
#define icl__sampler_2__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set Sampler 2 :: GPU Core Clocks */
#define icl__sampler_2__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set Sampler 2 :: AVG GPU Core Frequency */
#define icl__sampler_2__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set Sampler 2 :: AVG GPU Core Frequency */
#define icl__sampler_2__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set Sampler 2 :: GPU Busy */
#define icl__sampler_2__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set Sampler 2 :: VS Threads Dispatched */
#define icl__sampler_2__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set Sampler 2 :: HS Threads Dispatched */
#define icl__sampler_2__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set Sampler 2 :: DS Threads Dispatched */
#define icl__sampler_2__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set Sampler 2 :: GS Threads Dispatched */
#define icl__sampler_2__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set Sampler 2 :: FS Threads Dispatched */
#define icl__sampler_2__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set Sampler 2 :: CS Threads Dispatched */
#define icl__sampler_2__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set Sampler 2 :: EU Active */
#define icl__sampler_2__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set Sampler 2 :: EU Stall */
#define icl__sampler_2__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set Sampler 2 :: EU Both FPU Pipes Active */
#define icl__sampler_2__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set Sampler 2 :: VS FPU0 Pipe Active */
#define icl__sampler_2__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set Sampler 2 :: VS FPU1 Pipe Active */
#define icl__sampler_2__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set Sampler 2 :: VS Send Pipe Active */
#define icl__sampler_2__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set Sampler 2 :: PS FPU0 Pipe Active */
#define icl__sampler_2__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set Sampler 2 :: PS FPU1 Pipe Active */
#define icl__sampler_2__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set Sampler 2 :: PS Send Pipeline Active */
#define icl__sampler_2__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set Sampler 2 :: FS Both FPU Active */
#define icl__sampler_2__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set Sampler 2 :: Rasterized Pixels */
#define icl__sampler_2__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set Sampler 2 :: Early Hi-Depth Test Fails */
#define icl__sampler_2__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set Sampler 2 :: Early Depth Test Fails */
#define icl__sampler_2__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set Sampler 2 :: Samples Killed in FS */
#define icl__sampler_2__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set Sampler 2 :: Pixels Failing Tests */
#define icl__sampler_2__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set Sampler 2 :: Samples Written */
#define icl__sampler_2__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set Sampler 2 :: Samples Blended */
#define icl__sampler_2__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set Sampler 2 :: Sampler Texels */
#define icl__sampler_2__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set Sampler 2 :: Sampler Texels Misses */
#define icl__sampler_2__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set Sampler 2 :: SLM Bytes Read */
#define icl__sampler_2__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set Sampler 2 :: SLM Bytes Read */
#define icl__sampler_2__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set Sampler 2 :: SLM Bytes Written */
#define icl__sampler_2__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set Sampler 2 :: SLM Bytes Written */
#define icl__sampler_2__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set Sampler 2 :: Shader Memory Accesses */
#define icl__sampler_2__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set Sampler 2 :: Shader Atomic Memory Accesses */
#define icl__sampler_2__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set Sampler 2 :: L3 Shader Throughput */
#define icl__sampler_2__l3_shader_throughput__read \
    icl__render_basic__l3_shader_throughput__read

/* Metric set Sampler 2 :: L3 Shader Throughput */
#define icl__sampler_2__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set Sampler 2 :: Shader Barrier Messages */
#define icl__sampler_2__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set Sampler 2 :: Slice0 Subslice0 Sampler Output Ready */
#define icl__sampler_2__sampler00_output_ready__read \
    bdw__render_pipe_profile__vf_bottleneck__read

/* Metric set Sampler 2 :: Slice0 Subslice1 Sampler Output Ready */
#define icl__sampler_2__sampler01_output_ready__read \
    bdw__render_pipe_profile__hs_stall__read

/* Metric set Sampler 2 :: Slice0 Subslice2 Sampler Output Ready */
#define icl__sampler_2__sampler02_output_ready__read \
    bdw__render_pipe_profile__ds_stall__read

/* Metric set Sampler 2 :: Slice0 Subslice3 Sampler Output Ready */
#define icl__sampler_2__sampler03_output_ready__read \
    bdw__render_pipe_profile__so_stall__read

/* Metric set Sampler 2 :: Slice0 Subslice4 Sampler Output Ready */
#define icl__sampler_2__sampler04_output_ready__read \
    bdw__render_pipe_profile__cl_stall__read

/* Metric set Sampler 2 :: Slice0 Subslice5 Sampler Output Ready */
#define icl__sampler_2__sampler05_output_ready__read \
    bdw__render_pipe_profile__sf_stall__read

/* Metric set Sampler 2 :: Slice0 Subslice6 Sampler Output Ready */
#define icl__sampler_2__sampler06_output_ready__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set Sampler 2 :: Slice0 Subslice7 Sampler Output Ready */
#define icl__sampler_2__sampler07_output_ready__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set Sampler 2 :: SQ is full */
#define icl__sampler_2__gt_request_queue_full__read \
    bdw__render_pipe_profile__early_depth_bottleneck__read

/* Metric set TDL_1 :: GPU Time Elapsed */
#define icl__tdl_1__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set TDL_1 :: GPU Core Clocks */
#define icl__tdl_1__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set TDL_1 :: AVG GPU Core Frequency */
#define icl__tdl_1__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set TDL_1 :: AVG GPU Core Frequency */
#define icl__tdl_1__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set TDL_1 :: GPU Busy */
#define icl__tdl_1__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set TDL_1 :: VS Threads Dispatched */
#define icl__tdl_1__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set TDL_1 :: HS Threads Dispatched */
#define icl__tdl_1__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set TDL_1 :: DS Threads Dispatched */
#define icl__tdl_1__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set TDL_1 :: GS Threads Dispatched */
#define icl__tdl_1__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set TDL_1 :: FS Threads Dispatched */
#define icl__tdl_1__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set TDL_1 :: CS Threads Dispatched */
#define icl__tdl_1__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set TDL_1 :: EU Active */
#define icl__tdl_1__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set TDL_1 :: EU Stall */
#define icl__tdl_1__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set TDL_1 :: EU Both FPU Pipes Active */
#define icl__tdl_1__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set TDL_1 :: VS FPU0 Pipe Active */
#define icl__tdl_1__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set TDL_1 :: VS FPU1 Pipe Active */
#define icl__tdl_1__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set TDL_1 :: VS Send Pipe Active */
#define icl__tdl_1__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set TDL_1 :: VS EU Active */
#define icl__tdl_1__vs_eu_active__read \
    bdw__compute_l3_cache__eu_hybrid_fpu0_instruction__read

/* Metric set TDL_1 :: VS AVG Active per Thread */
static uint64_t
icl__tdl_1__vs_eu_active_per_thread__read(const struct intel_perf *perf,
                                          const struct intel_perf_metric_set *metric_set,
                                          uint64_t *accumulator)
{
    /* RPN equation: A 13 READ A 1 READ UDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 13];
    uint64_t tmp1 = accumulator[metric_set->a_offset + 1];
    uint64_t tmp2 = tmp0;
    uint64_t tmp3 = tmp1;
    uint64_t tmp4 = tmp3 ? tmp2 / tmp3 : 0;

    return tmp4;
}

/* Metric set TDL_1 :: VS EU Stall */
#define icl__tdl_1__vs_eu_stall__read \
    bdw__compute_l3_cache__eu_hybrid_fpu1_instruction__read

/* Metric set TDL_1 :: VS AVG Stall per Thread */
static uint64_t
icl__tdl_1__vs_eu_stall_per_thread__read(const struct intel_perf *perf,
                                         const struct intel_perf_metric_set *metric_set,
                                         uint64_t *accumulator)
{
    /* RPN equation: A 14 READ A 1 READ UDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 14];
    uint64_t tmp1 = accumulator[metric_set->a_offset + 1];
    uint64_t tmp2 = tmp0;
    uint64_t tmp3 = tmp1;
    uint64_t tmp4 = tmp3 ? tmp2 / tmp3 : 0;

    return tmp4;
}

/* Metric set TDL_1 :: PS FPU0 Pipe Active */
#define icl__tdl_1__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set TDL_1 :: PS FPU1 Pipe Active */
#define icl__tdl_1__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set TDL_1 :: PS Send Pipeline Active */
#define icl__tdl_1__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set TDL_1 :: FS Both FPU Active */
#define icl__tdl_1__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set TDL_1 :: FS EU Active */
#define icl__tdl_1__ps_eu_active__read \
    bdw__compute_l3_cache__eu_move_fpu0_instruction__read

/* Metric set TDL_1 :: FS AVG Active per Thread */
static uint64_t
icl__tdl_1__ps_eu_active_per_thread__read(const struct intel_perf *perf,
                                          const struct intel_perf_metric_set *metric_set,
                                          uint64_t *accumulator)
{
    /* RPN equation: A 19 READ A 6 READ UDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 19];
    uint64_t tmp1 = accumulator[metric_set->a_offset + 6];
    uint64_t tmp2 = tmp0;
    uint64_t tmp3 = tmp1;
    uint64_t tmp4 = tmp3 ? tmp2 / tmp3 : 0;

    return tmp4;
}

/* Metric set TDL_1 :: FS EU Stall */
#define icl__tdl_1__ps_eu_stall__read \
    bdw__compute_l3_cache__eu_move_fpu1_instruction__read

/* Metric set TDL_1 :: FS AVG Stall per Thread */
static uint64_t
icl__tdl_1__ps_eu_stall_per_thread__read(const struct intel_perf *perf,
                                         const struct intel_perf_metric_set *metric_set,
                                         uint64_t *accumulator)
{
    /* RPN equation: A 20 READ A 6 READ UDIV */
    uint64_t tmp0 = accumulator[metric_set->a_offset + 20];
    uint64_t tmp1 = accumulator[metric_set->a_offset + 6];
    uint64_t tmp2 = tmp0;
    uint64_t tmp3 = tmp1;
    uint64_t tmp4 = tmp3 ? tmp2 / tmp3 : 0;

    return tmp4;
}

/* Metric set TDL_1 :: Rasterized Pixels */
#define icl__tdl_1__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set TDL_1 :: Early Hi-Depth Test Fails */
#define icl__tdl_1__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set TDL_1 :: Early Depth Test Fails */
#define icl__tdl_1__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set TDL_1 :: Samples Killed in FS */
#define icl__tdl_1__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set TDL_1 :: Pixels Failing Tests */
#define icl__tdl_1__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set TDL_1 :: Samples Written */
#define icl__tdl_1__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set TDL_1 :: Samples Blended */
#define icl__tdl_1__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set TDL_1 :: Sampler Texels */
#define icl__tdl_1__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set TDL_1 :: Sampler Texels Misses */
#define icl__tdl_1__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set TDL_1 :: SLM Bytes Read */
#define icl__tdl_1__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set TDL_1 :: SLM Bytes Read */
#define icl__tdl_1__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_1 :: SLM Bytes Written */
#define icl__tdl_1__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set TDL_1 :: SLM Bytes Written */
#define icl__tdl_1__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_1 :: Shader Memory Accesses */
#define icl__tdl_1__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set TDL_1 :: Shader Atomic Memory Accesses */
#define icl__tdl_1__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set TDL_1 :: L3 Shader Throughput */
#define icl__tdl_1__l3_shader_throughput__read \
    icl__render_basic__l3_shader_throughput__read

/* Metric set TDL_1 :: L3 Shader Throughput */
#define icl__tdl_1__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_1 :: Shader Barrier Messages */
#define icl__tdl_1__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set TDL_1 :: PS Thread Ready For Dispatch on Slice0 Subslice0 Thread Dispatcher */
#define icl__tdl_1__ps_thread00_ready_for_dispatch__read \
    bdw__render_pipe_profile__early_depth_bottleneck__read

/* Metric set TDL_1 :: PS Thread Ready For Dispatch on Slice0 Subslice1 Thread Dispatcher */
#define icl__tdl_1__ps_thread01_ready_for_dispatch__read \
    bdw__render_pipe_profile__sf_bottleneck__read

/* Metric set TDL_1 :: PS Thread Ready For Dispatch on Slice0 Subslice2 Thread Dispatcher */
#define icl__tdl_1__ps_thread02_ready_for_dispatch__read \
    bdw__render_pipe_profile__cl_bottleneck__read

/* Metric set TDL_1 :: PS Thread Ready For Dispatch on Slice0 Subslice3 Thread Dispatcher */
#define icl__tdl_1__ps_thread03_ready_for_dispatch__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* Metric set TDL_1 :: PS Thread Ready For Dispatch on Slice0 Subslice4 Thread Dispatcher */
#define icl__tdl_1__ps_thread04_ready_for_dispatch__read \
    bdw__render_basic__sampler1_bottleneck__read

/* Metric set TDL_1 :: PS Thread Ready For Dispatch on Slice0 Subslice5 Thread Dispatcher */
#define icl__tdl_1__ps_thread05_ready_for_dispatch__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Metric set TDL_1 :: PS Thread Ready For Dispatch on Slice0 Subslice6 Thread Dispatcher */
#define icl__tdl_1__ps_thread06_ready_for_dispatch__read \
    bdw__render_basic__sampler1_busy__read

/* Metric set TDL_1 :: PS Thread Ready For Dispatch on Slice0 Subslice7 Thread Dispatcher */
#define icl__tdl_1__ps_thread07_ready_for_dispatch__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set TDL_2 :: GPU Time Elapsed */
#define icl__tdl_2__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set TDL_2 :: GPU Core Clocks */
#define icl__tdl_2__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set TDL_2 :: AVG GPU Core Frequency */
#define icl__tdl_2__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set TDL_2 :: AVG GPU Core Frequency */
#define icl__tdl_2__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set TDL_2 :: GPU Busy */
#define icl__tdl_2__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set TDL_2 :: VS Threads Dispatched */
#define icl__tdl_2__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set TDL_2 :: HS Threads Dispatched */
#define icl__tdl_2__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set TDL_2 :: DS Threads Dispatched */
#define icl__tdl_2__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set TDL_2 :: GS Threads Dispatched */
#define icl__tdl_2__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set TDL_2 :: FS Threads Dispatched */
#define icl__tdl_2__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set TDL_2 :: CS Threads Dispatched */
#define icl__tdl_2__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set TDL_2 :: EU Active */
#define icl__tdl_2__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set TDL_2 :: EU Stall */
#define icl__tdl_2__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set TDL_2 :: EU Both FPU Pipes Active */
#define icl__tdl_2__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set TDL_2 :: VS FPU0 Pipe Active */
#define icl__tdl_2__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set TDL_2 :: VS FPU1 Pipe Active */
#define icl__tdl_2__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set TDL_2 :: VS Send Pipe Active */
#define icl__tdl_2__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set TDL_2 :: PS FPU0 Pipe Active */
#define icl__tdl_2__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set TDL_2 :: PS FPU1 Pipe Active */
#define icl__tdl_2__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set TDL_2 :: PS Send Pipeline Active */
#define icl__tdl_2__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set TDL_2 :: FS Both FPU Active */
#define icl__tdl_2__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set TDL_2 :: Rasterized Pixels */
#define icl__tdl_2__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set TDL_2 :: Early Hi-Depth Test Fails */
#define icl__tdl_2__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set TDL_2 :: Early Depth Test Fails */
#define icl__tdl_2__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set TDL_2 :: Samples Killed in FS */
#define icl__tdl_2__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set TDL_2 :: Pixels Failing Tests */
#define icl__tdl_2__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set TDL_2 :: Samples Written */
#define icl__tdl_2__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set TDL_2 :: Samples Blended */
#define icl__tdl_2__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set TDL_2 :: Sampler Texels */
#define icl__tdl_2__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set TDL_2 :: Sampler Texels Misses */
#define icl__tdl_2__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set TDL_2 :: SLM Bytes Read */
#define icl__tdl_2__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set TDL_2 :: SLM Bytes Read */
#define icl__tdl_2__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_2 :: SLM Bytes Written */
#define icl__tdl_2__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set TDL_2 :: SLM Bytes Written */
#define icl__tdl_2__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_2 :: Shader Memory Accesses */
#define icl__tdl_2__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set TDL_2 :: Shader Atomic Memory Accesses */
#define icl__tdl_2__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set TDL_2 :: L3 Shader Throughput */
#define icl__tdl_2__l3_shader_throughput__read \
    icl__render_basic__l3_shader_throughput__read

/* Metric set TDL_2 :: L3 Shader Throughput */
#define icl__tdl_2__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_2 :: Shader Barrier Messages */
#define icl__tdl_2__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set TDL_2 :: Non-PS Thread Ready For Dispatch on Slice0 Subslice0 Thread Dispatcher */
static double
icl__tdl_2__non_ps_thread00_ready_for_dispatch__read(const struct intel_perf *perf,
                                                     const struct intel_perf_metric_set *metric_set,
                                                     uint64_t *accumulator)
{
    /* RPN equation: GPU_CLOCK 0 READ B 7 READ FSUB 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->gpu_clock_offset + 0];
    uint64_t tmp1 = accumulator[metric_set->b_offset + 7];
    double tmp2 = tmp0 - tmp1;
    uint64_t tmp3 = tmp2 * 100;
    double tmp4 = tmp3;
    double tmp5 = icl__tdl_2__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp6 = tmp5 ? tmp4 / tmp5 : 0;

    return tmp6;
}

/* Metric set TDL_2 :: Non-PS Thread Ready For Dispatch on Slice0 Subslice1 Thread Dispatcher */
static double
icl__tdl_2__non_ps_thread01_ready_for_dispatch__read(const struct intel_perf *perf,
                                                     const struct intel_perf_metric_set *metric_set,
                                                     uint64_t *accumulator)
{
    /* RPN equation: GPU_CLOCK 0 READ C 0 READ FSUB 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->gpu_clock_offset + 0];
    uint64_t tmp1 = accumulator[metric_set->c_offset + 0];
    double tmp2 = tmp0 - tmp1;
    uint64_t tmp3 = tmp2 * 100;
    double tmp4 = tmp3;
    double tmp5 = icl__tdl_2__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp6 = tmp5 ? tmp4 / tmp5 : 0;

    return tmp6;
}

/* Metric set TDL_2 :: Non-PS Thread Ready For Dispatch on Slice0 Subslice2 Thread Dispatcher */
static double
icl__tdl_2__non_ps_thread02_ready_for_dispatch__read(const struct intel_perf *perf,
                                                     const struct intel_perf_metric_set *metric_set,
                                                     uint64_t *accumulator)
{
    /* RPN equation: GPU_CLOCK 0 READ C 1 READ FSUB 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->gpu_clock_offset + 0];
    uint64_t tmp1 = accumulator[metric_set->c_offset + 1];
    double tmp2 = tmp0 - tmp1;
    uint64_t tmp3 = tmp2 * 100;
    double tmp4 = tmp3;
    double tmp5 = icl__tdl_2__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp6 = tmp5 ? tmp4 / tmp5 : 0;

    return tmp6;
}

/* Metric set TDL_2 :: Non-PS Thread Ready For Dispatch on Slice0 Subslice3 Thread Dispatcher */
static double
icl__tdl_2__non_ps_thread03_ready_for_dispatch__read(const struct intel_perf *perf,
                                                     const struct intel_perf_metric_set *metric_set,
                                                     uint64_t *accumulator)
{
    /* RPN equation: GPU_CLOCK 0 READ C 2 READ FSUB 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->gpu_clock_offset + 0];
    uint64_t tmp1 = accumulator[metric_set->c_offset + 2];
    double tmp2 = tmp0 - tmp1;
    uint64_t tmp3 = tmp2 * 100;
    double tmp4 = tmp3;
    double tmp5 = icl__tdl_2__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp6 = tmp5 ? tmp4 / tmp5 : 0;

    return tmp6;
}

/* Metric set TDL_2 :: Non-PS Thread Ready For Dispatch on Slice0 Subslice4 Thread Dispatcher */
static double
icl__tdl_2__non_ps_thread04_ready_for_dispatch__read(const struct intel_perf *perf,
                                                     const struct intel_perf_metric_set *metric_set,
                                                     uint64_t *accumulator)
{
    /* RPN equation: GPU_CLOCK 0 READ C 3 READ FSUB 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->gpu_clock_offset + 0];
    uint64_t tmp1 = accumulator[metric_set->c_offset + 3];
    double tmp2 = tmp0 - tmp1;
    uint64_t tmp3 = tmp2 * 100;
    double tmp4 = tmp3;
    double tmp5 = icl__tdl_2__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp6 = tmp5 ? tmp4 / tmp5 : 0;

    return tmp6;
}

/* Metric set TDL_2 :: Non-PS Thread Ready For Dispatch on Slice0 Subslice5 Thread Dispatcher */
static double
icl__tdl_2__non_ps_thread05_ready_for_dispatch__read(const struct intel_perf *perf,
                                                     const struct intel_perf_metric_set *metric_set,
                                                     uint64_t *accumulator)
{
    /* RPN equation: GPU_CLOCK 0 READ C 4 READ FSUB 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->gpu_clock_offset + 0];
    uint64_t tmp1 = accumulator[metric_set->c_offset + 4];
    double tmp2 = tmp0 - tmp1;
    uint64_t tmp3 = tmp2 * 100;
    double tmp4 = tmp3;
    double tmp5 = icl__tdl_2__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp6 = tmp5 ? tmp4 / tmp5 : 0;

    return tmp6;
}

/* Metric set TDL_2 :: Non-PS Thread Ready For Dispatch on Slice0 Subslice6 Thread Dispatcher */
static double
icl__tdl_2__non_ps_thread06_ready_for_dispatch__read(const struct intel_perf *perf,
                                                     const struct intel_perf_metric_set *metric_set,
                                                     uint64_t *accumulator)
{
    /* RPN equation: GPU_CLOCK 0 READ C 5 READ FSUB 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->gpu_clock_offset + 0];
    uint64_t tmp1 = accumulator[metric_set->c_offset + 5];
    double tmp2 = tmp0 - tmp1;
    uint64_t tmp3 = tmp2 * 100;
    double tmp4 = tmp3;
    double tmp5 = icl__tdl_2__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp6 = tmp5 ? tmp4 / tmp5 : 0;

    return tmp6;
}

/* Metric set TDL_2 :: Non-PS Thread Ready For Dispatch on Slice0 Subslice7 Thread Dispatcher */
static double
icl__tdl_2__non_ps_thread07_ready_for_dispatch__read(const struct intel_perf *perf,
                                                     const struct intel_perf_metric_set *metric_set,
                                                     uint64_t *accumulator)
{
    /* RPN equation: GPU_CLOCK 0 READ C 6 READ FSUB 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->gpu_clock_offset + 0];
    uint64_t tmp1 = accumulator[metric_set->c_offset + 6];
    double tmp2 = tmp0 - tmp1;
    uint64_t tmp3 = tmp2 * 100;
    double tmp4 = tmp3;
    double tmp5 = icl__tdl_2__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp6 = tmp5 ? tmp4 / tmp5 : 0;

    return tmp6;
}

/* Metric set TDL_2 :: SQ is full */
#define icl__tdl_2__gt_request_queue_full__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set TDL_3 :: GPU Time Elapsed */
#define icl__tdl_3__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set TDL_3 :: GPU Core Clocks */
#define icl__tdl_3__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set TDL_3 :: AVG GPU Core Frequency */
#define icl__tdl_3__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set TDL_3 :: AVG GPU Core Frequency */
#define icl__tdl_3__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set TDL_3 :: GPU Busy */
#define icl__tdl_3__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set TDL_3 :: VS Threads Dispatched */
#define icl__tdl_3__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set TDL_3 :: HS Threads Dispatched */
#define icl__tdl_3__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set TDL_3 :: DS Threads Dispatched */
#define icl__tdl_3__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set TDL_3 :: GS Threads Dispatched */
#define icl__tdl_3__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set TDL_3 :: FS Threads Dispatched */
#define icl__tdl_3__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set TDL_3 :: CS Threads Dispatched */
#define icl__tdl_3__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set TDL_3 :: EU Active */
#define icl__tdl_3__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set TDL_3 :: EU Stall */
#define icl__tdl_3__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set TDL_3 :: EU Both FPU Pipes Active */
#define icl__tdl_3__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set TDL_3 :: VS FPU0 Pipe Active */
#define icl__tdl_3__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set TDL_3 :: VS FPU1 Pipe Active */
#define icl__tdl_3__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set TDL_3 :: VS Send Pipe Active */
#define icl__tdl_3__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set TDL_3 :: PS FPU0 Pipe Active */
#define icl__tdl_3__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set TDL_3 :: PS FPU1 Pipe Active */
#define icl__tdl_3__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set TDL_3 :: PS Send Pipeline Active */
#define icl__tdl_3__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set TDL_3 :: FS Both FPU Active */
#define icl__tdl_3__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set TDL_3 :: Rasterized Pixels */
#define icl__tdl_3__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set TDL_3 :: Early Hi-Depth Test Fails */
#define icl__tdl_3__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set TDL_3 :: Early Depth Test Fails */
#define icl__tdl_3__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set TDL_3 :: Samples Killed in FS */
#define icl__tdl_3__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set TDL_3 :: Pixels Failing Tests */
#define icl__tdl_3__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set TDL_3 :: Samples Written */
#define icl__tdl_3__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set TDL_3 :: Samples Blended */
#define icl__tdl_3__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set TDL_3 :: Sampler Texels */
#define icl__tdl_3__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set TDL_3 :: Sampler Texels Misses */
#define icl__tdl_3__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set TDL_3 :: SLM Bytes Read */
#define icl__tdl_3__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set TDL_3 :: SLM Bytes Read */
#define icl__tdl_3__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_3 :: SLM Bytes Written */
#define icl__tdl_3__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set TDL_3 :: SLM Bytes Written */
#define icl__tdl_3__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_3 :: Shader Memory Accesses */
#define icl__tdl_3__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set TDL_3 :: Shader Atomic Memory Accesses */
#define icl__tdl_3__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set TDL_3 :: L3 Shader Throughput */
#define icl__tdl_3__l3_shader_throughput__read \
    icl__render_basic__l3_shader_throughput__read

/* Metric set TDL_3 :: L3 Shader Throughput */
#define icl__tdl_3__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_3 :: Shader Barrier Messages */
#define icl__tdl_3__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set TDL_3 :: Thread Header Ready on Slice0 Subslice0 Thread Dispatcher Port 0 */
#define icl__tdl_3__thread_header00_ready_port0__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set TDL_3 :: Thread Header Ready on Slice0 Subslice0 Thread Dispatcher Port 1 */
#define icl__tdl_3__thread_header00_ready_port1__read \
    bdw__render_basic__sampler1_busy__read

/* Metric set TDL_3 :: Thread Header Ready on Slice0 Subslice1 Thread Dispatcher Port 0 */
#define icl__tdl_3__thread_header01_ready_port0__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Metric set TDL_3 :: Thread Header Ready on Slice0 Subslice1 Thread Dispatcher Port 1 */
#define icl__tdl_3__thread_header01_ready_port1__read \
    bdw__render_basic__sampler1_bottleneck__read

/* Metric set TDL_3 :: Thread Header Ready on Slice0 Subslice2 Thread Dispatcher Port 0 */
#define icl__tdl_3__thread_header02_ready_port0__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* Metric set TDL_3 :: Thread Header Ready on Slice0 Subslice2 Thread Dispatcher Port 1 */
#define icl__tdl_3__thread_header02_ready_port1__read \
    bdw__render_pipe_profile__cl_bottleneck__read

/* Metric set TDL_3 :: Thread Header Ready on Slice0 Subslice3 Thread Dispatcher Port 0 */
#define icl__tdl_3__thread_header03_ready_port0__read \
    bdw__render_pipe_profile__sf_bottleneck__read

/* Metric set TDL_3 :: Thread Header Ready on Slice0 Subslice3 Thread Dispatcher Port 1 */
#define icl__tdl_3__thread_header03_ready_port1__read \
    bdw__render_pipe_profile__early_depth_bottleneck__read

/* Metric set TDL_3 :: Thread Header Ready on Slice0 Subslice4 Thread Dispatcher Port 0 */
#define icl__tdl_3__thread_header04_ready_port0__read \
    bdw__render_pipe_profile__vf_bottleneck__read

/* Metric set TDL_3 :: Thread Header Ready on Slice0 Subslice4 Thread Dispatcher Port 1 */
#define icl__tdl_3__thread_header04_ready_port1__read \
    bdw__render_pipe_profile__hs_stall__read

/* Metric set TDL_3 :: Thread Header Ready on Slice0 Subslice5 Thread Dispatcher Port 0 */
#define icl__tdl_3__thread_header05_ready_port0__read \
    bdw__render_pipe_profile__ds_stall__read

/* Metric set TDL_3 :: Thread Header Ready on Slice0 Subslice5 Thread Dispatcher Port 1 */
#define icl__tdl_3__thread_header05_ready_port1__read \
    bdw__render_pipe_profile__so_stall__read

/* Metric set TDL_3 :: Thread Header Ready on Slice0 Subslice6 Thread Dispatcher Port 0 */
#define icl__tdl_3__thread_header06_ready_port0__read \
    bdw__render_pipe_profile__cl_stall__read

/* Metric set TDL_3 :: Thread Header Ready on Slice0 Subslice6 Thread Dispatcher Port 1 */
#define icl__tdl_3__thread_header06_ready_port1__read \
    bdw__render_pipe_profile__sf_stall__read

/* Metric set TDL_3 :: Thread Header Ready on Slice0 Subslice7 Thread Dispatcher Port 0 */
#define icl__tdl_3__thread_header07_ready_port0__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set TDL_3 :: Thread Header Ready on Slice0 Subslice7 Thread Dispatcher Port 1 */
#define icl__tdl_3__thread_header07_ready_port1__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Gpu Rings Busyness :: GPU Time Elapsed */
#define icl__gpu_busyness__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Gpu Rings Busyness :: GPU Core Clocks */
#define icl__gpu_busyness__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Gpu Rings Busyness :: AVG GPU Core Frequency */
#define icl__gpu_busyness__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Gpu Rings Busyness :: AVG GPU Core Frequency */
#define icl__gpu_busyness__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Gpu Rings Busyness :: GPU Busy */
#define icl__gpu_busyness__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Gpu Rings Busyness :: Render Ring Busy */
#define icl__gpu_busyness__render_busy__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Gpu Rings Busyness :: Vdbox0 Ring Busy */
#define icl__gpu_busyness__vdbox0_busy__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Gpu Rings Busyness :: Vdbox1 Ring Busy */
#define icl__gpu_busyness__vdbox1_busy__read \
    bdw__render_pipe_profile__sf_stall__read

/* Gpu Rings Busyness :: Vebox Ring Busy */
#define icl__gpu_busyness__vebox_busy__read \
    bdw__render_pipe_profile__cl_stall__read

/* Gpu Rings Busyness :: Blitter Ring Busy */
#define icl__gpu_busyness__blitter_busy__read \
    bdw__render_pipe_profile__so_stall__read

/* Gpu Rings Busyness :: Posh Ring Busy */
#define icl__gpu_busyness__posh_engine_busy__read \
    bdw__render_pipe_profile__ds_stall__read

/* Gpu Rings Busyness :: AnyRingBusy */
#define icl__gpu_busyness__any_ring_busy__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set TestOa :: GPU Time Elapsed */
#define icl__test_oa__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set TestOa :: GPU Core Clocks */
#define icl__test_oa__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set TestOa :: AVG GPU Core Frequency */
#define icl__test_oa__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set TestOa :: AVG GPU Core Frequency */
#define icl__test_oa__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set TestOa :: TestCounter0 */
#define icl__test_oa__counter0__read \
    hsw__compute_extended__eu_untyped_reads0__read

/* Metric set TestOa :: TestCounter1 */
#define icl__test_oa__counter1__read \
    hsw__compute_extended__eu_untyped_writes0__read

/* Metric set TestOa :: TestCounter2 */
#define icl__test_oa__counter2__read \
    hsw__compute_extended__eu_typed_reads0__read

/* Metric set TestOa :: TestCounter3 */
#define icl__test_oa__counter3__read \
    hsw__compute_extended__eu_typed_writes0__read

/* Metric set TestOa :: TestCounter4 */
#define icl__test_oa__counter4__read \
    hsw__compute_extended__eu_untyped_atomics0__read

/* Metric set TestOa :: TestCounter5 */
#define icl__test_oa__counter5__read \
    hsw__compute_extended__eu_typed_atomics0__read

/* Metric set TestOa :: TestCounter6 */
#define icl__test_oa__counter6__read \
    hsw__compute_extended__eu_urb_atomics0__read

/* Metric set TestOa :: TestCounter7 */
#define icl__test_oa__counter7__read \
    hsw__compute_extended__gpu_clocks__read

/* Metric set TestOa :: TestCounter8 */
#define icl__test_oa__counter8__read \
    hsw__compute_extended__typed_writes0__read

/* Render Metrics Basic Gen11 :: GPU Time Elapsed */
#define ehl__render_basic__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Render Metrics Basic Gen11 :: GPU Core Clocks */
#define ehl__render_basic__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Render Metrics Basic Gen11 :: AVG GPU Core Frequency */
#define ehl__render_basic__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Render Metrics Basic Gen11 :: AVG GPU Core Frequency */
#define ehl__render_basic__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Render Metrics Basic Gen11 :: VS Threads Dispatched */
#define ehl__render_basic__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Render Metrics Basic Gen11 :: HS Threads Dispatched */
#define ehl__render_basic__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Render Metrics Basic Gen11 :: DS Threads Dispatched */
#define ehl__render_basic__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Render Metrics Basic Gen11 :: GS Threads Dispatched */
#define ehl__render_basic__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Render Metrics Basic Gen11 :: FS Threads Dispatched */
#define ehl__render_basic__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Render Metrics Basic Gen11 :: CS Threads Dispatched */
#define ehl__render_basic__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Render Metrics Basic Gen11 :: GPU Busy */
#define ehl__render_basic__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Render Metrics Basic Gen11 :: EU Active */
#define ehl__render_basic__eu_active__read \
    bdw__render_basic__eu_active__read

/* Render Metrics Basic Gen11 :: EU Stall */
#define ehl__render_basic__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Render Metrics Basic Gen11 :: EU Both FPU Pipes Active */
#define ehl__render_basic__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Render Metrics Basic Gen11 :: VS FPU0 Pipe Active */
#define ehl__render_basic__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Render Metrics Basic Gen11 :: VS FPU1 Pipe Active */
#define ehl__render_basic__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Render Metrics Basic Gen11 :: VS Send Pipe Active */
#define ehl__render_basic__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Render Metrics Basic Gen11 :: PS FPU0 Pipe Active */
#define ehl__render_basic__ps_fpu0_active__read \
    bdw__compute_l3_cache__eu_hybrid_fpu0_instruction__read

/* Render Metrics Basic Gen11 :: PS FPU1 Pipe Active */
#define ehl__render_basic__ps_fpu1_active__read \
    bdw__compute_l3_cache__eu_hybrid_fpu1_instruction__read

/* Render Metrics Basic Gen11 :: PS Send Pipeline Active */
#define ehl__render_basic__ps_send_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Render Metrics Basic Gen11 :: Sampler00 Busy */
#define ehl__render_basic__sampler00_busy__read \
    bdw__render_pipe_profile__hs_stall__read

/* Render Metrics Basic Gen11 :: Samplers Busy */
#define ehl__render_basic__samplers_busy__read \
    bdw__render_pipe_profile__hs_stall__read

/* Render Metrics Basic Gen11 :: Sampler00 Bottleneck */
#define ehl__render_basic__sampler00_bottleneck__read \
    bdw__render_pipe_profile__vf_bottleneck__read

/* Render Metrics Basic Gen11 :: Rasterized Pixels */
#define ehl__render_basic__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Render Metrics Basic Gen11 :: Early Hi-Depth Test Fails */
#define ehl__render_basic__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Render Metrics Basic Gen11 :: Early Depth Test Fails */
#define ehl__render_basic__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Render Metrics Basic Gen11 :: Samples Killed in FS */
#define ehl__render_basic__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Render Metrics Basic Gen11 :: Pixels Failing Tests */
#define ehl__render_basic__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Render Metrics Basic Gen11 :: Samples Written */
#define ehl__render_basic__samples_written__read \
    bdw__render_basic__samples_written__read

/* Render Metrics Basic Gen11 :: Samples Blended */
#define ehl__render_basic__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Render Metrics Basic Gen11 :: Sampler Texels */
#define ehl__render_basic__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Render Metrics Basic Gen11 :: Sampler Texels Misses */
#define ehl__render_basic__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Render Metrics Basic Gen11 :: Sampler Cache Misses */
static uint64_t
ehl__render_basic__sampler_l1_misses__read(const struct intel_perf *perf,
                                           const struct intel_perf_metric_set *metric_set,
                                           uint64_t *accumulator)
{
    /* RPN equation: C 4 READ C 5 READ UADD 8 UMUL */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 4];
    uint64_t tmp1 = accumulator[metric_set->c_offset + 5];
    uint64_t tmp2 = tmp0 + tmp1;
    uint64_t tmp3 = tmp2 * 8;

    return tmp3;
}

/* Render Metrics Basic Gen11 :: SLM Bytes Read */
#define ehl__render_basic__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Render Metrics Basic Gen11 :: SLM Bytes Read */
#define ehl__render_basic__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics Basic Gen11 :: SLM Bytes Written */
#define ehl__render_basic__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Render Metrics Basic Gen11 :: SLM Bytes Written */
#define ehl__render_basic__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics Basic Gen11 :: Shader Memory Accesses */
#define ehl__render_basic__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Render Metrics Basic Gen11 :: Shader Atomic Memory Accesses */
#define ehl__render_basic__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Render Metrics Basic Gen11 :: L3 Shader Throughput */
#define ehl__render_basic__l3_shader_throughput__read \
    cnl__render_basic__l3_shader_throughput__read

/* Render Metrics Basic Gen11 :: L3 Shader Throughput */
#define ehl__render_basic__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics Basic Gen11 :: Shader Barrier Messages */
#define ehl__render_basic__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Render Metrics Basic Gen11 :: GTI Read Throughput */
static uint64_t
ehl__render_basic__gti_read_throughput__read(const struct intel_perf *perf,
                                             const struct intel_perf_metric_set *metric_set,
                                             uint64_t *accumulator)
{
    /* RPN equation: 64  B 5 READ B 4 READ UADD UMUL */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 5];
    uint64_t tmp1 = accumulator[metric_set->b_offset + 4];
    uint64_t tmp2 = tmp0 + tmp1;
    uint64_t tmp3 = 64 * tmp2;

    return tmp3;
}

/* Render Metrics Basic Gen11 :: GTI Read Throughput */
#define ehl__render_basic__gti_read_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Render Metrics Basic Gen11 :: GTI Write Throughput */
#define ehl__render_basic__gti_write_throughput__read \
    icl__render_basic__gti_write_throughput__read

/* Render Metrics Basic Gen11 :: GTI Write Throughput */
#define ehl__render_basic__gti_write_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Render Metrics Basic Gen11 :: Samplers Bottleneck */
#define ehl__render_basic__sampler_bottleneck__read \
    bdw__render_pipe_profile__vf_bottleneck__read

/* Compute Metrics Basic Gen11 :: GPU Time Elapsed */
#define ehl__compute_basic__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Compute Metrics Basic Gen11 :: GPU Core Clocks */
#define ehl__compute_basic__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Compute Metrics Basic Gen11 :: AVG GPU Core Frequency */
#define ehl__compute_basic__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Compute Metrics Basic Gen11 :: AVG GPU Core Frequency */
#define ehl__compute_basic__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Compute Metrics Basic Gen11 :: GPU Busy */
#define ehl__compute_basic__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Compute Metrics Basic Gen11 :: VS Threads Dispatched */
#define ehl__compute_basic__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Compute Metrics Basic Gen11 :: HS Threads Dispatched */
#define ehl__compute_basic__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Compute Metrics Basic Gen11 :: DS Threads Dispatched */
#define ehl__compute_basic__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Compute Metrics Basic Gen11 :: GS Threads Dispatched */
#define ehl__compute_basic__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Compute Metrics Basic Gen11 :: FS Threads Dispatched */
#define ehl__compute_basic__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Compute Metrics Basic Gen11 :: CS Threads Dispatched */
#define ehl__compute_basic__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Compute Metrics Basic Gen11 :: EU Active */
#define ehl__compute_basic__eu_active__read \
    bdw__render_basic__eu_active__read

/* Compute Metrics Basic Gen11 :: EU Stall */
#define ehl__compute_basic__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Compute Metrics Basic Gen11 :: EU AVG IPC Rate */
#define ehl__compute_basic__eu_avg_ipc_rate__read \
    cnl__compute_basic__eu_avg_ipc_rate__read

/* Compute Metrics Basic Gen11 :: EU AVG IPC Rate */
#define ehl__compute_basic__eu_avg_ipc_rate__max \
    bdw__compute_basic__eu_avg_ipc_rate__max

/* Compute Metrics Basic Gen11 :: EU Both FPU Pipes Active */
#define ehl__compute_basic__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Compute Metrics Basic Gen11 :: EU FPU0 Pipe Active */
#define ehl__compute_basic__fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Compute Metrics Basic Gen11 :: EU FPU1 Pipe Active */
#define ehl__compute_basic__fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Compute Metrics Basic Gen11 :: EU Send Pipe Active */
#define ehl__compute_basic__eu_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Compute Metrics Basic Gen11 :: EU Thread Occupancy */
#define ehl__compute_basic__eu_thread_occupancy__read \
    cnl__compute_basic__eu_thread_occupancy__read

/* Compute Metrics Basic Gen11 :: Rasterized Pixels */
#define ehl__compute_basic__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Compute Metrics Basic Gen11 :: Early Hi-Depth Test Fails */
#define ehl__compute_basic__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Compute Metrics Basic Gen11 :: Early Depth Test Fails */
#define ehl__compute_basic__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Compute Metrics Basic Gen11 :: Samples Killed in FS */
#define ehl__compute_basic__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Compute Metrics Basic Gen11 :: Pixels Failing Tests */
#define ehl__compute_basic__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Compute Metrics Basic Gen11 :: Samples Written */
#define ehl__compute_basic__samples_written__read \
    bdw__render_basic__samples_written__read

/* Compute Metrics Basic Gen11 :: Samples Blended */
#define ehl__compute_basic__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Compute Metrics Basic Gen11 :: Sampler Texels */
#define ehl__compute_basic__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Compute Metrics Basic Gen11 :: Sampler Texels Misses */
#define ehl__compute_basic__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Compute Metrics Basic Gen11 :: SLM Bytes Read */
#define ehl__compute_basic__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Compute Metrics Basic Gen11 :: SLM Bytes Read */
#define ehl__compute_basic__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Basic Gen11 :: SLM Bytes Written */
#define ehl__compute_basic__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Compute Metrics Basic Gen11 :: SLM Bytes Written */
#define ehl__compute_basic__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Basic Gen11 :: Shader Memory Accesses */
#define ehl__compute_basic__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Compute Metrics Basic Gen11 :: Shader Atomic Memory Accesses */
#define ehl__compute_basic__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Compute Metrics Basic Gen11 :: L3 Shader Throughput */
#define ehl__compute_basic__l3_shader_throughput__read \
    cnl__render_basic__l3_shader_throughput__read

/* Compute Metrics Basic Gen11 :: L3 Shader Throughput */
#define ehl__compute_basic__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Basic Gen11 :: Shader Barrier Messages */
#define ehl__compute_basic__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Compute Metrics Basic Gen11 :: Typed Bytes Read */
#define ehl__compute_basic__typed_bytes_read__read \
    icl__compute_basic__typed_bytes_read__read

/* Compute Metrics Basic Gen11 :: Typed Bytes Read */
#define ehl__compute_basic__typed_bytes_read__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen11 :: Typed Bytes Written */
#define ehl__compute_basic__typed_bytes_written__read \
    icl__compute_basic__typed_bytes_written__read

/* Compute Metrics Basic Gen11 :: Typed Bytes Written */
#define ehl__compute_basic__typed_bytes_written__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen11 :: Untyped Bytes Read */
#define ehl__compute_basic__untyped_bytes_read__read \
    icl__compute_basic__untyped_bytes_read__read

/* Compute Metrics Basic Gen11 :: Untyped Bytes Read */
#define ehl__compute_basic__untyped_bytes_read__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen11 :: Untyped Writes */
#define ehl__compute_basic__untyped_bytes_written__read \
    icl__compute_basic__untyped_bytes_written__read

/* Compute Metrics Basic Gen11 :: Untyped Writes */
#define ehl__compute_basic__untyped_bytes_written__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen11 :: Typed Atomics Accesses */
#define ehl__compute_basic__typed_atomics__read \
    icl__compute_basic__typed_atomics__read

/* Compute Metrics Basic Gen11 :: Typed Atomics Accesses */
#define ehl__compute_basic__typed_atomics__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics Basic Gen11 :: GTI Read Throughput */
static uint64_t
ehl__compute_basic__gti_read_throughput__read(const struct intel_perf *perf,
                                              const struct intel_perf_metric_set *metric_set,
                                              uint64_t *accumulator)
{
    /* RPN equation: 64  B 7 READ B 6 READ UADD UMUL */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 7];
    uint64_t tmp1 = accumulator[metric_set->b_offset + 6];
    uint64_t tmp2 = tmp0 + tmp1;
    uint64_t tmp3 = 64 * tmp2;

    return tmp3;
}

/* Compute Metrics Basic Gen11 :: GTI Read Throughput */
#define ehl__compute_basic__gti_read_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Compute Metrics Basic Gen11 :: GTI Write Throughput */
#define ehl__compute_basic__gti_write_throughput__read \
    icl__render_basic__gti_write_throughput__read

/* Compute Metrics Basic Gen11 :: GTI Write Throughput */
#define ehl__compute_basic__gti_write_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* ComputeExtended Gen11 :: GPU Time Elapsed */
#define ehl__compute_extended__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* ComputeExtended Gen11 :: GPU Core Clocks */
#define ehl__compute_extended__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* ComputeExtended Gen11 :: AVG GPU Core Frequency */
#define ehl__compute_extended__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* ComputeExtended Gen11 :: AVG GPU Core Frequency */
#define ehl__compute_extended__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* ComputeExtended Gen11 :: GPU Busy */
#define ehl__compute_extended__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* ComputeExtended Gen11 :: CS Threads Dispatched */
#define ehl__compute_extended__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* ComputeExtended Gen11 :: Typed Atomics 00 */
#define ehl__compute_extended__typed_atomics00__read \
    hsw__memory_reads__gpu_core_clocks__read

/* ComputeExtended Gen11 :: Typed Reads 00 */
#define ehl__compute_extended__typed_reads00__read \
    hsw__memory_reads__llc_read_accesses__read

/* ComputeExtended Gen11 :: Typed Writes 00 */
#define ehl__compute_extended__typed_writes00__read \
    hsw__memory_reads__gti_memory_reads__read

/* ComputeExtended Gen11 :: Untyped Reads 00 */
#define ehl__compute_extended__untyped_reads00__read \
    hsw__compute_extended__typed_atomics0__read

/* ComputeExtended Gen11 :: Untyped Writes 00 */
#define ehl__compute_extended__untyped_writes00__read \
    hsw__compute_extended__untyped_reads0__read

/* ComputeExtended Gen11 :: Eu Typed Reads 00 */
#define ehl__compute_extended__eu_typed_reads00__read \
    hsw__compute_extended__eu_typed_writes0__read

/* ComputeExtended Gen11 :: Eu Typed Writes 00 */
#define ehl__compute_extended__eu_typed_writes00__read \
    hsw__compute_extended__eu_untyped_atomics0__read

/* ComputeExtended Gen11 :: Eu Typed Atomics 00 */
#define ehl__compute_extended__eu_typed_atomics00__read \
    hsw__compute_extended__eu_typed_reads0__read

/* ComputeExtended Gen11 :: Eu A32 Untyped Reads 00 */
#define ehl__compute_extended__eu_a32_untyped_reads00__read \
    hsw__compute_extended__eu_untyped_reads0__read

/* ComputeExtended Gen11 :: Eu A32 Untyped Writes 00 */
#define ehl__compute_extended__eu_a32_untyped_writes00__read \
    icl__compute_extended__eu_a32_untyped_writes00__read

/* ComputeExtended Gen11 :: Eu 64 Untyped Reads 00 */
#define ehl__compute_extended__eu_a64_untyped_reads00__read \
    icl__compute_extended__eu_a64_untyped_reads00__read

/* ComputeExtended Gen11 :: Eu A64 Untyped Writes 00 */
#define ehl__compute_extended__eu_a64_untyped_writes00__read \
    hsw__render_basic__gpu_core_clocks__read

/* ComputeExtended Gen11 :: TypedAtomicsPerCacheLine */
#define ehl__compute_extended__typed_atomics_per_cache_line__read \
    icl__compute_extended__typed_atomics_per_cache_line__read

/* ComputeExtended Gen11 :: TypedReadsPerCacheLine */
#define ehl__compute_extended__typed_reads_per_cache_line__read \
    icl__compute_extended__typed_reads_per_cache_line__read

/* ComputeExtended Gen11 :: TypedWritesPerCacheLine */
#define ehl__compute_extended__typed_writes_per_cache_line__read \
    icl__compute_extended__typed_writes_per_cache_line__read

/* ComputeExtended Gen11 :: UntypedReadsPerCacheLine */
#define ehl__compute_extended__untyped_reads_per_cache_line__read \
    icl__compute_extended__untyped_reads_per_cache_line__read

/* ComputeExtended Gen11 :: UntypedWritesPerCacheLine */
#define ehl__compute_extended__untyped_writes_per_cache_line__read \
    icl__compute_extended__untyped_writes_per_cache_line__read

/* Compute Metrics L3 Cache Gen11 :: GPU Time Elapsed */
#define ehl__compute_l3_cache__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Compute Metrics L3 Cache Gen11 :: GPU Core Clocks */
#define ehl__compute_l3_cache__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Compute Metrics L3 Cache Gen11 :: AVG GPU Core Frequency */
#define ehl__compute_l3_cache__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Compute Metrics L3 Cache Gen11 :: AVG GPU Core Frequency */
#define ehl__compute_l3_cache__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Compute Metrics L3 Cache Gen11 :: GPU Busy */
#define ehl__compute_l3_cache__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Compute Metrics L3 Cache Gen11 :: VS Threads Dispatched */
#define ehl__compute_l3_cache__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Compute Metrics L3 Cache Gen11 :: HS Threads Dispatched */
#define ehl__compute_l3_cache__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Compute Metrics L3 Cache Gen11 :: DS Threads Dispatched */
#define ehl__compute_l3_cache__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Compute Metrics L3 Cache Gen11 :: GS Threads Dispatched */
#define ehl__compute_l3_cache__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Compute Metrics L3 Cache Gen11 :: FS Threads Dispatched */
#define ehl__compute_l3_cache__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Compute Metrics L3 Cache Gen11 :: CS Threads Dispatched */
#define ehl__compute_l3_cache__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Compute Metrics L3 Cache Gen11 :: EU Active */
#define ehl__compute_l3_cache__eu_active__read \
    bdw__render_basic__eu_active__read

/* Compute Metrics L3 Cache Gen11 :: EU Stall */
#define ehl__compute_l3_cache__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Compute Metrics L3 Cache Gen11 :: EU AVG IPC Rate */
#define ehl__compute_l3_cache__eu_avg_ipc_rate__read \
    cnl__compute_basic__eu_avg_ipc_rate__read

/* Compute Metrics L3 Cache Gen11 :: EU AVG IPC Rate */
#define ehl__compute_l3_cache__eu_avg_ipc_rate__max \
    bdw__compute_basic__eu_avg_ipc_rate__max

/* Compute Metrics L3 Cache Gen11 :: EU Both FPU Pipes Active */
#define ehl__compute_l3_cache__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Compute Metrics L3 Cache Gen11 :: EU FPU0 Pipe Active */
#define ehl__compute_l3_cache__fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Compute Metrics L3 Cache Gen11 :: EU FPU1 Pipe Active */
#define ehl__compute_l3_cache__fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Compute Metrics L3 Cache Gen11 :: EU Send Pipe Active */
#define ehl__compute_l3_cache__eu_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Compute Metrics L3 Cache Gen11 :: EU FPU0 Hybrid Instruction */
#define ehl__compute_l3_cache__eu_hybrid_fpu0_instruction__read \
    bdw__compute_l3_cache__eu_hybrid_fpu0_instruction__read

/* Compute Metrics L3 Cache Gen11 :: EU FPU1 Hybrid Instruction */
#define ehl__compute_l3_cache__eu_hybrid_fpu1_instruction__read \
    bdw__compute_l3_cache__eu_hybrid_fpu1_instruction__read

/* Compute Metrics L3 Cache Gen11 :: EU FPU0 Ternary Instruction */
#define ehl__compute_l3_cache__eu_ternary_fpu0_instruction__read \
    bdw__render_basic__ps_fpu0_active__read

/* Compute Metrics L3 Cache Gen11 :: EU FPU1 Ternary Instruction */
#define ehl__compute_l3_cache__eu_ternary_fpu1_instruction__read \
    bdw__render_basic__ps_fpu1_active__read

/* Compute Metrics L3 Cache Gen11 :: EU FPU0 Binary Instruction */
#define ehl__compute_l3_cache__eu_binary_fpu0_instruction__read \
    bdw__render_basic__ps_send_active__read

/* Compute Metrics L3 Cache Gen11 :: EU FPU1 Binary Instruction */
#define ehl__compute_l3_cache__eu_binary_fpu1_instruction__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Compute Metrics L3 Cache Gen11 :: EU FPU0 Move Instruction */
#define ehl__compute_l3_cache__eu_move_fpu0_instruction__read \
    bdw__compute_l3_cache__eu_move_fpu0_instruction__read

/* Compute Metrics L3 Cache Gen11 :: EU FPU1 Move Instruction */
#define ehl__compute_l3_cache__eu_move_fpu1_instruction__read \
    bdw__compute_l3_cache__eu_move_fpu1_instruction__read

/* Compute Metrics L3 Cache Gen11 :: Rasterized Pixels */
#define ehl__compute_l3_cache__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Compute Metrics L3 Cache Gen11 :: Early Hi-Depth Test Fails */
#define ehl__compute_l3_cache__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Compute Metrics L3 Cache Gen11 :: Early Depth Test Fails */
#define ehl__compute_l3_cache__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Compute Metrics L3 Cache Gen11 :: Samples Killed in FS */
#define ehl__compute_l3_cache__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Compute Metrics L3 Cache Gen11 :: Pixels Failing Tests */
#define ehl__compute_l3_cache__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Compute Metrics L3 Cache Gen11 :: Samples Written */
#define ehl__compute_l3_cache__samples_written__read \
    bdw__render_basic__samples_written__read

/* Compute Metrics L3 Cache Gen11 :: Samples Blended */
#define ehl__compute_l3_cache__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Compute Metrics L3 Cache Gen11 :: Sampler Accesses */
#define ehl__compute_l3_cache__sampler_accesses__read \
    bdw__render_pipe_profile__sampler_accesses__read

/* Compute Metrics L3 Cache Gen11 :: Sampler Texels */
#define ehl__compute_l3_cache__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Compute Metrics L3 Cache Gen11 :: Sampler Texels Misses */
#define ehl__compute_l3_cache__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Compute Metrics L3 Cache Gen11 :: SLM Bytes Read */
#define ehl__compute_l3_cache__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Compute Metrics L3 Cache Gen11 :: SLM Bytes Read */
#define ehl__compute_l3_cache__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics L3 Cache Gen11 :: SLM Bytes Written */
#define ehl__compute_l3_cache__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Compute Metrics L3 Cache Gen11 :: SLM Bytes Written */
#define ehl__compute_l3_cache__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics L3 Cache Gen11 :: Shader Memory Accesses */
#define ehl__compute_l3_cache__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Compute Metrics L3 Cache Gen11 :: Shader Atomic Memory Accesses */
#define ehl__compute_l3_cache__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Compute Metrics L3 Cache Gen11 :: Shader Barrier Messages */
#define ehl__compute_l3_cache__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Compute Metrics L3 Cache Gen11 :: Slice0 L3 Bank0 Accesses */
#define ehl__compute_l3_cache__l3_bank00_accesses__read \
    icl__compute_l3_cache__l3_bank00_accesses__read

/* Compute Metrics L3 Cache Gen11 :: Slice0 L3 Bank1 Accesses */
#define ehl__compute_l3_cache__l3_bank01_accesses__read \
    hsw__memory_writes__llc_wr_accesses__read

/* Compute Metrics L3 Cache Gen11 :: Slice0 L3 Bank2 Accesses */
#define ehl__compute_l3_cache__l3_bank02_accesses__read \
    icl__compute_l3_cache__l3_bank02_accesses__read

/* Compute Metrics L3 Cache Gen11 :: Slice0 L3 Bank3 Accesses */
#define ehl__compute_l3_cache__l3_bank03_accesses__read \
    icl__compute_l3_cache__l3_bank03_accesses__read

/* Compute Metrics L3 Cache Gen11 :: Slice0 L3 Bank4 Accesses */
#define ehl__compute_l3_cache__l3_bank04_accesses__read \
    bdw__memory_reads__gti_ring_accesses__read

/* Compute Metrics L3 Cache Gen11 :: Slice0 L3 Bank5 Accesses */
#define ehl__compute_l3_cache__l3_bank05_accesses__read \
    bdw__compute_l3_cache__l3_bank10_accesses__read

/* Compute Metrics L3 Cache Gen11 :: Slice0 L3 Bank6 Accesses */
#define ehl__compute_l3_cache__l3_bank06_accesses__read \
    bdw__compute_l3_cache__l3_bank01_accesses__read

/* Compute Metrics L3 Cache Gen11 :: Slice0 L3 Bank7 Accesses */
#define ehl__compute_l3_cache__l3_bank07_accesses__read \
    bdw__compute_l3_cache__l3_bank00_accesses__read

/* Compute Metrics L3 Cache Gen11 :: L3 Accesses */
#define ehl__compute_l3_cache__l3_accesses__read \
    icl__compute_l3_cache__l3_accesses__read

/* Compute Metrics L3 Cache Gen11 :: L3 Lookup Accesses w/o IC */
static uint64_t
ehl__compute_l3_cache__l3_lookups__read(const struct intel_perf *perf,
                                        const struct intel_perf_metric_set *metric_set,
                                        uint64_t *accumulator)
{
    /* RPN equation: B 7 READ B 6 READ UADD 8 UMUL A 32 READ UADD */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 7];
    uint64_t tmp1 = accumulator[metric_set->b_offset + 6];
    uint64_t tmp2 = tmp0 + tmp1;
    uint64_t tmp3 = tmp2 * 8;
    uint64_t tmp4 = accumulator[metric_set->a_offset + 32];
    uint64_t tmp5 = tmp3 + tmp4;

    return tmp5;
}

/* Compute Metrics L3 Cache Gen11 :: L3 Misses */
static uint64_t
ehl__compute_l3_cache__l3_misses__read(const struct intel_perf *perf,
                                       const struct intel_perf_metric_set *metric_set,
                                       uint64_t *accumulator)
{
    /* RPN equation: 2 B 5 READ B 4 READ UADD UMUL */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 5];
    uint64_t tmp1 = accumulator[metric_set->b_offset + 4];
    uint64_t tmp2 = tmp0 + tmp1;
    uint64_t tmp3 = 2 * tmp2;

    return tmp3;
}

/* Compute Metrics L3 Cache Gen11 :: L3 Sampler Throughput */
static uint64_t
ehl__compute_l3_cache__l3_sampler_throughput__read(const struct intel_perf *perf,
                                                   const struct intel_perf_metric_set *metric_set,
                                                   uint64_t *accumulator)
{
    /* RPN equation: 64  B 7 READ B 6 READ UADD 8 UMUL UMUL */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 7];
    uint64_t tmp1 = accumulator[metric_set->b_offset + 6];
    uint64_t tmp2 = tmp0 + tmp1;
    uint64_t tmp3 = tmp2 * 8;
    uint64_t tmp4 = 64 * tmp3;

    return tmp4;
}

/* Compute Metrics L3 Cache Gen11 :: L3 Sampler Throughput */
#define ehl__compute_l3_cache__l3_sampler_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics L3 Cache Gen11 :: L3 Shader Throughput */
#define ehl__compute_l3_cache__l3_shader_throughput__read \
    cnl__render_basic__l3_shader_throughput__read

/* Compute Metrics L3 Cache Gen11 :: L3 Shader Throughput */
#define ehl__compute_l3_cache__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics L3 Cache Gen11 :: L3 Total Throughput */
#define ehl__compute_l3_cache__l3_total_throughput__read \
    icl__compute_l3_cache__l3_total_throughput__read

/* Compute Metrics L3 Cache Gen11 :: L3 Total Throughput */
#define ehl__compute_l3_cache__l3_total_throughput__max \
    bdw__render_basic__gti_depth_throughput__max

/* Compute Metrics L3 Cache Gen11 :: GTI L3 Throughput */
static uint64_t
ehl__compute_l3_cache__gti_l3_throughput__read(const struct intel_perf *perf,
                                               const struct intel_perf_metric_set *metric_set,
                                               uint64_t *accumulator)
{
    /* RPN equation: $L3Misses 64 UMUL */
    uint64_t tmp0 = ehl__compute_l3_cache__l3_misses__read(perf, metric_set, accumulator) * 64;

    return tmp0;
}

/* Compute Metrics L3 Cache Gen11 :: GTI L3 Throughput */
#define ehl__compute_l3_cache__gti_l3_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Compute Metrics L3 Cache Gen11 :: GTI Read Throughput */
#define ehl__compute_l3_cache__gti_read_throughput__read \
    icl__compute_l3_cache__gti_read_throughput__read

/* Compute Metrics L3 Cache Gen11 :: GTI Read Throughput */
#define ehl__compute_l3_cache__gti_read_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Compute Metrics L3 Cache Gen11 :: GTI Write Throughput */
#define ehl__compute_l3_cache__gti_write_throughput__read \
    icl__compute_l3_cache__gti_write_throughput__read

/* Compute Metrics L3 Cache Gen11 :: GTI Write Throughput */
#define ehl__compute_l3_cache__gti_write_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Render Metrics for 3D Pipeline Profile Gen11 :: GPU Time Elapsed */
#define ehl__render_pipe_profile__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: GPU Core Clocks */
#define ehl__render_pipe_profile__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: AVG GPU Core Frequency */
#define ehl__render_pipe_profile__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: AVG GPU Core Frequency */
#define ehl__render_pipe_profile__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Render Metrics for 3D Pipeline Profile Gen11 :: GPU Busy */
#define ehl__render_pipe_profile__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: VS Threads Dispatched */
#define ehl__render_pipe_profile__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: HS Threads Dispatched */
#define ehl__render_pipe_profile__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: DS Threads Dispatched */
#define ehl__render_pipe_profile__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: GS Threads Dispatched */
#define ehl__render_pipe_profile__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: FS Threads Dispatched */
#define ehl__render_pipe_profile__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: CS Threads Dispatched */
#define ehl__render_pipe_profile__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: EU Active */
#define ehl__render_pipe_profile__eu_active__read \
    bdw__render_basic__eu_active__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: EU Stall */
#define ehl__render_pipe_profile__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: Rasterized Pixels */
#define ehl__render_pipe_profile__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: Early Hi-Depth Test Fails */
#define ehl__render_pipe_profile__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: Early Depth Test Fails */
#define ehl__render_pipe_profile__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: Samples Killed in FS */
#define ehl__render_pipe_profile__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: Pixels Failing Tests */
#define ehl__render_pipe_profile__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: Samples Written */
#define ehl__render_pipe_profile__samples_written__read \
    bdw__render_basic__samples_written__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: Samples Blended */
#define ehl__render_pipe_profile__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: Sampler Texels */
#define ehl__render_pipe_profile__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: Sampler Texels Misses */
#define ehl__render_pipe_profile__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: SLM Bytes Read */
#define ehl__render_pipe_profile__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: SLM Bytes Read */
#define ehl__render_pipe_profile__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics for 3D Pipeline Profile Gen11 :: SLM Bytes Written */
#define ehl__render_pipe_profile__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: SLM Bytes Written */
#define ehl__render_pipe_profile__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics for 3D Pipeline Profile Gen11 :: Shader Memory Accesses */
#define ehl__render_pipe_profile__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: Shader Atomic Memory Accesses */
#define ehl__render_pipe_profile__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: L3 Shader Throughput */
#define ehl__render_pipe_profile__l3_shader_throughput__read \
    cnl__render_basic__l3_shader_throughput__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: L3 Shader Throughput */
#define ehl__render_pipe_profile__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics for 3D Pipeline Profile Gen11 :: Shader Barrier Messages */
#define ehl__render_pipe_profile__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: VF Bottleneck */
#define ehl__render_pipe_profile__vf_bottleneck__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: VS Bottleneck */
#define ehl__render_pipe_profile__vs_bottleneck__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: HS Bottleneck */
#define ehl__render_pipe_profile__hs_bottleneck__read \
    bdw__render_pipe_profile__sf_stall__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: DS Bottleneck */
#define ehl__render_pipe_profile__ds_bottleneck__read \
    bdw__render_pipe_profile__cl_stall__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: GS Bottleneck */
#define ehl__render_pipe_profile__gs_bottleneck__read \
    bdw__render_pipe_profile__so_stall__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: SO Bottleneck */
#define ehl__render_pipe_profile__so_bottleneck__read \
    bdw__render_pipe_profile__ds_stall__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: Clipper Bottleneck */
#define ehl__render_pipe_profile__cl_bottleneck__read \
    bdw__render_pipe_profile__hs_stall__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: Strip-Fans Bottleneck */
#define ehl__render_pipe_profile__sf_bottleneck__read \
    bdw__render_pipe_profile__vf_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: Hi-Depth Bottleneck */
#define ehl__render_pipe_profile__hi_depth_bottleneck__read \
    bdw__render_pipe_profile__early_depth_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: Early Depth Bottleneck */
#define ehl__render_pipe_profile__early_depth_bottleneck__read \
    bdw__render_pipe_profile__sf_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: BC Bottleneck */
#define ehl__render_pipe_profile__bc_bottleneck__read \
    bdw__render_pipe_profile__cl_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: HS Stall */
#define ehl__render_pipe_profile__hs_stall__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: DS Stall */
#define ehl__render_pipe_profile__ds_stall__read \
    bdw__render_basic__sampler1_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: SO Stall */
#define ehl__render_pipe_profile__so_stall__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: CL Stall */
#define ehl__render_pipe_profile__cl_stall__read \
    bdw__render_basic__sampler1_busy__read

/* Render Metrics for 3D Pipeline Profile Gen11 :: SF Stall */
#define ehl__render_pipe_profile__sf_stall__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set HDCAndSF :: GPU Time Elapsed */
#define ehl__hdc_and_sf__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set HDCAndSF :: GPU Core Clocks */
#define ehl__hdc_and_sf__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set HDCAndSF :: AVG GPU Core Frequency */
#define ehl__hdc_and_sf__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set HDCAndSF :: AVG GPU Core Frequency */
#define ehl__hdc_and_sf__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set HDCAndSF :: GPU Busy */
#define ehl__hdc_and_sf__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set HDCAndSF :: VS Threads Dispatched */
#define ehl__hdc_and_sf__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set HDCAndSF :: HS Threads Dispatched */
#define ehl__hdc_and_sf__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set HDCAndSF :: DS Threads Dispatched */
#define ehl__hdc_and_sf__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set HDCAndSF :: GS Threads Dispatched */
#define ehl__hdc_and_sf__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set HDCAndSF :: FS Threads Dispatched */
#define ehl__hdc_and_sf__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set HDCAndSF :: CS Threads Dispatched */
#define ehl__hdc_and_sf__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set HDCAndSF :: EU Active */
#define ehl__hdc_and_sf__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set HDCAndSF :: EU Stall */
#define ehl__hdc_and_sf__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set HDCAndSF :: EU Both FPU Pipes Active */
#define ehl__hdc_and_sf__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set HDCAndSF :: VS FPU0 Pipe Active */
#define ehl__hdc_and_sf__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set HDCAndSF :: VS FPU1 Pipe Active */
#define ehl__hdc_and_sf__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set HDCAndSF :: VS Send Pipe Active */
#define ehl__hdc_and_sf__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set HDCAndSF :: PS FPU0 Pipe Active */
#define ehl__hdc_and_sf__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set HDCAndSF :: PS FPU1 Pipe Active */
#define ehl__hdc_and_sf__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set HDCAndSF :: PS Send Pipeline Active */
#define ehl__hdc_and_sf__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set HDCAndSF :: FS Both FPU Active */
#define ehl__hdc_and_sf__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set HDCAndSF :: Rasterized Pixels */
#define ehl__hdc_and_sf__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set HDCAndSF :: Early Hi-Depth Test Fails */
#define ehl__hdc_and_sf__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set HDCAndSF :: Early Depth Test Fails */
#define ehl__hdc_and_sf__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set HDCAndSF :: Samples Killed in FS */
#define ehl__hdc_and_sf__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set HDCAndSF :: Pixels Failing Tests */
#define ehl__hdc_and_sf__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set HDCAndSF :: Samples Written */
#define ehl__hdc_and_sf__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set HDCAndSF :: Samples Blended */
#define ehl__hdc_and_sf__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set HDCAndSF :: Sampler Texels */
#define ehl__hdc_and_sf__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set HDCAndSF :: Sampler Texels Misses */
#define ehl__hdc_and_sf__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set HDCAndSF :: SLM Bytes Read */
#define ehl__hdc_and_sf__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set HDCAndSF :: SLM Bytes Read */
#define ehl__hdc_and_sf__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set HDCAndSF :: SLM Bytes Written */
#define ehl__hdc_and_sf__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set HDCAndSF :: SLM Bytes Written */
#define ehl__hdc_and_sf__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set HDCAndSF :: Shader Memory Accesses */
#define ehl__hdc_and_sf__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set HDCAndSF :: Shader Atomic Memory Accesses */
#define ehl__hdc_and_sf__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set HDCAndSF :: L3 Shader Throughput */
#define ehl__hdc_and_sf__l3_shader_throughput__read \
    cnl__render_basic__l3_shader_throughput__read

/* Metric set HDCAndSF :: L3 Shader Throughput */
#define ehl__hdc_and_sf__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set HDCAndSF :: Shader Barrier Messages */
#define ehl__hdc_and_sf__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set HDCAndSF :: Slice0 Subslice group 0 Non-sampler Shader Access Stalled On L3 */
#define ehl__hdc_and_sf__non_sampler_shader00_access_stalled_on_l3__read \
    icl__hdc_and_sf__non_sampler_shader00_access_stalled_on_l3__read

/* Metric set HDCAndSF :: Slice0 Subslice group 1 Non-sampler Shader Access Stalled On L3 */
#define ehl__hdc_and_sf__non_sampler_shader01_access_stalled_on_l3__read \
    icl__hdc_and_sf__non_sampler_shader01_access_stalled_on_l3__read

/* Metric set HDCAndSF :: Slice0 Subslice group 2 Non-sampler Shader Access Stalled On L3 */
#define ehl__hdc_and_sf__non_sampler_shader02_access_stalled_on_l3__read \
    icl__hdc_and_sf__non_sampler_shader02_access_stalled_on_l3__read

/* Metric set HDCAndSF :: Slice0 Subslice group 3 Non-sampler Shader Access Stalled On L3 */
#define ehl__hdc_and_sf__non_sampler_shader03_access_stalled_on_l3__read \
    icl__hdc_and_sf__non_sampler_shader03_access_stalled_on_l3__read

/* Metric set HDCAndSF :: Polygon Data Ready */
#define ehl__hdc_and_sf__poly_data_ready__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set HDCAndSF :: SQ is full */
#define ehl__hdc_and_sf__gt_request_queue_full__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set RasterizerAndPixelBackend :: GPU Time Elapsed */
#define ehl__rasterizer_and_pixel_backend__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set RasterizerAndPixelBackend :: GPU Core Clocks */
#define ehl__rasterizer_and_pixel_backend__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set RasterizerAndPixelBackend :: AVG GPU Core Frequency */
#define ehl__rasterizer_and_pixel_backend__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set RasterizerAndPixelBackend :: AVG GPU Core Frequency */
#define ehl__rasterizer_and_pixel_backend__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set RasterizerAndPixelBackend :: GPU Busy */
#define ehl__rasterizer_and_pixel_backend__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set RasterizerAndPixelBackend :: VS Threads Dispatched */
#define ehl__rasterizer_and_pixel_backend__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set RasterizerAndPixelBackend :: HS Threads Dispatched */
#define ehl__rasterizer_and_pixel_backend__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set RasterizerAndPixelBackend :: DS Threads Dispatched */
#define ehl__rasterizer_and_pixel_backend__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set RasterizerAndPixelBackend :: GS Threads Dispatched */
#define ehl__rasterizer_and_pixel_backend__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set RasterizerAndPixelBackend :: FS Threads Dispatched */
#define ehl__rasterizer_and_pixel_backend__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set RasterizerAndPixelBackend :: CS Threads Dispatched */
#define ehl__rasterizer_and_pixel_backend__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set RasterizerAndPixelBackend :: EU Active */
#define ehl__rasterizer_and_pixel_backend__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set RasterizerAndPixelBackend :: EU Stall */
#define ehl__rasterizer_and_pixel_backend__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set RasterizerAndPixelBackend :: EU Both FPU Pipes Active */
#define ehl__rasterizer_and_pixel_backend__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set RasterizerAndPixelBackend :: VS FPU0 Pipe Active */
#define ehl__rasterizer_and_pixel_backend__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set RasterizerAndPixelBackend :: VS FPU1 Pipe Active */
#define ehl__rasterizer_and_pixel_backend__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set RasterizerAndPixelBackend :: VS Send Pipe Active */
#define ehl__rasterizer_and_pixel_backend__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set RasterizerAndPixelBackend :: PS FPU0 Pipe Active */
#define ehl__rasterizer_and_pixel_backend__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set RasterizerAndPixelBackend :: PS FPU1 Pipe Active */
#define ehl__rasterizer_and_pixel_backend__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set RasterizerAndPixelBackend :: PS Send Pipeline Active */
#define ehl__rasterizer_and_pixel_backend__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set RasterizerAndPixelBackend :: FS Both FPU Active */
#define ehl__rasterizer_and_pixel_backend__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set RasterizerAndPixelBackend :: Rasterized Pixels */
#define ehl__rasterizer_and_pixel_backend__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set RasterizerAndPixelBackend :: Early Hi-Depth Test Fails */
#define ehl__rasterizer_and_pixel_backend__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set RasterizerAndPixelBackend :: Early Depth Test Fails */
#define ehl__rasterizer_and_pixel_backend__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set RasterizerAndPixelBackend :: Samples Killed in FS */
#define ehl__rasterizer_and_pixel_backend__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set RasterizerAndPixelBackend :: Pixels Failing Tests */
#define ehl__rasterizer_and_pixel_backend__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set RasterizerAndPixelBackend :: Samples Written */
#define ehl__rasterizer_and_pixel_backend__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set RasterizerAndPixelBackend :: Samples Blended */
#define ehl__rasterizer_and_pixel_backend__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set RasterizerAndPixelBackend :: Sampler Texels */
#define ehl__rasterizer_and_pixel_backend__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set RasterizerAndPixelBackend :: Sampler Texels Misses */
#define ehl__rasterizer_and_pixel_backend__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Read */
#define ehl__rasterizer_and_pixel_backend__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Read */
#define ehl__rasterizer_and_pixel_backend__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Written */
#define ehl__rasterizer_and_pixel_backend__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Written */
#define ehl__rasterizer_and_pixel_backend__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set RasterizerAndPixelBackend :: Shader Memory Accesses */
#define ehl__rasterizer_and_pixel_backend__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set RasterizerAndPixelBackend :: Shader Atomic Memory Accesses */
#define ehl__rasterizer_and_pixel_backend__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set RasterizerAndPixelBackend :: L3 Shader Throughput */
#define ehl__rasterizer_and_pixel_backend__l3_shader_throughput__read \
    cnl__render_basic__l3_shader_throughput__read

/* Metric set RasterizerAndPixelBackend :: L3 Shader Throughput */
#define ehl__rasterizer_and_pixel_backend__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set RasterizerAndPixelBackend :: Shader Barrier Messages */
#define ehl__rasterizer_and_pixel_backend__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Rasterizer Input Available */
#define ehl__rasterizer_and_pixel_backend__rasterizer0_input_available__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Rasterizer Output Ready */
#define ehl__rasterizer_and_pixel_backend__rasterizer0_output_ready__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Pipe0 Post-EarlyZ Pixel Data Ready */
#define ehl__rasterizer_and_pixel_backend__pixel_data00_ready__read \
    bdw__render_basic__sampler1_busy__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Pipe1 Post-EarlyZ Pixel Data Ready */
#define ehl__rasterizer_and_pixel_backend__pixel_data01_ready__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Pipe0 PS Output Available */
#define ehl__rasterizer_and_pixel_backend__ps_output00_available__read \
    bdw__render_pipe_profile__cl_stall__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Pipe1 PS Output Available */
#define ehl__rasterizer_and_pixel_backend__ps_output01_available__read \
    bdw__render_pipe_profile__sf_stall__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Pipe0 Pixel Values Ready */
#define ehl__rasterizer_and_pixel_backend__pixel_values00_ready__read \
    bdw__render_pipe_profile__ds_stall__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Pipe1 Pixel Values Ready */
#define ehl__rasterizer_and_pixel_backend__pixel_values01_ready__read \
    bdw__render_pipe_profile__so_stall__read

/* Metric set RasterizerAndPixelBackend :: SQ is full */
#define ehl__rasterizer_and_pixel_backend__gt_request_queue_full__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set L3_1 :: GPU Time Elapsed */
#define ehl__l3_1__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set L3_1 :: GPU Core Clocks */
#define ehl__l3_1__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set L3_1 :: AVG GPU Core Frequency */
#define ehl__l3_1__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set L3_1 :: AVG GPU Core Frequency */
#define ehl__l3_1__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set L3_1 :: GPU Busy */
#define ehl__l3_1__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set L3_1 :: VS Threads Dispatched */
#define ehl__l3_1__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set L3_1 :: HS Threads Dispatched */
#define ehl__l3_1__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set L3_1 :: DS Threads Dispatched */
#define ehl__l3_1__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set L3_1 :: GS Threads Dispatched */
#define ehl__l3_1__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set L3_1 :: FS Threads Dispatched */
#define ehl__l3_1__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set L3_1 :: CS Threads Dispatched */
#define ehl__l3_1__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set L3_1 :: EU Active */
#define ehl__l3_1__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set L3_1 :: EU Stall */
#define ehl__l3_1__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set L3_1 :: EU Both FPU Pipes Active */
#define ehl__l3_1__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set L3_1 :: VS FPU0 Pipe Active */
#define ehl__l3_1__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set L3_1 :: VS FPU1 Pipe Active */
#define ehl__l3_1__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set L3_1 :: VS Send Pipe Active */
#define ehl__l3_1__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set L3_1 :: PS FPU0 Pipe Active */
#define ehl__l3_1__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set L3_1 :: PS FPU1 Pipe Active */
#define ehl__l3_1__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set L3_1 :: PS Send Pipeline Active */
#define ehl__l3_1__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set L3_1 :: FS Both FPU Active */
#define ehl__l3_1__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set L3_1 :: Rasterized Pixels */
#define ehl__l3_1__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set L3_1 :: Early Hi-Depth Test Fails */
#define ehl__l3_1__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set L3_1 :: Early Depth Test Fails */
#define ehl__l3_1__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set L3_1 :: Samples Killed in FS */
#define ehl__l3_1__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set L3_1 :: Pixels Failing Tests */
#define ehl__l3_1__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set L3_1 :: Samples Written */
#define ehl__l3_1__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set L3_1 :: Samples Blended */
#define ehl__l3_1__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set L3_1 :: Sampler Texels */
#define ehl__l3_1__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set L3_1 :: Sampler Texels Misses */
#define ehl__l3_1__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set L3_1 :: SLM Bytes Read */
#define ehl__l3_1__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set L3_1 :: SLM Bytes Read */
#define ehl__l3_1__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_1 :: SLM Bytes Written */
#define ehl__l3_1__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set L3_1 :: SLM Bytes Written */
#define ehl__l3_1__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_1 :: Shader Memory Accesses */
#define ehl__l3_1__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set L3_1 :: Shader Atomic Memory Accesses */
#define ehl__l3_1__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set L3_1 :: L3 Shader Throughput */
#define ehl__l3_1__l3_shader_throughput__read \
    cnl__render_basic__l3_shader_throughput__read

/* Metric set L3_1 :: L3 Shader Throughput */
#define ehl__l3_1__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set L3_1 :: Shader Barrier Messages */
#define ehl__l3_1__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set L3_1 :: Slice0 L3 Bank0 Active */
#define ehl__l3_1__l30_bank0_active__read \
    bdw__render_pipe_profile__vf_bottleneck__read

/* Metric set L3_1 :: Slice0 L3 Bank1 Active */
#define ehl__l3_1__l30_bank1_active__read \
    bdw__render_pipe_profile__hs_stall__read

/* Metric set L3_1 :: Slice0 L3 Bank2 Active */
#define ehl__l3_1__l30_bank2_active__read \
    bdw__render_pipe_profile__ds_stall__read

/* Metric set L3_1 :: Slice0 L3 Bank3 Active */
#define ehl__l3_1__l30_bank3_active__read \
    bdw__render_pipe_profile__so_stall__read

/* Metric set L3_1 :: Slice0 L3 Bank4 Active */
#define ehl__l3_1__l30_bank4_active__read \
    bdw__render_pipe_profile__cl_stall__read

/* Metric set L3_1 :: Slice0 L3 Bank5 Active */
#define ehl__l3_1__l30_bank5_active__read \
    bdw__render_pipe_profile__sf_stall__read

/* Metric set L3_1 :: Slice0 L3 Bank6 Active */
#define ehl__l3_1__l30_bank6_active__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set L3_1 :: Slice0 L3 Bank7 Active */
#define ehl__l3_1__l30_bank7_active__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set L3_1 :: SQ is full */
#define ehl__l3_1__gt_request_queue_full__read \
    bdw__render_pipe_profile__early_depth_bottleneck__read

/* Gen11 L2Bank0 stalled metric set :: GPU Time Elapsed */
#define ehl__l3_2__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Gen11 L2Bank0 stalled metric set :: GPU Core Clocks */
#define ehl__l3_2__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Gen11 L2Bank0 stalled metric set :: AVG GPU Core Frequency */
#define ehl__l3_2__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Gen11 L2Bank0 stalled metric set :: AVG GPU Core Frequency */
#define ehl__l3_2__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Gen11 L2Bank0 stalled metric set :: GPU Busy */
#define ehl__l3_2__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Gen11 L2Bank0 stalled metric set :: VS Threads Dispatched */
#define ehl__l3_2__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Gen11 L2Bank0 stalled metric set :: HS Threads Dispatched */
#define ehl__l3_2__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Gen11 L2Bank0 stalled metric set :: DS Threads Dispatched */
#define ehl__l3_2__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Gen11 L2Bank0 stalled metric set :: GS Threads Dispatched */
#define ehl__l3_2__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Gen11 L2Bank0 stalled metric set :: FS Threads Dispatched */
#define ehl__l3_2__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Gen11 L2Bank0 stalled metric set :: CS Threads Dispatched */
#define ehl__l3_2__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Gen11 L2Bank0 stalled metric set :: Rasterized Pixels */
#define ehl__l3_2__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Gen11 L2Bank0 stalled metric set :: Early Hi-Depth Test Fails */
#define ehl__l3_2__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Gen11 L2Bank0 stalled metric set :: Early Depth Test Fails */
#define ehl__l3_2__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Gen11 L2Bank0 stalled metric set :: Samples Killed in FS */
#define ehl__l3_2__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Gen11 L2Bank0 stalled metric set :: Pixels Failing Tests */
#define ehl__l3_2__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Gen11 L2Bank0 stalled metric set :: Samples Written */
#define ehl__l3_2__samples_written__read \
    bdw__render_basic__samples_written__read

/* Gen11 L2Bank0 stalled metric set :: Samples Blended */
#define ehl__l3_2__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Gen11 L2Bank0 stalled metric set :: EU Active */
#define ehl__l3_2__eu_active__read \
    bdw__render_basic__eu_active__read

/* Gen11 L2Bank0 stalled metric set :: EU Stall */
#define ehl__l3_2__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Gen11 L2Bank0 stalled metric set :: EU Both FPU Pipes Active */
#define ehl__l3_2__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Gen11 L2Bank0 stalled metric set :: EU Thread Occupancy */
#define ehl__l3_2__eu_thread_occupancy__read \
    bdw__vme_pipe__eu_thread_occupancy__read

/* Gen11 L2Bank0 stalled metric set :: VS FPU0 Pipe Active */
#define ehl__l3_2__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Gen11 L2Bank0 stalled metric set :: VS FPU1 Pipe Active */
#define ehl__l3_2__vs_fpu1_active__read \
    bdw__render_basic__vs_send_active__read

/* Gen11 L2Bank0 stalled metric set :: VS Send Pipe Active */
#define ehl__l3_2__vs_send_active__read \
    bdw__compute_l3_cache__eu_hybrid_fpu0_instruction__read

/* Gen11 L2Bank0 stalled metric set :: PS FPU0 Pipe Active */
#define ehl__l3_2__ps_fpu0_active__read \
    bdw__compute_l3_cache__eu_hybrid_fpu1_instruction__read

/* Gen11 L2Bank0 stalled metric set :: PS FPU1 Pipe Active */
#define ehl__l3_2__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Gen11 L2Bank0 stalled metric set :: PS Send Pipeline Active */
#define ehl__l3_2__ps_send_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Gen11 L2Bank0 stalled metric set :: FS Both FPU Active */
#define ehl__l3_2__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_send_active__read

/* Gen11 L2Bank0 stalled metric set :: Slice0 L3 Bank0 Stalled */
#define ehl__l3_2__l30_bank0_stalled__read \
    icl__l3_2__l30_bank0_stalled__read

/* Gen11 L2Bank1 stalled metric set :: GPU Time Elapsed */
#define ehl__l3_3__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Gen11 L2Bank1 stalled metric set :: GPU Core Clocks */
#define ehl__l3_3__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Gen11 L2Bank1 stalled metric set :: AVG GPU Core Frequency */
#define ehl__l3_3__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Gen11 L2Bank1 stalled metric set :: AVG GPU Core Frequency */
#define ehl__l3_3__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Gen11 L2Bank1 stalled metric set :: GPU Busy */
#define ehl__l3_3__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Gen11 L2Bank1 stalled metric set :: VS Threads Dispatched */
#define ehl__l3_3__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Gen11 L2Bank1 stalled metric set :: HS Threads Dispatched */
#define ehl__l3_3__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Gen11 L2Bank1 stalled metric set :: DS Threads Dispatched */
#define ehl__l3_3__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Gen11 L2Bank1 stalled metric set :: GS Threads Dispatched */
#define ehl__l3_3__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Gen11 L2Bank1 stalled metric set :: FS Threads Dispatched */
#define ehl__l3_3__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Gen11 L2Bank1 stalled metric set :: CS Threads Dispatched */
#define ehl__l3_3__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Gen11 L2Bank1 stalled metric set :: Rasterized Pixels */
#define ehl__l3_3__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Gen11 L2Bank1 stalled metric set :: Early Hi-Depth Test Fails */
#define ehl__l3_3__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Gen11 L2Bank1 stalled metric set :: Early Depth Test Fails */
#define ehl__l3_3__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Gen11 L2Bank1 stalled metric set :: Samples Killed in FS */
#define ehl__l3_3__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Gen11 L2Bank1 stalled metric set :: Pixels Failing Tests */
#define ehl__l3_3__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Gen11 L2Bank1 stalled metric set :: Samples Written */
#define ehl__l3_3__samples_written__read \
    bdw__render_basic__samples_written__read

/* Gen11 L2Bank1 stalled metric set :: Samples Blended */
#define ehl__l3_3__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Gen11 L2Bank1 stalled metric set :: EU Active */
#define ehl__l3_3__eu_active__read \
    bdw__render_basic__eu_active__read

/* Gen11 L2Bank1 stalled metric set :: EU Stall */
#define ehl__l3_3__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Gen11 L2Bank1 stalled metric set :: EU Both FPU Pipes Active */
#define ehl__l3_3__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Gen11 L2Bank1 stalled metric set :: EU Thread Occupancy */
#define ehl__l3_3__eu_thread_occupancy__read \
    bdw__vme_pipe__eu_thread_occupancy__read

/* Gen11 L2Bank1 stalled metric set :: VS FPU0 Pipe Active */
#define ehl__l3_3__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Gen11 L2Bank1 stalled metric set :: VS FPU1 Pipe Active */
#define ehl__l3_3__vs_fpu1_active__read \
    bdw__render_basic__vs_send_active__read

/* Gen11 L2Bank1 stalled metric set :: VS Send Pipe Active */
#define ehl__l3_3__vs_send_active__read \
    bdw__compute_l3_cache__eu_hybrid_fpu0_instruction__read

/* Gen11 L2Bank1 stalled metric set :: PS FPU0 Pipe Active */
#define ehl__l3_3__ps_fpu0_active__read \
    bdw__compute_l3_cache__eu_hybrid_fpu1_instruction__read

/* Gen11 L2Bank1 stalled metric set :: PS FPU1 Pipe Active */
#define ehl__l3_3__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Gen11 L2Bank1 stalled metric set :: PS Send Pipeline Active */
#define ehl__l3_3__ps_send_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Gen11 L2Bank1 stalled metric set :: FS Both FPU Active */
#define ehl__l3_3__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_send_active__read

/* Gen11 L2Bank1 stalled metric set :: Slice0 L3 Bank1 Stalled */
#define ehl__l3_3__l30_bank1_stalled__read \
    icl__l3_2__l30_bank0_stalled__read

/* Gen11 L2Bank4 stalled metric set :: GPU Time Elapsed */
#define ehl__l3_4__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Gen11 L2Bank4 stalled metric set :: GPU Core Clocks */
#define ehl__l3_4__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Gen11 L2Bank4 stalled metric set :: AVG GPU Core Frequency */
#define ehl__l3_4__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Gen11 L2Bank4 stalled metric set :: AVG GPU Core Frequency */
#define ehl__l3_4__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Gen11 L2Bank4 stalled metric set :: GPU Busy */
#define ehl__l3_4__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Gen11 L2Bank4 stalled metric set :: VS Threads Dispatched */
#define ehl__l3_4__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Gen11 L2Bank4 stalled metric set :: HS Threads Dispatched */
#define ehl__l3_4__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Gen11 L2Bank4 stalled metric set :: DS Threads Dispatched */
#define ehl__l3_4__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Gen11 L2Bank4 stalled metric set :: GS Threads Dispatched */
#define ehl__l3_4__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Gen11 L2Bank4 stalled metric set :: FS Threads Dispatched */
#define ehl__l3_4__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Gen11 L2Bank4 stalled metric set :: CS Threads Dispatched */
#define ehl__l3_4__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Gen11 L2Bank4 stalled metric set :: Rasterized Pixels */
#define ehl__l3_4__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Gen11 L2Bank4 stalled metric set :: Early Hi-Depth Test Fails */
#define ehl__l3_4__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Gen11 L2Bank4 stalled metric set :: Early Depth Test Fails */
#define ehl__l3_4__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Gen11 L2Bank4 stalled metric set :: Samples Killed in FS */
#define ehl__l3_4__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Gen11 L2Bank4 stalled metric set :: Pixels Failing Tests */
#define ehl__l3_4__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Gen11 L2Bank4 stalled metric set :: Samples Written */
#define ehl__l3_4__samples_written__read \
    bdw__render_basic__samples_written__read

/* Gen11 L2Bank4 stalled metric set :: Samples Blended */
#define ehl__l3_4__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Gen11 L2Bank4 stalled metric set :: EU Active */
#define ehl__l3_4__eu_active__read \
    bdw__render_basic__eu_active__read

/* Gen11 L2Bank4 stalled metric set :: EU Stall */
#define ehl__l3_4__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Gen11 L2Bank4 stalled metric set :: EU Both FPU Pipes Active */
#define ehl__l3_4__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Gen11 L2Bank4 stalled metric set :: EU Thread Occupancy */
#define ehl__l3_4__eu_thread_occupancy__read \
    bdw__vme_pipe__eu_thread_occupancy__read

/* Gen11 L2Bank4 stalled metric set :: VS FPU0 Pipe Active */
#define ehl__l3_4__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Gen11 L2Bank4 stalled metric set :: VS FPU1 Pipe Active */
#define ehl__l3_4__vs_fpu1_active__read \
    bdw__render_basic__vs_send_active__read

/* Gen11 L2Bank4 stalled metric set :: VS Send Pipe Active */
#define ehl__l3_4__vs_send_active__read \
    bdw__compute_l3_cache__eu_hybrid_fpu0_instruction__read

/* Gen11 L2Bank4 stalled metric set :: PS FPU0 Pipe Active */
#define ehl__l3_4__ps_fpu0_active__read \
    bdw__compute_l3_cache__eu_hybrid_fpu1_instruction__read

/* Gen11 L2Bank4 stalled metric set :: PS FPU1 Pipe Active */
#define ehl__l3_4__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Gen11 L2Bank4 stalled metric set :: PS Send Pipeline Active */
#define ehl__l3_4__ps_send_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Gen11 L2Bank4 stalled metric set :: FS Both FPU Active */
#define ehl__l3_4__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_send_active__read

/* Gen11 L2Bank4 stalled metric set :: Slice0 L3 Bank4 Stalled */
#define ehl__l3_4__l30_bank4_stalled__read \
    icl__l3_2__l30_bank0_stalled__read

/* Gen11 L2Bank5 stalled metric set :: GPU Time Elapsed */
#define ehl__l3_5__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Gen11 L2Bank5 stalled metric set :: GPU Core Clocks */
#define ehl__l3_5__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Gen11 L2Bank5 stalled metric set :: AVG GPU Core Frequency */
#define ehl__l3_5__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Gen11 L2Bank5 stalled metric set :: AVG GPU Core Frequency */
#define ehl__l3_5__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Gen11 L2Bank5 stalled metric set :: GPU Busy */
#define ehl__l3_5__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Gen11 L2Bank5 stalled metric set :: VS Threads Dispatched */
#define ehl__l3_5__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Gen11 L2Bank5 stalled metric set :: HS Threads Dispatched */
#define ehl__l3_5__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Gen11 L2Bank5 stalled metric set :: DS Threads Dispatched */
#define ehl__l3_5__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Gen11 L2Bank5 stalled metric set :: GS Threads Dispatched */
#define ehl__l3_5__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Gen11 L2Bank5 stalled metric set :: FS Threads Dispatched */
#define ehl__l3_5__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Gen11 L2Bank5 stalled metric set :: CS Threads Dispatched */
#define ehl__l3_5__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Gen11 L2Bank5 stalled metric set :: Rasterized Pixels */
#define ehl__l3_5__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Gen11 L2Bank5 stalled metric set :: Early Hi-Depth Test Fails */
#define ehl__l3_5__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Gen11 L2Bank5 stalled metric set :: Early Depth Test Fails */
#define ehl__l3_5__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Gen11 L2Bank5 stalled metric set :: Samples Killed in FS */
#define ehl__l3_5__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Gen11 L2Bank5 stalled metric set :: Pixels Failing Tests */
#define ehl__l3_5__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Gen11 L2Bank5 stalled metric set :: Samples Written */
#define ehl__l3_5__samples_written__read \
    bdw__render_basic__samples_written__read

/* Gen11 L2Bank5 stalled metric set :: Samples Blended */
#define ehl__l3_5__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Gen11 L2Bank5 stalled metric set :: EU Active */
#define ehl__l3_5__eu_active__read \
    bdw__render_basic__eu_active__read

/* Gen11 L2Bank5 stalled metric set :: EU Stall */
#define ehl__l3_5__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Gen11 L2Bank5 stalled metric set :: EU Both FPU Pipes Active */
#define ehl__l3_5__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Gen11 L2Bank5 stalled metric set :: EU Thread Occupancy */
#define ehl__l3_5__eu_thread_occupancy__read \
    bdw__vme_pipe__eu_thread_occupancy__read

/* Gen11 L2Bank5 stalled metric set :: VS FPU0 Pipe Active */
#define ehl__l3_5__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Gen11 L2Bank5 stalled metric set :: VS FPU1 Pipe Active */
#define ehl__l3_5__vs_fpu1_active__read \
    bdw__render_basic__vs_send_active__read

/* Gen11 L2Bank5 stalled metric set :: VS Send Pipe Active */
#define ehl__l3_5__vs_send_active__read \
    bdw__compute_l3_cache__eu_hybrid_fpu0_instruction__read

/* Gen11 L2Bank5 stalled metric set :: PS FPU0 Pipe Active */
#define ehl__l3_5__ps_fpu0_active__read \
    bdw__compute_l3_cache__eu_hybrid_fpu1_instruction__read

/* Gen11 L2Bank5 stalled metric set :: PS FPU1 Pipe Active */
#define ehl__l3_5__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Gen11 L2Bank5 stalled metric set :: PS Send Pipeline Active */
#define ehl__l3_5__ps_send_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Gen11 L2Bank5 stalled metric set :: FS Both FPU Active */
#define ehl__l3_5__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_send_active__read

/* Gen11 L2Bank5 stalled metric set :: Slice0 L3 Bank5 Stalled */
#define ehl__l3_5__l30_bank5_stalled__read \
    icl__l3_5__l30_bank5_stalled__read

/* Metric set Sampler 1 :: GPU Time Elapsed */
#define ehl__sampler_1__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set Sampler 1 :: GPU Core Clocks */
#define ehl__sampler_1__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set Sampler 1 :: AVG GPU Core Frequency */
#define ehl__sampler_1__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set Sampler 1 :: AVG GPU Core Frequency */
#define ehl__sampler_1__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set Sampler 1 :: GPU Busy */
#define ehl__sampler_1__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set Sampler 1 :: VS Threads Dispatched */
#define ehl__sampler_1__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set Sampler 1 :: HS Threads Dispatched */
#define ehl__sampler_1__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set Sampler 1 :: DS Threads Dispatched */
#define ehl__sampler_1__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set Sampler 1 :: GS Threads Dispatched */
#define ehl__sampler_1__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set Sampler 1 :: FS Threads Dispatched */
#define ehl__sampler_1__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set Sampler 1 :: CS Threads Dispatched */
#define ehl__sampler_1__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set Sampler 1 :: EU Active */
#define ehl__sampler_1__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set Sampler 1 :: EU Stall */
#define ehl__sampler_1__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set Sampler 1 :: EU Both FPU Pipes Active */
#define ehl__sampler_1__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set Sampler 1 :: VS FPU0 Pipe Active */
#define ehl__sampler_1__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set Sampler 1 :: VS FPU1 Pipe Active */
#define ehl__sampler_1__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set Sampler 1 :: VS Send Pipe Active */
#define ehl__sampler_1__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set Sampler 1 :: PS FPU0 Pipe Active */
#define ehl__sampler_1__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set Sampler 1 :: PS FPU1 Pipe Active */
#define ehl__sampler_1__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set Sampler 1 :: PS Send Pipeline Active */
#define ehl__sampler_1__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set Sampler 1 :: FS Both FPU Active */
#define ehl__sampler_1__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set Sampler 1 :: Rasterized Pixels */
#define ehl__sampler_1__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set Sampler 1 :: Early Hi-Depth Test Fails */
#define ehl__sampler_1__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set Sampler 1 :: Early Depth Test Fails */
#define ehl__sampler_1__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set Sampler 1 :: Samples Killed in FS */
#define ehl__sampler_1__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set Sampler 1 :: Pixels Failing Tests */
#define ehl__sampler_1__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set Sampler 1 :: Samples Written */
#define ehl__sampler_1__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set Sampler 1 :: Samples Blended */
#define ehl__sampler_1__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set Sampler 1 :: Sampler Texels */
#define ehl__sampler_1__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set Sampler 1 :: Sampler Texels Misses */
#define ehl__sampler_1__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set Sampler 1 :: SLM Bytes Read */
#define ehl__sampler_1__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set Sampler 1 :: SLM Bytes Read */
#define ehl__sampler_1__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set Sampler 1 :: SLM Bytes Written */
#define ehl__sampler_1__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set Sampler 1 :: SLM Bytes Written */
#define ehl__sampler_1__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set Sampler 1 :: Shader Memory Accesses */
#define ehl__sampler_1__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set Sampler 1 :: Shader Atomic Memory Accesses */
#define ehl__sampler_1__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set Sampler 1 :: L3 Shader Throughput */
#define ehl__sampler_1__l3_shader_throughput__read \
    cnl__render_basic__l3_shader_throughput__read

/* Metric set Sampler 1 :: L3 Shader Throughput */
#define ehl__sampler_1__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set Sampler 1 :: Shader Barrier Messages */
#define ehl__sampler_1__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set Sampler 1 :: Slice0 Subslice0 Input Available */
#define ehl__sampler_1__sampler00_input_available__read \
    bdw__render_pipe_profile__early_depth_bottleneck__read

/* Metric set Sampler 1 :: Slice0 Subslice1 Input Available */
#define ehl__sampler_1__sampler01_input_available__read \
    bdw__render_pipe_profile__sf_bottleneck__read

/* Metric set Sampler 1 :: Slice0 Subslice2 Input Available */
#define ehl__sampler_1__sampler02_input_available__read \
    bdw__render_pipe_profile__cl_bottleneck__read

/* Metric set Sampler 1 :: Slice0 Subslice3 Input Available */
#define ehl__sampler_1__sampler03_input_available__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* Metric set Sampler 1 :: Slice0 Subslice4 Input Available */
#define ehl__sampler_1__sampler04_input_available__read \
    bdw__render_basic__sampler1_bottleneck__read

/* Metric set Sampler 1 :: Slice0 Subslice5 Input Available */
#define ehl__sampler_1__sampler05_input_available__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Metric set Sampler 1 :: Slice0 Subslice6 Input Available */
#define ehl__sampler_1__sampler06_input_available__read \
    bdw__render_basic__sampler1_busy__read

/* Metric set Sampler 1 :: Slice0 Subslice7 Input Available */
#define ehl__sampler_1__sampler07_input_available__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set Sampler 2 :: GPU Time Elapsed */
#define ehl__sampler_2__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set Sampler 2 :: GPU Core Clocks */
#define ehl__sampler_2__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set Sampler 2 :: AVG GPU Core Frequency */
#define ehl__sampler_2__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set Sampler 2 :: AVG GPU Core Frequency */
#define ehl__sampler_2__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set Sampler 2 :: GPU Busy */
#define ehl__sampler_2__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set Sampler 2 :: VS Threads Dispatched */
#define ehl__sampler_2__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set Sampler 2 :: HS Threads Dispatched */
#define ehl__sampler_2__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set Sampler 2 :: DS Threads Dispatched */
#define ehl__sampler_2__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set Sampler 2 :: GS Threads Dispatched */
#define ehl__sampler_2__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set Sampler 2 :: FS Threads Dispatched */
#define ehl__sampler_2__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set Sampler 2 :: CS Threads Dispatched */
#define ehl__sampler_2__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set Sampler 2 :: EU Active */
#define ehl__sampler_2__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set Sampler 2 :: EU Stall */
#define ehl__sampler_2__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set Sampler 2 :: EU Both FPU Pipes Active */
#define ehl__sampler_2__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set Sampler 2 :: VS FPU0 Pipe Active */
#define ehl__sampler_2__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set Sampler 2 :: VS FPU1 Pipe Active */
#define ehl__sampler_2__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set Sampler 2 :: VS Send Pipe Active */
#define ehl__sampler_2__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set Sampler 2 :: PS FPU0 Pipe Active */
#define ehl__sampler_2__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set Sampler 2 :: PS FPU1 Pipe Active */
#define ehl__sampler_2__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set Sampler 2 :: PS Send Pipeline Active */
#define ehl__sampler_2__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set Sampler 2 :: FS Both FPU Active */
#define ehl__sampler_2__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set Sampler 2 :: Rasterized Pixels */
#define ehl__sampler_2__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set Sampler 2 :: Early Hi-Depth Test Fails */
#define ehl__sampler_2__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set Sampler 2 :: Early Depth Test Fails */
#define ehl__sampler_2__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set Sampler 2 :: Samples Killed in FS */
#define ehl__sampler_2__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set Sampler 2 :: Pixels Failing Tests */
#define ehl__sampler_2__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set Sampler 2 :: Samples Written */
#define ehl__sampler_2__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set Sampler 2 :: Samples Blended */
#define ehl__sampler_2__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set Sampler 2 :: Sampler Texels */
#define ehl__sampler_2__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set Sampler 2 :: Sampler Texels Misses */
#define ehl__sampler_2__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set Sampler 2 :: SLM Bytes Read */
#define ehl__sampler_2__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set Sampler 2 :: SLM Bytes Read */
#define ehl__sampler_2__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set Sampler 2 :: SLM Bytes Written */
#define ehl__sampler_2__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set Sampler 2 :: SLM Bytes Written */
#define ehl__sampler_2__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set Sampler 2 :: Shader Memory Accesses */
#define ehl__sampler_2__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set Sampler 2 :: Shader Atomic Memory Accesses */
#define ehl__sampler_2__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set Sampler 2 :: L3 Shader Throughput */
#define ehl__sampler_2__l3_shader_throughput__read \
    cnl__render_basic__l3_shader_throughput__read

/* Metric set Sampler 2 :: L3 Shader Throughput */
#define ehl__sampler_2__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set Sampler 2 :: Shader Barrier Messages */
#define ehl__sampler_2__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set Sampler 2 :: Slice0 Subslice0 Sampler Output Ready */
#define ehl__sampler_2__sampler00_output_ready__read \
    bdw__render_pipe_profile__vf_bottleneck__read

/* Metric set Sampler 2 :: Slice0 Subslice1 Sampler Output Ready */
#define ehl__sampler_2__sampler01_output_ready__read \
    bdw__render_pipe_profile__hs_stall__read

/* Metric set Sampler 2 :: Slice0 Subslice2 Sampler Output Ready */
#define ehl__sampler_2__sampler02_output_ready__read \
    bdw__render_pipe_profile__ds_stall__read

/* Metric set Sampler 2 :: Slice0 Subslice3 Sampler Output Ready */
#define ehl__sampler_2__sampler03_output_ready__read \
    bdw__render_pipe_profile__so_stall__read

/* Metric set Sampler 2 :: Slice0 Subslice4 Sampler Output Ready */
#define ehl__sampler_2__sampler04_output_ready__read \
    bdw__render_pipe_profile__cl_stall__read

/* Metric set Sampler 2 :: Slice0 Subslice5 Sampler Output Ready */
#define ehl__sampler_2__sampler05_output_ready__read \
    bdw__render_pipe_profile__sf_stall__read

/* Metric set Sampler 2 :: Slice0 Subslice6 Sampler Output Ready */
#define ehl__sampler_2__sampler06_output_ready__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set Sampler 2 :: Slice0 Subslice7 Sampler Output Ready */
#define ehl__sampler_2__sampler07_output_ready__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set Sampler 2 :: SQ is full */
#define ehl__sampler_2__gt_request_queue_full__read \
    bdw__render_pipe_profile__early_depth_bottleneck__read

/* Metric set TDL_1 :: GPU Time Elapsed */
#define ehl__tdl_1__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set TDL_1 :: GPU Core Clocks */
#define ehl__tdl_1__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set TDL_1 :: AVG GPU Core Frequency */
#define ehl__tdl_1__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set TDL_1 :: AVG GPU Core Frequency */
#define ehl__tdl_1__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set TDL_1 :: GPU Busy */
#define ehl__tdl_1__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set TDL_1 :: VS Threads Dispatched */
#define ehl__tdl_1__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set TDL_1 :: HS Threads Dispatched */
#define ehl__tdl_1__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set TDL_1 :: DS Threads Dispatched */
#define ehl__tdl_1__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set TDL_1 :: GS Threads Dispatched */
#define ehl__tdl_1__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set TDL_1 :: FS Threads Dispatched */
#define ehl__tdl_1__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set TDL_1 :: CS Threads Dispatched */
#define ehl__tdl_1__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set TDL_1 :: EU Active */
#define ehl__tdl_1__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set TDL_1 :: EU Stall */
#define ehl__tdl_1__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set TDL_1 :: EU Both FPU Pipes Active */
#define ehl__tdl_1__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set TDL_1 :: VS FPU0 Pipe Active */
#define ehl__tdl_1__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set TDL_1 :: VS FPU1 Pipe Active */
#define ehl__tdl_1__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set TDL_1 :: VS Send Pipe Active */
#define ehl__tdl_1__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set TDL_1 :: VS EU Active */
#define ehl__tdl_1__vs_eu_active__read \
    bdw__compute_l3_cache__eu_hybrid_fpu0_instruction__read

/* Metric set TDL_1 :: VS AVG Active per Thread */
#define ehl__tdl_1__vs_eu_active_per_thread__read \
    icl__tdl_1__vs_eu_active_per_thread__read

/* Metric set TDL_1 :: VS EU Stall */
#define ehl__tdl_1__vs_eu_stall__read \
    bdw__compute_l3_cache__eu_hybrid_fpu1_instruction__read

/* Metric set TDL_1 :: VS AVG Stall per Thread */
#define ehl__tdl_1__vs_eu_stall_per_thread__read \
    icl__tdl_1__vs_eu_stall_per_thread__read

/* Metric set TDL_1 :: PS FPU0 Pipe Active */
#define ehl__tdl_1__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set TDL_1 :: PS FPU1 Pipe Active */
#define ehl__tdl_1__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set TDL_1 :: PS Send Pipeline Active */
#define ehl__tdl_1__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set TDL_1 :: FS Both FPU Active */
#define ehl__tdl_1__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set TDL_1 :: FS EU Active */
#define ehl__tdl_1__ps_eu_active__read \
    bdw__compute_l3_cache__eu_move_fpu0_instruction__read

/* Metric set TDL_1 :: FS AVG Active per Thread */
#define ehl__tdl_1__ps_eu_active_per_thread__read \
    icl__tdl_1__ps_eu_active_per_thread__read

/* Metric set TDL_1 :: FS EU Stall */
#define ehl__tdl_1__ps_eu_stall__read \
    bdw__compute_l3_cache__eu_move_fpu1_instruction__read

/* Metric set TDL_1 :: FS AVG Stall per Thread */
#define ehl__tdl_1__ps_eu_stall_per_thread__read \
    icl__tdl_1__ps_eu_stall_per_thread__read

/* Metric set TDL_1 :: Rasterized Pixels */
#define ehl__tdl_1__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set TDL_1 :: Early Hi-Depth Test Fails */
#define ehl__tdl_1__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set TDL_1 :: Early Depth Test Fails */
#define ehl__tdl_1__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set TDL_1 :: Samples Killed in FS */
#define ehl__tdl_1__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set TDL_1 :: Pixels Failing Tests */
#define ehl__tdl_1__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set TDL_1 :: Samples Written */
#define ehl__tdl_1__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set TDL_1 :: Samples Blended */
#define ehl__tdl_1__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set TDL_1 :: Sampler Texels */
#define ehl__tdl_1__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set TDL_1 :: Sampler Texels Misses */
#define ehl__tdl_1__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set TDL_1 :: SLM Bytes Read */
#define ehl__tdl_1__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set TDL_1 :: SLM Bytes Read */
#define ehl__tdl_1__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_1 :: SLM Bytes Written */
#define ehl__tdl_1__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set TDL_1 :: SLM Bytes Written */
#define ehl__tdl_1__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_1 :: Shader Memory Accesses */
#define ehl__tdl_1__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set TDL_1 :: Shader Atomic Memory Accesses */
#define ehl__tdl_1__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set TDL_1 :: L3 Shader Throughput */
#define ehl__tdl_1__l3_shader_throughput__read \
    cnl__render_basic__l3_shader_throughput__read

/* Metric set TDL_1 :: L3 Shader Throughput */
#define ehl__tdl_1__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_1 :: Shader Barrier Messages */
#define ehl__tdl_1__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set TDL_1 :: PS Thread Ready For Dispatch on Slice0 Subslice0 Thread Dispatcher */
#define ehl__tdl_1__ps_thread00_ready_for_dispatch__read \
    bdw__render_pipe_profile__early_depth_bottleneck__read

/* Metric set TDL_1 :: PS Thread Ready For Dispatch on Slice0 Subslice1 Thread Dispatcher */
#define ehl__tdl_1__ps_thread01_ready_for_dispatch__read \
    bdw__render_pipe_profile__sf_bottleneck__read

/* Metric set TDL_1 :: PS Thread Ready For Dispatch on Slice0 Subslice2 Thread Dispatcher */
#define ehl__tdl_1__ps_thread02_ready_for_dispatch__read \
    bdw__render_pipe_profile__cl_bottleneck__read

/* Metric set TDL_1 :: PS Thread Ready For Dispatch on Slice0 Subslice3 Thread Dispatcher */
#define ehl__tdl_1__ps_thread03_ready_for_dispatch__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* Metric set TDL_1 :: PS Thread Ready For Dispatch on Slice0 Subslice4 Thread Dispatcher */
#define ehl__tdl_1__ps_thread04_ready_for_dispatch__read \
    bdw__render_basic__sampler1_bottleneck__read

/* Metric set TDL_1 :: PS Thread Ready For Dispatch on Slice0 Subslice5 Thread Dispatcher */
#define ehl__tdl_1__ps_thread05_ready_for_dispatch__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Metric set TDL_1 :: PS Thread Ready For Dispatch on Slice0 Subslice6 Thread Dispatcher */
#define ehl__tdl_1__ps_thread06_ready_for_dispatch__read \
    bdw__render_basic__sampler1_busy__read

/* Metric set TDL_1 :: PS Thread Ready For Dispatch on Slice0 Subslice7 Thread Dispatcher */
#define ehl__tdl_1__ps_thread07_ready_for_dispatch__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set TDL_2 :: GPU Time Elapsed */
#define ehl__tdl_2__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set TDL_2 :: GPU Core Clocks */
#define ehl__tdl_2__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set TDL_2 :: AVG GPU Core Frequency */
#define ehl__tdl_2__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set TDL_2 :: AVG GPU Core Frequency */
#define ehl__tdl_2__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set TDL_2 :: GPU Busy */
#define ehl__tdl_2__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set TDL_2 :: VS Threads Dispatched */
#define ehl__tdl_2__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set TDL_2 :: HS Threads Dispatched */
#define ehl__tdl_2__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set TDL_2 :: DS Threads Dispatched */
#define ehl__tdl_2__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set TDL_2 :: GS Threads Dispatched */
#define ehl__tdl_2__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set TDL_2 :: FS Threads Dispatched */
#define ehl__tdl_2__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set TDL_2 :: CS Threads Dispatched */
#define ehl__tdl_2__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set TDL_2 :: EU Active */
#define ehl__tdl_2__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set TDL_2 :: EU Stall */
#define ehl__tdl_2__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set TDL_2 :: EU Both FPU Pipes Active */
#define ehl__tdl_2__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set TDL_2 :: VS FPU0 Pipe Active */
#define ehl__tdl_2__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set TDL_2 :: VS FPU1 Pipe Active */
#define ehl__tdl_2__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set TDL_2 :: VS Send Pipe Active */
#define ehl__tdl_2__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set TDL_2 :: PS FPU0 Pipe Active */
#define ehl__tdl_2__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set TDL_2 :: PS FPU1 Pipe Active */
#define ehl__tdl_2__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set TDL_2 :: PS Send Pipeline Active */
#define ehl__tdl_2__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set TDL_2 :: FS Both FPU Active */
#define ehl__tdl_2__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set TDL_2 :: Rasterized Pixels */
#define ehl__tdl_2__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set TDL_2 :: Early Hi-Depth Test Fails */
#define ehl__tdl_2__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set TDL_2 :: Early Depth Test Fails */
#define ehl__tdl_2__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set TDL_2 :: Samples Killed in FS */
#define ehl__tdl_2__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set TDL_2 :: Pixels Failing Tests */
#define ehl__tdl_2__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set TDL_2 :: Samples Written */
#define ehl__tdl_2__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set TDL_2 :: Samples Blended */
#define ehl__tdl_2__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set TDL_2 :: Sampler Texels */
#define ehl__tdl_2__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set TDL_2 :: Sampler Texels Misses */
#define ehl__tdl_2__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set TDL_2 :: SLM Bytes Read */
#define ehl__tdl_2__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set TDL_2 :: SLM Bytes Read */
#define ehl__tdl_2__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_2 :: SLM Bytes Written */
#define ehl__tdl_2__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set TDL_2 :: SLM Bytes Written */
#define ehl__tdl_2__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_2 :: Shader Memory Accesses */
#define ehl__tdl_2__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set TDL_2 :: Shader Atomic Memory Accesses */
#define ehl__tdl_2__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set TDL_2 :: L3 Shader Throughput */
#define ehl__tdl_2__l3_shader_throughput__read \
    cnl__render_basic__l3_shader_throughput__read

/* Metric set TDL_2 :: L3 Shader Throughput */
#define ehl__tdl_2__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_2 :: Shader Barrier Messages */
#define ehl__tdl_2__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set TDL_2 :: Non-PS Thread Ready For Dispatch on Slice0 Subslice0 Thread Dispatcher */
#define ehl__tdl_2__non_ps_thread00_ready_for_dispatch__read \
    icl__tdl_2__non_ps_thread00_ready_for_dispatch__read

/* Metric set TDL_2 :: Non-PS Thread Ready For Dispatch on Slice0 Subslice1 Thread Dispatcher */
#define ehl__tdl_2__non_ps_thread01_ready_for_dispatch__read \
    icl__tdl_2__non_ps_thread01_ready_for_dispatch__read

/* Metric set TDL_2 :: Non-PS Thread Ready For Dispatch on Slice0 Subslice2 Thread Dispatcher */
#define ehl__tdl_2__non_ps_thread02_ready_for_dispatch__read \
    icl__tdl_2__non_ps_thread02_ready_for_dispatch__read

/* Metric set TDL_2 :: Non-PS Thread Ready For Dispatch on Slice0 Subslice3 Thread Dispatcher */
#define ehl__tdl_2__non_ps_thread03_ready_for_dispatch__read \
    icl__tdl_2__non_ps_thread03_ready_for_dispatch__read

/* Metric set TDL_2 :: Non-PS Thread Ready For Dispatch on Slice0 Subslice4 Thread Dispatcher */
#define ehl__tdl_2__non_ps_thread04_ready_for_dispatch__read \
    icl__tdl_2__non_ps_thread04_ready_for_dispatch__read

/* Metric set TDL_2 :: Non-PS Thread Ready For Dispatch on Slice0 Subslice5 Thread Dispatcher */
#define ehl__tdl_2__non_ps_thread05_ready_for_dispatch__read \
    icl__tdl_2__non_ps_thread05_ready_for_dispatch__read

/* Metric set TDL_2 :: Non-PS Thread Ready For Dispatch on Slice0 Subslice6 Thread Dispatcher */
#define ehl__tdl_2__non_ps_thread06_ready_for_dispatch__read \
    icl__tdl_2__non_ps_thread06_ready_for_dispatch__read

/* Metric set TDL_2 :: Non-PS Thread Ready For Dispatch on Slice0 Subslice7 Thread Dispatcher */
#define ehl__tdl_2__non_ps_thread07_ready_for_dispatch__read \
    icl__tdl_2__non_ps_thread07_ready_for_dispatch__read

/* Metric set TDL_2 :: SQ is full */
#define ehl__tdl_2__gt_request_queue_full__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Metric set TDL_3 :: GPU Time Elapsed */
#define ehl__tdl_3__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set TDL_3 :: GPU Core Clocks */
#define ehl__tdl_3__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set TDL_3 :: AVG GPU Core Frequency */
#define ehl__tdl_3__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set TDL_3 :: AVG GPU Core Frequency */
#define ehl__tdl_3__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set TDL_3 :: GPU Busy */
#define ehl__tdl_3__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set TDL_3 :: VS Threads Dispatched */
#define ehl__tdl_3__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set TDL_3 :: HS Threads Dispatched */
#define ehl__tdl_3__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set TDL_3 :: DS Threads Dispatched */
#define ehl__tdl_3__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set TDL_3 :: GS Threads Dispatched */
#define ehl__tdl_3__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set TDL_3 :: FS Threads Dispatched */
#define ehl__tdl_3__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set TDL_3 :: CS Threads Dispatched */
#define ehl__tdl_3__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set TDL_3 :: EU Active */
#define ehl__tdl_3__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set TDL_3 :: EU Stall */
#define ehl__tdl_3__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set TDL_3 :: EU Both FPU Pipes Active */
#define ehl__tdl_3__eu_fpu_both_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set TDL_3 :: VS FPU0 Pipe Active */
#define ehl__tdl_3__vs_fpu0_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set TDL_3 :: VS FPU1 Pipe Active */
#define ehl__tdl_3__vs_fpu1_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set TDL_3 :: VS Send Pipe Active */
#define ehl__tdl_3__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set TDL_3 :: PS FPU0 Pipe Active */
#define ehl__tdl_3__ps_fpu0_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set TDL_3 :: PS FPU1 Pipe Active */
#define ehl__tdl_3__ps_fpu1_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set TDL_3 :: PS Send Pipeline Active */
#define ehl__tdl_3__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set TDL_3 :: FS Both FPU Active */
#define ehl__tdl_3__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set TDL_3 :: Rasterized Pixels */
#define ehl__tdl_3__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set TDL_3 :: Early Hi-Depth Test Fails */
#define ehl__tdl_3__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set TDL_3 :: Early Depth Test Fails */
#define ehl__tdl_3__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set TDL_3 :: Samples Killed in FS */
#define ehl__tdl_3__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set TDL_3 :: Pixels Failing Tests */
#define ehl__tdl_3__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set TDL_3 :: Samples Written */
#define ehl__tdl_3__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set TDL_3 :: Samples Blended */
#define ehl__tdl_3__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set TDL_3 :: Sampler Texels */
#define ehl__tdl_3__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set TDL_3 :: Sampler Texels Misses */
#define ehl__tdl_3__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set TDL_3 :: SLM Bytes Read */
#define ehl__tdl_3__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set TDL_3 :: SLM Bytes Read */
#define ehl__tdl_3__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_3 :: SLM Bytes Written */
#define ehl__tdl_3__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set TDL_3 :: SLM Bytes Written */
#define ehl__tdl_3__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_3 :: Shader Memory Accesses */
#define ehl__tdl_3__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set TDL_3 :: Shader Atomic Memory Accesses */
#define ehl__tdl_3__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set TDL_3 :: L3 Shader Throughput */
#define ehl__tdl_3__l3_shader_throughput__read \
    cnl__render_basic__l3_shader_throughput__read

/* Metric set TDL_3 :: L3 Shader Throughput */
#define ehl__tdl_3__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set TDL_3 :: Shader Barrier Messages */
#define ehl__tdl_3__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set TDL_3 :: Thread Header Ready on Slice0 Subslice0 Thread Dispatcher Port 0 */
#define ehl__tdl_3__thread_header00_ready_port0__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set TDL_3 :: Thread Header Ready on Slice0 Subslice0 Thread Dispatcher Port 1 */
#define ehl__tdl_3__thread_header00_ready_port1__read \
    bdw__render_basic__sampler1_busy__read

/* Metric set TDL_3 :: Thread Header Ready on Slice0 Subslice1 Thread Dispatcher Port 0 */
#define ehl__tdl_3__thread_header01_ready_port0__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Metric set TDL_3 :: Thread Header Ready on Slice0 Subslice1 Thread Dispatcher Port 1 */
#define ehl__tdl_3__thread_header01_ready_port1__read \
    bdw__render_basic__sampler1_bottleneck__read

/* Metric set TDL_3 :: Thread Header Ready on Slice0 Subslice2 Thread Dispatcher Port 0 */
#define ehl__tdl_3__thread_header02_ready_port0__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* Metric set TDL_3 :: Thread Header Ready on Slice0 Subslice2 Thread Dispatcher Port 1 */
#define ehl__tdl_3__thread_header02_ready_port1__read \
    bdw__render_pipe_profile__cl_bottleneck__read

/* Metric set TDL_3 :: Thread Header Ready on Slice0 Subslice3 Thread Dispatcher Port 0 */
#define ehl__tdl_3__thread_header03_ready_port0__read \
    bdw__render_pipe_profile__sf_bottleneck__read

/* Metric set TDL_3 :: Thread Header Ready on Slice0 Subslice3 Thread Dispatcher Port 1 */
#define ehl__tdl_3__thread_header03_ready_port1__read \
    bdw__render_pipe_profile__early_depth_bottleneck__read

/* Metric set TDL_3 :: Thread Header Ready on Slice0 Subslice4 Thread Dispatcher Port 0 */
#define ehl__tdl_3__thread_header04_ready_port0__read \
    bdw__render_pipe_profile__vf_bottleneck__read

/* Metric set TDL_3 :: Thread Header Ready on Slice0 Subslice4 Thread Dispatcher Port 1 */
#define ehl__tdl_3__thread_header04_ready_port1__read \
    bdw__render_pipe_profile__hs_stall__read

/* Metric set TDL_3 :: Thread Header Ready on Slice0 Subslice5 Thread Dispatcher Port 0 */
#define ehl__tdl_3__thread_header05_ready_port0__read \
    bdw__render_pipe_profile__ds_stall__read

/* Metric set TDL_3 :: Thread Header Ready on Slice0 Subslice5 Thread Dispatcher Port 1 */
#define ehl__tdl_3__thread_header05_ready_port1__read \
    bdw__render_pipe_profile__so_stall__read

/* Metric set TDL_3 :: Thread Header Ready on Slice0 Subslice6 Thread Dispatcher Port 0 */
#define ehl__tdl_3__thread_header06_ready_port0__read \
    bdw__render_pipe_profile__cl_stall__read

/* Metric set TDL_3 :: Thread Header Ready on Slice0 Subslice6 Thread Dispatcher Port 1 */
#define ehl__tdl_3__thread_header06_ready_port1__read \
    bdw__render_pipe_profile__sf_stall__read

/* Metric set TDL_3 :: Thread Header Ready on Slice0 Subslice7 Thread Dispatcher Port 0 */
#define ehl__tdl_3__thread_header07_ready_port0__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set TDL_3 :: Thread Header Ready on Slice0 Subslice7 Thread Dispatcher Port 1 */
#define ehl__tdl_3__thread_header07_ready_port1__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Gpu Rings Busyness :: GPU Time Elapsed */
#define ehl__gpu_busyness__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Gpu Rings Busyness :: GPU Core Clocks */
#define ehl__gpu_busyness__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Gpu Rings Busyness :: AVG GPU Core Frequency */
#define ehl__gpu_busyness__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Gpu Rings Busyness :: AVG GPU Core Frequency */
#define ehl__gpu_busyness__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Gpu Rings Busyness :: GPU Busy */
#define ehl__gpu_busyness__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Gpu Rings Busyness :: Render Ring Busy */
#define ehl__gpu_busyness__render_busy__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Gpu Rings Busyness :: Vdbox0 Ring Busy */
#define ehl__gpu_busyness__vdbox0_busy__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Gpu Rings Busyness :: Vdbox1 Ring Busy */
#define ehl__gpu_busyness__vdbox1_busy__read \
    bdw__render_pipe_profile__sf_stall__read

/* Gpu Rings Busyness :: Vebox Ring Busy */
#define ehl__gpu_busyness__vebox_busy__read \
    bdw__render_pipe_profile__cl_stall__read

/* Gpu Rings Busyness :: Blitter Ring Busy */
#define ehl__gpu_busyness__blitter_busy__read \
    bdw__render_pipe_profile__so_stall__read

/* Gpu Rings Busyness :: AnyRingBusy */
#define ehl__gpu_busyness__any_ring_busy__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set TestOa :: GPU Time Elapsed */
#define ehl__test_oa__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set TestOa :: GPU Core Clocks */
#define ehl__test_oa__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set TestOa :: AVG GPU Core Frequency */
#define ehl__test_oa__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set TestOa :: AVG GPU Core Frequency */
#define ehl__test_oa__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set TestOa :: TestCounter0 */
#define ehl__test_oa__counter0__read \
    hsw__compute_extended__eu_untyped_reads0__read

/* Metric set TestOa :: TestCounter1 */
#define ehl__test_oa__counter1__read \
    hsw__compute_extended__eu_untyped_writes0__read

/* Metric set TestOa :: TestCounter2 */
#define ehl__test_oa__counter2__read \
    hsw__compute_extended__eu_typed_reads0__read

/* Metric set TestOa :: TestCounter3 */
#define ehl__test_oa__counter3__read \
    hsw__compute_extended__eu_typed_writes0__read

/* Metric set TestOa :: TestCounter4 */
#define ehl__test_oa__counter4__read \
    hsw__compute_extended__eu_untyped_atomics0__read

/* Metric set TestOa :: TestCounter5 */
#define ehl__test_oa__counter5__read \
    hsw__compute_extended__eu_typed_atomics0__read

/* Metric set TestOa :: TestCounter6 */
#define ehl__test_oa__counter6__read \
    hsw__compute_extended__eu_urb_atomics0__read

/* Metric set TestOa :: TestCounter7 */
#define ehl__test_oa__counter7__read \
    hsw__compute_extended__gpu_clocks__read

/* Metric set TestOa :: TestCounter8 */
#define ehl__test_oa__counter8__read \
    hsw__compute_extended__typed_writes0__read

/* Render Metrics Basic Gen12 :: GPU Time Elapsed */
#define tgl__render_basic__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Render Metrics Basic Gen12 :: GPU Core Clocks */
#define tgl__render_basic__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Render Metrics Basic Gen12 :: AVG GPU Core Frequency */
#define tgl__render_basic__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Render Metrics Basic Gen12 :: AVG GPU Core Frequency */
#define tgl__render_basic__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Render Metrics Basic Gen12 :: VS Threads Dispatched */
#define tgl__render_basic__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Render Metrics Basic Gen12 :: HS Threads Dispatched */
#define tgl__render_basic__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Render Metrics Basic Gen12 :: DS Threads Dispatched */
#define tgl__render_basic__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Render Metrics Basic Gen12 :: GS Threads Dispatched */
#define tgl__render_basic__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Render Metrics Basic Gen12 :: FS Threads Dispatched */
#define tgl__render_basic__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Render Metrics Basic Gen12 :: CS Threads Dispatched */
#define tgl__render_basic__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Render Metrics Basic Gen12 :: GPU Busy */
#define tgl__render_basic__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Render Metrics Basic Gen12 :: EU Active */
#define tgl__render_basic__eu_active__read \
    bdw__render_basic__eu_active__read

/* Render Metrics Basic Gen12 :: EU Stall */
#define tgl__render_basic__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Render Metrics Basic Gen12 :: EU FPU And EM Pipes Active */
#define tgl__render_basic__eu_fpu_em_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Render Metrics Basic Gen12 :: VS FPU Pipe Active */
#define tgl__render_basic__vs_fpu_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Render Metrics Basic Gen12 :: VS EM Pipe Active */
#define tgl__render_basic__vs_em_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Render Metrics Basic Gen12 :: VS Send Pipe Active */
#define tgl__render_basic__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Render Metrics Basic Gen12 :: PS FPU Pipe Active */
#define tgl__render_basic__ps_fpu_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Render Metrics Basic Gen12 :: PS EM Pipe Active */
#define tgl__render_basic__ps_em_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Render Metrics Basic Gen12 :: PS Send Pipeline Active */
#define tgl__render_basic__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Render Metrics Basic Gen12 :: FS Both FPU Active */
#define tgl__render_basic__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Render Metrics Basic Gen12 :: Samplers Busy */
static double
tgl__render_basic__samplers_busy__read(const struct intel_perf *perf,
                                       const struct intel_perf_metric_set *metric_set,
                                       uint64_t *accumulator)
{
    /* RPN equation: C 7 READ GPU_CLOCK 0 READ FDIV */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 7];
    uint64_t tmp1 = accumulator[metric_set->gpu_clock_offset + 0];
    double tmp2 = tmp0;
    double tmp3 = tmp1;
    double tmp4 = tmp3 ? tmp2 / tmp3 : 0;

    return tmp4;
}

/* Render Metrics Basic Gen12 :: Samplers Bottleneck */
static double
tgl__render_basic__sampler_bottleneck__read(const struct intel_perf *perf,
                                            const struct intel_perf_metric_set *metric_set,
                                            uint64_t *accumulator)
{
    /* RPN equation: C 6 READ GPU_CLOCK 0 READ FDIV */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 6];
    uint64_t tmp1 = accumulator[metric_set->gpu_clock_offset + 0];
    double tmp2 = tmp0;
    double tmp3 = tmp1;
    double tmp4 = tmp3 ? tmp2 / tmp3 : 0;

    return tmp4;
}

/* Render Metrics Basic Gen12 :: Rasterized Pixels */
#define tgl__render_basic__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Render Metrics Basic Gen12 :: Early Hi-Depth Test Fails */
#define tgl__render_basic__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Render Metrics Basic Gen12 :: Early Depth Test Fails */
#define tgl__render_basic__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Render Metrics Basic Gen12 :: Samples Killed in FS */
#define tgl__render_basic__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Render Metrics Basic Gen12 :: Pixels Failing Tests */
#define tgl__render_basic__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Render Metrics Basic Gen12 :: Samples Written */
#define tgl__render_basic__samples_written__read \
    bdw__render_basic__samples_written__read

/* Render Metrics Basic Gen12 :: Samples Blended */
#define tgl__render_basic__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Render Metrics Basic Gen12 :: Sampler Texels */
#define tgl__render_basic__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Render Metrics Basic Gen12 :: Sampler Texels Misses */
#define tgl__render_basic__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Render Metrics Basic Gen12 :: SLM Bytes Read */
#define tgl__render_basic__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Render Metrics Basic Gen12 :: SLM Bytes Read */
#define tgl__render_basic__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics Basic Gen12 :: SLM Bytes Written */
#define tgl__render_basic__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Render Metrics Basic Gen12 :: SLM Bytes Written */
#define tgl__render_basic__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics Basic Gen12 :: Shader Memory Accesses */
#define tgl__render_basic__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Render Metrics Basic Gen12 :: Shader Atomic Memory Accesses */
#define tgl__render_basic__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Render Metrics Basic Gen12 :: L3 Shader Throughput */
#define tgl__render_basic__l3_shader_throughput__read \
    cnl__render_basic__l3_shader_throughput__read

/* Render Metrics Basic Gen12 :: L3 Shader Throughput */
#define tgl__render_basic__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics Basic Gen12 :: Shader Barrier Messages */
#define tgl__render_basic__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Render Metrics Basic Gen12 :: GTI Read Throughput */
static uint64_t
tgl__render_basic__gti_read_throughput__read(const struct intel_perf *perf,
                                             const struct intel_perf_metric_set *metric_set,
                                             uint64_t *accumulator)
{
    /* RPN equation: 64  C 5 READ C 4 READ UADD C 3 READ UADD C 2 READ UADD UMUL */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 5];
    uint64_t tmp1 = accumulator[metric_set->c_offset + 4];
    uint64_t tmp2 = tmp0 + tmp1;
    uint64_t tmp3 = accumulator[metric_set->c_offset + 3];
    uint64_t tmp4 = tmp2 + tmp3;
    uint64_t tmp5 = accumulator[metric_set->c_offset + 2];
    uint64_t tmp6 = tmp4 + tmp5;
    uint64_t tmp7 = 64 * tmp6;

    return tmp7;
}

/* Render Metrics Basic Gen12 :: GTI Read Throughput */
#define tgl__render_basic__gti_read_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Render Metrics Basic Gen12 :: GTI Write Throughput */
static uint64_t
tgl__render_basic__gti_write_throughput__read(const struct intel_perf *perf,
                                              const struct intel_perf_metric_set *metric_set,
                                              uint64_t *accumulator)
{
    /* RPN equation: 64  C 1 READ C 0 READ UADD UMUL */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 1];
    uint64_t tmp1 = accumulator[metric_set->c_offset + 0];
    uint64_t tmp2 = tmp0 + tmp1;
    uint64_t tmp3 = 64 * tmp2;

    return tmp3;
}

/* Render Metrics Basic Gen12 :: GTI Write Throughput */
#define tgl__render_basic__gti_write_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Compute Metrics Basic :: GPU Time Elapsed */
#define tgl__compute_basic__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Compute Metrics Basic :: GPU Core Clocks */
#define tgl__compute_basic__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Compute Metrics Basic :: AVG GPU Core Frequency */
#define tgl__compute_basic__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Compute Metrics Basic :: AVG GPU Core Frequency */
#define tgl__compute_basic__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Compute Metrics Basic :: GPU Busy */
#define tgl__compute_basic__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Compute Metrics Basic :: VS Threads Dispatched */
#define tgl__compute_basic__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Compute Metrics Basic :: HS Threads Dispatched */
#define tgl__compute_basic__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Compute Metrics Basic :: DS Threads Dispatched */
#define tgl__compute_basic__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Compute Metrics Basic :: GS Threads Dispatched */
#define tgl__compute_basic__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Compute Metrics Basic :: FS Threads Dispatched */
#define tgl__compute_basic__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Compute Metrics Basic :: CS Threads Dispatched */
#define tgl__compute_basic__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Compute Metrics Basic :: EU Active */
#define tgl__compute_basic__eu_active__read \
    bdw__render_basic__eu_active__read

/* Compute Metrics Basic :: EU Stall */
#define tgl__compute_basic__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Compute Metrics Basic :: EU AVG IPC Rate */
#define tgl__compute_basic__eu_avg_ipc_rate__read \
    cnl__compute_basic__eu_avg_ipc_rate__read

/* Compute Metrics Basic :: EU AVG IPC Rate */
#define tgl__compute_basic__eu_avg_ipc_rate__max \
    bdw__compute_basic__eu_avg_ipc_rate__max

/* Compute Metrics Basic :: EU FPU And EM Pipes Active */
#define tgl__compute_basic__eu_fpu_em_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Compute Metrics Basic :: EU FPU Pipe Active */
#define tgl__compute_basic__fpu_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Compute Metrics Basic :: EM Pipe Active */
#define tgl__compute_basic__em_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Compute Metrics Basic :: EU Send Pipe Active */
#define tgl__compute_basic__eu_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Compute Metrics Basic :: EU Thread Occupancy */
#define tgl__compute_basic__eu_thread_occupancy__read \
    cnl__compute_basic__eu_thread_occupancy__read

/* Compute Metrics Basic :: Rasterized Pixels */
#define tgl__compute_basic__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Compute Metrics Basic :: Early Hi-Depth Test Fails */
#define tgl__compute_basic__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Compute Metrics Basic :: Early Depth Test Fails */
#define tgl__compute_basic__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Compute Metrics Basic :: Samples Killed in FS */
#define tgl__compute_basic__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Compute Metrics Basic :: Pixels Failing Tests */
#define tgl__compute_basic__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Compute Metrics Basic :: Samples Written */
#define tgl__compute_basic__samples_written__read \
    bdw__render_basic__samples_written__read

/* Compute Metrics Basic :: Samples Blended */
#define tgl__compute_basic__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Compute Metrics Basic :: Sampler Texels */
#define tgl__compute_basic__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Compute Metrics Basic :: Sampler Texels Misses */
#define tgl__compute_basic__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Compute Metrics Basic :: SLM Bytes Read */
#define tgl__compute_basic__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Compute Metrics Basic :: SLM Bytes Read */
#define tgl__compute_basic__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Basic :: SLM Bytes Written */
#define tgl__compute_basic__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Compute Metrics Basic :: SLM Bytes Written */
#define tgl__compute_basic__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Basic :: Shader Memory Accesses */
#define tgl__compute_basic__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Compute Metrics Basic :: Shader Atomic Memory Accesses */
#define tgl__compute_basic__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Compute Metrics Basic :: L3 Shader Throughput */
#define tgl__compute_basic__l3_shader_throughput__read \
    cnl__render_basic__l3_shader_throughput__read

/* Compute Metrics Basic :: L3 Shader Throughput */
#define tgl__compute_basic__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Compute Metrics Basic :: Shader Barrier Messages */
#define tgl__compute_basic__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Compute Metrics Basic :: GTI Read Throughput */
static uint64_t
tgl__compute_basic__gti_read_throughput__read(const struct intel_perf *perf,
                                              const struct intel_perf_metric_set *metric_set,
                                              uint64_t *accumulator)
{
    /* RPN equation: 64  C 7 READ C 6 READ UADD C 5 READ UADD C 4 READ UADD UMUL */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 7];
    uint64_t tmp1 = accumulator[metric_set->c_offset + 6];
    uint64_t tmp2 = tmp0 + tmp1;
    uint64_t tmp3 = accumulator[metric_set->c_offset + 5];
    uint64_t tmp4 = tmp2 + tmp3;
    uint64_t tmp5 = accumulator[metric_set->c_offset + 4];
    uint64_t tmp6 = tmp4 + tmp5;
    uint64_t tmp7 = 64 * tmp6;

    return tmp7;
}

/* Compute Metrics Basic :: GTI Read Throughput */
#define tgl__compute_basic__gti_read_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Compute Metrics Basic :: GTI Write Throughput */
static uint64_t
tgl__compute_basic__gti_write_throughput__read(const struct intel_perf *perf,
                                               const struct intel_perf_metric_set *metric_set,
                                               uint64_t *accumulator)
{
    /* RPN equation: 64  C 3 READ C 2 READ UADD UMUL */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 3];
    uint64_t tmp1 = accumulator[metric_set->c_offset + 2];
    uint64_t tmp2 = tmp0 + tmp1;
    uint64_t tmp3 = 64 * tmp2;

    return tmp3;
}

/* Compute Metrics Basic :: GTI Write Throughput */
#define tgl__compute_basic__gti_write_throughput__max \
    bdw__render_basic__gti_vf_throughput__max

/* Render Metrics for 3D Pipeline Profile :: GPU Time Elapsed */
#define tgl__render_pipe_profile__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Render Metrics for 3D Pipeline Profile :: GPU Core Clocks */
#define tgl__render_pipe_profile__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Render Metrics for 3D Pipeline Profile :: AVG GPU Core Frequency */
#define tgl__render_pipe_profile__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Render Metrics for 3D Pipeline Profile :: AVG GPU Core Frequency */
#define tgl__render_pipe_profile__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Render Metrics for 3D Pipeline Profile :: GPU Busy */
#define tgl__render_pipe_profile__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Render Metrics for 3D Pipeline Profile :: VS Threads Dispatched */
#define tgl__render_pipe_profile__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Render Metrics for 3D Pipeline Profile :: HS Threads Dispatched */
#define tgl__render_pipe_profile__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Render Metrics for 3D Pipeline Profile :: DS Threads Dispatched */
#define tgl__render_pipe_profile__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Render Metrics for 3D Pipeline Profile :: GS Threads Dispatched */
#define tgl__render_pipe_profile__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Render Metrics for 3D Pipeline Profile :: FS Threads Dispatched */
#define tgl__render_pipe_profile__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Render Metrics for 3D Pipeline Profile :: CS Threads Dispatched */
#define tgl__render_pipe_profile__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Render Metrics for 3D Pipeline Profile :: EU Active */
#define tgl__render_pipe_profile__eu_active__read \
    bdw__render_basic__eu_active__read

/* Render Metrics for 3D Pipeline Profile :: EU Stall */
#define tgl__render_pipe_profile__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Render Metrics for 3D Pipeline Profile :: Rasterized Pixels */
#define tgl__render_pipe_profile__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Render Metrics for 3D Pipeline Profile :: Early Hi-Depth Test Fails */
#define tgl__render_pipe_profile__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Render Metrics for 3D Pipeline Profile :: Early Depth Test Fails */
#define tgl__render_pipe_profile__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Render Metrics for 3D Pipeline Profile :: Samples Killed in FS */
#define tgl__render_pipe_profile__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Render Metrics for 3D Pipeline Profile :: Pixels Failing Tests */
#define tgl__render_pipe_profile__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Render Metrics for 3D Pipeline Profile :: Samples Written */
#define tgl__render_pipe_profile__samples_written__read \
    bdw__render_basic__samples_written__read

/* Render Metrics for 3D Pipeline Profile :: Samples Blended */
#define tgl__render_pipe_profile__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Render Metrics for 3D Pipeline Profile :: Sampler Texels */
#define tgl__render_pipe_profile__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Render Metrics for 3D Pipeline Profile :: Sampler Texels Misses */
#define tgl__render_pipe_profile__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Render Metrics for 3D Pipeline Profile :: SLM Bytes Read */
#define tgl__render_pipe_profile__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Render Metrics for 3D Pipeline Profile :: SLM Bytes Read */
#define tgl__render_pipe_profile__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics for 3D Pipeline Profile :: SLM Bytes Written */
#define tgl__render_pipe_profile__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Render Metrics for 3D Pipeline Profile :: SLM Bytes Written */
#define tgl__render_pipe_profile__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics for 3D Pipeline Profile :: Shader Memory Accesses */
#define tgl__render_pipe_profile__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Render Metrics for 3D Pipeline Profile :: Shader Atomic Memory Accesses */
#define tgl__render_pipe_profile__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Render Metrics for 3D Pipeline Profile :: L3 Shader Throughput */
#define tgl__render_pipe_profile__l3_shader_throughput__read \
    cnl__render_basic__l3_shader_throughput__read

/* Render Metrics for 3D Pipeline Profile :: L3 Shader Throughput */
#define tgl__render_pipe_profile__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Render Metrics for 3D Pipeline Profile :: Shader Barrier Messages */
#define tgl__render_pipe_profile__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Render Metrics for 3D Pipeline Profile :: VF Bottleneck */
#define tgl__render_pipe_profile__vf_bottleneck__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Render Metrics for 3D Pipeline Profile :: VS Bottleneck */
#define tgl__render_pipe_profile__vs_bottleneck__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Render Metrics for 3D Pipeline Profile :: HS Bottleneck */
#define tgl__render_pipe_profile__hs_bottleneck__read \
    bdw__render_pipe_profile__cl_bottleneck__read

/* Render Metrics for 3D Pipeline Profile :: DS Bottleneck */
#define tgl__render_pipe_profile__ds_bottleneck__read \
    bdw__render_pipe_profile__sf_stall__read

/* Render Metrics for 3D Pipeline Profile :: GS Bottleneck */
#define tgl__render_pipe_profile__gs_bottleneck__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* Render Metrics for 3D Pipeline Profile :: SO Bottleneck */
#define tgl__render_pipe_profile__so_bottleneck__read \
    bdw__render_pipe_profile__cl_stall__read

/* Render Metrics for 3D Pipeline Profile :: Clipper Bottleneck */
#define tgl__render_pipe_profile__cl_bottleneck__read \
    bdw__render_pipe_profile__so_stall__read

/* Render Metrics for 3D Pipeline Profile :: Strip-Fans Bottleneck */
#define tgl__render_pipe_profile__sf_bottleneck__read \
    bdw__render_pipe_profile__ds_stall__read

/* Render Metrics for 3D Pipeline Profile :: Hi-Depth Bottleneck */
#define tgl__render_pipe_profile__hi_depth_bottleneck__read \
    bdw__render_basic__sampler1_bottleneck__read

/* Render Metrics for 3D Pipeline Profile :: BC Bottleneck */
#define tgl__render_pipe_profile__bc_bottleneck__read \
    bdw__render_pipe_profile__hs_stall__read

/* Render Metrics for 3D Pipeline Profile :: HS Stall */
#define tgl__render_pipe_profile__hs_stall__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Render Metrics for 3D Pipeline Profile :: DS Stall */
#define tgl__render_pipe_profile__ds_stall__read \
    bdw__render_pipe_profile__vf_bottleneck__read

/* Render Metrics for 3D Pipeline Profile :: SO Stall */
#define tgl__render_pipe_profile__so_stall__read \
    bdw__render_pipe_profile__early_depth_bottleneck__read

/* Render Metrics for 3D Pipeline Profile :: CL Stall */
#define tgl__render_pipe_profile__cl_stall__read \
    bdw__render_basic__sampler1_busy__read

/* Render Metrics for 3D Pipeline Profile :: SF Stall */
#define tgl__render_pipe_profile__sf_stall__read \
    bdw__render_pipe_profile__sf_bottleneck__read

/* Metric set HDCAndSF :: GPU Time Elapsed */
#define tgl__hdc_and_sf__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set HDCAndSF :: GPU Core Clocks */
#define tgl__hdc_and_sf__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set HDCAndSF :: AVG GPU Core Frequency */
#define tgl__hdc_and_sf__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set HDCAndSF :: AVG GPU Core Frequency */
#define tgl__hdc_and_sf__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set HDCAndSF :: GPU Busy */
#define tgl__hdc_and_sf__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set HDCAndSF :: VS Threads Dispatched */
#define tgl__hdc_and_sf__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set HDCAndSF :: HS Threads Dispatched */
#define tgl__hdc_and_sf__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set HDCAndSF :: DS Threads Dispatched */
#define tgl__hdc_and_sf__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set HDCAndSF :: GS Threads Dispatched */
#define tgl__hdc_and_sf__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set HDCAndSF :: FS Threads Dispatched */
#define tgl__hdc_and_sf__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set HDCAndSF :: CS Threads Dispatched */
#define tgl__hdc_and_sf__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set HDCAndSF :: EU Active */
#define tgl__hdc_and_sf__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set HDCAndSF :: EU Stall */
#define tgl__hdc_and_sf__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set HDCAndSF :: EU FPU And EM Pipes Active */
#define tgl__hdc_and_sf__eu_fpu_em_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set HDCAndSF :: VS FPU Pipe Active */
#define tgl__hdc_and_sf__vs_fpu_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set HDCAndSF :: VS EM Pipe Active */
#define tgl__hdc_and_sf__vs_em_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set HDCAndSF :: VS Send Pipe Active */
#define tgl__hdc_and_sf__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set HDCAndSF :: PS FPU Pipe Active */
#define tgl__hdc_and_sf__ps_fpu_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set HDCAndSF :: PS EM Pipe Active */
#define tgl__hdc_and_sf__ps_em_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set HDCAndSF :: PS Send Pipeline Active */
#define tgl__hdc_and_sf__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set HDCAndSF :: FS Both FPU Active */
#define tgl__hdc_and_sf__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set HDCAndSF :: Rasterized Pixels */
#define tgl__hdc_and_sf__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set HDCAndSF :: Early Hi-Depth Test Fails */
#define tgl__hdc_and_sf__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set HDCAndSF :: Early Depth Test Fails */
#define tgl__hdc_and_sf__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set HDCAndSF :: Samples Killed in FS */
#define tgl__hdc_and_sf__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set HDCAndSF :: Pixels Failing Tests */
#define tgl__hdc_and_sf__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set HDCAndSF :: Samples Written */
#define tgl__hdc_and_sf__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set HDCAndSF :: Samples Blended */
#define tgl__hdc_and_sf__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set HDCAndSF :: Sampler Texels */
#define tgl__hdc_and_sf__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set HDCAndSF :: Sampler Texels Misses */
#define tgl__hdc_and_sf__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set HDCAndSF :: SLM Bytes Read */
#define tgl__hdc_and_sf__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set HDCAndSF :: SLM Bytes Read */
#define tgl__hdc_and_sf__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set HDCAndSF :: SLM Bytes Written */
#define tgl__hdc_and_sf__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set HDCAndSF :: SLM Bytes Written */
#define tgl__hdc_and_sf__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set HDCAndSF :: Shader Memory Accesses */
#define tgl__hdc_and_sf__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set HDCAndSF :: Shader Atomic Memory Accesses */
#define tgl__hdc_and_sf__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set HDCAndSF :: L3 Shader Throughput */
#define tgl__hdc_and_sf__l3_shader_throughput__read \
    cnl__render_basic__l3_shader_throughput__read

/* Metric set HDCAndSF :: L3 Shader Throughput */
#define tgl__hdc_and_sf__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set HDCAndSF :: Shader Barrier Messages */
#define tgl__hdc_and_sf__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set HDCAndSF :: Slice0 Dualsubslice0 Non-sampler Shader Access Stalled On L3 */
#define tgl__hdc_and_sf__non_sampler_shader00_access_stalled_on_l3__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Metric set HDCAndSF :: Slice0 Dualsubslice1 Non-sampler Shader Access Stalled On L3 */
#define tgl__hdc_and_sf__non_sampler_shader01_access_stalled_on_l3__read \
    bdw__render_basic__sampler1_bottleneck__read

/* Metric set HDCAndSF :: Slice0 Dualsubslice2 Non-sampler Shader Access Stalled On L3 */
#define tgl__hdc_and_sf__non_sampler_shader02_access_stalled_on_l3__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* Metric set HDCAndSF :: Slice0 Dualsubslice3 Non-sampler Shader Access Stalled On L3 */
#define tgl__hdc_and_sf__non_sampler_shader03_access_stalled_on_l3__read \
    bdw__render_pipe_profile__cl_bottleneck__read

/* Metric set HDCAndSF :: Slice0 Dualsubslice4 Non-sampler Shader Access Stalled On L3 */
#define tgl__hdc_and_sf__non_sampler_shader04_access_stalled_on_l3__read \
    bdw__render_basic__sampler1_busy__read

/* Metric set HDCAndSF :: Slice0 Dualsubslice5 Non-sampler Shader Access Stalled On L3 */
#define tgl__hdc_and_sf__non_sampler_shader05_access_stalled_on_l3__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set HDCAndSF :: Polygon Data Ready */
#define tgl__hdc_and_sf__poly_data_ready__read \
    bdw__render_pipe_profile__sf_bottleneck__read

/* Metric set RasterizerAndPixelBackend :: GPU Time Elapsed */
#define tgl__rasterizer_and_pixel_backend__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set RasterizerAndPixelBackend :: GPU Core Clocks */
#define tgl__rasterizer_and_pixel_backend__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set RasterizerAndPixelBackend :: AVG GPU Core Frequency */
#define tgl__rasterizer_and_pixel_backend__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set RasterizerAndPixelBackend :: AVG GPU Core Frequency */
#define tgl__rasterizer_and_pixel_backend__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set RasterizerAndPixelBackend :: GPU Busy */
#define tgl__rasterizer_and_pixel_backend__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Metric set RasterizerAndPixelBackend :: VS Threads Dispatched */
#define tgl__rasterizer_and_pixel_backend__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Metric set RasterizerAndPixelBackend :: HS Threads Dispatched */
#define tgl__rasterizer_and_pixel_backend__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Metric set RasterizerAndPixelBackend :: DS Threads Dispatched */
#define tgl__rasterizer_and_pixel_backend__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Metric set RasterizerAndPixelBackend :: GS Threads Dispatched */
#define tgl__rasterizer_and_pixel_backend__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Metric set RasterizerAndPixelBackend :: FS Threads Dispatched */
#define tgl__rasterizer_and_pixel_backend__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Metric set RasterizerAndPixelBackend :: CS Threads Dispatched */
#define tgl__rasterizer_and_pixel_backend__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Metric set RasterizerAndPixelBackend :: EU Active */
#define tgl__rasterizer_and_pixel_backend__eu_active__read \
    bdw__render_basic__eu_active__read

/* Metric set RasterizerAndPixelBackend :: EU Stall */
#define tgl__rasterizer_and_pixel_backend__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Metric set RasterizerAndPixelBackend :: EU FPU And EM Pipes Active */
#define tgl__rasterizer_and_pixel_backend__eu_fpu_em_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Metric set RasterizerAndPixelBackend :: VS FPU Pipe Active */
#define tgl__rasterizer_and_pixel_backend__vs_fpu_active__read \
    bdw__render_basic__vs_fpu0_active__read

/* Metric set RasterizerAndPixelBackend :: VS EM Pipe Active */
#define tgl__rasterizer_and_pixel_backend__vs_em_active__read \
    bdw__render_basic__vs_fpu1_active__read

/* Metric set RasterizerAndPixelBackend :: VS Send Pipe Active */
#define tgl__rasterizer_and_pixel_backend__vs_send_active__read \
    bdw__render_basic__vs_send_active__read

/* Metric set RasterizerAndPixelBackend :: PS FPU Pipe Active */
#define tgl__rasterizer_and_pixel_backend__ps_fpu_active__read \
    bdw__render_basic__ps_fpu0_active__read

/* Metric set RasterizerAndPixelBackend :: PS EM Pipe Active */
#define tgl__rasterizer_and_pixel_backend__ps_em_active__read \
    bdw__render_basic__ps_fpu1_active__read

/* Metric set RasterizerAndPixelBackend :: PS Send Pipeline Active */
#define tgl__rasterizer_and_pixel_backend__ps_send_active__read \
    bdw__render_basic__ps_send_active__read

/* Metric set RasterizerAndPixelBackend :: FS Both FPU Active */
#define tgl__rasterizer_and_pixel_backend__ps_eu_both_fpu_active__read \
    bdw__render_basic__ps_eu_both_fpu_active__read

/* Metric set RasterizerAndPixelBackend :: Rasterized Pixels */
#define tgl__rasterizer_and_pixel_backend__rasterized_pixels__read \
    bdw__render_basic__rasterized_pixels__read

/* Metric set RasterizerAndPixelBackend :: Early Hi-Depth Test Fails */
#define tgl__rasterizer_and_pixel_backend__hi_depth_test_fails__read \
    bdw__render_basic__hi_depth_test_fails__read

/* Metric set RasterizerAndPixelBackend :: Early Depth Test Fails */
#define tgl__rasterizer_and_pixel_backend__early_depth_test_fails__read \
    bdw__render_basic__early_depth_test_fails__read

/* Metric set RasterizerAndPixelBackend :: Samples Killed in FS */
#define tgl__rasterizer_and_pixel_backend__samples_killed_in_ps__read \
    bdw__render_basic__samples_killed_in_ps__read

/* Metric set RasterizerAndPixelBackend :: Pixels Failing Tests */
#define tgl__rasterizer_and_pixel_backend__pixels_failing_post_ps_tests__read \
    bdw__render_basic__pixels_failing_post_ps_tests__read

/* Metric set RasterizerAndPixelBackend :: Samples Written */
#define tgl__rasterizer_and_pixel_backend__samples_written__read \
    bdw__render_basic__samples_written__read

/* Metric set RasterizerAndPixelBackend :: Samples Blended */
#define tgl__rasterizer_and_pixel_backend__samples_blended__read \
    bdw__render_basic__samples_blended__read

/* Metric set RasterizerAndPixelBackend :: Sampler Texels */
#define tgl__rasterizer_and_pixel_backend__sampler_texels__read \
    bdw__render_basic__sampler_texels__read

/* Metric set RasterizerAndPixelBackend :: Sampler Texels Misses */
#define tgl__rasterizer_and_pixel_backend__sampler_texel_misses__read \
    bdw__render_basic__sampler_texel_misses__read

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Read */
#define tgl__rasterizer_and_pixel_backend__slm_bytes_read__read \
    bdw__render_basic__slm_bytes_read__read

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Read */
#define tgl__rasterizer_and_pixel_backend__slm_bytes_read__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Written */
#define tgl__rasterizer_and_pixel_backend__slm_bytes_written__read \
    bdw__render_basic__slm_bytes_written__read

/* Metric set RasterizerAndPixelBackend :: SLM Bytes Written */
#define tgl__rasterizer_and_pixel_backend__slm_bytes_written__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set RasterizerAndPixelBackend :: Shader Memory Accesses */
#define tgl__rasterizer_and_pixel_backend__shader_memory_accesses__read \
    bdw__render_basic__shader_memory_accesses__read

/* Metric set RasterizerAndPixelBackend :: Shader Atomic Memory Accesses */
#define tgl__rasterizer_and_pixel_backend__shader_atomics__read \
    bdw__render_basic__shader_atomics__read

/* Metric set RasterizerAndPixelBackend :: L3 Shader Throughput */
#define tgl__rasterizer_and_pixel_backend__l3_shader_throughput__read \
    cnl__render_basic__l3_shader_throughput__read

/* Metric set RasterizerAndPixelBackend :: L3 Shader Throughput */
#define tgl__rasterizer_and_pixel_backend__l3_shader_throughput__max \
    bdw__render_basic__slm_bytes_read__max

/* Metric set RasterizerAndPixelBackend :: Shader Barrier Messages */
#define tgl__rasterizer_and_pixel_backend__shader_barriers__read \
    hsw__render_basic__early_depth_test_fails__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Rasterizer Input Available */
#define tgl__rasterizer_and_pixel_backend__rasterizer0_input_available__read \
    bdw__render_basic__sampler0_busy__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Rasterizer Output Ready */
#define tgl__rasterizer_and_pixel_backend__rasterizer0_output_ready__read \
    bdw__render_pipe_profile__so_stall__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Pipe0 Post-EarlyZ Pixel Data Ready */
#define tgl__rasterizer_and_pixel_backend__pixel_data00_ready__read \
    bdw__render_basic__sampler1_busy__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Pipe0 PS Output Available */
#define tgl__rasterizer_and_pixel_backend__ps_output00_available__read \
    bdw__render_pipe_profile__ds_stall__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Pipe1 PS Output Available */
#define tgl__rasterizer_and_pixel_backend__ps_output01_available__read \
    bdw__render_pipe_profile__hs_stall__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Pipe2 PS Output Available */
#define tgl__rasterizer_and_pixel_backend__ps_output02_available__read \
    bdw__render_pipe_profile__vf_bottleneck__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Pipe0 Pixel Values Ready */
#define tgl__rasterizer_and_pixel_backend__pixel_values00_ready__read \
    bdw__render_pipe_profile__early_depth_bottleneck__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Pipe1 Pixel Values Ready */
#define tgl__rasterizer_and_pixel_backend__pixel_values01_ready__read \
    bdw__render_pipe_profile__sf_bottleneck__read

/* Metric set RasterizerAndPixelBackend :: Slice0 Pipe2 Pixel Values Ready */
#define tgl__rasterizer_and_pixel_backend__pixel_values02_ready__read \
    bdw__render_pipe_profile__cl_bottleneck__read

/* Metric set RasterizerAndPixelBackend :: SQ00 is full */
#define tgl__rasterizer_and_pixel_backend__gt_request_queue00_full__read \
    bdw__render_pipe_profile__cl_stall__read

/* Metric set RasterizerAndPixelBackend :: SQ01 is full */
#define tgl__rasterizer_and_pixel_backend__gt_request_queue01_full__read \
    bdw__render_pipe_profile__sf_stall__read

/* Metric set RasterizerAndPixelBackend :: SQ10 is full */
#define tgl__rasterizer_and_pixel_backend__gt_request_queue10_full__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* Metric set RasterizerAndPixelBackend :: SQ11 is full */
#define tgl__rasterizer_and_pixel_backend__gt_request_queue11_full__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* Gen12LP L3_1 :: GPU Time Elapsed */
#define tgl__l3_1__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Gen12LP L3_1 :: GPU Core Clocks */
#define tgl__l3_1__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Gen12LP L3_1 :: AVG GPU Core Frequency */
#define tgl__l3_1__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Gen12LP L3_1 :: AVG GPU Core Frequency */
#define tgl__l3_1__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Gen12LP L3_1 :: GPU Busy */
#define tgl__l3_1__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Gen12LP L3_1 :: EU Active */
#define tgl__l3_1__eu_active__read \
    bdw__render_basic__eu_active__read

/* Gen12LP L3_1 :: EU Stall */
#define tgl__l3_1__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Gen12LP L3_1 :: EU FPU And EM Pipes Active */
#define tgl__l3_1__eu_fpu_em_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Gen12LP L3_1 :: EU Thread Occupancy */
#define tgl__l3_1__eu_thread_occupancy__read \
    bdw__vme_pipe__eu_thread_occupancy__read

/* Gen12LP L3_1 :: VS Threads Dispatched */
#define tgl__l3_1__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Gen12LP L3_1 :: HS Threads Dispatched */
#define tgl__l3_1__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Gen12LP L3_1 :: DS Threads Dispatched */
#define tgl__l3_1__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Gen12LP L3_1 :: GS Threads Dispatched */
#define tgl__l3_1__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Gen12LP L3_1 :: FS Threads Dispatched */
#define tgl__l3_1__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Gen12LP L3_1 :: CS Threads Dispatched */
#define tgl__l3_1__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Gen12LP L3_1 :: Slice0 L3 Bank0 Input Available */
static double
tgl__l3_1__l30_bank0_input_available__read(const struct intel_perf *perf,
                                           const struct intel_perf_metric_set *metric_set,
                                           uint64_t *accumulator)
{
    /* RPN equation: C 7 READ C 6 READ FADD C 5 READ FADD C 4 READ FADD 4 FDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 7];
    uint64_t tmp1 = accumulator[metric_set->c_offset + 6];
    double tmp2 = tmp0 + tmp1;
    uint64_t tmp3 = accumulator[metric_set->c_offset + 5];
    double tmp4 = tmp2 + tmp3;
    uint64_t tmp5 = accumulator[metric_set->c_offset + 4];
    double tmp6 = tmp4 + tmp5;
    double tmp7 = tmp6;
    double tmp8 = 4;
    double tmp9 = tmp8 ? tmp7 / tmp8 : 0;
    uint64_t tmp10 = tmp9 * 100;
    double tmp11 = tmp10;
    double tmp12 = tgl__l3_1__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp13 = tmp12 ? tmp11 / tmp12 : 0;

    return tmp13;
}

/* Gen12LP L3_1 :: Slice0 L3 Bank1 Input Available */
static double
tgl__l3_1__l30_bank1_input_available__read(const struct intel_perf *perf,
                                           const struct intel_perf_metric_set *metric_set,
                                           uint64_t *accumulator)
{
    /* RPN equation: C 3 READ C 2 READ FADD C 1 READ FADD C 0 READ FADD 4 FDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 3];
    uint64_t tmp1 = accumulator[metric_set->c_offset + 2];
    double tmp2 = tmp0 + tmp1;
    uint64_t tmp3 = accumulator[metric_set->c_offset + 1];
    double tmp4 = tmp2 + tmp3;
    uint64_t tmp5 = accumulator[metric_set->c_offset + 0];
    double tmp6 = tmp4 + tmp5;
    double tmp7 = tmp6;
    double tmp8 = 4;
    double tmp9 = tmp8 ? tmp7 / tmp8 : 0;
    uint64_t tmp10 = tmp9 * 100;
    double tmp11 = tmp10;
    double tmp12 = tgl__l3_1__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp13 = tmp12 ? tmp11 / tmp12 : 0;

    return tmp13;
}

/* Gen12LP L3_1 :: Slice0 L3 Bank4 Input Available */
static double
tgl__l3_1__l30_bank4_input_available__read(const struct intel_perf *perf,
                                           const struct intel_perf_metric_set *metric_set,
                                           uint64_t *accumulator)
{
    /* RPN equation: B 3 READ B 2 READ FADD B 1 READ FADD B 0 READ FADD 4 FDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 3];
    uint64_t tmp1 = accumulator[metric_set->b_offset + 2];
    double tmp2 = tmp0 + tmp1;
    uint64_t tmp3 = accumulator[metric_set->b_offset + 1];
    double tmp4 = tmp2 + tmp3;
    uint64_t tmp5 = accumulator[metric_set->b_offset + 0];
    double tmp6 = tmp4 + tmp5;
    double tmp7 = tmp6;
    double tmp8 = 4;
    double tmp9 = tmp8 ? tmp7 / tmp8 : 0;
    uint64_t tmp10 = tmp9 * 100;
    double tmp11 = tmp10;
    double tmp12 = tgl__l3_1__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp13 = tmp12 ? tmp11 / tmp12 : 0;

    return tmp13;
}

/* Gen12LP L3_1 :: Slice0 L3 Bank5 Input Available */
static double
tgl__l3_1__l30_bank5_input_available__read(const struct intel_perf *perf,
                                           const struct intel_perf_metric_set *metric_set,
                                           uint64_t *accumulator)
{
    /* RPN equation: B 7 READ B 6 READ FADD B 5 READ FADD B 4 READ FADD 4 FDIV 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->b_offset + 7];
    uint64_t tmp1 = accumulator[metric_set->b_offset + 6];
    double tmp2 = tmp0 + tmp1;
    uint64_t tmp3 = accumulator[metric_set->b_offset + 5];
    double tmp4 = tmp2 + tmp3;
    uint64_t tmp5 = accumulator[metric_set->b_offset + 4];
    double tmp6 = tmp4 + tmp5;
    double tmp7 = tmp6;
    double tmp8 = 4;
    double tmp9 = tmp8 ? tmp7 / tmp8 : 0;
    uint64_t tmp10 = tmp9 * 100;
    double tmp11 = tmp10;
    double tmp12 = tgl__l3_1__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp13 = tmp12 ? tmp11 / tmp12 : 0;

    return tmp13;
}

/* Gen12LP L3_2 :: GPU Time Elapsed */
#define tgl__l3_2__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Gen12LP L3_2 :: GPU Core Clocks */
#define tgl__l3_2__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Gen12LP L3_2 :: AVG GPU Core Frequency */
#define tgl__l3_2__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Gen12LP L3_2 :: AVG GPU Core Frequency */
#define tgl__l3_2__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Gen12LP L3_2 :: GPU Busy */
#define tgl__l3_2__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Gen12LP L3_2 :: EU Active */
#define tgl__l3_2__eu_active__read \
    bdw__render_basic__eu_active__read

/* Gen12LP L3_2 :: EU Stall */
#define tgl__l3_2__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Gen12LP L3_2 :: EU FPU And EM Pipes Active */
#define tgl__l3_2__eu_fpu_em_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Gen12LP L3_2 :: VS Threads Dispatched */
#define tgl__l3_2__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Gen12LP L3_2 :: EU Thread Occupancy */
#define tgl__l3_2__eu_thread_occupancy__read \
    bdw__vme_pipe__eu_thread_occupancy__read

/* Gen12LP L3_2 :: HS Threads Dispatched */
#define tgl__l3_2__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Gen12LP L3_2 :: DS Threads Dispatched */
#define tgl__l3_2__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Gen12LP L3_2 :: GS Threads Dispatched */
#define tgl__l3_2__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Gen12LP L3_2 :: FS Threads Dispatched */
#define tgl__l3_2__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Gen12LP L3_2 :: CS Threads Dispatched */
#define tgl__l3_2__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Gen12LP L3_2 :: Slice0 L3 Bank2 Input Available */
#define tgl__l3_2__l30_bank2_input_available__read \
    tgl__l3_1__l30_bank4_input_available__read

/* Gen12LP L3_2 :: Slice0 L3 Bank3 Input Available */
#define tgl__l3_2__l30_bank3_input_available__read \
    tgl__l3_1__l30_bank5_input_available__read

/* Gen12LP L3_2 :: Slice0 L3 Bank6 Input Available */
#define tgl__l3_2__l30_bank6_input_available__read \
    tgl__l3_1__l30_bank1_input_available__read

/* Gen12LP L3_2 :: Slice0 L3 Bank7 Input Available */
#define tgl__l3_2__l30_bank7_input_available__read \
    tgl__l3_1__l30_bank0_input_available__read

/* Gen12LP L3_3 :: GPU Time Elapsed */
#define tgl__l3_3__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Gen12LP L3_3 :: GPU Core Clocks */
#define tgl__l3_3__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Gen12LP L3_3 :: AVG GPU Core Frequency */
#define tgl__l3_3__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Gen12LP L3_3 :: AVG GPU Core Frequency */
#define tgl__l3_3__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Gen12LP L3_3 :: GPU Busy */
#define tgl__l3_3__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Gen12LP L3_3 :: EU Active */
#define tgl__l3_3__eu_active__read \
    bdw__render_basic__eu_active__read

/* Gen12LP L3_3 :: EU Stall */
#define tgl__l3_3__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Gen12LP L3_3 :: EU FPU And EM Pipes Active */
#define tgl__l3_3__eu_fpu_em_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Gen12LP L3_3 :: VS Threads Dispatched */
#define tgl__l3_3__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Gen12LP L3_3 :: EU Thread Occupancy */
#define tgl__l3_3__eu_thread_occupancy__read \
    bdw__vme_pipe__eu_thread_occupancy__read

/* Gen12LP L3_3 :: HS Threads Dispatched */
#define tgl__l3_3__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Gen12LP L3_3 :: DS Threads Dispatched */
#define tgl__l3_3__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Gen12LP L3_3 :: GS Threads Dispatched */
#define tgl__l3_3__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Gen12LP L3_3 :: FS Threads Dispatched */
#define tgl__l3_3__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Gen12LP L3_3 :: CS Threads Dispatched */
#define tgl__l3_3__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Gen12LP L3_3 :: Slice0 L3 Bank0 Output Ready */
static double
tgl__l3_3__l30_bank0_output_ready__read(const struct intel_perf *perf,
                                        const struct intel_perf_metric_set *metric_set,
                                        uint64_t *accumulator)
{
    /* RPN equation: C 7 READ C 6 READ FADD 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 7];
    uint64_t tmp1 = accumulator[metric_set->c_offset + 6];
    double tmp2 = tmp0 + tmp1;
    uint64_t tmp3 = tmp2 * 100;
    double tmp4 = tmp3;
    double tmp5 = tgl__l3_3__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp6 = tmp5 ? tmp4 / tmp5 : 0;

    return tmp6;
}

/* Gen12LP L3_3 :: Slice0 L3 Bank4 Output Ready */
static double
tgl__l3_3__l30_bank4_output_ready__read(const struct intel_perf *perf,
                                        const struct intel_perf_metric_set *metric_set,
                                        uint64_t *accumulator)
{
    /* RPN equation: C 5 READ C 4 READ FADD 100 UMUL $GpuCoreClocks FDIV */
    uint64_t tmp0 = accumulator[metric_set->c_offset + 5];
    uint64_t tmp1 = accumulator[metric_set->c_offset + 4];
    double tmp2 = tmp0 + tmp1;
    uint64_t tmp3 = tmp2 * 100;
    double tmp4 = tmp3;
    double tmp5 = tgl__l3_3__gpu_core_clocks__read(perf, metric_set, accumulator);
    double tmp6 = tmp5 ? tmp4 / tmp5 : 0;

    return tmp6;
}

/* Gen12LP L3_4 :: GPU Time Elapsed */
#define tgl__l3_4__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Gen12LP L3_4 :: GPU Core Clocks */
#define tgl__l3_4__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Gen12LP L3_4 :: AVG GPU Core Frequency */
#define tgl__l3_4__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Gen12LP L3_4 :: AVG GPU Core Frequency */
#define tgl__l3_4__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Gen12LP L3_4 :: GPU Busy */
#define tgl__l3_4__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Gen12LP L3_4 :: EU Active */
#define tgl__l3_4__eu_active__read \
    bdw__render_basic__eu_active__read

/* Gen12LP L3_4 :: EU Stall */
#define tgl__l3_4__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Gen12LP L3_4 :: EU FPU And EM Pipes Active */
#define tgl__l3_4__eu_fpu_em_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Gen12LP L3_4 :: VS Threads Dispatched */
#define tgl__l3_4__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Gen12LP L3_4 :: EU Thread Occupancy */
#define tgl__l3_4__eu_thread_occupancy__read \
    bdw__vme_pipe__eu_thread_occupancy__read

/* Gen12LP L3_4 :: HS Threads Dispatched */
#define tgl__l3_4__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Gen12LP L3_4 :: DS Threads Dispatched */
#define tgl__l3_4__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Gen12LP L3_4 :: GS Threads Dispatched */
#define tgl__l3_4__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Gen12LP L3_4 :: FS Threads Dispatched */
#define tgl__l3_4__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Gen12LP L3_4 :: CS Threads Dispatched */
#define tgl__l3_4__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Gen12LP L3_4 :: Slice0 L3 Bank1 Output Ready */
#define tgl__l3_4__l30_bank1_output_ready__read \
    tgl__l3_3__l30_bank4_output_ready__read

/* Gen12LP L3_4 :: Slice0 L3 Bank5 Output Ready */
#define tgl__l3_4__l30_bank5_output_ready__read \
    tgl__l3_3__l30_bank0_output_ready__read

/* Gen12LP L3_5 :: GPU Time Elapsed */
#define tgl__l3_5__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Gen12LP L3_5 :: GPU Core Clocks */
#define tgl__l3_5__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Gen12LP L3_5 :: AVG GPU Core Frequency */
#define tgl__l3_5__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Gen12LP L3_5 :: AVG GPU Core Frequency */
#define tgl__l3_5__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Gen12LP L3_5 :: GPU Busy */
#define tgl__l3_5__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Gen12LP L3_5 :: EU Active */
#define tgl__l3_5__eu_active__read \
    bdw__render_basic__eu_active__read

/* Gen12LP L3_5 :: EU Stall */
#define tgl__l3_5__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Gen12LP L3_5 :: EU FPU And EM Pipes Active */
#define tgl__l3_5__eu_fpu_em_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Gen12LP L3_5 :: VS Threads Dispatched */
#define tgl__l3_5__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Gen12LP L3_5 :: EU Thread Occupancy */
#define tgl__l3_5__eu_thread_occupancy__read \
    bdw__vme_pipe__eu_thread_occupancy__read

/* Gen12LP L3_5 :: HS Threads Dispatched */
#define tgl__l3_5__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Gen12LP L3_5 :: DS Threads Dispatched */
#define tgl__l3_5__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Gen12LP L3_5 :: GS Threads Dispatched */
#define tgl__l3_5__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Gen12LP L3_5 :: FS Threads Dispatched */
#define tgl__l3_5__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Gen12LP L3_5 :: CS Threads Dispatched */
#define tgl__l3_5__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Gen12LP L3_5 :: Slice0 L3 Bank2 Output Ready */
#define tgl__l3_5__l30_bank2_output_ready__read \
    tgl__l3_3__l30_bank4_output_ready__read

/* Gen12LP L3_5 :: Slice0 L3 Bank6 Output Ready */
#define tgl__l3_5__l30_bank6_output_ready__read \
    tgl__l3_3__l30_bank0_output_ready__read

/* Gen12LP L3_6 :: GPU Time Elapsed */
#define tgl__l3_6__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Gen12LP L3_6 :: GPU Core Clocks */
#define tgl__l3_6__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Gen12LP L3_6 :: AVG GPU Core Frequency */
#define tgl__l3_6__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Gen12LP L3_6 :: AVG GPU Core Frequency */
#define tgl__l3_6__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Gen12LP L3_6 :: GPU Busy */
#define tgl__l3_6__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Gen12LP L3_6 :: EU Active */
#define tgl__l3_6__eu_active__read \
    bdw__render_basic__eu_active__read

/* Gen12LP L3_6 :: EU Stall */
#define tgl__l3_6__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Gen12LP L3_6 :: EU FPU And EM Pipes Active */
#define tgl__l3_6__eu_fpu_em_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Gen12LP L3_6 :: VS Threads Dispatched */
#define tgl__l3_6__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Gen12LP L3_6 :: EU Thread Occupancy */
#define tgl__l3_6__eu_thread_occupancy__read \
    bdw__vme_pipe__eu_thread_occupancy__read

/* Gen12LP L3_6 :: HS Threads Dispatched */
#define tgl__l3_6__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Gen12LP L3_6 :: DS Threads Dispatched */
#define tgl__l3_6__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Gen12LP L3_6 :: GS Threads Dispatched */
#define tgl__l3_6__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Gen12LP L3_6 :: FS Threads Dispatched */
#define tgl__l3_6__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Gen12LP L3_6 :: CS Threads Dispatched */
#define tgl__l3_6__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Gen12LP L3_6 :: Slice0 L3 Bank3 Output Ready */
#define tgl__l3_6__l30_bank3_output_ready__read \
    tgl__l3_3__l30_bank4_output_ready__read

/* Gen12LP L3_6 :: Slice0 L3 Bank7 Output Ready */
#define tgl__l3_6__l30_bank7_output_ready__read \
    tgl__l3_3__l30_bank0_output_ready__read

/* Sampler_1 :: GPU Time Elapsed */
#define tgl__sampler_1__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Sampler_1 :: GPU Core Clocks */
#define tgl__sampler_1__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Sampler_1 :: AVG GPU Core Frequency */
#define tgl__sampler_1__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Sampler_1 :: AVG GPU Core Frequency */
#define tgl__sampler_1__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Sampler_1 :: GPU Busy */
#define tgl__sampler_1__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Sampler_1 :: VS Threads Dispatched */
#define tgl__sampler_1__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Sampler_1 :: HS Threads Dispatched */
#define tgl__sampler_1__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Sampler_1 :: DS Threads Dispatched */
#define tgl__sampler_1__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Sampler_1 :: GS Threads Dispatched */
#define tgl__sampler_1__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Sampler_1 :: FS Threads Dispatched */
#define tgl__sampler_1__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Sampler_1 :: CS Threads Dispatched */
#define tgl__sampler_1__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Sampler_1 :: EU Active */
#define tgl__sampler_1__eu_active__read \
    bdw__render_basic__eu_active__read

/* Sampler_1 :: EU Stall */
#define tgl__sampler_1__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Sampler_1 :: EU FPU And EM Pipes Active */
#define tgl__sampler_1__eu_fpu_em_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Sampler_1 :: EU Thread Occupancy */
#define tgl__sampler_1__eu_thread_occupancy__read \
    bdw__vme_pipe__eu_thread_occupancy__read

/* Sampler_1 :: Slice0 DualSubslice0 Input Available */
#define tgl__sampler_1__sampler00_input_available__read \
    bdw__render_pipe_profile__cl_bottleneck__read

/* Sampler_1 :: Slice0 DualSubslice1 Input Available */
#define tgl__sampler_1__sampler01_input_available__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* Sampler_1 :: Slice0 DualSubslice2 Input Available */
#define tgl__sampler_1__sampler02_input_available__read \
    bdw__render_basic__sampler1_bottleneck__read

/* Sampler_1 :: Slice0 DualSubslice3 Input Available */
#define tgl__sampler_1__sampler03_input_available__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Sampler_1 :: Slice0 DualSubslice4 Input Available */
#define tgl__sampler_1__sampler04_input_available__read \
    bdw__render_basic__sampler1_busy__read

/* Sampler_1 :: Slice0 DualSubslice5 Input Available */
#define tgl__sampler_1__sampler05_input_available__read \
    bdw__render_basic__sampler0_busy__read

/* Sampler_2 :: GPU Time Elapsed */
#define tgl__sampler_2__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Sampler_2 :: GPU Core Clocks */
#define tgl__sampler_2__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Sampler_2 :: AVG GPU Core Frequency */
#define tgl__sampler_2__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Sampler_2 :: AVG GPU Core Frequency */
#define tgl__sampler_2__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Sampler_2 :: GPU Busy */
#define tgl__sampler_2__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* Sampler_2 :: VS Threads Dispatched */
#define tgl__sampler_2__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* Sampler_2 :: HS Threads Dispatched */
#define tgl__sampler_2__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* Sampler_2 :: DS Threads Dispatched */
#define tgl__sampler_2__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* Sampler_2 :: GS Threads Dispatched */
#define tgl__sampler_2__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* Sampler_2 :: FS Threads Dispatched */
#define tgl__sampler_2__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* Sampler_2 :: CS Threads Dispatched */
#define tgl__sampler_2__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* Sampler_2 :: EU Active */
#define tgl__sampler_2__eu_active__read \
    bdw__render_basic__eu_active__read

/* Sampler_2 :: EU Stall */
#define tgl__sampler_2__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* Sampler_2 :: EU FPU And EM Pipes Active */
#define tgl__sampler_2__eu_fpu_em_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* Sampler_2 :: EU Thread Occupancy */
#define tgl__sampler_2__eu_thread_occupancy__read \
    bdw__vme_pipe__eu_thread_occupancy__read

/* Sampler_2 :: Slice0 DualSubslice0 Sampler Output Ready */
#define tgl__sampler_2__sampler00_output_ready__read \
    bdw__render_pipe_profile__cl_bottleneck__read

/* Sampler_2 :: Slice0 DualSubslice1 Sampler Output Ready */
#define tgl__sampler_2__sampler01_output_ready__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* Sampler_2 :: Slice0 DualSubslice2 Sampler Output Ready */
#define tgl__sampler_2__sampler02_output_ready__read \
    bdw__render_basic__sampler1_bottleneck__read

/* Sampler_2 :: Slice0 DualSubslice3 Sampler Output Ready */
#define tgl__sampler_2__sampler03_output_ready__read \
    bdw__render_basic__sampler0_bottleneck__read

/* Sampler_2 :: Slice0 DualSubslice4 Sampler Output Ready */
#define tgl__sampler_2__sampler04_output_ready__read \
    bdw__render_basic__sampler1_busy__read

/* Sampler_2 :: Slice0 DualSubslice5 Sampler Output Ready */
#define tgl__sampler_2__sampler05_output_ready__read \
    bdw__render_basic__sampler0_busy__read

/* TDL_1 :: GPU Time Elapsed */
#define tgl__tdl_1__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* TDL_1 :: GPU Core Clocks */
#define tgl__tdl_1__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* TDL_1 :: AVG GPU Core Frequency */
#define tgl__tdl_1__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* TDL_1 :: AVG GPU Core Frequency */
#define tgl__tdl_1__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* TDL_1 :: GPU Busy */
#define tgl__tdl_1__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* TDL_1 :: VS Threads Dispatched */
#define tgl__tdl_1__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* TDL_1 :: HS Threads Dispatched */
#define tgl__tdl_1__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* TDL_1 :: DS Threads Dispatched */
#define tgl__tdl_1__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* TDL_1 :: GS Threads Dispatched */
#define tgl__tdl_1__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* TDL_1 :: FS Threads Dispatched */
#define tgl__tdl_1__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* TDL_1 :: CS Threads Dispatched */
#define tgl__tdl_1__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* TDL_1 :: EU Active */
#define tgl__tdl_1__eu_active__read \
    bdw__render_basic__eu_active__read

/* TDL_1 :: EU Stall */
#define tgl__tdl_1__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* TDL_1 :: EU FPU And EM Pipes Active */
#define tgl__tdl_1__eu_fpu_em_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* TDL_1 :: EU Thread Occupancy */
#define tgl__tdl_1__eu_thread_occupancy__read \
    bdw__vme_pipe__eu_thread_occupancy__read

/* TDL_1 :: Non-PS Thread Ready For Dispatch on Slice0 DualSubslice0 Thread Dispatcher */
#define tgl__tdl_1__non_ps_thread00_ready_for_dispatch__read \
    bdw__render_pipe_profile__cl_bottleneck__read

/* TDL_1 :: Non-PS Thread Ready For Dispatch on Slice0 DualSubslice1 Thread Dispatcher */
#define tgl__tdl_1__non_ps_thread01_ready_for_dispatch__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* TDL_1 :: Non-PS Thread Ready For Dispatch on Slice0 DualSubslice2 Thread Dispatcher */
#define tgl__tdl_1__non_ps_thread02_ready_for_dispatch__read \
    bdw__render_basic__sampler1_bottleneck__read

/* TDL_1 :: Non-PS Thread Ready For Dispatch on Slice0 DualSubslice3 Thread Dispatcher */
#define tgl__tdl_1__non_ps_thread03_ready_for_dispatch__read \
    bdw__render_basic__sampler0_bottleneck__read

/* TDL_1 :: Non-PS Thread Ready For Dispatch on Slice0 DualSubslice4 Thread Dispatcher */
#define tgl__tdl_1__non_ps_thread04_ready_for_dispatch__read \
    bdw__render_basic__sampler1_busy__read

/* TDL_1 :: Non-PS Thread Ready For Dispatch on Slice0 DualSubslice5 Thread Dispatcher */
#define tgl__tdl_1__non_ps_thread05_ready_for_dispatch__read \
    bdw__render_basic__sampler0_busy__read

/* TDL_1 :: Thread Header Ready on Slice0 DualSubslice0 Thread Dispatcher Port 0 */
#define tgl__tdl_1__thread_header00_ready_port0__read \
    bdw__render_pipe_profile__vf_bottleneck__read

/* TDL_1 :: Thread Header Ready on Slice0 DualSubslice0 Thread Dispatcher Port 1 */
#define tgl__tdl_1__thread_header00_ready_port1__read \
    bdw__render_pipe_profile__hs_stall__read

/* TDL_1 :: Thread Header Ready on Slice0 DualSubslice0 Thread Dispatcher Port 2 */
#define tgl__tdl_1__thread_header00_ready_port2__read \
    bdw__render_pipe_profile__ds_stall__read

/* TDL_1 :: Thread Header Ready on Slice0 DualSubslice0 Thread Dispatcher Port 3 */
#define tgl__tdl_1__thread_header00_ready_port3__read \
    bdw__render_pipe_profile__so_stall__read

/* TDL_1 :: Thread Header Ready on Slice0 DualSubslice1 Thread Dispatcher Port 0 */
#define tgl__tdl_1__thread_header01_ready_port0__read \
    bdw__render_pipe_profile__cl_stall__read

/* TDL_1 :: Thread Header Ready on Slice0 DualSubslice1 Thread Dispatcher Port 1 */
#define tgl__tdl_1__thread_header01_ready_port1__read \
    bdw__render_pipe_profile__sf_stall__read

/* TDL_1 :: Thread Header Ready on Slice0 DualSubslice1 Thread Dispatcher Port 2 */
#define tgl__tdl_1__thread_header01_ready_port2__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* TDL_1 :: Thread Header Ready on Slice0 DualSubslice1 Thread Dispatcher Port 3 */
#define tgl__tdl_1__thread_header01_ready_port3__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* TDL_1 :: Thread Header Ready on Slice0 DualSubslice0 Thread Dispatcher */
#define tgl__tdl_1__thread_header00_ready__read \
    bdw__render_pipe_profile__sf_bottleneck__read

/* TDL_1 :: Thread Header Ready on Slice0 DualSubslice1 Thread Dispatcher */
#define tgl__tdl_1__thread_header01_ready__read \
    bdw__render_pipe_profile__early_depth_bottleneck__read

/* TDL_2 :: GPU Time Elapsed */
#define tgl__tdl_2__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* TDL_2 :: GPU Core Clocks */
#define tgl__tdl_2__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* TDL_2 :: AVG GPU Core Frequency */
#define tgl__tdl_2__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* TDL_2 :: AVG GPU Core Frequency */
#define tgl__tdl_2__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* TDL_2 :: GPU Busy */
#define tgl__tdl_2__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* TDL_2 :: VS Threads Dispatched */
#define tgl__tdl_2__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* TDL_2 :: HS Threads Dispatched */
#define tgl__tdl_2__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* TDL_2 :: DS Threads Dispatched */
#define tgl__tdl_2__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* TDL_2 :: GS Threads Dispatched */
#define tgl__tdl_2__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* TDL_2 :: FS Threads Dispatched */
#define tgl__tdl_2__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* TDL_2 :: CS Threads Dispatched */
#define tgl__tdl_2__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* TDL_2 :: EU Active */
#define tgl__tdl_2__eu_active__read \
    bdw__render_basic__eu_active__read

/* TDL_2 :: EU Stall */
#define tgl__tdl_2__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* TDL_2 :: EU FPU And EM Pipes Active */
#define tgl__tdl_2__eu_fpu_em_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* TDL_2 :: EU Thread Occupancy */
#define tgl__tdl_2__eu_thread_occupancy__read \
    bdw__vme_pipe__eu_thread_occupancy__read

/* TDL_2 :: PS Thread Ready For Dispatch on Slice0 Dualsubslice0 Thread Dispatcher */
#define tgl__tdl_2__ps_thread00_ready_for_dispatch__read \
    bdw__render_pipe_profile__cl_bottleneck__read

/* TDL_2 :: PS Thread Ready For Dispatch on Slice0 Dualsubslice1 Thread Dispatcher */
#define tgl__tdl_2__ps_thread01_ready_for_dispatch__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* TDL_2 :: PS Thread Ready For Dispatch on Slice0 Dualsubslice2 Thread Dispatcher */
#define tgl__tdl_2__ps_thread02_ready_for_dispatch__read \
    bdw__render_basic__sampler1_bottleneck__read

/* TDL_2 :: PS Thread Ready For Dispatch on Slice0 Dualsubslice3 Thread Dispatcher */
#define tgl__tdl_2__ps_thread03_ready_for_dispatch__read \
    bdw__render_basic__sampler0_bottleneck__read

/* TDL_2 :: PS Thread Ready For Dispatch on Slice0 Dualsubslice4 Thread Dispatcher */
#define tgl__tdl_2__ps_thread04_ready_for_dispatch__read \
    bdw__render_basic__sampler1_busy__read

/* TDL_2 :: PS Thread Ready For Dispatch on Slice0 Dualsubslice5 Thread Dispatcher */
#define tgl__tdl_2__ps_thread05_ready_for_dispatch__read \
    bdw__render_basic__sampler0_busy__read

/* TDL_2 :: Thread Header Ready on Slice0 DualSubslice5 Thread Dispatcher */
#define tgl__tdl_2__thread_header05_ready__read \
    bdw__render_pipe_profile__sf_bottleneck__read

/* TDL_2 :: Thread Header Ready on Slice0 DualSubslice5 Thread Dispatcher Port 0 */
#define tgl__tdl_2__thread_header05_ready_port0__read \
    bdw__render_pipe_profile__cl_stall__read

/* TDL_2 :: Thread Header Ready on Slice0 DualSubslice5 Thread Dispatcher Port 1 */
#define tgl__tdl_2__thread_header05_ready_port1__read \
    bdw__render_pipe_profile__sf_stall__read

/* TDL_2 :: Thread Header Ready on Slice0 DualSubslice5 Thread Dispatcher Port 2 */
#define tgl__tdl_2__thread_header05_ready_port2__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* TDL_2 :: Thread Header Ready on Slice0 DualSubslice5 Thread Dispatcher Port 3 */
#define tgl__tdl_2__thread_header05_ready_port3__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* TDL_3 :: GPU Time Elapsed */
#define tgl__tdl_3__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* TDL_3 :: GPU Core Clocks */
#define tgl__tdl_3__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* TDL_3 :: AVG GPU Core Frequency */
#define tgl__tdl_3__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* TDL_3 :: AVG GPU Core Frequency */
#define tgl__tdl_3__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* TDL_3 :: GPU Busy */
#define tgl__tdl_3__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* TDL_3 :: VS Threads Dispatched */
#define tgl__tdl_3__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* TDL_3 :: HS Threads Dispatched */
#define tgl__tdl_3__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* TDL_3 :: DS Threads Dispatched */
#define tgl__tdl_3__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* TDL_3 :: GS Threads Dispatched */
#define tgl__tdl_3__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* TDL_3 :: FS Threads Dispatched */
#define tgl__tdl_3__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* TDL_3 :: CS Threads Dispatched */
#define tgl__tdl_3__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* TDL_3 :: EU Active */
#define tgl__tdl_3__eu_active__read \
    bdw__render_basic__eu_active__read

/* TDL_3 :: EU Stall */
#define tgl__tdl_3__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* TDL_3 :: EU FPU And EM Pipes Active */
#define tgl__tdl_3__eu_fpu_em_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* TDL_3 :: EU Thread Occupancy */
#define tgl__tdl_3__eu_thread_occupancy__read \
    bdw__vme_pipe__eu_thread_occupancy__read

/* TDL_3 :: Thread Header Ready on Slice0 DualSubslice2 Thread Dispatcher */
#define tgl__tdl_3__thread_header02_ready__read \
    bdw__render_basic__sampler0_busy__read

/* TDL_3 :: Thread Header Ready on Slice0 DualSubslice3 Thread Dispatcher */
#define tgl__tdl_3__thread_header03_ready__read \
    bdw__render_basic__sampler1_busy__read

/* TDL_3 :: Thread Header Ready on Slice0 DualSubslice4 Thread Dispatcher */
#define tgl__tdl_3__thread_header04_ready__read \
    bdw__render_basic__sampler0_bottleneck__read

/* TDL_3 :: Thread Header Ready on Slice0 DualSubslice2 Thread Dispatcher Port 0 */
#define tgl__tdl_3__thread_header02_ready_port0__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* TDL_3 :: Thread Header Ready on Slice0 DualSubslice2 Thread Dispatcher Port 1 */
#define tgl__tdl_3__thread_header02_ready_port1__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* TDL_3 :: Thread Header Ready on Slice0 DualSubslice2 Thread Dispatcher Port 2 */
#define tgl__tdl_3__thread_header02_ready_port2__read \
    bdw__render_pipe_profile__sf_stall__read

/* TDL_3 :: Thread Header Ready on Slice0 DualSubslice2 Thread Dispatcher Port 3 */
#define tgl__tdl_3__thread_header02_ready_port3__read \
    bdw__render_pipe_profile__cl_stall__read

/* TDL_3 :: Thread Header Ready on Slice0 DualSubslice3 Thread Dispatcher Port 0 */
#define tgl__tdl_3__thread_header03_ready_port0__read \
    bdw__render_pipe_profile__so_stall__read

/* TDL_3 :: Thread Header Ready on Slice0 DualSubslice3 Thread Dispatcher Port 1 */
#define tgl__tdl_3__thread_header03_ready_port1__read \
    bdw__render_pipe_profile__ds_stall__read

/* TDL_3 :: Thread Header Ready on Slice0 DualSubslice3 Thread Dispatcher Port 2 */
#define tgl__tdl_3__thread_header03_ready_port2__read \
    bdw__render_pipe_profile__hs_stall__read

/* TDL_3 :: Thread Header Ready on Slice0 DualSubslice3 Thread Dispatcher Port 3 */
#define tgl__tdl_3__thread_header03_ready_port3__read \
    bdw__render_pipe_profile__vf_bottleneck__read

/* TDL_3 :: Thread Header Ready on Slice0 DualSubslice4 Thread Dispatcher Port 0 */
#define tgl__tdl_3__thread_header04_ready_port0__read \
    bdw__render_pipe_profile__early_depth_bottleneck__read

/* TDL_3 :: Thread Header Ready on Slice0 DualSubslice4 Thread Dispatcher Port 1 */
#define tgl__tdl_3__thread_header04_ready_port1__read \
    bdw__render_pipe_profile__sf_bottleneck__read

/* TDL_3 :: Thread Header Ready on Slice0 DualSubslice4 Thread Dispatcher Port 2 */
#define tgl__tdl_3__thread_header04_ready_port2__read \
    bdw__render_pipe_profile__cl_bottleneck__read

/* TDL_3 :: Thread Header Ready on Slice0 DualSubslice4 Thread Dispatcher Port 3 */
#define tgl__tdl_3__thread_header04_ready_port3__read \
    bdw__render_pipe_profile__so_bottleneck__read

/* GpuBusyness :: GPU Time Elapsed */
#define tgl__gpu_busyness__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* GpuBusyness :: GPU Core Clocks */
#define tgl__gpu_busyness__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* GpuBusyness :: AVG GPU Core Frequency */
#define tgl__gpu_busyness__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* GpuBusyness :: AVG GPU Core Frequency */
#define tgl__gpu_busyness__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* GpuBusyness :: GPU Busy */
#define tgl__gpu_busyness__gpu_busy__read \
    bdw__render_basic__gpu_busy__read

/* GpuBusyness :: EU Active */
#define tgl__gpu_busyness__eu_active__read \
    bdw__render_basic__eu_active__read

/* GpuBusyness :: EU Stall */
#define tgl__gpu_busyness__eu_stall__read \
    bdw__render_basic__eu_stall__read

/* GpuBusyness :: EU FPU And EM Pipes Active */
#define tgl__gpu_busyness__eu_fpu_em_active__read \
    bdw__render_basic__eu_fpu_both_active__read

/* GpuBusyness :: EU Thread Occupancy */
#define tgl__gpu_busyness__eu_thread_occupancy__read \
    bdw__vme_pipe__eu_thread_occupancy__read

/* GpuBusyness :: VS Threads Dispatched */
#define tgl__gpu_busyness__vs_threads__read \
    bdw__render_basic__vs_threads__read

/* GpuBusyness :: HS Threads Dispatched */
#define tgl__gpu_busyness__hs_threads__read \
    bdw__render_basic__hs_threads__read

/* GpuBusyness :: DS Threads Dispatched */
#define tgl__gpu_busyness__ds_threads__read \
    bdw__render_basic__ds_threads__read

/* GpuBusyness :: GS Threads Dispatched */
#define tgl__gpu_busyness__gs_threads__read \
    hsw__render_basic__vs_threads__read

/* GpuBusyness :: FS Threads Dispatched */
#define tgl__gpu_busyness__ps_threads__read \
    bdw__render_basic__ps_threads__read

/* GpuBusyness :: CS Threads Dispatched */
#define tgl__gpu_busyness__cs_threads__read \
    bdw__render_basic__cs_threads__read

/* GpuBusyness :: Render Ring Busy */
#define tgl__gpu_busyness__render_busy__read \
    bdw__render_pipe_profile__hi_depth_bottleneck__read

/* GpuBusyness :: Compute Ring Busy */
#define tgl__gpu_busyness__compute_busy__read \
    bdw__render_pipe_profile__so_stall__read

/* GpuBusyness :: Posh Ring Busy */
#define tgl__gpu_busyness__posh_engine_busy__read \
    bdw__render_pipe_profile__sf_stall__read

/* GpuBusyness :: Blitter Ring Busy */
#define tgl__gpu_busyness__blitter_busy__read \
    bdw__render_pipe_profile__cl_stall__read

/* GpuBusyness :: Vebox Ring Busy */
#define tgl__gpu_busyness__vebox_busy__read \
    bdw__render_pipe_profile__bc_bottleneck__read

/* GpuBusyness :: Vdbox0 Ring Busy */
#define tgl__gpu_busyness__vdbox0_busy__read \
    bdw__render_pipe_profile__hs_stall__read

/* GpuBusyness :: Vdbox1 Ring Busy */
#define tgl__gpu_busyness__vdbox1_busy__read \
    bdw__render_pipe_profile__ds_stall__read

/* GpuBusyness :: Render and compute engines are simultaneously busy */
#define tgl__gpu_busyness__render_and_compute_busy__read \
    bdw__render_basic__sampler0_busy__read

/* GpuBusyness :: Any Engine Busy */
#define tgl__gpu_busyness__any_engine_busy__read \
    bdw__render_basic__sampler1_busy__read

/* Metric set TestOa :: GPU Time Elapsed */
#define tgl__test_oa__gpu_time__read \
    hsw__render_basic__gpu_time__read

/* Metric set TestOa :: GPU Core Clocks */
#define tgl__test_oa__gpu_core_clocks__read \
    bdw__render_basic__gpu_core_clocks__read

/* Metric set TestOa :: AVG GPU Core Frequency */
#define tgl__test_oa__avg_gpu_core_frequency__read \
    bdw__render_basic__avg_gpu_core_frequency__read

/* Metric set TestOa :: AVG GPU Core Frequency */
#define tgl__test_oa__avg_gpu_core_frequency__max \
    hsw__render_basic__avg_gpu_core_frequency__max

/* Metric set TestOa :: TestCounter0 */
#define tgl__test_oa__counter0__read \
    hsw__compute_extended__eu_untyped_reads0__read

/* Metric set TestOa :: TestCounter1 */
#define tgl__test_oa__counter1__read \
    hsw__compute_extended__eu_untyped_writes0__read

/* Metric set TestOa :: TestCounter2 */
#define tgl__test_oa__counter2__read \
    hsw__compute_extended__eu_typed_reads0__read

/* Metric set TestOa :: TestCounter3 */
#define tgl__test_oa__counter3__read \
    hsw__compute_extended__eu_typed_writes0__read

/* Metric set TestOa :: TestCounter4 */
#define tgl__test_oa__counter4__read \
    hsw__compute_extended__eu_untyped_atomics0__read

/* Metric set TestOa :: TestCounter5 */
#define tgl__test_oa__counter5__read \
    hsw__compute_extended__eu_typed_atomics0__read

/* Metric set TestOa :: TestCounter6 */
#define tgl__test_oa__counter6__read \
    hsw__compute_extended__eu_urb_atomics0__read

/* Metric set TestOa :: TestCounter7 */
#define tgl__test_oa__counter7__read \
    hsw__compute_extended__gpu_clocks__read

/* Metric set TestOa :: TestCounter8 */
#define tgl__test_oa__counter8__read \
    hsw__compute_extended__typed_writes0__read

/* Metric set TestOa :: TestCounter9 - OAR enable */
#define tgl__test_oa__counter9__read \
    hsw__compute_extended__untyped_writes0__read

static void
hsw_add_render_basic_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Render Metrics Basic Gen7.5";
    metric_set->symbol_name = "RenderBasic";
    metric_set->hw_config_guid = "a490e9d2-55b3-4db0-8dab-53011032c5f3";
    metric_set->counters = calloc(70, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A45_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->a_offset = 1;
    metric_set->b_offset = metric_set->a_offset + 45;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(62, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(4, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000253A4, .val = 0x01600000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00025440, .val = 0x00100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00025128, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x0002691C, .val = 0x00000800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00026AA0, .val = 0x01500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00026B9C, .val = 0x00006000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x0002791C, .val = 0x00000800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00027AA0, .val = 0x01500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00027B9C, .val = 0x00006000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x0002641C, .val = 0x00000400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00025380, .val = 0x00000010 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x0002538C, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00025384, .val = 0x0800AAAA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00025400, .val = 0x00000004 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x0002540C, .val = 0x06029000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00025410, .val = 0x00000002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00025404, .val = 0x5C30FFFF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00025100, .val = 0x00000016 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00025110, .val = 0x00000400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00025104, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00026804, .val = 0x00001211 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00026884, .val = 0x00000100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00026900, .val = 0x00000002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00026908, .val = 0x00700000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00026904, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00026984, .val = 0x00001022 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00026A04, .val = 0x00000011 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00026A80, .val = 0x00000006 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00026A88, .val = 0x00000C02 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00026A84, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00026B04, .val = 0x00001000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00026B80, .val = 0x00000002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00026B8C, .val = 0x00000007 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00026B84, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00027804, .val = 0x00004844 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00027884, .val = 0x00000400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00027900, .val = 0x00000002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00027908, .val = 0x0E000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00027904, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00027984, .val = 0x00004088 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00027A04, .val = 0x00000044 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00027A80, .val = 0x00000006 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00027A88, .val = 0x00018040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00027A84, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00027B04, .val = 0x00004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00027B80, .val = 0x00000002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00027B8C, .val = 0x000000E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00027B84, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00026104, .val = 0x00002222 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00026184, .val = 0x0C006666 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00026284, .val = 0x04000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00026304, .val = 0x04000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00026400, .val = 0x00000002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00026410, .val = 0x000000A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00026404, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00025420, .val = 0x04108020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00025424, .val = 0x1284A420 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x0002541C, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00025428, .val = 0x00042049 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0400000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091C4, .val = 0xE4500000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Alpha Test Fails";
    counter->symbol_name = "AlphaTestFails";
    counter->desc = "The total number of pixels dropped on post-FS alpha test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = hsw__render_basic__alpha_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = hsw__render_basic__avg_gpu_core_frequency__read;
    counter->max_uint64 = hsw__render_basic__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Duration";
    counter->symbol_name = "CsDuration";
    counter->desc = "Total Compute Shader GPU duration.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_US;
    counter->read_uint64 = hsw__render_basic__cs_duration__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS EU Active";
    counter->symbol_name = "CsEuActive";
    counter->desc = "The percentage of time in which compute shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__render_basic__cs_eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS AVG Active per Thread";
    counter->symbol_name = "CsEuActivePerThread";
    counter->desc = "The average number of cycles per hardware thread run in which compute shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__render_basic__cs_eu_active_per_thread__read;
    counter->max_uint64 = percentage_max_callback_uint64;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS EU Stall";
    counter->symbol_name = "CsEuStall";
    counter->desc = "The percentage of time in which compute shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__render_basic__cs_eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS AVG Stall per Thread";
    counter->symbol_name = "CsEuStallPerThread";
    counter->desc = "The average number of cycles per hardware thread run in which compute shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__render_basic__cs_eu_stall_per_thread__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = hsw__render_basic__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TES Duration";
    counter->symbol_name = "DsDuration";
    counter->desc = "Total Evaluation Shader GPU duration.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_US;
    counter->read_uint64 = hsw__render_basic__ds_duration__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Evaluation Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TES EU Active";
    counter->symbol_name = "DsEuActive";
    counter->desc = "The percentage of time in which evaluation shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__render_basic__ds_eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Evaluation Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TES AVG Active per Thread";
    counter->symbol_name = "DsEuActivePerThread";
    counter->desc = "The average number of cycles per hardware thread run in which evaluation shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__render_basic__ds_eu_active_per_thread__read;
    counter->max_uint64 = percentage_max_callback_uint64;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Evaluation Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TES EU Stall";
    counter->symbol_name = "DsEuStall";
    counter->desc = "The percentage of time in which evaluation shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__render_basic__ds_eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Evaluation Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TES AVG Stall per Thread";
    counter->symbol_name = "DsEuStallPerThread";
    counter->desc = "The average number of cycles per hardware thread run in which evaluation shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__render_basic__ds_eu_stall_per_thread__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Evaluation Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TES Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of evaluation shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = hsw__render_basic__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Evaluation Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = hsw__render_basic__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__render_basic__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Idle";
    counter->symbol_name = "EuIdle";
    counter->desc = "The percentage of time in which the Execution Units were idle.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__render_basic__eu_idle__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__render_basic__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has being processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__render_basic__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__render_basic__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = hsw__render_basic__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Duration";
    counter->symbol_name = "GsDuration";
    counter->desc = "Total Geometry Shader GPU duration.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_US;
    counter->read_uint64 = hsw__render_basic__gs_duration__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS EU Active";
    counter->symbol_name = "GsEuActive";
    counter->desc = "The percentage of time in which geometry shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__render_basic__gs_eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS AVG Active per Thread";
    counter->symbol_name = "GsEuActivePerThread";
    counter->desc = "The average number of cycles per hardware thread run in which geometry shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__render_basic__gs_eu_active_per_thread__read;
    counter->max_uint64 = percentage_max_callback_uint64;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS EU Stall";
    counter->symbol_name = "GsEuStall";
    counter->desc = "The percentage of time in which geometry shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__render_basic__gs_eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS AVG Stall per Thread";
    counter->symbol_name = "GsEuStallPerThread";
    counter->desc = "The average number of cycles per hardware thread run in which geometry shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__render_basic__gs_eu_stall_per_thread__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = hsw__render_basic__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Depth Throughput";
    counter->symbol_name = "GtiDepthThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between depth caches and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = hsw__render_basic__gti_depth_throughput__read;
    counter->max_uint64 = hsw__render_basic__gti_depth_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI L3 Throughput";
    counter->symbol_name = "GtiL3Throughput";
    counter->desc = "The total number of GPU memory bytes transferred between L3 caches and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = hsw__render_basic__gti_l3_throughput__read;
    counter->max_uint64 = hsw__render_basic__gti_l3_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI RCC Throughput";
    counter->symbol_name = "GtiRccThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between render color caches and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = hsw__render_basic__gti_rcc_throughput__read;
    counter->max_uint64 = hsw__render_basic__gti_rcc_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Read Throughput";
    counter->symbol_name = "GtiReadThroughput";
    counter->desc = "The total number of GPU memory bytes read from GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = hsw__render_basic__gti_read_throughput__read;
    counter->max_uint64 = hsw__render_basic__gti_read_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Fixed Pipe Throughput";
    counter->symbol_name = "GtiVfThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between 3D Pipeline (Command Dispatch, Input Assembly and Stream Output) and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = hsw__render_basic__gti_vf_throughput__read;
    counter->max_uint64 = hsw__render_basic__gti_vf_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Write Throughput";
    counter->symbol_name = "GtiWriteThroughput";
    counter->desc = "The total number of GPU memory bytes written to GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = hsw__render_basic__gti_write_throughput__read;
    counter->max_uint64 = hsw__render_basic__gti_write_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = hsw__render_basic__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TCS Duration";
    counter->symbol_name = "HsDuration";
    counter->desc = "Total Control Shader GPU duration.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_US;
    counter->read_uint64 = hsw__render_basic__hs_duration__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Control Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TCS EU Active";
    counter->symbol_name = "HsEuActive";
    counter->desc = "The percentage of time in which control shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__render_basic__hs_eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Control Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TCS AVG Active per Thread";
    counter->symbol_name = "HsEuActivePerThread";
    counter->desc = "The average number of cycles per hardware thread run in which control shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__render_basic__hs_eu_active_per_thread__read;
    counter->max_uint64 = percentage_max_callback_uint64;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Control Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TCS EU Stall";
    counter->symbol_name = "HsEuStall";
    counter->desc = "The percentage of time in which control shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__render_basic__hs_eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Control Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TCS AVG Stall per Thread";
    counter->symbol_name = "HsEuStallPerThread";
    counter->desc = "The average number of cycles per hardware thread run in which control shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__render_basic__hs_eu_stall_per_thread__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Control Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TCS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of control shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = hsw__render_basic__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Control Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Sampler Throughput";
    counter->symbol_name = "L3SamplerThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between samplers and L3 caches.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = hsw__render_basic__l3_sampler_throughput__read;
    counter->max_uint64 = hsw__render_basic__l3_sampler_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Sampler");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "LLC GPU Accesses";
        counter->symbol_name = "LlcAccesses";
        counter->desc = "The total number of LLC cache lookups done from the GPU (64b reads, 32B writes).";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = hsw__render_basic__llc_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "LLC");
    }

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "LLC GPU Throughput";
        counter->symbol_name = "LlcGpuThroughput";
        counter->desc = "The total number of GPU memory bytes transferred between GPU and LLC.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
        counter->read_uint64 = hsw__render_basic__llc_gpu_throughput__read;
        counter->max_uint64 = hsw__render_basic__llc_gpu_throughput__max;
        intel_perf_add_logical_counter(perf, counter, "LLC");
    }

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "LLC GPU Hits";
        counter->symbol_name = "LlcHits";
        counter->desc = "The total number of successful LLC cache lookups done from the GPU.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = hsw__render_basic__llc_hits__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "LLC");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Late Depth Test Fails";
    counter->symbol_name = "PostPsDepthTestFails";
    counter->desc = "The total number of pixels dropped on post-FS depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = hsw__render_basic__post_ps_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Late Stencil Test Fails";
    counter->symbol_name = "PostPsStencilTestFails";
    counter->desc = "The total number of pixels dropped on post-FS stencil test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = hsw__render_basic__post_ps_stencil_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Duration";
    counter->symbol_name = "PsDuration";
    counter->desc = "Total Fragment Shader GPU duration.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_US;
    counter->read_uint64 = hsw__render_basic__ps_duration__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS EU Active";
    counter->symbol_name = "PsEuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__render_basic__ps_eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS AVG Active per Thread";
    counter->symbol_name = "PsEuActivePerThread";
    counter->desc = "The average number of cycles per hardware thread run in which fragment shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__render_basic__ps_eu_active_per_thread__read;
    counter->max_uint64 = percentage_max_callback_uint64;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS EU Stall";
    counter->symbol_name = "PsEuStall";
    counter->desc = "The percentage of time in which fragment shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__render_basic__ps_eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS AVG Stall per Thread";
    counter->symbol_name = "PsEuStallPerThread";
    counter->desc = "The average number of cycles per hardware thread run in which fragment shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__render_basic__ps_eu_stall_per_thread__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = hsw__render_basic__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Sampler 0 Bottleneck";
        counter->symbol_name = "Sampler0Bottleneck";
        counter->desc = "The percentage of time in which sampler 0 was bottlenecks.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = hsw__render_basic__sampler0_bottleneck__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Sampler 0 Busy";
        counter->symbol_name = "Sampler0Busy";
        counter->desc = "The percentage of time in which sampler 0 was busy.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = hsw__render_basic__sampler0_busy__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Sampler 0 Texels LOD0";
        counter->symbol_name = "Sampler0Texels";
        counter->desc = "The total number of texels lookups in LOD0 in sampler 0 unit.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
        counter->read_uint64 = hsw__render_basic__sampler0_texels__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Sampler 1 Bottleneck";
        counter->symbol_name = "Sampler1Bottleneck";
        counter->desc = "The percentage of time in which sampler 1 was bottlenecks.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = hsw__render_basic__sampler1_bottleneck__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Sampler 1 Busy";
        counter->symbol_name = "Sampler1Busy";
        counter->desc = "The percentage of time in which sampler 1 was busy.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = hsw__render_basic__sampler1_busy__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Sampler 1 Texels LOD0";
        counter->symbol_name = "Sampler1Texels";
        counter->desc = "The total number of texels lookups in LOD0 in sampler 1 unit.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
        counter->read_uint64 = hsw__render_basic__sampler1_texels__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Bottleneck";
    counter->symbol_name = "SamplerBottleneck";
    counter->desc = "The percentage of time in which samplers were bottlenecks.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__render_basic__sampler_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels LOD0";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels lookups in LOD0 in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = hsw__render_basic__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samplers Busy";
    counter->symbol_name = "SamplersBusy";
    counter->desc = "The percentage of time in which samplers were busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__render_basic__samplers_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = hsw__render_basic__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = hsw__render_basic__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = hsw__render_basic__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Duration";
    counter->symbol_name = "VsDuration";
    counter->desc = "Total Vertex Shader GPU duration.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_US;
    counter->read_uint64 = hsw__render_basic__vs_duration__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS EU Active";
    counter->symbol_name = "VsEuActive";
    counter->desc = "The percentage of time in which vertex shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__render_basic__vs_eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS AVG Active per Thread";
    counter->symbol_name = "VsEuActivePerThread";
    counter->desc = "The average number of cycles per hardware thread run in which vertex shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__render_basic__vs_eu_active_per_thread__read;
    counter->max_uint64 = percentage_max_callback_uint64;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS EU Stall";
    counter->symbol_name = "VsEuStall";
    counter->desc = "The percentage of time in which vertex shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__render_basic__vs_eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS AVG Stall per Thread";
    counter->symbol_name = "VsEuStallPerThread";
    counter->desc = "The average number of cycles per hardware thread run in which vertex shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__render_basic__vs_eu_stall_per_thread__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = hsw__render_basic__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 70);
}

static void
hsw_add_compute_basic_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Compute Metrics Basic Gen7.5";
    metric_set->symbol_name = "ComputeBasic";
    metric_set->hw_config_guid = "b344c8cb-a291-4cbf-aa9c-b40213bfc96f";
    metric_set->counters = calloc(52, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A45_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->a_offset = 1;
    metric_set->b_offset = metric_set->a_offset + 45;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(35, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(16, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000253A4, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x0002681C, .val = 0x01F00800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00026820, .val = 0x00001000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x0002781C, .val = 0x01F00800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00026520, .val = 0x00000007 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000265A0, .val = 0x00000007 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00025380, .val = 0x00000010 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x0002538C, .val = 0x00300000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00025384, .val = 0xAA8AAAAA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00025404, .val = 0xFFFFFFFF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00026800, .val = 0x00004202 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00026808, .val = 0x00605817 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x0002680C, .val = 0x10001005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00026804, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00027800, .val = 0x00000102 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00027808, .val = 0x0C0701E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x0002780C, .val = 0x000200A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00027804, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00026484, .val = 0x44000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00026704, .val = 0x44000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00026500, .val = 0x00000006 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00026510, .val = 0x00000001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00026504, .val = 0x88000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00026580, .val = 0x00000006 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00026590, .val = 0x00000020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00026584, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00026104, .val = 0x55822222 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00026184, .val = 0xAA866666 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00025420, .val = 0x08320C83 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00025424, .val = 0x06820C83 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x0002541C, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00025428, .val = 0x00000C03 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0400000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091C4, .val = 0xE4500000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002718, .val = 0xAAAAAAAA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000271C, .val = 0xAAAAAAAA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002728, .val = 0xAAAAAAAA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000272C, .val = 0xAAAAAAAA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002748, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000274C, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002750, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002754, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002758, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000275C, .val = 0x00000000 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Alpha Test Fails";
    counter->symbol_name = "AlphaTestFails";
    counter->desc = "The total number of pixels dropped on post-FS alpha test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = hsw__compute_basic__alpha_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = hsw__compute_basic__avg_gpu_core_frequency__read;
    counter->max_uint64 = hsw__compute_basic__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS EU Active";
    counter->symbol_name = "CsEuActive";
    counter->desc = "The percentage of time in which compute shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__compute_basic__cs_eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS AVG Active per Thread";
    counter->symbol_name = "CsEuActivePerThread";
    counter->desc = "The average number of cycles per hardware thread run in which compute shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__compute_basic__cs_eu_active_per_thread__read;
    counter->max_uint64 = percentage_max_callback_uint64;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS EU Stall";
    counter->symbol_name = "CsEuStall";
    counter->desc = "The percentage of time in which compute shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__compute_basic__cs_eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS AVG Stall per Thread";
    counter->symbol_name = "CsEuStallPerThread";
    counter->desc = "The average number of cycles per hardware thread run in which compute shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__compute_basic__cs_eu_stall_per_thread__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = hsw__compute_basic__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TES EU Active";
    counter->symbol_name = "DsEuActive";
    counter->desc = "The percentage of time in which evaluation shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__compute_basic__ds_eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Evaluation Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TES AVG Active per Thread";
    counter->symbol_name = "DsEuActivePerThread";
    counter->desc = "The average number of cycles per hardware thread run in which evaluation shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__compute_basic__ds_eu_active_per_thread__read;
    counter->max_uint64 = percentage_max_callback_uint64;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Evaluation Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TES EU Stall";
    counter->symbol_name = "DsEuStall";
    counter->desc = "The percentage of time in which evaluation shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__compute_basic__ds_eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Evaluation Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TES AVG Stall per Thread";
    counter->symbol_name = "DsEuStallPerThread";
    counter->desc = "The average number of cycles per hardware thread run in which evaluation shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__compute_basic__ds_eu_stall_per_thread__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Evaluation Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TES Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of evaluation shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = hsw__compute_basic__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Evaluation Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = hsw__compute_basic__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__compute_basic__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__compute_basic__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has being processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__compute_basic__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__compute_basic__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = hsw__compute_basic__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS EU Active";
    counter->symbol_name = "GsEuActive";
    counter->desc = "The percentage of time in which geometry shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__compute_basic__gs_eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS AVG Active per Thread";
    counter->symbol_name = "GsEuActivePerThread";
    counter->desc = "The average number of cycles per hardware thread run in which geometry shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__compute_basic__gs_eu_active_per_thread__read;
    counter->max_uint64 = percentage_max_callback_uint64;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS EU Stall";
    counter->symbol_name = "GsEuStall";
    counter->desc = "The percentage of time in which geometry shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__compute_basic__gs_eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS AVG Stall per Thread";
    counter->symbol_name = "GsEuStallPerThread";
    counter->desc = "The average number of cycles per hardware thread run in which geometry shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__compute_basic__gs_eu_stall_per_thread__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = hsw__compute_basic__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = hsw__compute_basic__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TCS EU Active";
    counter->symbol_name = "HsEuActive";
    counter->desc = "The percentage of time in which control shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__compute_basic__hs_eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Control Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TCS AVG Active per Thread";
    counter->symbol_name = "HsEuActivePerThread";
    counter->desc = "The average number of cycles per hardware thread run in which control shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__compute_basic__hs_eu_active_per_thread__read;
    counter->max_uint64 = percentage_max_callback_uint64;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Control Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TCS EU Stall";
    counter->symbol_name = "HsEuStall";
    counter->desc = "The percentage of time in which control shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__compute_basic__hs_eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Control Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TCS AVG Stall per Thread";
    counter->symbol_name = "HsEuStallPerThread";
    counter->desc = "The average number of cycles per hardware thread run in which control shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__compute_basic__hs_eu_stall_per_thread__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Control Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TCS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of control shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = hsw__compute_basic__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Control Shader");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "LLC GPU Accesses";
        counter->symbol_name = "LlcAccesses";
        counter->desc = "The total number of LLC cache lookups done from the GPU (64b reads, 32B writes).";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = hsw__compute_basic__llc_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "LLC");
    }

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "LLC GPU Hits";
        counter->symbol_name = "LlcHits";
        counter->desc = "The total number of successful LLC cache lookups done from the GPU.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = hsw__compute_basic__llc_hits__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "LLC");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Late Depth Test Fails";
    counter->symbol_name = "PostPsDepthTestFails";
    counter->desc = "The total number of pixels dropped on post-FS depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = hsw__compute_basic__post_ps_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Late Stencil Test Fails";
    counter->symbol_name = "PostPsStencilTestFails";
    counter->desc = "The total number of pixels dropped on post-FS stencil test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = hsw__compute_basic__post_ps_stencil_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS EU Active";
    counter->symbol_name = "PsEuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__compute_basic__ps_eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS AVG Active per Thread";
    counter->symbol_name = "PsEuActivePerThread";
    counter->desc = "The average number of cycles per hardware thread run in which fragment shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__compute_basic__ps_eu_active_per_thread__read;
    counter->max_uint64 = percentage_max_callback_uint64;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS EU Stall";
    counter->symbol_name = "PsEuStall";
    counter->desc = "The percentage of time in which fragment shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__compute_basic__ps_eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS AVG Stall per Thread";
    counter->symbol_name = "PsEuStallPerThread";
    counter->desc = "The average number of cycles per hardware thread run in which fragment shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__compute_basic__ps_eu_stall_per_thread__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = hsw__compute_basic__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = hsw__compute_basic__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = hsw__compute_basic__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = hsw__compute_basic__slm_bytes_read__read;
    counter->max_uint64 = hsw__compute_basic__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of byten written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = hsw__compute_basic__slm_bytes_written__read;
    counter->max_uint64 = hsw__compute_basic__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Atomics";
    counter->symbol_name = "TypedAtomics";
    counter->desc = "The total number of typed atomics.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = hsw__compute_basic__typed_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Bytes Read";
    counter->symbol_name = "TypedBytesRead";
    counter->desc = "The total number of typed memory bytes read via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = hsw__compute_basic__typed_bytes_read__read;
    counter->max_uint64 = hsw__compute_basic__typed_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Bytes Written";
    counter->symbol_name = "TypedBytesWritten";
    counter->desc = "The total number of untyped memory bytes written via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = hsw__compute_basic__typed_bytes_written__read;
    counter->max_uint64 = hsw__compute_basic__typed_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Untyped Bytes Read";
    counter->symbol_name = "UntypedBytesRead";
    counter->desc = "The total number of typed memory bytes read via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = hsw__compute_basic__untyped_bytes_read__read;
    counter->max_uint64 = hsw__compute_basic__untyped_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Untyped Writes";
    counter->symbol_name = "UntypedBytesWritten";
    counter->desc = "The total number of untyped memory bytes written via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = hsw__compute_basic__untyped_bytes_written__read;
    counter->max_uint64 = hsw__compute_basic__untyped_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS EU Active";
    counter->symbol_name = "VsEuActive";
    counter->desc = "The percentage of time in which vertex shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__compute_basic__vs_eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS AVG Active per Thread";
    counter->symbol_name = "VsEuActivePerThread";
    counter->desc = "The average number of cycles per hardware thread run in which vertex shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__compute_basic__vs_eu_active_per_thread__read;
    counter->max_uint64 = percentage_max_callback_uint64;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS EU Stall";
    counter->symbol_name = "VsEuStall";
    counter->desc = "The percentage of time in which vertex shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__compute_basic__vs_eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS AVG Stall per Thread";
    counter->symbol_name = "VsEuStallPerThread";
    counter->desc = "The average number of cycles per hardware thread run in which vertex shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__compute_basic__vs_eu_stall_per_thread__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = hsw__compute_basic__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 52);
}

static void
hsw_add_compute_extended_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Compute Metrics Extended Gen7.5";
    metric_set->symbol_name = "ComputeExtended";
    metric_set->hw_config_guid = "480f9795-cf6a-4204-a9e3-cd7015515f8d";
    metric_set->counters = calloc(22, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A45_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->a_offset = 1;
    metric_set->b_offset = metric_set->a_offset + 45;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(18, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(20, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x0002681C, .val = 0x3EB00800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00026820, .val = 0x00900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00025384, .val = 0x02AAAAAA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00025404, .val = 0x03FFFFFF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00026800, .val = 0x00142284 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00026808, .val = 0x0E629062 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x0002680C, .val = 0x3F6F55CB };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00026810, .val = 0x00000014 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00026804, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00026104, .val = 0x02AAAAAA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00026184, .val = 0x02AAAAAA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00025420, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00025424, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x0002541C, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00025428, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0400000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091C4, .val = 0xE4500000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007FE2A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x0007FE6A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x0007FE92 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x0007FEA2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x0007FE32 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x0007FE9A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x0007FF23 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x0007FFF3 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000FFFE };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = hsw__compute_extended__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuTypedAtomics0";
    counter->symbol_name = "EuTypedAtomics0";
    counter->desc = "The subslice 0 EU Typed Atomics subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = hsw__compute_extended__eu_typed_atomics0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuTypedReads0";
    counter->symbol_name = "EuTypedReads0";
    counter->desc = "The subslice 0 EU Typed Reads subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = hsw__compute_extended__eu_typed_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuTypedWrites0";
    counter->symbol_name = "EuTypedWrites0";
    counter->desc = "The subslice 0 EU Typed Writes subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = hsw__compute_extended__eu_typed_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuUntypedAtomics0";
    counter->symbol_name = "EuUntypedAtomics0";
    counter->desc = "The subslice 0 EU Untyped Atomics subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = hsw__compute_extended__eu_untyped_atomics0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuUntypedReads0";
    counter->symbol_name = "EuUntypedReads0";
    counter->desc = "The subslice 0 EU Untyped Reads subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = hsw__compute_extended__eu_untyped_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuUntypedWrites0";
    counter->symbol_name = "EuUntypedWrites0";
    counter->desc = "The subslice 0 EU Untyped Writes subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = hsw__compute_extended__eu_untyped_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuUrbAtomics0";
    counter->symbol_name = "EuUrbAtomics0";
    counter->desc = "The subslice 0 EU URB Atomics subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = hsw__compute_extended__eu_urb_atomics0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__compute_extended__gpu_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = hsw__compute_extended__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "LLC GPU Accesses";
        counter->symbol_name = "LlcAccesses";
        counter->desc = "The total number of LLC cache lookups done from the GPU (64b reads, 32B writes).";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = hsw__compute_extended__llc_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "LLC");
    }

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "LLC GPU Hits";
        counter->symbol_name = "LlcHits";
        counter->desc = "The total number of successful LLC cache lookups done from the GPU.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = hsw__compute_extended__llc_hits__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "LLC");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Atomics 0";
    counter->symbol_name = "TypedAtomics0";
    counter->desc = "The subslice 0 typed atomics.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = hsw__compute_extended__typed_atomics0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TypedAtomicsPerCacheLine";
    counter->symbol_name = "TypedAtomicsPerCacheLine";
    counter->desc = "The ratio of EU typed atomics requests to L3 cache line writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
    counter->read_float = hsw__compute_extended__typed_atomics_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Reads 0";
    counter->symbol_name = "TypedReads0";
    counter->desc = "The subslice 0 typed reads.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = hsw__compute_extended__typed_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TypedReadsPerCacheLine";
    counter->symbol_name = "TypedReadsPerCacheLine";
    counter->desc = "The ratio of EU typed read requests to L3 cache line reads.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
    counter->read_float = hsw__compute_extended__typed_reads_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Writes 0";
    counter->symbol_name = "TypedWrites0";
    counter->desc = "The subslice 0 typed writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = hsw__compute_extended__typed_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TypedWritesPerCacheLine";
    counter->symbol_name = "TypedWritesPerCacheLine";
    counter->desc = "The ratio of EU typed write requests to L3 cache line writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
    counter->read_float = hsw__compute_extended__typed_writes_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Untyped Reads 0";
    counter->symbol_name = "UntypedReads0";
    counter->desc = "The subslice 0 untyped reads (including SLM reads).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = hsw__compute_extended__untyped_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "UntypedReadsPerCacheLine";
    counter->symbol_name = "UntypedReadsPerCacheLine";
    counter->desc = "The ratio of EU untyped read requests to L3 cache line reads.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
    counter->read_float = hsw__compute_extended__untyped_reads_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Untyped Writes 0";
    counter->symbol_name = "UntypedWrites0";
    counter->desc = "The subslice 0 untyped writes (including SLM writes).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = hsw__compute_extended__untyped_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "UntypedWritesPerCacheLine";
    counter->symbol_name = "UntypedWritesPerCacheLine";
    counter->desc = "The ratio of EU untyped write requests to L3 cache line writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
    counter->read_float = hsw__compute_extended__untyped_writes_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    assert(metric_set->n_counters <= 22);
}

static void
hsw_add_memory_reads_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Memory Reads Distribution Gen7.5";
    metric_set->symbol_name = "MemoryReads";
    metric_set->hw_config_guid = "399d3001-97d6-4240-b065-4fb843138e17";
    metric_set->counters = calloc(56, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A45_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->a_offset = 1;
    metric_set->b_offset = metric_set->a_offset + 45;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(21, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(28, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000253A4, .val = 0x34300000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00025440, .val = 0x2D800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00025444, .val = 0x00000008 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00025128, .val = 0x0E600000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00025380, .val = 0x00000450 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00025390, .val = 0x00052C43 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00025384, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00025400, .val = 0x00006144 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00025408, .val = 0x0A418820 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x0002540C, .val = 0x000820E6 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00025404, .val = 0xFF500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00025100, .val = 0x000005D6 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x0002510C, .val = 0x0EF00000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00025104, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00025420, .val = 0x02108421 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00025424, .val = 0x00008421 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x0002541C, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00025428, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0400000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091C4, .val = 0xE4500000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000274C, .val = 0x76543298 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002748, .val = 0x98989898 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x000000E4 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000275C, .val = 0x98A98A98 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002758, .val = 0x88888888 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002754, .val = 0x000C5500 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002750, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007F81A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FC00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x0007F82A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FC00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x0007F872 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FC00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x0007F8BA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FC00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x0007F87A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FC00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x0007F8EA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FC00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x0007F8E2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FC00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x0007F8F2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000FC00 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Alpha Test Fails";
    counter->symbol_name = "AlphaTestFails";
    counter->desc = "The total number of pixels dropped on post-FS alpha test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = hsw__memory_reads__alpha_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = hsw__memory_reads__avg_gpu_core_frequency__read;
    counter->max_uint64 = hsw__memory_reads__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS EU Active";
    counter->symbol_name = "CsEuActive";
    counter->desc = "The percentage of time in which compute shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__memory_reads__cs_eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS AVG Active per Thread";
    counter->symbol_name = "CsEuActivePerThread";
    counter->desc = "The average number of cycles per hardware thread run in which compute shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__memory_reads__cs_eu_active_per_thread__read;
    counter->max_uint64 = percentage_max_callback_uint64;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS EU Stall";
    counter->symbol_name = "CsEuStall";
    counter->desc = "The percentage of time in which compute shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__memory_reads__cs_eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS AVG Stall per Thread";
    counter->symbol_name = "CsEuStallPerThread";
    counter->desc = "The average number of cycles per hardware thread run in which compute shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__memory_reads__cs_eu_stall_per_thread__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = hsw__memory_reads__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TES EU Active";
    counter->symbol_name = "DsEuActive";
    counter->desc = "The percentage of time in which evaluation shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__memory_reads__ds_eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Evaluation Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TES AVG Active per Thread";
    counter->symbol_name = "DsEuActivePerThread";
    counter->desc = "The average number of cycles per hardware thread run in which evaluation shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__memory_reads__ds_eu_active_per_thread__read;
    counter->max_uint64 = percentage_max_callback_uint64;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Evaluation Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TES EU Stall";
    counter->symbol_name = "DsEuStall";
    counter->desc = "The percentage of time in which evaluation shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__memory_reads__ds_eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Evaluation Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TES AVG Stall per Thread";
    counter->symbol_name = "DsEuStallPerThread";
    counter->desc = "The average number of cycles per hardware thread run in which evaluation shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__memory_reads__ds_eu_stall_per_thread__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Evaluation Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TES Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of evaluation shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = hsw__memory_reads__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Evaluation Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = hsw__memory_reads__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__memory_reads__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__memory_reads__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has being processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__memory_reads__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__memory_reads__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = hsw__memory_reads__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS EU Active";
    counter->symbol_name = "GsEuActive";
    counter->desc = "The percentage of time in which geometry shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__memory_reads__gs_eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS AVG Active per Thread";
    counter->symbol_name = "GsEuActivePerThread";
    counter->desc = "The average number of cycles per hardware thread run in which geometry shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__memory_reads__gs_eu_active_per_thread__read;
    counter->max_uint64 = percentage_max_callback_uint64;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS EU Stall";
    counter->symbol_name = "GsEuStall";
    counter->desc = "The percentage of time in which geometry shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__memory_reads__gs_eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS AVG Stall per Thread";
    counter->symbol_name = "GsEuStallPerThread";
    counter->desc = "The average number of cycles per hardware thread run in which geometry shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__memory_reads__gs_eu_stall_per_thread__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = hsw__memory_reads__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiCmdStreamerMemoryReads";
    counter->symbol_name = "GtiCmdStreamerMemoryReads";
    counter->desc = "The total number of GTI memory reads from Command Streamer.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = hsw__memory_reads__gti_cmd_streamer_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Command Streamer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiHiDepthMemoryReads";
    counter->symbol_name = "GtiHiDepthMemoryReads";
    counter->desc = "The total number of GTI memory reads from Hierarchical Depth Cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = hsw__memory_reads__gti_hi_depth_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Reads";
    counter->symbol_name = "GtiL3Reads";
    counter->desc = "The total number of GTI memory reads from L3 (L3 misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = hsw__memory_reads__gti_l3_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiMemoryReads";
    counter->symbol_name = "GtiMemoryReads";
    counter->desc = "The total number of GTI memory reads (64B each).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = hsw__memory_reads__gti_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiMscMemoryReads";
    counter->symbol_name = "GtiMscMemoryReads";
    counter->desc = "The total number of GTI memory reads from Multisampling Color Cache (Multisampling Color Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = hsw__memory_reads__gti_msc_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRccMemoryReads";
    counter->symbol_name = "GtiRccMemoryReads";
    counter->desc = "The total number of GTI memory reads from Render Color Cache (Render Color Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = hsw__memory_reads__gti_rcc_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRczMemoryReads";
    counter->symbol_name = "GtiRczMemoryReads";
    counter->desc = "The total number of GTI memory reads from Render Depth Cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = hsw__memory_reads__gti_rcz_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRsMemoryReads";
    counter->symbol_name = "GtiRsMemoryReads";
    counter->desc = "The total number of GTI memory reads from Resource Streamer.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = hsw__memory_reads__gti_rs_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Resource Streamer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiStcMemoryReads";
    counter->symbol_name = "GtiStcMemoryReads";
    counter->desc = "The total number of GTI memory reads from Stencil Cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = hsw__memory_reads__gti_stc_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiVfMemoryReads";
    counter->symbol_name = "GtiVfMemoryReads";
    counter->desc = "The total number of GTI memory reads from Vertex Fetch.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = hsw__memory_reads__gti_vf_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Vertex Fetch");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = hsw__memory_reads__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TCS EU Active";
    counter->symbol_name = "HsEuActive";
    counter->desc = "The percentage of time in which control shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__memory_reads__hs_eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Control Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TCS AVG Active per Thread";
    counter->symbol_name = "HsEuActivePerThread";
    counter->desc = "The average number of cycles per hardware thread run in which control shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__memory_reads__hs_eu_active_per_thread__read;
    counter->max_uint64 = percentage_max_callback_uint64;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Control Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TCS EU Stall";
    counter->symbol_name = "HsEuStall";
    counter->desc = "The percentage of time in which control shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__memory_reads__hs_eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Control Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TCS AVG Stall per Thread";
    counter->symbol_name = "HsEuStallPerThread";
    counter->desc = "The average number of cycles per hardware thread run in which control shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__memory_reads__hs_eu_stall_per_thread__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Control Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TCS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of control shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = hsw__memory_reads__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Control Shader");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "LLC GPU Accesses";
        counter->symbol_name = "LlcAccesses";
        counter->desc = "The total number of LLC cache lookups done from the GPU (64b reads, 32B writes).";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = hsw__memory_reads__llc_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "LLC");
    }

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "LLC GPU Hits";
        counter->symbol_name = "LlcHits";
        counter->desc = "The total number of successful LLC cache lookups done from the GPU.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = hsw__memory_reads__llc_hits__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "LLC");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "LLC GPU Read Accesses";
    counter->symbol_name = "LlcReadAccesses";
    counter->desc = "The total number of LLC cache lookups for reads done from the GPU.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = hsw__memory_reads__llc_read_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "LLC");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Late Depth Test Fails";
    counter->symbol_name = "PostPsDepthTestFails";
    counter->desc = "The total number of pixels dropped on post-FS depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = hsw__memory_reads__post_ps_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Late Stencil Test Fails";
    counter->symbol_name = "PostPsStencilTestFails";
    counter->desc = "The total number of pixels dropped on post-FS stencil test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = hsw__memory_reads__post_ps_stencil_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS EU Active";
    counter->symbol_name = "PsEuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__memory_reads__ps_eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS AVG Active per Thread";
    counter->symbol_name = "PsEuActivePerThread";
    counter->desc = "The average number of cycles per hardware thread run in which fragment shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__memory_reads__ps_eu_active_per_thread__read;
    counter->max_uint64 = percentage_max_callback_uint64;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS EU Stall";
    counter->symbol_name = "PsEuStall";
    counter->desc = "The percentage of time in which fragment shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__memory_reads__ps_eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS AVG Stall per Thread";
    counter->symbol_name = "PsEuStallPerThread";
    counter->desc = "The average number of cycles per hardware thread run in which fragment shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__memory_reads__ps_eu_stall_per_thread__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = hsw__memory_reads__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = hsw__memory_reads__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = hsw__memory_reads__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS EU Active";
    counter->symbol_name = "VsEuActive";
    counter->desc = "The percentage of time in which vertex shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__memory_reads__vs_eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS AVG Active per Thread";
    counter->symbol_name = "VsEuActivePerThread";
    counter->desc = "The average number of cycles per hardware thread run in which vertex shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__memory_reads__vs_eu_active_per_thread__read;
    counter->max_uint64 = percentage_max_callback_uint64;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS EU Stall";
    counter->symbol_name = "VsEuStall";
    counter->desc = "The percentage of time in which vertex shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__memory_reads__vs_eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS AVG Stall per Thread";
    counter->symbol_name = "VsEuStallPerThread";
    counter->desc = "The average number of cycles per hardware thread run in which vertex shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__memory_reads__vs_eu_stall_per_thread__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = hsw__memory_reads__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 56);
}

static void
hsw_add_memory_writes_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Memory Writes Distribution Gen7.5";
    metric_set->symbol_name = "MemoryWrites";
    metric_set->hw_config_guid = "f3c1ff4b-d0da-4ffa-8780-2c6b98f3f2d5";
    metric_set->counters = calloc(56, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A45_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->a_offset = 1;
    metric_set->b_offset = metric_set->a_offset + 45;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(21, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(28, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000253A4, .val = 0x34300000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00025440, .val = 0x01500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00025444, .val = 0x00000120 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00025128, .val = 0x0C200000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00025380, .val = 0x00000450 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00025390, .val = 0x00052C43 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00025384, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00025400, .val = 0x00007184 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00025408, .val = 0x0A418820 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x0002540C, .val = 0x000820E6 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00025404, .val = 0xFF500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00025100, .val = 0x000005D6 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x0002510C, .val = 0x1E700000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00025104, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00025420, .val = 0x02108421 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00025424, .val = 0x00008421 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x0002541C, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00025428, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0400000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091C4, .val = 0xE4500000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000274C, .val = 0x76543298 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002748, .val = 0x98989898 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x000000E4 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000275C, .val = 0xBABABABA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002758, .val = 0x88888888 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002754, .val = 0x000C5500 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002750, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007F81A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FC00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x0007F82A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FC00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x0007F822 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FC00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x0007F8BA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FC00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x0007F87A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FC00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x0007F8EA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FC00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x0007F8E2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FC00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x0007F8F2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000FC00 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Alpha Test Fails";
    counter->symbol_name = "AlphaTestFails";
    counter->desc = "The total number of pixels dropped on post-FS alpha test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = hsw__memory_writes__alpha_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = hsw__memory_writes__avg_gpu_core_frequency__read;
    counter->max_uint64 = hsw__memory_writes__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS EU Active";
    counter->symbol_name = "CsEuActive";
    counter->desc = "The percentage of time in which compute shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__memory_writes__cs_eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS AVG Active per Thread";
    counter->symbol_name = "CsEuActivePerThread";
    counter->desc = "The average number of cycles per hardware thread run in which compute shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__memory_writes__cs_eu_active_per_thread__read;
    counter->max_uint64 = percentage_max_callback_uint64;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS EU Stall";
    counter->symbol_name = "CsEuStall";
    counter->desc = "The percentage of time in which compute shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__memory_writes__cs_eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS AVG Stall per Thread";
    counter->symbol_name = "CsEuStallPerThread";
    counter->desc = "The average number of cycles per hardware thread run in which compute shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__memory_writes__cs_eu_stall_per_thread__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = hsw__memory_writes__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TES EU Active";
    counter->symbol_name = "DsEuActive";
    counter->desc = "The percentage of time in which evaluation shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__memory_writes__ds_eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Evaluation Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TES AVG Active per Thread";
    counter->symbol_name = "DsEuActivePerThread";
    counter->desc = "The average number of cycles per hardware thread run in which evaluation shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__memory_writes__ds_eu_active_per_thread__read;
    counter->max_uint64 = percentage_max_callback_uint64;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Evaluation Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TES EU Stall";
    counter->symbol_name = "DsEuStall";
    counter->desc = "The percentage of time in which evaluation shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__memory_writes__ds_eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Evaluation Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TES AVG Stall per Thread";
    counter->symbol_name = "DsEuStallPerThread";
    counter->desc = "The average number of cycles per hardware thread run in which evaluation shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__memory_writes__ds_eu_stall_per_thread__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Evaluation Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TES Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of evaluation shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = hsw__memory_writes__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Evaluation Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = hsw__memory_writes__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__memory_writes__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__memory_writes__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has being processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__memory_writes__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__memory_writes__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = hsw__memory_writes__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS EU Active";
    counter->symbol_name = "GsEuActive";
    counter->desc = "The percentage of time in which geometry shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__memory_writes__gs_eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS AVG Active per Thread";
    counter->symbol_name = "GsEuActivePerThread";
    counter->desc = "The average number of cycles per hardware thread run in which geometry shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__memory_writes__gs_eu_active_per_thread__read;
    counter->max_uint64 = percentage_max_callback_uint64;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS EU Stall";
    counter->symbol_name = "GsEuStall";
    counter->desc = "The percentage of time in which geometry shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__memory_writes__gs_eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS AVG Stall per Thread";
    counter->symbol_name = "GsEuStallPerThread";
    counter->desc = "The average number of cycles per hardware thread run in which geometry shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__memory_writes__gs_eu_stall_per_thread__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = hsw__memory_writes__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiCmdStreamerMemoryWrites";
    counter->symbol_name = "GtiCmdStreamerMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Command Streamer.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = hsw__memory_writes__gti_cmd_streamer_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Command Streamer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiHizMemoryWrites";
    counter->symbol_name = "GtiHizMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Hierarchical Depth Cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = hsw__memory_writes__gti_hiz_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Writes";
    counter->symbol_name = "GtiL3Writes";
    counter->desc = "The total number of GTI memory writes from L3 (L3 invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = hsw__memory_writes__gti_l3_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiMemoryWrites";
    counter->symbol_name = "GtiMemoryWrites";
    counter->desc = "The total number of GTI memory writes (64B each).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = hsw__memory_writes__gti_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiMscMemoryWrites";
    counter->symbol_name = "GtiMscMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Multisampling Color Cache (Multisampling Color Cache invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = hsw__memory_writes__gti_msc_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRccMemoryWrites";
    counter->symbol_name = "GtiRccMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Render Color Cache (Render Color Cache invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = hsw__memory_writes__gti_rcc_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRczMemoryWrites";
    counter->symbol_name = "GtiRczMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Render Depth Cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = hsw__memory_writes__gti_rcz_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiSoMemoryWrites";
    counter->symbol_name = "GtiSoMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Stream Output.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = hsw__memory_writes__gti_so_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Stream Output");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiStcMemoryWrites";
    counter->symbol_name = "GtiStcMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Stencil Cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = hsw__memory_writes__gti_stc_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = hsw__memory_writes__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TCS EU Active";
    counter->symbol_name = "HsEuActive";
    counter->desc = "The percentage of time in which control shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__memory_writes__hs_eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Control Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TCS AVG Active per Thread";
    counter->symbol_name = "HsEuActivePerThread";
    counter->desc = "The average number of cycles per hardware thread run in which control shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__memory_writes__hs_eu_active_per_thread__read;
    counter->max_uint64 = percentage_max_callback_uint64;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Control Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TCS EU Stall";
    counter->symbol_name = "HsEuStall";
    counter->desc = "The percentage of time in which control shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__memory_writes__hs_eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Control Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TCS AVG Stall per Thread";
    counter->symbol_name = "HsEuStallPerThread";
    counter->desc = "The average number of cycles per hardware thread run in which control shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__memory_writes__hs_eu_stall_per_thread__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Control Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TCS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of control shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = hsw__memory_writes__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Control Shader");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "LLC GPU Accesses";
        counter->symbol_name = "LlcAccesses";
        counter->desc = "The total number of LLC cache lookups done from the GPU (64b reads, 32B writes).";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = hsw__memory_writes__llc_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "LLC");
    }

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "LLC GPU Throughput";
        counter->symbol_name = "LlcGpuThroughput";
        counter->desc = "The total number of GPU memory bytes transferred between GPU and LLC.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
        counter->read_uint64 = hsw__memory_writes__llc_gpu_throughput__read;
        counter->max_uint64 = hsw__memory_writes__llc_gpu_throughput__max;
        intel_perf_add_logical_counter(perf, counter, "LLC");
    }

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "LLC GPU Hits";
        counter->symbol_name = "LlcHits";
        counter->desc = "The total number of successful LLC cache lookups done from the GPU.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = hsw__memory_writes__llc_hits__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "LLC");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "LLC GPU Write Accesses";
    counter->symbol_name = "LlcWrAccesses";
    counter->desc = "The total number of LLC cache lookups for write done from the GPU (32B writes).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = hsw__memory_writes__llc_wr_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "LLC");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Late Depth Test Fails";
    counter->symbol_name = "PostPsDepthTestFails";
    counter->desc = "The total number of pixels dropped on post-FS depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = hsw__memory_writes__post_ps_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Late Stencil Test Fails";
    counter->symbol_name = "PostPsStencilTestFails";
    counter->desc = "The total number of pixels dropped on post-FS stencil test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = hsw__memory_writes__post_ps_stencil_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS EU Active";
    counter->symbol_name = "PsEuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__memory_writes__ps_eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS AVG Active per Thread";
    counter->symbol_name = "PsEuActivePerThread";
    counter->desc = "The average number of cycles per hardware thread run in which fragment shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__memory_writes__ps_eu_active_per_thread__read;
    counter->max_uint64 = percentage_max_callback_uint64;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS EU Stall";
    counter->symbol_name = "PsEuStall";
    counter->desc = "The percentage of time in which fragment shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__memory_writes__ps_eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS AVG Stall per Thread";
    counter->symbol_name = "PsEuStallPerThread";
    counter->desc = "The average number of cycles per hardware thread run in which fragment shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__memory_writes__ps_eu_stall_per_thread__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = hsw__memory_writes__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = hsw__memory_writes__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = hsw__memory_writes__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS EU Active";
    counter->symbol_name = "VsEuActive";
    counter->desc = "The percentage of time in which vertex shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__memory_writes__vs_eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS AVG Active per Thread";
    counter->symbol_name = "VsEuActivePerThread";
    counter->desc = "The average number of cycles per hardware thread run in which vertex shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__memory_writes__vs_eu_active_per_thread__read;
    counter->max_uint64 = percentage_max_callback_uint64;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS EU Stall";
    counter->symbol_name = "VsEuStall";
    counter->desc = "The percentage of time in which vertex shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__memory_writes__vs_eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS AVG Stall per Thread";
    counter->symbol_name = "VsEuStallPerThread";
    counter->desc = "The average number of cycles per hardware thread run in which vertex shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__memory_writes__vs_eu_stall_per_thread__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = hsw__memory_writes__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 56);
}

static void
hsw_add_sampler_balance_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set SamplerBalance";
    metric_set->symbol_name = "SamplerBalance";
    metric_set->hw_config_guid = "e111cda4-19c3-41ee-b326-f99ac44ebf78";
    metric_set->counters = calloc(57, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A45_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->a_offset = 1;
    metric_set->b_offset = metric_set->a_offset + 45;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(43, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(6, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x0002EB9C, .val = 0x01906400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x0002FB9C, .val = 0x01906400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000253A4, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00026B9C, .val = 0x01906400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00027B9C, .val = 0x01906400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00027104, .val = 0x00A00000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00027184, .val = 0x00A50000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x0002E804, .val = 0x00500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x0002E984, .val = 0x00500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x0002EB04, .val = 0x00500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x0002EB80, .val = 0x00000084 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x0002EB8C, .val = 0x14200000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x0002EB84, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x0002F804, .val = 0x00050000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x0002F984, .val = 0x00050000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x0002FB04, .val = 0x00050000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x0002FB80, .val = 0x00000084 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x0002FB8C, .val = 0x00050800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x0002FB84, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00025380, .val = 0x00000010 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x0002538C, .val = 0x000000C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00025384, .val = 0xAA550000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00025404, .val = 0xFFFFC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00026804, .val = 0x50000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00026984, .val = 0x50000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00026B04, .val = 0x50000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00026B80, .val = 0x00000084 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00026B90, .val = 0x00050800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00026B84, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00027804, .val = 0x05000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00027984, .val = 0x05000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00027B04, .val = 0x05000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00027B80, .val = 0x00000084 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00027B90, .val = 0x00000142 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00027B84, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00026104, .val = 0xA0000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00026184, .val = 0xA5000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00025424, .val = 0x00008620 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x0002541C, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00025428, .val = 0x0004A54A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0400000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091C4, .val = 0xE4500000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Alpha Test Fails";
    counter->symbol_name = "AlphaTestFails";
    counter->desc = "The total number of pixels dropped on post-FS alpha test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = hsw__sampler_balance__alpha_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = hsw__sampler_balance__avg_gpu_core_frequency__read;
    counter->max_uint64 = hsw__sampler_balance__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Duration";
    counter->symbol_name = "CsDuration";
    counter->desc = "Total Compute Shader GPU duration.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_US;
    counter->read_uint64 = hsw__sampler_balance__cs_duration__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS EU Active";
    counter->symbol_name = "CsEuActive";
    counter->desc = "The percentage of time in which compute shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__sampler_balance__cs_eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS AVG Active per Thread";
    counter->symbol_name = "CsEuActivePerThread";
    counter->desc = "The average number of cycles per hardware thread run in which compute shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__sampler_balance__cs_eu_active_per_thread__read;
    counter->max_uint64 = percentage_max_callback_uint64;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS EU Stall";
    counter->symbol_name = "CsEuStall";
    counter->desc = "The percentage of time in which compute shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__sampler_balance__cs_eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS AVG Stall per Thread";
    counter->symbol_name = "CsEuStallPerThread";
    counter->desc = "The average number of cycles per hardware thread run in which compute shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__sampler_balance__cs_eu_stall_per_thread__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = hsw__sampler_balance__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TES Duration";
    counter->symbol_name = "DsDuration";
    counter->desc = "Total Evaluation Shader GPU duration.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_US;
    counter->read_uint64 = hsw__sampler_balance__ds_duration__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Evaluation Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TES EU Active";
    counter->symbol_name = "DsEuActive";
    counter->desc = "The percentage of time in which evaluation shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__sampler_balance__ds_eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Evaluation Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TES AVG Active per Thread";
    counter->symbol_name = "DsEuActivePerThread";
    counter->desc = "The average number of cycles per hardware thread run in which evaluation shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__sampler_balance__ds_eu_active_per_thread__read;
    counter->max_uint64 = percentage_max_callback_uint64;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Evaluation Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TES EU Stall";
    counter->symbol_name = "DsEuStall";
    counter->desc = "The percentage of time in which evaluation shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__sampler_balance__ds_eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Evaluation Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TES AVG Stall per Thread";
    counter->symbol_name = "DsEuStallPerThread";
    counter->desc = "The average number of cycles per hardware thread run in which evaluation shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__sampler_balance__ds_eu_stall_per_thread__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Evaluation Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TES Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of evaluation shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = hsw__sampler_balance__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Evaluation Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = hsw__sampler_balance__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__sampler_balance__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Idle";
    counter->symbol_name = "EuIdle";
    counter->desc = "The percentage of time in which the Execution Units were idle.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__sampler_balance__eu_idle__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__sampler_balance__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has being processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__sampler_balance__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__sampler_balance__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = hsw__sampler_balance__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Duration";
    counter->symbol_name = "GsDuration";
    counter->desc = "Total Geometry Shader GPU duration.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_US;
    counter->read_uint64 = hsw__sampler_balance__gs_duration__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS EU Active";
    counter->symbol_name = "GsEuActive";
    counter->desc = "The percentage of time in which geometry shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__sampler_balance__gs_eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS AVG Active per Thread";
    counter->symbol_name = "GsEuActivePerThread";
    counter->desc = "The average number of cycles per hardware thread run in which geometry shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__sampler_balance__gs_eu_active_per_thread__read;
    counter->max_uint64 = percentage_max_callback_uint64;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS EU Stall";
    counter->symbol_name = "GsEuStall";
    counter->desc = "The percentage of time in which geometry shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__sampler_balance__gs_eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS AVG Stall per Thread";
    counter->symbol_name = "GsEuStallPerThread";
    counter->desc = "The average number of cycles per hardware thread run in which geometry shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__sampler_balance__gs_eu_stall_per_thread__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = hsw__sampler_balance__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = hsw__sampler_balance__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TCS Duration";
    counter->symbol_name = "HsDuration";
    counter->desc = "Total Control Shader GPU duration.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_US;
    counter->read_uint64 = hsw__sampler_balance__hs_duration__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Control Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TCS EU Active";
    counter->symbol_name = "HsEuActive";
    counter->desc = "The percentage of time in which control shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__sampler_balance__hs_eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Control Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TCS AVG Active per Thread";
    counter->symbol_name = "HsEuActivePerThread";
    counter->desc = "The average number of cycles per hardware thread run in which control shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__sampler_balance__hs_eu_active_per_thread__read;
    counter->max_uint64 = percentage_max_callback_uint64;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Control Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TCS EU Stall";
    counter->symbol_name = "HsEuStall";
    counter->desc = "The percentage of time in which control shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__sampler_balance__hs_eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Control Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TCS AVG Stall per Thread";
    counter->symbol_name = "HsEuStallPerThread";
    counter->desc = "The average number of cycles per hardware thread run in which control shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__sampler_balance__hs_eu_stall_per_thread__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Control Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TCS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of control shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = hsw__sampler_balance__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Control Shader");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "LLC GPU Accesses";
        counter->symbol_name = "LlcAccesses";
        counter->desc = "The total number of LLC cache lookups done from the GPU (64b reads, 32B writes).";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = hsw__sampler_balance__llc_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "LLC");
    }

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "LLC GPU Hits";
        counter->symbol_name = "LlcHits";
        counter->desc = "The total number of successful LLC cache lookups done from the GPU.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = hsw__sampler_balance__llc_hits__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "LLC");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Late Depth Test Fails";
    counter->symbol_name = "PostPsDepthTestFails";
    counter->desc = "The total number of pixels dropped on post-FS depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = hsw__sampler_balance__post_ps_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Late Stencil Test Fails";
    counter->symbol_name = "PostPsStencilTestFails";
    counter->desc = "The total number of pixels dropped on post-FS stencil test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = hsw__sampler_balance__post_ps_stencil_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Duration";
    counter->symbol_name = "PsDuration";
    counter->desc = "Total Fragment Shader GPU duration.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_US;
    counter->read_uint64 = hsw__sampler_balance__ps_duration__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS EU Active";
    counter->symbol_name = "PsEuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__sampler_balance__ps_eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS AVG Active per Thread";
    counter->symbol_name = "PsEuActivePerThread";
    counter->desc = "The average number of cycles per hardware thread run in which fragment shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__sampler_balance__ps_eu_active_per_thread__read;
    counter->max_uint64 = percentage_max_callback_uint64;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS EU Stall";
    counter->symbol_name = "PsEuStall";
    counter->desc = "The percentage of time in which fragment shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__sampler_balance__ps_eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS AVG Stall per Thread";
    counter->symbol_name = "PsEuStallPerThread";
    counter->desc = "The average number of cycles per hardware thread run in which fragment shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__sampler_balance__ps_eu_stall_per_thread__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = hsw__sampler_balance__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Sampler L2 cache misses (ss0)";
        counter->symbol_name = "Sampler0L2CacheMisses";
        counter->desc = "Number of sampler L2 cache misses (ss0)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = hsw__sampler_balance__sampler0_l2_cache_misses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Sampler L2 cache misses (ss1)";
        counter->symbol_name = "Sampler1L2CacheMisses";
        counter->desc = "Number of sampler L2 cache misses (ss1)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = hsw__sampler_balance__sampler1_l2_cache_misses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Sampler L2 cache misses (ss2)";
        counter->symbol_name = "Sampler2L2CacheMisses";
        counter->desc = "Number of sampler L2 cache misses (ss2)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = hsw__sampler_balance__sampler2_l2_cache_misses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");
    }

    if (perf->devinfo.subslice_mask & 0x8) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Sampler L2 cache misses (ss3)";
        counter->symbol_name = "Sampler3L2CacheMisses";
        counter->desc = "Number of sampler L2 cache misses (ss3)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = hsw__sampler_balance__sampler3_l2_cache_misses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler L2 cache misses";
    counter->symbol_name = "SamplerL2CacheMisses";
    counter->desc = "Number of sampler L2 cache misses";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = hsw__sampler_balance__sampler_l2_cache_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = hsw__sampler_balance__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = hsw__sampler_balance__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Duration";
    counter->symbol_name = "VsDuration";
    counter->desc = "Total Vertex Shader GPU duration.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_US;
    counter->read_uint64 = hsw__sampler_balance__vs_duration__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS EU Active";
    counter->symbol_name = "VsEuActive";
    counter->desc = "The percentage of time in which vertex shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__sampler_balance__vs_eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS AVG Active per Thread";
    counter->symbol_name = "VsEuActivePerThread";
    counter->desc = "The average number of cycles per hardware thread run in which vertex shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__sampler_balance__vs_eu_active_per_thread__read;
    counter->max_uint64 = percentage_max_callback_uint64;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS EU Stall";
    counter->symbol_name = "VsEuStall";
    counter->desc = "The percentage of time in which vertex shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = hsw__sampler_balance__vs_eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS AVG Stall per Thread";
    counter->symbol_name = "VsEuStallPerThread";
    counter->desc = "The average number of cycles per hardware thread run in which vertex shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = hsw__sampler_balance__vs_eu_stall_per_thread__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = hsw__sampler_balance__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 57);
}

static void
bdw_add_render_basic_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Render Metrics Basic Gen8";
    metric_set->symbol_name = "RenderBasic";
    metric_set->hw_config_guid = "b541bd57-0e0f-4154-b4c0-5858010a2bf7";
    metric_set->counters = calloc(52, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(219, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(5, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    if (perf->devinfo.slice_mask & 0x01) {
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x143F000F };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14110014 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14310014 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14BF000F };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x118A0317 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13837BE0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3B800060 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3D800005 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x005C4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x065C8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x085CC000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x003D8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x183D0800 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A3F0023 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x103F0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00584000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08584000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A5A4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x005B4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E5B8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x185B2400 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1D4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1F0800 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1FAA00 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00384000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E384000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16384000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18380001 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00392000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06398000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0839A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A391000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00104000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08104000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00110030 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08110031 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10110000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00134000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16130020 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06308000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08308000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06311800 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08311880 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10310000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E334000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16330080 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0ABF1180 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10BF0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0ADA8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A9D8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x109F0002 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AB94000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D888000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038A0380 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058A000E };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x018A8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8A8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x198A8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B8A00A0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x078A0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x098A0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x238B2820 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x258B2550 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x198C1000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B8D8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F85AA80 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2185AAA0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2385002A };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D831021 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F83572F };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01835680 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0383002C };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11830000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19835400 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B830001 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05830000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0184C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07848000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0984C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B84C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D84C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F84C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0384C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05844000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B80C137 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D80C147 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1180C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17808000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1980C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F80C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1380C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15804000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D801110 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4F800331 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43800802 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45801465 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53801111 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x478014A5 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F800CA5 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41800003 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    }

    if (perf->devinfo.slice_mask & 0x02) {
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x143F000F };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14BF000F };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14910014 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14B10014 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x118A0317 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13837BE0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3B800060 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3D800005 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A3F0023 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x103F0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A5A4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1D4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1F8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A391000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00DC4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06DC8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08DCC000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00BD8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18BD0800 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0ABF1180 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10BF0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00D84000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08D84000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0ADA8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00DB4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EDB8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18DB2400 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A9D8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C9F0800 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E9F2A00 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x109F0002 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00B84000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EB84000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16B84000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18B80001 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00B92000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06B98000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08B9A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AB94000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00904000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08904000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00910030 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08910031 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10910000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00934000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16930020 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06B08000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08B08000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06B11800 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08B11880 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10B10000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EB34000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16B30080 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01888000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D88B800 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038A0380 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058A000E };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B8A0080 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x078A0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x098A0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x238B2840 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x258B26A0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x018C4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8C4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x178C2000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x198C1100 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x018D2000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x078D8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x098DA000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B8D8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F85AA80 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2185AAA0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2385002A };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D831021 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F83572F };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01835680 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0383002C };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11830000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19835400 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B830001 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05830000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0184C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07848000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0984C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B84C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D84C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F84C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0384C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05844000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B80C137 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D80C147 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1180C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17808000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1980C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F80C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1380C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15804000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D801550 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4F800331 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43800802 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51800400 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x458004A1 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53805555 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47800421 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F801421 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41800845 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    }

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = bdw__render_basic__avg_gpu_core_frequency__read;
    counter->max_uint64 = bdw__render_basic__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__render_basic__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__render_basic__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__render_basic__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__render_basic__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__render_basic__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__render_basic__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__render_basic__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = bdw__render_basic__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = bdw__render_basic__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__render_basic__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Depth Throughput";
    counter->symbol_name = "GtiDepthThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between depth caches and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__render_basic__gti_depth_throughput__read;
    counter->max_uint64 = bdw__render_basic__gti_depth_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI HDC TLB Lookup Throughput";
    counter->symbol_name = "GtiHdcLookupsThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between GTI and HDC, when HDC is doing TLB lookups.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__render_basic__gti_hdc_lookups_throughput__read;
    counter->max_uint64 = bdw__render_basic__gti_hdc_lookups_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI L3 Throughput";
    counter->symbol_name = "GtiL3Throughput";
    counter->desc = "The total number of GPU memory bytes transferred between L3 caches and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__render_basic__gti_l3_throughput__read;
    counter->max_uint64 = bdw__render_basic__gti_l3_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI RCC Throughput";
    counter->symbol_name = "GtiRccThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between render color caches and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__render_basic__gti_rcc_throughput__read;
    counter->max_uint64 = bdw__render_basic__gti_rcc_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Read Throughput";
    counter->symbol_name = "GtiReadThroughput";
    counter->desc = "The total number of GPU memory bytes read from GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__render_basic__gti_read_throughput__read;
    counter->max_uint64 = bdw__render_basic__gti_read_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Fixed Pipe Throughput";
    counter->symbol_name = "GtiVfThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between 3D Pipeline (Command Dispatch, Input Assembly and Stream Output) and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__render_basic__gti_vf_throughput__read;
    counter->max_uint64 = bdw__render_basic__gti_vf_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Write Throughput";
    counter->symbol_name = "GtiWriteThroughput";
    counter->desc = "The total number of GPU memory bytes written to GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__render_basic__gti_write_throughput__read;
    counter->max_uint64 = bdw__render_basic__gti_write_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__render_basic__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__render_basic__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Lookup Accesses w/o IC";
    counter->symbol_name = "L3Lookups";
    counter->desc = "The total number of L3 cache lookup accesses w/o IC.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__render_basic__l3_lookups__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/TAG");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Misses";
    counter->symbol_name = "L3Misses";
    counter->desc = "The total number of L3 misses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__render_basic__l3_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/TAG");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Sampler Throughput";
    counter->symbol_name = "L3SamplerThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between samplers and L3 caches.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__render_basic__l3_sampler_throughput__read;
    counter->max_uint64 = bdw__render_basic__l3_sampler_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__render_basic__l3_shader_throughput__read;
    counter->max_uint64 = bdw__render_basic__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__render_basic__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__render_basic__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__render_basic__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__render_basic__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__render_basic__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__render_basic__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__render_basic__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    if (perf->devinfo.subslice_mask & 0x09) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Sampler 0 Bottleneck";
        counter->symbol_name = "Sampler0Bottleneck";
        counter->desc = "The percentage of time in which Sampler 0 has been slowing down the pipe when processing EU requests.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__render_basic__sampler0_bottleneck__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x09) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Sampler 0 Busy";
        counter->symbol_name = "Sampler0Busy";
        counter->desc = "The percentage of time in which Sampler 0 has been processing EU requests.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__render_basic__sampler0_busy__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x12) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Sampler 1 Bottleneck";
        counter->symbol_name = "Sampler1Bottleneck";
        counter->desc = "The percentage of time in which Sampler 1 has been slowing down the pipe when processing EU requests.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__render_basic__sampler1_bottleneck__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x12) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Sampler 1 Busy";
        counter->symbol_name = "Sampler1Busy";
        counter->desc = "The percentage of time in which Sampler 1 has been processing EU requests.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__render_basic__sampler1_busy__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samplers Bottleneck";
    counter->symbol_name = "SamplerBottleneck";
    counter->desc = "The percentage of time in which samplers have been slowing down the pipe when processing EU requests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__render_basic__sampler_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Cache Misses";
    counter->symbol_name = "SamplerL1Misses";
    counter->desc = "The total number of sampler cache misses in all LODs in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__render_basic__sampler_l1_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bdw__render_basic__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bdw__render_basic__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samplers Busy";
    counter->symbol_name = "SamplersBusy";
    counter->desc = "The percentage of time in which samplers have been processing EU requests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__render_basic__samplers_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__render_basic__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__render_basic__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__render_basic__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__render_basic__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__render_basic__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__render_basic__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__render_basic__slm_bytes_read__read;
    counter->max_uint64 = bdw__render_basic__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__render_basic__slm_bytes_written__read;
    counter->max_uint64 = bdw__render_basic__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__render_basic__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__render_basic__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__render_basic__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__render_basic__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 52);
}

static void
bdw_add_compute_basic_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Compute Metrics Basic Gen8";
    metric_set->symbol_name = "ComputeBasic";
    metric_set->hw_config_guid = "35fbc9b2-a891-40a6-a38d-022bb7057552";
    metric_set->counters = calloc(39, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(182, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(5, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    if (perf->devinfo.slice_mask & 0x01) {
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x105C00E0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x105800E0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x103800E0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3580001A };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3B800060 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3D800005 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x065C2100 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A5C0041 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C5C6600 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x005C6580 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x085C8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E5C8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00580042 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08582080 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C58004C };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E582580 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x005B4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x185B1000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A5B0104 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1FA800 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1FAA00 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x101F02AA };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08380042 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A382080 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E38404C };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0238404B };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00384000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16380000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18381145 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04380000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0039A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06398000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0839A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A39A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C39A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E39A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02392000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x018A8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8A8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x198A8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B8AAAA0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D8A0002 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038A8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058A8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x238B02A0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x258B5550 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x278B0015 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F850A80 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2185AAA0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2385002A };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19835400 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B830155 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0184C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07848000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0984C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B84C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D84C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F84C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03844000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17808137 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1980C147 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B80C0E5 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D80C0E3 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1180C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F80C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13804000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D24, .val = 0x00000000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D801000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4F800111 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43800062 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45800062 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47800062 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F801062 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41801084 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    }

    if (perf->devinfo.slice_mask & 0x02) {
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10DC00E0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10D800E0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10B800E0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3580001A };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3B800060 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3D800005 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06DC2100 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0ADC0041 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CDC6600 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00DC6580 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08DC8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EDC8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00D80042 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08D82080 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CD8004C };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0ED82580 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00DB4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18DB1000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1ADB0104 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C9FA800 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E9FAA00 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x109F02AA };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08B80042 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AB82080 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EB8404C };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02B8404B };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00B84000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16B80000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18B81145 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04B80000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00B9A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06B98000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08B9A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AB9A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CB9A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EB9A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02B92000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01888000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D88F800 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F88000F };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03888000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05888000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x238B0540 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x258BAAA0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x278B002A };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x018C4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8C4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x178C2000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x198C5500 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B8C0015 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038C4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058C4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x018DA000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x078D8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x098DA000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B8DA000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D8DA000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8DA000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038D2000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F850A80 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2185AAA0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2385002A };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19835400 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B830155 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0184C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07848000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0984C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B84C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D84C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F84C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03844000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17808137 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1980C147 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B80C0E5 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D80C0E3 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1180C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F80C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13804000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D24, .val = 0x00000000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D805000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4F800555 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43800062 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45800062 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47800062 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F800062 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    }

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00000003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00002001 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00778008 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00088078 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00808708 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00A08908 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = bdw__compute_basic__avg_gpu_core_frequency__read;
    counter->max_uint64 = bdw__compute_basic__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__compute_basic__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__compute_basic__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__compute_basic__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__compute_basic__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU AVG IPC Rate";
    counter->symbol_name = "EuAvgIpcRate";
    counter->desc = "The average rate of IPC calculated for 2 FPU pipelines.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NUMBER;
    counter->read_float = bdw__compute_basic__eu_avg_ipc_rate__read;
    counter->max_float = bdw__compute_basic__eu_avg_ipc_rate__max;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__compute_basic__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Send Pipe Active";
    counter->symbol_name = "EuSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__compute_basic__eu_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__compute_basic__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Thread Occupancy";
    counter->symbol_name = "EuThreadOccupancy";
    counter->desc = "The percentage of time in which hardware threads occupied EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__compute_basic__eu_thread_occupancy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Pipe Active";
    counter->symbol_name = "Fpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__compute_basic__fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active";
    counter->symbol_name = "Fpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__compute_basic__fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__compute_basic__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = bdw__compute_basic__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = bdw__compute_basic__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__compute_basic__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Read Throughput";
    counter->symbol_name = "GtiReadThroughput";
    counter->desc = "The total number of GPU memory bytes read from GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__compute_basic__gti_read_throughput__read;
    counter->max_uint64 = bdw__compute_basic__gti_read_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Write Throughput";
    counter->symbol_name = "GtiWriteThroughput";
    counter->desc = "The total number of GPU memory bytes written to GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__compute_basic__gti_write_throughput__read;
    counter->max_uint64 = bdw__compute_basic__gti_write_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__compute_basic__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__compute_basic__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__compute_basic__l3_shader_throughput__read;
    counter->max_uint64 = bdw__compute_basic__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__compute_basic__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__compute_basic__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__compute_basic__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bdw__compute_basic__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bdw__compute_basic__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__compute_basic__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__compute_basic__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__compute_basic__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__compute_basic__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__compute_basic__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__compute_basic__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__compute_basic__slm_bytes_read__read;
    counter->max_uint64 = bdw__compute_basic__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__compute_basic__slm_bytes_written__read;
    counter->max_uint64 = bdw__compute_basic__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Bytes Read";
    counter->symbol_name = "TypedBytesRead";
    counter->desc = "The total number of typed memory bytes read via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__compute_basic__typed_bytes_read__read;
    counter->max_uint64 = bdw__compute_basic__typed_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Bytes Written";
    counter->symbol_name = "TypedBytesWritten";
    counter->desc = "The total number of typed memory bytes written via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__compute_basic__typed_bytes_written__read;
    counter->max_uint64 = bdw__compute_basic__typed_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Untyped Bytes Read";
    counter->symbol_name = "UntypedBytesRead";
    counter->desc = "The total number of typed memory bytes read via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__compute_basic__untyped_bytes_read__read;
    counter->max_uint64 = bdw__compute_basic__untyped_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Untyped Writes";
    counter->symbol_name = "UntypedBytesWritten";
    counter->desc = "The total number of untyped memory bytes written via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__compute_basic__untyped_bytes_written__read;
    counter->max_uint64 = bdw__compute_basic__untyped_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__compute_basic__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 39);
}

static void
bdw_add_render_pipe_profile_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Render Metrics for 3D Pipeline Profile";
    metric_set->symbol_name = "RenderPipeProfile";
    metric_set->hw_config_guid = "233d0544-fff7-4281-8291-e02f222aff72";
    metric_set->counters = calloc(44, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(111, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(21, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1E0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1F000F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10176800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1191001F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B880320 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01890C40 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x118A1C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x118D7C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x118E0020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x118F4C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13900001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x065C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C3D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06584000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C5B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x081E0040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1E0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021F5400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x101F0010 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1F0080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C384000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06392000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C13C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06164000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06170012 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00170000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01910005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07880002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01880C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F880000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D880000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05880000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09890032 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x078A0800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8A0A00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x198A4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B8A2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D8A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038A4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B8A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D8A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x238B54C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x258BAA55 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x278B0019 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x198C0100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8D0015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x018D1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x098D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B8DF000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D8D3000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038DE000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058D3000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D8E0004 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058E000C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x098E0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x078E0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038E0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B8F0020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x198F0C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x078F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x098F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B900980 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03900D80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F85AA80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2185AAAA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2385002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19835400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B830155 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0184C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0784C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0984C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B84C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D84C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F84C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0384C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0584C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1180C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1780C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1980C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B80C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D80C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F80C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1380C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1580C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D24, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D801111 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3D800800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4F801011 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43800443 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51801111 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45800422 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53801111 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47800C60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F800422 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41800021 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007FFEA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x00007FFC };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x0007AFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000F5FD };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00079FFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000F3FB };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x0007BF7A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000F7E7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x0007FEFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000F7CF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00077FFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000EFDF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x0006FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000CFBF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x0003FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x00005F7F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00025024 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00035034 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00045044 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00055054 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00065064 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = bdw__render_pipe_profile__avg_gpu_core_frequency__read;
    counter->max_uint64 = bdw__render_pipe_profile__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "BC Bottleneck";
    counter->symbol_name = "BcBottleneck";
    counter->desc = "The percentage of time in which barycentric coordinates calculation pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__render_pipe_profile__bc_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Barycentric Calc");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Clipper Bottleneck";
    counter->symbol_name = "ClBottleneck";
    counter->desc = "The percentage of time in which clipper pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__render_pipe_profile__cl_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Clipper");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CL Stall";
    counter->symbol_name = "ClStall";
    counter->desc = "The percentage of time in which clipper pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__render_pipe_profile__cl_stall__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Clipper");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__render_pipe_profile__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Bottleneck";
    counter->symbol_name = "DsBottleneck";
    counter->desc = "The percentage of time in which domain shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__render_pipe_profile__ds_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Stall";
    counter->symbol_name = "DsStall";
    counter->desc = "The percentage of time in which domain shader pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__render_pipe_profile__ds_stall__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__render_pipe_profile__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Bottleneck";
    counter->symbol_name = "EarlyDepthBottleneck";
    counter->desc = "The percentage of time in which early depth test pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__render_pipe_profile__early_depth_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__render_pipe_profile__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__render_pipe_profile__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__render_pipe_profile__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__render_pipe_profile__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = bdw__render_pipe_profile__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = bdw__render_pipe_profile__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Bottleneck";
    counter->symbol_name = "GsBottleneck";
    counter->desc = "The percentage of time in which geometry shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__render_pipe_profile__gs_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__render_pipe_profile__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Hi-Depth Bottleneck";
    counter->symbol_name = "HiDepthBottleneck";
    counter->desc = "The percentage of time in which early hierarchical depth test pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__render_pipe_profile__hi_depth_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__render_pipe_profile__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Bottleneck";
    counter->symbol_name = "HsBottleneck";
    counter->desc = "The percentage of time in which hull shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__render_pipe_profile__hs_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Stall";
    counter->symbol_name = "HsStall";
    counter->desc = "The percentage of time in which hull stall pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__render_pipe_profile__hs_stall__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__render_pipe_profile__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__render_pipe_profile__l3_shader_throughput__read;
    counter->max_uint64 = bdw__render_pipe_profile__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__render_pipe_profile__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__render_pipe_profile__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__render_pipe_profile__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Accesses";
    counter->symbol_name = "SamplerAccesses";
    counter->desc = "The total number of messages send to samplers.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__render_pipe_profile__sampler_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bdw__render_pipe_profile__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bdw__render_pipe_profile__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__render_pipe_profile__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__render_pipe_profile__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__render_pipe_profile__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Strip-Fans Bottleneck";
    counter->symbol_name = "SfBottleneck";
    counter->desc = "The percentage of time in which strip-fans pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__render_pipe_profile__sf_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Strip-Fans");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SF Stall";
    counter->symbol_name = "SfStall";
    counter->desc = "The percentage of time in which strip-fans pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__render_pipe_profile__sf_stall__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Strip-Fans");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__render_pipe_profile__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__render_pipe_profile__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__render_pipe_profile__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__render_pipe_profile__slm_bytes_read__read;
    counter->max_uint64 = bdw__render_pipe_profile__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__render_pipe_profile__slm_bytes_written__read;
    counter->max_uint64 = bdw__render_pipe_profile__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SO Bottleneck";
    counter->symbol_name = "SoBottleneck";
    counter->desc = "The percentage of time in which stream output pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__render_pipe_profile__so_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Stream Output");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SO Stall";
    counter->symbol_name = "SoStall";
    counter->desc = "The percentage of time in which stream-output pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__render_pipe_profile__so_stall__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Stream Output");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VF Bottleneck";
    counter->symbol_name = "VfBottleneck";
    counter->desc = "The percentage of time in which vertex fetch pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__render_pipe_profile__vf_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Input Assembler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Bottleneck";
    counter->symbol_name = "VsBottleneck";
    counter->desc = "The percentage of time in which vertex shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__render_pipe_profile__vs_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__render_pipe_profile__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 44);
}

static void
bdw_add_memory_reads_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Memory Reads Distribution Gen8";
    metric_set->symbol_name = "MemoryReads";
    metric_set->hw_config_guid = "2b255d48-2117-4fef-a8f7-f151e1d25a2c";
    metric_set->counters = calloc(42, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(50, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(28, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x198B0343 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13845800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15840018 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3580001A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038B6300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058B6B62 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x078B006A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x118B0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x238B0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x258B0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F85A080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2185AAAA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2385000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01840018 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07844C80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09840D9A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B840E9C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D840F9E };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F840010 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11840000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03848000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0584C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F8000E5 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x138080E3 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1580C0E1 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11804000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1780C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1980C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B80C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D80C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F804000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D24, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3D800800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4F800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43800842 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45800842 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47801042 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F800084 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000274C, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002748, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00006667 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000275C, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002758, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002754, .val = 0x00006465 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002750, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007F81A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x0007F82A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x0007F872 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x0007F8BA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x0007F87A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x0007F8EA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x0007F8E2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x0007F8F2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000FE00 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00025024 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00035034 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00045044 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00055054 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00065064 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = bdw__memory_reads__avg_gpu_core_frequency__read;
    counter->max_uint64 = bdw__memory_reads__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__memory_reads__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__memory_reads__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__memory_reads__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__memory_reads__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__memory_reads__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__memory_reads__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = bdw__memory_reads__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = bdw__memory_reads__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__memory_reads__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiCmdStreamerMemoryReads";
    counter->symbol_name = "GtiCmdStreamerMemoryReads";
    counter->desc = "The total number of GTI memory reads from Command Streamer.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__memory_reads__gti_cmd_streamer_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Command Streamer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiHizMemoryReads";
    counter->symbol_name = "GtiHizMemoryReads";
    counter->desc = "The total number of GTI memory reads from Hierarchical Depth Cache (Hi-Depth Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__memory_reads__gti_hiz_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank0Reads";
    counter->symbol_name = "GtiL3Bank0Reads";
    counter->desc = "The total number of GTI memory reads from L3 Bank 0 (L3 Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__memory_reads__gti_l3_bank0_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank1Reads";
    counter->symbol_name = "GtiL3Bank1Reads";
    counter->desc = "The total number of GTI memory reads from L3 Bank 1 (L3 Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__memory_reads__gti_l3_bank1_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank2Reads";
    counter->symbol_name = "GtiL3Bank2Reads";
    counter->desc = "The total number of GTI memory reads from L3 Bank 2 (L3 Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__memory_reads__gti_l3_bank2_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank3Reads";
    counter->symbol_name = "GtiL3Bank3Reads";
    counter->desc = "The total number of GTI memory reads from L3 Bank 3 (L3 Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__memory_reads__gti_l3_bank3_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Reads";
    counter->symbol_name = "GtiL3Reads";
    counter->desc = "The total number of GTI memory reads from L3 (L3 Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__memory_reads__gti_l3_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiMemoryReads";
    counter->symbol_name = "GtiMemoryReads";
    counter->desc = "The total number of GTI memory reads.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__memory_reads__gti_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiMscMemoryReads";
    counter->symbol_name = "GtiMscMemoryReads";
    counter->desc = "The total number of GTI memory reads from Multisampling Color Cache (Multisampling Color Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__memory_reads__gti_msc_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRccMemoryReads";
    counter->symbol_name = "GtiRccMemoryReads";
    counter->desc = "The total number of GTI memory reads from Render Color Cache (Render Color Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__memory_reads__gti_rcc_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRczMemoryReads";
    counter->symbol_name = "GtiRczMemoryReads";
    counter->desc = "The total number of GTI memory reads from Render Depth Cache (Render Depth Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__memory_reads__gti_rcz_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRingAccesses";
    counter->symbol_name = "GtiRingAccesses";
    counter->desc = "The total number of all accesses from GTI to the ring.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__memory_reads__gti_ring_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRsMemoryReads";
    counter->symbol_name = "GtiRsMemoryReads";
    counter->desc = "The total number of GTI memory reads from Resource Streamer.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__memory_reads__gti_rs_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Resource Streamer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiStcMemoryReads";
    counter->symbol_name = "GtiStcMemoryReads";
    counter->desc = "The total number of GTI memory reads from Stencil Cache (Stencil Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__memory_reads__gti_stc_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiVfMemoryReads";
    counter->symbol_name = "GtiVfMemoryReads";
    counter->desc = "The total number of GTI memory reads from Vertex Fetch.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__memory_reads__gti_vf_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Vertex Fetch");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__memory_reads__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__memory_reads__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__memory_reads__l3_shader_throughput__read;
    counter->max_uint64 = bdw__memory_reads__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__memory_reads__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__memory_reads__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__memory_reads__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bdw__memory_reads__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bdw__memory_reads__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__memory_reads__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__memory_reads__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__memory_reads__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__memory_reads__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__memory_reads__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__memory_reads__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__memory_reads__slm_bytes_read__read;
    counter->max_uint64 = bdw__memory_reads__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__memory_reads__slm_bytes_written__read;
    counter->max_uint64 = bdw__memory_reads__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__memory_reads__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 42);
}

static void
bdw_add_memory_writes_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Memory Writes Distribution Gen8";
    metric_set->symbol_name = "MemoryWrites";
    metric_set->hw_config_guid = "f7fd3220-b466-4a4d-9f98-b0caf3f2394c";
    metric_set->counters = calloc(41, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(49, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(28, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x198B0343 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13845400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3580001A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3D800805 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038B6300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058B6B62 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x078B006A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x118B0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x238B0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x258B0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F85A080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2185AAAA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x23850002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01840010 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07844880 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09840992 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B840A94 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D840B96 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11840000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03848000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0584C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D800147 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F8000E5 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x138080E3 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1580C0E1 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11804000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1780C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1980C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B80C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D80C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D24, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4F800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43800842 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45800842 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47801082 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F800084 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000274C, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002748, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00006667 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000275C, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002758, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002754, .val = 0x00006465 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002750, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007F81A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x0007F82A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x0007F822 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x0007F8BA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x0007F87A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x0007F8EA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x0007F8E2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x0007F8F2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000FE00 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00025024 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00035034 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00045044 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00055054 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00065064 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = bdw__memory_writes__avg_gpu_core_frequency__read;
    counter->max_uint64 = bdw__memory_writes__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__memory_writes__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__memory_writes__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__memory_writes__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__memory_writes__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__memory_writes__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__memory_writes__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = bdw__memory_writes__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = bdw__memory_writes__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__memory_writes__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiCmdStreamerMemoryWrites";
    counter->symbol_name = "GtiCmdStreamerMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Command Streamer.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__memory_writes__gti_cmd_streamer_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Command Streamer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiHizMemoryWrites";
    counter->symbol_name = "GtiHizMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Hierarchical Depth Cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__memory_writes__gti_hiz_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank0Writes";
    counter->symbol_name = "GtiL3Bank0Writes";
    counter->desc = "The total number of GTI memory writes from L3 Bank 0 (L3 Bank 0 invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__memory_writes__gti_l3_bank0_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank1Writes";
    counter->symbol_name = "GtiL3Bank1Writes";
    counter->desc = "The total number of GTI memory writes from L3 Bank 1 (L3 Bank 1 invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__memory_writes__gti_l3_bank1_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank2Writes";
    counter->symbol_name = "GtiL3Bank2Writes";
    counter->desc = "The total number of GTI memory writes from L3 Bank 2 (L3 Bank 2 invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__memory_writes__gti_l3_bank2_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank3Writes";
    counter->symbol_name = "GtiL3Bank3Writes";
    counter->desc = "The total number of GTI memory writes from L3 Bank 3 (L3 Bank 3 invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__memory_writes__gti_l3_bank3_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Writes";
    counter->symbol_name = "GtiL3Writes";
    counter->desc = "The total number of GTI memory writes from L3 (L3 invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__memory_writes__gti_l3_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiMemoryWrites";
    counter->symbol_name = "GtiMemoryWrites";
    counter->desc = "The total number of GTI memory writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__memory_writes__gti_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiMscMemoryWrites";
    counter->symbol_name = "GtiMscMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Multisampling Color Cache (Multisampling Color Cache invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__memory_writes__gti_msc_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRccMemoryWrites";
    counter->symbol_name = "GtiRccMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Render Color Cache (Render Color Cache invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__memory_writes__gti_rcc_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRczMemoryWrites";
    counter->symbol_name = "GtiRczMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Render Depth Cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__memory_writes__gti_rcz_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRingAccesses";
    counter->symbol_name = "GtiRingAccesses";
    counter->desc = "The total number of all GTI accesses to the ring.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__memory_writes__gti_ring_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiSoMemoryWrites";
    counter->symbol_name = "GtiSoMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Stream Output.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__memory_writes__gti_so_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Stream Output");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiStcMemoryWrites";
    counter->symbol_name = "GtiStcMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Stencil Cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__memory_writes__gti_stc_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__memory_writes__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__memory_writes__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__memory_writes__l3_shader_throughput__read;
    counter->max_uint64 = bdw__memory_writes__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__memory_writes__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__memory_writes__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__memory_writes__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bdw__memory_writes__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bdw__memory_writes__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__memory_writes__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__memory_writes__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__memory_writes__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__memory_writes__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__memory_writes__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__memory_writes__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__memory_writes__slm_bytes_read__read;
    counter->max_uint64 = bdw__memory_writes__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__memory_writes__slm_bytes_written__read;
    counter->max_uint64 = bdw__memory_writes__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__memory_writes__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 41);
}

static void
bdw_add_compute_extended_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Compute Metrics Extended Gen8";
    metric_set->symbol_name = "ComputeExtended";
    metric_set->hw_config_guid = "e99ccaca-821c-4df9-97a7-96bdb7204e43";
    metric_set->counters = calloc(38, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(648, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(21, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    if (perf->devinfo.subslice_mask & 0x01) {
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x143D0160 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x163D2800 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x183D0120 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x105800E0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x005CC000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x065C8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x085CC000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A5CC000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C5CC000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E5CC000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x025CC000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x045CC000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x003D0011 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x063D0900 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x083D0A13 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A3D0B15 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C3D2317 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x043D21B7 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x103D0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E3D0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A3D0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E5825C1 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00586100 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0258204C };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06588000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0858C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A58C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C58C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0458C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x005B4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E5B4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x185B5400 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A5B0155 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x025B4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x045B4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x065B4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x085B4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A5B4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1FA800 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1FAA2A };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x101F02AA };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00384000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E384000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16384000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18381555 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02384000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04384000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06384000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08384000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A384000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0039A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06398000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0839A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A39A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C39A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E39A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0239A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0439A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x018A8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8A8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x198A8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B8AAAA0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D8A0002 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038A8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058A8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x078A8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x098A8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B8A8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x238B2AA0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x258B5551 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x278B0015 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F85AA80 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2185AAA2 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2385002A };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19835400 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B830155 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0184C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07848000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0984C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B84C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D84C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F84C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0384C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0584C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1180C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17808000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1980C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B80C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D80C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F80C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1380C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1580C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D24, .val = 0x00000000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3D800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4F800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47800420 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F800421 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    }

    if (perf->devinfo.subslice_mask & 0x02) {
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x105C00E0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x145B0160 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x165B2800 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x185B0120 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E5C25C1 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x005C6100 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x025C204C };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x065C8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x085CC000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A5CC000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C5CC000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x045CC000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x005B0011 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x065B0900 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x085B0A13 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A5B0B15 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C5B2317 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x045B21B7 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x105B0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E5B0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A5B0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1FA800 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1FAA2A };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x101F02AA };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00384000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E384000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16384000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18381555 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02384000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04384000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06384000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08384000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A384000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0039A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06398000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0839A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A39A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C39A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E39A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0239A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0439A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x018A8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8A8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x198A8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B8AAAA0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D8A0002 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038A8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058A8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x078A8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x098A8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B8A8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x238B2AA0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x258B5551 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x278B0015 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F85AA80 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2185AAA2 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2385002A };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19835400 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B830155 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0184C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07848000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0984C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B84C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D84C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F84C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0384C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0584C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1180C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17808000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1980C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B80C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D80C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F80C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1380C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1580C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D24, .val = 0x00000000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3D800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4F800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47800420 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F800421 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    }

    if (perf->devinfo.subslice_mask & 0x04) {
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x103800E0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x143A0160 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x163A2800 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x183A0120 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1FA800 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1FAA2A };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x101F02AA };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E38A5C1 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0038A100 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0238204C };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16388000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x183802AA };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04380000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06380000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08388000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A388000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0039A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06398000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0839A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A39A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C39A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E39A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0239A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0439A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x003A0011 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x063A0900 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x083A0A13 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A3A0B15 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C3A2317 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x043A21B7 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x103A0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E3A0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A3A0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x018A8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8A8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x198A8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B8AAAA0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D8A0002 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038A8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058A8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x078A8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x098A8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B8A8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x238B2AA0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x258B5551 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x278B0015 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F85AA80 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2185AAA2 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2385002A };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19835400 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B830155 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0184C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07848000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0984C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B84C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D84C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F84C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0384C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0584C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1180C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17808000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1980C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B80C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D80C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F80C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1380C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1580C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D24, .val = 0x00000000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3D800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4F800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47800420 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F800421 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    }

    if (perf->devinfo.subslice_mask & 0x08) {
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14BD0160 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16BD2800 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18BD0120 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10D800E0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00DCC000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06DC8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08DCC000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0ADCC000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CDCC000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EDCC000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02DCC000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04DCC000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00BD0011 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06BD0900 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08BD0A13 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0ABD0B15 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CBD2317 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04BD21B7 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10BD0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EBD0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1ABD0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0ED825C1 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00D86100 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02D8204C };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06D88000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08D8C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AD8C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CD8C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04D8C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00DB4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EDB4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18DB5400 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1ADB0155 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02DB4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04DB4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06DB4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08DB4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0ADB4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C9FA800 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E9FAA2A };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x109F02AA };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00B84000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EB84000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16B84000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18B81555 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02B84000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04B84000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06B84000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08B84000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AB84000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00B9A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06B98000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08B9A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AB9A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CB9A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EB9A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02B9A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04B9A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01888000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D88F800 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F88000F };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03888000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05888000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07888000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09888000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B888000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x238B5540 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x258BAAA2 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x278B002A };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x018C4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8C4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x178C2000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x198C5500 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B8C0015 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038C4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058C4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x078C4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x098C4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B8C4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x018DA000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x078D8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x098DA000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B8DA000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D8DA000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8DA000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038DA000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058DA000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F85AA80 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2185AAA2 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2385002A };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19835400 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B830155 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0184C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07848000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0984C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B84C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D84C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F84C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0384C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0584C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1180C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17808000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1980C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B80C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D80C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F80C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1380C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1580C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D24, .val = 0x00000000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3D800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4F800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47800420 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F800421 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    }

    if (perf->devinfo.subslice_mask & 0x10) {
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10DC00E0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14DB0160 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16DB2800 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18DB0120 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EDC25C1 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00DC6100 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02DC204C };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06DC8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08DCC000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0ADCC000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CDCC000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04DCC000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00DB0011 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06DB0900 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08DB0A13 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0ADB0B15 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CDB2317 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04DB21B7 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10DB0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EDB0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1ADB0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C9FA800 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E9FAA2A };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x109F02AA };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00B84000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EB84000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16B84000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18B81555 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02B84000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04B84000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06B84000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08B84000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AB84000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00B9A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06B98000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08B9A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AB9A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CB9A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EB9A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02B9A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04B9A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01888000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D88F800 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F88000F };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03888000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05888000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07888000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09888000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B888000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x238B5540 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x258BAAA2 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x278B002A };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x018C4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8C4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x178C2000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x198C5500 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B8C0015 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038C4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058C4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x078C4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x098C4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B8C4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x018DA000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x078D8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x098DA000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B8DA000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D8DA000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8DA000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038DA000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058DA000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F85AA80 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2185AAA2 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2385002A };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19835400 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B830155 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0184C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07848000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0984C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B84C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D84C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F84C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0384C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0584C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1180C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17808000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1980C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B80C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D80C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F80C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1380C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1580C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D24, .val = 0x00000000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3D800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4F800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47800420 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F800421 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    }

    if (perf->devinfo.subslice_mask & 0x20) {
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10B800E0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14BA0160 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16BA2800 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18BA0120 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C9FA800 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E9FAA2A };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x109F02AA };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EB8A5C1 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00B8A100 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02B8204C };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16B88000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18B802AA };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04B80000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06B80000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08B88000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AB88000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00B9A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06B98000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08B9A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AB9A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CB9A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EB9A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02B9A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04B9A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00BA0011 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06BA0900 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08BA0A13 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0ABA0B15 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CBA2317 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04BA21B7 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10BA0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EBA0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1ABA0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01888000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D88F800 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F88000F };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03888000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05888000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07888000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09888000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B888000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x238B5540 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x258BAAA2 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x278B002A };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x018C4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8C4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x178C2000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x198C5500 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B8C0015 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038C4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058C4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x078C4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x098C4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B8C4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x018DA000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x078D8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x098DA000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B8DA000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D8DA000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8DA000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038DA000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058DA000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F85AA80 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2185AAA2 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2385002A };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19835400 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B830155 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0184C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07848000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0984C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B84C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D84C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F84C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0384C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0584C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1180C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17808000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1980C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B80C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D80C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F80C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1380C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1580C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D24, .val = 0x00000000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3D800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4F800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47800420 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F800421 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    }

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007FC2A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x0007FC6A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x0007FC92 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x0007FCA2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x0007FC32 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x0007FC9A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x0007FE6A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x0007FE7A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000BF00 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00000003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00002001 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00778008 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00088078 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00808708 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00A08908 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = bdw__compute_extended__avg_gpu_core_frequency__read;
    counter->max_uint64 = bdw__compute_extended__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__compute_extended__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuA64UntypedReads0";
    counter->symbol_name = "EuA64UntypedReads0";
    counter->desc = "The subslice 0 EU A64 Untyped Reads subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__compute_extended__eu_a64_untyped_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuA64UntypedWrites0";
    counter->symbol_name = "EuA64UntypedWrites0";
    counter->desc = "The subslice 0 EU A64 Untyped Writes subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__compute_extended__eu_a64_untyped_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__compute_extended__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU AVG IPC Rate";
    counter->symbol_name = "EuAvgIpcRate";
    counter->desc = "The average rate of IPC calculated for 2 FPU pipelines.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NUMBER;
    counter->read_float = bdw__compute_extended__eu_avg_ipc_rate__read;
    counter->max_float = bdw__compute_extended__eu_avg_ipc_rate__max;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__compute_extended__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Send Pipe Active";
    counter->symbol_name = "EuSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__compute_extended__eu_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__compute_extended__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Thread Occupancy";
    counter->symbol_name = "EuThreadOccupancy";
    counter->desc = "The percentage of time in which hardware threads occupied EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__compute_extended__eu_thread_occupancy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuTypedAtomics0";
    counter->symbol_name = "EuTypedAtomics0";
    counter->desc = "The subslice 0 EU Typed Atomics subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__compute_extended__eu_typed_atomics0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuTypedReads0";
    counter->symbol_name = "EuTypedReads0";
    counter->desc = "The subslice 0 EU Typed Reads subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__compute_extended__eu_typed_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuTypedWrites0";
    counter->symbol_name = "EuTypedWrites0";
    counter->desc = "The subslice 0 EU Typed Writes subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__compute_extended__eu_typed_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuUntypedAtomics0";
    counter->symbol_name = "EuUntypedAtomics0";
    counter->desc = "The subslice 0 EU Untyped Atomics subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__compute_extended__eu_untyped_atomics0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuUntypedReads0";
    counter->symbol_name = "EuUntypedReads0";
    counter->desc = "The subslice 0 EU Untyped Reads subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__compute_extended__eu_untyped_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuUntypedWrites0";
    counter->symbol_name = "EuUntypedWrites0";
    counter->desc = "The subslice 0 EU Untyped Writes subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__compute_extended__eu_untyped_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Pipe Active";
    counter->symbol_name = "Fpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__compute_extended__fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active";
    counter->symbol_name = "Fpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__compute_extended__fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = bdw__compute_extended__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = bdw__compute_extended__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__compute_extended__l3_shader_throughput__read;
    counter->max_uint64 = bdw__compute_extended__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bdw__compute_extended__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bdw__compute_extended__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__compute_extended__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__compute_extended__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__compute_extended__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__compute_extended__slm_bytes_read__read;
    counter->max_uint64 = bdw__compute_extended__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__compute_extended__slm_bytes_written__read;
    counter->max_uint64 = bdw__compute_extended__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Atomics 0";
    counter->symbol_name = "TypedAtomics0";
    counter->desc = "The subslice 0 typed atomics.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__compute_extended__typed_atomics0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TypedAtomicsPerCacheLine";
    counter->symbol_name = "TypedAtomicsPerCacheLine";
    counter->desc = "Ratio of EU typed atomics requests to L3 cache line writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_ATOMIC_REQUESTS_TO_L3_CACHE_LINES;
    counter->read_float = bdw__compute_extended__typed_atomics_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Reads 0";
    counter->symbol_name = "TypedReads0";
    counter->desc = "The subslice 0 typed reads.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__compute_extended__typed_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TypedReadsPerCacheLine";
    counter->symbol_name = "TypedReadsPerCacheLine";
    counter->desc = "Ratio of EU typed read requests to L3 cache line reads.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_REQUESTS_TO_L3_CACHE_LINES;
    counter->read_float = bdw__compute_extended__typed_reads_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Writes 0";
    counter->symbol_name = "TypedWrites0";
    counter->desc = "The subslice 0 typed writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__compute_extended__typed_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TypedWritesPerCacheLine";
    counter->symbol_name = "TypedWritesPerCacheLine";
    counter->desc = "Ratio of EU typed write requests to L3 cache line writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_REQUESTS_TO_L3_CACHE_LINES;
    counter->read_float = bdw__compute_extended__typed_writes_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Untyped Reads 0";
    counter->symbol_name = "UntypedReads0";
    counter->desc = "The subslice 0 untyped reads (including SLM reads).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__compute_extended__untyped_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "UntypedReadsPerCacheLine";
    counter->symbol_name = "UntypedReadsPerCacheLine";
    counter->desc = "Ratio of EU untyped read requests to L3 cache line reads.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_REQUESTS_TO_L3_CACHE_LINES;
    counter->read_float = bdw__compute_extended__untyped_reads_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Untyped Writes 0";
    counter->symbol_name = "UntypedWrites0";
    counter->desc = "The subslice 0 untyped writes (including SLM writes).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__compute_extended__untyped_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "UntypedWritesPerCacheLine";
    counter->symbol_name = "UntypedWritesPerCacheLine";
    counter->desc = "Ratio of EU untyped write requests to L3 cache line writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_REQUESTS_TO_L3_CACHE_LINES;
    counter->read_float = bdw__compute_extended__untyped_writes_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    assert(metric_set->n_counters <= 38);
}

static void
bdw_add_compute_l3_cache_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Compute Metrics L3 Cache Gen8";
    metric_set->symbol_name = "ComputeL3Cache";
    metric_set->hw_config_guid = "27a364dc-8225-4ecb-b607-d6f1925598d9";
    metric_set->counters = calloc(58, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(107, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(13, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x143F00B3 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14BF00B3 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x138303C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3B800060 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3D800805 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x003F0029 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x063F1400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x083F1225 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E3F1327 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x103F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x005A4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x065A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x085AC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E5AC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x061D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x081DC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1DC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1F0800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1F2A00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x101F0280 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00391000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06394000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08395000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E395000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0ABF1429 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CBF1225 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00BF1380 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02BF0026 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10BF0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0ADAC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CDAC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00DA8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02DA4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A9DC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C9DC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x009D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x029D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E9F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x109F002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C9FA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AB95000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CB95000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00B94000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02B91000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D88C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F880003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03888000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05888000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x018A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x198A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B8A8020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D8A0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x238B0520 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x258BA950 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x278B0016 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x198C5400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B8C0001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B8DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D8DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x018D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F85AA80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2185AAA0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2385002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03835180 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05834022 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11830000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19835400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B830155 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07830000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09830000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0184C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07848000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0984C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B84C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D84C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F84C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0384C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05844000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B80C137 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D80C147 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1180C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17808000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1980C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F80C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1380C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15804000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D24, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D801000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4F800111 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43800842 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47800840 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F800800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x418014A2 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FEFE };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x0007FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FEFD };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x0007FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FBEF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x0007FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FBDF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00000003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00002001 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00101100 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00201200 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00301300 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00401400 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = bdw__compute_l3_cache__avg_gpu_core_frequency__read;
    counter->max_uint64 = bdw__compute_l3_cache__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__compute_l3_cache__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__compute_l3_cache__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__compute_l3_cache__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__compute_l3_cache__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU AVG IPC Rate";
    counter->symbol_name = "EuAvgIpcRate";
    counter->desc = "The average rate of IPC calculated for 2 FPU pipelines.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NUMBER;
    counter->read_float = bdw__compute_l3_cache__eu_avg_ipc_rate__read;
    counter->max_float = bdw__compute_l3_cache__eu_avg_ipc_rate__max;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Binary Instruction";
    counter->symbol_name = "EuBinaryFpu0Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing binary instructions on FPU0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__compute_l3_cache__eu_binary_fpu0_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Binary Instruction";
    counter->symbol_name = "EuBinaryFpu1Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing binary instructions on FPU1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__compute_l3_cache__eu_binary_fpu1_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__compute_l3_cache__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Hybrid Instruction";
    counter->symbol_name = "EuHybridFpu0Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing hybrid instructions on FPU0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__compute_l3_cache__eu_hybrid_fpu0_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Hybrid Instruction";
    counter->symbol_name = "EuHybridFpu1Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing hybrid instructions on FPU1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__compute_l3_cache__eu_hybrid_fpu1_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Move Instruction";
    counter->symbol_name = "EuMoveFpu0Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing move instructions on FPU0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__compute_l3_cache__eu_move_fpu0_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Move Instruction";
    counter->symbol_name = "EuMoveFpu1Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing move instructions on FPU1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__compute_l3_cache__eu_move_fpu1_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Send Pipe Active";
    counter->symbol_name = "EuSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__compute_l3_cache__eu_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__compute_l3_cache__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Ternary Instruction";
    counter->symbol_name = "EuTernaryFpu0Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing ternary instructions on FPU0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__compute_l3_cache__eu_ternary_fpu0_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Ternary Instruction";
    counter->symbol_name = "EuTernaryFpu1Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing ternary instructions on FPU1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__compute_l3_cache__eu_ternary_fpu1_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Pipe Active";
    counter->symbol_name = "Fpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__compute_l3_cache__fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active";
    counter->symbol_name = "Fpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__compute_l3_cache__fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__compute_l3_cache__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = bdw__compute_l3_cache__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = bdw__compute_l3_cache__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__compute_l3_cache__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI L3 Throughput";
    counter->symbol_name = "GtiL3Throughput";
    counter->desc = "The total number of GPU memory bytes transferred between L3 caches and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__compute_l3_cache__gti_l3_throughput__read;
    counter->max_uint64 = bdw__compute_l3_cache__gti_l3_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Read Throughput";
    counter->symbol_name = "GtiReadThroughput";
    counter->desc = "The total number of GPU memory bytes read from GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__compute_l3_cache__gti_read_throughput__read;
    counter->max_uint64 = bdw__compute_l3_cache__gti_read_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Write Throughput";
    counter->symbol_name = "GtiWriteThroughput";
    counter->desc = "The total number of GPU memory bytes written to GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__compute_l3_cache__gti_write_throughput__read;
    counter->max_uint64 = bdw__compute_l3_cache__gti_write_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__compute_l3_cache__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__compute_l3_cache__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Accesses";
    counter->symbol_name = "L3Accesses";
    counter->desc = "The total number of L3 accesses from all entities.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__compute_l3_cache__l3_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3");

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 00 Accesses";
        counter->symbol_name = "L3Bank00Accesses";
        counter->desc = "The total number of accesses to L3 Bank 00.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = bdw__compute_l3_cache__l3_bank00_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 00 IC Accesses";
        counter->symbol_name = "L3Bank00IcAccesses";
        counter->desc = "The total number of accesses to L3 Bank 00 from IC cache.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = bdw__compute_l3_cache__l3_bank00_ic_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3/IC");
    }

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 00 IC Hits";
        counter->symbol_name = "L3Bank00IcHits";
        counter->desc = "The total number of hits in L3 Bank 00 from IC cache.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = bdw__compute_l3_cache__l3_bank00_ic_hits__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3/IC");
    }

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 01 Accesses";
        counter->symbol_name = "L3Bank01Accesses";
        counter->desc = "The total number of accesses to L3 Bank 01.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = bdw__compute_l3_cache__l3_bank01_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 02 Accesses";
        counter->symbol_name = "L3Bank02Accesses";
        counter->desc = "The total number of accesses to L3 Bank 02.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = bdw__compute_l3_cache__l3_bank02_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 03 Accesses";
        counter->symbol_name = "L3Bank03Accesses";
        counter->desc = "The total number of accesses to L3 Bank 03.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = bdw__compute_l3_cache__l3_bank03_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    if (perf->devinfo.slice_mask & 0x02) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 10 Accesses";
        counter->symbol_name = "L3Bank10Accesses";
        counter->desc = "The total number of accesses to L3 Bank 10.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = bdw__compute_l3_cache__l3_bank10_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    if (perf->devinfo.slice_mask & 0x02) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 10 IC Accesses";
        counter->symbol_name = "L3Bank10IcAccesses";
        counter->desc = "The total number of accesses to L3 Bank 10 from IC cache.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = bdw__compute_l3_cache__l3_bank10_ic_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3/IC");
    }

    if (perf->devinfo.slice_mask & 0x02) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 10 IC Hits";
        counter->symbol_name = "L3Bank10IcHits";
        counter->desc = "The total number of hits in L3 Bank 10 from IC cache.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = bdw__compute_l3_cache__l3_bank10_ic_hits__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3/IC");
    }

    if (perf->devinfo.slice_mask & 0x02) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 11 Accesses";
        counter->symbol_name = "L3Bank11Accesses";
        counter->desc = "The total number of accesses to L3 Bank 11.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = bdw__compute_l3_cache__l3_bank11_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    if (perf->devinfo.slice_mask & 0x02) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 12 Accesses";
        counter->symbol_name = "L3Bank12Accesses";
        counter->desc = "The total number of accesses to L3 Bank 12.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = bdw__compute_l3_cache__l3_bank12_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    if (perf->devinfo.slice_mask & 0x02) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 13 Accesses";
        counter->symbol_name = "L3Bank13Accesses";
        counter->desc = "The total number of accesses to L3 Bank 13.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = bdw__compute_l3_cache__l3_bank13_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Misses";
    counter->symbol_name = "L3Misses";
    counter->desc = "The total number of L3 misses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__compute_l3_cache__l3_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/TAG");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__compute_l3_cache__l3_shader_throughput__read;
    counter->max_uint64 = bdw__compute_l3_cache__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Total Throughput";
    counter->symbol_name = "L3TotalThroughput";
    counter->desc = "The total number of GPU memory bytes transferred via L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__compute_l3_cache__l3_total_throughput__read;
    counter->max_uint64 = bdw__compute_l3_cache__l3_total_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__compute_l3_cache__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__compute_l3_cache__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__compute_l3_cache__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bdw__compute_l3_cache__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bdw__compute_l3_cache__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__compute_l3_cache__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__compute_l3_cache__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__compute_l3_cache__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__compute_l3_cache__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__compute_l3_cache__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__compute_l3_cache__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__compute_l3_cache__slm_bytes_read__read;
    counter->max_uint64 = bdw__compute_l3_cache__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__compute_l3_cache__slm_bytes_written__read;
    counter->max_uint64 = bdw__compute_l3_cache__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__compute_l3_cache__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 58);
}

static void
bdw_add_data_port_reads_coalescing_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Data Port Reads Coalescing Gen8";
    metric_set->symbol_name = "DataPortReadsCoalescing";
    metric_set->hw_config_guid = "857fc630-2f09-4804-85f1-084adfadd5ab";
    metric_set->counters = calloc(35, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(114, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(24, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    if (perf->devinfo.subslice_mask & 0x01) {
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x103D0005 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x163D240B };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1058022F };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x185B5520 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x198B0003 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x005CC000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x065CC000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x085CC000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A5CC000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C5CC000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E5CC000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x025C4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x045C8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x003D0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x063D00B0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x083D0182 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A3D10A0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C3D11A2 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E3D0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x183D0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A3D0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E582242 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00586700 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0258004F };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0658C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0858C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A58C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C58C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x045B6300 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x105B0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x005B4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E5B4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A5B0155 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x025B4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A5B0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C5B4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1FA800 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1FAAA0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x101F02AA };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00384000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E384000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16384000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18381555 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02384000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04384000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A384000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C384000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0039A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0639A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0839A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A39A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C39A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E39A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02392000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04398000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x018A8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8A8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x198A8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B8AAAA0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D8A0002 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038A8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058A8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B8A8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D8A8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038B6300 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058B0062 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x118B0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x238B02A0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x258B5555 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x278B0015 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F85AA80 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2185AAAA };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2385002A };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19835400 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B830155 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0184C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0784C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0984C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B84C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D84C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F84C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0384C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0584C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1180C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1780C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1980C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B80C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D80C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F80C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1380C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1580C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D24, .val = 0x00000000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D801000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3D800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4F800001 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47800420 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F800421 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41800041 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    }

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000274C, .val = 0xBA98BA98 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002748, .val = 0xBA98BA98 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00003377 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007FFF2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x00007FF0 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x0007FFE2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x00007FF0 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x0007FFC2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x00007FF0 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x0007FF82 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x00007FF0 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x0007FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000BFEF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x0007FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000BFDF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x0007FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000BFBF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x0007FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000BF7F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00000003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00002001 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00778008 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00088078 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00808708 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00A08908 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = bdw__data_port_reads_coalescing__avg_gpu_core_frequency__read;
    counter->max_uint64 = bdw__data_port_reads_coalescing__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__data_port_reads_coalescing__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__data_port_reads_coalescing__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__data_port_reads_coalescing__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU AVG IPC Rate";
    counter->symbol_name = "EuAvgIpcRate";
    counter->desc = "The average rate of IPC calculated for 2 FPU pipelines.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NUMBER;
    counter->read_float = bdw__data_port_reads_coalescing__eu_avg_ipc_rate__read;
    counter->max_float = bdw__data_port_reads_coalescing__eu_avg_ipc_rate__max;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuBytesReadPerCacheLine";
    counter->symbol_name = "EuBytesReadPerCacheLine";
    counter->desc = "Average EU bytes read per L3 cache line.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_BYTES_PER_L3_CACHE_LINE;
    counter->read_float = bdw__data_port_reads_coalescing__eu_bytes_read_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuDataReadsPerCacheLine";
    counter->symbol_name = "EuDataReadsPerCacheLine";
    counter->desc = "Coalescing ratio of EU read requests to L3 cache lines.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_UTILIZATION;
    counter->read_float = bdw__data_port_reads_coalescing__eu_data_reads_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__data_port_reads_coalescing__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU to Data Port 0 Reads 128";
    counter->symbol_name = "EuHdc0Reads128B";
    counter->desc = "The subslice 0 EU data reads from Data Port with 128B per message.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__data_port_reads_coalescing__eu_hdc0_reads128_b__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU to Data Port 0 Reads 256";
    counter->symbol_name = "EuHdc0Reads256B";
    counter->desc = "The subslice 0 EU data reads from Data Port with 256B per message.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__data_port_reads_coalescing__eu_hdc0_reads256_b__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU to Data Port 0 Reads 32";
    counter->symbol_name = "EuHdc0Reads32B";
    counter->desc = "The subslice 0 EU data reads from Data Port with 32B per message.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__data_port_reads_coalescing__eu_hdc0_reads32_b__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU to Data Port 0 Reads 64";
    counter->symbol_name = "EuHdc0Reads64B";
    counter->desc = "The subslice 0 EU data reads from Data Port with 64B per message.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__data_port_reads_coalescing__eu_hdc0_reads64_b__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Send Pipe Active";
    counter->symbol_name = "EuSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__data_port_reads_coalescing__eu_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__data_port_reads_coalescing__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Thread Occupancy";
    counter->symbol_name = "EuThreadOccupancy";
    counter->desc = "The percentage of time in which hardware threads occupied EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__data_port_reads_coalescing__eu_thread_occupancy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Pipe Active";
    counter->symbol_name = "Fpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__data_port_reads_coalescing__fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active";
    counter->symbol_name = "Fpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__data_port_reads_coalescing__fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = bdw__data_port_reads_coalescing__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = bdw__data_port_reads_coalescing__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__data_port_reads_coalescing__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Data Port 0 to L3 Data Reads";
    counter->symbol_name = "Hdc0L3DataReads";
    counter->desc = "The subslice 0 Data Port data and constant reads from L3 cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__data_port_reads_coalescing__hdc0_l3_data_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Data Port 0 to L3 Data Writes";
    counter->symbol_name = "Hdc0L3DataWrites";
    counter->desc = "The subslice 0 Data Port data writes to L3 cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__data_port_reads_coalescing__hdc0_l3_data_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "All Data Port 0 Reads from L3";
    counter->symbol_name = "Hdc0L3Reads";
    counter->desc = "The subslice 0 Data Port reads from L3 cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__data_port_reads_coalescing__hdc0_l3_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "All Data Port 0 Writes to L3";
    counter->symbol_name = "Hdc0L3Writes";
    counter->desc = "The subslice 0 Data Port writes to L3 cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__data_port_reads_coalescing__hdc0_l3_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__data_port_reads_coalescing__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__data_port_reads_coalescing__l3_shader_throughput__read;
    counter->max_uint64 = bdw__data_port_reads_coalescing__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__data_port_reads_coalescing__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bdw__data_port_reads_coalescing__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bdw__data_port_reads_coalescing__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__data_port_reads_coalescing__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__data_port_reads_coalescing__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__data_port_reads_coalescing__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__data_port_reads_coalescing__slm_bytes_read__read;
    counter->max_uint64 = bdw__data_port_reads_coalescing__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__data_port_reads_coalescing__slm_bytes_written__read;
    counter->max_uint64 = bdw__data_port_reads_coalescing__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__data_port_reads_coalescing__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 35);
}

static void
bdw_add_data_port_writes_coalescing_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Data Port Writes Coalescing Gen8";
    metric_set->symbol_name = "DataPortWritesCoalescing";
    metric_set->hw_config_guid = "343ebc99-4a55-414c-8c17-d8e259cf5e20";
    metric_set->counters = calloc(38, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(110, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(24, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    if (perf->devinfo.subslice_mask & 0x01) {
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x103D0005 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x143D0120 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x163D2400 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1058022F };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x105B0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x198B0003 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x005CC000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x065CC000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x085CC000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A5CC000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E5CC000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x025C4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x045C8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x003D0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x063D0094 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x083D0182 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A3D1814 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E3D0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x183D0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A3D0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C3D0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E582242 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00586700 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0258004F };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0658C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0858C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A58C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x045B6A80 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x005B4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E5B4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x185B5400 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A5B0141 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x025B4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A5B0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C5B4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1FA800 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1FAAA0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x101F0282 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00384000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E384000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16384000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18381415 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02384000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04384000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A384000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C384000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0039A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0639A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0839A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A39A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E39A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02392000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04398000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x018A8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8A8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x198A8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B8A82A0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D8A0002 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038A8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058A8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B8A8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D8A8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038B6300 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058B0062 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x118B0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x238B02A0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x258B1555 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x278B0014 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F85AA80 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21852AAA };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x23850028 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19835400 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B830141 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D834000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0184C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0784C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0984C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B84C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F84C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0384C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0584C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1180C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1780C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1980C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B80C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F80C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1380C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1580C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D24, .val = 0x00000000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D801000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3D800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4F800001 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53800000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47800420 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F800421 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41800041 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    }

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000274C, .val = 0xBA98BA98 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002748, .val = 0xBA98BA98 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00003377 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007FF72 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000BFD0 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x0007FF62 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000BFD0 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x0007FF42 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000BFD0 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x0007FF02 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000BFD0 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x0005FFF2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000BFD0 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x0005FFE2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000BFD0 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x0005FFC2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000BFD0 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x0005FF82 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000BFD0 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00000003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00002001 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00778008 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00088078 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00808708 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00A08908 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = bdw__data_port_writes_coalescing__avg_gpu_core_frequency__read;
    counter->max_uint64 = bdw__data_port_writes_coalescing__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__data_port_writes_coalescing__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__data_port_writes_coalescing__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__data_port_writes_coalescing__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU AVG IPC Rate";
    counter->symbol_name = "EuAvgIpcRate";
    counter->desc = "The average rate of IPC calculated for 2 FPU pipelines.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NUMBER;
    counter->read_float = bdw__data_port_writes_coalescing__eu_avg_ipc_rate__read;
    counter->max_float = bdw__data_port_writes_coalescing__eu_avg_ipc_rate__max;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuBytesWrittenPerCacheLine";
    counter->symbol_name = "EuBytesWrittenPerCacheLine";
    counter->desc = "Average EU bytes written per L3 cache line.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_BYTES_PER_L3_CACHE_LINE;
    counter->read_float = bdw__data_port_writes_coalescing__eu_bytes_written_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuDataWritesPerCacheLine";
    counter->symbol_name = "EuDataWritesPerCacheLine";
    counter->desc = "Coalescing ratio of EU write requests to L3 cache lines.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_UTILIZATION;
    counter->read_float = bdw__data_port_writes_coalescing__eu_data_writes_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__data_port_writes_coalescing__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU to Data Port 0 Writes 128";
    counter->symbol_name = "EuHdc0Writes128B";
    counter->desc = "The subslice 0 EU data writes to Data Port with 128B per message.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__data_port_writes_coalescing__eu_hdc0_writes128_b__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU to Data Port 0 Writes 64B";
    counter->symbol_name = "EuHdc0Writes128BSimd16";
    counter->desc = "The subslice 0 EU data simd16 writes to Data Port with 128B per message.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__data_port_writes_coalescing__eu_hdc0_writes128_b_simd16__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU to Data Port 0 Writes 128";
    counter->symbol_name = "EuHdc0Writes192B";
    counter->desc = "The subslice 0 EU data simd16 writes to Data Port with 192B per message.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__data_port_writes_coalescing__eu_hdc0_writes192_b__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU to Data Port 0 Writes 256B";
    counter->symbol_name = "EuHdc0Writes256BSimd16";
    counter->desc = "The subslice 0 EU data simd16 writes to Data Port with 256B per message.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__data_port_writes_coalescing__eu_hdc0_writes256_b_simd16__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU to Data Port 0 Writes 32B";
    counter->symbol_name = "EuHdc0Writes32B";
    counter->desc = "The subslice 0 EU data writes to Data Port with 32B per message.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__data_port_writes_coalescing__eu_hdc0_writes32_b__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU to Data Port 0 Writes 64B";
    counter->symbol_name = "EuHdc0Writes64B";
    counter->desc = "The subslice 0 EU data writes to Data Port with 64B per message.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__data_port_writes_coalescing__eu_hdc0_writes64_b__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU to Data Port 0 Writes 64B";
    counter->symbol_name = "EuHdc0Writes96B";
    counter->desc = "The subslice 0 EU data writes to Data Port with 64B per message.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__data_port_writes_coalescing__eu_hdc0_writes96_b__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Send Pipe Active";
    counter->symbol_name = "EuSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__data_port_writes_coalescing__eu_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__data_port_writes_coalescing__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Thread Occupancy";
    counter->symbol_name = "EuThreadOccupancy";
    counter->desc = "The percentage of time in which hardware threads occupied EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__data_port_writes_coalescing__eu_thread_occupancy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Pipe Active";
    counter->symbol_name = "Fpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__data_port_writes_coalescing__fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active";
    counter->symbol_name = "Fpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__data_port_writes_coalescing__fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = bdw__data_port_writes_coalescing__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = bdw__data_port_writes_coalescing__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__data_port_writes_coalescing__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Data Port 0 to L3 Data Reads";
    counter->symbol_name = "Hdc0L3DataReads";
    counter->desc = "The subslice 0 Data Port data and constant reads from L3 cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__data_port_writes_coalescing__hdc0_l3_data_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Data Port 0 to L3 Data Writes";
    counter->symbol_name = "Hdc0L3DataWrites";
    counter->desc = "The subslice 0 Data Port data writes to L3 cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__data_port_writes_coalescing__hdc0_l3_data_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "All Data Port 0 Reads from L3";
    counter->symbol_name = "Hdc0L3Reads";
    counter->desc = "The subslice 0 Data Port reads from L3 cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__data_port_writes_coalescing__hdc0_l3_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "All Data Port 0 Writes to L3";
    counter->symbol_name = "Hdc0L3Writes";
    counter->desc = "The subslice 0 Data Port writes to L3 cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__data_port_writes_coalescing__hdc0_l3_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__data_port_writes_coalescing__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__data_port_writes_coalescing__l3_shader_throughput__read;
    counter->max_uint64 = bdw__data_port_writes_coalescing__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__data_port_writes_coalescing__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bdw__data_port_writes_coalescing__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bdw__data_port_writes_coalescing__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__data_port_writes_coalescing__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__data_port_writes_coalescing__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__data_port_writes_coalescing__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__data_port_writes_coalescing__slm_bytes_read__read;
    counter->max_uint64 = bdw__data_port_writes_coalescing__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__data_port_writes_coalescing__slm_bytes_written__read;
    counter->max_uint64 = bdw__data_port_writes_coalescing__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__data_port_writes_coalescing__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 38);
}

static void
bdw_add_hdc_and_sf_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set HDCAndSF";
    metric_set->symbol_name = "HDCAndSF";
    metric_set->hw_config_guid = "78490af2-10fa-430b-ae3c-94ec04d5214e";
    metric_set->counters = calloc(43, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(99, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(8, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x105C0232 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10580232 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10380232 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10DC0232 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10D80232 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10B80232 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x118E4400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x025C6080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x045C004B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x005C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00582080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0258004B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x025B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x045B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1FA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1F00AA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04386080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0638404B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02384000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08384000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A380000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C380000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00398000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0239A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0439A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06392000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CDC25C1 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0ADCC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AD825C1 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18DB4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1ADB0001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E9F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x109F02AA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EB825C1 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18B80154 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AB9A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CB9A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EB9A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D88C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F88000F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x078A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x098A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B8A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D8A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x258BAA05 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x278B002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x238B2A80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x198C5400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B8C0015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x098DC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B8DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D8DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x098E05C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058E0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x198F0020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2185AA0A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2385002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F85AA00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19835000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B830155 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09848000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B84C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D84C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F84C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01848000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0384C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0584C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07844000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19808000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B80C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D80C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F80C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11808000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1380C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1580C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17804000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51800040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43800400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45800800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47800C62 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F801042 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4F800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x418014A4 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x10800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFF7 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = bdw__hdc_and_sf__avg_gpu_core_frequency__read;
    counter->max_uint64 = bdw__hdc_and_sf__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__hdc_and_sf__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__hdc_and_sf__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__hdc_and_sf__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__hdc_and_sf__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__hdc_and_sf__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__hdc_and_sf__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__hdc_and_sf__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__hdc_and_sf__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = bdw__hdc_and_sf__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = bdw__hdc_and_sf__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__hdc_and_sf__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__hdc_and_sf__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__hdc_and_sf__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__hdc_and_sf__l3_shader_throughput__read;
    counter->max_uint64 = bdw__hdc_and_sf__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "HDC stalled by L3 (s0.ss0)";
        counter->symbol_name = "NonSamplerShader00AccessStalledOnL3";
        counter->desc = "Percentage of time when HDC has messges to L3, but it's stalled due to lack of credits (s0.ss0)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__hdc_and_sf__non_sampler_shader00_access_stalled_on_l3__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Data Port");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "HDC stalled by L3 (s0.ss1)";
        counter->symbol_name = "NonSamplerShader01AccessStalledOnL3";
        counter->desc = "Percentage of time when HDC has messges to L3, but it's stalled due to lack of credits (s0.ss1)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__hdc_and_sf__non_sampler_shader01_access_stalled_on_l3__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Data Port");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "HDC stalled by L3 (s0.ss2)";
        counter->symbol_name = "NonSamplerShader02AccessStalledOnL3";
        counter->desc = "Percentage of time when HDC has messges to L3, but it's stalled due to lack of credits (s0.ss2)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__hdc_and_sf__non_sampler_shader02_access_stalled_on_l3__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Data Port");
    }

    if (perf->devinfo.subslice_mask & 0x8) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "HDC stalled by L3 (s0.ss0)";
        counter->symbol_name = "NonSamplerShader10AccessStalledOnL3";
        counter->desc = "Percentage of time when HDC has messges to L3, but it's stalled due to lack of credits (s0.ss0)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__hdc_and_sf__non_sampler_shader10_access_stalled_on_l3__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Data Port");
    }

    if (perf->devinfo.subslice_mask & 0x10) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "HDC stalled by L3 (s0.ss1)";
        counter->symbol_name = "NonSamplerShader11AccessStalledOnL3";
        counter->desc = "Percentage of time when HDC has messges to L3, but it's stalled due to lack of credits (s0.ss1)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__hdc_and_sf__non_sampler_shader11_access_stalled_on_l3__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Data Port");
    }

    if (perf->devinfo.subslice_mask & 0x20) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "HDC stalled by L3 (s0.ss2)";
        counter->symbol_name = "NonSamplerShader12AccessStalledOnL3";
        counter->desc = "Percentage of time when HDC has messges to L3, but it's stalled due to lack of credits (s0.ss2)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__hdc_and_sf__non_sampler_shader12_access_stalled_on_l3__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Data Port");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__hdc_and_sf__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Polygon Data Ready";
    counter->symbol_name = "PolyDataReady";
    counter->desc = "The percentage of time in which geometry pipeline output is ready";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__hdc_and_sf__poly_data_ready__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe/Strip-Fans");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__hdc_and_sf__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__hdc_and_sf__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__hdc_and_sf__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__hdc_and_sf__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__hdc_and_sf__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__hdc_and_sf__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bdw__hdc_and_sf__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bdw__hdc_and_sf__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__hdc_and_sf__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__hdc_and_sf__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__hdc_and_sf__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__hdc_and_sf__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__hdc_and_sf__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__hdc_and_sf__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__hdc_and_sf__slm_bytes_read__read;
    counter->max_uint64 = bdw__hdc_and_sf__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__hdc_and_sf__slm_bytes_written__read;
    counter->max_uint64 = bdw__hdc_and_sf__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__hdc_and_sf__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__hdc_and_sf__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__hdc_and_sf__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__hdc_and_sf__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 43);
}

static void
bdw_add_l3_1_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set L3_1";
    metric_set->symbol_name = "L3_1";
    metric_set->hw_config_guid = "c0abdd97-3b13-4cad-814c-bd178804e02c";
    metric_set->counters = calloc(40, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(92, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(22, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10BF03DA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14BF0001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12980340 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12990340 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CBF1187 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EBF1205 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00BF0500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02BF042B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04BF002C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CDAC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EDAC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00DA8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02DAC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04DA4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04983400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10980000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06990034 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10990000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C9DC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E9DC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x009D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x029DC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x049D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x109F02A8 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C9FA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E9F00BA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CB88000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CB95000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EB95000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00B94000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02B95000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04B91000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06B92000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CBA4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F88000F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03888000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05888000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07888000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09888000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B888000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D880400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x258B800A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x278B002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x238B5500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x198C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B8C0015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x078C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x098C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B8C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D8C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D8DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x018D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x078D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2185800A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2385002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F85AA00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B830154 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D84C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F84C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01848000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0384C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0584C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07844000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D80C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F80C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11808000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1380C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1580C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17804000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4F800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41800060 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00100070 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFF1 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00014002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000C3FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00010002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000C7FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00004002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000D3FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00100700 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FF1F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00001402 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FC3F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x00001002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FC7F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x00000402 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000FD3F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = bdw__l3_1__avg_gpu_core_frequency__read;
    counter->max_uint64 = bdw__l3_1__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__l3_1__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__l3_1__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__l3_1__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__l3_1__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__l3_1__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__l3_1__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__l3_1__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__l3_1__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = bdw__l3_1__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = bdw__l3_1__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__l3_1__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__l3_1__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__l3_1__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    if (perf->devinfo.slice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice1 L3 Bank0 Active";
        counter->symbol_name = "L31Bank0Active";
        counter->desc = "The percentage of time in which slice1 L3 bank0 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__l3_1__l31_bank0_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice1 L3 Bank0 Stalled";
        counter->symbol_name = "L31Bank0Stalled";
        counter->desc = "The percentage of time in which slice1 L3 bank0 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__l3_1__l31_bank0_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice1 L3 Bank1 Active";
        counter->symbol_name = "L31Bank1Active";
        counter->desc = "The percentage of time in which slice1 L3 bank1 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__l3_1__l31_bank1_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice1 L3 Bank1 Stalled";
        counter->symbol_name = "L31Bank1Stalled";
        counter->desc = "The percentage of time in which slice1 L3 bank1 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__l3_1__l31_bank1_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__l3_1__l3_shader_throughput__read;
    counter->max_uint64 = bdw__l3_1__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__l3_1__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__l3_1__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__l3_1__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__l3_1__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__l3_1__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__l3_1__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__l3_1__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bdw__l3_1__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bdw__l3_1__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__l3_1__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__l3_1__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__l3_1__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__l3_1__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__l3_1__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__l3_1__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__l3_1__slm_bytes_read__read;
    counter->max_uint64 = bdw__l3_1__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__l3_1__slm_bytes_written__read;
    counter->max_uint64 = bdw__l3_1__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__l3_1__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__l3_1__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__l3_1__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__l3_1__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 40);
}

static void
bdw_add_l3_2_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set L3_2";
    metric_set->symbol_name = "L3_2";
    metric_set->hw_config_guid = "ad665281-a7cf-483a-bd10-0e07c43f61c7";
    metric_set->counters = calloc(40, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(79, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(22, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x103F03DA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x143F0001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12180340 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12190340 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C3F1187 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E3F1205 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x003F0500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x023F042B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x043F002C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C5AC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E5AC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x005A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x025AC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x045A4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04183400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10180000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06190034 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10190000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1DC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1DC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021DC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x101F02A8 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1FA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1F00BA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C388000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C395000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E395000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00394000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02395000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04391000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06392000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C3A4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B8AA800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D8A0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x078A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x098A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B8A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D8A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x258B4005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x278B0015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x238B2A80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2185800A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2385002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F85AA00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B830154 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D84C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F84C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01848000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0384C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0584C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07844000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D80C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F80C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11808000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1380C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1580C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17804000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4F800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41800060 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00100070 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFF1 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00014002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000C3FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00010002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000C7FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00004002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000D3FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00100700 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FF1F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00001402 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FC3F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x00001002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FC7F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x00000402 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000FD3F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = bdw__l3_2__avg_gpu_core_frequency__read;
    counter->max_uint64 = bdw__l3_2__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__l3_2__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__l3_2__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__l3_2__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__l3_2__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__l3_2__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__l3_2__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__l3_2__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__l3_2__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = bdw__l3_2__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = bdw__l3_2__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__l3_2__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__l3_2__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__l3_2__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank0 Active";
        counter->symbol_name = "L30Bank0Active";
        counter->desc = "The percentage of time in which slice0 L3 bank0 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__l3_2__l30_bank0_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank0 Stalled";
        counter->symbol_name = "L30Bank0Stalled";
        counter->desc = "The percentage of time in which slice0 L3 bank0 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__l3_2__l30_bank0_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank1 Active";
        counter->symbol_name = "L30Bank1Active";
        counter->desc = "The percentage of time in which slice0 L3 bank1 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__l3_2__l30_bank1_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank1 Stalled";
        counter->symbol_name = "L30Bank1Stalled";
        counter->desc = "The percentage of time in which slice0 L3 bank1 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__l3_2__l30_bank1_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__l3_2__l3_shader_throughput__read;
    counter->max_uint64 = bdw__l3_2__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__l3_2__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__l3_2__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__l3_2__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__l3_2__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__l3_2__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__l3_2__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__l3_2__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bdw__l3_2__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bdw__l3_2__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__l3_2__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__l3_2__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__l3_2__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__l3_2__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__l3_2__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__l3_2__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__l3_2__slm_bytes_read__read;
    counter->max_uint64 = bdw__l3_2__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__l3_2__slm_bytes_written__read;
    counter->max_uint64 = bdw__l3_2__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__l3_2__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__l3_2__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__l3_2__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__l3_2__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 40);
}

static void
bdw_add_l3_3_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set L3_3";
    metric_set->symbol_name = "L3_3";
    metric_set->hw_config_guid = "930a15aa-4300-4fce-a9ba-edb0b9e880be";
    metric_set->counters = calloc(40, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(95, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(22, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x121B0340 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x103F0274 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x123F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x129B0340 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10BF0274 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12BF0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041B3400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x101B0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x045C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A3D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x003F0080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x023F0793 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x043F0014 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04588000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x005A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x025AC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x045A4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A5B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021DC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1FA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1F002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A384000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00394000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02395000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04399000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x069B0034 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x109B0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06DC4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CBD4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CBF0981 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EBF0A0F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06D84000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CDAC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EDAC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CDB4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C9DC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E9DC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x109F02A8 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E9F0080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CB84000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CB95000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EB95000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06B92000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F88000F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D880400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x078A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x098A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B8A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x258B8009 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x278B002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x238B2A80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x198C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B8C0015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D8C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D8DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x078D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2185800A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2385002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F85AA00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B830154 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D84C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F84C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01848000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0384C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0584C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07844000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D80C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F80C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11808000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1380C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1580C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17804000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45800C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47800C63 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F8014A5 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4F800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41800045 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00100070 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFF1 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00014002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000C3FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00010002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000C7FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00004002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000D3FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00100700 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FF1F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00001402 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FC3F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x00001002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FC7F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x00000402 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000FD3F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = bdw__l3_3__avg_gpu_core_frequency__read;
    counter->max_uint64 = bdw__l3_3__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__l3_3__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__l3_3__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__l3_3__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__l3_3__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__l3_3__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__l3_3__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__l3_3__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__l3_3__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = bdw__l3_3__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = bdw__l3_3__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__l3_3__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__l3_3__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__l3_3__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank3 Active";
        counter->symbol_name = "L30Bank3Active";
        counter->desc = "The percentage of time in which slice0 L3 bank3 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__l3_3__l30_bank3_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank3 Stalled";
        counter->symbol_name = "L30Bank3Stalled";
        counter->desc = "The percentage of time in which slice0 L3 bank3 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__l3_3__l30_bank3_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice1 L3 Bank3 Active";
        counter->symbol_name = "L31Bank3Active";
        counter->desc = "The percentage of time in which slice1 L3 bank3 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__l3_3__l31_bank3_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice1 L3 Bank3 Stalled";
        counter->symbol_name = "L31Bank3Stalled";
        counter->desc = "The percentage of time in which slice1 L3 bank3 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__l3_3__l31_bank3_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__l3_3__l3_shader_throughput__read;
    counter->max_uint64 = bdw__l3_3__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__l3_3__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__l3_3__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__l3_3__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__l3_3__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__l3_3__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__l3_3__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__l3_3__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bdw__l3_3__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bdw__l3_3__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__l3_3__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__l3_3__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__l3_3__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__l3_3__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__l3_3__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__l3_3__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__l3_3__slm_bytes_read__read;
    counter->max_uint64 = bdw__l3_3__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__l3_3__slm_bytes_written__read;
    counter->max_uint64 = bdw__l3_3__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__l3_3__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__l3_3__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__l3_3__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__l3_3__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 40);
}

static void
bdw_add_l3_4_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set L3_4";
    metric_set->symbol_name = "L3_4";
    metric_set->hw_config_guid = "d7793b26-b5e3-4f0f-ad78-7ebc9d0b4c7d";
    metric_set->counters = calloc(40, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(94, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(22, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x121A0340 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x103F0017 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x123F0020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x129A0340 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10BF0017 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12BF0020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041A3400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x101A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x043B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A3E0010 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x003F0200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x023F0113 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x043F0014 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02592000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x005A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x025AC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x045A4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021DC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1FA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1F001A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00394000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02395000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04391000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x069A0034 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x109A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06BB4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0ABE0040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CBF0984 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EBF0A02 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02D94000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CDAC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EDAC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C9C0400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C9DC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E9DC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C9E0400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x109F02A8 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E9F0040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CB95000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EB95000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F88000F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D880400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x078A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x098A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B8A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x258B8009 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x278B002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x238B2A80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x198C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B8C0015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D8C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D8DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x078D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2185800A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2385002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F85AA00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B830154 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D84C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F84C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01848000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0384C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0584C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07844000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D80C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F80C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11808000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1380C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1580C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17804000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45800800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47800842 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F801084 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4F800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41800044 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00100070 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFF1 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00014002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000C3FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00010002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000C7FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00004002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000D3FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00100700 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FF1F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00001402 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FC3F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x00001002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FC7F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x00000402 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000FD3F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = bdw__l3_4__avg_gpu_core_frequency__read;
    counter->max_uint64 = bdw__l3_4__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__l3_4__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__l3_4__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__l3_4__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__l3_4__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__l3_4__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__l3_4__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__l3_4__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__l3_4__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = bdw__l3_4__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = bdw__l3_4__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__l3_4__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__l3_4__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__l3_4__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank2 Active";
        counter->symbol_name = "L30Bank2Active";
        counter->desc = "The percentage of time in which slice0 L3 bank2 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__l3_4__l30_bank2_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank2 Stalled";
        counter->symbol_name = "L30Bank2Stalled";
        counter->desc = "The percentage of time in which slice0 L3 bank2 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__l3_4__l30_bank2_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice1 L3 Bank2 Active";
        counter->symbol_name = "L31Bank2Active";
        counter->desc = "The percentage of time in which slice1 L3 bank2 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__l3_4__l31_bank2_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice1 L3 Bank2 Stalled";
        counter->symbol_name = "L31Bank2Stalled";
        counter->desc = "The percentage of time in which slice1 L3 bank2 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__l3_4__l31_bank2_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__l3_4__l3_shader_throughput__read;
    counter->max_uint64 = bdw__l3_4__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__l3_4__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__l3_4__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__l3_4__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__l3_4__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__l3_4__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__l3_4__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__l3_4__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bdw__l3_4__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bdw__l3_4__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__l3_4__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__l3_4__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__l3_4__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__l3_4__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__l3_4__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__l3_4__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__l3_4__slm_bytes_read__read;
    counter->max_uint64 = bdw__l3_4__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__l3_4__slm_bytes_written__read;
    counter->max_uint64 = bdw__l3_4__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__l3_4__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__l3_4__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__l3_4__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__l3_4__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 40);
}

static void
bdw_add_rasterizer_and_pixel_backend_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set RasterizerAndPixelBackend";
    metric_set->symbol_name = "RasterizerAndPixelBackend";
    metric_set->hw_config_guid = "da0f7875-1143-4d73-a39c-9128a951c46a";
    metric_set->counters = calloc(46, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(115, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(18, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x143B000E };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x043C55C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1E0280 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1E0408 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10390000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12397A1F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14BB000E };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04BC5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A9E0296 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C9E0008 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10B90000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12B97A1F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x063B0042 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x103B0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x083C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A3E0040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x043F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02594000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x045A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1C0400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x081E02C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1E0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1FA800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1F0260 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x101F0014 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x003905E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06390BC0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02390018 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04394000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04BB0042 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10BB0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02BC05C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08BC0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0ABE0004 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02BF8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02D91000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02DA8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x089C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x029D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x089E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E9E0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E9FA806 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x109F0142 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08B90617 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AB90BE0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02B94000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D88F000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F88000C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07888000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09888000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x018A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B8A2800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B8A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D8A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x238B52A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x258B6A95 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x278B0029 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x178C2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x198C1500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B8C0014 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x078C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x098C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x098DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B8DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F85AA80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2185AAAA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2385002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19835400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B830155 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0184C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0784C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0984C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B84C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D84C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F84C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0384C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0584C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1180C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1780C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1980C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B80C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D80C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F80C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1380C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1580C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D800444 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3D800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4F804000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43801080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45800084 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53800044 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47801080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41800840 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00006000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000F3FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00001800 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FCFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000600 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FF3F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00000180 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FFCF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00000060 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FFF3 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00000018 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FFFC };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = bdw__rasterizer_and_pixel_backend__avg_gpu_core_frequency__read;
    counter->max_uint64 = bdw__rasterizer_and_pixel_backend__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__rasterizer_and_pixel_backend__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__rasterizer_and_pixel_backend__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__rasterizer_and_pixel_backend__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__rasterizer_and_pixel_backend__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__rasterizer_and_pixel_backend__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__rasterizer_and_pixel_backend__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__rasterizer_and_pixel_backend__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__rasterizer_and_pixel_backend__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = bdw__rasterizer_and_pixel_backend__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = bdw__rasterizer_and_pixel_backend__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__rasterizer_and_pixel_backend__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__rasterizer_and_pixel_backend__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__rasterizer_and_pixel_backend__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__rasterizer_and_pixel_backend__l3_shader_throughput__read;
    counter->max_uint64 = bdw__rasterizer_and_pixel_backend__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 PS Output Available";
        counter->symbol_name = "PSOutput0Available";
        counter->desc = "The percentage of time in which slice0 PS output is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__rasterizer_and_pixel_backend__ps_output0_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe");
    }

    if (perf->devinfo.slice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice1 PS Output Available";
        counter->symbol_name = "PSOutput1Available";
        counter->desc = "The percentage of time in which slice1 PS output is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__rasterizer_and_pixel_backend__ps_output1_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Post-EarlyZ Pixel Data Ready";
        counter->symbol_name = "PixelData0Ready";
        counter->desc = "The percentage of time in which slice0 post-EarlyZ pixel data is ready (after early Z tests have been applied)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__rasterizer_and_pixel_backend__pixel_data0_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Rasterizer/Early Depth Test");
    }

    if (perf->devinfo.slice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice1 Post-EarlyZ Pixel Data Ready";
        counter->symbol_name = "PixelData1Ready";
        counter->desc = "The percentage of time in which slice1 post-EarlyZ pixel data is ready (after early Z tests have been applied)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__rasterizer_and_pixel_backend__pixel_data1_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Rasterizer/Early Depth Test");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Pixel Values Ready";
        counter->symbol_name = "PixelValues0Ready";
        counter->desc = "The percentage of time in which slice0 pixel values are ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__rasterizer_and_pixel_backend__pixel_values0_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe");
    }

    if (perf->devinfo.slice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice1 Pixel Values Ready";
        counter->symbol_name = "PixelValues1Ready";
        counter->desc = "The percentage of time in which slice1 pixel values are ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__rasterizer_and_pixel_backend__pixel_values1_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__rasterizer_and_pixel_backend__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__rasterizer_and_pixel_backend__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__rasterizer_and_pixel_backend__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__rasterizer_and_pixel_backend__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__rasterizer_and_pixel_backend__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__rasterizer_and_pixel_backend__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__rasterizer_and_pixel_backend__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Rasterizer Input Available";
        counter->symbol_name = "Rasterizer0InputAvailable";
        counter->desc = "The percentage of time in which slice0 rasterizer input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__rasterizer_and_pixel_backend__rasterizer0_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Rasterizer");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Rasterizer Output Ready";
        counter->symbol_name = "Rasterizer0OutputReady";
        counter->desc = "The percentage of time in which slice0 rasterizer output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__rasterizer_and_pixel_backend__rasterizer0_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Rasterizer");
    }

    if (perf->devinfo.slice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice1 Rasterizer Input Available";
        counter->symbol_name = "Rasterizer1InputAvailable";
        counter->desc = "The percentage of time in which slice1 rasterizer input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__rasterizer_and_pixel_backend__rasterizer1_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Rasterizer");
    }

    if (perf->devinfo.slice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice1 Rasterizer Output Ready";
        counter->symbol_name = "Rasterizer1OutputReady";
        counter->desc = "The percentage of time in which slice1 rasterizer output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__rasterizer_and_pixel_backend__rasterizer1_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Rasterizer");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bdw__rasterizer_and_pixel_backend__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bdw__rasterizer_and_pixel_backend__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__rasterizer_and_pixel_backend__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__rasterizer_and_pixel_backend__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__rasterizer_and_pixel_backend__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__rasterizer_and_pixel_backend__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__rasterizer_and_pixel_backend__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__rasterizer_and_pixel_backend__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__rasterizer_and_pixel_backend__slm_bytes_read__read;
    counter->max_uint64 = bdw__rasterizer_and_pixel_backend__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__rasterizer_and_pixel_backend__slm_bytes_written__read;
    counter->max_uint64 = bdw__rasterizer_and_pixel_backend__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__rasterizer_and_pixel_backend__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__rasterizer_and_pixel_backend__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__rasterizer_and_pixel_backend__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__rasterizer_and_pixel_backend__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 46);
}

static void
bdw_add_sampler_1_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set Sampler_1";
    metric_set->symbol_name = "Sampler_1";
    metric_set->hw_config_guid = "52c186e4-39e3-4534-87cd-41bd47763df9";
    metric_set->counters = calloc(42, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(127, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(12, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18921400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x149500AB };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18B21400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14B500AB };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18D21400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14D500AB };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CDC8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EDC4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02DCC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04DCC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1ABD00A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0ABD8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CD88000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0ED84000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04D88000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1ADB0050 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04DB8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06DB8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08DB8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0ADB4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x109F02A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C9FA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E9F00AA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18B82500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02B88000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04B84000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06B84000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08B84000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AB84000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CB88000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CB98000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EB9A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00B98000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02B9A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04B9A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06B92000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1ABA0200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02BA8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CBA8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04918000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04927300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10920000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1893000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A934000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A946000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C959000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E950098 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10950000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04B04000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04B14000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04B20073 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10B20000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04B38000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06B38000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08B34000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04B4C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02B59890 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10B50000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06D04000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06D14000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06D20073 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10D20000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18D30020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02D38000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CD34000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AD48000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04D42000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0ED59000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00D59800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10D50000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F88000E };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03888000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05888000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07888000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09888000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B888000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D880400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x278B002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x238B5500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x258B000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B8C0015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x078C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x098C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B8C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D8C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D8D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x018D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x078D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2385002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F85AA00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2185000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B830150 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D848000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F84C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01848000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0384C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0584C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07844000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D808000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F80C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11808000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1380C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1580C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17804000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47801021 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F800C64 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4F800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41800C02 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x70800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0000C000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000E7FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00003000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000F9FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000C00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FE7F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = bdw__sampler_1__avg_gpu_core_frequency__read;
    counter->max_uint64 = bdw__sampler_1__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__sampler_1__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__sampler_1__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__sampler_1__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__sampler_1__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__sampler_1__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__sampler_1__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__sampler_1__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__sampler_1__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = bdw__sampler_1__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = bdw__sampler_1__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__sampler_1__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__sampler_1__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__sampler_1__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__sampler_1__l3_shader_throughput__read;
    counter->max_uint64 = bdw__sampler_1__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__sampler_1__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__sampler_1__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__sampler_1__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__sampler_1__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__sampler_1__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__sampler_1__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__sampler_1__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    if (perf->devinfo.subslice_mask & 0x8) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice1 Subslice0 Input Available";
        counter->symbol_name = "Sampler10InputAvailable";
        counter->desc = "The percentage of time in which slice1 subslice0 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__sampler_1__sampler10_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x8) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice1 Subslice0 Sampler Output Ready";
        counter->symbol_name = "Sampler10OutputReady";
        counter->desc = "The percentage of time in which slice1 subslice0 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__sampler_1__sampler10_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x10) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice1 Subslice1 Input Available";
        counter->symbol_name = "Sampler11InputAvailable";
        counter->desc = "The percentage of time in which slice1 subslice1 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__sampler_1__sampler11_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x10) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice1 Subslice1 Sampler Output Ready";
        counter->symbol_name = "Sampler11OutputReady";
        counter->desc = "The percentage of time in which slice1 subslice1 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__sampler_1__sampler11_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x20) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice1 Subslice2 Input Available";
        counter->symbol_name = "Sampler12InputAvailable";
        counter->desc = "The percentage of time in which slice1 subslice2 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__sampler_1__sampler12_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x20) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice1 Subslice2 Sampler Output Ready";
        counter->symbol_name = "Sampler12OutputReady";
        counter->desc = "The percentage of time in which slice1 subslice2 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__sampler_1__sampler12_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bdw__sampler_1__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bdw__sampler_1__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__sampler_1__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__sampler_1__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__sampler_1__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__sampler_1__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__sampler_1__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__sampler_1__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__sampler_1__slm_bytes_read__read;
    counter->max_uint64 = bdw__sampler_1__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__sampler_1__slm_bytes_written__read;
    counter->max_uint64 = bdw__sampler_1__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__sampler_1__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__sampler_1__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__sampler_1__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__sampler_1__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 42);
}

static void
bdw_add_sampler_2_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set Sampler_2";
    metric_set->symbol_name = "Sampler_2";
    metric_set->hw_config_guid = "edcb8c31-764d-451a-9ecd-c9c89fb54f8d";
    metric_set->counters = calloc(42, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(115, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(12, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18121400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141500AB };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18321400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x143500AB };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18521400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x145500AB };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C5C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E5C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x025CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x045CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A3D00A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A3D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C588000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E584000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04588000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A5B0050 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x045B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x065B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x085B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A5B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x101F02A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1FA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1F00AA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18382500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02388000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04384000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06384000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08384000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A384000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C388000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C398000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E39A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00398000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0239A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0439A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06392000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A3A0200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x023A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C3A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04108000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04118000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04127300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10120000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1813000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A134000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A146000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C159000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E150098 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10150000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04304000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04314000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04320073 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10320000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04338000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06338000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08334000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0434C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02359890 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10350000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06504000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06514000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06520073 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10520000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18530020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02538000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C534000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A548000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04542000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E559000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00559800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10550000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B8AA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D8A0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x078A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x098A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B8A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D8A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x278B0015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x238B2A80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x258B0005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2385002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F85AA00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2185000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B830150 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D848000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F84C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01848000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0384C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0584C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07844000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D808000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F80C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11808000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1380C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1580C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17804000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47801021 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F800C64 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4F800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41800C02 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x70800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0000C000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000E7FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00003000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000F9FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000C00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FE7F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = bdw__sampler_2__avg_gpu_core_frequency__read;
    counter->max_uint64 = bdw__sampler_2__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__sampler_2__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__sampler_2__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__sampler_2__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__sampler_2__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__sampler_2__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__sampler_2__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__sampler_2__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__sampler_2__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = bdw__sampler_2__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = bdw__sampler_2__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__sampler_2__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__sampler_2__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__sampler_2__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__sampler_2__l3_shader_throughput__read;
    counter->max_uint64 = bdw__sampler_2__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__sampler_2__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__sampler_2__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__sampler_2__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__sampler_2__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__sampler_2__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__sampler_2__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__sampler_2__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice0 Input Available";
        counter->symbol_name = "Sampler00InputAvailable";
        counter->desc = "The percentage of time in which slice0 subslice0 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__sampler_2__sampler00_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice0 Sampler Output Ready";
        counter->symbol_name = "Sampler00OutputReady";
        counter->desc = "The percentage of time in which slice0 subslice0 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__sampler_2__sampler00_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice1 Input Available";
        counter->symbol_name = "Sampler01InputAvailable";
        counter->desc = "The percentage of time in which slice0 subslice1 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__sampler_2__sampler01_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice1 Sampler Output Ready";
        counter->symbol_name = "Sampler01OutputReady";
        counter->desc = "The percentage of time in which slice0 subslice1 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__sampler_2__sampler01_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice2 Input Available";
        counter->symbol_name = "Sampler02InputAvailable";
        counter->desc = "The percentage of time in which slice0 subslice2 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__sampler_2__sampler02_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice2 Sampler Output Ready";
        counter->symbol_name = "Sampler02OutputReady";
        counter->desc = "The percentage of time in which slice0 subslice2 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__sampler_2__sampler02_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bdw__sampler_2__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bdw__sampler_2__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__sampler_2__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__sampler_2__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__sampler_2__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__sampler_2__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__sampler_2__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__sampler_2__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__sampler_2__slm_bytes_read__read;
    counter->max_uint64 = bdw__sampler_2__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__sampler_2__slm_bytes_written__read;
    counter->max_uint64 = bdw__sampler_2__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__sampler_2__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__sampler_2__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__sampler_2__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__sampler_2__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 42);
}

static void
bdw_add_tdl_1_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set TDL_1";
    metric_set->symbol_name = "TDL_1";
    metric_set->hw_config_guid = "729fc3f4-ccff-4902-be6b-f1a22cc92c02";
    metric_set->counters = calloc(48, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(152, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(18, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16154D60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16352E60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16554D60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16950000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16B50000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16D50000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x005C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x045CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x065C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x083D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A3D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0458C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x025B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x085B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A5B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C5B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1FA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1F00AA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02384000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04388000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06388000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08384000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A384000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C384000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00398000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0239A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0439A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06392000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x043A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x063A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08138000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A138000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06143000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0415CFC7 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10150000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02338000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C338000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04342000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06344000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0035C700 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x063500CF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10350000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04538000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06538000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0454C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0255CFC7 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10550000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06DC8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08DC4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CDCC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EDCC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1ABD00A8 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CD8C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0ED84000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EDB8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18DB0800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1ADB0254 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E9FAA00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x109F02AA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EB84000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16B84000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18B8156A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06B98000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08B9A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AB9A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CB9A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EB9A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18BAA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1ABA0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16934000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1893000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A947000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C95C5C1 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E9500C3 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10950000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EB38000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16B30040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18B30020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06B48000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08B41000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AB48000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06B5C500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08B500C3 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EB5C100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10B50000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16D31500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08D4E000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08D5C100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AD5C3C5 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10D50000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D88F800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F88000F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x078A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x098A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B8A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D8A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x258BAAA5 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x278B002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x238B2A80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x178C2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x198C5500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B8C0015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x078D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x098DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B8DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D8DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2185AAAA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2385002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F85AA00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19835400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B830155 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0784C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0984C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B84C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D84C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F84C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01848000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0384C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0584C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1780C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1980C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B80C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D80C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F80C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11808000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1380C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1580C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4F800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43800C42 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45800063 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47800800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F8014A4 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41801042 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FDFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FE7F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FFBF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FFCF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FFF7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FFF9 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = bdw__tdl_1__avg_gpu_core_frequency__read;
    counter->max_uint64 = bdw__tdl_1__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__tdl_1__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__tdl_1__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__tdl_1__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__tdl_1__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__tdl_1__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__tdl_1__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__tdl_1__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__tdl_1__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = bdw__tdl_1__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = bdw__tdl_1__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__tdl_1__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__tdl_1__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__tdl_1__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__tdl_1__l3_shader_throughput__read;
    counter->max_uint64 = bdw__tdl_1__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    if (perf->devinfo.subslice_mask & 0x8) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "NonPS Thread Ready For Dispatch on Slice1 Subslice0";
        counter->symbol_name = "NonPSThread10ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice1 subslice0 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__tdl_1__non_ps_thread10_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x10) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "NonPS Thread Ready For Dispatch on Slice1 Subslice1";
        counter->symbol_name = "NonPSThread11ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice1 subslice1 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__tdl_1__non_ps_thread11_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x20) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "NonPS Thread Ready For Dispatch on Slice1 Subslice2";
        counter->symbol_name = "NonPSThread12ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice1 subslice2 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__tdl_1__non_ps_thread12_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x8) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice1 Subslice0";
        counter->symbol_name = "PSThread10ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice1 subslice0 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__tdl_1__ps_thread10_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x10) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice1 Subslice1";
        counter->symbol_name = "PSThread11ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice1 subslice1 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__tdl_1__ps_thread11_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x20) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice1 Subslice2";
        counter->symbol_name = "PSThread12ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice1 subslice2 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__tdl_1__ps_thread12_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__tdl_1__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__tdl_1__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__tdl_1__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__tdl_1__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__tdl_1__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__tdl_1__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__tdl_1__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bdw__tdl_1__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bdw__tdl_1__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__tdl_1__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__tdl_1__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__tdl_1__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__tdl_1__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__tdl_1__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__tdl_1__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__tdl_1__slm_bytes_read__read;
    counter->max_uint64 = bdw__tdl_1__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__tdl_1__slm_bytes_written__read;
    counter->max_uint64 = bdw__tdl_1__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice0 Port 0";
        counter->symbol_name = "ThreadHeader00ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice0 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__tdl_1__thread_header00_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice0 Port 1";
        counter->symbol_name = "ThreadHeader00ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice0 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__tdl_1__thread_header00_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice1 Port 0";
        counter->symbol_name = "ThreadHeader01ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice1 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__tdl_1__thread_header01_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice1 Port 1";
        counter->symbol_name = "ThreadHeader01ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice1 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__tdl_1__thread_header01_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice2 Port 0";
        counter->symbol_name = "ThreadHeader02ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice2 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__tdl_1__thread_header02_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice2 Port 1";
        counter->symbol_name = "ThreadHeader02ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice2 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__tdl_1__thread_header02_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__tdl_1__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__tdl_1__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__tdl_1__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__tdl_1__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 48);
}

static void
bdw_add_tdl_2_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set TDL_2";
    metric_set->symbol_name = "TDL_2";
    metric_set->hw_config_guid = "29598975-4785-43ab-a981-1dfa58d0e835";
    metric_set->counters = calloc(48, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(156, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(18, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16150000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16350000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16550000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16952E60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16B54D60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16D52E60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x065C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x085CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A5CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C5C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E3D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x183DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06588000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08588000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A584000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E5B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x185B5800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A5B000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1FAA00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x101F02AA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E384000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16384000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18382A55 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06398000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0839A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A39A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C39A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E39A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A3A02A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E138000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16130500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08146000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0615C100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0815C500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1500C3 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10150000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16335040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08349000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A341000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x083500C1 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A35C500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C3500C3 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10350000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1853002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A54E000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C55C500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E55C1C3 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10550000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00DC8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02DCC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04DC4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04BD8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06BD8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02D8C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02DB8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04DB4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06DB4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08DB8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C9FA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E9F00AA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02B84000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04B84000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06B84000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08B84000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AB88000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CB88000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00B98000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02B9A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04B9A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06B92000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0ABA8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CBA8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0494C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0295CFC7 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10950000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02B38000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08B38000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04B42000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06B41000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00B5C700 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04B500CF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10B50000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AD38000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CD38000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06D46000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04D5C700 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06D500CF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10D50000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03888000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05888000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07888000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09888000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B888000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D880400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x198A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B8AAAA0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D8A0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x258B555A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x278B0015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x238B5500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x078C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x098C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B8C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D8C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x018D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x078D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2185AAAA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2385002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F85AA00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19835400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B830155 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0784C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0984C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B84C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D84C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F84C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01848000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0384C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0584C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1780C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1980C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B80C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D80C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F80C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11808000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1380C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1580C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4F800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43800882 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45801082 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x478014A5 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F800002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41800C62 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FDFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FE7F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FF9F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FFE7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FFFB };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FFFD };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = bdw__tdl_2__avg_gpu_core_frequency__read;
    counter->max_uint64 = bdw__tdl_2__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__tdl_2__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__tdl_2__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__tdl_2__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__tdl_2__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__tdl_2__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__tdl_2__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__tdl_2__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__tdl_2__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = bdw__tdl_2__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = bdw__tdl_2__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__tdl_2__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__tdl_2__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__tdl_2__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__tdl_2__l3_shader_throughput__read;
    counter->max_uint64 = bdw__tdl_2__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "NonPS Thread Ready For Dispatch on Slice0 Subslice0";
        counter->symbol_name = "NonPSThread00ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice0 subslice0 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__tdl_2__non_ps_thread00_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "NonPS Thread Ready For Dispatch on Slice0 Subslice1";
        counter->symbol_name = "NonPSThread01ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice0 subslice1 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__tdl_2__non_ps_thread01_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "NonPS Thread Ready For Dispatch on Slice0 Subslice2";
        counter->symbol_name = "NonPSThread02ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice0 subslice2 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__tdl_2__non_ps_thread02_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice0 Subslice0";
        counter->symbol_name = "PSThread00ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice0 subslice0 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__tdl_2__ps_thread00_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice0 Subslice1";
        counter->symbol_name = "PSThread01ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice0 subslice1 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__tdl_2__ps_thread01_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice0 Subslice2";
        counter->symbol_name = "PSThread02ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice0 subslice2 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__tdl_2__ps_thread02_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__tdl_2__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__tdl_2__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__tdl_2__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__tdl_2__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__tdl_2__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__tdl_2__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__tdl_2__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bdw__tdl_2__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bdw__tdl_2__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__tdl_2__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__tdl_2__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bdw__tdl_2__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__tdl_2__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__tdl_2__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bdw__tdl_2__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__tdl_2__slm_bytes_read__read;
    counter->max_uint64 = bdw__tdl_2__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bdw__tdl_2__slm_bytes_written__read;
    counter->max_uint64 = bdw__tdl_2__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    if (perf->devinfo.subslice_mask & 0x8) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice1 Subslice0 Port 0";
        counter->symbol_name = "ThreadHeader10ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice1 subslice0 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__tdl_2__thread_header10_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x8) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice1 Subslice0 Port 1";
        counter->symbol_name = "ThreadHeader10ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice1 subslice0 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__tdl_2__thread_header10_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x10) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice1 Subslice1 Port 0";
        counter->symbol_name = "ThreadHeader11ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice1 subslice1 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__tdl_2__thread_header11_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x10) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice1 Subslice1 Port 1";
        counter->symbol_name = "ThreadHeader11ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice1 subslice1 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__tdl_2__thread_header11_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x20) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice1 Subslice2 Port 0";
        counter->symbol_name = "ThreadHeader12ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice1 subslice2 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__tdl_2__thread_header12_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x20) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice1 Subslice2 Port 1";
        counter->symbol_name = "ThreadHeader12ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice1 subslice2 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__tdl_2__thread_header12_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__tdl_2__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__tdl_2__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__tdl_2__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__tdl_2__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 48);
}

static void
bdw_add_compute_extra_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Compute Metrics Extra Gen8";
    metric_set->symbol_name = "ComputeExtra";
    metric_set->hw_config_guid = "8fb61ba2-2fbb-454c-a136-2dec5a8a595e";
    metric_set->counters = calloc(5, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(93, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(6, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x161503E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x163503E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x165503E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x169503E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16B503E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16D503E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x045CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x083D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04584000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x085B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A5B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1F00A8 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08384000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A384000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C388000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0439A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06392000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C3A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08138000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06141000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041500C3 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10150000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A338000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06342000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0435C300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10350000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C538000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06544000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x065500C3 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10550000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00DC8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02DC4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02BD8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00D88000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02DB4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04DB8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C9FA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E9F0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02B84000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04B84000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06B88000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00B98000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02B9A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06BA8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04942000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0095C300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10950000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04B38000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04B44000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02B500C3 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10B50000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06D38000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04D48000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02D5C300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10D50000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03888000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05888000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07888000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x098A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B8A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D8A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x238B3500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x258B0005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x078C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x018D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F85AA00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2185000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01848000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0384C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0584C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07844000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11808000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1380C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1580C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17804000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F800C40 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4F800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41801482 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00001000 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00003002 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00011010 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00050012 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00052051 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00000008 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = bdw__compute_extra__avg_gpu_core_frequency__read;
    counter->max_uint64 = bdw__compute_extra__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active";
    counter->symbol_name = "Fpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__compute_extra__fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active including Ext Math";
    counter->symbol_name = "Fpu1ActiveAdjusted";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing including Extended Math processing";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__compute_extra__fpu1_active_adjusted__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = bdw__compute_extra__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = bdw__compute_extra__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    assert(metric_set->n_counters <= 5);
}

static void
bdw_add_vme_pipe_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Media Vme Pipe Gen8";
    metric_set->symbol_name = "VMEPipe";
    metric_set->hw_config_guid = "e1743ca0-7fc8-410b-a066-de7bbb9280b7";
    metric_set->counters = calloc(10, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(87, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(17, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(2, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14100812 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14125800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x161200C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14300812 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14325800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x163200C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x005C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x065C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x085CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A5CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C5CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x003D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E3D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x183D2800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00584000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06588000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0858C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x005B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E5B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x185B9400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A5B002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1F0800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1FAA00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x101F002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00384000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E384000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16384000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18380155 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00392000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06398000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0839A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A39A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C39A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00100047 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06101A80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0810C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0811C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08126151 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10120000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00134000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E134000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x161300A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A301AC7 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10300000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C30C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C31C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C326151 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10320000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16332A00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18330001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x018A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x198A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B8A2AA0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x238B0020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x258B5550 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x278B0001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F850080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2185AAA0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x23850002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19835400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B830015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01844000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07848000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0984C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B84C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D84C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11804000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17808000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1980C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B80C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D80C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3D800800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4F800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43800002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45800884 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47800002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00100030 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFF9 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FFFC };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FFF3 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00100180 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FFCF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FFCF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FF3F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00008003 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = bdw__vme_pipe__avg_gpu_core_frequency__read;
    counter->max_uint64 = bdw__vme_pipe__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__vme_pipe__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__vme_pipe__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__vme_pipe__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__vme_pipe__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Thread Occupancy";
    counter->symbol_name = "EuThreadOccupancy";
    counter->desc = "The percentage of time in which hardware threads occupied EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__vme_pipe__eu_thread_occupancy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__vme_pipe__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = bdw__vme_pipe__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = bdw__vme_pipe__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VME Busy";
    counter->symbol_name = "VMEBusy";
    counter->desc = "The percentage of time in which VME (IME or CRE) was actively processing data.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__vme_pipe__vme_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "VME Pipe");

    assert(metric_set->n_counters <= 10);
}

static void
bdw_add_gpu_busyness_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Gpu Rings Busyness";
    metric_set->symbol_name = "GpuBusyness";
    metric_set->hw_config_guid = "0a9eb7be-feee-4275-a139-6d9cedf0fdb0";
    metric_set->counters = calloc(9, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(39, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1AF00100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x118B0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11850008 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17830100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A700100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D940040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02F00085 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10F00000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x24F00000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x078B0003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x238B0400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x258B0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03850500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F858800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2185000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05834055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11830000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09830000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B838000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03844000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0584C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07844000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1380C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1580C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17804000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04708500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10700000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x24700000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D801000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4F800004 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x418014A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x10800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007C000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x000007FF };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AnyRingBusy";
    counter->symbol_name = "AnyRingBusy";
    counter->desc = "The percentage of time when any command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__gpu_busyness__any_ring_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = bdw__gpu_busyness__avg_gpu_core_frequency__read;
    counter->max_uint64 = bdw__gpu_busyness__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Blitter Ring Busy";
    counter->symbol_name = "BlitterBusy";
    counter->desc = "The percentage of time when blitter command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__gpu_busyness__blitter_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = bdw__gpu_busyness__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = bdw__gpu_busyness__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Render Ring Busy";
    counter->symbol_name = "RenderBusy";
    counter->desc = "The percentage of time when render command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__gpu_busyness__render_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Vdbox0 Ring Busy";
    counter->symbol_name = "Vdbox0Busy";
    counter->desc = "The percentage of time when Vdbox0 command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__gpu_busyness__vdbox0_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Vdbox1 Ring Busy";
    counter->symbol_name = "Vdbox1Busy";
    counter->desc = "The percentage of time when Vdbox1 command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__gpu_busyness__vdbox1_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Vebox Ring Busy";
    counter->symbol_name = "VeboxBusy";
    counter->desc = "The percentage of time when vebox command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__gpu_busyness__vebox_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    assert(metric_set->n_counters <= 9);
}

static void
bdw_add_test_oa_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "MDAPI testing set Gen8";
    metric_set->symbol_name = "TestOa";
    metric_set->hw_config_guid = "d6de6f55-e526-4f79-a6a6-d7315c09044e";
    metric_set->counters = calloc(12, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(14, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(22, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x198B0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x078B0066 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x118B0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x258B0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21850008 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07844000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17804000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4F800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000004 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00000003 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000007 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00100002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FFF7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00100002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FFCF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00100082 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FFEF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x001000C2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FFE7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x00100001 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000FFE7 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = bdw__test_oa__avg_gpu_core_frequency__read;
    counter->max_uint64 = bdw__test_oa__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter0";
    counter->symbol_name = "Counter0";
    counter->desc = "HW test counter 0. Factor: 0.0";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = bdw__test_oa__counter0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter1";
    counter->symbol_name = "Counter1";
    counter->desc = "HW test counter 1. Factor: 1.0";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = bdw__test_oa__counter1__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter2";
    counter->symbol_name = "Counter2";
    counter->desc = "HW test counter 2. Factor: 1.0";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = bdw__test_oa__counter2__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter3";
    counter->symbol_name = "Counter3";
    counter->desc = "HW test counter 3. Factor: 0.5";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = bdw__test_oa__counter3__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter4";
    counter->symbol_name = "Counter4";
    counter->desc = "HW test counter 4. Factor: 0.333";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = bdw__test_oa__counter4__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter5";
    counter->symbol_name = "Counter5";
    counter->desc = "HW test counter 5. Factor: 0.333";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = bdw__test_oa__counter5__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter6";
    counter->symbol_name = "Counter6";
    counter->desc = "HW test counter 6. Factor: 0.166";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = bdw__test_oa__counter6__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter7";
    counter->symbol_name = "Counter7";
    counter->desc = "HW test counter 7. Factor: 0.666";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = bdw__test_oa__counter7__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter8";
    counter->symbol_name = "Counter8";
    counter->desc = "HW test counter 8. Should be equal to 1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = bdw__test_oa__counter8__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = bdw__test_oa__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = bdw__test_oa__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    assert(metric_set->n_counters <= 12);
}

static void
bdw_add_stc__pma_stall_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set PMA Stall";
    metric_set->symbol_name = "STC_PmaStall";
    metric_set->hw_config_guid = "e713f347-953e-4d8c-b02f-6be31df2db2b";
    metric_set->counters = calloc(11, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(34, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1F0001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001F0015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041F4AC0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x061F03D8 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x018A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x198A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B8A00A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x238B0020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x258B0550 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F850080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21850AA0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19835400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01844000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07848000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0984C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B844000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11804000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17808000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1980C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B804000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3D800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4F800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x10800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x008000E1 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x001FFFE0 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = bdw__stc__pma_stall__avg_gpu_core_frequency__read;
    counter->max_uint64 = bdw__stc__pma_stall__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__stc__pma_stall__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__stc__pma_stall__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bdw__stc__pma_stall__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = bdw__stc__pma_stall__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = bdw__stc__pma_stall__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__stc__pma_stall__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__stc__pma_stall__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__stc__pma_stall__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "STC PMA stall";
        counter->symbol_name = "StcPMAStall";
        counter->desc = "Percentage of time when stencil cache line and an overlapping pixel are causing stalls";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bdw__stc__pma_stall__stc_pma_stall__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Stencil Cache");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bdw__stc__pma_stall__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 11);
}

static void
chv_add_render_basic_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Render Metrics Basic Gen8LP";
    metric_set->symbol_name = "RenderBasic";
    metric_set->hw_config_guid = "9d8a3af5-c02c-4a4a-b947-f1672469e0fb";
    metric_set->counters = calloc(50, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(73, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(5, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59800001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x285A0006 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2C110014 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2E110000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2C310014 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2E310000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B8303DF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3580024F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00580888 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E5A0015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x205A0014 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x045A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x025A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02180500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00190555 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021D0500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021F0A00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00380444 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02390500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x003A0666 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00100111 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06110030 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A110031 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E110046 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04110000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00110000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00130111 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00300444 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08310030 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C310031 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10310046 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04310000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00310000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00330444 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038A0A00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x018B0FFF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038B0A00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01855000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03850055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13830021 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15830020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1783002F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1983002E };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B83002D };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D83002C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05830000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01840555 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03840500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x23800074 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2580007D };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01805000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03800055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01865000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03860055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01875000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03870055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x418000AA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4380000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4780000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4F800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = chv__render_basic__avg_gpu_core_frequency__read;
    counter->max_uint64 = chv__render_basic__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__render_basic__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__render_basic__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__render_basic__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__render_basic__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__render_basic__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__render_basic__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__render_basic__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = chv__render_basic__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = chv__render_basic__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__render_basic__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Depth Throughput";
    counter->symbol_name = "GtiDepthThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between depth caches and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = chv__render_basic__gti_depth_throughput__read;
    counter->max_uint64 = chv__render_basic__gti_depth_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI HDC TLB Lookup Throughput";
    counter->symbol_name = "GtiHdcLookupsThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between GTI and HDC, when HDC is doing TLB lookups.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = chv__render_basic__gti_hdc_lookups_throughput__read;
    counter->max_uint64 = chv__render_basic__gti_hdc_lookups_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI L3 Throughput";
    counter->symbol_name = "GtiL3Throughput";
    counter->desc = "The total number of GPU memory bytes transferred between L3 caches and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = chv__render_basic__gti_l3_throughput__read;
    counter->max_uint64 = chv__render_basic__gti_l3_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI RCC Throughput";
    counter->symbol_name = "GtiRccThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between render color caches and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = chv__render_basic__gti_rcc_throughput__read;
    counter->max_uint64 = chv__render_basic__gti_rcc_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Read Throughput";
    counter->symbol_name = "GtiReadThroughput";
    counter->desc = "The total number of GPU memory bytes read from GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = chv__render_basic__gti_read_throughput__read;
    counter->max_uint64 = chv__render_basic__gti_read_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Fixed Pipe Throughput";
    counter->symbol_name = "GtiVfThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between 3D Pipeline (Command Dispatch, Input Assembly and Stream Output) and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = chv__render_basic__gti_vf_throughput__read;
    counter->max_uint64 = chv__render_basic__gti_vf_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Write Throughput";
    counter->symbol_name = "GtiWriteThroughput";
    counter->desc = "The total number of GPU memory bytes written to GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = chv__render_basic__gti_write_throughput__read;
    counter->max_uint64 = chv__render_basic__gti_write_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__render_basic__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__render_basic__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Misses";
    counter->symbol_name = "L3Misses";
    counter->desc = "The total number of L3 misses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = chv__render_basic__l3_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/TAG");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Sampler Throughput";
    counter->symbol_name = "L3SamplerThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between samplers and L3 caches.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = chv__render_basic__l3_sampler_throughput__read;
    counter->max_uint64 = chv__render_basic__l3_sampler_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = chv__render_basic__l3_shader_throughput__read;
    counter->max_uint64 = chv__render_basic__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__render_basic__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__render_basic__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__render_basic__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__render_basic__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__render_basic__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__render_basic__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__render_basic__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler 0 Bottleneck";
    counter->symbol_name = "Sampler0Bottleneck";
    counter->desc = "The percentage of time in which Sampler 0 has been slowing down the pipe when processing EU requests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__render_basic__sampler0_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler 0 Busy";
    counter->symbol_name = "Sampler0Busy";
    counter->desc = "The percentage of time in which Sampler 0 has been processing EU requests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__render_basic__sampler0_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler 1 Bottleneck";
    counter->symbol_name = "Sampler1Bottleneck";
    counter->desc = "The percentage of time in which Sampler 1 has been slowing down the pipe when processing EU requests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__render_basic__sampler1_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler 1 Busy";
    counter->symbol_name = "Sampler1Busy";
    counter->desc = "The percentage of time in which Sampler 1 has been processing EU requests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__render_basic__sampler1_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samplers Bottleneck";
    counter->symbol_name = "SamplerBottleneck";
    counter->desc = "The percentage of time in which samplers have been slowing down the pipe when processing EU requests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__render_basic__sampler_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = chv__render_basic__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = chv__render_basic__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samplers Busy";
    counter->symbol_name = "SamplersBusy";
    counter->desc = "The percentage of time in which samplers have been processing EU requests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__render_basic__samplers_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__render_basic__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__render_basic__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__render_basic__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = chv__render_basic__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = chv__render_basic__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = chv__render_basic__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = chv__render_basic__slm_bytes_read__read;
    counter->max_uint64 = chv__render_basic__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = chv__render_basic__slm_bytes_written__read;
    counter->max_uint64 = chv__render_basic__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__render_basic__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__render_basic__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__render_basic__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__render_basic__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 50);
}

static void
chv_add_compute_basic_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Compute Metrics Basic Gen8LP";
    metric_set->symbol_name = "ComputeBasic";
    metric_set->hw_config_guid = "f522a89c-ecd1-4522-8331-3383c54af5f5";
    metric_set->counters = calloc(42, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(43, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(4, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59800001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2E5800E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2E3800E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3580024F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3D800140 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08580042 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C580040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1058004C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1458004B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04580000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00580000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00195555 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06380042 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A380040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E38004C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1238004B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04380000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00384444 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x003A5555 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x018BFFFF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01845555 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17800074 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1980007D };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B80007C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D8000B6 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F8000B7 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x418000AA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x438000AA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4980012A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B80012A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D80012A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4F80012A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x518001CE };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x538001CE };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x5580000E };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00000003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00002001 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00778008 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00088078 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00808708 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00A08908 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = chv__compute_basic__avg_gpu_core_frequency__read;
    counter->max_uint64 = chv__compute_basic__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__compute_basic__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__compute_basic__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__compute_basic__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__compute_basic__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU AVG IPC Rate";
    counter->symbol_name = "EuAvgIpcRate";
    counter->desc = "The average rate of IPC calculated for 2 FPU pipelines.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NUMBER;
    counter->read_float = chv__compute_basic__eu_avg_ipc_rate__read;
    counter->max_float = chv__compute_basic__eu_avg_ipc_rate__max;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__compute_basic__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Send Pipe Active";
    counter->symbol_name = "EuSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__compute_basic__eu_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__compute_basic__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Thread Occupancy";
    counter->symbol_name = "EuThreadOccupancy";
    counter->desc = "The percentage of time in which hardware threads occupied EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__compute_basic__eu_thread_occupancy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Pipe Active";
    counter->symbol_name = "Fpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__compute_basic__fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active";
    counter->symbol_name = "Fpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__compute_basic__fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__compute_basic__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = chv__compute_basic__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = chv__compute_basic__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__compute_basic__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Read Throughput";
    counter->symbol_name = "GtiReadThroughput";
    counter->desc = "The total number of GPU memory bytes read from GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = chv__compute_basic__gti_read_throughput__read;
    counter->max_uint64 = chv__compute_basic__gti_read_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Ring Throughput";
    counter->symbol_name = "GtiRingThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between GTI and Uncore ring.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = chv__compute_basic__gti_ring_throughput__read;
    counter->max_uint64 = chv__compute_basic__gti_ring_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Read-Only Stall";
    counter->symbol_name = "GtiRoStall";
    counter->desc = "The percentage of time in which GTI Read-Only port has been stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__compute_basic__gti_ro_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Read-Write Stall";
    counter->symbol_name = "GtiRwStall";
    counter->desc = "The percentage of time in which GTI Read-Write port has been stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__compute_basic__gti_rw_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Write Throughput";
    counter->symbol_name = "GtiWriteThroughput";
    counter->desc = "The total number of GPU memory bytes written to GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = chv__compute_basic__gti_write_throughput__read;
    counter->max_uint64 = chv__compute_basic__gti_write_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__compute_basic__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__compute_basic__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = chv__compute_basic__l3_shader_throughput__read;
    counter->max_uint64 = chv__compute_basic__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__compute_basic__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__compute_basic__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__compute_basic__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = chv__compute_basic__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = chv__compute_basic__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__compute_basic__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__compute_basic__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__compute_basic__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = chv__compute_basic__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = chv__compute_basic__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = chv__compute_basic__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = chv__compute_basic__slm_bytes_read__read;
    counter->max_uint64 = chv__compute_basic__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = chv__compute_basic__slm_bytes_written__read;
    counter->max_uint64 = chv__compute_basic__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Bytes Read";
    counter->symbol_name = "TypedBytesRead";
    counter->desc = "The total number of typed memory bytes read via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = chv__compute_basic__typed_bytes_read__read;
    counter->max_uint64 = chv__compute_basic__typed_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Bytes Written";
    counter->symbol_name = "TypedBytesWritten";
    counter->desc = "The total number of untyped memory bytes written via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = chv__compute_basic__typed_bytes_written__read;
    counter->max_uint64 = chv__compute_basic__typed_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Untyped Bytes Read";
    counter->symbol_name = "UntypedBytesRead";
    counter->desc = "The total number of typed memory bytes read via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = chv__compute_basic__untyped_bytes_read__read;
    counter->max_uint64 = chv__compute_basic__untyped_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Untyped Writes";
    counter->symbol_name = "UntypedBytesWritten";
    counter->desc = "The total number of untyped memory bytes written via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = chv__compute_basic__untyped_bytes_written__read;
    counter->max_uint64 = chv__compute_basic__untyped_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__compute_basic__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 42);
}

static void
chv_add_render_pipe_profile_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Render Metrics for 3D Pipeline Profile";
    metric_set->symbol_name = "RenderPipeProfile";
    metric_set->hw_config_guid = "a9ccc03d-a943-4e6b-9cd6-13e063075927";
    metric_set->counters = calloc(44, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(82, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(20, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59800001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x261E0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x281F000F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2817001A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2791001F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x27880019 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D890000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x278A0007 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x298D001F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x278E0020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B8F0012 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x29900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00184000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02181000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02194000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141E0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041E0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001E0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x221F0015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x023A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0213C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02164000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x24170012 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04170000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07910005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05910000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01911500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03910501 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D880002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D880003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05880000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B890032 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B890031 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05890000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01890040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03890040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x098A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x198A0004 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x018A8050 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038A2050 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x018B95A9 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038BE5A9 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x018C1500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038C0501 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x178D0015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058D0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x138E0004 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x218E000C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058E0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x018E0500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038E0101 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8F0027 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x018F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038F0001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11900013 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F900017 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01900100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03900001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01845555 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03845555 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x418000AA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x438000AA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x458000AA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x478000AA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4980018C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B80014B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D800128 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4F80012A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51800187 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x5380014B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55800149 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x5780010A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007FFEA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x00007FFC };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x0007AFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000F5FD };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00079FFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000F3FB };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x0007BF7A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000F7E7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x0007FEFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000F7CF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00077FFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000EFDF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x0006FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000CFBF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x0003FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x00005F7F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00025024 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00035034 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00045044 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00055054 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00065064 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = chv__render_pipe_profile__avg_gpu_core_frequency__read;
    counter->max_uint64 = chv__render_pipe_profile__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "BC Bottleneck";
    counter->symbol_name = "BcBottleneck";
    counter->desc = "The percentage of time in which barycentric coordinates calculation pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__render_pipe_profile__bc_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Barycentric Calc");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Clipper Bottleneck";
    counter->symbol_name = "ClBottleneck";
    counter->desc = "The percentage of time in which clipper pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__render_pipe_profile__cl_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Clipper");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CL Stall";
    counter->symbol_name = "ClStall";
    counter->desc = "The percentage of time in which clipper pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__render_pipe_profile__cl_stall__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Clipper");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__render_pipe_profile__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Bottleneck";
    counter->symbol_name = "DsBottleneck";
    counter->desc = "The percentage of time in which domain shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__render_pipe_profile__ds_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Stall";
    counter->symbol_name = "DsStall";
    counter->desc = "The percentage of time in which domain shader pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__render_pipe_profile__ds_stall__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__render_pipe_profile__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Bottleneck";
    counter->symbol_name = "EarlyDepthBottleneck";
    counter->desc = "The percentage of time in which early depth test pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__render_pipe_profile__early_depth_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__render_pipe_profile__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__render_pipe_profile__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__render_pipe_profile__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__render_pipe_profile__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = chv__render_pipe_profile__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = chv__render_pipe_profile__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Bottleneck";
    counter->symbol_name = "GsBottleneck";
    counter->desc = "The percentage of time in which geometry shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__render_pipe_profile__gs_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__render_pipe_profile__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Hi-Depth Bottleneck";
    counter->symbol_name = "HiDepthBottleneck";
    counter->desc = "The percentage of time in which early hierarchical depth test pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__render_pipe_profile__hi_depth_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__render_pipe_profile__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Bottleneck";
    counter->symbol_name = "HsBottleneck";
    counter->desc = "The percentage of time in which hull shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__render_pipe_profile__hs_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Stall";
    counter->symbol_name = "HsStall";
    counter->desc = "The percentage of time in which hull stall pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__render_pipe_profile__hs_stall__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__render_pipe_profile__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = chv__render_pipe_profile__l3_shader_throughput__read;
    counter->max_uint64 = chv__render_pipe_profile__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__render_pipe_profile__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__render_pipe_profile__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__render_pipe_profile__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Accesses";
    counter->symbol_name = "SamplerAccesses";
    counter->desc = "The total number of messages send to samplers.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = chv__render_pipe_profile__sampler_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = chv__render_pipe_profile__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = chv__render_pipe_profile__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__render_pipe_profile__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__render_pipe_profile__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__render_pipe_profile__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Strip-Fans Bottleneck";
    counter->symbol_name = "SfBottleneck";
    counter->desc = "The percentage of time in which strip-fans pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__render_pipe_profile__sf_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Strip-Fans");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SF Stall";
    counter->symbol_name = "SfStall";
    counter->desc = "The percentage of time in which strip-fans pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__render_pipe_profile__sf_stall__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Strip-Fans");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = chv__render_pipe_profile__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = chv__render_pipe_profile__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = chv__render_pipe_profile__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = chv__render_pipe_profile__slm_bytes_read__read;
    counter->max_uint64 = chv__render_pipe_profile__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = chv__render_pipe_profile__slm_bytes_written__read;
    counter->max_uint64 = chv__render_pipe_profile__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SO Bottleneck";
    counter->symbol_name = "SoBottleneck";
    counter->desc = "The percentage of time in which stream output pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__render_pipe_profile__so_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Stream Output");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SO Stall";
    counter->symbol_name = "SoStall";
    counter->desc = "The percentage of time in which stream-output pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__render_pipe_profile__so_stall__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Stream Output");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VF Bottleneck";
    counter->symbol_name = "VfBottleneck";
    counter->desc = "The percentage of time in which vertex fetch pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__render_pipe_profile__vf_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Input Assembler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Bottleneck";
    counter->symbol_name = "VsBottleneck";
    counter->desc = "The percentage of time in which vertex shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__render_pipe_profile__vs_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__render_pipe_profile__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 44);
}

static void
chv_add_hdc_and_sf_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set HDCAndSF";
    metric_set->symbol_name = "HDCAndSF";
    metric_set->hw_config_guid = "33af8252-7a51-4aa3-b0ba-1b946f209d7b";
    metric_set->counters = calloc(43, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(99, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(8, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x105C0232 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10580232 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10380232 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10DC0232 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10D80232 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10B80232 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x118E4400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x025C6080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x045C004B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x005C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00582080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0258004B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x025B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x045B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1FA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1F00AA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04386080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0638404B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02384000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08384000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A380000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C380000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00398000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0239A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0439A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06392000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CDC25C1 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0ADCC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AD825C1 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18DB4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1ADB0001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E9F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x109F02AA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EB825C1 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18B80154 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AB9A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CB9A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EB9A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D88C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F88000F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x078A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x098A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B8A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D8A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x258BAA05 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x278B002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x238B2A80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x198C5400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B8C0015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x098DC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B8DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D8DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x098E05C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058E0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x198F0020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2185AA0A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2385002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F85AA00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19835000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B830155 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09848000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B84C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D84C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F84C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01848000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0384C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0584C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07844000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19808000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B80C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D80C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F80C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11808000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1380C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1580C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17804000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51800040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43800400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45800800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47800C62 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F801042 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4F800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x418014A4 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x10800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFF7 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = chv__hdc_and_sf__avg_gpu_core_frequency__read;
    counter->max_uint64 = chv__hdc_and_sf__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__hdc_and_sf__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__hdc_and_sf__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__hdc_and_sf__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__hdc_and_sf__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__hdc_and_sf__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__hdc_and_sf__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__hdc_and_sf__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__hdc_and_sf__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = chv__hdc_and_sf__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = chv__hdc_and_sf__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__hdc_and_sf__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__hdc_and_sf__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__hdc_and_sf__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = chv__hdc_and_sf__l3_shader_throughput__read;
    counter->max_uint64 = chv__hdc_and_sf__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "HDC stalled by L3 (s0.ss0)";
        counter->symbol_name = "NonSamplerShader00AccessStalledOnL3";
        counter->desc = "Percentage of time when HDC has messges to L3, but it's stalled due to lack of credits (s0.ss0)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__hdc_and_sf__non_sampler_shader00_access_stalled_on_l3__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Data Port");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "HDC stalled by L3 (s0.ss1)";
        counter->symbol_name = "NonSamplerShader01AccessStalledOnL3";
        counter->desc = "Percentage of time when HDC has messges to L3, but it's stalled due to lack of credits (s0.ss1)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__hdc_and_sf__non_sampler_shader01_access_stalled_on_l3__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Data Port");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "HDC stalled by L3 (s0.ss2)";
        counter->symbol_name = "NonSamplerShader02AccessStalledOnL3";
        counter->desc = "Percentage of time when HDC has messges to L3, but it's stalled due to lack of credits (s0.ss2)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__hdc_and_sf__non_sampler_shader02_access_stalled_on_l3__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Data Port");
    }

    if (perf->devinfo.subslice_mask & 0x8) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "HDC stalled by L3 (s0.ss0)";
        counter->symbol_name = "NonSamplerShader10AccessStalledOnL3";
        counter->desc = "Percentage of time when HDC has messges to L3, but it's stalled due to lack of credits (s0.ss0)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__hdc_and_sf__non_sampler_shader10_access_stalled_on_l3__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Data Port");
    }

    if (perf->devinfo.subslice_mask & 0x10) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "HDC stalled by L3 (s0.ss1)";
        counter->symbol_name = "NonSamplerShader11AccessStalledOnL3";
        counter->desc = "Percentage of time when HDC has messges to L3, but it's stalled due to lack of credits (s0.ss1)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__hdc_and_sf__non_sampler_shader11_access_stalled_on_l3__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Data Port");
    }

    if (perf->devinfo.subslice_mask & 0x20) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "HDC stalled by L3 (s0.ss2)";
        counter->symbol_name = "NonSamplerShader12AccessStalledOnL3";
        counter->desc = "Percentage of time when HDC has messges to L3, but it's stalled due to lack of credits (s0.ss2)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__hdc_and_sf__non_sampler_shader12_access_stalled_on_l3__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Data Port");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__hdc_and_sf__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Polygon Data Ready";
    counter->symbol_name = "PolyDataReady";
    counter->desc = "The percentage of time in which geometry pipeline output is ready";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__hdc_and_sf__poly_data_ready__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe/Strip-Fans");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__hdc_and_sf__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__hdc_and_sf__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__hdc_and_sf__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__hdc_and_sf__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__hdc_and_sf__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__hdc_and_sf__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = chv__hdc_and_sf__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = chv__hdc_and_sf__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__hdc_and_sf__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__hdc_and_sf__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__hdc_and_sf__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = chv__hdc_and_sf__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = chv__hdc_and_sf__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = chv__hdc_and_sf__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = chv__hdc_and_sf__slm_bytes_read__read;
    counter->max_uint64 = chv__hdc_and_sf__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = chv__hdc_and_sf__slm_bytes_written__read;
    counter->max_uint64 = chv__hdc_and_sf__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__hdc_and_sf__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__hdc_and_sf__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__hdc_and_sf__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__hdc_and_sf__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 43);
}

static void
chv_add_l3_1_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set L3_1";
    metric_set->symbol_name = "L3_1";
    metric_set->hw_config_guid = "78f52900-5317-4417-8067-966fbf215a1f";
    metric_set->counters = calloc(40, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(92, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(22, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10BF03DA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14BF0001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12980340 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12990340 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CBF1187 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EBF1205 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00BF0500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02BF042B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04BF002C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CDAC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EDAC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00DA8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02DAC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04DA4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04983400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10980000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06990034 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10990000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C9DC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E9DC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x009D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x029DC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x049D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x109F02A8 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C9FA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E9F00BA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CB88000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CB95000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EB95000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00B94000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02B95000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04B91000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06B92000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CBA4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F88000F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03888000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05888000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07888000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09888000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B888000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D880400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x258B800A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x278B002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x238B5500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x198C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B8C0015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x078C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x098C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B8C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D8C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D8DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x018D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x078D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2185800A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2385002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F85AA00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B830154 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D84C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F84C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01848000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0384C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0584C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07844000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D80C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F80C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11808000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1380C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1580C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17804000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4F800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41800060 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00100070 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFF1 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00014002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000C3FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00010002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000C7FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00004002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000D3FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00100700 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FF1F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00001402 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FC3F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x00001002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FC7F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x00000402 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000FD3F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = chv__l3_1__avg_gpu_core_frequency__read;
    counter->max_uint64 = chv__l3_1__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__l3_1__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__l3_1__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__l3_1__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__l3_1__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__l3_1__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__l3_1__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__l3_1__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__l3_1__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = chv__l3_1__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = chv__l3_1__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__l3_1__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__l3_1__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__l3_1__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    if (perf->devinfo.slice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice1 L3 Bank0 Active";
        counter->symbol_name = "L31Bank0Active";
        counter->desc = "The percentage of time in which slice1 L3 bank0 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__l3_1__l31_bank0_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice1 L3 Bank0 Stalled";
        counter->symbol_name = "L31Bank0Stalled";
        counter->desc = "The percentage of time in which slice1 L3 bank0 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__l3_1__l31_bank0_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice1 L3 Bank1 Active";
        counter->symbol_name = "L31Bank1Active";
        counter->desc = "The percentage of time in which slice1 L3 bank1 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__l3_1__l31_bank1_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice1 L3 Bank1 Stalled";
        counter->symbol_name = "L31Bank1Stalled";
        counter->desc = "The percentage of time in which slice1 L3 bank1 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__l3_1__l31_bank1_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = chv__l3_1__l3_shader_throughput__read;
    counter->max_uint64 = chv__l3_1__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__l3_1__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__l3_1__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__l3_1__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__l3_1__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__l3_1__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__l3_1__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__l3_1__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = chv__l3_1__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = chv__l3_1__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__l3_1__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__l3_1__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__l3_1__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = chv__l3_1__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = chv__l3_1__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = chv__l3_1__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = chv__l3_1__slm_bytes_read__read;
    counter->max_uint64 = chv__l3_1__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = chv__l3_1__slm_bytes_written__read;
    counter->max_uint64 = chv__l3_1__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__l3_1__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__l3_1__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__l3_1__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__l3_1__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 40);
}

static void
chv_add_l3_2_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set L3_2";
    metric_set->symbol_name = "L3_2";
    metric_set->hw_config_guid = "0db4fe4a-2648-4064-bd6a-89c06d0c27b3";
    metric_set->counters = calloc(40, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(79, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(22, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x103F03DA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x143F0001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12180340 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12190340 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C3F1187 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E3F1205 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x003F0500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x023F042B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x043F002C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C5AC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E5AC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x005A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x025AC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x045A4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04183400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10180000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06190034 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10190000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1DC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1DC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021DC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x101F02A8 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1FA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1F00BA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C388000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C395000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E395000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00394000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02395000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04391000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06392000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C3A4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B8AA800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D8A0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x078A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x098A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B8A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D8A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x258B4005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x278B0015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x238B2A80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2185800A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2385002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F85AA00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B830154 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D84C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F84C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01848000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0384C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0584C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07844000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D80C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F80C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11808000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1380C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1580C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17804000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4F800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41800060 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00100070 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFF1 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00014002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000C3FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00010002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000C7FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00004002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000D3FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00100700 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FF1F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00001402 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FC3F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x00001002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FC7F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x00000402 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000FD3F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = chv__l3_2__avg_gpu_core_frequency__read;
    counter->max_uint64 = chv__l3_2__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__l3_2__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__l3_2__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__l3_2__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__l3_2__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__l3_2__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__l3_2__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__l3_2__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__l3_2__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = chv__l3_2__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = chv__l3_2__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__l3_2__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__l3_2__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__l3_2__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank0 Active";
        counter->symbol_name = "L30Bank0Active";
        counter->desc = "The percentage of time in which slice0 L3 bank0 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__l3_2__l30_bank0_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank0 Stalled";
        counter->symbol_name = "L30Bank0Stalled";
        counter->desc = "The percentage of time in which slice0 L3 bank0 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__l3_2__l30_bank0_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank1 Active";
        counter->symbol_name = "L30Bank1Active";
        counter->desc = "The percentage of time in which slice0 L3 bank1 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__l3_2__l30_bank1_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank1 Stalled";
        counter->symbol_name = "L30Bank1Stalled";
        counter->desc = "The percentage of time in which slice0 L3 bank1 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__l3_2__l30_bank1_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = chv__l3_2__l3_shader_throughput__read;
    counter->max_uint64 = chv__l3_2__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__l3_2__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__l3_2__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__l3_2__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__l3_2__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__l3_2__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__l3_2__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__l3_2__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = chv__l3_2__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = chv__l3_2__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__l3_2__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__l3_2__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__l3_2__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = chv__l3_2__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = chv__l3_2__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = chv__l3_2__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = chv__l3_2__slm_bytes_read__read;
    counter->max_uint64 = chv__l3_2__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = chv__l3_2__slm_bytes_written__read;
    counter->max_uint64 = chv__l3_2__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__l3_2__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__l3_2__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__l3_2__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__l3_2__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 40);
}

static void
chv_add_l3_3_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set L3_3";
    metric_set->symbol_name = "L3_3";
    metric_set->hw_config_guid = "0de6539e-33b4-4aee-83c4-9ab45a579b94";
    metric_set->counters = calloc(40, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(95, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(22, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x121B0340 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x103F0274 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x123F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x129B0340 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10BF0274 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12BF0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041B3400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x101B0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x045C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A3D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x003F0080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x023F0793 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x043F0014 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04588000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x005A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x025AC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x045A4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A5B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021DC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1FA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1F002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A384000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00394000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02395000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04399000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x069B0034 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x109B0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06DC4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CBD4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CBF0981 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EBF0A0F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06D84000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CDAC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EDAC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CDB4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C9DC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E9DC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x109F02A8 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E9F0080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CB84000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CB95000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EB95000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06B92000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F88000F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D880400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x078A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x098A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B8A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x258B8009 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x278B002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x238B2A80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x198C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B8C0015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D8C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D8DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x078D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2185800A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2385002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F85AA00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B830154 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D84C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F84C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01848000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0384C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0584C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07844000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D80C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F80C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11808000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1380C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1580C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17804000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45800C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47800C63 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F8014A5 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4F800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41800045 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00100070 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFF1 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00014002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000C3FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00010002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000C7FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00004002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000D3FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00100700 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FF1F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00001402 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FC3F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x00001002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FC7F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x00000402 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000FD3F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = chv__l3_3__avg_gpu_core_frequency__read;
    counter->max_uint64 = chv__l3_3__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__l3_3__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__l3_3__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__l3_3__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__l3_3__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__l3_3__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__l3_3__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__l3_3__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__l3_3__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = chv__l3_3__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = chv__l3_3__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__l3_3__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__l3_3__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__l3_3__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank3 Active";
        counter->symbol_name = "L30Bank3Active";
        counter->desc = "The percentage of time in which slice0 L3 bank3 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__l3_3__l30_bank3_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank3 Stalled";
        counter->symbol_name = "L30Bank3Stalled";
        counter->desc = "The percentage of time in which slice0 L3 bank3 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__l3_3__l30_bank3_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice1 L3 Bank3 Active";
        counter->symbol_name = "L31Bank3Active";
        counter->desc = "The percentage of time in which slice1 L3 bank3 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__l3_3__l31_bank3_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice1 L3 Bank3 Stalled";
        counter->symbol_name = "L31Bank3Stalled";
        counter->desc = "The percentage of time in which slice1 L3 bank3 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__l3_3__l31_bank3_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = chv__l3_3__l3_shader_throughput__read;
    counter->max_uint64 = chv__l3_3__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__l3_3__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__l3_3__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__l3_3__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__l3_3__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__l3_3__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__l3_3__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__l3_3__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = chv__l3_3__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = chv__l3_3__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__l3_3__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__l3_3__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__l3_3__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = chv__l3_3__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = chv__l3_3__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = chv__l3_3__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = chv__l3_3__slm_bytes_read__read;
    counter->max_uint64 = chv__l3_3__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = chv__l3_3__slm_bytes_written__read;
    counter->max_uint64 = chv__l3_3__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__l3_3__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__l3_3__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__l3_3__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__l3_3__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 40);
}

static void
chv_add_l3_4_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set L3_4";
    metric_set->symbol_name = "L3_4";
    metric_set->hw_config_guid = "be74c9d6-268f-4d7f-b2e8-8d91d4441883";
    metric_set->counters = calloc(40, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(94, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(22, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x121A0340 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x103F0017 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x123F0020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x129A0340 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10BF0017 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12BF0020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041A3400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x101A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x043B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A3E0010 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x003F0200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x023F0113 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x043F0014 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02592000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x005A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x025AC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x045A4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021DC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1FA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1F001A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00394000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02395000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04391000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x069A0034 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x109A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06BB4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0ABE0040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CBF0984 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EBF0A02 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02D94000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CDAC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EDAC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C9C0400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C9DC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E9DC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C9E0400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x109F02A8 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E9F0040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CB95000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EB95000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F88000F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D880400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x078A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x098A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B8A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x258B8009 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x278B002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x238B2A80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x198C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B8C0015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D8C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D8DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x078D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2185800A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2385002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F85AA00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B830154 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D84C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F84C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01848000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0384C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0584C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07844000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D80C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F80C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11808000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1380C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1580C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17804000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45800800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47800842 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F801084 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4F800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41800044 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00100070 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFF1 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00014002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000C3FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00010002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000C7FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00004002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000D3FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00100700 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FF1F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00001402 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FC3F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x00001002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FC7F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x00000402 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000FD3F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = chv__l3_4__avg_gpu_core_frequency__read;
    counter->max_uint64 = chv__l3_4__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__l3_4__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__l3_4__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__l3_4__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__l3_4__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__l3_4__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__l3_4__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__l3_4__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__l3_4__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = chv__l3_4__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = chv__l3_4__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__l3_4__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__l3_4__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__l3_4__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank2 Active";
        counter->symbol_name = "L30Bank2Active";
        counter->desc = "The percentage of time in which slice0 L3 bank2 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__l3_4__l30_bank2_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank2 Stalled";
        counter->symbol_name = "L30Bank2Stalled";
        counter->desc = "The percentage of time in which slice0 L3 bank2 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__l3_4__l30_bank2_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice1 L3 Bank2 Active";
        counter->symbol_name = "L31Bank2Active";
        counter->desc = "The percentage of time in which slice1 L3 bank2 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__l3_4__l31_bank2_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice1 L3 Bank2 Stalled";
        counter->symbol_name = "L31Bank2Stalled";
        counter->desc = "The percentage of time in which slice1 L3 bank2 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__l3_4__l31_bank2_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = chv__l3_4__l3_shader_throughput__read;
    counter->max_uint64 = chv__l3_4__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__l3_4__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__l3_4__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__l3_4__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__l3_4__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__l3_4__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__l3_4__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__l3_4__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = chv__l3_4__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = chv__l3_4__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__l3_4__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__l3_4__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__l3_4__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = chv__l3_4__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = chv__l3_4__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = chv__l3_4__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = chv__l3_4__slm_bytes_read__read;
    counter->max_uint64 = chv__l3_4__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = chv__l3_4__slm_bytes_written__read;
    counter->max_uint64 = chv__l3_4__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__l3_4__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__l3_4__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__l3_4__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__l3_4__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 40);
}

static void
chv_add_rasterizer_and_pixel_backend_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set RasterizerAndPixelBackend";
    metric_set->symbol_name = "RasterizerAndPixelBackend";
    metric_set->hw_config_guid = "31bc1ff3-8d09-4497-9d79-59c4f943b502";
    metric_set->counters = calloc(46, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(115, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(18, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x143B000E };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x043C55C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1E0280 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1E0408 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10390000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12397A1F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14BB000E };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04BC5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A9E0296 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C9E0008 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10B90000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12B97A1F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x063B0042 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x103B0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x083C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A3E0040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x043F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02594000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x045A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1C0400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x081E02C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1E0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1FA800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1F0260 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x101F0014 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x003905E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06390BC0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02390018 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04394000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04BB0042 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10BB0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02BC05C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08BC0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0ABE0004 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02BF8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02D91000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02DA8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x089C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x029D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x089E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E9E0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E9FA806 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x109F0142 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08B90617 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AB90BE0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02B94000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D88F000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F88000C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07888000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09888000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x018A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B8A2800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B8A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D8A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x238B52A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x258B6A95 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x278B0029 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x178C2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x198C1500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B8C0014 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x078C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x098C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x098DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B8DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F85AA80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2185AAAA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2385002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19835400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B830155 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0184C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0784C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0984C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B84C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D84C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F84C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0384C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0584C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1180C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1780C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1980C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B80C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D80C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F80C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1380C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1580C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D800444 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3D800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4F804000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43801080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45800084 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53800044 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47801080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41800840 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00006000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000F3FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00001800 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FCFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000600 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FF3F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00000180 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FFCF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00000060 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FFF3 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00000018 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FFFC };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = chv__rasterizer_and_pixel_backend__avg_gpu_core_frequency__read;
    counter->max_uint64 = chv__rasterizer_and_pixel_backend__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__rasterizer_and_pixel_backend__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__rasterizer_and_pixel_backend__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__rasterizer_and_pixel_backend__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__rasterizer_and_pixel_backend__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__rasterizer_and_pixel_backend__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__rasterizer_and_pixel_backend__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__rasterizer_and_pixel_backend__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__rasterizer_and_pixel_backend__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = chv__rasterizer_and_pixel_backend__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = chv__rasterizer_and_pixel_backend__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__rasterizer_and_pixel_backend__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__rasterizer_and_pixel_backend__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__rasterizer_and_pixel_backend__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = chv__rasterizer_and_pixel_backend__l3_shader_throughput__read;
    counter->max_uint64 = chv__rasterizer_and_pixel_backend__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 PS Output Available";
        counter->symbol_name = "PSOutput0Available";
        counter->desc = "The percentage of time in which slice0 PS output is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__rasterizer_and_pixel_backend__ps_output0_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe");
    }

    if (perf->devinfo.slice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice1 PS Output Available";
        counter->symbol_name = "PSOutput1Available";
        counter->desc = "The percentage of time in which slice1 PS output is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__rasterizer_and_pixel_backend__ps_output1_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Post-EarlyZ Pixel Data Ready";
        counter->symbol_name = "PixelData0Ready";
        counter->desc = "The percentage of time in which slice0 post-EarlyZ pixel data is ready (after early Z tests have been applied))";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__rasterizer_and_pixel_backend__pixel_data0_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Rasterizer/Early Depth Test");
    }

    if (perf->devinfo.slice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice1 Post-EarlyZ Pixel Data Ready";
        counter->symbol_name = "PixelData1Ready";
        counter->desc = "The percentage of time in which slice1 post-EarlyZ pixel data is ready (after early Z tests have been applied)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__rasterizer_and_pixel_backend__pixel_data1_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Rasterizer/Early Depth Test");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Pixel Values Ready";
        counter->symbol_name = "PixelValues0Ready";
        counter->desc = "The percentage of time in which slice0 pixel values are ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__rasterizer_and_pixel_backend__pixel_values0_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe");
    }

    if (perf->devinfo.slice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice1 Pixel Values Ready";
        counter->symbol_name = "PixelValues1Ready";
        counter->desc = "The percentage of time in which slice1 pixel values are ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__rasterizer_and_pixel_backend__pixel_values1_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__rasterizer_and_pixel_backend__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__rasterizer_and_pixel_backend__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__rasterizer_and_pixel_backend__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__rasterizer_and_pixel_backend__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__rasterizer_and_pixel_backend__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__rasterizer_and_pixel_backend__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__rasterizer_and_pixel_backend__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Rasterizer Input Available";
        counter->symbol_name = "Rasterizer0InputAvailable";
        counter->desc = "The percentage of time in which slice0 rasterizer input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__rasterizer_and_pixel_backend__rasterizer0_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Rasterizer");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Rasterizer Output Ready";
        counter->symbol_name = "Rasterizer0OutputReady";
        counter->desc = "The percentage of time in which slice0 rasterizer output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__rasterizer_and_pixel_backend__rasterizer0_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Rasterizer");
    }

    if (perf->devinfo.slice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice1 Rasterizer Input Available";
        counter->symbol_name = "Rasterizer1InputAvailable";
        counter->desc = "The percentage of time in which slice1 rasterizer input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__rasterizer_and_pixel_backend__rasterizer1_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Rasterizer");
    }

    if (perf->devinfo.slice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice1 Rasterizer Output Ready";
        counter->symbol_name = "Rasterizer1OutputReady";
        counter->desc = "The percentage of time in which slice1 rasterizer output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__rasterizer_and_pixel_backend__rasterizer1_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Rasterizer");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = chv__rasterizer_and_pixel_backend__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = chv__rasterizer_and_pixel_backend__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__rasterizer_and_pixel_backend__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__rasterizer_and_pixel_backend__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__rasterizer_and_pixel_backend__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = chv__rasterizer_and_pixel_backend__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = chv__rasterizer_and_pixel_backend__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = chv__rasterizer_and_pixel_backend__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = chv__rasterizer_and_pixel_backend__slm_bytes_read__read;
    counter->max_uint64 = chv__rasterizer_and_pixel_backend__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = chv__rasterizer_and_pixel_backend__slm_bytes_written__read;
    counter->max_uint64 = chv__rasterizer_and_pixel_backend__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__rasterizer_and_pixel_backend__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__rasterizer_and_pixel_backend__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__rasterizer_and_pixel_backend__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__rasterizer_and_pixel_backend__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 46);
}

static void
chv_add_sampler_1_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set Sampler_1";
    metric_set->symbol_name = "Sampler_1";
    metric_set->hw_config_guid = "05450fec-bb5c-4b0a-8995-e03631168a34";
    metric_set->counters = calloc(42, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(127, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(12, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18921400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x149500AB };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18B21400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14B500AB };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18D21400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14D500AB };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CDC8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EDC4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02DCC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04DCC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1ABD00A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0ABD8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CD88000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0ED84000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04D88000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1ADB0050 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04DB8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06DB8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08DB8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0ADB4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x109F02A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C9FA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E9F00AA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18B82500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02B88000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04B84000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06B84000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08B84000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AB84000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CB88000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CB98000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EB9A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00B98000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02B9A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04B9A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06B92000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1ABA0200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02BA8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CBA8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04918000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04927300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10920000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1893000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A934000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A946000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C959000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E950098 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10950000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04B04000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04B14000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04B20073 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10B20000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04B38000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06B38000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08B34000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04B4C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02B59890 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10B50000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06D04000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06D14000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06D20073 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10D20000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18D30020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02D38000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CD34000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AD48000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04D42000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0ED59000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00D59800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10D50000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F88000E };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03888000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05888000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07888000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09888000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B888000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D880400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x278B002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x238B5500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x258B000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B8C0015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x078C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x098C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B8C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D8C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D8D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x018D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x078D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2385002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F85AA00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2185000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B830150 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D848000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F84C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01848000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0384C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0584C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07844000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D808000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F80C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11808000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1380C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1580C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17804000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47801021 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F800C64 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4F800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41800C02 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x70800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0000C000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000E7FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00003000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000F9FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000C00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FE7F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = chv__sampler_1__avg_gpu_core_frequency__read;
    counter->max_uint64 = chv__sampler_1__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__sampler_1__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__sampler_1__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__sampler_1__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__sampler_1__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__sampler_1__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__sampler_1__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__sampler_1__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__sampler_1__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = chv__sampler_1__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = chv__sampler_1__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__sampler_1__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__sampler_1__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__sampler_1__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = chv__sampler_1__l3_shader_throughput__read;
    counter->max_uint64 = chv__sampler_1__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__sampler_1__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__sampler_1__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__sampler_1__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__sampler_1__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__sampler_1__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__sampler_1__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__sampler_1__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    if (perf->devinfo.subslice_mask & 0x8) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice1 Subslice0 Input Available";
        counter->symbol_name = "Sampler10InputAvailable";
        counter->desc = "The percentage of time in which slice1 subslice0 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__sampler_1__sampler10_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x8) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice1 Subslice0 Sampler Output Ready";
        counter->symbol_name = "Sampler10OutputReady";
        counter->desc = "The percentage of time in which slice1 subslice0 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__sampler_1__sampler10_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x10) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice1 Subslice1 Input Available";
        counter->symbol_name = "Sampler11InputAvailable";
        counter->desc = "The percentage of time in which slice1 subslice1 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__sampler_1__sampler11_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x10) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice1 Subslice1 Sampler Output Ready";
        counter->symbol_name = "Sampler11OutputReady";
        counter->desc = "The percentage of time in which slice1 subslice1 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__sampler_1__sampler11_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x20) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice1 Subslice2 Input Available";
        counter->symbol_name = "Sampler12InputAvailable";
        counter->desc = "The percentage of time in which slice1 subslice2 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__sampler_1__sampler12_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x20) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice1 Subslice2 Sampler Output Ready";
        counter->symbol_name = "Sampler12OutputReady";
        counter->desc = "The percentage of time in which slice1 subslice2 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__sampler_1__sampler12_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = chv__sampler_1__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = chv__sampler_1__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__sampler_1__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__sampler_1__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__sampler_1__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = chv__sampler_1__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = chv__sampler_1__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = chv__sampler_1__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = chv__sampler_1__slm_bytes_read__read;
    counter->max_uint64 = chv__sampler_1__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = chv__sampler_1__slm_bytes_written__read;
    counter->max_uint64 = chv__sampler_1__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__sampler_1__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__sampler_1__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__sampler_1__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__sampler_1__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 42);
}

static void
chv_add_sampler_2_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set Sampler_2";
    metric_set->symbol_name = "Sampler_2";
    metric_set->hw_config_guid = "883c8a56-8767-4de8-beec-a99462c6674b";
    metric_set->counters = calloc(42, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(115, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(12, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18121400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141500AB };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18321400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x143500AB };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18521400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x145500AB };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C5C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E5C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x025CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x045CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A3D00A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A3D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C588000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E584000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04588000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A5B0050 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x045B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x065B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x085B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A5B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x101F02A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1FA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1F00AA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18382500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02388000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04384000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06384000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08384000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A384000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C388000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C398000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E39A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00398000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0239A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0439A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06392000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A3A0200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x023A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C3A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04108000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04118000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04127300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10120000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1813000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A134000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A146000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C159000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E150098 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10150000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04304000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04314000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04320073 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10320000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04338000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06338000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08334000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0434C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02359890 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10350000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06504000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06514000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06520073 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10520000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18530020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02538000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C534000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A548000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04542000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E559000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00559800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10550000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B8AA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D8A0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x078A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x098A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B8A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D8A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x278B0015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x238B2A80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x258B0005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2385002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F85AA00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2185000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B830150 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D848000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F84C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01848000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0384C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0584C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07844000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D808000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F80C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11808000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1380C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1580C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17804000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47801021 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F800C64 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4F800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41800C02 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x70800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0000C000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000E7FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00003000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000F9FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000C00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FE7F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = chv__sampler_2__avg_gpu_core_frequency__read;
    counter->max_uint64 = chv__sampler_2__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__sampler_2__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__sampler_2__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__sampler_2__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__sampler_2__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__sampler_2__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__sampler_2__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__sampler_2__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__sampler_2__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = chv__sampler_2__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = chv__sampler_2__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__sampler_2__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__sampler_2__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__sampler_2__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = chv__sampler_2__l3_shader_throughput__read;
    counter->max_uint64 = chv__sampler_2__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__sampler_2__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__sampler_2__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__sampler_2__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__sampler_2__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__sampler_2__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__sampler_2__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__sampler_2__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice0 Input Available";
        counter->symbol_name = "Sampler00InputAvailable";
        counter->desc = "The percentage of time in which slice0 subslice0 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__sampler_2__sampler00_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice0 Sampler Output Ready";
        counter->symbol_name = "Sampler00OutputReady";
        counter->desc = "The percentage of time in which slice0 subslice0 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__sampler_2__sampler00_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice1 Input Available";
        counter->symbol_name = "Sampler01InputAvailable";
        counter->desc = "The percentage of time in which slice0 subslice1 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__sampler_2__sampler01_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice1 Sampler Output Ready";
        counter->symbol_name = "Sampler01OutputReady";
        counter->desc = "The percentage of time in which slice0 subslice1 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__sampler_2__sampler01_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice2 Input Available";
        counter->symbol_name = "Sampler02InputAvailable";
        counter->desc = "The percentage of time in which slice0 subslice2 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__sampler_2__sampler02_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice2 Sampler Output Ready";
        counter->symbol_name = "Sampler02OutputReady";
        counter->desc = "The percentage of time in which slice0 subslice2 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__sampler_2__sampler02_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = chv__sampler_2__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = chv__sampler_2__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__sampler_2__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__sampler_2__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__sampler_2__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = chv__sampler_2__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = chv__sampler_2__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = chv__sampler_2__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = chv__sampler_2__slm_bytes_read__read;
    counter->max_uint64 = chv__sampler_2__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = chv__sampler_2__slm_bytes_written__read;
    counter->max_uint64 = chv__sampler_2__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__sampler_2__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__sampler_2__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__sampler_2__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__sampler_2__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 42);
}

static void
chv_add_tdl_1_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set TDL_1";
    metric_set->symbol_name = "TDL_1";
    metric_set->hw_config_guid = "eb97e523-d9ac-48a9-b7f8-9cc909ddbf14";
    metric_set->counters = calloc(48, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(152, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(18, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16154D60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16352E60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16554D60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16950000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16B50000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16D50000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x005C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x045CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x065C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x083D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A3D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0458C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x025B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x085B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A5B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C5B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1FA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1F00AA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02384000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04388000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06388000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08384000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A384000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C384000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00398000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0239A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0439A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06392000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x043A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x063A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08138000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A138000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06143000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0415CFC7 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10150000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02338000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C338000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04342000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06344000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0035C700 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x063500CF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10350000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04538000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06538000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0454C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0255CFC7 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10550000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06DC8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08DC4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CDCC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EDCC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1ABD00A8 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CD8C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0ED84000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EDB8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18DB0800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1ADB0254 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E9FAA00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x109F02AA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EB84000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16B84000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18B8156A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06B98000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08B9A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AB9A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CB9A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EB9A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18BAA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1ABA0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16934000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1893000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A947000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C95C5C1 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E9500C3 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10950000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EB38000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16B30040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18B30020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06B48000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08B41000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AB48000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06B5C500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08B500C3 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EB5C100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10B50000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16D31500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08D4E000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08D5C100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AD5C3C5 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10D50000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D88F800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F88000F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x078A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x098A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B8A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D8A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x258BAAA5 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x278B002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x238B2A80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x178C2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x198C5500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B8C0015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x078D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x098DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B8DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D8DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2185AAAA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2385002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F85AA00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19835400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B830155 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0784C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0984C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B84C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D84C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F84C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01848000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0384C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0584C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1780C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1980C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B80C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D80C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F80C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11808000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1380C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1580C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4F800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43800C42 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45800063 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47800800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F8014A4 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41801042 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FDFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FE7F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FFBF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FFCF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FFF7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FFF9 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = chv__tdl_1__avg_gpu_core_frequency__read;
    counter->max_uint64 = chv__tdl_1__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__tdl_1__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__tdl_1__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__tdl_1__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__tdl_1__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__tdl_1__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__tdl_1__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__tdl_1__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__tdl_1__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = chv__tdl_1__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = chv__tdl_1__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__tdl_1__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__tdl_1__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__tdl_1__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = chv__tdl_1__l3_shader_throughput__read;
    counter->max_uint64 = chv__tdl_1__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    if (perf->devinfo.subslice_mask & 0x8) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "NonPS Thread Ready For Dispatch on Slice1 Subslice0";
        counter->symbol_name = "NonPSThread10ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice1 subslice0 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__tdl_1__non_ps_thread10_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x10) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "NonPS Thread Ready For Dispatch on Slice1 Subslice1";
        counter->symbol_name = "NonPSThread11ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice1 subslice1 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__tdl_1__non_ps_thread11_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x20) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "NonPS Thread Ready For Dispatch on Slice1 Subslice2";
        counter->symbol_name = "NonPSThread12ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice1 subslice2 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__tdl_1__non_ps_thread12_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x8) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice1 Subslice0";
        counter->symbol_name = "PSThread10ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice1 subslice0 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__tdl_1__ps_thread10_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x10) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice1 Subslice1";
        counter->symbol_name = "PSThread11ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice1 subslice1 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__tdl_1__ps_thread11_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x20) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice1 Subslice2";
        counter->symbol_name = "PSThread12ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice1 subslice2 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__tdl_1__ps_thread12_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__tdl_1__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__tdl_1__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__tdl_1__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__tdl_1__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__tdl_1__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__tdl_1__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__tdl_1__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = chv__tdl_1__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = chv__tdl_1__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__tdl_1__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__tdl_1__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__tdl_1__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = chv__tdl_1__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = chv__tdl_1__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = chv__tdl_1__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = chv__tdl_1__slm_bytes_read__read;
    counter->max_uint64 = chv__tdl_1__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = chv__tdl_1__slm_bytes_written__read;
    counter->max_uint64 = chv__tdl_1__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice0 Port 0";
        counter->symbol_name = "ThreadHeader00ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice0 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__tdl_1__thread_header00_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice0 Port 1";
        counter->symbol_name = "ThreadHeader00ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice0 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__tdl_1__thread_header00_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice1 Port 0";
        counter->symbol_name = "ThreadHeader01ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice1 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__tdl_1__thread_header01_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice1 Port 1";
        counter->symbol_name = "ThreadHeader01ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice1 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__tdl_1__thread_header01_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice2 Port 0";
        counter->symbol_name = "ThreadHeader02ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice2 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__tdl_1__thread_header02_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice2 Port 1";
        counter->symbol_name = "ThreadHeader02ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice2 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__tdl_1__thread_header02_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__tdl_1__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__tdl_1__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__tdl_1__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__tdl_1__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 48);
}

static void
chv_add_tdl_2_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set TDL_2";
    metric_set->symbol_name = "TDL_2";
    metric_set->hw_config_guid = "dff6158e-8409-452c-be76-91c9946330bd";
    metric_set->counters = calloc(48, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(156, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(18, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16150000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16350000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16550000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16952E60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16B54D60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16D52E60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x065C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x085CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A5CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C5C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E3D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x183DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06588000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08588000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A584000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E5B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x185B5800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A5B000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1FAA00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x101F02AA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E384000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16384000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18382A55 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06398000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0839A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A39A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C39A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E39A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A3A02A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E138000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16130500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08146000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0615C100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0815C500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1500C3 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10150000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16335040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08349000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A341000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x083500C1 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A35C500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C3500C3 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10350000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1853002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A54E000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C55C500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E55C1C3 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10550000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00DC8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02DCC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04DC4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04BD8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06BD8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02D8C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02DB8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04DB4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06DB4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08DB8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C9FA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E9F00AA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02B84000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04B84000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06B84000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08B84000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AB88000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CB88000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00B98000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02B9A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04B9A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06B92000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0ABA8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CBA8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0494C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0295CFC7 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10950000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02B38000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08B38000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04B42000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06B41000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00B5C700 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04B500CF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10B50000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AD38000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CD38000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06D46000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04D5C700 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06D500CF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10D50000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03888000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05888000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07888000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09888000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B888000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D880400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x198A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B8AAAA0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D8A0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x258B555A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x278B0015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x238B5500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x078C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x098C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B8C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D8C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x018D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x078D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2185AAAA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2385002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F85AA00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19835400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B830155 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D834000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0784C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0984C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B84C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D84C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F84C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01848000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0384C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0584C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1780C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1980C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B80C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D80C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F80C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11808000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1380C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1580C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4F800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43800882 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45801082 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x478014A5 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F800002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41800C62 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FDFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FE7F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FF9F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FFE7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FFFB };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FFFD };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = chv__tdl_2__avg_gpu_core_frequency__read;
    counter->max_uint64 = chv__tdl_2__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__tdl_2__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__tdl_2__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__tdl_2__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__tdl_2__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__tdl_2__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__tdl_2__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__tdl_2__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__tdl_2__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = chv__tdl_2__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = chv__tdl_2__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__tdl_2__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__tdl_2__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__tdl_2__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = chv__tdl_2__l3_shader_throughput__read;
    counter->max_uint64 = chv__tdl_2__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "NonPS Thread Ready For Dispatch on Slice0 Subslice0";
        counter->symbol_name = "NonPSThread00ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice0 subslice0 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__tdl_2__non_ps_thread00_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "NonPS Thread Ready For Dispatch on Slice0 Subslice1";
        counter->symbol_name = "NonPSThread01ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice0 subslice1 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__tdl_2__non_ps_thread01_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "NonPS Thread Ready For Dispatch on Slice0 Subslice2";
        counter->symbol_name = "NonPSThread02ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice0 subslice2 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__tdl_2__non_ps_thread02_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice0 Subslice0";
        counter->symbol_name = "PSThread00ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice0 subslice0 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__tdl_2__ps_thread00_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice0 Subslice1";
        counter->symbol_name = "PSThread01ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice0 subslice1 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__tdl_2__ps_thread01_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice0 Subslice2";
        counter->symbol_name = "PSThread02ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice0 subslice2 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__tdl_2__ps_thread02_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__tdl_2__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__tdl_2__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__tdl_2__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__tdl_2__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__tdl_2__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__tdl_2__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__tdl_2__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = chv__tdl_2__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = chv__tdl_2__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__tdl_2__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__tdl_2__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = chv__tdl_2__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = chv__tdl_2__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = chv__tdl_2__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = chv__tdl_2__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = chv__tdl_2__slm_bytes_read__read;
    counter->max_uint64 = chv__tdl_2__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = chv__tdl_2__slm_bytes_written__read;
    counter->max_uint64 = chv__tdl_2__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    if (perf->devinfo.subslice_mask & 0x8) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice1 Subslice0 Port 0";
        counter->symbol_name = "ThreadHeader10ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice1 subslice0 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__tdl_2__thread_header10_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x8) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice1 Subslice0 Port 1";
        counter->symbol_name = "ThreadHeader10ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice1 subslice0 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__tdl_2__thread_header10_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x10) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice1 Subslice1 Port 0";
        counter->symbol_name = "ThreadHeader11ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice1 subslice1 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__tdl_2__thread_header11_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x10) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice1 Subslice1 Port 1";
        counter->symbol_name = "ThreadHeader11ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice1 subslice1 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__tdl_2__thread_header11_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x20) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice1 Subslice2 Port 0";
        counter->symbol_name = "ThreadHeader12ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice1 subslice2 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__tdl_2__thread_header12_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x20) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice1 Subslice2 Port 1";
        counter->symbol_name = "ThreadHeader12ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice1 subslice2 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = chv__tdl_2__thread_header12_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__tdl_2__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__tdl_2__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = chv__tdl_2__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = chv__tdl_2__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 48);
}

static void
chv_add_test_oa_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "MDAPI testing set Gen8LP";
    metric_set->symbol_name = "TestOa";
    metric_set->hw_config_guid = "4a534b07-cba3-414d-8d60-874830e883aa";
    metric_set->counters = calloc(12, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(13, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(22, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59800001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x338B0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x258B0066 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058B0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x038B0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03844000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47800080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x001823A4, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000004 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00000003 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000007 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00100002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FFF7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00100002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FFCF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00100082 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FFEF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x001000C2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FFE7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x00100001 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000FFE7 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = chv__test_oa__avg_gpu_core_frequency__read;
    counter->max_uint64 = chv__test_oa__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter0";
    counter->symbol_name = "Counter0";
    counter->desc = "HW test counter 0. Factor: 0.0";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = chv__test_oa__counter0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter1";
    counter->symbol_name = "Counter1";
    counter->desc = "HW test counter 1. Factor: 1.0";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = chv__test_oa__counter1__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter2";
    counter->symbol_name = "Counter2";
    counter->desc = "HW test counter 2. Factor: 1.0";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = chv__test_oa__counter2__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter3";
    counter->symbol_name = "Counter3";
    counter->desc = "HW test counter 3. Factor: 0.5";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = chv__test_oa__counter3__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter4";
    counter->symbol_name = "Counter4";
    counter->desc = "HW test counter 4. Factor: 0.333";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = chv__test_oa__counter4__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter5";
    counter->symbol_name = "Counter5";
    counter->desc = "HW test counter 5. Factor: 0.333";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = chv__test_oa__counter5__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter6";
    counter->symbol_name = "Counter6";
    counter->desc = "HW test counter 6. Factor: 0.166";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = chv__test_oa__counter6__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter7";
    counter->symbol_name = "Counter7";
    counter->desc = "HW test counter 7. Factor: 0.666";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = chv__test_oa__counter7__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter8";
    counter->symbol_name = "Counter8";
    counter->desc = "HW test counter 8. Should be equal to 1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = chv__test_oa__counter8__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = chv__test_oa__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = chv__test_oa__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    assert(metric_set->n_counters <= 12);
}

static void
sklgt2_add_render_basic_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Render Metrics Basic Gen9";
    metric_set->symbol_name = "RenderBasic";
    metric_set->hw_config_guid = "07b25942-d9fd-4fce-bd58-e29abd66b7de";
    metric_set->counters = calloc(52, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(70, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(5, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    if (perf->devinfo.revision >= 0x02) {
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x166C01E0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12170280 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12370280 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11930317 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x159303DF };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F900003 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A4E0080 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A6C0053 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C6C0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1B4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1C0001 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002F1000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042F1000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004C4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C8400 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D2000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080DA000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0D2000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F0400 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F6600 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002C8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x162C2200 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062D8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082D8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00133000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08133000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00170020 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08170021 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10170000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0633C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0833C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06370800 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08370840 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10370000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D933031 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F933E3F };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01933D00 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0393073C };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0593000E };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D930000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19930000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B930000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D900157 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F900158 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190001F };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51904400 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900020 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900C21 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900061 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57904440 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900004 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53904444 };
    }

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00222222 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt2__render_basic__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt2__render_basic__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__render_basic__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__render_basic__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__render_basic__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__render_basic__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__render_basic__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__render_basic__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__render_basic__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt2__render_basic__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt2__render_basic__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__render_basic__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Depth Throughput";
    counter->symbol_name = "GtiDepthThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between depth caches and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__render_basic__gti_depth_throughput__read;
    counter->max_uint64 = sklgt2__render_basic__gti_depth_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI HDC TLB Lookup Throughput";
    counter->symbol_name = "GtiHdcLookupsThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between GTI and HDC, when HDC is doing TLB lookups.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__render_basic__gti_hdc_lookups_throughput__read;
    counter->max_uint64 = sklgt2__render_basic__gti_hdc_lookups_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI L3 Throughput";
    counter->symbol_name = "GtiL3Throughput";
    counter->desc = "The total number of GPU memory bytes transferred between L3 caches and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__render_basic__gti_l3_throughput__read;
    counter->max_uint64 = sklgt2__render_basic__gti_l3_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI RCC Throughput";
    counter->symbol_name = "GtiRccThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between render color caches and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__render_basic__gti_rcc_throughput__read;
    counter->max_uint64 = sklgt2__render_basic__gti_rcc_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Read Throughput";
    counter->symbol_name = "GtiReadThroughput";
    counter->desc = "The total number of GPU memory bytes read from GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__render_basic__gti_read_throughput__read;
    counter->max_uint64 = sklgt2__render_basic__gti_read_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Fixed Pipe Throughput";
    counter->symbol_name = "GtiVfThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between 3D Pipeline (Command Dispatch, Input Assembly and Stream Output) and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__render_basic__gti_vf_throughput__read;
    counter->max_uint64 = sklgt2__render_basic__gti_vf_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Write Throughput";
    counter->symbol_name = "GtiWriteThroughput";
    counter->desc = "The total number of GPU memory bytes written to GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__render_basic__gti_write_throughput__read;
    counter->max_uint64 = sklgt2__render_basic__gti_write_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__render_basic__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__render_basic__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Lookup Accesses w/o IC";
    counter->symbol_name = "L3Lookups";
    counter->desc = "The total number of L3 cache lookup accesses w/o IC.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__render_basic__l3_lookups__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/TAG");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Misses";
    counter->symbol_name = "L3Misses";
    counter->desc = "The total number of L3 misses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__render_basic__l3_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/TAG");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Sampler Throughput";
    counter->symbol_name = "L3SamplerThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between samplers and L3 caches.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__render_basic__l3_sampler_throughput__read;
    counter->max_uint64 = sklgt2__render_basic__l3_sampler_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__render_basic__l3_shader_throughput__read;
    counter->max_uint64 = sklgt2__render_basic__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__render_basic__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__render_basic__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__render_basic__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__render_basic__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__render_basic__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__render_basic__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__render_basic__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    if (perf->devinfo.subslice_mask & 0x09) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Sampler 0 Bottleneck";
        counter->symbol_name = "Sampler0Bottleneck";
        counter->desc = "The percentage of time in which Sampler 0 has been slowing down the pipe when processing EU requests.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt2__render_basic__sampler0_bottleneck__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x09) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Sampler 0 Busy";
        counter->symbol_name = "Sampler0Busy";
        counter->desc = "The percentage of time in which Sampler 0 has been processing EU requests.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt2__render_basic__sampler0_busy__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x12) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Sampler 1 Bottleneck";
        counter->symbol_name = "Sampler1Bottleneck";
        counter->desc = "The percentage of time in which Sampler 1 has been slowing down the pipe when processing EU requests.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt2__render_basic__sampler1_bottleneck__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x12) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Sampler 1 Busy";
        counter->symbol_name = "Sampler1Busy";
        counter->desc = "The percentage of time in which Sampler 1 has been processing EU requests.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt2__render_basic__sampler1_busy__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samplers Bottleneck";
    counter->symbol_name = "SamplerBottleneck";
    counter->desc = "The percentage of time in which samplers have been slowing down the pipe when processing EU requests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__render_basic__sampler_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Cache Misses";
    counter->symbol_name = "SamplerL1Misses";
    counter->desc = "The total number of sampler cache misses in all LODs in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__render_basic__sampler_l1_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt2__render_basic__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt2__render_basic__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samplers Busy";
    counter->symbol_name = "SamplersBusy";
    counter->desc = "The percentage of time in which samplers have been processing EU requests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__render_basic__samplers_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__render_basic__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__render_basic__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__render_basic__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__render_basic__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__render_basic__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__render_basic__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__render_basic__slm_bytes_read__read;
    counter->max_uint64 = sklgt2__render_basic__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__render_basic__slm_bytes_written__read;
    counter->max_uint64 = sklgt2__render_basic__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__render_basic__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__render_basic__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__render_basic__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__render_basic__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 52);
}

static void
sklgt2_add_compute_basic_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Compute Metrics Basic Gen9";
    metric_set->symbol_name = "ComputeBasic";
    metric_set->hw_config_guid = "00b80b4c-d215-4378-9015-da3dda3b61ea";
    metric_set->counters = calloc(39, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(155, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(5, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    if ((perf->devinfo.slice_mask & 0x01) &&
        (perf->devinfo.revision < 0x02)) {
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x104F00E0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x124F1C00 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C00E0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37906800 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F901403 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x184E8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A4E8200 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044E8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004F0DB2 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064F0900 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084F1880 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4F0011 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4F0E3C };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E4F1D80 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x086C0002 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A6C0100 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E6C000C };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x026C000B };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C6C0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6C0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x081B4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1B8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1B4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021B4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1C4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1C0012 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141C8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x005BC000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x065B8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x085B8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A5B4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C5BC000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E5B8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x105C8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A5CA000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C5C002D };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x125C8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C0800 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4C0082 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084C8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000DA000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080DA000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0DA000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0DA000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0DA000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020D2000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F5400 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F5500 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0155 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002CC000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2CC000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x162CBE00 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x182C00EF };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022CC000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042C8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19900157 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B900167 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D900105 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F900103 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11900FFF };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900840 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900842 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900840 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900840 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900040 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900840 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53901111 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    }

    if ((perf->devinfo.slice_mask & 0x01) &&
        (perf->devinfo.revision >= 0x02)) {
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x104F00E0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x124F1C00 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C00E0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37906800 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F901403 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004E8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A4E0820 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C4E0002 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064F0900 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084F0032 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4F1810 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4F0E00 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E4F003C };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004F0D80 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x024F003B };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x006C0002 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x086C0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C6C000C };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E6C0B00 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x186C0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C6C0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E6C0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001B4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x081B8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1B4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1B8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x101C8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1C8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1C0024 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x065B8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x085B4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A5BC000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C5B8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E5B4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x005B8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x025B4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A5C6000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C5C001B };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x125C8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x145C8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004C8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C2000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4C0208 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000DA000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080DA000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0DA000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0DA000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0DA000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020D2000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F5400 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F5500 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0155 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002C8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2CC000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x162CFB00 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x182C00BE };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022CC000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042CC000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19900157 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B900167 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D900105 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F900103 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11900FFF };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900800 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900842 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900802 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900802 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900002 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900842 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53901111 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    }

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00000003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00002001 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00778008 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00088078 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00808708 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00A08908 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt2__compute_basic__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt2__compute_basic__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__compute_basic__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__compute_basic__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__compute_basic__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__compute_basic__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU AVG IPC Rate";
    counter->symbol_name = "EuAvgIpcRate";
    counter->desc = "The average rate of IPC calculated for 2 FPU pipelines.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NUMBER;
    counter->read_float = sklgt2__compute_basic__eu_avg_ipc_rate__read;
    counter->max_float = sklgt2__compute_basic__eu_avg_ipc_rate__max;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__compute_basic__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Send Pipe Active";
    counter->symbol_name = "EuSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__compute_basic__eu_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__compute_basic__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Thread Occupancy";
    counter->symbol_name = "EuThreadOccupancy";
    counter->desc = "The percentage of time in which hardware threads occupied EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__compute_basic__eu_thread_occupancy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Pipe Active";
    counter->symbol_name = "Fpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__compute_basic__fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active";
    counter->symbol_name = "Fpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__compute_basic__fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__compute_basic__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt2__compute_basic__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt2__compute_basic__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__compute_basic__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Read Throughput";
    counter->symbol_name = "GtiReadThroughput";
    counter->desc = "The total number of GPU memory bytes read from GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__compute_basic__gti_read_throughput__read;
    counter->max_uint64 = sklgt2__compute_basic__gti_read_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Write Throughput";
    counter->symbol_name = "GtiWriteThroughput";
    counter->desc = "The total number of GPU memory bytes written to GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__compute_basic__gti_write_throughput__read;
    counter->max_uint64 = sklgt2__compute_basic__gti_write_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__compute_basic__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__compute_basic__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__compute_basic__l3_shader_throughput__read;
    counter->max_uint64 = sklgt2__compute_basic__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__compute_basic__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__compute_basic__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__compute_basic__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt2__compute_basic__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt2__compute_basic__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__compute_basic__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__compute_basic__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__compute_basic__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__compute_basic__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__compute_basic__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__compute_basic__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__compute_basic__slm_bytes_read__read;
    counter->max_uint64 = sklgt2__compute_basic__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__compute_basic__slm_bytes_written__read;
    counter->max_uint64 = sklgt2__compute_basic__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Bytes Read";
    counter->symbol_name = "TypedBytesRead";
    counter->desc = "The total number of typed memory bytes read via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__compute_basic__typed_bytes_read__read;
    counter->max_uint64 = sklgt2__compute_basic__typed_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Bytes Written";
    counter->symbol_name = "TypedBytesWritten";
    counter->desc = "The total number of untyped memory bytes written via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__compute_basic__typed_bytes_written__read;
    counter->max_uint64 = sklgt2__compute_basic__typed_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Untyped Bytes Read";
    counter->symbol_name = "UntypedBytesRead";
    counter->desc = "The total number of typed memory bytes read via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__compute_basic__untyped_bytes_read__read;
    counter->max_uint64 = sklgt2__compute_basic__untyped_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Untyped Writes";
    counter->symbol_name = "UntypedBytesWritten";
    counter->desc = "The total number of untyped memory bytes written via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__compute_basic__untyped_bytes_written__read;
    counter->max_uint64 = sklgt2__compute_basic__untyped_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__compute_basic__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 39);
}

static void
sklgt2_add_render_pipe_profile_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Render Metrics for 3D Pipeline Profile Gen9";
    metric_set->symbol_name = "RenderPipeProfile";
    metric_set->hw_config_guid = "2a0c0933-37e7-427c-9951-ded42a78bb27";
    metric_set->counters = calloc(43, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(230, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(21, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    if (perf->devinfo.revision < 0x02) {
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0E001F };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0F0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10116800 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x178A03E0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11824C00 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11830020 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13840020 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11850019 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11860007 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01870C40 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17880000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022F4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C0040 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0D8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040D4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020E5400 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000E0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080F0040 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000F0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F0040 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2C8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06104000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06110012 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06131000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01898000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D890100 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03898000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09808000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B808000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0380C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8A0075 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D8A0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x118A8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B8A4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x138A8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D81A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15818000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17818000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B820030 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07828000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D824000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F828000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05824000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D830003 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0583000C };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09830000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03838000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07838000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B840980 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03844D80 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11840000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09848000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09850080 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03850003 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01850000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07860000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F860400 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09870032 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01888052 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11880000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09884000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15968000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17968000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F96C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F950011 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D950014 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0592C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B928000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D924000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F924000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11928000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1392C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09924000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01985000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07988000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09981000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B982000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D982000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F989000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05982000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13904000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21904000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x23904000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x27904000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x29908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B904000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F904000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31904000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15904000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B904000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B978000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F974000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11974000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13978000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09974000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190C080 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x419010A0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55904000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45901000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900084 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57904400 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x499000A5 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900081 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x439014A4 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900400 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    }

    if (perf->devinfo.revision >= 0x02) {
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0E001F };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0F0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10116800 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x178A03E0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11824C00 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11830020 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13840020 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11850019 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11860007 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01870C40 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17880000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022F4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C0040 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0D8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040D4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020E5400 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000E0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080F0040 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000F0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F0040 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2C8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06104000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06110012 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06131000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01898000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D890100 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03898000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09808000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B808000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0380C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8A0075 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D8A0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x118A8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B8A4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x138A8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D81A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15818000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17818000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B820030 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07828000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D824000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F828000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05824000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D830003 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0583000C };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09830000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03838000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07838000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B840980 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03844D80 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11840000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09848000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09850080 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03850003 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01850000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07860000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F860400 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09870032 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01888052 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11880000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09884000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B931001 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D930001 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19934000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B958000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D950094 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19958000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05E5A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01E5C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0592C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B928000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D924000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F924000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11928000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1392C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09924000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01985000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07988000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09981000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B982000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D982000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F989000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05982000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13904000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21904000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x23904000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x27904000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x29908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B904000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F904000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31904000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15904000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B904000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190C080 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x419010A0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55904000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45901000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900084 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57904400 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x499000A5 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900081 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x439014A4 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900400 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    }

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007FFEA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x00007FFC };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x0007AFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000F5FD };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00079FFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000F3FB };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x0007BF7A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000F7E7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x0007FEFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000F7CF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00077FFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000EFDF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x0006FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000CFBF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x0003FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x00005F7F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00025024 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00035034 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00045044 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00055054 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00065064 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt2__render_pipe_profile__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt2__render_pipe_profile__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "BC Bottleneck";
    counter->symbol_name = "BcBottleneck";
    counter->desc = "The percentage of time in which barycentric coordinates calculation pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__render_pipe_profile__bc_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Barycentric Calc");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Clipper Bottleneck";
    counter->symbol_name = "ClBottleneck";
    counter->desc = "The percentage of time in which clipper pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__render_pipe_profile__cl_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Clipper");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CL Stall";
    counter->symbol_name = "ClStall";
    counter->desc = "The percentage of time in which clipper pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__render_pipe_profile__cl_stall__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Clipper");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__render_pipe_profile__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Bottleneck";
    counter->symbol_name = "DsBottleneck";
    counter->desc = "The percentage of time in which domain shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__render_pipe_profile__ds_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Stall";
    counter->symbol_name = "DsStall";
    counter->desc = "The percentage of time in which domain shader pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__render_pipe_profile__ds_stall__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__render_pipe_profile__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Bottleneck";
    counter->symbol_name = "EarlyDepthBottleneck";
    counter->desc = "The percentage of time in which early depth test pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__render_pipe_profile__early_depth_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__render_pipe_profile__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__render_pipe_profile__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__render_pipe_profile__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__render_pipe_profile__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt2__render_pipe_profile__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt2__render_pipe_profile__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Bottleneck";
    counter->symbol_name = "GsBottleneck";
    counter->desc = "The percentage of time in which geometry shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__render_pipe_profile__gs_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__render_pipe_profile__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Hi-Depth Bottleneck";
    counter->symbol_name = "HiDepthBottleneck";
    counter->desc = "The percentage of time in which early hierarchical depth test pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__render_pipe_profile__hi_depth_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__render_pipe_profile__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Bottleneck";
    counter->symbol_name = "HsBottleneck";
    counter->desc = "The percentage of time in which hull shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__render_pipe_profile__hs_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Stall";
    counter->symbol_name = "HsStall";
    counter->desc = "The percentage of time in which hull stall pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__render_pipe_profile__hs_stall__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__render_pipe_profile__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__render_pipe_profile__l3_shader_throughput__read;
    counter->max_uint64 = sklgt2__render_pipe_profile__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__render_pipe_profile__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__render_pipe_profile__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__render_pipe_profile__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt2__render_pipe_profile__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt2__render_pipe_profile__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__render_pipe_profile__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__render_pipe_profile__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__render_pipe_profile__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Strip-Fans Bottleneck";
    counter->symbol_name = "SfBottleneck";
    counter->desc = "The percentage of time in which strip-fans pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__render_pipe_profile__sf_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Strip-Fans");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SF Stall";
    counter->symbol_name = "SfStall";
    counter->desc = "The percentage of time in which strip-fans pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__render_pipe_profile__sf_stall__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Strip-Fans");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__render_pipe_profile__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__render_pipe_profile__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__render_pipe_profile__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__render_pipe_profile__slm_bytes_read__read;
    counter->max_uint64 = sklgt2__render_pipe_profile__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__render_pipe_profile__slm_bytes_written__read;
    counter->max_uint64 = sklgt2__render_pipe_profile__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SO Bottleneck";
    counter->symbol_name = "SoBottleneck";
    counter->desc = "The percentage of time in which stream output pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__render_pipe_profile__so_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Stream Output");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SO Stall";
    counter->symbol_name = "SoStall";
    counter->desc = "The percentage of time in which stream-output pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__render_pipe_profile__so_stall__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Stream Output");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VF Bottleneck";
    counter->symbol_name = "VfBottleneck";
    counter->desc = "The percentage of time in which vertex fetch pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__render_pipe_profile__vf_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Input Assembler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Bottleneck";
    counter->symbol_name = "VsBottleneck";
    counter->desc = "The percentage of time in which vertex shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__render_pipe_profile__vs_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__render_pipe_profile__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 43);
}

static void
sklgt2_add_memory_reads_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Memory Reads Distribution Gen9";
    metric_set->symbol_name = "MemoryReads";
    metric_set->hw_config_guid = "246b35f1-44e0-4d03-8936-e452e291d064";
    metric_set->counters = calloc(41, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(167, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(32, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    if ((perf->devinfo.slice_mask & 0x01) &&
        (perf->devinfo.revision < 0x02)) {
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11810C00 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1381001A };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13946000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37906800 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F900003 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03811300 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05811B12 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0781001A };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F810000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17810000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19810000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B810000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D810000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F968000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1196C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13964000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11938000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B93FE00 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01940010 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07941100 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09941312 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B941514 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D941716 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11940000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19940000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B940000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D940000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B954000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D95A550 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F9502AA };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F900157 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31900105 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15900103 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17900101 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x23908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x27908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x29908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900C00 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900063 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900003 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    }

    if ((perf->devinfo.revision < 0x05) &&
        (perf->devinfo.revision >= 0x02)) {
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11810C00 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1381001A };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13946000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15940016 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37906800 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03811300 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05811B12 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0781001A };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F810000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17810000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19810000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B810000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D810000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19930800 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B93AA55 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D9300AA };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01940010 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07941100 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09941312 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B941514 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D941716 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F940018 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B940000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11940000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01E58000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03E57000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31900105 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15900103 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17900101 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x23908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x27908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x29908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900C20 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900400 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900421 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900421 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900061 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900003 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    }

    if (perf->devinfo.revision >= 0x05) {
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11810C00 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1381001A };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37906800 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F900064 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03811300 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05811B12 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0781001A };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F810000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17810000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19810000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B810000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D810000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B930055 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03E58000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05E5C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07E54000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13900150 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21900151 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x23900152 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25900153 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x27900154 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x29900155 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B900156 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D900157 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F90015F };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31900105 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15900103 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17900101 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900C60 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900C00 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900C63 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900C63 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900063 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900003 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    }

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000272C, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002728, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000271C, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002718, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000274C, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002748, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00006667 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000275C, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002758, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002754, .val = 0x00006465 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002750, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007F81A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x0007F82A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x0007F872 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x0007F8BA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x0007F87A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x0007F8EA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x0007F8E2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x0007F8F2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000FE00 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00025024 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00035034 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00045044 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00055054 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00065064 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt2__memory_reads__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt2__memory_reads__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__memory_reads__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__memory_reads__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__memory_reads__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__memory_reads__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__memory_reads__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__memory_reads__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt2__memory_reads__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt2__memory_reads__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__memory_reads__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiCmdStreamerMemoryReads";
    counter->symbol_name = "GtiCmdStreamerMemoryReads";
    counter->desc = "The total number of GTI memory reads from Command Streamer.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__memory_reads__gti_cmd_streamer_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Command Streamer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiHizMemoryReads";
    counter->symbol_name = "GtiHizMemoryReads";
    counter->desc = "The total number of GTI memory reads from Hierarchical Depth Cache (Hi-Depth Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__memory_reads__gti_hiz_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank0Reads";
    counter->symbol_name = "GtiL3Bank0Reads";
    counter->desc = "The total number of GTI memory reads from L3 Bank 0 (L3 Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__memory_reads__gti_l3_bank0_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank1Reads";
    counter->symbol_name = "GtiL3Bank1Reads";
    counter->desc = "The total number of GTI memory reads from L3 Bank 1 (L3 Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__memory_reads__gti_l3_bank1_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank2Reads";
    counter->symbol_name = "GtiL3Bank2Reads";
    counter->desc = "The total number of GTI memory reads from L3 Bank 2 (L3 Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__memory_reads__gti_l3_bank2_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank3Reads";
    counter->symbol_name = "GtiL3Bank3Reads";
    counter->desc = "The total number of GTI memory reads from L3 Bank 3 (L3 Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__memory_reads__gti_l3_bank3_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Reads";
    counter->symbol_name = "GtiL3Reads";
    counter->desc = "The total number of GTI memory reads from L3 (L3 Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__memory_reads__gti_l3_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiMemoryReads";
    counter->symbol_name = "GtiMemoryReads";
    counter->desc = "The total number of GTI memory reads.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__memory_reads__gti_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiMscMemoryReads";
    counter->symbol_name = "GtiMscMemoryReads";
    counter->desc = "The total number of GTI memory reads from Multisampling Color Cache (Multisampling Color Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__memory_reads__gti_msc_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRccMemoryReads";
    counter->symbol_name = "GtiRccMemoryReads";
    counter->desc = "The total number of GTI memory reads from Render Color Cache (Render Color Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__memory_reads__gti_rcc_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRczMemoryReads";
    counter->symbol_name = "GtiRczMemoryReads";
    counter->desc = "The total number of GTI memory reads from Render Depth Cache (Render Depth Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__memory_reads__gti_rcz_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRingAccesses";
    counter->symbol_name = "GtiRingAccesses";
    counter->desc = "The total number of all accesses from GTI to the ring.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__memory_reads__gti_ring_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRsMemoryReads";
    counter->symbol_name = "GtiRsMemoryReads";
    counter->desc = "The total number of GTI memory reads from Resource Streamer.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__memory_reads__gti_rs_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Resource Streamer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiStcMemoryReads";
    counter->symbol_name = "GtiStcMemoryReads";
    counter->desc = "The total number of GTI memory reads from Stencil Cache (Stencil Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__memory_reads__gti_stc_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiVfMemoryReads";
    counter->symbol_name = "GtiVfMemoryReads";
    counter->desc = "The total number of GTI memory reads from Vertex Fetch.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__memory_reads__gti_vf_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Vertex Fetch");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__memory_reads__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__memory_reads__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__memory_reads__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__memory_reads__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__memory_reads__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt2__memory_reads__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt2__memory_reads__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__memory_reads__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__memory_reads__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__memory_reads__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__memory_reads__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__memory_reads__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__memory_reads__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__memory_reads__slm_bytes_read__read;
    counter->max_uint64 = sklgt2__memory_reads__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__memory_reads__slm_bytes_written__read;
    counter->max_uint64 = sklgt2__memory_reads__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__memory_reads__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 41);
}

static void
sklgt2_add_memory_writes_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Memory Writes Distribution Gen9";
    metric_set->symbol_name = "MemoryWrites";
    metric_set->hw_config_guid = "e0d3da02-00bf-4a96-9795-b48158c73a68";
    metric_set->counters = calloc(41, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(213, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(32, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    if ((perf->devinfo.slice_mask & 0x01) &&
        (perf->devinfo.revision < 0x02)) {
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11810C00 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1381001A };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13945400 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37906800 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F901400 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03811300 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05811B12 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0781001A };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F810000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17810000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19810000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B810000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D810000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F968000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1196C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13964000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11938000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B93FE00 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01940010 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07941100 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09941312 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B941514 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D941716 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11940000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19940000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B940000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D940000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B954000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D95A550 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F9502AA };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F900167 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31900105 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15900103 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17900101 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x23908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x27908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x29908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900C00 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900063 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900003 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11810C00 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1381001A };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37906800 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F901000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03811300 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05811B12 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0781001A };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F810000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17810000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19810000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B810000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D810000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B930055 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03E58000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05E5C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07E54000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13900160 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21900161 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x23900162 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25900163 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x27900164 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x29900165 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B900166 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D900167 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F900150 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31900105 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15900103 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17900101 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900C60 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900C00 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900C63 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900C63 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900063 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900003 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    }

    if ((perf->devinfo.revision < 0x05) &&
        (perf->devinfo.revision >= 0x02)) {
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11810C00 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1381001A };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13945400 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37906800 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F901400 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03811300 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05811B12 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0781001A };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F810000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17810000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19810000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B810000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D810000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19930800 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B93AA55 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D93002A };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01940010 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07941100 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09941312 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B941514 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D941716 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B940000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11940000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01E58000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03E57000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F900167 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31900105 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15900103 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17900101 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x23908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x27908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x29908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900C20 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900400 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900421 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900421 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900063 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900003 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11810C00 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1381001A };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37906800 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F901000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03811300 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05811B12 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0781001A };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F810000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17810000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19810000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B810000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D810000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B930055 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03E58000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05E5C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07E54000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13900160 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21900161 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x23900162 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25900163 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x27900164 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x29900165 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B900166 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D900167 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F900150 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31900105 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15900103 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17900101 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F908000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900C60 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900C00 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900C63 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900C63 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900063 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900003 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    }

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000272C, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002728, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000271C, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002718, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000274C, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002748, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00006667 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000275C, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002758, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002754, .val = 0x00006465 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002750, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007F81A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x0007F82A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x0007F822 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x0007F8BA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x0007F87A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x0007F8EA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x0007F8E2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x0007F8F2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000FE00 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00025024 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00035034 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00045044 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00055054 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00065064 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt2__memory_writes__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt2__memory_writes__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__memory_writes__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__memory_writes__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__memory_writes__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__memory_writes__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__memory_writes__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__memory_writes__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt2__memory_writes__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt2__memory_writes__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__memory_writes__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiCmdStreamerMemoryWrites";
    counter->symbol_name = "GtiCmdStreamerMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Command Streamer.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__memory_writes__gti_cmd_streamer_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Command Streamer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiHizMemoryWrites";
    counter->symbol_name = "GtiHizMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Hierarchical Depth Cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__memory_writes__gti_hiz_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank0Writes";
    counter->symbol_name = "GtiL3Bank0Writes";
    counter->desc = "The total number of GTI memory writes from L3 Bank 0 (L3 Bank 0 invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__memory_writes__gti_l3_bank0_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank1Writes";
    counter->symbol_name = "GtiL3Bank1Writes";
    counter->desc = "The total number of GTI memory writes from L3 Bank 1 (L3 Bank 1 invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__memory_writes__gti_l3_bank1_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank2Writes";
    counter->symbol_name = "GtiL3Bank2Writes";
    counter->desc = "The total number of GTI memory writes from L3 Bank 2 (L3 Bank 2 invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__memory_writes__gti_l3_bank2_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank3Writes";
    counter->symbol_name = "GtiL3Bank3Writes";
    counter->desc = "The total number of GTI memory writes from L3 Bank 3 (L3 Bank 3 invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__memory_writes__gti_l3_bank3_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Writes";
    counter->symbol_name = "GtiL3Writes";
    counter->desc = "The total number of GTI memory writes from L3 (L3 invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__memory_writes__gti_l3_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiMemoryWrites";
    counter->symbol_name = "GtiMemoryWrites";
    counter->desc = "The total number of GTI memory writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__memory_writes__gti_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiMscMemoryWrites";
    counter->symbol_name = "GtiMscMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Multisampling Color Cache (Multisampling Color Cache invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__memory_writes__gti_msc_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRccMemoryWrites";
    counter->symbol_name = "GtiRccMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Render Color Cache (Render Color Cache invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__memory_writes__gti_rcc_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRczMemoryWrites";
    counter->symbol_name = "GtiRczMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Render Depth Cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__memory_writes__gti_rcz_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRingAccesses";
    counter->symbol_name = "GtiRingAccesses";
    counter->desc = "The total number of all GTI accesses to the ring.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__memory_writes__gti_ring_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiSoMemoryWrites";
    counter->symbol_name = "GtiSoMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Stream Output.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__memory_writes__gti_so_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Stream Output");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiStcMemoryWrites";
    counter->symbol_name = "GtiStcMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Stencil Cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__memory_writes__gti_stc_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__memory_writes__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__memory_writes__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__memory_writes__l3_shader_throughput__read;
    counter->max_uint64 = sklgt2__memory_writes__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__memory_writes__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__memory_writes__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__memory_writes__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt2__memory_writes__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt2__memory_writes__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__memory_writes__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__memory_writes__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__memory_writes__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__memory_writes__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__memory_writes__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__memory_writes__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__memory_writes__slm_bytes_read__read;
    counter->max_uint64 = sklgt2__memory_writes__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__memory_writes__slm_bytes_written__read;
    counter->max_uint64 = sklgt2__memory_writes__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__memory_writes__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 41);
}

static void
sklgt2_add_compute_extended_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Compute Metrics Extended Gen9";
    metric_set->symbol_name = "ComputeExtended";
    metric_set->hw_config_guid = "c26b1fda-2752-4a33-a448-4c8718366846";
    metric_set->counters = calloc(38, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(73, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(21, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    if (perf->devinfo.subslice_mask & 0x01) {
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C00E0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141C8160 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x161C8015 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181C0120 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004E8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E4E8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x184E8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A4EAAA0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C4E0002 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x024E8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044E8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064E8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084E8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4E8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E6C0B01 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x006C0200 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x026C000C };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C6C0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E6C0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6C0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1BC000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001B8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021BC000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001C0041 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x061C4200 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x081C4443 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1C4645 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1C7647 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041C7357 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1C0030 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x101C0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1C0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x121C8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004C8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4CAA2A };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4C02AA };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084CA000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000DA000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080DA000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0DA000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0DA000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0DA000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F5400 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F5515 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0155 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002C8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2C8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x162CAA00 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x182C00AA };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022C8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042C8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062C8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082C8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11907FFF };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900040 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900802 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900842 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900842 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900800 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    }

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007FC2A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x0007FC6A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x0007FC92 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x0007FCA2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x0007FC32 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x0007FC9A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x0007FE6A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x0007FE7A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000BF00 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00000003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00002001 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00778008 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00088078 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00808708 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00A08908 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt2__compute_extended__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt2__compute_extended__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__compute_extended__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuA64UntypedReads0";
    counter->symbol_name = "EuA64UntypedReads0";
    counter->desc = "The subslice 0 EU A64 Untyped Reads subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__compute_extended__eu_a64_untyped_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuA64UntypedWrites0";
    counter->symbol_name = "EuA64UntypedWrites0";
    counter->desc = "The subslice 0 EU A64 Untyped Writes subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__compute_extended__eu_a64_untyped_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__compute_extended__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU AVG IPC Rate";
    counter->symbol_name = "EuAvgIpcRate";
    counter->desc = "The average rate of IPC calculated for 2 FPU pipelines.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NUMBER;
    counter->read_float = sklgt2__compute_extended__eu_avg_ipc_rate__read;
    counter->max_float = sklgt2__compute_extended__eu_avg_ipc_rate__max;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__compute_extended__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Send Pipe Active";
    counter->symbol_name = "EuSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__compute_extended__eu_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__compute_extended__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Thread Occupancy";
    counter->symbol_name = "EuThreadOccupancy";
    counter->desc = "The percentage of time in which hardware threads occupied EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__compute_extended__eu_thread_occupancy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuTypedAtomics0";
    counter->symbol_name = "EuTypedAtomics0";
    counter->desc = "The subslice 0 EU Typed Atomics subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__compute_extended__eu_typed_atomics0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuTypedReads0";
    counter->symbol_name = "EuTypedReads0";
    counter->desc = "The subslice 0 EU Typed Reads subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__compute_extended__eu_typed_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuTypedWrites0";
    counter->symbol_name = "EuTypedWrites0";
    counter->desc = "The subslice 0 EU Typed Writes subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__compute_extended__eu_typed_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuUntypedAtomics0";
    counter->symbol_name = "EuUntypedAtomics0";
    counter->desc = "The subslice 0 EU Untyped Atomics subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__compute_extended__eu_untyped_atomics0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuUntypedReads0";
    counter->symbol_name = "EuUntypedReads0";
    counter->desc = "The subslice 0 EU Untyped Reads subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__compute_extended__eu_untyped_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuUntypedWrites0";
    counter->symbol_name = "EuUntypedWrites0";
    counter->desc = "The subslice 0 EU Untyped Writes subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__compute_extended__eu_untyped_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Pipe Active";
    counter->symbol_name = "Fpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__compute_extended__fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active";
    counter->symbol_name = "Fpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__compute_extended__fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt2__compute_extended__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt2__compute_extended__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__compute_extended__l3_shader_throughput__read;
    counter->max_uint64 = sklgt2__compute_extended__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt2__compute_extended__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt2__compute_extended__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__compute_extended__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__compute_extended__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__compute_extended__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__compute_extended__slm_bytes_read__read;
    counter->max_uint64 = sklgt2__compute_extended__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__compute_extended__slm_bytes_written__read;
    counter->max_uint64 = sklgt2__compute_extended__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Atomics 0";
    counter->symbol_name = "TypedAtomics0";
    counter->desc = "The subslice 0 typed atomics.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__compute_extended__typed_atomics0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TypedAtomicsPerCacheLine";
    counter->symbol_name = "TypedAtomicsPerCacheLine";
    counter->desc = "The ratio of EU typed atomics requests to L3 cache line writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
    counter->read_float = sklgt2__compute_extended__typed_atomics_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Reads 0";
    counter->symbol_name = "TypedReads0";
    counter->desc = "The subslice 0 typed reads.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__compute_extended__typed_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TypedReadsPerCacheLine";
    counter->symbol_name = "TypedReadsPerCacheLine";
    counter->desc = "The ratio of EU typed read requests to L3 cache line reads.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
    counter->read_float = sklgt2__compute_extended__typed_reads_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Writes 0";
    counter->symbol_name = "TypedWrites0";
    counter->desc = "The subslice 0 typed writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__compute_extended__typed_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TypedWritesPerCacheLine";
    counter->symbol_name = "TypedWritesPerCacheLine";
    counter->desc = "The ratio of EU typed write requests to L3 cache line writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
    counter->read_float = sklgt2__compute_extended__typed_writes_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Untyped Reads 0";
    counter->symbol_name = "UntypedReads0";
    counter->desc = "The subslice 0 untyped reads (including SLM reads).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__compute_extended__untyped_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "UntypedReadsPerCacheLine";
    counter->symbol_name = "UntypedReadsPerCacheLine";
    counter->desc = "The ratio of EU untyped read requests to L3 cache line reads.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
    counter->read_float = sklgt2__compute_extended__untyped_reads_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Untyped Writes 0";
    counter->symbol_name = "UntypedWrites0";
    counter->desc = "The subslice 0 untyped writes (including SLM writes).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__compute_extended__untyped_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "UntypedWritesPerCacheLine";
    counter->symbol_name = "UntypedWritesPerCacheLine";
    counter->desc = "The ratio of EU untyped write requests to L3 cache line writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
    counter->read_float = sklgt2__compute_extended__untyped_writes_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    assert(metric_set->n_counters <= 38);
}

static void
sklgt2_add_compute_l3_cache_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Compute Metrics L3 Cache Gen9";
    metric_set->symbol_name = "ComputeL3Cache";
    metric_set->hw_config_guid = "9fb22842-e708-43f7-9752-e0e41670c39e";
    metric_set->counters = calloc(54, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(61, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(13, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x166C0760 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1593001E };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F901403 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x184E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A4E8020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C4E0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x006C0051 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x066C5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x086C5C5D };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E6C5E5F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x186C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x061B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x081BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x101C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1CE000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1C0030 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C2A00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4C0280 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F0400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F1500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0140 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x162C0A00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x182C00A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03933300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05930032 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11930000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B930000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D900157 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F900167 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190030F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900042 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53901111 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900420 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FEFE };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x0007FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FEFD };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x0007FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FBEF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x0007FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FBDF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00000003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00002001 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00101100 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00201200 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00301300 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00401400 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt2__compute_l3_cache__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt2__compute_l3_cache__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__compute_l3_cache__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__compute_l3_cache__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__compute_l3_cache__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__compute_l3_cache__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU AVG IPC Rate";
    counter->symbol_name = "EuAvgIpcRate";
    counter->desc = "The average rate of IPC calculated for 2 FPU pipelines.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NUMBER;
    counter->read_float = sklgt2__compute_l3_cache__eu_avg_ipc_rate__read;
    counter->max_float = sklgt2__compute_l3_cache__eu_avg_ipc_rate__max;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Binary Instruction";
    counter->symbol_name = "EuBinaryFpu0Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing binary instructions on FPU0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__compute_l3_cache__eu_binary_fpu0_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Binary Instruction";
    counter->symbol_name = "EuBinaryFpu1Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing binary instructions on FPU1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__compute_l3_cache__eu_binary_fpu1_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__compute_l3_cache__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Hybrid Instruction";
    counter->symbol_name = "EuHybridFpu0Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing hybrid instructions on FPU0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__compute_l3_cache__eu_hybrid_fpu0_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Hybrid Instruction";
    counter->symbol_name = "EuHybridFpu1Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing hybrid instructions on FPU1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__compute_l3_cache__eu_hybrid_fpu1_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Move Instruction";
    counter->symbol_name = "EuMoveFpu0Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing move instructions on FPU0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__compute_l3_cache__eu_move_fpu0_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Move Instruction";
    counter->symbol_name = "EuMoveFpu1Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing move instructions on FPU1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__compute_l3_cache__eu_move_fpu1_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Send Pipe Active";
    counter->symbol_name = "EuSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__compute_l3_cache__eu_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__compute_l3_cache__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Ternary Instruction";
    counter->symbol_name = "EuTernaryFpu0Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing ternary instructions on FPU0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__compute_l3_cache__eu_ternary_fpu0_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Ternary Instruction";
    counter->symbol_name = "EuTernaryFpu1Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing ternary instructions on FPU1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__compute_l3_cache__eu_ternary_fpu1_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Pipe Active";
    counter->symbol_name = "Fpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__compute_l3_cache__fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active";
    counter->symbol_name = "Fpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__compute_l3_cache__fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__compute_l3_cache__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt2__compute_l3_cache__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt2__compute_l3_cache__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__compute_l3_cache__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI L3 Throughput";
    counter->symbol_name = "GtiL3Throughput";
    counter->desc = "The total number of GPU memory bytes transferred between L3 caches and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__compute_l3_cache__gti_l3_throughput__read;
    counter->max_uint64 = sklgt2__compute_l3_cache__gti_l3_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Read Throughput";
    counter->symbol_name = "GtiReadThroughput";
    counter->desc = "The total number of GPU memory bytes read from GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__compute_l3_cache__gti_read_throughput__read;
    counter->max_uint64 = sklgt2__compute_l3_cache__gti_read_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Write Throughput";
    counter->symbol_name = "GtiWriteThroughput";
    counter->desc = "The total number of GPU memory bytes written to GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__compute_l3_cache__gti_write_throughput__read;
    counter->max_uint64 = sklgt2__compute_l3_cache__gti_write_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__compute_l3_cache__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__compute_l3_cache__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Accesses";
    counter->symbol_name = "L3Accesses";
    counter->desc = "The total number of L3 accesses from all entities.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__compute_l3_cache__l3_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3");

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 00 Accesses";
        counter->symbol_name = "L3Bank00Accesses";
        counter->desc = "The total number of accesses to L3 Bank 00.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = sklgt2__compute_l3_cache__l3_bank00_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 00 IC Accesses";
        counter->symbol_name = "L3Bank00IcAccesses";
        counter->desc = "The total number of accesses to L3 Bank 00 from IC cache.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = sklgt2__compute_l3_cache__l3_bank00_ic_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3/IC");
    }

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 00 IC Hits";
        counter->symbol_name = "L3Bank00IcHits";
        counter->desc = "The total number of hits in L3 Bank 00 from IC cache.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = sklgt2__compute_l3_cache__l3_bank00_ic_hits__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3/IC");
    }

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 01 Accesses";
        counter->symbol_name = "L3Bank01Accesses";
        counter->desc = "The total number of accesses to L3 Bank 01.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = sklgt2__compute_l3_cache__l3_bank01_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 02 Accesses";
        counter->symbol_name = "L3Bank02Accesses";
        counter->desc = "The total number of accesses to L3 Bank 02.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = sklgt2__compute_l3_cache__l3_bank02_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 03 Accesses";
        counter->symbol_name = "L3Bank03Accesses";
        counter->desc = "The total number of accesses to L3 Bank 03.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = sklgt2__compute_l3_cache__l3_bank03_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Misses";
    counter->symbol_name = "L3Misses";
    counter->desc = "The total number of L3 misses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__compute_l3_cache__l3_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/TAG");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Sampler Throughput";
    counter->symbol_name = "L3SamplerThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between samplers and L3 caches.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__compute_l3_cache__l3_sampler_throughput__read;
    counter->max_uint64 = sklgt2__compute_l3_cache__l3_sampler_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__compute_l3_cache__l3_shader_throughput__read;
    counter->max_uint64 = sklgt2__compute_l3_cache__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Total Throughput";
    counter->symbol_name = "L3TotalThroughput";
    counter->desc = "The total number of GPU memory bytes transferred via L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__compute_l3_cache__l3_total_throughput__read;
    counter->max_uint64 = sklgt2__compute_l3_cache__l3_total_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__compute_l3_cache__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__compute_l3_cache__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__compute_l3_cache__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Accesses";
    counter->symbol_name = "SamplerAccesses";
    counter->desc = "The total number of messages send to samplers.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__compute_l3_cache__sampler_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt2__compute_l3_cache__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt2__compute_l3_cache__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__compute_l3_cache__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__compute_l3_cache__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__compute_l3_cache__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__compute_l3_cache__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__compute_l3_cache__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__compute_l3_cache__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__compute_l3_cache__slm_bytes_read__read;
    counter->max_uint64 = sklgt2__compute_l3_cache__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__compute_l3_cache__slm_bytes_written__read;
    counter->max_uint64 = sklgt2__compute_l3_cache__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__compute_l3_cache__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 54);
}

static void
sklgt2_add_hdc_and_sf_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set HDCAndSF";
    metric_set->symbol_name = "HDCAndSF";
    metric_set->hw_config_guid = "b4aa5e13-2d25-418f-827d-421f5cc4c43b";
    metric_set->counters = calloc(40, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(56, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(8, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x104F0232 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x124F4640 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C0232 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11834400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004F1880 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x024F08BB };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044F001B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x046C0100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x066C000B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x061B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1C1800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x005B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x025BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x045B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x125C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x145C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x165C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x185C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C00A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F0055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F828000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8305C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09830000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07830000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D950080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13928000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F988000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190FC00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B9000A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900842 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x10800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FDFF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt2__hdc_and_sf__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt2__hdc_and_sf__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__hdc_and_sf__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__hdc_and_sf__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__hdc_and_sf__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__hdc_and_sf__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__hdc_and_sf__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__hdc_and_sf__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt2__hdc_and_sf__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__hdc_and_sf__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt2__hdc_and_sf__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt2__hdc_and_sf__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__hdc_and_sf__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__hdc_and_sf__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__hdc_and_sf__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__hdc_and_sf__l3_shader_throughput__read;
    counter->max_uint64 = sklgt2__hdc_and_sf__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "HDC stalled by L3 (s0.ss0)";
        counter->symbol_name = "NonSamplerShader00AccessStalledOnL3";
        counter->desc = "Percentage of time when HDC has messges to L3, but it's stalled due to lack of credits (s0.ss0)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt2__hdc_and_sf__non_sampler_shader00_access_stalled_on_l3__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Data Port");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "HDC stalled by L3 (s0.ss1)";
        counter->symbol_name = "NonSamplerShader01AccessStalledOnL3";
        counter->desc = "Percentage of time when HDC has messges to L3, but it's stalled due to lack of credits (s0.ss1)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt2__hdc_and_sf__non_sampler_shader01_access_stalled_on_l3__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Data Port");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "HDC stalled by L3 (s0.ss2)";
        counter->symbol_name = "NonSamplerShader02AccessStalledOnL3";
        counter->desc = "Percentage of time when HDC has messges to L3, but it's stalled due to lack of credits (s0.ss2)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt2__hdc_and_sf__non_sampler_shader02_access_stalled_on_l3__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Data Port");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__hdc_and_sf__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Polygon Data Ready";
    counter->symbol_name = "PolyDataReady";
    counter->desc = "The percentage of time in which geometry pipeline output is ready";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__hdc_and_sf__poly_data_ready__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe/Strip-Fans");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__hdc_and_sf__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__hdc_and_sf__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__hdc_and_sf__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__hdc_and_sf__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__hdc_and_sf__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__hdc_and_sf__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt2__hdc_and_sf__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt2__hdc_and_sf__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__hdc_and_sf__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__hdc_and_sf__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__hdc_and_sf__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__hdc_and_sf__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__hdc_and_sf__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__hdc_and_sf__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__hdc_and_sf__slm_bytes_read__read;
    counter->max_uint64 = sklgt2__hdc_and_sf__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__hdc_and_sf__slm_bytes_written__read;
    counter->max_uint64 = sklgt2__hdc_and_sf__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__hdc_and_sf__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__hdc_and_sf__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__hdc_and_sf__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__hdc_and_sf__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 40);
}

static void
sklgt2_add_l3_1_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set L3_1";
    metric_set->symbol_name = "L3_1";
    metric_set->hw_config_guid = "504000e8-64f2-4aac-8301-51b81aa60d45";
    metric_set->counters = calloc(40, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(73, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(22, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x126C7B40 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x166C0020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A603444 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A613400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A4EA800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C4E0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x024E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C6C5327 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E6C5425 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x006C2A00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x026C285B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x046C005C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6C0800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1C003C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x121C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x161C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1C0800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x065B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A5C1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10600000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04600000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C610044 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10610000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06610000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4C02A8 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084CA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0154 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F0055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x182C00AA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190FFC0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900420 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900021 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900421 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00100070 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFF1 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00014002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000C3FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00010002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000C7FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00004002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000D3FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00100700 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FF1F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00001402 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FC3F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x00001002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FC7F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x00000402 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000FD3F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt2__l3_1__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt2__l3_1__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__l3_1__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__l3_1__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__l3_1__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__l3_1__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__l3_1__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__l3_1__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt2__l3_1__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__l3_1__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt2__l3_1__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt2__l3_1__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__l3_1__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__l3_1__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__l3_1__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank0 Active";
        counter->symbol_name = "L30Bank0Active";
        counter->desc = "The percentage of time in which slice0 L3 bank0 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt2__l3_1__l30_bank0_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank0 Stalled";
        counter->symbol_name = "L30Bank0Stalled";
        counter->desc = "The percentage of time in which slice0 L3 bank0 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt2__l3_1__l30_bank0_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank1 Active";
        counter->symbol_name = "L30Bank1Active";
        counter->desc = "The percentage of time in which slice0 L3 bank1 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt2__l3_1__l30_bank1_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank1 Stalled";
        counter->symbol_name = "L30Bank1Stalled";
        counter->desc = "The percentage of time in which slice0 L3 bank1 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt2__l3_1__l30_bank1_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__l3_1__l3_shader_throughput__read;
    counter->max_uint64 = sklgt2__l3_1__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__l3_1__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__l3_1__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__l3_1__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__l3_1__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__l3_1__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__l3_1__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__l3_1__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt2__l3_1__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt2__l3_1__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__l3_1__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__l3_1__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__l3_1__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__l3_1__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__l3_1__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__l3_1__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__l3_1__slm_bytes_read__read;
    counter->max_uint64 = sklgt2__l3_1__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__l3_1__slm_bytes_written__read;
    counter->max_uint64 = sklgt2__l3_1__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__l3_1__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__l3_1__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__l3_1__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__l3_1__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 40);
}

static void
sklgt2_add_l3_2_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set L3_2";
    metric_set->symbol_name = "L3_2";
    metric_set->hw_config_guid = "f542479b-6685-4670-ad8e-9fe282a2eb5b";
    metric_set->counters = calloc(38, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(46, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(14, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x126C02E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x146C0001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A623400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x026C3324 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x046C3422 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x161C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1C0800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x065B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A5C1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06614000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C620044 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10620000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06620000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F0055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190F800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00100070 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFF1 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00028002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x000087FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00020002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x00008FFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00008002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000A7FF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt2__l3_2__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt2__l3_2__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__l3_2__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__l3_2__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__l3_2__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__l3_2__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__l3_2__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__l3_2__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt2__l3_2__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__l3_2__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt2__l3_2__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt2__l3_2__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__l3_2__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__l3_2__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__l3_2__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank2 Active";
        counter->symbol_name = "L30Bank2Active";
        counter->desc = "The percentage of time in which slice0 L3 bank2 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt2__l3_2__l30_bank2_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank2 Stalled";
        counter->symbol_name = "L30Bank2Stalled";
        counter->desc = "The percentage of time in which slice0 L3 bank2 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt2__l3_2__l30_bank2_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__l3_2__l3_shader_throughput__read;
    counter->max_uint64 = sklgt2__l3_2__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__l3_2__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__l3_2__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__l3_2__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__l3_2__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__l3_2__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__l3_2__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__l3_2__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt2__l3_2__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt2__l3_2__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__l3_2__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__l3_2__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__l3_2__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__l3_2__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__l3_2__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__l3_2__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__l3_2__slm_bytes_read__read;
    counter->max_uint64 = sklgt2__l3_2__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__l3_2__slm_bytes_written__read;
    counter->max_uint64 = sklgt2__l3_2__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__l3_2__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__l3_2__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__l3_2__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__l3_2__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 38);
}

static void
sklgt2_add_l3_3_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set L3_3";
    metric_set->symbol_name = "L3_3";
    metric_set->hw_config_guid = "1cbf1e9f-c2de-4cc2-8d1c-2c33c25a2332";
    metric_set->counters = calloc(38, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(45, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(14, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x126C4E80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x146C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A633400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x026C3321 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x046C342F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6C2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x061B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x161C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1C1800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06604000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C630044 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10630000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06630000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C00AA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F0055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190F800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900842 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00100070 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFF1 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00028002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x000087FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00020002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x00008FFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00008002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000A7FF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt2__l3_3__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt2__l3_3__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__l3_3__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__l3_3__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__l3_3__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__l3_3__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__l3_3__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__l3_3__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt2__l3_3__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__l3_3__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt2__l3_3__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt2__l3_3__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__l3_3__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__l3_3__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__l3_3__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank3 Active";
        counter->symbol_name = "L30Bank3Active";
        counter->desc = "The percentage of time in which slice0 L3 bank3 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt2__l3_3__l30_bank3_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank3 Stalled";
        counter->symbol_name = "L30Bank3Stalled";
        counter->desc = "The percentage of time in which slice0 L3 bank3 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt2__l3_3__l30_bank3_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__l3_3__l3_shader_throughput__read;
    counter->max_uint64 = sklgt2__l3_3__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__l3_3__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__l3_3__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__l3_3__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__l3_3__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__l3_3__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__l3_3__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__l3_3__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt2__l3_3__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt2__l3_3__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__l3_3__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__l3_3__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__l3_3__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__l3_3__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__l3_3__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__l3_3__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__l3_3__slm_bytes_read__read;
    counter->max_uint64 = sklgt2__l3_3__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__l3_3__slm_bytes_written__read;
    counter->max_uint64 = sklgt2__l3_3__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__l3_3__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__l3_3__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__l3_3__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__l3_3__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 38);
}

static void
sklgt2_add_rasterizer_and_pixel_backend_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set RasterizerAndPixelBackend";
    metric_set->symbol_name = "RasterizerAndPixelBackend";
    metric_set->hw_config_guid = "b4e54cc8-a3a0-4ccd-9990-65d3184e5a38";
    metric_set->counters = calloc(41, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(33, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(10, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x102F3800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x144D0500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x120D03C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x140D03CF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F0004 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4E4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042F0480 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C0090 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064D0027 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004D0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D0D40 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020D803F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040D8023 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100D0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020F0010 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F0050 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190FC00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41901400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43901485 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000EFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00006000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000F3FF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt2__rasterizer_and_pixel_backend__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt2__rasterizer_and_pixel_backend__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__rasterizer_and_pixel_backend__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__rasterizer_and_pixel_backend__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__rasterizer_and_pixel_backend__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__rasterizer_and_pixel_backend__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__rasterizer_and_pixel_backend__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__rasterizer_and_pixel_backend__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt2__rasterizer_and_pixel_backend__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__rasterizer_and_pixel_backend__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt2__rasterizer_and_pixel_backend__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt2__rasterizer_and_pixel_backend__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__rasterizer_and_pixel_backend__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__rasterizer_and_pixel_backend__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__rasterizer_and_pixel_backend__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__rasterizer_and_pixel_backend__l3_shader_throughput__read;
    counter->max_uint64 = sklgt2__rasterizer_and_pixel_backend__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 PS Output Available";
        counter->symbol_name = "PSOutput0Available";
        counter->desc = "The percentage of time in which slice0 PS output is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt2__rasterizer_and_pixel_backend__ps_output0_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Post-EarlyZ Pixel Data Ready";
        counter->symbol_name = "PixelData0Ready";
        counter->desc = "The percentage of time in which slice0 post-EarlyZ pixel data is ready (after early Z tests have been applied)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt2__rasterizer_and_pixel_backend__pixel_data0_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Rasterizer/Early Depth Test");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Pixel Values Ready";
        counter->symbol_name = "PixelValues0Ready";
        counter->desc = "The percentage of time in which slice0 pixel values are ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt2__rasterizer_and_pixel_backend__pixel_values0_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__rasterizer_and_pixel_backend__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__rasterizer_and_pixel_backend__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__rasterizer_and_pixel_backend__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__rasterizer_and_pixel_backend__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__rasterizer_and_pixel_backend__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__rasterizer_and_pixel_backend__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__rasterizer_and_pixel_backend__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Rasterizer Input Available";
        counter->symbol_name = "Rasterizer0InputAvailable";
        counter->desc = "The percentage of time in which slice0 rasterizer input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt2__rasterizer_and_pixel_backend__rasterizer0_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Rasterizer");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Rasterizer Output Ready";
        counter->symbol_name = "Rasterizer0OutputReady";
        counter->desc = "The percentage of time in which slice0 rasterizer output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt2__rasterizer_and_pixel_backend__rasterizer0_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Rasterizer");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt2__rasterizer_and_pixel_backend__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt2__rasterizer_and_pixel_backend__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__rasterizer_and_pixel_backend__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__rasterizer_and_pixel_backend__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__rasterizer_and_pixel_backend__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__rasterizer_and_pixel_backend__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__rasterizer_and_pixel_backend__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__rasterizer_and_pixel_backend__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__rasterizer_and_pixel_backend__slm_bytes_read__read;
    counter->max_uint64 = sklgt2__rasterizer_and_pixel_backend__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__rasterizer_and_pixel_backend__slm_bytes_written__read;
    counter->max_uint64 = sklgt2__rasterizer_and_pixel_backend__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__rasterizer_and_pixel_backend__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__rasterizer_and_pixel_backend__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__rasterizer_and_pixel_backend__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__rasterizer_and_pixel_backend__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 41);
}

static void
sklgt2_add_sampler_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set Sampler";
    metric_set->symbol_name = "Sampler";
    metric_set->hw_config_guid = "efe7eba4-fd9e-4a09-a92b-334970b5de57";
    metric_set->counters = calloc(42, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(71, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(12, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14152C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16150005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x121600A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14352C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16350005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x123600A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14552C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16550005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x125600A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062F6000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022F2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4C0050 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C0010 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0350 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0FB000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F00DA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x182C0028 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022DC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C138000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E132000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0413C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C140018 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C157000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E150078 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10150000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04162180 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02160000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04174000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0233A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04333000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14348000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16348000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02357870 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10350000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04360043 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02360000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04371000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E538000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00538000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06533000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C540020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12548000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E557000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00557800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10550000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06560043 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02560000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06571000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190FF80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900060 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900842 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900060 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x70800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0000C000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000E7FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00003000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000F9FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000C00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FE7F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt2__sampler__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt2__sampler__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__sampler__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__sampler__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__sampler__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__sampler__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__sampler__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__sampler__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt2__sampler__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__sampler__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt2__sampler__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt2__sampler__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__sampler__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__sampler__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__sampler__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__sampler__l3_shader_throughput__read;
    counter->max_uint64 = sklgt2__sampler__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__sampler__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__sampler__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__sampler__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__sampler__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__sampler__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__sampler__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__sampler__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice0 Input Available";
        counter->symbol_name = "Sampler00InputAvailable";
        counter->desc = "The percentage of time in which slice0 subslice0 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt2__sampler__sampler00_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice0 Sampler Output Ready";
        counter->symbol_name = "Sampler00OutputReady";
        counter->desc = "The percentage of time in which slice0 subslice0 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt2__sampler__sampler00_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice1 Input Available";
        counter->symbol_name = "Sampler01InputAvailable";
        counter->desc = "The percentage of time in which slice0 subslice1 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt2__sampler__sampler01_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice1 Sampler Output Ready";
        counter->symbol_name = "Sampler01OutputReady";
        counter->desc = "The percentage of time in which slice0 subslice1 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt2__sampler__sampler01_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice2 Input Available";
        counter->symbol_name = "Sampler02InputAvailable";
        counter->desc = "The percentage of time in which slice0 subslice2 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt2__sampler__sampler02_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice2 Sampler Output Ready";
        counter->symbol_name = "Sampler02OutputReady";
        counter->desc = "The percentage of time in which slice0 subslice2 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt2__sampler__sampler02_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt2__sampler__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt2__sampler__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__sampler__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__sampler__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__sampler__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__sampler__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__sampler__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__sampler__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__sampler__slm_bytes_read__read;
    counter->max_uint64 = sklgt2__sampler__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__sampler__slm_bytes_written__read;
    counter->max_uint64 = sklgt2__sampler__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__sampler__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__sampler__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__sampler__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__sampler__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 42);
}

static void
sklgt2_add_tdl_1_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set TDL_1";
    metric_set->symbol_name = "TDL_1";
    metric_set->hw_config_guid = "e9bd0bbb-c7b7-4a26-a27a-246987354776";
    metric_set->counters = calloc(42, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(70, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(18, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12120000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12320000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12520000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022F3000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C0015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F03A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0FF000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F0095 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02108000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0410C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02118000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0411C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02121880 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041219B5 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00120000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02134000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04135000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C308000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E304000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06304000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C318000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E314000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06314000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C321A80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E320033 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06320031 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00320000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C334000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E331000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06331000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E508000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00508000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02504000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E518000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00518000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02514000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E521880 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00521A80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02520033 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E534000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00534000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02531000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190FF80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900062 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x00007FFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x00009FFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000EFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000F3FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FDFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FE7F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt2__tdl_1__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt2__tdl_1__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__tdl_1__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__tdl_1__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__tdl_1__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__tdl_1__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__tdl_1__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__tdl_1__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt2__tdl_1__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__tdl_1__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt2__tdl_1__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt2__tdl_1__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__tdl_1__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__tdl_1__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__tdl_1__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__tdl_1__l3_shader_throughput__read;
    counter->max_uint64 = sklgt2__tdl_1__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "NonPS Thread Ready For Dispatch on Slice0 Subslice0";
        counter->symbol_name = "NonPSThread00ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice0 subslice0 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt2__tdl_1__non_ps_thread00_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "NonPS Thread Ready For Dispatch on Slice0 Subslice1";
        counter->symbol_name = "NonPSThread01ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice0 subslice1 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt2__tdl_1__non_ps_thread01_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "NonPS Thread Ready For Dispatch on Slice0 Subslice2";
        counter->symbol_name = "NonPSThread02ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice0 subslice2 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt2__tdl_1__non_ps_thread02_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice0 Subslice0";
        counter->symbol_name = "PSThread00ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice0 subslice0 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt2__tdl_1__ps_thread00_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice0 Subslice1";
        counter->symbol_name = "PSThread01ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice0 subslice1 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt2__tdl_1__ps_thread01_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice0 Subslice2";
        counter->symbol_name = "PSThread02ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice0 subslice2 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt2__tdl_1__ps_thread02_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__tdl_1__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__tdl_1__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__tdl_1__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__tdl_1__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__tdl_1__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__tdl_1__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__tdl_1__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt2__tdl_1__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt2__tdl_1__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__tdl_1__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__tdl_1__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__tdl_1__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__tdl_1__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__tdl_1__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__tdl_1__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__tdl_1__slm_bytes_read__read;
    counter->max_uint64 = sklgt2__tdl_1__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__tdl_1__slm_bytes_written__read;
    counter->max_uint64 = sklgt2__tdl_1__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__tdl_1__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__tdl_1__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__tdl_1__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__tdl_1__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 42);
}

static void
sklgt2_add_tdl_2_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set TDL_2";
    metric_set->symbol_name = "TDL_2";
    metric_set->hw_config_guid = "0a7accbf-8c55-455f-9984-23e9fb0b826d";
    metric_set->counters = calloc(42, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(44, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(6, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x000000A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12124D60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12322E60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12524D60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022F3000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C0014 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0FE000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F0097 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0410C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0411C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04121FB7 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00120000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04135000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00308000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06304000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00318000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06314000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00321B80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0632003F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00334000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06331000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0250C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0251C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02521FB7 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00520000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02535000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190FC00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900063 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt2__tdl_2__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt2__tdl_2__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__tdl_2__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__tdl_2__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__tdl_2__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__tdl_2__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__tdl_2__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__tdl_2__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt2__tdl_2__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__tdl_2__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt2__tdl_2__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt2__tdl_2__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__tdl_2__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__tdl_2__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__tdl_2__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__tdl_2__l3_shader_throughput__read;
    counter->max_uint64 = sklgt2__tdl_2__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__tdl_2__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__tdl_2__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__tdl_2__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__tdl_2__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__tdl_2__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__tdl_2__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__tdl_2__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt2__tdl_2__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt2__tdl_2__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__tdl_2__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__tdl_2__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__tdl_2__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__tdl_2__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__tdl_2__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt2__tdl_2__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__tdl_2__slm_bytes_read__read;
    counter->max_uint64 = sklgt2__tdl_2__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt2__tdl_2__slm_bytes_written__read;
    counter->max_uint64 = sklgt2__tdl_2__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice0 Port 0";
        counter->symbol_name = "ThreadHeader00ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice0 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt2__tdl_2__thread_header00_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice0 Port 1";
        counter->symbol_name = "ThreadHeader00ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice0 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt2__tdl_2__thread_header00_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice1 Port 0";
        counter->symbol_name = "ThreadHeader01ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice1 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt2__tdl_2__thread_header01_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice1 Port 1";
        counter->symbol_name = "ThreadHeader01ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice1 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt2__tdl_2__thread_header01_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice2 Port 0";
        counter->symbol_name = "ThreadHeader02ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice2 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt2__tdl_2__thread_header02_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice2 Port 1";
        counter->symbol_name = "ThreadHeader02ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice2 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt2__tdl_2__thread_header02_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__tdl_2__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__tdl_2__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__tdl_2__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__tdl_2__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 42);
}

static void
sklgt2_add_compute_extra_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Compute Metrics Extra Gen9";
    metric_set->symbol_name = "ComputeExtra";
    metric_set->hw_config_guid = "41a24047-7484-4ead-ae37-de907e5ff2b2";
    metric_set->counters = calloc(5, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(32, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(6, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x121203E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x123203E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x125203E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C0040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F006C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06104000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06114000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06120033 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00120000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06131000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04308000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04318000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04321980 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00320000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04334000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04504000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04514000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04520033 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00520000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04531000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190E000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00001000 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00003002 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00011010 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00050012 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00052051 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00000008 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt2__compute_extra__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt2__compute_extra__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active";
    counter->symbol_name = "Fpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__compute_extra__fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active including Ext Math";
    counter->symbol_name = "Fpu1ActiveAdjusted";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing including Extended Math processing";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__compute_extra__fpu1_active_adjusted__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt2__compute_extra__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt2__compute_extra__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    assert(metric_set->n_counters <= 5);
}

static void
sklgt2_add_vme_pipe_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Media Vme Pipe Gen9";
    metric_set->symbol_name = "VMEPipe";
    metric_set->hw_config_guid = "95910492-943f-44bd-9461-390240f243fd";
    metric_set->counters = calloc(10, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(62, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(17, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(2, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141A5800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x161A00C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12180240 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14180002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x143A5800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x163A00C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12380240 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14380002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002F1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042F3000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C1500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F0400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F9500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x162C0A00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2DC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2DC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04193000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x081A28C1 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00133000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0613C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0813F000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00172000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06178000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0817A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00180037 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06180940 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08180000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02180000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04183000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06393000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C3A28C1 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x003A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A33F000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C33F000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A37A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C37A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A380977 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08380000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04380000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06383000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x119000FF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47901000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900844 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00100030 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFF9 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FFFC };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FFF3 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00100180 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FFCF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FFCF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FF3F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00008003 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt2__vme_pipe__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt2__vme_pipe__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__vme_pipe__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__vme_pipe__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__vme_pipe__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__vme_pipe__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Thread Occupancy";
    counter->symbol_name = "EuThreadOccupancy";
    counter->desc = "The percentage of time in which hardware threads occupied EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__vme_pipe__eu_thread_occupancy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__vme_pipe__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt2__vme_pipe__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt2__vme_pipe__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VME Busy";
    counter->symbol_name = "VMEBusy";
    counter->desc = "The percentage of time in which VME (IME or CRE) was actively processing data.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__vme_pipe__vme_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "VME Pipe");

    assert(metric_set->n_counters <= 10);
}

static void
sklgt2_add_gpu_busyness_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Gpu Rings Busyness";
    metric_set->symbol_name = "GpuBusyness";
    metric_set->hw_config_guid = "c44a5cf7-886d-477b-bebd-2d738923e4c3";
    metric_set->counters = calloc(8, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(34, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13805800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05962C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19950016 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21C05800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07800035 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D810400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07960025 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21960000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B964000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B930062 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17948000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B940008 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05950075 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D950000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07E54000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09924000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05982000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09978000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0BC000A5 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11C00000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05C00000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0BC54000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900C60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x10800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00078000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x00000FFF };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AnyRingBusy";
    counter->symbol_name = "AnyRingBusy";
    counter->desc = "The percentage of time when any command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__gpu_busyness__any_ring_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt2__gpu_busyness__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt2__gpu_busyness__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Blitter Ring Busy";
    counter->symbol_name = "BlitterBusy";
    counter->desc = "The percentage of time when blitter command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__gpu_busyness__blitter_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt2__gpu_busyness__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt2__gpu_busyness__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Render Ring Busy";
    counter->symbol_name = "RenderBusy";
    counter->desc = "The percentage of time when render command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__gpu_busyness__render_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Vdbox0 Ring Busy";
    counter->symbol_name = "Vdbox0Busy";
    counter->desc = "The percentage of time when Vdbox0 command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__gpu_busyness__vdbox0_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Vebox Ring Busy";
    counter->symbol_name = "VeboxBusy";
    counter->desc = "The percentage of time when vebox command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__gpu_busyness__vebox_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    assert(metric_set->n_counters <= 8);
}

static void
sklgt2_add_ff_bottlenecks_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "FF Bottlenecks";
    metric_set->symbol_name = "FfBottlenecks";
    metric_set->hw_config_guid = "e0b2aae4-9b8f-4211-8df0-f8e8cb203209";
    metric_set->counters = calloc(30, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(60, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(5, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(5, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11850019 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11860007 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19867C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01870000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15880000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01898000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B898000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D890C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D808000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x118A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B8A2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D8A0003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F810002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0982C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D824000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05833000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07831000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D848000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D850080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01850000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09860080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D860080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07870C80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B870C80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01880032 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B888032 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11880000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07888000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D930010 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D950013 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0DE58000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05924000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B928000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D92C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F92C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11928000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01981000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07984000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0998A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B985000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D982000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x23904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x27904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x29904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00000011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00000008 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt2__ff_bottlenecks__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt2__ff_bottlenecks__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__ff_bottlenecks__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Bottleneck";
    counter->symbol_name = "DsBottleneck";
    counter->desc = "The percentage of time in which domain shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__ff_bottlenecks__ds_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__ff_bottlenecks__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__ff_bottlenecks__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__ff_bottlenecks__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__ff_bottlenecks__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__ff_bottlenecks__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Thread Occupancy";
    counter->symbol_name = "EuThreadOccupancy";
    counter->desc = "The percentage of time in which hardware threads occupied EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__ff_bottlenecks__eu_thread_occupancy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__ff_bottlenecks__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt2__ff_bottlenecks__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt2__ff_bottlenecks__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Bottleneck";
    counter->symbol_name = "GsBottleneck";
    counter->desc = "The percentage of time in which geometry shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__ff_bottlenecks__gs_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__ff_bottlenecks__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__ff_bottlenecks__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Bottleneck";
    counter->symbol_name = "HsBottleneck";
    counter->desc = "The percentage of time in which hull shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__ff_bottlenecks__hs_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__ff_bottlenecks__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__ff_bottlenecks__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__ff_bottlenecks__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__ff_bottlenecks__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__ff_bottlenecks__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__ff_bottlenecks__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__ff_bottlenecks__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__ff_bottlenecks__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt2__ff_bottlenecks__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TE Bottleneck";
    counter->symbol_name = "TeBottleneck";
    counter->desc = "The percentage of time in which tesselation pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__ff_bottlenecks__te_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS is sending vertices to CL";
    counter->symbol_name = "VsClBypass";
    counter->desc = "The percentage of time in which VS is sending vertices to CL bypassing other pipeline stages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__ff_bottlenecks__vs_cl_bypass__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__ff_bottlenecks__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt2__ff_bottlenecks__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt2__ff_bottlenecks__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 30);
}

static void
sklgt2_add_test_oa_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "MDAPI testing set Gen9";
    metric_set->symbol_name = "TestOa";
    metric_set->hw_config_guid = "1651949f-0ac0-4cb1-a06f-dafd74a407d1";
    metric_set->counters = calloc(12, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(13, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(21, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07810016 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B930040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07E54000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000004 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00000003 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000007 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00100002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FFF7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00100002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FFCF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00100082 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FFEF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x001000C2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FFE7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x00100001 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000FFE7 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt2__test_oa__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt2__test_oa__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter0";
    counter->symbol_name = "Counter0";
    counter->desc = "HW test counter 0. Factor: 0.0";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = sklgt2__test_oa__counter0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter1";
    counter->symbol_name = "Counter1";
    counter->desc = "HW test counter 1. Factor: 1.0";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = sklgt2__test_oa__counter1__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter2";
    counter->symbol_name = "Counter2";
    counter->desc = "HW test counter 2. Factor: 1.0";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = sklgt2__test_oa__counter2__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter3";
    counter->symbol_name = "Counter3";
    counter->desc = "HW test counter 3. Factor: 0.5";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = sklgt2__test_oa__counter3__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter4";
    counter->symbol_name = "Counter4";
    counter->desc = "HW test counter 4. Factor: 0.333";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = sklgt2__test_oa__counter4__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter5";
    counter->symbol_name = "Counter5";
    counter->desc = "HW test counter 5. Factor: 0.333";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = sklgt2__test_oa__counter5__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter6";
    counter->symbol_name = "Counter6";
    counter->desc = "HW test counter 6. Factor: 0.166";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = sklgt2__test_oa__counter6__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter7";
    counter->symbol_name = "Counter7";
    counter->desc = "HW test counter 7. Factor: 0.666";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = sklgt2__test_oa__counter7__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter8";
    counter->symbol_name = "Counter8";
    counter->desc = "HW test counter 8. Should be equal to 1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = sklgt2__test_oa__counter8__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt2__test_oa__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt2__test_oa__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    assert(metric_set->n_counters <= 12);
}

static void
sklgt2_add_pma__stall_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set PMA Stall";
    metric_set->symbol_name = "PMA_Stall";
    metric_set->hw_config_guid = "27871149-2fa9-40ba-aa73-350d60c03a09";
    metric_set->counters = calloc(4, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(24, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(9, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x122D3080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F0800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0FAA00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002D0025 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062D1300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082D16A4 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2D162E };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x102D0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190003F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00E00021 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0007FFF8 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x07000101 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0038FFC7 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt2__pma__stall__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt2__pma__stall__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt2__pma__stall__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt2__pma__stall__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "STC PMA stall";
        counter->symbol_name = "StcPMAStall";
        counter->desc = "Percentage of time when stencil cache line and an overlapping pixel are causing stalls";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt2__pma__stall__stc_pma_stall__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Stencil Cache");
    }

    assert(metric_set->n_counters <= 4);
}

static void
sklgt3_add_render_basic_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Render Metrics Basic Gen9";
    metric_set->symbol_name = "RenderBasic";
    metric_set->hw_config_guid = "21fef15a-83f4-4ffa-bb81-7da6e38b8e4b";
    metric_set->counters = calloc(52, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(83, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(5, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x166C01E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12170280 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12370280 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16EC01E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11930317 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x159303DF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F900003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A4E0380 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A6C0053 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1C0001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002F1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042F1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C8400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4C0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F0400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F6600 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x162CA200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00133000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08133000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00170020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08170021 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10170000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0633C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0833C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06370800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08370840 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10370000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1ACE0200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AEC5300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10EC0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1CEC0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A9B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C9C0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CCC0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A8D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x108F0001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16AC8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D933031 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F933E3F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01933D00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0393073C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0593000E };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D930000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19930000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B930000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D900157 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F900158 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190003F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51907710 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x419020A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55901515 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900529 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47901025 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57907770 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49902100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900108 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900007 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43902108 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53907777 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00222222 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt3__render_basic__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt3__render_basic__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__render_basic__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__render_basic__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__render_basic__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__render_basic__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__render_basic__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__render_basic__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__render_basic__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt3__render_basic__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt3__render_basic__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__render_basic__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Depth Throughput";
    counter->symbol_name = "GtiDepthThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between depth caches and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__render_basic__gti_depth_throughput__read;
    counter->max_uint64 = sklgt3__render_basic__gti_depth_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI HDC TLB Lookup Throughput";
    counter->symbol_name = "GtiHdcLookupsThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between GTI and HDC, when HDC is doing TLB lookups.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__render_basic__gti_hdc_lookups_throughput__read;
    counter->max_uint64 = sklgt3__render_basic__gti_hdc_lookups_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI L3 Throughput";
    counter->symbol_name = "GtiL3Throughput";
    counter->desc = "The total number of GPU memory bytes transferred between L3 caches and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__render_basic__gti_l3_throughput__read;
    counter->max_uint64 = sklgt3__render_basic__gti_l3_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI RCC Throughput";
    counter->symbol_name = "GtiRccThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between render color caches and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__render_basic__gti_rcc_throughput__read;
    counter->max_uint64 = sklgt3__render_basic__gti_rcc_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Read Throughput";
    counter->symbol_name = "GtiReadThroughput";
    counter->desc = "The total number of GPU memory bytes read from GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__render_basic__gti_read_throughput__read;
    counter->max_uint64 = sklgt3__render_basic__gti_read_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Fixed Pipe Throughput";
    counter->symbol_name = "GtiVfThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between 3D Pipeline (Command Dispatch, Input Assembly and Stream Output) and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__render_basic__gti_vf_throughput__read;
    counter->max_uint64 = sklgt3__render_basic__gti_vf_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Write Throughput";
    counter->symbol_name = "GtiWriteThroughput";
    counter->desc = "The total number of GPU memory bytes written to GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__render_basic__gti_write_throughput__read;
    counter->max_uint64 = sklgt3__render_basic__gti_write_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__render_basic__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__render_basic__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Lookup Accesses w/o IC";
    counter->symbol_name = "L3Lookups";
    counter->desc = "The total number of L3 cache lookup accesses w/o IC.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__render_basic__l3_lookups__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/TAG");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Misses";
    counter->symbol_name = "L3Misses";
    counter->desc = "The total number of L3 misses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__render_basic__l3_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/TAG");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Sampler Throughput";
    counter->symbol_name = "L3SamplerThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between samplers and L3 caches.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__render_basic__l3_sampler_throughput__read;
    counter->max_uint64 = sklgt3__render_basic__l3_sampler_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__render_basic__l3_shader_throughput__read;
    counter->max_uint64 = sklgt3__render_basic__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__render_basic__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__render_basic__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__render_basic__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__render_basic__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__render_basic__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__render_basic__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__render_basic__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    if (perf->devinfo.subslice_mask & 0x09) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Sampler 0 Bottleneck";
        counter->symbol_name = "Sampler0Bottleneck";
        counter->desc = "The percentage of time in which Sampler 0 has been slowing down the pipe when processing EU requests.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt3__render_basic__sampler0_bottleneck__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x09) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Sampler 0 Busy";
        counter->symbol_name = "Sampler0Busy";
        counter->desc = "The percentage of time in which Sampler 0 has been processing EU requests.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt3__render_basic__sampler0_busy__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x12) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Sampler 1 Bottleneck";
        counter->symbol_name = "Sampler1Bottleneck";
        counter->desc = "The percentage of time in which Sampler 1 has been slowing down the pipe when processing EU requests.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt3__render_basic__sampler1_bottleneck__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x12) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Sampler 1 Busy";
        counter->symbol_name = "Sampler1Busy";
        counter->desc = "The percentage of time in which Sampler 1 has been processing EU requests.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt3__render_basic__sampler1_busy__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samplers Bottleneck";
    counter->symbol_name = "SamplerBottleneck";
    counter->desc = "The percentage of time in which samplers have been slowing down the pipe when processing EU requests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__render_basic__sampler_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Cache Misses";
    counter->symbol_name = "SamplerL1Misses";
    counter->desc = "The total number of sampler cache misses in all LODs in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__render_basic__sampler_l1_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt3__render_basic__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt3__render_basic__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samplers Busy";
    counter->symbol_name = "SamplersBusy";
    counter->desc = "The percentage of time in which samplers have been processing EU requests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__render_basic__samplers_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__render_basic__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__render_basic__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__render_basic__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__render_basic__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__render_basic__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__render_basic__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__render_basic__slm_bytes_read__read;
    counter->max_uint64 = sklgt3__render_basic__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__render_basic__slm_bytes_written__read;
    counter->max_uint64 = sklgt3__render_basic__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__render_basic__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__render_basic__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__render_basic__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__render_basic__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 52);
}

static void
sklgt3_add_compute_basic_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Compute Metrics Basic Gen9";
    metric_set->symbol_name = "ComputeBasic";
    metric_set->hw_config_guid = "4320492b-fd03-42ac-922f-dbe1ef3b7b58";
    metric_set->counters = calloc(39, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(78, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(5, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x104F00E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x124F1C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C00E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37906800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F900003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A4E0820 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C4E0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064F0900 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084F0032 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4F1891 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4F0E00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E4F003C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004F0D80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x024F003B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x006C0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x086C0100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C6C000C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E6C0B00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x186C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x081B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x101C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1C0024 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x065B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x085B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A5BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C5B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E5B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x005B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x025B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A5C6000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C5C001B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x125C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x145C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4C0208 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F5400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F5500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0155 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x162CFB00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x182C00BE };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19900157 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B900158 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D900105 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F900103 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11900FFF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900863 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900802 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900802 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900C62 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53903333 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00000003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00002001 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00778008 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00088078 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00808708 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00A08908 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt3__compute_basic__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt3__compute_basic__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__compute_basic__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__compute_basic__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__compute_basic__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__compute_basic__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU AVG IPC Rate";
    counter->symbol_name = "EuAvgIpcRate";
    counter->desc = "The average rate of IPC calculated for 2 FPU pipelines.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NUMBER;
    counter->read_float = sklgt3__compute_basic__eu_avg_ipc_rate__read;
    counter->max_float = sklgt3__compute_basic__eu_avg_ipc_rate__max;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__compute_basic__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Send Pipe Active";
    counter->symbol_name = "EuSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__compute_basic__eu_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__compute_basic__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Thread Occupancy";
    counter->symbol_name = "EuThreadOccupancy";
    counter->desc = "The percentage of time in which hardware threads occupied EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__compute_basic__eu_thread_occupancy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Pipe Active";
    counter->symbol_name = "Fpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__compute_basic__fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active";
    counter->symbol_name = "Fpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__compute_basic__fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__compute_basic__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt3__compute_basic__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt3__compute_basic__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__compute_basic__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Read Throughput";
    counter->symbol_name = "GtiReadThroughput";
    counter->desc = "The total number of GPU memory bytes read from GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__compute_basic__gti_read_throughput__read;
    counter->max_uint64 = sklgt3__compute_basic__gti_read_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Write Throughput";
    counter->symbol_name = "GtiWriteThroughput";
    counter->desc = "The total number of GPU memory bytes written to GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__compute_basic__gti_write_throughput__read;
    counter->max_uint64 = sklgt3__compute_basic__gti_write_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__compute_basic__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__compute_basic__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__compute_basic__l3_shader_throughput__read;
    counter->max_uint64 = sklgt3__compute_basic__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__compute_basic__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__compute_basic__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__compute_basic__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt3__compute_basic__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt3__compute_basic__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__compute_basic__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__compute_basic__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__compute_basic__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__compute_basic__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__compute_basic__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__compute_basic__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__compute_basic__slm_bytes_read__read;
    counter->max_uint64 = sklgt3__compute_basic__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__compute_basic__slm_bytes_written__read;
    counter->max_uint64 = sklgt3__compute_basic__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Bytes Read";
    counter->symbol_name = "TypedBytesRead";
    counter->desc = "The total number of typed memory bytes read via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__compute_basic__typed_bytes_read__read;
    counter->max_uint64 = sklgt3__compute_basic__typed_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Bytes Written";
    counter->symbol_name = "TypedBytesWritten";
    counter->desc = "The total number of untyped memory bytes written via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__compute_basic__typed_bytes_written__read;
    counter->max_uint64 = sklgt3__compute_basic__typed_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Untyped Bytes Read";
    counter->symbol_name = "UntypedBytesRead";
    counter->desc = "The total number of typed memory bytes read via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__compute_basic__untyped_bytes_read__read;
    counter->max_uint64 = sklgt3__compute_basic__untyped_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Untyped Writes";
    counter->symbol_name = "UntypedBytesWritten";
    counter->desc = "The total number of untyped memory bytes written via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__compute_basic__untyped_bytes_written__read;
    counter->max_uint64 = sklgt3__compute_basic__untyped_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__compute_basic__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 39);
}

static void
sklgt3_add_render_pipe_profile_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Render Metrics for 3D Pipeline Profile Gen9";
    metric_set->symbol_name = "RenderPipeProfile";
    metric_set->hw_config_guid = "bd2d9cae-b9ec-4f5b-9d2f-934bed398a2d";
    metric_set->counters = calloc(43, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(114, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(21, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0E001F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10116800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x178A03E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11824C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11830020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13840020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11850019 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11860007 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01870C40 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17880000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C0040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020E5400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000E0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080F0040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F0040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06104000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06110012 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06131000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01898000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D890100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03898000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09808000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B808000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0380C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8A0075 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D8A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x118A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B8A4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x138A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D81A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15818000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17818000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B820030 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07828000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D824000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F828000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05824000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D830003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0583000C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09830000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03838000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07838000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B840980 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03844D80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11840000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09848000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09850080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03850003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01850000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07860000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F860400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09870032 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01888052 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11880000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09884000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B931001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D930001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19934000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B958000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D950094 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19958000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09E58000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0BE58000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03E5C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0592C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B928000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D924000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F924000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11928000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1392C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09924000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01985000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07988000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09981000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B982000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D982000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F989000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05982000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x23904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x27904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x29908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190C080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51901150 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41901400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55905111 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45901400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x479004A5 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57903455 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B9000A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900455 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007FFEA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x00007FFC };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x0007AFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000F5FD };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00079FFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000F3FB };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x0007BF7A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000F7E7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x0007FEFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000F7CF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00077FFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000EFDF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x0006FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000CFBF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x0003FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x00005F7F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00025024 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00035034 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00045044 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00055054 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00065064 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt3__render_pipe_profile__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt3__render_pipe_profile__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "BC Bottleneck";
    counter->symbol_name = "BcBottleneck";
    counter->desc = "The percentage of time in which barycentric coordinates calculation pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__render_pipe_profile__bc_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Barycentric Calc");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Clipper Bottleneck";
    counter->symbol_name = "ClBottleneck";
    counter->desc = "The percentage of time in which clipper pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__render_pipe_profile__cl_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Clipper");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CL Stall";
    counter->symbol_name = "ClStall";
    counter->desc = "The percentage of time in which clipper pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__render_pipe_profile__cl_stall__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Clipper");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__render_pipe_profile__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Bottleneck";
    counter->symbol_name = "DsBottleneck";
    counter->desc = "The percentage of time in which domain shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__render_pipe_profile__ds_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Stall";
    counter->symbol_name = "DsStall";
    counter->desc = "The percentage of time in which domain shader pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__render_pipe_profile__ds_stall__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__render_pipe_profile__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Bottleneck";
    counter->symbol_name = "EarlyDepthBottleneck";
    counter->desc = "The percentage of time in which early depth test pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__render_pipe_profile__early_depth_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__render_pipe_profile__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__render_pipe_profile__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__render_pipe_profile__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__render_pipe_profile__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt3__render_pipe_profile__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt3__render_pipe_profile__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Bottleneck";
    counter->symbol_name = "GsBottleneck";
    counter->desc = "The percentage of time in which geometry shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__render_pipe_profile__gs_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__render_pipe_profile__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Hi-Depth Bottleneck";
    counter->symbol_name = "HiDepthBottleneck";
    counter->desc = "The percentage of time in which early hierarchical depth test pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__render_pipe_profile__hi_depth_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__render_pipe_profile__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Bottleneck";
    counter->symbol_name = "HsBottleneck";
    counter->desc = "The percentage of time in which hull shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__render_pipe_profile__hs_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Stall";
    counter->symbol_name = "HsStall";
    counter->desc = "The percentage of time in which hull stall pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__render_pipe_profile__hs_stall__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__render_pipe_profile__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__render_pipe_profile__l3_shader_throughput__read;
    counter->max_uint64 = sklgt3__render_pipe_profile__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__render_pipe_profile__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__render_pipe_profile__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__render_pipe_profile__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt3__render_pipe_profile__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt3__render_pipe_profile__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__render_pipe_profile__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__render_pipe_profile__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__render_pipe_profile__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Strip-Fans Bottleneck";
    counter->symbol_name = "SfBottleneck";
    counter->desc = "The percentage of time in which strip-fans pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__render_pipe_profile__sf_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Strip-Fans");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SF Stall";
    counter->symbol_name = "SfStall";
    counter->desc = "The percentage of time in which strip-fans pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__render_pipe_profile__sf_stall__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Strip-Fans");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__render_pipe_profile__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__render_pipe_profile__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__render_pipe_profile__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__render_pipe_profile__slm_bytes_read__read;
    counter->max_uint64 = sklgt3__render_pipe_profile__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__render_pipe_profile__slm_bytes_written__read;
    counter->max_uint64 = sklgt3__render_pipe_profile__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SO Bottleneck";
    counter->symbol_name = "SoBottleneck";
    counter->desc = "The percentage of time in which stream output pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__render_pipe_profile__so_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Stream Output");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SO Stall";
    counter->symbol_name = "SoStall";
    counter->desc = "The percentage of time in which stream-output pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__render_pipe_profile__so_stall__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Stream Output");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VF Bottleneck";
    counter->symbol_name = "VfBottleneck";
    counter->desc = "The percentage of time in which vertex fetch pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__render_pipe_profile__vf_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Input Assembler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Bottleneck";
    counter->symbol_name = "VsBottleneck";
    counter->desc = "The percentage of time in which vertex shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__render_pipe_profile__vs_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__render_pipe_profile__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 43);
}

static void
sklgt3_add_memory_reads_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Memory Reads Distribution Gen9";
    metric_set->symbol_name = "MemoryReads";
    metric_set->hw_config_guid = "4ca0f3fe-7fd3-4924-98cb-1807d9879767";
    metric_set->counters = calloc(41, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(47, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(32, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11810C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1381001A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37906800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F900064 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03811300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05811B12 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0781001A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B930055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03E58000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05E5C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07E54000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13900150 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21900151 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x23900152 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25900153 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x27900154 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x29900155 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B900156 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D900157 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F90015F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31900105 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15900103 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17900101 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900C60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900C63 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900C63 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900063 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000272C, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002728, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000271C, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002718, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000274C, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002748, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00006667 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000275C, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002758, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002754, .val = 0x00006465 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002750, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007F81A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x0007F82A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x0007F872 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x0007F8BA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x0007F87A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x0007F8EA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x0007F8E2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x0007F8F2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000FE00 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00025024 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00035034 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00045044 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00055054 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00065064 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt3__memory_reads__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt3__memory_reads__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__memory_reads__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__memory_reads__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__memory_reads__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__memory_reads__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__memory_reads__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__memory_reads__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt3__memory_reads__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt3__memory_reads__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__memory_reads__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiCmdStreamerMemoryReads";
    counter->symbol_name = "GtiCmdStreamerMemoryReads";
    counter->desc = "The total number of GTI memory reads from Command Streamer.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__memory_reads__gti_cmd_streamer_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Command Streamer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiHizMemoryReads";
    counter->symbol_name = "GtiHizMemoryReads";
    counter->desc = "The total number of GTI memory reads from Hierarchical Depth Cache (Hi-Depth Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__memory_reads__gti_hiz_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank0Reads";
    counter->symbol_name = "GtiL3Bank0Reads";
    counter->desc = "The total number of GTI memory reads from L3 Bank 0 (L3 Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__memory_reads__gti_l3_bank0_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank1Reads";
    counter->symbol_name = "GtiL3Bank1Reads";
    counter->desc = "The total number of GTI memory reads from L3 Bank 1 (L3 Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__memory_reads__gti_l3_bank1_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank2Reads";
    counter->symbol_name = "GtiL3Bank2Reads";
    counter->desc = "The total number of GTI memory reads from L3 Bank 2 (L3 Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__memory_reads__gti_l3_bank2_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank3Reads";
    counter->symbol_name = "GtiL3Bank3Reads";
    counter->desc = "The total number of GTI memory reads from L3 Bank 3 (L3 Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__memory_reads__gti_l3_bank3_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Reads";
    counter->symbol_name = "GtiL3Reads";
    counter->desc = "The total number of GTI memory reads from L3 (L3 Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__memory_reads__gti_l3_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiMemoryReads";
    counter->symbol_name = "GtiMemoryReads";
    counter->desc = "The total number of GTI memory reads.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__memory_reads__gti_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiMscMemoryReads";
    counter->symbol_name = "GtiMscMemoryReads";
    counter->desc = "The total number of GTI memory reads from Multisampling Color Cache (Multisampling Color Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__memory_reads__gti_msc_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRccMemoryReads";
    counter->symbol_name = "GtiRccMemoryReads";
    counter->desc = "The total number of GTI memory reads from Render Color Cache (Render Color Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__memory_reads__gti_rcc_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRczMemoryReads";
    counter->symbol_name = "GtiRczMemoryReads";
    counter->desc = "The total number of GTI memory reads from Render Depth Cache (Render Depth Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__memory_reads__gti_rcz_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRingAccesses";
    counter->symbol_name = "GtiRingAccesses";
    counter->desc = "The total number of all accesses from GTI to the ring.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__memory_reads__gti_ring_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRsMemoryReads";
    counter->symbol_name = "GtiRsMemoryReads";
    counter->desc = "The total number of GTI memory reads from Resource Streamer.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__memory_reads__gti_rs_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Resource Streamer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiStcMemoryReads";
    counter->symbol_name = "GtiStcMemoryReads";
    counter->desc = "The total number of GTI memory reads from Stencil Cache (Stencil Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__memory_reads__gti_stc_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiVfMemoryReads";
    counter->symbol_name = "GtiVfMemoryReads";
    counter->desc = "The total number of GTI memory reads from Vertex Fetch.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__memory_reads__gti_vf_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Vertex Fetch");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__memory_reads__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__memory_reads__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__memory_reads__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__memory_reads__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__memory_reads__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt3__memory_reads__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt3__memory_reads__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__memory_reads__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__memory_reads__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__memory_reads__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__memory_reads__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__memory_reads__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__memory_reads__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__memory_reads__slm_bytes_read__read;
    counter->max_uint64 = sklgt3__memory_reads__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__memory_reads__slm_bytes_written__read;
    counter->max_uint64 = sklgt3__memory_reads__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__memory_reads__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 41);
}

static void
sklgt3_add_memory_writes_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Memory Writes Distribution Gen9";
    metric_set->symbol_name = "MemoryWrites";
    metric_set->hw_config_guid = "a0c0172c-ee13-403d-99ff-2bdf6936cf14";
    metric_set->counters = calloc(41, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(47, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(32, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11810C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1381001A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37906800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F901000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03811300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05811B12 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0781001A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B930055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03E58000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05E5C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07E54000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13900160 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21900161 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x23900162 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25900163 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x27900164 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x29900165 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B900166 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D900167 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F900150 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31900105 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15900103 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17900101 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900C60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900C63 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900C63 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900063 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000272C, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002728, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000271C, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002718, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000274C, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002748, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00006667 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000275C, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002758, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002754, .val = 0x00006465 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002750, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007F81A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x0007F82A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x0007F822 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x0007F8BA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x0007F87A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x0007F8EA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x0007F8E2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x0007F8F2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000FE00 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00025024 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00035034 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00045044 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00055054 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00065064 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt3__memory_writes__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt3__memory_writes__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__memory_writes__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__memory_writes__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__memory_writes__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__memory_writes__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__memory_writes__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__memory_writes__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt3__memory_writes__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt3__memory_writes__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__memory_writes__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiCmdStreamerMemoryWrites";
    counter->symbol_name = "GtiCmdStreamerMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Command Streamer.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__memory_writes__gti_cmd_streamer_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Command Streamer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiHizMemoryWrites";
    counter->symbol_name = "GtiHizMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Hierarchical Depth Cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__memory_writes__gti_hiz_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank0Writes";
    counter->symbol_name = "GtiL3Bank0Writes";
    counter->desc = "The total number of GTI memory writes from L3 Bank 0 (L3 Bank 0 invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__memory_writes__gti_l3_bank0_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank1Writes";
    counter->symbol_name = "GtiL3Bank1Writes";
    counter->desc = "The total number of GTI memory writes from L3 Bank 1 (L3 Bank 1 invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__memory_writes__gti_l3_bank1_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank2Writes";
    counter->symbol_name = "GtiL3Bank2Writes";
    counter->desc = "The total number of GTI memory writes from L3 Bank 2 (L3 Bank 2 invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__memory_writes__gti_l3_bank2_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank3Writes";
    counter->symbol_name = "GtiL3Bank3Writes";
    counter->desc = "The total number of GTI memory writes from L3 Bank 3 (L3 Bank 3 invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__memory_writes__gti_l3_bank3_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Writes";
    counter->symbol_name = "GtiL3Writes";
    counter->desc = "The total number of GTI memory writes from L3 (L3 invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__memory_writes__gti_l3_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiMemoryWrites";
    counter->symbol_name = "GtiMemoryWrites";
    counter->desc = "The total number of GTI memory writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__memory_writes__gti_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiMscMemoryWrites";
    counter->symbol_name = "GtiMscMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Multisampling Color Cache (Multisampling Color Cache invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__memory_writes__gti_msc_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRccMemoryWrites";
    counter->symbol_name = "GtiRccMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Render Color Cache (Render Color Cache invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__memory_writes__gti_rcc_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRczMemoryWrites";
    counter->symbol_name = "GtiRczMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Render Depth Cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__memory_writes__gti_rcz_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRingAccesses";
    counter->symbol_name = "GtiRingAccesses";
    counter->desc = "The total number of all GTI accesses to the ring.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__memory_writes__gti_ring_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiSoMemoryWrites";
    counter->symbol_name = "GtiSoMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Stream Output.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__memory_writes__gti_so_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Stream Output");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiStcMemoryWrites";
    counter->symbol_name = "GtiStcMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Stencil Cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__memory_writes__gti_stc_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__memory_writes__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__memory_writes__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__memory_writes__l3_shader_throughput__read;
    counter->max_uint64 = sklgt3__memory_writes__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__memory_writes__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__memory_writes__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__memory_writes__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt3__memory_writes__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt3__memory_writes__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__memory_writes__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__memory_writes__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__memory_writes__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__memory_writes__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__memory_writes__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__memory_writes__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__memory_writes__slm_bytes_read__read;
    counter->max_uint64 = sklgt3__memory_writes__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__memory_writes__slm_bytes_written__read;
    counter->max_uint64 = sklgt3__memory_writes__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__memory_writes__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 41);
}

static void
sklgt3_add_compute_extended_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Compute Metrics Extended Gen9";
    metric_set->symbol_name = "ComputeExtended";
    metric_set->hw_config_guid = "52435e0b-f188-42ea-8680-21a56ee20dee";
    metric_set->counters = calloc(38, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(72, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(21, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C00E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141C8160 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x161C8015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181C0120 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x184E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A4EAAA0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C4E0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x024E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E6C0B01 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x006C0200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x026C000C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001C0041 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x061C4200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x081C4443 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1C4645 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1C7647 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041C7357 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1C0030 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x101C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x121C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4CAA2A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4C02AA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084CA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F5400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F5515 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0155 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x162CAA00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x182C00AA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11907FFF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900802 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900842 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900842 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007FC2A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x0007FC6A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x0007FC92 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x0007FCA2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x0007FC32 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x0007FC9A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x0007FE6A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x0007FE7A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000BF00 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00000003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00002001 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00778008 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00088078 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00808708 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00A08908 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt3__compute_extended__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt3__compute_extended__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__compute_extended__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuA64UntypedReads0";
    counter->symbol_name = "EuA64UntypedReads0";
    counter->desc = "The subslice 0 EU A64 Untyped Reads subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__compute_extended__eu_a64_untyped_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuA64UntypedWrites0";
    counter->symbol_name = "EuA64UntypedWrites0";
    counter->desc = "The subslice 0 EU A64 Untyped Writes subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__compute_extended__eu_a64_untyped_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__compute_extended__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU AVG IPC Rate";
    counter->symbol_name = "EuAvgIpcRate";
    counter->desc = "The average rate of IPC calculated for 2 FPU pipelines.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NUMBER;
    counter->read_float = sklgt3__compute_extended__eu_avg_ipc_rate__read;
    counter->max_float = sklgt3__compute_extended__eu_avg_ipc_rate__max;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__compute_extended__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Send Pipe Active";
    counter->symbol_name = "EuSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__compute_extended__eu_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__compute_extended__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Thread Occupancy";
    counter->symbol_name = "EuThreadOccupancy";
    counter->desc = "The percentage of time in which hardware threads occupied EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__compute_extended__eu_thread_occupancy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuTypedAtomics0";
    counter->symbol_name = "EuTypedAtomics0";
    counter->desc = "The subslice 0 EU Typed Atomics subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__compute_extended__eu_typed_atomics0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuTypedReads0";
    counter->symbol_name = "EuTypedReads0";
    counter->desc = "The subslice 0 EU Typed Reads subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__compute_extended__eu_typed_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuTypedWrites0";
    counter->symbol_name = "EuTypedWrites0";
    counter->desc = "The subslice 0 EU Typed Writes subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__compute_extended__eu_typed_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuUntypedAtomics0";
    counter->symbol_name = "EuUntypedAtomics0";
    counter->desc = "The subslice 0 EU Untyped Atomics subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__compute_extended__eu_untyped_atomics0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuUntypedReads0";
    counter->symbol_name = "EuUntypedReads0";
    counter->desc = "The subslice 0 EU Untyped Reads subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__compute_extended__eu_untyped_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuUntypedWrites0";
    counter->symbol_name = "EuUntypedWrites0";
    counter->desc = "The subslice 0 EU Untyped Writes subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__compute_extended__eu_untyped_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Pipe Active";
    counter->symbol_name = "Fpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__compute_extended__fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active";
    counter->symbol_name = "Fpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__compute_extended__fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt3__compute_extended__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt3__compute_extended__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__compute_extended__l3_shader_throughput__read;
    counter->max_uint64 = sklgt3__compute_extended__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt3__compute_extended__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt3__compute_extended__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__compute_extended__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__compute_extended__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__compute_extended__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__compute_extended__slm_bytes_read__read;
    counter->max_uint64 = sklgt3__compute_extended__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__compute_extended__slm_bytes_written__read;
    counter->max_uint64 = sklgt3__compute_extended__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Atomics 0";
    counter->symbol_name = "TypedAtomics0";
    counter->desc = "The subslice 0 typed atomics.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__compute_extended__typed_atomics0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TypedAtomicsPerCacheLine";
    counter->symbol_name = "TypedAtomicsPerCacheLine";
    counter->desc = "The ratio of EU typed atomics requests to L3 cache line writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
    counter->read_float = sklgt3__compute_extended__typed_atomics_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Reads 0";
    counter->symbol_name = "TypedReads0";
    counter->desc = "The subslice 0 typed reads.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__compute_extended__typed_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TypedReadsPerCacheLine";
    counter->symbol_name = "TypedReadsPerCacheLine";
    counter->desc = "The ratio of EU typed read requests to L3 cache line reads.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
    counter->read_float = sklgt3__compute_extended__typed_reads_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Writes 0";
    counter->symbol_name = "TypedWrites0";
    counter->desc = "The subslice 0 typed writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__compute_extended__typed_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TypedWritesPerCacheLine";
    counter->symbol_name = "TypedWritesPerCacheLine";
    counter->desc = "The ratio of EU typed write requests to L3 cache line writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
    counter->read_float = sklgt3__compute_extended__typed_writes_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Untyped Reads 0";
    counter->symbol_name = "UntypedReads0";
    counter->desc = "The subslice 0 untyped reads (including SLM reads).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__compute_extended__untyped_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "UntypedReadsPerCacheLine";
    counter->symbol_name = "UntypedReadsPerCacheLine";
    counter->desc = "The ratio of EU untyped read requests to L3 cache line reads.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
    counter->read_float = sklgt3__compute_extended__untyped_reads_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Untyped Writes 0";
    counter->symbol_name = "UntypedWrites0";
    counter->desc = "The subslice 0 untyped writes (including SLM writes).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__compute_extended__untyped_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "UntypedWritesPerCacheLine";
    counter->symbol_name = "UntypedWritesPerCacheLine";
    counter->desc = "The ratio of EU untyped write requests to L3 cache line writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
    counter->read_float = sklgt3__compute_extended__untyped_writes_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    assert(metric_set->n_counters <= 38);
}

static void
sklgt3_add_compute_l3_cache_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Compute Metrics L3 Cache Gen9";
    metric_set->symbol_name = "ComputeL3Cache";
    metric_set->hw_config_guid = "27076eeb-49f3-4fed-8423-c66506005c63";
    metric_set->counters = calloc(54, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(60, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(13, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x166C0760 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1593001E };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F900003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x184E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A4E8020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C4E0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x006C0051 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x066C5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x086C5C5D };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E6C5E5F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x186C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x061B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x081BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x101C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1CE000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1C0030 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C2A00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4C0280 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F0400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F1500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0140 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x162C0A00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x182C00A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03933300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05930032 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11930000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B930000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D900157 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F900158 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190030F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900063 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53903333 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900840 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FEFE };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x0007FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FEFD };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x0007FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FBEF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x0007FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FBDF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00000003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00002001 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00101100 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00201200 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00301300 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00401400 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt3__compute_l3_cache__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt3__compute_l3_cache__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__compute_l3_cache__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__compute_l3_cache__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__compute_l3_cache__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__compute_l3_cache__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU AVG IPC Rate";
    counter->symbol_name = "EuAvgIpcRate";
    counter->desc = "The average rate of IPC calculated for 2 FPU pipelines.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NUMBER;
    counter->read_float = sklgt3__compute_l3_cache__eu_avg_ipc_rate__read;
    counter->max_float = sklgt3__compute_l3_cache__eu_avg_ipc_rate__max;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Binary Instruction";
    counter->symbol_name = "EuBinaryFpu0Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing binary instructions on FPU0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__compute_l3_cache__eu_binary_fpu0_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Binary Instruction";
    counter->symbol_name = "EuBinaryFpu1Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing binary instructions on FPU1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__compute_l3_cache__eu_binary_fpu1_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__compute_l3_cache__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Hybrid Instruction";
    counter->symbol_name = "EuHybridFpu0Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing hybrid instructions on FPU0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__compute_l3_cache__eu_hybrid_fpu0_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Hybrid Instruction";
    counter->symbol_name = "EuHybridFpu1Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing hybrid instructions on FPU1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__compute_l3_cache__eu_hybrid_fpu1_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Move Instruction";
    counter->symbol_name = "EuMoveFpu0Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing move instructions on FPU0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__compute_l3_cache__eu_move_fpu0_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Move Instruction";
    counter->symbol_name = "EuMoveFpu1Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing move instructions on FPU1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__compute_l3_cache__eu_move_fpu1_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Send Pipe Active";
    counter->symbol_name = "EuSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__compute_l3_cache__eu_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__compute_l3_cache__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Ternary Instruction";
    counter->symbol_name = "EuTernaryFpu0Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing ternary instructions on FPU0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__compute_l3_cache__eu_ternary_fpu0_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Ternary Instruction";
    counter->symbol_name = "EuTernaryFpu1Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing ternary instructions on FPU1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__compute_l3_cache__eu_ternary_fpu1_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Pipe Active";
    counter->symbol_name = "Fpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__compute_l3_cache__fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active";
    counter->symbol_name = "Fpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__compute_l3_cache__fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__compute_l3_cache__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt3__compute_l3_cache__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt3__compute_l3_cache__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__compute_l3_cache__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI L3 Throughput";
    counter->symbol_name = "GtiL3Throughput";
    counter->desc = "The total number of GPU memory bytes transferred between L3 caches and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__compute_l3_cache__gti_l3_throughput__read;
    counter->max_uint64 = sklgt3__compute_l3_cache__gti_l3_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Read Throughput";
    counter->symbol_name = "GtiReadThroughput";
    counter->desc = "The total number of GPU memory bytes read from GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__compute_l3_cache__gti_read_throughput__read;
    counter->max_uint64 = sklgt3__compute_l3_cache__gti_read_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Write Throughput";
    counter->symbol_name = "GtiWriteThroughput";
    counter->desc = "The total number of GPU memory bytes written to GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__compute_l3_cache__gti_write_throughput__read;
    counter->max_uint64 = sklgt3__compute_l3_cache__gti_write_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__compute_l3_cache__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__compute_l3_cache__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Accesses";
    counter->symbol_name = "L3Accesses";
    counter->desc = "The total number of L3 accesses from all entities.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__compute_l3_cache__l3_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3");

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 00 Accesses";
        counter->symbol_name = "L3Bank00Accesses";
        counter->desc = "The total number of accesses to L3 Bank 00.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = sklgt3__compute_l3_cache__l3_bank00_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 00 IC Accesses";
        counter->symbol_name = "L3Bank00IcAccesses";
        counter->desc = "The total number of accesses to L3 Bank 00 from IC cache.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = sklgt3__compute_l3_cache__l3_bank00_ic_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3/IC");
    }

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 00 IC Hits";
        counter->symbol_name = "L3Bank00IcHits";
        counter->desc = "The total number of hits in L3 Bank 00 from IC cache.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = sklgt3__compute_l3_cache__l3_bank00_ic_hits__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3/IC");
    }

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 01 Accesses";
        counter->symbol_name = "L3Bank01Accesses";
        counter->desc = "The total number of accesses to L3 Bank 01.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = sklgt3__compute_l3_cache__l3_bank01_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 02 Accesses";
        counter->symbol_name = "L3Bank02Accesses";
        counter->desc = "The total number of accesses to L3 Bank 02.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = sklgt3__compute_l3_cache__l3_bank02_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 03 Accesses";
        counter->symbol_name = "L3Bank03Accesses";
        counter->desc = "The total number of accesses to L3 Bank 03.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = sklgt3__compute_l3_cache__l3_bank03_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Misses";
    counter->symbol_name = "L3Misses";
    counter->desc = "The total number of L3 misses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__compute_l3_cache__l3_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/TAG");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Sampler Throughput";
    counter->symbol_name = "L3SamplerThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between samplers and L3 caches.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__compute_l3_cache__l3_sampler_throughput__read;
    counter->max_uint64 = sklgt3__compute_l3_cache__l3_sampler_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__compute_l3_cache__l3_shader_throughput__read;
    counter->max_uint64 = sklgt3__compute_l3_cache__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Total Throughput";
    counter->symbol_name = "L3TotalThroughput";
    counter->desc = "The total number of GPU memory bytes transferred via L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__compute_l3_cache__l3_total_throughput__read;
    counter->max_uint64 = sklgt3__compute_l3_cache__l3_total_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__compute_l3_cache__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__compute_l3_cache__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__compute_l3_cache__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Accesses";
    counter->symbol_name = "SamplerAccesses";
    counter->desc = "The total number of messages send to samplers.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__compute_l3_cache__sampler_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt3__compute_l3_cache__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt3__compute_l3_cache__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__compute_l3_cache__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__compute_l3_cache__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__compute_l3_cache__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__compute_l3_cache__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__compute_l3_cache__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__compute_l3_cache__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__compute_l3_cache__slm_bytes_read__read;
    counter->max_uint64 = sklgt3__compute_l3_cache__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__compute_l3_cache__slm_bytes_written__read;
    counter->max_uint64 = sklgt3__compute_l3_cache__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__compute_l3_cache__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 54);
}

static void
sklgt3_add_hdc_and_sf_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set HDCAndSF";
    metric_set->symbol_name = "HDCAndSF";
    metric_set->hw_config_guid = "a1b8363b-b986-47b6-929a-847afde3dec8";
    metric_set->counters = calloc(40, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(55, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(8, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x104F0232 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x124F4640 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C0232 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11834400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004F1880 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x024F08BB };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044F001B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x046C0100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x066C000B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x061B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1C1800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x005B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x025BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x045B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x125C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x145C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x165C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x185C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C00A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F0055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F828000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8305C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09830000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07830000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D950080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13928000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F988000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190FC00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900842 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x10800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FDFF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt3__hdc_and_sf__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt3__hdc_and_sf__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__hdc_and_sf__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__hdc_and_sf__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__hdc_and_sf__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__hdc_and_sf__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__hdc_and_sf__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__hdc_and_sf__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt3__hdc_and_sf__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__hdc_and_sf__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt3__hdc_and_sf__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt3__hdc_and_sf__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__hdc_and_sf__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__hdc_and_sf__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__hdc_and_sf__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__hdc_and_sf__l3_shader_throughput__read;
    counter->max_uint64 = sklgt3__hdc_and_sf__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "HDC stalled by L3 (s0.ss0)";
        counter->symbol_name = "NonSamplerShader00AccessStalledOnL3";
        counter->desc = "Percentage of time when HDC has messges to L3, but it's stalled due to lack of credits (s0.ss0)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt3__hdc_and_sf__non_sampler_shader00_access_stalled_on_l3__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Data Port");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "HDC stalled by L3 (s0.ss1)";
        counter->symbol_name = "NonSamplerShader01AccessStalledOnL3";
        counter->desc = "Percentage of time when HDC has messges to L3, but it's stalled due to lack of credits (s0.ss1)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt3__hdc_and_sf__non_sampler_shader01_access_stalled_on_l3__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Data Port");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "HDC stalled by L3 (s0.ss2)";
        counter->symbol_name = "NonSamplerShader02AccessStalledOnL3";
        counter->desc = "Percentage of time when HDC has messges to L3, but it's stalled due to lack of credits (s0.ss2)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt3__hdc_and_sf__non_sampler_shader02_access_stalled_on_l3__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Data Port");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__hdc_and_sf__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Polygon Data Ready";
    counter->symbol_name = "PolyDataReady";
    counter->desc = "The percentage of time in which geometry pipeline output is ready";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__hdc_and_sf__poly_data_ready__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe/Strip-Fans");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__hdc_and_sf__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__hdc_and_sf__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__hdc_and_sf__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__hdc_and_sf__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__hdc_and_sf__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__hdc_and_sf__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt3__hdc_and_sf__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt3__hdc_and_sf__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__hdc_and_sf__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__hdc_and_sf__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__hdc_and_sf__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__hdc_and_sf__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__hdc_and_sf__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__hdc_and_sf__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__hdc_and_sf__slm_bytes_read__read;
    counter->max_uint64 = sklgt3__hdc_and_sf__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__hdc_and_sf__slm_bytes_written__read;
    counter->max_uint64 = sklgt3__hdc_and_sf__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__hdc_and_sf__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__hdc_and_sf__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__hdc_and_sf__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__hdc_and_sf__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 40);
}

static void
sklgt3_add_l3_1_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set L3_1";
    metric_set->symbol_name = "L3_1";
    metric_set->hw_config_guid = "fa857069-7f95-44c9-a3e0-cb8ccbc35abb";
    metric_set->counters = calloc(40, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(72, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(22, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x126C7B40 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x166C0020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A603444 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A613400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A4EA800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C4E0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x024E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C6C5327 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E6C5425 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x006C2A00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x026C285B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x046C005C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6C0800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1C003C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x121C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x161C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1C0800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x065B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A5C1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10600000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04600000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C610044 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10610000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06610000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4C02A8 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084CA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0154 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F0055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x182C00AA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190FFC0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900420 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900021 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900421 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900040 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00100070 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFF1 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00014002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000C3FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00010002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000C7FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00004002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000D3FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00100700 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FF1F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00001402 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FC3F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x00001002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FC7F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x00000402 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000FD3F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt3__l3_1__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt3__l3_1__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__l3_1__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__l3_1__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__l3_1__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__l3_1__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__l3_1__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__l3_1__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt3__l3_1__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__l3_1__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt3__l3_1__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt3__l3_1__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__l3_1__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__l3_1__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__l3_1__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank0 Active";
        counter->symbol_name = "L30Bank0Active";
        counter->desc = "The percentage of time in which slice0 L3 bank0 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt3__l3_1__l30_bank0_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank0 Stalled";
        counter->symbol_name = "L30Bank0Stalled";
        counter->desc = "The percentage of time in which slice0 L3 bank0 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt3__l3_1__l30_bank0_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank1 Active";
        counter->symbol_name = "L30Bank1Active";
        counter->desc = "The percentage of time in which slice0 L3 bank1 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt3__l3_1__l30_bank1_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank1 Stalled";
        counter->symbol_name = "L30Bank1Stalled";
        counter->desc = "The percentage of time in which slice0 L3 bank1 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt3__l3_1__l30_bank1_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__l3_1__l3_shader_throughput__read;
    counter->max_uint64 = sklgt3__l3_1__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__l3_1__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__l3_1__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__l3_1__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__l3_1__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__l3_1__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__l3_1__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__l3_1__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt3__l3_1__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt3__l3_1__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__l3_1__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__l3_1__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__l3_1__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__l3_1__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__l3_1__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__l3_1__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__l3_1__slm_bytes_read__read;
    counter->max_uint64 = sklgt3__l3_1__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__l3_1__slm_bytes_written__read;
    counter->max_uint64 = sklgt3__l3_1__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__l3_1__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__l3_1__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__l3_1__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__l3_1__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 40);
}

static void
sklgt3_add_l3_2_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set L3_2";
    metric_set->symbol_name = "L3_2";
    metric_set->hw_config_guid = "9830a5f3-a5e2-4773-a49d-6371407c382a";
    metric_set->counters = calloc(38, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(45, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(14, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x126C02E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x146C0001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A623400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x026C3324 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x046C3422 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x161C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1C0800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x065B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A5C1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06614000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C620044 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10620000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06620000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F0055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190F800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00100070 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFF1 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00028002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x000087FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00020002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x00008FFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00008002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000A7FF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt3__l3_2__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt3__l3_2__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__l3_2__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__l3_2__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__l3_2__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__l3_2__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__l3_2__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__l3_2__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt3__l3_2__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__l3_2__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt3__l3_2__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt3__l3_2__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__l3_2__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__l3_2__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__l3_2__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank2 Active";
        counter->symbol_name = "L30Bank2Active";
        counter->desc = "The percentage of time in which slice0 L3 bank2 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt3__l3_2__l30_bank2_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank2 Stalled";
        counter->symbol_name = "L30Bank2Stalled";
        counter->desc = "The percentage of time in which slice0 L3 bank2 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt3__l3_2__l30_bank2_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__l3_2__l3_shader_throughput__read;
    counter->max_uint64 = sklgt3__l3_2__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__l3_2__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__l3_2__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__l3_2__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__l3_2__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__l3_2__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__l3_2__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__l3_2__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt3__l3_2__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt3__l3_2__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__l3_2__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__l3_2__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__l3_2__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__l3_2__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__l3_2__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__l3_2__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__l3_2__slm_bytes_read__read;
    counter->max_uint64 = sklgt3__l3_2__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__l3_2__slm_bytes_written__read;
    counter->max_uint64 = sklgt3__l3_2__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__l3_2__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__l3_2__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__l3_2__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__l3_2__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 38);
}

static void
sklgt3_add_l3_3_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set L3_3";
    metric_set->symbol_name = "L3_3";
    metric_set->hw_config_guid = "59452ceb-24bb-4878-87ec-87aab7b4f9db";
    metric_set->counters = calloc(38, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(44, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(14, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x126C4E80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x146C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A633400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x026C3321 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x046C342F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6C2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x061B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x161C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1C1800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06604000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C630044 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10630000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06630000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C00AA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F0055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190F800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900842 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00100070 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFF1 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00028002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x000087FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00020002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x00008FFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00008002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000A7FF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt3__l3_3__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt3__l3_3__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__l3_3__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__l3_3__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__l3_3__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__l3_3__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__l3_3__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__l3_3__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt3__l3_3__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__l3_3__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt3__l3_3__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt3__l3_3__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__l3_3__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__l3_3__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__l3_3__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank3 Active";
        counter->symbol_name = "L30Bank3Active";
        counter->desc = "The percentage of time in which slice0 L3 bank3 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt3__l3_3__l30_bank3_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank3 Stalled";
        counter->symbol_name = "L30Bank3Stalled";
        counter->desc = "The percentage of time in which slice0 L3 bank3 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt3__l3_3__l30_bank3_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__l3_3__l3_shader_throughput__read;
    counter->max_uint64 = sklgt3__l3_3__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__l3_3__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__l3_3__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__l3_3__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__l3_3__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__l3_3__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__l3_3__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__l3_3__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt3__l3_3__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt3__l3_3__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__l3_3__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__l3_3__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__l3_3__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__l3_3__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__l3_3__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__l3_3__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__l3_3__slm_bytes_read__read;
    counter->max_uint64 = sklgt3__l3_3__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__l3_3__slm_bytes_written__read;
    counter->max_uint64 = sklgt3__l3_3__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__l3_3__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__l3_3__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__l3_3__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__l3_3__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 38);
}

static void
sklgt3_add_rasterizer_and_pixel_backend_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set RasterizerAndPixelBackend";
    metric_set->symbol_name = "RasterizerAndPixelBackend";
    metric_set->hw_config_guid = "d2249ff7-34b4-4203-b474-7c11546f9dae";
    metric_set->counters = calloc(41, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(32, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(10, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x102F3800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x144D0500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x120D03C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x140D03CF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F0004 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4E4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042F0480 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C0090 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064D0027 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004D0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D0D40 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020D803F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040D8023 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100D0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020F0010 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F0050 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190FC00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41901400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43901485 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000EFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00006000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000F3FF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt3__rasterizer_and_pixel_backend__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt3__rasterizer_and_pixel_backend__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__rasterizer_and_pixel_backend__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__rasterizer_and_pixel_backend__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__rasterizer_and_pixel_backend__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__rasterizer_and_pixel_backend__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__rasterizer_and_pixel_backend__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__rasterizer_and_pixel_backend__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt3__rasterizer_and_pixel_backend__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__rasterizer_and_pixel_backend__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt3__rasterizer_and_pixel_backend__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt3__rasterizer_and_pixel_backend__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__rasterizer_and_pixel_backend__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__rasterizer_and_pixel_backend__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__rasterizer_and_pixel_backend__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__rasterizer_and_pixel_backend__l3_shader_throughput__read;
    counter->max_uint64 = sklgt3__rasterizer_and_pixel_backend__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 PS Output Available";
        counter->symbol_name = "PSOutput0Available";
        counter->desc = "The percentage of time in which slice0 PS output is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt3__rasterizer_and_pixel_backend__ps_output0_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Post-EarlyZ Pixel Data Ready";
        counter->symbol_name = "PixelData0Ready";
        counter->desc = "The percentage of time in which slice0 post-EarlyZ pixel data is ready (after early Z tests have been applied)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt3__rasterizer_and_pixel_backend__pixel_data0_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Rasterizer/Early Depth Test");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Pixel Values Ready";
        counter->symbol_name = "PixelValues0Ready";
        counter->desc = "The percentage of time in which slice0 pixel values are ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt3__rasterizer_and_pixel_backend__pixel_values0_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__rasterizer_and_pixel_backend__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__rasterizer_and_pixel_backend__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__rasterizer_and_pixel_backend__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__rasterizer_and_pixel_backend__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__rasterizer_and_pixel_backend__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__rasterizer_and_pixel_backend__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__rasterizer_and_pixel_backend__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Rasterizer Input Available";
        counter->symbol_name = "Rasterizer0InputAvailable";
        counter->desc = "The percentage of time in which slice0 rasterizer input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt3__rasterizer_and_pixel_backend__rasterizer0_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Rasterizer");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Rasterizer Output Ready";
        counter->symbol_name = "Rasterizer0OutputReady";
        counter->desc = "The percentage of time in which slice0 rasterizer output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt3__rasterizer_and_pixel_backend__rasterizer0_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Rasterizer");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt3__rasterizer_and_pixel_backend__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt3__rasterizer_and_pixel_backend__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__rasterizer_and_pixel_backend__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__rasterizer_and_pixel_backend__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__rasterizer_and_pixel_backend__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__rasterizer_and_pixel_backend__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__rasterizer_and_pixel_backend__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__rasterizer_and_pixel_backend__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__rasterizer_and_pixel_backend__slm_bytes_read__read;
    counter->max_uint64 = sklgt3__rasterizer_and_pixel_backend__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__rasterizer_and_pixel_backend__slm_bytes_written__read;
    counter->max_uint64 = sklgt3__rasterizer_and_pixel_backend__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__rasterizer_and_pixel_backend__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__rasterizer_and_pixel_backend__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__rasterizer_and_pixel_backend__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__rasterizer_and_pixel_backend__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 41);
}

static void
sklgt3_add_sampler_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set Sampler";
    metric_set->symbol_name = "Sampler";
    metric_set->hw_config_guid = "c9cf7c63-0065-4226-941e-98590bad8f75";
    metric_set->counters = calloc(42, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(70, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(12, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14152C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16150005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x121600A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14352C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16350005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x123600A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14552C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16550005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x125600A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062F6000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022F2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4C0050 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C0010 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0350 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0FB000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F00DA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x182C0028 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022DC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C138000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E132000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0413C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C140018 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C157000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E150078 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10150000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04162180 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02160000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04174000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0233A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04333000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14348000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16348000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02357870 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10350000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04360043 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02360000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04371000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E538000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00538000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06533000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C540020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12548000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E557000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00557800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10550000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06560043 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02560000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06571000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190FF80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900060 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900842 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900060 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x70800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0000C000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000E7FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00003000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000F9FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000C00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FE7F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt3__sampler__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt3__sampler__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__sampler__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__sampler__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__sampler__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__sampler__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__sampler__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__sampler__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt3__sampler__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__sampler__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt3__sampler__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt3__sampler__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__sampler__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__sampler__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__sampler__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__sampler__l3_shader_throughput__read;
    counter->max_uint64 = sklgt3__sampler__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__sampler__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__sampler__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__sampler__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__sampler__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__sampler__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__sampler__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__sampler__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice0 Input Available";
        counter->symbol_name = "Sampler00InputAvailable";
        counter->desc = "The percentage of time in which slice0 subslice0 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt3__sampler__sampler00_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice0 Sampler Output Ready";
        counter->symbol_name = "Sampler00OutputReady";
        counter->desc = "The percentage of time in which slice0 subslice0 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt3__sampler__sampler00_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice1 Input Available";
        counter->symbol_name = "Sampler01InputAvailable";
        counter->desc = "The percentage of time in which slice0 subslice1 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt3__sampler__sampler01_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice1 Sampler Output Ready";
        counter->symbol_name = "Sampler01OutputReady";
        counter->desc = "The percentage of time in which slice0 subslice1 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt3__sampler__sampler01_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice2 Input Available";
        counter->symbol_name = "Sampler02InputAvailable";
        counter->desc = "The percentage of time in which slice0 subslice2 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt3__sampler__sampler02_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice2 Sampler Output Ready";
        counter->symbol_name = "Sampler02OutputReady";
        counter->desc = "The percentage of time in which slice0 subslice2 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt3__sampler__sampler02_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt3__sampler__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt3__sampler__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__sampler__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__sampler__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__sampler__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__sampler__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__sampler__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__sampler__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__sampler__slm_bytes_read__read;
    counter->max_uint64 = sklgt3__sampler__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__sampler__slm_bytes_written__read;
    counter->max_uint64 = sklgt3__sampler__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__sampler__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__sampler__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__sampler__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__sampler__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 42);
}

static void
sklgt3_add_tdl_1_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set TDL_1";
    metric_set->symbol_name = "TDL_1";
    metric_set->hw_config_guid = "e3bb1501-89ca-43fb-8668-9d96159e10a2";
    metric_set->counters = calloc(42, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(69, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(18, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12120000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12320000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12520000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022F3000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C0015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F03A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0FF000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F0095 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02108000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0410C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02118000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0411C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02121880 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041219B5 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00120000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02134000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04135000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C308000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E304000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06304000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C318000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E314000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06314000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C321A80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E320033 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06320031 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00320000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C334000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E331000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06331000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E508000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00508000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02504000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E518000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00518000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02514000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E521880 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00521A80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02520033 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E534000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00534000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02531000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190FF80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900062 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900040 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x00007FFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x00009FFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000EFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000F3FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FDFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FE7F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt3__tdl_1__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt3__tdl_1__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__tdl_1__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__tdl_1__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__tdl_1__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__tdl_1__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__tdl_1__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__tdl_1__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt3__tdl_1__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__tdl_1__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt3__tdl_1__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt3__tdl_1__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__tdl_1__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__tdl_1__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__tdl_1__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__tdl_1__l3_shader_throughput__read;
    counter->max_uint64 = sklgt3__tdl_1__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "NonPS Thread Ready For Dispatch on Slice0 Subslice0";
        counter->symbol_name = "NonPSThread00ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice0 subslice0 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt3__tdl_1__non_ps_thread00_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "NonPS Thread Ready For Dispatch on Slice0 Subslice1";
        counter->symbol_name = "NonPSThread01ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice0 subslice1 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt3__tdl_1__non_ps_thread01_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "NonPS Thread Ready For Dispatch on Slice0 Subslice2";
        counter->symbol_name = "NonPSThread02ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice0 subslice2 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt3__tdl_1__non_ps_thread02_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice0 Subslice0";
        counter->symbol_name = "PSThread00ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice0 subslice0 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt3__tdl_1__ps_thread00_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice0 Subslice1";
        counter->symbol_name = "PSThread01ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice0 subslice1 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt3__tdl_1__ps_thread01_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice0 Subslice2";
        counter->symbol_name = "PSThread02ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice0 subslice2 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt3__tdl_1__ps_thread02_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__tdl_1__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__tdl_1__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__tdl_1__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__tdl_1__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__tdl_1__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__tdl_1__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__tdl_1__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt3__tdl_1__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt3__tdl_1__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__tdl_1__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__tdl_1__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__tdl_1__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__tdl_1__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__tdl_1__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__tdl_1__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__tdl_1__slm_bytes_read__read;
    counter->max_uint64 = sklgt3__tdl_1__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__tdl_1__slm_bytes_written__read;
    counter->max_uint64 = sklgt3__tdl_1__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__tdl_1__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__tdl_1__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__tdl_1__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__tdl_1__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 42);
}

static void
sklgt3_add_tdl_2_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set TDL_2";
    metric_set->symbol_name = "TDL_2";
    metric_set->hw_config_guid = "29194a55-7e75-4152-a71f-ef34b1ae4cca";
    metric_set->counters = calloc(42, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(43, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(6, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12124D60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12322E60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12524D60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022F3000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C0014 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0FE000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F0097 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0410C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0411C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04121FB7 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00120000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04135000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00308000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06304000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00318000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06314000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00321B80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0632003F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00334000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06331000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0250C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0251C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02521FB7 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00520000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02535000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190FC00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900063 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt3__tdl_2__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt3__tdl_2__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__tdl_2__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__tdl_2__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__tdl_2__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__tdl_2__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__tdl_2__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__tdl_2__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt3__tdl_2__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__tdl_2__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt3__tdl_2__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt3__tdl_2__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__tdl_2__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__tdl_2__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__tdl_2__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__tdl_2__l3_shader_throughput__read;
    counter->max_uint64 = sklgt3__tdl_2__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__tdl_2__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__tdl_2__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__tdl_2__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__tdl_2__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__tdl_2__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__tdl_2__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__tdl_2__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt3__tdl_2__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt3__tdl_2__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__tdl_2__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__tdl_2__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt3__tdl_2__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__tdl_2__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__tdl_2__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt3__tdl_2__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__tdl_2__slm_bytes_read__read;
    counter->max_uint64 = sklgt3__tdl_2__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt3__tdl_2__slm_bytes_written__read;
    counter->max_uint64 = sklgt3__tdl_2__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice0 Port 0";
        counter->symbol_name = "ThreadHeader00ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice0 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt3__tdl_2__thread_header00_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice0 Port 1";
        counter->symbol_name = "ThreadHeader00ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice0 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt3__tdl_2__thread_header00_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice1 Port 0";
        counter->symbol_name = "ThreadHeader01ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice1 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt3__tdl_2__thread_header01_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice1 Port 1";
        counter->symbol_name = "ThreadHeader01ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice1 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt3__tdl_2__thread_header01_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice2 Port 0";
        counter->symbol_name = "ThreadHeader02ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice2 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt3__tdl_2__thread_header02_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice2 Port 1";
        counter->symbol_name = "ThreadHeader02ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice2 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt3__tdl_2__thread_header02_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__tdl_2__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__tdl_2__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__tdl_2__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__tdl_2__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 42);
}

static void
sklgt3_add_compute_extra_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Compute Metrics Extra Gen9";
    metric_set->symbol_name = "ComputeExtra";
    metric_set->hw_config_guid = "2d80a648-7b5a-4e92-bbe7-3b5c76f2e221";
    metric_set->counters = calloc(5, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(69, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x121203E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x123203E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x125203E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x129203E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12B203E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12D203E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x024EC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044EC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064EC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084CA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C0042 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F006D };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06104000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06114000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06120033 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00120000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06131000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04308000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04318000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04321980 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00320000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04334000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04504000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04514000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04520033 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00520000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04531000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00AF8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0ACC0001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x008D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x028DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C8FB000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E8F0001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06AC8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02AD4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02918000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02921980 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00920000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02934000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02B04000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02B14000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02B20033 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00B20000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02B31000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00D08000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00D18000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00D21980 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00D34000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190FC00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900402 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53901550 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt3__compute_extra__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt3__compute_extra__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active";
    counter->symbol_name = "Fpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__compute_extra__fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active including Ext Math";
    counter->symbol_name = "Fpu1ActiveAdjusted";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing including Extended Math processing";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__compute_extra__fpu1_active_adjusted__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt3__compute_extra__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt3__compute_extra__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    assert(metric_set->n_counters <= 5);
}

static void
sklgt3_add_vme_pipe_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Media Vme Pipe Gen9";
    metric_set->symbol_name = "VMEPipe";
    metric_set->hw_config_guid = "cfae9232-6ffc-42cc-a703-9790016925f0";
    metric_set->counters = calloc(10, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(73, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(17, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(2, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141A5800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x161A00C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12180240 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14180002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x149A5800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x169A00C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12980240 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14980002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A4E3FC0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002F1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042F3000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C9500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4C002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F0400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F5500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x162CAA00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x182C000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04193000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x081A28C1 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00133000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0613C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0813F000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00172000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06178000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0817A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00180037 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06180940 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08180000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02180000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04183000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04AFC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06AF3000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0ACC4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CCC0015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A8DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C8DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E8F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x108F0015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16ACA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18AC000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06993000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C9A28C1 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x009A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A93F000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C93F000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A97A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C97A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A980977 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08980000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04980000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06983000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x119000FF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900050 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900115 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900884 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00100030 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFF9 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FFFC };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FFF3 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00100180 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FFCF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FFCF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FF3F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00008003 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt3__vme_pipe__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt3__vme_pipe__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt3__vme_pipe__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__vme_pipe__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__vme_pipe__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__vme_pipe__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Thread Occupancy";
    counter->symbol_name = "EuThreadOccupancy";
    counter->desc = "The percentage of time in which hardware threads occupied EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__vme_pipe__eu_thread_occupancy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__vme_pipe__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt3__vme_pipe__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt3__vme_pipe__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VME Busy";
    counter->symbol_name = "VMEBusy";
    counter->desc = "The percentage of time in which VME (IME or CRE) was actively processing data.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__vme_pipe__vme_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "VME Pipe");

    assert(metric_set->n_counters <= 10);
}

static void
sklgt3_add_gpu_busyness_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Gpu Rings Busyness";
    metric_set->symbol_name = "GpuBusyness";
    metric_set->hw_config_guid = "0c5058ff-fdf4-4e0d-81fb-c0310fb76525";
    metric_set->counters = calloc(9, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(43, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21D05800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13805800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05962C25 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19950016 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21C05800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09D000A5 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11D00000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05D00000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09D54000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07800035 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D810400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21960000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0996C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B964000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B930068 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15948000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B94000C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03957500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D950000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17950000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07E54000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07928000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03988000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09978000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0BC000A5 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11C00000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05C00000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0BC54000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900463 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x10800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007C000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x000007FF };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AnyRingBusy";
    counter->symbol_name = "AnyRingBusy";
    counter->desc = "The percentage of time when any command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__gpu_busyness__any_ring_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt3__gpu_busyness__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt3__gpu_busyness__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Blitter Ring Busy";
    counter->symbol_name = "BlitterBusy";
    counter->desc = "The percentage of time when blitter command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__gpu_busyness__blitter_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt3__gpu_busyness__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt3__gpu_busyness__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Render Ring Busy";
    counter->symbol_name = "RenderBusy";
    counter->desc = "The percentage of time when render command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__gpu_busyness__render_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Vdbox0 Ring Busy";
    counter->symbol_name = "Vdbox0Busy";
    counter->desc = "The percentage of time when Vdbox0 command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__gpu_busyness__vdbox0_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Vdbox1 Ring Busy";
    counter->symbol_name = "Vdbox1Busy";
    counter->desc = "The percentage of time when Vdbox1 command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__gpu_busyness__vdbox1_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Vebox Ring Busy";
    counter->symbol_name = "VeboxBusy";
    counter->desc = "The percentage of time when vebox command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt3__gpu_busyness__vebox_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    assert(metric_set->n_counters <= 9);
}

static void
sklgt3_add_test_oa_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "MDAPI testing set Gen9";
    metric_set->symbol_name = "TestOa";
    metric_set->hw_config_guid = "2b985803-d3c9-4629-8a4f-634bfecba0e8";
    metric_set->counters = calloc(12, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(13, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(22, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07810013 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B930040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07E54000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000004 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00000003 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000007 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00100002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FFF7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00100002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FFCF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00100082 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FFEF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x001000C2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FFE7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x00100001 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000FFE7 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt3__test_oa__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt3__test_oa__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter0";
    counter->symbol_name = "Counter0";
    counter->desc = "HW test counter 0. Factor: 0.0";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = sklgt3__test_oa__counter0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter1";
    counter->symbol_name = "Counter1";
    counter->desc = "HW test counter 1. Factor: 1.0";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = sklgt3__test_oa__counter1__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter2";
    counter->symbol_name = "Counter2";
    counter->desc = "HW test counter 2. Factor: 1.0";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = sklgt3__test_oa__counter2__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter3";
    counter->symbol_name = "Counter3";
    counter->desc = "HW test counter 3. Factor: 0.5";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = sklgt3__test_oa__counter3__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter4";
    counter->symbol_name = "Counter4";
    counter->desc = "HW test counter 4. Factor: 0.333";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = sklgt3__test_oa__counter4__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter5";
    counter->symbol_name = "Counter5";
    counter->desc = "HW test counter 5. Factor: 0.333";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = sklgt3__test_oa__counter5__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter6";
    counter->symbol_name = "Counter6";
    counter->desc = "HW test counter 6. Factor: 0.166";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = sklgt3__test_oa__counter6__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter7";
    counter->symbol_name = "Counter7";
    counter->desc = "HW test counter 7. Factor: 0.666";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = sklgt3__test_oa__counter7__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter8";
    counter->symbol_name = "Counter8";
    counter->desc = "HW test counter 8. Should be equal to 1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = sklgt3__test_oa__counter8__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt3__test_oa__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt3__test_oa__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    assert(metric_set->n_counters <= 12);
}

static void
sklgt3_add_pma__stall_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set PMA Stall";
    metric_set->symbol_name = "PMA_Stall";
    metric_set->hw_config_guid = "c889fd93-8dc7-4ba5-9451-de34a8b5ea3f";
    metric_set->counters = calloc(4, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(24, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(9, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x122D3080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F0800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0FAA00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002D0025 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062D1300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082D16A4 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2D162E };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x102D0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190003F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00E00021 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0007FFF8 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x07000101 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0038FFC7 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt3__pma__stall__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt3__pma__stall__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt3__pma__stall__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt3__pma__stall__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "STC PMA stall";
        counter->symbol_name = "StcPMAStall";
        counter->desc = "Percentage of time when stencil cache line and an overlapping pixel are causing stalls";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt3__pma__stall__stc_pma_stall__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Stencil Cache");
    }

    assert(metric_set->n_counters <= 4);
}

static void
sklgt4_add_render_basic_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Render Metrics Basic Gen9";
    metric_set->symbol_name = "RenderBasic";
    metric_set->hw_config_guid = "95322a71-bb05-4437-bc27-f7dd7b27d136";
    metric_set->counters = calloc(51, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(94, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(5, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x166C01E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12170280 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12370280 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16EC01E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x176C01E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11930317 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x159303DF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F900003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A4E03B0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A6C0053 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1C0001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002F1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042F1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4CA400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4C0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F0400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F5600 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x162CAA00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00133000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08133000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00170020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08170021 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10170000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0633C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06370800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10370000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1ACE0230 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AEC5300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10EC0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1CEC0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A9B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C9C0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0ACC2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CCC0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x088D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A8D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E8F1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x108F0001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16AC8800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B4E0020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x096C5300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x116C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x091B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B1C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B4C2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x090D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F0F1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x172C0800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D933031 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F933E3F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01933D00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0393073C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0593000E };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D930000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19930000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B930000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D900157 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F900158 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190003F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x5190FF30 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900060 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55903033 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45901421 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900803 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x5790FFF1 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x5990000F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x5390FFFF };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00222222 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt4__render_basic__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt4__render_basic__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__render_basic__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__render_basic__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__render_basic__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__render_basic__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__render_basic__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__render_basic__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__render_basic__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt4__render_basic__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt4__render_basic__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__render_basic__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Depth Throughput";
    counter->symbol_name = "GtiDepthThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between depth caches and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__render_basic__gti_depth_throughput__read;
    counter->max_uint64 = sklgt4__render_basic__gti_depth_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI HDC TLB Lookup Throughput";
    counter->symbol_name = "GtiHdcLookupsThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between GTI and HDC, when HDC is doing TLB lookups.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__render_basic__gti_hdc_lookups_throughput__read;
    counter->max_uint64 = sklgt4__render_basic__gti_hdc_lookups_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI L3 Throughput";
    counter->symbol_name = "GtiL3Throughput";
    counter->desc = "The total number of GPU memory bytes transferred between L3 caches and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__render_basic__gti_l3_throughput__read;
    counter->max_uint64 = sklgt4__render_basic__gti_l3_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI RCC Throughput";
    counter->symbol_name = "GtiRccThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between render color caches and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__render_basic__gti_rcc_throughput__read;
    counter->max_uint64 = sklgt4__render_basic__gti_rcc_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Read Throughput";
    counter->symbol_name = "GtiReadThroughput";
    counter->desc = "The total number of GPU memory bytes read from GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__render_basic__gti_read_throughput__read;
    counter->max_uint64 = sklgt4__render_basic__gti_read_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Fixed Pipe Throughput";
    counter->symbol_name = "GtiVfThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between 3D Pipeline (Command Dispatch, Input Assembly and Stream Output) and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__render_basic__gti_vf_throughput__read;
    counter->max_uint64 = sklgt4__render_basic__gti_vf_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Write Throughput";
    counter->symbol_name = "GtiWriteThroughput";
    counter->desc = "The total number of GPU memory bytes written to GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__render_basic__gti_write_throughput__read;
    counter->max_uint64 = sklgt4__render_basic__gti_write_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__render_basic__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__render_basic__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Lookup Accesses w/o IC";
    counter->symbol_name = "L3Lookups";
    counter->desc = "The total number of L3 cache lookup accesses w/o IC.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__render_basic__l3_lookups__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/TAG");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Misses";
    counter->symbol_name = "L3Misses";
    counter->desc = "The total number of L3 misses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__render_basic__l3_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/TAG");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Sampler Throughput";
    counter->symbol_name = "L3SamplerThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between samplers and L3 caches.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__render_basic__l3_sampler_throughput__read;
    counter->max_uint64 = sklgt4__render_basic__l3_sampler_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__render_basic__l3_shader_throughput__read;
    counter->max_uint64 = sklgt4__render_basic__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__render_basic__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__render_basic__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__render_basic__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__render_basic__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__render_basic__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__render_basic__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__render_basic__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    if (perf->devinfo.subslice_mask & 0x09) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Sampler 0 Bottleneck";
        counter->symbol_name = "Sampler0Bottleneck";
        counter->desc = "The percentage of time in which Sampler 0 has been slowing down the pipe when processing EU requests.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt4__render_basic__sampler0_bottleneck__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x09) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Sampler 0 Busy";
        counter->symbol_name = "Sampler0Busy";
        counter->desc = "The percentage of time in which Sampler 0 has been processing EU requests.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt4__render_basic__sampler0_busy__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x12) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Sampler 1 Busy";
        counter->symbol_name = "Sampler1Busy";
        counter->desc = "The percentage of time in which Sampler 1 has been processing EU requests.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt4__render_basic__sampler1_busy__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samplers Bottleneck";
    counter->symbol_name = "SamplerBottleneck";
    counter->desc = "The percentage of time in which samplers have been slowing down the pipe when processing EU requests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__render_basic__sampler_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Cache Misses";
    counter->symbol_name = "SamplerL1Misses";
    counter->desc = "The total number of sampler cache misses in all LODs in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__render_basic__sampler_l1_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt4__render_basic__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt4__render_basic__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samplers Busy";
    counter->symbol_name = "SamplersBusy";
    counter->desc = "The percentage of time in which samplers have been processing EU requests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__render_basic__samplers_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__render_basic__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__render_basic__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__render_basic__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__render_basic__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__render_basic__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__render_basic__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__render_basic__slm_bytes_read__read;
    counter->max_uint64 = sklgt4__render_basic__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__render_basic__slm_bytes_written__read;
    counter->max_uint64 = sklgt4__render_basic__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__render_basic__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__render_basic__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__render_basic__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__render_basic__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 51);
}

static void
sklgt4_add_compute_basic_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Compute Metrics Basic Gen9";
    metric_set->symbol_name = "ComputeBasic";
    metric_set->hw_config_guid = "7277228f-e7f3-4743-945a-6a2049d11377";
    metric_set->counters = calloc(39, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(78, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(5, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x104F00E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x124F1C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C00E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37906800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F900003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A4E0820 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C4E0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064F0900 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084F0032 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4F1891 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4F0E00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E4F003C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004F0D80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x024F003B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x006C0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x086C0100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C6C000C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E6C0B00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x186C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x081B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x101C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1C0024 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x065B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x085B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A5BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C5B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E5B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x005B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x025B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A5C6000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C5C001B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x125C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x145C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4C0208 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F5400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F5500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0155 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x162CFB00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x182C00BE };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19900157 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B900158 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D900105 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F900103 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11900FFF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900821 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900802 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900802 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900422 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53905555 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00000003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00002001 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00778008 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00088078 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00808708 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00A08908 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt4__compute_basic__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt4__compute_basic__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__compute_basic__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__compute_basic__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__compute_basic__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__compute_basic__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU AVG IPC Rate";
    counter->symbol_name = "EuAvgIpcRate";
    counter->desc = "The average rate of IPC calculated for 2 FPU pipelines.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NUMBER;
    counter->read_float = sklgt4__compute_basic__eu_avg_ipc_rate__read;
    counter->max_float = sklgt4__compute_basic__eu_avg_ipc_rate__max;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__compute_basic__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Send Pipe Active";
    counter->symbol_name = "EuSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__compute_basic__eu_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__compute_basic__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Thread Occupancy";
    counter->symbol_name = "EuThreadOccupancy";
    counter->desc = "The percentage of time in which hardware threads occupied EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__compute_basic__eu_thread_occupancy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Pipe Active";
    counter->symbol_name = "Fpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__compute_basic__fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active";
    counter->symbol_name = "Fpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__compute_basic__fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__compute_basic__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt4__compute_basic__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt4__compute_basic__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__compute_basic__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Read Throughput";
    counter->symbol_name = "GtiReadThroughput";
    counter->desc = "The total number of GPU memory bytes read from GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__compute_basic__gti_read_throughput__read;
    counter->max_uint64 = sklgt4__compute_basic__gti_read_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Write Throughput";
    counter->symbol_name = "GtiWriteThroughput";
    counter->desc = "The total number of GPU memory bytes written to GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__compute_basic__gti_write_throughput__read;
    counter->max_uint64 = sklgt4__compute_basic__gti_write_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__compute_basic__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__compute_basic__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__compute_basic__l3_shader_throughput__read;
    counter->max_uint64 = sklgt4__compute_basic__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__compute_basic__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__compute_basic__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__compute_basic__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt4__compute_basic__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt4__compute_basic__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__compute_basic__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__compute_basic__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__compute_basic__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__compute_basic__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__compute_basic__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__compute_basic__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__compute_basic__slm_bytes_read__read;
    counter->max_uint64 = sklgt4__compute_basic__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__compute_basic__slm_bytes_written__read;
    counter->max_uint64 = sklgt4__compute_basic__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Bytes Read";
    counter->symbol_name = "TypedBytesRead";
    counter->desc = "The total number of typed memory bytes read via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__compute_basic__typed_bytes_read__read;
    counter->max_uint64 = sklgt4__compute_basic__typed_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Bytes Written";
    counter->symbol_name = "TypedBytesWritten";
    counter->desc = "The total number of untyped memory bytes written via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__compute_basic__typed_bytes_written__read;
    counter->max_uint64 = sklgt4__compute_basic__typed_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Untyped Bytes Read";
    counter->symbol_name = "UntypedBytesRead";
    counter->desc = "The total number of typed memory bytes read via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__compute_basic__untyped_bytes_read__read;
    counter->max_uint64 = sklgt4__compute_basic__untyped_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Untyped Writes";
    counter->symbol_name = "UntypedBytesWritten";
    counter->desc = "The total number of untyped memory bytes written via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__compute_basic__untyped_bytes_written__read;
    counter->max_uint64 = sklgt4__compute_basic__untyped_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__compute_basic__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 39);
}

static void
sklgt4_add_render_pipe_profile_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Render Metrics for 3D Pipeline Profile Gen9";
    metric_set->symbol_name = "RenderPipeProfile";
    metric_set->hw_config_guid = "463c668c-3f60-49b6-8f85-d995b635b3b2";
    metric_set->counters = calloc(43, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(114, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(21, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0E001F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10116800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x178A03E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11824C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11830020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13840020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11850019 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11860007 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01870C40 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17880000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C0040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020E5400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000E0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080F0040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F0040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06104000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06110012 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06131000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01898000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D890100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03898000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09808000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B808000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0380C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8A0075 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D8A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x118A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B8A4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x138A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D81A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15818000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17818000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B820030 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07828000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D824000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F828000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05824000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D830003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0583000C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09830000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03838000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07838000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B840980 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03844D80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11840000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09848000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09850080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03850003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01850000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07860000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F860400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09870032 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01888052 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11880000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09884000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B931001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D930001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19934000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B958000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D950094 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19958000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09E58000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0BE58000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03E5C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0592C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B928000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D924000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F924000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11928000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1392C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09924000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01985000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07988000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09981000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B982000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D982000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F989000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05982000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x23904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x27904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x29908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190C080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51901110 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900440 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55901111 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900C21 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57901411 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900042 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900024 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900841 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900411 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007FFEA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x00007FFC };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x0007AFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000F5FD };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00079FFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000F3FB };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x0007BF7A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000F7E7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x0007FEFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000F7CF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00077FFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000EFDF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x0006FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000CFBF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x0003FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x00005F7F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00025024 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00035034 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00045044 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00055054 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00065064 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt4__render_pipe_profile__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt4__render_pipe_profile__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "BC Bottleneck";
    counter->symbol_name = "BcBottleneck";
    counter->desc = "The percentage of time in which barycentric coordinates calculation pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__render_pipe_profile__bc_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Barycentric Calc");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Clipper Bottleneck";
    counter->symbol_name = "ClBottleneck";
    counter->desc = "The percentage of time in which clipper pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__render_pipe_profile__cl_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Clipper");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CL Stall";
    counter->symbol_name = "ClStall";
    counter->desc = "The percentage of time in which clipper pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__render_pipe_profile__cl_stall__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Clipper");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__render_pipe_profile__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Bottleneck";
    counter->symbol_name = "DsBottleneck";
    counter->desc = "The percentage of time in which domain shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__render_pipe_profile__ds_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Stall";
    counter->symbol_name = "DsStall";
    counter->desc = "The percentage of time in which domain shader pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__render_pipe_profile__ds_stall__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__render_pipe_profile__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Bottleneck";
    counter->symbol_name = "EarlyDepthBottleneck";
    counter->desc = "The percentage of time in which early depth test pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__render_pipe_profile__early_depth_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__render_pipe_profile__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__render_pipe_profile__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__render_pipe_profile__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__render_pipe_profile__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt4__render_pipe_profile__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt4__render_pipe_profile__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Bottleneck";
    counter->symbol_name = "GsBottleneck";
    counter->desc = "The percentage of time in which geometry shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__render_pipe_profile__gs_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__render_pipe_profile__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Hi-Depth Bottleneck";
    counter->symbol_name = "HiDepthBottleneck";
    counter->desc = "The percentage of time in which early hierarchical depth test pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__render_pipe_profile__hi_depth_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__render_pipe_profile__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Bottleneck";
    counter->symbol_name = "HsBottleneck";
    counter->desc = "The percentage of time in which hull shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__render_pipe_profile__hs_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Stall";
    counter->symbol_name = "HsStall";
    counter->desc = "The percentage of time in which hull stall pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__render_pipe_profile__hs_stall__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__render_pipe_profile__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__render_pipe_profile__l3_shader_throughput__read;
    counter->max_uint64 = sklgt4__render_pipe_profile__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__render_pipe_profile__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__render_pipe_profile__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__render_pipe_profile__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt4__render_pipe_profile__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt4__render_pipe_profile__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__render_pipe_profile__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__render_pipe_profile__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__render_pipe_profile__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Strip-Fans Bottleneck";
    counter->symbol_name = "SfBottleneck";
    counter->desc = "The percentage of time in which strip-fans pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__render_pipe_profile__sf_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Strip-Fans");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SF Stall";
    counter->symbol_name = "SfStall";
    counter->desc = "The percentage of time in which strip-fans pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__render_pipe_profile__sf_stall__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Strip-Fans");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__render_pipe_profile__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__render_pipe_profile__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__render_pipe_profile__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__render_pipe_profile__slm_bytes_read__read;
    counter->max_uint64 = sklgt4__render_pipe_profile__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__render_pipe_profile__slm_bytes_written__read;
    counter->max_uint64 = sklgt4__render_pipe_profile__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SO Bottleneck";
    counter->symbol_name = "SoBottleneck";
    counter->desc = "The percentage of time in which stream output pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__render_pipe_profile__so_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Stream Output");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SO Stall";
    counter->symbol_name = "SoStall";
    counter->desc = "The percentage of time in which stream-output pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__render_pipe_profile__so_stall__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Stream Output");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VF Bottleneck";
    counter->symbol_name = "VfBottleneck";
    counter->desc = "The percentage of time in which vertex fetch pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__render_pipe_profile__vf_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Input Assembler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Bottleneck";
    counter->symbol_name = "VsBottleneck";
    counter->desc = "The percentage of time in which vertex shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__render_pipe_profile__vs_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__render_pipe_profile__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 43);
}

static void
sklgt4_add_memory_reads_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Memory Reads Distribution Gen9";
    metric_set->symbol_name = "MemoryReads";
    metric_set->hw_config_guid = "3ae6e74c-72c3-4040-9bd0-7961430b8cc8";
    metric_set->counters = calloc(41, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(47, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(32, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11810C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1381001A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37906800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F900064 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03811300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05811B12 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0781001A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B930055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03E58000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05E5C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07E54000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13900150 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21900151 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x23900152 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25900153 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x27900154 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x29900155 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B900156 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D900157 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F90015F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31900105 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15900103 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17900101 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900C60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900C63 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900C63 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900063 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000272C, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002728, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000271C, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002718, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000274C, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002748, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00006667 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000275C, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002758, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002754, .val = 0x00006465 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002750, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007F81A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x0007F82A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x0007F872 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x0007F8BA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x0007F87A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x0007F8EA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x0007F8E2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x0007F8F2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000FE00 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00025024 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00035034 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00045044 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00055054 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00065064 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt4__memory_reads__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt4__memory_reads__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__memory_reads__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__memory_reads__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__memory_reads__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__memory_reads__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__memory_reads__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__memory_reads__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt4__memory_reads__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt4__memory_reads__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__memory_reads__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiCmdStreamerMemoryReads";
    counter->symbol_name = "GtiCmdStreamerMemoryReads";
    counter->desc = "The total number of GTI memory reads from Command Streamer.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__memory_reads__gti_cmd_streamer_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Command Streamer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiHizMemoryReads";
    counter->symbol_name = "GtiHizMemoryReads";
    counter->desc = "The total number of GTI memory reads from Hierarchical Depth Cache (Hi-Depth Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__memory_reads__gti_hiz_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank0Reads";
    counter->symbol_name = "GtiL3Bank0Reads";
    counter->desc = "The total number of GTI memory reads from L3 Bank 0 (L3 Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__memory_reads__gti_l3_bank0_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank1Reads";
    counter->symbol_name = "GtiL3Bank1Reads";
    counter->desc = "The total number of GTI memory reads from L3 Bank 1 (L3 Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__memory_reads__gti_l3_bank1_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank2Reads";
    counter->symbol_name = "GtiL3Bank2Reads";
    counter->desc = "The total number of GTI memory reads from L3 Bank 2 (L3 Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__memory_reads__gti_l3_bank2_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank3Reads";
    counter->symbol_name = "GtiL3Bank3Reads";
    counter->desc = "The total number of GTI memory reads from L3 Bank 3 (L3 Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__memory_reads__gti_l3_bank3_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Reads";
    counter->symbol_name = "GtiL3Reads";
    counter->desc = "The total number of GTI memory reads from L3 (L3 Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__memory_reads__gti_l3_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiMemoryReads";
    counter->symbol_name = "GtiMemoryReads";
    counter->desc = "The total number of GTI memory reads.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__memory_reads__gti_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiMscMemoryReads";
    counter->symbol_name = "GtiMscMemoryReads";
    counter->desc = "The total number of GTI memory reads from Multisampling Color Cache (Multisampling Color Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__memory_reads__gti_msc_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRccMemoryReads";
    counter->symbol_name = "GtiRccMemoryReads";
    counter->desc = "The total number of GTI memory reads from Render Color Cache (Render Color Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__memory_reads__gti_rcc_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRczMemoryReads";
    counter->symbol_name = "GtiRczMemoryReads";
    counter->desc = "The total number of GTI memory reads from Render Depth Cache (Render Depth Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__memory_reads__gti_rcz_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRingAccesses";
    counter->symbol_name = "GtiRingAccesses";
    counter->desc = "The total number of all accesses from GTI to the ring.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__memory_reads__gti_ring_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRsMemoryReads";
    counter->symbol_name = "GtiRsMemoryReads";
    counter->desc = "The total number of GTI memory reads from Resource Streamer.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__memory_reads__gti_rs_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Resource Streamer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiStcMemoryReads";
    counter->symbol_name = "GtiStcMemoryReads";
    counter->desc = "The total number of GTI memory reads from Stencil Cache (Stencil Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__memory_reads__gti_stc_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiVfMemoryReads";
    counter->symbol_name = "GtiVfMemoryReads";
    counter->desc = "The total number of GTI memory reads from Vertex Fetch.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__memory_reads__gti_vf_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Vertex Fetch");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__memory_reads__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__memory_reads__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__memory_reads__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__memory_reads__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__memory_reads__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt4__memory_reads__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt4__memory_reads__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__memory_reads__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__memory_reads__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__memory_reads__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__memory_reads__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__memory_reads__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__memory_reads__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__memory_reads__slm_bytes_read__read;
    counter->max_uint64 = sklgt4__memory_reads__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__memory_reads__slm_bytes_written__read;
    counter->max_uint64 = sklgt4__memory_reads__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__memory_reads__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 41);
}

static void
sklgt4_add_memory_writes_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Memory Writes Distribution Gen9";
    metric_set->symbol_name = "MemoryWrites";
    metric_set->hw_config_guid = "055f256d-4052-467c-8dec-6064a4806433";
    metric_set->counters = calloc(41, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(47, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(32, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11810C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1381001A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37906800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F901000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03811300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05811B12 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0781001A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B930055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03E58000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05E5C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07E54000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13900160 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21900161 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x23900162 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25900163 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x27900164 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x29900165 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B900166 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D900167 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F900150 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31900105 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15900103 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17900101 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900C60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900C63 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900C63 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900063 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000272C, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002728, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000271C, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002718, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000274C, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002748, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00006667 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000275C, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002758, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002754, .val = 0x00006465 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002750, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007F81A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x0007F82A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x0007F822 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x0007F8BA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x0007F87A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x0007F8EA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x0007F8E2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x0007F8F2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000FE00 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00025024 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00035034 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00045044 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00055054 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00065064 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt4__memory_writes__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt4__memory_writes__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__memory_writes__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__memory_writes__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__memory_writes__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__memory_writes__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__memory_writes__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__memory_writes__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt4__memory_writes__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt4__memory_writes__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__memory_writes__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiCmdStreamerMemoryWrites";
    counter->symbol_name = "GtiCmdStreamerMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Command Streamer.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__memory_writes__gti_cmd_streamer_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Command Streamer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiHizMemoryWrites";
    counter->symbol_name = "GtiHizMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Hierarchical Depth Cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__memory_writes__gti_hiz_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank0Writes";
    counter->symbol_name = "GtiL3Bank0Writes";
    counter->desc = "The total number of GTI memory writes from L3 Bank 0 (L3 Bank 0 invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__memory_writes__gti_l3_bank0_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank1Writes";
    counter->symbol_name = "GtiL3Bank1Writes";
    counter->desc = "The total number of GTI memory writes from L3 Bank 1 (L3 Bank 1 invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__memory_writes__gti_l3_bank1_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank2Writes";
    counter->symbol_name = "GtiL3Bank2Writes";
    counter->desc = "The total number of GTI memory writes from L3 Bank 2 (L3 Bank 2 invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__memory_writes__gti_l3_bank2_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank3Writes";
    counter->symbol_name = "GtiL3Bank3Writes";
    counter->desc = "The total number of GTI memory writes from L3 Bank 3 (L3 Bank 3 invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__memory_writes__gti_l3_bank3_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Writes";
    counter->symbol_name = "GtiL3Writes";
    counter->desc = "The total number of GTI memory writes from L3 (L3 invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__memory_writes__gti_l3_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiMemoryWrites";
    counter->symbol_name = "GtiMemoryWrites";
    counter->desc = "The total number of GTI memory writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__memory_writes__gti_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiMscMemoryWrites";
    counter->symbol_name = "GtiMscMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Multisampling Color Cache (Multisampling Color Cache invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__memory_writes__gti_msc_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRccMemoryWrites";
    counter->symbol_name = "GtiRccMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Render Color Cache (Render Color Cache invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__memory_writes__gti_rcc_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRczMemoryWrites";
    counter->symbol_name = "GtiRczMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Render Depth Cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__memory_writes__gti_rcz_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRingAccesses";
    counter->symbol_name = "GtiRingAccesses";
    counter->desc = "The total number of all GTI accesses to the ring.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__memory_writes__gti_ring_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiSoMemoryWrites";
    counter->symbol_name = "GtiSoMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Stream Output.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__memory_writes__gti_so_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Stream Output");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiStcMemoryWrites";
    counter->symbol_name = "GtiStcMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Stencil Cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__memory_writes__gti_stc_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__memory_writes__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__memory_writes__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__memory_writes__l3_shader_throughput__read;
    counter->max_uint64 = sklgt4__memory_writes__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__memory_writes__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__memory_writes__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__memory_writes__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt4__memory_writes__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt4__memory_writes__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__memory_writes__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__memory_writes__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__memory_writes__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__memory_writes__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__memory_writes__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__memory_writes__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__memory_writes__slm_bytes_read__read;
    counter->max_uint64 = sklgt4__memory_writes__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__memory_writes__slm_bytes_written__read;
    counter->max_uint64 = sklgt4__memory_writes__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__memory_writes__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 41);
}

static void
sklgt4_add_compute_extended_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Compute Metrics Extended Gen9";
    metric_set->symbol_name = "ComputeExtended";
    metric_set->hw_config_guid = "753972d4-87cd-4460-824d-754463ac5054";
    metric_set->counters = calloc(38, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(72, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(21, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C00E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141C8160 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x161C8015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181C0120 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x184E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A4EAAA0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C4E0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x024E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E6C0B01 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x006C0200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x026C000C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001C0041 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x061C4200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x081C4443 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1C4645 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1C7647 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041C7357 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1C0030 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x101C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x121C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4CAA2A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4C02AA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084CA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F5400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F5515 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0155 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x162CAA00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x182C00AA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11907FFF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900802 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900842 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900842 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007FC2A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x0007FC6A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x0007FC92 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x0007FCA2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x0007FC32 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x0007FC9A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x0007FE6A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x0007FE7A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000BF00 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00000003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00002001 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00778008 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00088078 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00808708 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00A08908 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt4__compute_extended__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt4__compute_extended__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__compute_extended__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuA64UntypedReads0";
    counter->symbol_name = "EuA64UntypedReads0";
    counter->desc = "The subslice 0 EU A64 Untyped Reads subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__compute_extended__eu_a64_untyped_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuA64UntypedWrites0";
    counter->symbol_name = "EuA64UntypedWrites0";
    counter->desc = "The subslice 0 EU A64 Untyped Writes subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__compute_extended__eu_a64_untyped_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__compute_extended__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU AVG IPC Rate";
    counter->symbol_name = "EuAvgIpcRate";
    counter->desc = "The average rate of IPC calculated for 2 FPU pipelines.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NUMBER;
    counter->read_float = sklgt4__compute_extended__eu_avg_ipc_rate__read;
    counter->max_float = sklgt4__compute_extended__eu_avg_ipc_rate__max;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__compute_extended__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Send Pipe Active";
    counter->symbol_name = "EuSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__compute_extended__eu_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__compute_extended__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Thread Occupancy";
    counter->symbol_name = "EuThreadOccupancy";
    counter->desc = "The percentage of time in which hardware threads occupied EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__compute_extended__eu_thread_occupancy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuTypedAtomics0";
    counter->symbol_name = "EuTypedAtomics0";
    counter->desc = "The subslice 0 EU Typed Atomics subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__compute_extended__eu_typed_atomics0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuTypedReads0";
    counter->symbol_name = "EuTypedReads0";
    counter->desc = "The subslice 0 EU Typed Reads subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__compute_extended__eu_typed_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuTypedWrites0";
    counter->symbol_name = "EuTypedWrites0";
    counter->desc = "The subslice 0 EU Typed Writes subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__compute_extended__eu_typed_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuUntypedAtomics0";
    counter->symbol_name = "EuUntypedAtomics0";
    counter->desc = "The subslice 0 EU Untyped Atomics subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__compute_extended__eu_untyped_atomics0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuUntypedReads0";
    counter->symbol_name = "EuUntypedReads0";
    counter->desc = "The subslice 0 EU Untyped Reads subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__compute_extended__eu_untyped_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuUntypedWrites0";
    counter->symbol_name = "EuUntypedWrites0";
    counter->desc = "The subslice 0 EU Untyped Writes subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__compute_extended__eu_untyped_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Pipe Active";
    counter->symbol_name = "Fpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__compute_extended__fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active";
    counter->symbol_name = "Fpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__compute_extended__fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt4__compute_extended__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt4__compute_extended__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__compute_extended__l3_shader_throughput__read;
    counter->max_uint64 = sklgt4__compute_extended__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt4__compute_extended__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt4__compute_extended__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__compute_extended__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__compute_extended__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__compute_extended__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__compute_extended__slm_bytes_read__read;
    counter->max_uint64 = sklgt4__compute_extended__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__compute_extended__slm_bytes_written__read;
    counter->max_uint64 = sklgt4__compute_extended__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Atomics 0";
    counter->symbol_name = "TypedAtomics0";
    counter->desc = "The subslice 0 typed atomics.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__compute_extended__typed_atomics0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TypedAtomicsPerCacheLine";
    counter->symbol_name = "TypedAtomicsPerCacheLine";
    counter->desc = "The ratio of EU typed atomics requests to L3 cache line writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
    counter->read_float = sklgt4__compute_extended__typed_atomics_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Reads 0";
    counter->symbol_name = "TypedReads0";
    counter->desc = "The subslice 0 typed reads.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__compute_extended__typed_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TypedReadsPerCacheLine";
    counter->symbol_name = "TypedReadsPerCacheLine";
    counter->desc = "The ratio of EU typed read requests to L3 cache line reads.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
    counter->read_float = sklgt4__compute_extended__typed_reads_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Writes 0";
    counter->symbol_name = "TypedWrites0";
    counter->desc = "The subslice 0 typed writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__compute_extended__typed_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TypedWritesPerCacheLine";
    counter->symbol_name = "TypedWritesPerCacheLine";
    counter->desc = "The ratio of EU typed write requests to L3 cache line writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
    counter->read_float = sklgt4__compute_extended__typed_writes_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Untyped Reads 0";
    counter->symbol_name = "UntypedReads0";
    counter->desc = "The subslice 0 untyped reads (including SLM reads).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__compute_extended__untyped_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "UntypedReadsPerCacheLine";
    counter->symbol_name = "UntypedReadsPerCacheLine";
    counter->desc = "The ratio of EU untyped read requests to L3 cache line reads.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
    counter->read_float = sklgt4__compute_extended__untyped_reads_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Untyped Writes 0";
    counter->symbol_name = "UntypedWrites0";
    counter->desc = "The subslice 0 untyped writes (including SLM writes).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__compute_extended__untyped_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "UntypedWritesPerCacheLine";
    counter->symbol_name = "UntypedWritesPerCacheLine";
    counter->desc = "The ratio of EU untyped write requests to L3 cache line writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
    counter->read_float = sklgt4__compute_extended__untyped_writes_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    assert(metric_set->n_counters <= 38);
}

static void
sklgt4_add_compute_l3_cache_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Compute Metrics L3 Cache Gen9";
    metric_set->symbol_name = "ComputeL3Cache";
    metric_set->hw_config_guid = "4e4392e9-8f73-457b-ab44-b49f7a0c733b";
    metric_set->counters = calloc(54, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(60, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(13, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x166C0760 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1593001E };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F900003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x184E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A4E8020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C4E0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x006C0051 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x066C5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x086C5C5D };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E6C5E5F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x186C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x061B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x081BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x101C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1CE000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1C0030 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C2A00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4C0280 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F0400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F1500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0140 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x162C0A00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x182C00A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03933300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05930032 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11930000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B930000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D900157 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F900158 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190030F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900021 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53905555 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FEFE };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x0007FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FEFD };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x0007FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FBEF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x0007FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FBDF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00000003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00002001 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00101100 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00201200 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00301300 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00401400 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt4__compute_l3_cache__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt4__compute_l3_cache__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__compute_l3_cache__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__compute_l3_cache__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__compute_l3_cache__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__compute_l3_cache__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU AVG IPC Rate";
    counter->symbol_name = "EuAvgIpcRate";
    counter->desc = "The average rate of IPC calculated for 2 FPU pipelines.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NUMBER;
    counter->read_float = sklgt4__compute_l3_cache__eu_avg_ipc_rate__read;
    counter->max_float = sklgt4__compute_l3_cache__eu_avg_ipc_rate__max;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Binary Instruction";
    counter->symbol_name = "EuBinaryFpu0Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing binary instructions on FPU0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__compute_l3_cache__eu_binary_fpu0_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Binary Instruction";
    counter->symbol_name = "EuBinaryFpu1Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing binary instructions on FPU1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__compute_l3_cache__eu_binary_fpu1_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__compute_l3_cache__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Hybrid Instruction";
    counter->symbol_name = "EuHybridFpu0Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing hybrid instructions on FPU0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__compute_l3_cache__eu_hybrid_fpu0_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Hybrid Instruction";
    counter->symbol_name = "EuHybridFpu1Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing hybrid instructions on FPU1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__compute_l3_cache__eu_hybrid_fpu1_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Move Instruction";
    counter->symbol_name = "EuMoveFpu0Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing move instructions on FPU0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__compute_l3_cache__eu_move_fpu0_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Move Instruction";
    counter->symbol_name = "EuMoveFpu1Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing move instructions on FPU1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__compute_l3_cache__eu_move_fpu1_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Send Pipe Active";
    counter->symbol_name = "EuSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__compute_l3_cache__eu_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__compute_l3_cache__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Ternary Instruction";
    counter->symbol_name = "EuTernaryFpu0Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing ternary instructions on FPU0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__compute_l3_cache__eu_ternary_fpu0_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Ternary Instruction";
    counter->symbol_name = "EuTernaryFpu1Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing ternary instructions on FPU1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__compute_l3_cache__eu_ternary_fpu1_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Pipe Active";
    counter->symbol_name = "Fpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__compute_l3_cache__fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active";
    counter->symbol_name = "Fpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__compute_l3_cache__fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__compute_l3_cache__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt4__compute_l3_cache__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt4__compute_l3_cache__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__compute_l3_cache__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI L3 Throughput";
    counter->symbol_name = "GtiL3Throughput";
    counter->desc = "The total number of GPU memory bytes transferred between L3 caches and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__compute_l3_cache__gti_l3_throughput__read;
    counter->max_uint64 = sklgt4__compute_l3_cache__gti_l3_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Read Throughput";
    counter->symbol_name = "GtiReadThroughput";
    counter->desc = "The total number of GPU memory bytes read from GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__compute_l3_cache__gti_read_throughput__read;
    counter->max_uint64 = sklgt4__compute_l3_cache__gti_read_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Write Throughput";
    counter->symbol_name = "GtiWriteThroughput";
    counter->desc = "The total number of GPU memory bytes written to GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__compute_l3_cache__gti_write_throughput__read;
    counter->max_uint64 = sklgt4__compute_l3_cache__gti_write_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__compute_l3_cache__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__compute_l3_cache__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Accesses";
    counter->symbol_name = "L3Accesses";
    counter->desc = "The total number of L3 accesses from all entities.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__compute_l3_cache__l3_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3");

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 00 Accesses";
        counter->symbol_name = "L3Bank00Accesses";
        counter->desc = "The total number of accesses to L3 Bank 00.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = sklgt4__compute_l3_cache__l3_bank00_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 00 IC Accesses";
        counter->symbol_name = "L3Bank00IcAccesses";
        counter->desc = "The total number of accesses to L3 Bank 00 from IC cache.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = sklgt4__compute_l3_cache__l3_bank00_ic_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3/IC");
    }

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 00 IC Hits";
        counter->symbol_name = "L3Bank00IcHits";
        counter->desc = "The total number of hits in L3 Bank 00 from IC cache.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = sklgt4__compute_l3_cache__l3_bank00_ic_hits__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3/IC");
    }

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 01 Accesses";
        counter->symbol_name = "L3Bank01Accesses";
        counter->desc = "The total number of accesses to L3 Bank 01.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = sklgt4__compute_l3_cache__l3_bank01_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 02 Accesses";
        counter->symbol_name = "L3Bank02Accesses";
        counter->desc = "The total number of accesses to L3 Bank 02.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = sklgt4__compute_l3_cache__l3_bank02_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 03 Accesses";
        counter->symbol_name = "L3Bank03Accesses";
        counter->desc = "The total number of accesses to L3 Bank 03.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = sklgt4__compute_l3_cache__l3_bank03_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Misses";
    counter->symbol_name = "L3Misses";
    counter->desc = "The total number of L3 misses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__compute_l3_cache__l3_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/TAG");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Sampler Throughput";
    counter->symbol_name = "L3SamplerThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between samplers and L3 caches.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__compute_l3_cache__l3_sampler_throughput__read;
    counter->max_uint64 = sklgt4__compute_l3_cache__l3_sampler_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__compute_l3_cache__l3_shader_throughput__read;
    counter->max_uint64 = sklgt4__compute_l3_cache__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Total Throughput";
    counter->symbol_name = "L3TotalThroughput";
    counter->desc = "The total number of GPU memory bytes transferred via L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__compute_l3_cache__l3_total_throughput__read;
    counter->max_uint64 = sklgt4__compute_l3_cache__l3_total_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__compute_l3_cache__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__compute_l3_cache__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__compute_l3_cache__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Accesses";
    counter->symbol_name = "SamplerAccesses";
    counter->desc = "The total number of messages send to samplers.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__compute_l3_cache__sampler_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt4__compute_l3_cache__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt4__compute_l3_cache__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__compute_l3_cache__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__compute_l3_cache__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__compute_l3_cache__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__compute_l3_cache__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__compute_l3_cache__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__compute_l3_cache__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__compute_l3_cache__slm_bytes_read__read;
    counter->max_uint64 = sklgt4__compute_l3_cache__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__compute_l3_cache__slm_bytes_written__read;
    counter->max_uint64 = sklgt4__compute_l3_cache__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__compute_l3_cache__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 54);
}

static void
sklgt4_add_hdc_and_sf_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set HDCAndSF";
    metric_set->symbol_name = "HDCAndSF";
    metric_set->hw_config_guid = "75f56991-b149-4122-ade9-d9c0c80c733b";
    metric_set->counters = calloc(40, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(55, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(8, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x104F0232 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x124F4640 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C0232 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11834400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004F1880 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x024F08BB };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044F001B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x046C0100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x066C000B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x061B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1C1800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x005B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x025BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x045B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x125C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x145C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x165C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x185C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C00A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F0055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F828000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8305C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09830000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07830000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D950080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13928000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F988000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190FC00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900842 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x10800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FDFF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt4__hdc_and_sf__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt4__hdc_and_sf__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__hdc_and_sf__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__hdc_and_sf__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__hdc_and_sf__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__hdc_and_sf__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__hdc_and_sf__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__hdc_and_sf__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt4__hdc_and_sf__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__hdc_and_sf__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt4__hdc_and_sf__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt4__hdc_and_sf__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__hdc_and_sf__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__hdc_and_sf__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__hdc_and_sf__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__hdc_and_sf__l3_shader_throughput__read;
    counter->max_uint64 = sklgt4__hdc_and_sf__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "HDC stalled by L3 (s0.ss0)";
        counter->symbol_name = "NonSamplerShader00AccessStalledOnL3";
        counter->desc = "Percentage of time when HDC has messges to L3, but it's stalled due to lack of credits (s0.ss0)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt4__hdc_and_sf__non_sampler_shader00_access_stalled_on_l3__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Data Port");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "HDC stalled by L3 (s0.ss1)";
        counter->symbol_name = "NonSamplerShader01AccessStalledOnL3";
        counter->desc = "Percentage of time when HDC has messges to L3, but it's stalled due to lack of credits (s0.ss1)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt4__hdc_and_sf__non_sampler_shader01_access_stalled_on_l3__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Data Port");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "HDC stalled by L3 (s0.ss2)";
        counter->symbol_name = "NonSamplerShader02AccessStalledOnL3";
        counter->desc = "Percentage of time when HDC has messges to L3, but it's stalled due to lack of credits (s0.ss2)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt4__hdc_and_sf__non_sampler_shader02_access_stalled_on_l3__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Data Port");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__hdc_and_sf__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Polygon Data Ready";
    counter->symbol_name = "PolyDataReady";
    counter->desc = "The percentage of time in which geometry pipeline output is ready";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__hdc_and_sf__poly_data_ready__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe/Strip-Fans");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__hdc_and_sf__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__hdc_and_sf__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__hdc_and_sf__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__hdc_and_sf__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__hdc_and_sf__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__hdc_and_sf__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt4__hdc_and_sf__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt4__hdc_and_sf__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__hdc_and_sf__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__hdc_and_sf__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__hdc_and_sf__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__hdc_and_sf__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__hdc_and_sf__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__hdc_and_sf__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__hdc_and_sf__slm_bytes_read__read;
    counter->max_uint64 = sklgt4__hdc_and_sf__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__hdc_and_sf__slm_bytes_written__read;
    counter->max_uint64 = sklgt4__hdc_and_sf__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__hdc_and_sf__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__hdc_and_sf__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__hdc_and_sf__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__hdc_and_sf__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 40);
}

static void
sklgt4_add_l3_1_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set L3_1";
    metric_set->symbol_name = "L3_1";
    metric_set->hw_config_guid = "0d4cda70-da83-466f-b61e-7a064fe6a232";
    metric_set->counters = calloc(40, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(72, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(22, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x126C7B40 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x166C0020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A603444 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A613400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A4EA800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C4E0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x024E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C6C5327 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E6C5425 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x006C2A00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x026C285B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x046C005C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6C0800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1C003C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x121C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x161C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1C0800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x065B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A5C1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10600000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04600000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C610044 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10610000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06610000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4C02A8 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084CA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0154 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F0055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x182C00AA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190FFC0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900420 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900021 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900421 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900040 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00100070 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFF1 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00014002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000C3FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00010002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000C7FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00004002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000D3FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00100700 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FF1F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00001402 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FC3F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x00001002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FC7F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x00000402 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000FD3F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt4__l3_1__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt4__l3_1__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__l3_1__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__l3_1__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__l3_1__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__l3_1__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__l3_1__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__l3_1__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt4__l3_1__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__l3_1__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt4__l3_1__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt4__l3_1__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__l3_1__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__l3_1__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__l3_1__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank0 Active";
        counter->symbol_name = "L30Bank0Active";
        counter->desc = "The percentage of time in which slice0 L3 bank0 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt4__l3_1__l30_bank0_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank0 Stalled";
        counter->symbol_name = "L30Bank0Stalled";
        counter->desc = "The percentage of time in which slice0 L3 bank0 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt4__l3_1__l30_bank0_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank1 Active";
        counter->symbol_name = "L30Bank1Active";
        counter->desc = "The percentage of time in which slice0 L3 bank1 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt4__l3_1__l30_bank1_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank1 Stalled";
        counter->symbol_name = "L30Bank1Stalled";
        counter->desc = "The percentage of time in which slice0 L3 bank1 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt4__l3_1__l30_bank1_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__l3_1__l3_shader_throughput__read;
    counter->max_uint64 = sklgt4__l3_1__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__l3_1__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__l3_1__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__l3_1__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__l3_1__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__l3_1__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__l3_1__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__l3_1__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt4__l3_1__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt4__l3_1__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__l3_1__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__l3_1__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__l3_1__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__l3_1__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__l3_1__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__l3_1__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__l3_1__slm_bytes_read__read;
    counter->max_uint64 = sklgt4__l3_1__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__l3_1__slm_bytes_written__read;
    counter->max_uint64 = sklgt4__l3_1__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__l3_1__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__l3_1__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__l3_1__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__l3_1__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 40);
}

static void
sklgt4_add_l3_2_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set L3_2";
    metric_set->symbol_name = "L3_2";
    metric_set->hw_config_guid = "20137ace-b110-4341-883f-1094c820093c";
    metric_set->counters = calloc(38, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(45, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(14, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x126C02E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x146C0001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A623400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x026C3324 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x046C3422 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x161C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1C0800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x065B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A5C1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06614000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C620044 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10620000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06620000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F0055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190F800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00100070 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFF1 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00028002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x000087FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00020002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x00008FFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00008002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000A7FF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt4__l3_2__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt4__l3_2__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__l3_2__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__l3_2__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__l3_2__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__l3_2__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__l3_2__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__l3_2__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt4__l3_2__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__l3_2__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt4__l3_2__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt4__l3_2__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__l3_2__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__l3_2__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__l3_2__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank2 Active";
        counter->symbol_name = "L30Bank2Active";
        counter->desc = "The percentage of time in which slice0 L3 bank2 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt4__l3_2__l30_bank2_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank2 Stalled";
        counter->symbol_name = "L30Bank2Stalled";
        counter->desc = "The percentage of time in which slice0 L3 bank2 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt4__l3_2__l30_bank2_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__l3_2__l3_shader_throughput__read;
    counter->max_uint64 = sklgt4__l3_2__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__l3_2__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__l3_2__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__l3_2__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__l3_2__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__l3_2__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__l3_2__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__l3_2__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt4__l3_2__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt4__l3_2__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__l3_2__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__l3_2__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__l3_2__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__l3_2__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__l3_2__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__l3_2__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__l3_2__slm_bytes_read__read;
    counter->max_uint64 = sklgt4__l3_2__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__l3_2__slm_bytes_written__read;
    counter->max_uint64 = sklgt4__l3_2__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__l3_2__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__l3_2__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__l3_2__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__l3_2__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 38);
}

static void
sklgt4_add_l3_3_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set L3_3";
    metric_set->symbol_name = "L3_3";
    metric_set->hw_config_guid = "d3a6b05e-46ef-44a8-96c3-9bd3e58acbe6";
    metric_set->counters = calloc(38, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(44, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(14, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x126C4E80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x146C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A633400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x026C3321 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x046C342F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6C2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x061B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x161C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1C1800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06604000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C630044 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10630000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06630000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C00AA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F0055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190F800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900842 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00100070 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFF1 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00028002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x000087FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00020002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x00008FFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00008002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000A7FF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt4__l3_3__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt4__l3_3__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__l3_3__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__l3_3__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__l3_3__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__l3_3__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__l3_3__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__l3_3__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt4__l3_3__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__l3_3__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt4__l3_3__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt4__l3_3__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__l3_3__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__l3_3__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__l3_3__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank3 Active";
        counter->symbol_name = "L30Bank3Active";
        counter->desc = "The percentage of time in which slice0 L3 bank3 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt4__l3_3__l30_bank3_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank3 Stalled";
        counter->symbol_name = "L30Bank3Stalled";
        counter->desc = "The percentage of time in which slice0 L3 bank3 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt4__l3_3__l30_bank3_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__l3_3__l3_shader_throughput__read;
    counter->max_uint64 = sklgt4__l3_3__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__l3_3__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__l3_3__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__l3_3__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__l3_3__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__l3_3__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__l3_3__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__l3_3__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt4__l3_3__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt4__l3_3__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__l3_3__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__l3_3__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__l3_3__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__l3_3__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__l3_3__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__l3_3__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__l3_3__slm_bytes_read__read;
    counter->max_uint64 = sklgt4__l3_3__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__l3_3__slm_bytes_written__read;
    counter->max_uint64 = sklgt4__l3_3__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__l3_3__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__l3_3__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__l3_3__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__l3_3__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 38);
}

static void
sklgt4_add_rasterizer_and_pixel_backend_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set RasterizerAndPixelBackend";
    metric_set->symbol_name = "RasterizerAndPixelBackend";
    metric_set->hw_config_guid = "4081b948-63f1-4b1a-abaa-6017cb77a63b";
    metric_set->counters = calloc(41, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(32, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(10, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x102F3800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x144D0500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x120D03C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x140D03CF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F0004 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4E4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042F0480 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C0090 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064D0027 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004D0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D0D40 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020D803F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040D8023 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100D0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020F0010 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F0050 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190FC00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41901400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43901485 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000EFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00006000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000F3FF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt4__rasterizer_and_pixel_backend__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt4__rasterizer_and_pixel_backend__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__rasterizer_and_pixel_backend__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__rasterizer_and_pixel_backend__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__rasterizer_and_pixel_backend__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__rasterizer_and_pixel_backend__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__rasterizer_and_pixel_backend__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__rasterizer_and_pixel_backend__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt4__rasterizer_and_pixel_backend__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__rasterizer_and_pixel_backend__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt4__rasterizer_and_pixel_backend__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt4__rasterizer_and_pixel_backend__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__rasterizer_and_pixel_backend__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__rasterizer_and_pixel_backend__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__rasterizer_and_pixel_backend__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__rasterizer_and_pixel_backend__l3_shader_throughput__read;
    counter->max_uint64 = sklgt4__rasterizer_and_pixel_backend__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 PS Output Available";
        counter->symbol_name = "PSOutput0Available";
        counter->desc = "The percentage of time in which slice0 PS output is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt4__rasterizer_and_pixel_backend__ps_output0_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Post-EarlyZ Pixel Data Ready";
        counter->symbol_name = "PixelData0Ready";
        counter->desc = "The percentage of time in which slice0 post-EarlyZ pixel data is ready (after early Z tests have been applied)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt4__rasterizer_and_pixel_backend__pixel_data0_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Rasterizer/Early Depth Test");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Pixel Values Ready";
        counter->symbol_name = "PixelValues0Ready";
        counter->desc = "The percentage of time in which slice0 pixel values are ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt4__rasterizer_and_pixel_backend__pixel_values0_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__rasterizer_and_pixel_backend__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__rasterizer_and_pixel_backend__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__rasterizer_and_pixel_backend__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__rasterizer_and_pixel_backend__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__rasterizer_and_pixel_backend__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__rasterizer_and_pixel_backend__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__rasterizer_and_pixel_backend__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Rasterizer Input Available";
        counter->symbol_name = "Rasterizer0InputAvailable";
        counter->desc = "The percentage of time in which slice0 rasterizer input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt4__rasterizer_and_pixel_backend__rasterizer0_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Rasterizer");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Rasterizer Output Ready";
        counter->symbol_name = "Rasterizer0OutputReady";
        counter->desc = "The percentage of time in which slice0 rasterizer output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt4__rasterizer_and_pixel_backend__rasterizer0_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Rasterizer");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt4__rasterizer_and_pixel_backend__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt4__rasterizer_and_pixel_backend__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__rasterizer_and_pixel_backend__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__rasterizer_and_pixel_backend__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__rasterizer_and_pixel_backend__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__rasterizer_and_pixel_backend__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__rasterizer_and_pixel_backend__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__rasterizer_and_pixel_backend__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__rasterizer_and_pixel_backend__slm_bytes_read__read;
    counter->max_uint64 = sklgt4__rasterizer_and_pixel_backend__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__rasterizer_and_pixel_backend__slm_bytes_written__read;
    counter->max_uint64 = sklgt4__rasterizer_and_pixel_backend__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__rasterizer_and_pixel_backend__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__rasterizer_and_pixel_backend__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__rasterizer_and_pixel_backend__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__rasterizer_and_pixel_backend__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 41);
}

static void
sklgt4_add_sampler_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set Sampler";
    metric_set->symbol_name = "Sampler";
    metric_set->hw_config_guid = "eae6bbb1-0e2b-478d-bd9e-f10ded2178f9";
    metric_set->counters = calloc(42, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(70, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(12, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14152C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16150005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x121600A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14352C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16350005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x123600A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14552C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16550005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x125600A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062F6000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022F2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4C0050 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C0010 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0350 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0FB000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F00DA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x182C0028 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022DC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C138000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E132000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0413C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C140018 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C157000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E150078 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10150000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04162180 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02160000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04174000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0233A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04333000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14348000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16348000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02357870 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10350000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04360043 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02360000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04371000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E538000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00538000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06533000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C540020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12548000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E557000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00557800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10550000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06560043 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02560000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06571000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190FF80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900060 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900842 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900060 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x70800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0000C000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000E7FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00003000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000F9FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000C00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FE7F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt4__sampler__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt4__sampler__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__sampler__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__sampler__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__sampler__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__sampler__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__sampler__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__sampler__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt4__sampler__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__sampler__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt4__sampler__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt4__sampler__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__sampler__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__sampler__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__sampler__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__sampler__l3_shader_throughput__read;
    counter->max_uint64 = sklgt4__sampler__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__sampler__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__sampler__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__sampler__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__sampler__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__sampler__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__sampler__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__sampler__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice0 Input Available";
        counter->symbol_name = "Sampler00InputAvailable";
        counter->desc = "The percentage of time in which slice0 subslice0 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt4__sampler__sampler00_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice0 Sampler Output Ready";
        counter->symbol_name = "Sampler00OutputReady";
        counter->desc = "The percentage of time in which slice0 subslice0 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt4__sampler__sampler00_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice1 Input Available";
        counter->symbol_name = "Sampler01InputAvailable";
        counter->desc = "The percentage of time in which slice0 subslice1 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt4__sampler__sampler01_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice1 Sampler Output Ready";
        counter->symbol_name = "Sampler01OutputReady";
        counter->desc = "The percentage of time in which slice0 subslice1 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt4__sampler__sampler01_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice2 Input Available";
        counter->symbol_name = "Sampler02InputAvailable";
        counter->desc = "The percentage of time in which slice0 subslice2 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt4__sampler__sampler02_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice2 Sampler Output Ready";
        counter->symbol_name = "Sampler02OutputReady";
        counter->desc = "The percentage of time in which slice0 subslice2 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt4__sampler__sampler02_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt4__sampler__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt4__sampler__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__sampler__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__sampler__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__sampler__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__sampler__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__sampler__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__sampler__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__sampler__slm_bytes_read__read;
    counter->max_uint64 = sklgt4__sampler__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__sampler__slm_bytes_written__read;
    counter->max_uint64 = sklgt4__sampler__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__sampler__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__sampler__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__sampler__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__sampler__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 42);
}

static void
sklgt4_add_tdl_1_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set TDL_1";
    metric_set->symbol_name = "TDL_1";
    metric_set->hw_config_guid = "1bba4bd2-81d4-45ec-847f-bc363e17e14d";
    metric_set->counters = calloc(42, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(69, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(18, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12120000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12320000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12520000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022F3000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C0015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F03A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0FF000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F0095 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02108000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0410C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02118000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0411C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02121880 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041219B5 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00120000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02134000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04135000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C308000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E304000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06304000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C318000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E314000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06314000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C321A80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E320033 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06320031 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00320000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C334000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E331000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06331000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E508000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00508000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02504000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E518000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00518000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02514000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E521880 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00521A80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02520033 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E534000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00534000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02531000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190FF80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900062 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900040 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x00007FFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x00009FFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000EFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000F3FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FDFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FE7F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt4__tdl_1__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt4__tdl_1__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__tdl_1__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__tdl_1__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__tdl_1__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__tdl_1__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__tdl_1__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__tdl_1__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt4__tdl_1__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__tdl_1__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt4__tdl_1__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt4__tdl_1__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__tdl_1__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__tdl_1__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__tdl_1__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__tdl_1__l3_shader_throughput__read;
    counter->max_uint64 = sklgt4__tdl_1__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "NonPS Thread Ready For Dispatch on Slice0 Subslice0";
        counter->symbol_name = "NonPSThread00ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice0 subslice0 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt4__tdl_1__non_ps_thread00_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "NonPS Thread Ready For Dispatch on Slice0 Subslice1";
        counter->symbol_name = "NonPSThread01ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice0 subslice1 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt4__tdl_1__non_ps_thread01_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "NonPS Thread Ready For Dispatch on Slice0 Subslice2";
        counter->symbol_name = "NonPSThread02ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice0 subslice2 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt4__tdl_1__non_ps_thread02_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice0 Subslice0";
        counter->symbol_name = "PSThread00ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice0 subslice0 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt4__tdl_1__ps_thread00_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice0 Subslice1";
        counter->symbol_name = "PSThread01ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice0 subslice1 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt4__tdl_1__ps_thread01_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice0 Subslice2";
        counter->symbol_name = "PSThread02ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice0 subslice2 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt4__tdl_1__ps_thread02_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__tdl_1__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__tdl_1__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__tdl_1__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__tdl_1__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__tdl_1__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__tdl_1__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__tdl_1__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt4__tdl_1__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt4__tdl_1__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__tdl_1__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__tdl_1__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__tdl_1__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__tdl_1__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__tdl_1__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__tdl_1__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__tdl_1__slm_bytes_read__read;
    counter->max_uint64 = sklgt4__tdl_1__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__tdl_1__slm_bytes_written__read;
    counter->max_uint64 = sklgt4__tdl_1__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__tdl_1__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__tdl_1__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__tdl_1__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__tdl_1__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 42);
}

static void
sklgt4_add_tdl_2_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set TDL_2";
    metric_set->symbol_name = "TDL_2";
    metric_set->hw_config_guid = "a4b3106c-cfec-49f5-8e26-470470379e66";
    metric_set->counters = calloc(42, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(43, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(6, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12124D60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12322E60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12524D60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022F3000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C0014 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0FE000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F0097 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0410C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0411C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04121FB7 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00120000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04135000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00308000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06304000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00318000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06314000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00321B80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0632003F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00334000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06331000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0250C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0251C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02521FB7 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00520000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02535000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190FC00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900063 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt4__tdl_2__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt4__tdl_2__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__tdl_2__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__tdl_2__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__tdl_2__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__tdl_2__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__tdl_2__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__tdl_2__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt4__tdl_2__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__tdl_2__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt4__tdl_2__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt4__tdl_2__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__tdl_2__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__tdl_2__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__tdl_2__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__tdl_2__l3_shader_throughput__read;
    counter->max_uint64 = sklgt4__tdl_2__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__tdl_2__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__tdl_2__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__tdl_2__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__tdl_2__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__tdl_2__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__tdl_2__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__tdl_2__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt4__tdl_2__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = sklgt4__tdl_2__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__tdl_2__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__tdl_2__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = sklgt4__tdl_2__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__tdl_2__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__tdl_2__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = sklgt4__tdl_2__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__tdl_2__slm_bytes_read__read;
    counter->max_uint64 = sklgt4__tdl_2__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = sklgt4__tdl_2__slm_bytes_written__read;
    counter->max_uint64 = sklgt4__tdl_2__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice0 Port 0";
        counter->symbol_name = "ThreadHeader00ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice0 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt4__tdl_2__thread_header00_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice0 Port 1";
        counter->symbol_name = "ThreadHeader00ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice0 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt4__tdl_2__thread_header00_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice1 Port 0";
        counter->symbol_name = "ThreadHeader01ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice1 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt4__tdl_2__thread_header01_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice1 Port 1";
        counter->symbol_name = "ThreadHeader01ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice1 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt4__tdl_2__thread_header01_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice2 Port 0";
        counter->symbol_name = "ThreadHeader02ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice2 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt4__tdl_2__thread_header02_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice2 Port 1";
        counter->symbol_name = "ThreadHeader02ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice2 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt4__tdl_2__thread_header02_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__tdl_2__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__tdl_2__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__tdl_2__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__tdl_2__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 42);
}

static void
sklgt4_add_compute_extra_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Compute Metrics Extra Gen9";
    metric_set->symbol_name = "ComputeExtra";
    metric_set->hw_config_guid = "a5aa857d-e8f0-4dfa-8981-ce340fa748fd";
    metric_set->counters = calloc(4, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(112, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x121203E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x123203E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x125203E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x129203E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12B203E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12D203E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x131203E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x133203E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x135203E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A4EF000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C4E0003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x024EC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044EC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064EC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4C02A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084CA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C0042 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0150 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F006D };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x182C00A8 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06104000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06114000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06120033 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00120000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06131000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04308000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04318000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04321980 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00320000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04334000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04504000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04514000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04520033 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00520000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04531000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1ACEF000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1CCE0003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00AF8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CCC02A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0ACC0001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C8D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E8DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x008D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x028DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x108F0150 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C8FB000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E8F0001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18AC00A8 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06AC8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02AD4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02918000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02921980 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00920000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02934000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02B04000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02B14000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02B20033 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00B20000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02B31000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00D08000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00D18000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00D21980 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00D34000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x072F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D4C0100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D0D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x110F01B0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x192C0080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F2D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F108000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F118000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F121980 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01120000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F134000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F304000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F314000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F320033 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01320000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F331000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D508000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D518000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D521980 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01520000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D534000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190FF80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51901100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41901000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43901423 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53903331 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900044 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt4__compute_extra__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt4__compute_extra__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active";
    counter->symbol_name = "Fpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__compute_extra__fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt4__compute_extra__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt4__compute_extra__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    assert(metric_set->n_counters <= 4);
}

static void
sklgt4_add_vme_pipe_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Media Vme Pipe Gen9";
    metric_set->symbol_name = "VMEPipe";
    metric_set->hw_config_guid = "0e8d8b86-4ee7-4cdd-aaaa-58adc92cb29e";
    metric_set->counters = calloc(10, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(73, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(17, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(2, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141A5800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x161A00C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12180240 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14180002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x149A5800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x169A00C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12980240 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14980002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A4E3FC0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002F1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042F3000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C9500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4C002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F0400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F5500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x162CAA00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x182C000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04193000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x081A28C1 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00133000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0613C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0813F000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00172000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06178000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0817A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00180037 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06180940 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08180000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02180000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04183000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04AFC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06AF3000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0ACC4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CCC0015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A8DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C8DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E8F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x108F0015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16ACA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18AC000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06993000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C9A28C1 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x009A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A93F000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C93F000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A97A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C97A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A980977 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08980000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04980000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06983000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x119000FF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900010 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900060 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900111 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900821 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00100030 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFF9 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FFFC };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FFF3 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00100180 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FFCF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FFCF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FF3F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00008003 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt4__vme_pipe__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt4__vme_pipe__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = sklgt4__vme_pipe__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__vme_pipe__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__vme_pipe__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__vme_pipe__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Thread Occupancy";
    counter->symbol_name = "EuThreadOccupancy";
    counter->desc = "The percentage of time in which hardware threads occupied EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__vme_pipe__eu_thread_occupancy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__vme_pipe__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt4__vme_pipe__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt4__vme_pipe__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VME Busy";
    counter->symbol_name = "VMEBusy";
    counter->desc = "The percentage of time in which VME (IME or CRE) was actively processing data.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__vme_pipe__vme_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "VME Pipe");

    assert(metric_set->n_counters <= 10);
}

static void
sklgt4_add_gpu_busyness_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Gpu Rings Busyness";
    metric_set->symbol_name = "GpuBusyness";
    metric_set->hw_config_guid = "4e5b1599-5b01-4b3d-89fa-6b26a25fe02b";
    metric_set->counters = calloc(9, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(43, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21D05800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13805800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05962C25 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19950016 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21C05800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09D000A5 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11D00000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05D00000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09D54000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07800035 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D810400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21960000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0996C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B964000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B930068 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15948000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B94000C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03957500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D950000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17950000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07E54000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07928000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03988000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09978000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0BC000A5 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11C00000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05C00000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0BC54000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900463 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x10800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007C000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x000007FF };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AnyRingBusy";
    counter->symbol_name = "AnyRingBusy";
    counter->desc = "The percentage of time when any command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__gpu_busyness__any_ring_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt4__gpu_busyness__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt4__gpu_busyness__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Blitter Ring Busy";
    counter->symbol_name = "BlitterBusy";
    counter->desc = "The percentage of time when blitter command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__gpu_busyness__blitter_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt4__gpu_busyness__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt4__gpu_busyness__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Render Ring Busy";
    counter->symbol_name = "RenderBusy";
    counter->desc = "The percentage of time when render command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__gpu_busyness__render_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Vdbox0 Ring Busy";
    counter->symbol_name = "Vdbox0Busy";
    counter->desc = "The percentage of time when Vdbox0 command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__gpu_busyness__vdbox0_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Vdbox1 Ring Busy";
    counter->symbol_name = "Vdbox1Busy";
    counter->desc = "The percentage of time when Vdbox1 command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__gpu_busyness__vdbox1_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Vebox Ring Busy";
    counter->symbol_name = "VeboxBusy";
    counter->desc = "The percentage of time when vebox command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = sklgt4__gpu_busyness__vebox_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    assert(metric_set->n_counters <= 9);
}

static void
sklgt4_add_test_oa_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "MDAPI testing set Gen9";
    metric_set->symbol_name = "TestOa";
    metric_set->hw_config_guid = "882fa433-1f4a-4a67-a962-c741888fe5f5";
    metric_set->counters = calloc(12, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(13, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(22, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07810013 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B930040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07E54000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000004 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00000003 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000007 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00100002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FFF7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00100002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FFCF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00100082 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FFEF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x001000C2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FFE7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x00100001 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000FFE7 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt4__test_oa__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt4__test_oa__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter0";
    counter->symbol_name = "Counter0";
    counter->desc = "HW test counter 0. Factor: 0.0";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = sklgt4__test_oa__counter0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter1";
    counter->symbol_name = "Counter1";
    counter->desc = "HW test counter 1. Factor: 1.0";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = sklgt4__test_oa__counter1__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter2";
    counter->symbol_name = "Counter2";
    counter->desc = "HW test counter 2. Factor: 1.0";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = sklgt4__test_oa__counter2__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter3";
    counter->symbol_name = "Counter3";
    counter->desc = "HW test counter 3. Factor: 0.5";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = sklgt4__test_oa__counter3__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter4";
    counter->symbol_name = "Counter4";
    counter->desc = "HW test counter 4. Factor: 0.333";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = sklgt4__test_oa__counter4__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter5";
    counter->symbol_name = "Counter5";
    counter->desc = "HW test counter 5. Factor: 0.333";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = sklgt4__test_oa__counter5__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter6";
    counter->symbol_name = "Counter6";
    counter->desc = "HW test counter 6. Factor: 0.166";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = sklgt4__test_oa__counter6__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter7";
    counter->symbol_name = "Counter7";
    counter->desc = "HW test counter 7. Factor: 0.666";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = sklgt4__test_oa__counter7__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter8";
    counter->symbol_name = "Counter8";
    counter->desc = "HW test counter 8. Should be equal to 1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = sklgt4__test_oa__counter8__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt4__test_oa__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt4__test_oa__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    assert(metric_set->n_counters <= 12);
}

static void
sklgt4_add_pma__stall_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set PMA Stall";
    metric_set->symbol_name = "PMA_Stall";
    metric_set->hw_config_guid = "befe9fd6-474e-4a3d-b98e-cd793715cf91";
    metric_set->counters = calloc(4, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(24, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(9, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x122D3080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F0800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0FAA00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002D0025 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062D1300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082D16A4 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2D162E };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x102D0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190003F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00E00021 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0007FFF8 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x07000101 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0038FFC7 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = sklgt4__pma__stall__avg_gpu_core_frequency__read;
    counter->max_uint64 = sklgt4__pma__stall__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = sklgt4__pma__stall__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = sklgt4__pma__stall__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "STC PMA stall";
        counter->symbol_name = "StcPMAStall";
        counter->desc = "Percentage of time when stencil cache line and an overlapping pixel are causing stalls";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = sklgt4__pma__stall__stc_pma_stall__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Stencil Cache");
    }

    assert(metric_set->n_counters <= 4);
}

static void
kblgt2_add_render_basic_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Render Metrics Basic Gen9";
    metric_set->symbol_name = "RenderBasic";
    metric_set->hw_config_guid = "99c1a40e-a090-4354-86e3-4d068bb1917e";
    metric_set->counters = calloc(52, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(70, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(5, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x166C01E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12170280 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12370280 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11930317 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x159303DF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F900003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A4E0080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A6C0053 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1C0001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002F1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042F1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C8400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F0400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F6600 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x162C2200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00133000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08133000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00170020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08170021 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10170000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0633C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0833C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06370800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08370840 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10370000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D933031 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F933E3F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01933D00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0393073C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0593000E };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D930000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19930000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B930000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D900157 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F900158 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190001F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51904400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900C21 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900061 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57904440 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900004 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53904444 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00222222 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = kblgt2__render_basic__avg_gpu_core_frequency__read;
    counter->max_uint64 = kblgt2__render_basic__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__render_basic__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__render_basic__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__render_basic__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__render_basic__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__render_basic__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__render_basic__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__render_basic__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = kblgt2__render_basic__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = kblgt2__render_basic__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__render_basic__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Depth Throughput";
    counter->symbol_name = "GtiDepthThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between depth caches and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__render_basic__gti_depth_throughput__read;
    counter->max_uint64 = kblgt2__render_basic__gti_depth_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI HDC TLB Lookup Throughput";
    counter->symbol_name = "GtiHdcLookupsThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between GTI and HDC, when HDC is doing TLB lookups.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__render_basic__gti_hdc_lookups_throughput__read;
    counter->max_uint64 = kblgt2__render_basic__gti_hdc_lookups_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI L3 Throughput";
    counter->symbol_name = "GtiL3Throughput";
    counter->desc = "The total number of GPU memory bytes transferred between L3 caches and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__render_basic__gti_l3_throughput__read;
    counter->max_uint64 = kblgt2__render_basic__gti_l3_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI RCC Throughput";
    counter->symbol_name = "GtiRccThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between render color caches and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__render_basic__gti_rcc_throughput__read;
    counter->max_uint64 = kblgt2__render_basic__gti_rcc_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Read Throughput";
    counter->symbol_name = "GtiReadThroughput";
    counter->desc = "The total number of GPU memory bytes read from GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__render_basic__gti_read_throughput__read;
    counter->max_uint64 = kblgt2__render_basic__gti_read_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Fixed Pipe Throughput";
    counter->symbol_name = "GtiVfThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between 3D Pipeline (Command Dispatch, Input Assembly and Stream Output) and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__render_basic__gti_vf_throughput__read;
    counter->max_uint64 = kblgt2__render_basic__gti_vf_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Write Throughput";
    counter->symbol_name = "GtiWriteThroughput";
    counter->desc = "The total number of GPU memory bytes written to GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__render_basic__gti_write_throughput__read;
    counter->max_uint64 = kblgt2__render_basic__gti_write_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__render_basic__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__render_basic__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Lookup Accesses w/o IC";
    counter->symbol_name = "L3Lookups";
    counter->desc = "The total number of L3 cache lookup accesses w/o IC.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__render_basic__l3_lookups__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/TAG");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Misses";
    counter->symbol_name = "L3Misses";
    counter->desc = "The total number of L3 misses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__render_basic__l3_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/TAG");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Sampler Throughput";
    counter->symbol_name = "L3SamplerThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between samplers and L3 caches.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__render_basic__l3_sampler_throughput__read;
    counter->max_uint64 = kblgt2__render_basic__l3_sampler_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__render_basic__l3_shader_throughput__read;
    counter->max_uint64 = kblgt2__render_basic__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__render_basic__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__render_basic__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__render_basic__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__render_basic__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__render_basic__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__render_basic__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__render_basic__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    if (perf->devinfo.subslice_mask & 0x09) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Sampler 0 Bottleneck";
        counter->symbol_name = "Sampler0Bottleneck";
        counter->desc = "The percentage of time in which Sampler 0 has been slowing down the pipe when processing EU requests.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt2__render_basic__sampler0_bottleneck__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x09) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Sampler 0 Busy";
        counter->symbol_name = "Sampler0Busy";
        counter->desc = "The percentage of time in which Sampler 0 has been processing EU requests.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt2__render_basic__sampler0_busy__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x12) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Sampler 1 Bottleneck";
        counter->symbol_name = "Sampler1Bottleneck";
        counter->desc = "The percentage of time in which Sampler 1 has been slowing down the pipe when processing EU requests.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt2__render_basic__sampler1_bottleneck__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x12) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Sampler 1 Busy";
        counter->symbol_name = "Sampler1Busy";
        counter->desc = "The percentage of time in which Sampler 1 has been processing EU requests.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt2__render_basic__sampler1_busy__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samplers Bottleneck";
    counter->symbol_name = "SamplerBottleneck";
    counter->desc = "The percentage of time in which samplers have been slowing down the pipe when processing EU requests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__render_basic__sampler_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Cache Misses";
    counter->symbol_name = "SamplerL1Misses";
    counter->desc = "The total number of sampler cache misses in all LODs in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__render_basic__sampler_l1_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt2__render_basic__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt2__render_basic__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samplers Busy";
    counter->symbol_name = "SamplersBusy";
    counter->desc = "The percentage of time in which samplers have been processing EU requests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__render_basic__samplers_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__render_basic__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__render_basic__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__render_basic__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__render_basic__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__render_basic__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__render_basic__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__render_basic__slm_bytes_read__read;
    counter->max_uint64 = kblgt2__render_basic__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__render_basic__slm_bytes_written__read;
    counter->max_uint64 = kblgt2__render_basic__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__render_basic__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__render_basic__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__render_basic__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__render_basic__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 52);
}

static void
kblgt2_add_compute_basic_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Compute Metrics Basic Gen9";
    metric_set->symbol_name = "ComputeBasic";
    metric_set->hw_config_guid = "12994724-3a5a-4303-bb3c-ba0175d2c200";
    metric_set->counters = calloc(39, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(78, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(5, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x104F00E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x124F1C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C00E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37906800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F900003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A4E0820 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C4E0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064F0900 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084F0032 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4F1891 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4F0E00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E4F003C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004F0D80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x024F003B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x006C0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x086C0100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C6C000C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E6C0B00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x186C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x081B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x101C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1C0024 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x065B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x085B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A5BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C5B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E5B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x005B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x025B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A5C6000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C5C001B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x125C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x145C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4C0208 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F5400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F5500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0155 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x162CFB00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x182C00BE };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19900157 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B900158 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D900105 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F900103 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11900FFF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900821 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900802 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900802 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900422 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53904444 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00000003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00002001 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00778008 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00088078 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00808708 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00222222 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = kblgt2__compute_basic__avg_gpu_core_frequency__read;
    counter->max_uint64 = kblgt2__compute_basic__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__compute_basic__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__compute_basic__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__compute_basic__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__compute_basic__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU AVG IPC Rate";
    counter->symbol_name = "EuAvgIpcRate";
    counter->desc = "The average rate of IPC calculated for 2 FPU pipelines.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NUMBER;
    counter->read_float = kblgt2__compute_basic__eu_avg_ipc_rate__read;
    counter->max_float = kblgt2__compute_basic__eu_avg_ipc_rate__max;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__compute_basic__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Send Pipe Active";
    counter->symbol_name = "EuSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__compute_basic__eu_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__compute_basic__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Thread Occupancy";
    counter->symbol_name = "EuThreadOccupancy";
    counter->desc = "The percentage of time in which hardware threads occupied EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__compute_basic__eu_thread_occupancy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Pipe Active";
    counter->symbol_name = "Fpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__compute_basic__fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active";
    counter->symbol_name = "Fpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__compute_basic__fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__compute_basic__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = kblgt2__compute_basic__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = kblgt2__compute_basic__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__compute_basic__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Read Throughput";
    counter->symbol_name = "GtiReadThroughput";
    counter->desc = "The total number of GPU memory bytes read from GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__compute_basic__gti_read_throughput__read;
    counter->max_uint64 = kblgt2__compute_basic__gti_read_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Write Throughput";
    counter->symbol_name = "GtiWriteThroughput";
    counter->desc = "The total number of GPU memory bytes written to GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__compute_basic__gti_write_throughput__read;
    counter->max_uint64 = kblgt2__compute_basic__gti_write_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__compute_basic__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__compute_basic__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__compute_basic__l3_shader_throughput__read;
    counter->max_uint64 = kblgt2__compute_basic__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__compute_basic__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__compute_basic__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__compute_basic__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt2__compute_basic__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt2__compute_basic__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__compute_basic__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__compute_basic__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__compute_basic__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__compute_basic__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__compute_basic__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__compute_basic__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__compute_basic__slm_bytes_read__read;
    counter->max_uint64 = kblgt2__compute_basic__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__compute_basic__slm_bytes_written__read;
    counter->max_uint64 = kblgt2__compute_basic__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Bytes Read";
    counter->symbol_name = "TypedBytesRead";
    counter->desc = "The total number of typed memory bytes read via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__compute_basic__typed_bytes_read__read;
    counter->max_uint64 = kblgt2__compute_basic__typed_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Bytes Written";
    counter->symbol_name = "TypedBytesWritten";
    counter->desc = "The total number of untyped memory bytes written via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__compute_basic__typed_bytes_written__read;
    counter->max_uint64 = kblgt2__compute_basic__typed_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Untyped Bytes Read";
    counter->symbol_name = "UntypedBytesRead";
    counter->desc = "The total number of typed memory bytes read via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__compute_basic__untyped_bytes_read__read;
    counter->max_uint64 = kblgt2__compute_basic__untyped_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Untyped Writes";
    counter->symbol_name = "UntypedBytesWritten";
    counter->desc = "The total number of untyped memory bytes written via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__compute_basic__untyped_bytes_written__read;
    counter->max_uint64 = kblgt2__compute_basic__untyped_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__compute_basic__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 39);
}

static void
kblgt2_add_render_pipe_profile_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Render Metrics for 3D Pipeline Profile Gen9";
    metric_set->symbol_name = "RenderPipeProfile";
    metric_set->hw_config_guid = "d7a17a3a-ca71-40d2-a919-ace80d50633f";
    metric_set->counters = calloc(43, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(114, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(21, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0E001F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10116800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x178A03E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11824C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11830020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13840020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11850019 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11860007 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01870C40 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17880000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C0040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020E5400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000E0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080F0040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F0040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06104000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06110012 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06131000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01898000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D890100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03898000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09808000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B808000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0380C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8A0075 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D8A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x118A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B8A4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x138A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D81A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15818000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17818000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B820030 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07828000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D824000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F828000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05824000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D830003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0583000C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09830000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03838000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07838000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B840980 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03844D80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11840000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09848000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09850080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03850003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01850000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07860000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F860400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09870032 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01888052 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11880000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09884000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B931001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D930001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19934000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B958000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D950094 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19958000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09E58000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0BE58000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03E5C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0592C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B928000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D924000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F924000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11928000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1392C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09924000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01985000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07988000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09981000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B982000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D982000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F989000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05982000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x23904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x27904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x29908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190C080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900440 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900C21 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900042 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900024 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900841 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900400 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007FFEA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x00007FFC };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x0007AFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000F5FD };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00079FFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000F3FB };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x0007BF7A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000F7E7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x0007FEFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000F7CF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00077FFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000EFDF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x0006FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000CFBF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x0003FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x00005F7F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00025024 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00035034 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00045044 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00055054 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00065064 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = kblgt2__render_pipe_profile__avg_gpu_core_frequency__read;
    counter->max_uint64 = kblgt2__render_pipe_profile__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "BC Bottleneck";
    counter->symbol_name = "BcBottleneck";
    counter->desc = "The percentage of time in which barycentric coordinates calculation pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__render_pipe_profile__bc_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Barycentric Calc");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Clipper Bottleneck";
    counter->symbol_name = "ClBottleneck";
    counter->desc = "The percentage of time in which clipper pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__render_pipe_profile__cl_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Clipper");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CL Stall";
    counter->symbol_name = "ClStall";
    counter->desc = "The percentage of time in which clipper pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__render_pipe_profile__cl_stall__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Clipper");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__render_pipe_profile__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Bottleneck";
    counter->symbol_name = "DsBottleneck";
    counter->desc = "The percentage of time in which domain shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__render_pipe_profile__ds_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Stall";
    counter->symbol_name = "DsStall";
    counter->desc = "The percentage of time in which domain shader pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__render_pipe_profile__ds_stall__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__render_pipe_profile__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Bottleneck";
    counter->symbol_name = "EarlyDepthBottleneck";
    counter->desc = "The percentage of time in which early depth test pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__render_pipe_profile__early_depth_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__render_pipe_profile__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__render_pipe_profile__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__render_pipe_profile__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__render_pipe_profile__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = kblgt2__render_pipe_profile__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = kblgt2__render_pipe_profile__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Bottleneck";
    counter->symbol_name = "GsBottleneck";
    counter->desc = "The percentage of time in which geometry shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__render_pipe_profile__gs_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__render_pipe_profile__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Hi-Depth Bottleneck";
    counter->symbol_name = "HiDepthBottleneck";
    counter->desc = "The percentage of time in which early hierarchical depth test pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__render_pipe_profile__hi_depth_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__render_pipe_profile__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Bottleneck";
    counter->symbol_name = "HsBottleneck";
    counter->desc = "The percentage of time in which hull shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__render_pipe_profile__hs_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Stall";
    counter->symbol_name = "HsStall";
    counter->desc = "The percentage of time in which hull stall pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__render_pipe_profile__hs_stall__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__render_pipe_profile__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__render_pipe_profile__l3_shader_throughput__read;
    counter->max_uint64 = kblgt2__render_pipe_profile__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__render_pipe_profile__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__render_pipe_profile__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__render_pipe_profile__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt2__render_pipe_profile__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt2__render_pipe_profile__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__render_pipe_profile__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__render_pipe_profile__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__render_pipe_profile__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Strip-Fans Bottleneck";
    counter->symbol_name = "SfBottleneck";
    counter->desc = "The percentage of time in which strip-fans pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__render_pipe_profile__sf_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Strip-Fans");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SF Stall";
    counter->symbol_name = "SfStall";
    counter->desc = "The percentage of time in which strip-fans pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__render_pipe_profile__sf_stall__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Strip-Fans");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__render_pipe_profile__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__render_pipe_profile__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__render_pipe_profile__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__render_pipe_profile__slm_bytes_read__read;
    counter->max_uint64 = kblgt2__render_pipe_profile__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__render_pipe_profile__slm_bytes_written__read;
    counter->max_uint64 = kblgt2__render_pipe_profile__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SO Bottleneck";
    counter->symbol_name = "SoBottleneck";
    counter->desc = "The percentage of time in which stream output pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__render_pipe_profile__so_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Stream Output");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SO Stall";
    counter->symbol_name = "SoStall";
    counter->desc = "The percentage of time in which stream-output pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__render_pipe_profile__so_stall__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Stream Output");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VF Bottleneck";
    counter->symbol_name = "VfBottleneck";
    counter->desc = "The percentage of time in which vertex fetch pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__render_pipe_profile__vf_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Input Assembler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Bottleneck";
    counter->symbol_name = "VsBottleneck";
    counter->desc = "The percentage of time in which vertex shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__render_pipe_profile__vs_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__render_pipe_profile__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 43);
}

static void
kblgt2_add_memory_reads_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Memory Reads Distribution Gen9";
    metric_set->symbol_name = "MemoryReads";
    metric_set->hw_config_guid = "57b59202-172b-477a-87de-33f85572c589";
    metric_set->counters = calloc(41, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(47, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(32, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11810C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1381001A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37906800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F900064 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03811300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05811B12 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0781001A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B930055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03E58000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05E5C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07E54000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13900150 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21900151 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x23900152 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25900153 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x27900154 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x29900155 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B900156 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D900157 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F90015F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31900105 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15900103 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17900101 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900C60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900C63 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900C63 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900063 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000272C, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002728, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000271C, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002718, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000274C, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002748, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00006667 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000275C, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002758, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002754, .val = 0x00006465 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002750, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007F81A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x0007F82A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x0007F872 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x0007F8BA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x0007F87A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x0007F8EA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x0007F8E2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x0007F8F2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000FE00 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00025024 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00035034 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00045044 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00055054 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00065064 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = kblgt2__memory_reads__avg_gpu_core_frequency__read;
    counter->max_uint64 = kblgt2__memory_reads__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__memory_reads__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__memory_reads__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__memory_reads__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__memory_reads__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__memory_reads__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__memory_reads__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = kblgt2__memory_reads__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = kblgt2__memory_reads__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__memory_reads__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiCmdStreamerMemoryReads";
    counter->symbol_name = "GtiCmdStreamerMemoryReads";
    counter->desc = "The total number of GTI memory reads from Command Streamer.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__memory_reads__gti_cmd_streamer_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Command Streamer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiHizMemoryReads";
    counter->symbol_name = "GtiHizMemoryReads";
    counter->desc = "The total number of GTI memory reads from Hierarchical Depth Cache (Hi-Depth Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__memory_reads__gti_hiz_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank0Reads";
    counter->symbol_name = "GtiL3Bank0Reads";
    counter->desc = "The total number of GTI memory reads from L3 Bank 0 (L3 Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__memory_reads__gti_l3_bank0_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank1Reads";
    counter->symbol_name = "GtiL3Bank1Reads";
    counter->desc = "The total number of GTI memory reads from L3 Bank 1 (L3 Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__memory_reads__gti_l3_bank1_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank2Reads";
    counter->symbol_name = "GtiL3Bank2Reads";
    counter->desc = "The total number of GTI memory reads from L3 Bank 2 (L3 Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__memory_reads__gti_l3_bank2_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank3Reads";
    counter->symbol_name = "GtiL3Bank3Reads";
    counter->desc = "The total number of GTI memory reads from L3 Bank 3 (L3 Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__memory_reads__gti_l3_bank3_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Reads";
    counter->symbol_name = "GtiL3Reads";
    counter->desc = "The total number of GTI memory reads from L3 (L3 Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__memory_reads__gti_l3_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiMemoryReads";
    counter->symbol_name = "GtiMemoryReads";
    counter->desc = "The total number of GTI memory reads.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__memory_reads__gti_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiMscMemoryReads";
    counter->symbol_name = "GtiMscMemoryReads";
    counter->desc = "The total number of GTI memory reads from Multisampling Color Cache (Multisampling Color Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__memory_reads__gti_msc_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRccMemoryReads";
    counter->symbol_name = "GtiRccMemoryReads";
    counter->desc = "The total number of GTI memory reads from Render Color Cache (Render Color Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__memory_reads__gti_rcc_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRczMemoryReads";
    counter->symbol_name = "GtiRczMemoryReads";
    counter->desc = "The total number of GTI memory reads from Render Depth Cache (Render Depth Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__memory_reads__gti_rcz_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRingAccesses";
    counter->symbol_name = "GtiRingAccesses";
    counter->desc = "The total number of all accesses from GTI to the ring.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__memory_reads__gti_ring_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRsMemoryReads";
    counter->symbol_name = "GtiRsMemoryReads";
    counter->desc = "The total number of GTI memory reads from Resource Streamer.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__memory_reads__gti_rs_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Resource Streamer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiStcMemoryReads";
    counter->symbol_name = "GtiStcMemoryReads";
    counter->desc = "The total number of GTI memory reads from Stencil Cache (Stencil Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__memory_reads__gti_stc_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiVfMemoryReads";
    counter->symbol_name = "GtiVfMemoryReads";
    counter->desc = "The total number of GTI memory reads from Vertex Fetch.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__memory_reads__gti_vf_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Vertex Fetch");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__memory_reads__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__memory_reads__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__memory_reads__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__memory_reads__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__memory_reads__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt2__memory_reads__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt2__memory_reads__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__memory_reads__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__memory_reads__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__memory_reads__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__memory_reads__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__memory_reads__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__memory_reads__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__memory_reads__slm_bytes_read__read;
    counter->max_uint64 = kblgt2__memory_reads__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__memory_reads__slm_bytes_written__read;
    counter->max_uint64 = kblgt2__memory_reads__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__memory_reads__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 41);
}

static void
kblgt2_add_memory_writes_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Memory Writes Distribution Gen9";
    metric_set->symbol_name = "MemoryWrites";
    metric_set->hw_config_guid = "3addf8ef-8e9b-40f5-a448-3dbb5d5128b0";
    metric_set->counters = calloc(41, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(47, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(32, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11810C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1381001A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37906800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F901000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03811300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05811B12 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0781001A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B930055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03E58000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05E5C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07E54000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13900160 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21900161 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x23900162 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25900163 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x27900164 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x29900165 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B900166 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D900167 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F900150 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31900105 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15900103 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17900101 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900C60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900C63 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900C63 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900063 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000272C, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002728, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000271C, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002718, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000274C, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002748, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00006667 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000275C, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002758, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002754, .val = 0x00006465 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002750, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007F81A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x0007F82A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x0007F822 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x0007F8BA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x0007F87A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x0007F8EA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x0007F8E2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x0007F8F2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000FE00 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00025024 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00035034 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00045044 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00055054 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00065064 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = kblgt2__memory_writes__avg_gpu_core_frequency__read;
    counter->max_uint64 = kblgt2__memory_writes__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__memory_writes__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__memory_writes__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__memory_writes__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__memory_writes__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__memory_writes__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__memory_writes__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = kblgt2__memory_writes__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = kblgt2__memory_writes__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__memory_writes__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiCmdStreamerMemoryWrites";
    counter->symbol_name = "GtiCmdStreamerMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Command Streamer.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__memory_writes__gti_cmd_streamer_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Command Streamer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiHizMemoryWrites";
    counter->symbol_name = "GtiHizMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Hierarchical Depth Cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__memory_writes__gti_hiz_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank0Writes";
    counter->symbol_name = "GtiL3Bank0Writes";
    counter->desc = "The total number of GTI memory writes from L3 Bank 0 (L3 Bank 0 invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__memory_writes__gti_l3_bank0_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank1Writes";
    counter->symbol_name = "GtiL3Bank1Writes";
    counter->desc = "The total number of GTI memory writes from L3 Bank 1 (L3 Bank 1 invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__memory_writes__gti_l3_bank1_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank2Writes";
    counter->symbol_name = "GtiL3Bank2Writes";
    counter->desc = "The total number of GTI memory writes from L3 Bank 2 (L3 Bank 2 invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__memory_writes__gti_l3_bank2_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank3Writes";
    counter->symbol_name = "GtiL3Bank3Writes";
    counter->desc = "The total number of GTI memory writes from L3 Bank 3 (L3 Bank 3 invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__memory_writes__gti_l3_bank3_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Writes";
    counter->symbol_name = "GtiL3Writes";
    counter->desc = "The total number of GTI memory writes from L3 (L3 invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__memory_writes__gti_l3_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiMemoryWrites";
    counter->symbol_name = "GtiMemoryWrites";
    counter->desc = "The total number of GTI memory writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__memory_writes__gti_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiMscMemoryWrites";
    counter->symbol_name = "GtiMscMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Multisampling Color Cache (Multisampling Color Cache invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__memory_writes__gti_msc_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRccMemoryWrites";
    counter->symbol_name = "GtiRccMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Render Color Cache (Render Color Cache invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__memory_writes__gti_rcc_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRczMemoryWrites";
    counter->symbol_name = "GtiRczMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Render Depth Cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__memory_writes__gti_rcz_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRingAccesses";
    counter->symbol_name = "GtiRingAccesses";
    counter->desc = "The total number of all GTI accesses to the ring.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__memory_writes__gti_ring_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiSoMemoryWrites";
    counter->symbol_name = "GtiSoMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Stream Output.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__memory_writes__gti_so_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Stream Output");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiStcMemoryWrites";
    counter->symbol_name = "GtiStcMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Stencil Cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__memory_writes__gti_stc_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__memory_writes__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__memory_writes__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__memory_writes__l3_shader_throughput__read;
    counter->max_uint64 = kblgt2__memory_writes__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__memory_writes__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__memory_writes__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__memory_writes__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt2__memory_writes__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt2__memory_writes__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__memory_writes__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__memory_writes__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__memory_writes__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__memory_writes__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__memory_writes__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__memory_writes__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__memory_writes__slm_bytes_read__read;
    counter->max_uint64 = kblgt2__memory_writes__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__memory_writes__slm_bytes_written__read;
    counter->max_uint64 = kblgt2__memory_writes__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__memory_writes__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 41);
}

static void
kblgt2_add_compute_extended_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Compute Metrics Extended Gen9";
    metric_set->symbol_name = "ComputeExtended";
    metric_set->hw_config_guid = "4af0400a-81c3-47db-a6b6-deddbd75680e";
    metric_set->counters = calloc(38, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(72, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(21, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C00E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141C8160 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x161C8015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181C0120 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x184E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A4EAAA0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C4E0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x024E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E6C0B01 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x006C0200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x026C000C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001C0041 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x061C4200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x081C4443 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1C4645 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1C7647 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041C7357 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1C0030 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x101C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x121C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4CAA2A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4C02AA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084CA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F5400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F5515 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0155 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x162CAA00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x182C00AA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11907FFF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900802 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900842 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900842 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007FC2A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x0007FC6A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x0007FC92 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x0007FCA2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x0007FC32 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x0007FC9A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x0007FE6A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x0007FE7A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000BF00 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00000003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00002001 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00778008 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00088078 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00808708 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00A08908 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = kblgt2__compute_extended__avg_gpu_core_frequency__read;
    counter->max_uint64 = kblgt2__compute_extended__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__compute_extended__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuA64UntypedReads0";
    counter->symbol_name = "EuA64UntypedReads0";
    counter->desc = "The subslice 0 EU A64 Untyped Reads subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__compute_extended__eu_a64_untyped_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuA64UntypedWrites0";
    counter->symbol_name = "EuA64UntypedWrites0";
    counter->desc = "The subslice 0 EU A64 Untyped Writes subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__compute_extended__eu_a64_untyped_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__compute_extended__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU AVG IPC Rate";
    counter->symbol_name = "EuAvgIpcRate";
    counter->desc = "The average rate of IPC calculated for 2 FPU pipelines.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NUMBER;
    counter->read_float = kblgt2__compute_extended__eu_avg_ipc_rate__read;
    counter->max_float = kblgt2__compute_extended__eu_avg_ipc_rate__max;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__compute_extended__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Send Pipe Active";
    counter->symbol_name = "EuSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__compute_extended__eu_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__compute_extended__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Thread Occupancy";
    counter->symbol_name = "EuThreadOccupancy";
    counter->desc = "The percentage of time in which hardware threads occupied EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__compute_extended__eu_thread_occupancy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuTypedAtomics0";
    counter->symbol_name = "EuTypedAtomics0";
    counter->desc = "The subslice 0 EU Typed Atomics subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__compute_extended__eu_typed_atomics0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuTypedReads0";
    counter->symbol_name = "EuTypedReads0";
    counter->desc = "The subslice 0 EU Typed Reads subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__compute_extended__eu_typed_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuTypedWrites0";
    counter->symbol_name = "EuTypedWrites0";
    counter->desc = "The subslice 0 EU Typed Writes subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__compute_extended__eu_typed_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuUntypedAtomics0";
    counter->symbol_name = "EuUntypedAtomics0";
    counter->desc = "The subslice 0 EU Untyped Atomics subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__compute_extended__eu_untyped_atomics0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuUntypedReads0";
    counter->symbol_name = "EuUntypedReads0";
    counter->desc = "The subslice 0 EU Untyped Reads subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__compute_extended__eu_untyped_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuUntypedWrites0";
    counter->symbol_name = "EuUntypedWrites0";
    counter->desc = "The subslice 0 EU Untyped Writes subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__compute_extended__eu_untyped_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Pipe Active";
    counter->symbol_name = "Fpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__compute_extended__fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active";
    counter->symbol_name = "Fpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__compute_extended__fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = kblgt2__compute_extended__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = kblgt2__compute_extended__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__compute_extended__l3_shader_throughput__read;
    counter->max_uint64 = kblgt2__compute_extended__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt2__compute_extended__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt2__compute_extended__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__compute_extended__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__compute_extended__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__compute_extended__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__compute_extended__slm_bytes_read__read;
    counter->max_uint64 = kblgt2__compute_extended__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__compute_extended__slm_bytes_written__read;
    counter->max_uint64 = kblgt2__compute_extended__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Atomics 0";
    counter->symbol_name = "TypedAtomics0";
    counter->desc = "The subslice 0 typed atomics.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__compute_extended__typed_atomics0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TypedAtomicsPerCacheLine";
    counter->symbol_name = "TypedAtomicsPerCacheLine";
    counter->desc = "The ratio of EU typed atomics requests to L3 cache line writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
    counter->read_float = kblgt2__compute_extended__typed_atomics_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Reads 0";
    counter->symbol_name = "TypedReads0";
    counter->desc = "The subslice 0 typed reads.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__compute_extended__typed_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TypedReadsPerCacheLine";
    counter->symbol_name = "TypedReadsPerCacheLine";
    counter->desc = "The ratio of EU typed read requests to L3 cache line reads.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
    counter->read_float = kblgt2__compute_extended__typed_reads_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Writes 0";
    counter->symbol_name = "TypedWrites0";
    counter->desc = "The subslice 0 typed writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__compute_extended__typed_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TypedWritesPerCacheLine";
    counter->symbol_name = "TypedWritesPerCacheLine";
    counter->desc = "The ratio of EU typed write requests to L3 cache line writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
    counter->read_float = kblgt2__compute_extended__typed_writes_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Untyped Reads 0";
    counter->symbol_name = "UntypedReads0";
    counter->desc = "The subslice 0 untyped reads (including SLM reads).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__compute_extended__untyped_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "UntypedReadsPerCacheLine";
    counter->symbol_name = "UntypedReadsPerCacheLine";
    counter->desc = "The ratio of EU untyped read requests to L3 cache line reads.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
    counter->read_float = kblgt2__compute_extended__untyped_reads_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Untyped Writes 0";
    counter->symbol_name = "UntypedWrites0";
    counter->desc = "The subslice 0 untyped writes (including SLM writes).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__compute_extended__untyped_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "UntypedWritesPerCacheLine";
    counter->symbol_name = "UntypedWritesPerCacheLine";
    counter->desc = "The ratio of EU untyped write requests to L3 cache line writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
    counter->read_float = kblgt2__compute_extended__untyped_writes_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    assert(metric_set->n_counters <= 38);
}

static void
kblgt2_add_compute_l3_cache_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Compute Metrics L3 Cache Gen9";
    metric_set->symbol_name = "ComputeL3Cache";
    metric_set->hw_config_guid = "0e22f995-79ca-4f67-83ab-e9d9772488d8";
    metric_set->counters = calloc(54, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(60, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(13, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x166C0760 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1593001E };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F900003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x184E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A4E8020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C4E0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x006C0051 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x066C5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x086C5C5D };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E6C5E5F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x186C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x061B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x081BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x101C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1CE000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1C0030 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C2A00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4C0280 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F0400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F1500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0140 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x162C0A00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x182C00A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03933300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05930032 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11930000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B930000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D900157 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F900158 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190030F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900021 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53904444 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FEFE };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x0007FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FEFD };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x0007FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FBEF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x0007FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FBDF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00000003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00002001 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00101100 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00201200 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00301300 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00401400 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = kblgt2__compute_l3_cache__avg_gpu_core_frequency__read;
    counter->max_uint64 = kblgt2__compute_l3_cache__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__compute_l3_cache__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__compute_l3_cache__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__compute_l3_cache__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__compute_l3_cache__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU AVG IPC Rate";
    counter->symbol_name = "EuAvgIpcRate";
    counter->desc = "The average rate of IPC calculated for 2 FPU pipelines.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NUMBER;
    counter->read_float = kblgt2__compute_l3_cache__eu_avg_ipc_rate__read;
    counter->max_float = kblgt2__compute_l3_cache__eu_avg_ipc_rate__max;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Binary Instruction";
    counter->symbol_name = "EuBinaryFpu0Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing binary instructions on FPU0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__compute_l3_cache__eu_binary_fpu0_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Binary Instruction";
    counter->symbol_name = "EuBinaryFpu1Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing binary instructions on FPU1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__compute_l3_cache__eu_binary_fpu1_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__compute_l3_cache__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Hybrid Instruction";
    counter->symbol_name = "EuHybridFpu0Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing hybrid instructions on FPU0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__compute_l3_cache__eu_hybrid_fpu0_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Hybrid Instruction";
    counter->symbol_name = "EuHybridFpu1Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing hybrid instructions on FPU1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__compute_l3_cache__eu_hybrid_fpu1_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Move Instruction";
    counter->symbol_name = "EuMoveFpu0Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing move instructions on FPU0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__compute_l3_cache__eu_move_fpu0_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Move Instruction";
    counter->symbol_name = "EuMoveFpu1Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing move instructions on FPU1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__compute_l3_cache__eu_move_fpu1_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Send Pipe Active";
    counter->symbol_name = "EuSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__compute_l3_cache__eu_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__compute_l3_cache__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Ternary Instruction";
    counter->symbol_name = "EuTernaryFpu0Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing ternary instructions on FPU0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__compute_l3_cache__eu_ternary_fpu0_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Ternary Instruction";
    counter->symbol_name = "EuTernaryFpu1Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing ternary instructions on FPU1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__compute_l3_cache__eu_ternary_fpu1_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Pipe Active";
    counter->symbol_name = "Fpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__compute_l3_cache__fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active";
    counter->symbol_name = "Fpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__compute_l3_cache__fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__compute_l3_cache__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = kblgt2__compute_l3_cache__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = kblgt2__compute_l3_cache__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__compute_l3_cache__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI L3 Throughput";
    counter->symbol_name = "GtiL3Throughput";
    counter->desc = "The total number of GPU memory bytes transferred between L3 caches and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__compute_l3_cache__gti_l3_throughput__read;
    counter->max_uint64 = kblgt2__compute_l3_cache__gti_l3_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Read Throughput";
    counter->symbol_name = "GtiReadThroughput";
    counter->desc = "The total number of GPU memory bytes read from GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__compute_l3_cache__gti_read_throughput__read;
    counter->max_uint64 = kblgt2__compute_l3_cache__gti_read_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Write Throughput";
    counter->symbol_name = "GtiWriteThroughput";
    counter->desc = "The total number of GPU memory bytes written to GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__compute_l3_cache__gti_write_throughput__read;
    counter->max_uint64 = kblgt2__compute_l3_cache__gti_write_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__compute_l3_cache__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__compute_l3_cache__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Accesses";
    counter->symbol_name = "L3Accesses";
    counter->desc = "The total number of L3 accesses from all entities.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__compute_l3_cache__l3_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3");

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 00 Accesses";
        counter->symbol_name = "L3Bank00Accesses";
        counter->desc = "The total number of accesses to L3 Bank 00.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = kblgt2__compute_l3_cache__l3_bank00_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 00 IC Accesses";
        counter->symbol_name = "L3Bank00IcAccesses";
        counter->desc = "The total number of accesses to L3 Bank 00 from IC cache.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = kblgt2__compute_l3_cache__l3_bank00_ic_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3/IC");
    }

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 00 IC Hits";
        counter->symbol_name = "L3Bank00IcHits";
        counter->desc = "The total number of hits in L3 Bank 00 from IC cache.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = kblgt2__compute_l3_cache__l3_bank00_ic_hits__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3/IC");
    }

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 01 Accesses";
        counter->symbol_name = "L3Bank01Accesses";
        counter->desc = "The total number of accesses to L3 Bank 01.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = kblgt2__compute_l3_cache__l3_bank01_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 02 Accesses";
        counter->symbol_name = "L3Bank02Accesses";
        counter->desc = "The total number of accesses to L3 Bank 02.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = kblgt2__compute_l3_cache__l3_bank02_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 03 Accesses";
        counter->symbol_name = "L3Bank03Accesses";
        counter->desc = "The total number of accesses to L3 Bank 03.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = kblgt2__compute_l3_cache__l3_bank03_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Misses";
    counter->symbol_name = "L3Misses";
    counter->desc = "The total number of L3 misses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__compute_l3_cache__l3_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/TAG");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Sampler Throughput";
    counter->symbol_name = "L3SamplerThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between samplers and L3 caches.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__compute_l3_cache__l3_sampler_throughput__read;
    counter->max_uint64 = kblgt2__compute_l3_cache__l3_sampler_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__compute_l3_cache__l3_shader_throughput__read;
    counter->max_uint64 = kblgt2__compute_l3_cache__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Total Throughput";
    counter->symbol_name = "L3TotalThroughput";
    counter->desc = "The total number of GPU memory bytes transferred via L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__compute_l3_cache__l3_total_throughput__read;
    counter->max_uint64 = kblgt2__compute_l3_cache__l3_total_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__compute_l3_cache__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__compute_l3_cache__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__compute_l3_cache__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Accesses";
    counter->symbol_name = "SamplerAccesses";
    counter->desc = "The total number of messages send to samplers.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__compute_l3_cache__sampler_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt2__compute_l3_cache__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt2__compute_l3_cache__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__compute_l3_cache__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__compute_l3_cache__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__compute_l3_cache__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__compute_l3_cache__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__compute_l3_cache__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__compute_l3_cache__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__compute_l3_cache__slm_bytes_read__read;
    counter->max_uint64 = kblgt2__compute_l3_cache__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__compute_l3_cache__slm_bytes_written__read;
    counter->max_uint64 = kblgt2__compute_l3_cache__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__compute_l3_cache__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 54);
}

static void
kblgt2_add_hdc_and_sf_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set HDCAndSF";
    metric_set->symbol_name = "HDCAndSF";
    metric_set->hw_config_guid = "fb149d66-fad2-4230-b0d7-4d689b9116d3";
    metric_set->counters = calloc(40, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(55, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(8, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x104F0232 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x124F4640 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C0232 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11834400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004F1880 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x024F08BB };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044F001B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x046C0100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x066C000B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x061B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1C1800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x005B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x025BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x045B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x125C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x145C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x165C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x185C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C00A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F0055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F828000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8305C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09830000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07830000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D950080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13928000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F988000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190FC00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900842 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x10800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FDFF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = kblgt2__hdc_and_sf__avg_gpu_core_frequency__read;
    counter->max_uint64 = kblgt2__hdc_and_sf__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__hdc_and_sf__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__hdc_and_sf__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__hdc_and_sf__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__hdc_and_sf__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__hdc_and_sf__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__hdc_and_sf__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt2__hdc_and_sf__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__hdc_and_sf__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = kblgt2__hdc_and_sf__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = kblgt2__hdc_and_sf__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__hdc_and_sf__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__hdc_and_sf__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__hdc_and_sf__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__hdc_and_sf__l3_shader_throughput__read;
    counter->max_uint64 = kblgt2__hdc_and_sf__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "HDC stalled by L3 (s0.ss0)";
        counter->symbol_name = "NonSamplerShader00AccessStalledOnL3";
        counter->desc = "Percentage of time when HDC has messges to L3, but it's stalled due to lack of credits (s0.ss0)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt2__hdc_and_sf__non_sampler_shader00_access_stalled_on_l3__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Data Port");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "HDC stalled by L3 (s0.ss1)";
        counter->symbol_name = "NonSamplerShader01AccessStalledOnL3";
        counter->desc = "Percentage of time when HDC has messges to L3, but it's stalled due to lack of credits (s0.ss1)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt2__hdc_and_sf__non_sampler_shader01_access_stalled_on_l3__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Data Port");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "HDC stalled by L3 (s0.ss2)";
        counter->symbol_name = "NonSamplerShader02AccessStalledOnL3";
        counter->desc = "Percentage of time when HDC has messges to L3, but it's stalled due to lack of credits (s0.ss2)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt2__hdc_and_sf__non_sampler_shader02_access_stalled_on_l3__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Data Port");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__hdc_and_sf__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Polygon Data Ready";
    counter->symbol_name = "PolyDataReady";
    counter->desc = "The percentage of time in which geometry pipeline output is ready";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__hdc_and_sf__poly_data_ready__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe/Strip-Fans");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__hdc_and_sf__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__hdc_and_sf__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__hdc_and_sf__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__hdc_and_sf__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__hdc_and_sf__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__hdc_and_sf__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt2__hdc_and_sf__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt2__hdc_and_sf__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__hdc_and_sf__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__hdc_and_sf__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__hdc_and_sf__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__hdc_and_sf__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__hdc_and_sf__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__hdc_and_sf__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__hdc_and_sf__slm_bytes_read__read;
    counter->max_uint64 = kblgt2__hdc_and_sf__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__hdc_and_sf__slm_bytes_written__read;
    counter->max_uint64 = kblgt2__hdc_and_sf__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__hdc_and_sf__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__hdc_and_sf__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__hdc_and_sf__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__hdc_and_sf__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 40);
}

static void
kblgt2_add_l3_1_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set L3_1";
    metric_set->symbol_name = "L3_1";
    metric_set->hw_config_guid = "f889f8cc-4c93-4ac8-b75f-551c0b9b87f7";
    metric_set->counters = calloc(40, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(72, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(22, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x126C7B40 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x166C0020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A603444 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A613400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A4EA800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C4E0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x024E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C6C5327 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E6C5425 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x006C2A00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x026C285B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x046C005C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6C0800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1C003C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x121C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x161C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1C0800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x065B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A5C1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10600000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04600000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C610044 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10610000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06610000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4C02A8 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084CA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0154 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F0055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x182C00AA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190FFC0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900420 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900021 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900421 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900040 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00100070 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFF1 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00014002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000C3FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00010002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000C7FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00004002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000D3FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00100700 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FF1F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00001402 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FC3F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x00001002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FC7F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x00000402 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000FD3F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = kblgt2__l3_1__avg_gpu_core_frequency__read;
    counter->max_uint64 = kblgt2__l3_1__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__l3_1__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__l3_1__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__l3_1__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__l3_1__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__l3_1__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__l3_1__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt2__l3_1__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__l3_1__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = kblgt2__l3_1__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = kblgt2__l3_1__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__l3_1__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__l3_1__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__l3_1__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank0 Active";
        counter->symbol_name = "L30Bank0Active";
        counter->desc = "The percentage of time in which slice0 L3 bank0 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt2__l3_1__l30_bank0_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank0 Stalled";
        counter->symbol_name = "L30Bank0Stalled";
        counter->desc = "The percentage of time in which slice0 L3 bank0 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt2__l3_1__l30_bank0_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank1 Active";
        counter->symbol_name = "L30Bank1Active";
        counter->desc = "The percentage of time in which slice0 L3 bank1 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt2__l3_1__l30_bank1_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank1 Stalled";
        counter->symbol_name = "L30Bank1Stalled";
        counter->desc = "The percentage of time in which slice0 L3 bank1 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt2__l3_1__l30_bank1_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__l3_1__l3_shader_throughput__read;
    counter->max_uint64 = kblgt2__l3_1__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__l3_1__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__l3_1__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__l3_1__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__l3_1__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__l3_1__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__l3_1__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__l3_1__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt2__l3_1__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt2__l3_1__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__l3_1__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__l3_1__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__l3_1__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__l3_1__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__l3_1__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__l3_1__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__l3_1__slm_bytes_read__read;
    counter->max_uint64 = kblgt2__l3_1__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__l3_1__slm_bytes_written__read;
    counter->max_uint64 = kblgt2__l3_1__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__l3_1__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__l3_1__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__l3_1__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__l3_1__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 40);
}

static void
kblgt2_add_l3_2_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set L3_2";
    metric_set->symbol_name = "L3_2";
    metric_set->hw_config_guid = "6d344efd-8e9e-42d4-a29e-1011c29f82c2";
    metric_set->counters = calloc(38, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(45, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(14, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x126C02E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x146C0001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A623400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x026C3324 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x046C3422 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x161C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1C0800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x065B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A5C1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06614000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C620044 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10620000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06620000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F0055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190F800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00100070 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFF1 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00028002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x000087FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00020002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x00008FFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00008002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000A7FF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = kblgt2__l3_2__avg_gpu_core_frequency__read;
    counter->max_uint64 = kblgt2__l3_2__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__l3_2__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__l3_2__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__l3_2__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__l3_2__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__l3_2__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__l3_2__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt2__l3_2__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__l3_2__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = kblgt2__l3_2__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = kblgt2__l3_2__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__l3_2__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__l3_2__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__l3_2__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank2 Active";
        counter->symbol_name = "L30Bank2Active";
        counter->desc = "The percentage of time in which slice0 L3 bank2 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt2__l3_2__l30_bank2_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank2 Stalled";
        counter->symbol_name = "L30Bank2Stalled";
        counter->desc = "The percentage of time in which slice0 L3 bank2 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt2__l3_2__l30_bank2_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__l3_2__l3_shader_throughput__read;
    counter->max_uint64 = kblgt2__l3_2__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__l3_2__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__l3_2__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__l3_2__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__l3_2__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__l3_2__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__l3_2__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__l3_2__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt2__l3_2__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt2__l3_2__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__l3_2__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__l3_2__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__l3_2__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__l3_2__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__l3_2__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__l3_2__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__l3_2__slm_bytes_read__read;
    counter->max_uint64 = kblgt2__l3_2__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__l3_2__slm_bytes_written__read;
    counter->max_uint64 = kblgt2__l3_2__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__l3_2__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__l3_2__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__l3_2__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__l3_2__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 38);
}

static void
kblgt2_add_l3_3_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set L3_3";
    metric_set->symbol_name = "L3_3";
    metric_set->hw_config_guid = "e3b386ae-c195-47d5-af29-8a1afa0ae2bf";
    metric_set->counters = calloc(38, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(44, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(14, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x126C4E80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x146C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A633400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x026C3321 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x046C342F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6C2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x061B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x161C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1C1800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06604000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C630044 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10630000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06630000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C00AA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F0055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190F800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900842 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00100070 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFF1 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00028002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x000087FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00020002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x00008FFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00008002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000A7FF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = kblgt2__l3_3__avg_gpu_core_frequency__read;
    counter->max_uint64 = kblgt2__l3_3__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__l3_3__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__l3_3__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__l3_3__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__l3_3__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__l3_3__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__l3_3__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt2__l3_3__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__l3_3__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = kblgt2__l3_3__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = kblgt2__l3_3__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__l3_3__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__l3_3__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__l3_3__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank3 Active";
        counter->symbol_name = "L30Bank3Active";
        counter->desc = "The percentage of time in which slice0 L3 bank3 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt2__l3_3__l30_bank3_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank3 Stalled";
        counter->symbol_name = "L30Bank3Stalled";
        counter->desc = "The percentage of time in which slice0 L3 bank3 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt2__l3_3__l30_bank3_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__l3_3__l3_shader_throughput__read;
    counter->max_uint64 = kblgt2__l3_3__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__l3_3__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__l3_3__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__l3_3__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__l3_3__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__l3_3__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__l3_3__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__l3_3__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt2__l3_3__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt2__l3_3__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__l3_3__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__l3_3__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__l3_3__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__l3_3__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__l3_3__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__l3_3__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__l3_3__slm_bytes_read__read;
    counter->max_uint64 = kblgt2__l3_3__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__l3_3__slm_bytes_written__read;
    counter->max_uint64 = kblgt2__l3_3__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__l3_3__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__l3_3__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__l3_3__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__l3_3__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 38);
}

static void
kblgt2_add_rasterizer_and_pixel_backend_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set RasterizerAndPixelBackend";
    metric_set->symbol_name = "RasterizerAndPixelBackend";
    metric_set->hw_config_guid = "f9954679-a055-4862-9f57-9d66e3ebf81c";
    metric_set->counters = calloc(41, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(32, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(10, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x102F3800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x144D0500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x120D03C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x140D03CF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F0004 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4E4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042F0480 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C0090 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064D0027 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004D0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D0D40 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020D803F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040D8023 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100D0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020F0010 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F0050 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190FC00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41901400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43901485 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000EFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00006000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000F3FF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = kblgt2__rasterizer_and_pixel_backend__avg_gpu_core_frequency__read;
    counter->max_uint64 = kblgt2__rasterizer_and_pixel_backend__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__rasterizer_and_pixel_backend__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__rasterizer_and_pixel_backend__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__rasterizer_and_pixel_backend__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__rasterizer_and_pixel_backend__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__rasterizer_and_pixel_backend__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__rasterizer_and_pixel_backend__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt2__rasterizer_and_pixel_backend__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__rasterizer_and_pixel_backend__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = kblgt2__rasterizer_and_pixel_backend__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = kblgt2__rasterizer_and_pixel_backend__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__rasterizer_and_pixel_backend__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__rasterizer_and_pixel_backend__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__rasterizer_and_pixel_backend__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__rasterizer_and_pixel_backend__l3_shader_throughput__read;
    counter->max_uint64 = kblgt2__rasterizer_and_pixel_backend__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 PS Output Available";
        counter->symbol_name = "PSOutput0Available";
        counter->desc = "The percentage of time in which slice0 PS output is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt2__rasterizer_and_pixel_backend__ps_output0_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Post-EarlyZ Pixel Data Ready";
        counter->symbol_name = "PixelData0Ready";
        counter->desc = "The percentage of time in which slice0 post-EarlyZ pixel data is ready (after early Z tests have been applied)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt2__rasterizer_and_pixel_backend__pixel_data0_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Rasterizer/Early Depth Test");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Pixel Values Ready";
        counter->symbol_name = "PixelValues0Ready";
        counter->desc = "The percentage of time in which slice0 pixel values are ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt2__rasterizer_and_pixel_backend__pixel_values0_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__rasterizer_and_pixel_backend__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__rasterizer_and_pixel_backend__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__rasterizer_and_pixel_backend__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__rasterizer_and_pixel_backend__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__rasterizer_and_pixel_backend__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__rasterizer_and_pixel_backend__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__rasterizer_and_pixel_backend__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Rasterizer Input Available";
        counter->symbol_name = "Rasterizer0InputAvailable";
        counter->desc = "The percentage of time in which slice0 rasterizer input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt2__rasterizer_and_pixel_backend__rasterizer0_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Rasterizer");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Rasterizer Output Ready";
        counter->symbol_name = "Rasterizer0OutputReady";
        counter->desc = "The percentage of time in which slice0 rasterizer output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt2__rasterizer_and_pixel_backend__rasterizer0_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Rasterizer");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt2__rasterizer_and_pixel_backend__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt2__rasterizer_and_pixel_backend__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__rasterizer_and_pixel_backend__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__rasterizer_and_pixel_backend__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__rasterizer_and_pixel_backend__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__rasterizer_and_pixel_backend__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__rasterizer_and_pixel_backend__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__rasterizer_and_pixel_backend__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__rasterizer_and_pixel_backend__slm_bytes_read__read;
    counter->max_uint64 = kblgt2__rasterizer_and_pixel_backend__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__rasterizer_and_pixel_backend__slm_bytes_written__read;
    counter->max_uint64 = kblgt2__rasterizer_and_pixel_backend__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__rasterizer_and_pixel_backend__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__rasterizer_and_pixel_backend__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__rasterizer_and_pixel_backend__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__rasterizer_and_pixel_backend__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 41);
}

static void
kblgt2_add_sampler_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set Sampler";
    metric_set->symbol_name = "Sampler";
    metric_set->hw_config_guid = "4ed5e27e-fd1a-4f11-ad8f-9374e128c697";
    metric_set->counters = calloc(42, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(70, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(12, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14152C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16150005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x121600A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14352C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16350005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x123600A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14552C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16550005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x125600A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062F6000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022F2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4C0050 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C0010 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0350 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0FB000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F00DA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x182C0028 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022DC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C138000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E132000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0413C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C140018 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C157000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E150078 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10150000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04162180 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02160000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04174000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0233A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04333000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14348000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16348000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02357870 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10350000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04360043 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02360000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04371000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E538000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00538000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06533000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C540020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12548000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E557000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00557800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10550000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06560043 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02560000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06571000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190FF80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900060 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900842 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900060 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x70800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0000C000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000E7FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00003000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000F9FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000C00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FE7F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = kblgt2__sampler__avg_gpu_core_frequency__read;
    counter->max_uint64 = kblgt2__sampler__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__sampler__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__sampler__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__sampler__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__sampler__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__sampler__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__sampler__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt2__sampler__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__sampler__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = kblgt2__sampler__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = kblgt2__sampler__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__sampler__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__sampler__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__sampler__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__sampler__l3_shader_throughput__read;
    counter->max_uint64 = kblgt2__sampler__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__sampler__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__sampler__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__sampler__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__sampler__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__sampler__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__sampler__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__sampler__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice0 Input Available";
        counter->symbol_name = "Sampler00InputAvailable";
        counter->desc = "The percentage of time in which slice0 subslice0 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt2__sampler__sampler00_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice0 Sampler Output Ready";
        counter->symbol_name = "Sampler00OutputReady";
        counter->desc = "The percentage of time in which slice0 subslice0 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt2__sampler__sampler00_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice1 Input Available";
        counter->symbol_name = "Sampler01InputAvailable";
        counter->desc = "The percentage of time in which slice0 subslice1 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt2__sampler__sampler01_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice1 Sampler Output Ready";
        counter->symbol_name = "Sampler01OutputReady";
        counter->desc = "The percentage of time in which slice0 subslice1 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt2__sampler__sampler01_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice2 Input Available";
        counter->symbol_name = "Sampler02InputAvailable";
        counter->desc = "The percentage of time in which slice0 subslice2 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt2__sampler__sampler02_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice2 Sampler Output Ready";
        counter->symbol_name = "Sampler02OutputReady";
        counter->desc = "The percentage of time in which slice0 subslice2 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt2__sampler__sampler02_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt2__sampler__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt2__sampler__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__sampler__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__sampler__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__sampler__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__sampler__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__sampler__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__sampler__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__sampler__slm_bytes_read__read;
    counter->max_uint64 = kblgt2__sampler__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__sampler__slm_bytes_written__read;
    counter->max_uint64 = kblgt2__sampler__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__sampler__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__sampler__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__sampler__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__sampler__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 42);
}

static void
kblgt2_add_tdl_1_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set TDL_1";
    metric_set->symbol_name = "TDL_1";
    metric_set->hw_config_guid = "9eaf384d-8f53-41b8-a71d-108308780fbc";
    metric_set->counters = calloc(42, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(69, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(18, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12120000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12320000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12520000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022F3000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C0015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F03A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0FF000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F0095 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02108000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0410C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02118000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0411C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02121880 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041219B5 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00120000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02134000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04135000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C308000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E304000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06304000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C318000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E314000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06314000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C321A80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E320033 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06320031 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00320000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C334000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E331000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06331000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E508000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00508000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02504000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E518000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00518000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02514000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E521880 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00521A80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02520033 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E534000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00534000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02531000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190FF80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900062 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900040 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x00007FFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x00009FFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000EFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000F3FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FDFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FE7F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = kblgt2__tdl_1__avg_gpu_core_frequency__read;
    counter->max_uint64 = kblgt2__tdl_1__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__tdl_1__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__tdl_1__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__tdl_1__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__tdl_1__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__tdl_1__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__tdl_1__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt2__tdl_1__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__tdl_1__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = kblgt2__tdl_1__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = kblgt2__tdl_1__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__tdl_1__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__tdl_1__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__tdl_1__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__tdl_1__l3_shader_throughput__read;
    counter->max_uint64 = kblgt2__tdl_1__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "NonPS Thread Ready For Dispatch on Slice0 Subslice0";
        counter->symbol_name = "NonPSThread00ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice0 subslice0 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt2__tdl_1__non_ps_thread00_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "NonPS Thread Ready For Dispatch on Slice0 Subslice1";
        counter->symbol_name = "NonPSThread01ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice0 subslice1 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt2__tdl_1__non_ps_thread01_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "NonPS Thread Ready For Dispatch on Slice0 Subslice2";
        counter->symbol_name = "NonPSThread02ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice0 subslice2 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt2__tdl_1__non_ps_thread02_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice0 Subslice0";
        counter->symbol_name = "PSThread00ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice0 subslice0 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt2__tdl_1__ps_thread00_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice0 Subslice1";
        counter->symbol_name = "PSThread01ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice0 subslice1 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt2__tdl_1__ps_thread01_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice0 Subslice2";
        counter->symbol_name = "PSThread02ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice0 subslice2 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt2__tdl_1__ps_thread02_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__tdl_1__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__tdl_1__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__tdl_1__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__tdl_1__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__tdl_1__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__tdl_1__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__tdl_1__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt2__tdl_1__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt2__tdl_1__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__tdl_1__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__tdl_1__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__tdl_1__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__tdl_1__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__tdl_1__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__tdl_1__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__tdl_1__slm_bytes_read__read;
    counter->max_uint64 = kblgt2__tdl_1__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__tdl_1__slm_bytes_written__read;
    counter->max_uint64 = kblgt2__tdl_1__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__tdl_1__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__tdl_1__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__tdl_1__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__tdl_1__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 42);
}

static void
kblgt2_add_tdl_2_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set TDL_2";
    metric_set->symbol_name = "TDL_2";
    metric_set->hw_config_guid = "a00cbdf2-eabd-4240-9a89-86e2ac1ca1e4";
    metric_set->counters = calloc(42, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(43, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(6, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12124D60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12322E60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12524D60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022F3000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C0014 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0FE000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F0097 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0410C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0411C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04121FB7 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00120000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04135000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00308000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06304000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00318000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06314000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00321B80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0632003F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00334000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06331000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0250C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0251C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02521FB7 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00520000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02535000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190FC00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900063 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = kblgt2__tdl_2__avg_gpu_core_frequency__read;
    counter->max_uint64 = kblgt2__tdl_2__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__tdl_2__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__tdl_2__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__tdl_2__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__tdl_2__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__tdl_2__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__tdl_2__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt2__tdl_2__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__tdl_2__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = kblgt2__tdl_2__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = kblgt2__tdl_2__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__tdl_2__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__tdl_2__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__tdl_2__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__tdl_2__l3_shader_throughput__read;
    counter->max_uint64 = kblgt2__tdl_2__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__tdl_2__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__tdl_2__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__tdl_2__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__tdl_2__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__tdl_2__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__tdl_2__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__tdl_2__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt2__tdl_2__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt2__tdl_2__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__tdl_2__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__tdl_2__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt2__tdl_2__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__tdl_2__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__tdl_2__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt2__tdl_2__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__tdl_2__slm_bytes_read__read;
    counter->max_uint64 = kblgt2__tdl_2__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt2__tdl_2__slm_bytes_written__read;
    counter->max_uint64 = kblgt2__tdl_2__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice0 Port 0";
        counter->symbol_name = "ThreadHeader00ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice0 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt2__tdl_2__thread_header00_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice0 Port 1";
        counter->symbol_name = "ThreadHeader00ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice0 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt2__tdl_2__thread_header00_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice1 Port 0";
        counter->symbol_name = "ThreadHeader01ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice1 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt2__tdl_2__thread_header01_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice1 Port 1";
        counter->symbol_name = "ThreadHeader01ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice1 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt2__tdl_2__thread_header01_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice2 Port 0";
        counter->symbol_name = "ThreadHeader02ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice2 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt2__tdl_2__thread_header02_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice2 Port 1";
        counter->symbol_name = "ThreadHeader02ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice2 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt2__tdl_2__thread_header02_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__tdl_2__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__tdl_2__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__tdl_2__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__tdl_2__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 42);
}

static void
kblgt2_add_compute_extra_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Compute Metrics Extra Gen9";
    metric_set->symbol_name = "ComputeExtra";
    metric_set->hw_config_guid = "aa7a3fb9-22fb-43ff-a32d-0ab6c13bbd16";
    metric_set->counters = calloc(5, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(32, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(6, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x121203E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x123203E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x125203E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C0040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F006C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06104000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06114000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06120033 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00120000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06131000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04308000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04318000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04321980 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00320000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04334000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04504000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04514000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04520033 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00520000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04531000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190E000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00001000 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00003002 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00011010 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00050012 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00052051 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00000008 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = kblgt2__compute_extra__avg_gpu_core_frequency__read;
    counter->max_uint64 = kblgt2__compute_extra__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active";
    counter->symbol_name = "Fpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__compute_extra__fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active including Ext Math";
    counter->symbol_name = "Fpu1ActiveAdjusted";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing including Extended Math processing";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__compute_extra__fpu1_active_adjusted__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = kblgt2__compute_extra__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = kblgt2__compute_extra__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    assert(metric_set->n_counters <= 5);
}

static void
kblgt2_add_vme_pipe_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Media Vme Pipe Gen9";
    metric_set->symbol_name = "VMEPipe";
    metric_set->hw_config_guid = "398a4268-ef6f-4ffc-b55f-3c7b5363ce61";
    metric_set->counters = calloc(10, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(62, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(17, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(2, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141A5800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x161A00C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12180240 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14180002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x143A5800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x163A00C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12380240 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14380002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002F1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042F3000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C1500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F0400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F9500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x162C0A00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2DC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2DC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04193000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x081A28C1 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00133000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0613C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0813F000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00172000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06178000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0817A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00180037 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06180940 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08180000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02180000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04183000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06393000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C3A28C1 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x003A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A33F000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C33F000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A37A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C37A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A380977 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08380000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04380000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06383000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x119000FF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47901000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900844 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00100030 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFF9 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FFFC };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FFF3 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00100180 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FFCF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FFCF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FF3F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00008003 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = kblgt2__vme_pipe__avg_gpu_core_frequency__read;
    counter->max_uint64 = kblgt2__vme_pipe__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt2__vme_pipe__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__vme_pipe__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__vme_pipe__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__vme_pipe__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Thread Occupancy";
    counter->symbol_name = "EuThreadOccupancy";
    counter->desc = "The percentage of time in which hardware threads occupied EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__vme_pipe__eu_thread_occupancy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__vme_pipe__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = kblgt2__vme_pipe__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = kblgt2__vme_pipe__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VME Busy";
    counter->symbol_name = "VMEBusy";
    counter->desc = "The percentage of time in which VME (IME or CRE) was actively processing data.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__vme_pipe__vme_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "VME Pipe");

    assert(metric_set->n_counters <= 10);
}

static void
kblgt2_add_gpu_busyness_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Gpu Rings Busyness";
    metric_set->symbol_name = "GpuBusyness";
    metric_set->hw_config_guid = "6c66fe6e-2988-454a-bfae-7fca3bbcbec2";
    metric_set->counters = calloc(8, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(34, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13805800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05962C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19950016 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19C05800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07800035 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D810400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07960025 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21960000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B964000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B930062 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17948000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B940008 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05950075 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D950000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07E54000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09924000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05982000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09978000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05C08500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25C00000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1BC00000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0BC54000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900C60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x10800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00078000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x00000FFF };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AnyRingBusy";
    counter->symbol_name = "AnyRingBusy";
    counter->desc = "The percentage of time when any command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__gpu_busyness__any_ring_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = kblgt2__gpu_busyness__avg_gpu_core_frequency__read;
    counter->max_uint64 = kblgt2__gpu_busyness__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Blitter Ring Busy";
    counter->symbol_name = "BlitterBusy";
    counter->desc = "The percentage of time when blitter command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__gpu_busyness__blitter_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = kblgt2__gpu_busyness__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = kblgt2__gpu_busyness__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Render Ring Busy";
    counter->symbol_name = "RenderBusy";
    counter->desc = "The percentage of time when render command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__gpu_busyness__render_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Vdbox0 Ring Busy";
    counter->symbol_name = "Vdbox0Busy";
    counter->desc = "The percentage of time when Vdbox0 command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__gpu_busyness__vdbox0_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Vebox Ring Busy";
    counter->symbol_name = "VeboxBusy";
    counter->desc = "The percentage of time when vebox command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt2__gpu_busyness__vebox_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    assert(metric_set->n_counters <= 8);
}

static void
kblgt2_add_test_oa_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "MDAPI testing set Gen9.5";
    metric_set->symbol_name = "TestOa";
    metric_set->hw_config_guid = "baa3c7e4-52b6-4b85-801e-465a94b746dd";
    metric_set->counters = calloc(12, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(13, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(22, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07810013 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B930040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07E54000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000004 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00000003 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000007 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00100002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FFF7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00100002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FFCF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00100082 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FFEF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x001000C2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FFE7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x00100001 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000FFE7 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = kblgt2__test_oa__avg_gpu_core_frequency__read;
    counter->max_uint64 = kblgt2__test_oa__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter0";
    counter->symbol_name = "Counter0";
    counter->desc = "HW test counter 0. Factor: 0.0";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = kblgt2__test_oa__counter0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter1";
    counter->symbol_name = "Counter1";
    counter->desc = "HW test counter 1. Factor: 1.0";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = kblgt2__test_oa__counter1__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter2";
    counter->symbol_name = "Counter2";
    counter->desc = "HW test counter 2. Factor: 1.0";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = kblgt2__test_oa__counter2__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter3";
    counter->symbol_name = "Counter3";
    counter->desc = "HW test counter 3. Factor: 0.5";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = kblgt2__test_oa__counter3__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter4";
    counter->symbol_name = "Counter4";
    counter->desc = "HW test counter 4. Factor: 0.333";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = kblgt2__test_oa__counter4__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter5";
    counter->symbol_name = "Counter5";
    counter->desc = "HW test counter 5. Factor: 0.333";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = kblgt2__test_oa__counter5__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter6";
    counter->symbol_name = "Counter6";
    counter->desc = "HW test counter 6. Factor: 0.166";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = kblgt2__test_oa__counter6__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter7";
    counter->symbol_name = "Counter7";
    counter->desc = "HW test counter 7. Factor: 0.666";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = kblgt2__test_oa__counter7__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter8";
    counter->symbol_name = "Counter8";
    counter->desc = "HW test counter 8. Should be equal to 1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = kblgt2__test_oa__counter8__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = kblgt2__test_oa__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = kblgt2__test_oa__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    assert(metric_set->n_counters <= 12);
}

static void
kblgt2_add_pma__stall_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set PMA Stall";
    metric_set->symbol_name = "PMA_Stall";
    metric_set->hw_config_guid = "b49aa434-4958-4d98-9e6f-443ff27ca74d";
    metric_set->counters = calloc(4, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(24, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(9, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x122D3080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F0800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0FAA00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002D0025 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062D1300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082D16A4 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2D162E };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x102D0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190003F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00E00021 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0007FFF8 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x07000101 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0038FFC7 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = kblgt2__pma__stall__avg_gpu_core_frequency__read;
    counter->max_uint64 = kblgt2__pma__stall__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = kblgt2__pma__stall__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = kblgt2__pma__stall__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "STC PMA stall";
        counter->symbol_name = "StcPMAStall";
        counter->desc = "Percentage of time when stencil cache line and an overlapping pixel are causing stalls";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt2__pma__stall__stc_pma_stall__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Stencil Cache");
    }

    assert(metric_set->n_counters <= 4);
}

static void
kblgt3_add_render_basic_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Render Metrics Basic Gen9";
    metric_set->symbol_name = "RenderBasic";
    metric_set->hw_config_guid = "17b4f3e0-d578-4ae3-b7a8-98d756d1e0df";
    metric_set->counters = calloc(52, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(83, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(5, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x166C01E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12170280 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12370280 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16EC01E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11930317 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x159303DF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F900003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A4E0380 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A6C0053 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1C0001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002F1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042F1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C8400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4C0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F0400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F6600 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x162CA200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00133000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08133000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00170020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08170021 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10170000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0633C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0833C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06370800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08370840 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10370000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1ACE0200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AEC5300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10EC0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1CEC0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A9B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C9C0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CCC0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A8D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x108F0001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16AC8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D933031 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F933E3F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01933D00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0393073C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0593000E };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D930000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19930000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B930000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D900157 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F900158 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190003F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51902240 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900242 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900084 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47901400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57902220 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900C60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900063 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900C63 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53902222 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00222222 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = kblgt3__render_basic__avg_gpu_core_frequency__read;
    counter->max_uint64 = kblgt3__render_basic__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__render_basic__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__render_basic__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__render_basic__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__render_basic__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__render_basic__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__render_basic__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__render_basic__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = kblgt3__render_basic__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = kblgt3__render_basic__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__render_basic__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Depth Throughput";
    counter->symbol_name = "GtiDepthThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between depth caches and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__render_basic__gti_depth_throughput__read;
    counter->max_uint64 = kblgt3__render_basic__gti_depth_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI HDC TLB Lookup Throughput";
    counter->symbol_name = "GtiHdcLookupsThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between GTI and HDC, when HDC is doing TLB lookups.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__render_basic__gti_hdc_lookups_throughput__read;
    counter->max_uint64 = kblgt3__render_basic__gti_hdc_lookups_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI L3 Throughput";
    counter->symbol_name = "GtiL3Throughput";
    counter->desc = "The total number of GPU memory bytes transferred between L3 caches and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__render_basic__gti_l3_throughput__read;
    counter->max_uint64 = kblgt3__render_basic__gti_l3_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI RCC Throughput";
    counter->symbol_name = "GtiRccThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between render color caches and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__render_basic__gti_rcc_throughput__read;
    counter->max_uint64 = kblgt3__render_basic__gti_rcc_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Read Throughput";
    counter->symbol_name = "GtiReadThroughput";
    counter->desc = "The total number of GPU memory bytes read from GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__render_basic__gti_read_throughput__read;
    counter->max_uint64 = kblgt3__render_basic__gti_read_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Fixed Pipe Throughput";
    counter->symbol_name = "GtiVfThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between 3D Pipeline (Command Dispatch, Input Assembly and Stream Output) and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__render_basic__gti_vf_throughput__read;
    counter->max_uint64 = kblgt3__render_basic__gti_vf_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Write Throughput";
    counter->symbol_name = "GtiWriteThroughput";
    counter->desc = "The total number of GPU memory bytes written to GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__render_basic__gti_write_throughput__read;
    counter->max_uint64 = kblgt3__render_basic__gti_write_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__render_basic__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__render_basic__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Lookup Accesses w/o IC";
    counter->symbol_name = "L3Lookups";
    counter->desc = "The total number of L3 cache lookup accesses w/o IC.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__render_basic__l3_lookups__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/TAG");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Misses";
    counter->symbol_name = "L3Misses";
    counter->desc = "The total number of L3 misses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__render_basic__l3_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/TAG");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Sampler Throughput";
    counter->symbol_name = "L3SamplerThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between samplers and L3 caches.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__render_basic__l3_sampler_throughput__read;
    counter->max_uint64 = kblgt3__render_basic__l3_sampler_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__render_basic__l3_shader_throughput__read;
    counter->max_uint64 = kblgt3__render_basic__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__render_basic__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__render_basic__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__render_basic__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__render_basic__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__render_basic__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__render_basic__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__render_basic__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    if (perf->devinfo.subslice_mask & 0x09) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Sampler 0 Bottleneck";
        counter->symbol_name = "Sampler0Bottleneck";
        counter->desc = "The percentage of time in which Sampler 0 has been slowing down the pipe when processing EU requests.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt3__render_basic__sampler0_bottleneck__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x09) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Sampler 0 Busy";
        counter->symbol_name = "Sampler0Busy";
        counter->desc = "The percentage of time in which Sampler 0 has been processing EU requests.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt3__render_basic__sampler0_busy__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x12) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Sampler 1 Bottleneck";
        counter->symbol_name = "Sampler1Bottleneck";
        counter->desc = "The percentage of time in which Sampler 1 has been slowing down the pipe when processing EU requests.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt3__render_basic__sampler1_bottleneck__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x12) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Sampler 1 Busy";
        counter->symbol_name = "Sampler1Busy";
        counter->desc = "The percentage of time in which Sampler 1 has been processing EU requests.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt3__render_basic__sampler1_busy__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samplers Bottleneck";
    counter->symbol_name = "SamplerBottleneck";
    counter->desc = "The percentage of time in which samplers have been slowing down the pipe when processing EU requests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__render_basic__sampler_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Cache Misses";
    counter->symbol_name = "SamplerL1Misses";
    counter->desc = "The total number of sampler cache misses in all LODs in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__render_basic__sampler_l1_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt3__render_basic__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt3__render_basic__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samplers Busy";
    counter->symbol_name = "SamplersBusy";
    counter->desc = "The percentage of time in which samplers have been processing EU requests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__render_basic__samplers_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__render_basic__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__render_basic__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__render_basic__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__render_basic__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__render_basic__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__render_basic__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__render_basic__slm_bytes_read__read;
    counter->max_uint64 = kblgt3__render_basic__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__render_basic__slm_bytes_written__read;
    counter->max_uint64 = kblgt3__render_basic__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__render_basic__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__render_basic__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__render_basic__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__render_basic__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 52);
}

static void
kblgt3_add_compute_basic_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Compute Metrics Basic Gen9";
    metric_set->symbol_name = "ComputeBasic";
    metric_set->hw_config_guid = "a5dc0bc5-d6fa-4f3a-9979-d3248c786042";
    metric_set->counters = calloc(39, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(78, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(5, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x104F00E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x124F1C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C00E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37906800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F900003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A4E0820 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C4E0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064F0900 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084F0032 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4F1891 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4F0E00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E4F003C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004F0D80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x024F003B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x006C0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x086C0100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C6C000C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E6C0B00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x186C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x081B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x101C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1C0024 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x065B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x085B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A5BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C5B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E5B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x005B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x025B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A5C6000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C5C001B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x125C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x145C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4C0208 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F5400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F5500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0155 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x162CFB00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x182C00BE };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19900157 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B900158 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D900105 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F900103 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11900FFF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900821 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900802 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900802 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900422 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53904444 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00000003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00002001 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00778008 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00088078 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00808708 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00222222 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = kblgt3__compute_basic__avg_gpu_core_frequency__read;
    counter->max_uint64 = kblgt3__compute_basic__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__compute_basic__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__compute_basic__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__compute_basic__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__compute_basic__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU AVG IPC Rate";
    counter->symbol_name = "EuAvgIpcRate";
    counter->desc = "The average rate of IPC calculated for 2 FPU pipelines.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NUMBER;
    counter->read_float = kblgt3__compute_basic__eu_avg_ipc_rate__read;
    counter->max_float = kblgt3__compute_basic__eu_avg_ipc_rate__max;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__compute_basic__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Send Pipe Active";
    counter->symbol_name = "EuSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__compute_basic__eu_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__compute_basic__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Thread Occupancy";
    counter->symbol_name = "EuThreadOccupancy";
    counter->desc = "The percentage of time in which hardware threads occupied EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__compute_basic__eu_thread_occupancy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Pipe Active";
    counter->symbol_name = "Fpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__compute_basic__fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active";
    counter->symbol_name = "Fpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__compute_basic__fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__compute_basic__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = kblgt3__compute_basic__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = kblgt3__compute_basic__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__compute_basic__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Read Throughput";
    counter->symbol_name = "GtiReadThroughput";
    counter->desc = "The total number of GPU memory bytes read from GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__compute_basic__gti_read_throughput__read;
    counter->max_uint64 = kblgt3__compute_basic__gti_read_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Write Throughput";
    counter->symbol_name = "GtiWriteThroughput";
    counter->desc = "The total number of GPU memory bytes written to GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__compute_basic__gti_write_throughput__read;
    counter->max_uint64 = kblgt3__compute_basic__gti_write_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__compute_basic__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__compute_basic__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__compute_basic__l3_shader_throughput__read;
    counter->max_uint64 = kblgt3__compute_basic__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__compute_basic__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__compute_basic__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__compute_basic__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt3__compute_basic__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt3__compute_basic__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__compute_basic__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__compute_basic__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__compute_basic__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__compute_basic__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__compute_basic__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__compute_basic__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__compute_basic__slm_bytes_read__read;
    counter->max_uint64 = kblgt3__compute_basic__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__compute_basic__slm_bytes_written__read;
    counter->max_uint64 = kblgt3__compute_basic__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Bytes Read";
    counter->symbol_name = "TypedBytesRead";
    counter->desc = "The total number of typed memory bytes read via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__compute_basic__typed_bytes_read__read;
    counter->max_uint64 = kblgt3__compute_basic__typed_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Bytes Written";
    counter->symbol_name = "TypedBytesWritten";
    counter->desc = "The total number of untyped memory bytes written via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__compute_basic__typed_bytes_written__read;
    counter->max_uint64 = kblgt3__compute_basic__typed_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Untyped Bytes Read";
    counter->symbol_name = "UntypedBytesRead";
    counter->desc = "The total number of typed memory bytes read via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__compute_basic__untyped_bytes_read__read;
    counter->max_uint64 = kblgt3__compute_basic__untyped_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Untyped Writes";
    counter->symbol_name = "UntypedBytesWritten";
    counter->desc = "The total number of untyped memory bytes written via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__compute_basic__untyped_bytes_written__read;
    counter->max_uint64 = kblgt3__compute_basic__untyped_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__compute_basic__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 39);
}

static void
kblgt3_add_render_pipe_profile_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Render Metrics for 3D Pipeline Profile Gen9";
    metric_set->symbol_name = "RenderPipeProfile";
    metric_set->hw_config_guid = "c7c735f3-ce58-45cf-aa04-30b183f1faff";
    metric_set->counters = calloc(43, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(114, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(21, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0E001F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10116800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x178A03E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11824C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11830020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13840020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11850019 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11860007 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01870C40 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17880000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C0040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020E5400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000E0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080F0040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F0040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06104000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06110012 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06131000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01898000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D890100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03898000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09808000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B808000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0380C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8A0075 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D8A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x118A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B8A4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x138A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D81A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15818000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17818000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B820030 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07828000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D824000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F828000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05824000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D830003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0583000C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09830000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03838000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07838000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B840980 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03844D80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11840000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09848000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09850080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03850003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01850000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07860000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F860400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09870032 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01888052 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11880000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09884000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B931001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D930001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19934000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B958000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D950094 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19958000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09E58000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0BE58000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03E5C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0592C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B928000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D924000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F924000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11928000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1392C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09924000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01985000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07988000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09981000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B982000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D982000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F989000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05982000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x23904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x27904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x29908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190C080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900440 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900C21 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900042 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900024 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900841 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900400 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007FFEA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x00007FFC };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x0007AFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000F5FD };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00079FFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000F3FB };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x0007BF7A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000F7E7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x0007FEFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000F7CF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00077FFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000EFDF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x0006FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000CFBF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x0003FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x00005F7F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00025024 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00035034 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00045044 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00055054 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00065064 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = kblgt3__render_pipe_profile__avg_gpu_core_frequency__read;
    counter->max_uint64 = kblgt3__render_pipe_profile__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "BC Bottleneck";
    counter->symbol_name = "BcBottleneck";
    counter->desc = "The percentage of time in which barycentric coordinates calculation pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__render_pipe_profile__bc_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Barycentric Calc");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Clipper Bottleneck";
    counter->symbol_name = "ClBottleneck";
    counter->desc = "The percentage of time in which clipper pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__render_pipe_profile__cl_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Clipper");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CL Stall";
    counter->symbol_name = "ClStall";
    counter->desc = "The percentage of time in which clipper pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__render_pipe_profile__cl_stall__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Clipper");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__render_pipe_profile__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Bottleneck";
    counter->symbol_name = "DsBottleneck";
    counter->desc = "The percentage of time in which domain shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__render_pipe_profile__ds_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Stall";
    counter->symbol_name = "DsStall";
    counter->desc = "The percentage of time in which domain shader pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__render_pipe_profile__ds_stall__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__render_pipe_profile__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Bottleneck";
    counter->symbol_name = "EarlyDepthBottleneck";
    counter->desc = "The percentage of time in which early depth test pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__render_pipe_profile__early_depth_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__render_pipe_profile__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__render_pipe_profile__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__render_pipe_profile__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__render_pipe_profile__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = kblgt3__render_pipe_profile__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = kblgt3__render_pipe_profile__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Bottleneck";
    counter->symbol_name = "GsBottleneck";
    counter->desc = "The percentage of time in which geometry shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__render_pipe_profile__gs_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__render_pipe_profile__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Hi-Depth Bottleneck";
    counter->symbol_name = "HiDepthBottleneck";
    counter->desc = "The percentage of time in which early hierarchical depth test pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__render_pipe_profile__hi_depth_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__render_pipe_profile__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Bottleneck";
    counter->symbol_name = "HsBottleneck";
    counter->desc = "The percentage of time in which hull shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__render_pipe_profile__hs_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Stall";
    counter->symbol_name = "HsStall";
    counter->desc = "The percentage of time in which hull stall pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__render_pipe_profile__hs_stall__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__render_pipe_profile__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__render_pipe_profile__l3_shader_throughput__read;
    counter->max_uint64 = kblgt3__render_pipe_profile__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__render_pipe_profile__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__render_pipe_profile__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__render_pipe_profile__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt3__render_pipe_profile__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt3__render_pipe_profile__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__render_pipe_profile__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__render_pipe_profile__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__render_pipe_profile__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Strip-Fans Bottleneck";
    counter->symbol_name = "SfBottleneck";
    counter->desc = "The percentage of time in which strip-fans pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__render_pipe_profile__sf_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Strip-Fans");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SF Stall";
    counter->symbol_name = "SfStall";
    counter->desc = "The percentage of time in which strip-fans pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__render_pipe_profile__sf_stall__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Strip-Fans");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__render_pipe_profile__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__render_pipe_profile__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__render_pipe_profile__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__render_pipe_profile__slm_bytes_read__read;
    counter->max_uint64 = kblgt3__render_pipe_profile__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__render_pipe_profile__slm_bytes_written__read;
    counter->max_uint64 = kblgt3__render_pipe_profile__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SO Bottleneck";
    counter->symbol_name = "SoBottleneck";
    counter->desc = "The percentage of time in which stream output pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__render_pipe_profile__so_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Stream Output");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SO Stall";
    counter->symbol_name = "SoStall";
    counter->desc = "The percentage of time in which stream-output pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__render_pipe_profile__so_stall__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Stream Output");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VF Bottleneck";
    counter->symbol_name = "VfBottleneck";
    counter->desc = "The percentage of time in which vertex fetch pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__render_pipe_profile__vf_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Input Assembler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Bottleneck";
    counter->symbol_name = "VsBottleneck";
    counter->desc = "The percentage of time in which vertex shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__render_pipe_profile__vs_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__render_pipe_profile__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 43);
}

static void
kblgt3_add_memory_reads_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Memory Reads Distribution Gen9";
    metric_set->symbol_name = "MemoryReads";
    metric_set->hw_config_guid = "96ec2219-040b-428a-856a-6bc03363a057";
    metric_set->counters = calloc(41, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(47, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(32, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11810C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1381001A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37906800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F900064 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03811300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05811B12 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0781001A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B930055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03E58000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05E5C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07E54000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13900150 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21900151 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x23900152 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25900153 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x27900154 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x29900155 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B900156 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D900157 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F90015F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31900105 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15900103 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17900101 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900C60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900C63 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900C63 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900063 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000272C, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002728, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000271C, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002718, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000274C, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002748, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00006667 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000275C, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002758, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002754, .val = 0x00006465 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002750, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007F81A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x0007F82A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x0007F872 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x0007F8BA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x0007F87A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x0007F8EA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x0007F8E2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x0007F8F2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000FE00 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00025024 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00035034 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00045044 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00055054 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00065064 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = kblgt3__memory_reads__avg_gpu_core_frequency__read;
    counter->max_uint64 = kblgt3__memory_reads__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__memory_reads__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__memory_reads__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__memory_reads__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__memory_reads__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__memory_reads__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__memory_reads__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = kblgt3__memory_reads__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = kblgt3__memory_reads__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__memory_reads__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiCmdStreamerMemoryReads";
    counter->symbol_name = "GtiCmdStreamerMemoryReads";
    counter->desc = "The total number of GTI memory reads from Command Streamer.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__memory_reads__gti_cmd_streamer_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Command Streamer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiHizMemoryReads";
    counter->symbol_name = "GtiHizMemoryReads";
    counter->desc = "The total number of GTI memory reads from Hierarchical Depth Cache (Hi-Depth Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__memory_reads__gti_hiz_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank0Reads";
    counter->symbol_name = "GtiL3Bank0Reads";
    counter->desc = "The total number of GTI memory reads from L3 Bank 0 (L3 Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__memory_reads__gti_l3_bank0_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank1Reads";
    counter->symbol_name = "GtiL3Bank1Reads";
    counter->desc = "The total number of GTI memory reads from L3 Bank 1 (L3 Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__memory_reads__gti_l3_bank1_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank2Reads";
    counter->symbol_name = "GtiL3Bank2Reads";
    counter->desc = "The total number of GTI memory reads from L3 Bank 2 (L3 Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__memory_reads__gti_l3_bank2_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank3Reads";
    counter->symbol_name = "GtiL3Bank3Reads";
    counter->desc = "The total number of GTI memory reads from L3 Bank 3 (L3 Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__memory_reads__gti_l3_bank3_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Reads";
    counter->symbol_name = "GtiL3Reads";
    counter->desc = "The total number of GTI memory reads from L3 (L3 Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__memory_reads__gti_l3_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiMemoryReads";
    counter->symbol_name = "GtiMemoryReads";
    counter->desc = "The total number of GTI memory reads.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__memory_reads__gti_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiMscMemoryReads";
    counter->symbol_name = "GtiMscMemoryReads";
    counter->desc = "The total number of GTI memory reads from Multisampling Color Cache (Multisampling Color Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__memory_reads__gti_msc_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRccMemoryReads";
    counter->symbol_name = "GtiRccMemoryReads";
    counter->desc = "The total number of GTI memory reads from Render Color Cache (Render Color Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__memory_reads__gti_rcc_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRczMemoryReads";
    counter->symbol_name = "GtiRczMemoryReads";
    counter->desc = "The total number of GTI memory reads from Render Depth Cache (Render Depth Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__memory_reads__gti_rcz_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRingAccesses";
    counter->symbol_name = "GtiRingAccesses";
    counter->desc = "The total number of all accesses from GTI to the ring.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__memory_reads__gti_ring_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRsMemoryReads";
    counter->symbol_name = "GtiRsMemoryReads";
    counter->desc = "The total number of GTI memory reads from Resource Streamer.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__memory_reads__gti_rs_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Resource Streamer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiStcMemoryReads";
    counter->symbol_name = "GtiStcMemoryReads";
    counter->desc = "The total number of GTI memory reads from Stencil Cache (Stencil Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__memory_reads__gti_stc_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiVfMemoryReads";
    counter->symbol_name = "GtiVfMemoryReads";
    counter->desc = "The total number of GTI memory reads from Vertex Fetch.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__memory_reads__gti_vf_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Vertex Fetch");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__memory_reads__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__memory_reads__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__memory_reads__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__memory_reads__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__memory_reads__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt3__memory_reads__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt3__memory_reads__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__memory_reads__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__memory_reads__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__memory_reads__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__memory_reads__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__memory_reads__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__memory_reads__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__memory_reads__slm_bytes_read__read;
    counter->max_uint64 = kblgt3__memory_reads__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__memory_reads__slm_bytes_written__read;
    counter->max_uint64 = kblgt3__memory_reads__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__memory_reads__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 41);
}

static void
kblgt3_add_memory_writes_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Memory Writes Distribution Gen9";
    metric_set->symbol_name = "MemoryWrites";
    metric_set->hw_config_guid = "03372b64-4996-4d3b-aa18-790e75eeb9c2";
    metric_set->counters = calloc(41, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(47, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(32, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11810C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1381001A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37906800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F901000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03811300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05811B12 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0781001A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B930055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03E58000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05E5C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07E54000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13900160 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21900161 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x23900162 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25900163 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x27900164 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x29900165 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B900166 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D900167 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F900150 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31900105 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15900103 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17900101 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900C60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900C63 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900C63 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900063 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000272C, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002728, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000271C, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002718, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000274C, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002748, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00006667 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000275C, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002758, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002754, .val = 0x00006465 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002750, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007F81A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x0007F82A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x0007F822 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x0007F8BA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x0007F87A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x0007F8EA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x0007F8E2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x0007F8F2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000FE00 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00025024 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00035034 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00045044 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00055054 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00065064 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = kblgt3__memory_writes__avg_gpu_core_frequency__read;
    counter->max_uint64 = kblgt3__memory_writes__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__memory_writes__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__memory_writes__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__memory_writes__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__memory_writes__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__memory_writes__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__memory_writes__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = kblgt3__memory_writes__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = kblgt3__memory_writes__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__memory_writes__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiCmdStreamerMemoryWrites";
    counter->symbol_name = "GtiCmdStreamerMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Command Streamer.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__memory_writes__gti_cmd_streamer_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Command Streamer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiHizMemoryWrites";
    counter->symbol_name = "GtiHizMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Hierarchical Depth Cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__memory_writes__gti_hiz_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank0Writes";
    counter->symbol_name = "GtiL3Bank0Writes";
    counter->desc = "The total number of GTI memory writes from L3 Bank 0 (L3 Bank 0 invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__memory_writes__gti_l3_bank0_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank1Writes";
    counter->symbol_name = "GtiL3Bank1Writes";
    counter->desc = "The total number of GTI memory writes from L3 Bank 1 (L3 Bank 1 invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__memory_writes__gti_l3_bank1_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank2Writes";
    counter->symbol_name = "GtiL3Bank2Writes";
    counter->desc = "The total number of GTI memory writes from L3 Bank 2 (L3 Bank 2 invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__memory_writes__gti_l3_bank2_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank3Writes";
    counter->symbol_name = "GtiL3Bank3Writes";
    counter->desc = "The total number of GTI memory writes from L3 Bank 3 (L3 Bank 3 invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__memory_writes__gti_l3_bank3_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Writes";
    counter->symbol_name = "GtiL3Writes";
    counter->desc = "The total number of GTI memory writes from L3 (L3 invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__memory_writes__gti_l3_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiMemoryWrites";
    counter->symbol_name = "GtiMemoryWrites";
    counter->desc = "The total number of GTI memory writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__memory_writes__gti_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiMscMemoryWrites";
    counter->symbol_name = "GtiMscMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Multisampling Color Cache (Multisampling Color Cache invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__memory_writes__gti_msc_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRccMemoryWrites";
    counter->symbol_name = "GtiRccMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Render Color Cache (Render Color Cache invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__memory_writes__gti_rcc_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRczMemoryWrites";
    counter->symbol_name = "GtiRczMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Render Depth Cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__memory_writes__gti_rcz_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRingAccesses";
    counter->symbol_name = "GtiRingAccesses";
    counter->desc = "The total number of all GTI accesses to the ring.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__memory_writes__gti_ring_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiSoMemoryWrites";
    counter->symbol_name = "GtiSoMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Stream Output.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__memory_writes__gti_so_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Stream Output");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiStcMemoryWrites";
    counter->symbol_name = "GtiStcMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Stencil Cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__memory_writes__gti_stc_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__memory_writes__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__memory_writes__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__memory_writes__l3_shader_throughput__read;
    counter->max_uint64 = kblgt3__memory_writes__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__memory_writes__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__memory_writes__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__memory_writes__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt3__memory_writes__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt3__memory_writes__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__memory_writes__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__memory_writes__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__memory_writes__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__memory_writes__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__memory_writes__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__memory_writes__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__memory_writes__slm_bytes_read__read;
    counter->max_uint64 = kblgt3__memory_writes__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__memory_writes__slm_bytes_written__read;
    counter->max_uint64 = kblgt3__memory_writes__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__memory_writes__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 41);
}

static void
kblgt3_add_compute_extended_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Compute Metrics Extended Gen9";
    metric_set->symbol_name = "ComputeExtended";
    metric_set->hw_config_guid = "31b4ce5a-bd61-4c1f-bb5d-f2e731412150";
    metric_set->counters = calloc(38, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(72, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(21, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C00E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141C8160 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x161C8015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181C0120 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x184E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A4EAAA0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C4E0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x024E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E6C0B01 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x006C0200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x026C000C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001C0041 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x061C4200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x081C4443 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1C4645 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1C7647 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041C7357 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1C0030 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x101C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x121C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4CAA2A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4C02AA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084CA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F5400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F5515 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0155 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x162CAA00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x182C00AA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11907FFF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900802 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900842 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900842 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007FC2A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x0007FC6A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x0007FC92 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x0007FCA2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x0007FC32 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x0007FC9A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x0007FE6A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x0007FE7A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000BF00 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00000003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00002001 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00778008 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00088078 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00808708 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00A08908 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = kblgt3__compute_extended__avg_gpu_core_frequency__read;
    counter->max_uint64 = kblgt3__compute_extended__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__compute_extended__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuA64UntypedReads0";
    counter->symbol_name = "EuA64UntypedReads0";
    counter->desc = "The subslice 0 EU A64 Untyped Reads subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__compute_extended__eu_a64_untyped_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuA64UntypedWrites0";
    counter->symbol_name = "EuA64UntypedWrites0";
    counter->desc = "The subslice 0 EU A64 Untyped Writes subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__compute_extended__eu_a64_untyped_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__compute_extended__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU AVG IPC Rate";
    counter->symbol_name = "EuAvgIpcRate";
    counter->desc = "The average rate of IPC calculated for 2 FPU pipelines.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NUMBER;
    counter->read_float = kblgt3__compute_extended__eu_avg_ipc_rate__read;
    counter->max_float = kblgt3__compute_extended__eu_avg_ipc_rate__max;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__compute_extended__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Send Pipe Active";
    counter->symbol_name = "EuSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__compute_extended__eu_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__compute_extended__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Thread Occupancy";
    counter->symbol_name = "EuThreadOccupancy";
    counter->desc = "The percentage of time in which hardware threads occupied EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__compute_extended__eu_thread_occupancy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuTypedAtomics0";
    counter->symbol_name = "EuTypedAtomics0";
    counter->desc = "The subslice 0 EU Typed Atomics subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__compute_extended__eu_typed_atomics0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuTypedReads0";
    counter->symbol_name = "EuTypedReads0";
    counter->desc = "The subslice 0 EU Typed Reads subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__compute_extended__eu_typed_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuTypedWrites0";
    counter->symbol_name = "EuTypedWrites0";
    counter->desc = "The subslice 0 EU Typed Writes subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__compute_extended__eu_typed_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuUntypedAtomics0";
    counter->symbol_name = "EuUntypedAtomics0";
    counter->desc = "The subslice 0 EU Untyped Atomics subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__compute_extended__eu_untyped_atomics0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuUntypedReads0";
    counter->symbol_name = "EuUntypedReads0";
    counter->desc = "The subslice 0 EU Untyped Reads subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__compute_extended__eu_untyped_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuUntypedWrites0";
    counter->symbol_name = "EuUntypedWrites0";
    counter->desc = "The subslice 0 EU Untyped Writes subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__compute_extended__eu_untyped_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Pipe Active";
    counter->symbol_name = "Fpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__compute_extended__fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active";
    counter->symbol_name = "Fpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__compute_extended__fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = kblgt3__compute_extended__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = kblgt3__compute_extended__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__compute_extended__l3_shader_throughput__read;
    counter->max_uint64 = kblgt3__compute_extended__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt3__compute_extended__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt3__compute_extended__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__compute_extended__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__compute_extended__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__compute_extended__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__compute_extended__slm_bytes_read__read;
    counter->max_uint64 = kblgt3__compute_extended__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__compute_extended__slm_bytes_written__read;
    counter->max_uint64 = kblgt3__compute_extended__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Atomics 0";
    counter->symbol_name = "TypedAtomics0";
    counter->desc = "The subslice 0 typed atomics.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__compute_extended__typed_atomics0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TypedAtomicsPerCacheLine";
    counter->symbol_name = "TypedAtomicsPerCacheLine";
    counter->desc = "The ratio of EU typed atomics requests to L3 cache line writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
    counter->read_float = kblgt3__compute_extended__typed_atomics_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Reads 0";
    counter->symbol_name = "TypedReads0";
    counter->desc = "The subslice 0 typed reads.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__compute_extended__typed_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TypedReadsPerCacheLine";
    counter->symbol_name = "TypedReadsPerCacheLine";
    counter->desc = "The ratio of EU typed read requests to L3 cache line reads.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
    counter->read_float = kblgt3__compute_extended__typed_reads_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Writes 0";
    counter->symbol_name = "TypedWrites0";
    counter->desc = "The subslice 0 typed writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__compute_extended__typed_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TypedWritesPerCacheLine";
    counter->symbol_name = "TypedWritesPerCacheLine";
    counter->desc = "The ratio of EU typed write requests to L3 cache line writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
    counter->read_float = kblgt3__compute_extended__typed_writes_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Untyped Reads 0";
    counter->symbol_name = "UntypedReads0";
    counter->desc = "The subslice 0 untyped reads (including SLM reads).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__compute_extended__untyped_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "UntypedReadsPerCacheLine";
    counter->symbol_name = "UntypedReadsPerCacheLine";
    counter->desc = "The ratio of EU untyped read requests to L3 cache line reads.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
    counter->read_float = kblgt3__compute_extended__untyped_reads_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Untyped Writes 0";
    counter->symbol_name = "UntypedWrites0";
    counter->desc = "The subslice 0 untyped writes (including SLM writes).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__compute_extended__untyped_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "UntypedWritesPerCacheLine";
    counter->symbol_name = "UntypedWritesPerCacheLine";
    counter->desc = "The ratio of EU untyped write requests to L3 cache line writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
    counter->read_float = kblgt3__compute_extended__untyped_writes_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    assert(metric_set->n_counters <= 38);
}

static void
kblgt3_add_compute_l3_cache_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Compute Metrics L3 Cache Gen9";
    metric_set->symbol_name = "ComputeL3Cache";
    metric_set->hw_config_guid = "2ce0911a-27fc-4887-96f0-11084fa807c3";
    metric_set->counters = calloc(54, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(60, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(13, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x166C0760 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1593001E };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F900003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x184E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A4E8020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C4E0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x006C0051 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x066C5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x086C5C5D };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E6C5E5F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x186C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x061B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x081BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x101C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1CE000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1C0030 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C2A00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4C0280 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F0400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F1500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0140 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x162C0A00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x182C00A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03933300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05930032 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11930000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B930000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D900157 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F900158 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190030F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900021 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53904444 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FEFE };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x0007FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FEFD };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x0007FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FBEF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x0007FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FBDF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00000003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00002001 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00101100 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00201200 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00301300 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00401400 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = kblgt3__compute_l3_cache__avg_gpu_core_frequency__read;
    counter->max_uint64 = kblgt3__compute_l3_cache__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__compute_l3_cache__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__compute_l3_cache__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__compute_l3_cache__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__compute_l3_cache__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU AVG IPC Rate";
    counter->symbol_name = "EuAvgIpcRate";
    counter->desc = "The average rate of IPC calculated for 2 FPU pipelines.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NUMBER;
    counter->read_float = kblgt3__compute_l3_cache__eu_avg_ipc_rate__read;
    counter->max_float = kblgt3__compute_l3_cache__eu_avg_ipc_rate__max;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Binary Instruction";
    counter->symbol_name = "EuBinaryFpu0Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing binary instructions on FPU0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__compute_l3_cache__eu_binary_fpu0_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Binary Instruction";
    counter->symbol_name = "EuBinaryFpu1Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing binary instructions on FPU1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__compute_l3_cache__eu_binary_fpu1_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__compute_l3_cache__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Hybrid Instruction";
    counter->symbol_name = "EuHybridFpu0Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing hybrid instructions on FPU0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__compute_l3_cache__eu_hybrid_fpu0_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Hybrid Instruction";
    counter->symbol_name = "EuHybridFpu1Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing hybrid instructions on FPU1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__compute_l3_cache__eu_hybrid_fpu1_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Move Instruction";
    counter->symbol_name = "EuMoveFpu0Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing move instructions on FPU0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__compute_l3_cache__eu_move_fpu0_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Move Instruction";
    counter->symbol_name = "EuMoveFpu1Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing move instructions on FPU1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__compute_l3_cache__eu_move_fpu1_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Send Pipe Active";
    counter->symbol_name = "EuSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__compute_l3_cache__eu_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__compute_l3_cache__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Ternary Instruction";
    counter->symbol_name = "EuTernaryFpu0Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing ternary instructions on FPU0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__compute_l3_cache__eu_ternary_fpu0_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Ternary Instruction";
    counter->symbol_name = "EuTernaryFpu1Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing ternary instructions on FPU1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__compute_l3_cache__eu_ternary_fpu1_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Pipe Active";
    counter->symbol_name = "Fpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__compute_l3_cache__fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active";
    counter->symbol_name = "Fpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__compute_l3_cache__fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__compute_l3_cache__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = kblgt3__compute_l3_cache__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = kblgt3__compute_l3_cache__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__compute_l3_cache__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI L3 Throughput";
    counter->symbol_name = "GtiL3Throughput";
    counter->desc = "The total number of GPU memory bytes transferred between L3 caches and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__compute_l3_cache__gti_l3_throughput__read;
    counter->max_uint64 = kblgt3__compute_l3_cache__gti_l3_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Read Throughput";
    counter->symbol_name = "GtiReadThroughput";
    counter->desc = "The total number of GPU memory bytes read from GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__compute_l3_cache__gti_read_throughput__read;
    counter->max_uint64 = kblgt3__compute_l3_cache__gti_read_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Write Throughput";
    counter->symbol_name = "GtiWriteThroughput";
    counter->desc = "The total number of GPU memory bytes written to GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__compute_l3_cache__gti_write_throughput__read;
    counter->max_uint64 = kblgt3__compute_l3_cache__gti_write_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__compute_l3_cache__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__compute_l3_cache__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Accesses";
    counter->symbol_name = "L3Accesses";
    counter->desc = "The total number of L3 accesses from all entities.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__compute_l3_cache__l3_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3");

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 00 Accesses";
        counter->symbol_name = "L3Bank00Accesses";
        counter->desc = "The total number of accesses to L3 Bank 00.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = kblgt3__compute_l3_cache__l3_bank00_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 00 IC Accesses";
        counter->symbol_name = "L3Bank00IcAccesses";
        counter->desc = "The total number of accesses to L3 Bank 00 from IC cache.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = kblgt3__compute_l3_cache__l3_bank00_ic_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3/IC");
    }

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 00 IC Hits";
        counter->symbol_name = "L3Bank00IcHits";
        counter->desc = "The total number of hits in L3 Bank 00 from IC cache.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = kblgt3__compute_l3_cache__l3_bank00_ic_hits__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3/IC");
    }

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 01 Accesses";
        counter->symbol_name = "L3Bank01Accesses";
        counter->desc = "The total number of accesses to L3 Bank 01.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = kblgt3__compute_l3_cache__l3_bank01_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 02 Accesses";
        counter->symbol_name = "L3Bank02Accesses";
        counter->desc = "The total number of accesses to L3 Bank 02.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = kblgt3__compute_l3_cache__l3_bank02_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 03 Accesses";
        counter->symbol_name = "L3Bank03Accesses";
        counter->desc = "The total number of accesses to L3 Bank 03.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = kblgt3__compute_l3_cache__l3_bank03_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Misses";
    counter->symbol_name = "L3Misses";
    counter->desc = "The total number of L3 misses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__compute_l3_cache__l3_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/TAG");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Sampler Throughput";
    counter->symbol_name = "L3SamplerThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between samplers and L3 caches.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__compute_l3_cache__l3_sampler_throughput__read;
    counter->max_uint64 = kblgt3__compute_l3_cache__l3_sampler_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__compute_l3_cache__l3_shader_throughput__read;
    counter->max_uint64 = kblgt3__compute_l3_cache__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Total Throughput";
    counter->symbol_name = "L3TotalThroughput";
    counter->desc = "The total number of GPU memory bytes transferred via L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__compute_l3_cache__l3_total_throughput__read;
    counter->max_uint64 = kblgt3__compute_l3_cache__l3_total_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__compute_l3_cache__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__compute_l3_cache__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__compute_l3_cache__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Accesses";
    counter->symbol_name = "SamplerAccesses";
    counter->desc = "The total number of messages send to samplers.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__compute_l3_cache__sampler_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt3__compute_l3_cache__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt3__compute_l3_cache__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__compute_l3_cache__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__compute_l3_cache__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__compute_l3_cache__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__compute_l3_cache__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__compute_l3_cache__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__compute_l3_cache__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__compute_l3_cache__slm_bytes_read__read;
    counter->max_uint64 = kblgt3__compute_l3_cache__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__compute_l3_cache__slm_bytes_written__read;
    counter->max_uint64 = kblgt3__compute_l3_cache__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__compute_l3_cache__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 54);
}

static void
kblgt3_add_hdc_and_sf_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set HDCAndSF";
    metric_set->symbol_name = "HDCAndSF";
    metric_set->hw_config_guid = "b128f45f-bfa2-4991-aadc-05be7898e398";
    metric_set->counters = calloc(40, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(55, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(9, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x104F0232 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x124F4640 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C0232 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11834400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004F1880 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x024F08BB };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044F001B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x046C0100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x066C000B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x061B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1C1800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x005B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x025BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x045B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x125C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x145C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x165C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x185C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C00A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F0055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F828000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8305C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09830000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07830000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D950080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13928000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F988000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190FC00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900842 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x10800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FDFF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = kblgt3__hdc_and_sf__avg_gpu_core_frequency__read;
    counter->max_uint64 = kblgt3__hdc_and_sf__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__hdc_and_sf__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__hdc_and_sf__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__hdc_and_sf__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__hdc_and_sf__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__hdc_and_sf__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__hdc_and_sf__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt3__hdc_and_sf__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__hdc_and_sf__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = kblgt3__hdc_and_sf__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = kblgt3__hdc_and_sf__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__hdc_and_sf__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__hdc_and_sf__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__hdc_and_sf__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__hdc_and_sf__l3_shader_throughput__read;
    counter->max_uint64 = kblgt3__hdc_and_sf__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "HDC stalled by L3 (s0.ss0)";
        counter->symbol_name = "NonSamplerShader00AccessStalledOnL3";
        counter->desc = "Percentage of time when HDC has messges to L3, but it's stalled due to lack of credits (s0.ss0)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt3__hdc_and_sf__non_sampler_shader00_access_stalled_on_l3__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Data Port");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "HDC stalled by L3 (s0.ss1)";
        counter->symbol_name = "NonSamplerShader01AccessStalledOnL3";
        counter->desc = "Percentage of time when HDC has messges to L3, but it's stalled due to lack of credits (s0.ss1)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt3__hdc_and_sf__non_sampler_shader01_access_stalled_on_l3__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Data Port");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "HDC stalled by L3 (s0.ss2)";
        counter->symbol_name = "NonSamplerShader02AccessStalledOnL3";
        counter->desc = "Percentage of time when HDC has messges to L3, but it's stalled due to lack of credits (s0.ss2)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt3__hdc_and_sf__non_sampler_shader02_access_stalled_on_l3__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Data Port");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__hdc_and_sf__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Polygon Data Ready";
    counter->symbol_name = "PolyDataReady";
    counter->desc = "The percentage of time in which geometry pipeline output is ready";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__hdc_and_sf__poly_data_ready__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe/Strip-Fans");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__hdc_and_sf__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__hdc_and_sf__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__hdc_and_sf__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__hdc_and_sf__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__hdc_and_sf__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__hdc_and_sf__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt3__hdc_and_sf__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt3__hdc_and_sf__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__hdc_and_sf__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__hdc_and_sf__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__hdc_and_sf__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__hdc_and_sf__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__hdc_and_sf__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__hdc_and_sf__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__hdc_and_sf__slm_bytes_read__read;
    counter->max_uint64 = kblgt3__hdc_and_sf__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__hdc_and_sf__slm_bytes_written__read;
    counter->max_uint64 = kblgt3__hdc_and_sf__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__hdc_and_sf__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__hdc_and_sf__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__hdc_and_sf__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__hdc_and_sf__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 40);
}

static void
kblgt3_add_l3_1_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set L3_1";
    metric_set->symbol_name = "L3_1";
    metric_set->hw_config_guid = "f3566b55-9c13-47bf-8327-4a887af75262";
    metric_set->counters = calloc(40, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(72, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(22, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x126C7B40 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x166C0020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A603444 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A613400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A4EA800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C4E0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x024E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C6C5327 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E6C5425 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x006C2A00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x026C285B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x046C005C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6C0800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1C003C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x121C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x161C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1C0800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x065B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A5C1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10600000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04600000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C610044 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10610000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06610000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4C02A8 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084CA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0154 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F0055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x182C00AA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190FFC0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900420 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900021 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900421 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900040 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00100070 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFF1 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00014002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000C3FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00010002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000C7FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00004002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000D3FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00100700 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FF1F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00001402 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FC3F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x00001002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FC7F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x00000402 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000FD3F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = kblgt3__l3_1__avg_gpu_core_frequency__read;
    counter->max_uint64 = kblgt3__l3_1__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__l3_1__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__l3_1__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__l3_1__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__l3_1__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__l3_1__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__l3_1__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt3__l3_1__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__l3_1__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = kblgt3__l3_1__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = kblgt3__l3_1__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__l3_1__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__l3_1__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__l3_1__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank0 Active";
        counter->symbol_name = "L30Bank0Active";
        counter->desc = "The percentage of time in which slice0 L3 bank0 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt3__l3_1__l30_bank0_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank0 Stalled";
        counter->symbol_name = "L30Bank0Stalled";
        counter->desc = "The percentage of time in which slice0 L3 bank0 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt3__l3_1__l30_bank0_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank1 Active";
        counter->symbol_name = "L30Bank1Active";
        counter->desc = "The percentage of time in which slice0 L3 bank1 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt3__l3_1__l30_bank1_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank1 Stalled";
        counter->symbol_name = "L30Bank1Stalled";
        counter->desc = "The percentage of time in which slice0 L3 bank1 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt3__l3_1__l30_bank1_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__l3_1__l3_shader_throughput__read;
    counter->max_uint64 = kblgt3__l3_1__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__l3_1__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__l3_1__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__l3_1__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__l3_1__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__l3_1__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__l3_1__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__l3_1__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt3__l3_1__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt3__l3_1__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__l3_1__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__l3_1__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__l3_1__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__l3_1__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__l3_1__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__l3_1__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__l3_1__slm_bytes_read__read;
    counter->max_uint64 = kblgt3__l3_1__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__l3_1__slm_bytes_written__read;
    counter->max_uint64 = kblgt3__l3_1__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__l3_1__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__l3_1__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__l3_1__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__l3_1__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 40);
}

static void
kblgt3_add_l3_2_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set L3_2";
    metric_set->symbol_name = "L3_2";
    metric_set->hw_config_guid = "7b21aa68-9076-4ab4-8a84-e45a06c8eac6";
    metric_set->counters = calloc(38, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(45, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(14, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x126C02E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x146C0001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A623400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x026C3324 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x046C3422 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x161C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1C0800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x065B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A5C1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06614000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C620044 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10620000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06620000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F0055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190F800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00100070 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFF1 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00028002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x000087FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00020002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x00008FFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00008002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000A7FF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = kblgt3__l3_2__avg_gpu_core_frequency__read;
    counter->max_uint64 = kblgt3__l3_2__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__l3_2__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__l3_2__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__l3_2__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__l3_2__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__l3_2__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__l3_2__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt3__l3_2__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__l3_2__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = kblgt3__l3_2__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = kblgt3__l3_2__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__l3_2__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__l3_2__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__l3_2__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank2 Active";
        counter->symbol_name = "L30Bank2Active";
        counter->desc = "The percentage of time in which slice0 L3 bank2 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt3__l3_2__l30_bank2_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank2 Stalled";
        counter->symbol_name = "L30Bank2Stalled";
        counter->desc = "The percentage of time in which slice0 L3 bank2 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt3__l3_2__l30_bank2_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__l3_2__l3_shader_throughput__read;
    counter->max_uint64 = kblgt3__l3_2__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__l3_2__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__l3_2__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__l3_2__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__l3_2__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__l3_2__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__l3_2__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__l3_2__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt3__l3_2__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt3__l3_2__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__l3_2__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__l3_2__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__l3_2__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__l3_2__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__l3_2__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__l3_2__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__l3_2__slm_bytes_read__read;
    counter->max_uint64 = kblgt3__l3_2__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__l3_2__slm_bytes_written__read;
    counter->max_uint64 = kblgt3__l3_2__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__l3_2__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__l3_2__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__l3_2__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__l3_2__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 38);
}

static void
kblgt3_add_l3_3_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set L3_3";
    metric_set->symbol_name = "L3_3";
    metric_set->hw_config_guid = "71b4b9dd-ae28-48ce-9a1a-5431e1f23afd";
    metric_set->counters = calloc(38, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(44, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(14, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x126C4E80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x146C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A633400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x026C3321 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x046C342F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6C2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x061B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x161C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1C1800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06604000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C630044 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10630000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06630000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C00AA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F0055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190F800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900842 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00100070 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFF1 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00028002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x000087FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00020002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x00008FFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00008002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000A7FF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = kblgt3__l3_3__avg_gpu_core_frequency__read;
    counter->max_uint64 = kblgt3__l3_3__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__l3_3__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__l3_3__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__l3_3__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__l3_3__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__l3_3__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__l3_3__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt3__l3_3__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__l3_3__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = kblgt3__l3_3__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = kblgt3__l3_3__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__l3_3__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__l3_3__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__l3_3__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank3 Active";
        counter->symbol_name = "L30Bank3Active";
        counter->desc = "The percentage of time in which slice0 L3 bank3 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt3__l3_3__l30_bank3_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank3 Stalled";
        counter->symbol_name = "L30Bank3Stalled";
        counter->desc = "The percentage of time in which slice0 L3 bank3 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt3__l3_3__l30_bank3_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__l3_3__l3_shader_throughput__read;
    counter->max_uint64 = kblgt3__l3_3__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__l3_3__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__l3_3__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__l3_3__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__l3_3__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__l3_3__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__l3_3__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__l3_3__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt3__l3_3__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt3__l3_3__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__l3_3__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__l3_3__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__l3_3__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__l3_3__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__l3_3__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__l3_3__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__l3_3__slm_bytes_read__read;
    counter->max_uint64 = kblgt3__l3_3__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__l3_3__slm_bytes_written__read;
    counter->max_uint64 = kblgt3__l3_3__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__l3_3__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__l3_3__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__l3_3__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__l3_3__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 38);
}

static void
kblgt3_add_rasterizer_and_pixel_backend_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set RasterizerAndPixelBackend";
    metric_set->symbol_name = "RasterizerAndPixelBackend";
    metric_set->hw_config_guid = "52c646ca-52da-4853-877e-8645e73ed330";
    metric_set->counters = calloc(41, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(32, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(10, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x102F3800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x144D0500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x120D03C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x140D03CF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F0004 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4E4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042F0480 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C0090 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064D0027 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004D0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D0D40 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020D803F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040D8023 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100D0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020F0010 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F0050 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190FC00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41901400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43901485 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000EFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00006000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000F3FF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = kblgt3__rasterizer_and_pixel_backend__avg_gpu_core_frequency__read;
    counter->max_uint64 = kblgt3__rasterizer_and_pixel_backend__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__rasterizer_and_pixel_backend__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__rasterizer_and_pixel_backend__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__rasterizer_and_pixel_backend__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__rasterizer_and_pixel_backend__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__rasterizer_and_pixel_backend__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__rasterizer_and_pixel_backend__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt3__rasterizer_and_pixel_backend__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__rasterizer_and_pixel_backend__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = kblgt3__rasterizer_and_pixel_backend__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = kblgt3__rasterizer_and_pixel_backend__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__rasterizer_and_pixel_backend__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__rasterizer_and_pixel_backend__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__rasterizer_and_pixel_backend__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__rasterizer_and_pixel_backend__l3_shader_throughput__read;
    counter->max_uint64 = kblgt3__rasterizer_and_pixel_backend__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 PS Output Available";
        counter->symbol_name = "PSOutput0Available";
        counter->desc = "The percentage of time in which slice0 PS output is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt3__rasterizer_and_pixel_backend__ps_output0_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Post-EarlyZ Pixel Data Ready";
        counter->symbol_name = "PixelData0Ready";
        counter->desc = "The percentage of time in which slice0 post-EarlyZ pixel data is ready (after early Z tests have been applied)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt3__rasterizer_and_pixel_backend__pixel_data0_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Rasterizer/Early Depth Test");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Pixel Values Ready";
        counter->symbol_name = "PixelValues0Ready";
        counter->desc = "The percentage of time in which slice0 pixel values are ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt3__rasterizer_and_pixel_backend__pixel_values0_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__rasterizer_and_pixel_backend__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__rasterizer_and_pixel_backend__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__rasterizer_and_pixel_backend__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__rasterizer_and_pixel_backend__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__rasterizer_and_pixel_backend__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__rasterizer_and_pixel_backend__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__rasterizer_and_pixel_backend__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Rasterizer Input Available";
        counter->symbol_name = "Rasterizer0InputAvailable";
        counter->desc = "The percentage of time in which slice0 rasterizer input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt3__rasterizer_and_pixel_backend__rasterizer0_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Rasterizer");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Rasterizer Output Ready";
        counter->symbol_name = "Rasterizer0OutputReady";
        counter->desc = "The percentage of time in which slice0 rasterizer output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt3__rasterizer_and_pixel_backend__rasterizer0_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Rasterizer");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt3__rasterizer_and_pixel_backend__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt3__rasterizer_and_pixel_backend__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__rasterizer_and_pixel_backend__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__rasterizer_and_pixel_backend__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__rasterizer_and_pixel_backend__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__rasterizer_and_pixel_backend__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__rasterizer_and_pixel_backend__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__rasterizer_and_pixel_backend__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__rasterizer_and_pixel_backend__slm_bytes_read__read;
    counter->max_uint64 = kblgt3__rasterizer_and_pixel_backend__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__rasterizer_and_pixel_backend__slm_bytes_written__read;
    counter->max_uint64 = kblgt3__rasterizer_and_pixel_backend__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__rasterizer_and_pixel_backend__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__rasterizer_and_pixel_backend__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__rasterizer_and_pixel_backend__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__rasterizer_and_pixel_backend__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 41);
}

static void
kblgt3_add_sampler_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set Sampler";
    metric_set->symbol_name = "Sampler";
    metric_set->hw_config_guid = "c4bb682f-677c-4875-990b-005230be87b4";
    metric_set->counters = calloc(42, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(70, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(12, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14152C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16150005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x121600A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14352C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16350005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x123600A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14552C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16550005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x125600A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062F6000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022F2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4C0050 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C0010 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0350 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0FB000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F00DA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x182C0028 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022DC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C138000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E132000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0413C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C140018 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C157000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E150078 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10150000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04162180 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02160000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04174000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0233A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04333000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14348000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16348000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02357870 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10350000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04360043 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02360000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04371000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E538000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00538000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06533000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C540020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12548000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E557000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00557800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10550000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06560043 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02560000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06571000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190FF80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900060 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900842 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900060 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x70800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0000C000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000E7FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00003000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000F9FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000C00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FE7F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = kblgt3__sampler__avg_gpu_core_frequency__read;
    counter->max_uint64 = kblgt3__sampler__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__sampler__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__sampler__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__sampler__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__sampler__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__sampler__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__sampler__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt3__sampler__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__sampler__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = kblgt3__sampler__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = kblgt3__sampler__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__sampler__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__sampler__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__sampler__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__sampler__l3_shader_throughput__read;
    counter->max_uint64 = kblgt3__sampler__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__sampler__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__sampler__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__sampler__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__sampler__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__sampler__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__sampler__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__sampler__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice0 Input Available";
        counter->symbol_name = "Sampler00InputAvailable";
        counter->desc = "The percentage of time in which slice0 subslice0 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt3__sampler__sampler00_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice0 Sampler Output Ready";
        counter->symbol_name = "Sampler00OutputReady";
        counter->desc = "The percentage of time in which slice0 subslice0 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt3__sampler__sampler00_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice1 Input Available";
        counter->symbol_name = "Sampler01InputAvailable";
        counter->desc = "The percentage of time in which slice0 subslice1 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt3__sampler__sampler01_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice1 Sampler Output Ready";
        counter->symbol_name = "Sampler01OutputReady";
        counter->desc = "The percentage of time in which slice0 subslice1 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt3__sampler__sampler01_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice2 Input Available";
        counter->symbol_name = "Sampler02InputAvailable";
        counter->desc = "The percentage of time in which slice0 subslice2 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt3__sampler__sampler02_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice2 Sampler Output Ready";
        counter->symbol_name = "Sampler02OutputReady";
        counter->desc = "The percentage of time in which slice0 subslice2 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt3__sampler__sampler02_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt3__sampler__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt3__sampler__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__sampler__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__sampler__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__sampler__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__sampler__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__sampler__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__sampler__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__sampler__slm_bytes_read__read;
    counter->max_uint64 = kblgt3__sampler__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__sampler__slm_bytes_written__read;
    counter->max_uint64 = kblgt3__sampler__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__sampler__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__sampler__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__sampler__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__sampler__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 42);
}

static void
kblgt3_add_tdl_1_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set TDL_1";
    metric_set->symbol_name = "TDL_1";
    metric_set->hw_config_guid = "ade8521b-5e72-45d4-8c25-d9f0da774899";
    metric_set->counters = calloc(42, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(69, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(18, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12120000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12320000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12520000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022F3000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C0015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F03A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0FF000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F0095 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02108000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0410C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02118000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0411C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02121880 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041219B5 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00120000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02134000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04135000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C308000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E304000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06304000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C318000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E314000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06314000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C321A80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E320033 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06320031 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00320000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C334000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E331000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06331000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E508000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00508000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02504000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E518000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00518000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02514000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E521880 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00521A80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02520033 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E534000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00534000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02531000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190FF80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900062 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900040 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x00007FFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x00009FFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000EFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000F3FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FDFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FE7F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = kblgt3__tdl_1__avg_gpu_core_frequency__read;
    counter->max_uint64 = kblgt3__tdl_1__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__tdl_1__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__tdl_1__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__tdl_1__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__tdl_1__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__tdl_1__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__tdl_1__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt3__tdl_1__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__tdl_1__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = kblgt3__tdl_1__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = kblgt3__tdl_1__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__tdl_1__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__tdl_1__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__tdl_1__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__tdl_1__l3_shader_throughput__read;
    counter->max_uint64 = kblgt3__tdl_1__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "NonPS Thread Ready For Dispatch on Slice0 Subslice0";
        counter->symbol_name = "NonPSThread00ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice0 subslice0 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt3__tdl_1__non_ps_thread00_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "NonPS Thread Ready For Dispatch on Slice0 Subslice1";
        counter->symbol_name = "NonPSThread01ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice0 subslice1 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt3__tdl_1__non_ps_thread01_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "NonPS Thread Ready For Dispatch on Slice0 Subslice2";
        counter->symbol_name = "NonPSThread02ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice0 subslice2 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt3__tdl_1__non_ps_thread02_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice0 Subslice0";
        counter->symbol_name = "PSThread00ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice0 subslice0 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt3__tdl_1__ps_thread00_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice0 Subslice1";
        counter->symbol_name = "PSThread01ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice0 subslice1 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt3__tdl_1__ps_thread01_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice0 Subslice2";
        counter->symbol_name = "PSThread02ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice0 subslice2 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt3__tdl_1__ps_thread02_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__tdl_1__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__tdl_1__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__tdl_1__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__tdl_1__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__tdl_1__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__tdl_1__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__tdl_1__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt3__tdl_1__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt3__tdl_1__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__tdl_1__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__tdl_1__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__tdl_1__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__tdl_1__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__tdl_1__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__tdl_1__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__tdl_1__slm_bytes_read__read;
    counter->max_uint64 = kblgt3__tdl_1__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__tdl_1__slm_bytes_written__read;
    counter->max_uint64 = kblgt3__tdl_1__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__tdl_1__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__tdl_1__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__tdl_1__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__tdl_1__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 42);
}

static void
kblgt3_add_tdl_2_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set TDL_2";
    metric_set->symbol_name = "TDL_2";
    metric_set->hw_config_guid = "9df2815d-4e9e-417f-bde1-3788dc6e1ea1";
    metric_set->counters = calloc(42, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(43, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(6, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12124D60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12322E60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12524D60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022F3000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C0014 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0FE000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F0097 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0410C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0411C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04121FB7 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00120000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04135000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00308000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06304000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00318000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06314000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00321B80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0632003F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00334000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06331000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0250C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0251C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02521FB7 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00520000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02535000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190FC00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900063 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = kblgt3__tdl_2__avg_gpu_core_frequency__read;
    counter->max_uint64 = kblgt3__tdl_2__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__tdl_2__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__tdl_2__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__tdl_2__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__tdl_2__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__tdl_2__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__tdl_2__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt3__tdl_2__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__tdl_2__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = kblgt3__tdl_2__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = kblgt3__tdl_2__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__tdl_2__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__tdl_2__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__tdl_2__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__tdl_2__l3_shader_throughput__read;
    counter->max_uint64 = kblgt3__tdl_2__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__tdl_2__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__tdl_2__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__tdl_2__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__tdl_2__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__tdl_2__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__tdl_2__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__tdl_2__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt3__tdl_2__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = kblgt3__tdl_2__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__tdl_2__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__tdl_2__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = kblgt3__tdl_2__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__tdl_2__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__tdl_2__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = kblgt3__tdl_2__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__tdl_2__slm_bytes_read__read;
    counter->max_uint64 = kblgt3__tdl_2__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = kblgt3__tdl_2__slm_bytes_written__read;
    counter->max_uint64 = kblgt3__tdl_2__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice0 Port 0";
        counter->symbol_name = "ThreadHeader00ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice0 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt3__tdl_2__thread_header00_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice0 Port 1";
        counter->symbol_name = "ThreadHeader00ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice0 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt3__tdl_2__thread_header00_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice1 Port 0";
        counter->symbol_name = "ThreadHeader01ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice1 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt3__tdl_2__thread_header01_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice1 Port 1";
        counter->symbol_name = "ThreadHeader01ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice1 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt3__tdl_2__thread_header01_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice2 Port 0";
        counter->symbol_name = "ThreadHeader02ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice2 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt3__tdl_2__thread_header02_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice2 Port 1";
        counter->symbol_name = "ThreadHeader02ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice2 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt3__tdl_2__thread_header02_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__tdl_2__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__tdl_2__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__tdl_2__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__tdl_2__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 42);
}

static void
kblgt3_add_compute_extra_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Compute Metrics Extra Gen9";
    metric_set->symbol_name = "ComputeExtra";
    metric_set->hw_config_guid = "efc497ac-884e-4ee4-a4a8-15fba22aaf21";
    metric_set->counters = calloc(5, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(69, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x121203E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x123203E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x125203E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x129203E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12B203E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12D203E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x024EC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044EC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064EC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084CA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C0042 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F006D };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06104000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06114000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06120033 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00120000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06131000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04308000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04318000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04321980 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00320000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04334000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04504000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04514000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04520033 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00520000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04531000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00AF8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0ACC0001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x008D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x028DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C8FB000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E8F0001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06AC8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02AD4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02918000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02921980 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00920000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02934000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02B04000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02B14000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02B20033 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00B20000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02B31000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00D08000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00D18000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00D21980 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00D34000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190FC00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900420 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x459000A1 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = kblgt3__compute_extra__avg_gpu_core_frequency__read;
    counter->max_uint64 = kblgt3__compute_extra__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active";
    counter->symbol_name = "Fpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__compute_extra__fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active including Ext Math";
    counter->symbol_name = "Fpu1ActiveAdjusted";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing including Extended Math processing";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__compute_extra__fpu1_active_adjusted__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = kblgt3__compute_extra__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = kblgt3__compute_extra__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    assert(metric_set->n_counters <= 5);
}

static void
kblgt3_add_vme_pipe_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Media Vme Pipe Gen9";
    metric_set->symbol_name = "VMEPipe";
    metric_set->hw_config_guid = "bfd9764d-2c5b-4c16-bfc1-89de3ca10917";
    metric_set->counters = calloc(10, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(73, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(17, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(2, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141A5800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x161A00C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12180240 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14180002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x149A5800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x169A00C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12980240 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14980002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A4E3FC0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002F1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042F3000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C9500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4C002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F0400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F5500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x162CAA00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x182C000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04193000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x081A28C1 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00133000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0613C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0813F000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00172000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06178000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0817A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00180037 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06180940 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08180000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02180000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04183000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04AFC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06AF3000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0ACC4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CCC0015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A8DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C8DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E8F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x108F0015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16ACA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18AC000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06993000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C9A28C1 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x009A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A93F000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C93F000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A97A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C97A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A980977 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08980000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04980000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06983000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x119000FF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900004 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x479008A5 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00100030 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFF9 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FFFC };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FFF3 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00100180 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FFCF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FFCF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FF3F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00008003 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = kblgt3__vme_pipe__avg_gpu_core_frequency__read;
    counter->max_uint64 = kblgt3__vme_pipe__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = kblgt3__vme_pipe__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__vme_pipe__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__vme_pipe__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__vme_pipe__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Thread Occupancy";
    counter->symbol_name = "EuThreadOccupancy";
    counter->desc = "The percentage of time in which hardware threads occupied EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__vme_pipe__eu_thread_occupancy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__vme_pipe__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = kblgt3__vme_pipe__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = kblgt3__vme_pipe__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VME Busy";
    counter->symbol_name = "VMEBusy";
    counter->desc = "The percentage of time in which VME (IME or CRE) was actively processing data.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__vme_pipe__vme_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "VME Pipe");

    assert(metric_set->n_counters <= 10);
}

static void
kblgt3_add_gpu_busyness_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Gpu Rings Busyness";
    metric_set->symbol_name = "GpuBusyness";
    metric_set->hw_config_guid = "b55ecba1-2aa9-422e-89ff-b9e30f03d447";
    metric_set->counters = calloc(9, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(42, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19D05800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13805800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05962C25 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19950016 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19C05800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05D00085 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25D00000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09D54000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07800035 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D810400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21960000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0996C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B964000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B930068 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15948000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B94000C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03957500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D950000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17950000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07E54000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07928000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03988000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09978000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05C08500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25C00000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1BC00000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0BC54000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900463 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x10800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007C000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x000007FF };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AnyRingBusy";
    counter->symbol_name = "AnyRingBusy";
    counter->desc = "The percentage of time when any command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__gpu_busyness__any_ring_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = kblgt3__gpu_busyness__avg_gpu_core_frequency__read;
    counter->max_uint64 = kblgt3__gpu_busyness__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Blitter Ring Busy";
    counter->symbol_name = "BlitterBusy";
    counter->desc = "The percentage of time when blitter command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__gpu_busyness__blitter_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = kblgt3__gpu_busyness__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = kblgt3__gpu_busyness__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Render Ring Busy";
    counter->symbol_name = "RenderBusy";
    counter->desc = "The percentage of time when render command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__gpu_busyness__render_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Vdbox0 Ring Busy";
    counter->symbol_name = "Vdbox0Busy";
    counter->desc = "The percentage of time when Vdbox0 command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__gpu_busyness__vdbox0_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Vdbox1 Ring Busy";
    counter->symbol_name = "Vdbox1Busy";
    counter->desc = "The percentage of time when Vdbox1 command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__gpu_busyness__vdbox1_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Vebox Ring Busy";
    counter->symbol_name = "VeboxBusy";
    counter->desc = "The percentage of time when vebox command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = kblgt3__gpu_busyness__vebox_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    assert(metric_set->n_counters <= 9);
}

static void
kblgt3_add_test_oa_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "MDAPI testing set Gen9";
    metric_set->symbol_name = "TestOa";
    metric_set->hw_config_guid = "f1792f32-6db2-4b50-b4b2-557128f1688d";
    metric_set->counters = calloc(12, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(13, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(22, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07810013 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B930040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07E54000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000004 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00000003 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000007 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00100002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FFF7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00100002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FFCF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00100082 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FFEF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x001000C2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FFE7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x00100001 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000FFE7 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = kblgt3__test_oa__avg_gpu_core_frequency__read;
    counter->max_uint64 = kblgt3__test_oa__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter0";
    counter->symbol_name = "Counter0";
    counter->desc = "HW test counter 0. Factor: 0.0";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = kblgt3__test_oa__counter0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter1";
    counter->symbol_name = "Counter1";
    counter->desc = "HW test counter 1. Factor: 1.0";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = kblgt3__test_oa__counter1__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter2";
    counter->symbol_name = "Counter2";
    counter->desc = "HW test counter 2. Factor: 1.0";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = kblgt3__test_oa__counter2__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter3";
    counter->symbol_name = "Counter3";
    counter->desc = "HW test counter 3. Factor: 0.5";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = kblgt3__test_oa__counter3__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter4";
    counter->symbol_name = "Counter4";
    counter->desc = "HW test counter 4. Factor: 0.333";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = kblgt3__test_oa__counter4__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter5";
    counter->symbol_name = "Counter5";
    counter->desc = "HW test counter 5. Factor: 0.333";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = kblgt3__test_oa__counter5__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter6";
    counter->symbol_name = "Counter6";
    counter->desc = "HW test counter 6. Factor: 0.166";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = kblgt3__test_oa__counter6__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter7";
    counter->symbol_name = "Counter7";
    counter->desc = "HW test counter 7. Factor: 0.666";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = kblgt3__test_oa__counter7__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter8";
    counter->symbol_name = "Counter8";
    counter->desc = "HW test counter 8. Should be equal to 1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = kblgt3__test_oa__counter8__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = kblgt3__test_oa__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = kblgt3__test_oa__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    assert(metric_set->n_counters <= 12);
}

static void
kblgt3_add_pma__stall_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set PMA Stall";
    metric_set->symbol_name = "PMA_Stall";
    metric_set->hw_config_guid = "85bc2e4f-2563-4388-921b-dc0dad879cf3";
    metric_set->counters = calloc(4, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(24, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(9, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x122D3080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F0800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0FAA00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002D0025 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062D1300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082D16A4 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2D162E };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x102D0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190003F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00E00021 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0007FFF8 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x07000101 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0038FFC7 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = kblgt3__pma__stall__avg_gpu_core_frequency__read;
    counter->max_uint64 = kblgt3__pma__stall__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = kblgt3__pma__stall__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = kblgt3__pma__stall__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "STC PMA stall";
        counter->symbol_name = "StcPMAStall";
        counter->desc = "Percentage of time when stencil cache line and an overlapping pixel are causing stalls";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = kblgt3__pma__stall__stc_pma_stall__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Stencil Cache");
    }

    assert(metric_set->n_counters <= 4);
}

static void
cflgt2_add_render_basic_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Render Metrics Basic Gen9";
    metric_set->symbol_name = "RenderBasic";
    metric_set->hw_config_guid = "7fa796a4-0c7a-4201-afc6-cff0b2f528a2";
    metric_set->counters = calloc(52, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(70, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(5, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x166C01E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12170280 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12370280 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11930317 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x159303DF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F900003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A4E0080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A6C0053 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1C0001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002F1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042F1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C8400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F0400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F6600 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x162C2200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00133000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08133000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00170020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08170021 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10170000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0633C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0833C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06370800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08370840 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10370000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D933031 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F933E3F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01933D00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0393073C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0593000E };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D930000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19930000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B930000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D900157 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F900158 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190001F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51904400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900C21 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900061 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57904440 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900004 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53904444 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00222222 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = cflgt2__render_basic__avg_gpu_core_frequency__read;
    counter->max_uint64 = cflgt2__render_basic__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__render_basic__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__render_basic__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__render_basic__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__render_basic__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__render_basic__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__render_basic__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__render_basic__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = cflgt2__render_basic__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = cflgt2__render_basic__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__render_basic__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Depth Throughput";
    counter->symbol_name = "GtiDepthThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between depth caches and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__render_basic__gti_depth_throughput__read;
    counter->max_uint64 = cflgt2__render_basic__gti_depth_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI HDC TLB Lookup Throughput";
    counter->symbol_name = "GtiHdcLookupsThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between GTI and HDC, when HDC is doing TLB lookups.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__render_basic__gti_hdc_lookups_throughput__read;
    counter->max_uint64 = cflgt2__render_basic__gti_hdc_lookups_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI L3 Throughput";
    counter->symbol_name = "GtiL3Throughput";
    counter->desc = "The total number of GPU memory bytes transferred between L3 caches and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__render_basic__gti_l3_throughput__read;
    counter->max_uint64 = cflgt2__render_basic__gti_l3_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI RCC Throughput";
    counter->symbol_name = "GtiRccThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between render color caches and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__render_basic__gti_rcc_throughput__read;
    counter->max_uint64 = cflgt2__render_basic__gti_rcc_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Read Throughput";
    counter->symbol_name = "GtiReadThroughput";
    counter->desc = "The total number of GPU memory bytes read from GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__render_basic__gti_read_throughput__read;
    counter->max_uint64 = cflgt2__render_basic__gti_read_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Fixed Pipe Throughput";
    counter->symbol_name = "GtiVfThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between 3D Pipeline (Command Dispatch, Input Assembly and Stream Output) and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__render_basic__gti_vf_throughput__read;
    counter->max_uint64 = cflgt2__render_basic__gti_vf_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Write Throughput";
    counter->symbol_name = "GtiWriteThroughput";
    counter->desc = "The total number of GPU memory bytes written to GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__render_basic__gti_write_throughput__read;
    counter->max_uint64 = cflgt2__render_basic__gti_write_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__render_basic__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__render_basic__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Lookup Accesses w/o IC";
    counter->symbol_name = "L3Lookups";
    counter->desc = "The total number of L3 cache lookup accesses w/o IC.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__render_basic__l3_lookups__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/TAG");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Misses";
    counter->symbol_name = "L3Misses";
    counter->desc = "The total number of L3 misses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__render_basic__l3_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/TAG");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Sampler Throughput";
    counter->symbol_name = "L3SamplerThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between samplers and L3 caches.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__render_basic__l3_sampler_throughput__read;
    counter->max_uint64 = cflgt2__render_basic__l3_sampler_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__render_basic__l3_shader_throughput__read;
    counter->max_uint64 = cflgt2__render_basic__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__render_basic__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__render_basic__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__render_basic__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__render_basic__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__render_basic__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__render_basic__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__render_basic__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    if (perf->devinfo.subslice_mask & 0x09) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Sampler 0 Bottleneck";
        counter->symbol_name = "Sampler0Bottleneck";
        counter->desc = "The percentage of time in which Sampler 0 has been slowing down the pipe when processing EU requests.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt2__render_basic__sampler0_bottleneck__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x09) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Sampler 0 Busy";
        counter->symbol_name = "Sampler0Busy";
        counter->desc = "The percentage of time in which Sampler 0 has been processing EU requests.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt2__render_basic__sampler0_busy__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x12) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Sampler 1 Bottleneck";
        counter->symbol_name = "Sampler1Bottleneck";
        counter->desc = "The percentage of time in which Sampler 1 has been slowing down the pipe when processing EU requests.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt2__render_basic__sampler1_bottleneck__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x12) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Sampler 1 Busy";
        counter->symbol_name = "Sampler1Busy";
        counter->desc = "The percentage of time in which Sampler 1 has been processing EU requests.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt2__render_basic__sampler1_busy__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samplers Bottleneck";
    counter->symbol_name = "SamplerBottleneck";
    counter->desc = "The percentage of time in which samplers have been slowing down the pipe when processing EU requests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__render_basic__sampler_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Cache Misses";
    counter->symbol_name = "SamplerL1Misses";
    counter->desc = "The total number of sampler cache misses in all LODs in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__render_basic__sampler_l1_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt2__render_basic__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt2__render_basic__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samplers Busy";
    counter->symbol_name = "SamplersBusy";
    counter->desc = "The percentage of time in which samplers have been processing EU requests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__render_basic__samplers_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__render_basic__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__render_basic__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__render_basic__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__render_basic__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__render_basic__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__render_basic__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__render_basic__slm_bytes_read__read;
    counter->max_uint64 = cflgt2__render_basic__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__render_basic__slm_bytes_written__read;
    counter->max_uint64 = cflgt2__render_basic__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__render_basic__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__render_basic__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__render_basic__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__render_basic__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 52);
}

static void
cflgt2_add_compute_basic_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Compute Metrics Basic Gen9";
    metric_set->symbol_name = "ComputeBasic";
    metric_set->hw_config_guid = "a4985100-5f76-4822-8ca7-67908cb26274";
    metric_set->counters = calloc(39, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(78, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(5, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x104F00E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x124F1C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C00E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37906800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F900003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A4E0820 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C4E0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064F0900 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084F0032 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4F1891 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4F0E00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E4F003C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004F0D80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x024F003B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x006C0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x086C0100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C6C000C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E6C0B00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x186C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x081B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x101C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1C0024 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x065B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x085B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A5BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C5B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E5B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x005B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x025B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A5C6000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C5C001B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x125C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x145C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4C0208 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F5400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F5500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0155 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x162CFB00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x182C00BE };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19900157 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B900158 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D900105 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F900103 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11900FFF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900821 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900802 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900802 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900422 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53904444 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00000003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00002001 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00778008 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00088078 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00808708 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00222222 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = cflgt2__compute_basic__avg_gpu_core_frequency__read;
    counter->max_uint64 = cflgt2__compute_basic__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__compute_basic__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__compute_basic__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__compute_basic__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__compute_basic__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU AVG IPC Rate";
    counter->symbol_name = "EuAvgIpcRate";
    counter->desc = "The average rate of IPC calculated for 2 FPU pipelines.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NUMBER;
    counter->read_float = cflgt2__compute_basic__eu_avg_ipc_rate__read;
    counter->max_float = cflgt2__compute_basic__eu_avg_ipc_rate__max;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__compute_basic__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Send Pipe Active";
    counter->symbol_name = "EuSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__compute_basic__eu_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__compute_basic__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Thread Occupancy";
    counter->symbol_name = "EuThreadOccupancy";
    counter->desc = "The percentage of time in which hardware threads occupied EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__compute_basic__eu_thread_occupancy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Pipe Active";
    counter->symbol_name = "Fpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__compute_basic__fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active";
    counter->symbol_name = "Fpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__compute_basic__fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__compute_basic__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = cflgt2__compute_basic__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = cflgt2__compute_basic__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__compute_basic__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Read Throughput";
    counter->symbol_name = "GtiReadThroughput";
    counter->desc = "The total number of GPU memory bytes read from GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__compute_basic__gti_read_throughput__read;
    counter->max_uint64 = cflgt2__compute_basic__gti_read_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Write Throughput";
    counter->symbol_name = "GtiWriteThroughput";
    counter->desc = "The total number of GPU memory bytes written to GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__compute_basic__gti_write_throughput__read;
    counter->max_uint64 = cflgt2__compute_basic__gti_write_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__compute_basic__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__compute_basic__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__compute_basic__l3_shader_throughput__read;
    counter->max_uint64 = cflgt2__compute_basic__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__compute_basic__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__compute_basic__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__compute_basic__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt2__compute_basic__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt2__compute_basic__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__compute_basic__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__compute_basic__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__compute_basic__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__compute_basic__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__compute_basic__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__compute_basic__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__compute_basic__slm_bytes_read__read;
    counter->max_uint64 = cflgt2__compute_basic__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__compute_basic__slm_bytes_written__read;
    counter->max_uint64 = cflgt2__compute_basic__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Bytes Read";
    counter->symbol_name = "TypedBytesRead";
    counter->desc = "The total number of typed memory bytes read via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__compute_basic__typed_bytes_read__read;
    counter->max_uint64 = cflgt2__compute_basic__typed_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Bytes Written";
    counter->symbol_name = "TypedBytesWritten";
    counter->desc = "The total number of untyped memory bytes written via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__compute_basic__typed_bytes_written__read;
    counter->max_uint64 = cflgt2__compute_basic__typed_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Untyped Bytes Read";
    counter->symbol_name = "UntypedBytesRead";
    counter->desc = "The total number of typed memory bytes read via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__compute_basic__untyped_bytes_read__read;
    counter->max_uint64 = cflgt2__compute_basic__untyped_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Untyped Writes";
    counter->symbol_name = "UntypedBytesWritten";
    counter->desc = "The total number of untyped memory bytes written via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__compute_basic__untyped_bytes_written__read;
    counter->max_uint64 = cflgt2__compute_basic__untyped_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__compute_basic__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 39);
}

static void
cflgt2_add_render_pipe_profile_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Render Metrics for 3D Pipeline Profile Gen9";
    metric_set->symbol_name = "RenderPipeProfile";
    metric_set->hw_config_guid = "2221e4d5-ed7b-445e-b2cc-3de1b97f4d42";
    metric_set->counters = calloc(43, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(114, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(21, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0E001F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10116800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x178A03E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11824C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11830020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13840020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11850019 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11860007 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01870C40 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17880000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C0040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020E5400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000E0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080F0040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F0040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06104000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06110012 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06131000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01898000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D890100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03898000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09808000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B808000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0380C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8A0075 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D8A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x118A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B8A4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x138A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D81A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15818000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17818000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B820030 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07828000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D824000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F828000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05824000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D830003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0583000C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09830000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03838000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07838000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B840980 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03844D80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11840000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09848000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09850080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03850003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01850000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07860000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F860400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09870032 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01888052 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11880000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09884000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B931001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D930001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19934000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B958000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D950094 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19958000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09E58000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0BE58000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03E5C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0592C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B928000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D924000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F924000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11928000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1392C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09924000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01985000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07988000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09981000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B982000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D982000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F989000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05982000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x23904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x27904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x29908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190C080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900440 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900C21 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900042 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900024 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900841 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900400 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007FFEA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x00007FFC };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x0007AFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000F5FD };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00079FFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000F3FB };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x0007BF7A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000F7E7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x0007FEFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000F7CF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00077FFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000EFDF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x0006FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000CFBF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x0003FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x00005F7F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00025024 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00035034 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00045044 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00055054 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00065064 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = cflgt2__render_pipe_profile__avg_gpu_core_frequency__read;
    counter->max_uint64 = cflgt2__render_pipe_profile__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "BC Bottleneck";
    counter->symbol_name = "BcBottleneck";
    counter->desc = "The percentage of time in which barycentric coordinates calculation pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__render_pipe_profile__bc_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Barycentric Calc");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Clipper Bottleneck";
    counter->symbol_name = "ClBottleneck";
    counter->desc = "The percentage of time in which clipper pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__render_pipe_profile__cl_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Clipper");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CL Stall";
    counter->symbol_name = "ClStall";
    counter->desc = "The percentage of time in which clipper pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__render_pipe_profile__cl_stall__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Clipper");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__render_pipe_profile__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Bottleneck";
    counter->symbol_name = "DsBottleneck";
    counter->desc = "The percentage of time in which domain shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__render_pipe_profile__ds_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Stall";
    counter->symbol_name = "DsStall";
    counter->desc = "The percentage of time in which domain shader pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__render_pipe_profile__ds_stall__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__render_pipe_profile__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Bottleneck";
    counter->symbol_name = "EarlyDepthBottleneck";
    counter->desc = "The percentage of time in which early depth test pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__render_pipe_profile__early_depth_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__render_pipe_profile__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__render_pipe_profile__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__render_pipe_profile__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__render_pipe_profile__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = cflgt2__render_pipe_profile__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = cflgt2__render_pipe_profile__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Bottleneck";
    counter->symbol_name = "GsBottleneck";
    counter->desc = "The percentage of time in which geometry shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__render_pipe_profile__gs_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__render_pipe_profile__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Hi-Depth Bottleneck";
    counter->symbol_name = "HiDepthBottleneck";
    counter->desc = "The percentage of time in which early hierarchical depth test pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__render_pipe_profile__hi_depth_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__render_pipe_profile__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Bottleneck";
    counter->symbol_name = "HsBottleneck";
    counter->desc = "The percentage of time in which hull shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__render_pipe_profile__hs_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Stall";
    counter->symbol_name = "HsStall";
    counter->desc = "The percentage of time in which hull stall pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__render_pipe_profile__hs_stall__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__render_pipe_profile__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__render_pipe_profile__l3_shader_throughput__read;
    counter->max_uint64 = cflgt2__render_pipe_profile__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__render_pipe_profile__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__render_pipe_profile__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__render_pipe_profile__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt2__render_pipe_profile__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt2__render_pipe_profile__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__render_pipe_profile__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__render_pipe_profile__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__render_pipe_profile__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Strip-Fans Bottleneck";
    counter->symbol_name = "SfBottleneck";
    counter->desc = "The percentage of time in which strip-fans pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__render_pipe_profile__sf_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Strip-Fans");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SF Stall";
    counter->symbol_name = "SfStall";
    counter->desc = "The percentage of time in which strip-fans pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__render_pipe_profile__sf_stall__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Strip-Fans");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__render_pipe_profile__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__render_pipe_profile__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__render_pipe_profile__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__render_pipe_profile__slm_bytes_read__read;
    counter->max_uint64 = cflgt2__render_pipe_profile__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__render_pipe_profile__slm_bytes_written__read;
    counter->max_uint64 = cflgt2__render_pipe_profile__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SO Bottleneck";
    counter->symbol_name = "SoBottleneck";
    counter->desc = "The percentage of time in which stream output pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__render_pipe_profile__so_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Stream Output");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SO Stall";
    counter->symbol_name = "SoStall";
    counter->desc = "The percentage of time in which stream-output pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__render_pipe_profile__so_stall__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Stream Output");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VF Bottleneck";
    counter->symbol_name = "VfBottleneck";
    counter->desc = "The percentage of time in which vertex fetch pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__render_pipe_profile__vf_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Input Assembler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Bottleneck";
    counter->symbol_name = "VsBottleneck";
    counter->desc = "The percentage of time in which vertex shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__render_pipe_profile__vs_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__render_pipe_profile__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 43);
}

static void
cflgt2_add_memory_reads_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Memory Reads Distribution Gen9";
    metric_set->symbol_name = "MemoryReads";
    metric_set->hw_config_guid = "82096a90-e2fa-4f38-ac14-562b2496933a";
    metric_set->counters = calloc(41, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(47, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(32, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11810C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1381001A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37906800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F900064 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03811300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05811B12 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0781001A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B930055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03E58000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05E5C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07E54000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13900150 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21900151 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x23900152 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25900153 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x27900154 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x29900155 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B900156 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D900157 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F90015F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31900105 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15900103 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17900101 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900C60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900C63 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900C63 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900063 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000272C, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002728, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000271C, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002718, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000274C, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002748, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00006667 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000275C, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002758, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002754, .val = 0x00006465 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002750, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007F81A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x0007F82A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x0007F872 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x0007F8BA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x0007F87A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x0007F8EA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x0007F8E2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x0007F8F2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000FE00 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00025024 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00035034 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00045044 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00055054 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00065064 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = cflgt2__memory_reads__avg_gpu_core_frequency__read;
    counter->max_uint64 = cflgt2__memory_reads__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__memory_reads__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__memory_reads__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__memory_reads__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__memory_reads__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__memory_reads__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__memory_reads__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = cflgt2__memory_reads__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = cflgt2__memory_reads__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__memory_reads__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiCmdStreamerMemoryReads";
    counter->symbol_name = "GtiCmdStreamerMemoryReads";
    counter->desc = "The total number of GTI memory reads from Command Streamer.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__memory_reads__gti_cmd_streamer_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Command Streamer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiHizMemoryReads";
    counter->symbol_name = "GtiHizMemoryReads";
    counter->desc = "The total number of GTI memory reads from Hierarchical Depth Cache (Hi-Depth Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__memory_reads__gti_hiz_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank0Reads";
    counter->symbol_name = "GtiL3Bank0Reads";
    counter->desc = "The total number of GTI memory reads from L3 Bank 0 (L3 Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__memory_reads__gti_l3_bank0_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank1Reads";
    counter->symbol_name = "GtiL3Bank1Reads";
    counter->desc = "The total number of GTI memory reads from L3 Bank 1 (L3 Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__memory_reads__gti_l3_bank1_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank2Reads";
    counter->symbol_name = "GtiL3Bank2Reads";
    counter->desc = "The total number of GTI memory reads from L3 Bank 2 (L3 Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__memory_reads__gti_l3_bank2_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank3Reads";
    counter->symbol_name = "GtiL3Bank3Reads";
    counter->desc = "The total number of GTI memory reads from L3 Bank 3 (L3 Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__memory_reads__gti_l3_bank3_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Reads";
    counter->symbol_name = "GtiL3Reads";
    counter->desc = "The total number of GTI memory reads from L3 (L3 Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__memory_reads__gti_l3_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiMemoryReads";
    counter->symbol_name = "GtiMemoryReads";
    counter->desc = "The total number of GTI memory reads.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__memory_reads__gti_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiMscMemoryReads";
    counter->symbol_name = "GtiMscMemoryReads";
    counter->desc = "The total number of GTI memory reads from Multisampling Color Cache (Multisampling Color Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__memory_reads__gti_msc_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRccMemoryReads";
    counter->symbol_name = "GtiRccMemoryReads";
    counter->desc = "The total number of GTI memory reads from Render Color Cache (Render Color Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__memory_reads__gti_rcc_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRczMemoryReads";
    counter->symbol_name = "GtiRczMemoryReads";
    counter->desc = "The total number of GTI memory reads from Render Depth Cache (Render Depth Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__memory_reads__gti_rcz_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRingAccesses";
    counter->symbol_name = "GtiRingAccesses";
    counter->desc = "The total number of all accesses from GTI to the ring.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__memory_reads__gti_ring_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRsMemoryReads";
    counter->symbol_name = "GtiRsMemoryReads";
    counter->desc = "The total number of GTI memory reads from Resource Streamer.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__memory_reads__gti_rs_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Resource Streamer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiStcMemoryReads";
    counter->symbol_name = "GtiStcMemoryReads";
    counter->desc = "The total number of GTI memory reads from Stencil Cache (Stencil Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__memory_reads__gti_stc_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiVfMemoryReads";
    counter->symbol_name = "GtiVfMemoryReads";
    counter->desc = "The total number of GTI memory reads from Vertex Fetch.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__memory_reads__gti_vf_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Vertex Fetch");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__memory_reads__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__memory_reads__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__memory_reads__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__memory_reads__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__memory_reads__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt2__memory_reads__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt2__memory_reads__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__memory_reads__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__memory_reads__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__memory_reads__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__memory_reads__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__memory_reads__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__memory_reads__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__memory_reads__slm_bytes_read__read;
    counter->max_uint64 = cflgt2__memory_reads__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__memory_reads__slm_bytes_written__read;
    counter->max_uint64 = cflgt2__memory_reads__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__memory_reads__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 41);
}

static void
cflgt2_add_memory_writes_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Memory Writes Distribution Gen9";
    metric_set->symbol_name = "MemoryWrites";
    metric_set->hw_config_guid = "9f638880-02e9-4a8d-896a-7670a3bf0d35";
    metric_set->counters = calloc(41, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(47, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(32, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11810C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1381001A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37906800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F901000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03811300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05811B12 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0781001A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B930055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03E58000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05E5C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07E54000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13900160 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21900161 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x23900162 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25900163 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x27900164 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x29900165 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B900166 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D900167 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F900150 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31900105 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15900103 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17900101 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900C60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900C63 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900C63 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900063 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000272C, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002728, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000271C, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002718, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000274C, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002748, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00006667 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000275C, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002758, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002754, .val = 0x00006465 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002750, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007F81A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x0007F82A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x0007F822 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x0007F8BA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x0007F87A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x0007F8EA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x0007F8E2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x0007F8F2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000FE00 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00025024 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00035034 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00045044 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00055054 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00065064 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = cflgt2__memory_writes__avg_gpu_core_frequency__read;
    counter->max_uint64 = cflgt2__memory_writes__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__memory_writes__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__memory_writes__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__memory_writes__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__memory_writes__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__memory_writes__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__memory_writes__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = cflgt2__memory_writes__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = cflgt2__memory_writes__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__memory_writes__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiCmdStreamerMemoryWrites";
    counter->symbol_name = "GtiCmdStreamerMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Command Streamer.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__memory_writes__gti_cmd_streamer_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Command Streamer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiHizMemoryWrites";
    counter->symbol_name = "GtiHizMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Hierarchical Depth Cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__memory_writes__gti_hiz_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank0Writes";
    counter->symbol_name = "GtiL3Bank0Writes";
    counter->desc = "The total number of GTI memory writes from L3 Bank 0 (L3 Bank 0 invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__memory_writes__gti_l3_bank0_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank1Writes";
    counter->symbol_name = "GtiL3Bank1Writes";
    counter->desc = "The total number of GTI memory writes from L3 Bank 1 (L3 Bank 1 invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__memory_writes__gti_l3_bank1_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank2Writes";
    counter->symbol_name = "GtiL3Bank2Writes";
    counter->desc = "The total number of GTI memory writes from L3 Bank 2 (L3 Bank 2 invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__memory_writes__gti_l3_bank2_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank3Writes";
    counter->symbol_name = "GtiL3Bank3Writes";
    counter->desc = "The total number of GTI memory writes from L3 Bank 3 (L3 Bank 3 invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__memory_writes__gti_l3_bank3_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Writes";
    counter->symbol_name = "GtiL3Writes";
    counter->desc = "The total number of GTI memory writes from L3 (L3 invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__memory_writes__gti_l3_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiMemoryWrites";
    counter->symbol_name = "GtiMemoryWrites";
    counter->desc = "The total number of GTI memory writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__memory_writes__gti_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiMscMemoryWrites";
    counter->symbol_name = "GtiMscMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Multisampling Color Cache (Multisampling Color Cache invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__memory_writes__gti_msc_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRccMemoryWrites";
    counter->symbol_name = "GtiRccMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Render Color Cache (Render Color Cache invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__memory_writes__gti_rcc_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRczMemoryWrites";
    counter->symbol_name = "GtiRczMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Render Depth Cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__memory_writes__gti_rcz_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRingAccesses";
    counter->symbol_name = "GtiRingAccesses";
    counter->desc = "The total number of all GTI accesses to the ring.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__memory_writes__gti_ring_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiSoMemoryWrites";
    counter->symbol_name = "GtiSoMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Stream Output.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__memory_writes__gti_so_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Stream Output");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiStcMemoryWrites";
    counter->symbol_name = "GtiStcMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Stencil Cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__memory_writes__gti_stc_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__memory_writes__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__memory_writes__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__memory_writes__l3_shader_throughput__read;
    counter->max_uint64 = cflgt2__memory_writes__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__memory_writes__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__memory_writes__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__memory_writes__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt2__memory_writes__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt2__memory_writes__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__memory_writes__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__memory_writes__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__memory_writes__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__memory_writes__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__memory_writes__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__memory_writes__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__memory_writes__slm_bytes_read__read;
    counter->max_uint64 = cflgt2__memory_writes__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__memory_writes__slm_bytes_written__read;
    counter->max_uint64 = cflgt2__memory_writes__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__memory_writes__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 41);
}

static void
cflgt2_add_compute_extended_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Compute Metrics Extended Gen9";
    metric_set->symbol_name = "ComputeExtended";
    metric_set->hw_config_guid = "8d4ad934-7c16-43d5-845a-51067a4c8e2f";
    metric_set->counters = calloc(38, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(72, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(21, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C00E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141C8160 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x161C8015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181C0120 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x184E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A4EAAA0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C4E0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x024E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E6C0B01 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x006C0200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x026C000C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001C0041 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x061C4200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x081C4443 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1C4645 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1C7647 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041C7357 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1C0030 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x101C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x121C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4CAA2A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4C02AA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084CA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F5400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F5515 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0155 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x162CAA00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x182C00AA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11907FFF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900802 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900842 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900842 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007FC2A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x0007FC6A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x0007FC92 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x0007FCA2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x0007FC32 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x0007FC9A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x0007FE6A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x0007FE7A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000BF00 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00000003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00002001 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00778008 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00088078 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00808708 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00A08908 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = cflgt2__compute_extended__avg_gpu_core_frequency__read;
    counter->max_uint64 = cflgt2__compute_extended__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__compute_extended__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuA64UntypedReads0";
    counter->symbol_name = "EuA64UntypedReads0";
    counter->desc = "The subslice 0 EU A64 Untyped Reads subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__compute_extended__eu_a64_untyped_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuA64UntypedWrites0";
    counter->symbol_name = "EuA64UntypedWrites0";
    counter->desc = "The subslice 0 EU A64 Untyped Writes subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__compute_extended__eu_a64_untyped_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__compute_extended__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU AVG IPC Rate";
    counter->symbol_name = "EuAvgIpcRate";
    counter->desc = "The average rate of IPC calculated for 2 FPU pipelines.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NUMBER;
    counter->read_float = cflgt2__compute_extended__eu_avg_ipc_rate__read;
    counter->max_float = cflgt2__compute_extended__eu_avg_ipc_rate__max;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__compute_extended__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Send Pipe Active";
    counter->symbol_name = "EuSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__compute_extended__eu_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__compute_extended__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Thread Occupancy";
    counter->symbol_name = "EuThreadOccupancy";
    counter->desc = "The percentage of time in which hardware threads occupied EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__compute_extended__eu_thread_occupancy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuTypedAtomics0";
    counter->symbol_name = "EuTypedAtomics0";
    counter->desc = "The subslice 0 EU Typed Atomics subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__compute_extended__eu_typed_atomics0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuTypedReads0";
    counter->symbol_name = "EuTypedReads0";
    counter->desc = "The subslice 0 EU Typed Reads subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__compute_extended__eu_typed_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuTypedWrites0";
    counter->symbol_name = "EuTypedWrites0";
    counter->desc = "The subslice 0 EU Typed Writes subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__compute_extended__eu_typed_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuUntypedAtomics0";
    counter->symbol_name = "EuUntypedAtomics0";
    counter->desc = "The subslice 0 EU Untyped Atomics subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__compute_extended__eu_untyped_atomics0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuUntypedReads0";
    counter->symbol_name = "EuUntypedReads0";
    counter->desc = "The subslice 0 EU Untyped Reads subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__compute_extended__eu_untyped_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuUntypedWrites0";
    counter->symbol_name = "EuUntypedWrites0";
    counter->desc = "The subslice 0 EU Untyped Writes subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__compute_extended__eu_untyped_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Pipe Active";
    counter->symbol_name = "Fpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__compute_extended__fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active";
    counter->symbol_name = "Fpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__compute_extended__fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = cflgt2__compute_extended__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = cflgt2__compute_extended__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__compute_extended__l3_shader_throughput__read;
    counter->max_uint64 = cflgt2__compute_extended__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt2__compute_extended__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt2__compute_extended__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__compute_extended__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__compute_extended__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__compute_extended__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__compute_extended__slm_bytes_read__read;
    counter->max_uint64 = cflgt2__compute_extended__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__compute_extended__slm_bytes_written__read;
    counter->max_uint64 = cflgt2__compute_extended__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Atomics 0";
    counter->symbol_name = "TypedAtomics0";
    counter->desc = "The subslice 0 typed atomics.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__compute_extended__typed_atomics0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TypedAtomicsPerCacheLine";
    counter->symbol_name = "TypedAtomicsPerCacheLine";
    counter->desc = "The ratio of EU typed atomics requests to L3 cache line writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
    counter->read_float = cflgt2__compute_extended__typed_atomics_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Reads 0";
    counter->symbol_name = "TypedReads0";
    counter->desc = "The subslice 0 typed reads.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__compute_extended__typed_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TypedReadsPerCacheLine";
    counter->symbol_name = "TypedReadsPerCacheLine";
    counter->desc = "The ratio of EU typed read requests to L3 cache line reads.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
    counter->read_float = cflgt2__compute_extended__typed_reads_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Writes 0";
    counter->symbol_name = "TypedWrites0";
    counter->desc = "The subslice 0 typed writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__compute_extended__typed_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TypedWritesPerCacheLine";
    counter->symbol_name = "TypedWritesPerCacheLine";
    counter->desc = "The ratio of EU typed write requests to L3 cache line writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
    counter->read_float = cflgt2__compute_extended__typed_writes_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Untyped Reads 0";
    counter->symbol_name = "UntypedReads0";
    counter->desc = "The subslice 0 untyped reads (including SLM reads).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__compute_extended__untyped_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "UntypedReadsPerCacheLine";
    counter->symbol_name = "UntypedReadsPerCacheLine";
    counter->desc = "The ratio of EU untyped read requests to L3 cache line reads.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
    counter->read_float = cflgt2__compute_extended__untyped_reads_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Untyped Writes 0";
    counter->symbol_name = "UntypedWrites0";
    counter->desc = "The subslice 0 untyped writes (including SLM writes).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__compute_extended__untyped_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "UntypedWritesPerCacheLine";
    counter->symbol_name = "UntypedWritesPerCacheLine";
    counter->desc = "The ratio of EU untyped write requests to L3 cache line writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
    counter->read_float = cflgt2__compute_extended__untyped_writes_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    assert(metric_set->n_counters <= 38);
}

static void
cflgt2_add_compute_l3_cache_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Compute Metrics L3 Cache Gen9";
    metric_set->symbol_name = "ComputeL3Cache";
    metric_set->hw_config_guid = "4389cf07-1424-4963-b2d2-64fcec75406d";
    metric_set->counters = calloc(54, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(60, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(13, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x166C0760 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1593001E };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F900003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x184E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A4E8020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C4E0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x006C0051 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x066C5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x086C5C5D };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E6C5E5F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x186C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x061B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x081BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x101C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1CE000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1C0030 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C2A00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4C0280 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F0400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F1500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0140 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x162C0A00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x182C00A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03933300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05930032 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11930000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B930000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D900157 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F900158 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190030F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900021 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53904444 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FEFE };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x0007FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FEFD };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x0007FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FBEF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x0007FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FBDF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00000003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00002001 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00101100 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00201200 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00301300 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00401400 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = cflgt2__compute_l3_cache__avg_gpu_core_frequency__read;
    counter->max_uint64 = cflgt2__compute_l3_cache__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__compute_l3_cache__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__compute_l3_cache__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__compute_l3_cache__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__compute_l3_cache__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU AVG IPC Rate";
    counter->symbol_name = "EuAvgIpcRate";
    counter->desc = "The average rate of IPC calculated for 2 FPU pipelines.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NUMBER;
    counter->read_float = cflgt2__compute_l3_cache__eu_avg_ipc_rate__read;
    counter->max_float = cflgt2__compute_l3_cache__eu_avg_ipc_rate__max;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Binary Instruction";
    counter->symbol_name = "EuBinaryFpu0Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing binary instructions on FPU0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__compute_l3_cache__eu_binary_fpu0_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Binary Instruction";
    counter->symbol_name = "EuBinaryFpu1Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing binary instructions on FPU1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__compute_l3_cache__eu_binary_fpu1_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__compute_l3_cache__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Hybrid Instruction";
    counter->symbol_name = "EuHybridFpu0Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing hybrid instructions on FPU0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__compute_l3_cache__eu_hybrid_fpu0_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Hybrid Instruction";
    counter->symbol_name = "EuHybridFpu1Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing hybrid instructions on FPU1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__compute_l3_cache__eu_hybrid_fpu1_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Move Instruction";
    counter->symbol_name = "EuMoveFpu0Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing move instructions on FPU0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__compute_l3_cache__eu_move_fpu0_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Move Instruction";
    counter->symbol_name = "EuMoveFpu1Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing move instructions on FPU1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__compute_l3_cache__eu_move_fpu1_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Send Pipe Active";
    counter->symbol_name = "EuSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__compute_l3_cache__eu_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__compute_l3_cache__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Ternary Instruction";
    counter->symbol_name = "EuTernaryFpu0Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing ternary instructions on FPU0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__compute_l3_cache__eu_ternary_fpu0_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Ternary Instruction";
    counter->symbol_name = "EuTernaryFpu1Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing ternary instructions on FPU1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__compute_l3_cache__eu_ternary_fpu1_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Pipe Active";
    counter->symbol_name = "Fpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__compute_l3_cache__fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active";
    counter->symbol_name = "Fpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__compute_l3_cache__fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__compute_l3_cache__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = cflgt2__compute_l3_cache__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = cflgt2__compute_l3_cache__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__compute_l3_cache__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI L3 Throughput";
    counter->symbol_name = "GtiL3Throughput";
    counter->desc = "The total number of GPU memory bytes transferred between L3 caches and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__compute_l3_cache__gti_l3_throughput__read;
    counter->max_uint64 = cflgt2__compute_l3_cache__gti_l3_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Read Throughput";
    counter->symbol_name = "GtiReadThroughput";
    counter->desc = "The total number of GPU memory bytes read from GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__compute_l3_cache__gti_read_throughput__read;
    counter->max_uint64 = cflgt2__compute_l3_cache__gti_read_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Write Throughput";
    counter->symbol_name = "GtiWriteThroughput";
    counter->desc = "The total number of GPU memory bytes written to GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__compute_l3_cache__gti_write_throughput__read;
    counter->max_uint64 = cflgt2__compute_l3_cache__gti_write_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__compute_l3_cache__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__compute_l3_cache__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Accesses";
    counter->symbol_name = "L3Accesses";
    counter->desc = "The total number of L3 accesses from all entities.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__compute_l3_cache__l3_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3");

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 00 Accesses";
        counter->symbol_name = "L3Bank00Accesses";
        counter->desc = "The total number of accesses to L3 Bank 00.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = cflgt2__compute_l3_cache__l3_bank00_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 00 IC Accesses";
        counter->symbol_name = "L3Bank00IcAccesses";
        counter->desc = "The total number of accesses to L3 Bank 00 from IC cache.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = cflgt2__compute_l3_cache__l3_bank00_ic_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3/IC");
    }

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 00 IC Hits";
        counter->symbol_name = "L3Bank00IcHits";
        counter->desc = "The total number of hits in L3 Bank 00 from IC cache.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = cflgt2__compute_l3_cache__l3_bank00_ic_hits__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3/IC");
    }

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 01 Accesses";
        counter->symbol_name = "L3Bank01Accesses";
        counter->desc = "The total number of accesses to L3 Bank 01.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = cflgt2__compute_l3_cache__l3_bank01_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 02 Accesses";
        counter->symbol_name = "L3Bank02Accesses";
        counter->desc = "The total number of accesses to L3 Bank 02.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = cflgt2__compute_l3_cache__l3_bank02_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 03 Accesses";
        counter->symbol_name = "L3Bank03Accesses";
        counter->desc = "The total number of accesses to L3 Bank 03.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = cflgt2__compute_l3_cache__l3_bank03_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Misses";
    counter->symbol_name = "L3Misses";
    counter->desc = "The total number of L3 misses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__compute_l3_cache__l3_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/TAG");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Sampler Throughput";
    counter->symbol_name = "L3SamplerThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between samplers and L3 caches.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__compute_l3_cache__l3_sampler_throughput__read;
    counter->max_uint64 = cflgt2__compute_l3_cache__l3_sampler_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__compute_l3_cache__l3_shader_throughput__read;
    counter->max_uint64 = cflgt2__compute_l3_cache__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Total Throughput";
    counter->symbol_name = "L3TotalThroughput";
    counter->desc = "The total number of GPU memory bytes transferred via L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__compute_l3_cache__l3_total_throughput__read;
    counter->max_uint64 = cflgt2__compute_l3_cache__l3_total_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__compute_l3_cache__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__compute_l3_cache__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__compute_l3_cache__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Accesses";
    counter->symbol_name = "SamplerAccesses";
    counter->desc = "The total number of messages send to samplers.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__compute_l3_cache__sampler_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt2__compute_l3_cache__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt2__compute_l3_cache__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__compute_l3_cache__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__compute_l3_cache__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__compute_l3_cache__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__compute_l3_cache__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__compute_l3_cache__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__compute_l3_cache__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__compute_l3_cache__slm_bytes_read__read;
    counter->max_uint64 = cflgt2__compute_l3_cache__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__compute_l3_cache__slm_bytes_written__read;
    counter->max_uint64 = cflgt2__compute_l3_cache__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__compute_l3_cache__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 54);
}

static void
cflgt2_add_hdc_and_sf_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set HDCAndSF";
    metric_set->symbol_name = "HDCAndSF";
    metric_set->hw_config_guid = "ac544b3a-ff78-46ea-9808-ee6fef0978b4";
    metric_set->counters = calloc(40, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(55, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(8, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x104F0232 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x124F4640 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C0232 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11834400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004F1880 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x024F08BB };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044F001B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x046C0100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x066C000B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x061B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1C1800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x005B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x025BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x045B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x125C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x145C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x165C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x185C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C00A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F0055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F828000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8305C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09830000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07830000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D950080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13928000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F988000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190FC00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900842 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x10800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FDFF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = cflgt2__hdc_and_sf__avg_gpu_core_frequency__read;
    counter->max_uint64 = cflgt2__hdc_and_sf__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__hdc_and_sf__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__hdc_and_sf__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__hdc_and_sf__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__hdc_and_sf__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__hdc_and_sf__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__hdc_and_sf__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt2__hdc_and_sf__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__hdc_and_sf__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = cflgt2__hdc_and_sf__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = cflgt2__hdc_and_sf__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__hdc_and_sf__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__hdc_and_sf__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__hdc_and_sf__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__hdc_and_sf__l3_shader_throughput__read;
    counter->max_uint64 = cflgt2__hdc_and_sf__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "HDC stalled by L3 (s0.ss0)";
        counter->symbol_name = "NonSamplerShader00AccessStalledOnL3";
        counter->desc = "Percentage of time when HDC has messges to L3, but it's stalled due to lack of credits (s0.ss0)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt2__hdc_and_sf__non_sampler_shader00_access_stalled_on_l3__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Data Port");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "HDC stalled by L3 (s0.ss1)";
        counter->symbol_name = "NonSamplerShader01AccessStalledOnL3";
        counter->desc = "Percentage of time when HDC has messges to L3, but it's stalled due to lack of credits (s0.ss1)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt2__hdc_and_sf__non_sampler_shader01_access_stalled_on_l3__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Data Port");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "HDC stalled by L3 (s0.ss2)";
        counter->symbol_name = "NonSamplerShader02AccessStalledOnL3";
        counter->desc = "Percentage of time when HDC has messges to L3, but it's stalled due to lack of credits (s0.ss2)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt2__hdc_and_sf__non_sampler_shader02_access_stalled_on_l3__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Data Port");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__hdc_and_sf__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Polygon Data Ready";
    counter->symbol_name = "PolyDataReady";
    counter->desc = "The percentage of time in which geometry pipeline output is ready";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__hdc_and_sf__poly_data_ready__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe/Strip-Fans");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__hdc_and_sf__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__hdc_and_sf__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__hdc_and_sf__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__hdc_and_sf__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__hdc_and_sf__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__hdc_and_sf__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt2__hdc_and_sf__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt2__hdc_and_sf__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__hdc_and_sf__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__hdc_and_sf__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__hdc_and_sf__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__hdc_and_sf__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__hdc_and_sf__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__hdc_and_sf__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__hdc_and_sf__slm_bytes_read__read;
    counter->max_uint64 = cflgt2__hdc_and_sf__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__hdc_and_sf__slm_bytes_written__read;
    counter->max_uint64 = cflgt2__hdc_and_sf__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__hdc_and_sf__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__hdc_and_sf__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__hdc_and_sf__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__hdc_and_sf__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 40);
}

static void
cflgt2_add_l3_1_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set L3_1";
    metric_set->symbol_name = "L3_1";
    metric_set->hw_config_guid = "a35c5867-0ab8-4d45-8fc1-eb0906f0eff5";
    metric_set->counters = calloc(40, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(72, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(22, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x126C7B40 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x166C0020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A603444 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A613400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A4EA800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C4E0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x024E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C6C5327 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E6C5425 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x006C2A00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x026C285B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x046C005C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6C0800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1C003C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x121C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x161C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1C0800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x065B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A5C1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10600000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04600000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C610044 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10610000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06610000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4C02A8 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084CA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0154 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F0055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x182C00AA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190FFC0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900420 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900021 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900421 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900040 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00100070 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFF1 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00014002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000C3FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00010002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000C7FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00004002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000D3FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00100700 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FF1F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00001402 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FC3F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x00001002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FC7F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x00000402 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000FD3F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = cflgt2__l3_1__avg_gpu_core_frequency__read;
    counter->max_uint64 = cflgt2__l3_1__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__l3_1__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__l3_1__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__l3_1__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__l3_1__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__l3_1__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__l3_1__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt2__l3_1__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__l3_1__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = cflgt2__l3_1__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = cflgt2__l3_1__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__l3_1__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__l3_1__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__l3_1__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank0 Active";
        counter->symbol_name = "L30Bank0Active";
        counter->desc = "The percentage of time in which slice0 L3 bank0 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt2__l3_1__l30_bank0_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank0 Stalled";
        counter->symbol_name = "L30Bank0Stalled";
        counter->desc = "The percentage of time in which slice0 L3 bank0 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt2__l3_1__l30_bank0_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank1 Active";
        counter->symbol_name = "L30Bank1Active";
        counter->desc = "The percentage of time in which slice0 L3 bank1 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt2__l3_1__l30_bank1_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank1 Stalled";
        counter->symbol_name = "L30Bank1Stalled";
        counter->desc = "The percentage of time in which slice0 L3 bank1 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt2__l3_1__l30_bank1_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__l3_1__l3_shader_throughput__read;
    counter->max_uint64 = cflgt2__l3_1__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__l3_1__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__l3_1__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__l3_1__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__l3_1__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__l3_1__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__l3_1__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__l3_1__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt2__l3_1__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt2__l3_1__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__l3_1__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__l3_1__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__l3_1__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__l3_1__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__l3_1__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__l3_1__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__l3_1__slm_bytes_read__read;
    counter->max_uint64 = cflgt2__l3_1__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__l3_1__slm_bytes_written__read;
    counter->max_uint64 = cflgt2__l3_1__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__l3_1__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__l3_1__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__l3_1__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__l3_1__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 40);
}

static void
cflgt2_add_l3_2_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set L3_2";
    metric_set->symbol_name = "L3_2";
    metric_set->hw_config_guid = "bb4bcce9-2cbb-4818-9e49-67ce2c99cd25";
    metric_set->counters = calloc(38, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(45, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(14, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x126C02E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x146C0001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A623400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x026C3324 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x046C3422 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x161C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1C0800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x065B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A5C1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06614000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C620044 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10620000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06620000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F0055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190F800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00100070 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFF1 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00028002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x000087FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00020002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x00008FFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00008002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000A7FF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = cflgt2__l3_2__avg_gpu_core_frequency__read;
    counter->max_uint64 = cflgt2__l3_2__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__l3_2__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__l3_2__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__l3_2__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__l3_2__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__l3_2__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__l3_2__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt2__l3_2__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__l3_2__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = cflgt2__l3_2__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = cflgt2__l3_2__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__l3_2__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__l3_2__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__l3_2__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank2 Active";
        counter->symbol_name = "L30Bank2Active";
        counter->desc = "The percentage of time in which slice0 L3 bank2 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt2__l3_2__l30_bank2_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank2 Stalled";
        counter->symbol_name = "L30Bank2Stalled";
        counter->desc = "The percentage of time in which slice0 L3 bank2 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt2__l3_2__l30_bank2_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__l3_2__l3_shader_throughput__read;
    counter->max_uint64 = cflgt2__l3_2__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__l3_2__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__l3_2__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__l3_2__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__l3_2__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__l3_2__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__l3_2__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__l3_2__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt2__l3_2__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt2__l3_2__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__l3_2__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__l3_2__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__l3_2__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__l3_2__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__l3_2__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__l3_2__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__l3_2__slm_bytes_read__read;
    counter->max_uint64 = cflgt2__l3_2__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__l3_2__slm_bytes_written__read;
    counter->max_uint64 = cflgt2__l3_2__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__l3_2__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__l3_2__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__l3_2__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__l3_2__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 38);
}

static void
cflgt2_add_l3_3_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set L3_3";
    metric_set->symbol_name = "L3_3";
    metric_set->hw_config_guid = "9e1229f8-d87f-4f44-b067-3544e17195aa";
    metric_set->counters = calloc(38, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(44, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(14, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x126C4E80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x146C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A633400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x026C3321 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x046C342F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6C2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x061B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x161C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1C1800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06604000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C630044 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10630000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06630000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C00AA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F0055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190F800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900842 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00100070 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFF1 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00028002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x000087FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00020002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x00008FFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00008002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000A7FF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = cflgt2__l3_3__avg_gpu_core_frequency__read;
    counter->max_uint64 = cflgt2__l3_3__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__l3_3__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__l3_3__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__l3_3__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__l3_3__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__l3_3__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__l3_3__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt2__l3_3__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__l3_3__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = cflgt2__l3_3__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = cflgt2__l3_3__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__l3_3__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__l3_3__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__l3_3__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank3 Active";
        counter->symbol_name = "L30Bank3Active";
        counter->desc = "The percentage of time in which slice0 L3 bank3 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt2__l3_3__l30_bank3_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank3 Stalled";
        counter->symbol_name = "L30Bank3Stalled";
        counter->desc = "The percentage of time in which slice0 L3 bank3 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt2__l3_3__l30_bank3_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__l3_3__l3_shader_throughput__read;
    counter->max_uint64 = cflgt2__l3_3__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__l3_3__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__l3_3__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__l3_3__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__l3_3__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__l3_3__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__l3_3__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__l3_3__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt2__l3_3__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt2__l3_3__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__l3_3__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__l3_3__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__l3_3__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__l3_3__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__l3_3__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__l3_3__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__l3_3__slm_bytes_read__read;
    counter->max_uint64 = cflgt2__l3_3__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__l3_3__slm_bytes_written__read;
    counter->max_uint64 = cflgt2__l3_3__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__l3_3__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__l3_3__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__l3_3__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__l3_3__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 38);
}

static void
cflgt2_add_rasterizer_and_pixel_backend_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set RasterizerAndPixelBackend";
    metric_set->symbol_name = "RasterizerAndPixelBackend";
    metric_set->hw_config_guid = "3e91908a-1c70-4004-b2ab-a10ef14f24f9";
    metric_set->counters = calloc(41, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(32, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(10, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x102F3800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x144D0500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x120D03C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x140D03CF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F0004 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4E4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042F0480 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C0090 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064D0027 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004D0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D0D40 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020D803F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040D8023 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100D0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020F0010 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F0050 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190FC00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41901400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43901485 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000EFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00006000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000F3FF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = cflgt2__rasterizer_and_pixel_backend__avg_gpu_core_frequency__read;
    counter->max_uint64 = cflgt2__rasterizer_and_pixel_backend__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__rasterizer_and_pixel_backend__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__rasterizer_and_pixel_backend__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__rasterizer_and_pixel_backend__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__rasterizer_and_pixel_backend__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__rasterizer_and_pixel_backend__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__rasterizer_and_pixel_backend__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt2__rasterizer_and_pixel_backend__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__rasterizer_and_pixel_backend__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = cflgt2__rasterizer_and_pixel_backend__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = cflgt2__rasterizer_and_pixel_backend__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__rasterizer_and_pixel_backend__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__rasterizer_and_pixel_backend__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__rasterizer_and_pixel_backend__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__rasterizer_and_pixel_backend__l3_shader_throughput__read;
    counter->max_uint64 = cflgt2__rasterizer_and_pixel_backend__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 PS Output Available";
        counter->symbol_name = "PSOutput0Available";
        counter->desc = "The percentage of time in which slice0 PS output is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt2__rasterizer_and_pixel_backend__ps_output0_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Post-EarlyZ Pixel Data Ready";
        counter->symbol_name = "PixelData0Ready";
        counter->desc = "The percentage of time in which slice0 post-EarlyZ pixel data is ready (after early Z tests have been applied)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt2__rasterizer_and_pixel_backend__pixel_data0_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Rasterizer/Early Depth Test");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Pixel Values Ready";
        counter->symbol_name = "PixelValues0Ready";
        counter->desc = "The percentage of time in which slice0 pixel values are ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt2__rasterizer_and_pixel_backend__pixel_values0_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__rasterizer_and_pixel_backend__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__rasterizer_and_pixel_backend__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__rasterizer_and_pixel_backend__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__rasterizer_and_pixel_backend__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__rasterizer_and_pixel_backend__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__rasterizer_and_pixel_backend__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__rasterizer_and_pixel_backend__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Rasterizer Input Available";
        counter->symbol_name = "Rasterizer0InputAvailable";
        counter->desc = "The percentage of time in which slice0 rasterizer input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt2__rasterizer_and_pixel_backend__rasterizer0_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Rasterizer");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Rasterizer Output Ready";
        counter->symbol_name = "Rasterizer0OutputReady";
        counter->desc = "The percentage of time in which slice0 rasterizer output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt2__rasterizer_and_pixel_backend__rasterizer0_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Rasterizer");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt2__rasterizer_and_pixel_backend__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt2__rasterizer_and_pixel_backend__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__rasterizer_and_pixel_backend__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__rasterizer_and_pixel_backend__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__rasterizer_and_pixel_backend__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__rasterizer_and_pixel_backend__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__rasterizer_and_pixel_backend__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__rasterizer_and_pixel_backend__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__rasterizer_and_pixel_backend__slm_bytes_read__read;
    counter->max_uint64 = cflgt2__rasterizer_and_pixel_backend__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__rasterizer_and_pixel_backend__slm_bytes_written__read;
    counter->max_uint64 = cflgt2__rasterizer_and_pixel_backend__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__rasterizer_and_pixel_backend__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__rasterizer_and_pixel_backend__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__rasterizer_and_pixel_backend__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__rasterizer_and_pixel_backend__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 41);
}

static void
cflgt2_add_sampler_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set Sampler";
    metric_set->symbol_name = "Sampler";
    metric_set->hw_config_guid = "9a6ba957-7955-4a09-a8ce-083030ba3c1f";
    metric_set->counters = calloc(42, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(70, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(12, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14152C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16150005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x121600A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14352C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16350005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x123600A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14552C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16550005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x125600A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062F6000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022F2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4C0050 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C0010 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0350 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0FB000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F00DA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x182C0028 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022DC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C138000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E132000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0413C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C140018 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C157000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E150078 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10150000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04162180 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02160000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04174000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0233A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04333000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14348000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16348000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02357870 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10350000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04360043 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02360000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04371000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E538000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00538000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06533000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C540020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12548000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E557000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00557800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10550000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06560043 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02560000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06571000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190FF80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900060 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900842 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900060 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x70800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0000C000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000E7FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00003000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000F9FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000C00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FE7F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = cflgt2__sampler__avg_gpu_core_frequency__read;
    counter->max_uint64 = cflgt2__sampler__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__sampler__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__sampler__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__sampler__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__sampler__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__sampler__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__sampler__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt2__sampler__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__sampler__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = cflgt2__sampler__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = cflgt2__sampler__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__sampler__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__sampler__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__sampler__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__sampler__l3_shader_throughput__read;
    counter->max_uint64 = cflgt2__sampler__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__sampler__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__sampler__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__sampler__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__sampler__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__sampler__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__sampler__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__sampler__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice0 Input Available";
        counter->symbol_name = "Sampler00InputAvailable";
        counter->desc = "The percentage of time in which slice0 subslice0 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt2__sampler__sampler00_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice0 Sampler Output Ready";
        counter->symbol_name = "Sampler00OutputReady";
        counter->desc = "The percentage of time in which slice0 subslice0 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt2__sampler__sampler00_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice1 Input Available";
        counter->symbol_name = "Sampler01InputAvailable";
        counter->desc = "The percentage of time in which slice0 subslice1 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt2__sampler__sampler01_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice1 Sampler Output Ready";
        counter->symbol_name = "Sampler01OutputReady";
        counter->desc = "The percentage of time in which slice0 subslice1 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt2__sampler__sampler01_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice2 Input Available";
        counter->symbol_name = "Sampler02InputAvailable";
        counter->desc = "The percentage of time in which slice0 subslice2 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt2__sampler__sampler02_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice2 Sampler Output Ready";
        counter->symbol_name = "Sampler02OutputReady";
        counter->desc = "The percentage of time in which slice0 subslice2 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt2__sampler__sampler02_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt2__sampler__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt2__sampler__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__sampler__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__sampler__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__sampler__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__sampler__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__sampler__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__sampler__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__sampler__slm_bytes_read__read;
    counter->max_uint64 = cflgt2__sampler__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__sampler__slm_bytes_written__read;
    counter->max_uint64 = cflgt2__sampler__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__sampler__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__sampler__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__sampler__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__sampler__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 42);
}

static void
cflgt2_add_tdl_1_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set TDL_1";
    metric_set->symbol_name = "TDL_1";
    metric_set->hw_config_guid = "c54e7ca3-c60c-4396-ac3d-f9899c9a6ee4";
    metric_set->counters = calloc(42, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(69, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(18, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12120000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12320000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12520000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022F3000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C0015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F03A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0FF000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F0095 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02108000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0410C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02118000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0411C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02121880 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041219B5 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00120000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02134000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04135000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C308000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E304000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06304000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C318000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E314000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06314000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C321A80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E320033 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06320031 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00320000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C334000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E331000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06331000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E508000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00508000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02504000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E518000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00518000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02514000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E521880 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00521A80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02520033 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E534000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00534000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02531000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190FF80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900062 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900040 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x00007FFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x00009FFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000EFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000F3FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FDFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FE7F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = cflgt2__tdl_1__avg_gpu_core_frequency__read;
    counter->max_uint64 = cflgt2__tdl_1__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__tdl_1__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__tdl_1__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__tdl_1__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__tdl_1__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__tdl_1__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__tdl_1__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt2__tdl_1__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__tdl_1__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = cflgt2__tdl_1__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = cflgt2__tdl_1__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__tdl_1__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__tdl_1__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__tdl_1__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__tdl_1__l3_shader_throughput__read;
    counter->max_uint64 = cflgt2__tdl_1__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "NonPS Thread Ready For Dispatch on Slice0 Subslice0";
        counter->symbol_name = "NonPSThread00ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice0 subslice0 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt2__tdl_1__non_ps_thread00_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "NonPS Thread Ready For Dispatch on Slice0 Subslice1";
        counter->symbol_name = "NonPSThread01ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice0 subslice1 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt2__tdl_1__non_ps_thread01_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "NonPS Thread Ready For Dispatch on Slice0 Subslice2";
        counter->symbol_name = "NonPSThread02ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice0 subslice2 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt2__tdl_1__non_ps_thread02_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice0 Subslice0";
        counter->symbol_name = "PSThread00ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice0 subslice0 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt2__tdl_1__ps_thread00_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice0 Subslice1";
        counter->symbol_name = "PSThread01ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice0 subslice1 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt2__tdl_1__ps_thread01_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice0 Subslice2";
        counter->symbol_name = "PSThread02ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice0 subslice2 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt2__tdl_1__ps_thread02_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__tdl_1__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__tdl_1__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__tdl_1__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__tdl_1__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__tdl_1__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__tdl_1__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__tdl_1__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt2__tdl_1__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt2__tdl_1__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__tdl_1__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__tdl_1__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__tdl_1__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__tdl_1__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__tdl_1__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__tdl_1__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__tdl_1__slm_bytes_read__read;
    counter->max_uint64 = cflgt2__tdl_1__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__tdl_1__slm_bytes_written__read;
    counter->max_uint64 = cflgt2__tdl_1__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__tdl_1__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__tdl_1__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__tdl_1__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__tdl_1__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 42);
}

static void
cflgt2_add_tdl_2_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set TDL_2";
    metric_set->symbol_name = "TDL_2";
    metric_set->hw_config_guid = "e438cd5d-1da7-46c6-9823-4780f370d11d";
    metric_set->counters = calloc(42, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(43, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(6, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12124D60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12322E60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12524D60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022F3000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C0014 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0FE000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F0097 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0410C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0411C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04121FB7 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00120000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04135000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00308000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06304000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00318000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06314000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00321B80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0632003F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00334000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06331000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0250C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0251C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02521FB7 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00520000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02535000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190FC00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900063 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = cflgt2__tdl_2__avg_gpu_core_frequency__read;
    counter->max_uint64 = cflgt2__tdl_2__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__tdl_2__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__tdl_2__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__tdl_2__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__tdl_2__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__tdl_2__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__tdl_2__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt2__tdl_2__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__tdl_2__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = cflgt2__tdl_2__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = cflgt2__tdl_2__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__tdl_2__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__tdl_2__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__tdl_2__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__tdl_2__l3_shader_throughput__read;
    counter->max_uint64 = cflgt2__tdl_2__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__tdl_2__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__tdl_2__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__tdl_2__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__tdl_2__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__tdl_2__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__tdl_2__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__tdl_2__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt2__tdl_2__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt2__tdl_2__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__tdl_2__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__tdl_2__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt2__tdl_2__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__tdl_2__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__tdl_2__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt2__tdl_2__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__tdl_2__slm_bytes_read__read;
    counter->max_uint64 = cflgt2__tdl_2__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt2__tdl_2__slm_bytes_written__read;
    counter->max_uint64 = cflgt2__tdl_2__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice0 Port 0";
        counter->symbol_name = "ThreadHeader00ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice0 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt2__tdl_2__thread_header00_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice0 Port 1";
        counter->symbol_name = "ThreadHeader00ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice0 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt2__tdl_2__thread_header00_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice1 Port 0";
        counter->symbol_name = "ThreadHeader01ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice1 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt2__tdl_2__thread_header01_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice1 Port 1";
        counter->symbol_name = "ThreadHeader01ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice1 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt2__tdl_2__thread_header01_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice2 Port 0";
        counter->symbol_name = "ThreadHeader02ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice2 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt2__tdl_2__thread_header02_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice2 Port 1";
        counter->symbol_name = "ThreadHeader02ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice2 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt2__tdl_2__thread_header02_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__tdl_2__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__tdl_2__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__tdl_2__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__tdl_2__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 42);
}

static void
cflgt2_add_compute_extra_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Compute Metrics Extra Gen9";
    metric_set->symbol_name = "ComputeExtra";
    metric_set->hw_config_guid = "5f679fb0-909e-4c0e-b4b2-8e801f83e71b";
    metric_set->counters = calloc(5, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(32, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(6, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x121203E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x123203E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x125203E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C0040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F006C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06104000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06114000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06120033 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00120000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06131000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04308000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04318000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04321980 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00320000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04334000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04504000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04514000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04520033 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00520000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04531000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190E000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00001000 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00003002 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00011010 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00050012 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00052051 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00000008 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = cflgt2__compute_extra__avg_gpu_core_frequency__read;
    counter->max_uint64 = cflgt2__compute_extra__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active";
    counter->symbol_name = "Fpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__compute_extra__fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active including Ext Math";
    counter->symbol_name = "Fpu1ActiveAdjusted";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing including Extended Math processing";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__compute_extra__fpu1_active_adjusted__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = cflgt2__compute_extra__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = cflgt2__compute_extra__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    assert(metric_set->n_counters <= 5);
}

static void
cflgt2_add_vme_pipe_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Media Vme Pipe Gen9";
    metric_set->symbol_name = "VMEPipe";
    metric_set->hw_config_guid = "0d09ba9a-1d1c-457d-83e2-74ac448014d6";
    metric_set->counters = calloc(10, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(62, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(17, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(2, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141A5800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x161A00C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12180240 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14180002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x143A5800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x163A00C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12380240 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14380002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002F1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042F3000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C1500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F0400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F9500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x162C0A00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2DC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2DC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04193000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x081A28C1 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00133000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0613C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0813F000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00172000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06178000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0817A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00180037 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06180940 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08180000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02180000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04183000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06393000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C3A28C1 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x003A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A33F000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C33F000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A37A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C37A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A380977 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08380000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04380000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06383000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x119000FF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47901000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900844 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00100030 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFF9 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FFFC };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FFF3 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00100180 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FFCF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FFCF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FF3F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00008003 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = cflgt2__vme_pipe__avg_gpu_core_frequency__read;
    counter->max_uint64 = cflgt2__vme_pipe__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt2__vme_pipe__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__vme_pipe__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__vme_pipe__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__vme_pipe__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Thread Occupancy";
    counter->symbol_name = "EuThreadOccupancy";
    counter->desc = "The percentage of time in which hardware threads occupied EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__vme_pipe__eu_thread_occupancy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__vme_pipe__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = cflgt2__vme_pipe__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = cflgt2__vme_pipe__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VME Busy";
    counter->symbol_name = "VMEBusy";
    counter->desc = "The percentage of time in which VME (IME or CRE) was actively processing data.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__vme_pipe__vme_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "VME Pipe");

    assert(metric_set->n_counters <= 10);
}

static void
cflgt2_add_gpu_busyness_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Gpu Rings Busyness";
    metric_set->symbol_name = "GpuBusyness";
    metric_set->hw_config_guid = "e2f162ae-5732-4af0-8b11-69510f57094a";
    metric_set->counters = calloc(8, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(34, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13805800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05962C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19950016 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19C05800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07800035 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D810400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07960025 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21960000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B964000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B930062 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17948000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B940008 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05950075 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D950000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07E54000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09924000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05982000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09978000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05C08500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25C00000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1BC00000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0BC54000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900C60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x10800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00078000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x00000FFF };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AnyRingBusy";
    counter->symbol_name = "AnyRingBusy";
    counter->desc = "The percentage of time when any command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__gpu_busyness__any_ring_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = cflgt2__gpu_busyness__avg_gpu_core_frequency__read;
    counter->max_uint64 = cflgt2__gpu_busyness__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Blitter Ring Busy";
    counter->symbol_name = "BlitterBusy";
    counter->desc = "The percentage of time when blitter command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__gpu_busyness__blitter_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = cflgt2__gpu_busyness__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = cflgt2__gpu_busyness__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Render Ring Busy";
    counter->symbol_name = "RenderBusy";
    counter->desc = "The percentage of time when render command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__gpu_busyness__render_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Vdbox0 Ring Busy";
    counter->symbol_name = "Vdbox0Busy";
    counter->desc = "The percentage of time when Vdbox0 command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__gpu_busyness__vdbox0_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Vebox Ring Busy";
    counter->symbol_name = "VeboxBusy";
    counter->desc = "The percentage of time when vebox command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt2__gpu_busyness__vebox_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    assert(metric_set->n_counters <= 8);
}

static void
cflgt2_add_test_oa_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "MDAPI testing set Gen9.5";
    metric_set->symbol_name = "TestOa";
    metric_set->hw_config_guid = "74fb4902-d3d3-4237-9e90-cbdc68d0a446";
    metric_set->counters = calloc(12, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(13, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(22, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07810013 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B930040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07E54000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000004 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00000003 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000007 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00100002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FFF7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00100002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FFCF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00100082 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FFEF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x001000C2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FFE7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x00100001 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000FFE7 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = cflgt2__test_oa__avg_gpu_core_frequency__read;
    counter->max_uint64 = cflgt2__test_oa__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter0";
    counter->symbol_name = "Counter0";
    counter->desc = "HW test counter 0. Factor: 0.0";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = cflgt2__test_oa__counter0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter1";
    counter->symbol_name = "Counter1";
    counter->desc = "HW test counter 1. Factor: 1.0";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = cflgt2__test_oa__counter1__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter2";
    counter->symbol_name = "Counter2";
    counter->desc = "HW test counter 2. Factor: 1.0";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = cflgt2__test_oa__counter2__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter3";
    counter->symbol_name = "Counter3";
    counter->desc = "HW test counter 3. Factor: 0.5";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = cflgt2__test_oa__counter3__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter4";
    counter->symbol_name = "Counter4";
    counter->desc = "HW test counter 4. Factor: 0.333";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = cflgt2__test_oa__counter4__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter5";
    counter->symbol_name = "Counter5";
    counter->desc = "HW test counter 5. Factor: 0.333";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = cflgt2__test_oa__counter5__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter6";
    counter->symbol_name = "Counter6";
    counter->desc = "HW test counter 6. Factor: 0.166";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = cflgt2__test_oa__counter6__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter7";
    counter->symbol_name = "Counter7";
    counter->desc = "HW test counter 7. Factor: 0.666";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = cflgt2__test_oa__counter7__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter8";
    counter->symbol_name = "Counter8";
    counter->desc = "HW test counter 8. Should be equal to 1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = cflgt2__test_oa__counter8__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = cflgt2__test_oa__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = cflgt2__test_oa__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    assert(metric_set->n_counters <= 12);
}

static void
cflgt2_add_pma__stall_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set PMA Stall";
    metric_set->symbol_name = "PMA_Stall";
    metric_set->hw_config_guid = "5ccbf9fb-6bf2-456b-a749-bdff7b1aff13";
    metric_set->counters = calloc(4, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(24, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(9, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x122D3080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F0800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0FAA00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002D0025 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062D1300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082D16A4 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2D162E };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x102D0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190003F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00E00021 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0007FFF8 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x07000101 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0038FFC7 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = cflgt2__pma__stall__avg_gpu_core_frequency__read;
    counter->max_uint64 = cflgt2__pma__stall__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = cflgt2__pma__stall__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = cflgt2__pma__stall__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "STC PMA stall";
        counter->symbol_name = "StcPMAStall";
        counter->desc = "Percentage of time when stencil cache line and an overlapping pixel are causing stalls";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt2__pma__stall__stc_pma_stall__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Stencil Cache");
    }

    assert(metric_set->n_counters <= 4);
}

static void
cflgt3_add_render_basic_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Render Metrics Basic Gen9";
    metric_set->symbol_name = "RenderBasic";
    metric_set->hw_config_guid = "b316bcab-212f-4228-97de-af6b5a1a2ea1";
    metric_set->counters = calloc(52, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(83, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(5, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x166C01E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12170280 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12370280 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16EC01E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11930317 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x159303DF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F900003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A4E0380 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A6C0053 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1C0001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002F1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042F1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C8400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4C0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F0400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F6600 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x162CA200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00133000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08133000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00170020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08170021 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10170000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0633C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0833C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06370800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08370840 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10370000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1ACE0200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AEC5300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10EC0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1CEC0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A9B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C9C0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CCC0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A8D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x108F0001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16AC8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D933031 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F933E3F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01933D00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0393073C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0593000E };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D930000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19930000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B930000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D900157 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F900158 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190003F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51902240 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900242 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900084 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47901400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57902220 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900C60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900063 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900C63 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53902222 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00222222 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = cflgt3__render_basic__avg_gpu_core_frequency__read;
    counter->max_uint64 = cflgt3__render_basic__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__render_basic__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__render_basic__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__render_basic__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__render_basic__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__render_basic__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__render_basic__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__render_basic__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = cflgt3__render_basic__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = cflgt3__render_basic__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__render_basic__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Depth Throughput";
    counter->symbol_name = "GtiDepthThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between depth caches and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__render_basic__gti_depth_throughput__read;
    counter->max_uint64 = cflgt3__render_basic__gti_depth_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI HDC TLB Lookup Throughput";
    counter->symbol_name = "GtiHdcLookupsThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between GTI and HDC, when HDC is doing TLB lookups.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__render_basic__gti_hdc_lookups_throughput__read;
    counter->max_uint64 = cflgt3__render_basic__gti_hdc_lookups_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI L3 Throughput";
    counter->symbol_name = "GtiL3Throughput";
    counter->desc = "The total number of GPU memory bytes transferred between L3 caches and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__render_basic__gti_l3_throughput__read;
    counter->max_uint64 = cflgt3__render_basic__gti_l3_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI RCC Throughput";
    counter->symbol_name = "GtiRccThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between render color caches and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__render_basic__gti_rcc_throughput__read;
    counter->max_uint64 = cflgt3__render_basic__gti_rcc_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Read Throughput";
    counter->symbol_name = "GtiReadThroughput";
    counter->desc = "The total number of GPU memory bytes read from GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__render_basic__gti_read_throughput__read;
    counter->max_uint64 = cflgt3__render_basic__gti_read_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Fixed Pipe Throughput";
    counter->symbol_name = "GtiVfThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between 3D Pipeline (Command Dispatch, Input Assembly and Stream Output) and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__render_basic__gti_vf_throughput__read;
    counter->max_uint64 = cflgt3__render_basic__gti_vf_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Write Throughput";
    counter->symbol_name = "GtiWriteThroughput";
    counter->desc = "The total number of GPU memory bytes written to GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__render_basic__gti_write_throughput__read;
    counter->max_uint64 = cflgt3__render_basic__gti_write_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__render_basic__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__render_basic__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Lookup Accesses w/o IC";
    counter->symbol_name = "L3Lookups";
    counter->desc = "The total number of L3 cache lookup accesses w/o IC.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__render_basic__l3_lookups__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/TAG");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Misses";
    counter->symbol_name = "L3Misses";
    counter->desc = "The total number of L3 misses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__render_basic__l3_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/TAG");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Sampler Throughput";
    counter->symbol_name = "L3SamplerThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between samplers and L3 caches.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__render_basic__l3_sampler_throughput__read;
    counter->max_uint64 = cflgt3__render_basic__l3_sampler_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__render_basic__l3_shader_throughput__read;
    counter->max_uint64 = cflgt3__render_basic__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__render_basic__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__render_basic__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__render_basic__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__render_basic__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__render_basic__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__render_basic__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__render_basic__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    if (perf->devinfo.subslice_mask & 0x09) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Sampler 0 Bottleneck";
        counter->symbol_name = "Sampler0Bottleneck";
        counter->desc = "The percentage of time in which Sampler 0 has been slowing down the pipe when processing EU requests.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt3__render_basic__sampler0_bottleneck__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x09) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Sampler 0 Busy";
        counter->symbol_name = "Sampler0Busy";
        counter->desc = "The percentage of time in which Sampler 0 has been processing EU requests.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt3__render_basic__sampler0_busy__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x12) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Sampler 1 Bottleneck";
        counter->symbol_name = "Sampler1Bottleneck";
        counter->desc = "The percentage of time in which Sampler 1 has been slowing down the pipe when processing EU requests.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt3__render_basic__sampler1_bottleneck__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x12) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Sampler 1 Busy";
        counter->symbol_name = "Sampler1Busy";
        counter->desc = "The percentage of time in which Sampler 1 has been processing EU requests.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt3__render_basic__sampler1_busy__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samplers Bottleneck";
    counter->symbol_name = "SamplerBottleneck";
    counter->desc = "The percentage of time in which samplers have been slowing down the pipe when processing EU requests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__render_basic__sampler_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Cache Misses";
    counter->symbol_name = "SamplerL1Misses";
    counter->desc = "The total number of sampler cache misses in all LODs in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__render_basic__sampler_l1_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt3__render_basic__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt3__render_basic__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samplers Busy";
    counter->symbol_name = "SamplersBusy";
    counter->desc = "The percentage of time in which samplers have been processing EU requests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__render_basic__samplers_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__render_basic__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__render_basic__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__render_basic__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__render_basic__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__render_basic__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__render_basic__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__render_basic__slm_bytes_read__read;
    counter->max_uint64 = cflgt3__render_basic__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__render_basic__slm_bytes_written__read;
    counter->max_uint64 = cflgt3__render_basic__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__render_basic__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__render_basic__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__render_basic__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__render_basic__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 52);
}

static void
cflgt3_add_compute_basic_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Compute Metrics Basic Gen9";
    metric_set->symbol_name = "ComputeBasic";
    metric_set->hw_config_guid = "d2eec5b1-4dd8-4170-ae83-9531abd0692f";
    metric_set->counters = calloc(39, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(78, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(5, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x104F00E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x124F1C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C00E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37906800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F900003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A4E0820 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C4E0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064F0900 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084F0032 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4F1891 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4F0E00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E4F003C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004F0D80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x024F003B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x006C0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x086C0100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C6C000C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E6C0B00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x186C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x081B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x101C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1C0024 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x065B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x085B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A5BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C5B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E5B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x005B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x025B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A5C6000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C5C001B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x125C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x145C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4C0208 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F5400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F5500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0155 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x162CFB00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x182C00BE };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19900157 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B900158 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D900105 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F900103 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11900FFF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900821 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900802 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900802 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900422 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53904444 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00000003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00002001 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00778008 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00088078 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00808708 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00222222 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = cflgt3__compute_basic__avg_gpu_core_frequency__read;
    counter->max_uint64 = cflgt3__compute_basic__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__compute_basic__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__compute_basic__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__compute_basic__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__compute_basic__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU AVG IPC Rate";
    counter->symbol_name = "EuAvgIpcRate";
    counter->desc = "The average rate of IPC calculated for 2 FPU pipelines.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NUMBER;
    counter->read_float = cflgt3__compute_basic__eu_avg_ipc_rate__read;
    counter->max_float = cflgt3__compute_basic__eu_avg_ipc_rate__max;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__compute_basic__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Send Pipe Active";
    counter->symbol_name = "EuSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__compute_basic__eu_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__compute_basic__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Thread Occupancy";
    counter->symbol_name = "EuThreadOccupancy";
    counter->desc = "The percentage of time in which hardware threads occupied EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__compute_basic__eu_thread_occupancy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Pipe Active";
    counter->symbol_name = "Fpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__compute_basic__fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active";
    counter->symbol_name = "Fpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__compute_basic__fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__compute_basic__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = cflgt3__compute_basic__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = cflgt3__compute_basic__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__compute_basic__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Read Throughput";
    counter->symbol_name = "GtiReadThroughput";
    counter->desc = "The total number of GPU memory bytes read from GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__compute_basic__gti_read_throughput__read;
    counter->max_uint64 = cflgt3__compute_basic__gti_read_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Write Throughput";
    counter->symbol_name = "GtiWriteThroughput";
    counter->desc = "The total number of GPU memory bytes written to GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__compute_basic__gti_write_throughput__read;
    counter->max_uint64 = cflgt3__compute_basic__gti_write_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__compute_basic__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__compute_basic__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__compute_basic__l3_shader_throughput__read;
    counter->max_uint64 = cflgt3__compute_basic__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__compute_basic__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__compute_basic__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__compute_basic__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt3__compute_basic__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt3__compute_basic__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__compute_basic__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__compute_basic__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__compute_basic__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__compute_basic__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__compute_basic__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__compute_basic__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__compute_basic__slm_bytes_read__read;
    counter->max_uint64 = cflgt3__compute_basic__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__compute_basic__slm_bytes_written__read;
    counter->max_uint64 = cflgt3__compute_basic__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Bytes Read";
    counter->symbol_name = "TypedBytesRead";
    counter->desc = "The total number of typed memory bytes read via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__compute_basic__typed_bytes_read__read;
    counter->max_uint64 = cflgt3__compute_basic__typed_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Bytes Written";
    counter->symbol_name = "TypedBytesWritten";
    counter->desc = "The total number of untyped memory bytes written via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__compute_basic__typed_bytes_written__read;
    counter->max_uint64 = cflgt3__compute_basic__typed_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Untyped Bytes Read";
    counter->symbol_name = "UntypedBytesRead";
    counter->desc = "The total number of typed memory bytes read via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__compute_basic__untyped_bytes_read__read;
    counter->max_uint64 = cflgt3__compute_basic__untyped_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Untyped Writes";
    counter->symbol_name = "UntypedBytesWritten";
    counter->desc = "The total number of untyped memory bytes written via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__compute_basic__untyped_bytes_written__read;
    counter->max_uint64 = cflgt3__compute_basic__untyped_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__compute_basic__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 39);
}

static void
cflgt3_add_render_pipe_profile_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Render Metrics for 3D Pipeline Profile Gen9";
    metric_set->symbol_name = "RenderPipeProfile";
    metric_set->hw_config_guid = "9875e050-b1bc-45e6-a6ab-665594601df9";
    metric_set->counters = calloc(43, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(114, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(21, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0E001F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10116800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x178A03E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11824C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11830020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13840020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11850019 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11860007 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01870C40 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17880000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C0040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020E5400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000E0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080F0040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F0040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06104000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06110012 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06131000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01898000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D890100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03898000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09808000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B808000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0380C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8A0075 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D8A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x118A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B8A4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x138A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D81A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15818000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17818000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B820030 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07828000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D824000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F828000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05824000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D830003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0583000C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09830000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03838000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07838000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B840980 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03844D80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11840000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09848000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09850080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03850003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01850000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07860000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F860400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09870032 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01888052 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11880000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09884000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B931001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D930001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19934000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B958000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D950094 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19958000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09E58000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0BE58000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03E5C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0592C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B928000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D924000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F924000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11928000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1392C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09924000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01985000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07988000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09981000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B982000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D982000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F989000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05982000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x23904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x27904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x29908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190C080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900440 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900C21 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900042 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900024 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900841 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900400 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007FFEA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x00007FFC };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x0007AFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000F5FD };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00079FFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000F3FB };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x0007BF7A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000F7E7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x0007FEFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000F7CF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00077FFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000EFDF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x0006FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000CFBF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x0003FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x00005F7F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00025024 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00035034 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00045044 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00055054 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00065064 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = cflgt3__render_pipe_profile__avg_gpu_core_frequency__read;
    counter->max_uint64 = cflgt3__render_pipe_profile__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "BC Bottleneck";
    counter->symbol_name = "BcBottleneck";
    counter->desc = "The percentage of time in which barycentric coordinates calculation pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__render_pipe_profile__bc_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Barycentric Calc");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Clipper Bottleneck";
    counter->symbol_name = "ClBottleneck";
    counter->desc = "The percentage of time in which clipper pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__render_pipe_profile__cl_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Clipper");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CL Stall";
    counter->symbol_name = "ClStall";
    counter->desc = "The percentage of time in which clipper pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__render_pipe_profile__cl_stall__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Clipper");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__render_pipe_profile__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Bottleneck";
    counter->symbol_name = "DsBottleneck";
    counter->desc = "The percentage of time in which domain shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__render_pipe_profile__ds_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Stall";
    counter->symbol_name = "DsStall";
    counter->desc = "The percentage of time in which domain shader pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__render_pipe_profile__ds_stall__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__render_pipe_profile__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Bottleneck";
    counter->symbol_name = "EarlyDepthBottleneck";
    counter->desc = "The percentage of time in which early depth test pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__render_pipe_profile__early_depth_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__render_pipe_profile__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__render_pipe_profile__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__render_pipe_profile__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__render_pipe_profile__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = cflgt3__render_pipe_profile__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = cflgt3__render_pipe_profile__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Bottleneck";
    counter->symbol_name = "GsBottleneck";
    counter->desc = "The percentage of time in which geometry shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__render_pipe_profile__gs_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__render_pipe_profile__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Hi-Depth Bottleneck";
    counter->symbol_name = "HiDepthBottleneck";
    counter->desc = "The percentage of time in which early hierarchical depth test pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__render_pipe_profile__hi_depth_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__render_pipe_profile__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Bottleneck";
    counter->symbol_name = "HsBottleneck";
    counter->desc = "The percentage of time in which hull shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__render_pipe_profile__hs_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Stall";
    counter->symbol_name = "HsStall";
    counter->desc = "The percentage of time in which hull stall pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__render_pipe_profile__hs_stall__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__render_pipe_profile__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__render_pipe_profile__l3_shader_throughput__read;
    counter->max_uint64 = cflgt3__render_pipe_profile__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__render_pipe_profile__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__render_pipe_profile__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__render_pipe_profile__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt3__render_pipe_profile__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt3__render_pipe_profile__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__render_pipe_profile__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__render_pipe_profile__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__render_pipe_profile__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Strip-Fans Bottleneck";
    counter->symbol_name = "SfBottleneck";
    counter->desc = "The percentage of time in which strip-fans pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__render_pipe_profile__sf_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Strip-Fans");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SF Stall";
    counter->symbol_name = "SfStall";
    counter->desc = "The percentage of time in which strip-fans pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__render_pipe_profile__sf_stall__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Strip-Fans");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__render_pipe_profile__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__render_pipe_profile__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__render_pipe_profile__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__render_pipe_profile__slm_bytes_read__read;
    counter->max_uint64 = cflgt3__render_pipe_profile__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__render_pipe_profile__slm_bytes_written__read;
    counter->max_uint64 = cflgt3__render_pipe_profile__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SO Bottleneck";
    counter->symbol_name = "SoBottleneck";
    counter->desc = "The percentage of time in which stream output pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__render_pipe_profile__so_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Stream Output");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SO Stall";
    counter->symbol_name = "SoStall";
    counter->desc = "The percentage of time in which stream-output pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__render_pipe_profile__so_stall__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Stream Output");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VF Bottleneck";
    counter->symbol_name = "VfBottleneck";
    counter->desc = "The percentage of time in which vertex fetch pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__render_pipe_profile__vf_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Input Assembler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Bottleneck";
    counter->symbol_name = "VsBottleneck";
    counter->desc = "The percentage of time in which vertex shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__render_pipe_profile__vs_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__render_pipe_profile__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 43);
}

static void
cflgt3_add_memory_reads_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Memory Reads Distribution Gen9";
    metric_set->symbol_name = "MemoryReads";
    metric_set->hw_config_guid = "49c65f34-e625-4ca4-86b7-88693e624d4c";
    metric_set->counters = calloc(41, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(47, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(32, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11810C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1381001A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37906800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F900064 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03811300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05811B12 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0781001A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B930055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03E58000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05E5C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07E54000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13900150 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21900151 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x23900152 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25900153 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x27900154 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x29900155 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B900156 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D900157 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F90015F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31900105 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15900103 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17900101 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900C60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900C63 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900C63 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900063 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000272C, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002728, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000271C, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002718, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000274C, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002748, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00006667 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000275C, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002758, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002754, .val = 0x00006465 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002750, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007F81A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x0007F82A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x0007F872 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x0007F8BA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x0007F87A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x0007F8EA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x0007F8E2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x0007F8F2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000FE00 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00025024 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00035034 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00045044 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00055054 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00065064 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = cflgt3__memory_reads__avg_gpu_core_frequency__read;
    counter->max_uint64 = cflgt3__memory_reads__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__memory_reads__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__memory_reads__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__memory_reads__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__memory_reads__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__memory_reads__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__memory_reads__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = cflgt3__memory_reads__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = cflgt3__memory_reads__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__memory_reads__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiCmdStreamerMemoryReads";
    counter->symbol_name = "GtiCmdStreamerMemoryReads";
    counter->desc = "The total number of GTI memory reads from Command Streamer.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__memory_reads__gti_cmd_streamer_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Command Streamer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiHizMemoryReads";
    counter->symbol_name = "GtiHizMemoryReads";
    counter->desc = "The total number of GTI memory reads from Hierarchical Depth Cache (Hi-Depth Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__memory_reads__gti_hiz_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank0Reads";
    counter->symbol_name = "GtiL3Bank0Reads";
    counter->desc = "The total number of GTI memory reads from L3 Bank 0 (L3 Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__memory_reads__gti_l3_bank0_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank1Reads";
    counter->symbol_name = "GtiL3Bank1Reads";
    counter->desc = "The total number of GTI memory reads from L3 Bank 1 (L3 Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__memory_reads__gti_l3_bank1_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank2Reads";
    counter->symbol_name = "GtiL3Bank2Reads";
    counter->desc = "The total number of GTI memory reads from L3 Bank 2 (L3 Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__memory_reads__gti_l3_bank2_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank3Reads";
    counter->symbol_name = "GtiL3Bank3Reads";
    counter->desc = "The total number of GTI memory reads from L3 Bank 3 (L3 Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__memory_reads__gti_l3_bank3_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Reads";
    counter->symbol_name = "GtiL3Reads";
    counter->desc = "The total number of GTI memory reads from L3 (L3 Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__memory_reads__gti_l3_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiMemoryReads";
    counter->symbol_name = "GtiMemoryReads";
    counter->desc = "The total number of GTI memory reads.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__memory_reads__gti_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiMscMemoryReads";
    counter->symbol_name = "GtiMscMemoryReads";
    counter->desc = "The total number of GTI memory reads from Multisampling Color Cache (Multisampling Color Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__memory_reads__gti_msc_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRccMemoryReads";
    counter->symbol_name = "GtiRccMemoryReads";
    counter->desc = "The total number of GTI memory reads from Render Color Cache (Render Color Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__memory_reads__gti_rcc_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRczMemoryReads";
    counter->symbol_name = "GtiRczMemoryReads";
    counter->desc = "The total number of GTI memory reads from Render Depth Cache (Render Depth Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__memory_reads__gti_rcz_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRingAccesses";
    counter->symbol_name = "GtiRingAccesses";
    counter->desc = "The total number of all accesses from GTI to the ring.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__memory_reads__gti_ring_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRsMemoryReads";
    counter->symbol_name = "GtiRsMemoryReads";
    counter->desc = "The total number of GTI memory reads from Resource Streamer.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__memory_reads__gti_rs_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Resource Streamer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiStcMemoryReads";
    counter->symbol_name = "GtiStcMemoryReads";
    counter->desc = "The total number of GTI memory reads from Stencil Cache (Stencil Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__memory_reads__gti_stc_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiVfMemoryReads";
    counter->symbol_name = "GtiVfMemoryReads";
    counter->desc = "The total number of GTI memory reads from Vertex Fetch.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__memory_reads__gti_vf_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Vertex Fetch");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__memory_reads__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__memory_reads__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__memory_reads__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__memory_reads__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__memory_reads__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt3__memory_reads__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt3__memory_reads__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__memory_reads__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__memory_reads__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__memory_reads__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__memory_reads__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__memory_reads__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__memory_reads__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__memory_reads__slm_bytes_read__read;
    counter->max_uint64 = cflgt3__memory_reads__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__memory_reads__slm_bytes_written__read;
    counter->max_uint64 = cflgt3__memory_reads__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__memory_reads__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 41);
}

static void
cflgt3_add_memory_writes_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Memory Writes Distribution Gen9";
    metric_set->symbol_name = "MemoryWrites";
    metric_set->hw_config_guid = "45c9e8ee-2998-4d83-88e8-9cb7e03287bf";
    metric_set->counters = calloc(41, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(47, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(32, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11810C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1381001A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37906800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F901000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03811300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05811B12 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0781001A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B930055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03E58000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05E5C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07E54000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13900160 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21900161 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x23900162 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25900163 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x27900164 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x29900165 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B900166 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D900167 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F900150 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31900105 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15900103 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17900101 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900C60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900C63 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900C63 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900063 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000272C, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002728, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000271C, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002718, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000274C, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002748, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00006667 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000275C, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002758, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002754, .val = 0x00006465 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002750, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007F81A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x0007F82A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x0007F822 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x0007F8BA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x0007F87A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x0007F8EA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x0007F8E2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x0007F8F2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000FE00 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00025024 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00035034 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00045044 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00055054 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00065064 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = cflgt3__memory_writes__avg_gpu_core_frequency__read;
    counter->max_uint64 = cflgt3__memory_writes__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__memory_writes__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__memory_writes__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__memory_writes__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__memory_writes__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__memory_writes__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__memory_writes__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = cflgt3__memory_writes__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = cflgt3__memory_writes__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__memory_writes__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiCmdStreamerMemoryWrites";
    counter->symbol_name = "GtiCmdStreamerMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Command Streamer.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__memory_writes__gti_cmd_streamer_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Command Streamer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiHizMemoryWrites";
    counter->symbol_name = "GtiHizMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Hierarchical Depth Cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__memory_writes__gti_hiz_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank0Writes";
    counter->symbol_name = "GtiL3Bank0Writes";
    counter->desc = "The total number of GTI memory writes from L3 Bank 0 (L3 Bank 0 invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__memory_writes__gti_l3_bank0_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank1Writes";
    counter->symbol_name = "GtiL3Bank1Writes";
    counter->desc = "The total number of GTI memory writes from L3 Bank 1 (L3 Bank 1 invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__memory_writes__gti_l3_bank1_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank2Writes";
    counter->symbol_name = "GtiL3Bank2Writes";
    counter->desc = "The total number of GTI memory writes from L3 Bank 2 (L3 Bank 2 invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__memory_writes__gti_l3_bank2_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank3Writes";
    counter->symbol_name = "GtiL3Bank3Writes";
    counter->desc = "The total number of GTI memory writes from L3 Bank 3 (L3 Bank 3 invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__memory_writes__gti_l3_bank3_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Writes";
    counter->symbol_name = "GtiL3Writes";
    counter->desc = "The total number of GTI memory writes from L3 (L3 invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__memory_writes__gti_l3_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiMemoryWrites";
    counter->symbol_name = "GtiMemoryWrites";
    counter->desc = "The total number of GTI memory writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__memory_writes__gti_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiMscMemoryWrites";
    counter->symbol_name = "GtiMscMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Multisampling Color Cache (Multisampling Color Cache invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__memory_writes__gti_msc_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRccMemoryWrites";
    counter->symbol_name = "GtiRccMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Render Color Cache (Render Color Cache invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__memory_writes__gti_rcc_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRczMemoryWrites";
    counter->symbol_name = "GtiRczMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Render Depth Cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__memory_writes__gti_rcz_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRingAccesses";
    counter->symbol_name = "GtiRingAccesses";
    counter->desc = "The total number of all GTI accesses to the ring.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__memory_writes__gti_ring_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiSoMemoryWrites";
    counter->symbol_name = "GtiSoMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Stream Output.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__memory_writes__gti_so_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Stream Output");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiStcMemoryWrites";
    counter->symbol_name = "GtiStcMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Stencil Cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__memory_writes__gti_stc_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__memory_writes__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__memory_writes__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__memory_writes__l3_shader_throughput__read;
    counter->max_uint64 = cflgt3__memory_writes__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__memory_writes__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__memory_writes__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__memory_writes__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt3__memory_writes__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt3__memory_writes__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__memory_writes__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__memory_writes__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__memory_writes__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__memory_writes__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__memory_writes__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__memory_writes__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__memory_writes__slm_bytes_read__read;
    counter->max_uint64 = cflgt3__memory_writes__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__memory_writes__slm_bytes_written__read;
    counter->max_uint64 = cflgt3__memory_writes__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__memory_writes__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 41);
}

static void
cflgt3_add_compute_extended_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Compute Metrics Extended Gen9";
    metric_set->symbol_name = "ComputeExtended";
    metric_set->hw_config_guid = "bac415ce-d7a2-4f8d-9b16-834deba7330e";
    metric_set->counters = calloc(38, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(72, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(21, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C00E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141C8160 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x161C8015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181C0120 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x184E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A4EAAA0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C4E0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x024E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E6C0B01 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x006C0200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x026C000C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001C0041 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x061C4200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x081C4443 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1C4645 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1C7647 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041C7357 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1C0030 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x101C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x121C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4CAA2A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4C02AA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084CA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F5400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F5515 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0155 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x162CAA00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x182C00AA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11907FFF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900802 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900842 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900842 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007FC2A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x0007FC6A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x0007FC92 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x0007FCA2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x0007FC32 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x0007FC9A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x0007FE6A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x0007FE7A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000BF00 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00000003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00002001 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00778008 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00088078 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00808708 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00A08908 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = cflgt3__compute_extended__avg_gpu_core_frequency__read;
    counter->max_uint64 = cflgt3__compute_extended__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__compute_extended__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuA64UntypedReads0";
    counter->symbol_name = "EuA64UntypedReads0";
    counter->desc = "The subslice 0 EU A64 Untyped Reads subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__compute_extended__eu_a64_untyped_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuA64UntypedWrites0";
    counter->symbol_name = "EuA64UntypedWrites0";
    counter->desc = "The subslice 0 EU A64 Untyped Writes subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__compute_extended__eu_a64_untyped_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__compute_extended__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU AVG IPC Rate";
    counter->symbol_name = "EuAvgIpcRate";
    counter->desc = "The average rate of IPC calculated for 2 FPU pipelines.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NUMBER;
    counter->read_float = cflgt3__compute_extended__eu_avg_ipc_rate__read;
    counter->max_float = cflgt3__compute_extended__eu_avg_ipc_rate__max;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__compute_extended__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Send Pipe Active";
    counter->symbol_name = "EuSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__compute_extended__eu_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__compute_extended__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Thread Occupancy";
    counter->symbol_name = "EuThreadOccupancy";
    counter->desc = "The percentage of time in which hardware threads occupied EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__compute_extended__eu_thread_occupancy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuTypedAtomics0";
    counter->symbol_name = "EuTypedAtomics0";
    counter->desc = "The subslice 0 EU Typed Atomics subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__compute_extended__eu_typed_atomics0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuTypedReads0";
    counter->symbol_name = "EuTypedReads0";
    counter->desc = "The subslice 0 EU Typed Reads subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__compute_extended__eu_typed_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuTypedWrites0";
    counter->symbol_name = "EuTypedWrites0";
    counter->desc = "The subslice 0 EU Typed Writes subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__compute_extended__eu_typed_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuUntypedAtomics0";
    counter->symbol_name = "EuUntypedAtomics0";
    counter->desc = "The subslice 0 EU Untyped Atomics subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__compute_extended__eu_untyped_atomics0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuUntypedReads0";
    counter->symbol_name = "EuUntypedReads0";
    counter->desc = "The subslice 0 EU Untyped Reads subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__compute_extended__eu_untyped_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuUntypedWrites0";
    counter->symbol_name = "EuUntypedWrites0";
    counter->desc = "The subslice 0 EU Untyped Writes subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__compute_extended__eu_untyped_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Pipe Active";
    counter->symbol_name = "Fpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__compute_extended__fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active";
    counter->symbol_name = "Fpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__compute_extended__fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = cflgt3__compute_extended__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = cflgt3__compute_extended__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__compute_extended__l3_shader_throughput__read;
    counter->max_uint64 = cflgt3__compute_extended__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt3__compute_extended__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt3__compute_extended__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__compute_extended__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__compute_extended__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__compute_extended__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__compute_extended__slm_bytes_read__read;
    counter->max_uint64 = cflgt3__compute_extended__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__compute_extended__slm_bytes_written__read;
    counter->max_uint64 = cflgt3__compute_extended__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Atomics 0";
    counter->symbol_name = "TypedAtomics0";
    counter->desc = "The subslice 0 typed atomics.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__compute_extended__typed_atomics0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TypedAtomicsPerCacheLine";
    counter->symbol_name = "TypedAtomicsPerCacheLine";
    counter->desc = "The ratio of EU typed atomics requests to L3 cache line writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
    counter->read_float = cflgt3__compute_extended__typed_atomics_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Reads 0";
    counter->symbol_name = "TypedReads0";
    counter->desc = "The subslice 0 typed reads.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__compute_extended__typed_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TypedReadsPerCacheLine";
    counter->symbol_name = "TypedReadsPerCacheLine";
    counter->desc = "The ratio of EU typed read requests to L3 cache line reads.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
    counter->read_float = cflgt3__compute_extended__typed_reads_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Writes 0";
    counter->symbol_name = "TypedWrites0";
    counter->desc = "The subslice 0 typed writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__compute_extended__typed_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TypedWritesPerCacheLine";
    counter->symbol_name = "TypedWritesPerCacheLine";
    counter->desc = "The ratio of EU typed write requests to L3 cache line writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
    counter->read_float = cflgt3__compute_extended__typed_writes_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Untyped Reads 0";
    counter->symbol_name = "UntypedReads0";
    counter->desc = "The subslice 0 untyped reads (including SLM reads).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__compute_extended__untyped_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "UntypedReadsPerCacheLine";
    counter->symbol_name = "UntypedReadsPerCacheLine";
    counter->desc = "The ratio of EU untyped read requests to L3 cache line reads.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
    counter->read_float = cflgt3__compute_extended__untyped_reads_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Untyped Writes 0";
    counter->symbol_name = "UntypedWrites0";
    counter->desc = "The subslice 0 untyped writes (including SLM writes).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__compute_extended__untyped_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "UntypedWritesPerCacheLine";
    counter->symbol_name = "UntypedWritesPerCacheLine";
    counter->desc = "The ratio of EU untyped write requests to L3 cache line writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
    counter->read_float = cflgt3__compute_extended__untyped_writes_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    assert(metric_set->n_counters <= 38);
}

static void
cflgt3_add_compute_l3_cache_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Compute Metrics L3 Cache Gen9";
    metric_set->symbol_name = "ComputeL3Cache";
    metric_set->hw_config_guid = "a8cfca44-0e74-4338-9e57-3daad98957dd";
    metric_set->counters = calloc(54, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(60, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(13, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x166C0760 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1593001E };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F900003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x184E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A4E8020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C4E0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x006C0051 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x066C5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x086C5C5D };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E6C5E5F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x186C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x061B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x081BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x101C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1CE000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1C0030 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C2A00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4C0280 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F0400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F1500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0140 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x162C0A00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x182C00A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03933300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05930032 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11930000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B930000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D900157 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F900158 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190030F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900021 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53904444 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FEFE };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x0007FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FEFD };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x0007FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FBEF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x0007FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FBDF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00000003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00002001 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00101100 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00201200 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00301300 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00401400 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = cflgt3__compute_l3_cache__avg_gpu_core_frequency__read;
    counter->max_uint64 = cflgt3__compute_l3_cache__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__compute_l3_cache__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__compute_l3_cache__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__compute_l3_cache__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__compute_l3_cache__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU AVG IPC Rate";
    counter->symbol_name = "EuAvgIpcRate";
    counter->desc = "The average rate of IPC calculated for 2 FPU pipelines.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NUMBER;
    counter->read_float = cflgt3__compute_l3_cache__eu_avg_ipc_rate__read;
    counter->max_float = cflgt3__compute_l3_cache__eu_avg_ipc_rate__max;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Binary Instruction";
    counter->symbol_name = "EuBinaryFpu0Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing binary instructions on FPU0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__compute_l3_cache__eu_binary_fpu0_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Binary Instruction";
    counter->symbol_name = "EuBinaryFpu1Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing binary instructions on FPU1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__compute_l3_cache__eu_binary_fpu1_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__compute_l3_cache__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Hybrid Instruction";
    counter->symbol_name = "EuHybridFpu0Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing hybrid instructions on FPU0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__compute_l3_cache__eu_hybrid_fpu0_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Hybrid Instruction";
    counter->symbol_name = "EuHybridFpu1Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing hybrid instructions on FPU1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__compute_l3_cache__eu_hybrid_fpu1_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Move Instruction";
    counter->symbol_name = "EuMoveFpu0Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing move instructions on FPU0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__compute_l3_cache__eu_move_fpu0_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Move Instruction";
    counter->symbol_name = "EuMoveFpu1Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing move instructions on FPU1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__compute_l3_cache__eu_move_fpu1_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Send Pipe Active";
    counter->symbol_name = "EuSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__compute_l3_cache__eu_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__compute_l3_cache__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Ternary Instruction";
    counter->symbol_name = "EuTernaryFpu0Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing ternary instructions on FPU0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__compute_l3_cache__eu_ternary_fpu0_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Ternary Instruction";
    counter->symbol_name = "EuTernaryFpu1Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing ternary instructions on FPU1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__compute_l3_cache__eu_ternary_fpu1_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Pipe Active";
    counter->symbol_name = "Fpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__compute_l3_cache__fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active";
    counter->symbol_name = "Fpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__compute_l3_cache__fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__compute_l3_cache__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = cflgt3__compute_l3_cache__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = cflgt3__compute_l3_cache__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__compute_l3_cache__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI L3 Throughput";
    counter->symbol_name = "GtiL3Throughput";
    counter->desc = "The total number of GPU memory bytes transferred between L3 caches and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__compute_l3_cache__gti_l3_throughput__read;
    counter->max_uint64 = cflgt3__compute_l3_cache__gti_l3_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Read Throughput";
    counter->symbol_name = "GtiReadThroughput";
    counter->desc = "The total number of GPU memory bytes read from GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__compute_l3_cache__gti_read_throughput__read;
    counter->max_uint64 = cflgt3__compute_l3_cache__gti_read_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Write Throughput";
    counter->symbol_name = "GtiWriteThroughput";
    counter->desc = "The total number of GPU memory bytes written to GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__compute_l3_cache__gti_write_throughput__read;
    counter->max_uint64 = cflgt3__compute_l3_cache__gti_write_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__compute_l3_cache__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__compute_l3_cache__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Accesses";
    counter->symbol_name = "L3Accesses";
    counter->desc = "The total number of L3 accesses from all entities.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__compute_l3_cache__l3_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3");

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 00 Accesses";
        counter->symbol_name = "L3Bank00Accesses";
        counter->desc = "The total number of accesses to L3 Bank 00.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = cflgt3__compute_l3_cache__l3_bank00_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 00 IC Accesses";
        counter->symbol_name = "L3Bank00IcAccesses";
        counter->desc = "The total number of accesses to L3 Bank 00 from IC cache.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = cflgt3__compute_l3_cache__l3_bank00_ic_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3/IC");
    }

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 00 IC Hits";
        counter->symbol_name = "L3Bank00IcHits";
        counter->desc = "The total number of hits in L3 Bank 00 from IC cache.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = cflgt3__compute_l3_cache__l3_bank00_ic_hits__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3/IC");
    }

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 01 Accesses";
        counter->symbol_name = "L3Bank01Accesses";
        counter->desc = "The total number of accesses to L3 Bank 01.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = cflgt3__compute_l3_cache__l3_bank01_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 02 Accesses";
        counter->symbol_name = "L3Bank02Accesses";
        counter->desc = "The total number of accesses to L3 Bank 02.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = cflgt3__compute_l3_cache__l3_bank02_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 03 Accesses";
        counter->symbol_name = "L3Bank03Accesses";
        counter->desc = "The total number of accesses to L3 Bank 03.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = cflgt3__compute_l3_cache__l3_bank03_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Misses";
    counter->symbol_name = "L3Misses";
    counter->desc = "The total number of L3 misses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__compute_l3_cache__l3_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/TAG");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Sampler Throughput";
    counter->symbol_name = "L3SamplerThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between samplers and L3 caches.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__compute_l3_cache__l3_sampler_throughput__read;
    counter->max_uint64 = cflgt3__compute_l3_cache__l3_sampler_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__compute_l3_cache__l3_shader_throughput__read;
    counter->max_uint64 = cflgt3__compute_l3_cache__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Total Throughput";
    counter->symbol_name = "L3TotalThroughput";
    counter->desc = "The total number of GPU memory bytes transferred via L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__compute_l3_cache__l3_total_throughput__read;
    counter->max_uint64 = cflgt3__compute_l3_cache__l3_total_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__compute_l3_cache__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__compute_l3_cache__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__compute_l3_cache__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Accesses";
    counter->symbol_name = "SamplerAccesses";
    counter->desc = "The total number of messages send to samplers.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__compute_l3_cache__sampler_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt3__compute_l3_cache__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt3__compute_l3_cache__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__compute_l3_cache__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__compute_l3_cache__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__compute_l3_cache__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__compute_l3_cache__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__compute_l3_cache__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__compute_l3_cache__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__compute_l3_cache__slm_bytes_read__read;
    counter->max_uint64 = cflgt3__compute_l3_cache__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__compute_l3_cache__slm_bytes_written__read;
    counter->max_uint64 = cflgt3__compute_l3_cache__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__compute_l3_cache__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 54);
}

static void
cflgt3_add_hdc_and_sf_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set HDCAndSF";
    metric_set->symbol_name = "HDCAndSF";
    metric_set->hw_config_guid = "c4bee67c-0de6-4bc2-9900-5388dcc8adca";
    metric_set->counters = calloc(40, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(55, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(9, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x104F0232 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x124F4640 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C0232 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11834400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004F1880 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x024F08BB };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044F001B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x046C0100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x066C000B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x061B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1C1800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x005B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x025BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x045B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x125C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x145C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x165C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x185C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C00A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F0055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F828000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8305C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09830000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07830000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D950080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13928000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F988000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190FC00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900842 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x10800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FDFF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = cflgt3__hdc_and_sf__avg_gpu_core_frequency__read;
    counter->max_uint64 = cflgt3__hdc_and_sf__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__hdc_and_sf__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__hdc_and_sf__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__hdc_and_sf__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__hdc_and_sf__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__hdc_and_sf__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__hdc_and_sf__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt3__hdc_and_sf__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__hdc_and_sf__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = cflgt3__hdc_and_sf__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = cflgt3__hdc_and_sf__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__hdc_and_sf__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__hdc_and_sf__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__hdc_and_sf__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__hdc_and_sf__l3_shader_throughput__read;
    counter->max_uint64 = cflgt3__hdc_and_sf__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "HDC stalled by L3 (s0.ss0)";
        counter->symbol_name = "NonSamplerShader00AccessStalledOnL3";
        counter->desc = "Percentage of time when HDC has messges to L3, but it's stalled due to lack of credits (s0.ss0)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt3__hdc_and_sf__non_sampler_shader00_access_stalled_on_l3__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Data Port");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "HDC stalled by L3 (s0.ss1)";
        counter->symbol_name = "NonSamplerShader01AccessStalledOnL3";
        counter->desc = "Percentage of time when HDC has messges to L3, but it's stalled due to lack of credits (s0.ss1)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt3__hdc_and_sf__non_sampler_shader01_access_stalled_on_l3__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Data Port");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "HDC stalled by L3 (s0.ss2)";
        counter->symbol_name = "NonSamplerShader02AccessStalledOnL3";
        counter->desc = "Percentage of time when HDC has messges to L3, but it's stalled due to lack of credits (s0.ss2)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt3__hdc_and_sf__non_sampler_shader02_access_stalled_on_l3__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Data Port");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__hdc_and_sf__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Polygon Data Ready";
    counter->symbol_name = "PolyDataReady";
    counter->desc = "The percentage of time in which geometry pipeline output is ready";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__hdc_and_sf__poly_data_ready__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe/Strip-Fans");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__hdc_and_sf__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__hdc_and_sf__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__hdc_and_sf__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__hdc_and_sf__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__hdc_and_sf__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__hdc_and_sf__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt3__hdc_and_sf__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt3__hdc_and_sf__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__hdc_and_sf__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__hdc_and_sf__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__hdc_and_sf__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__hdc_and_sf__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__hdc_and_sf__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__hdc_and_sf__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__hdc_and_sf__slm_bytes_read__read;
    counter->max_uint64 = cflgt3__hdc_and_sf__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__hdc_and_sf__slm_bytes_written__read;
    counter->max_uint64 = cflgt3__hdc_and_sf__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__hdc_and_sf__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__hdc_and_sf__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__hdc_and_sf__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__hdc_and_sf__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 40);
}

static void
cflgt3_add_l3_1_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set L3_1";
    metric_set->symbol_name = "L3_1";
    metric_set->hw_config_guid = "2f77a650-54a6-4777-98dc-e49000c13ceb";
    metric_set->counters = calloc(40, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(72, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(22, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x126C7B40 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x166C0020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A603444 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A613400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A4EA800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C4E0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x024E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C6C5327 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E6C5425 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x006C2A00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x026C285B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x046C005C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6C0800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1C003C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x121C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x161C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1C0800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x065B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A5C1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10600000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04600000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C610044 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10610000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06610000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4C02A8 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084CA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0154 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F0055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x182C00AA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190FFC0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900420 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900021 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900421 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900040 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00100070 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFF1 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00014002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000C3FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00010002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000C7FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00004002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000D3FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00100700 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FF1F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00001402 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FC3F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x00001002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FC7F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x00000402 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000FD3F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = cflgt3__l3_1__avg_gpu_core_frequency__read;
    counter->max_uint64 = cflgt3__l3_1__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__l3_1__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__l3_1__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__l3_1__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__l3_1__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__l3_1__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__l3_1__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt3__l3_1__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__l3_1__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = cflgt3__l3_1__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = cflgt3__l3_1__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__l3_1__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__l3_1__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__l3_1__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank0 Active";
        counter->symbol_name = "L30Bank0Active";
        counter->desc = "The percentage of time in which slice0 L3 bank0 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt3__l3_1__l30_bank0_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank0 Stalled";
        counter->symbol_name = "L30Bank0Stalled";
        counter->desc = "The percentage of time in which slice0 L3 bank0 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt3__l3_1__l30_bank0_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank1 Active";
        counter->symbol_name = "L30Bank1Active";
        counter->desc = "The percentage of time in which slice0 L3 bank1 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt3__l3_1__l30_bank1_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank1 Stalled";
        counter->symbol_name = "L30Bank1Stalled";
        counter->desc = "The percentage of time in which slice0 L3 bank1 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt3__l3_1__l30_bank1_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__l3_1__l3_shader_throughput__read;
    counter->max_uint64 = cflgt3__l3_1__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__l3_1__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__l3_1__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__l3_1__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__l3_1__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__l3_1__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__l3_1__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__l3_1__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt3__l3_1__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt3__l3_1__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__l3_1__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__l3_1__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__l3_1__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__l3_1__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__l3_1__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__l3_1__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__l3_1__slm_bytes_read__read;
    counter->max_uint64 = cflgt3__l3_1__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__l3_1__slm_bytes_written__read;
    counter->max_uint64 = cflgt3__l3_1__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__l3_1__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__l3_1__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__l3_1__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__l3_1__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 40);
}

static void
cflgt3_add_l3_2_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set L3_2";
    metric_set->symbol_name = "L3_2";
    metric_set->hw_config_guid = "61cf6b31-9ddd-4deb-bae5-7339dd1f63b3";
    metric_set->counters = calloc(38, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(45, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(14, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x126C02E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x146C0001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A623400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x026C3324 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x046C3422 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x161C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1C0800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x065B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A5C1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06614000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C620044 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10620000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06620000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F0055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190F800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00100070 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFF1 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00028002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x000087FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00020002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x00008FFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00008002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000A7FF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = cflgt3__l3_2__avg_gpu_core_frequency__read;
    counter->max_uint64 = cflgt3__l3_2__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__l3_2__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__l3_2__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__l3_2__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__l3_2__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__l3_2__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__l3_2__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt3__l3_2__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__l3_2__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = cflgt3__l3_2__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = cflgt3__l3_2__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__l3_2__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__l3_2__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__l3_2__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank2 Active";
        counter->symbol_name = "L30Bank2Active";
        counter->desc = "The percentage of time in which slice0 L3 bank2 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt3__l3_2__l30_bank2_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank2 Stalled";
        counter->symbol_name = "L30Bank2Stalled";
        counter->desc = "The percentage of time in which slice0 L3 bank2 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt3__l3_2__l30_bank2_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__l3_2__l3_shader_throughput__read;
    counter->max_uint64 = cflgt3__l3_2__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__l3_2__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__l3_2__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__l3_2__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__l3_2__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__l3_2__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__l3_2__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__l3_2__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt3__l3_2__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt3__l3_2__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__l3_2__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__l3_2__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__l3_2__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__l3_2__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__l3_2__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__l3_2__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__l3_2__slm_bytes_read__read;
    counter->max_uint64 = cflgt3__l3_2__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__l3_2__slm_bytes_written__read;
    counter->max_uint64 = cflgt3__l3_2__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__l3_2__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__l3_2__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__l3_2__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__l3_2__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 38);
}

static void
cflgt3_add_l3_3_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set L3_3";
    metric_set->symbol_name = "L3_3";
    metric_set->hw_config_guid = "1421ea8b-a4c9-4383-922a-60ba96c42f24";
    metric_set->counters = calloc(38, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(44, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(14, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x126C4E80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x146C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A633400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x026C3321 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x046C342F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6C2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x061B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x161C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1C1800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06604000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C630044 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10630000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06630000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C00AA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F0055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190F800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900842 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00100070 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFF1 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00028002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x000087FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00020002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x00008FFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00008002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000A7FF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = cflgt3__l3_3__avg_gpu_core_frequency__read;
    counter->max_uint64 = cflgt3__l3_3__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__l3_3__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__l3_3__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__l3_3__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__l3_3__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__l3_3__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__l3_3__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt3__l3_3__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__l3_3__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = cflgt3__l3_3__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = cflgt3__l3_3__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__l3_3__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__l3_3__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__l3_3__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank3 Active";
        counter->symbol_name = "L30Bank3Active";
        counter->desc = "The percentage of time in which slice0 L3 bank3 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt3__l3_3__l30_bank3_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank3 Stalled";
        counter->symbol_name = "L30Bank3Stalled";
        counter->desc = "The percentage of time in which slice0 L3 bank3 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt3__l3_3__l30_bank3_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__l3_3__l3_shader_throughput__read;
    counter->max_uint64 = cflgt3__l3_3__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__l3_3__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__l3_3__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__l3_3__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__l3_3__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__l3_3__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__l3_3__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__l3_3__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt3__l3_3__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt3__l3_3__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__l3_3__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__l3_3__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__l3_3__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__l3_3__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__l3_3__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__l3_3__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__l3_3__slm_bytes_read__read;
    counter->max_uint64 = cflgt3__l3_3__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__l3_3__slm_bytes_written__read;
    counter->max_uint64 = cflgt3__l3_3__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__l3_3__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__l3_3__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__l3_3__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__l3_3__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 38);
}

static void
cflgt3_add_rasterizer_and_pixel_backend_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set RasterizerAndPixelBackend";
    metric_set->symbol_name = "RasterizerAndPixelBackend";
    metric_set->hw_config_guid = "6e1f0a90-c65f-4da9-86d0-c79b3c0063f6";
    metric_set->counters = calloc(41, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(32, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(10, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x102F3800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x144D0500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x120D03C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x140D03CF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F0004 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4E4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042F0480 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C0090 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064D0027 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004D0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D0D40 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020D803F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040D8023 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100D0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020F0010 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F0050 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190FC00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41901400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43901485 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000EFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00006000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000F3FF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = cflgt3__rasterizer_and_pixel_backend__avg_gpu_core_frequency__read;
    counter->max_uint64 = cflgt3__rasterizer_and_pixel_backend__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__rasterizer_and_pixel_backend__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__rasterizer_and_pixel_backend__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__rasterizer_and_pixel_backend__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__rasterizer_and_pixel_backend__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__rasterizer_and_pixel_backend__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__rasterizer_and_pixel_backend__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt3__rasterizer_and_pixel_backend__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__rasterizer_and_pixel_backend__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = cflgt3__rasterizer_and_pixel_backend__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = cflgt3__rasterizer_and_pixel_backend__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__rasterizer_and_pixel_backend__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__rasterizer_and_pixel_backend__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__rasterizer_and_pixel_backend__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__rasterizer_and_pixel_backend__l3_shader_throughput__read;
    counter->max_uint64 = cflgt3__rasterizer_and_pixel_backend__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 PS Output Available";
        counter->symbol_name = "PSOutput0Available";
        counter->desc = "The percentage of time in which slice0 PS output is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt3__rasterizer_and_pixel_backend__ps_output0_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Post-EarlyZ Pixel Data Ready";
        counter->symbol_name = "PixelData0Ready";
        counter->desc = "The percentage of time in which slice0 post-EarlyZ pixel data is ready (after early Z tests have been applied)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt3__rasterizer_and_pixel_backend__pixel_data0_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Rasterizer/Early Depth Test");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Pixel Values Ready";
        counter->symbol_name = "PixelValues0Ready";
        counter->desc = "The percentage of time in which slice0 pixel values are ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt3__rasterizer_and_pixel_backend__pixel_values0_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__rasterizer_and_pixel_backend__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__rasterizer_and_pixel_backend__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__rasterizer_and_pixel_backend__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__rasterizer_and_pixel_backend__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__rasterizer_and_pixel_backend__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__rasterizer_and_pixel_backend__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__rasterizer_and_pixel_backend__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Rasterizer Input Available";
        counter->symbol_name = "Rasterizer0InputAvailable";
        counter->desc = "The percentage of time in which slice0 rasterizer input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt3__rasterizer_and_pixel_backend__rasterizer0_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Rasterizer");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Rasterizer Output Ready";
        counter->symbol_name = "Rasterizer0OutputReady";
        counter->desc = "The percentage of time in which slice0 rasterizer output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt3__rasterizer_and_pixel_backend__rasterizer0_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Rasterizer");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt3__rasterizer_and_pixel_backend__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt3__rasterizer_and_pixel_backend__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__rasterizer_and_pixel_backend__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__rasterizer_and_pixel_backend__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__rasterizer_and_pixel_backend__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__rasterizer_and_pixel_backend__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__rasterizer_and_pixel_backend__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__rasterizer_and_pixel_backend__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__rasterizer_and_pixel_backend__slm_bytes_read__read;
    counter->max_uint64 = cflgt3__rasterizer_and_pixel_backend__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__rasterizer_and_pixel_backend__slm_bytes_written__read;
    counter->max_uint64 = cflgt3__rasterizer_and_pixel_backend__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__rasterizer_and_pixel_backend__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__rasterizer_and_pixel_backend__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__rasterizer_and_pixel_backend__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__rasterizer_and_pixel_backend__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 41);
}

static void
cflgt3_add_sampler_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set Sampler";
    metric_set->symbol_name = "Sampler";
    metric_set->hw_config_guid = "7cb05eab-0857-4189-93bc-09326d298637";
    metric_set->counters = calloc(42, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(70, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(12, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14152C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16150005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x121600A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14352C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16350005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x123600A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14552C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16550005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x125600A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062F6000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022F2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4C0050 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C0010 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0350 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0FB000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F00DA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x182C0028 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022DC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C138000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E132000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0413C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C140018 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C157000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E150078 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10150000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04162180 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02160000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04174000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0233A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04333000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14348000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16348000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02357870 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10350000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04360043 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02360000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04371000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E538000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00538000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06533000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C540020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12548000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E557000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00557800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10550000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06560043 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02560000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06571000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190FF80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900060 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900842 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900060 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x70800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0000C000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000E7FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00003000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000F9FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000C00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FE7F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = cflgt3__sampler__avg_gpu_core_frequency__read;
    counter->max_uint64 = cflgt3__sampler__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__sampler__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__sampler__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__sampler__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__sampler__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__sampler__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__sampler__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt3__sampler__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__sampler__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = cflgt3__sampler__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = cflgt3__sampler__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__sampler__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__sampler__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__sampler__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__sampler__l3_shader_throughput__read;
    counter->max_uint64 = cflgt3__sampler__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__sampler__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__sampler__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__sampler__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__sampler__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__sampler__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__sampler__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__sampler__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice0 Input Available";
        counter->symbol_name = "Sampler00InputAvailable";
        counter->desc = "The percentage of time in which slice0 subslice0 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt3__sampler__sampler00_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice0 Sampler Output Ready";
        counter->symbol_name = "Sampler00OutputReady";
        counter->desc = "The percentage of time in which slice0 subslice0 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt3__sampler__sampler00_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice1 Input Available";
        counter->symbol_name = "Sampler01InputAvailable";
        counter->desc = "The percentage of time in which slice0 subslice1 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt3__sampler__sampler01_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice1 Sampler Output Ready";
        counter->symbol_name = "Sampler01OutputReady";
        counter->desc = "The percentage of time in which slice0 subslice1 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt3__sampler__sampler01_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice2 Input Available";
        counter->symbol_name = "Sampler02InputAvailable";
        counter->desc = "The percentage of time in which slice0 subslice2 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt3__sampler__sampler02_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice2 Sampler Output Ready";
        counter->symbol_name = "Sampler02OutputReady";
        counter->desc = "The percentage of time in which slice0 subslice2 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt3__sampler__sampler02_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt3__sampler__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt3__sampler__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__sampler__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__sampler__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__sampler__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__sampler__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__sampler__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__sampler__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__sampler__slm_bytes_read__read;
    counter->max_uint64 = cflgt3__sampler__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__sampler__slm_bytes_written__read;
    counter->max_uint64 = cflgt3__sampler__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__sampler__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__sampler__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__sampler__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__sampler__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 42);
}

static void
cflgt3_add_tdl_1_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set TDL_1";
    metric_set->symbol_name = "TDL_1";
    metric_set->hw_config_guid = "05a06d02-0c12-486b-bb1d-9be053848980";
    metric_set->counters = calloc(42, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(69, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(18, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12120000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12320000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12520000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022F3000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C0015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F03A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0FF000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F0095 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02108000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0410C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02118000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0411C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02121880 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041219B5 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00120000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02134000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04135000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C308000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E304000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06304000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C318000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E314000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06314000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C321A80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E320033 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06320031 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00320000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C334000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E331000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06331000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E508000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00508000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02504000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E518000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00518000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02514000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E521880 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00521A80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02520033 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E534000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00534000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02531000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190FF80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900062 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900040 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x00007FFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x00009FFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000EFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000F3FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FDFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FE7F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = cflgt3__tdl_1__avg_gpu_core_frequency__read;
    counter->max_uint64 = cflgt3__tdl_1__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__tdl_1__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__tdl_1__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__tdl_1__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__tdl_1__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__tdl_1__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__tdl_1__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt3__tdl_1__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__tdl_1__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = cflgt3__tdl_1__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = cflgt3__tdl_1__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__tdl_1__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__tdl_1__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__tdl_1__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__tdl_1__l3_shader_throughput__read;
    counter->max_uint64 = cflgt3__tdl_1__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "NonPS Thread Ready For Dispatch on Slice0 Subslice0";
        counter->symbol_name = "NonPSThread00ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice0 subslice0 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt3__tdl_1__non_ps_thread00_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "NonPS Thread Ready For Dispatch on Slice0 Subslice1";
        counter->symbol_name = "NonPSThread01ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice0 subslice1 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt3__tdl_1__non_ps_thread01_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "NonPS Thread Ready For Dispatch on Slice0 Subslice2";
        counter->symbol_name = "NonPSThread02ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice0 subslice2 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt3__tdl_1__non_ps_thread02_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice0 Subslice0";
        counter->symbol_name = "PSThread00ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice0 subslice0 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt3__tdl_1__ps_thread00_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice0 Subslice1";
        counter->symbol_name = "PSThread01ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice0 subslice1 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt3__tdl_1__ps_thread01_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice0 Subslice2";
        counter->symbol_name = "PSThread02ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice0 subslice2 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt3__tdl_1__ps_thread02_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__tdl_1__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__tdl_1__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__tdl_1__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__tdl_1__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__tdl_1__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__tdl_1__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__tdl_1__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt3__tdl_1__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt3__tdl_1__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__tdl_1__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__tdl_1__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__tdl_1__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__tdl_1__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__tdl_1__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__tdl_1__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__tdl_1__slm_bytes_read__read;
    counter->max_uint64 = cflgt3__tdl_1__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__tdl_1__slm_bytes_written__read;
    counter->max_uint64 = cflgt3__tdl_1__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__tdl_1__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__tdl_1__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__tdl_1__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__tdl_1__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 42);
}

static void
cflgt3_add_tdl_2_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set TDL_2";
    metric_set->symbol_name = "TDL_2";
    metric_set->hw_config_guid = "cddbd1dc-41a2-4fe4-8b05-3d2773120814";
    metric_set->counters = calloc(42, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(43, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(6, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12124D60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12322E60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12524D60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022F3000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C0014 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0FE000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F0097 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0410C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0411C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04121FB7 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00120000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04135000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00308000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06304000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00318000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06314000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00321B80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0632003F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00334000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06331000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0250C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0251C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02521FB7 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00520000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02535000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190FC00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900063 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = cflgt3__tdl_2__avg_gpu_core_frequency__read;
    counter->max_uint64 = cflgt3__tdl_2__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__tdl_2__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__tdl_2__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__tdl_2__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__tdl_2__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__tdl_2__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__tdl_2__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt3__tdl_2__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__tdl_2__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = cflgt3__tdl_2__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = cflgt3__tdl_2__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__tdl_2__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__tdl_2__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__tdl_2__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__tdl_2__l3_shader_throughput__read;
    counter->max_uint64 = cflgt3__tdl_2__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__tdl_2__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__tdl_2__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__tdl_2__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__tdl_2__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__tdl_2__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__tdl_2__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__tdl_2__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt3__tdl_2__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cflgt3__tdl_2__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__tdl_2__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__tdl_2__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cflgt3__tdl_2__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__tdl_2__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__tdl_2__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cflgt3__tdl_2__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__tdl_2__slm_bytes_read__read;
    counter->max_uint64 = cflgt3__tdl_2__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cflgt3__tdl_2__slm_bytes_written__read;
    counter->max_uint64 = cflgt3__tdl_2__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice0 Port 0";
        counter->symbol_name = "ThreadHeader00ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice0 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt3__tdl_2__thread_header00_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice0 Port 1";
        counter->symbol_name = "ThreadHeader00ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice0 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt3__tdl_2__thread_header00_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice1 Port 0";
        counter->symbol_name = "ThreadHeader01ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice1 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt3__tdl_2__thread_header01_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice1 Port 1";
        counter->symbol_name = "ThreadHeader01ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice1 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt3__tdl_2__thread_header01_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice2 Port 0";
        counter->symbol_name = "ThreadHeader02ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice2 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt3__tdl_2__thread_header02_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice2 Port 1";
        counter->symbol_name = "ThreadHeader02ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice2 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt3__tdl_2__thread_header02_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__tdl_2__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__tdl_2__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__tdl_2__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__tdl_2__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 42);
}

static void
cflgt3_add_compute_extra_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Compute Metrics Extra Gen9";
    metric_set->symbol_name = "ComputeExtra";
    metric_set->hw_config_guid = "e61ae394-9d9e-4204-a735-1dad7e44d953";
    metric_set->counters = calloc(5, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(69, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x121203E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x123203E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x125203E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x129203E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12B203E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12D203E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x024EC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044EC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064EC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084CA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C0042 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F006D };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06104000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06114000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06120033 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00120000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06131000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04308000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04318000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04321980 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00320000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04334000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04504000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04514000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04520033 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00520000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04531000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00AF8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0ACC0001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x008D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x028DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C8FB000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E8F0001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06AC8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02AD4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02918000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02921980 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00920000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02934000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02B04000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02B14000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02B20033 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00B20000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02B31000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00D08000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00D18000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00D21980 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00D34000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190FC00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900420 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x459000A1 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = cflgt3__compute_extra__avg_gpu_core_frequency__read;
    counter->max_uint64 = cflgt3__compute_extra__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active";
    counter->symbol_name = "Fpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__compute_extra__fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active including Ext Math";
    counter->symbol_name = "Fpu1ActiveAdjusted";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing including Extended Math processing";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__compute_extra__fpu1_active_adjusted__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = cflgt3__compute_extra__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = cflgt3__compute_extra__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    assert(metric_set->n_counters <= 5);
}

static void
cflgt3_add_vme_pipe_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Media Vme Pipe Gen9";
    metric_set->symbol_name = "VMEPipe";
    metric_set->hw_config_guid = "94272ad9-45ee-4e34-b7a7-51546cd6405c";
    metric_set->counters = calloc(10, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(73, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(17, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(2, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141A5800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x161A00C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12180240 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14180002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x149A5800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x169A00C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12980240 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14980002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A4E3FC0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002F1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042F3000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C9500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4C002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F0400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0F5500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x162CAA00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x182C000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04193000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x081A28C1 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00133000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0613C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0813F000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00172000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06178000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0817A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00180037 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06180940 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08180000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02180000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04183000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04AFC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06AF3000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0ACC4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CCC0015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A8DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C8DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E8F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x108F0015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16ACA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18AC000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06993000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C9A28C1 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x009A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A93F000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C93F000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A97A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C97A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A980977 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08980000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04980000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06983000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x119000FF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900004 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x479008A5 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00100030 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFF9 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FFFC };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FFF3 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00100180 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FFCF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FFCF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FF3F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00008003 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = cflgt3__vme_pipe__avg_gpu_core_frequency__read;
    counter->max_uint64 = cflgt3__vme_pipe__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cflgt3__vme_pipe__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__vme_pipe__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__vme_pipe__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__vme_pipe__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Thread Occupancy";
    counter->symbol_name = "EuThreadOccupancy";
    counter->desc = "The percentage of time in which hardware threads occupied EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__vme_pipe__eu_thread_occupancy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__vme_pipe__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = cflgt3__vme_pipe__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = cflgt3__vme_pipe__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VME Busy";
    counter->symbol_name = "VMEBusy";
    counter->desc = "The percentage of time in which VME (IME or CRE) was actively processing data.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__vme_pipe__vme_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "VME Pipe");

    assert(metric_set->n_counters <= 10);
}

static void
cflgt3_add_gpu_busyness_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Gpu Rings Busyness";
    metric_set->symbol_name = "GpuBusyness";
    metric_set->hw_config_guid = "22b7e0c2-cade-425f-b099-34479768c72a";
    metric_set->counters = calloc(9, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(42, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19D05800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13805800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05962C25 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19950016 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19C05800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05D00085 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25D00000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09D54000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07800035 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D810400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21960000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0996C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B964000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B930068 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15948000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B94000C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03957500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D950000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17950000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07E54000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07928000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03988000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09978000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05C08500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25C00000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1BC00000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0BC54000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900463 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x10800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007C000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x000007FF };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AnyRingBusy";
    counter->symbol_name = "AnyRingBusy";
    counter->desc = "The percentage of time when any command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__gpu_busyness__any_ring_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = cflgt3__gpu_busyness__avg_gpu_core_frequency__read;
    counter->max_uint64 = cflgt3__gpu_busyness__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Blitter Ring Busy";
    counter->symbol_name = "BlitterBusy";
    counter->desc = "The percentage of time when blitter command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__gpu_busyness__blitter_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = cflgt3__gpu_busyness__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = cflgt3__gpu_busyness__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Render Ring Busy";
    counter->symbol_name = "RenderBusy";
    counter->desc = "The percentage of time when render command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__gpu_busyness__render_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Vdbox0 Ring Busy";
    counter->symbol_name = "Vdbox0Busy";
    counter->desc = "The percentage of time when Vdbox0 command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__gpu_busyness__vdbox0_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Vdbox1 Ring Busy";
    counter->symbol_name = "Vdbox1Busy";
    counter->desc = "The percentage of time when Vdbox1 command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__gpu_busyness__vdbox1_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Vebox Ring Busy";
    counter->symbol_name = "VeboxBusy";
    counter->desc = "The percentage of time when vebox command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cflgt3__gpu_busyness__vebox_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    assert(metric_set->n_counters <= 9);
}

static void
cflgt3_add_test_oa_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "MDAPI testing set Gen9";
    metric_set->symbol_name = "TestOa";
    metric_set->hw_config_guid = "577e8e2c-3fa0-4875-8743-3538d585e3b0";
    metric_set->counters = calloc(12, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(13, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(22, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07810013 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D810000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B930040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07E54000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000004 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00000003 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000007 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00100002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FFF7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00100002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FFCF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00100082 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FFEF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x001000C2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FFE7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x00100001 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000FFE7 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = cflgt3__test_oa__avg_gpu_core_frequency__read;
    counter->max_uint64 = cflgt3__test_oa__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter0";
    counter->symbol_name = "Counter0";
    counter->desc = "HW test counter 0. Factor: 0.0";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = cflgt3__test_oa__counter0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter1";
    counter->symbol_name = "Counter1";
    counter->desc = "HW test counter 1. Factor: 1.0";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = cflgt3__test_oa__counter1__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter2";
    counter->symbol_name = "Counter2";
    counter->desc = "HW test counter 2. Factor: 1.0";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = cflgt3__test_oa__counter2__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter3";
    counter->symbol_name = "Counter3";
    counter->desc = "HW test counter 3. Factor: 0.5";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = cflgt3__test_oa__counter3__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter4";
    counter->symbol_name = "Counter4";
    counter->desc = "HW test counter 4. Factor: 0.333";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = cflgt3__test_oa__counter4__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter5";
    counter->symbol_name = "Counter5";
    counter->desc = "HW test counter 5. Factor: 0.333";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = cflgt3__test_oa__counter5__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter6";
    counter->symbol_name = "Counter6";
    counter->desc = "HW test counter 6. Factor: 0.166";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = cflgt3__test_oa__counter6__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter7";
    counter->symbol_name = "Counter7";
    counter->desc = "HW test counter 7. Factor: 0.666";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = cflgt3__test_oa__counter7__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter8";
    counter->symbol_name = "Counter8";
    counter->desc = "HW test counter 8. Should be equal to 1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = cflgt3__test_oa__counter8__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = cflgt3__test_oa__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = cflgt3__test_oa__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    assert(metric_set->n_counters <= 12);
}

static void
cflgt3_add_pma__stall_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set PMA Stall";
    metric_set->symbol_name = "PMA_Stall";
    metric_set->hw_config_guid = "c11af8d1-858b-4f8b-98fb-8d683ba8bda0";
    metric_set->counters = calloc(4, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(24, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(9, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x122D3080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F0800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0FAA00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002D0025 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062D1300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082D16A4 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2D162E };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x102D0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1190003F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00E00021 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0007FFF8 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x07000101 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0038FFC7 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = cflgt3__pma__stall__avg_gpu_core_frequency__read;
    counter->max_uint64 = cflgt3__pma__stall__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = cflgt3__pma__stall__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = cflgt3__pma__stall__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "STC PMA stall";
        counter->symbol_name = "StcPMAStall";
        counter->desc = "Percentage of time when stencil cache line and an overlapping pixel are causing stalls";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cflgt3__pma__stall__stc_pma_stall__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Stencil Cache");
    }

    assert(metric_set->n_counters <= 4);
}

static void
bxt_add_render_basic_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Render Metrics Basic Gen9";
    metric_set->symbol_name = "RenderBasic";
    metric_set->hw_config_guid = "22b9519a-e9ba-4c41-8b54-f4f8ca14fa0a";
    metric_set->counters = calloc(52, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(80, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(5, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    if (perf->devinfo.revision >= 0x03) {
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x166C00F0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12120280 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12320280 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11930317 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x159303DF };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F900C00 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x419000A0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002D1000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062D4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082D5000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2D1000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2E0800 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2E5900 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4C8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E4C4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064E8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084E8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4E2000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C4F0010 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A6C0053 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C6C0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A0FCC00 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C0F0002 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C2C0040 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00101000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04101000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00114000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08114000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00120020 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08120021 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00141000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08141000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02308000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04302000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06318000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08318000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06320800 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08320840 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00320000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06344000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08344000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D931831 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F939F3F };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01939E80 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x039303BC };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0593000E };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1993002A };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07930000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09930000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D900177 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F900187 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13904000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21904000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x23904000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25904000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x27904000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B904000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D904000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F904000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31904000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15904000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17904000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19904000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B904000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53901110 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900423 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900111 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900C02 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900020 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59901111 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900421 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D900001 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900821 };
    }

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = bxt__render_basic__avg_gpu_core_frequency__read;
    counter->max_uint64 = bxt__render_basic__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__render_basic__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__render_basic__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__render_basic__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__render_basic__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__render_basic__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__render_basic__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__render_basic__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = bxt__render_basic__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = bxt__render_basic__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__render_basic__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Depth Throughput";
    counter->symbol_name = "GtiDepthThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between depth caches and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bxt__render_basic__gti_depth_throughput__read;
    counter->max_uint64 = bxt__render_basic__gti_depth_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI HDC TLB Lookup Throughput";
    counter->symbol_name = "GtiHdcLookupsThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between GTI and HDC, when HDC is doing TLB lookups.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bxt__render_basic__gti_hdc_lookups_throughput__read;
    counter->max_uint64 = bxt__render_basic__gti_hdc_lookups_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI L3 Throughput";
    counter->symbol_name = "GtiL3Throughput";
    counter->desc = "The total number of GPU memory bytes transferred between L3 caches and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bxt__render_basic__gti_l3_throughput__read;
    counter->max_uint64 = bxt__render_basic__gti_l3_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI RCC Throughput";
    counter->symbol_name = "GtiRccThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between render color caches and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bxt__render_basic__gti_rcc_throughput__read;
    counter->max_uint64 = bxt__render_basic__gti_rcc_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Read Throughput";
    counter->symbol_name = "GtiReadThroughput";
    counter->desc = "The total number of GPU memory bytes read from GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bxt__render_basic__gti_read_throughput__read;
    counter->max_uint64 = bxt__render_basic__gti_read_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Fixed Pipe Throughput";
    counter->symbol_name = "GtiVfThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between 3D Pipeline (Command Dispatch, Input Assembly and Stream Output) and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bxt__render_basic__gti_vf_throughput__read;
    counter->max_uint64 = bxt__render_basic__gti_vf_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Write Throughput";
    counter->symbol_name = "GtiWriteThroughput";
    counter->desc = "The total number of GPU memory bytes written to GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bxt__render_basic__gti_write_throughput__read;
    counter->max_uint64 = bxt__render_basic__gti_write_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__render_basic__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__render_basic__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Lookup Accesses w/o IC";
    counter->symbol_name = "L3Lookups";
    counter->desc = "The total number of L3 cache lookup accesses w/o IC.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__render_basic__l3_lookups__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/TAG");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Misses";
    counter->symbol_name = "L3Misses";
    counter->desc = "The total number of L3 misses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__render_basic__l3_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/TAG");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Sampler Throughput";
    counter->symbol_name = "L3SamplerThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between samplers and L3 caches.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bxt__render_basic__l3_sampler_throughput__read;
    counter->max_uint64 = bxt__render_basic__l3_sampler_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bxt__render_basic__l3_shader_throughput__read;
    counter->max_uint64 = bxt__render_basic__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__render_basic__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__render_basic__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__render_basic__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__render_basic__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__render_basic__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__render_basic__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__render_basic__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    if (perf->devinfo.subslice_mask & 0x09) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Sampler 0 Bottleneck";
        counter->symbol_name = "Sampler0Bottleneck";
        counter->desc = "The percentage of time in which Sampler 0 has been slowing down the pipe when processing EU requests.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bxt__render_basic__sampler0_bottleneck__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x09) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Sampler 0 Busy";
        counter->symbol_name = "Sampler0Busy";
        counter->desc = "The percentage of time in which Sampler 0 has been processing EU requests.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bxt__render_basic__sampler0_busy__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x12) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Sampler 1 Bottleneck";
        counter->symbol_name = "Sampler1Bottleneck";
        counter->desc = "The percentage of time in which Sampler 1 has been slowing down the pipe when processing EU requests.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bxt__render_basic__sampler1_bottleneck__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x12) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Sampler 1 Busy";
        counter->symbol_name = "Sampler1Busy";
        counter->desc = "The percentage of time in which Sampler 1 has been processing EU requests.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bxt__render_basic__sampler1_busy__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samplers Bottleneck";
    counter->symbol_name = "SamplerBottleneck";
    counter->desc = "The percentage of time in which samplers have been slowing down the pipe when processing EU requests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__render_basic__sampler_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Cache Misses";
    counter->symbol_name = "SamplerL1Misses";
    counter->desc = "The total number of sampler cache misses in all LODs in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__render_basic__sampler_l1_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bxt__render_basic__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bxt__render_basic__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samplers Busy";
    counter->symbol_name = "SamplersBusy";
    counter->desc = "The percentage of time in which samplers have been processing EU requests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__render_basic__samplers_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__render_basic__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__render_basic__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__render_basic__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__render_basic__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__render_basic__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__render_basic__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bxt__render_basic__slm_bytes_read__read;
    counter->max_uint64 = bxt__render_basic__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bxt__render_basic__slm_bytes_written__read;
    counter->max_uint64 = bxt__render_basic__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__render_basic__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__render_basic__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__render_basic__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__render_basic__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 52);
}

static void
bxt_add_compute_basic_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Compute Metrics Basic Gen9";
    metric_set->symbol_name = "ComputeBasic";
    metric_set->hw_config_guid = "012d72cf-82a9-4d25-8ddf-74076fd30797";
    metric_set->counters = calloc(39, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(72, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(5, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x104F00E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x124F1C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x39900340 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F900C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002D5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2D1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2D5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2E1400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2E5100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x102E0114 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E4C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x104C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x124C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x164C2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004EA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4E2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4EA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004F6B42 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064F6200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084F4100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4F0061 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4F6C4C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E4F4B00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A4F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C4F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x180F5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A0F8800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C0F08A2 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x182C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C2C1451 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E2C0001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A2C0010 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19938A28 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19900177 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B900178 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D900125 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F900123 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x27904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53901000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900111 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00000003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00002001 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00778008 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00088078 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00808708 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00A08908 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = bxt__compute_basic__avg_gpu_core_frequency__read;
    counter->max_uint64 = bxt__compute_basic__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__compute_basic__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__compute_basic__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__compute_basic__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__compute_basic__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU AVG IPC Rate";
    counter->symbol_name = "EuAvgIpcRate";
    counter->desc = "The average rate of IPC calculated for 2 FPU pipelines.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NUMBER;
    counter->read_float = bxt__compute_basic__eu_avg_ipc_rate__read;
    counter->max_float = bxt__compute_basic__eu_avg_ipc_rate__max;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__compute_basic__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Send Pipe Active";
    counter->symbol_name = "EuSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__compute_basic__eu_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__compute_basic__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Thread Occupancy";
    counter->symbol_name = "EuThreadOccupancy";
    counter->desc = "The percentage of time in which hardware threads occupied EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__compute_basic__eu_thread_occupancy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Pipe Active";
    counter->symbol_name = "Fpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__compute_basic__fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active";
    counter->symbol_name = "Fpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__compute_basic__fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__compute_basic__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = bxt__compute_basic__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = bxt__compute_basic__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__compute_basic__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Read Throughput";
    counter->symbol_name = "GtiReadThroughput";
    counter->desc = "The total number of GPU memory bytes read from GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bxt__compute_basic__gti_read_throughput__read;
    counter->max_uint64 = bxt__compute_basic__gti_read_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Write Throughput";
    counter->symbol_name = "GtiWriteThroughput";
    counter->desc = "The total number of GPU memory bytes written to GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bxt__compute_basic__gti_write_throughput__read;
    counter->max_uint64 = bxt__compute_basic__gti_write_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__compute_basic__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__compute_basic__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bxt__compute_basic__l3_shader_throughput__read;
    counter->max_uint64 = bxt__compute_basic__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__compute_basic__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__compute_basic__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__compute_basic__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bxt__compute_basic__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bxt__compute_basic__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__compute_basic__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__compute_basic__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__compute_basic__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__compute_basic__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__compute_basic__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__compute_basic__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bxt__compute_basic__slm_bytes_read__read;
    counter->max_uint64 = bxt__compute_basic__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bxt__compute_basic__slm_bytes_written__read;
    counter->max_uint64 = bxt__compute_basic__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Bytes Read";
    counter->symbol_name = "TypedBytesRead";
    counter->desc = "The total number of typed memory bytes read via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bxt__compute_basic__typed_bytes_read__read;
    counter->max_uint64 = bxt__compute_basic__typed_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Bytes Written";
    counter->symbol_name = "TypedBytesWritten";
    counter->desc = "The total number of untyped memory bytes written via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bxt__compute_basic__typed_bytes_written__read;
    counter->max_uint64 = bxt__compute_basic__typed_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Untyped Bytes Read";
    counter->symbol_name = "UntypedBytesRead";
    counter->desc = "The total number of typed memory bytes read via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bxt__compute_basic__untyped_bytes_read__read;
    counter->max_uint64 = bxt__compute_basic__untyped_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Untyped Writes";
    counter->symbol_name = "UntypedBytesWritten";
    counter->desc = "The total number of untyped memory bytes written via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bxt__compute_basic__untyped_bytes_written__read;
    counter->max_uint64 = bxt__compute_basic__untyped_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__compute_basic__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 39);
}

static void
bxt_add_render_pipe_profile_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Render Metrics for 3D Pipeline Profile Gen9";
    metric_set->symbol_name = "RenderPipeProfile";
    metric_set->hw_config_guid = "ce416533-e49e-4211-80af-ec513590a914";
    metric_set->counters = calloc(43, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(94, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(21, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2E001F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10186800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11810019 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15810013 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13820020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11830020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17840000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11860007 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21860000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x178703E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062D1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022E5400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002E0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2E0080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082F0040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06143000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06174000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06180012 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00180000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D804000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F804000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05804000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09810200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B810030 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03810003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21819140 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x23819050 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25810018 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B820980 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03820D80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11820000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0182C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07828000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09824000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F828000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D830004 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0583000C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F831000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01848072 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11840000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07848000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09844000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F848000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07860000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09860092 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F860400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01869100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F870065 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01870000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19930800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B952000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D955055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F951455 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0992A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F928000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1192A800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1392028A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B92A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D922000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x23908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x27908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x29908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900C01 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900863 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900061 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900C22 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007FFEA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x00007FFC };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x0007AFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000F5FD };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00079FFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000F3FB };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x0007BF7A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000F7E7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x0007FEFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000F7CF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00077FFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000EFDF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x0006FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000CFBF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x0003FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x00005F7F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00025024 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00035034 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00045044 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00055054 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00065064 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = bxt__render_pipe_profile__avg_gpu_core_frequency__read;
    counter->max_uint64 = bxt__render_pipe_profile__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "BC Bottleneck";
    counter->symbol_name = "BcBottleneck";
    counter->desc = "The percentage of time in which barycentric coordinates calculation pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__render_pipe_profile__bc_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Barycentric Calc");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Clipper Bottleneck";
    counter->symbol_name = "ClBottleneck";
    counter->desc = "The percentage of time in which clipper pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__render_pipe_profile__cl_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Clipper");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CL Stall";
    counter->symbol_name = "ClStall";
    counter->desc = "The percentage of time in which clipper pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__render_pipe_profile__cl_stall__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Clipper");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__render_pipe_profile__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Bottleneck";
    counter->symbol_name = "DsBottleneck";
    counter->desc = "The percentage of time in which domain shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__render_pipe_profile__ds_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Stall";
    counter->symbol_name = "DsStall";
    counter->desc = "The percentage of time in which domain shader pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__render_pipe_profile__ds_stall__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__render_pipe_profile__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Bottleneck";
    counter->symbol_name = "EarlyDepthBottleneck";
    counter->desc = "The percentage of time in which early depth test pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__render_pipe_profile__early_depth_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__render_pipe_profile__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__render_pipe_profile__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__render_pipe_profile__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__render_pipe_profile__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = bxt__render_pipe_profile__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = bxt__render_pipe_profile__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Bottleneck";
    counter->symbol_name = "GsBottleneck";
    counter->desc = "The percentage of time in which geometry shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__render_pipe_profile__gs_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__render_pipe_profile__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Hi-Depth Bottleneck";
    counter->symbol_name = "HiDepthBottleneck";
    counter->desc = "The percentage of time in which early hierarchical depth test pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__render_pipe_profile__hi_depth_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__render_pipe_profile__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Bottleneck";
    counter->symbol_name = "HsBottleneck";
    counter->desc = "The percentage of time in which hull shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__render_pipe_profile__hs_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Stall";
    counter->symbol_name = "HsStall";
    counter->desc = "The percentage of time in which hull stall pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__render_pipe_profile__hs_stall__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__render_pipe_profile__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bxt__render_pipe_profile__l3_shader_throughput__read;
    counter->max_uint64 = bxt__render_pipe_profile__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__render_pipe_profile__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__render_pipe_profile__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__render_pipe_profile__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bxt__render_pipe_profile__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bxt__render_pipe_profile__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__render_pipe_profile__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__render_pipe_profile__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__render_pipe_profile__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Strip-Fans Bottleneck";
    counter->symbol_name = "SfBottleneck";
    counter->desc = "The percentage of time in which strip-fans pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__render_pipe_profile__sf_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Strip-Fans");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SF Stall";
    counter->symbol_name = "SfStall";
    counter->desc = "The percentage of time in which strip-fans pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__render_pipe_profile__sf_stall__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Strip-Fans");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__render_pipe_profile__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__render_pipe_profile__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__render_pipe_profile__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bxt__render_pipe_profile__slm_bytes_read__read;
    counter->max_uint64 = bxt__render_pipe_profile__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bxt__render_pipe_profile__slm_bytes_written__read;
    counter->max_uint64 = bxt__render_pipe_profile__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SO Bottleneck";
    counter->symbol_name = "SoBottleneck";
    counter->desc = "The percentage of time in which stream output pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__render_pipe_profile__so_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Stream Output");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SO Stall";
    counter->symbol_name = "SoStall";
    counter->desc = "The percentage of time in which stream-output pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__render_pipe_profile__so_stall__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Stream Output");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VF Bottleneck";
    counter->symbol_name = "VfBottleneck";
    counter->desc = "The percentage of time in which vertex fetch pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__render_pipe_profile__vf_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Input Assembler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Bottleneck";
    counter->symbol_name = "VsBottleneck";
    counter->desc = "The percentage of time in which vertex shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__render_pipe_profile__vs_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__render_pipe_profile__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 43);
}

static void
bxt_add_memory_reads_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Memory Reads Distribution Gen9";
    metric_set->symbol_name = "MemoryReads";
    metric_set->hw_config_guid = "398e2452-18d7-42d0-b241-e4d0a9148ada";
    metric_set->counters = calloc(41, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(44, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(32, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19800343 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x39900340 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F901000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03803180 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058035E2 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0780006A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2181A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2381000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D950550 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B928000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D92A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F922000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13900170 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21900171 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x23900172 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25900173 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x27900174 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x29900175 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B900176 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D900177 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F90017F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31900125 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15900123 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17900121 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43901084 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47901080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49901084 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B901084 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D900004 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000272C, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002728, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000271C, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002718, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000274C, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002748, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00006667 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000275C, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002758, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002754, .val = 0x00006465 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002750, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007F81A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x0007F82A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x0007F872 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x0007F8BA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x0007F87A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x0007F8EA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x0007F8E2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x0007F8F2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000FE00 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00025024 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00035034 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00045044 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00055054 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00065064 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = bxt__memory_reads__avg_gpu_core_frequency__read;
    counter->max_uint64 = bxt__memory_reads__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__memory_reads__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__memory_reads__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__memory_reads__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__memory_reads__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__memory_reads__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__memory_reads__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = bxt__memory_reads__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = bxt__memory_reads__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__memory_reads__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiCmdStreamerMemoryReads";
    counter->symbol_name = "GtiCmdStreamerMemoryReads";
    counter->desc = "The total number of GTI memory reads from Command Streamer.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__memory_reads__gti_cmd_streamer_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Command Streamer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiHizMemoryReads";
    counter->symbol_name = "GtiHizMemoryReads";
    counter->desc = "The total number of GTI memory reads from Hierarchical Depth Cache (Hi-Depth Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__memory_reads__gti_hiz_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank0Reads";
    counter->symbol_name = "GtiL3Bank0Reads";
    counter->desc = "The total number of GTI memory reads from L3 Bank 0 (L3 Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__memory_reads__gti_l3_bank0_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank1Reads";
    counter->symbol_name = "GtiL3Bank1Reads";
    counter->desc = "The total number of GTI memory reads from L3 Bank 1 (L3 Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__memory_reads__gti_l3_bank1_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank2Reads";
    counter->symbol_name = "GtiL3Bank2Reads";
    counter->desc = "The total number of GTI memory reads from L3 Bank 2 (L3 Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__memory_reads__gti_l3_bank2_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank3Reads";
    counter->symbol_name = "GtiL3Bank3Reads";
    counter->desc = "The total number of GTI memory reads from L3 Bank 3 (L3 Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__memory_reads__gti_l3_bank3_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Reads";
    counter->symbol_name = "GtiL3Reads";
    counter->desc = "The total number of GTI memory reads from L3 (L3 Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__memory_reads__gti_l3_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiMemoryReads";
    counter->symbol_name = "GtiMemoryReads";
    counter->desc = "The total number of GTI memory reads.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__memory_reads__gti_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiMscMemoryReads";
    counter->symbol_name = "GtiMscMemoryReads";
    counter->desc = "The total number of GTI memory reads from Multisampling Color Cache (Multisampling Color Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__memory_reads__gti_msc_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRccMemoryReads";
    counter->symbol_name = "GtiRccMemoryReads";
    counter->desc = "The total number of GTI memory reads from Render Color Cache (Render Color Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__memory_reads__gti_rcc_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRczMemoryReads";
    counter->symbol_name = "GtiRczMemoryReads";
    counter->desc = "The total number of GTI memory reads from Render Depth Cache (Render Depth Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__memory_reads__gti_rcz_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRingAccesses";
    counter->symbol_name = "GtiRingAccesses";
    counter->desc = "The total number of all accesses from GTI to the ring.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__memory_reads__gti_ring_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRsMemoryReads";
    counter->symbol_name = "GtiRsMemoryReads";
    counter->desc = "The total number of GTI memory reads from Resource Streamer.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__memory_reads__gti_rs_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Resource Streamer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiStcMemoryReads";
    counter->symbol_name = "GtiStcMemoryReads";
    counter->desc = "The total number of GTI memory reads from Stencil Cache (Stencil Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__memory_reads__gti_stc_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiVfMemoryReads";
    counter->symbol_name = "GtiVfMemoryReads";
    counter->desc = "The total number of GTI memory reads from Vertex Fetch.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__memory_reads__gti_vf_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Vertex Fetch");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__memory_reads__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__memory_reads__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__memory_reads__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__memory_reads__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__memory_reads__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bxt__memory_reads__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bxt__memory_reads__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__memory_reads__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__memory_reads__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__memory_reads__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__memory_reads__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__memory_reads__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__memory_reads__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bxt__memory_reads__slm_bytes_read__read;
    counter->max_uint64 = bxt__memory_reads__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bxt__memory_reads__slm_bytes_written__read;
    counter->max_uint64 = bxt__memory_reads__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__memory_reads__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 41);
}

static void
bxt_add_memory_writes_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Memory Writes Distribution Gen9";
    metric_set->symbol_name = "MemoryWrites";
    metric_set->hw_config_guid = "d324a0d6-7269-4847-a5c2-6f71ddc7fed5";
    metric_set->counters = calloc(41, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(44, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(32, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19800343 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x39900340 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03803180 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058035E2 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0780006A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2181A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2381000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D950550 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B928000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D92A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F922000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13900180 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21900181 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x23900182 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25900183 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x27900184 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x29900185 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B900186 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D900187 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F900170 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31900125 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15900123 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17900121 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43901084 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47901080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49901084 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B901084 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D900004 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000272C, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002728, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000271C, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002718, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000274C, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002748, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00006667 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000275C, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002758, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002754, .val = 0x00006465 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002750, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007F81A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x0007F82A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x0007F822 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x0007F8BA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x0007F87A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x0007F8EA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x0007F8E2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x0007F8F2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000FE00 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00025024 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00035034 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00045044 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00055054 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00065064 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = bxt__memory_writes__avg_gpu_core_frequency__read;
    counter->max_uint64 = bxt__memory_writes__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__memory_writes__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__memory_writes__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__memory_writes__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__memory_writes__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__memory_writes__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__memory_writes__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = bxt__memory_writes__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = bxt__memory_writes__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__memory_writes__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiCmdStreamerMemoryWrites";
    counter->symbol_name = "GtiCmdStreamerMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Command Streamer.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__memory_writes__gti_cmd_streamer_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Command Streamer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiHizMemoryWrites";
    counter->symbol_name = "GtiHizMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Hierarchical Depth Cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__memory_writes__gti_hiz_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank0Writes";
    counter->symbol_name = "GtiL3Bank0Writes";
    counter->desc = "The total number of GTI memory writes from L3 Bank 0 (L3 Bank 0 invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__memory_writes__gti_l3_bank0_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank1Writes";
    counter->symbol_name = "GtiL3Bank1Writes";
    counter->desc = "The total number of GTI memory writes from L3 Bank 1 (L3 Bank 1 invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__memory_writes__gti_l3_bank1_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank2Writes";
    counter->symbol_name = "GtiL3Bank2Writes";
    counter->desc = "The total number of GTI memory writes from L3 Bank 2 (L3 Bank 2 invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__memory_writes__gti_l3_bank2_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank3Writes";
    counter->symbol_name = "GtiL3Bank3Writes";
    counter->desc = "The total number of GTI memory writes from L3 Bank 3 (L3 Bank 3 invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__memory_writes__gti_l3_bank3_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Writes";
    counter->symbol_name = "GtiL3Writes";
    counter->desc = "The total number of GTI memory writes from L3 (L3 invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__memory_writes__gti_l3_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiMemoryWrites";
    counter->symbol_name = "GtiMemoryWrites";
    counter->desc = "The total number of GTI memory writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__memory_writes__gti_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiMscMemoryWrites";
    counter->symbol_name = "GtiMscMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Multisampling Color Cache (Multisampling Color Cache invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__memory_writes__gti_msc_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRccMemoryWrites";
    counter->symbol_name = "GtiRccMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Render Color Cache (Render Color Cache invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__memory_writes__gti_rcc_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRczMemoryWrites";
    counter->symbol_name = "GtiRczMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Render Depth Cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__memory_writes__gti_rcz_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRingAccesses";
    counter->symbol_name = "GtiRingAccesses";
    counter->desc = "The total number of all GTI accesses to the ring.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__memory_writes__gti_ring_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiSoMemoryWrites";
    counter->symbol_name = "GtiSoMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Stream Output.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__memory_writes__gti_so_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Stream Output");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiStcMemoryWrites";
    counter->symbol_name = "GtiStcMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Stencil Cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__memory_writes__gti_stc_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__memory_writes__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__memory_writes__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bxt__memory_writes__l3_shader_throughput__read;
    counter->max_uint64 = bxt__memory_writes__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__memory_writes__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__memory_writes__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__memory_writes__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bxt__memory_writes__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bxt__memory_writes__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__memory_writes__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__memory_writes__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__memory_writes__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__memory_writes__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__memory_writes__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__memory_writes__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bxt__memory_writes__slm_bytes_read__read;
    counter->max_uint64 = bxt__memory_writes__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bxt__memory_writes__slm_bytes_written__read;
    counter->max_uint64 = bxt__memory_writes__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__memory_writes__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 41);
}

static void
bxt_add_compute_extended_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Compute Metrics Extended Gen9";
    metric_set->symbol_name = "ComputeExtended";
    metric_set->hw_config_guid = "caf3596a-7bb1-4dec-b3b3-2a080d283b49";
    metric_set->counters = calloc(38, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(93, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(21, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x104F00E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141C0160 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x161C0015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181C0120 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002D5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082D5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2D5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2D5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2D5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022D5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042D5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2E5400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2E5515 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x102E0155 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E4CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x104C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x124C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x144C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x164C2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004EA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084EA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4EA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4EA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E4EA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x024EA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044EA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E4F4B41 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004F4200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x024F404C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C4F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A4F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x061B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x081BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001C0031 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x061C1900 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x081C1A33 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1C1B35 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1C3337 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041C31C7 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x180F5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A0FA8AA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C0F0AAA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x182C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C2C6AAA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E2C0001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A2C2950 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1993AAAA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x23904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x27904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x29904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900420 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D900001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900001 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007FC2A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x0007FC6A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x0007FC92 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x0007FCA2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x0007FC32 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x0007FC9A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x0007FE6A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x0007FE7A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000BF00 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00000003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00002001 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00778008 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00088078 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00808708 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00A08908 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = bxt__compute_extended__avg_gpu_core_frequency__read;
    counter->max_uint64 = bxt__compute_extended__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__compute_extended__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuA64UntypedReads0";
    counter->symbol_name = "EuA64UntypedReads0";
    counter->desc = "The subslice 0 EU A64 Untyped Reads subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__compute_extended__eu_a64_untyped_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuA64UntypedWrites0";
    counter->symbol_name = "EuA64UntypedWrites0";
    counter->desc = "The subslice 0 EU A64 Untyped Writes subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__compute_extended__eu_a64_untyped_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__compute_extended__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU AVG IPC Rate";
    counter->symbol_name = "EuAvgIpcRate";
    counter->desc = "The average rate of IPC calculated for 2 FPU pipelines.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NUMBER;
    counter->read_float = bxt__compute_extended__eu_avg_ipc_rate__read;
    counter->max_float = bxt__compute_extended__eu_avg_ipc_rate__max;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__compute_extended__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Send Pipe Active";
    counter->symbol_name = "EuSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__compute_extended__eu_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__compute_extended__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Thread Occupancy";
    counter->symbol_name = "EuThreadOccupancy";
    counter->desc = "The percentage of time in which hardware threads occupied EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__compute_extended__eu_thread_occupancy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuTypedAtomics0";
    counter->symbol_name = "EuTypedAtomics0";
    counter->desc = "The subslice 0 EU Typed Atomics subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__compute_extended__eu_typed_atomics0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuTypedReads0";
    counter->symbol_name = "EuTypedReads0";
    counter->desc = "The subslice 0 EU Typed Reads subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__compute_extended__eu_typed_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuTypedWrites0";
    counter->symbol_name = "EuTypedWrites0";
    counter->desc = "The subslice 0 EU Typed Writes subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__compute_extended__eu_typed_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuUntypedAtomics0";
    counter->symbol_name = "EuUntypedAtomics0";
    counter->desc = "The subslice 0 EU Untyped Atomics subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__compute_extended__eu_untyped_atomics0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuUntypedReads0";
    counter->symbol_name = "EuUntypedReads0";
    counter->desc = "The subslice 0 EU Untyped Reads subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__compute_extended__eu_untyped_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuUntypedWrites0";
    counter->symbol_name = "EuUntypedWrites0";
    counter->desc = "The subslice 0 EU Untyped Writes subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__compute_extended__eu_untyped_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Pipe Active";
    counter->symbol_name = "Fpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__compute_extended__fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active";
    counter->symbol_name = "Fpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__compute_extended__fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = bxt__compute_extended__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = bxt__compute_extended__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bxt__compute_extended__l3_shader_throughput__read;
    counter->max_uint64 = bxt__compute_extended__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bxt__compute_extended__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bxt__compute_extended__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__compute_extended__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__compute_extended__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__compute_extended__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bxt__compute_extended__slm_bytes_read__read;
    counter->max_uint64 = bxt__compute_extended__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bxt__compute_extended__slm_bytes_written__read;
    counter->max_uint64 = bxt__compute_extended__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Atomics 0";
    counter->symbol_name = "TypedAtomics0";
    counter->desc = "The subslice 0 typed atomics.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__compute_extended__typed_atomics0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TypedAtomicsPerCacheLine";
    counter->symbol_name = "TypedAtomicsPerCacheLine";
    counter->desc = "The ratio of EU typed atomics requests to L3 cache line writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
    counter->read_float = bxt__compute_extended__typed_atomics_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Reads 0";
    counter->symbol_name = "TypedReads0";
    counter->desc = "The subslice 0 typed reads.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__compute_extended__typed_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TypedReadsPerCacheLine";
    counter->symbol_name = "TypedReadsPerCacheLine";
    counter->desc = "The ratio of EU typed read requests to L3 cache line reads.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
    counter->read_float = bxt__compute_extended__typed_reads_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Writes 0";
    counter->symbol_name = "TypedWrites0";
    counter->desc = "The subslice 0 typed writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__compute_extended__typed_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TypedWritesPerCacheLine";
    counter->symbol_name = "TypedWritesPerCacheLine";
    counter->desc = "The ratio of EU typed write requests to L3 cache line writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
    counter->read_float = bxt__compute_extended__typed_writes_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Untyped Reads 0";
    counter->symbol_name = "UntypedReads0";
    counter->desc = "The subslice 0 untyped reads (including SLM reads).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__compute_extended__untyped_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "UntypedReadsPerCacheLine";
    counter->symbol_name = "UntypedReadsPerCacheLine";
    counter->desc = "The ratio of EU untyped read requests to L3 cache line reads.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
    counter->read_float = bxt__compute_extended__untyped_reads_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Untyped Writes 0";
    counter->symbol_name = "UntypedWrites0";
    counter->desc = "The subslice 0 untyped writes (including SLM writes).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__compute_extended__untyped_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "UntypedWritesPerCacheLine";
    counter->symbol_name = "UntypedWritesPerCacheLine";
    counter->desc = "The ratio of EU untyped write requests to L3 cache line writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
    counter->read_float = bxt__compute_extended__untyped_writes_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    assert(metric_set->n_counters <= 38);
}

static void
bxt_add_compute_l3_cache_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Compute Metrics L3 Cache Gen9";
    metric_set->symbol_name = "ComputeL3Cache";
    metric_set->hw_config_guid = "49b956e2-d5b9-47e0-9d8a-cee5e8cec527";
    metric_set->counters = calloc(54, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(68, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(13, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x166C03B0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1593001E };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F900C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002D1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082D5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2D5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2E0400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2E1500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x102E0140 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x144C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x164C2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004E2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084EA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E4EA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A4F4001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C4F5005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x006C0051 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x066C5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x086C5C5D };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E6C5E5F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x146C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x180F1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A0FA800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C0F0A00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x182C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C2C4015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E2C0001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03931980 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05930032 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11930000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1993A00A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07930000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09930000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D900177 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F900178 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x23904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53901000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900111 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900400 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FEFE };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x0007FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FEFD };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x0007FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FBEF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x0007FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FBDF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00000003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00002001 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00101100 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00201200 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00301300 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00401400 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = bxt__compute_l3_cache__avg_gpu_core_frequency__read;
    counter->max_uint64 = bxt__compute_l3_cache__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__compute_l3_cache__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__compute_l3_cache__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__compute_l3_cache__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__compute_l3_cache__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU AVG IPC Rate";
    counter->symbol_name = "EuAvgIpcRate";
    counter->desc = "The average rate of IPC calculated for 2 FPU pipelines.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NUMBER;
    counter->read_float = bxt__compute_l3_cache__eu_avg_ipc_rate__read;
    counter->max_float = bxt__compute_l3_cache__eu_avg_ipc_rate__max;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Binary Instruction";
    counter->symbol_name = "EuBinaryFpu0Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing binary instructions on FPU0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__compute_l3_cache__eu_binary_fpu0_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Binary Instruction";
    counter->symbol_name = "EuBinaryFpu1Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing binary instructions on FPU1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__compute_l3_cache__eu_binary_fpu1_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__compute_l3_cache__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Hybrid Instruction";
    counter->symbol_name = "EuHybridFpu0Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing hybrid instructions on FPU0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__compute_l3_cache__eu_hybrid_fpu0_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Hybrid Instruction";
    counter->symbol_name = "EuHybridFpu1Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing hybrid instructions on FPU1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__compute_l3_cache__eu_hybrid_fpu1_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Move Instruction";
    counter->symbol_name = "EuMoveFpu0Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing move instructions on FPU0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__compute_l3_cache__eu_move_fpu0_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Move Instruction";
    counter->symbol_name = "EuMoveFpu1Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing move instructions on FPU1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__compute_l3_cache__eu_move_fpu1_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Send Pipe Active";
    counter->symbol_name = "EuSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__compute_l3_cache__eu_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__compute_l3_cache__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Ternary Instruction";
    counter->symbol_name = "EuTernaryFpu0Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing ternary instructions on FPU0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__compute_l3_cache__eu_ternary_fpu0_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Ternary Instruction";
    counter->symbol_name = "EuTernaryFpu1Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing ternary instructions on FPU1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__compute_l3_cache__eu_ternary_fpu1_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Pipe Active";
    counter->symbol_name = "Fpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__compute_l3_cache__fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active";
    counter->symbol_name = "Fpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__compute_l3_cache__fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__compute_l3_cache__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = bxt__compute_l3_cache__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = bxt__compute_l3_cache__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__compute_l3_cache__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI L3 Throughput";
    counter->symbol_name = "GtiL3Throughput";
    counter->desc = "The total number of GPU memory bytes transferred between L3 caches and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bxt__compute_l3_cache__gti_l3_throughput__read;
    counter->max_uint64 = bxt__compute_l3_cache__gti_l3_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Read Throughput";
    counter->symbol_name = "GtiReadThroughput";
    counter->desc = "The total number of GPU memory bytes read from GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bxt__compute_l3_cache__gti_read_throughput__read;
    counter->max_uint64 = bxt__compute_l3_cache__gti_read_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Write Throughput";
    counter->symbol_name = "GtiWriteThroughput";
    counter->desc = "The total number of GPU memory bytes written to GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bxt__compute_l3_cache__gti_write_throughput__read;
    counter->max_uint64 = bxt__compute_l3_cache__gti_write_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__compute_l3_cache__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__compute_l3_cache__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Accesses";
    counter->symbol_name = "L3Accesses";
    counter->desc = "The total number of L3 accesses from all entities.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__compute_l3_cache__l3_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3");

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 00 Accesses";
        counter->symbol_name = "L3Bank00Accesses";
        counter->desc = "The total number of accesses to L3 Bank 00.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = bxt__compute_l3_cache__l3_bank00_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 00 IC Accesses";
        counter->symbol_name = "L3Bank00IcAccesses";
        counter->desc = "The total number of accesses to L3 Bank 00 from IC cache.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = bxt__compute_l3_cache__l3_bank00_ic_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3/IC");
    }

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 00 IC Hits";
        counter->symbol_name = "L3Bank00IcHits";
        counter->desc = "The total number of hits in L3 Bank 00 from IC cache.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = bxt__compute_l3_cache__l3_bank00_ic_hits__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3/IC");
    }

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 01 Accesses";
        counter->symbol_name = "L3Bank01Accesses";
        counter->desc = "The total number of accesses to L3 Bank 01.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = bxt__compute_l3_cache__l3_bank01_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 02 Accesses";
        counter->symbol_name = "L3Bank02Accesses";
        counter->desc = "The total number of accesses to L3 Bank 02.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = bxt__compute_l3_cache__l3_bank02_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 03 Accesses";
        counter->symbol_name = "L3Bank03Accesses";
        counter->desc = "The total number of accesses to L3 Bank 03.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = bxt__compute_l3_cache__l3_bank03_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Misses";
    counter->symbol_name = "L3Misses";
    counter->desc = "The total number of L3 misses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__compute_l3_cache__l3_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/TAG");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Sampler Throughput";
    counter->symbol_name = "L3SamplerThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between samplers and L3 caches.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bxt__compute_l3_cache__l3_sampler_throughput__read;
    counter->max_uint64 = bxt__compute_l3_cache__l3_sampler_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bxt__compute_l3_cache__l3_shader_throughput__read;
    counter->max_uint64 = bxt__compute_l3_cache__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Total Throughput";
    counter->symbol_name = "L3TotalThroughput";
    counter->desc = "The total number of GPU memory bytes transferred via L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bxt__compute_l3_cache__l3_total_throughput__read;
    counter->max_uint64 = bxt__compute_l3_cache__l3_total_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__compute_l3_cache__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__compute_l3_cache__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__compute_l3_cache__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Accesses";
    counter->symbol_name = "SamplerAccesses";
    counter->desc = "The total number of messages send to samplers.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__compute_l3_cache__sampler_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bxt__compute_l3_cache__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bxt__compute_l3_cache__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__compute_l3_cache__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__compute_l3_cache__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__compute_l3_cache__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__compute_l3_cache__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__compute_l3_cache__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__compute_l3_cache__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bxt__compute_l3_cache__slm_bytes_read__read;
    counter->max_uint64 = bxt__compute_l3_cache__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bxt__compute_l3_cache__slm_bytes_written__read;
    counter->max_uint64 = bxt__compute_l3_cache__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__compute_l3_cache__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 54);
}

static void
bxt_add_hdc_and_sf_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set HDCAndSF";
    metric_set->symbol_name = "HDCAndSF";
    metric_set->hw_config_guid = "ad9d9bc2-ccb7-4f5d-adbb-b4e67e615efd";
    metric_set->counters = calloc(39, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(43, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(8, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x104F0232 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x124F4640 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11834400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042D5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062D1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2E0055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x024E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044EA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064E2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x024F6100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044F416B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064F004B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A4F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A0F02A8 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A2C5500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F808000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25810020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8305C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F951000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13920200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D900003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x10800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FDFF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = bxt__hdc_and_sf__avg_gpu_core_frequency__read;
    counter->max_uint64 = bxt__hdc_and_sf__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__hdc_and_sf__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__hdc_and_sf__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__hdc_and_sf__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__hdc_and_sf__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__hdc_and_sf__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__hdc_and_sf__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bxt__hdc_and_sf__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__hdc_and_sf__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = bxt__hdc_and_sf__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = bxt__hdc_and_sf__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__hdc_and_sf__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__hdc_and_sf__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__hdc_and_sf__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bxt__hdc_and_sf__l3_shader_throughput__read;
    counter->max_uint64 = bxt__hdc_and_sf__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "HDC stalled by L3 (s0.ss0)";
        counter->symbol_name = "NonSamplerShader00AccessStalledOnL3";
        counter->desc = "Percentage of time when HDC has messges to L3, but it's stalled due to lack of credits (s0.ss0)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bxt__hdc_and_sf__non_sampler_shader00_access_stalled_on_l3__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Data Port");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "HDC stalled by L3 (s0.ss1)";
        counter->symbol_name = "NonSamplerShader01AccessStalledOnL3";
        counter->desc = "Percentage of time when HDC has messges to L3, but it's stalled due to lack of credits (s0.ss1)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bxt__hdc_and_sf__non_sampler_shader01_access_stalled_on_l3__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Data Port");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__hdc_and_sf__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Polygon Data Ready";
    counter->symbol_name = "PolyDataReady";
    counter->desc = "The percentage of time in which geometry pipeline output is ready";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__hdc_and_sf__poly_data_ready__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe/Strip-Fans");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__hdc_and_sf__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__hdc_and_sf__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__hdc_and_sf__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__hdc_and_sf__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__hdc_and_sf__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__hdc_and_sf__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bxt__hdc_and_sf__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bxt__hdc_and_sf__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__hdc_and_sf__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__hdc_and_sf__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__hdc_and_sf__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__hdc_and_sf__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__hdc_and_sf__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__hdc_and_sf__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bxt__hdc_and_sf__slm_bytes_read__read;
    counter->max_uint64 = bxt__hdc_and_sf__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bxt__hdc_and_sf__slm_bytes_written__read;
    counter->max_uint64 = bxt__hdc_and_sf__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__hdc_and_sf__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__hdc_and_sf__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__hdc_and_sf__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__hdc_and_sf__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 39);
}

static void
bxt_add_l3_1_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set L3_1";
    metric_set->symbol_name = "L3_1";
    metric_set->hw_config_guid = "bde7b434-349c-4aad-8596-eb23c0352168";
    metric_set->counters = calloc(40, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(156, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(22, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    if (perf->devinfo.revision >= 0x03) {
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12643400 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12653400 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C6800 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x126C001E };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x166C0010 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2D5000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2D5000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002D4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022D5000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042D5000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062D1000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x102E0154 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2E5000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2E0055 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x104C8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x124C8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x144C8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x164C2000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044C8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064CC000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084CC000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4EA000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E4EA000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004E8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x024EA000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044EA000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064E2000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C4F5500 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A4F1554 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A640024 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10640000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04640000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C650024 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10650000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06650000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C6C5327 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E6C5425 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x006C2A00 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x026C285B };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x046C005C };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C6C0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6C0900 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C0F0AA0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x180F4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A0F02AA };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C2C5400 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E2C0001 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A2C5550 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1993AA00 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03938000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05938000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07938000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09938000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B938000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D938000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B904000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D904000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F904000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31904000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15904000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17904000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19904000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B904000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D904000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F904000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900421 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D900001 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900420 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900021 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900000 };
    }

    if (perf->devinfo.revision < 0x03) {
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14640340 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14650340 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C6800 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x126C001E };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x166C0010 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2D5000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2D5000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002D4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022D5000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042D5000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062D1000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x102E0154 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2E5000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2E0055 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x104C8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x124C8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x144C8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x164C2000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044C8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064CC000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084CC000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4EA000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E4EA000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004E8000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x024EA000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044EA000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064E2000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C4F5500 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A4F1554 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04642400 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x22640000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A640000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06650024 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x22650000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C650000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C6C5327 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E6C5425 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x006C2A00 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x026C285B };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x046C005C };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C6C0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6C0900 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C0F0AA0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x180F4000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A0F02AA };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C2C5400 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E2C0001 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A2C5550 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1993AA00 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03938000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05938000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07938000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09938000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B938000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D938000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B904000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D904000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F904000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31904000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15904000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17904000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19904000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B904000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D904000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F904000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900421 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D900001 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900420 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900021 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900000 };
    }

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00100070 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFF1 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00014002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000C3FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00010002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000C7FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00004002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000D3FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00100700 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FF1F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00001402 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FC3F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x00001002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FC7F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x00000402 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000FD3F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = bxt__l3_1__avg_gpu_core_frequency__read;
    counter->max_uint64 = bxt__l3_1__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__l3_1__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__l3_1__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__l3_1__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__l3_1__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__l3_1__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__l3_1__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bxt__l3_1__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__l3_1__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = bxt__l3_1__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = bxt__l3_1__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__l3_1__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__l3_1__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__l3_1__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank0 Active";
        counter->symbol_name = "L30Bank0Active";
        counter->desc = "The percentage of time in which slice0 L3 bank0 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bxt__l3_1__l30_bank0_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank0 Stalled";
        counter->symbol_name = "L30Bank0Stalled";
        counter->desc = "The percentage of time in which slice0 L3 bank0 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bxt__l3_1__l30_bank0_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank1 Active";
        counter->symbol_name = "L30Bank1Active";
        counter->desc = "The percentage of time in which slice0 L3 bank1 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bxt__l3_1__l30_bank1_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank1 Stalled";
        counter->symbol_name = "L30Bank1Stalled";
        counter->desc = "The percentage of time in which slice0 L3 bank1 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bxt__l3_1__l30_bank1_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bxt__l3_1__l3_shader_throughput__read;
    counter->max_uint64 = bxt__l3_1__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__l3_1__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__l3_1__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__l3_1__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__l3_1__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__l3_1__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__l3_1__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__l3_1__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bxt__l3_1__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bxt__l3_1__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__l3_1__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__l3_1__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__l3_1__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__l3_1__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__l3_1__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__l3_1__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bxt__l3_1__slm_bytes_read__read;
    counter->max_uint64 = bxt__l3_1__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bxt__l3_1__slm_bytes_written__read;
    counter->max_uint64 = bxt__l3_1__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__l3_1__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__l3_1__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__l3_1__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__l3_1__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 40);
}

static void
bxt_add_rasterizer_and_pixel_backend_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set RasterizerAndPixelBackend";
    metric_set->symbol_name = "RasterizerAndPixelBackend";
    metric_set->hw_config_guid = "f3d845e6-bfc3-4ffe-b0e5-dddc80c21f07";
    metric_set->counters = calloc(41, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(42, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(10, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x102D7800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x122D79E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2F0004 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100E3800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x180F0005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002D0940 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022D802F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042D4013 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062D1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2E0050 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022F0010 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064E2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040E0480 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000E0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060F0027 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A0F0040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x439014A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x459000A4 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000EFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00006000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000F3FF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = bxt__rasterizer_and_pixel_backend__avg_gpu_core_frequency__read;
    counter->max_uint64 = bxt__rasterizer_and_pixel_backend__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__rasterizer_and_pixel_backend__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__rasterizer_and_pixel_backend__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__rasterizer_and_pixel_backend__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__rasterizer_and_pixel_backend__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__rasterizer_and_pixel_backend__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__rasterizer_and_pixel_backend__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bxt__rasterizer_and_pixel_backend__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__rasterizer_and_pixel_backend__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = bxt__rasterizer_and_pixel_backend__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = bxt__rasterizer_and_pixel_backend__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__rasterizer_and_pixel_backend__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__rasterizer_and_pixel_backend__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__rasterizer_and_pixel_backend__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bxt__rasterizer_and_pixel_backend__l3_shader_throughput__read;
    counter->max_uint64 = bxt__rasterizer_and_pixel_backend__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 PS Output Available";
        counter->symbol_name = "PSOutput0Available";
        counter->desc = "The percentage of time in which slice0 PS output is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bxt__rasterizer_and_pixel_backend__ps_output0_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Post-EarlyZ Pixel Data Ready";
        counter->symbol_name = "PixelData0Ready";
        counter->desc = "The percentage of time in which slice0 post-EarlyZ pixel data is ready (after early Z tests have been applied)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bxt__rasterizer_and_pixel_backend__pixel_data0_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Rasterizer/Early Depth Test");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Pixel Values Ready";
        counter->symbol_name = "PixelValues0Ready";
        counter->desc = "The percentage of time in which slice0 pixel values are ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bxt__rasterizer_and_pixel_backend__pixel_values0_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__rasterizer_and_pixel_backend__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__rasterizer_and_pixel_backend__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__rasterizer_and_pixel_backend__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__rasterizer_and_pixel_backend__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__rasterizer_and_pixel_backend__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__rasterizer_and_pixel_backend__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__rasterizer_and_pixel_backend__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Rasterizer Input Available";
        counter->symbol_name = "Rasterizer0InputAvailable";
        counter->desc = "The percentage of time in which slice0 rasterizer input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bxt__rasterizer_and_pixel_backend__rasterizer0_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Rasterizer");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Rasterizer Output Ready";
        counter->symbol_name = "Rasterizer0OutputReady";
        counter->desc = "The percentage of time in which slice0 rasterizer output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bxt__rasterizer_and_pixel_backend__rasterizer0_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Rasterizer");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bxt__rasterizer_and_pixel_backend__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bxt__rasterizer_and_pixel_backend__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__rasterizer_and_pixel_backend__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__rasterizer_and_pixel_backend__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__rasterizer_and_pixel_backend__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__rasterizer_and_pixel_backend__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__rasterizer_and_pixel_backend__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__rasterizer_and_pixel_backend__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bxt__rasterizer_and_pixel_backend__slm_bytes_read__read;
    counter->max_uint64 = bxt__rasterizer_and_pixel_backend__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bxt__rasterizer_and_pixel_backend__slm_bytes_written__read;
    counter->max_uint64 = bxt__rasterizer_and_pixel_backend__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__rasterizer_and_pixel_backend__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__rasterizer_and_pixel_backend__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__rasterizer_and_pixel_backend__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__rasterizer_and_pixel_backend__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 41);
}

static void
bxt_add_sampler_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set Sampler";
    metric_set->symbol_name = "Sampler";
    metric_set->hw_config_guid = "a53d620b-c14e-49df-bd27-e076b3fb98f3";
    metric_set->counters = calloc(42, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(94, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(12, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x121300A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141600AB };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x123300A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x143600AB };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x125300A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x145600AB };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2D5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022D5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042D5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062D1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x102E01A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2E5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2E0065 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x164C2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x024EA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044E2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064E2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C0F0800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x180F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A0F023F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E2C0003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A2CC030 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04132180 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02130000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E142000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E150140 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C150040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C163000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E160068 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10160000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18160000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A164000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04330043 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02330000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0234A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04342000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C350015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02363460 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10360000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04360000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06360000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08364000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06530043 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02530000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E548000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00548000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06542000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E550400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A552000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C550100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E563000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00563400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10560000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18560000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02560000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C564000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1993A800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B9014A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D900001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900820 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45901022 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x70800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0000C000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000E7FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00003000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000F9FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000C00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FE7F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = bxt__sampler__avg_gpu_core_frequency__read;
    counter->max_uint64 = bxt__sampler__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__sampler__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__sampler__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__sampler__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__sampler__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__sampler__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__sampler__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bxt__sampler__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__sampler__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = bxt__sampler__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = bxt__sampler__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__sampler__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__sampler__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__sampler__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bxt__sampler__l3_shader_throughput__read;
    counter->max_uint64 = bxt__sampler__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__sampler__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__sampler__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__sampler__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__sampler__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__sampler__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__sampler__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__sampler__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice0 Input Available";
        counter->symbol_name = "Sampler00InputAvailable";
        counter->desc = "The percentage of time in which slice0 subslice0 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bxt__sampler__sampler00_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice0 Sampler Output Ready";
        counter->symbol_name = "Sampler00OutputReady";
        counter->desc = "The percentage of time in which slice0 subslice0 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bxt__sampler__sampler00_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice1 Input Available";
        counter->symbol_name = "Sampler01InputAvailable";
        counter->desc = "The percentage of time in which slice0 subslice1 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bxt__sampler__sampler01_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice1 Sampler Output Ready";
        counter->symbol_name = "Sampler01OutputReady";
        counter->desc = "The percentage of time in which slice0 subslice1 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bxt__sampler__sampler01_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice2 Input Available";
        counter->symbol_name = "Sampler02InputAvailable";
        counter->desc = "The percentage of time in which slice0 subslice2 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bxt__sampler__sampler02_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice2 Sampler Output Ready";
        counter->symbol_name = "Sampler02OutputReady";
        counter->desc = "The percentage of time in which slice0 subslice2 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bxt__sampler__sampler02_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bxt__sampler__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bxt__sampler__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__sampler__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__sampler__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__sampler__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__sampler__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__sampler__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__sampler__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bxt__sampler__slm_bytes_read__read;
    counter->max_uint64 = bxt__sampler__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bxt__sampler__slm_bytes_written__read;
    counter->max_uint64 = bxt__sampler__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__sampler__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__sampler__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__sampler__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__sampler__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 42);
}

static void
bxt_add_tdl_1_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set TDL_1";
    metric_set->symbol_name = "TDL_1";
    metric_set->hw_config_guid = "8a44b172-6e1d-445f-8937-c06cc487ba39";
    metric_set->counters = calloc(42, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(87, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(18, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x143A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x145A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2D5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022D5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042D5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062D1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x102E0150 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2E5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2E006A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x124C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x144C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x164C2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E4EA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x024E2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064E2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C0F0BC0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x180F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A0F0302 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E2C0003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A2C00F0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021A3080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041A31E5 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0414A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C150054 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06168000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08168000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A168000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C3A3280 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E3A0063 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x063A0061 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x023A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C348000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E342000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06342000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E350140 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C350100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18360028 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C368000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E5A3080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x005A3280 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x025A0063 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E548000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00548000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02542000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E550400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A552000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C550001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18560080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02568000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04568000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1993A800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900420 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45901084 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900001 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x00007FFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x00009FFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000EFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000F3FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FDFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FE7F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = bxt__tdl_1__avg_gpu_core_frequency__read;
    counter->max_uint64 = bxt__tdl_1__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__tdl_1__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__tdl_1__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__tdl_1__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__tdl_1__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__tdl_1__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__tdl_1__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bxt__tdl_1__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__tdl_1__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = bxt__tdl_1__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = bxt__tdl_1__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__tdl_1__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__tdl_1__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__tdl_1__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bxt__tdl_1__l3_shader_throughput__read;
    counter->max_uint64 = bxt__tdl_1__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "NonPS Thread Ready For Dispatch on Slice0 Subslice0";
        counter->symbol_name = "NonPSThread00ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice0 subslice0 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bxt__tdl_1__non_ps_thread00_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "NonPS Thread Ready For Dispatch on Slice0 Subslice1";
        counter->symbol_name = "NonPSThread01ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice0 subslice1 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bxt__tdl_1__non_ps_thread01_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "NonPS Thread Ready For Dispatch on Slice0 Subslice2";
        counter->symbol_name = "NonPSThread02ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice0 subslice2 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bxt__tdl_1__non_ps_thread02_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice0 Subslice0";
        counter->symbol_name = "PSThread00ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice0 subslice0 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bxt__tdl_1__ps_thread00_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice0 Subslice1";
        counter->symbol_name = "PSThread01ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice0 subslice1 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bxt__tdl_1__ps_thread01_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice0 Subslice2";
        counter->symbol_name = "PSThread02ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice0 subslice2 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bxt__tdl_1__ps_thread02_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__tdl_1__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__tdl_1__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__tdl_1__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__tdl_1__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__tdl_1__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__tdl_1__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__tdl_1__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bxt__tdl_1__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bxt__tdl_1__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__tdl_1__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__tdl_1__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__tdl_1__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__tdl_1__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__tdl_1__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__tdl_1__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bxt__tdl_1__slm_bytes_read__read;
    counter->max_uint64 = bxt__tdl_1__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bxt__tdl_1__slm_bytes_written__read;
    counter->max_uint64 = bxt__tdl_1__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__tdl_1__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__tdl_1__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__tdl_1__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__tdl_1__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 42);
}

static void
bxt_add_tdl_2_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set TDL_2";
    metric_set->symbol_name = "TDL_2";
    metric_set->hw_config_guid = "9d4643f8-aa05-482e-8193-070a8ab0d117";
    metric_set->counters = calloc(42, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(59, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(6, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141A026B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x143A0173 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x145A026B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022D5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042D5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062D1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2E5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2E0069 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x024EA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064E2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x180F6000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A0F030A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A2C03C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041A37E7 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0414A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C150050 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08168000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A168000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x003A3380 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x063A006F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x023A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00348000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06342000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A352000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C350100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02368000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C368000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x025A37E7 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0254A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C550005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04568000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06568000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45901080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = bxt__tdl_2__avg_gpu_core_frequency__read;
    counter->max_uint64 = bxt__tdl_2__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__tdl_2__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__tdl_2__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__tdl_2__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__tdl_2__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__tdl_2__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__tdl_2__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bxt__tdl_2__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__tdl_2__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = bxt__tdl_2__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = bxt__tdl_2__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__tdl_2__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__tdl_2__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__tdl_2__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bxt__tdl_2__l3_shader_throughput__read;
    counter->max_uint64 = bxt__tdl_2__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__tdl_2__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__tdl_2__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__tdl_2__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__tdl_2__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__tdl_2__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__tdl_2__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__tdl_2__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bxt__tdl_2__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = bxt__tdl_2__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__tdl_2__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__tdl_2__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = bxt__tdl_2__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__tdl_2__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__tdl_2__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = bxt__tdl_2__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bxt__tdl_2__slm_bytes_read__read;
    counter->max_uint64 = bxt__tdl_2__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = bxt__tdl_2__slm_bytes_written__read;
    counter->max_uint64 = bxt__tdl_2__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice0 Port 0";
        counter->symbol_name = "ThreadHeader00ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice0 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bxt__tdl_2__thread_header00_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice0 Port 1";
        counter->symbol_name = "ThreadHeader00ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice0 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bxt__tdl_2__thread_header00_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice1 Port 0";
        counter->symbol_name = "ThreadHeader01ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice1 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bxt__tdl_2__thread_header01_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice1 Port 1";
        counter->symbol_name = "ThreadHeader01ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice1 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bxt__tdl_2__thread_header01_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice2 Port 0";
        counter->symbol_name = "ThreadHeader02ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice2 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bxt__tdl_2__thread_header02_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice2 Port 1";
        counter->symbol_name = "ThreadHeader02ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice2 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bxt__tdl_2__thread_header02_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__tdl_2__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__tdl_2__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__tdl_2__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = bxt__tdl_2__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 42);
}

static void
bxt_add_compute_extra_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Compute Metrics Extra Gen9";
    metric_set->symbol_name = "ComputeExtra";
    metric_set->hw_config_guid = "fa6ecf21-2cb8-4d0b-9308-6e4a7b4ca87a";
    metric_set->counters = calloc(5, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(37, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(6, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141A001F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x143A001F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x145A001F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042D5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062D1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2E0094 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044EA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A0F00E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A2C0C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x061A0063 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06142000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C150100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C168000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x043A3180 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x023A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04348000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C350040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A368000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x045A0063 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x025A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04542000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C550010 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08568000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900004 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00001000 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00003002 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00011010 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00050012 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00052051 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00000008 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = bxt__compute_extra__avg_gpu_core_frequency__read;
    counter->max_uint64 = bxt__compute_extra__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active";
    counter->symbol_name = "Fpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__compute_extra__fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active including Ext Math";
    counter->symbol_name = "Fpu1ActiveAdjusted";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing including Extended Math processing";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__compute_extra__fpu1_active_adjusted__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = bxt__compute_extra__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = bxt__compute_extra__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    assert(metric_set->n_counters <= 5);
}

static void
bxt_add_gpu_busyness_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Gpu Rings Busyness";
    metric_set->symbol_name = "GpuBusyness";
    metric_set->hw_config_guid = "c9f5fa3a-d14f-400c-a89a-211206b00ee7";
    metric_set->counters = calloc(8, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(30, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13805800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05962C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19950016 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21C05800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07800035 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x23810008 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07960025 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D960000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F960000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B934000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09948000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05950085 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11950000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D950400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B924000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D922000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F922000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0BC000A5 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900442 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x10800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00078000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x00000FFF };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AnyRingBusy";
    counter->symbol_name = "AnyRingBusy";
    counter->desc = "The percentage of time when any command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__gpu_busyness__any_ring_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = bxt__gpu_busyness__avg_gpu_core_frequency__read;
    counter->max_uint64 = bxt__gpu_busyness__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Blitter Ring Busy";
    counter->symbol_name = "BlitterBusy";
    counter->desc = "The percentage of time when blitter command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__gpu_busyness__blitter_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = bxt__gpu_busyness__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = bxt__gpu_busyness__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Render Ring Busy";
    counter->symbol_name = "RenderBusy";
    counter->desc = "The percentage of time when render command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__gpu_busyness__render_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Vdbox0 Ring Busy";
    counter->symbol_name = "Vdbox0Busy";
    counter->desc = "The percentage of time when Vdbox0 command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__gpu_busyness__vdbox0_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Vebox Ring Busy";
    counter->symbol_name = "VeboxBusy";
    counter->desc = "The percentage of time when vebox command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = bxt__gpu_busyness__vebox_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    assert(metric_set->n_counters <= 8);
}

static void
bxt_add_test_oa_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "MDAPI testing set Gen9";
    metric_set->symbol_name = "TestOa";
    metric_set->hw_config_guid = "5ee72f5c-092f-421e-8b70-225f7c3e9612";
    metric_set->counters = calloc(12, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(12, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(22, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07800063 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x23810008 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D950400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F922000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000004 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00000003 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000007 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00100002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FFF7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00100002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FFCF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00100082 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FFEF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x001000C2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FFE7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x00100001 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000FFE7 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = bxt__test_oa__avg_gpu_core_frequency__read;
    counter->max_uint64 = bxt__test_oa__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter0";
    counter->symbol_name = "Counter0";
    counter->desc = "HW test counter 0. Factor: 0.0";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = bxt__test_oa__counter0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter1";
    counter->symbol_name = "Counter1";
    counter->desc = "HW test counter 1. Factor: 1.0";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = bxt__test_oa__counter1__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter2";
    counter->symbol_name = "Counter2";
    counter->desc = "HW test counter 2. Factor: 1.0";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = bxt__test_oa__counter2__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter3";
    counter->symbol_name = "Counter3";
    counter->desc = "HW test counter 3. Factor: 0.5";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = bxt__test_oa__counter3__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter4";
    counter->symbol_name = "Counter4";
    counter->desc = "HW test counter 4. Factor: 0.333";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = bxt__test_oa__counter4__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter5";
    counter->symbol_name = "Counter5";
    counter->desc = "HW test counter 5. Factor: 0.333";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = bxt__test_oa__counter5__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter6";
    counter->symbol_name = "Counter6";
    counter->desc = "HW test counter 6. Factor: 0.166";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = bxt__test_oa__counter6__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter7";
    counter->symbol_name = "Counter7";
    counter->desc = "HW test counter 7. Factor: 0.666";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = bxt__test_oa__counter7__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter8";
    counter->symbol_name = "Counter8";
    counter->desc = "HW test counter 8. Should be equal to 1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = bxt__test_oa__counter8__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = bxt__test_oa__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = bxt__test_oa__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    assert(metric_set->n_counters <= 12);
}

static void
bxt_add_pma__stall_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set PMA Stall";
    metric_set->symbol_name = "PMA_Stall";
    metric_set->hw_config_guid = "d49cd0d8-8c7f-4465-94fc-51e08c9050bc";
    metric_set->counters = calloc(4, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(34, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(9, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x124C3080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002D1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082D5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2D5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2E0400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2E5500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x102E0001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004C0045 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064C2300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084C26C4 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C264E };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x164C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E4C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x199300AA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x23904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x27904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x29904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00E00021 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0007FFF8 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x07000101 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0038FFC7 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = bxt__pma__stall__avg_gpu_core_frequency__read;
    counter->max_uint64 = bxt__pma__stall__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = bxt__pma__stall__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = bxt__pma__stall__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "STC PMA stall";
        counter->symbol_name = "StcPMAStall";
        counter->desc = "Percentage of time when stencil cache line and an overlapping pixel are causing stalls";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = bxt__pma__stall__stc_pma_stall__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Stencil Cache");
    }

    assert(metric_set->n_counters <= 4);
}

static void
glk_add_render_basic_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Render Metrics Basic Gen9";
    metric_set->symbol_name = "RenderBasic";
    metric_set->hw_config_guid = "d72df5c7-5b4a-4274-a43f-00b0fd51fc68";
    metric_set->counters = calloc(52, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(80, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(5, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x166C00F0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12120280 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12320280 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11930317 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x159303DF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F900C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x419000A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002D1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082D5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2D1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2E0800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2E5900 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E4C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4E2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C4F0010 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A6C0053 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A0FCC00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C0F0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C2C0040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00101000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04101000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00114000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08114000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00120020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08120021 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00141000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08141000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02308000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04302000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06318000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08318000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06320800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08320840 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00320000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06344000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08344000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D931831 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F939F3F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01939E80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x039303BC };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0593000E };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1993002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07930000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09930000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D900177 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F900187 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x23904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x27904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53901110 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900423 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900111 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900C02 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59901111 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900421 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D900001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900821 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = glk__render_basic__avg_gpu_core_frequency__read;
    counter->max_uint64 = glk__render_basic__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__render_basic__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__render_basic__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__render_basic__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__render_basic__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__render_basic__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__render_basic__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__render_basic__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = glk__render_basic__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = glk__render_basic__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__render_basic__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Depth Throughput";
    counter->symbol_name = "GtiDepthThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between depth caches and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = glk__render_basic__gti_depth_throughput__read;
    counter->max_uint64 = glk__render_basic__gti_depth_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI HDC TLB Lookup Throughput";
    counter->symbol_name = "GtiHdcLookupsThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between GTI and HDC, when HDC is doing TLB lookups.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = glk__render_basic__gti_hdc_lookups_throughput__read;
    counter->max_uint64 = glk__render_basic__gti_hdc_lookups_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI L3 Throughput";
    counter->symbol_name = "GtiL3Throughput";
    counter->desc = "The total number of GPU memory bytes transferred between L3 caches and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = glk__render_basic__gti_l3_throughput__read;
    counter->max_uint64 = glk__render_basic__gti_l3_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI RCC Throughput";
    counter->symbol_name = "GtiRccThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between render color caches and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = glk__render_basic__gti_rcc_throughput__read;
    counter->max_uint64 = glk__render_basic__gti_rcc_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Read Throughput";
    counter->symbol_name = "GtiReadThroughput";
    counter->desc = "The total number of GPU memory bytes read from GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = glk__render_basic__gti_read_throughput__read;
    counter->max_uint64 = glk__render_basic__gti_read_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Fixed Pipe Throughput";
    counter->symbol_name = "GtiVfThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between 3D Pipeline (Command Dispatch, Input Assembly and Stream Output) and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = glk__render_basic__gti_vf_throughput__read;
    counter->max_uint64 = glk__render_basic__gti_vf_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Write Throughput";
    counter->symbol_name = "GtiWriteThroughput";
    counter->desc = "The total number of GPU memory bytes written to GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = glk__render_basic__gti_write_throughput__read;
    counter->max_uint64 = glk__render_basic__gti_write_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__render_basic__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__render_basic__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Lookup Accesses w/o IC";
    counter->symbol_name = "L3Lookups";
    counter->desc = "The total number of L3 cache lookup accesses w/o IC.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__render_basic__l3_lookups__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/TAG");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Misses";
    counter->symbol_name = "L3Misses";
    counter->desc = "The total number of L3 misses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__render_basic__l3_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/TAG");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Sampler Throughput";
    counter->symbol_name = "L3SamplerThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between samplers and L3 caches.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = glk__render_basic__l3_sampler_throughput__read;
    counter->max_uint64 = glk__render_basic__l3_sampler_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = glk__render_basic__l3_shader_throughput__read;
    counter->max_uint64 = glk__render_basic__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__render_basic__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__render_basic__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__render_basic__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__render_basic__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__render_basic__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__render_basic__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__render_basic__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    if (perf->devinfo.subslice_mask & 0x09) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Sampler 0 Bottleneck";
        counter->symbol_name = "Sampler0Bottleneck";
        counter->desc = "The percentage of time in which Sampler 0 has been slowing down the pipe when processing EU requests.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = glk__render_basic__sampler0_bottleneck__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x09) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Sampler 0 Busy";
        counter->symbol_name = "Sampler0Busy";
        counter->desc = "The percentage of time in which Sampler 0 has been processing EU requests.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = glk__render_basic__sampler0_busy__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x12) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Sampler 1 Bottleneck";
        counter->symbol_name = "Sampler1Bottleneck";
        counter->desc = "The percentage of time in which Sampler 1 has been slowing down the pipe when processing EU requests.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = glk__render_basic__sampler1_bottleneck__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x12) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Sampler 1 Busy";
        counter->symbol_name = "Sampler1Busy";
        counter->desc = "The percentage of time in which Sampler 1 has been processing EU requests.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = glk__render_basic__sampler1_busy__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samplers Bottleneck";
    counter->symbol_name = "SamplerBottleneck";
    counter->desc = "The percentage of time in which samplers have been slowing down the pipe when processing EU requests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__render_basic__sampler_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Cache Misses";
    counter->symbol_name = "SamplerL1Misses";
    counter->desc = "The total number of sampler cache misses in all LODs in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__render_basic__sampler_l1_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = glk__render_basic__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = glk__render_basic__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samplers Busy";
    counter->symbol_name = "SamplersBusy";
    counter->desc = "The percentage of time in which samplers have been processing EU requests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__render_basic__samplers_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__render_basic__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__render_basic__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__render_basic__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__render_basic__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__render_basic__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__render_basic__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = glk__render_basic__slm_bytes_read__read;
    counter->max_uint64 = glk__render_basic__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = glk__render_basic__slm_bytes_written__read;
    counter->max_uint64 = glk__render_basic__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__render_basic__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__render_basic__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__render_basic__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__render_basic__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 52);
}

static void
glk_add_compute_basic_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Compute Metrics Basic Gen9";
    metric_set->symbol_name = "ComputeBasic";
    metric_set->hw_config_guid = "814285f6-354d-41d2-ba49-e24e622714a0";
    metric_set->counters = calloc(39, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(72, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(5, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x104F00E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x124F1C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x39900340 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F900C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002D5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2D1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2D5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2E1400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2E5100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x102E0114 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E4C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x104C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x124C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x164C2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004EA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4E2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4EA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004F6B42 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064F6200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084F4100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4F0061 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4F6C4C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E4F4B00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A4F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C4F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x180F5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A0F8800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C0F08A2 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x182C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C2C1451 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E2C0001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A2C0010 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19938A28 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19900177 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B900178 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D900125 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F900123 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x27904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53901000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900111 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00000003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00002001 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00778008 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00088078 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00808708 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00A08908 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = glk__compute_basic__avg_gpu_core_frequency__read;
    counter->max_uint64 = glk__compute_basic__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__compute_basic__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__compute_basic__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__compute_basic__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__compute_basic__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU AVG IPC Rate";
    counter->symbol_name = "EuAvgIpcRate";
    counter->desc = "The average rate of IPC calculated for 2 FPU pipelines.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NUMBER;
    counter->read_float = glk__compute_basic__eu_avg_ipc_rate__read;
    counter->max_float = glk__compute_basic__eu_avg_ipc_rate__max;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__compute_basic__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Send Pipe Active";
    counter->symbol_name = "EuSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__compute_basic__eu_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__compute_basic__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Thread Occupancy";
    counter->symbol_name = "EuThreadOccupancy";
    counter->desc = "The percentage of time in which hardware threads occupied EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__compute_basic__eu_thread_occupancy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Pipe Active";
    counter->symbol_name = "Fpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__compute_basic__fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active";
    counter->symbol_name = "Fpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__compute_basic__fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__compute_basic__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = glk__compute_basic__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = glk__compute_basic__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__compute_basic__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Read Throughput";
    counter->symbol_name = "GtiReadThroughput";
    counter->desc = "The total number of GPU memory bytes read from GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = glk__compute_basic__gti_read_throughput__read;
    counter->max_uint64 = glk__compute_basic__gti_read_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Write Throughput";
    counter->symbol_name = "GtiWriteThroughput";
    counter->desc = "The total number of GPU memory bytes written to GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = glk__compute_basic__gti_write_throughput__read;
    counter->max_uint64 = glk__compute_basic__gti_write_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__compute_basic__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__compute_basic__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = glk__compute_basic__l3_shader_throughput__read;
    counter->max_uint64 = glk__compute_basic__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__compute_basic__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__compute_basic__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__compute_basic__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = glk__compute_basic__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = glk__compute_basic__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__compute_basic__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__compute_basic__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__compute_basic__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__compute_basic__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__compute_basic__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__compute_basic__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = glk__compute_basic__slm_bytes_read__read;
    counter->max_uint64 = glk__compute_basic__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = glk__compute_basic__slm_bytes_written__read;
    counter->max_uint64 = glk__compute_basic__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Bytes Read";
    counter->symbol_name = "TypedBytesRead";
    counter->desc = "The total number of typed memory bytes read via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = glk__compute_basic__typed_bytes_read__read;
    counter->max_uint64 = glk__compute_basic__typed_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Bytes Written";
    counter->symbol_name = "TypedBytesWritten";
    counter->desc = "The total number of untyped memory bytes written via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = glk__compute_basic__typed_bytes_written__read;
    counter->max_uint64 = glk__compute_basic__typed_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Untyped Bytes Read";
    counter->symbol_name = "UntypedBytesRead";
    counter->desc = "The total number of typed memory bytes read via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = glk__compute_basic__untyped_bytes_read__read;
    counter->max_uint64 = glk__compute_basic__untyped_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Untyped Writes";
    counter->symbol_name = "UntypedBytesWritten";
    counter->desc = "The total number of untyped memory bytes written via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = glk__compute_basic__untyped_bytes_written__read;
    counter->max_uint64 = glk__compute_basic__untyped_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__compute_basic__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 39);
}

static void
glk_add_render_pipe_profile_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Render Metrics for 3D Pipeline Profile Gen9";
    metric_set->symbol_name = "RenderPipeProfile";
    metric_set->hw_config_guid = "07d397a6-b3e6-49f6-9433-a4f293d55978";
    metric_set->counters = calloc(43, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(94, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(21, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2E001F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10186800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11810019 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15810013 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13820020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11830020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17840000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11860007 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21860000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x178703E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062D1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022E5400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002E0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2E0080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082F0040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06143000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06174000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06180012 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00180000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D804000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F804000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05804000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09810200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B810030 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03810003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21819140 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x23819050 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25810018 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B820980 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03820D80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11820000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0182C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07828000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09824000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F828000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D830004 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0583000C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F831000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01848072 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11840000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07848000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09844000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F848000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07860000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09860092 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F860400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01869100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F870065 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01870000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19930800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B952000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D955055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F951455 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0992A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F928000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1192A800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1392028A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B92A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D922000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x23908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x27908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x29908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900C01 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900863 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900061 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900C22 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007FFEA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x00007FFC };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x0007AFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000F5FD };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00079FFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000F3FB };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x0007BF7A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000F7E7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x0007FEFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000F7CF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00077FFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000EFDF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x0006FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000CFBF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x0003FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x00005F7F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00025024 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00035034 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00045044 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00055054 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00065064 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = glk__render_pipe_profile__avg_gpu_core_frequency__read;
    counter->max_uint64 = glk__render_pipe_profile__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "BC Bottleneck";
    counter->symbol_name = "BcBottleneck";
    counter->desc = "The percentage of time in which barycentric coordinates calculation pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__render_pipe_profile__bc_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Barycentric Calc");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Clipper Bottleneck";
    counter->symbol_name = "ClBottleneck";
    counter->desc = "The percentage of time in which clipper pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__render_pipe_profile__cl_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Clipper");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CL Stall";
    counter->symbol_name = "ClStall";
    counter->desc = "The percentage of time in which clipper pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__render_pipe_profile__cl_stall__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Clipper");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__render_pipe_profile__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Bottleneck";
    counter->symbol_name = "DsBottleneck";
    counter->desc = "The percentage of time in which domain shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__render_pipe_profile__ds_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Stall";
    counter->symbol_name = "DsStall";
    counter->desc = "The percentage of time in which domain shader pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__render_pipe_profile__ds_stall__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__render_pipe_profile__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Bottleneck";
    counter->symbol_name = "EarlyDepthBottleneck";
    counter->desc = "The percentage of time in which early depth test pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__render_pipe_profile__early_depth_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__render_pipe_profile__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__render_pipe_profile__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__render_pipe_profile__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__render_pipe_profile__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = glk__render_pipe_profile__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = glk__render_pipe_profile__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Bottleneck";
    counter->symbol_name = "GsBottleneck";
    counter->desc = "The percentage of time in which geometry shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__render_pipe_profile__gs_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__render_pipe_profile__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Hi-Depth Bottleneck";
    counter->symbol_name = "HiDepthBottleneck";
    counter->desc = "The percentage of time in which early hierarchical depth test pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__render_pipe_profile__hi_depth_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__render_pipe_profile__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Bottleneck";
    counter->symbol_name = "HsBottleneck";
    counter->desc = "The percentage of time in which hull shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__render_pipe_profile__hs_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Stall";
    counter->symbol_name = "HsStall";
    counter->desc = "The percentage of time in which hull stall pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__render_pipe_profile__hs_stall__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__render_pipe_profile__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = glk__render_pipe_profile__l3_shader_throughput__read;
    counter->max_uint64 = glk__render_pipe_profile__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__render_pipe_profile__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__render_pipe_profile__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__render_pipe_profile__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = glk__render_pipe_profile__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = glk__render_pipe_profile__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__render_pipe_profile__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__render_pipe_profile__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__render_pipe_profile__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Strip-Fans Bottleneck";
    counter->symbol_name = "SfBottleneck";
    counter->desc = "The percentage of time in which strip-fans pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__render_pipe_profile__sf_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Strip-Fans");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SF Stall";
    counter->symbol_name = "SfStall";
    counter->desc = "The percentage of time in which strip-fans pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__render_pipe_profile__sf_stall__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Strip-Fans");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__render_pipe_profile__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__render_pipe_profile__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__render_pipe_profile__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = glk__render_pipe_profile__slm_bytes_read__read;
    counter->max_uint64 = glk__render_pipe_profile__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = glk__render_pipe_profile__slm_bytes_written__read;
    counter->max_uint64 = glk__render_pipe_profile__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SO Bottleneck";
    counter->symbol_name = "SoBottleneck";
    counter->desc = "The percentage of time in which stream output pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__render_pipe_profile__so_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Stream Output");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SO Stall";
    counter->symbol_name = "SoStall";
    counter->desc = "The percentage of time in which stream-output pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__render_pipe_profile__so_stall__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Stream Output");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VF Bottleneck";
    counter->symbol_name = "VfBottleneck";
    counter->desc = "The percentage of time in which vertex fetch pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__render_pipe_profile__vf_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Input Assembler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Bottleneck";
    counter->symbol_name = "VsBottleneck";
    counter->desc = "The percentage of time in which vertex shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__render_pipe_profile__vs_bottleneck__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__render_pipe_profile__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 43);
}

static void
glk_add_memory_reads_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Memory Reads Distribution Gen9";
    metric_set->symbol_name = "MemoryReads";
    metric_set->hw_config_guid = "1a356946-5428-450b-a2f0-89f8783a302d";
    metric_set->counters = calloc(41, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(44, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(32, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19800343 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x39900340 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F901000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03803180 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058035E2 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0780006A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2181A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2381000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D950550 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B928000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D92A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F922000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13900170 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21900171 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x23900172 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25900173 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x27900174 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x29900175 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B900176 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D900177 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F90017F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31900125 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15900123 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17900121 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43901084 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47901080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49901084 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B901084 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D900004 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000272C, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002728, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000271C, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002718, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000274C, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002748, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00006667 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000275C, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002758, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002754, .val = 0x00006465 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002750, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007F81A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x0007F82A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x0007F872 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x0007F8BA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x0007F87A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x0007F8EA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x0007F8E2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x0007F8F2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000FE00 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00025024 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00035034 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00045044 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00055054 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00065064 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = glk__memory_reads__avg_gpu_core_frequency__read;
    counter->max_uint64 = glk__memory_reads__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__memory_reads__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__memory_reads__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__memory_reads__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__memory_reads__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__memory_reads__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__memory_reads__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = glk__memory_reads__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = glk__memory_reads__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__memory_reads__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiCmdStreamerMemoryReads";
    counter->symbol_name = "GtiCmdStreamerMemoryReads";
    counter->desc = "The total number of GTI memory reads from Command Streamer.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__memory_reads__gti_cmd_streamer_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Command Streamer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiHizMemoryReads";
    counter->symbol_name = "GtiHizMemoryReads";
    counter->desc = "The total number of GTI memory reads from Hierarchical Depth Cache (Hi-Depth Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__memory_reads__gti_hiz_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank0Reads";
    counter->symbol_name = "GtiL3Bank0Reads";
    counter->desc = "The total number of GTI memory reads from L3 Bank 0 (L3 Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__memory_reads__gti_l3_bank0_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank1Reads";
    counter->symbol_name = "GtiL3Bank1Reads";
    counter->desc = "The total number of GTI memory reads from L3 Bank 1 (L3 Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__memory_reads__gti_l3_bank1_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank2Reads";
    counter->symbol_name = "GtiL3Bank2Reads";
    counter->desc = "The total number of GTI memory reads from L3 Bank 2 (L3 Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__memory_reads__gti_l3_bank2_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank3Reads";
    counter->symbol_name = "GtiL3Bank3Reads";
    counter->desc = "The total number of GTI memory reads from L3 Bank 3 (L3 Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__memory_reads__gti_l3_bank3_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Reads";
    counter->symbol_name = "GtiL3Reads";
    counter->desc = "The total number of GTI memory reads from L3 (L3 Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__memory_reads__gti_l3_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiMemoryReads";
    counter->symbol_name = "GtiMemoryReads";
    counter->desc = "The total number of GTI memory reads.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__memory_reads__gti_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiMscMemoryReads";
    counter->symbol_name = "GtiMscMemoryReads";
    counter->desc = "The total number of GTI memory reads from Multisampling Color Cache (Multisampling Color Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__memory_reads__gti_msc_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRccMemoryReads";
    counter->symbol_name = "GtiRccMemoryReads";
    counter->desc = "The total number of GTI memory reads from Render Color Cache (Render Color Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__memory_reads__gti_rcc_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRczMemoryReads";
    counter->symbol_name = "GtiRczMemoryReads";
    counter->desc = "The total number of GTI memory reads from Render Depth Cache (Render Depth Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__memory_reads__gti_rcz_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRingAccesses";
    counter->symbol_name = "GtiRingAccesses";
    counter->desc = "The total number of all accesses from GTI to the ring.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__memory_reads__gti_ring_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRsMemoryReads";
    counter->symbol_name = "GtiRsMemoryReads";
    counter->desc = "The total number of GTI memory reads from Resource Streamer.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__memory_reads__gti_rs_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Resource Streamer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiStcMemoryReads";
    counter->symbol_name = "GtiStcMemoryReads";
    counter->desc = "The total number of GTI memory reads from Stencil Cache (Stencil Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__memory_reads__gti_stc_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiVfMemoryReads";
    counter->symbol_name = "GtiVfMemoryReads";
    counter->desc = "The total number of GTI memory reads from Vertex Fetch.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__memory_reads__gti_vf_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Vertex Fetch");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__memory_reads__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__memory_reads__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__memory_reads__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__memory_reads__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__memory_reads__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = glk__memory_reads__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = glk__memory_reads__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__memory_reads__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__memory_reads__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__memory_reads__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__memory_reads__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__memory_reads__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__memory_reads__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = glk__memory_reads__slm_bytes_read__read;
    counter->max_uint64 = glk__memory_reads__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = glk__memory_reads__slm_bytes_written__read;
    counter->max_uint64 = glk__memory_reads__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__memory_reads__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 41);
}

static void
glk_add_memory_writes_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Memory Writes Distribution Gen9";
    metric_set->symbol_name = "MemoryWrites";
    metric_set->hw_config_guid = "5299be9d-7a61-4c99-9f81-f87e6c5aaca9";
    metric_set->counters = calloc(41, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(44, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(32, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19800343 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x39900340 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03803180 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x058035E2 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0780006A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2181A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2381000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D950550 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B928000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D92A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F922000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13900180 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21900181 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x23900182 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25900183 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x27900184 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x29900185 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B900186 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D900187 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F900170 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31900125 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15900123 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17900121 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43901084 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47901080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49901084 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B901084 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D900004 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000272C, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002728, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000271C, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002718, .val = 0xFFFFFFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000274C, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002748, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00006667 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000275C, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002758, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002754, .val = 0x00006465 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002750, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007F81A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x0007F82A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x0007F822 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x0007F8BA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x0007F87A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x0007F8EA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x0007F8E2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x0007F8F2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000FE00 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00025024 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00035034 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00045044 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00055054 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00065064 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = glk__memory_writes__avg_gpu_core_frequency__read;
    counter->max_uint64 = glk__memory_writes__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__memory_writes__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__memory_writes__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__memory_writes__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__memory_writes__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__memory_writes__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__memory_writes__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = glk__memory_writes__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = glk__memory_writes__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__memory_writes__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiCmdStreamerMemoryWrites";
    counter->symbol_name = "GtiCmdStreamerMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Command Streamer.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__memory_writes__gti_cmd_streamer_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Command Streamer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiHizMemoryWrites";
    counter->symbol_name = "GtiHizMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Hierarchical Depth Cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__memory_writes__gti_hiz_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank0Writes";
    counter->symbol_name = "GtiL3Bank0Writes";
    counter->desc = "The total number of GTI memory writes from L3 Bank 0 (L3 Bank 0 invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__memory_writes__gti_l3_bank0_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank1Writes";
    counter->symbol_name = "GtiL3Bank1Writes";
    counter->desc = "The total number of GTI memory writes from L3 Bank 1 (L3 Bank 1 invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__memory_writes__gti_l3_bank1_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank2Writes";
    counter->symbol_name = "GtiL3Bank2Writes";
    counter->desc = "The total number of GTI memory writes from L3 Bank 2 (L3 Bank 2 invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__memory_writes__gti_l3_bank2_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank3Writes";
    counter->symbol_name = "GtiL3Bank3Writes";
    counter->desc = "The total number of GTI memory writes from L3 Bank 3 (L3 Bank 3 invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__memory_writes__gti_l3_bank3_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Writes";
    counter->symbol_name = "GtiL3Writes";
    counter->desc = "The total number of GTI memory writes from L3 (L3 invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__memory_writes__gti_l3_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiMemoryWrites";
    counter->symbol_name = "GtiMemoryWrites";
    counter->desc = "The total number of GTI memory writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__memory_writes__gti_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiMscMemoryWrites";
    counter->symbol_name = "GtiMscMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Multisampling Color Cache (Multisampling Color Cache invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__memory_writes__gti_msc_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRccMemoryWrites";
    counter->symbol_name = "GtiRccMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Render Color Cache (Render Color Cache invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__memory_writes__gti_rcc_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRczMemoryWrites";
    counter->symbol_name = "GtiRczMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Render Depth Cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__memory_writes__gti_rcz_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRingAccesses";
    counter->symbol_name = "GtiRingAccesses";
    counter->desc = "The total number of all GTI accesses to the ring.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__memory_writes__gti_ring_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiSoMemoryWrites";
    counter->symbol_name = "GtiSoMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Stream Output.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__memory_writes__gti_so_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Stream Output");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiStcMemoryWrites";
    counter->symbol_name = "GtiStcMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Stencil Cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__memory_writes__gti_stc_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__memory_writes__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__memory_writes__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = glk__memory_writes__l3_shader_throughput__read;
    counter->max_uint64 = glk__memory_writes__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__memory_writes__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__memory_writes__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__memory_writes__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = glk__memory_writes__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = glk__memory_writes__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__memory_writes__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__memory_writes__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__memory_writes__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__memory_writes__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__memory_writes__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__memory_writes__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = glk__memory_writes__slm_bytes_read__read;
    counter->max_uint64 = glk__memory_writes__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = glk__memory_writes__slm_bytes_written__read;
    counter->max_uint64 = glk__memory_writes__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__memory_writes__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 41);
}

static void
glk_add_compute_extended_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Compute Metrics Extended Gen9";
    metric_set->symbol_name = "ComputeExtended";
    metric_set->hw_config_guid = "bc9bcff2-459a-4cbc-986d-a84b077153f3";
    metric_set->counters = calloc(38, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(93, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(21, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x104F00E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141C0160 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x161C0015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181C0120 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002D5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082D5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2D5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2D5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2D5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022D5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042D5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2E5400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2E5515 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x102E0155 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E4CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x104C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x124C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x144C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x164C2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004EA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084EA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4EA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4EA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E4EA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x024EA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044EA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E4F4B41 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004F4200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x024F404C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C4F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A4F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x061B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x081BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001C0031 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x061C1900 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x081C1A33 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1C1B35 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1C3337 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041C31C7 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x180F5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A0FA8AA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C0F0AAA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x182C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C2C6AAA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E2C0001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A2C2950 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1993AAAA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x23904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x27904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x29904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900420 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D900001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900001 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007FC2A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x0007FC6A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x0007FC92 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x0007FCA2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x0007FC32 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x0007FC9A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x0007FE6A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000BF00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x0007FE7A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000BF00 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00000003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00002001 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00778008 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00088078 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00808708 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00A08908 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = glk__compute_extended__avg_gpu_core_frequency__read;
    counter->max_uint64 = glk__compute_extended__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__compute_extended__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuA64UntypedReads0";
    counter->symbol_name = "EuA64UntypedReads0";
    counter->desc = "The subslice 0 EU A64 Untyped Reads subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__compute_extended__eu_a64_untyped_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuA64UntypedWrites0";
    counter->symbol_name = "EuA64UntypedWrites0";
    counter->desc = "The subslice 0 EU A64 Untyped Writes subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__compute_extended__eu_a64_untyped_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__compute_extended__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU AVG IPC Rate";
    counter->symbol_name = "EuAvgIpcRate";
    counter->desc = "The average rate of IPC calculated for 2 FPU pipelines.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NUMBER;
    counter->read_float = glk__compute_extended__eu_avg_ipc_rate__read;
    counter->max_float = glk__compute_extended__eu_avg_ipc_rate__max;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__compute_extended__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Send Pipe Active";
    counter->symbol_name = "EuSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__compute_extended__eu_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__compute_extended__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Thread Occupancy";
    counter->symbol_name = "EuThreadOccupancy";
    counter->desc = "The percentage of time in which hardware threads occupied EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__compute_extended__eu_thread_occupancy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuTypedAtomics0";
    counter->symbol_name = "EuTypedAtomics0";
    counter->desc = "The subslice 0 EU Typed Atomics subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__compute_extended__eu_typed_atomics0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuTypedReads0";
    counter->symbol_name = "EuTypedReads0";
    counter->desc = "The subslice 0 EU Typed Reads subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__compute_extended__eu_typed_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuTypedWrites0";
    counter->symbol_name = "EuTypedWrites0";
    counter->desc = "The subslice 0 EU Typed Writes subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__compute_extended__eu_typed_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuUntypedAtomics0";
    counter->symbol_name = "EuUntypedAtomics0";
    counter->desc = "The subslice 0 EU Untyped Atomics subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__compute_extended__eu_untyped_atomics0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuUntypedReads0";
    counter->symbol_name = "EuUntypedReads0";
    counter->desc = "The subslice 0 EU Untyped Reads subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__compute_extended__eu_untyped_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuUntypedWrites0";
    counter->symbol_name = "EuUntypedWrites0";
    counter->desc = "The subslice 0 EU Untyped Writes subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__compute_extended__eu_untyped_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Pipe Active";
    counter->symbol_name = "Fpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__compute_extended__fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active";
    counter->symbol_name = "Fpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__compute_extended__fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = glk__compute_extended__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = glk__compute_extended__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = glk__compute_extended__l3_shader_throughput__read;
    counter->max_uint64 = glk__compute_extended__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = glk__compute_extended__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = glk__compute_extended__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__compute_extended__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__compute_extended__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__compute_extended__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = glk__compute_extended__slm_bytes_read__read;
    counter->max_uint64 = glk__compute_extended__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = glk__compute_extended__slm_bytes_written__read;
    counter->max_uint64 = glk__compute_extended__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Atomics 0";
    counter->symbol_name = "TypedAtomics0";
    counter->desc = "The subslice 0 typed atomics.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__compute_extended__typed_atomics0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TypedAtomicsPerCacheLine";
    counter->symbol_name = "TypedAtomicsPerCacheLine";
    counter->desc = "The ratio of EU typed atomics requests to L3 cache line writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
    counter->read_float = glk__compute_extended__typed_atomics_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Reads 0";
    counter->symbol_name = "TypedReads0";
    counter->desc = "The subslice 0 typed reads.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__compute_extended__typed_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TypedReadsPerCacheLine";
    counter->symbol_name = "TypedReadsPerCacheLine";
    counter->desc = "The ratio of EU typed read requests to L3 cache line reads.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
    counter->read_float = glk__compute_extended__typed_reads_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Writes 0";
    counter->symbol_name = "TypedWrites0";
    counter->desc = "The subslice 0 typed writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__compute_extended__typed_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TypedWritesPerCacheLine";
    counter->symbol_name = "TypedWritesPerCacheLine";
    counter->desc = "The ratio of EU typed write requests to L3 cache line writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
    counter->read_float = glk__compute_extended__typed_writes_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Untyped Reads 0";
    counter->symbol_name = "UntypedReads0";
    counter->desc = "The subslice 0 untyped reads (including SLM reads).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__compute_extended__untyped_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "UntypedReadsPerCacheLine";
    counter->symbol_name = "UntypedReadsPerCacheLine";
    counter->desc = "The ratio of EU untyped read requests to L3 cache line reads.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
    counter->read_float = glk__compute_extended__untyped_reads_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Untyped Writes 0";
    counter->symbol_name = "UntypedWrites0";
    counter->desc = "The subslice 0 untyped writes (including SLM writes).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__compute_extended__untyped_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "UntypedWritesPerCacheLine";
    counter->symbol_name = "UntypedWritesPerCacheLine";
    counter->desc = "The ratio of EU untyped write requests to L3 cache line writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
    counter->read_float = glk__compute_extended__untyped_writes_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    assert(metric_set->n_counters <= 38);
}

static void
glk_add_compute_l3_cache_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Compute Metrics L3 Cache Gen9";
    metric_set->symbol_name = "ComputeL3Cache";
    metric_set->hw_config_guid = "88ec931f-5b4a-453a-9db6-a61232b6143d";
    metric_set->counters = calloc(54, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(68, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(13, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x166C03B0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1593001E };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F900C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002D1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082D5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2D5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2E0400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2E1500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x102E0140 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x144C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x164C2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004E2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084EA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E4EA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A4F4001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C4F5005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x006C0051 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x066C5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x086C5C5D };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E6C5E5F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x146C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x180F1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A0FA800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C0F0A00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x182C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C2C4015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E2C0001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03931980 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05930032 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11930000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1993A00A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07930000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09930000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D900177 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F900178 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x23904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53901000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900111 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900400 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FEFE };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x0007FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FEFD };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x0007FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FBEF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x0007FFFA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FBDF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00000003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00002001 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00101100 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00201200 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00301300 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00401400 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = glk__compute_l3_cache__avg_gpu_core_frequency__read;
    counter->max_uint64 = glk__compute_l3_cache__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__compute_l3_cache__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__compute_l3_cache__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__compute_l3_cache__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__compute_l3_cache__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU AVG IPC Rate";
    counter->symbol_name = "EuAvgIpcRate";
    counter->desc = "The average rate of IPC calculated for 2 FPU pipelines.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NUMBER;
    counter->read_float = glk__compute_l3_cache__eu_avg_ipc_rate__read;
    counter->max_float = glk__compute_l3_cache__eu_avg_ipc_rate__max;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Binary Instruction";
    counter->symbol_name = "EuBinaryFpu0Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing binary instructions on FPU0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__compute_l3_cache__eu_binary_fpu0_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Binary Instruction";
    counter->symbol_name = "EuBinaryFpu1Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing binary instructions on FPU1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__compute_l3_cache__eu_binary_fpu1_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__compute_l3_cache__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Hybrid Instruction";
    counter->symbol_name = "EuHybridFpu0Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing hybrid instructions on FPU0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__compute_l3_cache__eu_hybrid_fpu0_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Hybrid Instruction";
    counter->symbol_name = "EuHybridFpu1Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing hybrid instructions on FPU1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__compute_l3_cache__eu_hybrid_fpu1_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Move Instruction";
    counter->symbol_name = "EuMoveFpu0Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing move instructions on FPU0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__compute_l3_cache__eu_move_fpu0_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Move Instruction";
    counter->symbol_name = "EuMoveFpu1Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing move instructions on FPU1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__compute_l3_cache__eu_move_fpu1_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Send Pipe Active";
    counter->symbol_name = "EuSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__compute_l3_cache__eu_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__compute_l3_cache__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Ternary Instruction";
    counter->symbol_name = "EuTernaryFpu0Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing ternary instructions on FPU0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__compute_l3_cache__eu_ternary_fpu0_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Ternary Instruction";
    counter->symbol_name = "EuTernaryFpu1Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing ternary instructions on FPU1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__compute_l3_cache__eu_ternary_fpu1_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Pipe Active";
    counter->symbol_name = "Fpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__compute_l3_cache__fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active";
    counter->symbol_name = "Fpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__compute_l3_cache__fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__compute_l3_cache__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = glk__compute_l3_cache__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = glk__compute_l3_cache__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__compute_l3_cache__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI L3 Throughput";
    counter->symbol_name = "GtiL3Throughput";
    counter->desc = "The total number of GPU memory bytes transferred between L3 caches and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = glk__compute_l3_cache__gti_l3_throughput__read;
    counter->max_uint64 = glk__compute_l3_cache__gti_l3_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Read Throughput";
    counter->symbol_name = "GtiReadThroughput";
    counter->desc = "The total number of GPU memory bytes read from GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = glk__compute_l3_cache__gti_read_throughput__read;
    counter->max_uint64 = glk__compute_l3_cache__gti_read_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Write Throughput";
    counter->symbol_name = "GtiWriteThroughput";
    counter->desc = "The total number of GPU memory bytes written to GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = glk__compute_l3_cache__gti_write_throughput__read;
    counter->max_uint64 = glk__compute_l3_cache__gti_write_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__compute_l3_cache__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__compute_l3_cache__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Accesses";
    counter->symbol_name = "L3Accesses";
    counter->desc = "The total number of L3 accesses from all entities.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__compute_l3_cache__l3_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3");

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 00 Accesses";
        counter->symbol_name = "L3Bank00Accesses";
        counter->desc = "The total number of accesses to L3 Bank 00.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = glk__compute_l3_cache__l3_bank00_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 00 IC Accesses";
        counter->symbol_name = "L3Bank00IcAccesses";
        counter->desc = "The total number of accesses to L3 Bank 00 from IC cache.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = glk__compute_l3_cache__l3_bank00_ic_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3/IC");
    }

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 00 IC Hits";
        counter->symbol_name = "L3Bank00IcHits";
        counter->desc = "The total number of hits in L3 Bank 00 from IC cache.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = glk__compute_l3_cache__l3_bank00_ic_hits__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3/IC");
    }

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 01 Accesses";
        counter->symbol_name = "L3Bank01Accesses";
        counter->desc = "The total number of accesses to L3 Bank 01.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = glk__compute_l3_cache__l3_bank01_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 02 Accesses";
        counter->symbol_name = "L3Bank02Accesses";
        counter->desc = "The total number of accesses to L3 Bank 02.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = glk__compute_l3_cache__l3_bank02_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    if (perf->devinfo.slice_mask & 0x01) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "L3 Bank 03 Accesses";
        counter->symbol_name = "L3Bank03Accesses";
        counter->desc = "The total number of accesses to L3 Bank 03.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = glk__compute_l3_cache__l3_bank03_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Misses";
    counter->symbol_name = "L3Misses";
    counter->desc = "The total number of L3 misses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__compute_l3_cache__l3_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/TAG");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Sampler Throughput";
    counter->symbol_name = "L3SamplerThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between samplers and L3 caches.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = glk__compute_l3_cache__l3_sampler_throughput__read;
    counter->max_uint64 = glk__compute_l3_cache__l3_sampler_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = glk__compute_l3_cache__l3_shader_throughput__read;
    counter->max_uint64 = glk__compute_l3_cache__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Total Throughput";
    counter->symbol_name = "L3TotalThroughput";
    counter->desc = "The total number of GPU memory bytes transferred via L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = glk__compute_l3_cache__l3_total_throughput__read;
    counter->max_uint64 = glk__compute_l3_cache__l3_total_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__compute_l3_cache__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__compute_l3_cache__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__compute_l3_cache__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Accesses";
    counter->symbol_name = "SamplerAccesses";
    counter->desc = "The total number of messages send to samplers.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__compute_l3_cache__sampler_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = glk__compute_l3_cache__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = glk__compute_l3_cache__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__compute_l3_cache__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__compute_l3_cache__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__compute_l3_cache__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__compute_l3_cache__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__compute_l3_cache__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__compute_l3_cache__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = glk__compute_l3_cache__slm_bytes_read__read;
    counter->max_uint64 = glk__compute_l3_cache__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = glk__compute_l3_cache__slm_bytes_written__read;
    counter->max_uint64 = glk__compute_l3_cache__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__compute_l3_cache__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 54);
}

static void
glk_add_hdc_and_sf_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set HDCAndSF";
    metric_set->symbol_name = "HDCAndSF";
    metric_set->hw_config_guid = "0329ea02-ebb8-43f1-bf89-c5bdcccd3eb4";
    metric_set->counters = calloc(39, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(43, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(8, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x104F0232 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x124F4640 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11834400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042D5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062D1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2E0055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x024E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044EA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064E2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x024F6100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044F416B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064F004B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A4F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A0F02A8 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A2C5500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F808000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25810020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F8305C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F951000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13920200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D900003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x10800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FDFF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = glk__hdc_and_sf__avg_gpu_core_frequency__read;
    counter->max_uint64 = glk__hdc_and_sf__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__hdc_and_sf__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__hdc_and_sf__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__hdc_and_sf__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__hdc_and_sf__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__hdc_and_sf__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__hdc_and_sf__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = glk__hdc_and_sf__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__hdc_and_sf__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = glk__hdc_and_sf__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = glk__hdc_and_sf__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__hdc_and_sf__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__hdc_and_sf__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__hdc_and_sf__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = glk__hdc_and_sf__l3_shader_throughput__read;
    counter->max_uint64 = glk__hdc_and_sf__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "HDC stalled by L3 (s0.ss0)";
        counter->symbol_name = "NonSamplerShader00AccessStalledOnL3";
        counter->desc = "Percentage of time when HDC has messges to L3, but it's stalled due to lack of credits (s0.ss0)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = glk__hdc_and_sf__non_sampler_shader00_access_stalled_on_l3__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Data Port");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "HDC stalled by L3 (s0.ss1)";
        counter->symbol_name = "NonSamplerShader01AccessStalledOnL3";
        counter->desc = "Percentage of time when HDC has messges to L3, but it's stalled due to lack of credits (s0.ss1)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = glk__hdc_and_sf__non_sampler_shader01_access_stalled_on_l3__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Data Port");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__hdc_and_sf__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Polygon Data Ready";
    counter->symbol_name = "PolyDataReady";
    counter->desc = "The percentage of time in which geometry pipeline output is ready";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__hdc_and_sf__poly_data_ready__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe/Strip-Fans");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__hdc_and_sf__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__hdc_and_sf__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__hdc_and_sf__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__hdc_and_sf__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__hdc_and_sf__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__hdc_and_sf__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = glk__hdc_and_sf__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = glk__hdc_and_sf__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__hdc_and_sf__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__hdc_and_sf__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__hdc_and_sf__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__hdc_and_sf__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__hdc_and_sf__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__hdc_and_sf__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = glk__hdc_and_sf__slm_bytes_read__read;
    counter->max_uint64 = glk__hdc_and_sf__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = glk__hdc_and_sf__slm_bytes_written__read;
    counter->max_uint64 = glk__hdc_and_sf__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__hdc_and_sf__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__hdc_and_sf__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__hdc_and_sf__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__hdc_and_sf__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 39);
}

static void
glk_add_l3_1_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set L3_1";
    metric_set->symbol_name = "L3_1";
    metric_set->hw_config_guid = "5e57a25a-1d18-4e94-b84b-08ea66751b8c";
    metric_set->counters = calloc(40, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(78, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(22, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12643400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12653400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C6800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x126C001E };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x166C0010 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2D5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2D5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022D5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042D5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062D1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x102E0154 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2E5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2E0055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x104C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x124C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x144C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x164C2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4EA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E4EA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x024EA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044EA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064E2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C4F5500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A4F1554 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A640024 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10640000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04640000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C650024 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10650000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06650000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C6C5327 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E6C5425 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x006C2A00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x026C285B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x046C005C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6C0900 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C0F0AA0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x180F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A0F02AA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C2C5400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E2C0001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A2C5550 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1993AA00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900421 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D900001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900420 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900021 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00100070 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFF1 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00014002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000C3FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00010002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000C7FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00004002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000D3FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00100700 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FF1F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00001402 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FC3F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x00001002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FC7F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x00000402 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000FD3F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = glk__l3_1__avg_gpu_core_frequency__read;
    counter->max_uint64 = glk__l3_1__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__l3_1__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__l3_1__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__l3_1__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__l3_1__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__l3_1__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__l3_1__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = glk__l3_1__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__l3_1__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = glk__l3_1__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = glk__l3_1__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__l3_1__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__l3_1__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__l3_1__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank0 Active";
        counter->symbol_name = "L30Bank0Active";
        counter->desc = "The percentage of time in which slice0 L3 bank0 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = glk__l3_1__l30_bank0_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank0 Stalled";
        counter->symbol_name = "L30Bank0Stalled";
        counter->desc = "The percentage of time in which slice0 L3 bank0 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = glk__l3_1__l30_bank0_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank1 Active";
        counter->symbol_name = "L30Bank1Active";
        counter->desc = "The percentage of time in which slice0 L3 bank1 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = glk__l3_1__l30_bank1_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank1 Stalled";
        counter->symbol_name = "L30Bank1Stalled";
        counter->desc = "The percentage of time in which slice0 L3 bank1 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = glk__l3_1__l30_bank1_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = glk__l3_1__l3_shader_throughput__read;
    counter->max_uint64 = glk__l3_1__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__l3_1__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__l3_1__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__l3_1__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__l3_1__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__l3_1__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__l3_1__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__l3_1__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = glk__l3_1__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = glk__l3_1__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__l3_1__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__l3_1__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__l3_1__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__l3_1__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__l3_1__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__l3_1__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = glk__l3_1__slm_bytes_read__read;
    counter->max_uint64 = glk__l3_1__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = glk__l3_1__slm_bytes_written__read;
    counter->max_uint64 = glk__l3_1__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__l3_1__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__l3_1__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__l3_1__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__l3_1__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 40);
}

static void
glk_add_rasterizer_and_pixel_backend_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set RasterizerAndPixelBackend";
    metric_set->symbol_name = "RasterizerAndPixelBackend";
    metric_set->hw_config_guid = "f0652373-d361-426f-b36d-9ffec288bdc6";
    metric_set->counters = calloc(41, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(42, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(10, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x102D7800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x122D79E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2F0004 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100E3800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x180F0005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002D0940 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022D802F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042D4013 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062D1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2E0050 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022F0010 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064E2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040E0480 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000E0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060F0027 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A0F0040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x439014A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x459000A4 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000EFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00006000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000F3FF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = glk__rasterizer_and_pixel_backend__avg_gpu_core_frequency__read;
    counter->max_uint64 = glk__rasterizer_and_pixel_backend__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__rasterizer_and_pixel_backend__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__rasterizer_and_pixel_backend__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__rasterizer_and_pixel_backend__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__rasterizer_and_pixel_backend__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__rasterizer_and_pixel_backend__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__rasterizer_and_pixel_backend__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = glk__rasterizer_and_pixel_backend__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__rasterizer_and_pixel_backend__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = glk__rasterizer_and_pixel_backend__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = glk__rasterizer_and_pixel_backend__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__rasterizer_and_pixel_backend__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__rasterizer_and_pixel_backend__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__rasterizer_and_pixel_backend__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = glk__rasterizer_and_pixel_backend__l3_shader_throughput__read;
    counter->max_uint64 = glk__rasterizer_and_pixel_backend__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 PS Output Available";
        counter->symbol_name = "PSOutput0Available";
        counter->desc = "The percentage of time in which slice0 PS output is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = glk__rasterizer_and_pixel_backend__ps_output0_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Post-EarlyZ Pixel Data Ready";
        counter->symbol_name = "PixelData0Ready";
        counter->desc = "The percentage of time in which slice0 post-EarlyZ pixel data is ready (after early Z tests have been applied)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = glk__rasterizer_and_pixel_backend__pixel_data0_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Rasterizer/Early Depth Test");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Pixel Values Ready";
        counter->symbol_name = "PixelValues0Ready";
        counter->desc = "The percentage of time in which slice0 pixel values are ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = glk__rasterizer_and_pixel_backend__pixel_values0_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__rasterizer_and_pixel_backend__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__rasterizer_and_pixel_backend__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__rasterizer_and_pixel_backend__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__rasterizer_and_pixel_backend__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__rasterizer_and_pixel_backend__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__rasterizer_and_pixel_backend__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__rasterizer_and_pixel_backend__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Rasterizer Input Available";
        counter->symbol_name = "Rasterizer0InputAvailable";
        counter->desc = "The percentage of time in which slice0 rasterizer input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = glk__rasterizer_and_pixel_backend__rasterizer0_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Rasterizer");
    }

    if (perf->devinfo.slice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Rasterizer Output Ready";
        counter->symbol_name = "Rasterizer0OutputReady";
        counter->desc = "The percentage of time in which slice0 rasterizer output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = glk__rasterizer_and_pixel_backend__rasterizer0_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Rasterizer");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = glk__rasterizer_and_pixel_backend__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = glk__rasterizer_and_pixel_backend__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__rasterizer_and_pixel_backend__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__rasterizer_and_pixel_backend__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__rasterizer_and_pixel_backend__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__rasterizer_and_pixel_backend__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__rasterizer_and_pixel_backend__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__rasterizer_and_pixel_backend__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = glk__rasterizer_and_pixel_backend__slm_bytes_read__read;
    counter->max_uint64 = glk__rasterizer_and_pixel_backend__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = glk__rasterizer_and_pixel_backend__slm_bytes_written__read;
    counter->max_uint64 = glk__rasterizer_and_pixel_backend__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__rasterizer_and_pixel_backend__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__rasterizer_and_pixel_backend__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__rasterizer_and_pixel_backend__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__rasterizer_and_pixel_backend__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 41);
}

static void
glk_add_sampler_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set Sampler";
    metric_set->symbol_name = "Sampler";
    metric_set->hw_config_guid = "6ac97d12-ce13-428a-b20c-6902bde2608b";
    metric_set->counters = calloc(42, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(94, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(12, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x121300A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141600AB };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x123300A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x143600AB };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x125300A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x145600AB };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2D5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022D5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042D5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062D1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x102E01A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2E5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2E0065 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x164C2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x024EA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044E2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064E2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C0F0800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x180F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A0F023F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E2C0003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A2CC030 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04132180 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02130000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E142000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E150140 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C150040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C163000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E160068 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10160000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18160000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A164000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04330043 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02330000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0234A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04342000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C350015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02363460 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10360000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04360000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06360000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08364000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06530043 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02530000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E548000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00548000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06542000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E550400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A552000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C550100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E563000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00563400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10560000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18560000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02560000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C564000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1993A800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B9014A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D900001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900820 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45901022 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x70800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0000C000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000E7FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00003000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000F9FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000C00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FE7F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = glk__sampler__avg_gpu_core_frequency__read;
    counter->max_uint64 = glk__sampler__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__sampler__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__sampler__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__sampler__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__sampler__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__sampler__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__sampler__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = glk__sampler__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__sampler__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = glk__sampler__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = glk__sampler__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__sampler__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__sampler__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__sampler__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = glk__sampler__l3_shader_throughput__read;
    counter->max_uint64 = glk__sampler__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__sampler__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__sampler__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__sampler__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__sampler__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__sampler__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__sampler__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__sampler__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice0 Input Available";
        counter->symbol_name = "Sampler00InputAvailable";
        counter->desc = "The percentage of time in which slice0 subslice0 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = glk__sampler__sampler00_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice0 Sampler Output Ready";
        counter->symbol_name = "Sampler00OutputReady";
        counter->desc = "The percentage of time in which slice0 subslice0 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = glk__sampler__sampler00_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice1 Input Available";
        counter->symbol_name = "Sampler01InputAvailable";
        counter->desc = "The percentage of time in which slice0 subslice1 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = glk__sampler__sampler01_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice1 Sampler Output Ready";
        counter->symbol_name = "Sampler01OutputReady";
        counter->desc = "The percentage of time in which slice0 subslice1 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = glk__sampler__sampler01_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice2 Input Available";
        counter->symbol_name = "Sampler02InputAvailable";
        counter->desc = "The percentage of time in which slice0 subslice2 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = glk__sampler__sampler02_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice2 Sampler Output Ready";
        counter->symbol_name = "Sampler02OutputReady";
        counter->desc = "The percentage of time in which slice0 subslice2 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = glk__sampler__sampler02_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = glk__sampler__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = glk__sampler__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__sampler__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__sampler__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__sampler__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__sampler__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__sampler__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__sampler__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = glk__sampler__slm_bytes_read__read;
    counter->max_uint64 = glk__sampler__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = glk__sampler__slm_bytes_written__read;
    counter->max_uint64 = glk__sampler__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__sampler__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__sampler__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__sampler__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__sampler__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 42);
}

static void
glk_add_tdl_1_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set TDL_1";
    metric_set->symbol_name = "TDL_1";
    metric_set->hw_config_guid = "59ea703a-9a35-4aed-a985-0d9ab7aceaba";
    metric_set->counters = calloc(42, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(87, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(18, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x143A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x145A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2D5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022D5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042D5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062D1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x102E0150 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2E5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2E006A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x124C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x144C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x164C2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E4EA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x024E2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064E2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C0F0BC0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x180F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A0F0302 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E2C0003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A2C00F0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021A3080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041A31E5 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0414A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C150054 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06168000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08168000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A168000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C3A3280 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E3A0063 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x063A0061 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x023A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C348000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E342000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06342000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E350140 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C350100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18360028 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C368000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E5A3080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x005A3280 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x025A0063 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E548000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00548000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02542000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E550400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A552000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C550001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18560080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02568000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04568000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1993A800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x59900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B900420 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45901084 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900001 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x00007FFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x00009FFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000EFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000F3FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FDFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FE7F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = glk__tdl_1__avg_gpu_core_frequency__read;
    counter->max_uint64 = glk__tdl_1__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__tdl_1__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__tdl_1__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__tdl_1__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__tdl_1__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__tdl_1__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__tdl_1__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = glk__tdl_1__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__tdl_1__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = glk__tdl_1__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = glk__tdl_1__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__tdl_1__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__tdl_1__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__tdl_1__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = glk__tdl_1__l3_shader_throughput__read;
    counter->max_uint64 = glk__tdl_1__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "NonPS Thread Ready For Dispatch on Slice0 Subslice0";
        counter->symbol_name = "NonPSThread00ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice0 subslice0 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = glk__tdl_1__non_ps_thread00_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "NonPS Thread Ready For Dispatch on Slice0 Subslice1";
        counter->symbol_name = "NonPSThread01ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice0 subslice1 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = glk__tdl_1__non_ps_thread01_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "NonPS Thread Ready For Dispatch on Slice0 Subslice2";
        counter->symbol_name = "NonPSThread02ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice0 subslice2 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = glk__tdl_1__non_ps_thread02_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice0 Subslice0";
        counter->symbol_name = "PSThread00ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice0 subslice0 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = glk__tdl_1__ps_thread00_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice0 Subslice1";
        counter->symbol_name = "PSThread01ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice0 subslice1 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = glk__tdl_1__ps_thread01_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice0 Subslice2";
        counter->symbol_name = "PSThread02ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice0 subslice2 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = glk__tdl_1__ps_thread02_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__tdl_1__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__tdl_1__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__tdl_1__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__tdl_1__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__tdl_1__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__tdl_1__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__tdl_1__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = glk__tdl_1__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = glk__tdl_1__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__tdl_1__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__tdl_1__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__tdl_1__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__tdl_1__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__tdl_1__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__tdl_1__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = glk__tdl_1__slm_bytes_read__read;
    counter->max_uint64 = glk__tdl_1__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = glk__tdl_1__slm_bytes_written__read;
    counter->max_uint64 = glk__tdl_1__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__tdl_1__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__tdl_1__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__tdl_1__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__tdl_1__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 42);
}

static void
glk_add_tdl_2_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set TDL_2";
    metric_set->symbol_name = "TDL_2";
    metric_set->hw_config_guid = "f2d6d718-e7b1-48f4-9624-45230d2fe2a0";
    metric_set->counters = calloc(42, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(59, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(6, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x000091BC, .val = 0xE0500000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141A026B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x143A0173 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x145A026B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022D5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042D5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062D1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2E5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2E0069 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x024EA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064E2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x180F6000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A0F030A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A2C03C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041A37E7 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0414A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C150050 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08168000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A168000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x003A3380 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x063A006F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x023A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00348000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06342000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A352000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C350100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02368000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C368000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x025A37E7 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0254A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C550005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04568000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06568000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45901080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = glk__tdl_2__avg_gpu_core_frequency__read;
    counter->max_uint64 = glk__tdl_2__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__tdl_2__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__tdl_2__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__tdl_2__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__tdl_2__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__tdl_2__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__tdl_2__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    if (true &&
        perf->devinfo.query_mode) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "SQ is full";
        counter->symbol_name = "GTRequestQueueFull";
        counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = glk__tdl_2__gt_request_queue_full__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__tdl_2__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = glk__tdl_2__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = glk__tdl_2__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__tdl_2__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__tdl_2__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__tdl_2__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = glk__tdl_2__l3_shader_throughput__read;
    counter->max_uint64 = glk__tdl_2__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__tdl_2__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__tdl_2__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__tdl_2__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__tdl_2__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__tdl_2__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__tdl_2__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__tdl_2__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = glk__tdl_2__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = glk__tdl_2__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__tdl_2__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__tdl_2__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = glk__tdl_2__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__tdl_2__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__tdl_2__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = glk__tdl_2__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = glk__tdl_2__slm_bytes_read__read;
    counter->max_uint64 = glk__tdl_2__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = glk__tdl_2__slm_bytes_written__read;
    counter->max_uint64 = glk__tdl_2__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice0 Port 0";
        counter->symbol_name = "ThreadHeader00ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice0 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = glk__tdl_2__thread_header00_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice0 Port 1";
        counter->symbol_name = "ThreadHeader00ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice0 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = glk__tdl_2__thread_header00_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice1 Port 0";
        counter->symbol_name = "ThreadHeader01ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice1 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = glk__tdl_2__thread_header01_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice1 Port 1";
        counter->symbol_name = "ThreadHeader01ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice1 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = glk__tdl_2__thread_header01_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice2 Port 0";
        counter->symbol_name = "ThreadHeader02ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice2 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = glk__tdl_2__thread_header02_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 0x4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice2 Port 1";
        counter->symbol_name = "ThreadHeader02ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice2 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = glk__tdl_2__thread_header02_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__tdl_2__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__tdl_2__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__tdl_2__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = glk__tdl_2__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 42);
}

static void
glk_add_compute_extra_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Compute Metrics Extra Gen9";
    metric_set->symbol_name = "ComputeExtra";
    metric_set->hw_config_guid = "15274c82-27d2-4819-876a-7cb1a2c59ba4";
    metric_set->counters = calloc(5, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(37, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(6, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141A001F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x143A001F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x145A001F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042D5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062D1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2E0094 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044EA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A0F00E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A2C0C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x061A0063 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06142000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C150100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C168000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x043A3180 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x023A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04348000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C350040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A368000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x045A0063 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x025A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04542000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C550010 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08568000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x45900400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900004 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00001000 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00003002 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00011010 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00050012 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00052051 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00000008 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = glk__compute_extra__avg_gpu_core_frequency__read;
    counter->max_uint64 = glk__compute_extra__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active";
    counter->symbol_name = "Fpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__compute_extra__fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active including Ext Math";
    counter->symbol_name = "Fpu1ActiveAdjusted";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing including Extended Math processing";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = glk__compute_extra__fpu1_active_adjusted__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = glk__compute_extra__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = glk__compute_extra__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    assert(metric_set->n_counters <= 5);
}

static void
glk_add_test_oa_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "MDAPI testing set Gen9";
    metric_set->symbol_name = "TestOa";
    metric_set->hw_config_guid = "dd3fd789-e783-4204-8cd0-b671bbccb0cf";
    metric_set->counters = calloc(12, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(12, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(22, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07800063 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11800000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x23810008 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D950400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F922000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F908000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000004 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00000003 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000007 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00100002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FFF7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00100002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FFCF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00100082 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FFEF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x001000C2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FFE7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x00100001 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000FFE7 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = glk__test_oa__avg_gpu_core_frequency__read;
    counter->max_uint64 = glk__test_oa__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter0";
    counter->symbol_name = "Counter0";
    counter->desc = "HW test counter 0. Factor: 0.0";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = glk__test_oa__counter0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter1";
    counter->symbol_name = "Counter1";
    counter->desc = "HW test counter 1. Factor: 1.0";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = glk__test_oa__counter1__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter2";
    counter->symbol_name = "Counter2";
    counter->desc = "HW test counter 2. Factor: 1.0";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = glk__test_oa__counter2__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter3";
    counter->symbol_name = "Counter3";
    counter->desc = "HW test counter 3. Factor: 0.5";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = glk__test_oa__counter3__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter4";
    counter->symbol_name = "Counter4";
    counter->desc = "HW test counter 4. Factor: 0.333";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = glk__test_oa__counter4__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter5";
    counter->symbol_name = "Counter5";
    counter->desc = "HW test counter 5. Factor: 0.333";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = glk__test_oa__counter5__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter6";
    counter->symbol_name = "Counter6";
    counter->desc = "HW test counter 6. Factor: 0.166";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = glk__test_oa__counter6__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter7";
    counter->symbol_name = "Counter7";
    counter->desc = "HW test counter 7. Factor: 0.666";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = glk__test_oa__counter7__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter8";
    counter->symbol_name = "Counter8";
    counter->desc = "HW test counter 8. Should be equal to 1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = glk__test_oa__counter8__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = glk__test_oa__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = glk__test_oa__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    assert(metric_set->n_counters <= 12);
}

static void
glk_add_pma__stall_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set PMA Stall";
    metric_set->symbol_name = "PMA_Stall";
    metric_set->hw_config_guid = "e6868953-fb47-431d-a060-f785916558fc";
    metric_set->counters = calloc(4, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(34, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(9, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x124C3080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002D1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082D5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2D5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2E0400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2E5500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x102E0001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x004C0045 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x064C2300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084C26C4 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A4C264E };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x164C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C4C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E4C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F938000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x199300AA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x23904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x27904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x29904000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x37900000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33900000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00E00021 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0007FFF8 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x07000101 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0038FFC7 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = glk__pma__stall__avg_gpu_core_frequency__read;
    counter->max_uint64 = glk__pma__stall__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = glk__pma__stall__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = glk__pma__stall__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "STC PMA stall";
        counter->symbol_name = "StcPMAStall";
        counter->desc = "Percentage of time when stencil cache line and an overlapping pixel are causing stalls";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = glk__pma__stall__stc_pma_stall__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Stencil Cache");
    }

    assert(metric_set->n_counters <= 4);
}

static void
cnl_add_render_basic_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Render Metrics Basic Gen10";
    metric_set->symbol_name = "RenderBasic";
    metric_set->hw_config_guid = "2d975e19-7130-41d2-b06f-79d74f91e7c8";
    metric_set->counters = calloc(51, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(98, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(7, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(6, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x146C0008 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18110014 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14EC0008 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18910014 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A6C0054 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6C0444 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02738000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0473E000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04742000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C742000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04752000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C752000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C760800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E760800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0077C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E778000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1477C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x167702A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00194000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A190020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00110060 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08110061 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E110000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10110000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18144000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C140400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AEC5400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10EC0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1AEC0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04F38000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AF48000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CF48000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AF58000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CF58000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EF62200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EF7C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16F70230 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E994000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A990080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06916000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08916100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E910000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C941100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000007 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B086F4F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D080001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D073800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F070140 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09081E93 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01083160 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x030801A6 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11080000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F080000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D095000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F095000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01094000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03095000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05091000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13040154 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09044000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B045000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D049000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F042000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0507E700 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x070700D7 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25070000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B070000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1100C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F00C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2100C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2300C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2500C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2700C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x29004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47003331 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x390018C1 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49000333 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3D000407 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B001101 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F000120 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D003333 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x410018C6 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43000006 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3B001CC6 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x40800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x00000202 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FF3F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00222222 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = cnl__render_basic__avg_gpu_core_frequency__read;
    counter->max_uint64 = cnl__render_basic__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__render_basic__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__render_basic__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__render_basic__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__render_basic__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__render_basic__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__render_basic__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__render_basic__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = cnl__render_basic__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = cnl__render_basic__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__render_basic__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Depth Throughput";
    counter->symbol_name = "GtiDepthThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between depth caches and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cnl__render_basic__gti_depth_throughput__read;
    counter->max_uint64 = cnl__render_basic__gti_depth_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI L3 Throughput";
    counter->symbol_name = "GtiL3Throughput";
    counter->desc = "The total number of GPU memory bytes transferred between L3 caches and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cnl__render_basic__gti_l3_throughput__read;
    counter->max_uint64 = cnl__render_basic__gti_l3_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI RCC Throughput";
    counter->symbol_name = "GtiRccThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between render color caches and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cnl__render_basic__gti_rcc_throughput__read;
    counter->max_uint64 = cnl__render_basic__gti_rcc_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Read Throughput";
    counter->symbol_name = "GtiReadThroughput";
    counter->desc = "The total number of GPU memory bytes read from GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cnl__render_basic__gti_read_throughput__read;
    counter->max_uint64 = cnl__render_basic__gti_read_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Fixed Pipe Throughput";
    counter->symbol_name = "GtiVfThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between 3D Pipeline (Command Dispatch, Input Assembly and Stream Output) and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cnl__render_basic__gti_vf_throughput__read;
    counter->max_uint64 = cnl__render_basic__gti_vf_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Write Throughput";
    counter->symbol_name = "GtiWriteThroughput";
    counter->desc = "The total number of GPU memory bytes written to GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cnl__render_basic__gti_write_throughput__read;
    counter->max_uint64 = cnl__render_basic__gti_write_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__render_basic__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__render_basic__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Lookup Accesses w/o IC";
    counter->symbol_name = "L3Lookups";
    counter->desc = "The total number of L3 cache lookup accesses w/o IC.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__render_basic__l3_lookups__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/TAG");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Misses";
    counter->symbol_name = "L3Misses";
    counter->desc = "The total number of L3 misses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__render_basic__l3_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/TAG");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Sampler Throughput";
    counter->symbol_name = "L3SamplerThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between samplers and L3 caches.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cnl__render_basic__l3_sampler_throughput__read;
    counter->max_uint64 = cnl__render_basic__l3_sampler_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cnl__render_basic__l3_shader_throughput__read;
    counter->max_uint64 = cnl__render_basic__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__render_basic__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__render_basic__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__render_basic__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__render_basic__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__render_basic__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__render_basic__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__render_basic__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Sampler00 Bottleneck";
        counter->symbol_name = "Sampler00Bottleneck";
        counter->desc = "The percentage of time in which Slice0 Sampler0 has been slowing down the pipe when processing EU requests.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__render_basic__sampler00_bottleneck__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Sampler00 Busy";
        counter->symbol_name = "Sampler00Busy";
        counter->desc = "The percentage of time in which Slice0 Sampler0 has been processing EU requests.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__render_basic__sampler00_busy__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    if (perf->devinfo.subslice_mask & 8) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Sampler10 Bottleneck";
        counter->symbol_name = "Sampler10Bottleneck";
        counter->desc = "The percentage of time in which Slice1 Sampler0 has been slowing down the pipe when processing EU requests.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__render_basic__sampler10_bottleneck__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    if (perf->devinfo.subslice_mask & 8) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Sampler10 Busy";
        counter->symbol_name = "Sampler10Busy";
        counter->desc = "The percentage of time in which Slice1 Sampler0 has been processing EU requests.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__render_basic__sampler10_busy__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    if (perf->devinfo.subslice_mask & 9) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Samplers Bottleneck";
        counter->symbol_name = "SamplerBottleneck";
        counter->desc = "The percentage of time in which samplers have been slowing down the pipe when processing EU requests.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__render_basic__sampler_bottleneck__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Cache Misses";
    counter->symbol_name = "SamplerL1Misses";
    counter->desc = "The total number of sampler cache misses in all LODs in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__render_basic__sampler_l1_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cnl__render_basic__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cnl__render_basic__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    if (perf->devinfo.subslice_mask & 9) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Samplers Busy";
        counter->symbol_name = "SamplersBusy";
        counter->desc = "The percentage of time in which samplers have been processing EU requests.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__render_basic__samplers_busy__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__render_basic__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__render_basic__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__render_basic__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__render_basic__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__render_basic__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__render_basic__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cnl__render_basic__slm_bytes_read__read;
    counter->max_uint64 = cnl__render_basic__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cnl__render_basic__slm_bytes_written__read;
    counter->max_uint64 = cnl__render_basic__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__render_basic__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__render_basic__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__render_basic__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__render_basic__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 51);
}

static void
cnl_add_compute_basic_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Compute Metrics Basic Gen10";
    metric_set->symbol_name = "ComputeBasic";
    metric_set->hw_config_guid = "eed14f91-5f03-4e3a-8281-ac38030ac573";
    metric_set->counters = calloc(39, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(129, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(5, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(4, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x121A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x101A0007 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x123A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x129A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x109A0007 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12BA0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x125A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6C0140 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C6C0005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x186C0880 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04736000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0673C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00734000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02731000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0474A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E748000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06748000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0475A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E758000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06758000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C762800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10760002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E760002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0077C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E774000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14774000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x167797A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18770002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0277C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04778000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0677C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08778000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A7B0A00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C7B0028 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E7C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x147C0C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x167C0038 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C7D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E7D0080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0019C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A191800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0219C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0619C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001A2E52 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1A2880 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021A2D80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E39C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A396000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x063A2900 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C3A0051 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x003A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CF48000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12F40400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06F42000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08F42000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CF58000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14F50020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06F52000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08F52000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EF62008 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10F60080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CF68000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16F7C070 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18F70001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04F7C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08F7C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AFB8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CFB0200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14FC8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16FC0200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1EFD2008 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A990180 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C99000C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0499C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0899C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x089A2900 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E9A0051 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x029A005C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x049A005B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x009A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1AB90600 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1CB90030 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0ABA0052 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EBA2880 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00BA0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A590060 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C590003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x085A0052 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C5A2880 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x005A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000007 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D073800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F070140 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D048000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F042000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0507E700 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x070700D7 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25070000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B070000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1100C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F00C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2100C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2300C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2500C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2700C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2900C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B00C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D00C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F00C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1300C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1500C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1700C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1900C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47001011 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x39000021 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49001330 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3D001026 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B001000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F000400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D000001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41000081 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3B001801 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00000003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00002001 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00000008 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = cnl__compute_basic__avg_gpu_core_frequency__read;
    counter->max_uint64 = cnl__compute_basic__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__compute_basic__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__compute_basic__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__compute_basic__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__compute_basic__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU AVG IPC Rate";
    counter->symbol_name = "EuAvgIpcRate";
    counter->desc = "The average rate of IPC calculated for 2 FPU pipelines.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NUMBER;
    counter->read_float = cnl__compute_basic__eu_avg_ipc_rate__read;
    counter->max_float = cnl__compute_basic__eu_avg_ipc_rate__max;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__compute_basic__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Send Pipe Active";
    counter->symbol_name = "EuSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__compute_basic__eu_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__compute_basic__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Thread Occupancy";
    counter->symbol_name = "EuThreadOccupancy";
    counter->desc = "The percentage of time in which hardware threads occupied EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__compute_basic__eu_thread_occupancy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Pipe Active";
    counter->symbol_name = "Fpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__compute_basic__fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active";
    counter->symbol_name = "Fpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__compute_basic__fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__compute_basic__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = cnl__compute_basic__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = cnl__compute_basic__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__compute_basic__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Read Throughput";
    counter->symbol_name = "GtiReadThroughput";
    counter->desc = "The total number of GPU memory bytes read from GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cnl__compute_basic__gti_read_throughput__read;
    counter->max_uint64 = cnl__compute_basic__gti_read_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Write Throughput";
    counter->symbol_name = "GtiWriteThroughput";
    counter->desc = "The total number of GPU memory bytes written to GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cnl__compute_basic__gti_write_throughput__read;
    counter->max_uint64 = cnl__compute_basic__gti_write_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__compute_basic__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__compute_basic__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cnl__compute_basic__l3_shader_throughput__read;
    counter->max_uint64 = cnl__compute_basic__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__compute_basic__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__compute_basic__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__compute_basic__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cnl__compute_basic__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cnl__compute_basic__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__compute_basic__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__compute_basic__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__compute_basic__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__compute_basic__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__compute_basic__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__compute_basic__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cnl__compute_basic__slm_bytes_read__read;
    counter->max_uint64 = cnl__compute_basic__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cnl__compute_basic__slm_bytes_written__read;
    counter->max_uint64 = cnl__compute_basic__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Bytes Read";
    counter->symbol_name = "TypedBytesRead";
    counter->desc = "The total number of typed memory bytes read via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cnl__compute_basic__typed_bytes_read__read;
    counter->max_uint64 = cnl__compute_basic__typed_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Bytes Written";
    counter->symbol_name = "TypedBytesWritten";
    counter->desc = "The total number of untyped memory bytes written via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cnl__compute_basic__typed_bytes_written__read;
    counter->max_uint64 = cnl__compute_basic__typed_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    if (perf->devinfo.subslice_mask & 9) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Untyped Bytes Read";
        counter->symbol_name = "UntypedBytesRead";
        counter->desc = "The total number of typed memory bytes read via Data Port.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
        counter->read_uint64 = cnl__compute_basic__untyped_bytes_read__read;
        counter->max_uint64 = cnl__compute_basic__untyped_bytes_read__max;
        intel_perf_add_logical_counter(perf, counter, "L3/Data Port");
    }

    if (perf->devinfo.subslice_mask & 9) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Untyped Writes";
        counter->symbol_name = "UntypedBytesWritten";
        counter->desc = "The total number of untyped memory bytes written via Data Port.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
        counter->read_uint64 = cnl__compute_basic__untyped_bytes_written__read;
        counter->max_uint64 = cnl__compute_basic__untyped_bytes_written__max;
        intel_perf_add_logical_counter(perf, counter, "L3/Data Port");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__compute_basic__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 39);
}

static void
cnl_add_render_pipe_profile_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Render Metrics for 3D Pipeline Profile Gen10";
    metric_set->symbol_name = "RenderPipeProfile";
    metric_set->hw_config_guid = "0666ccac-f5aa-4dc2-aa12-c6e058f383f3";
    metric_set->counters = calloc(43, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(123, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(5, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(1, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A7003E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A710000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1017001E };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06700015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00700000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06710800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00710000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C746000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C75A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E754000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E762800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10760002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1477C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16770330 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A190040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08170001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C170000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000007 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01160031 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11177C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11187C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05190000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x110E7800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x130F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15120000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11130019 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F160C80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B160000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07162000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03168000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x071705C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x011704C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05170000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B180015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01185000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07185000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D185000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F185000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03186000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05185000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03190022 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F190000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09190000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D0E8023 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x030E1100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x050E4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D0F0180 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x050F0001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x010F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B100054 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07104000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09104000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B104000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D104000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B114000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D110006 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07118000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09118000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B114000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D114000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05127100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07120073 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21120001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F120000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F130002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01130000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B144000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F144025 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11140025 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D145200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11158000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F158080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13158000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0109A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0709A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B092000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D09A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F09A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0309A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0509A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x010BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x070BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B0B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D0BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F0BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x030BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x050BC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09045000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F045000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11044000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13040154 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B045000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D045000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2100C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2300C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2700C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x29004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47001111 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x39001022 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49001111 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3D000021 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B000100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F0018A5 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D001111 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41000001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43000002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3B000401 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = cnl__render_pipe_profile__avg_gpu_core_frequency__read;
    counter->max_uint64 = cnl__render_pipe_profile__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "BC Bottleneck";
    counter->symbol_name = "BcBottleneck";
    counter->desc = "The percentage of time in which barycentric coordinates calculation pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__render_pipe_profile__bc_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Barycentric Calc");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Clipper Bottleneck";
    counter->symbol_name = "ClBottleneck";
    counter->desc = "The percentage of time in which clipper pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__render_pipe_profile__cl_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Clipper");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CL Stall";
    counter->symbol_name = "ClStall";
    counter->desc = "The percentage of time in which clipper pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__render_pipe_profile__cl_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Clipper");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__render_pipe_profile__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Bottleneck";
    counter->symbol_name = "DsBottleneck";
    counter->desc = "The percentage of time in which domain shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__render_pipe_profile__ds_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Stall";
    counter->symbol_name = "DsStall";
    counter->desc = "The percentage of time in which domain shader pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__render_pipe_profile__ds_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__render_pipe_profile__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Bottleneck";
    counter->symbol_name = "EarlyDepthBottleneck";
    counter->desc = "The percentage of time in which early depth test pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__render_pipe_profile__early_depth_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__render_pipe_profile__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__render_pipe_profile__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__render_pipe_profile__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__render_pipe_profile__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = cnl__render_pipe_profile__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = cnl__render_pipe_profile__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Bottleneck";
    counter->symbol_name = "GsBottleneck";
    counter->desc = "The percentage of time in which geometry shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__render_pipe_profile__gs_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__render_pipe_profile__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Hi-Depth Bottleneck";
    counter->symbol_name = "HiDepthBottleneck";
    counter->desc = "The percentage of time in which early hierarchical depth test pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__render_pipe_profile__hi_depth_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__render_pipe_profile__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Bottleneck";
    counter->symbol_name = "HsBottleneck";
    counter->desc = "The percentage of time in which hull shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__render_pipe_profile__hs_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Stall";
    counter->symbol_name = "HsStall";
    counter->desc = "The percentage of time in which hull stall pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__render_pipe_profile__hs_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__render_pipe_profile__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cnl__render_pipe_profile__l3_shader_throughput__read;
    counter->max_uint64 = cnl__render_pipe_profile__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__render_pipe_profile__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__render_pipe_profile__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__render_pipe_profile__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cnl__render_pipe_profile__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cnl__render_pipe_profile__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__render_pipe_profile__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__render_pipe_profile__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__render_pipe_profile__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Strip-Fans Bottleneck";
    counter->symbol_name = "SfBottleneck";
    counter->desc = "The percentage of time in which strip-fans pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__render_pipe_profile__sf_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Strip-Fans");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SF Stall";
    counter->symbol_name = "SfStall";
    counter->desc = "The percentage of time in which strip-fans pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__render_pipe_profile__sf_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Strip-Fans");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__render_pipe_profile__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__render_pipe_profile__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__render_pipe_profile__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cnl__render_pipe_profile__slm_bytes_read__read;
    counter->max_uint64 = cnl__render_pipe_profile__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cnl__render_pipe_profile__slm_bytes_written__read;
    counter->max_uint64 = cnl__render_pipe_profile__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SO Bottleneck";
    counter->symbol_name = "SoBottleneck";
    counter->desc = "The percentage of time in which stream output pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__render_pipe_profile__so_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Stream Output");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SO Stall";
    counter->symbol_name = "SoStall";
    counter->desc = "The percentage of time in which stream-output pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__render_pipe_profile__so_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Stream Output");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VF Bottleneck";
    counter->symbol_name = "VfBottleneck";
    counter->desc = "The percentage of time in which vertex fetch pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__render_pipe_profile__vf_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Input Assembler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Bottleneck";
    counter->symbol_name = "VsBottleneck";
    counter->desc = "The percentage of time in which vertex shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__render_pipe_profile__vs_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__render_pipe_profile__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 43);
}

static void
cnl_add_memory_reads_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Memory Reads Distribution Gen10";
    metric_set->symbol_name = "MemoryReads";
    metric_set->hw_config_guid = "3500dcfd-837b-4ec8-b5cf-fe58b966263f";
    metric_set->counters = calloc(40, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(56, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(26, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(1, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000007 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17066860 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15070017 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F072920 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B038000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D038000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F034000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F063180 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01063100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0306006B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05060000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11080100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D085000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F094000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01094000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03091000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09046000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F04A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1104A800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x130401AA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B041000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x010700E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0707E153 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0907E3E2 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B07E5E4 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D07E7E6 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F0700EF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25070000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11070000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x23070000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D070000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x23004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x27004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x29004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x39000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3D000C63 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F000C63 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41000C63 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43000000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0000081A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x0000082A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000872 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x000008BA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x0000087A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x000008EA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x000008E2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x000008F2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000274C, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00006667 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002748, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000275C, .val = 0x86543210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002754, .val = 0x00000065 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = cnl__memory_reads__avg_gpu_core_frequency__read;
    counter->max_uint64 = cnl__memory_reads__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__memory_reads__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__memory_reads__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__memory_reads__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__memory_reads__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__memory_reads__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__memory_reads__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = cnl__memory_reads__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = cnl__memory_reads__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__memory_reads__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiCmdStreamerMemoryReads";
    counter->symbol_name = "GtiCmdStreamerMemoryReads";
    counter->desc = "The total number of GTI memory reads from Command Streamer.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__memory_reads__gti_cmd_streamer_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Command Streamer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiHizMemoryReads";
    counter->symbol_name = "GtiHizMemoryReads";
    counter->desc = "The total number of GTI memory reads from Hierarchical Depth Cache (Hi-Depth Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__memory_reads__gti_hiz_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank0Reads";
    counter->symbol_name = "GtiL3Bank0Reads";
    counter->desc = "The total number of GTI memory reads from L3 Bank 0 (L3 Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__memory_reads__gti_l3_bank0_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank1Reads";
    counter->symbol_name = "GtiL3Bank1Reads";
    counter->desc = "The total number of GTI memory reads from L3 Bank 1 (L3 Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__memory_reads__gti_l3_bank1_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank2Reads";
    counter->symbol_name = "GtiL3Bank2Reads";
    counter->desc = "The total number of GTI memory reads from L3 Bank 2 (L3 Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__memory_reads__gti_l3_bank2_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Reads";
    counter->symbol_name = "GtiL3Reads";
    counter->desc = "The total number of GTI memory reads from L3 (L3 Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__memory_reads__gti_l3_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiMemoryReads";
    counter->symbol_name = "GtiMemoryReads";
    counter->desc = "The total number of GTI memory reads.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__memory_reads__gti_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiMscMemoryReads";
    counter->symbol_name = "GtiMscMemoryReads";
    counter->desc = "The total number of GTI memory reads from Multisampling Color Cache (Multisampling Color Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__memory_reads__gti_msc_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRccMemoryReads";
    counter->symbol_name = "GtiRccMemoryReads";
    counter->desc = "The total number of GTI memory reads from Render Color Cache (Render Color Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__memory_reads__gti_rcc_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRczMemoryReads";
    counter->symbol_name = "GtiRczMemoryReads";
    counter->desc = "The total number of GTI memory reads from Render Depth Cache (Render Depth Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__memory_reads__gti_rcz_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRingAccesses";
    counter->symbol_name = "GtiRingAccesses";
    counter->desc = "The total number of all accesses from GTI to the ring.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__memory_reads__gti_ring_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRsMemoryReads";
    counter->symbol_name = "GtiRsMemoryReads";
    counter->desc = "The total number of GTI memory reads from Resource Streamer.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__memory_reads__gti_rs_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Resource Streamer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiStcMemoryReads";
    counter->symbol_name = "GtiStcMemoryReads";
    counter->desc = "The total number of GTI memory reads from Stencil Cache (Stencil Cache misses).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__memory_reads__gti_stc_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiVfMemoryReads";
    counter->symbol_name = "GtiVfMemoryReads";
    counter->desc = "The total number of GTI memory reads from Vertex Fetch.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__memory_reads__gti_vf_memory_reads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Vertex Fetch");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__memory_reads__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__memory_reads__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__memory_reads__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__memory_reads__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__memory_reads__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cnl__memory_reads__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cnl__memory_reads__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__memory_reads__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__memory_reads__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__memory_reads__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__memory_reads__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__memory_reads__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__memory_reads__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cnl__memory_reads__slm_bytes_read__read;
    counter->max_uint64 = cnl__memory_reads__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cnl__memory_reads__slm_bytes_written__read;
    counter->max_uint64 = cnl__memory_reads__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__memory_reads__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 40);
}

static void
cnl_add_memory_writes_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Memory Writes Distribution Gen10";
    metric_set->symbol_name = "MemoryWrites";
    metric_set->hw_config_guid = "63d18ead-3cfc-4972-a640-5e98b688dfee";
    metric_set->counters = calloc(40, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(56, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(24, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(1, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000007 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17066860 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15070017 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D073C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F07000E };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B038000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D038000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F034000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F063180 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01063100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0306006B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05060000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11080100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D085000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F094000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01094000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03091000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09046000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F04A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1104A800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x130401AA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B041000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x010700D0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0707D153 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0907D3D2 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B07D5D4 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D07D7D6 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F0700DF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25070000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11070000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x23070000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x23004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x27004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x29004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x39000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3D000C63 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F000C63 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41000C63 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43000000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x70800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0000081A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00000822 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x000008BA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x0000087A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x000008EA };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x000008E2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x000008F2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000274C, .val = 0x65432108 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x0000CCCE };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002748, .val = 0x65432108 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000275C, .val = 0x65432108 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002754, .val = 0x000000CA };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = cnl__memory_writes__avg_gpu_core_frequency__read;
    counter->max_uint64 = cnl__memory_writes__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__memory_writes__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__memory_writes__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__memory_writes__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__memory_writes__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__memory_writes__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__memory_writes__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = cnl__memory_writes__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = cnl__memory_writes__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__memory_writes__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiCmdStreamerMemoryWrites";
    counter->symbol_name = "GtiCmdStreamerMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Command Streamer.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__memory_writes__gti_cmd_streamer_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Command Streamer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiHizMemoryWrites";
    counter->symbol_name = "GtiHizMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Hierarchical Depth Cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__memory_writes__gti_hiz_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank0Writes";
    counter->symbol_name = "GtiL3Bank0Writes";
    counter->desc = "The total number of GTI memory writes from L3 Bank 0 (L3 Bank 0 invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__memory_writes__gti_l3_bank0_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank1Writes";
    counter->symbol_name = "GtiL3Bank1Writes";
    counter->desc = "The total number of GTI memory writes from L3 Bank 1 (L3 Bank 1 invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__memory_writes__gti_l3_bank1_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Bank2Writes";
    counter->symbol_name = "GtiL3Bank2Writes";
    counter->desc = "The total number of GTI memory writes from L3 Bank 2 (L3 Bank 2 invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__memory_writes__gti_l3_bank2_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiL3Writes";
    counter->symbol_name = "GtiL3Writes";
    counter->desc = "The total number of GTI memory writes from L3 (L3 invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__memory_writes__gti_l3_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiMemoryWrites";
    counter->symbol_name = "GtiMemoryWrites";
    counter->desc = "The total number of GTI memory writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__memory_writes__gti_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiMscMemoryWrites";
    counter->symbol_name = "GtiMscMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Multisampling Color Cache (Multisampling Color Cache invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__memory_writes__gti_msc_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRccMemoryWrites";
    counter->symbol_name = "GtiRccMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Render Color Cache (Render Color Cache invalidations).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__memory_writes__gti_rcc_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Color Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRczMemoryWrites";
    counter->symbol_name = "GtiRczMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Render Depth Cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__memory_writes__gti_rcz_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiRingAccesses";
    counter->symbol_name = "GtiRingAccesses";
    counter->desc = "The total number of all accesses from GTI to the ring.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__memory_writes__gti_ring_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiSoMemoryWrites";
    counter->symbol_name = "GtiSoMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Stream Output.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__memory_writes__gti_so_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/3D Pipe/Stream Output");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GtiStcMemoryWrites";
    counter->symbol_name = "GtiStcMemoryWrites";
    counter->desc = "The total number of GTI memory writes from Stencil Cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__memory_writes__gti_stc_memory_writes__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GTI/Depth Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__memory_writes__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__memory_writes__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cnl__memory_writes__l3_shader_throughput__read;
    counter->max_uint64 = cnl__memory_writes__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__memory_writes__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__memory_writes__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__memory_writes__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cnl__memory_writes__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cnl__memory_writes__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__memory_writes__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__memory_writes__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__memory_writes__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__memory_writes__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__memory_writes__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__memory_writes__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cnl__memory_writes__slm_bytes_read__read;
    counter->max_uint64 = cnl__memory_writes__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cnl__memory_writes__slm_bytes_written__read;
    counter->max_uint64 = cnl__memory_writes__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__memory_writes__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 40);
}

static void
cnl_add_compute_extended_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Compute Metrics Extended Gen10";
    metric_set->symbol_name = "ComputeExtended";
    metric_set->hw_config_guid = "1b4d1280-6bbd-4d57-90c6-a03ed6059688";
    metric_set->counters = calloc(38, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(80, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(21, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(4, sizeof(struct intel_perf_register_prog));

    if (perf->devinfo.subslice_mask & 1) {
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x121A0007 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x101A0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x121B000B };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x161B0009 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0474A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A748000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C74A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E74A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12741540 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0674A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08742000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0475A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A758000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C75A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E75A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x147500AA };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0675A000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08752000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C76A800 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E76AA0A };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x107602AA };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0077C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E77C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1477C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1677FFF0 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18770003 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0277C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0477C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0677C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0877C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00198000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E198000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A195540 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C19003A };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0219C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0419C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0619C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0819C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1A2A00 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001A2980 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021A2CDA };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041A0058 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001B0011 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x061B0900 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x081B0A13 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1B0B15 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1B2317 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1B0043 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x101B0000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10178000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1701FE };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000007 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1100C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F00C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2100C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2300C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2500C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2700C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2900C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B00C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D00C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F00C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1300C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1500C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1700C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1900C000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47000000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x39000420 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49000000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3D000000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B000000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F000000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D000000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41000000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35000000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31000000 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43000001 };
        metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3B000021 };
    }

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000C2A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00000C6A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000C32 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00000E6A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00000E7A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00000C92 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x00000CA2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x00000C9A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000FE00 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00000003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00002001 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00000008 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = cnl__compute_extended__avg_gpu_core_frequency__read;
    counter->max_uint64 = cnl__compute_extended__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__compute_extended__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuA64UntypedReads0";
    counter->symbol_name = "EuA64UntypedReads0";
    counter->desc = "The subslice 0 EU A64 Untyped Reads subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__compute_extended__eu_a64_untyped_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuA64UntypedWrites0";
    counter->symbol_name = "EuA64UntypedWrites0";
    counter->desc = "The subslice 0 EU A64 Untyped Writes subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__compute_extended__eu_a64_untyped_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__compute_extended__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU AVG IPC Rate";
    counter->symbol_name = "EuAvgIpcRate";
    counter->desc = "The average rate of IPC calculated for 2 FPU pipelines.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NUMBER;
    counter->read_float = cnl__compute_extended__eu_avg_ipc_rate__read;
    counter->max_float = cnl__compute_extended__eu_avg_ipc_rate__max;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__compute_extended__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Send Pipe Active";
    counter->symbol_name = "EuSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__compute_extended__eu_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__compute_extended__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Thread Occupancy";
    counter->symbol_name = "EuThreadOccupancy";
    counter->desc = "The percentage of time in which hardware threads occupied EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__compute_extended__eu_thread_occupancy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuTypedAtomics0";
    counter->symbol_name = "EuTypedAtomics0";
    counter->desc = "The subslice 0 EU Typed Atomics subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__compute_extended__eu_typed_atomics0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuTypedReads0";
    counter->symbol_name = "EuTypedReads0";
    counter->desc = "The subslice 0 EU Typed Reads subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__compute_extended__eu_typed_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuTypedWrites0";
    counter->symbol_name = "EuTypedWrites0";
    counter->desc = "The subslice 0 EU Typed Writes subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__compute_extended__eu_typed_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuUntypedAtomics0";
    counter->symbol_name = "EuUntypedAtomics0";
    counter->desc = "The subslice 0 EU Untyped Atomics subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__compute_extended__eu_untyped_atomics0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuUntypedReads0";
    counter->symbol_name = "EuUntypedReads0";
    counter->desc = "The subslice 0 EU Untyped Reads subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__compute_extended__eu_untyped_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EuUntypedWrites0";
    counter->symbol_name = "EuUntypedWrites0";
    counter->desc = "The subslice 0 EU Untyped Writes subslice 0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__compute_extended__eu_untyped_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Pipe Active";
    counter->symbol_name = "Fpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__compute_extended__fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active";
    counter->symbol_name = "Fpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__compute_extended__fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = cnl__compute_extended__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = cnl__compute_extended__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cnl__compute_extended__l3_shader_throughput__read;
    counter->max_uint64 = cnl__compute_extended__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cnl__compute_extended__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cnl__compute_extended__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__compute_extended__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__compute_extended__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__compute_extended__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cnl__compute_extended__slm_bytes_read__read;
    counter->max_uint64 = cnl__compute_extended__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cnl__compute_extended__slm_bytes_written__read;
    counter->max_uint64 = cnl__compute_extended__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Atomics 0";
    counter->symbol_name = "TypedAtomics0";
    counter->desc = "The subslice 0 typed atomics.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__compute_extended__typed_atomics0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TypedAtomicsPerCacheLine";
    counter->symbol_name = "TypedAtomicsPerCacheLine";
    counter->desc = "The ratio of EU typed atomics requests to L3 cache line writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
    counter->read_float = cnl__compute_extended__typed_atomics_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Reads 0";
    counter->symbol_name = "TypedReads0";
    counter->desc = "The subslice 0 typed reads.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__compute_extended__typed_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TypedReadsPerCacheLine";
    counter->symbol_name = "TypedReadsPerCacheLine";
    counter->desc = "The ratio of EU typed read requests to L3 cache line reads.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
    counter->read_float = cnl__compute_extended__typed_reads_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Writes 0";
    counter->symbol_name = "TypedWrites0";
    counter->desc = "The subslice 0 typed writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__compute_extended__typed_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TypedWritesPerCacheLine";
    counter->symbol_name = "TypedWritesPerCacheLine";
    counter->desc = "The ratio of EU typed write requests to L3 cache line writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
    counter->read_float = cnl__compute_extended__typed_writes_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Untyped Reads 0";
    counter->symbol_name = "UntypedReads0";
    counter->desc = "The subslice 0 untyped reads (including SLM reads).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__compute_extended__untyped_reads0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "UntypedReadsPerCacheLine";
    counter->symbol_name = "UntypedReadsPerCacheLine";
    counter->desc = "The ratio of EU untyped read requests to L3 cache line reads.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
    counter->read_float = cnl__compute_extended__untyped_reads_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Untyped Writes 0";
    counter->symbol_name = "UntypedWrites0";
    counter->desc = "The subslice 0 untyped writes (including SLM writes).";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__compute_extended__untyped_writes0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "UntypedWritesPerCacheLine";
    counter->symbol_name = "UntypedWritesPerCacheLine";
    counter->desc = "The ratio of EU untyped write requests to L3 cache line writes.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
    counter->read_float = cnl__compute_extended__untyped_writes_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    assert(metric_set->n_counters <= 38);
}

static void
cnl_add_compute_l3_cache_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Compute Metrics L3 Cache Gen10";
    metric_set->symbol_name = "ComputeL3Cache";
    metric_set->hw_config_guid = "f3b31b5a-00b3-4fb4-81fd-6446e505534c";
    metric_set->counters = calloc(55, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(67, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(5, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x146C0080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14EC0080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x006C0050 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x066C5100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x086C0052 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x026C5C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x186C0800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6C0540 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00739000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02739000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0473F000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00778000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E778000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14778000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x167702A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06778000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08778000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08EC5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AEC5251 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04EC005C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10EC0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1AEC0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18EC0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04F3E000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02F31000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16F702A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08F78000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000007 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B080360 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D073800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F070140 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01081060 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D080000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01094000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03091000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09044000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B041000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D048000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F042000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0507E700 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x070700D7 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x25070000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B070000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1100C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F00C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2100C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2300C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2500C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2700C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1700C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1900C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47001111 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x39002101 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49001110 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3D000429 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B000001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3B002401 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00000003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00002001 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00101100 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00201200 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00301300 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00401400 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = cnl__compute_l3_cache__avg_gpu_core_frequency__read;
    counter->max_uint64 = cnl__compute_l3_cache__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__compute_l3_cache__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__compute_l3_cache__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__compute_l3_cache__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__compute_l3_cache__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU AVG IPC Rate";
    counter->symbol_name = "EuAvgIpcRate";
    counter->desc = "The average rate of IPC calculated for 2 FPU pipelines.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NUMBER;
    counter->read_float = cnl__compute_l3_cache__eu_avg_ipc_rate__read;
    counter->max_float = cnl__compute_l3_cache__eu_avg_ipc_rate__max;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Binary Instruction";
    counter->symbol_name = "EuBinaryFpu0Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing binary instructions on FPU0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__compute_l3_cache__eu_binary_fpu0_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Binary Instruction";
    counter->symbol_name = "EuBinaryFpu1Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing binary instructions on FPU1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__compute_l3_cache__eu_binary_fpu1_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__compute_l3_cache__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Hybrid Instruction";
    counter->symbol_name = "EuHybridFpu0Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing hybrid instructions on FPU0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__compute_l3_cache__eu_hybrid_fpu0_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Hybrid Instruction";
    counter->symbol_name = "EuHybridFpu1Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing hybrid instructions on FPU1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__compute_l3_cache__eu_hybrid_fpu1_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Move Instruction";
    counter->symbol_name = "EuMoveFpu0Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing move instructions on FPU0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__compute_l3_cache__eu_move_fpu0_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Move Instruction";
    counter->symbol_name = "EuMoveFpu1Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing move instructions on FPU1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__compute_l3_cache__eu_move_fpu1_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Send Pipe Active";
    counter->symbol_name = "EuSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__compute_l3_cache__eu_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__compute_l3_cache__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Ternary Instruction";
    counter->symbol_name = "EuTernaryFpu0Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing ternary instructions on FPU0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__compute_l3_cache__eu_ternary_fpu0_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Ternary Instruction";
    counter->symbol_name = "EuTernaryFpu1Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing ternary instructions on FPU1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__compute_l3_cache__eu_ternary_fpu1_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Pipe Active";
    counter->symbol_name = "Fpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__compute_l3_cache__fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active";
    counter->symbol_name = "Fpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__compute_l3_cache__fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__compute_l3_cache__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = cnl__compute_l3_cache__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = cnl__compute_l3_cache__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__compute_l3_cache__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI L3 Throughput";
    counter->symbol_name = "GtiL3Throughput";
    counter->desc = "The total number of GPU memory bytes transferred between L3 caches and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cnl__compute_l3_cache__gti_l3_throughput__read;
    counter->max_uint64 = cnl__compute_l3_cache__gti_l3_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Read Throughput";
    counter->symbol_name = "GtiReadThroughput";
    counter->desc = "The total number of GPU memory bytes read from GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cnl__compute_l3_cache__gti_read_throughput__read;
    counter->max_uint64 = cnl__compute_l3_cache__gti_read_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Write Throughput";
    counter->symbol_name = "GtiWriteThroughput";
    counter->desc = "The total number of GPU memory bytes written to GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cnl__compute_l3_cache__gti_write_throughput__read;
    counter->max_uint64 = cnl__compute_l3_cache__gti_write_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__compute_l3_cache__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__compute_l3_cache__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Accesses";
    counter->symbol_name = "L3Accesses";
    counter->desc = "The total number of L3 accesses from all entities.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__compute_l3_cache__l3_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3");

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank0 Accesses";
        counter->symbol_name = "L3Bank00Accesses";
        counter->desc = "The total number of accesses to Slice0 L3 Bank0.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = cnl__compute_l3_cache__l3_bank00_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank1 Accesses";
        counter->symbol_name = "L3Bank01Accesses";
        counter->desc = "The total number of accesses to Slice0 L3 Bank1.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = cnl__compute_l3_cache__l3_bank01_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank2 Accesses";
        counter->symbol_name = "L3Bank02Accesses";
        counter->desc = "The total number of accesses to Slice0 L3 Bank2.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = cnl__compute_l3_cache__l3_bank02_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    if (perf->devinfo.slice_mask & 2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice1 L3 Bank0 Accesses";
        counter->symbol_name = "L3Bank10Accesses";
        counter->desc = "The total number of accesses to Slice1 L3 Bank0.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = cnl__compute_l3_cache__l3_bank10_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    if (perf->devinfo.slice_mask & 2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice1 L3 Bank1 Accesses";
        counter->symbol_name = "L3Bank11Accesses";
        counter->desc = "The total number of accesses to Slice1 L3 Bank1.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = cnl__compute_l3_cache__l3_bank11_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    if (perf->devinfo.slice_mask & 2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice1 L3 Bank2 Accesses";
        counter->symbol_name = "L3Bank12Accesses";
        counter->desc = "The total number of accesses to Slice1 L3 Bank2.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = cnl__compute_l3_cache__l3_bank12_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Lookup Accesses w/o IC";
    counter->symbol_name = "L3Lookups";
    counter->desc = "The total number of L3 cache lookup accesses w/o IC.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__compute_l3_cache__l3_lookups__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/TAG");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Misses";
    counter->symbol_name = "L3Misses";
    counter->desc = "The total number of L3 misses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__compute_l3_cache__l3_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/TAG");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Sampler Throughput";
    counter->symbol_name = "L3SamplerThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between samplers and L3 caches.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cnl__compute_l3_cache__l3_sampler_throughput__read;
    counter->max_uint64 = cnl__compute_l3_cache__l3_sampler_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cnl__compute_l3_cache__l3_shader_throughput__read;
    counter->max_uint64 = cnl__compute_l3_cache__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Total Throughput";
    counter->symbol_name = "L3TotalThroughput";
    counter->desc = "The total number of GPU memory bytes transferred via L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cnl__compute_l3_cache__l3_total_throughput__read;
    counter->max_uint64 = cnl__compute_l3_cache__l3_total_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__compute_l3_cache__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__compute_l3_cache__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__compute_l3_cache__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Accesses";
    counter->symbol_name = "SamplerAccesses";
    counter->desc = "The total number of messages send to samplers.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__compute_l3_cache__sampler_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cnl__compute_l3_cache__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cnl__compute_l3_cache__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__compute_l3_cache__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__compute_l3_cache__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__compute_l3_cache__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__compute_l3_cache__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__compute_l3_cache__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__compute_l3_cache__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cnl__compute_l3_cache__slm_bytes_read__read;
    counter->max_uint64 = cnl__compute_l3_cache__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cnl__compute_l3_cache__slm_bytes_written__read;
    counter->max_uint64 = cnl__compute_l3_cache__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__compute_l3_cache__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 55);
}

static void
cnl_add_hdc_and_sf_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set HDCAndSF";
    metric_set->symbol_name = "HDCAndSF";
    metric_set->hw_config_guid = "890094c5-8615-4f69-a8b9-706c5bcbd713";
    metric_set->counters = calloc(42, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(87, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(7, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(5, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x121A0011 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x123A0011 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x129A0011 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12BA0011 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x125A0011 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C6C0005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x186C00A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0673C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00736000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C74A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C75A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E762800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1477C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16779570 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18770002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02778000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04778000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A7B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C7B002A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x147C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x167C003E };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E7D0028 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1901E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x081A2B50 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A391E00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A3A2B50 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x003A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12F41400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14F500A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10F60280 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16F7C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18F70003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02F74000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04F74000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08FBA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02FC8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04FC8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1CFD000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C99003C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E9A2B50 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x009A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02B9C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04B9C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00BA2800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02BA0056 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A596000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C590003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C5A2B50 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x005A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000007 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x130E03C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2100F000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01181000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x010E0030 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x110E0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01104000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01118000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B142000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01092000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x010B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09041000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D000071 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2300C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2500C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2700C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2900C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B00C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D00C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F00C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1300C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1500C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x39000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B001111 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3D000408 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F000421 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41000084 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49000300 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x10800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFFE };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = cnl__hdc_and_sf__avg_gpu_core_frequency__read;
    counter->max_uint64 = cnl__hdc_and_sf__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__hdc_and_sf__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__hdc_and_sf__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__hdc_and_sf__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__hdc_and_sf__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__hdc_and_sf__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__hdc_and_sf__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SQ is full";
    counter->symbol_name = "GTRequestQueueFull";
    counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__hdc_and_sf__gt_request_queue_full__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__hdc_and_sf__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = cnl__hdc_and_sf__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = cnl__hdc_and_sf__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__hdc_and_sf__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__hdc_and_sf__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__hdc_and_sf__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cnl__hdc_and_sf__l3_shader_throughput__read;
    counter->max_uint64 = cnl__hdc_and_sf__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice0 Non-sampler Shader Access Stalled On L3";
        counter->symbol_name = "NonSamplerShader00AccessStalledOnL3";
        counter->desc = "Percentage of time when HDC has messages to L3, but it's stalled due to lack of credits (Slice0 Subslice0)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__hdc_and_sf__non_sampler_shader00_access_stalled_on_l3__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Data Port");
    }

    if (perf->devinfo.subslice_mask & 2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice1 Non-sampler Shader Access Stalled On L3";
        counter->symbol_name = "NonSamplerShader01AccessStalledOnL3";
        counter->desc = "Percentage of time when HDC has messages to L3, but it's stalled due to lack of credits (Slice0 Subslice1)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__hdc_and_sf__non_sampler_shader01_access_stalled_on_l3__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Data Port");
    }

    if (perf->devinfo.subslice_mask & 4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice2 Non-sampler Shader Access Stalled On L3";
        counter->symbol_name = "NonSamplerShader02AccessStalledOnL3";
        counter->desc = "Percentage of time when HDC has messages to L3, but it's stalled due to lack of credits (Slice0 Subslice2)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__hdc_and_sf__non_sampler_shader02_access_stalled_on_l3__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Data Port");
    }

    if (perf->devinfo.subslice_mask & 8) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice1 Subslice0 Non-sampler Shader Access Stalled On L3";
        counter->symbol_name = "NonSamplerShader10AccessStalledOnL3";
        counter->desc = "Percentage of time when HDC has messages to L3, but it's stalled due to lack of credits (Slice1 Subslice0)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__hdc_and_sf__non_sampler_shader10_access_stalled_on_l3__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Data Port");
    }

    if (perf->devinfo.subslice_mask & 16) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice1 Subslice1 Non-sampler Shader Access Stalled On L3";
        counter->symbol_name = "NonSamplerShader11AccessStalledOnL3";
        counter->desc = "Percentage of time when HDC has messages to L3, but it's stalled due to lack of credits (Slice1 Subslice1)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__hdc_and_sf__non_sampler_shader11_access_stalled_on_l3__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Data Port");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__hdc_and_sf__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Polygon Data Ready";
    counter->symbol_name = "PolyDataReady";
    counter->desc = "The percentage of time in which geometry pipeline output is ready";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__hdc_and_sf__poly_data_ready__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe/Strip-Fans");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__hdc_and_sf__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__hdc_and_sf__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__hdc_and_sf__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__hdc_and_sf__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__hdc_and_sf__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__hdc_and_sf__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cnl__hdc_and_sf__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cnl__hdc_and_sf__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__hdc_and_sf__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__hdc_and_sf__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__hdc_and_sf__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__hdc_and_sf__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__hdc_and_sf__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__hdc_and_sf__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cnl__hdc_and_sf__slm_bytes_read__read;
    counter->max_uint64 = cnl__hdc_and_sf__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cnl__hdc_and_sf__slm_bytes_written__read;
    counter->max_uint64 = cnl__hdc_and_sf__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__hdc_and_sf__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__hdc_and_sf__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__hdc_and_sf__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__hdc_and_sf__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 42);
}

static void
cnl_add_l3_1_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set L3_1";
    metric_set->symbol_name = "L3_1";
    metric_set->hw_config_guid = "e56f7dd7-ff55-4bae-89a1-a526a2e3b0d6";
    metric_set->counters = calloc(42, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(81, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(11, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(5, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1661001A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1665001A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1669001A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C1C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x126C0004 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x166C001D };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10EC0400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16EC0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02610024 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10610000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E610000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02652400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10650000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E650000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04690024 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10690000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E690000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x006C0020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x066C2800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A6C2820 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E6C3832 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x186C05A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6C1010 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C6C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x186D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A6E1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0073F000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02738000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0473D000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0673D000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00778000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E778000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14778000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16778A80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18770002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02778000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04778000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06778000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08774000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04784000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A7B0004 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08EC0020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CEC0020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00EC3600 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1AEC0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18EC0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04F31000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06F31000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00F32000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14F78000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16F70800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02F78000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000007 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2100F000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D000071 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1100C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F00C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2500C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2700C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2900C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D00C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F00C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1300C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1500C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1700C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1900C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47000101 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x39000001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49001300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3D000021 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B001100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F000420 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D001100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41000400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43000001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3B0000C7 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x70800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x20000801 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0111FEEE };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x40001001 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0222FDDD };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x80002002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0444FBBB };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = cnl__l3_1__avg_gpu_core_frequency__read;
    counter->max_uint64 = cnl__l3_1__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__l3_1__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__l3_1__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__l3_1__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__l3_1__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__l3_1__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__l3_1__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SQ is full";
    counter->symbol_name = "GTRequestQueueFull";
    counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__l3_1__gt_request_queue_full__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__l3_1__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = cnl__l3_1__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = cnl__l3_1__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__l3_1__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__l3_1__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__l3_1__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank0 Active";
        counter->symbol_name = "L30Bank0Active";
        counter->desc = "The percentage of time in which slice0 L3 bank0 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__l3_1__l30_bank0_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank0 Stalled";
        counter->symbol_name = "L30Bank0Stalled";
        counter->desc = "The percentage of time in which slice0 L3 bank0 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__l3_1__l30_bank0_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank1 Active";
        counter->symbol_name = "L30Bank1Active";
        counter->desc = "The percentage of time in which slice0 L3 bank1 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__l3_1__l30_bank1_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank1 Stalled";
        counter->symbol_name = "L30Bank1Stalled";
        counter->desc = "The percentage of time in which slice0 L3 bank1 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__l3_1__l30_bank1_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank2 Active";
        counter->symbol_name = "L30Bank2Active";
        counter->desc = "The percentage of time in which slice0 L3 bank2 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__l3_1__l30_bank2_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice1 L3 Bank2 Stalled";
        counter->symbol_name = "L31Bank2Stalled";
        counter->desc = "The percentage of time in which slice1 L3 bank2 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__l3_1__l31_bank2_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cnl__l3_1__l3_shader_throughput__read;
    counter->max_uint64 = cnl__l3_1__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__l3_1__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__l3_1__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__l3_1__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__l3_1__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__l3_1__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__l3_1__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__l3_1__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cnl__l3_1__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cnl__l3_1__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__l3_1__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__l3_1__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__l3_1__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__l3_1__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__l3_1__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__l3_1__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cnl__l3_1__slm_bytes_read__read;
    counter->max_uint64 = cnl__l3_1__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cnl__l3_1__slm_bytes_written__read;
    counter->max_uint64 = cnl__l3_1__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__l3_1__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__l3_1__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__l3_1__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__l3_1__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 42);
}

static void
cnl_add_l3_2_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set L3_2";
    metric_set->symbol_name = "L3_2";
    metric_set->hw_config_guid = "918834e2-a1a4-4d77-9f3a-0c229f8d803f";
    metric_set->counters = calloc(42, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(87, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(11, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(5, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106C0400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x166C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16E1001A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16E5001A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16E9001A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10EC1C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12EC0004 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16EC001D };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x086C0020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C6C0020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x006C3600 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x186C0A88 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6C0504 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C6C0005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0073F000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02739000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0473D000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0673D000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00778000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E778000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14778000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16778A80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18770002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02778000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04778000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06778000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08778000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02E10024 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10E10000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1EE10000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02E52400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10E50000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1EE50000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04E90024 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10E90000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1EE90000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00EC0020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06EC2800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AEC2820 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EEC3832 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18EC0580 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1AEC0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1CEC0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18ED8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AEE1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00F3D000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02F38000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04F3C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06F3C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00F78000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EF78000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16F78280 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18F70002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04F78000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06F78000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08F74000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04F84000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AFB0004 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000007 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2100F000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D000071 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1100C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F00C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2500C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2700C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2900C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D00C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F00C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1300C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1500C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1700C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1900C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47000010 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x39000883 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49000300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3D001064 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B000001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F000C60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D000001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41000C04 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3B000001 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x70800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x20000801 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0111FEEE };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x40001001 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0222FDDD };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x80002002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0444FBBB };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = cnl__l3_2__avg_gpu_core_frequency__read;
    counter->max_uint64 = cnl__l3_2__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__l3_2__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__l3_2__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__l3_2__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__l3_2__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__l3_2__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__l3_2__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SQ is full";
    counter->symbol_name = "GTRequestQueueFull";
    counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__l3_2__gt_request_queue_full__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__l3_2__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = cnl__l3_2__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = cnl__l3_2__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__l3_2__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__l3_2__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__l3_2__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank2 Stalled";
        counter->symbol_name = "L30Bank2Stalled";
        counter->desc = "The percentage of time in which slice0 L3 bank2 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__l3_2__l30_bank2_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice1 L3 Bank0 Active";
        counter->symbol_name = "L31Bank0Active";
        counter->desc = "The percentage of time in which slice1 L3 bank0 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__l3_2__l31_bank0_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice1 L3 Bank0 Stalled";
        counter->symbol_name = "L31Bank0Stalled";
        counter->desc = "The percentage of time in which slice1 L3 bank0 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__l3_2__l31_bank0_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice1 L3 Bank1 Active";
        counter->symbol_name = "L31Bank1Active";
        counter->desc = "The percentage of time in which slice1 L3 bank1 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__l3_2__l31_bank1_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice1 L3 Bank1 Stalled";
        counter->symbol_name = "L31Bank1Stalled";
        counter->desc = "The percentage of time in which slice1 L3 bank1 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__l3_2__l31_bank1_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice1 L3 Bank2 Active";
        counter->symbol_name = "L31Bank2Active";
        counter->desc = "The percentage of time in which slice1 L3 bank2 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__l3_2__l31_bank2_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cnl__l3_2__l3_shader_throughput__read;
    counter->max_uint64 = cnl__l3_2__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__l3_2__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__l3_2__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__l3_2__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__l3_2__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__l3_2__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__l3_2__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__l3_2__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cnl__l3_2__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cnl__l3_2__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__l3_2__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__l3_2__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__l3_2__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__l3_2__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__l3_2__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__l3_2__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cnl__l3_2__slm_bytes_read__read;
    counter->max_uint64 = cnl__l3_2__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cnl__l3_2__slm_bytes_written__read;
    counter->max_uint64 = cnl__l3_2__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__l3_2__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__l3_2__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__l3_2__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__l3_2__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 42);
}

static void
cnl_add_rasterizer_and_pixel_backend_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set RasterizerAndPixelBackend";
    metric_set->symbol_name = "RasterizerAndPixelBackend";
    metric_set->hw_config_guid = "2e95713a-c6d8-47a9-9207-eba3e208be51";
    metric_set->counters = calloc(46, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(93, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(13, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(5, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C710004 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10747000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12756800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04795000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x127C01C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CF10004 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10F47000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12F56800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04F95000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12FC01C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6C4044 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C6C0004 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x186C00A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00710010 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02738000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04732000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0673A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00736000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08740037 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C740000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A750F36 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10750000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04751000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C752000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E750000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C760800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E768800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10760002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0077C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E778000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1477C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x167767E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18770002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02778000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04778000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C790017 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08790000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C7B0088 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E7C0032 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x107C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x167C0004 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04F10200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00F10000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08F40DC0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CF40000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00F50D80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02F5003C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10F50000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AF54000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CF58000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04F50000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06F50000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EF62200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CF6A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EF7C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16F71030 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18F70001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02F7C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04F7C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CF905C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08F90000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CFB0220 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EFC1900 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10FC0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16FC0010 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000007 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2100F000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D000071 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1100C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F00C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2300C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2500C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2700C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2900C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B00C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D00C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F00C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1300C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1500C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47000001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x39000421 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49000300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3D000402 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B001101 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F000840 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D000101 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41000801 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43000001 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000180 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFCF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00006000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000F3FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FFFE };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FFFD };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = cnl__rasterizer_and_pixel_backend__avg_gpu_core_frequency__read;
    counter->max_uint64 = cnl__rasterizer_and_pixel_backend__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__rasterizer_and_pixel_backend__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__rasterizer_and_pixel_backend__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__rasterizer_and_pixel_backend__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__rasterizer_and_pixel_backend__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__rasterizer_and_pixel_backend__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__rasterizer_and_pixel_backend__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SQ is full";
    counter->symbol_name = "GTRequestQueueFull";
    counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__rasterizer_and_pixel_backend__gt_request_queue_full__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__rasterizer_and_pixel_backend__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = cnl__rasterizer_and_pixel_backend__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = cnl__rasterizer_and_pixel_backend__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__rasterizer_and_pixel_backend__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__rasterizer_and_pixel_backend__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__rasterizer_and_pixel_backend__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cnl__rasterizer_and_pixel_backend__l3_shader_throughput__read;
    counter->max_uint64 = cnl__rasterizer_and_pixel_backend__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 PS Output Available";
        counter->symbol_name = "PSOutput0Available";
        counter->desc = "The percentage of time in which slice0 PS output is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__rasterizer_and_pixel_backend__ps_output0_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe");
    }

    if (perf->devinfo.slice_mask & 2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice1 PS Output Available";
        counter->symbol_name = "PSOutput1Available";
        counter->desc = "The percentage of time in which slice1 PS output is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__rasterizer_and_pixel_backend__ps_output1_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Slice0 Post-EarlyZ Pixel Data Ready";
    counter->symbol_name = "PixelData0Ready";
    counter->desc = "The percentage of time in which slice0 post-EarlyZ pixel data is ready (after early Z tests have been applied)";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__rasterizer_and_pixel_backend__pixel_data0_ready__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Slice1 Post-EarlyZ Pixel Data Ready";
    counter->symbol_name = "PixelData1Ready";
    counter->desc = "The percentage of time in which slice1 post-EarlyZ pixel data is ready (after early Z tests have been applied)";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__rasterizer_and_pixel_backend__pixel_data1_ready__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU/Rasterizer/Early Depth Test");

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Pixel Values Ready";
        counter->symbol_name = "PixelValues0Ready";
        counter->desc = "The percentage of time in which slice0 pixel values are ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__rasterizer_and_pixel_backend__pixel_values0_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe");
    }

    if (perf->devinfo.slice_mask & 2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice1 Pixel Values Ready";
        counter->symbol_name = "PixelValues1Ready";
        counter->desc = "The percentage of time in which slice1 pixel values are ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__rasterizer_and_pixel_backend__pixel_values1_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__rasterizer_and_pixel_backend__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__rasterizer_and_pixel_backend__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__rasterizer_and_pixel_backend__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__rasterizer_and_pixel_backend__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__rasterizer_and_pixel_backend__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__rasterizer_and_pixel_backend__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__rasterizer_and_pixel_backend__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Rasterizer Input Available";
        counter->symbol_name = "Rasterizer0InputAvailable";
        counter->desc = "The percentage of time in which slice0 rasterizer input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__rasterizer_and_pixel_backend__rasterizer0_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Rasterizer");
    }

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Rasterizer Output Ready";
        counter->symbol_name = "Rasterizer0OutputReady";
        counter->desc = "The percentage of time in which slice0 rasterizer output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__rasterizer_and_pixel_backend__rasterizer0_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Rasterizer");
    }

    if (perf->devinfo.slice_mask & 2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice1 Rasterizer Input Available";
        counter->symbol_name = "Rasterizer1InputAvailable";
        counter->desc = "The percentage of time in which slice1 rasterizer input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__rasterizer_and_pixel_backend__rasterizer1_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Rasterizer");
    }

    if (perf->devinfo.slice_mask & 2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice1 Rasterizer Output Ready";
        counter->symbol_name = "Rasterizer1OutputReady";
        counter->desc = "The percentage of time in which slice1 rasterizer output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__rasterizer_and_pixel_backend__rasterizer1_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Rasterizer");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cnl__rasterizer_and_pixel_backend__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cnl__rasterizer_and_pixel_backend__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__rasterizer_and_pixel_backend__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__rasterizer_and_pixel_backend__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__rasterizer_and_pixel_backend__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__rasterizer_and_pixel_backend__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__rasterizer_and_pixel_backend__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__rasterizer_and_pixel_backend__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cnl__rasterizer_and_pixel_backend__slm_bytes_read__read;
    counter->max_uint64 = cnl__rasterizer_and_pixel_backend__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cnl__rasterizer_and_pixel_backend__slm_bytes_written__read;
    counter->max_uint64 = cnl__rasterizer_and_pixel_backend__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__rasterizer_and_pixel_backend__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__rasterizer_and_pixel_backend__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__rasterizer_and_pixel_backend__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__rasterizer_and_pixel_backend__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 46);
}

static void
cnl_add_sampler_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set Sampler";
    metric_set->symbol_name = "Sampler";
    metric_set->hw_config_guid = "9bcf4ff2-c15f-4bea-8ec8-8db87791942e";
    metric_set->counters = calloc(46, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(144, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(15, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(5, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14141400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1614000B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14161400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14341400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1634000B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14361400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14941400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1694000B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14961400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14B41400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16B4000B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14B61400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14541400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1654000B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14561400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6C5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C6C0005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x186C0280 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0673F000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0073C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04742000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A74A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04752000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A75A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C760800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E760280 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0077C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E77C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14774000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1677A950 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18770002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04778000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06778000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08774000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A774000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C77C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A7BA828 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C7B0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x147CE800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x167C0003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x087CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A7C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C7D8200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E7D0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00194000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E194000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C194000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00140050 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06145800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10140000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18140000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C140080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A150001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06160043 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10160000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C160000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A3900A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A394000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08345850 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10340000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C340020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08358000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04362180 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10360000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A360000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12F40140 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06F48000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14F5000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06F58000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10F60028 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EF60002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16F77C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18F70001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04F74000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06F7C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CFB0280 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08FB8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16FC0280 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04FC8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1EFD2800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1CFD0008 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A992000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C990001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06994000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C945850 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10940000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E940000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C940002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08952000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02962180 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10960000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06960000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1CB90014 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04B94000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EB45850 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10B40000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1EB40000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1AB48000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08B51000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02B60043 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10B60000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04B60000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A590A00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08594000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A545850 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10540000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C540008 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E540000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08554000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04560043 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10560000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08560000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000007 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2100F000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13000071 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1100C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F00C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2300C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2500C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2700C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2900C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B00C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D00C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F00C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1500C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1700C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1900C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B00C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D00C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47000031 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x39000143 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49001110 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3D000C61 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B000011 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F0018C3 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41000842 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43000002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3B000480 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x10800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000018 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFFC };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00000060 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FFF3 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000180 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FFCF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00000600 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FF3F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00001800 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FCFF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = cnl__sampler__avg_gpu_core_frequency__read;
    counter->max_uint64 = cnl__sampler__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__sampler__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__sampler__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__sampler__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__sampler__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__sampler__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__sampler__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SQ is full";
    counter->symbol_name = "GTRequestQueueFull";
    counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__sampler__gt_request_queue_full__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__sampler__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = cnl__sampler__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = cnl__sampler__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__sampler__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__sampler__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__sampler__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cnl__sampler__l3_shader_throughput__read;
    counter->max_uint64 = cnl__sampler__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__sampler__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__sampler__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__sampler__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__sampler__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__sampler__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__sampler__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__sampler__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice0 Input Available";
        counter->symbol_name = "Sampler00InputAvailable";
        counter->desc = "The percentage of time in which slice0 subslice0 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__sampler__sampler00_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice0 Sampler Output Ready";
        counter->symbol_name = "Sampler00OutputReady";
        counter->desc = "The percentage of time in which slice0 subslice0 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__sampler__sampler00_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice1 Input Available";
        counter->symbol_name = "Sampler01InputAvailable";
        counter->desc = "The percentage of time in which slice0 subslice1 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__sampler__sampler01_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice1 Sampler Output Ready";
        counter->symbol_name = "Sampler01OutputReady";
        counter->desc = "The percentage of time in which slice0 subslice1 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__sampler__sampler01_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice2 Input Available";
        counter->symbol_name = "Sampler02InputAvailable";
        counter->desc = "The percentage of time in which slice0 subslice2 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__sampler__sampler02_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice2 Sampler Output Ready";
        counter->symbol_name = "Sampler02OutputReady";
        counter->desc = "The percentage of time in which slice0 subslice2 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__sampler__sampler02_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 8) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice1 Subslice0 Input Available";
        counter->symbol_name = "Sampler10InputAvailable";
        counter->desc = "The percentage of time in which slice1 subslice0 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__sampler__sampler10_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 8) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice1 Subslice0 Sampler Output Ready";
        counter->symbol_name = "Sampler10OutputReady";
        counter->desc = "The percentage of time in which slice1 subslice0 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__sampler__sampler10_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 16) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice1 Subslice1 Input Available";
        counter->symbol_name = "Sampler11InputAvailable";
        counter->desc = "The percentage of time in which slice1 subslice1 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__sampler__sampler11_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 16) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice1 Subslice1 Sampler Output Ready";
        counter->symbol_name = "Sampler11OutputReady";
        counter->desc = "The percentage of time in which slice1 subslice1 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__sampler__sampler11_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cnl__sampler__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cnl__sampler__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__sampler__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__sampler__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__sampler__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__sampler__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__sampler__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__sampler__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cnl__sampler__slm_bytes_read__read;
    counter->max_uint64 = cnl__sampler__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cnl__sampler__slm_bytes_written__read;
    counter->max_uint64 = cnl__sampler__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__sampler__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__sampler__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__sampler__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__sampler__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 46);
}

static void
cnl_add_tdl_1_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set TDL_1";
    metric_set->symbol_name = "TDL_1";
    metric_set->hw_config_guid = "c46c7bb5-f26d-4634-b491-902394af85b1";
    metric_set->counters = calloc(46, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(143, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(15, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(5, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12180000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12380000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12980000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12B80000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12580000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6C5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C6C0005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x186C2800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0673F000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02733000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0474A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A748000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0475A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A758000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C762800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E760200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0077C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E77C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14774000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1677A950 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18770002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0277C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04774000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06774000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08778000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A778000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A7BA802 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C7B0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x087B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x147CE800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x167C0003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x047C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x067CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C7D8008 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E7D0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00194000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E194000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02194000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C140200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A142000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0015C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A150002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00168000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E168000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02168000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0018A1A3 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0618A500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10180000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A3900A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04394000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C342800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A348000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A35000C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08351000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A360140 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04368000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0838A5A3 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x023800A1 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10380000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12F40140 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08F42000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14F5000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08F52000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10F60028 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EF60008 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16F77C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18F70001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08F7C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AF74000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CFB0280 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AFB0020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16FC0280 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AFC8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1EFD2800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1CFD0200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A992000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C990001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08994000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E940028 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C940008 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A9500C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08954000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A964000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C960002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08968000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C98A5A3 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x049800A1 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10980000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1CB90014 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AB94000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1EB40280 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1CB40020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AB50300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08B58000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1CB60028 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AB68000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EB8A5A3 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04B8A100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10B80000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A590A00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06594000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C548002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E540002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A550030 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08552000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A561400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06568000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A58A5A3 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0258A100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10580000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000007 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2100F000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D000071 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1100C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F00C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2300C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2500C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2700C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2900C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B00C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D00C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F00C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1300C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1500C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1700C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1900C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B00C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47000111 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x39000421 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49001300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3D00042B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B000011 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F001081 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3B000004 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x10800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFFC };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FFF3 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FFCF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FF3F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FCFF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = cnl__tdl_1__avg_gpu_core_frequency__read;
    counter->max_uint64 = cnl__tdl_1__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__tdl_1__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__tdl_1__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__tdl_1__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__tdl_1__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__tdl_1__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__tdl_1__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SQ is full";
    counter->symbol_name = "GTRequestQueueFull";
    counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__tdl_1__gt_request_queue_full__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__tdl_1__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = cnl__tdl_1__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = cnl__tdl_1__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__tdl_1__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__tdl_1__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__tdl_1__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cnl__tdl_1__l3_shader_throughput__read;
    counter->max_uint64 = cnl__tdl_1__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "NonPS Thread Ready For Dispatch on Slice0 Subslice0";
        counter->symbol_name = "NonPSThread00ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice0 subslice0 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__tdl_1__non_ps_thread00_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "NonPS Thread Ready For Dispatch on Slice0 Subslice1";
        counter->symbol_name = "NonPSThread01ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice0 subslice1 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__tdl_1__non_ps_thread01_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "NonPS Thread Ready For Dispatch on Slice0 Subslice2";
        counter->symbol_name = "NonPSThread02ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice0 subslice2 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__tdl_1__non_ps_thread02_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 8) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "NonPS Thread Ready For Dispatch on Slice1 Subslice0";
        counter->symbol_name = "NonPSThread10ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice1 subslice0 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__tdl_1__non_ps_thread10_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 16) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "NonPS Thread Ready For Dispatch on Slice1 Subslice1";
        counter->symbol_name = "NonPSThread11ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice1 subslice1 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__tdl_1__non_ps_thread11_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice0 Subslice0";
        counter->symbol_name = "PSThread00ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice0 subslice0 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__tdl_1__ps_thread00_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice0 Subslice1";
        counter->symbol_name = "PSThread01ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice0 subslice1 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__tdl_1__ps_thread01_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice0 Subslice2";
        counter->symbol_name = "PSThread02ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice0 subslice2 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__tdl_1__ps_thread02_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 8) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice1 Subslice0";
        counter->symbol_name = "PSThread10ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice1 subslice0 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__tdl_1__ps_thread10_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 16) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice1 Subslice1";
        counter->symbol_name = "PSThread11ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice1 subslice1 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__tdl_1__ps_thread11_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__tdl_1__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__tdl_1__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__tdl_1__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__tdl_1__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__tdl_1__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__tdl_1__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__tdl_1__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cnl__tdl_1__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cnl__tdl_1__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__tdl_1__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__tdl_1__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__tdl_1__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__tdl_1__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__tdl_1__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__tdl_1__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cnl__tdl_1__slm_bytes_read__read;
    counter->max_uint64 = cnl__tdl_1__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cnl__tdl_1__slm_bytes_written__read;
    counter->max_uint64 = cnl__tdl_1__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__tdl_1__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__tdl_1__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__tdl_1__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__tdl_1__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 46);
}

static void
cnl_add_tdl_2_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set TDL_2";
    metric_set->symbol_name = "TDL_2";
    metric_set->hw_config_guid = "aa2d6ab4-99b3-42f8-94d6-4a9aa2baedaf";
    metric_set->counters = calloc(46, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(110, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(5, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(5, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12184D60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12384D60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12984D60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12B84D60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12584D60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x186C2A00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6C0001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00738000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02737000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12740140 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1475000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10760028 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16777C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18770001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02774000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04774000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06778000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08778000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A778000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C778000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C7B0280 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x087BA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x167C0280 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x027CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x047CC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E7D2800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A192000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C190001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E140028 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1500C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A164000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C160002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C18AFA7 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10180000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C390014 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E340280 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A350300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C360028 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E38AFA7 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10380000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06F48000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08F42000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06F58000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08F52000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EF6000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06F7C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08F7C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AF74000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CF74000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AFB00A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AFC8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CFC8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1CFD0A00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06994000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08994000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C94000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08956000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06968000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08968000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0298A700 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x049800AF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10980000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AB94000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CB94000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1CB400A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08B58000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AB50001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AB68000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CB68000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04B8A700 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06B800AF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10B80000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02594000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04594000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A54A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00558000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08551000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02568000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04568000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0058A700 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x025800AF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10580000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000007 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21003000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x27000071 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x33000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2900C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2B00C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2D00C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2F00C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1300C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1500C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1700C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1900C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B00C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D00C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B003000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3F002C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D001111 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41000421 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x43000001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x39001080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3B000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3D000000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = cnl__tdl_2__avg_gpu_core_frequency__read;
    counter->max_uint64 = cnl__tdl_2__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__tdl_2__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__tdl_2__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__tdl_2__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__tdl_2__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__tdl_2__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__tdl_2__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SQ is full";
    counter->symbol_name = "GTRequestQueueFull";
    counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__tdl_2__gt_request_queue_full__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__tdl_2__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = cnl__tdl_2__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = cnl__tdl_2__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__tdl_2__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__tdl_2__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__tdl_2__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cnl__tdl_2__l3_shader_throughput__read;
    counter->max_uint64 = cnl__tdl_2__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__tdl_2__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__tdl_2__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__tdl_2__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__tdl_2__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__tdl_2__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__tdl_2__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__tdl_2__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cnl__tdl_2__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = cnl__tdl_2__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__tdl_2__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__tdl_2__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = cnl__tdl_2__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__tdl_2__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__tdl_2__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = cnl__tdl_2__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cnl__tdl_2__slm_bytes_read__read;
    counter->max_uint64 = cnl__tdl_2__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = cnl__tdl_2__slm_bytes_written__read;
    counter->max_uint64 = cnl__tdl_2__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice0 Port 0";
        counter->symbol_name = "ThreadHeader00ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice0 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__tdl_2__thread_header00_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice0 Port 1";
        counter->symbol_name = "ThreadHeader00ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice0 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__tdl_2__thread_header00_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice1 Port 0";
        counter->symbol_name = "ThreadHeader01ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice1 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__tdl_2__thread_header01_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice1 Port 1";
        counter->symbol_name = "ThreadHeader01ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice1 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__tdl_2__thread_header01_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice2 Port 0";
        counter->symbol_name = "ThreadHeader02ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice2 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__tdl_2__thread_header02_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice2 Port 1";
        counter->symbol_name = "ThreadHeader02ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice2 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__tdl_2__thread_header02_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 8) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice1 Subslice0 Port 0";
        counter->symbol_name = "ThreadHeader10ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice1 subslice0 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__tdl_2__thread_header10_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 8) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice1 Subslice0 Port 1";
        counter->symbol_name = "ThreadHeader10ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice1 subslice0 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__tdl_2__thread_header10_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 16) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice1 Subslice1 Port 0";
        counter->symbol_name = "ThreadHeader11ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice1 subslice1 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__tdl_2__thread_header11_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 16) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice1 Subslice1 Port 1";
        counter->symbol_name = "ThreadHeader11ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice1 subslice1 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = cnl__tdl_2__thread_header11_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__tdl_2__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__tdl_2__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = cnl__tdl_2__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = cnl__tdl_2__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 46);
}

static void
cnl_add_test_oa_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set TestOa";
    metric_set->symbol_name = "TestOa";
    metric_set->hw_config_guid = "db41edd4-d8e7-4730-ad11-b9a2d6833503";
    metric_set->counters = calloc(12, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(26, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(21, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000007 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17060000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000007 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13034000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000007 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07060066 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000007 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05060000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000007 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F080040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000007 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07091000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000007 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F041000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000007 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000007 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x35000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000007 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000007 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3D000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000007 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31000000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000004 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00000003 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000007 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00100002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FFF7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00100002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FFCF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00100082 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FFEF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x001000C2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FFE7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x00100001 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000FFE7 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = cnl__test_oa__avg_gpu_core_frequency__read;
    counter->max_uint64 = cnl__test_oa__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter0";
    counter->symbol_name = "Counter0";
    counter->desc = "HW test counter 0. Factor: 0.0";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = cnl__test_oa__counter0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter1";
    counter->symbol_name = "Counter1";
    counter->desc = "HW test counter 1. Factor: 1.0";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = cnl__test_oa__counter1__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter2";
    counter->symbol_name = "Counter2";
    counter->desc = "HW test counter 2. Factor: 1.0";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = cnl__test_oa__counter2__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter3";
    counter->symbol_name = "Counter3";
    counter->desc = "HW test counter 3. Factor: 0.5";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = cnl__test_oa__counter3__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter4";
    counter->symbol_name = "Counter4";
    counter->desc = "HW test counter 4. Factor: 0.3333";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = cnl__test_oa__counter4__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter5";
    counter->symbol_name = "Counter5";
    counter->desc = "HW test counter 5. Factor: 0.3333";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = cnl__test_oa__counter5__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter6";
    counter->symbol_name = "Counter6";
    counter->desc = "HW test counter 6. Factor: 0.16666";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = cnl__test_oa__counter6__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter7";
    counter->symbol_name = "Counter7";
    counter->desc = "HW test counter 7. Factor: 0.6666";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = cnl__test_oa__counter7__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter8";
    counter->symbol_name = "Counter8";
    counter->desc = "HW test counter 8. Should be equal to 1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = cnl__test_oa__counter8__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = cnl__test_oa__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = cnl__test_oa__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    assert(metric_set->n_counters <= 12);
}

static void
icl_add_render_basic_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Render Metrics Basic Gen11";
    metric_set->symbol_name = "RenderBasic";
    metric_set->hw_config_guid = "193093b2-da24-49bf-b407-442c213b71b4";
    metric_set->counters = calloc(41, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(61, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(5, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(6, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x142C0014 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14120700 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x121500E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1E000C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1F000C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C200014 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16212800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2C2041 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x102C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A2C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10040140 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E040005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14050050 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06054000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08051000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x260600C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x24061800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04120023 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10120000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08120000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06131000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04144000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02150980 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10150000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1815000F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06150000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E18A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14190028 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1C01C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1C000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A5C01C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C5C000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001C0097 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x061C9400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1C00A7 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x101C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x081D8100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1D0004 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x085C9497 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A5CA700 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x105C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A5D000B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E1EEF80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x301F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x501F2404 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x521F0092 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x541F0024 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4E1F2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3E1F0300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x461F0303 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x481F0303 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4A1F0003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4C1F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x421F4001 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0xFFFFFFFF };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00000052 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = icl__render_basic__avg_gpu_core_frequency__read;
    counter->max_uint64 = icl__render_basic__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__render_basic__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__render_basic__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__render_basic__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__render_basic__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__render_basic__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__render_basic__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__render_basic__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = icl__render_basic__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = icl__render_basic__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__render_basic__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Read Throughput";
    counter->symbol_name = "GtiReadThroughput";
    counter->desc = "The total number of GPU memory bytes read from GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = icl__render_basic__gti_read_throughput__read;
    counter->max_uint64 = icl__render_basic__gti_read_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Write Throughput";
    counter->symbol_name = "GtiWriteThroughput";
    counter->desc = "The total number of GPU memory bytes written to GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = icl__render_basic__gti_write_throughput__read;
    counter->max_uint64 = icl__render_basic__gti_write_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__render_basic__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__render_basic__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = icl__render_basic__l3_shader_throughput__read;
    counter->max_uint64 = icl__render_basic__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__render_basic__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__render_basic__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__render_basic__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__render_basic__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__render_basic__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__render_basic__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Sampler00 Bottleneck";
        counter->symbol_name = "Sampler00Bottleneck";
        counter->desc = "The percentage of time in which Slice0 Sampler0 has been slowing down the pipe when processing EU requests.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__render_basic__sampler00_bottleneck__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Sampler00 Busy";
        counter->symbol_name = "Sampler00Busy";
        counter->desc = "The percentage of time in which Slice0 Sampler0 has been processing EU requests.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__render_basic__sampler00_busy__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    if (perf->devinfo.subslice_mask & 9) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Samplers Bottleneck";
        counter->symbol_name = "SamplerBottleneck";
        counter->desc = "The percentage of time in which samplers have been slowing down the pipe when processing EU requests.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__render_basic__sampler_bottleneck__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Cache Misses";
    counter->symbol_name = "SamplerL1Misses";
    counter->desc = "The total number of sampler cache misses in all LODs in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = icl__render_basic__sampler_l1_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = icl__render_basic__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = icl__render_basic__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    if (perf->devinfo.subslice_mask & 9) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Samplers Busy";
        counter->symbol_name = "SamplersBusy";
        counter->desc = "The percentage of time in which samplers have been processing EU requests.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__render_basic__samplers_busy__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__render_basic__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__render_basic__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__render_basic__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = icl__render_basic__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = icl__render_basic__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = icl__render_basic__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = icl__render_basic__slm_bytes_read__read;
    counter->max_uint64 = icl__render_basic__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = icl__render_basic__slm_bytes_written__read;
    counter->max_uint64 = icl__render_basic__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__render_basic__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__render_basic__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__render_basic__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__render_basic__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 41);
}

static void
icl_add_compute_basic_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Compute Metrics Basic Gen11";
    metric_set->symbol_name = "ComputeBasic";
    metric_set->hw_config_guid = "12ca7e9c-55cb-45cd-9f87-4fc821488e6d";
    metric_set->counters = calloc(40, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(114, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(5, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(5, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12230012 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10230019 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12A30012 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10A30019 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A200400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C200020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04208000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08208000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C208000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A230031 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E231E00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0223003D };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04230032 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06230033 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00230000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1AA01000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1CA00008 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02A08000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06A08000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AA08000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AA31880 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EA3003C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00A31E80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02A31900 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04A31980 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E044055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10040141 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C045000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14050050 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04054000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A051000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x260600CC };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x24067E00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18123000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A12000C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0212C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0612C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A12C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08138000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A134000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0413A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06132000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E144000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16150380 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1815000D };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0415C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0815C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C15C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A182000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E188000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02182000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04182000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06182000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12190400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14190020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A192000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C192000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E192000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1C2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x121D1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141D0008 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x081D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1C01C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1C000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A5C01C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C5C000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001C0097 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x061C9400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1C00A7 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x101C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x081D8100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1D0010 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x085C9497 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C5CA700 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x105C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A5D0023 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E1E0F80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x201E000E };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x301F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x501F2524 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x521F2522 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x541F0024 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3A1F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4E1F2430 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3E1F0300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x461F0303 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x481F3003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4A1F0300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4C1F0003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x401F3000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x421F3000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x441F3000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0xFFFFFFFF };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00000003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00002001 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00000008 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = icl__compute_basic__avg_gpu_core_frequency__read;
    counter->max_uint64 = icl__compute_basic__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__compute_basic__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__compute_basic__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__compute_basic__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__compute_basic__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU AVG IPC Rate";
    counter->symbol_name = "EuAvgIpcRate";
    counter->desc = "The average rate of IPC calculated for 2 FPU pipelines.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NUMBER;
    counter->read_float = icl__compute_basic__eu_avg_ipc_rate__read;
    counter->max_float = icl__compute_basic__eu_avg_ipc_rate__max;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__compute_basic__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Send Pipe Active";
    counter->symbol_name = "EuSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__compute_basic__eu_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__compute_basic__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Thread Occupancy";
    counter->symbol_name = "EuThreadOccupancy";
    counter->desc = "The percentage of time in which hardware threads occupied EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__compute_basic__eu_thread_occupancy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Pipe Active";
    counter->symbol_name = "Fpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__compute_basic__fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active";
    counter->symbol_name = "Fpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__compute_basic__fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__compute_basic__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = icl__compute_basic__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = icl__compute_basic__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__compute_basic__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Read Throughput";
    counter->symbol_name = "GtiReadThroughput";
    counter->desc = "The total number of GPU memory bytes read from GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = icl__compute_basic__gti_read_throughput__read;
    counter->max_uint64 = icl__compute_basic__gti_read_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Write Throughput";
    counter->symbol_name = "GtiWriteThroughput";
    counter->desc = "The total number of GPU memory bytes written to GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = icl__compute_basic__gti_write_throughput__read;
    counter->max_uint64 = icl__compute_basic__gti_write_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__compute_basic__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__compute_basic__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = icl__compute_basic__l3_shader_throughput__read;
    counter->max_uint64 = icl__compute_basic__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__compute_basic__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__compute_basic__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__compute_basic__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = icl__compute_basic__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = icl__compute_basic__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__compute_basic__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__compute_basic__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__compute_basic__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = icl__compute_basic__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = icl__compute_basic__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = icl__compute_basic__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = icl__compute_basic__slm_bytes_read__read;
    counter->max_uint64 = icl__compute_basic__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = icl__compute_basic__slm_bytes_written__read;
    counter->max_uint64 = icl__compute_basic__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Atomics Accesses";
    counter->symbol_name = "TypedAtomics";
    counter->desc = "The total number of typed atomic accesses via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = icl__compute_basic__typed_atomics__read;
    counter->max_uint64 = icl__compute_basic__typed_atomics__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Bytes Read";
    counter->symbol_name = "TypedBytesRead";
    counter->desc = "The total number of typed memory bytes read via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = icl__compute_basic__typed_bytes_read__read;
    counter->max_uint64 = icl__compute_basic__typed_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Bytes Written";
    counter->symbol_name = "TypedBytesWritten";
    counter->desc = "The total number of untyped memory bytes written via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = icl__compute_basic__typed_bytes_written__read;
    counter->max_uint64 = icl__compute_basic__typed_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Untyped Bytes Read";
    counter->symbol_name = "UntypedBytesRead";
    counter->desc = "The total number of typed memory bytes read via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = icl__compute_basic__untyped_bytes_read__read;
    counter->max_uint64 = icl__compute_basic__untyped_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Untyped Writes";
    counter->symbol_name = "UntypedBytesWritten";
    counter->desc = "The total number of untyped memory bytes written via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = icl__compute_basic__untyped_bytes_written__read;
    counter->max_uint64 = icl__compute_basic__untyped_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__compute_basic__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 40);
}

static void
icl_add_compute_extended_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "ComputeExtended Gen11";
    metric_set->symbol_name = "ComputeExtended";
    metric_set->hw_config_guid = "43eb7fc1-dc5e-45e2-a90a-0053f5397271";
    metric_set->counters = calloc(22, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(95, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(24, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1222000B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16220009 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12230019 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10230012 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x101E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1EF800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1E0007 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1FF800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1F0007 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00204000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E204000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A202AA0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C200005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04208000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06208000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08208000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A208000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C208000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00214000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E214000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14214000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16210555 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00220011 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06220900 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08220A13 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A220B15 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C222317 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E220043 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02231AB4 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04231DBA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06230039 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00230000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C044400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E045555 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10040055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04051000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14050015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2406FD00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2606007F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0015C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E15C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16157FF8 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18150003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0415C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0615C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0815C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A15C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C15C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00182000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0618A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0818A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A18A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C18A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E182000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0218A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0418A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08192000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E19A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12195540 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1419000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A19A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C19A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16136860 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x24000004 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x20000040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E132980 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00132D80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10130000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A130000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02130000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x301F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x501F4924 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x521F4924 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x541F000C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3A1F2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4E1F2413 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3E1F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x461F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x481F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4A1F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4C1F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x401F3013 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x421F3030 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x441F3030 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x30000036 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x01FFFE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x31000034 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x01FFFE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000C9A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00000C92 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00000CA2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00000E42 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x00000E6A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x00000C32 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000274C, .val = 0x87643210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00001811 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002748, .val = 0x87654310 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = icl__compute_extended__avg_gpu_core_frequency__read;
    counter->max_uint64 = icl__compute_extended__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__compute_extended__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Eu A32 Untyped Reads 00";
        counter->symbol_name = "EuA32UntypedReads00";
        counter->desc = "Slice0 Dualsubslice 0 Eu A32 Untyped Reads";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = icl__compute_extended__eu_a32_untyped_reads00__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3/Data Port");
    }

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Eu A32 Untyped Writes 00";
        counter->symbol_name = "EuA32UntypedWrites00";
        counter->desc = "Slice0 Dualsubslice 0 Eu A32 Untyped Writes";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = icl__compute_extended__eu_a32_untyped_writes00__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3/Data Port");
    }

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Eu 64 Untyped Reads 00";
        counter->symbol_name = "EuA64UntypedReads00";
        counter->desc = "Slice0 Dualsubslice 0 Eu 64 Untyped Reads";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_float = icl__compute_extended__eu_a64_untyped_reads00__read;
        counter->max_float = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3/Data Port");
    }

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Eu A64 Untyped Writes 00";
        counter->symbol_name = "EuA64UntypedWrites00";
        counter->desc = "Slice0 Dualsubslice 0 Eu A64 Untyped Writes";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = icl__compute_extended__eu_a64_untyped_writes00__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3/Data Port");
    }

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Eu Typed Atomics 00";
        counter->symbol_name = "EuTypedAtomics00";
        counter->desc = "Slice0 Dualsubslice 0 Eu Typed Atomics";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = icl__compute_extended__eu_typed_atomics00__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3/Data Port");
    }

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Eu Typed Reads 00";
        counter->symbol_name = "EuTypedReads00";
        counter->desc = "Slice0 Dualsubslice 0 Eu Typed Reads";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = icl__compute_extended__eu_typed_reads00__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3/Data Port");
    }

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Eu Typed Writes 00";
        counter->symbol_name = "EuTypedWrites00";
        counter->desc = "Slice0 Dualsubslice 0 Eu Typed Writes";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = icl__compute_extended__eu_typed_writes00__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3/Data Port");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__compute_extended__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = icl__compute_extended__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = icl__compute_extended__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Typed Atomics 00";
        counter->symbol_name = "TypedAtomics00";
        counter->desc = "Slice 0 Dualsubslice 0 typed atomics.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = icl__compute_extended__typed_atomics00__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3/Data Port");
    }

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "TypedAtomicsPerCacheLine";
        counter->symbol_name = "TypedAtomicsPerCacheLine";
        counter->desc = "The ratio of EU typed atomics requests to L3 cache line writes.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
        counter->read_float = icl__compute_extended__typed_atomics_per_cache_line__read;
        counter->max_float = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3/Data Port");
    }

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Typed Reads 00";
        counter->symbol_name = "TypedReads00";
        counter->desc = "Slice 0 Dualsubslice 0 typed reads.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = icl__compute_extended__typed_reads00__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3/Data Port");
    }

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "TypedReadsPerCacheLine";
        counter->symbol_name = "TypedReadsPerCacheLine";
        counter->desc = "The ratio of EU typed read requests to L3 cache line reads.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
        counter->read_float = icl__compute_extended__typed_reads_per_cache_line__read;
        counter->max_float = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3/Data Port");
    }

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Typed Writes 00";
        counter->symbol_name = "TypedWrites00";
        counter->desc = "Slice 0 Dualsubslice 0 typed writes.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = icl__compute_extended__typed_writes00__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3/Data Port");
    }

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "TypedWritesPerCacheLine";
        counter->symbol_name = "TypedWritesPerCacheLine";
        counter->desc = "The ratio of EU typed write requests to L3 cache line writes.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
        counter->read_float = icl__compute_extended__typed_writes_per_cache_line__read;
        counter->max_float = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3/Data Port");
    }

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Untyped Reads 00";
        counter->symbol_name = "UntypedReads00";
        counter->desc = "Slice 0 Dualsubslice 0 untyped reads (including SLM reads).";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = icl__compute_extended__untyped_reads00__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3/Data Port");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "UntypedReadsPerCacheLine";
    counter->symbol_name = "UntypedReadsPerCacheLine";
    counter->desc = "The ratio of EU untyped read requests to L3 cache line reads.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
    counter->read_float = icl__compute_extended__untyped_reads_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Untyped Writes 00";
        counter->symbol_name = "UntypedWrites00";
        counter->desc = "Slice 0 Dualsubslice 0 untyped writes (including SLM writes).";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = icl__compute_extended__untyped_writes00__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3/Data Port");
    }

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "UntypedWritesPerCacheLine";
        counter->symbol_name = "UntypedWritesPerCacheLine";
        counter->desc = "The ratio of EU untyped write requests to L3 cache line writes.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
        counter->read_float = icl__compute_extended__untyped_writes_per_cache_line__read;
        counter->max_float = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3/Data Port");
    }

    assert(metric_set->n_counters <= 22);
}

static void
icl_add_compute_l3_cache_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Compute Metrics L3 Cache Gen11";
    metric_set->symbol_name = "ComputeL3Cache";
    metric_set->hw_config_guid = "05d5e01f-0800-4975-b36b-7b169cad3fab";
    metric_set->counters = calloc(55, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(58, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(5, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14120700 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x121500E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10040154 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C045000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E040055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14050055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04054000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A051000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x260600F0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x24067E00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C120023 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E12152B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00121480 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02120028 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10120000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18120000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A120000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04120000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A13D000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04136000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C144000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E14C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02144000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C150980 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02154D80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04154C9A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06150018 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10150000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16150800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18150005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08150000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A150000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1217241C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x22000050 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18133C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x081710B0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10170000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x501F1124 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x521F4801 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x541F0024 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3A1F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4E1F2400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x461F3100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x481F0031 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4A1F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4C1F0030 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x301F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x401F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x421F3030 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x441F3030 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00000003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00002001 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00101100 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00201200 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00301300 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00401400 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = icl__compute_l3_cache__avg_gpu_core_frequency__read;
    counter->max_uint64 = icl__compute_l3_cache__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__compute_l3_cache__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__compute_l3_cache__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__compute_l3_cache__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__compute_l3_cache__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU AVG IPC Rate";
    counter->symbol_name = "EuAvgIpcRate";
    counter->desc = "The average rate of IPC calculated for 2 FPU pipelines.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NUMBER;
    counter->read_float = icl__compute_l3_cache__eu_avg_ipc_rate__read;
    counter->max_float = icl__compute_l3_cache__eu_avg_ipc_rate__max;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Binary Instruction";
    counter->symbol_name = "EuBinaryFpu0Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing binary instructions on FPU0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__compute_l3_cache__eu_binary_fpu0_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Binary Instruction";
    counter->symbol_name = "EuBinaryFpu1Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing binary instructions on FPU1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__compute_l3_cache__eu_binary_fpu1_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__compute_l3_cache__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Hybrid Instruction";
    counter->symbol_name = "EuHybridFpu0Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing hybrid instructions on FPU0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__compute_l3_cache__eu_hybrid_fpu0_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Hybrid Instruction";
    counter->symbol_name = "EuHybridFpu1Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing hybrid instructions on FPU1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__compute_l3_cache__eu_hybrid_fpu1_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Move Instruction";
    counter->symbol_name = "EuMoveFpu0Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing move instructions on FPU0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__compute_l3_cache__eu_move_fpu0_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Move Instruction";
    counter->symbol_name = "EuMoveFpu1Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing move instructions on FPU1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__compute_l3_cache__eu_move_fpu1_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Send Pipe Active";
    counter->symbol_name = "EuSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__compute_l3_cache__eu_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__compute_l3_cache__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Ternary Instruction";
    counter->symbol_name = "EuTernaryFpu0Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing ternary instructions on FPU0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__compute_l3_cache__eu_ternary_fpu0_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Ternary Instruction";
    counter->symbol_name = "EuTernaryFpu1Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing ternary instructions on FPU1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__compute_l3_cache__eu_ternary_fpu1_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Pipe Active";
    counter->symbol_name = "Fpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__compute_l3_cache__fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active";
    counter->symbol_name = "Fpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__compute_l3_cache__fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__compute_l3_cache__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = icl__compute_l3_cache__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = icl__compute_l3_cache__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__compute_l3_cache__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Read Throughput";
    counter->symbol_name = "GtiReadThroughput";
    counter->desc = "The total number of GPU memory bytes read from GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = icl__compute_l3_cache__gti_read_throughput__read;
    counter->max_uint64 = icl__compute_l3_cache__gti_read_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Write Throughput";
    counter->symbol_name = "GtiWriteThroughput";
    counter->desc = "The total number of GPU memory bytes written to GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = icl__compute_l3_cache__gti_write_throughput__read;
    counter->max_uint64 = icl__compute_l3_cache__gti_write_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__compute_l3_cache__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__compute_l3_cache__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Accesses";
    counter->symbol_name = "L3Accesses";
    counter->desc = "The total number of L3 accesses from all entities.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = icl__compute_l3_cache__l3_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3");

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank0 Accesses";
        counter->symbol_name = "L3Bank00Accesses";
        counter->desc = "The total number of accesses to Slice0 L3 Bank0.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = icl__compute_l3_cache__l3_bank00_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank1 Accesses";
        counter->symbol_name = "L3Bank01Accesses";
        counter->desc = "The total number of accesses to Slice0 L3 Bank1.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = icl__compute_l3_cache__l3_bank01_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank2 Accesses";
        counter->symbol_name = "L3Bank02Accesses";
        counter->desc = "The total number of accesses to Slice0 L3 Bank2.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = icl__compute_l3_cache__l3_bank02_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank3 Accesses";
        counter->symbol_name = "L3Bank03Accesses";
        counter->desc = "The total number of accesses to Slice0 L3 Bank3.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = icl__compute_l3_cache__l3_bank03_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank4 Accesses";
        counter->symbol_name = "L3Bank04Accesses";
        counter->desc = "The total number of accesses to Slice0 L3 Bank4.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = icl__compute_l3_cache__l3_bank04_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank5 Accesses";
        counter->symbol_name = "L3Bank05Accesses";
        counter->desc = "The total number of accesses to Slice0 L3 Bank5.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = icl__compute_l3_cache__l3_bank05_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank6 Accesses";
        counter->symbol_name = "L3Bank06Accesses";
        counter->desc = "The total number of accesses to Slice0 L3 Bank6.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = icl__compute_l3_cache__l3_bank06_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank7 Accesses";
        counter->symbol_name = "L3Bank07Accesses";
        counter->desc = "The total number of accesses to Slice0 L3 Bank7.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = icl__compute_l3_cache__l3_bank07_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Lookup Accesses w/o IC";
    counter->symbol_name = "L3Lookups";
    counter->desc = "The total number of L3 cache lookup accesses w/o IC.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = icl__compute_l3_cache__l3_lookups__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/TAG");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Sampler Throughput";
    counter->symbol_name = "L3SamplerThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between samplers and L3 caches.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = icl__compute_l3_cache__l3_sampler_throughput__read;
    counter->max_uint64 = icl__compute_l3_cache__l3_sampler_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = icl__compute_l3_cache__l3_shader_throughput__read;
    counter->max_uint64 = icl__compute_l3_cache__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Total Throughput";
    counter->symbol_name = "L3TotalThroughput";
    counter->desc = "The total number of GPU memory bytes transferred via L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = icl__compute_l3_cache__l3_total_throughput__read;
    counter->max_uint64 = icl__compute_l3_cache__l3_total_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__compute_l3_cache__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__compute_l3_cache__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__compute_l3_cache__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Accesses";
    counter->symbol_name = "SamplerAccesses";
    counter->desc = "The total number of messages send to samplers.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = icl__compute_l3_cache__sampler_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = icl__compute_l3_cache__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = icl__compute_l3_cache__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__compute_l3_cache__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__compute_l3_cache__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__compute_l3_cache__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = icl__compute_l3_cache__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = icl__compute_l3_cache__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = icl__compute_l3_cache__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = icl__compute_l3_cache__slm_bytes_read__read;
    counter->max_uint64 = icl__compute_l3_cache__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = icl__compute_l3_cache__slm_bytes_written__read;
    counter->max_uint64 = icl__compute_l3_cache__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__compute_l3_cache__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 55);
}

static void
icl_add_render_pipe_profile_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Render Metrics for 3D Pipeline Profile Gen11";
    metric_set->symbol_name = "RenderPipeProfile";
    metric_set->hw_config_guid = "03c7a167-2abc-4ba6-878a-f1d80082abca";
    metric_set->counters = calloc(43, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(101, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(5, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(1, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001F001E };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10160000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1017001F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1F0005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A200800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10040015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E054000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14050005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x26060038 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16157E00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C160022 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08160000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C170540 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04170000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A188000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C181000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12195000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14190001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12010000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100B7C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100F0019 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10107C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00110000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x120703C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10090000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06010080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E014180 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10010000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00014000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060B0015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0B2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020BA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040BA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0E0A02 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0EA800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020F0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x180F0800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A100017 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04107113 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18100020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06104000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08110C40 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02110C80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00024000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06028000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E02C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00039000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06036000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0803A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A032000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E035000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0203A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0403A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00044000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E044000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10068000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12068000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14068000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02068000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04068000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06068000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08068000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A068000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C068000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00070032 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E070033 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04070000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08098011 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00090980 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18090A00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02090000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04098000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06098000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A098000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C098000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x301F6000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x501F36DB };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x521F491B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x541F001B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3A1F6000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4E1F1B41 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3E1F2100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x461F4141 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x481F1160 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4A1F1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4C1F2120 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x401F0141 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x421F1160 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x441F3111 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = icl__render_pipe_profile__avg_gpu_core_frequency__read;
    counter->max_uint64 = icl__render_pipe_profile__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "BC Bottleneck";
    counter->symbol_name = "BcBottleneck";
    counter->desc = "The percentage of time in which barycentric coordinates calculation pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__render_pipe_profile__bc_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Barycentric Calc");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Clipper Bottleneck";
    counter->symbol_name = "ClBottleneck";
    counter->desc = "The percentage of time in which clipper pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__render_pipe_profile__cl_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Clipper");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CL Stall";
    counter->symbol_name = "ClStall";
    counter->desc = "The percentage of time in which clipper pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__render_pipe_profile__cl_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Clipper");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__render_pipe_profile__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Bottleneck";
    counter->symbol_name = "DsBottleneck";
    counter->desc = "The percentage of time in which domain shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__render_pipe_profile__ds_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Stall";
    counter->symbol_name = "DsStall";
    counter->desc = "The percentage of time in which domain shader pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__render_pipe_profile__ds_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__render_pipe_profile__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Bottleneck";
    counter->symbol_name = "EarlyDepthBottleneck";
    counter->desc = "The percentage of time in which early depth test pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__render_pipe_profile__early_depth_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__render_pipe_profile__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__render_pipe_profile__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__render_pipe_profile__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__render_pipe_profile__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = icl__render_pipe_profile__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = icl__render_pipe_profile__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Bottleneck";
    counter->symbol_name = "GsBottleneck";
    counter->desc = "The percentage of time in which geometry shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__render_pipe_profile__gs_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__render_pipe_profile__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Hi-Depth Bottleneck";
    counter->symbol_name = "HiDepthBottleneck";
    counter->desc = "The percentage of time in which early hierarchical depth test pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__render_pipe_profile__hi_depth_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__render_pipe_profile__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Bottleneck";
    counter->symbol_name = "HsBottleneck";
    counter->desc = "The percentage of time in which hull shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__render_pipe_profile__hs_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Stall";
    counter->symbol_name = "HsStall";
    counter->desc = "The percentage of time in which hull stall pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__render_pipe_profile__hs_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__render_pipe_profile__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = icl__render_pipe_profile__l3_shader_throughput__read;
    counter->max_uint64 = icl__render_pipe_profile__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__render_pipe_profile__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__render_pipe_profile__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__render_pipe_profile__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = icl__render_pipe_profile__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = icl__render_pipe_profile__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__render_pipe_profile__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__render_pipe_profile__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__render_pipe_profile__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Strip-Fans Bottleneck";
    counter->symbol_name = "SfBottleneck";
    counter->desc = "The percentage of time in which strip-fans pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__render_pipe_profile__sf_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Strip-Fans");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SF Stall";
    counter->symbol_name = "SfStall";
    counter->desc = "The percentage of time in which strip-fans pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__render_pipe_profile__sf_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Strip-Fans");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = icl__render_pipe_profile__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = icl__render_pipe_profile__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = icl__render_pipe_profile__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = icl__render_pipe_profile__slm_bytes_read__read;
    counter->max_uint64 = icl__render_pipe_profile__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = icl__render_pipe_profile__slm_bytes_written__read;
    counter->max_uint64 = icl__render_pipe_profile__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SO Bottleneck";
    counter->symbol_name = "SoBottleneck";
    counter->desc = "The percentage of time in which stream output pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__render_pipe_profile__so_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Stream Output");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SO Stall";
    counter->symbol_name = "SoStall";
    counter->desc = "The percentage of time in which stream-output pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__render_pipe_profile__so_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Stream Output");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VF Bottleneck";
    counter->symbol_name = "VfBottleneck";
    counter->desc = "The percentage of time in which vertex fetch pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__render_pipe_profile__vf_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Input Assembler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Bottleneck";
    counter->symbol_name = "VsBottleneck";
    counter->desc = "The percentage of time in which vertex shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__render_pipe_profile__vs_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__render_pipe_profile__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 43);
}

static void
icl_add_hdc_and_sf_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set HDCAndSF";
    metric_set->symbol_name = "HDCAndSF";
    metric_set->hw_config_guid = "c5cbc488-6569-41dd-9128-42bf6f0d317c";
    metric_set->counters = calloc(41, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(79, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(7, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(5, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1223000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10230009 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1263000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10630009 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12A3000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10A30009 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12E3000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10E30009 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10150019 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C20000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C231900 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E23003C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00230000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C600020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02608000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E631900 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00631E00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04A08000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06A08000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02A31E32 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00A30000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08E08000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AE08000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04E31E32 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00E30000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C045400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10040150 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E040015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14050054 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x24063F00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x260600E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E088000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00088000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14090040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04094000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080E5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A120020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0412C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0612C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A138000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0413E000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0214C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00150047 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16156000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18150007 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08158000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A158000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C188000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E182000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1419000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021CA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1F3061 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x301F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x521F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x541F0024 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3A1F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4E1F2400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x501F0024 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3E1F0100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4C1F3030 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x401F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x421F3000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x441F3330 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x10800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFFE };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = icl__hdc_and_sf__avg_gpu_core_frequency__read;
    counter->max_uint64 = icl__hdc_and_sf__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__hdc_and_sf__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__hdc_and_sf__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__hdc_and_sf__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__hdc_and_sf__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__hdc_and_sf__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__hdc_and_sf__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SQ is full";
    counter->symbol_name = "GTRequestQueueFull";
    counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__hdc_and_sf__gt_request_queue_full__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__hdc_and_sf__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = icl__hdc_and_sf__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = icl__hdc_and_sf__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__hdc_and_sf__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__hdc_and_sf__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__hdc_and_sf__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = icl__hdc_and_sf__l3_shader_throughput__read;
    counter->max_uint64 = icl__hdc_and_sf__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Slice0 Dualsubslice0 Non-sampler Shader Access Stalled On L3";
    counter->symbol_name = "NonSamplerShader00AccessStalledOnL3";
    counter->desc = "Percentage of time when HDC has messages to L3, but it's stalled due to lack of credits (Slice0 Dualsubslice0)";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__hdc_and_sf__non_sampler_shader00_access_stalled_on_l3__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Slice0 Dualsubslice1 Non-sampler Shader Access Stalled On L3";
    counter->symbol_name = "NonSamplerShader01AccessStalledOnL3";
    counter->desc = "Percentage of time when HDC has messages to L3, but it's stalled due to lack of credits (Slice0 Dualsubslice1)";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__hdc_and_sf__non_sampler_shader01_access_stalled_on_l3__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Slice0 Dualsubslice2 Non-sampler Shader Access Stalled On L3";
    counter->symbol_name = "NonSamplerShader02AccessStalledOnL3";
    counter->desc = "Percentage of time when HDC has messages to L3, but it's stalled due to lack of credits (Slice0 Dualsubslice2)";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__hdc_and_sf__non_sampler_shader02_access_stalled_on_l3__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Slice0 Dualsubslice3 Non-sampler Shader Access Stalled On L3";
    counter->symbol_name = "NonSamplerShader03AccessStalledOnL3";
    counter->desc = "Percentage of time when HDC has messages to L3, but it's stalled due to lack of credits (Slice0 Dualsubslice3)";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__hdc_and_sf__non_sampler_shader03_access_stalled_on_l3__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__hdc_and_sf__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Polygon Data Ready";
    counter->symbol_name = "PolyDataReady";
    counter->desc = "The percentage of time in which geometry pipeline output is ready";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__hdc_and_sf__poly_data_ready__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe/Strip-Fans");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__hdc_and_sf__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__hdc_and_sf__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__hdc_and_sf__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__hdc_and_sf__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__hdc_and_sf__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__hdc_and_sf__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = icl__hdc_and_sf__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = icl__hdc_and_sf__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__hdc_and_sf__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__hdc_and_sf__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__hdc_and_sf__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = icl__hdc_and_sf__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = icl__hdc_and_sf__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = icl__hdc_and_sf__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = icl__hdc_and_sf__slm_bytes_read__read;
    counter->max_uint64 = icl__hdc_and_sf__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = icl__hdc_and_sf__slm_bytes_written__read;
    counter->max_uint64 = icl__hdc_and_sf__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__hdc_and_sf__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__hdc_and_sf__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__hdc_and_sf__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__hdc_and_sf__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 41);
}

static void
icl_add_rasterizer_and_pixel_backend_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set RasterizerAndPixelBackend";
    metric_set->symbol_name = "RasterizerAndPixelBackend";
    metric_set->hw_config_guid = "0316ce4f-e03f-4738-8262-13528fce8eea";
    metric_set->counters = calloc(44, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(84, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(11, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(5, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x140A001F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040C5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x140F001F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04115017 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10136000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1213001C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16140000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10160018 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x101A0018 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C045400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E045545 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E051000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08051000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2406DF00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x26060007 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00084000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02084000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04094000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06094000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000A3080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x160A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020C05C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020D1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040D1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060E1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080E1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020F0061 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x160F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08110000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18120C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0613092F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08134025 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C130000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0413A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00148066 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10140000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0614C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08144000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A144000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x161500E8 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04158000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08158000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08161000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08184000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12190100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1A0020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x081A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1C1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x121D0400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1F3000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1F0061 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x301F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x501F4904 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x521F0024 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3A1F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4E1F2400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3E1F6000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x461F5050 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x481F1040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x401F4010 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x421F3000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x441F5033 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x70800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000038 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFF8 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FFF7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FFEF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = icl__rasterizer_and_pixel_backend__avg_gpu_core_frequency__read;
    counter->max_uint64 = icl__rasterizer_and_pixel_backend__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__rasterizer_and_pixel_backend__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__rasterizer_and_pixel_backend__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__rasterizer_and_pixel_backend__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__rasterizer_and_pixel_backend__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__rasterizer_and_pixel_backend__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__rasterizer_and_pixel_backend__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SQ is full";
    counter->symbol_name = "GTRequestQueueFull";
    counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__rasterizer_and_pixel_backend__gt_request_queue_full__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__rasterizer_and_pixel_backend__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = icl__rasterizer_and_pixel_backend__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = icl__rasterizer_and_pixel_backend__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__rasterizer_and_pixel_backend__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__rasterizer_and_pixel_backend__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__rasterizer_and_pixel_backend__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = icl__rasterizer_and_pixel_backend__l3_shader_throughput__read;
    counter->max_uint64 = icl__rasterizer_and_pixel_backend__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Slice0 Pipe0 PS Output Available";
    counter->symbol_name = "PSOutput00Available";
    counter->desc = "The percentage of time in which slice0 pipe0 PS output is available";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__rasterizer_and_pixel_backend__ps_output00_available__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Slice0 Pipe1 PS Output Available";
    counter->symbol_name = "PSOutput01Available";
    counter->desc = "The percentage of time in which slice0 pipe1 PS output is available";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__rasterizer_and_pixel_backend__ps_output01_available__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Slice0 Pipe0 Post-EarlyZ Pixel Data Ready";
    counter->symbol_name = "PixelData00Ready";
    counter->desc = "The percentage of time in which slice0  pipe0 post-EarlyZ pixel data is ready (after early Z tests have been applied)";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__rasterizer_and_pixel_backend__pixel_data00_ready__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Slice0 Pipe1 Post-EarlyZ Pixel Data Ready";
    counter->symbol_name = "PixelData01Ready";
    counter->desc = "The percentage of time in which slice0  pipe1 post-EarlyZ pixel data is ready (after early Z tests have been applied)";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__rasterizer_and_pixel_backend__pixel_data01_ready__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Slice0 Pipe0 Pixel Values Ready";
    counter->symbol_name = "PixelValues00Ready";
    counter->desc = "The percentage of time in which slice0 pipe0 pixel values are ready";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__rasterizer_and_pixel_backend__pixel_values00_ready__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Slice0 Pipe1 Pixel Values Ready";
    counter->symbol_name = "PixelValues01Ready";
    counter->desc = "The percentage of time in which slice0 pipe1 pixel values are ready";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__rasterizer_and_pixel_backend__pixel_values01_ready__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__rasterizer_and_pixel_backend__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__rasterizer_and_pixel_backend__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__rasterizer_and_pixel_backend__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__rasterizer_and_pixel_backend__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__rasterizer_and_pixel_backend__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__rasterizer_and_pixel_backend__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__rasterizer_and_pixel_backend__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Rasterizer Input Available";
        counter->symbol_name = "Rasterizer0InputAvailable";
        counter->desc = "The percentage of time in which slice0 rasterizer input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__rasterizer_and_pixel_backend__rasterizer0_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Rasterizer");
    }

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Rasterizer Output Ready";
        counter->symbol_name = "Rasterizer0OutputReady";
        counter->desc = "The percentage of time in which slice0 rasterizer output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__rasterizer_and_pixel_backend__rasterizer0_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Rasterizer");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = icl__rasterizer_and_pixel_backend__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = icl__rasterizer_and_pixel_backend__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__rasterizer_and_pixel_backend__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__rasterizer_and_pixel_backend__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__rasterizer_and_pixel_backend__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = icl__rasterizer_and_pixel_backend__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = icl__rasterizer_and_pixel_backend__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = icl__rasterizer_and_pixel_backend__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = icl__rasterizer_and_pixel_backend__slm_bytes_read__read;
    counter->max_uint64 = icl__rasterizer_and_pixel_backend__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = icl__rasterizer_and_pixel_backend__slm_bytes_written__read;
    counter->max_uint64 = icl__rasterizer_and_pixel_backend__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__rasterizer_and_pixel_backend__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__rasterizer_and_pixel_backend__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__rasterizer_and_pixel_backend__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__rasterizer_and_pixel_backend__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 44);
}

static void
icl_add_l3_1_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set L3_1";
    metric_set->symbol_name = "L3_1";
    metric_set->hw_config_guid = "21d69ec3-91e1-48a8-acd6-c0c4ec6e819a";
    metric_set->counters = calloc(44, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(69, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(5, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(5, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17340000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17740000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17B40000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17F40000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16340000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16740000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16B40000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16F40000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07340037 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21340000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09740037 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21740000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0BB40037 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21B40000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0DF40037 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x21F40000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0000A7 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08012000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A034000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C038000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C340037 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x20340000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E740037 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x20740000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02B40037 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x20B40000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04F40037 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x20F40000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10040200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E040055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14050070 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04058000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06056000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A051000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x260600C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x24067E00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02074000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04078000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06124000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08124000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A124000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C124000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04138000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06137000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0414C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06144000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1F3000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2A1F0061 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x521F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x541F0024 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3A1F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4E1F2460 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x501F0124 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4C1F0133 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x301F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x401F6060 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x421F0010 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x441F0000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = icl__l3_1__avg_gpu_core_frequency__read;
    counter->max_uint64 = icl__l3_1__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__l3_1__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__l3_1__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__l3_1__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_1__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_1__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_1__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SQ is full";
    counter->symbol_name = "GTRequestQueueFull";
    counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_1__gt_request_queue_full__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_1__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = icl__l3_1__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = icl__l3_1__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__l3_1__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__l3_1__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__l3_1__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank0 Active";
        counter->symbol_name = "L30Bank0Active";
        counter->desc = "The percentage of time in which slice0 L3 bank0 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__l3_1__l30_bank0_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank1 Active";
        counter->symbol_name = "L30Bank1Active";
        counter->desc = "The percentage of time in which slice0 L3 bank1 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__l3_1__l30_bank1_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank2 Active";
        counter->symbol_name = "L30Bank2Active";
        counter->desc = "The percentage of time in which slice0 L3 bank2 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__l3_1__l30_bank2_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank3 Active";
        counter->symbol_name = "L30Bank3Active";
        counter->desc = "The percentage of time in which slice0 L3 bank3 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__l3_1__l30_bank3_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank4 Active";
        counter->symbol_name = "L30Bank4Active";
        counter->desc = "The percentage of time in which slice0 L3 bank4 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__l3_1__l30_bank4_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank5 Active";
        counter->symbol_name = "L30Bank5Active";
        counter->desc = "The percentage of time in which slice0 L3 bank5 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__l3_1__l30_bank5_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank6 Active";
        counter->symbol_name = "L30Bank6Active";
        counter->desc = "The percentage of time in which slice0 L3 bank6 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__l3_1__l30_bank6_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank7 Active";
        counter->symbol_name = "L30Bank7Active";
        counter->desc = "The percentage of time in which slice0 L3 bank7 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__l3_1__l30_bank7_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = icl__l3_1__l3_shader_throughput__read;
    counter->max_uint64 = icl__l3_1__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__l3_1__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_1__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_1__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_1__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_1__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__l3_1__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__l3_1__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = icl__l3_1__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = icl__l3_1__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__l3_1__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__l3_1__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__l3_1__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = icl__l3_1__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = icl__l3_1__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = icl__l3_1__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = icl__l3_1__slm_bytes_read__read;
    counter->max_uint64 = icl__l3_1__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = icl__l3_1__slm_bytes_written__read;
    counter->max_uint64 = icl__l3_1__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_1__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_1__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_1__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__l3_1__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 44);
}

static void
icl_add_l3_2_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Gen11 L2Bank0 stalled metric set";
    metric_set->symbol_name = "L3_2";
    metric_set->hw_config_guid = "e60e9155-6830-4aec-baf2-1c3c15a73869";
    metric_set->counters = calloc(29, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(27, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(13, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(6, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10050C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12050002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00050025 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06050900 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080508EA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0508AB };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C050A21 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E050A60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04050000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14050000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x24068100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x260600FF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x301F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x501F4800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x521F4924 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x541F0024 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3E1F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x461F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x481F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4A1F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4C1F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4E1F0000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000022 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFF8 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00000082 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FFE7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000402 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FF1F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00001002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FCFF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00008003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00011010 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00050012 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00052051 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00000053 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = icl__l3_2__avg_gpu_core_frequency__read;
    counter->max_uint64 = icl__l3_2__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__l3_2__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__l3_2__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__l3_2__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_2__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_2__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_2__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Thread Occupancy";
    counter->symbol_name = "EuThreadOccupancy";
    counter->desc = "The percentage of time in which hardware threads occupied EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_2__eu_thread_occupancy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_2__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = icl__l3_2__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = icl__l3_2__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__l3_2__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__l3_2__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__l3_2__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank0 Stalled";
        counter->symbol_name = "L30Bank0Stalled";
        counter->desc = "The percentage of time in which slice0 L3 bank0 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__l3_2__l30_bank0_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__l3_2__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_2__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_2__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_2__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_2__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__l3_2__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__l3_2__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__l3_2__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__l3_2__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__l3_2__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_2__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_2__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_2__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__l3_2__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 29);
}

static void
icl_add_l3_3_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Gen11 L2Bank1 stalled metric set";
    metric_set->symbol_name = "L3_3";
    metric_set->hw_config_guid = "47c364d5-1799-4d17-9447-add9358c6451";
    metric_set->counters = calloc(29, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(27, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(13, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(6, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10050400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12050000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00050025 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06050900 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080508EA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0508AB };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C050A21 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E050A60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04050000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14050000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x24068100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x260600FF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x301F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x501F4800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x521F4924 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x541F0024 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3E1F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x461F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x481F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4A1F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4C1F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4E1F0000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000022 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFF8 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00000082 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FFE7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000402 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FF1F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00001002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FCFF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00008003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00011010 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00050012 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00052051 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00000053 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = icl__l3_3__avg_gpu_core_frequency__read;
    counter->max_uint64 = icl__l3_3__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__l3_3__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__l3_3__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__l3_3__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_3__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_3__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_3__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Thread Occupancy";
    counter->symbol_name = "EuThreadOccupancy";
    counter->desc = "The percentage of time in which hardware threads occupied EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_3__eu_thread_occupancy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_3__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = icl__l3_3__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = icl__l3_3__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__l3_3__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__l3_3__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__l3_3__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank1 Stalled";
        counter->symbol_name = "L30Bank1Stalled";
        counter->desc = "The percentage of time in which slice0 L3 bank1 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__l3_3__l30_bank1_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__l3_3__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_3__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_3__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_3__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_3__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__l3_3__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__l3_3__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__l3_3__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__l3_3__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__l3_3__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_3__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_3__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_3__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__l3_3__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 29);
}

static void
icl_add_l3_4_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Gen11 L2Bank4 stalled metric set";
    metric_set->symbol_name = "L3_4";
    metric_set->hw_config_guid = "e5ab5c08-3130-4469-8eaf-b23d3dc817d4";
    metric_set->counters = calloc(29, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(56, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(13, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(6, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10010C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12010002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C000400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E005500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10000155 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00010025 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06010900 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080108EA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0108AB };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C010A21 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E010A60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04010000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14010000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C040400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E045500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10040155 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04051000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A054000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14050055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x24068100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x260600FF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00124000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E124000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18125540 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A120015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04131000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06138000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0813F000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A13F000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00144000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0814C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A14C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C14C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E14C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16152AA8 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18150005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x301F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x501F4800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x521F4924 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x541F0024 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3E1F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x461F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x481F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4A1F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4C1F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4E1F0000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000022 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFF8 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00000082 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FFE7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000402 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FF1F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00001002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FCFF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00008003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00011010 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00050012 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00052051 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00000053 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = icl__l3_4__avg_gpu_core_frequency__read;
    counter->max_uint64 = icl__l3_4__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__l3_4__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__l3_4__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__l3_4__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_4__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_4__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_4__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Thread Occupancy";
    counter->symbol_name = "EuThreadOccupancy";
    counter->desc = "The percentage of time in which hardware threads occupied EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_4__eu_thread_occupancy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_4__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = icl__l3_4__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = icl__l3_4__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__l3_4__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__l3_4__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__l3_4__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank4 Stalled";
        counter->symbol_name = "L30Bank4Stalled";
        counter->desc = "The percentage of time in which slice0 L3 bank4 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__l3_4__l30_bank4_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__l3_4__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_4__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_4__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_4__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_4__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__l3_4__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__l3_4__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__l3_4__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__l3_4__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__l3_4__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_4__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_4__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_4__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__l3_4__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 29);
}

static void
icl_add_l3_5_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Gen11 L2Bank5 stalled metric set";
    metric_set->symbol_name = "L3_5";
    metric_set->hw_config_guid = "6cdf23c1-f725-414c-959a-c90fa5571b1f";
    metric_set->counters = calloc(29, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(56, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(13, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(6, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10010400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12010000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C000400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E005500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10000155 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00010022 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06010840 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08010828 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A010969 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C010AA4 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E010AE3 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04010000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14010000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C040400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E045500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10040155 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04051000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A054000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14050055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x24068100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x260600FF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00124000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E124000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18125540 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A120015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04131000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06138000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0813F000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A13F000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00144000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0814C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A14C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C14C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E14C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16152AA8 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18150005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x301F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x501F4800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x521F4924 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x541F0024 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3E1F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x461F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x481F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4A1F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4C1F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4E1F0000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000022 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFF8 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00000082 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FFE7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000402 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FF1F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00001002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FCFF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00008003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00011010 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00050012 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00052051 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00000053 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = icl__l3_5__avg_gpu_core_frequency__read;
    counter->max_uint64 = icl__l3_5__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__l3_5__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__l3_5__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__l3_5__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_5__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_5__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_5__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Thread Occupancy";
    counter->symbol_name = "EuThreadOccupancy";
    counter->desc = "The percentage of time in which hardware threads occupied EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_5__eu_thread_occupancy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_5__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = icl__l3_5__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = icl__l3_5__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__l3_5__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__l3_5__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__l3_5__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank5 Stalled";
        counter->symbol_name = "L30Bank5Stalled";
        counter->desc = "The percentage of time in which slice0 L3 bank5 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__l3_5__l30_bank5_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__l3_5__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_5__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_5__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_5__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_5__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__l3_5__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__l3_5__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__l3_5__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__l3_5__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__l3_5__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_5__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_5__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__l3_5__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__l3_5__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 29);
}

static void
icl_add_sampler_1_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set Sampler 1";
    metric_set->symbol_name = "Sampler_1";
    metric_set->hw_config_guid = "51a2eb6d-9fad-4489-8f22-ab845fe7882a";
    metric_set->counters = calloc(43, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(168, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(21, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(5, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x142A0165 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x142F0165 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x146A0165 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x146F0165 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14AA0165 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14AF0165 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14EA0165 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14EF0165 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x161E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181EC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1E0400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x061F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x081F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1F0400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06204000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08204000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A204000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C204000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06218000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08218000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A218000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C218000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042A1800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062AC038 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x102A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082AC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x182C0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022F2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042F0048 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x102F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C5E000C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x125E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x145E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E5F000C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x025F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x045F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C600014 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02604000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04604000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16612800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02618000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04618000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x006A1800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x026A0038 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6A00F0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x046A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6C000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x066C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x086C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E6F2440 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A9EC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C9E0003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C9FC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E9F0003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1AA02A00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1CA00001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16A102A8 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CAA1C30 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10AA0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18AAF000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1AAA0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18ACAA00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AAF2440 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10AF0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10DE8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1ADE3800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00DF8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CDF3800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00E04000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EE04000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1AE000A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00E18000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EE18000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14E18000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16E10002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08EA1C30 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10EA0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00EAC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EEAC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18EA0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04EC8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18EC00A8 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00EF0040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06EF2400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10EF0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C045400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E045555 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10040155 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14050055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2406FF00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x260600FF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E08A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00088000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02082000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14090050 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04094000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06091000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040E1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0E4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0E5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1812FC00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A12002B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0813C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A13F000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04136000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A14C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C14C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E14C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02144000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00158000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E158000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16152AD0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18150005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0615C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0815C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A15C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C15C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02188000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0418A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06182000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A198000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C19A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E192000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1CA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1CA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x121D5400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141D0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x301F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x501F4924 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x521F4924 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x541F0024 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3A1F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4E1F2400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3E1F3000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x461F4030 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x481F0040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4A1F1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4C1F0010 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x401F1010 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x421F3030 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x441F4040 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000018 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFFC };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00000060 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FFF3 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000180 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FFCF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00000600 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FF3F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00001800 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FCFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00006000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000F3FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x00018000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000CFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x00060000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x00003FFF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = icl__sampler_1__avg_gpu_core_frequency__read;
    counter->max_uint64 = icl__sampler_1__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__sampler_1__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__sampler_1__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__sampler_1__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__sampler_1__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__sampler_1__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__sampler_1__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__sampler_1__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = icl__sampler_1__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = icl__sampler_1__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__sampler_1__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__sampler_1__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__sampler_1__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = icl__sampler_1__l3_shader_throughput__read;
    counter->max_uint64 = icl__sampler_1__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__sampler_1__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__sampler_1__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__sampler_1__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__sampler_1__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__sampler_1__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__sampler_1__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__sampler_1__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice0 Input Available";
        counter->symbol_name = "Sampler00InputAvailable";
        counter->desc = "The percentage of time in which slice0 subslice0 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__sampler_1__sampler00_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice1 Input Available";
        counter->symbol_name = "Sampler01InputAvailable";
        counter->desc = "The percentage of time in which slice0 subslice1 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__sampler_1__sampler01_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice2 Input Available";
        counter->symbol_name = "Sampler02InputAvailable";
        counter->desc = "The percentage of time in which slice0 subslice2 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__sampler_1__sampler02_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 8) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice3 Input Available";
        counter->symbol_name = "Sampler03InputAvailable";
        counter->desc = "The percentage of time in which slice0 subslice3 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__sampler_1__sampler03_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 16) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice4 Input Available";
        counter->symbol_name = "Sampler04InputAvailable";
        counter->desc = "The percentage of time in which slice0 subslice4 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__sampler_1__sampler04_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 32) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice5 Input Available";
        counter->symbol_name = "Sampler05InputAvailable";
        counter->desc = "The percentage of time in which slice0 subslice5 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__sampler_1__sampler05_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 64) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice6 Input Available";
        counter->symbol_name = "Sampler06InputAvailable";
        counter->desc = "The percentage of time in which slice0 subslice6 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__sampler_1__sampler06_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 128) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice7 Input Available";
        counter->symbol_name = "Sampler07InputAvailable";
        counter->desc = "The percentage of time in which slice0 subslice7 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__sampler_1__sampler07_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = icl__sampler_1__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = icl__sampler_1__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__sampler_1__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__sampler_1__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__sampler_1__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = icl__sampler_1__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = icl__sampler_1__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = icl__sampler_1__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = icl__sampler_1__slm_bytes_read__read;
    counter->max_uint64 = icl__sampler_1__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = icl__sampler_1__slm_bytes_written__read;
    counter->max_uint64 = icl__sampler_1__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__sampler_1__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__sampler_1__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__sampler_1__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__sampler_1__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 43);
}

static void
icl_add_sampler_2_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set Sampler 2";
    metric_set->symbol_name = "Sampler_2";
    metric_set->hw_config_guid = "afc0f021-8c33-4d60-803d-93487f96c7c1";
    metric_set->counters = calloc(44, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(137, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(5, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(5, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x142D0005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14320005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x146D0005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14720005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14AD0005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14B20005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14ED0005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14F20005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1E000C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1F000C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C200014 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16212800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x22290010 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A2A00D0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A2C000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2D0033 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022D0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E300080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A310008 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E321980 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02320000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x125E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x145E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x025F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x045F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02604000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04604000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02618000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04618000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12698000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x026A4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x046AC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x066C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x086C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x006D1980 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x026D0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x026F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A702000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08718000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02720033 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x169E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x189E4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x069F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x089F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06A04000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08A04000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06A18000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08A18000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16A98000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06AA4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08AAC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AAC8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CAC8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02AD1980 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04AF4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1CB00002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CB18000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04B20033 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02B20000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18DE8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1ADE0400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0ADF8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CDF0400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AE04000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CE04000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AE18000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CE18000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1EE98000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AEA4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CEAC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EEC8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18EC0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04ED1980 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02ED0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06EF4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1CF00020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18F10002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06F20033 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02F20000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10040140 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C045000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E040055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14050050 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04054000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A051000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x260600C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x24067E00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00088000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02082000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04094000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06091000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080E4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0E1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0612C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0812C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0413E000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06131000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0214C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04144000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1815000F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A158000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C158000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E18A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14190028 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041C2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1F3000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2A1F0061 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x521F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x541F0024 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3A1F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4E1F2430 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x501F0124 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4C1F5047 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x301F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x401F0020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x421F0020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x441F3050 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = icl__sampler_2__avg_gpu_core_frequency__read;
    counter->max_uint64 = icl__sampler_2__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__sampler_2__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__sampler_2__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__sampler_2__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__sampler_2__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__sampler_2__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__sampler_2__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SQ is full";
    counter->symbol_name = "GTRequestQueueFull";
    counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__sampler_2__gt_request_queue_full__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__sampler_2__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = icl__sampler_2__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = icl__sampler_2__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__sampler_2__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__sampler_2__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__sampler_2__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = icl__sampler_2__l3_shader_throughput__read;
    counter->max_uint64 = icl__sampler_2__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__sampler_2__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__sampler_2__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__sampler_2__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__sampler_2__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__sampler_2__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__sampler_2__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__sampler_2__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice0 Sampler Output Ready";
        counter->symbol_name = "Sampler00OutputReady";
        counter->desc = "The percentage of time in which slice0 subslice0 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__sampler_2__sampler00_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice1 Sampler Output Ready";
        counter->symbol_name = "Sampler01OutputReady";
        counter->desc = "The percentage of time in which slice0 subslice1 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__sampler_2__sampler01_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice2 Sampler Output Ready";
        counter->symbol_name = "Sampler02OutputReady";
        counter->desc = "The percentage of time in which slice0 subslice2 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__sampler_2__sampler02_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 8) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice3 Sampler Output Ready";
        counter->symbol_name = "Sampler03OutputReady";
        counter->desc = "The percentage of time in which slice0 subslice3 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__sampler_2__sampler03_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 16) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice4 Sampler Output Ready";
        counter->symbol_name = "Sampler04OutputReady";
        counter->desc = "The percentage of time in which slice0 subslice4 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__sampler_2__sampler04_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 32) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice5 Sampler Output Ready";
        counter->symbol_name = "Sampler05OutputReady";
        counter->desc = "The percentage of time in which slice0 subslice5 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__sampler_2__sampler05_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 64) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice6 Sampler Output Ready";
        counter->symbol_name = "Sampler06OutputReady";
        counter->desc = "The percentage of time in which slice0 subslice6 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__sampler_2__sampler06_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 128) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice7 Sampler Output Ready";
        counter->symbol_name = "Sampler07OutputReady";
        counter->desc = "The percentage of time in which slice0 subslice7 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__sampler_2__sampler07_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = icl__sampler_2__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = icl__sampler_2__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__sampler_2__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__sampler_2__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__sampler_2__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = icl__sampler_2__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = icl__sampler_2__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = icl__sampler_2__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = icl__sampler_2__slm_bytes_read__read;
    counter->max_uint64 = icl__sampler_2__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = icl__sampler_2__slm_bytes_written__read;
    counter->max_uint64 = icl__sampler_2__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__sampler_2__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__sampler_2__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__sampler_2__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__sampler_2__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 44);
}

static void
icl_add_tdl_1_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set TDL_1";
    metric_set->symbol_name = "TDL_1";
    metric_set->hw_config_guid = "eddc2f32-b196-4a72-9bf8-21770e35f8bd";
    metric_set->counters = calloc(51, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(186, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(21, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14290000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x142E0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14690000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x146E0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14A90000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14AE0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14E90000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14EE0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x161E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181EC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1E0400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x061F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x081F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1F0400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06204000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08204000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A204000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C204000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06218000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08218000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A218000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C218000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0429C300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062900C5 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x22290000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E290000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x20290000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062AC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082AC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2A4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2A4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x182C0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022EC300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042E00C5 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x102E0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A304000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C300001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C5E000C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x125E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x145E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E5F000C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x025F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x045F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C600014 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02604000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04604000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16612800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02618000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04618000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0069C300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x026900C5 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x22690000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12690000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6A00F0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x026A4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x046A4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6C000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x066C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x086C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E6EC5C3 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106E0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E6FC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E700050 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A9EC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C9E0003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C9FC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E9F0003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1AA02A00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1CA00001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16A102A8 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CA9C5C3 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x22A90000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18AAF000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1AAA0005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18ACAA00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AAEC5C3 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10AE0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AAFC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1CB05000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10DE8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1ADE3800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00DF8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CDF3800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00E04000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EE04000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1AE000A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00E18000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EE18000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14E18000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16E10002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08E9C5C3 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x22E90000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x20E90000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00EAC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EEAC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18EA0500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04EC8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18EC00A8 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00EE00C3 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06EEC500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10EE0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00EF4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06EF8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18F04000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1CF00040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C045400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E045555 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10040155 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14050055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2406FF00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x260600FF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E08A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00088000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02082000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14090050 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04094000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06091000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040E1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0E4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0E5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1812FC00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A12002B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0813C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A13F000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04136000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A14C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C14C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E14C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02144000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00158000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E158000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16152AD0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18150005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0615C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0815C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A15C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C15C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02188000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0418A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06182000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A198000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C19A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E192000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1CA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1CA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x121D5400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141D0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x301F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x501F4924 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x521F4924 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x541F0024 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3A1F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4E1F2400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3E1F3000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x461F5030 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x481F0050 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4A1F2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4C1F0020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x401F2020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x421F3030 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x441F5050 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000018 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFFC };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00000060 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FFF3 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000180 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FFCF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00000600 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FF3F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00001800 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FCFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00006000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000F3FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x00018000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000CFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x00060000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x00003FFF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = icl__tdl_1__avg_gpu_core_frequency__read;
    counter->max_uint64 = icl__tdl_1__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__tdl_1__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__tdl_1__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__tdl_1__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__tdl_1__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__tdl_1__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__tdl_1__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__tdl_1__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = icl__tdl_1__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = icl__tdl_1__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__tdl_1__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__tdl_1__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__tdl_1__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = icl__tdl_1__l3_shader_throughput__read;
    counter->max_uint64 = icl__tdl_1__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice0 Subslice0 Thread Dispatcher";
        counter->symbol_name = "PSThread00ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice0 subslice0 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__tdl_1__ps_thread00_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice0 Subslice1 Thread Dispatcher";
        counter->symbol_name = "PSThread01ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice0 subslice1 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__tdl_1__ps_thread01_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice0 Subslice2 Thread Dispatcher";
        counter->symbol_name = "PSThread02ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice0 subslice2 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__tdl_1__ps_thread02_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 8) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice0 Subslice3 Thread Dispatcher";
        counter->symbol_name = "PSThread03ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice0 subslice3 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__tdl_1__ps_thread03_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 16) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice0 Subslice4 Thread Dispatcher";
        counter->symbol_name = "PSThread04ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice0 subslice4 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__tdl_1__ps_thread04_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 32) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice0 Subslice5 Thread Dispatcher";
        counter->symbol_name = "PSThread05ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice0 subslice5 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__tdl_1__ps_thread05_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 64) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice0 Subslice6 Thread Dispatcher";
        counter->symbol_name = "PSThread06ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice0 subslice6 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__tdl_1__ps_thread06_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 128) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice0 Subslice7 Thread Dispatcher";
        counter->symbol_name = "PSThread07ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice0 subslice7 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__tdl_1__ps_thread07_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__tdl_1__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS EU Active";
    counter->symbol_name = "PsEuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__tdl_1__ps_eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS AVG Active per Thread";
    counter->symbol_name = "PsEuActivePerThread";
    counter->desc = "The average number of cycles per hardware thread run in which fragment shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = icl__tdl_1__ps_eu_active_per_thread__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__tdl_1__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS EU Stall";
    counter->symbol_name = "PsEuStall";
    counter->desc = "The percentage of time in which fragment shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__tdl_1__ps_eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS AVG Stall per Thread";
    counter->symbol_name = "PsEuStallPerThread";
    counter->desc = "The average number of cycles per hardware thread run in which fragment shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = icl__tdl_1__ps_eu_stall_per_thread__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__tdl_1__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__tdl_1__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__tdl_1__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__tdl_1__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__tdl_1__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = icl__tdl_1__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = icl__tdl_1__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__tdl_1__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__tdl_1__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__tdl_1__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = icl__tdl_1__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = icl__tdl_1__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = icl__tdl_1__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = icl__tdl_1__slm_bytes_read__read;
    counter->max_uint64 = icl__tdl_1__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = icl__tdl_1__slm_bytes_written__read;
    counter->max_uint64 = icl__tdl_1__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS EU Active";
    counter->symbol_name = "VsEuActive";
    counter->desc = "The percentage of time in which vertex shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__tdl_1__vs_eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS AVG Active per Thread";
    counter->symbol_name = "VsEuActivePerThread";
    counter->desc = "The average number of cycles per hardware thread run in which vertex shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = icl__tdl_1__vs_eu_active_per_thread__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS EU Stall";
    counter->symbol_name = "VsEuStall";
    counter->desc = "The percentage of time in which vertex shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__tdl_1__vs_eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS AVG Stall per Thread";
    counter->symbol_name = "VsEuStallPerThread";
    counter->desc = "The average number of cycles per hardware thread run in which vertex shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = icl__tdl_1__vs_eu_stall_per_thread__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__tdl_1__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__tdl_1__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__tdl_1__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__tdl_1__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 51);
}

static void
icl_add_tdl_2_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set TDL_2";
    metric_set->symbol_name = "TDL_2";
    metric_set->hw_config_guid = "c6d3af7b-037b-4656-95e1-4f838f0a2c14";
    metric_set->counters = calloc(44, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(127, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(5, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(5, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14290000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x142E0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14690000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x146E0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14A90000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14AE0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14E90000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14EE0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1E0006 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1F0006 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C200005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16210A00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C29C100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x22290000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A2A0034 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x182C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A2C0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2E00C1 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x102E0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E300010 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C5E0008 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x125E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E5F0008 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x025F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C600010 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02604000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16612000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02618000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E69C100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x22690000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6A0040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x026AC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6C0008 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x066C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x006EC100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106E0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x006F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A700400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x149E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x169E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x049F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x069F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04A04000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06A04000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04A18000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06A18000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02A900C1 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x22A90000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04AA4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06AAC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08AC8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AAC8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02AEC100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10AE0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02AF8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1AB04000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18DEC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08DF8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0ADF8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08E04000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AE04000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08E18000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AE18000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04E900C1 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x22E90000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1CE90000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08EA4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AEAC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CEC8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EEC8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04EEC100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10EE0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04EF8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1CF00004 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10040150 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C045000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E040015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14050054 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04054000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x260600E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x24063E00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E088000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00088000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14090040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04094000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080E5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A120020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0412C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0612C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A138000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0413E000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0214C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16156000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18150007 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08158000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A158000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C188000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E182000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1419000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021CA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1F3061 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x521F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x541F0024 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3A1F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4E1F2420 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x501F0024 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4C1F3050 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x301F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x401F2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x421F5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x441F3730 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = icl__tdl_2__avg_gpu_core_frequency__read;
    counter->max_uint64 = icl__tdl_2__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__tdl_2__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__tdl_2__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__tdl_2__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__tdl_2__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__tdl_2__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__tdl_2__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SQ is full";
    counter->symbol_name = "GTRequestQueueFull";
    counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__tdl_2__gt_request_queue_full__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__tdl_2__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = icl__tdl_2__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = icl__tdl_2__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__tdl_2__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__tdl_2__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__tdl_2__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = icl__tdl_2__l3_shader_throughput__read;
    counter->max_uint64 = icl__tdl_2__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Non-PS Thread Ready For Dispatch on Slice0 Subslice0 Thread Dispatcher";
        counter->symbol_name = "NonPSThread00ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice0 subslice0 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__tdl_2__non_ps_thread00_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Non-PS Thread Ready For Dispatch on Slice0 Subslice1 Thread Dispatcher";
        counter->symbol_name = "NonPSThread01ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice0 subslice1 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__tdl_2__non_ps_thread01_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Non-PS Thread Ready For Dispatch on Slice0 Subslice2 Thread Dispatcher";
        counter->symbol_name = "NonPSThread02ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice0 subslice2 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__tdl_2__non_ps_thread02_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 8) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Non-PS Thread Ready For Dispatch on Slice0 Subslice3 Thread Dispatcher";
        counter->symbol_name = "NonPSThread03ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice0 subslice3 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__tdl_2__non_ps_thread03_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 16) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Non-PS Thread Ready For Dispatch on Slice0 Subslice4 Thread Dispatcher";
        counter->symbol_name = "NonPSThread04ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice0 subslice4 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__tdl_2__non_ps_thread04_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 32) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Non-PS Thread Ready For Dispatch on Slice0 Subslice5 Thread Dispatcher";
        counter->symbol_name = "NonPSThread05ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice0 subslice5 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__tdl_2__non_ps_thread05_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 64) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Non-PS Thread Ready For Dispatch on Slice0 Subslice6 Thread Dispatcher";
        counter->symbol_name = "NonPSThread06ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice0 subslice6 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__tdl_2__non_ps_thread06_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 128) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Non-PS Thread Ready For Dispatch on Slice0 Subslice7 Thread Dispatcher";
        counter->symbol_name = "NonPSThread07ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice0 subslice7 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__tdl_2__non_ps_thread07_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__tdl_2__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__tdl_2__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__tdl_2__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__tdl_2__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__tdl_2__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__tdl_2__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__tdl_2__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = icl__tdl_2__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = icl__tdl_2__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__tdl_2__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__tdl_2__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__tdl_2__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = icl__tdl_2__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = icl__tdl_2__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = icl__tdl_2__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = icl__tdl_2__slm_bytes_read__read;
    counter->max_uint64 = icl__tdl_2__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = icl__tdl_2__slm_bytes_written__read;
    counter->max_uint64 = icl__tdl_2__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__tdl_2__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__tdl_2__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__tdl_2__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__tdl_2__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 44);
}

static void
icl_add_tdl_3_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set TDL_3";
    metric_set->symbol_name = "TDL_3";
    metric_set->hw_config_guid = "fd25ec19-3ed1-40c9-8648-1d2387449a92";
    metric_set->counters = calloc(51, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(191, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(5, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(5, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14292C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16290013 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x142E2C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x162E0013 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14692C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16690013 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x146E2C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x166E0013 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14A92C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16A90013 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14AE2C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16AE0013 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14E92C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16E90013 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14EE2C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16EE0013 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x101E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1E3800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1F3800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00204000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E204000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A2000A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00218000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E218000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14218000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16210002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002900C7 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0629CF00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x22290000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10290000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x20290000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002A4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2A4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x182A0F00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x182C00A8 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082ECFC7 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x102E0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082FC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C300500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A5EC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C5E0003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C5FC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E5F0003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A602A00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C600001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x166102A8 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A69CFC7 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x22690000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x186A5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6A000F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x186CAA00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C6ECFC7 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106E0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C6FC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E700005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C9E000C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x129E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x149E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E9F000C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x029F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x049F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1CA00014 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02A04000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04A04000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16A12800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02A18000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04A18000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EA9CFC7 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x22A90000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1AAA0050 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02AAC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04AAC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1AAC000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06AC8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08AC8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00AEC700 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02AE00CF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10AE0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00AF8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02AF4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1AB01400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16DE8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18DEC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1ADE0400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06DF8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08DF8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0ADF8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CDF0400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06E04000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08E04000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AE04000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CE04000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06E18000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08E18000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AE18000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CE18000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02E9C700 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04E900CF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x22E90000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1CE90000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06EA4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08EA4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AEAC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CEAC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AEC8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CEC8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EEC8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18EC0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04EEC700 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06EE00CF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10EE0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04EF8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06EF4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1CF00014 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C045400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E045555 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10040155 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14050055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2406FF00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x260600FF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A08A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C08A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E095000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14090005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060E4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080E5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0E1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1812A800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A12003E };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0212C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0412C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0813C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A13F000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04136000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A14C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C14C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E14C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02144000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0015C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E15C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16152AF8 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18150005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06158000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08158000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A158000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C158000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00182000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06188000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0818A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08192000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E198000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12190140 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1CA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021C2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141D0028 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x081D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x301F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x501F4924 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x521F4924 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x541F0024 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3A1F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4E1F2420 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3E1F5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x461F3050 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x481F2030 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4A1F0020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4C1F2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x401F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x421F5050 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x441F3030 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = icl__tdl_3__avg_gpu_core_frequency__read;
    counter->max_uint64 = icl__tdl_3__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__tdl_3__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__tdl_3__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__tdl_3__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__tdl_3__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__tdl_3__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__tdl_3__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__tdl_3__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = icl__tdl_3__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = icl__tdl_3__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__tdl_3__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__tdl_3__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__tdl_3__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = icl__tdl_3__l3_shader_throughput__read;
    counter->max_uint64 = icl__tdl_3__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__tdl_3__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__tdl_3__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__tdl_3__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__tdl_3__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__tdl_3__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__tdl_3__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__tdl_3__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = icl__tdl_3__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = icl__tdl_3__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__tdl_3__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__tdl_3__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = icl__tdl_3__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = icl__tdl_3__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = icl__tdl_3__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = icl__tdl_3__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = icl__tdl_3__slm_bytes_read__read;
    counter->max_uint64 = icl__tdl_3__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = icl__tdl_3__slm_bytes_written__read;
    counter->max_uint64 = icl__tdl_3__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice0 Thread Dispatcher Port 0";
        counter->symbol_name = "ThreadHeader00ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice0 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__tdl_3__thread_header00_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice0 Thread Dispatcher Port 1";
        counter->symbol_name = "ThreadHeader00ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice0 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__tdl_3__thread_header00_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice1 Thread Dispatcher Port 0";
        counter->symbol_name = "ThreadHeader01ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice1 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__tdl_3__thread_header01_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice1 Thread Dispatcher Port 1";
        counter->symbol_name = "ThreadHeader01ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice1 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__tdl_3__thread_header01_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice2 Thread Dispatcher Port 0";
        counter->symbol_name = "ThreadHeader02ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice2 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__tdl_3__thread_header02_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice2 Thread Dispatcher Port 1";
        counter->symbol_name = "ThreadHeader02ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice2 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__tdl_3__thread_header02_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 8) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice3 Thread Dispatcher Port 0";
        counter->symbol_name = "ThreadHeader03ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice3 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__tdl_3__thread_header03_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 8) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice3 Thread Dispatcher Port 1";
        counter->symbol_name = "ThreadHeader03ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice3 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__tdl_3__thread_header03_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 16) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice4 Thread Dispatcher Port 0";
        counter->symbol_name = "ThreadHeader04ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice4 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__tdl_3__thread_header04_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 16) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice4 Thread Dispatcher Port 1";
        counter->symbol_name = "ThreadHeader04ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice4 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__tdl_3__thread_header04_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 32) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice5 Thread Dispatcher Port 0";
        counter->symbol_name = "ThreadHeader05ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice5 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__tdl_3__thread_header05_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 32) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice5 Thread Dispatcher Port 1";
        counter->symbol_name = "ThreadHeader05ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice5 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__tdl_3__thread_header05_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 64) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice6 Thread Dispatcher Port 0";
        counter->symbol_name = "ThreadHeader06ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice6 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__tdl_3__thread_header06_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 64) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice6 Thread Dispatcher Port 1";
        counter->symbol_name = "ThreadHeader06ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice6 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__tdl_3__thread_header06_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 128) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice7 Thread Dispatcher Port 0";
        counter->symbol_name = "ThreadHeader07ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice7 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__tdl_3__thread_header07_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 128) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice7 Thread Dispatcher Port 1";
        counter->symbol_name = "ThreadHeader07ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice7 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = icl__tdl_3__thread_header07_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__tdl_3__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__tdl_3__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__tdl_3__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = icl__tdl_3__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 51);
}

static void
icl_add_gpu_busyness_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Gpu Rings Busyness";
    metric_set->symbol_name = "GpuBusyness";
    metric_set->hw_config_guid = "40dc79f2-88c8-47c6-8f86-f509e39fbe5d";
    metric_set->counters = calloc(11, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(55, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E061200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x22062400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10002400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00038000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06032000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020600F3 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C060043 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x20060000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02000023 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x20002000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x081A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3A1F6000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4E1F2900 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x501F00E9 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10204000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C214000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x401F4131 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x421F1021 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x441F3100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x301F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181B2400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x185B2400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12240120 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06218000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08212000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x180B8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E080010 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041B8300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x101B0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x221B0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041E4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x184B4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044F2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E480004 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x045B0083 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x105B0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x225B0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x045E1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0823A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02242980 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10240000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06240000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A244000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C250004 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08268000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x10800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007C000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x000007FF };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AnyRingBusy";
    counter->symbol_name = "AnyRingBusy";
    counter->desc = "The percentage of time when any command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__gpu_busyness__any_ring_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = icl__gpu_busyness__avg_gpu_core_frequency__read;
    counter->max_uint64 = icl__gpu_busyness__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Blitter Ring Busy";
    counter->symbol_name = "BlitterBusy";
    counter->desc = "The percentage of time when blitter command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__gpu_busyness__blitter_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__gpu_busyness__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = icl__gpu_busyness__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = icl__gpu_busyness__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Posh Ring Busy";
    counter->symbol_name = "PoshEngineBusy";
    counter->desc = "The percentage of time when posh command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__gpu_busyness__posh_engine_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Render Ring Busy";
    counter->symbol_name = "RenderBusy";
    counter->desc = "The percentage of time when render command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__gpu_busyness__render_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Vdbox0 Ring Busy";
    counter->symbol_name = "Vdbox0Busy";
    counter->desc = "The percentage of time when Vdbox0 command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__gpu_busyness__vdbox0_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Vdbox1 Ring Busy";
    counter->symbol_name = "Vdbox1Busy";
    counter->desc = "The percentage of time when Vdbox1 command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__gpu_busyness__vdbox1_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Vebox Ring Busy";
    counter->symbol_name = "VeboxBusy";
    counter->desc = "The percentage of time when vebox command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = icl__gpu_busyness__vebox_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    assert(metric_set->n_counters <= 11);
}

static void
icl_add_test_oa_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set TestOa";
    metric_set->symbol_name = "TestOa";
    metric_set->hw_config_guid = "3c0bf614-5d67-4326-887f-a24eb8a58244";
    metric_set->counters = calloc(12, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(12, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(21, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16130000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x24000001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E130056 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10130000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A130000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x541F0001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4C1F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x301F0000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000004 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00000003 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000007 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00100002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FFF7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00100002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FFCF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00100082 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FFEF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x001000C2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FFE7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x00100001 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000FFE7 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = icl__test_oa__avg_gpu_core_frequency__read;
    counter->max_uint64 = icl__test_oa__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter0";
    counter->symbol_name = "Counter0";
    counter->desc = "HW test counter 0. Factor: 0.0";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = icl__test_oa__counter0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter1";
    counter->symbol_name = "Counter1";
    counter->desc = "HW test counter 1. Factor: 1.0";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = icl__test_oa__counter1__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter2";
    counter->symbol_name = "Counter2";
    counter->desc = "HW test counter 2. Factor: 1.0";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = icl__test_oa__counter2__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter3";
    counter->symbol_name = "Counter3";
    counter->desc = "HW test counter 3. Factor: 0.5";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = icl__test_oa__counter3__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter4";
    counter->symbol_name = "Counter4";
    counter->desc = "HW test counter 4. Factor: 0.3333";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = icl__test_oa__counter4__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter5";
    counter->symbol_name = "Counter5";
    counter->desc = "HW test counter 5. Factor: 0.3333";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = icl__test_oa__counter5__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter6";
    counter->symbol_name = "Counter6";
    counter->desc = "HW test counter 6. Factor: 0.16666";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = icl__test_oa__counter6__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter7";
    counter->symbol_name = "Counter7";
    counter->desc = "HW test counter 7. Factor: 0.6666";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = icl__test_oa__counter7__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter8";
    counter->symbol_name = "Counter8";
    counter->desc = "HW test counter 8. Should be equal to 1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = icl__test_oa__counter8__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = icl__test_oa__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = icl__test_oa__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    assert(metric_set->n_counters <= 12);
}

static void
ehl_add_render_basic_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Render Metrics Basic Gen11";
    metric_set->symbol_name = "RenderBasic";
    metric_set->hw_config_guid = "a95112cc-804a-4c80-b57b-2870e56cc240";
    metric_set->counters = calloc(41, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(60, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(5, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(6, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x142C0014 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14120700 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x121500E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E1E0030 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A204000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C200001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E213000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2C1831 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x102C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x182C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10040140 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E040005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14050050 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06054000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08051000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x260600C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x24061800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04120023 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10120000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08120000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06131000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04144000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02150980 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10150000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1815000F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06150000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E18A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14190028 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1C01C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1C000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A5C01C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C5C000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001C0097 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1CA700 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x101C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x081D0100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1D0008 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x085C0097 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A5C00A7 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x105C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A5D0005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E1EB300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x301F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x501F2004 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x521F0090 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x541F0024 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4E1F2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3E1F6100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x461F6100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x481F6100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4A1F0061 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4C1F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x421F3060 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0xFFFFFFFF };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00000052 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = ehl__render_basic__avg_gpu_core_frequency__read;
    counter->max_uint64 = ehl__render_basic__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__render_basic__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__render_basic__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__render_basic__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__render_basic__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__render_basic__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__render_basic__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__render_basic__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = ehl__render_basic__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = ehl__render_basic__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__render_basic__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Read Throughput";
    counter->symbol_name = "GtiReadThroughput";
    counter->desc = "The total number of GPU memory bytes read from GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = ehl__render_basic__gti_read_throughput__read;
    counter->max_uint64 = ehl__render_basic__gti_read_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Write Throughput";
    counter->symbol_name = "GtiWriteThroughput";
    counter->desc = "The total number of GPU memory bytes written to GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = ehl__render_basic__gti_write_throughput__read;
    counter->max_uint64 = ehl__render_basic__gti_write_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__render_basic__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__render_basic__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = ehl__render_basic__l3_shader_throughput__read;
    counter->max_uint64 = ehl__render_basic__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__render_basic__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__render_basic__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__render_basic__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__render_basic__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__render_basic__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__render_basic__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Sampler00 Bottleneck";
        counter->symbol_name = "Sampler00Bottleneck";
        counter->desc = "The percentage of time in which Slice0 Sampler0 has been slowing down the pipe when processing EU requests.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__render_basic__sampler00_bottleneck__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Sampler00 Busy";
        counter->symbol_name = "Sampler00Busy";
        counter->desc = "The percentage of time in which Slice0 Sampler0 has been processing EU requests.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__render_basic__sampler00_busy__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    if (perf->devinfo.subslice_mask & 9) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Samplers Bottleneck";
        counter->symbol_name = "SamplerBottleneck";
        counter->desc = "The percentage of time in which samplers have been slowing down the pipe when processing EU requests.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__render_basic__sampler_bottleneck__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Cache Misses";
    counter->symbol_name = "SamplerL1Misses";
    counter->desc = "The total number of sampler cache misses in all LODs in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = ehl__render_basic__sampler_l1_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = ehl__render_basic__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = ehl__render_basic__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    if (perf->devinfo.subslice_mask & 9) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Samplers Busy";
        counter->symbol_name = "SamplersBusy";
        counter->desc = "The percentage of time in which samplers have been processing EU requests.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__render_basic__samplers_busy__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__render_basic__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__render_basic__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__render_basic__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = ehl__render_basic__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = ehl__render_basic__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = ehl__render_basic__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = ehl__render_basic__slm_bytes_read__read;
    counter->max_uint64 = ehl__render_basic__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = ehl__render_basic__slm_bytes_written__read;
    counter->max_uint64 = ehl__render_basic__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__render_basic__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__render_basic__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__render_basic__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__render_basic__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 41);
}

static void
ehl_add_compute_basic_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Compute Metrics Basic Gen11";
    metric_set->symbol_name = "ComputeBasic";
    metric_set->hw_config_guid = "54449e8a-196b-4c43-8ecd-540b0504b5c1";
    metric_set->counters = calloc(40, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(112, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(5, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(4, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12230012 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10230019 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12A30012 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10A30019 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A200080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C200002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04208000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08208000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C208000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A230031 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E231E00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0223003D };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04230032 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06230033 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00230000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1AA08200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02A08000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06A08000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AA08000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AA31880 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EA3003C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00A31E80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02A31900 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04A31980 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E044055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10040141 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C045000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14050050 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04054000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A051000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x260600CC };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x24067E00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18123000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A12000C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0212C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0612C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A12C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08138000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A134000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0413A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06132000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E144000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16150380 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1815000D };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0415C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0815C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C15C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A182000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E188000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02182000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04182000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06182000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12190400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14190020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A192000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C192000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E192000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1C2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x121D1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141D0008 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x081D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1C01C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1C000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A5C01C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C5C000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001C0097 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1CA700 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x101C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x081D0100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1D0020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x085C0097 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C5C00A7 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x105C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A5D0011 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E1E0300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x201E000B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x301F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x501F2124 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x521F2520 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x541F0024 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3A1F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4E1F2430 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3E1F0300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x461F0300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x481F3000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4A1F0300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4C1F0003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x401F3000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x421F3000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x441F3000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00000003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00002001 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00000008 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = ehl__compute_basic__avg_gpu_core_frequency__read;
    counter->max_uint64 = ehl__compute_basic__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__compute_basic__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__compute_basic__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__compute_basic__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__compute_basic__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU AVG IPC Rate";
    counter->symbol_name = "EuAvgIpcRate";
    counter->desc = "The average rate of IPC calculated for 2 FPU pipelines.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NUMBER;
    counter->read_float = ehl__compute_basic__eu_avg_ipc_rate__read;
    counter->max_float = ehl__compute_basic__eu_avg_ipc_rate__max;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__compute_basic__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Send Pipe Active";
    counter->symbol_name = "EuSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__compute_basic__eu_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__compute_basic__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Thread Occupancy";
    counter->symbol_name = "EuThreadOccupancy";
    counter->desc = "The percentage of time in which hardware threads occupied EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__compute_basic__eu_thread_occupancy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Pipe Active";
    counter->symbol_name = "Fpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__compute_basic__fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active";
    counter->symbol_name = "Fpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__compute_basic__fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__compute_basic__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = ehl__compute_basic__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = ehl__compute_basic__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__compute_basic__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Read Throughput";
    counter->symbol_name = "GtiReadThroughput";
    counter->desc = "The total number of GPU memory bytes read from GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = ehl__compute_basic__gti_read_throughput__read;
    counter->max_uint64 = ehl__compute_basic__gti_read_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Write Throughput";
    counter->symbol_name = "GtiWriteThroughput";
    counter->desc = "The total number of GPU memory bytes written to GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = ehl__compute_basic__gti_write_throughput__read;
    counter->max_uint64 = ehl__compute_basic__gti_write_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__compute_basic__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__compute_basic__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = ehl__compute_basic__l3_shader_throughput__read;
    counter->max_uint64 = ehl__compute_basic__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__compute_basic__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__compute_basic__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__compute_basic__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = ehl__compute_basic__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = ehl__compute_basic__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__compute_basic__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__compute_basic__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__compute_basic__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = ehl__compute_basic__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = ehl__compute_basic__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = ehl__compute_basic__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = ehl__compute_basic__slm_bytes_read__read;
    counter->max_uint64 = ehl__compute_basic__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = ehl__compute_basic__slm_bytes_written__read;
    counter->max_uint64 = ehl__compute_basic__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Atomics Accesses";
    counter->symbol_name = "TypedAtomics";
    counter->desc = "The total number of typed atomic accesses via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = ehl__compute_basic__typed_atomics__read;
    counter->max_uint64 = ehl__compute_basic__typed_atomics__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Bytes Read";
    counter->symbol_name = "TypedBytesRead";
    counter->desc = "The total number of typed memory bytes read via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = ehl__compute_basic__typed_bytes_read__read;
    counter->max_uint64 = ehl__compute_basic__typed_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Typed Bytes Written";
    counter->symbol_name = "TypedBytesWritten";
    counter->desc = "The total number of untyped memory bytes written via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = ehl__compute_basic__typed_bytes_written__read;
    counter->max_uint64 = ehl__compute_basic__typed_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Untyped Bytes Read";
    counter->symbol_name = "UntypedBytesRead";
    counter->desc = "The total number of typed memory bytes read via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = ehl__compute_basic__untyped_bytes_read__read;
    counter->max_uint64 = ehl__compute_basic__untyped_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Untyped Writes";
    counter->symbol_name = "UntypedBytesWritten";
    counter->desc = "The total number of untyped memory bytes written via Data Port.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = ehl__compute_basic__untyped_bytes_written__read;
    counter->max_uint64 = ehl__compute_basic__untyped_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__compute_basic__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 40);
}

static void
ehl_add_compute_extended_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "ComputeExtended Gen11";
    metric_set->symbol_name = "ComputeExtended";
    metric_set->hw_config_guid = "05700b63-f044-4c79-b8ae-676972114745";
    metric_set->counters = calloc(22, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(94, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(24, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14210160 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18210120 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12230019 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10230012 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x101E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1EE000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E1E001F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00204000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E204000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18204000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A205550 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04208000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06208000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08208000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A208000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C208000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00210041 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06214200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08214443 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A214645 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C217647 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E210073 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E210000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10210000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02231AB4 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04231DBA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06230039 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00230000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C044400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E045555 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10040055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04051000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14050015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2406FD00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2606007F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0015C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E15C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16157FF8 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18150003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0415C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0615C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0815C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A15C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C15C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00182000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0618A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0818A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A18A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C18A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E182000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0218A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0418A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08192000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E19A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12195540 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1419000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A19A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C19A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18130343 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x22000008 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12008000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E137300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00137B00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10130000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E130000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C130000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E168000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00168000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1A0010 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021A4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x301F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x501F4924 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x521F4924 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x541F000C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3A1F2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4E1F2441 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3E1F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x461F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x481F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4A1F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4C1F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x401F1041 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x421F1010 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x441F1010 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x30000036 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x01FFFE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x31000034 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x01FFFE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000C9A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00000C92 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00000CA2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00000E42 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x00000E6A };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x00000C32 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000FE00 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000274C, .val = 0x87643210 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002744, .val = 0x00001811 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002748, .val = 0x87654310 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = ehl__compute_extended__avg_gpu_core_frequency__read;
    counter->max_uint64 = ehl__compute_extended__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__compute_extended__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Eu A32 Untyped Reads 00";
        counter->symbol_name = "EuA32UntypedReads00";
        counter->desc = "Slice0 Subslice group 0 Eu A32 Untyped Reads";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = ehl__compute_extended__eu_a32_untyped_reads00__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3/Data Port");
    }

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Eu A32 Untyped Writes 00";
        counter->symbol_name = "EuA32UntypedWrites00";
        counter->desc = "Slice0 Subslice group 0 Eu A32 Untyped Writes";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = ehl__compute_extended__eu_a32_untyped_writes00__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3/Data Port");
    }

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Eu 64 Untyped Reads 00";
        counter->symbol_name = "EuA64UntypedReads00";
        counter->desc = "Slice0 Subslice group 0 Eu 64 Untyped Reads";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_float = ehl__compute_extended__eu_a64_untyped_reads00__read;
        counter->max_float = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3/Data Port");
    }

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Eu A64 Untyped Writes 00";
        counter->symbol_name = "EuA64UntypedWrites00";
        counter->desc = "Slice0 Subslice group 0 Eu A64 Untyped Writes";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = ehl__compute_extended__eu_a64_untyped_writes00__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3/Data Port");
    }

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Eu Typed Atomics 00";
        counter->symbol_name = "EuTypedAtomics00";
        counter->desc = "Slice0 Subslice group 0 Eu Typed Atomics";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = ehl__compute_extended__eu_typed_atomics00__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3/Data Port");
    }

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Eu Typed Reads 00";
        counter->symbol_name = "EuTypedReads00";
        counter->desc = "Slice0 Subslice group 0 Eu Typed Reads";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = ehl__compute_extended__eu_typed_reads00__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3/Data Port");
    }

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Eu Typed Writes 00";
        counter->symbol_name = "EuTypedWrites00";
        counter->desc = "Slice0 Subslice group 0 Eu Typed Writes";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = ehl__compute_extended__eu_typed_writes00__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3/Data Port");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__compute_extended__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = ehl__compute_extended__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = ehl__compute_extended__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Typed Atomics 00";
        counter->symbol_name = "TypedAtomics00";
        counter->desc = "Slice 0 Subslice group 0 typed atomics.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = ehl__compute_extended__typed_atomics00__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3/Data Port");
    }

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "TypedAtomicsPerCacheLine";
        counter->symbol_name = "TypedAtomicsPerCacheLine";
        counter->desc = "The ratio of EU typed atomics requests to L3 cache line writes.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
        counter->read_float = ehl__compute_extended__typed_atomics_per_cache_line__read;
        counter->max_float = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3/Data Port");
    }

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Typed Reads 00";
        counter->symbol_name = "TypedReads00";
        counter->desc = "Slice 0 Subslice group 0 typed reads.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = ehl__compute_extended__typed_reads00__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3/Data Port");
    }

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "TypedReadsPerCacheLine";
        counter->symbol_name = "TypedReadsPerCacheLine";
        counter->desc = "The ratio of EU typed read requests to L3 cache line reads.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
        counter->read_float = ehl__compute_extended__typed_reads_per_cache_line__read;
        counter->max_float = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3/Data Port");
    }

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Typed Writes 00";
        counter->symbol_name = "TypedWrites00";
        counter->desc = "Slice 0 Subslice group 0 typed writes.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = ehl__compute_extended__typed_writes00__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3/Data Port");
    }

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "TypedWritesPerCacheLine";
        counter->symbol_name = "TypedWritesPerCacheLine";
        counter->desc = "The ratio of EU typed write requests to L3 cache line writes.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
        counter->read_float = ehl__compute_extended__typed_writes_per_cache_line__read;
        counter->max_float = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3/Data Port");
    }

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Untyped Reads 00";
        counter->symbol_name = "UntypedReads00";
        counter->desc = "Slice 0 Subslice group 0 untyped reads (including SLM reads).";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = ehl__compute_extended__untyped_reads00__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3/Data Port");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "UntypedReadsPerCacheLine";
    counter->symbol_name = "UntypedReadsPerCacheLine";
    counter->desc = "The ratio of EU untyped read requests to L3 cache line reads.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
    counter->read_float = ehl__compute_extended__untyped_reads_per_cache_line__read;
    counter->max_float = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Untyped Writes 00";
        counter->symbol_name = "UntypedWrites00";
        counter->desc = "Slice 0 Subslice group 0 untyped writes (including SLM writes).";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = ehl__compute_extended__untyped_writes00__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3/Data Port");
    }

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "UntypedWritesPerCacheLine";
        counter->symbol_name = "UntypedWritesPerCacheLine";
        counter->desc = "The ratio of EU untyped write requests to L3 cache line writes.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EU_SENDS_TO_L3_CACHE_LINES;
        counter->read_float = ehl__compute_extended__untyped_writes_per_cache_line__read;
        counter->max_float = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3/Data Port");
    }

    assert(metric_set->n_counters <= 22);
}

static void
ehl_add_compute_l3_cache_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Compute Metrics L3 Cache Gen11";
    metric_set->symbol_name = "ComputeL3Cache";
    metric_set->hw_config_guid = "89e1f7ae-1100-4b4f-92f3-0caf88e3d833";
    metric_set->counters = calloc(57, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(67, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(5, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14120700 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x121500E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10040154 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C045000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E040055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14050055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04054000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A051000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x260600F0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x24067E00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C120023 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E12152B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00121480 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02120028 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10120000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18120000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A120000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04120000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A13D000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04136000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C144000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E14C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02144000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C150980 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02154D80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04154C9A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06150018 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10150000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16150800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18150005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08150000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A150000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1473A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1217241C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2000F000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C134000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E130015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x061434A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E140000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C143000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0816C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A16C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x081710B0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00170000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x161A2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181A1500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x501F1124 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x521F4849 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x541F0024 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3A1F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4E1F2400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x461F0100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x481F1101 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4A1F0011 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4C1F0030 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x301F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x401F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x421F3030 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x441F3030 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00000003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00002001 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00101100 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00201200 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00301300 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00401400 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = ehl__compute_l3_cache__avg_gpu_core_frequency__read;
    counter->max_uint64 = ehl__compute_l3_cache__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__compute_l3_cache__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__compute_l3_cache__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__compute_l3_cache__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__compute_l3_cache__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU AVG IPC Rate";
    counter->symbol_name = "EuAvgIpcRate";
    counter->desc = "The average rate of IPC calculated for 2 FPU pipelines.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NUMBER;
    counter->read_float = ehl__compute_l3_cache__eu_avg_ipc_rate__read;
    counter->max_float = ehl__compute_l3_cache__eu_avg_ipc_rate__max;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Binary Instruction";
    counter->symbol_name = "EuBinaryFpu0Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing binary instructions on FPU0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__compute_l3_cache__eu_binary_fpu0_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Binary Instruction";
    counter->symbol_name = "EuBinaryFpu1Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing binary instructions on FPU1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__compute_l3_cache__eu_binary_fpu1_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__compute_l3_cache__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Hybrid Instruction";
    counter->symbol_name = "EuHybridFpu0Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing hybrid instructions on FPU0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__compute_l3_cache__eu_hybrid_fpu0_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Hybrid Instruction";
    counter->symbol_name = "EuHybridFpu1Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing hybrid instructions on FPU1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__compute_l3_cache__eu_hybrid_fpu1_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Move Instruction";
    counter->symbol_name = "EuMoveFpu0Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing move instructions on FPU0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__compute_l3_cache__eu_move_fpu0_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Move Instruction";
    counter->symbol_name = "EuMoveFpu1Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing move instructions on FPU1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__compute_l3_cache__eu_move_fpu1_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Send Pipe Active";
    counter->symbol_name = "EuSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__compute_l3_cache__eu_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__compute_l3_cache__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Ternary Instruction";
    counter->symbol_name = "EuTernaryFpu0Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing ternary instructions on FPU0.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__compute_l3_cache__eu_ternary_fpu0_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Ternary Instruction";
    counter->symbol_name = "EuTernaryFpu1Instruction";
    counter->desc = "The percentage of time in which execution units were actively processing ternary instructions on FPU1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__compute_l3_cache__eu_ternary_fpu1_instruction__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes/Instructions");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU0 Pipe Active";
    counter->symbol_name = "Fpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__compute_l3_cache__fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU1 Pipe Active";
    counter->symbol_name = "Fpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__compute_l3_cache__fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__compute_l3_cache__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = ehl__compute_l3_cache__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = ehl__compute_l3_cache__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__compute_l3_cache__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI L3 Throughput";
    counter->symbol_name = "GtiL3Throughput";
    counter->desc = "The total number of GPU memory bytes transferred between L3 caches and GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = ehl__compute_l3_cache__gti_l3_throughput__read;
    counter->max_uint64 = ehl__compute_l3_cache__gti_l3_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI/L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Read Throughput";
    counter->symbol_name = "GtiReadThroughput";
    counter->desc = "The total number of GPU memory bytes read from GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = ehl__compute_l3_cache__gti_read_throughput__read;
    counter->max_uint64 = ehl__compute_l3_cache__gti_read_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Write Throughput";
    counter->symbol_name = "GtiWriteThroughput";
    counter->desc = "The total number of GPU memory bytes written to GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = ehl__compute_l3_cache__gti_write_throughput__read;
    counter->max_uint64 = ehl__compute_l3_cache__gti_write_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__compute_l3_cache__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__compute_l3_cache__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Accesses";
    counter->symbol_name = "L3Accesses";
    counter->desc = "The total number of L3 accesses from all entities.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = ehl__compute_l3_cache__l3_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3");

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank0 Accesses";
        counter->symbol_name = "L3Bank00Accesses";
        counter->desc = "The total number of accesses to Slice0 L3 Bank0.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = ehl__compute_l3_cache__l3_bank00_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank1 Accesses";
        counter->symbol_name = "L3Bank01Accesses";
        counter->desc = "The total number of accesses to Slice0 L3 Bank1.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = ehl__compute_l3_cache__l3_bank01_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank2 Accesses";
        counter->symbol_name = "L3Bank02Accesses";
        counter->desc = "The total number of accesses to Slice0 L3 Bank2.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = ehl__compute_l3_cache__l3_bank02_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank3 Accesses";
        counter->symbol_name = "L3Bank03Accesses";
        counter->desc = "The total number of accesses to Slice0 L3 Bank3.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = ehl__compute_l3_cache__l3_bank03_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank4 Accesses";
        counter->symbol_name = "L3Bank04Accesses";
        counter->desc = "The total number of accesses to Slice0 L3 Bank4.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = ehl__compute_l3_cache__l3_bank04_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank5 Accesses";
        counter->symbol_name = "L3Bank05Accesses";
        counter->desc = "The total number of accesses to Slice0 L3 Bank5.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = ehl__compute_l3_cache__l3_bank05_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank6 Accesses";
        counter->symbol_name = "L3Bank06Accesses";
        counter->desc = "The total number of accesses to Slice0 L3 Bank6.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = ehl__compute_l3_cache__l3_bank06_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank7 Accesses";
        counter->symbol_name = "L3Bank07Accesses";
        counter->desc = "The total number of accesses to Slice0 L3 Bank7.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
        counter->read_uint64 = ehl__compute_l3_cache__l3_bank07_accesses__read;
        counter->max_uint64 = NULL /* undefined */;
        intel_perf_add_logical_counter(perf, counter, "L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Lookup Accesses w/o IC";
    counter->symbol_name = "L3Lookups";
    counter->desc = "The total number of L3 cache lookup accesses w/o IC.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = ehl__compute_l3_cache__l3_lookups__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/TAG");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Misses";
    counter->symbol_name = "L3Misses";
    counter->desc = "The total number of L3 misses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = ehl__compute_l3_cache__l3_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/TAG");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Sampler Throughput";
    counter->symbol_name = "L3SamplerThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between samplers and L3 caches.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = ehl__compute_l3_cache__l3_sampler_throughput__read;
    counter->max_uint64 = ehl__compute_l3_cache__l3_sampler_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = ehl__compute_l3_cache__l3_shader_throughput__read;
    counter->max_uint64 = ehl__compute_l3_cache__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Total Throughput";
    counter->symbol_name = "L3TotalThroughput";
    counter->desc = "The total number of GPU memory bytes transferred via L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = ehl__compute_l3_cache__l3_total_throughput__read;
    counter->max_uint64 = ehl__compute_l3_cache__l3_total_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__compute_l3_cache__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__compute_l3_cache__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__compute_l3_cache__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Accesses";
    counter->symbol_name = "SamplerAccesses";
    counter->desc = "The total number of messages send to samplers.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = ehl__compute_l3_cache__sampler_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = ehl__compute_l3_cache__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = ehl__compute_l3_cache__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__compute_l3_cache__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__compute_l3_cache__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__compute_l3_cache__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = ehl__compute_l3_cache__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = ehl__compute_l3_cache__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = ehl__compute_l3_cache__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = ehl__compute_l3_cache__slm_bytes_read__read;
    counter->max_uint64 = ehl__compute_l3_cache__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = ehl__compute_l3_cache__slm_bytes_written__read;
    counter->max_uint64 = ehl__compute_l3_cache__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__compute_l3_cache__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 57);
}

static void
ehl_add_render_pipe_profile_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Render Metrics for 3D Pipeline Profile Gen11";
    metric_set->symbol_name = "RenderPipeProfile";
    metric_set->hw_config_guid = "7bfa0a68-c327-46e8-a556-cfa7b4651071";
    metric_set->counters = calloc(43, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(87, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(5, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(1, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x101E001E };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10160000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1017001F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1E0500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E1E0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A200100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10040015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E054000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14050005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x26060038 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16157E00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C160022 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08160000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C170540 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04170000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A188000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C181000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12195000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14190001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100A0019 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x140A001F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x180B0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x160C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C020000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1806801F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1007001E };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12080000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0A0047 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020A0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040A0043 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x200A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E0A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x180A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A0A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080B3100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020B3200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100B0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040C2900 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100200B1 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020200B3 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08020000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00020000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00034000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08038000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E034000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02038000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C04FFB6 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E04E039 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C059000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10050042 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06060095 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E060084 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C068000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14068000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A068000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00070022 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E070023 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08078000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02078000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06080100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E080300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C080004 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A082000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14088000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18088000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C090800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16098000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x301F6000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x501F36DB };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x521F491B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x541F001B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3A1F6000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4E1F1B41 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3E1F3100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x461F5141 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x481F3111 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4A1F1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4C1F3120 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x401F3151 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x421F3111 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x441F5121 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = ehl__render_pipe_profile__avg_gpu_core_frequency__read;
    counter->max_uint64 = ehl__render_pipe_profile__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "BC Bottleneck";
    counter->symbol_name = "BcBottleneck";
    counter->desc = "The percentage of time in which barycentric coordinates calculation pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__render_pipe_profile__bc_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Barycentric Calc");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Clipper Bottleneck";
    counter->symbol_name = "ClBottleneck";
    counter->desc = "The percentage of time in which clipper pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__render_pipe_profile__cl_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Clipper");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CL Stall";
    counter->symbol_name = "ClStall";
    counter->desc = "The percentage of time in which clipper pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__render_pipe_profile__cl_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Clipper");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__render_pipe_profile__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Bottleneck";
    counter->symbol_name = "DsBottleneck";
    counter->desc = "The percentage of time in which domain shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__render_pipe_profile__ds_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Stall";
    counter->symbol_name = "DsStall";
    counter->desc = "The percentage of time in which domain shader pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__render_pipe_profile__ds_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__render_pipe_profile__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Bottleneck";
    counter->symbol_name = "EarlyDepthBottleneck";
    counter->desc = "The percentage of time in which early depth test pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__render_pipe_profile__early_depth_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__render_pipe_profile__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__render_pipe_profile__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__render_pipe_profile__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__render_pipe_profile__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = ehl__render_pipe_profile__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = ehl__render_pipe_profile__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Bottleneck";
    counter->symbol_name = "GsBottleneck";
    counter->desc = "The percentage of time in which geometry shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__render_pipe_profile__gs_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__render_pipe_profile__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Hi-Depth Bottleneck";
    counter->symbol_name = "HiDepthBottleneck";
    counter->desc = "The percentage of time in which early hierarchical depth test pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__render_pipe_profile__hi_depth_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__render_pipe_profile__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Bottleneck";
    counter->symbol_name = "HsBottleneck";
    counter->desc = "The percentage of time in which hull shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__render_pipe_profile__hs_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Stall";
    counter->symbol_name = "HsStall";
    counter->desc = "The percentage of time in which hull stall pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__render_pipe_profile__hs_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__render_pipe_profile__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = ehl__render_pipe_profile__l3_shader_throughput__read;
    counter->max_uint64 = ehl__render_pipe_profile__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__render_pipe_profile__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__render_pipe_profile__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__render_pipe_profile__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = ehl__render_pipe_profile__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = ehl__render_pipe_profile__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__render_pipe_profile__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__render_pipe_profile__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__render_pipe_profile__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Strip-Fans Bottleneck";
    counter->symbol_name = "SfBottleneck";
    counter->desc = "The percentage of time in which strip-fans pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__render_pipe_profile__sf_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Strip-Fans");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SF Stall";
    counter->symbol_name = "SfStall";
    counter->desc = "The percentage of time in which strip-fans pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__render_pipe_profile__sf_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Strip-Fans");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = ehl__render_pipe_profile__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = ehl__render_pipe_profile__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = ehl__render_pipe_profile__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = ehl__render_pipe_profile__slm_bytes_read__read;
    counter->max_uint64 = ehl__render_pipe_profile__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = ehl__render_pipe_profile__slm_bytes_written__read;
    counter->max_uint64 = ehl__render_pipe_profile__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SO Bottleneck";
    counter->symbol_name = "SoBottleneck";
    counter->desc = "The percentage of time in which stream output pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__render_pipe_profile__so_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Stream Output");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SO Stall";
    counter->symbol_name = "SoStall";
    counter->desc = "The percentage of time in which stream-output pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__render_pipe_profile__so_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Stream Output");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VF Bottleneck";
    counter->symbol_name = "VfBottleneck";
    counter->desc = "The percentage of time in which vertex fetch pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__render_pipe_profile__vf_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Input Assembler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Bottleneck";
    counter->symbol_name = "VsBottleneck";
    counter->desc = "The percentage of time in which vertex shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__render_pipe_profile__vs_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__render_pipe_profile__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 43);
}

static void
ehl_add_hdc_and_sf_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set HDCAndSF";
    metric_set->symbol_name = "HDCAndSF";
    metric_set->hw_config_guid = "697eadd2-bc54-459f-b634-fcb3d4a2d627";
    metric_set->counters = calloc(41, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(79, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(7, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(5, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1223000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10230009 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1263000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10630009 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12A3000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10A30009 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12E3000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10E30009 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10150019 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A20A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C231900 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E23003C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00230000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C600002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02608000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E631900 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00631E00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04A08000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06A08000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02A31E32 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00A30000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08E08000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AE08000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04E31E32 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00E30000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C045400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10040150 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E040015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14050054 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x24063F00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x260600E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E088000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00088000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14090040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04094000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080E5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A120020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0412C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0612C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A138000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0413E000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0214C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00150047 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16156000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18150007 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08158000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A158000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C188000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E182000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1419000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021CA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1F3061 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x301F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x521F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x541F0024 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3A1F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4E1F2400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x501F0024 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3E1F0100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4C1F3030 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x401F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x421F3000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x441F3330 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x10800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFFE };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = ehl__hdc_and_sf__avg_gpu_core_frequency__read;
    counter->max_uint64 = ehl__hdc_and_sf__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__hdc_and_sf__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__hdc_and_sf__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__hdc_and_sf__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__hdc_and_sf__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__hdc_and_sf__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__hdc_and_sf__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SQ is full";
    counter->symbol_name = "GTRequestQueueFull";
    counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__hdc_and_sf__gt_request_queue_full__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__hdc_and_sf__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = ehl__hdc_and_sf__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = ehl__hdc_and_sf__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__hdc_and_sf__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__hdc_and_sf__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__hdc_and_sf__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = ehl__hdc_and_sf__l3_shader_throughput__read;
    counter->max_uint64 = ehl__hdc_and_sf__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Slice0 Subslice group 0 Non-sampler Shader Access Stalled On L3";
    counter->symbol_name = "NonSamplerShader00AccessStalledOnL3";
    counter->desc = "Percentage of time when HDC has messages to L3, but it's stalled due to lack of credits (Slice0 Subslice group 0)";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__hdc_and_sf__non_sampler_shader00_access_stalled_on_l3__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Slice0 Subslice group 1 Non-sampler Shader Access Stalled On L3";
    counter->symbol_name = "NonSamplerShader01AccessStalledOnL3";
    counter->desc = "Percentage of time when HDC has messages to L3, but it's stalled due to lack of credits (Slice0 Subslice group 1)";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__hdc_and_sf__non_sampler_shader01_access_stalled_on_l3__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Slice0 Subslice group 2 Non-sampler Shader Access Stalled On L3";
    counter->symbol_name = "NonSamplerShader02AccessStalledOnL3";
    counter->desc = "Percentage of time when HDC has messages to L3, but it's stalled due to lack of credits (Slice0 Subslice group 2)";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__hdc_and_sf__non_sampler_shader02_access_stalled_on_l3__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Slice0 Subslice group 3 Non-sampler Shader Access Stalled On L3";
    counter->symbol_name = "NonSamplerShader03AccessStalledOnL3";
    counter->desc = "Percentage of time when HDC has messages to L3, but it's stalled due to lack of credits (Slice0 Subslice group 3)";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__hdc_and_sf__non_sampler_shader03_access_stalled_on_l3__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__hdc_and_sf__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Polygon Data Ready";
    counter->symbol_name = "PolyDataReady";
    counter->desc = "The percentage of time in which geometry pipeline output is ready";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__hdc_and_sf__poly_data_ready__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe/Strip-Fans");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__hdc_and_sf__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__hdc_and_sf__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__hdc_and_sf__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__hdc_and_sf__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__hdc_and_sf__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__hdc_and_sf__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = ehl__hdc_and_sf__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = ehl__hdc_and_sf__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__hdc_and_sf__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__hdc_and_sf__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__hdc_and_sf__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = ehl__hdc_and_sf__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = ehl__hdc_and_sf__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = ehl__hdc_and_sf__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = ehl__hdc_and_sf__slm_bytes_read__read;
    counter->max_uint64 = ehl__hdc_and_sf__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = ehl__hdc_and_sf__slm_bytes_written__read;
    counter->max_uint64 = ehl__hdc_and_sf__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__hdc_and_sf__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__hdc_and_sf__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__hdc_and_sf__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__hdc_and_sf__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 41);
}

static void
ehl_add_rasterizer_and_pixel_backend_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set RasterizerAndPixelBackend";
    metric_set->symbol_name = "RasterizerAndPixelBackend";
    metric_set->hw_config_guid = "5cda6ba5-f3b7-43a4-8027-8d0958a263c4";
    metric_set->counters = calloc(44, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(81, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(11, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(5, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x120A03E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x140C0500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x120F03E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14110500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10136000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1213001C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16140000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10160018 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x101A0018 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C045400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E045545 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E051000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08051000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2406DF00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x26060007 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02084000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04098000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06094000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000A0C40 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020C0B80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080C0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040D1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060E2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080E1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020F0031 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04110017 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08110000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18120C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0613092F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08134025 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C130000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0413A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00148066 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10140000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0614C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08144000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A144000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x161500E8 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04158000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08158000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08161000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08184000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12190100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1A0020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x081A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1C1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x121D0400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1F3000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1F0061 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x301F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x501F4904 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x521F0024 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3A1F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4E1F2400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3E1F5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x461F4040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x481F0030 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x401F4010 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x421F3000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x441F4023 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x70800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000038 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFF8 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FFF7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FFEF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = ehl__rasterizer_and_pixel_backend__avg_gpu_core_frequency__read;
    counter->max_uint64 = ehl__rasterizer_and_pixel_backend__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__rasterizer_and_pixel_backend__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__rasterizer_and_pixel_backend__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__rasterizer_and_pixel_backend__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__rasterizer_and_pixel_backend__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__rasterizer_and_pixel_backend__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__rasterizer_and_pixel_backend__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SQ is full";
    counter->symbol_name = "GTRequestQueueFull";
    counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__rasterizer_and_pixel_backend__gt_request_queue_full__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__rasterizer_and_pixel_backend__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = ehl__rasterizer_and_pixel_backend__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = ehl__rasterizer_and_pixel_backend__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__rasterizer_and_pixel_backend__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__rasterizer_and_pixel_backend__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__rasterizer_and_pixel_backend__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = ehl__rasterizer_and_pixel_backend__l3_shader_throughput__read;
    counter->max_uint64 = ehl__rasterizer_and_pixel_backend__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Slice0 Pipe0 PS Output Available";
    counter->symbol_name = "PSOutput00Available";
    counter->desc = "The percentage of time in which slice0 pipe0 PS output is available";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__rasterizer_and_pixel_backend__ps_output00_available__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Slice0 Pipe1 PS Output Available";
    counter->symbol_name = "PSOutput01Available";
    counter->desc = "The percentage of time in which slice0 pipe1 PS output is available";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__rasterizer_and_pixel_backend__ps_output01_available__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Slice0 Pipe0 Post-EarlyZ Pixel Data Ready";
    counter->symbol_name = "PixelData00Ready";
    counter->desc = "The percentage of time in which slice0  pipe0 post-EarlyZ pixel data is ready (after early Z tests have been applied)";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__rasterizer_and_pixel_backend__pixel_data00_ready__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Slice0 Pipe1 Post-EarlyZ Pixel Data Ready";
    counter->symbol_name = "PixelData01Ready";
    counter->desc = "The percentage of time in which slice0  pipe1 post-EarlyZ pixel data is ready (after early Z tests have been applied)";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__rasterizer_and_pixel_backend__pixel_data01_ready__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Slice0 Pipe0 Pixel Values Ready";
    counter->symbol_name = "PixelValues00Ready";
    counter->desc = "The percentage of time in which slice0 pipe0 pixel values are ready";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__rasterizer_and_pixel_backend__pixel_values00_ready__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Slice0 Pipe1 Pixel Values Ready";
    counter->symbol_name = "PixelValues01Ready";
    counter->desc = "The percentage of time in which slice0 pipe1 pixel values are ready";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__rasterizer_and_pixel_backend__pixel_values01_ready__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__rasterizer_and_pixel_backend__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__rasterizer_and_pixel_backend__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__rasterizer_and_pixel_backend__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__rasterizer_and_pixel_backend__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__rasterizer_and_pixel_backend__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__rasterizer_and_pixel_backend__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__rasterizer_and_pixel_backend__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Rasterizer Input Available";
        counter->symbol_name = "Rasterizer0InputAvailable";
        counter->desc = "The percentage of time in which slice0 rasterizer input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__rasterizer_and_pixel_backend__rasterizer0_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Rasterizer");
    }

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Rasterizer Output Ready";
        counter->symbol_name = "Rasterizer0OutputReady";
        counter->desc = "The percentage of time in which slice0 rasterizer output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__rasterizer_and_pixel_backend__rasterizer0_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Rasterizer");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = ehl__rasterizer_and_pixel_backend__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = ehl__rasterizer_and_pixel_backend__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__rasterizer_and_pixel_backend__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__rasterizer_and_pixel_backend__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__rasterizer_and_pixel_backend__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = ehl__rasterizer_and_pixel_backend__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = ehl__rasterizer_and_pixel_backend__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = ehl__rasterizer_and_pixel_backend__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = ehl__rasterizer_and_pixel_backend__slm_bytes_read__read;
    counter->max_uint64 = ehl__rasterizer_and_pixel_backend__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = ehl__rasterizer_and_pixel_backend__slm_bytes_written__read;
    counter->max_uint64 = ehl__rasterizer_and_pixel_backend__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__rasterizer_and_pixel_backend__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__rasterizer_and_pixel_backend__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__rasterizer_and_pixel_backend__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__rasterizer_and_pixel_backend__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 44);
}

static void
ehl_add_l3_1_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set L3_1";
    metric_set->symbol_name = "L3_1";
    metric_set->hw_config_guid = "834bfd76-48d7-4552-81fa-ba1f21d6014c";
    metric_set->counters = calloc(44, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(69, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(5, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(5, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17340000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17740000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17B40000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17F40000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16340000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16740000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16B40000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16F40000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07340017 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x27340000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09740017 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x27740000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0BB40017 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x27B40000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0DF40017 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x27F40000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0000A7 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08012000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A034000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C038000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C340017 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x26340000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E740017 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x26740000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02B40017 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x26B40000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04F40017 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x26F40000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10040200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E040055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14050070 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04058000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06056000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A051000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x260600C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x24067E00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02074000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04078000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06124000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08124000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A124000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C124000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04138000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06137000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0414C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06144000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1F3000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2A1F0061 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x521F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x541F0024 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3A1F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4E1F2460 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x501F0124 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4C1F0133 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x301F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x401F6060 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x421F0010 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x441F0000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = ehl__l3_1__avg_gpu_core_frequency__read;
    counter->max_uint64 = ehl__l3_1__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__l3_1__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__l3_1__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__l3_1__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_1__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_1__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_1__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SQ is full";
    counter->symbol_name = "GTRequestQueueFull";
    counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_1__gt_request_queue_full__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_1__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = ehl__l3_1__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = ehl__l3_1__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__l3_1__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__l3_1__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__l3_1__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank0 Active";
        counter->symbol_name = "L30Bank0Active";
        counter->desc = "The percentage of time in which slice0 L3 bank0 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__l3_1__l30_bank0_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank1 Active";
        counter->symbol_name = "L30Bank1Active";
        counter->desc = "The percentage of time in which slice0 L3 bank1 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__l3_1__l30_bank1_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank2 Active";
        counter->symbol_name = "L30Bank2Active";
        counter->desc = "The percentage of time in which slice0 L3 bank2 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__l3_1__l30_bank2_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank3 Active";
        counter->symbol_name = "L30Bank3Active";
        counter->desc = "The percentage of time in which slice0 L3 bank3 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__l3_1__l30_bank3_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank4 Active";
        counter->symbol_name = "L30Bank4Active";
        counter->desc = "The percentage of time in which slice0 L3 bank4 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__l3_1__l30_bank4_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank5 Active";
        counter->symbol_name = "L30Bank5Active";
        counter->desc = "The percentage of time in which slice0 L3 bank5 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__l3_1__l30_bank5_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank6 Active";
        counter->symbol_name = "L30Bank6Active";
        counter->desc = "The percentage of time in which slice0 L3 bank6 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__l3_1__l30_bank6_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank7 Active";
        counter->symbol_name = "L30Bank7Active";
        counter->desc = "The percentage of time in which slice0 L3 bank7 is active";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__l3_1__l30_bank7_active__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = ehl__l3_1__l3_shader_throughput__read;
    counter->max_uint64 = ehl__l3_1__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__l3_1__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_1__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_1__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_1__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_1__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__l3_1__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__l3_1__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = ehl__l3_1__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = ehl__l3_1__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__l3_1__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__l3_1__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__l3_1__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = ehl__l3_1__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = ehl__l3_1__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = ehl__l3_1__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = ehl__l3_1__slm_bytes_read__read;
    counter->max_uint64 = ehl__l3_1__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = ehl__l3_1__slm_bytes_written__read;
    counter->max_uint64 = ehl__l3_1__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_1__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_1__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_1__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__l3_1__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 44);
}

static void
ehl_add_l3_2_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Gen11 L2Bank0 stalled metric set";
    metric_set->symbol_name = "L3_2";
    metric_set->hw_config_guid = "f3da54bc-da93-4008-bafc-daebdd79ab40";
    metric_set->counters = calloc(29, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(27, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(13, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(6, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10050C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12050002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00050025 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06050900 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080508EA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0508AB };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C050A21 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E050A60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04050000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14050000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x24068100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x260600FF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x301F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x501F4800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x521F4924 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x541F0024 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3E1F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x461F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x481F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4A1F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4C1F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4E1F0000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000022 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFF8 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00000082 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FFE7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000402 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FF1F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00001002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FCFF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00008003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00011010 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00050012 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00052051 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00000053 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = ehl__l3_2__avg_gpu_core_frequency__read;
    counter->max_uint64 = ehl__l3_2__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__l3_2__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__l3_2__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__l3_2__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_2__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_2__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_2__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Thread Occupancy";
    counter->symbol_name = "EuThreadOccupancy";
    counter->desc = "The percentage of time in which hardware threads occupied EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_2__eu_thread_occupancy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_2__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = ehl__l3_2__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = ehl__l3_2__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__l3_2__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__l3_2__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__l3_2__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank0 Stalled";
        counter->symbol_name = "L30Bank0Stalled";
        counter->desc = "The percentage of time in which slice0 L3 bank0 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__l3_2__l30_bank0_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__l3_2__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_2__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_2__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_2__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_2__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__l3_2__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__l3_2__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__l3_2__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__l3_2__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__l3_2__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_2__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_2__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_2__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__l3_2__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 29);
}

static void
ehl_add_l3_3_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Gen11 L2Bank1 stalled metric set";
    metric_set->symbol_name = "L3_3";
    metric_set->hw_config_guid = "fb4664db-4a4b-4d45-8f38-ceab6eac078c";
    metric_set->counters = calloc(29, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(27, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(13, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(6, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10050400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12050000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00050025 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06050900 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080508EA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0508AB };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C050A21 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E050A60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04050000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14050000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x24068100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x260600FF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x301F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x501F4800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x521F4924 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x541F0024 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3E1F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x461F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x481F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4A1F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4C1F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4E1F0000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000022 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFF8 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00000082 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FFE7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000402 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FF1F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00001002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FCFF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00008003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00011010 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00050012 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00052051 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00000053 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = ehl__l3_3__avg_gpu_core_frequency__read;
    counter->max_uint64 = ehl__l3_3__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__l3_3__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__l3_3__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__l3_3__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_3__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_3__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_3__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Thread Occupancy";
    counter->symbol_name = "EuThreadOccupancy";
    counter->desc = "The percentage of time in which hardware threads occupied EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_3__eu_thread_occupancy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_3__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = ehl__l3_3__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = ehl__l3_3__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__l3_3__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__l3_3__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__l3_3__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank1 Stalled";
        counter->symbol_name = "L30Bank1Stalled";
        counter->desc = "The percentage of time in which slice0 L3 bank1 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__l3_3__l30_bank1_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__l3_3__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_3__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_3__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_3__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_3__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__l3_3__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__l3_3__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__l3_3__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__l3_3__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__l3_3__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_3__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_3__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_3__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__l3_3__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 29);
}

static void
ehl_add_l3_4_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Gen11 L2Bank4 stalled metric set";
    metric_set->symbol_name = "L3_4";
    metric_set->hw_config_guid = "0092ff25-7595-4671-b21a-d7d94a19a38b";
    metric_set->counters = calloc(29, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(56, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(13, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(6, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10010C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12010002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C000400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E005500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10000155 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00010025 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06010900 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080108EA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0108AB };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C010A21 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E010A60 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04010000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14010000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C040400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E045500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10040155 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04051000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A054000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14050055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x24068100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x260600FF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00124000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E124000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18125540 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A120015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04131000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06138000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0813F000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A13F000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00144000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0814C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A14C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C14C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E14C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16152AA8 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18150005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x301F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x501F4800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x521F4924 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x541F0024 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3E1F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x461F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x481F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4A1F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4C1F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4E1F0000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000022 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFF8 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00000082 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FFE7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000402 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FF1F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00001002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FCFF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00008003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00011010 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00050012 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00052051 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00000053 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = ehl__l3_4__avg_gpu_core_frequency__read;
    counter->max_uint64 = ehl__l3_4__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__l3_4__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__l3_4__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__l3_4__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_4__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_4__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_4__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Thread Occupancy";
    counter->symbol_name = "EuThreadOccupancy";
    counter->desc = "The percentage of time in which hardware threads occupied EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_4__eu_thread_occupancy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_4__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = ehl__l3_4__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = ehl__l3_4__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__l3_4__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__l3_4__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__l3_4__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank4 Stalled";
        counter->symbol_name = "L30Bank4Stalled";
        counter->desc = "The percentage of time in which slice0 L3 bank4 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__l3_4__l30_bank4_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__l3_4__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_4__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_4__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_4__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_4__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__l3_4__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__l3_4__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__l3_4__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__l3_4__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__l3_4__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_4__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_4__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_4__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__l3_4__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 29);
}

static void
ehl_add_l3_5_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Gen11 L2Bank5 stalled metric set";
    metric_set->symbol_name = "L3_5";
    metric_set->hw_config_guid = "079c833a-21cb-4832-bc9a-3ea6fc42f516";
    metric_set->counters = calloc(29, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(56, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(13, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(6, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10010400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12010000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C000400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E005500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10000155 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00010022 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06010840 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08010828 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A010969 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C010AA4 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E010AE3 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04010000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14010000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C040400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E045500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10040155 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04051000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A054000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14050055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x24068100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x260600FF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00124000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E124000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18125540 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A120015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04131000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06138000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0813F000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A13F000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00144000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0814C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A14C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C14C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E14C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16152AA8 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18150005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x301F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x501F4800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x521F4924 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x541F0024 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3E1F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x461F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x481F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4A1F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4C1F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4E1F0000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000022 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFF8 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00000082 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FFE7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000402 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FF1F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00001002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FCFF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00008003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00011010 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00050012 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00052051 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00000053 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = ehl__l3_5__avg_gpu_core_frequency__read;
    counter->max_uint64 = ehl__l3_5__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__l3_5__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__l3_5__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__l3_5__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_5__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_5__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_5__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Thread Occupancy";
    counter->symbol_name = "EuThreadOccupancy";
    counter->desc = "The percentage of time in which hardware threads occupied EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_5__eu_thread_occupancy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_5__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = ehl__l3_5__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = ehl__l3_5__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__l3_5__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__l3_5__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__l3_5__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank5 Stalled";
        counter->symbol_name = "L30Bank5Stalled";
        counter->desc = "The percentage of time in which slice0 L3 bank5 is stalled";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__l3_5__l30_bank5_stalled__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__l3_5__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_5__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_5__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_5__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_5__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__l3_5__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__l3_5__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__l3_5__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__l3_5__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__l3_5__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_5__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_5__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__l3_5__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__l3_5__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 29);
}

static void
ehl_add_sampler_1_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set Sampler 1";
    metric_set->symbol_name = "Sampler_1";
    metric_set->hw_config_guid = "bf151068-b27b-4851-b46c-627c132f1cb4";
    metric_set->counters = calloc(43, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(160, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(21, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(5, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x142A0165 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x142F0165 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x146A0165 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x146F0165 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14AA0165 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14AF0165 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14EA0165 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14EF0165 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x161E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1E1800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06204000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08204000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A204000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C204000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16218000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18218000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E210018 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042A1800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062AC038 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x102A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082AC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022F2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042F0048 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x102F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E5E0030 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x125E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x145E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A604000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C600001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02604000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04604000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E613000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12618000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14618000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x006A1800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x026A0038 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6A00F0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x046A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x186C5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x026C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x046C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E6F2440 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E9E000F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1AA01540 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1EA10F00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CAA1C30 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10AA0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18AAF000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1AAA0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18AC0550 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AAF2440 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10AF0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1AAF0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10DE8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1CDEE000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00E04000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EE04000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18E04000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1AE00010 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10E18000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1EE100E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08EA1C30 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10EA0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00EAC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EEAC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18EA0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00EC4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EEC4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18EC0005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00EF0040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06EF2400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10EF0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EEF0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C045400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E045555 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10040155 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14050055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2406FF00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x260600FF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E08A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00088000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02082000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14090050 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04094000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06091000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040E1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0E4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0E5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1812FC00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A12002B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0813C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A13F000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04136000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A14C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C14C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E14C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02144000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00158000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E158000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16152AD0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18150005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0615C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0815C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A15C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C15C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02188000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0418A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06182000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A198000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C19A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E192000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1CA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1CA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x121D5400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141D0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x301F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x501F4924 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x521F4924 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x541F0024 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3A1F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4E1F2400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3E1F3000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x461F4030 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x481F0040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4A1F1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4C1F0010 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x401F1010 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x421F3030 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x441F4040 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000018 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFFC };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00000060 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FFF3 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000180 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FFCF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00000600 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FF3F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00001800 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FCFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00006000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000F3FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x00018000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000CFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x00060000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x00003FFF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = ehl__sampler_1__avg_gpu_core_frequency__read;
    counter->max_uint64 = ehl__sampler_1__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__sampler_1__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__sampler_1__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__sampler_1__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__sampler_1__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__sampler_1__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__sampler_1__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__sampler_1__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = ehl__sampler_1__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = ehl__sampler_1__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__sampler_1__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__sampler_1__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__sampler_1__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = ehl__sampler_1__l3_shader_throughput__read;
    counter->max_uint64 = ehl__sampler_1__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__sampler_1__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__sampler_1__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__sampler_1__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__sampler_1__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__sampler_1__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__sampler_1__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__sampler_1__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice0 Input Available";
        counter->symbol_name = "Sampler00InputAvailable";
        counter->desc = "The percentage of time in which slice0 subslice0 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__sampler_1__sampler00_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice1 Input Available";
        counter->symbol_name = "Sampler01InputAvailable";
        counter->desc = "The percentage of time in which slice0 subslice1 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__sampler_1__sampler01_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice2 Input Available";
        counter->symbol_name = "Sampler02InputAvailable";
        counter->desc = "The percentage of time in which slice0 subslice2 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__sampler_1__sampler02_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 8) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice3 Input Available";
        counter->symbol_name = "Sampler03InputAvailable";
        counter->desc = "The percentage of time in which slice0 subslice3 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__sampler_1__sampler03_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 16) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice4 Input Available";
        counter->symbol_name = "Sampler04InputAvailable";
        counter->desc = "The percentage of time in which slice0 subslice4 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__sampler_1__sampler04_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 32) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice5 Input Available";
        counter->symbol_name = "Sampler05InputAvailable";
        counter->desc = "The percentage of time in which slice0 subslice5 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__sampler_1__sampler05_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 64) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice6 Input Available";
        counter->symbol_name = "Sampler06InputAvailable";
        counter->desc = "The percentage of time in which slice0 subslice6 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__sampler_1__sampler06_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 128) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice7 Input Available";
        counter->symbol_name = "Sampler07InputAvailable";
        counter->desc = "The percentage of time in which slice0 subslice7 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__sampler_1__sampler07_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = ehl__sampler_1__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = ehl__sampler_1__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__sampler_1__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__sampler_1__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__sampler_1__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = ehl__sampler_1__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = ehl__sampler_1__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = ehl__sampler_1__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = ehl__sampler_1__slm_bytes_read__read;
    counter->max_uint64 = ehl__sampler_1__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = ehl__sampler_1__slm_bytes_written__read;
    counter->max_uint64 = ehl__sampler_1__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__sampler_1__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__sampler_1__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__sampler_1__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__sampler_1__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 43);
}

static void
ehl_add_sampler_2_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set Sampler 2";
    metric_set->symbol_name = "Sampler_2";
    metric_set->hw_config_guid = "5e64ae48-92a7-49b3-b7d8-af36b32ee866";
    metric_set->counters = calloc(44, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(122, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(5, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(5, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x142D0005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14320005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x146D0005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14720005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14AD0005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14B20005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14ED0005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14F20005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E1E0030 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A204000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C200001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E213000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A2A00C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x182C6000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2D0033 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022D0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A2F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C300008 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E318000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E321980 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02320000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x125E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x145E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02604000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04604000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12618000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14618000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x046AC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x026C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x046C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x006D1980 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x026D0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x046F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14708000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02714000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02720033 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x169E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x189E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06A04000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08A04000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16A18000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18A18000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08AAC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06AC8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08AC4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02AD1980 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08AF8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18B04000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04B14000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04B20033 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02B20000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1CDE1800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AE04000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CE04000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1EE10018 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CEAC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AEC8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CEC4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04ED1980 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02ED0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CEF8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1AF00400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06F14000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06F20033 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02F20000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10040140 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C045000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E040055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14050050 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04054000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A051000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x260600C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x24067E00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00088000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02082000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04094000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06091000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080E4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0E1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0612C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0812C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0413E000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06131000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0214C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04144000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1815000F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A158000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C158000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E18A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14190028 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041C2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1F3000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2A1F0061 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x521F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x541F0024 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3A1F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4E1F2430 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x501F0124 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4C1F0137 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x301F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x401F0040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x421F0040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x441F3001 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = ehl__sampler_2__avg_gpu_core_frequency__read;
    counter->max_uint64 = ehl__sampler_2__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__sampler_2__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__sampler_2__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__sampler_2__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__sampler_2__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__sampler_2__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__sampler_2__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SQ is full";
    counter->symbol_name = "GTRequestQueueFull";
    counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__sampler_2__gt_request_queue_full__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__sampler_2__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = ehl__sampler_2__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = ehl__sampler_2__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__sampler_2__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__sampler_2__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__sampler_2__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = ehl__sampler_2__l3_shader_throughput__read;
    counter->max_uint64 = ehl__sampler_2__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__sampler_2__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__sampler_2__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__sampler_2__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__sampler_2__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__sampler_2__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__sampler_2__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__sampler_2__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice0 Sampler Output Ready";
        counter->symbol_name = "Sampler00OutputReady";
        counter->desc = "The percentage of time in which slice0 subslice0 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__sampler_2__sampler00_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice1 Sampler Output Ready";
        counter->symbol_name = "Sampler01OutputReady";
        counter->desc = "The percentage of time in which slice0 subslice1 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__sampler_2__sampler01_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice2 Sampler Output Ready";
        counter->symbol_name = "Sampler02OutputReady";
        counter->desc = "The percentage of time in which slice0 subslice2 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__sampler_2__sampler02_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 8) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice3 Sampler Output Ready";
        counter->symbol_name = "Sampler03OutputReady";
        counter->desc = "The percentage of time in which slice0 subslice3 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__sampler_2__sampler03_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 16) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice4 Sampler Output Ready";
        counter->symbol_name = "Sampler04OutputReady";
        counter->desc = "The percentage of time in which slice0 subslice4 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__sampler_2__sampler04_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 32) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice5 Sampler Output Ready";
        counter->symbol_name = "Sampler05OutputReady";
        counter->desc = "The percentage of time in which slice0 subslice5 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__sampler_2__sampler05_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 64) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice6 Sampler Output Ready";
        counter->symbol_name = "Sampler06OutputReady";
        counter->desc = "The percentage of time in which slice0 subslice6 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__sampler_2__sampler06_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 128) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Subslice7 Sampler Output Ready";
        counter->symbol_name = "Sampler07OutputReady";
        counter->desc = "The percentage of time in which slice0 subslice7 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__sampler_2__sampler07_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = ehl__sampler_2__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = ehl__sampler_2__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__sampler_2__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__sampler_2__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__sampler_2__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = ehl__sampler_2__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = ehl__sampler_2__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = ehl__sampler_2__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = ehl__sampler_2__slm_bytes_read__read;
    counter->max_uint64 = ehl__sampler_2__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = ehl__sampler_2__slm_bytes_written__read;
    counter->max_uint64 = ehl__sampler_2__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__sampler_2__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__sampler_2__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__sampler_2__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__sampler_2__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 44);
}

static void
ehl_add_tdl_1_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set TDL_1";
    metric_set->symbol_name = "TDL_1";
    metric_set->hw_config_guid = "d1725c84-80c6-4488-9867-82b44c88fea6";
    metric_set->counters = calloc(51, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(163, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(21, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14290000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x142E0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14690000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x146E0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14A90000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14AE0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14E90000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14EE0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x161E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1E1800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06204000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08204000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A204000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C204000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16218000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18218000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E210018 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0429C300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062900C5 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10290000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062AC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082AC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2A4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2A4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A2C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C2C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x022EC300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x042E00C5 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x102E0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x062F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E5E0030 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x125E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x145E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A604000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C600001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02604000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04604000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E613000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12618000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14618000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0069C300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x026900C5 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10690000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6A00F0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x026A4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x046A4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x186C5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x026C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x046C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E6EC5C3 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106E0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6F5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E9E000F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1AA01540 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1EA10F00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CA9C5C3 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10A90000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18AAF000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1AAA0005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18AC0550 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AAEC5C3 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10AE0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1AAF0050 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10DE8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1CDEE000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00E04000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EE04000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18E04000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1AE00010 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10E18000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1EE100E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08E9C5C3 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10E90000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00EAC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EEAC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18EA0500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00EC4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EEC4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18EC0005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00EE00C3 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06EEC500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10EE0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00EF4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EEF4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C045400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E045555 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10040155 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14050055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2406FF00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x260600FF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E08A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00088000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02082000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14090050 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04094000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06091000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040E1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0E4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0E5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1812FC00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A12002B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0813C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A13F000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04136000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A14C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C14C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E14C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02144000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00158000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E158000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16152AD0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18150005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0615C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0815C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A15C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C15C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02188000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0418A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06182000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A198000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C19A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E192000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1CA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C1CA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x121D5400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141D0002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x301F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x501F4924 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x521F4924 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x541F0024 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3A1F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4E1F2400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3E1F3000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x461F4030 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x481F0040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4A1F1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4C1F0010 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x401F1010 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x421F3030 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x441F4040 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000018 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFFC };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00000060 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FFF3 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000180 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FFCF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00000600 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FF3F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00001800 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FCFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00006000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000F3FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x00018000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000CFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x00060000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x00003FFF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00015014 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0x00055054 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = ehl__tdl_1__avg_gpu_core_frequency__read;
    counter->max_uint64 = ehl__tdl_1__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__tdl_1__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__tdl_1__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__tdl_1__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__tdl_1__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__tdl_1__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__tdl_1__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__tdl_1__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = ehl__tdl_1__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = ehl__tdl_1__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__tdl_1__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__tdl_1__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__tdl_1__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = ehl__tdl_1__l3_shader_throughput__read;
    counter->max_uint64 = ehl__tdl_1__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice0 Subslice0 Thread Dispatcher";
        counter->symbol_name = "PSThread00ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice0 subslice0 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__tdl_1__ps_thread00_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice0 Subslice1 Thread Dispatcher";
        counter->symbol_name = "PSThread01ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice0 subslice1 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__tdl_1__ps_thread01_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice0 Subslice2 Thread Dispatcher";
        counter->symbol_name = "PSThread02ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice0 subslice2 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__tdl_1__ps_thread02_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 8) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice0 Subslice3 Thread Dispatcher";
        counter->symbol_name = "PSThread03ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice0 subslice3 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__tdl_1__ps_thread03_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 16) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice0 Subslice4 Thread Dispatcher";
        counter->symbol_name = "PSThread04ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice0 subslice4 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__tdl_1__ps_thread04_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 32) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice0 Subslice5 Thread Dispatcher";
        counter->symbol_name = "PSThread05ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice0 subslice5 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__tdl_1__ps_thread05_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 64) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice0 Subslice6 Thread Dispatcher";
        counter->symbol_name = "PSThread06ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice0 subslice6 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__tdl_1__ps_thread06_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 128) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice0 Subslice7 Thread Dispatcher";
        counter->symbol_name = "PSThread07ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice0 subslice7 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__tdl_1__ps_thread07_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__tdl_1__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS EU Active";
    counter->symbol_name = "PsEuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__tdl_1__ps_eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS AVG Active per Thread";
    counter->symbol_name = "PsEuActivePerThread";
    counter->desc = "The average number of cycles per hardware thread run in which fragment shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = ehl__tdl_1__ps_eu_active_per_thread__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__tdl_1__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS EU Stall";
    counter->symbol_name = "PsEuStall";
    counter->desc = "The percentage of time in which fragment shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__tdl_1__ps_eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS AVG Stall per Thread";
    counter->symbol_name = "PsEuStallPerThread";
    counter->desc = "The average number of cycles per hardware thread run in which fragment shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = ehl__tdl_1__ps_eu_stall_per_thread__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__tdl_1__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__tdl_1__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__tdl_1__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__tdl_1__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__tdl_1__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = ehl__tdl_1__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = ehl__tdl_1__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__tdl_1__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__tdl_1__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__tdl_1__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = ehl__tdl_1__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = ehl__tdl_1__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = ehl__tdl_1__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = ehl__tdl_1__slm_bytes_read__read;
    counter->max_uint64 = ehl__tdl_1__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = ehl__tdl_1__slm_bytes_written__read;
    counter->max_uint64 = ehl__tdl_1__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS EU Active";
    counter->symbol_name = "VsEuActive";
    counter->desc = "The percentage of time in which vertex shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__tdl_1__vs_eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS AVG Active per Thread";
    counter->symbol_name = "VsEuActivePerThread";
    counter->desc = "The average number of cycles per hardware thread run in which vertex shaders were processed actively on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = ehl__tdl_1__vs_eu_active_per_thread__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS EU Stall";
    counter->symbol_name = "VsEuStall";
    counter->desc = "The percentage of time in which vertex shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__tdl_1__vs_eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS AVG Stall per Thread";
    counter->symbol_name = "VsEuStallPerThread";
    counter->desc = "The average number of cycles per hardware thread run in which vertex shaders were stalled on the EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = ehl__tdl_1__vs_eu_stall_per_thread__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__tdl_1__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__tdl_1__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__tdl_1__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__tdl_1__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 51);
}

static void
ehl_add_tdl_2_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set TDL_2";
    metric_set->symbol_name = "TDL_2";
    metric_set->hw_config_guid = "47e27fcf-9904-4fc0-a661-636dffeafe7d";
    metric_set->counters = calloc(44, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(115, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(5, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(5, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14290000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x142E0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14690000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x146E0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14A90000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14AE0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14E90000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14EE0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E1E0018 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A205000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E211800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C29C100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10290000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A2A0034 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x182C1400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2E00C1 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x102E0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A2F1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E5E0020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x125E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C600001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02604000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E612000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12618000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E69C100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10690000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6A0040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x026AC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x186C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x026C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x006EC100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106E0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x026F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x149E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x169E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04A04000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06A04000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14A18000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16A18000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02A900C1 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10A90000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04AA4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06AAC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04AC4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06AC4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02AEC100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10AE0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06AF4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18DE8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1CDE0800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08E04000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AE04000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18E18000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1EE10008 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04E900C1 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10E90000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08EA4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AEAC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08EC4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AEC4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04EEC100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10EE0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AEF4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10040150 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C045000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E040015 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14050054 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04054000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x260600E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x24063E00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E088000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00088000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14090040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04094000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080E5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A120020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0412C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0612C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A138000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0413E000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0214C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16156000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18150007 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08158000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A158000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C188000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E182000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1419000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021CA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1F3061 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x521F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x541F0024 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3A1F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4E1F2410 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x501F0024 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4C1F3040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x301F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x401F1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x421F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x441F1730 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = ehl__tdl_2__avg_gpu_core_frequency__read;
    counter->max_uint64 = ehl__tdl_2__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__tdl_2__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__tdl_2__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__tdl_2__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__tdl_2__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__tdl_2__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__tdl_2__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SQ is full";
    counter->symbol_name = "GTRequestQueueFull";
    counter->desc = "The percentage of time when SQ is filled above a threshold (usually 48 entries)";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__tdl_2__gt_request_queue_full__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__tdl_2__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = ehl__tdl_2__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = ehl__tdl_2__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__tdl_2__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__tdl_2__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__tdl_2__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = ehl__tdl_2__l3_shader_throughput__read;
    counter->max_uint64 = ehl__tdl_2__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Non-PS Thread Ready For Dispatch on Slice0 Subslice0 Thread Dispatcher";
        counter->symbol_name = "NonPSThread00ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice0 subslice0 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__tdl_2__non_ps_thread00_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Non-PS Thread Ready For Dispatch on Slice0 Subslice1 Thread Dispatcher";
        counter->symbol_name = "NonPSThread01ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice0 subslice1 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__tdl_2__non_ps_thread01_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Non-PS Thread Ready For Dispatch on Slice0 Subslice2 Thread Dispatcher";
        counter->symbol_name = "NonPSThread02ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice0 subslice2 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__tdl_2__non_ps_thread02_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 8) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Non-PS Thread Ready For Dispatch on Slice0 Subslice3 Thread Dispatcher";
        counter->symbol_name = "NonPSThread03ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice0 subslice3 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__tdl_2__non_ps_thread03_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 16) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Non-PS Thread Ready For Dispatch on Slice0 Subslice4 Thread Dispatcher";
        counter->symbol_name = "NonPSThread04ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice0 subslice4 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__tdl_2__non_ps_thread04_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 32) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Non-PS Thread Ready For Dispatch on Slice0 Subslice5 Thread Dispatcher";
        counter->symbol_name = "NonPSThread05ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice0 subslice5 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__tdl_2__non_ps_thread05_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 64) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Non-PS Thread Ready For Dispatch on Slice0 Subslice6 Thread Dispatcher";
        counter->symbol_name = "NonPSThread06ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice0 subslice6 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__tdl_2__non_ps_thread06_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 128) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Non-PS Thread Ready For Dispatch on Slice0 Subslice7 Thread Dispatcher";
        counter->symbol_name = "NonPSThread07ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice0 subslice7 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__tdl_2__non_ps_thread07_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__tdl_2__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__tdl_2__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__tdl_2__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__tdl_2__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__tdl_2__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__tdl_2__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__tdl_2__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = ehl__tdl_2__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = ehl__tdl_2__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__tdl_2__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__tdl_2__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__tdl_2__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = ehl__tdl_2__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = ehl__tdl_2__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = ehl__tdl_2__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = ehl__tdl_2__slm_bytes_read__read;
    counter->max_uint64 = ehl__tdl_2__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = ehl__tdl_2__slm_bytes_written__read;
    counter->max_uint64 = ehl__tdl_2__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__tdl_2__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__tdl_2__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__tdl_2__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__tdl_2__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 44);
}

static void
ehl_add_tdl_3_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set TDL_3";
    metric_set->symbol_name = "TDL_3";
    metric_set->hw_config_guid = "98154f5e-cf17-423c-a096-e696f87c2906";
    metric_set->counters = calloc(51, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(171, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(5, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(5, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14292C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16290013 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x142E2C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x162E0013 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14692C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16690013 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x146E2C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x166E0013 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14A92C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16A90013 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14AE2C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16AE0013 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14E92C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16E90013 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14EE2C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16EE0013 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x101E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C1EE000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00204000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E204000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18204000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A200010 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10218000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E2100E0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002900C7 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0629CF00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10290000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002A4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2A4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x182A0F00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x002C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E2C4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x182C0005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x082ECFC7 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x102E0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A2F0005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E5E000F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A601540 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E610F00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A69CFC7 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10690000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x186A5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6A000F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x186C0550 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C6ECFC7 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x106E0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A6F0500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E9E0030 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x129E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x149E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1AA04000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1CA00001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02A04000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04A04000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1EA13000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12A18000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14A18000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EA9CFC7 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10A90000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1AAA0050 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02AAC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04AAC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18AC5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02AC4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04AC4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00AEC700 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02AE00CF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10AE0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02AF4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04AF4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16DE8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18DE8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1CDE1800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06E04000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08E04000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AE04000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CE04000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16E18000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18E18000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1EE10018 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02E9C700 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04E900CF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10E90000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06EA4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08EA4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AEAC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CEAC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06EC4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08EC4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AEC4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CEC4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04EEC700 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06EE00CF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10EE0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AEF4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CEF4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C045400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E045555 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10040155 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14050055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2406FF00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x260600FF };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A08A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C08A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E095000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14090005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060E4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080E5000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0E1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1812A800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A12003E };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0212C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0412C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0813C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A13F000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04136000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A14C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C14C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E14C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02144000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0015C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E15C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16152AF8 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18150005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04154000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06158000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08158000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A158000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C158000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00182000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06188000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0818A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08192000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E198000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12190140 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E1CA000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x001C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021C2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141D0028 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x081D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A1D2000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x301F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x501F4924 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x521F4924 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x541F0024 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3A1F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4E1F2410 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3E1F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x461F3040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x481F1030 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4A1F0010 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4C1F1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x401F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x421F4040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x441F3030 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = ehl__tdl_3__avg_gpu_core_frequency__read;
    counter->max_uint64 = ehl__tdl_3__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__tdl_3__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__tdl_3__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__tdl_3__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__tdl_3__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Both FPU Pipes Active";
    counter->symbol_name = "EuFpuBothActive";
    counter->desc = "The percentage of time in which both EU FPU pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__tdl_3__eu_fpu_both_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__tdl_3__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__tdl_3__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = ehl__tdl_3__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = ehl__tdl_3__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__tdl_3__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__tdl_3__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__tdl_3__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = ehl__tdl_3__l3_shader_throughput__read;
    counter->max_uint64 = ehl__tdl_3__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__tdl_3__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__tdl_3__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU0 Pipe Active";
    counter->symbol_name = "PsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__tdl_3__ps_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU1 Pipe Active";
    counter->symbol_name = "PsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__tdl_3__ps_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__tdl_3__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__tdl_3__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__tdl_3__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = ehl__tdl_3__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = ehl__tdl_3__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__tdl_3__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__tdl_3__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = ehl__tdl_3__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = ehl__tdl_3__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = ehl__tdl_3__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = ehl__tdl_3__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = ehl__tdl_3__slm_bytes_read__read;
    counter->max_uint64 = ehl__tdl_3__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = ehl__tdl_3__slm_bytes_written__read;
    counter->max_uint64 = ehl__tdl_3__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice0 Thread Dispatcher Port 0";
        counter->symbol_name = "ThreadHeader00ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice0 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__tdl_3__thread_header00_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice0 Thread Dispatcher Port 1";
        counter->symbol_name = "ThreadHeader00ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice0 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__tdl_3__thread_header00_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice1 Thread Dispatcher Port 0";
        counter->symbol_name = "ThreadHeader01ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice1 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__tdl_3__thread_header01_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice1 Thread Dispatcher Port 1";
        counter->symbol_name = "ThreadHeader01ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice1 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__tdl_3__thread_header01_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice2 Thread Dispatcher Port 0";
        counter->symbol_name = "ThreadHeader02ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice2 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__tdl_3__thread_header02_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice2 Thread Dispatcher Port 1";
        counter->symbol_name = "ThreadHeader02ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice2 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__tdl_3__thread_header02_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 8) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice3 Thread Dispatcher Port 0";
        counter->symbol_name = "ThreadHeader03ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice3 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__tdl_3__thread_header03_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 8) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice3 Thread Dispatcher Port 1";
        counter->symbol_name = "ThreadHeader03ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice3 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__tdl_3__thread_header03_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 16) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice4 Thread Dispatcher Port 0";
        counter->symbol_name = "ThreadHeader04ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice4 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__tdl_3__thread_header04_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 16) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice4 Thread Dispatcher Port 1";
        counter->symbol_name = "ThreadHeader04ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice4 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__tdl_3__thread_header04_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 32) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice5 Thread Dispatcher Port 0";
        counter->symbol_name = "ThreadHeader05ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice5 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__tdl_3__thread_header05_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 32) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice5 Thread Dispatcher Port 1";
        counter->symbol_name = "ThreadHeader05ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice5 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__tdl_3__thread_header05_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 64) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice6 Thread Dispatcher Port 0";
        counter->symbol_name = "ThreadHeader06ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice6 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__tdl_3__thread_header06_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 64) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice6 Thread Dispatcher Port 1";
        counter->symbol_name = "ThreadHeader06ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice6 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__tdl_3__thread_header06_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 128) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice7 Thread Dispatcher Port 0";
        counter->symbol_name = "ThreadHeader07ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice7 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__tdl_3__thread_header07_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 128) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 Subslice7 Thread Dispatcher Port 1";
        counter->symbol_name = "ThreadHeader07ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice0 subslice7 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = ehl__tdl_3__thread_header07_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU0 Pipe Active";
    counter->symbol_name = "VsFpu0Active";
    counter->desc = "The percentage of time in which EU FPU0 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__tdl_3__vs_fpu0_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU1 Pipe Active";
    counter->symbol_name = "VsFpu1Active";
    counter->desc = "The percentage of time in which EU FPU1 pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__tdl_3__vs_fpu1_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__tdl_3__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = ehl__tdl_3__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 51);
}

static void
ehl_add_gpu_busyness_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Gpu Rings Busyness";
    metric_set->symbol_name = "GpuBusyness";
    metric_set->hw_config_guid = "85254749-e937-4205-9b40-5df8847c9ee8";
    metric_set->counters = calloc(10, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(50, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(7, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12021200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14040120 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10002400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02020083 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10020000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00020000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06040043 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10040000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C040004 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02000023 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x22000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18008000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04194000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x081A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3A1F6000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4E1F2900 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x501F00E9 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04218000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06212000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x401F0160 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x421F0050 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x441F0100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x301F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x181B2400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x185B2400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14231200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06218000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08212000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080D8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040F4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0828C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041B8300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x221B0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1B0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x22162000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x084D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x044F1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08683000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x045B0083 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x225B0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x22560800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06230093 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x20230000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A238000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0x10800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x0007C000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x000007FF };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AnyRingBusy";
    counter->symbol_name = "AnyRingBusy";
    counter->desc = "The percentage of time when any command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__gpu_busyness__any_ring_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = ehl__gpu_busyness__avg_gpu_core_frequency__read;
    counter->max_uint64 = ehl__gpu_busyness__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Blitter Ring Busy";
    counter->symbol_name = "BlitterBusy";
    counter->desc = "The percentage of time when blitter command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__gpu_busyness__blitter_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__gpu_busyness__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = ehl__gpu_busyness__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = ehl__gpu_busyness__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Render Ring Busy";
    counter->symbol_name = "RenderBusy";
    counter->desc = "The percentage of time when render command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__gpu_busyness__render_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Vdbox0 Ring Busy";
    counter->symbol_name = "Vdbox0Busy";
    counter->desc = "The percentage of time when Vdbox0 command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__gpu_busyness__vdbox0_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Vdbox1 Ring Busy";
    counter->symbol_name = "Vdbox1Busy";
    counter->desc = "The percentage of time when Vdbox1 command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__gpu_busyness__vdbox1_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Vebox Ring Busy";
    counter->symbol_name = "VeboxBusy";
    counter->desc = "The percentage of time when vebox command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = ehl__gpu_busyness__vebox_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    assert(metric_set->n_counters <= 10);
}

static void
ehl_add_test_oa_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set TestOa";
    metric_set->symbol_name = "TestOa";
    metric_set->hw_config_guid = "9dace73d-0364-45bc-9a22-f27c2acda706";
    metric_set->counters = calloc(12, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(14, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(21, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18130000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x22000004 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E130076 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10130000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E130000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E164000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A1A0004 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x541F0001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x141F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4C1F0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x301F0000 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002740, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002710, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002714, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002720, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002724, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002770, .val = 0x00000004 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002774, .val = 0x0000FFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002778, .val = 0x00000003 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000277C, .val = 0x0000FFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002780, .val = 0x00000007 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002784, .val = 0x0000FFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002788, .val = 0x00100002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000278C, .val = 0x0000FFF7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002790, .val = 0x00100002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002794, .val = 0x0000FFCF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x00002798, .val = 0x00100082 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000279C, .val = 0x0000FFEF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A0, .val = 0x001000C2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A4, .val = 0x0000FFE7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027A8, .val = 0x00100001 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x000027AC, .val = 0x0000FFE7 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = ehl__test_oa__avg_gpu_core_frequency__read;
    counter->max_uint64 = ehl__test_oa__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter0";
    counter->symbol_name = "Counter0";
    counter->desc = "HW test counter 0. Factor: 0.0";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = ehl__test_oa__counter0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter1";
    counter->symbol_name = "Counter1";
    counter->desc = "HW test counter 1. Factor: 1.0";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = ehl__test_oa__counter1__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter2";
    counter->symbol_name = "Counter2";
    counter->desc = "HW test counter 2. Factor: 1.0";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = ehl__test_oa__counter2__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter3";
    counter->symbol_name = "Counter3";
    counter->desc = "HW test counter 3. Factor: 0.5";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = ehl__test_oa__counter3__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter4";
    counter->symbol_name = "Counter4";
    counter->desc = "HW test counter 4. Factor: 0.3333";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = ehl__test_oa__counter4__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter5";
    counter->symbol_name = "Counter5";
    counter->desc = "HW test counter 5. Factor: 0.3333";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = ehl__test_oa__counter5__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter6";
    counter->symbol_name = "Counter6";
    counter->desc = "HW test counter 6. Factor: 0.16666";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = ehl__test_oa__counter6__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter7";
    counter->symbol_name = "Counter7";
    counter->desc = "HW test counter 7. Factor: 0.6666";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = ehl__test_oa__counter7__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter8";
    counter->symbol_name = "Counter8";
    counter->desc = "HW test counter 8. Should be equal to 1.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = ehl__test_oa__counter8__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = ehl__test_oa__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = ehl__test_oa__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    assert(metric_set->n_counters <= 12);
}

static void
tgl_add_render_basic_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Render Metrics Basic Gen12";
    metric_set->symbol_name = "RenderBasic";
    metric_set->hw_config_guid = "daf004fb-fc9f-45e0-b842-1770e6d273c2";
    metric_set->counters = calloc(39, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(50, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(6, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(6, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14150001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A124000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C124000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A138000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C130100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04155100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06150050 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10150000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A150000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x34001000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x36000002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2205A000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05151D47 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09151536 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05351C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09351400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x5D102C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x5B1005BB };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B141800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x5F110500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F150137 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01150000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F168000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03164000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05164000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D350137 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03350147 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07350136 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01350000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F364000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01368000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03368000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55103130 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57100001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47103000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49103131 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B100131 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x65100002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x42000001 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D920, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D900, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D904, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D910, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D914, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC40, .val = 0x00000000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0xFFFFFFFF };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = tgl__render_basic__avg_gpu_core_frequency__read;
    counter->max_uint64 = tgl__render_basic__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__render_basic__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__render_basic__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = tgl__render_basic__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__render_basic__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU And EM Pipes Active";
    counter->symbol_name = "EuFpuEmActive";
    counter->desc = "The percentage of time in which EU FPU and EM pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__render_basic__eu_fpu_em_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__render_basic__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__render_basic__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = tgl__render_basic__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = tgl__render_basic__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__render_basic__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Read Throughput";
    counter->symbol_name = "GtiReadThroughput";
    counter->desc = "The total number of GPU memory bytes read from GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = tgl__render_basic__gti_read_throughput__read;
    counter->max_uint64 = tgl__render_basic__gti_read_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Write Throughput";
    counter->symbol_name = "GtiWriteThroughput";
    counter->desc = "The total number of GPU memory bytes written to GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = tgl__render_basic__gti_write_throughput__read;
    counter->max_uint64 = tgl__render_basic__gti_write_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = tgl__render_basic__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__render_basic__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = tgl__render_basic__l3_shader_throughput__read;
    counter->max_uint64 = tgl__render_basic__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = tgl__render_basic__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS EM Pipe Active";
    counter->symbol_name = "PsEmActive";
    counter->desc = "The percentage of time in which EU EM pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__render_basic__ps_em_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__render_basic__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU Pipe Active";
    counter->symbol_name = "PsFpuActive";
    counter->desc = "The percentage of time in which EU FPU pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__render_basic__ps_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__render_basic__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__render_basic__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = tgl__render_basic__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Samplers Bottleneck";
        counter->symbol_name = "SamplerBottleneck";
        counter->desc = "The percentage of time in which samplers have been slowing down the pipe when processing EU requests.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__render_basic__sampler_bottleneck__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = tgl__render_basic__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = tgl__render_basic__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Samplers Busy";
        counter->symbol_name = "SamplersBusy";
        counter->desc = "The percentage of time in which samplers have been processing EU requests.";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__render_basic__samplers_busy__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "Sampler");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = tgl__render_basic__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = tgl__render_basic__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = tgl__render_basic__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = tgl__render_basic__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = tgl__render_basic__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = tgl__render_basic__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = tgl__render_basic__slm_bytes_read__read;
    counter->max_uint64 = tgl__render_basic__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = tgl__render_basic__slm_bytes_written__read;
    counter->max_uint64 = tgl__render_basic__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS EM Pipe Active";
    counter->symbol_name = "VsEmActive";
    counter->desc = "The percentage of time in which EU EM pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__render_basic__vs_em_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU Pipe Active";
    counter->symbol_name = "VsFpuActive";
    counter->desc = "The percentage of time in which EU FPU pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__render_basic__vs_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__render_basic__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__render_basic__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 39);
}

static void
tgl_add_compute_basic_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Compute Metrics Basic";
    metric_set->symbol_name = "ComputeBasic";
    metric_set->hw_config_guid = "6ad92fc0-ed62-460c-b774-5353534c67ed";
    metric_set->counters = calloc(35, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(30, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(6, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(5, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05151D37 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09151547 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05351C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09351400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x5B100BBB };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D150136 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01150000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03164000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05164000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07164000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03350137 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07350147 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B350136 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01350000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01368000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03368000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05368000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x65100002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x42000001 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D920, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D900, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D904, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D910, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D914, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC40, .val = 0x00000000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00000003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00002001 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E758, .val = 0x00000008 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0xFFFFFFFF };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = tgl__compute_basic__avg_gpu_core_frequency__read;
    counter->max_uint64 = tgl__compute_basic__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__compute_basic__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__compute_basic__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = tgl__compute_basic__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EM Pipe Active";
    counter->symbol_name = "EmActive";
    counter->desc = "The percentage of time in which EU EM pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__compute_basic__em_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__compute_basic__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU AVG IPC Rate";
    counter->symbol_name = "EuAvgIpcRate";
    counter->desc = "The average rate of IPC calculated for 2 FPU pipelines.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NUMBER;
    counter->read_float = tgl__compute_basic__eu_avg_ipc_rate__read;
    counter->max_float = tgl__compute_basic__eu_avg_ipc_rate__max;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU And EM Pipes Active";
    counter->symbol_name = "EuFpuEmActive";
    counter->desc = "The percentage of time in which EU FPU and EM pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__compute_basic__eu_fpu_em_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Send Pipe Active";
    counter->symbol_name = "EuSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__compute_basic__eu_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__compute_basic__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Thread Occupancy";
    counter->symbol_name = "EuThreadOccupancy";
    counter->desc = "The percentage of time in which hardware threads occupied EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__compute_basic__eu_thread_occupancy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU Pipe Active";
    counter->symbol_name = "FpuActive";
    counter->desc = "The percentage of time in which EU FPU pipeline was actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__compute_basic__fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__compute_basic__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = tgl__compute_basic__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = tgl__compute_basic__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__compute_basic__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Read Throughput";
    counter->symbol_name = "GtiReadThroughput";
    counter->desc = "The total number of GPU memory bytes read from GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = tgl__compute_basic__gti_read_throughput__read;
    counter->max_uint64 = tgl__compute_basic__gti_read_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GTI Write Throughput";
    counter->symbol_name = "GtiWriteThroughput";
    counter->desc = "The total number of GPU memory bytes written to GTI.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = tgl__compute_basic__gti_write_throughput__read;
    counter->max_uint64 = tgl__compute_basic__gti_write_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = tgl__compute_basic__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__compute_basic__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = tgl__compute_basic__l3_shader_throughput__read;
    counter->max_uint64 = tgl__compute_basic__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = tgl__compute_basic__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__compute_basic__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = tgl__compute_basic__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = tgl__compute_basic__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = tgl__compute_basic__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = tgl__compute_basic__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = tgl__compute_basic__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = tgl__compute_basic__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = tgl__compute_basic__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = tgl__compute_basic__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = tgl__compute_basic__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = tgl__compute_basic__slm_bytes_read__read;
    counter->max_uint64 = tgl__compute_basic__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = tgl__compute_basic__slm_bytes_written__read;
    counter->max_uint64 = tgl__compute_basic__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__compute_basic__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 35);
}

static void
tgl_add_render_pipe_profile_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Render Metrics for 3D Pipeline Profile";
    metric_set->symbol_name = "RenderPipeProfile";
    metric_set->hw_config_guid = "77ae98cf-9a9e-4e35-be85-597b09ffbe53";
    metric_set->counters = calloc(42, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(143, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(6, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(1, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00123E00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060B00B3 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x140B3C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C0B0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x120C8320 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040DBE00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000D0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x280D0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2C0E7C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10087C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E120002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x20120000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E130002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0B0031 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x180B0092 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A0B00B1 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020B0093 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040B0033 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000B0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0C0022 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E0C0030 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C0C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x140C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x160C8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100DC017 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x160D0013 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C0D0081 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080D0082 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0D8102 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x140D0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0D0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x120D0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060DC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0EC1C5 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x180E0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100E4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x120EC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x140EC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x160E4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080E8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0EC000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C0F5555 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E0F0554 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E104000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10104000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14104000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16104000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18104000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A104000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C104000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02104000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04104000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06104000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08104000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A104000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C104000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E024000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10024000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2C024000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2E020055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02024000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04024000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06024000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08024000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A024000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C024000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A032000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C032000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2A035500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2C030001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02034000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04034000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06034000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08034000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A034000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18032000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x360036DB };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x380026DB };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A006000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C006000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E006000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x34001B00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x26050002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x120A4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x140A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x160A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x180A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A0A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C0A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08081000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x5B105555 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x5D101555 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B14FC00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D14003F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x5F115555 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x61111555 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D100604 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4F103400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51100200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53100004 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55101400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57100005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B100400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x65100002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x42000001 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D920, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D900, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D904, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D910, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D914, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC40, .val = 0x00000000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = tgl__render_pipe_profile__avg_gpu_core_frequency__read;
    counter->max_uint64 = tgl__render_pipe_profile__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "BC Bottleneck";
    counter->symbol_name = "BcBottleneck";
    counter->desc = "The percentage of time in which barycentric coordinates calculation pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__render_pipe_profile__bc_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Barycentric Calc");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Clipper Bottleneck";
    counter->symbol_name = "ClBottleneck";
    counter->desc = "The percentage of time in which clipper pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__render_pipe_profile__cl_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Clipper");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CL Stall";
    counter->symbol_name = "ClStall";
    counter->desc = "The percentage of time in which clipper pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__render_pipe_profile__cl_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Clipper");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__render_pipe_profile__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Bottleneck";
    counter->symbol_name = "DsBottleneck";
    counter->desc = "The percentage of time in which domain shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__render_pipe_profile__ds_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Stall";
    counter->symbol_name = "DsStall";
    counter->desc = "The percentage of time in which domain shader pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__render_pipe_profile__ds_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__render_pipe_profile__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = tgl__render_pipe_profile__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__render_pipe_profile__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__render_pipe_profile__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__render_pipe_profile__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = tgl__render_pipe_profile__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = tgl__render_pipe_profile__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Bottleneck";
    counter->symbol_name = "GsBottleneck";
    counter->desc = "The percentage of time in which geometry shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__render_pipe_profile__gs_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__render_pipe_profile__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Hi-Depth Bottleneck";
    counter->symbol_name = "HiDepthBottleneck";
    counter->desc = "The percentage of time in which early hierarchical depth test pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__render_pipe_profile__hi_depth_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = tgl__render_pipe_profile__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Bottleneck";
    counter->symbol_name = "HsBottleneck";
    counter->desc = "The percentage of time in which hull shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__render_pipe_profile__hs_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Stall";
    counter->symbol_name = "HsStall";
    counter->desc = "The percentage of time in which hull stall pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__render_pipe_profile__hs_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__render_pipe_profile__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = tgl__render_pipe_profile__l3_shader_throughput__read;
    counter->max_uint64 = tgl__render_pipe_profile__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = tgl__render_pipe_profile__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__render_pipe_profile__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = tgl__render_pipe_profile__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = tgl__render_pipe_profile__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = tgl__render_pipe_profile__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = tgl__render_pipe_profile__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = tgl__render_pipe_profile__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = tgl__render_pipe_profile__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Strip-Fans Bottleneck";
    counter->symbol_name = "SfBottleneck";
    counter->desc = "The percentage of time in which strip-fans pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__render_pipe_profile__sf_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Strip-Fans");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SF Stall";
    counter->symbol_name = "SfStall";
    counter->desc = "The percentage of time in which strip-fans pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__render_pipe_profile__sf_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Strip-Fans");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = tgl__render_pipe_profile__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = tgl__render_pipe_profile__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = tgl__render_pipe_profile__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = tgl__render_pipe_profile__slm_bytes_read__read;
    counter->max_uint64 = tgl__render_pipe_profile__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = tgl__render_pipe_profile__slm_bytes_written__read;
    counter->max_uint64 = tgl__render_pipe_profile__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SO Bottleneck";
    counter->symbol_name = "SoBottleneck";
    counter->desc = "The percentage of time in which stream output pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__render_pipe_profile__so_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Stream Output");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SO Stall";
    counter->symbol_name = "SoStall";
    counter->desc = "The percentage of time in which stream-output pipeline stage was stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__render_pipe_profile__so_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Stream Output");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VF Bottleneck";
    counter->symbol_name = "VfBottleneck";
    counter->desc = "The percentage of time in which vertex fetch pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__render_pipe_profile__vf_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Input Assembler");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Bottleneck";
    counter->symbol_name = "VsBottleneck";
    counter->desc = "The percentage of time in which vertex shader pipeline stage was slowing down the 3D pipeline.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__render_pipe_profile__vs_bottleneck__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__render_pipe_profile__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 42);
}

static void
tgl_add_hdc_and_sf_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set HDCAndSF";
    metric_set->symbol_name = "HDCAndSF";
    metric_set->hw_config_guid = "dedd95cd-1bd4-4e65-be7f-1fd7aa43fe12";
    metric_set->counters = calloc(42, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(82, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(34, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(5, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14112400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14312400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14512474 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14712400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14912400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14B12400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x240A0019 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C07C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x24070002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10110074 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08110000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C130400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12310074 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10310000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08310000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12328000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C330800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10510000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A510000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14528000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C531000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16710074 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10710000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A710000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16728000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C732000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E910074 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10910000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06910000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E928000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C930200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00B10074 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10B10000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00B28000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10B38000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E0F0020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16104000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2E020001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2A030600 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18002000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x36003488 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x3800001B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00014000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A012000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x24050038 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x24060080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x180A00F7 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x200A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x140A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x160A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41104000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x5B105000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x5D100055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B14E000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D140007 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B112000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x5F115000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x61110055 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47100600 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4F101116 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51100401 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53100030 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x65100002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x42000001 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D920, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D900, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D904, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D910, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D914, .val = 0x70800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC40, .val = 0x007F0000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D940, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D944, .val = 0x0000FFFE };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC00, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC04, .val = 0x0000FFFE };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D948, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D94C, .val = 0x0000FFFD };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC08, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC0C, .val = 0x0000FFFD };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D950, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D954, .val = 0x0000FFFB };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC10, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC14, .val = 0x0000FFFB };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D958, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D95C, .val = 0x0000FFF7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC18, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC1C, .val = 0x0000FFF7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D960, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D964, .val = 0x0000FFEF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC20, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC24, .val = 0x0000FFEF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D968, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D96C, .val = 0x0000FFDF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC28, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC2C, .val = 0x0000FFDF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D970, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D974, .val = 0x0000FFBF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC30, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC34, .val = 0x0000FFBF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = tgl__hdc_and_sf__avg_gpu_core_frequency__read;
    counter->max_uint64 = tgl__hdc_and_sf__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__hdc_and_sf__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__hdc_and_sf__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = tgl__hdc_and_sf__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__hdc_and_sf__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU And EM Pipes Active";
    counter->symbol_name = "EuFpuEmActive";
    counter->desc = "The percentage of time in which EU FPU and EM pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__hdc_and_sf__eu_fpu_em_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__hdc_and_sf__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__hdc_and_sf__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = tgl__hdc_and_sf__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = tgl__hdc_and_sf__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__hdc_and_sf__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = tgl__hdc_and_sf__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__hdc_and_sf__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = tgl__hdc_and_sf__l3_shader_throughput__read;
    counter->max_uint64 = tgl__hdc_and_sf__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Dualsubslice0 Non-sampler Shader Access Stalled On L3";
        counter->symbol_name = "NonSamplerShader00AccessStalledOnL3";
        counter->desc = "Percentage of time when HDC has messages to L3, but it's stalled due to lack of credits (Slice0 Dualsubslice0)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__hdc_and_sf__non_sampler_shader00_access_stalled_on_l3__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Data Port");
    }

    if (perf->devinfo.subslice_mask & 2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Dualsubslice1 Non-sampler Shader Access Stalled On L3";
        counter->symbol_name = "NonSamplerShader01AccessStalledOnL3";
        counter->desc = "Percentage of time when HDC has messages to L3, but it's stalled due to lack of credits (Slice0 Dualsubslice1)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__hdc_and_sf__non_sampler_shader01_access_stalled_on_l3__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Data Port");
    }

    if (perf->devinfo.subslice_mask & 4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Dualsubslice2 Non-sampler Shader Access Stalled On L3";
        counter->symbol_name = "NonSamplerShader02AccessStalledOnL3";
        counter->desc = "Percentage of time when HDC has messages to L3, but it's stalled due to lack of credits (Slice0 Dualsubslice2)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__hdc_and_sf__non_sampler_shader02_access_stalled_on_l3__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Data Port");
    }

    if (perf->devinfo.subslice_mask & 8) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Dualsubslice3 Non-sampler Shader Access Stalled On L3";
        counter->symbol_name = "NonSamplerShader03AccessStalledOnL3";
        counter->desc = "Percentage of time when HDC has messages to L3, but it's stalled due to lack of credits (Slice0 Dualsubslice3)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__hdc_and_sf__non_sampler_shader03_access_stalled_on_l3__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Data Port");
    }

    if (perf->devinfo.subslice_mask & 16) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Dualsubslice4 Non-sampler Shader Access Stalled On L3";
        counter->symbol_name = "NonSamplerShader04AccessStalledOnL3";
        counter->desc = "Percentage of time when HDC has messages to L3, but it's stalled due to lack of credits (Slice0 Dualsubslice4)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__hdc_and_sf__non_sampler_shader04_access_stalled_on_l3__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Data Port");
    }

    if (perf->devinfo.subslice_mask & 32) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Dualsubslice5 Non-sampler Shader Access Stalled On L3";
        counter->symbol_name = "NonSamplerShader05AccessStalledOnL3";
        counter->desc = "Percentage of time when HDC has messages to L3, but it's stalled due to lack of credits (Slice0 Dualsubslice5)";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__hdc_and_sf__non_sampler_shader05_access_stalled_on_l3__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Data Port");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = tgl__hdc_and_sf__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Polygon Data Ready";
    counter->symbol_name = "PolyDataReady";
    counter->desc = "The percentage of time in which geometry pipeline output is ready";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__hdc_and_sf__poly_data_ready__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe/Strip-Fans");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS EM Pipe Active";
    counter->symbol_name = "PsEmActive";
    counter->desc = "The percentage of time in which EU EM pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__hdc_and_sf__ps_em_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__hdc_and_sf__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU Pipe Active";
    counter->symbol_name = "PsFpuActive";
    counter->desc = "The percentage of time in which EU FPU pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__hdc_and_sf__ps_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__hdc_and_sf__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__hdc_and_sf__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = tgl__hdc_and_sf__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = tgl__hdc_and_sf__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = tgl__hdc_and_sf__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = tgl__hdc_and_sf__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = tgl__hdc_and_sf__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = tgl__hdc_and_sf__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = tgl__hdc_and_sf__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = tgl__hdc_and_sf__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = tgl__hdc_and_sf__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = tgl__hdc_and_sf__slm_bytes_read__read;
    counter->max_uint64 = tgl__hdc_and_sf__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = tgl__hdc_and_sf__slm_bytes_written__read;
    counter->max_uint64 = tgl__hdc_and_sf__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS EM Pipe Active";
    counter->symbol_name = "VsEmActive";
    counter->desc = "The percentage of time in which EU EM pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__hdc_and_sf__vs_em_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU Pipe Active";
    counter->symbol_name = "VsFpuActive";
    counter->desc = "The percentage of time in which EU FPU pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__hdc_and_sf__vs_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__hdc_and_sf__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__hdc_and_sf__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 42);
}

static void
tgl_add_rasterizer_and_pixel_backend_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set RasterizerAndPixelBackend";
    metric_set->symbol_name = "RasterizerAndPixelBackend";
    metric_set->hw_config_guid = "a889ccb3-5ebd-437f-b5c6-e951fba822f5";
    metric_set->counters = calloc(48, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(100, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(14, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(5, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E075000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A0700C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E055000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A0500C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E065000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A0600C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2A0A7300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2C0A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x120800A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A07C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E070027 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10070000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x24070000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2A032000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2C030008 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18006000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x360036D8 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x38003299 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C006000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2A010400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2C010001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C05C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00052700 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10050000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x24050000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x22050000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0600C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E062700 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10060000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x24060000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x26060000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000A0144 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0A0145 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100A0156 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040A014F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x200A0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x120A4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x140A4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x180A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E0A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08081980 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A080032 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10080000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31152800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x331500A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31352800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x333500A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41104000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x5B105FA5 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x5D101555 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B14E000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D14003F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B112000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x5F115005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x61111555 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07150016 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09150096 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01150000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03168000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05164000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B350016 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D350096 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01350000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05368000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07364000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47100400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D100616 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4F100404 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51100202 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53100002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55100204 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49101404 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B101616 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x65100002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x42000001 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D920, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D900, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D904, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D910, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D914, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC40, .val = 0x00030000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D940, .val = 0x00000038 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D944, .val = 0x0000FFF8 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC00, .val = 0x00000038 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC04, .val = 0x0000FFF8 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D948, .val = 0x000000C0 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D94C, .val = 0x0000FFE7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC08, .val = 0x000000C0 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC0C, .val = 0x0000FFE7 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00010003 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E658, .val = 0x00012011 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E45C, .val = 0x00051050 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E55C, .val = 0x00053052 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = tgl__rasterizer_and_pixel_backend__avg_gpu_core_frequency__read;
    counter->max_uint64 = tgl__rasterizer_and_pixel_backend__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__rasterizer_and_pixel_backend__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__rasterizer_and_pixel_backend__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Depth Test Fails";
    counter->symbol_name = "EarlyDepthTestFails";
    counter->desc = "The total number of pixels dropped on early depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = tgl__rasterizer_and_pixel_backend__early_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__rasterizer_and_pixel_backend__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU And EM Pipes Active";
    counter->symbol_name = "EuFpuEmActive";
    counter->desc = "The percentage of time in which EU FPU and EM pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__rasterizer_and_pixel_backend__eu_fpu_em_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__rasterizer_and_pixel_backend__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SQ00 is full";
    counter->symbol_name = "GTRequestQueue00Full";
    counter->desc = "The percentage of time when IDI0 SQ0 is filled above a threshold (usually 48 entries)";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__rasterizer_and_pixel_backend__gt_request_queue00_full__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SQ01 is full";
    counter->symbol_name = "GTRequestQueue01Full";
    counter->desc = "The percentage of time when IDI0 SQ1 is filled above a threshold (usually 48 entries)";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__rasterizer_and_pixel_backend__gt_request_queue01_full__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SQ10 is full";
    counter->symbol_name = "GTRequestQueue10Full";
    counter->desc = "The percentage of time when IDI1 SQ0 is filled above a threshold (usually 48 entries)";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__rasterizer_and_pixel_backend__gt_request_queue10_full__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SQ11 is full";
    counter->symbol_name = "GTRequestQueue11Full";
    counter->desc = "The percentage of time when IDI1 SQ1 is filled above a threshold (usually 48 entries)";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__rasterizer_and_pixel_backend__gt_request_queue11_full__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GTI");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__rasterizer_and_pixel_backend__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = tgl__rasterizer_and_pixel_backend__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = tgl__rasterizer_and_pixel_backend__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__rasterizer_and_pixel_backend__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Early Hi-Depth Test Fails";
    counter->symbol_name = "HiDepthTestFails";
    counter->desc = "The total number of pixels dropped on early hierarchical depth test.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = tgl__rasterizer_and_pixel_backend__hi_depth_test_fails__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer/Hi-Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__rasterizer_and_pixel_backend__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "L3 Shader Throughput";
    counter->symbol_name = "L3ShaderThroughput";
    counter->desc = "The total number of GPU memory bytes transferred between shaders and L3 caches w/o URB.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = tgl__rasterizer_and_pixel_backend__l3_shader_throughput__read;
    counter->max_uint64 = tgl__rasterizer_and_pixel_backend__l3_shader_throughput__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Slice0 Pipe0 PS Output Available";
    counter->symbol_name = "PSOutput00Available";
    counter->desc = "The percentage of time in which slice0 pipe0 PS output is available";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__rasterizer_and_pixel_backend__ps_output00_available__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Slice0 Pipe1 PS Output Available";
    counter->symbol_name = "PSOutput01Available";
    counter->desc = "The percentage of time in which slice0 pipe1 PS output is available";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__rasterizer_and_pixel_backend__ps_output01_available__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Slice0 Pipe2 PS Output Available";
    counter->symbol_name = "PSOutput02Available";
    counter->desc = "The percentage of time in which slice0 pipe2 PS output is available";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__rasterizer_and_pixel_backend__ps_output02_available__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Slice0 Pipe0 Post-EarlyZ Pixel Data Ready";
    counter->symbol_name = "PixelData00Ready";
    counter->desc = "The percentage of time in which slice0  pipe0 post-EarlyZ pixel data is ready (after early Z tests have been applied)";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__rasterizer_and_pixel_backend__pixel_data00_ready__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU/Rasterizer/Early Depth Test");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Slice0 Pipe0 Pixel Values Ready";
    counter->symbol_name = "PixelValues00Ready";
    counter->desc = "The percentage of time in which slice0 pipe0 pixel values are ready";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__rasterizer_and_pixel_backend__pixel_values00_ready__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Slice0 Pipe1 Pixel Values Ready";
    counter->symbol_name = "PixelValues01Ready";
    counter->desc = "The percentage of time in which slice0 pipe1 pixel values are ready";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__rasterizer_and_pixel_backend__pixel_values01_ready__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Slice0 Pipe2 Pixel Values Ready";
    counter->symbol_name = "PixelValues02Ready";
    counter->desc = "The percentage of time in which slice0 pipe2 pixel values are ready";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__rasterizer_and_pixel_backend__pixel_values02_ready__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU/3D Pipe");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Pixels Failing Tests";
    counter->symbol_name = "PixelsFailingPostPsTests";
    counter->desc = "The total number of pixels dropped on post-FS alpha, stencil, or depth tests.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = tgl__rasterizer_and_pixel_backend__pixels_failing_post_ps_tests__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS EM Pipe Active";
    counter->symbol_name = "PsEmActive";
    counter->desc = "The percentage of time in which EU EM pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__rasterizer_and_pixel_backend__ps_em_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Both FPU Active";
    counter->symbol_name = "PsEuBothFpuActive";
    counter->desc = "The percentage of time in which fragment shaders were processed actively on the both FPUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__rasterizer_and_pixel_backend__ps_eu_both_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS FPU Pipe Active";
    counter->symbol_name = "PsFpuActive";
    counter->desc = "The percentage of time in which EU FPU pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__rasterizer_and_pixel_backend__ps_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "PS Send Pipeline Active";
    counter->symbol_name = "PsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a pixel shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__rasterizer_and_pixel_backend__ps_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pixel Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__rasterizer_and_pixel_backend__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Rasterized Pixels";
    counter->symbol_name = "RasterizedPixels";
    counter->desc = "The total number of rasterized pixels.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = tgl__rasterizer_and_pixel_backend__rasterized_pixels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Rasterizer");

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Rasterizer Input Available";
        counter->symbol_name = "Rasterizer0InputAvailable";
        counter->desc = "The percentage of time in which slice0 rasterizer input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__rasterizer_and_pixel_backend__rasterizer0_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Rasterizer");
    }

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 Rasterizer Output Ready";
        counter->symbol_name = "Rasterizer0OutputReady";
        counter->desc = "The percentage of time in which slice0 rasterizer output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__rasterizer_and_pixel_backend__rasterizer0_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Rasterizer");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels Misses";
    counter->symbol_name = "SamplerTexelMisses";
    counter->desc = "The total number of texels lookups (with 2x2 accuracy) that missed L1 sampler cache.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = tgl__rasterizer_and_pixel_backend__sampler_texel_misses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Cache");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Sampler Texels";
    counter->symbol_name = "SamplerTexels";
    counter->desc = "The total number of texels seen on input (with 2x2 accuracy) in all sampler units.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_TEXELS;
    counter->read_uint64 = tgl__rasterizer_and_pixel_backend__sampler_texels__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "Sampler/Sampler Input");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Blended";
    counter->symbol_name = "SamplesBlended";
    counter->desc = "The total number of blended samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = tgl__rasterizer_and_pixel_backend__samples_blended__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Killed in FS";
    counter->symbol_name = "SamplesKilledInPs";
    counter->desc = "The total number of samples or pixels dropped in fragment shaders.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = tgl__rasterizer_and_pixel_backend__samples_killed_in_ps__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Samples Written";
    counter->symbol_name = "SamplesWritten";
    counter->desc = "The total number of samples or pixels written to all render targets.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PIXELS;
    counter->read_uint64 = tgl__rasterizer_and_pixel_backend__samples_written__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "3D Pipe/Output Merger");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Atomic Memory Accesses";
    counter->symbol_name = "ShaderAtomics";
    counter->desc = "The total number of shader atomic memory accesses.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = tgl__rasterizer_and_pixel_backend__shader_atomics__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/Atomics");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Barrier Messages";
    counter->symbol_name = "ShaderBarriers";
    counter->desc = "The total number of shader barrier messages.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = tgl__rasterizer_and_pixel_backend__shader_barriers__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Barrier");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Shader Memory Accesses";
    counter->symbol_name = "ShaderMemoryAccesses";
    counter->desc = "The total number of shader memory accesses to L3.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_MESSAGES;
    counter->read_uint64 = tgl__rasterizer_and_pixel_backend__shader_memory_accesses__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Read";
    counter->symbol_name = "SlmBytesRead";
    counter->desc = "The total number of GPU memory bytes read from shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = tgl__rasterizer_and_pixel_backend__slm_bytes_read__read;
    counter->max_uint64 = tgl__rasterizer_and_pixel_backend__slm_bytes_read__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "SLM Bytes Written";
    counter->symbol_name = "SlmBytesWritten";
    counter->desc = "The total number of GPU memory bytes written into shared local memory.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_THROUGHPUT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_BYTES;
    counter->read_uint64 = tgl__rasterizer_and_pixel_backend__slm_bytes_written__read;
    counter->max_uint64 = tgl__rasterizer_and_pixel_backend__slm_bytes_written__max;
    intel_perf_add_logical_counter(perf, counter, "L3/Data Port/SLM");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS EM Pipe Active";
    counter->symbol_name = "VsEmActive";
    counter->desc = "The percentage of time in which EU EM pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__rasterizer_and_pixel_backend__vs_em_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS FPU Pipe Active";
    counter->symbol_name = "VsFpuActive";
    counter->desc = "The percentage of time in which EU FPU pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__rasterizer_and_pixel_backend__vs_fpu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Send Pipe Active";
    counter->symbol_name = "VsSendActive";
    counter->desc = "The percentage of time in which EU send pipeline was actively processing a vertex shader instruction.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__rasterizer_and_pixel_backend__vs_send_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__rasterizer_and_pixel_backend__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 48);
}

static void
tgl_add_l3_1_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Gen12LP L3_1";
    metric_set->symbol_name = "L3_1";
    metric_set->hw_config_guid = "feee2629-03a8-4d31-ab4d-7d16572163fb";
    metric_set->counters = calloc(18, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(85, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(6, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(2, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04022000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06022800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04002827 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0600202C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00020024 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E020025 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10020026 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12020027 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1402002C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1602002D };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1802002E };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A02002F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2E020000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2C020000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00034000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A032000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C032000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E032000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2A035500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C000024 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E000025 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02000026 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0800002D };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A00002E };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C00002F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x360036D8 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18006000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x380000DB };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x34000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x000A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x120A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x140A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x160A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x180A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A0A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41104000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x5B105555 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x5D101555 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B14FC00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D14003F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B112000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x5F115555 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x61111555 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D100606 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4F100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55100600 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57100006 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49100606 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B100606 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x65100002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x42000001 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D920, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D900, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D904, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D910, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D914, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC40, .val = 0x00000000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00008003 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = tgl__l3_1__avg_gpu_core_frequency__read;
    counter->max_uint64 = tgl__l3_1__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__l3_1__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__l3_1__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__l3_1__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU And EM Pipes Active";
    counter->symbol_name = "EuFpuEmActive";
    counter->desc = "The percentage of time in which EU FPU and EM pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__l3_1__eu_fpu_em_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__l3_1__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Thread Occupancy";
    counter->symbol_name = "EuThreadOccupancy";
    counter->desc = "The percentage of time in which hardware threads occupied EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__l3_1__eu_thread_occupancy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__l3_1__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = tgl__l3_1__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = tgl__l3_1__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__l3_1__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__l3_1__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank0 Input Available";
        counter->symbol_name = "L30Bank0InputAvailable";
        counter->desc = "The percentage of time in which slice0 L3 bank0 has input available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__l3_1__l30_bank0_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank1 Input Available";
        counter->symbol_name = "L30Bank1InputAvailable";
        counter->desc = "The percentage of time in which slice0 L3 bank1 has input available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__l3_1__l30_bank1_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank4 Input Available";
        counter->symbol_name = "L30Bank4InputAvailable";
        counter->desc = "The percentage of time in which slice0 L3 bank4 has input available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__l3_1__l30_bank4_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank5 Input Available";
        counter->symbol_name = "L30Bank5InputAvailable";
        counter->desc = "The percentage of time in which slice0 L3 bank5 has input available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__l3_1__l30_bank5_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__l3_1__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__l3_1__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 18);
}

static void
tgl_add_l3_2_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Gen12LP L3_2";
    metric_set->symbol_name = "L3_2";
    metric_set->hw_config_guid = "5266f235-1711-4eef-9493-ebdf0238d512";
    metric_set->counters = calloc(18, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(86, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(6, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(2, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04023027 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0602382C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04003000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06003800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C020024 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E020025 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02020026 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0802002D };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A02002E };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C02002F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2E020000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2C030005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02034000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04034000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06034000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08034000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A034000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18032000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00000024 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E000025 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10000026 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12000027 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1400002C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1600002D };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1800002E };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A00602F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x36000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x38003600 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C006000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E006000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x34001B00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C0A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E0A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41104000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x5B105555 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x5D101555 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B14FC00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D14003F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B112000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x5F115555 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x61111555 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47100600 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4F100606 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51100606 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53100606 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55100006 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x65100002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x42000001 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D920, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D900, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D904, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D910, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D914, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC40, .val = 0x00000000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00008003 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = tgl__l3_2__avg_gpu_core_frequency__read;
    counter->max_uint64 = tgl__l3_2__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__l3_2__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__l3_2__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__l3_2__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU And EM Pipes Active";
    counter->symbol_name = "EuFpuEmActive";
    counter->desc = "The percentage of time in which EU FPU and EM pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__l3_2__eu_fpu_em_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__l3_2__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Thread Occupancy";
    counter->symbol_name = "EuThreadOccupancy";
    counter->desc = "The percentage of time in which hardware threads occupied EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__l3_2__eu_thread_occupancy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__l3_2__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = tgl__l3_2__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = tgl__l3_2__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__l3_2__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__l3_2__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank2 Input Available";
        counter->symbol_name = "L30Bank2InputAvailable";
        counter->desc = "The percentage of time in which slice0 L3 bank2 has input available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__l3_2__l30_bank2_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank3 Input Available";
        counter->symbol_name = "L30Bank3InputAvailable";
        counter->desc = "The percentage of time in which slice0 L3 bank3 has input available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__l3_2__l30_bank3_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank6 Input Available";
        counter->symbol_name = "L30Bank6InputAvailable";
        counter->desc = "The percentage of time in which slice0 L3 bank6 has input available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__l3_2__l30_bank6_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank7 Input Available";
        counter->symbol_name = "L30Bank7InputAvailable";
        counter->desc = "The percentage of time in which slice0 L3 bank7 has input available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__l3_2__l30_bank7_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__l3_2__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__l3_2__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 18);
}

static void
tgl_add_l3_3_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Gen12LP L3_3";
    metric_set->symbol_name = "L3_3";
    metric_set->hw_config_guid = "9c2cd379-bf93-4ded-b481-f64efd534c4a";
    metric_set->counters = calloc(16, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(36, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(6, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(2, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04020200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06020020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08020028 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2E020000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06034000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08034000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A000020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C000028 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x36000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E006000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x34000300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x5B100550 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B141C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x5F110550 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D100606 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x65100002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x42000001 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D920, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D900, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D904, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D910, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D914, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC40, .val = 0x00000000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00008003 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = tgl__l3_3__avg_gpu_core_frequency__read;
    counter->max_uint64 = tgl__l3_3__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__l3_3__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__l3_3__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__l3_3__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU And EM Pipes Active";
    counter->symbol_name = "EuFpuEmActive";
    counter->desc = "The percentage of time in which EU FPU and EM pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__l3_3__eu_fpu_em_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__l3_3__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Thread Occupancy";
    counter->symbol_name = "EuThreadOccupancy";
    counter->desc = "The percentage of time in which hardware threads occupied EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__l3_3__eu_thread_occupancy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__l3_3__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = tgl__l3_3__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = tgl__l3_3__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__l3_3__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__l3_3__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank0 Output Ready";
        counter->symbol_name = "L30Bank0OutputReady";
        counter->desc = "The percentage of time in which slice0 L3 bank0 output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__l3_3__l30_bank0_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank4 Output Ready";
        counter->symbol_name = "L30Bank4OutputReady";
        counter->desc = "The percentage of time in which slice0 L3 bank4 output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__l3_3__l30_bank4_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__l3_3__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__l3_3__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 16);
}

static void
tgl_add_l3_4_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Gen12LP L3_4";
    metric_set->symbol_name = "L3_4";
    metric_set->hw_config_guid = "6a68185d-0056-4891-a5f6-29aa1e1d81ae";
    metric_set->counters = calloc(16, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(36, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(6, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(2, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04020A00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06020800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04000A00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06000820 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A020020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C020028 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2E020000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A034000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18032000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08000028 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x36000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x34001800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x5B100550 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B141C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x5F110550 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B100606 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x65100002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x42000001 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D920, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D900, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D904, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D910, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D914, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC40, .val = 0x00000000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00008003 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = tgl__l3_4__avg_gpu_core_frequency__read;
    counter->max_uint64 = tgl__l3_4__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__l3_4__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__l3_4__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__l3_4__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU And EM Pipes Active";
    counter->symbol_name = "EuFpuEmActive";
    counter->desc = "The percentage of time in which EU FPU and EM pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__l3_4__eu_fpu_em_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__l3_4__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Thread Occupancy";
    counter->symbol_name = "EuThreadOccupancy";
    counter->desc = "The percentage of time in which hardware threads occupied EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__l3_4__eu_thread_occupancy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__l3_4__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = tgl__l3_4__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = tgl__l3_4__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__l3_4__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__l3_4__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank1 Output Ready";
        counter->symbol_name = "L30Bank1OutputReady";
        counter->desc = "The percentage of time in which slice0 L3 bank1 output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__l3_4__l30_bank1_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank5 Output Ready";
        counter->symbol_name = "L30Bank5OutputReady";
        counter->desc = "The percentage of time in which slice0 L3 bank5 output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__l3_4__l30_bank5_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__l3_4__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__l3_4__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 16);
}

static void
tgl_add_l3_5_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Gen12LP L3_5";
    metric_set->symbol_name = "L3_5";
    metric_set->hw_config_guid = "3f17a326-ae8b-4869-9f5a-3bccf793e287";
    metric_set->counters = calloc(16, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(36, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(6, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(2, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04021200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06021000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04001200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06001020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A020020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C020028 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2E020000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A034000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18032000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08000028 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x36000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x34001800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x5B100550 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B141C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x5F110550 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B100606 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x65100002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x42000001 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D920, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D900, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D904, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D910, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D914, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC40, .val = 0x00000000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00008003 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = tgl__l3_5__avg_gpu_core_frequency__read;
    counter->max_uint64 = tgl__l3_5__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__l3_5__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__l3_5__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__l3_5__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU And EM Pipes Active";
    counter->symbol_name = "EuFpuEmActive";
    counter->desc = "The percentage of time in which EU FPU and EM pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__l3_5__eu_fpu_em_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__l3_5__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Thread Occupancy";
    counter->symbol_name = "EuThreadOccupancy";
    counter->desc = "The percentage of time in which hardware threads occupied EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__l3_5__eu_thread_occupancy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__l3_5__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = tgl__l3_5__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = tgl__l3_5__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__l3_5__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__l3_5__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank2 Output Ready";
        counter->symbol_name = "L30Bank2OutputReady";
        counter->desc = "The percentage of time in which slice0 L3 bank2 output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__l3_5__l30_bank2_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank6 Output Ready";
        counter->symbol_name = "L30Bank6OutputReady";
        counter->desc = "The percentage of time in which slice0 L3 bank6 output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__l3_5__l30_bank6_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__l3_5__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__l3_5__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 16);
}

static void
tgl_add_l3_6_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Gen12LP L3_6";
    metric_set->symbol_name = "L3_6";
    metric_set->hw_config_guid = "d312c40a-9fb7-489a-9a1a-9cd80aac6d61";
    metric_set->counters = calloc(16, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(36, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(6, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(2, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04021A00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06021800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04001A00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06001820 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A020020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C020028 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2E020000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A034000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18032000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08000028 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x36000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x34001800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x5B100550 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B141C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x5F110550 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B100606 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x65100002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x42000001 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D920, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D900, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D904, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D910, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D914, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC40, .val = 0x00000000 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00008003 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = tgl__l3_6__avg_gpu_core_frequency__read;
    counter->max_uint64 = tgl__l3_6__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__l3_6__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__l3_6__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__l3_6__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU And EM Pipes Active";
    counter->symbol_name = "EuFpuEmActive";
    counter->desc = "The percentage of time in which EU FPU and EM pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__l3_6__eu_fpu_em_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__l3_6__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Thread Occupancy";
    counter->symbol_name = "EuThreadOccupancy";
    counter->desc = "The percentage of time in which hardware threads occupied EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__l3_6__eu_thread_occupancy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__l3_6__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = tgl__l3_6__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = tgl__l3_6__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__l3_6__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__l3_6__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank3 Output Ready";
        counter->symbol_name = "L30Bank3OutputReady";
        counter->desc = "The percentage of time in which slice0 L3 bank3 output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__l3_6__l30_bank3_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    if (perf->devinfo.slice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 L3 Bank7 Output Ready";
        counter->symbol_name = "L30Bank7OutputReady";
        counter->desc = "The percentage of time in which slice0 L3 bank7 output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__l3_6__l30_bank7_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GTI/L3");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__l3_6__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__l3_6__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 16);
}

static void
tgl_add_sampler_1_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Sampler_1";
    metric_set->symbol_name = "Sampler_1";
    metric_set->hw_config_guid = "f0f255a4-535c-43ed-9d6b-85958cef6c1c";
    metric_set->counters = calloc(20, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(124, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(30, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(2, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C121600 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18141600 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C325600 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18341600 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C521600 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x185416A6 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C721600 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18741600 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C921600 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18941600 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1CB21600 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18B41600 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C07C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2407002B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04120086 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x20120000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02124000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12138000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14138000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021400A6 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10140000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00140000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A150020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E320086 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x20320000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E330003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C3400A6 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10340000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E340000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C358000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A520086 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x20520000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18524000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C53C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10540000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C540000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C550800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16720086 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x20720000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14724000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C733000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x147400A6 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10740000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A740000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C750080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12920086 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x20920000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10924000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C930C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x109400A6 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08940000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C950008 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EB20086 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x20B20000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00B24000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10B38000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1CB30200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00B400A6 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10B40000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18B58000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E0F0028 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14104000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16104000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2C024000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2E020001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2A03A500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18002000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x36003248 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x380024DB };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00014000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A012000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C012000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E012000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2405C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x26050003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x220500A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x24062800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x140A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x160A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x180A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A0A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41104000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x5B105005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x5D101555 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B14E000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D14003F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B112000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x5F115005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x61111555 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47101600 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D101000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4F101603 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51100003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53101404 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55101111 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57100005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49100511 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x65100002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x42000001 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D920, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D900, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D904, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D910, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D914, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC40, .val = 0x003F0000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D940, .val = 0x00000018 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D944, .val = 0x0000FFFC };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC00, .val = 0x00000018 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC04, .val = 0x0000FFFC };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D948, .val = 0x00000060 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D94C, .val = 0x0000FFF3 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC08, .val = 0x00000060 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC0C, .val = 0x0000FFF3 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D950, .val = 0x00000180 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D954, .val = 0x0000FFCF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC10, .val = 0x00000180 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC14, .val = 0x0000FFCF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D958, .val = 0x00000600 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D95C, .val = 0x0000FF3F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC18, .val = 0x00000600 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC1C, .val = 0x0000FF3F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D960, .val = 0x00001800 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D964, .val = 0x0000FCFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC20, .val = 0x00001800 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC24, .val = 0x0000FCFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D968, .val = 0x00006000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D96C, .val = 0x0000F3FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC28, .val = 0x00006000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC2C, .val = 0x0000F3FF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00008003 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = tgl__sampler_1__avg_gpu_core_frequency__read;
    counter->max_uint64 = tgl__sampler_1__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__sampler_1__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__sampler_1__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__sampler_1__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU And EM Pipes Active";
    counter->symbol_name = "EuFpuEmActive";
    counter->desc = "The percentage of time in which EU FPU and EM pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__sampler_1__eu_fpu_em_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__sampler_1__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Thread Occupancy";
    counter->symbol_name = "EuThreadOccupancy";
    counter->desc = "The percentage of time in which hardware threads occupied EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__sampler_1__eu_thread_occupancy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__sampler_1__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = tgl__sampler_1__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = tgl__sampler_1__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__sampler_1__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__sampler_1__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__sampler_1__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 DualSubslice0 Input Available";
        counter->symbol_name = "Sampler00InputAvailable";
        counter->desc = "The percentage of time in which slice0 dualsubslice0 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__sampler_1__sampler00_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 DualSubslice1 Input Available";
        counter->symbol_name = "Sampler01InputAvailable";
        counter->desc = "The percentage of time in which slice0 dualsubslice1 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__sampler_1__sampler01_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 DualSubslice2 Input Available";
        counter->symbol_name = "Sampler02InputAvailable";
        counter->desc = "The percentage of time in which slice0 dualsubslice2 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__sampler_1__sampler02_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 8) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 DualSubslice3 Input Available";
        counter->symbol_name = "Sampler03InputAvailable";
        counter->desc = "The percentage of time in which slice0 dualsubslice3 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__sampler_1__sampler03_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 16) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 DualSubslice4 Input Available";
        counter->symbol_name = "Sampler04InputAvailable";
        counter->desc = "The percentage of time in which slice0 dualsubslice4 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__sampler_1__sampler04_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 32) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 DualSubslice5 Input Available";
        counter->symbol_name = "Sampler05InputAvailable";
        counter->desc = "The percentage of time in which slice0 dualsubslice5 sampler input is available";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__sampler_1__sampler05_input_available__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__sampler_1__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 20);
}

static void
tgl_add_sampler_2_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Sampler_2";
    metric_set->symbol_name = "Sampler_2";
    metric_set->hw_config_guid = "f47c6b97-fc10-4962-bb67-d623e9d6219b";
    metric_set->counters = calloc(20, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(126, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(30, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(2, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C123E00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04143E00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C323E00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04343E00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C523E00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04543E00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C723E00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04743E00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C923E00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04943E00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CB23E00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04B43E00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C07C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2407002B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04120033 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x20120000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02124000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12138000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14138000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02140013 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10140000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00140000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A150020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E320033 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x20320000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C324000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E330003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C340013 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10340000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E340000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C358000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A520033 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x20520000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18524000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C53C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18540013 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10540000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C540000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C550800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16720033 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x20720000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14724000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C733000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14740013 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10740000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A740000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C750080 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12920033 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x20920000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10924000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C930C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10940013 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08940000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C950008 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EB20033 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x20B20000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00B24000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10B38000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1CB30200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00B40013 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10B40000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18B58000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E0F0028 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14104000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16104000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2C024000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2E020001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2A03A500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18002000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x36003248 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x380024DB };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00014000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A012000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C012000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E012000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2405C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x26050003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x220500A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x24062800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x140A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x160A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x180A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A0A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41104000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x5B105005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x5D101555 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B14E000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D14003F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B112000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x5F115005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x61111555 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47101600 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D101000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4F101603 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51100003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53101404 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55101111 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57100005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49100511 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x65100002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x42000001 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D920, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D900, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D904, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D910, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D914, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC40, .val = 0x003F0000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D940, .val = 0x00000018 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D944, .val = 0x0000FFFC };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC00, .val = 0x00000018 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC04, .val = 0x0000FFFC };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D948, .val = 0x00000060 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D94C, .val = 0x0000FFF3 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC08, .val = 0x00000060 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC0C, .val = 0x0000FFF3 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D950, .val = 0x00000180 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D954, .val = 0x0000FFCF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC10, .val = 0x00000180 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC14, .val = 0x0000FFCF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D958, .val = 0x00000600 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D95C, .val = 0x0000FF3F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC18, .val = 0x00000600 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC1C, .val = 0x0000FF3F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D960, .val = 0x00001800 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D964, .val = 0x0000FCFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC20, .val = 0x00001800 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC24, .val = 0x0000FCFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D968, .val = 0x00006000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D96C, .val = 0x0000F3FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC28, .val = 0x00006000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC2C, .val = 0x0000F3FF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00008003 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = tgl__sampler_2__avg_gpu_core_frequency__read;
    counter->max_uint64 = tgl__sampler_2__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__sampler_2__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__sampler_2__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__sampler_2__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU And EM Pipes Active";
    counter->symbol_name = "EuFpuEmActive";
    counter->desc = "The percentage of time in which EU FPU and EM pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__sampler_2__eu_fpu_em_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__sampler_2__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Thread Occupancy";
    counter->symbol_name = "EuThreadOccupancy";
    counter->desc = "The percentage of time in which hardware threads occupied EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__sampler_2__eu_thread_occupancy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__sampler_2__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = tgl__sampler_2__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = tgl__sampler_2__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__sampler_2__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__sampler_2__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__sampler_2__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 DualSubslice0 Sampler Output Ready";
        counter->symbol_name = "Sampler00OutputReady";
        counter->desc = "The percentage of time in which slice0 dualsubslice0 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__sampler_2__sampler00_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 DualSubslice1 Sampler Output Ready";
        counter->symbol_name = "Sampler01OutputReady";
        counter->desc = "The percentage of time in which slice0 dualsubslice1 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__sampler_2__sampler01_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 DualSubslice2 Sampler Output Ready";
        counter->symbol_name = "Sampler02OutputReady";
        counter->desc = "The percentage of time in which slice0 dualsubslice2 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__sampler_2__sampler02_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 8) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 DualSubslice3 Sampler Output Ready";
        counter->symbol_name = "Sampler03OutputReady";
        counter->desc = "The percentage of time in which slice0 dualsubslice3 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__sampler_2__sampler03_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 16) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 DualSubslice4 Sampler Output Ready";
        counter->symbol_name = "Sampler04OutputReady";
        counter->desc = "The percentage of time in which slice0 dualsubslice4 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__sampler_2__sampler04_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    if (perf->devinfo.subslice_mask & 32) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Slice0 DualSubslice5 Sampler Output Ready";
        counter->symbol_name = "Sampler05OutputReady";
        counter->desc = "The percentage of time in which slice0 dualsubslice5 sampler output is ready";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__sampler_2__sampler05_output_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Sampler");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__sampler_2__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 20);
}

static void
tgl_add_tdl_1_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "TDL_1";
    metric_set->symbol_name = "TDL_1";
    metric_set->hw_config_guid = "2e49d25e-93e8-4e2b-b91b-51731f5fb315";
    metric_set->counters = calloc(30, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(126, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(38, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(2, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2611001C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2631001C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2651001C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2671001C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2691001C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x26B1001C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C07C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x24070002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16110103 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C110104 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E110105 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02110106 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04110107 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10110000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A110000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E110000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00110000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C132000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E130003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12138000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14138000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14310103 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06310104 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08310105 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A310106 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C310107 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10310000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02310000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04310000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14328000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06328000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08328000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A328000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C328000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C331100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16338000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18338000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A338000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12510103 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10510000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08510000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12528000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C530800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10710103 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08710000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10728000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C730400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E910103 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10910000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06910000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E928000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C930200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00B10103 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10B10000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00B28000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10B38000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C0F8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10104000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10024000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C032000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E034000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18002000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x360026CA };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x38002402 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x34001200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00014000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A012000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x240582C0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x26050002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2205FFA0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x24060020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x100A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x120A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41104000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x5B105555 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x5D101415 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B14FC00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D140033 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B112000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x5F115555 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x61111415 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47101600 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D100111 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4F100006 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51101114 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53100001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55101110 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57100001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49101111 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B101111 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x65100002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x42000001 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D920, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D900, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D904, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D910, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D914, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC40, .val = 0x00FF0000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D940, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D944, .val = 0x0000FFFE };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC00, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC04, .val = 0x0000FFFE };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D948, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D94C, .val = 0x0000FFFD };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC08, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC0C, .val = 0x0000FFFD };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D950, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D954, .val = 0x0000FFFB };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC10, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC14, .val = 0x0000FFFB };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D958, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D95C, .val = 0x0000FFF7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC18, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC1C, .val = 0x0000FFF7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D960, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D964, .val = 0x0000FFEF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC20, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC24, .val = 0x0000FFEF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D968, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D96C, .val = 0x0000FFDF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC28, .val = 0x00000002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC2C, .val = 0x0000FFDF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D970, .val = 0x00007800 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D974, .val = 0x0000F0FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC30, .val = 0x00007800 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC34, .val = 0x0000F0FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D978, .val = 0x00078000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D97C, .val = 0x00000FFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC38, .val = 0x00078000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC3C, .val = 0x00000FFF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00008003 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = tgl__tdl_1__avg_gpu_core_frequency__read;
    counter->max_uint64 = tgl__tdl_1__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__tdl_1__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__tdl_1__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__tdl_1__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU And EM Pipes Active";
    counter->symbol_name = "EuFpuEmActive";
    counter->desc = "The percentage of time in which EU FPU and EM pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__tdl_1__eu_fpu_em_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__tdl_1__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Thread Occupancy";
    counter->symbol_name = "EuThreadOccupancy";
    counter->desc = "The percentage of time in which hardware threads occupied EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__tdl_1__eu_thread_occupancy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__tdl_1__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = tgl__tdl_1__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = tgl__tdl_1__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__tdl_1__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__tdl_1__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Non-PS Thread Ready For Dispatch on Slice0 DualSubslice0 Thread Dispatcher";
        counter->symbol_name = "NonPSThread00ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice0 dualsubslice0 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__tdl_1__non_ps_thread00_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Non-PS Thread Ready For Dispatch on Slice0 DualSubslice1 Thread Dispatcher";
        counter->symbol_name = "NonPSThread01ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice0 dualsubslice1 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__tdl_1__non_ps_thread01_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Non-PS Thread Ready For Dispatch on Slice0 DualSubslice2 Thread Dispatcher";
        counter->symbol_name = "NonPSThread02ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice0 dualsubslice2 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__tdl_1__non_ps_thread02_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 8) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Non-PS Thread Ready For Dispatch on Slice0 DualSubslice3 Thread Dispatcher";
        counter->symbol_name = "NonPSThread03ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice0 dualsubslice3 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__tdl_1__non_ps_thread03_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 16) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Non-PS Thread Ready For Dispatch on Slice0 DualSubslice4 Thread Dispatcher";
        counter->symbol_name = "NonPSThread04ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice0 dualsubslice4 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__tdl_1__non_ps_thread04_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 32) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Non-PS Thread Ready For Dispatch on Slice0 DualSubslice5 Thread Dispatcher";
        counter->symbol_name = "NonPSThread05ReadyForDispatch";
        counter->desc = "The percentage of time in which non-PS thread is ready for dispatch on slice0 dualsubslice5 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__tdl_1__non_ps_thread05_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__tdl_1__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 DualSubslice0 Thread Dispatcher";
        counter->symbol_name = "ThreadHeader00Ready";
        counter->desc = "The percentage of time in which thread header is ready on slice0 dualsubslice0 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__tdl_1__thread_header00_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 DualSubslice0 Thread Dispatcher Port 0";
        counter->symbol_name = "ThreadHeader00ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice0 dualsubslice0 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__tdl_1__thread_header00_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 DualSubslice0 Thread Dispatcher Port 1";
        counter->symbol_name = "ThreadHeader00ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice0 dualsubslice0 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__tdl_1__thread_header00_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 DualSubslice0 Thread Dispatcher Port 2";
        counter->symbol_name = "ThreadHeader00ReadyPort2";
        counter->desc = "The percentage of time in which thread header is ready on slice0 dualsubslice0 thread dispatcher port 2";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__tdl_1__thread_header00_ready_port2__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 DualSubslice0 Thread Dispatcher Port 3";
        counter->symbol_name = "ThreadHeader00ReadyPort3";
        counter->desc = "The percentage of time in which thread header is ready on slice0 dualsubslice0 thread dispatcher port 3";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__tdl_1__thread_header00_ready_port3__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 DualSubslice1 Thread Dispatcher";
        counter->symbol_name = "ThreadHeader01Ready";
        counter->desc = "The percentage of time in which thread header is ready on slice0 dualsubslice1 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__tdl_1__thread_header01_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 DualSubslice1 Thread Dispatcher Port 0";
        counter->symbol_name = "ThreadHeader01ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice0 dualsubslice1 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__tdl_1__thread_header01_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 DualSubslice1 Thread Dispatcher Port 1";
        counter->symbol_name = "ThreadHeader01ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice0 dualsubslice1 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__tdl_1__thread_header01_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 DualSubslice1 Thread Dispatcher Port 2";
        counter->symbol_name = "ThreadHeader01ReadyPort2";
        counter->desc = "The percentage of time in which thread header is ready on slice0 dualsubslice1 thread dispatcher port 2";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__tdl_1__thread_header01_ready_port2__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 DualSubslice1 Thread Dispatcher Port 3";
        counter->symbol_name = "ThreadHeader01ReadyPort3";
        counter->desc = "The percentage of time in which thread header is ready on slice0 dualsubslice1 thread dispatcher port 3";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__tdl_1__thread_header01_ready_port3__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__tdl_1__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 30);
}

static void
tgl_add_tdl_2_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "TDL_2";
    metric_set->symbol_name = "TDL_2";
    metric_set->hw_config_guid = "2a42ff25-99b1-4048-a121-f0664ed42c90";
    metric_set->counters = calloc(25, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(141, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(34, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(2, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x24110340 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x24310340 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x24510340 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x24710340 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x24910340 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x24B10340 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x26B1001C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C07C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2407002B };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2207FF00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x021100F3 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x041100F2 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10110000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00110000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12138000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14138000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C3100F3 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E3100F2 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10310000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E310000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C328000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E328000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E330003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x185100F3 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A5100F2 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10510000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C510000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18528000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A528000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C53C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x147100F3 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x167100F2 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10710000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A710000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14728000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16728000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C733000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x109100F3 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x129100F2 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08910000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10928000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12928000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C930C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00B100F3 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EB100F2 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06B10104 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08B10105 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AB10106 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CB10107 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10B10000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02B10000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04B10000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00B28000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0EB28000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06B28000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08B28000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0AB28000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0CB28000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10B38000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1CB30300 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16B38000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18B38000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1AB38000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E0F0028 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14104000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16104000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2C024000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2E020001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2A03A500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18002000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x36003249 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x380024DB };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C004000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E002000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x34000900 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00014000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A012000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C012000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E012000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06014000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08014000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A014000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18012000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2405C000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x26050003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x220500A0 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x24062800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x140A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x160A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x180A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A0A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x41104000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x5B105555 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x5D101555 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B14FC00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D14003F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B112000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x5F115555 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x61111555 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0F128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47101600 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D100606 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4F100606 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51100006 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53100400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55101114 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57100001 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49100111 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B100606 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x65100002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x42000001 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D920, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D900, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D904, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D910, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D914, .val = 0x70800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC40, .val = 0x007F0000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D940, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D944, .val = 0x0000FFFC };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC00, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC04, .val = 0x0000FFFC };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D948, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D94C, .val = 0x0000FFF3 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC08, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC0C, .val = 0x0000FFF3 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D950, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D954, .val = 0x0000FFCF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC10, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC14, .val = 0x0000FFCF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D958, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D95C, .val = 0x0000FF3F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC18, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC1C, .val = 0x0000FF3F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D960, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D964, .val = 0x0000FCFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC20, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC24, .val = 0x0000FCFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D968, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D96C, .val = 0x0000F3FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC28, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC2C, .val = 0x0000F3FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D970, .val = 0x00078000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D974, .val = 0x00000FFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC30, .val = 0x00078000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC34, .val = 0x00000FFF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00008003 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = tgl__tdl_2__avg_gpu_core_frequency__read;
    counter->max_uint64 = tgl__tdl_2__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__tdl_2__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__tdl_2__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__tdl_2__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU And EM Pipes Active";
    counter->symbol_name = "EuFpuEmActive";
    counter->desc = "The percentage of time in which EU FPU and EM pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__tdl_2__eu_fpu_em_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__tdl_2__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Thread Occupancy";
    counter->symbol_name = "EuThreadOccupancy";
    counter->desc = "The percentage of time in which hardware threads occupied EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__tdl_2__eu_thread_occupancy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__tdl_2__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = tgl__tdl_2__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = tgl__tdl_2__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__tdl_2__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__tdl_2__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    if (perf->devinfo.subslice_mask & 1) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice0 Dualsubslice0 Thread Dispatcher";
        counter->symbol_name = "PSThread00ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice0 dualsubslice0 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__tdl_2__ps_thread00_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 2) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice0 Dualsubslice1 Thread Dispatcher";
        counter->symbol_name = "PSThread01ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice0 dualsubslice1 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__tdl_2__ps_thread01_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice0 Dualsubslice2 Thread Dispatcher";
        counter->symbol_name = "PSThread02ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice0 dualsubslice2 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__tdl_2__ps_thread02_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 8) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice0 Dualsubslice3 Thread Dispatcher";
        counter->symbol_name = "PSThread03ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice0 dualsubslice3 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__tdl_2__ps_thread03_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 16) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice0 Dualsubslice4 Thread Dispatcher";
        counter->symbol_name = "PSThread04ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice0 dualsubslice4 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__tdl_2__ps_thread04_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 32) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "PS Thread Ready For Dispatch on Slice0 Dualsubslice5 Thread Dispatcher";
        counter->symbol_name = "PSThread05ReadyForDispatch";
        counter->desc = "The percentage of time in which PS thread is ready for dispatch on slice0 dualsubslice5 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__tdl_2__ps_thread05_ready_for_dispatch__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__tdl_2__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    if (perf->devinfo.subslice_mask & 32) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 DualSubslice5 Thread Dispatcher";
        counter->symbol_name = "ThreadHeader05Ready";
        counter->desc = "The percentage of time in which thread header is ready on slice0 dualsubslice5 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__tdl_2__thread_header05_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 32) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 DualSubslice5 Thread Dispatcher Port 0";
        counter->symbol_name = "ThreadHeader05ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice0 dualsubslice5 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__tdl_2__thread_header05_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 32) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 DualSubslice5 Thread Dispatcher Port 1";
        counter->symbol_name = "ThreadHeader05ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice0 dualsubslice5 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__tdl_2__thread_header05_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 32) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 DualSubslice5 Thread Dispatcher Port 2";
        counter->symbol_name = "ThreadHeader05ReadyPort2";
        counter->desc = "The percentage of time in which thread header is ready on slice0 dualsubslice5 thread dispatcher port 2";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__tdl_2__thread_header05_ready_port2__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 32) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 DualSubslice5 Thread Dispatcher Port 3";
        counter->symbol_name = "ThreadHeader05ReadyPort3";
        counter->desc = "The percentage of time in which thread header is ready on slice0 dualsubslice5 thread dispatcher port 3";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__tdl_2__thread_header05_ready_port3__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__tdl_2__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 25);
}

static void
tgl_add_tdl_3_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "TDL_3";
    metric_set->symbol_name = "TDL_3";
    metric_set->hw_config_guid = "b763fa13-834e-4468-bba6-5f0d40db9813";
    metric_set->counters = calloc(29, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(116, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(18, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(2, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2651001C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2671001C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2691001C };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x24072A80 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06510107 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08510106 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A510105 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C510104 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10510000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02510000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04510000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06528000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08528000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A528000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C528000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16538000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18538000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A538000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C530100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C710107 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E710106 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02710105 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04710104 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10710000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E710000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x00710000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C728000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E728000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02728000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04728000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E730003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x12738000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14738000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14910107 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16910106 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18910105 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A910104 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x10910000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A910000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C910000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x14928000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x16928000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18928000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A928000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C93F000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E0F2800 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C0F000A };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C104000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E104000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02104000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04104000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2E020140 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02024000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04024000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2C030005 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x02034000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04034000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x06038000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08038000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A038000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x18034000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x36001003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x38003649 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1A006000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C006000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E006000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x34001B00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2A015500 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2206AA00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C0A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E0A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x020A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x060A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x5D101554 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x5B100555 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D14003F };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B141C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x61111554 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x5F110555 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x19128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x07128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x51100600 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x53100606 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55100006 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B100404 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D100404 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x65100002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x42000001 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D920, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D900, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D904, .val = 0x70800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D910, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D914, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC40, .val = 0x00070000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D940, .val = 0x00078000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D944, .val = 0x00000FFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC00, .val = 0x00078000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC04, .val = 0x00000FFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D948, .val = 0x00007800 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D94C, .val = 0x0000F0FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC08, .val = 0x00007800 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC0C, .val = 0x0000F0FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D950, .val = 0x00000780 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D954, .val = 0x0000FF0F };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC10, .val = 0x00000780 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC14, .val = 0x0000FF0F };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00008003 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = tgl__tdl_3__avg_gpu_core_frequency__read;
    counter->max_uint64 = tgl__tdl_3__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__tdl_3__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__tdl_3__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__tdl_3__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU And EM Pipes Active";
    counter->symbol_name = "EuFpuEmActive";
    counter->desc = "The percentage of time in which EU FPU and EM pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__tdl_3__eu_fpu_em_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__tdl_3__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Thread Occupancy";
    counter->symbol_name = "EuThreadOccupancy";
    counter->desc = "The percentage of time in which hardware threads occupied EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__tdl_3__eu_thread_occupancy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__tdl_3__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = tgl__tdl_3__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = tgl__tdl_3__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__tdl_3__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__tdl_3__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__tdl_3__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    if (perf->devinfo.subslice_mask & 4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 DualSubslice2 Thread Dispatcher";
        counter->symbol_name = "ThreadHeader02Ready";
        counter->desc = "The percentage of time in which thread header is ready on slice0 dualsubslice2 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__tdl_3__thread_header02_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 DualSubslice2 Thread Dispatcher Port 0";
        counter->symbol_name = "ThreadHeader02ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice0 dualsubslice2 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__tdl_3__thread_header02_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 DualSubslice2 Thread Dispatcher Port 1";
        counter->symbol_name = "ThreadHeader02ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice0 dualsubslice2 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__tdl_3__thread_header02_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 DualSubslice2 Thread Dispatcher Port 2";
        counter->symbol_name = "ThreadHeader02ReadyPort2";
        counter->desc = "The percentage of time in which thread header is ready on slice0 dualsubslice2 thread dispatcher port 2";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__tdl_3__thread_header02_ready_port2__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 4) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 DualSubslice2 Thread Dispatcher Port 3";
        counter->symbol_name = "ThreadHeader02ReadyPort3";
        counter->desc = "The percentage of time in which thread header is ready on slice0 dualsubslice2 thread dispatcher port 3";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__tdl_3__thread_header02_ready_port3__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 8) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 DualSubslice3 Thread Dispatcher";
        counter->symbol_name = "ThreadHeader03Ready";
        counter->desc = "The percentage of time in which thread header is ready on slice0 dualsubslice3 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__tdl_3__thread_header03_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 8) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 DualSubslice3 Thread Dispatcher Port 0";
        counter->symbol_name = "ThreadHeader03ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice0 dualsubslice3 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__tdl_3__thread_header03_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 8) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 DualSubslice3 Thread Dispatcher Port 1";
        counter->symbol_name = "ThreadHeader03ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice0 dualsubslice3 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__tdl_3__thread_header03_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 8) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 DualSubslice3 Thread Dispatcher Port 2";
        counter->symbol_name = "ThreadHeader03ReadyPort2";
        counter->desc = "The percentage of time in which thread header is ready on slice0 dualsubslice3 thread dispatcher port 2";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__tdl_3__thread_header03_ready_port2__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 8) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 DualSubslice3 Thread Dispatcher Port 3";
        counter->symbol_name = "ThreadHeader03ReadyPort3";
        counter->desc = "The percentage of time in which thread header is ready on slice0 dualsubslice3 thread dispatcher port 3";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__tdl_3__thread_header03_ready_port3__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 16) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 DualSubslice4 Thread Dispatcher";
        counter->symbol_name = "ThreadHeader04Ready";
        counter->desc = "The percentage of time in which thread header is ready on slice0 dualsubslice4 thread dispatcher";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__tdl_3__thread_header04_ready__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 16) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 DualSubslice4 Thread Dispatcher Port 0";
        counter->symbol_name = "ThreadHeader04ReadyPort0";
        counter->desc = "The percentage of time in which thread header is ready on slice0 dualsubslice4 thread dispatcher port 0";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__tdl_3__thread_header04_ready_port0__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 16) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 DualSubslice4 Thread Dispatcher Port 1";
        counter->symbol_name = "ThreadHeader04ReadyPort1";
        counter->desc = "The percentage of time in which thread header is ready on slice0 dualsubslice4 thread dispatcher port 1";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__tdl_3__thread_header04_ready_port1__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 16) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 DualSubslice4 Thread Dispatcher Port 2";
        counter->symbol_name = "ThreadHeader04ReadyPort2";
        counter->desc = "The percentage of time in which thread header is ready on slice0 dualsubslice4 thread dispatcher port 2";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__tdl_3__thread_header04_ready_port2__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    if (perf->devinfo.subslice_mask & 16) {
        counter = &metric_set->counters[metric_set->n_counters++];
        counter->metric_set = metric_set;
        counter->name = "Thread Header Ready on Slice0 DualSubslice4 Thread Dispatcher Port 3";
        counter->symbol_name = "ThreadHeader04ReadyPort3";
        counter->desc = "The percentage of time in which thread header is ready on slice0 dualsubslice4 thread dispatcher port 3";
        counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
        counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
        counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
        counter->read_float = tgl__tdl_3__thread_header04_ready_port3__read;
        counter->max_float = percentage_max_callback_float;
        intel_perf_add_logical_counter(perf, counter, "GPU/Thread Dispatcher");
    }

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__tdl_3__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 29);
}

static void
tgl_add_gpu_busyness_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "GpuBusyness";
    metric_set->symbol_name = "GpuBusyness";
    metric_set->hw_config_guid = "cc935a3e-8d96-4b47-bc46-3d84247e9a3a";
    metric_set->counters = calloc(23, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(67, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(14, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(2, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E0E1200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x220E0009 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0E101200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040E0043 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0E00B3 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x180E0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0C0E0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C0F0104 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08100053 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x20100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04104000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A104000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04024000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08024000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A024000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x04034000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x08034000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A034000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1C006000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x34001B00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x040A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x080A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0A0A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15102400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x230B0120 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15182400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x232B0120 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17100023 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x5D101000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x5B100545 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x15148000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B140C00 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x61112000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x5F110945 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x03124000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x05128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x09128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0B128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x13138000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B0D0040 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F0B00D3 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x190B0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x170B0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1B170002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x0D174000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x071800A3 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x11180000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x032D4000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x032B00D3 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x192B0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x092B0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55103000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x47101000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49107003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4B100402 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x4D100230 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x65100002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x42000001 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D920, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D900, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D904, .val = 0x30800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D910, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D914, .val = 0x00800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC40, .val = 0x00030000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D940, .val = 0x00024002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D944, .val = 0x0000B7FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC00, .val = 0x00024002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC04, .val = 0x0000B7FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D948, .val = 0x0007F000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D94C, .val = 0x000001FF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC08, .val = 0x0007F000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC0C, .val = 0x000001FF };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E458, .val = 0x00005004 };
    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E558, .val = 0x00008003 };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Any Engine Busy";
    counter->symbol_name = "AnyEngineBusy";
    counter->desc = "The percentage of time when any command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__gpu_busyness__any_engine_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = tgl__gpu_busyness__avg_gpu_core_frequency__read;
    counter->max_uint64 = tgl__gpu_busyness__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Blitter Ring Busy";
    counter->symbol_name = "BlitterBusy";
    counter->desc = "The percentage of time when blitter command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__gpu_busyness__blitter_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Compute Ring Busy";
    counter->symbol_name = "ComputeBusy";
    counter->desc = "The percentage of time when render command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__gpu_busyness__compute_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "CS Threads Dispatched";
    counter->symbol_name = "CsThreads";
    counter->desc = "The total number of compute shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__gpu_busyness__cs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Compute Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "DS Threads Dispatched";
    counter->symbol_name = "DsThreads";
    counter->desc = "The total number of domain shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__gpu_busyness__ds_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Domain Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Active";
    counter->symbol_name = "EuActive";
    counter->desc = "The percentage of time in which the Execution Units were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__gpu_busyness__eu_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU FPU And EM Pipes Active";
    counter->symbol_name = "EuFpuEmActive";
    counter->desc = "The percentage of time in which EU FPU and EM pipelines were actively processing.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__gpu_busyness__eu_fpu_em_active__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Pipes");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Stall";
    counter->symbol_name = "EuStall";
    counter->desc = "The percentage of time in which the Execution Units were stalled.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__gpu_busyness__eu_stall__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "EU Thread Occupancy";
    counter->symbol_name = "EuThreadOccupancy";
    counter->desc = "The percentage of time in which hardware threads occupied EUs.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__gpu_busyness__eu_thread_occupancy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "EU Array");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Busy";
    counter->symbol_name = "GpuBusy";
    counter->desc = "The percentage of time in which the GPU has been processing GPU commands.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__gpu_busyness__gpu_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = tgl__gpu_busyness__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = tgl__gpu_busyness__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GS Threads Dispatched";
    counter->symbol_name = "GsThreads";
    counter->desc = "The total number of geometry shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__gpu_busyness__gs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Geometry Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "HS Threads Dispatched";
    counter->symbol_name = "HsThreads";
    counter->desc = "The total number of hull shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__gpu_busyness__hs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Hull Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Posh Ring Busy";
    counter->symbol_name = "PoshEngineBusy";
    counter->desc = "The percentage of time when posh command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__gpu_busyness__posh_engine_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "FS Threads Dispatched";
    counter->symbol_name = "PsThreads";
    counter->desc = "The total number of fragment shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__gpu_busyness__ps_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Fragment Shader");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Render and compute engines are simultaneously busy";
    counter->symbol_name = "RenderAndComputeBusy";
    counter->desc = "The percentage of time when render and compute engines are simultaneously busy";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__gpu_busyness__render_and_compute_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Render Ring Busy";
    counter->symbol_name = "RenderBusy";
    counter->desc = "The percentage of time when render command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__gpu_busyness__render_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Vdbox0 Ring Busy";
    counter->symbol_name = "Vdbox0Busy";
    counter->desc = "The percentage of time when Vdbox0 command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__gpu_busyness__vdbox0_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Vdbox1 Ring Busy";
    counter->symbol_name = "Vdbox1Busy";
    counter->desc = "The percentage of time when Vdbox1 command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__gpu_busyness__vdbox1_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "Vebox Ring Busy";
    counter->symbol_name = "VeboxBusy";
    counter->desc = "The percentage of time when vebox command streamer was busy.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_FLOAT;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_PERCENT;
    counter->read_float = tgl__gpu_busyness__vebox_busy__read;
    counter->max_float = percentage_max_callback_float;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "VS Threads Dispatched";
    counter->symbol_name = "VsThreads";
    counter->desc = "The total number of vertex shader hardware threads dispatched.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_THREADS;
    counter->read_uint64 = tgl__gpu_busyness__vs_threads__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "EU Array/Vertex Shader");

    assert(metric_set->n_counters <= 23);
}

static void
tgl_add_test_oa_metric_set(struct intel_perf *perf)
{
    struct intel_perf_metric_set *metric_set;
    struct intel_perf_logical_counter *counter;

    metric_set = calloc(1, sizeof(*metric_set));
    metric_set->name = "Metric set TestOa";
    metric_set->symbol_name = "TestOa";
    metric_set->hw_config_guid = "30801299-fe7b-40ba-8a6c-64c6196f3748";
    metric_set->counters = calloc(13, sizeof(struct intel_perf_logical_counter));
    metric_set->n_counters = 0;
    metric_set->perf_oa_metrics_set = 0; // determined at runtime
    metric_set->perf_oa_format = I915_OA_FORMAT_A32u40_A4u32_B8_C8;

    metric_set->perf_raw_size = 256;
    metric_set->gpu_time_offset = 0;
    metric_set->gpu_clock_offset = 1;
    metric_set->a_offset = 2;
    metric_set->b_offset = metric_set->a_offset + 36;
    metric_set->c_offset = metric_set->b_offset + 8;

    intel_perf_add_metric_set(perf, metric_set);

    metric_set->mux_regs = calloc(29, sizeof(struct intel_perf_register_prog));
    metric_set->b_counter_regs = calloc(38, sizeof(struct intel_perf_register_prog));
    metric_set->flex_regs = calloc(1, sizeof(struct intel_perf_register_prog));

    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00000D04, .val = 0x00000200 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009840, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x280E0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E0E0147 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x180E0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x160E0000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E0F1000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E104000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2E020100 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x2C030004 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x38003000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1E0A8000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x49110000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x5D101400 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D140020 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1D1103A3 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x01110000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x61111000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x1F128000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x17100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x55100630 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x57100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x31100000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000003 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x65100002 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009884, .val = 0x00000000 };
    metric_set->mux_regs[metric_set->n_mux_regs++] = (struct intel_perf_register_prog) { .reg = 0x00009888, .val = 0x42000001 };

    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D920, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D900, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D904, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D910, .val = 0x00000000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D914, .val = 0xF0800000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC40, .val = 0x00FF0000 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D940, .val = 0x00000004 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D944, .val = 0x0000FFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC00, .val = 0x00000004 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC04, .val = 0x0000FFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D948, .val = 0x00000003 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D94C, .val = 0x0000FFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC08, .val = 0x00000003 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC0C, .val = 0x0000FFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D950, .val = 0x00000007 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D954, .val = 0x0000FFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC10, .val = 0x00000007 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC14, .val = 0x0000FFFF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D958, .val = 0x00100002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D95C, .val = 0x0000FFF7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC18, .val = 0x00100002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC1C, .val = 0x0000FFF7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D960, .val = 0x00100002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D964, .val = 0x0000FFCF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC20, .val = 0x00100002 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC24, .val = 0x0000FFCF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D968, .val = 0x00100082 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D96C, .val = 0x0000FFEF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC28, .val = 0x00100082 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC2C, .val = 0x0000FFEF };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D970, .val = 0x001000C2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D974, .val = 0x0000FFE7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC30, .val = 0x001000C2 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC34, .val = 0x0000FFE7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D978, .val = 0x00100001 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000D97C, .val = 0x0000FFE7 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC38, .val = 0x00100001 };
    metric_set->b_counter_regs[metric_set->n_b_counter_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000DC3C, .val = 0x0000FFE7 };

    metric_set->flex_regs[metric_set->n_flex_regs++] = (struct intel_perf_register_prog) { .reg = 0x0000E65C, .val = 0xFFFFFFFF };


    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "AVG GPU Core Frequency";
    counter->symbol_name = "AvgGpuCoreFrequency";
    counter->desc = "Average GPU Core Frequency in the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_HZ;
    counter->read_uint64 = tgl__test_oa__avg_gpu_core_frequency__read;
    counter->max_uint64 = tgl__test_oa__avg_gpu_core_frequency__max;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter0";
    counter->symbol_name = "Counter0";
    counter->desc = "HW test counter 0. Factor: 0.0";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = tgl__test_oa__counter0__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter1";
    counter->symbol_name = "Counter1";
    counter->desc = "HW test counter 1. Factor: 1.0";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = tgl__test_oa__counter1__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter2";
    counter->symbol_name = "Counter2";
    counter->desc = "HW test counter 2. Factor: 1.0";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = tgl__test_oa__counter2__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter3";
    counter->symbol_name = "Counter3";
    counter->desc = "HW test counter 3. Factor: 0.5";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = tgl__test_oa__counter3__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter4";
    counter->symbol_name = "Counter4";
    counter->desc = "HW test counter 4. Factor: 0.3333";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = tgl__test_oa__counter4__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter5";
    counter->symbol_name = "Counter5";
    counter->desc = "HW test counter 5. Factor: 0.3333";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = tgl__test_oa__counter5__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter6";
    counter->symbol_name = "Counter6";
    counter->desc = "HW test counter 6. Factor: 0.16666";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = tgl__test_oa__counter6__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter7";
    counter->symbol_name = "Counter7";
    counter->desc = "HW test counter 7. Factor: 0.6666";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = tgl__test_oa__counter7__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter8";
    counter->symbol_name = "Counter8";
    counter->desc = "HW test counter 8. Should be equal to 1 in IOStream or in OAG query mode";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = tgl__test_oa__counter8__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "TestCounter9 - OAR enable";
    counter->symbol_name = "Counter9";
    counter->desc = "HW test counter 9. Should be equal to 1 in OAR query mode.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_EVENTS;
    counter->read_uint64 = tgl__test_oa__counter9__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Core Clocks";
    counter->symbol_name = "GpuCoreClocks";
    counter->desc = "The total number of GPU core clocks elapsed during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_EVENT;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_CYCLES;
    counter->read_uint64 = tgl__test_oa__gpu_core_clocks__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    counter = &metric_set->counters[metric_set->n_counters++];
    counter->metric_set = metric_set;
    counter->name = "GPU Time Elapsed";
    counter->symbol_name = "GpuTime";
    counter->desc = "Time elapsed on the GPU during the measurement.";
    counter->type = INTEL_PERF_LOGICAL_COUNTER_TYPE_RAW;
    counter->storage = INTEL_PERF_LOGICAL_COUNTER_STORAGE_UINT64;
    counter->unit = INTEL_PERF_LOGICAL_COUNTER_UNIT_NS;
    counter->read_uint64 = tgl__test_oa__gpu_time__read;
    counter->max_uint64 = NULL /* undefined */;
    intel_perf_add_logical_counter(perf, counter, "GPU");

    assert(metric_set->n_counters <= 13);
}

void
intel_perf_load_metrics_hsw(struct intel_perf *perf)
{
    hsw_add_render_basic_metric_set(perf);
    hsw_add_compute_basic_metric_set(perf);
    hsw_add_compute_extended_metric_set(perf);
    hsw_add_memory_reads_metric_set(perf);
    hsw_add_memory_writes_metric_set(perf);
    hsw_add_sampler_balance_metric_set(perf);
}

void
intel_perf_load_metrics_bdw(struct intel_perf *perf)
{
    bdw_add_render_basic_metric_set(perf);
    bdw_add_compute_basic_metric_set(perf);
    bdw_add_render_pipe_profile_metric_set(perf);
    bdw_add_memory_reads_metric_set(perf);
    bdw_add_memory_writes_metric_set(perf);
    bdw_add_compute_extended_metric_set(perf);
    bdw_add_compute_l3_cache_metric_set(perf);
    bdw_add_data_port_reads_coalescing_metric_set(perf);
    bdw_add_data_port_writes_coalescing_metric_set(perf);
    bdw_add_hdc_and_sf_metric_set(perf);
    bdw_add_l3_1_metric_set(perf);
    bdw_add_l3_2_metric_set(perf);
    bdw_add_l3_3_metric_set(perf);
    bdw_add_l3_4_metric_set(perf);
    bdw_add_rasterizer_and_pixel_backend_metric_set(perf);
    bdw_add_sampler_1_metric_set(perf);
    bdw_add_sampler_2_metric_set(perf);
    bdw_add_tdl_1_metric_set(perf);
    bdw_add_tdl_2_metric_set(perf);
    bdw_add_compute_extra_metric_set(perf);
    bdw_add_vme_pipe_metric_set(perf);
    bdw_add_gpu_busyness_metric_set(perf);
    bdw_add_test_oa_metric_set(perf);
    bdw_add_stc__pma_stall_metric_set(perf);
}

void
intel_perf_load_metrics_chv(struct intel_perf *perf)
{
    chv_add_render_basic_metric_set(perf);
    chv_add_compute_basic_metric_set(perf);
    chv_add_render_pipe_profile_metric_set(perf);
    chv_add_hdc_and_sf_metric_set(perf);
    chv_add_l3_1_metric_set(perf);
    chv_add_l3_2_metric_set(perf);
    chv_add_l3_3_metric_set(perf);
    chv_add_l3_4_metric_set(perf);
    chv_add_rasterizer_and_pixel_backend_metric_set(perf);
    chv_add_sampler_1_metric_set(perf);
    chv_add_sampler_2_metric_set(perf);
    chv_add_tdl_1_metric_set(perf);
    chv_add_tdl_2_metric_set(perf);
    chv_add_test_oa_metric_set(perf);
}

void
intel_perf_load_metrics_sklgt2(struct intel_perf *perf)
{
    sklgt2_add_render_basic_metric_set(perf);
    sklgt2_add_compute_basic_metric_set(perf);
    sklgt2_add_render_pipe_profile_metric_set(perf);
    sklgt2_add_memory_reads_metric_set(perf);
    sklgt2_add_memory_writes_metric_set(perf);
    sklgt2_add_compute_extended_metric_set(perf);
    sklgt2_add_compute_l3_cache_metric_set(perf);
    sklgt2_add_hdc_and_sf_metric_set(perf);
    sklgt2_add_l3_1_metric_set(perf);
    sklgt2_add_l3_2_metric_set(perf);
    sklgt2_add_l3_3_metric_set(perf);
    sklgt2_add_rasterizer_and_pixel_backend_metric_set(perf);
    sklgt2_add_sampler_metric_set(perf);
    sklgt2_add_tdl_1_metric_set(perf);
    sklgt2_add_tdl_2_metric_set(perf);
    sklgt2_add_compute_extra_metric_set(perf);
    sklgt2_add_vme_pipe_metric_set(perf);
    sklgt2_add_gpu_busyness_metric_set(perf);
    sklgt2_add_ff_bottlenecks_metric_set(perf);
    sklgt2_add_test_oa_metric_set(perf);
    sklgt2_add_pma__stall_metric_set(perf);
}

void
intel_perf_load_metrics_sklgt3(struct intel_perf *perf)
{
    sklgt3_add_render_basic_metric_set(perf);
    sklgt3_add_compute_basic_metric_set(perf);
    sklgt3_add_render_pipe_profile_metric_set(perf);
    sklgt3_add_memory_reads_metric_set(perf);
    sklgt3_add_memory_writes_metric_set(perf);
    sklgt3_add_compute_extended_metric_set(perf);
    sklgt3_add_compute_l3_cache_metric_set(perf);
    sklgt3_add_hdc_and_sf_metric_set(perf);
    sklgt3_add_l3_1_metric_set(perf);
    sklgt3_add_l3_2_metric_set(perf);
    sklgt3_add_l3_3_metric_set(perf);
    sklgt3_add_rasterizer_and_pixel_backend_metric_set(perf);
    sklgt3_add_sampler_metric_set(perf);
    sklgt3_add_tdl_1_metric_set(perf);
    sklgt3_add_tdl_2_metric_set(perf);
    sklgt3_add_compute_extra_metric_set(perf);
    sklgt3_add_vme_pipe_metric_set(perf);
    sklgt3_add_gpu_busyness_metric_set(perf);
    sklgt3_add_test_oa_metric_set(perf);
    sklgt3_add_pma__stall_metric_set(perf);
}

void
intel_perf_load_metrics_sklgt4(struct intel_perf *perf)
{
    sklgt4_add_render_basic_metric_set(perf);
    sklgt4_add_compute_basic_metric_set(perf);
    sklgt4_add_render_pipe_profile_metric_set(perf);
    sklgt4_add_memory_reads_metric_set(perf);
    sklgt4_add_memory_writes_metric_set(perf);
    sklgt4_add_compute_extended_metric_set(perf);
    sklgt4_add_compute_l3_cache_metric_set(perf);
    sklgt4_add_hdc_and_sf_metric_set(perf);
    sklgt4_add_l3_1_metric_set(perf);
    sklgt4_add_l3_2_metric_set(perf);
    sklgt4_add_l3_3_metric_set(perf);
    sklgt4_add_rasterizer_and_pixel_backend_metric_set(perf);
    sklgt4_add_sampler_metric_set(perf);
    sklgt4_add_tdl_1_metric_set(perf);
    sklgt4_add_tdl_2_metric_set(perf);
    sklgt4_add_compute_extra_metric_set(perf);
    sklgt4_add_vme_pipe_metric_set(perf);
    sklgt4_add_gpu_busyness_metric_set(perf);
    sklgt4_add_test_oa_metric_set(perf);
    sklgt4_add_pma__stall_metric_set(perf);
}

void
intel_perf_load_metrics_kblgt2(struct intel_perf *perf)
{
    kblgt2_add_render_basic_metric_set(perf);
    kblgt2_add_compute_basic_metric_set(perf);
    kblgt2_add_render_pipe_profile_metric_set(perf);
    kblgt2_add_memory_reads_metric_set(perf);
    kblgt2_add_memory_writes_metric_set(perf);
    kblgt2_add_compute_extended_metric_set(perf);
    kblgt2_add_compute_l3_cache_metric_set(perf);
    kblgt2_add_hdc_and_sf_metric_set(perf);
    kblgt2_add_l3_1_metric_set(perf);
    kblgt2_add_l3_2_metric_set(perf);
    kblgt2_add_l3_3_metric_set(perf);
    kblgt2_add_rasterizer_and_pixel_backend_metric_set(perf);
    kblgt2_add_sampler_metric_set(perf);
    kblgt2_add_tdl_1_metric_set(perf);
    kblgt2_add_tdl_2_metric_set(perf);
    kblgt2_add_compute_extra_metric_set(perf);
    kblgt2_add_vme_pipe_metric_set(perf);
    kblgt2_add_gpu_busyness_metric_set(perf);
    kblgt2_add_test_oa_metric_set(perf);
    kblgt2_add_pma__stall_metric_set(perf);
}

void
intel_perf_load_metrics_kblgt3(struct intel_perf *perf)
{
    kblgt3_add_render_basic_metric_set(perf);
    kblgt3_add_compute_basic_metric_set(perf);
    kblgt3_add_render_pipe_profile_metric_set(perf);
    kblgt3_add_memory_reads_metric_set(perf);
    kblgt3_add_memory_writes_metric_set(perf);
    kblgt3_add_compute_extended_metric_set(perf);
    kblgt3_add_compute_l3_cache_metric_set(perf);
    kblgt3_add_hdc_and_sf_metric_set(perf);
    kblgt3_add_l3_1_metric_set(perf);
    kblgt3_add_l3_2_metric_set(perf);
    kblgt3_add_l3_3_metric_set(perf);
    kblgt3_add_rasterizer_and_pixel_backend_metric_set(perf);
    kblgt3_add_sampler_metric_set(perf);
    kblgt3_add_tdl_1_metric_set(perf);
    kblgt3_add_tdl_2_metric_set(perf);
    kblgt3_add_compute_extra_metric_set(perf);
    kblgt3_add_vme_pipe_metric_set(perf);
    kblgt3_add_gpu_busyness_metric_set(perf);
    kblgt3_add_test_oa_metric_set(perf);
    kblgt3_add_pma__stall_metric_set(perf);
}

void
intel_perf_load_metrics_cflgt2(struct intel_perf *perf)
{
    cflgt2_add_render_basic_metric_set(perf);
    cflgt2_add_compute_basic_metric_set(perf);
    cflgt2_add_render_pipe_profile_metric_set(perf);
    cflgt2_add_memory_reads_metric_set(perf);
    cflgt2_add_memory_writes_metric_set(perf);
    cflgt2_add_compute_extended_metric_set(perf);
    cflgt2_add_compute_l3_cache_metric_set(perf);
    cflgt2_add_hdc_and_sf_metric_set(perf);
    cflgt2_add_l3_1_metric_set(perf);
    cflgt2_add_l3_2_metric_set(perf);
    cflgt2_add_l3_3_metric_set(perf);
    cflgt2_add_rasterizer_and_pixel_backend_metric_set(perf);
    cflgt2_add_sampler_metric_set(perf);
    cflgt2_add_tdl_1_metric_set(perf);
    cflgt2_add_tdl_2_metric_set(perf);
    cflgt2_add_compute_extra_metric_set(perf);
    cflgt2_add_vme_pipe_metric_set(perf);
    cflgt2_add_gpu_busyness_metric_set(perf);
    cflgt2_add_test_oa_metric_set(perf);
    cflgt2_add_pma__stall_metric_set(perf);
}

void
intel_perf_load_metrics_cflgt3(struct intel_perf *perf)
{
    cflgt3_add_render_basic_metric_set(perf);
    cflgt3_add_compute_basic_metric_set(perf);
    cflgt3_add_render_pipe_profile_metric_set(perf);
    cflgt3_add_memory_reads_metric_set(perf);
    cflgt3_add_memory_writes_metric_set(perf);
    cflgt3_add_compute_extended_metric_set(perf);
    cflgt3_add_compute_l3_cache_metric_set(perf);
    cflgt3_add_hdc_and_sf_metric_set(perf);
    cflgt3_add_l3_1_metric_set(perf);
    cflgt3_add_l3_2_metric_set(perf);
    cflgt3_add_l3_3_metric_set(perf);
    cflgt3_add_rasterizer_and_pixel_backend_metric_set(perf);
    cflgt3_add_sampler_metric_set(perf);
    cflgt3_add_tdl_1_metric_set(perf);
    cflgt3_add_tdl_2_metric_set(perf);
    cflgt3_add_compute_extra_metric_set(perf);
    cflgt3_add_vme_pipe_metric_set(perf);
    cflgt3_add_gpu_busyness_metric_set(perf);
    cflgt3_add_test_oa_metric_set(perf);
    cflgt3_add_pma__stall_metric_set(perf);
}

void
intel_perf_load_metrics_bxt(struct intel_perf *perf)
{
    bxt_add_render_basic_metric_set(perf);
    bxt_add_compute_basic_metric_set(perf);
    bxt_add_render_pipe_profile_metric_set(perf);
    bxt_add_memory_reads_metric_set(perf);
    bxt_add_memory_writes_metric_set(perf);
    bxt_add_compute_extended_metric_set(perf);
    bxt_add_compute_l3_cache_metric_set(perf);
    bxt_add_hdc_and_sf_metric_set(perf);
    bxt_add_l3_1_metric_set(perf);
    bxt_add_rasterizer_and_pixel_backend_metric_set(perf);
    bxt_add_sampler_metric_set(perf);
    bxt_add_tdl_1_metric_set(perf);
    bxt_add_tdl_2_metric_set(perf);
    bxt_add_compute_extra_metric_set(perf);
    bxt_add_gpu_busyness_metric_set(perf);
    bxt_add_test_oa_metric_set(perf);
    bxt_add_pma__stall_metric_set(perf);
}

void
intel_perf_load_metrics_glk(struct intel_perf *perf)
{
    glk_add_render_basic_metric_set(perf);
    glk_add_compute_basic_metric_set(perf);
    glk_add_render_pipe_profile_metric_set(perf);
    glk_add_memory_reads_metric_set(perf);
    glk_add_memory_writes_metric_set(perf);
    glk_add_compute_extended_metric_set(perf);
    glk_add_compute_l3_cache_metric_set(perf);
    glk_add_hdc_and_sf_metric_set(perf);
    glk_add_l3_1_metric_set(perf);
    glk_add_rasterizer_and_pixel_backend_metric_set(perf);
    glk_add_sampler_metric_set(perf);
    glk_add_tdl_1_metric_set(perf);
    glk_add_tdl_2_metric_set(perf);
    glk_add_compute_extra_metric_set(perf);
    glk_add_test_oa_metric_set(perf);
    glk_add_pma__stall_metric_set(perf);
}

void
intel_perf_load_metrics_cnl(struct intel_perf *perf)
{
    cnl_add_render_basic_metric_set(perf);
    cnl_add_compute_basic_metric_set(perf);
    cnl_add_render_pipe_profile_metric_set(perf);
    cnl_add_memory_reads_metric_set(perf);
    cnl_add_memory_writes_metric_set(perf);
    cnl_add_compute_extended_metric_set(perf);
    cnl_add_compute_l3_cache_metric_set(perf);
    cnl_add_hdc_and_sf_metric_set(perf);
    cnl_add_l3_1_metric_set(perf);
    cnl_add_l3_2_metric_set(perf);
    cnl_add_rasterizer_and_pixel_backend_metric_set(perf);
    cnl_add_sampler_metric_set(perf);
    cnl_add_tdl_1_metric_set(perf);
    cnl_add_tdl_2_metric_set(perf);
    cnl_add_test_oa_metric_set(perf);
}

void
intel_perf_load_metrics_icl(struct intel_perf *perf)
{
    icl_add_render_basic_metric_set(perf);
    icl_add_compute_basic_metric_set(perf);
    icl_add_compute_extended_metric_set(perf);
    icl_add_compute_l3_cache_metric_set(perf);
    icl_add_render_pipe_profile_metric_set(perf);
    icl_add_hdc_and_sf_metric_set(perf);
    icl_add_rasterizer_and_pixel_backend_metric_set(perf);
    icl_add_l3_1_metric_set(perf);
    icl_add_l3_2_metric_set(perf);
    icl_add_l3_3_metric_set(perf);
    icl_add_l3_4_metric_set(perf);
    icl_add_l3_5_metric_set(perf);
    icl_add_sampler_1_metric_set(perf);
    icl_add_sampler_2_metric_set(perf);
    icl_add_tdl_1_metric_set(perf);
    icl_add_tdl_2_metric_set(perf);
    icl_add_tdl_3_metric_set(perf);
    icl_add_gpu_busyness_metric_set(perf);
    icl_add_test_oa_metric_set(perf);
}

void
intel_perf_load_metrics_ehl(struct intel_perf *perf)
{
    ehl_add_render_basic_metric_set(perf);
    ehl_add_compute_basic_metric_set(perf);
    ehl_add_compute_extended_metric_set(perf);
    ehl_add_compute_l3_cache_metric_set(perf);
    ehl_add_render_pipe_profile_metric_set(perf);
    ehl_add_hdc_and_sf_metric_set(perf);
    ehl_add_rasterizer_and_pixel_backend_metric_set(perf);
    ehl_add_l3_1_metric_set(perf);
    ehl_add_l3_2_metric_set(perf);
    ehl_add_l3_3_metric_set(perf);
    ehl_add_l3_4_metric_set(perf);
    ehl_add_l3_5_metric_set(perf);
    ehl_add_sampler_1_metric_set(perf);
    ehl_add_sampler_2_metric_set(perf);
    ehl_add_tdl_1_metric_set(perf);
    ehl_add_tdl_2_metric_set(perf);
    ehl_add_tdl_3_metric_set(perf);
    ehl_add_gpu_busyness_metric_set(perf);
    ehl_add_test_oa_metric_set(perf);
}

void
intel_perf_load_metrics_tgl(struct intel_perf *perf)
{
    tgl_add_render_basic_metric_set(perf);
    tgl_add_compute_basic_metric_set(perf);
    tgl_add_render_pipe_profile_metric_set(perf);
    tgl_add_hdc_and_sf_metric_set(perf);
    tgl_add_rasterizer_and_pixel_backend_metric_set(perf);
    tgl_add_l3_1_metric_set(perf);
    tgl_add_l3_2_metric_set(perf);
    tgl_add_l3_3_metric_set(perf);
    tgl_add_l3_4_metric_set(perf);
    tgl_add_l3_5_metric_set(perf);
    tgl_add_l3_6_metric_set(perf);
    tgl_add_sampler_1_metric_set(perf);
    tgl_add_sampler_2_metric_set(perf);
    tgl_add_tdl_1_metric_set(perf);
    tgl_add_tdl_2_metric_set(perf);
    tgl_add_tdl_3_metric_set(perf);
    tgl_add_gpu_busyness_metric_set(perf);
    tgl_add_test_oa_metric_set(perf);
}
